-- name=int_button_map_impl
--******************************************************************************************
function public.Init ()
  --
  public.DIRECTION = -1;
  public.POSITION = 0;

  private.MOUSE_OVER_ANIM_TIME = 0.3;

  ObjSet("obj_int_button_map", {
    event_mdown = int_button_map.MouseDown,
    event_menter = private.MouseEnterAnim,
    event_mleave = private.MouseLeaveAnim
  });

--  ObjSet("spr_int_button_map_button", {
--    event_mdown = int_button_map.MouseDown,
--    event_menter = private.MouseEnterAnim,
--    event_mleave = private.MouseLeaveAnim
--  });
--
end;
--******************************************************************************************
function private.MouseEnterAnim()

  SoundSfx( "aud_menu_icon_focus" )

  SetCursor( CURSOR_HAND );
  local obj = "spr_int_button_map_focus";
  local alp = ObjGet( obj ).alp;
  local tme = ( 1 - alp ) * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

  ObjAnimate( "spr_int_button_map_button_txt_focus", "alp", 0, 0, "",
  {
    0.0, 2, alp,
    tme, 2, 1
  } );

  if ObjGet("anm_int_button_map_hover").playing then
  else
    ObjSet( "anm_int_button_map_hover", {animfunc = "anim_focus", frame = 0 } );
    ld.AnimPlay( "anm_int_button_map_hover", "anim_focus", "" )
  end
  --ObjSet("vid_int_button_map", { playing = 1 });

end;
--******************************************************************************************
function private.MouseLeaveAnim()

  SetCursor( CURSOR_DEFAULT ); 
  local obj = "spr_int_button_map_focus";
  local alp = ObjGet( obj ).alp;
  local tme = alp * private.MOUSE_OVER_ANIM_TIME;

  ObjAnimate( obj, "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );

  ObjAnimate( "spr_int_button_map_button_txt_focus", "alp", 0, 0, "",
  {
    0.0, 1, alp,
    tme, 1, 0
  } );


  --ObjSet("vid_int_button_map", { playing = 0 });
  
end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

  
  else


  end;

end;
--******************************************************************************************
function public.Lock() 
  ObjAttach( "spr_int_button_map_button_lock", "obj_int_button_map" )
  ObjSet( "spr_int_button_map_button_lock", { alp = 0 } )
  ObjAnimate( "spr_int_button_map_button_lock", 8,0,0, _, { 0,0,ObjGet( "spr_int_button_map_button_lock" ).alp, 0.5,0,1 } )
  interface.WidgetSetInput( InterfaceWidget_BtnMap, false );
end
--******************************************************************************************
function public.UnLock() 
  ObjAnimate( "spr_int_button_map_button_lock", 8,0,0, function() 
    ObjDetach( "spr_int_button_map_button_lock" )
  end, { 0,0,ObjGet( "spr_int_button_map_button_lock" ).alp, 0.5,0,0 } )
  interface.WidgetSetInput( InterfaceWidget_BtnMap, true );
end