-- name=int_simon
--******************************************************************************************
function public.Init (pos_z)
  ObjAttach( "int_simon", interface.originhub );
  ObjSet( "int_simon", { pos_z = pos_z } );

  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  MsgSubscribe( Command_Level_Pause, private.PauseLevel );
  
  public.DIRECTION = -1;
  public.POSITION = ObjGet("int_simon").pos_x;

  public.MOUSE_OVER_ANIM_TIME=0.3
  public.SHOW_ANIM_TIME = 0.5
  public.pos_x = 0
  public.drag_simon = 0;
  public.attention=0
  public.state = -1
  --private.static_simon_cur = nil

  private.MOUSE_OVER_ANIM_TIME = 0.3;
  ObjSet("obj_int_simon", {
    event_mdown = private.MouseDown,
  });
 private.WideScreenUpdate()
end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

  MsgUnsubscribe( Command_Level_Pause, private.PauseLevel );

end;
--******************************************************************************************
function private.MouseDown()

 -- DbgTrace("clk_simon")
  --interface.DiaryShow()

end;
--******************************************************************************************
function private.WideScreenUpdate()

      local offset = 0.5 * ( GetAppWidth() - 1024 );
      local position = public.POSITION 
      ObjSet( "int_simon", { pos_x = position + (offset*public.DIRECTION)  } );

end;
--******************************************************************************************




function public.ShowAnim(event_id)
  --DbgTrace(event_id)
  local trg = function() public.EventAnimEnd( '"..event_id.."' ); end;
  local tme = public.MOUSE_OVER_ANIM_TIME
  ObjSet("int_simon",{visible=1})
    ObjAnimate( "int_simon",6 , 0, 0, trg,
  {
    0,0,0,0,
    tme,0,1,1
  } );
  
end;

function public.HideAnim(event_id)
  local trg = function()public.EventAnimEnd( '"..event_id.."' );end;
  local tme = public.MOUSE_OVER_ANIM_TIME
    --DbgTrace(event_id)  
  
  ObjAnimate( "int_simon", 6 , 0, 0, trg,
  {
    0,  0, 1,1,
    tme,0, 0,0
  } );
ld.SimonVidEnd()
end;


function public.EventAnimEnd(event_id)
------------------------------------------------------------------------------------
  if ( event_id == "show" ) then
    ObjSet( "int_simon",      { visible = 1, input = 1 } );
  elseif ( event_id == "hide" ) then
    ObjSet( "int_simon",      { visible = 0, input = 0 } );
  end;
    
end


function public.SimonGet()
    ObjSet( "int_simon",      { visible = 1, input = 1 } );
    --public.SimonCursorEnterZone()

end


--function public.SimonActiveDeploy(set_active)
--    if set_active == 1 then 
--      public.state = public.state+1
--      ObjAttach("obj_simon_opn_deploy","int_simon")
--    elseif set_active == 0 then
--      ObjAttach("obj_simon_opn_deploy","obj_simon_vid_root")
--    end
--end

function public.SimonFirstVid()
    --ld.LogTrace( "SimonFirstVid" );
    ObjSet( "int_simon",{ visible = 1, input = 1 } );
    ObjAttach('vid_simon_vid_first','int_simon')
    ObjSet( "vid_simon_vid_first", {alp=1} );
    ObjAttach('vid_simon_vid_doready','obj_simon_vid_root')
    VidPlay("vid_simon_vid_first",function()ObjAttach('vid_simon_vid_doready','int_simon');ObjAttach('vid_simon_vid_first','obj_simon_vid_root');VidStop("vid_simon_vid_first");end)
end


function public.SimonActiveCursor()

      private.SimonStaticStop()
      ---подготовка
      --ld.LogTrace( "SimonActiveCursor" );
      ObjSet( "vid_simon_vid_doready", {alp=1} );
      ObjSet( "vid_simon_start", {alp=0,playing="0"} );
      ObjSet( "vid_simon_static", {alp=0,playing="0"} );
      ObjSet( "vid_simon_end", {alp=0,playing="0"} );
      ObjSet( "vid_simon_vid_first", {alp=0,playing="0"} );
      ObjAttach("vid_simon_vid_first","obj_simon_vid_root")
      ObjAttach("vid_simon_start","obj_simon_vid_root")
      ObjAttach("vid_simon_static","obj_simon_vid_root")
      ObjAttach("vid_simon_end","obj_simon_vid_root")
      ObjAttach('vid_simon_vid_doreturn','obj_simon_vid_root')
      

      public.drag_simon = 1;
      ObjAttach('vid_simon_vid_dobackready','obj_simon_vid_root')


      ObjAttach("vid_simon_vid_doready","int_simon")
      VidPlay("vid_simon_vid_doready","")

      if ld.CheckRequirements( {"get_mouse"} ) and not ld.CheckRequirements( {"use_elf_sewingtable"} ) then
        --mouse
--ВАНЯ ! проверка на std ext
        SoundSfx( "aud_doready2" )
      elseif  ng_global.currentprogress == "ext" then
        SoundSfx( "aud_doready3" )
      else
        SoundSfx( "aud_doready" )
      end

      ObjAttach("anm_simon_cursor_state","obj_simon_cursor_drag")
      ObjAttach("obj_simon_cursor_drag","int_top")
      ObjSet( "obj_simon_cursor_drag", {inputrect_init=1,inputrect_x=-1,inputrect_y=-1,inputrect_w=2,inputrect_h=2} );

      ObjAnimate("anm_simon_cursor_state", 8, 0, 0, function()end, {0,0,1,0.01,0,1});
      --AnimPlay('anm_simon_cursor_state','DoState','')
      --ld.ShCur(CURSOR_SIMON_HOWER)
    --if ng_global.progress["std"]["use_birder"].done == 1 and 
    --   ng_global.progress["std"]["get_bird"].done ~= 1 and
    --   GetCurrentRoom() == "zz_cell" then
    --  ld.tutorial.TutorialShow('tutor_scrooge2', 0, 460, 120, 0, 170, 0.02)
    --end
end



function public.SimonDeActiveCursor()
      --подготовка назад
      

      public.drag_simon = 0;
      --ld.LogTrace( "SimonDeActiveCursor" );
      --AnimPlay("","","")
      ld.ShCur(CURSOR_DEFAULT)
      --SetCursor(CURSOR_DEFAULT);
      ObjSet("anm_simon_cursor_state", {alp=0});
      ObjAttach('vid_simon_vid_doready','obj_simon_vid_root');
      VidStop("vid_simon_vid_doready")
      VidStop("vid_simon_vid_dobackready")

      ObjAttach('vid_simon_vid_dobackready','int_simon')
      VidPlay("vid_simon_vid_dobackready",function()private.SimonStaticStartTme();ObjAttach('vid_simon_vid_dobackready','obj_simon_vid_root')end)

      ObjAttach("obj_simon_cursor_drag","int_simon")
      ObjSet( "obj_simon_cursor_drag", {inputrect_init=1,inputrect_x=-55,inputrect_y=-109,inputrect_w=107,inputrect_h=214} );
      ObjAttach("anm_simon_cursor_state","obj_simon_vid_root")
      public.attention=0
end

function public.SimonJump(func)
      --DbgTrace("vid_simon_vid_dojump play")
      --ld.LogTrace( "SimonJump" );
      ObjAttach("vid_simon_vid_doready","obj_simon_vid_root")
      ObjSet( "spr_simon_arrow", {visible = 1} );
      ObjAttach("vid_simon_vid_dojump","int_simon")
      if func then
        VidPlay("vid_simon_vid_dojump",func)
      else 
        VidPlay("vid_simon_vid_dojump","")
      end

      if ld.CheckRequirements( {"get_mouse"} ) and not ld.CheckRequirements( {"use_elf_sewingtable"} ) then
        --mouse
        SoundSfx( "aud_dojump2" )
      elseif  ng_global.currentprogress == "ext" then
        SoundSfx( "aud_dojump3" )
      else
        SoundSfx( "aud_dojump" )
      end

      ObjAttach("obj_simon_cursor_drag","int_simon")
      ObjSet( "obj_simon_cursor_drag", {inputrect_init=1,inputrect_x=-55,inputrect_y=-109,inputrect_w=107,inputrect_h=214} );
      ObjAttach("anm_simon_cursor_state","obj_simon_vid_root")
      ObjSet("anm_simon_cursor_state", {alp=0,frame=0});
      
end

function public.SimonReturn()

            
      public.drag_simon = 0;
      ld.ShCur(CURSOR_DEFAULT)
      --SetCursor(CURSOR_DEFAULT);
      --ld.LogTrace( "SimonReturn" );
      ObjSet("obj_simon_cursor_drag", {visible=1,input=1});
      ObjSet("obj_simon_no_simon", {input = 0,visible=0});

      private.SimonStaticStop()
      
      ObjAttach('vid_simon_vid_dojump','obj_simon_vid_root')
      ObjAttach('vid_simon_vid_doready','obj_simon_vid_root');
      VidStop("vid_simon_vid_dojump")
      VidStop("vid_simon_vid_doready")
      VidStop("vid_simon_vid_doreturn")


  
      ObjAttach("vid_simon_vid_doreturn","int_simon")
      VidPlay("vid_simon_vid_doreturn",function()ObjSet('obj_simon_cursor_drag', {input=1});private.SimonStaticStartTme();ObjAttach('vid_simon_vid_doreturn','obj_simon_vid_root')end)

      if ld.CheckRequirements( {"get_mouse"} ) and not ld.CheckRequirements( {"use_elf_sewingtable"} ) then
        --mouse
        SoundSfx( "aud_doreturn2" )
      elseif  ng_global.currentprogress == "ext" then
        SoundSfx( "aud_doreturn3" )
      else
        SoundSfx( "aud_doreturn" )
      end

      ObjSet("anm_simon_cursor_state", {alp=0});
      ObjAttach("anm_simon_cursor_state","obj_simon_vid_root")
      --AnimPlay("anm_simon_cursor_state","DoOpen","")
      --AnimStop('anm_simon_cursor_state')
      
    local i = math.random(1,3)
   -- ld.ShowBbt('simon_return'..i, "simon")
end

function public.SimonCursorEnterZone()
      --ld.LogTrace( "SimonCursorEnterZone" );
    --AnimPlay("anm_simon_cursor_state","DoOpen",function()
    --public.SimonCursorLoop()
    
    --end)
    ld.ShCur(CURSOR_SIMON_HOWER)
    --ObjSet( "spr_simon_arrow", {visible = 0} );
end

function public.SimonCursorLoop()
      --ld.LogTrace( "SimonCursorLoop" );
    --AnimStop('anm_simon_cursor_state')
    --AnimPlay('anm_simon_cursor_state','DoLoop','')
    --DbgTrace("LOOP")
    
    --ObjSet( "spr_simon_arrow", {visible = 0} );
end

function public.SimonCursorLeaveZone()
    --ld.LogTrace( "SimonCursorLeaveZone" );
    --AnimStop('anm_simon_cursor_state')
    --AnimPlay("anm_simon_cursor_state","DoClose",function()AnimPlay('anm_simon_cursor_state','DoState','')end)
   -- DbgTrace("leave")
    ld.ShCur(CURSOR_SIMON_DRAG)
    ObjSet( "spr_simon_arrow", {visible = 1} );
end

function public.SimonSetVisible(set_visible)
  set_visible = tonumber(set_visible )
  if set_visible == 0 then
    private.SimonStaticStop()
    ObjSet("vid_simon_vid_doready", {visible=0});
    ObjSet("obj_simon_cursor_drag", {visible=0,input=0});
    ObjSet("obj_simon_no_simon", {input = 1,visible=1});
    public.attention=0
  elseif set_visible == 1 then 

        private.SimonStaticStartTme()

    VidStop("vid_simon_vid_doready")
    ObjSet("vid_simon_vid_doready", {visible=1});
    ObjSet("obj_simon_cursor_drag", {visible=1,input=1});
    ObjSet("obj_simon_no_simon", {input = 0,visible=0});

  end
    
end

function public.SimonVidStart()
--ld.LogTrace( "SimonVidStart" );
  if ObjGet("anm_simon_cursor_state").alp~=1 then
--ld.LogTrace( "SimonVidStart alp~= 1 " );
      public.attention=1
      ObjSet( "vid_simon_vid_first", {alp=0,playing="0"} );
      ObjAttach("vid_simon_vid_first","obj_simon_vid_root")
    ObjSet( 'vid_simon_vid_doready', {alp=0})
    ObjAttach("vid_simon_vid_doready","obj_simon_vid_root")
    ObjAttach("vid_simon_vid_dobackready","obj_simon_vid_root")
    
    ObjAttach("vid_simon_start","int_simon")
    ObjAttach("vid_simon_static","obj_simon_vid_root")
    VidStop("vid_simon_start")
    ObjSet( "vid_simon_start", {alp=1} );
    ObjSet( "vid_simon_static", {looped = 1} );
    VidPlay("vid_simon_start",function()VidStop("vid_simon_static");ObjSet('vid_simon_static',{alp=1});ObjAttach('vid_simon_start','obj_simon_vid_root');ObjSet('vid_simon_start',{alp=0});ObjAttach('vid_simon_static','int_simon');VidPlay('vid_simon_static','')end)
  end
end

function public.SimonVidEnd()
--ld.LogTrace( "SimonVidEnd" );
--VidStop("vid_simon_start")
  if   public.attention==1 then
      public.attention=0
--    ld.LogTrace( "SimonVidEnd attention = 1" );
    ObjSet( "vid_simon_static", {looped = 0} );
    ObjAttach('vid_simon_static','obj_simon_vid_root');
    ObjAttach('vid_simon_start','obj_simon_vid_root');
    
    ObjSet( "vid_simon_static",{alp=0} );
    VidStop("vid_simon_end")
    ObjSet( "vid_simon_end", {alp=1} );
    ObjAttach('vid_simon_end','int_simon');
    VidPlay("vid_simon_end",function()ObjSet('vid_simon_end',{alp=0});ObjAttach('vid_simon_end','obj_simon_vid_root');ObjSet( 'vid_simon_vid_doready', {alp=1} );private.SimonStaticStartTme()end)
  end
end



function public.SimonDrag(drag_obj)

  local prg_name, o1, o2;
  local prg_arr = {}
  for i = 1,#game.progress_names do
    prg_name = game.progress_names[ i ];
    if (string.find(prg_name,"use_elf") or string.find(prg_name,"use_mouse") or string.find(prg_name,"use_fairyext") )and (not ld.CheckRequirements({prg_name})) and  common_impl.hint[ prg_name ].inv_obj == drag_obj then
      if common_impl.hint[ prg_name ].zz_gate then
        o1 = ObjGet( common_impl.hint[ prg_name ].zz_gate )
        o2 = ObjGet( common_impl.hint[ prg_name ].use_place )
        --ld.LogTrace( i, prg_name )
        if o1 and o2 and o1.input and o2.input then  
          table.insert( prg_arr,prg_name)
        end
      else 
        o2 = ObjGet( common_impl.hint[ prg_name ].use_place )
        if o2 and o2.input then  
          table.insert( prg_arr,prg_name)
        end
      end
    end
  end

  local active_obj 
  local room_current 
  local prg_name = ""
  if not common_impl.UseItemLock then
    if interface.GetCurrentComplexInv() == "" then
      room_current = GetCurrentRoom();
      
    else 
      room_current = "inv_complex_inv"
    end
  end

  for a=1,#prg_arr do
    if room_current == common_impl.hint[ prg_arr[a] ].room then
      prg_name = prg_arr[a]
      break
    elseif room_current == common_impl.hint[ prg_arr[a] ].zz then
      prg_name = prg_arr[a]
      break
    end
  end

    room_current = common.GetCurrentSubRoom() or GetCurrentRoom();
    local room_type = common.GetObjectPrefix( room_current );
    local correct_room = false


  if prg_name ~= "" then
    if ( room_type == "rm" ) then
      
      if room_current == common_impl.hint[ prg_name ].room then
        correct_room = true
      end
    elseif room_type == "zz" or room_type == "mg" then
      if room_current == common_impl.hint[ prg_name ].zz then
        correct_room = true
      end
    end
  end
  

  if correct_room then
    if ( room_type == "rm"  ) then
      if common_impl.hint[ prg_name ].zz and ObjGet(common_impl.hint[ prg_name ].zz_gate).input and  ObjGet(common_impl.hint[ prg_name ].use_place).input then
        active_obj = common_impl.hint[ prg_name ].zz_gate
      else 
        if common_impl.hint[ prg_name ].use_place and ObjGet(common_impl.hint[ prg_name ].use_place).input then
          active_obj = common_impl.hint[ prg_name ].use_place
        end
      end
    elseif ( room_type == "zz" or room_type == "mg" ) and ObjGet(common_impl.hint[ prg_name ].use_place).input then
      active_obj = common_impl.hint[ prg_name ].use_place
    end
  -- DbgTrace(active_obj)
  else

   if interface.GetCurrentComplexInv() ~= "" and common_impl.hint[ prg_name ] and ObjGetRelations( common_impl.hint[ prg_name ].zz or ""  ).parent == "int_complex_inv_impl" and ObjGet(common_impl.hint[ prg_name ].use_place).input then
     active_obj = common_impl.hint[ prg_name ].use_place; 
   end
  end
  local x1,x2
  local yy,y2
  local ang
  if active_obj then
    --DbgTrace("active_obj:"..tostring(active_obj).." alp=1");
      x1 = GetZoomCursorPos()[1]
      y1 = GetZoomCursorPos()[2]
      x2 = GetObjPosByObj(active_obj)[1]
      y2 = GetObjPosByObj(active_obj)[2]
    --end
    ang = ( math.atan(y2 - y1, x1 - x2) )/ math.pi * 180 
  
    if ang < 0 then ang = ang + 360 end;
    ObjSet( "spr_simon_arrow", {alp=1,ang = ang*math.pi / 180 } );
  else 
    ObjSet( "spr_simon_arrow", {alp=0} );
  end;

end


function private.SimonStatic( static_count )
  --ld.LogTrace( "SimonStatic" );
  --ld.LogTrace( static_count, private.SimonStaticStartTme_counter )
  if static_count ~= private.SimonStaticStartTme_counter then
    return
  end
  local num = 3; --math.random(3,5);
  ObjAttach("vid_simon_vid_static_"..num,"int_simon")
  --ld.LogTrace( private.static_simon_cur.." play" );
  VidPlay("vid_simon_vid_static_"..num,function() private.SimonStaticStartTme( static_count ) end)
end

function private.SimonStaticStartTme( from_static_count )
  --ld.LogTrace( " BEF SimonStaticStartTme",from_static_count );
  private.SimonStaticStartTme_counter = private.SimonStaticStartTme_counter or 0;

  if not from_static_count then
    --private.SimonStaticStartTme_counter = private.SimonStaticStartTme_counter + 1
  elseif from_static_count ~= private.SimonStaticStartTme_counter then
    --против двойного кота, который возникает при тормазах и странном поведении движка
    --ld.LogTrace( "!!!!!!!!!!",static_count, private.SimonStaticStartTme_counter )
    --ld.Lock( 1 )
    return
  end
    private.SimonStaticStartTme_counter = private.SimonStaticStartTme_counter + 1

  local static_count = private.SimonStaticStartTme_counter;

    private.SimonStaticStop( 1 )
    --ld.LogTrace( " AFT SimonStaticStartTme" );


    local func_end = function()
      VidStop("vid_simon_vid_static_1")
      ObjAttach("vid_simon_vid_static_1","obj_simon_vid_root")  
      private.SimonStatic( static_count )
    end
    private.static_play = true
    ObjAttach("vid_simon_vid_static_1","int_simon")
    --DbgTrace( "vid_simon_vid_static_1 play" );
    VidPlay("vid_simon_vid_static_1",func_end)

end

function private.SimonStaticStop( static )
  --ld.LogTrace( "SimonStaticStop" );

    for i=3,5 do
      VidStop("vid_simon_vid_static_"..i)
      ObjAttach("vid_simon_vid_static_"..i,"obj_simon_vid_root")
    end

  VidStop("vid_simon_vid_static_1")
  if not static then
    ObjAttach("vid_simon_vid_static_1","obj_simon_vid_root")
  end;
end

function public.SimonStaticStop()
  private.SimonStaticStop()
end
function public.SimonStaticStart()
  private.SimonStaticStartTme()
end





function public.SimonVoc(vid_voc)
  
  if private.SimonVoc_now then
    ObjDetach( private.SimonVoc_now )
  else
    private.SimonStaticStop()
  end

  ObjSet( "int_simon", { input = 0 } );
  private.SimonVoc_now = vid_voc
  ObjAttach( vid_voc, "int_simon" )
  VidPlay( vid_voc, public.SimonVocStop )
end

function public.SimonVocStop()
  if private.SimonVoc_now then
    ObjSet( "int_simon", { input = 1 } );
    ObjDetach( private.SimonVoc_now )
    private.SimonVoc_now = false
    private.SimonStaticStartTme()
  end;
end


function public.LoadAnotherPrg(person)

  private.vid_arr= 
  {
    "vid_simon_static"          ,
    "vid_simon_end"             ,
    "vid_simon_start"           ,
    "vid_simon_vid_dojump"      ,
    "vid_simon_vid_doreturn"    ,
    "vid_simon_vid_first"       ,
    "vid_simon_vid_dobackready" ,
    "vid_simon_vid_static_3"    ,
    --"vid_simon_vid_static_4"    ,
    --"vid_simon_vid_static_5"    ,
    "vid_simon_vid_doready"     ,
    "vid_simon_vid_static_1"    ,
    --"anm_simon_cursor_state"

  }

  if ng_global.currentprogress == "std" then

    if (person ~= "simon") and (ld.CheckRequirements( {"get_mouse"} ) and not ld.CheckRequirements( {"use_elf_sewingtable"} )) then    --кот в сопогах
  
      for i= 1,#private.vid_arr do

          ObjSet( private.vid_arr[i], {res = ObjGet(private.vid_arr[i]).res:gsub("/simon/vid","/simon/mouse/vid")} );
          ObjSet( private.vid_arr[i],{ drawoff_x = -3, drawoff_y = -51, frame = 0});
          if ("vid_simon_vid_static_1" == private.vid_arr[i]) or ("vid_simon_vid_static_3" == private.vid_arr[i]) then
            ObjSet(private.vid_arr[i],{ pos_x = 75, pos_y = 39 });
          end; 

      end
      ObjSet( "obj_simon_no_simon", {event_mdown=function() ld.ShowBbt("no_mousebbt") end} );  

    else

        for i= 1,#private.vid_arr do

            ObjSet( private.vid_arr[i], {res = ObjGet(private.vid_arr[i]).res:gsub("/simon/mouse/","/simon/")} );
            ObjSet( private.vid_arr[i],{ drawoff_x = 0, drawoff_y = 0, frame = 0});
            if ("vid_simon_vid_static_1" == private.vid_arr[i]) or ("vid_simon_vid_static_3" == private.vid_arr[i]) then
              ObjSet(private.vid_arr[i],{ pos_x = 75, pos_y = 39 });
            end; 

        end
        ObjSet( "obj_simon_no_simon", {event_mdown=function() ld.ShowBbt("no_simonbbt") end} );  

    end

  elseif ng_global.currentprogress == "ext" then

    if ld.CheckRequirements( {"get_fairyext"} ) then    --помощник бонуса
  
      for i= 1,#private.vid_arr do

        ObjSet( private.vid_arr[i], {res = ObjGet(private.vid_arr[i]).res:gsub("/simon/vid","/simon/fairyext/vid"),
          scale_x = 1,
          scale_y = 1
        } );
        if ("vid_simon_vid_static_1" == private.vid_arr[i]) or ("vid_simon_vid_static_3" == private.vid_arr[i]) then
          ObjSet(private.vid_arr[i],{ pos_x = 45, pos_y = 125 });
        end;  
        ObjSet( private.vid_arr[i],{ drawoff_x = 54, drawoff_y = -153, frame = 0 });
        

      end
      ObjSet( "obj_simon_no_simon", {event_mdown=function() ld.ShowBbt("no_fairyextbbt") end} );  
      --ObjSet( private.vid_arr[#private.vid_arr], {res = ObjGet(private.vid_arr[#private.vid_arr]).res:gsub("/simon/","/simon/fairyext/")} );
    end

  end


end


--******************************************************************************************
function private.PauseLevel( msg, param )
  if msg == "Command_Level_Pause" then
    ObjSet( "int_simon", { active = 1 - param.pause } )
  end;
end