-- name=mg_casket
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_casket";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_casket" ] = {type = "click", use_place = "fake", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "fake" };
  local win_casket_logic = function()
    if ld.CheckRequirements( {"win_casket"} ) then
      
    end
  end;
  local win_casket = function()
    if ld.CheckRequirements( {"win_casket"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_casket", win_casket, private.room_objname )
  cmn.AddSubscriber("win_casket", win_casket_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletelf1" ] = { type = "use", inv_obj = "inv_amuletelf1", use_place = "gfx_casket_amuletelf1_zone", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.use_amuletelf1_logic = function()
  ObjSet( "obj_casket_mmg1_root", { visible = 1, input = 1, active = 1 } )
end;
private.use_amuletelf1_inv = function()
  common_impl.ProcessMultiUseAll("amuletelf1", "amuletelf1")
end;
private.use_amuletelf1_beg = function()
  ObjDelete( "gfx_casket_amuletelf1_zone" );
end;
private.use_amuletelf1_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletelf1", private.use_amuletelf1_inv );
cmn.AddSubscriber( "use_amuletelf1", private.use_amuletelf1_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf1", private.use_amuletelf1_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf1", private.use_amuletelf1_logic );
cmn.AddSubscriber( "use_amuletelf1_inv", private.use_amuletelf1_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletelf1_beg", private.use_amuletelf1_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf1_end", private.use_amuletelf1_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf1_end", private.use_amuletelf1_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletelf1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletelf1" );
    cmn.CallEventHandler( "use_amuletelf1_end" );
    common_impl.Lock(0);
    level.tutorial_mg.first()
  if common_impl.ZzCompleteCheck( "use_amuletelf1" ) then cmn.GotoRoom( "rm_entrypoint" ); end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletelf1_inv" );
  cmn.CallEventHandler( "use_amuletelf1_beg" );
  common_impl.Lock(1);

  gm.CubeUse( func_end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_casket1" ] = { type = "click", use_place = "obj_casket_mmg1_root", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.win_casket1_logic = function()
  if ld.CheckRequirements( { "win_casket1" } ) then
    ObjSet( "spr_casket_goldenfeather", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_casket1_beg = function()
  
end;
private.win_casket1_end = function()
  if ld.CheckRequirements( { "win_casket1" } ) then
    ObjDelete( "obj_casket_mmg1_root" )
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_casket1", private.win_casket1_beg, private.room_objname );
cmn.AddSubscriber( "win_casket1", private.win_casket1_end, private.room_objname );
cmn.AddSubscriber( "win_casket1", private.win_casket1_logic );
cmn.AddSubscriber( "win_casket1_beg", private.win_casket1_beg, private.room_objname );
cmn.AddSubscriber( "win_casket1_end", private.win_casket1_end, private.room_objname );
cmn.AddSubscriber( "win_casket1_end", private.win_casket1_logic );
--------------------------------------------------------------------------------------------
function public.win_casket1()

  local func_end = function()
    cmn.SetEventDone( "win_casket1" );
    cmn.CallEventHandler( "win_casket1_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "win_casket1_beg" );
  common_impl.Lock(1);

  cmn.MiniGameHide( "casket1", true )
  SoundMgTheme( false )
  gm.GateHalf( false )

  SoundSfx( "aud_win_mg_casket" )
  ObjSet( "obj_casket_mmg1_root", { input = 0 } )
  ld.AnimPlay( "anm_casket_mmg1_anm_biscuit", "final", func_end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_goldenfeather" ] = { type = "get", get_obj = "spr_casket_goldenfeather", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.get_goldenfeather_logic = function()
  ObjSet( "gfx_casket_amuletelf2_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_goldenfeather_inv = function()
  interface.InventoryItemAdd("inv_goldenfeather","spr_casket_goldenfeather");
end;
private.get_goldenfeather_beg = function()
  ObjDelete("gfx_casket_goldenfeather")
end;
private.get_goldenfeather_end = function()
  
end;

cmn.AddSubscriber( "get_goldenfeather_beg", private.get_goldenfeather_inv );
cmn.AddSubscriber( "get_goldenfeather_beg", private.get_goldenfeather_beg, private.room_objname );
cmn.AddSubscriber( "get_goldenfeather_end", private.get_goldenfeather_end, private.room_objname );
cmn.AddSubscriber( "get_goldenfeather_end", private.get_goldenfeather_logic );
cmn.AddSubscriber( "get_goldenfeather", private.get_goldenfeather_inv );
cmn.AddSubscriber( "get_goldenfeather", private.get_goldenfeather_beg, private.room_objname );
cmn.AddSubscriber( "get_goldenfeather", private.get_goldenfeather_end, private.room_objname );
cmn.AddSubscriber( "get_goldenfeather", private.get_goldenfeather_logic );
--------------------------------------------------------------------
function public.get_goldenfeather()
  
  local func_end = function()
    ld.Lock( 0 )
    cmn.SetEventDone( "get_goldenfeather" );
    cmn.CallEventHandler( "get_goldenfeather_end" );
  end

  ld.Lock( 1 )
  cmn.CallEventHandler( "get_goldenfeather_beg" );

  gm.CubeBack( func_end )
  
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletelf2" ] = { type = "use", inv_obj = "inv_amuletelf2", use_place = "gfx_casket_amuletelf2_zone", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.use_amuletelf2_logic = function()
  ObjSet( "obj_casket_mmg2_root", { visible = 1, input = 1, active = 1 } )
end;
private.use_amuletelf2_inv = function()
  common_impl.ProcessMultiUseAll("amuletelf2", "amuletelf2")
end;
private.use_amuletelf2_beg = function()
  ObjDelete( "gfx_casket_amuletelf2_zone" );
end;
private.use_amuletelf2_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletelf2", private.use_amuletelf2_inv );
cmn.AddSubscriber( "use_amuletelf2", private.use_amuletelf2_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf2", private.use_amuletelf2_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf2", private.use_amuletelf2_logic );
cmn.AddSubscriber( "use_amuletelf2_inv", private.use_amuletelf2_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletelf2_beg", private.use_amuletelf2_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf2_end", private.use_amuletelf2_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf2_end", private.use_amuletelf2_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletelf2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletelf2" );
    cmn.CallEventHandler( "use_amuletelf2_end" );
    common_impl.Lock(0);
  if common_impl.ZzCompleteCheck( "use_amuletelf2" ) then cmn.GotoRoom( "rm_entrypoint" ); end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletelf2_inv" );
  cmn.CallEventHandler( "use_amuletelf2_beg" );
  common_impl.Lock(1);

  gm.CubeUse( func_end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_casket2" ] = { type = "click", use_place = "obj_casket_mmg2_root", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.win_casket2_logic = function()
  if ld.CheckRequirements( { "win_casket2" } ) then
    ObjSet( "spr_casket_snowqueen", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_casket2_beg = function()
  ObjDelete( "gfx_casket_win_casket2_zone" );
end;
private.win_casket2_end = function()
  if ld.CheckRequirements( { "win_casket2" } ) then
    ObjDelete( "obj_casket_mmg2_root" )
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_casket2", private.win_casket2_beg, private.room_objname );
cmn.AddSubscriber( "win_casket2", private.win_casket2_end, private.room_objname );
cmn.AddSubscriber( "win_casket2", private.win_casket2_logic );
cmn.AddSubscriber( "win_casket2_beg", private.win_casket2_beg, private.room_objname );
cmn.AddSubscriber( "win_casket2_end", private.win_casket2_end, private.room_objname );
cmn.AddSubscriber( "win_casket2_end", private.win_casket2_logic );
--------------------------------------------------------------------------------------------
function public.win_casket2()

  local func_end = function()
    gm.manager_clear()
    cmn.SetEventDone( "win_casket2" );
    cmn.CallEventHandler( "win_casket2_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "win_casket2_beg" );
  common_impl.Lock(1);

  cmn.MiniGameHide( "casket2", true )
  SoundMgTheme( false )
  gm.GateHalf( false )

  SoundSfx( "aud_win_mg_caasket2" )

  local ts = 0.1
  for i = 1, 10 do
    local o = ObjGet( "spr_casket_mmg2_light"..i )
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, ts*1,2,1, ts*2,3,0, ts*3,2,1, ts*4,3,0, ts*5,2,1, ts*6,3,0 } )
  end
    local o = ObjGet( "txt_casket_mmg2_counter" )
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, ts*1,2,1, ts*2,3,0, ts*3,2,1, ts*4,3,0, ts*5,2,1, ts*6,3,0 } )

  ld.StartTimer( ts*6, function() 
    ObjSet( "obj_casket_mmg2_root", { input = 0 } )
    ld.AnimPlay( "anm_casket_mmg2_anm_tree5", "tree_final", function() 
      ObjSet( "anm_casket_mmg2_anm_tree5", { animfunc = "tree_final_end", frame = 0 } )
      ObjSet( "spr_casket_snowqueen", { visible = 1, input = 1, active = 1 } )
      ObjAnimate( "obj_casket_mmg2_root", 8,0,0, func_end, { 0,0,1, 0.5,0,0 } )
    end )
  end )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_snowqueen" ] = { type = "get", get_obj = "spr_casket_snowqueen", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.get_snowqueen_logic = function()
  ObjSet( "gfx_casket_amuletelf3_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_snowqueen_inv = function()
  interface.InventoryItemAdd("inv_snowqueen","spr_casket_snowqueen");
end;
private.get_snowqueen_beg = function()
  ObjDelete("gfx_casket_snowqueen")
end;
private.get_snowqueen_end = function()
  
end;

cmn.AddSubscriber( "get_snowqueen_beg", private.get_snowqueen_inv );
cmn.AddSubscriber( "get_snowqueen_beg", private.get_snowqueen_beg, private.room_objname );
cmn.AddSubscriber( "get_snowqueen_end", private.get_snowqueen_end, private.room_objname );
cmn.AddSubscriber( "get_snowqueen_end", private.get_snowqueen_logic );
cmn.AddSubscriber( "get_snowqueen", private.get_snowqueen_inv );
cmn.AddSubscriber( "get_snowqueen", private.get_snowqueen_beg, private.room_objname );
cmn.AddSubscriber( "get_snowqueen", private.get_snowqueen_end, private.room_objname );
cmn.AddSubscriber( "get_snowqueen", private.get_snowqueen_logic );
--------------------------------------------------------------------
function public.get_snowqueen()
  
  local func_end = function()
    ld.Lock( 0 )
    cmn.SetEventDone( "get_snowqueen" );
    cmn.CallEventHandler( "get_snowqueen_end" );
  end

  ld.Lock( 1 )
  cmn.CallEventHandler( "get_snowqueen_beg" );

  gm.CubeBack( func_end )
  
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletelf3" ] = { type = "use", inv_obj = "inv_amuletelf3", use_place = "gfx_casket_amuletelf3_zone", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.use_amuletelf3_logic = function()
  ObjSet( "obj_casket_mmg3_root", { visible = 1, input = 1, active = 1 } )
end;
private.use_amuletelf3_inv = function()
  common_impl.ProcessMultiUseAll("amuletelf3", "amuletelf3")
end;
private.use_amuletelf3_beg = function()
  ObjDelete( "gfx_casket_amuletelf3_zone" );
end;
private.use_amuletelf3_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletelf3", private.use_amuletelf3_inv );
cmn.AddSubscriber( "use_amuletelf3", private.use_amuletelf3_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf3", private.use_amuletelf3_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf3", private.use_amuletelf3_logic );
cmn.AddSubscriber( "use_amuletelf3_inv", private.use_amuletelf3_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletelf3_beg", private.use_amuletelf3_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf3_end", private.use_amuletelf3_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf3_end", private.use_amuletelf3_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletelf3( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletelf3" );
    cmn.CallEventHandler( "use_amuletelf3_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletelf3_inv" );
  cmn.CallEventHandler( "use_amuletelf3_beg" );
  common_impl.Lock(1);

  gm.CubeUse( func_end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_casket3" ] = { type = "click", use_place = "obj_casket_mmg3_root", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.win_casket3_logic = function()
  if ld.CheckRequirements( { "win_casket3" } ) then
    ObjSet( "spr_casket_firtree", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_casket3_beg = function()

end;
private.win_casket3_end = function()
  if ld.CheckRequirements( { "win_casket3" } ) then
    ObjDelete( "obj_casket_mmg3_root" );
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_casket3", private.win_casket3_beg, private.room_objname );
cmn.AddSubscriber( "win_casket3", private.win_casket3_end, private.room_objname );
cmn.AddSubscriber( "win_casket3", private.win_casket3_logic );
cmn.AddSubscriber( "win_casket3_beg", private.win_casket3_beg, private.room_objname );
cmn.AddSubscriber( "win_casket3_end", private.win_casket3_end, private.room_objname );
cmn.AddSubscriber( "win_casket3_end", private.win_casket3_logic );
--------------------------------------------------------------------------------------------
function public.win_casket3()

  local func_end = function()
    cmn.SetEventDone( "win_casket3" );
    cmn.CallEventHandler( "win_casket3_end" );
    common_impl.Lock(0);
  end;

  cmn.MiniGameHide( "casket3", true )
  SoundMgTheme( false )
  gm.GateHalf( false )

  cmn.CallEventHandler( "win_casket3_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_win_casket3" )

  ObjSet( "spr_casket_firtree", { visible = 1, input = 1, active = 1 } )
  ObjAnimate( "spr_casket_firtree", 8,0,0, _, { 0,0,0, 0.5,0,1 } )
  ObjAnimate( "obj_casket_mmg3_root", 8,0,0, func_end, { 0,0,1, 0.5,0,0 } )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_firtree" ] = { type = "get", get_obj = "spr_casket_firtree", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.get_firtree_logic = function()
  ObjSet( "gfx_casket_amuletelf4_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_firtree_inv = function()
  interface.InventoryItemAdd("inv_firtree","spr_casket_firtree");
end;
private.get_firtree_beg = function()
  ObjDelete("gfx_casket_firtree")
end;
private.get_firtree_end = function()
  
end;

cmn.AddSubscriber( "get_firtree_beg", private.get_firtree_inv );
cmn.AddSubscriber( "get_firtree_beg", private.get_firtree_beg, private.room_objname );
cmn.AddSubscriber( "get_firtree_end", private.get_firtree_end, private.room_objname );
cmn.AddSubscriber( "get_firtree_end", private.get_firtree_logic );
cmn.AddSubscriber( "get_firtree", private.get_firtree_inv );
cmn.AddSubscriber( "get_firtree", private.get_firtree_beg, private.room_objname );
cmn.AddSubscriber( "get_firtree", private.get_firtree_end, private.room_objname );
cmn.AddSubscriber( "get_firtree", private.get_firtree_logic );
--------------------------------------------------------------------
function public.get_firtree()
  
  local func_end = function()
    ld.Lock( 0 )
    cmn.SetEventDone( "get_firtree" );
    cmn.CallEventHandler( "get_firtree_end" );
  end

  ld.Lock( 1 )
  cmn.CallEventHandler( "get_firtree_beg" );

  gm.CubeBack( func_end )
  
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletelf4" ] = { type = "use", inv_obj = "inv_amuletelf4", use_place = "gfx_casket_amuletelf4_zone", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.use_amuletelf4_logic = function()
  ObjSet( "obj_casket_mmg4_root", { visible = 1, input = 1, active = 1 } )

end;
private.use_amuletelf4_inv = function()
  common_impl.ProcessMultiUseAll("amuletelf4", "amuletelf4")
end;
private.use_amuletelf4_beg = function()
  ObjDelete( "gfx_casket_amuletelf4_zone" );
end;
private.use_amuletelf4_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletelf4", private.use_amuletelf4_inv );
cmn.AddSubscriber( "use_amuletelf4", private.use_amuletelf4_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf4", private.use_amuletelf4_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf4", private.use_amuletelf4_logic );
cmn.AddSubscriber( "use_amuletelf4_inv", private.use_amuletelf4_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletelf4_beg", private.use_amuletelf4_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf4_end", private.use_amuletelf4_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf4_end", private.use_amuletelf4_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletelf4( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletelf4" );
    cmn.CallEventHandler( "use_amuletelf4_end" );
    common_impl.Lock(0);
  if common_impl.ZzCompleteCheck( "use_amuletelf4" ) then cmn.GotoRoom( "rm_entrypoint" ); end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletelf4_inv" );
  cmn.CallEventHandler( "use_amuletelf4_beg" );
  common_impl.Lock(1);

  gm.CubeUse( func_end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_casket4" ] = { type = "click", use_place = "obj_casket_mmg4_root", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.win_casket4_logic = function()
  if ld.CheckRequirements( { "win_casket4" } ) then
    ObjSet( "spr_casket_hatamulet", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_casket4_beg = function()

end;
private.win_casket4_end = function()
  if ld.CheckRequirements( { "win_casket4" } ) then
    ObjDelete( "obj_casket_mmg4_root" );
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_casket4", private.win_casket4_beg, private.room_objname );
cmn.AddSubscriber( "win_casket4", private.win_casket4_end, private.room_objname );
cmn.AddSubscriber( "win_casket4", private.win_casket4_logic );
cmn.AddSubscriber( "win_casket4_beg", private.win_casket4_beg, private.room_objname );
cmn.AddSubscriber( "win_casket4_end", private.win_casket4_end, private.room_objname );
cmn.AddSubscriber( "win_casket4_end", private.win_casket4_logic );
--------------------------------------------------------------------------------------------
function public.win_casket4()

  local func_end = function()
    cmn.SetEventDone( "win_casket4" );
    cmn.CallEventHandler( "win_casket4_end" );
    common_impl.Lock(0);
  end;

  cmn.MiniGameHide( "casket4", true )
  SoundMgTheme( false )
  gm.GateHalf( false )

  cmn.CallEventHandler( "win_casket4_beg" );
  common_impl.Lock(1);

  local t = 1
  ObjAnimate( "obj_casket_mmg4_root", 8,0,0, _, { 0,0,1, t,0,0 } )
  ObjSet( "spr_casket_hatamulet", { visible = 1, input = 1, active = 1, alp = 0 } )
  ObjAnimate( "spr_casket_hatamulet", 8,0,0, func_end, { 0,0,0, t,0,1 } )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hatamulet" ] = { type = "get", get_obj = "spr_casket_hatamulet", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.get_hatamulet_logic = function()
  ObjSet( "gfx_casket_amuletelf5_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_hatamulet_inv = function()
  interface.InventoryItemAdd("inv_hatamulet","spr_casket_hatamulet");
end;
private.get_hatamulet_beg = function()
  ObjDelete("gfx_casket_hatamulet")
end;
private.get_hatamulet_end = function()
  
end;

cmn.AddSubscriber( "get_hatamulet_beg", private.get_hatamulet_inv );
cmn.AddSubscriber( "get_hatamulet_beg", private.get_hatamulet_beg, private.room_objname );
cmn.AddSubscriber( "get_hatamulet_end", private.get_hatamulet_end, private.room_objname );
cmn.AddSubscriber( "get_hatamulet_end", private.get_hatamulet_logic );
cmn.AddSubscriber( "get_hatamulet", private.get_hatamulet_inv );
cmn.AddSubscriber( "get_hatamulet", private.get_hatamulet_beg, private.room_objname );
cmn.AddSubscriber( "get_hatamulet", private.get_hatamulet_end, private.room_objname );
cmn.AddSubscriber( "get_hatamulet", private.get_hatamulet_logic );
--------------------------------------------------------------------
function public.get_hatamulet()
  local func_end = function()
    ld.Lock( 0 )
    cmn.SetEventDone( "get_hatamulet" );
    cmn.CallEventHandler( "get_hatamulet_end" );
  end

  ld.Lock( 1 )
  cmn.CallEventHandler( "get_hatamulet_beg" );

  gm.CubeBack( func_end )
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletelf5" ] = { type = "use", inv_obj = "inv_amuletelf5", use_place = "gfx_casket_amuletelf5_zone", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.use_amuletelf5_logic = function()
  ObjSet( "obj_casket_mmg5_root", { visible = 1, input = 1, active = 1 } )
end;
private.use_amuletelf5_inv = function()
  common_impl.ProcessMultiUseAll("amuletelf5", "amuletelf5")
end;
private.use_amuletelf5_beg = function()
  ObjDelete( "gfx_casket_amuletelf5_zone" );
end;
private.use_amuletelf5_end = function()
  ObjSet( "spr_casket_horn", { visible = 1 } )
  ObjSet( "anm_casket_mmg5_anm", { animfunc = "open", frame = 999 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletelf5", private.use_amuletelf5_inv );
cmn.AddSubscriber( "use_amuletelf5", private.use_amuletelf5_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf5", private.use_amuletelf5_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf5", private.use_amuletelf5_logic );
cmn.AddSubscriber( "use_amuletelf5_inv", private.use_amuletelf5_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletelf5_beg", private.use_amuletelf5_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf5_end", private.use_amuletelf5_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf5_end", private.use_amuletelf5_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletelf5( obj )

  local lockCount = 2

  local func_end = function()
    cmn.SetEventDone( "use_amuletelf5" );
    lockCount = lockCount - 1
    if lockCount <= 0 then
      ld.Lock( 0 )
    end
  end;

  local func_step = function()
    ObjSet( "spr_casket_horn", { visible = 1, alp = 0 } )
    ObjAnimate( "spr_casket_horn", 8,0,0, _, { 0,0,0, 0.5,0,1 } )
    ld.AnimPlay( "anm_casket_mmg5_anm", "open", function() 
      cmn.CallEventHandler( "use_amuletelf5_end" );
      lockCount = lockCount - 1
      if lockCount <= 0 then
        ld.Lock( 0 )
      end
    end );
  end

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletelf5_inv" );
  cmn.CallEventHandler( "use_amuletelf5_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_use_amuletelf5_jewelryshop" )
  gm.CubeUse( func_end, func_step )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_casket5" ] = { type = "click", use_place = "obj_casket_mmg5_root", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.win_casket5_logic = function()
  if ld.CheckRequirements( { "win_casket5" } ) then
    ObjSet( "spr_casket_horn", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_casket5_beg = function()

end;
private.win_casket5_end = function()
  if ld.CheckRequirements( { "win_casket5" } ) then
    ObjSet( "spr_casket_horn", { color_r = 1, color_g = 1, color_b = 1 } )
    ObjDelete( "obj_casket_mmg5_root" );
    ObjSet( "gfx_casket_horn", { active = 1 } )
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_casket5", private.win_casket5_beg, private.room_objname );
cmn.AddSubscriber( "win_casket5", private.win_casket5_end, private.room_objname );
cmn.AddSubscriber( "win_casket5", private.win_casket5_logic );
cmn.AddSubscriber( "win_casket5_beg", private.win_casket5_beg, private.room_objname );
cmn.AddSubscriber( "win_casket5_end", private.win_casket5_end, private.room_objname );
cmn.AddSubscriber( "win_casket5_end", private.win_casket5_logic );
--------------------------------------------------------------------------------------------
function public.win_casket5()

  local func_end = function()
    cmn.SetEventDone( "win_casket5" );
    cmn.CallEventHandler( "win_casket5_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "win_casket5_beg" );
  common_impl.Lock(1);

  cmn.MiniGameHide( "casket5", true )
  SoundMgTheme( false )
  gm.GateHalf( false )

  ObjSet( "spr_casket_horn", { visible = 1, input = 1, active = 1 } )
  local o = ObjGet( "spr_casket_horn" )
  ObjAnimate( o.name, 12,0,0, _, { 0,0,o.color_r,o.color_g,o.color_b, 1,0,o.color_r,o.color_g,o.color_b, 1.5,0,1,1,1 } )
  ld.AnimPlay( "anm_casket_mmg5_anm", "final", func_end )

  SoundSfx( "aud_win_snowflike_casket" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_horn" ] = { type = "get", get_obj = "spr_casket_horn", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.get_horn_logic = function()
  ObjSet( "gfx_casket_amuletelf6_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_horn_inv = function()
  interface.InventoryItemAdd("inv_horn","spr_casket_horn");
end;
private.get_horn_beg = function()
  ObjDelete("gfx_casket_horn")
end;
private.get_horn_end = function()
  
end;
cmn.AddSubscriber( "get_horn_beg", private.get_horn_inv );
cmn.AddSubscriber( "get_horn_beg", private.get_horn_beg, private.room_objname );
cmn.AddSubscriber( "get_horn_end", private.get_horn_end, private.room_objname );
cmn.AddSubscriber( "get_horn_end", private.get_horn_logic );
cmn.AddSubscriber( "get_horn", private.get_horn_inv );
cmn.AddSubscriber( "get_horn", private.get_horn_beg, private.room_objname );
cmn.AddSubscriber( "get_horn", private.get_horn_end, private.room_objname );
cmn.AddSubscriber( "get_horn", private.get_horn_logic );
--------------------------------------------------------------------
function public.get_horn()
  local func_end = function()
    ld.Lock( 0 )
    cmn.SetEventDone( "get_horn" );
    cmn.CallEventHandler( "get_horn_end" );
  end

  ld.Lock( 1 )
  cmn.CallEventHandler( "get_horn_beg" );

  gm.CubeBack( func_end )
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletelf6" ] = { type = "use", inv_obj = "inv_amuletelf6", use_place = "gfx_casket_amuletelf6_zone", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.use_amuletelf6_logic = function()
  ObjSet( "obj_casket_mmg6_root", { visible = 1, input = 1, active = 1 } )
end;
private.use_amuletelf6_inv = function()
  common_impl.ProcessMultiUseAll("amuletelf6", "amuletelf6")
end;
private.use_amuletelf6_beg = function()
  ObjDelete( "gfx_casket_amuletelf6_zone" );
end;
private.use_amuletelf6_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletelf6", private.use_amuletelf6_inv );
cmn.AddSubscriber( "use_amuletelf6", private.use_amuletelf6_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf6", private.use_amuletelf6_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf6", private.use_amuletelf6_logic );
cmn.AddSubscriber( "use_amuletelf6_inv", private.use_amuletelf6_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletelf6_beg", private.use_amuletelf6_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf6_end", private.use_amuletelf6_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf6_end", private.use_amuletelf6_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletelf6( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletelf6" );
    cmn.CallEventHandler( "use_amuletelf6_end" );
    common_impl.Lock(0);
  if common_impl.ZzCompleteCheck( "use_amuletelf6" ) then cmn.GotoRoom( "rm_entrypoint" ); end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletelf6_inv" );
  cmn.CallEventHandler( "use_amuletelf6_beg" );
  common_impl.Lock(1);

  gm.CubeUse( func_end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_casket6" ] = { type = "click", use_place = "obj_casket_mmg6_root", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.win_casket6_logic = function()
  if ld.CheckRequirements( {"win_casket6"} ) then
    ObjSet( "spr_casket_shell", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.win_casket6_beg = function()

end;
private.win_casket6_end = function()
  if ld.CheckRequirements( {"win_casket6"} ) then
    --ObjDelete( "obj_casket_mmg6_root" );
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_casket6", private.win_casket6_beg, private.room_objname );
cmn.AddSubscriber( "win_casket6", private.win_casket6_end, private.room_objname );
cmn.AddSubscriber( "win_casket6", private.win_casket6_logic );
cmn.AddSubscriber( "win_casket6_beg", private.win_casket6_beg, private.room_objname );
cmn.AddSubscriber( "win_casket6_end", private.win_casket6_end, private.room_objname );
cmn.AddSubscriber( "win_casket6_end", private.win_casket6_logic );
--------------------------------------------------------------------------------------------
function public.win_casket6()

  local func_end = function()
    cmn.SetEventDone( "win_casket6" );
    cmn.CallEventHandler( "win_casket6_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "win_casket6_beg" );
  common_impl.Lock(1);

  cmn.MiniGameHide( "casket6", true )
  SoundMgTheme( false )
  gm.GateHalf( false )

  --ObjSet( "spr_casket_shell", { visible = 1, input = 1, active = 1 } )
  --ObjAnimate( "spr_casket_shell", 8,0,0, _, { 0,0,0, 0.5,0,1 } )
  --ObjAnimate( "obj_casket_mmg6_root", 8,0,0, func_end, { 0,0,1, 0.5,0,0 } )

  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_shell" ] = { type = "get", get_obj = "spr_casket_shell", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.get_shell_logic = function()
  ObjSet( "gfx_casket_amuletelf7_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_shell_inv = function()
  interface.InventoryItemAdd("inv_shell","spr_casket_shell");
end;
private.get_shell_beg = function()
  ObjDelete("gfx_casket_shell")
end;
private.get_shell_end = function()
  
end;

cmn.AddSubscriber( "get_shell_beg", private.get_shell_inv );
cmn.AddSubscriber( "get_shell_beg", private.get_shell_beg, private.room_objname );
cmn.AddSubscriber( "get_shell_end", private.get_shell_end, private.room_objname );
cmn.AddSubscriber( "get_shell_end", private.get_shell_logic );
cmn.AddSubscriber( "get_shell", private.get_shell_inv );
cmn.AddSubscriber( "get_shell", private.get_shell_beg, private.room_objname );
cmn.AddSubscriber( "get_shell", private.get_shell_end, private.room_objname );
cmn.AddSubscriber( "get_shell", private.get_shell_logic );
--------------------------------------------------------------------
function public.get_shell()
  
  local func_end = function()
    ld.Lock( 0 )
    cmn.SetEventDone( "get_shell" );
    cmn.CallEventHandler( "get_shell_end" );
  end

  ld.Lock( 1 )
  cmn.CallEventHandler( "get_shell_beg" );

  gm.CubeBack( func_end )
  
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletelf7" ] = { type = "use", inv_obj = "inv_amuletelf7", use_place = "gfx_casket_amuletelf7_zone", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.use_amuletelf7_logic = function()
  ObjSet( "obj_casket_mmg7_root", { visible = 1, input = 1, active = 1 } )
end;
private.use_amuletelf7_inv = function()
  common_impl.ProcessMultiUseAll("amuletelf7", "amuletelf7")
end;
private.use_amuletelf7_beg = function()
  ObjDelete( "gfx_casket_amuletelf7_zone" );
end;
private.use_amuletelf7_end = function()
  ObjSet( "obj_casket_mmg7_root", { input = 1 } )
  ObjSet( "anm_casket_mmg7_anm", { animfunc = "first_stop", frame = 0 } )
  ObjSet( "anm_casket_mmg7_anm_paint_1", { visible = 1 } )
  ObjSet( "anm_casket_mmg7_anm_paint_2", { visible = 1 } )
  ObjSet( "anm_casket_mmg7_anm_paint_3", { visible = 1 } )
  ObjSet( "anm_casket_mmg7_anm_paint_4", { visible = 1 } )
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletelf7", private.use_amuletelf7_inv );
cmn.AddSubscriber( "use_amuletelf7", private.use_amuletelf7_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf7", private.use_amuletelf7_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf7", private.use_amuletelf7_logic );
cmn.AddSubscriber( "use_amuletelf7_inv", private.use_amuletelf7_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletelf7_beg", private.use_amuletelf7_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletelf7_end", private.use_amuletelf7_end, private.room_objname );
cmn.AddSubscriber( "use_amuletelf7_end", private.use_amuletelf7_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletelf7( obj )

  local lockCount = 2

  local func_end = function()
    cmn.SetEventDone( "use_amuletelf7" );
    lockCount = lockCount - 1
    if lockCount <= 0 then
      ld.Lock( 0 )
    end
  end;

  local func_step = function()
    ld.AnimPlay( "anm_casket_mmg7_anm", "first", function() 
      cmn.CallEventHandler( "use_amuletelf7_end" );
      lockCount = lockCount - 1
      if lockCount <= 0 then
        ld.Lock( 0 )
      end
    end );
  end

  cmn.CallEventHandler( "use_amuletelf7_inv" );
  cmn.CallEventHandler( "use_amuletelf7_beg" );
  common_impl.Lock(1);

  gm.CubeUse( func_end, func_step )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_casket7" ] = { type = "click", use_place = "obj_casket_mmg7_root", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.win_casket7_logic = function()
  if ld.CheckRequirements( { "win_casket7" } ) then
    ObjSet( "spr_casket_newangel", { visible = 1, input = 1, active = 1, alp = 0, pos_z = -1 } )
  end
end;
private.win_casket7_beg = function()

end;
private.win_casket7_end = function()
  if ld.CheckRequirements( { "win_casket7" } ) then
    ObjDelete( "obj_casket_mmg7_root" );
    ObjSet( "txt_casket_txt_casket_ends", { alp = 1 } )
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_casket7", private.win_casket7_beg, private.room_objname );
cmn.AddSubscriber( "win_casket7", private.win_casket7_end, private.room_objname );
cmn.AddSubscriber( "win_casket7", private.win_casket7_logic );
cmn.AddSubscriber( "win_casket7_beg", private.win_casket7_beg, private.room_objname );
cmn.AddSubscriber( "win_casket7_end", private.win_casket7_end, private.room_objname );
cmn.AddSubscriber( "win_casket7_end", private.win_casket7_logic );
--------------------------------------------------------------------------------------------
function public.win_casket7()

  local func_end = function()
    cmn.SetEventDone( "win_casket7" );
    cmn.CallEventHandler( "win_casket7_end" );
    common_impl.Lock(0);
    ld.ShowBbt("after_casket_last_game");
  end;

  cmn.CallEventHandler( "win_casket7_beg" );
  common_impl.Lock(1);

  cmn.MiniGameHide( "casket7", true )
  SoundMgTheme( false )
  gm.GateHalf( false )
  --ObjSet( "spr_casket_newangel", { visible = 1, alp = 0, active = 1, pos_z = -1 } )

  SoundSfx( "aud_win_last_casket_mg" )

  ObjSet( "anm_casket_mmg7_anm", { animfunc = "final", frame = 0 } )
  ObjAnimate( "obj_casket_mmg7_bucket_root", 8,0,0, function() 
    ld.AnimPlay( "anm_casket_mmg7_anm", "final", nil );
    ObjDelete( "obj_casket_mmg7_bucket_root" );
    ld.StartTimer( 0.6, function()
      ld.AnimPlay( "anm_casket_anm_cube", "cube_anim_death", func_end )
      ObjAnimate( "txt_casket_txt_casket_ends", 8,0,0, nil, {  0,0,0, 2.1,0,0, 2.35,0,1 } )
    end )
  end, { 0,0,1, 1.0,0,1, 1.5,0,0 } )

  --ObjAnimate( "spr_casket_newangel", 8,0,0, nil, { 0,0,0, 0.5,0,1 } )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_newangel" ] = { type = "get", get_obj = "spr_casket_newangel", room = "rm_entrypoint", zz = "mg_casket", zz_gate = "gmg_entrypoint_casket" };

private.get_newangel_logic = function()
  interface.InventoryItemRemove("inv_casket");
  interface.InventoryItemAdd("inv_newangel","spr_casket_newangel_fake");
end;
private.get_newangel_inv = function()

end;
private.get_newangel_beg = function()
  ObjDelete("gfx_casket_newangel")
end;
private.get_newangel_end = function()
  
end;

cmn.AddSubscriber( "get_newangel_beg", private.get_newangel_inv );
cmn.AddSubscriber( "get_newangel_beg", private.get_newangel_beg, private.room_objname );
cmn.AddSubscriber( "get_newangel_end", private.get_newangel_end, private.room_objname );
cmn.AddSubscriber( "get_newangel_end", private.get_newangel_logic );
cmn.AddSubscriber( "get_newangel", private.get_newangel_inv );
cmn.AddSubscriber( "get_newangel", private.get_newangel_beg, private.room_objname );
cmn.AddSubscriber( "get_newangel", private.get_newangel_end, private.room_objname );
cmn.AddSubscriber( "get_newangel", private.get_newangel_logic );
--------------------------------------------------------------------
function public.get_newangel()
  
  local func_end = function()
    ld.Lock( 0 )
    cmn.SetEventDone( "get_newangel" );
    cmn.CallEventHandler( "get_newangel_end" );
    int_cube.GoOut()
    cmn.SetEventDone( "win_casket" );
    ld.ShowBbt( "after_get_newangel" )
  end

  ld.Lock( 1 )
  ObjSet( "spr_casket_newangel", { visible = 0, input = 0, alp = 0 } )
  ObjSet( "spr_casket_newangel_fake", { visible = 1, active = 1, alp = 0 } )
  cmn.CallEventHandler( "get_newangel_beg" );

  --ld.LogTrace( ObjGet( "txt_casket_txt_casket_ends" ) )
  
  SoundSfx( "aud_get_golden_plate" )

  ObjAnimate( "txt_casket_txt_casket_ends", 8,0,0, function() 
    ld.AnimPlay( "anm_casket_anm_cube", "cube_anim_death2", func_end )
    ObjAnimate( "spr_casket_newangel_fake", 8,0,0, nil, { 0,0,0, 0.16,0,0, 0.5,0,1 } )
  end, { 0,0,1, 0.25,0,0 } )
  
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  --if not ld.CheckRequirements( {"win_casket"} ) then
  --  cmn.MiniGameShow( "casket" );
  --end

  if not ld.CheckRequirements( { "use_amuletelf1" } ) and not private.bbt_casket_jack then
    ld.ShowBbt( "casket_jack", "jack", "aud_jack_frost_5_voc" )
    private.bbt_casket_jack = true
  end

  level.tutorial_use.first()
  level.tutorial_mg.first()

  ld.LogTrace( GetCurrentRoom(), common.GetCurrentRoom() )

end;
--*********************************************************************************************************************
function public.PreOpen()
  --SoundEnv( "aud_mg_casket_env" )
  gm.load();

--  local cube_state = int_cube.GetState();
--  if cube_state.Passive then
--    gm.CubeSleep()
--  elseif cube_state.Opened then
--    gm.CubeOut()
--  elseif cube_state.Active then
--    gm.CubeAnim()
--    SoundEnv( "aud_mg_casket_env" )
--  end
--
  local mg_num = gm.GetActiveGame()
  if ld.CheckRequirements( { "win_casket7" } ) then
    ObjSet( "anm_casket_anm_cube", { animfunc = "cube_anim_death2", frame = 0 } )
    ObjSet( "txt_casket_txt_casket_ends", { visible = 1, input = 1, active = 1 } )
    SoundEnv( "aud_mg_casket_1_env" )
  elseif not ld.CheckRequirements( { "use_amuletelf"..mg_num } ) then
    if ld.CheckRequirements( { "get_amuletelf"..mg_num } ) then
      gm.CubeAnim()
    elseif common_impl.hint[ "use_amuletelf"..mg_num ]
    and common_impl.hint[ "use_amuletelf"..mg_num ].use_place
    and ObjGet( common_impl.hint[ "use_amuletelf"..mg_num ].use_place )
    and ObjGet( common_impl.hint[ "use_amuletelf"..mg_num ].use_place ).input then
      gm.CubeSleep();
    else
      gm.CubeOut();
    end
  elseif cmn.IsEventStart( "win_casket"..mg_num ) then
    gm.CubeOut();
  end

end;
--*********************************************************************************************************************
function public.Close()
  local mg_num = gm.GetActiveGame()
  if cmn.IsEventStart( "win_casket"..mg_num ) and not ld.CheckRequirements( {"win_casket"..mg_num} ) then
    cmn.MiniGameHide( "casket"..mg_num );
    SoundMgTheme( false )
  end
  gm.GateHalf( false )
end;
--*********************************************************************************************************************
function public.PreClose()
  int_cube.Return()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  if ld.Lock( 1 ) then
    gm[ "mmg"..gm.GetActiveGame() ].reset()
  end
end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  if ld.Lock( 1 ) then
    gm[ "mmg"..gm.GetActiveGame() ].skip()
  end
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_casket" );
  cmn.CallEventHandler( "win_casket" );
  interface_impl.ShowMgAchievements();
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide();
  ld.StartTimer( 0.5, private.WinEnd  );
end;
--*********************************************************************************************************************
function gm.manager_obj_init( name, obj_type, obj_owner, obj_set )
  gm.manager_objs = gm.manager_objs or {}
  gm.manager_trash = gm.manager_trash or {}
  gm.manager_trash[ name ] = {}
  gm.manager_counter = gm.manager_counter or {}
  gm.manager_counter[ name ] = 0 
  gm.manager_obj_type = gm.manager_obj_type or {}
  gm.manager_obj_type[ name ] = obj_type
  gm.manager_obj_owner = gm.manager_obj_owner or {}
  gm.manager_obj_owner[ name ] = obj_owner
  gm.manager_obj_set = gm.manager_obj_set or {}
  gm.manager_obj_set[ name ] = obj_set
end;
  function   gm.manager_clear()
    for k, v in pairs( gm.manager_objs ) do
      ObjDelete( k )
    end;
    gm.manager_objs = nil
    gm.manager_trash = nil
    gm.manager_counter = nil
    gm.manager_obj_type = nil
    gm.manager_obj_owner = nil
    gm.manager_obj_set = nil
  end;
  function   gm.manager_obj_get( name, life_time )
    local obj
    if #gm.manager_trash[ name ] == 0 then
      gm.manager_counter[ name ] = gm.manager_counter[ name ] + 1
      obj = gm.manager_obj_type[ name ].."_seedmg_"..name.."_"..gm.manager_counter[ name ]
      ObjCreate( obj, gm.manager_obj_type[ name ] )
      ObjSet( obj, gm.manager_obj_set[ name ] )
      gm.manager_objs[ obj ] = name
    else
      obj = table.remove( gm.manager_trash[ name ] )
    end
    ObjAttach( obj, gm.manager_obj_owner[ name ] )
    if life_time then
      ld.StartTimer( "tmr_manager_obj_detach_"..obj, life_time, function() gm.manager_obj_detach( obj ) end )
    end;
    return obj;
  end
  function   gm.manager_obj_detach( obj, time, func_end )
    local func = function() 
      if gm.manager_objs then
        table.insert( gm.manager_trash[ gm.manager_objs[ obj ] ], obj )
        ObjDetach( obj )
        if func_end then
          func_end()
        end
      else
        ObjDelete( obj )
      end
    end
    if time then
      ld.StartTimer( "tmr_manager_obj_detach_"..obj, time, func )
    else
      func();
    end
  end
  function   gm.manager_obj_disable( obj )
    table.insert( gm.manager_trash[ gm.manager_objs[ obj ] ], obj )
  end
--*********************************************************************************************************************
function gm.len( x1, y1, x2, y2 )
  return ( (x1-x2)^2 +(y1-y2)^2 )^0.5
end
--[[********************************************************************]]
--[[  возвращает угол между прямой и осью ОХ, расстояние между точками  ]]
--[[--------------------------------------------------------------------]]
function gm.ang_gip( x1, y1, x2, y2, len )
  x2 = x2 or 0;
  y2 = y2 or 0;
  len = len or ( (x1-x2)^2 +(y1-y2)^2 )^0.5
  y1=-y1; --переворот для игровой системы координат
  y2=-y2; --переворот для игровой системы координат
  if len == 0 then return 0,0 end --исключение
  local k = ( y1 - y2 ) / len
  local a = math.abs( math.asin( k ) )
  if x2 >= x1 and y2 <= y1 then
    a = math.pi*2 - a
    return a,len
  elseif x2 >= x1 and y2 >= y1 then
    return a,len
  elseif x2 <= x1 and y2 <= y1 then
    a = math.pi + a
    return a,len
  elseif x2 <= x1 and y2 >= y1 then
    a = math.pi - a
    return a,len
  end;
end
--[[********************************************************************]]
--[[                                                                    ]]
--[[--------------------------------------------------------------------]]

--[[*****************************************************]]
--[[  возвращаяет угол в пределах 0 <= ang <= math.pi*2  ]]
--[[-----------------------------------------------------]]
function gm.ang_norm( ang )
  while ang > math.pi * 2 do ang = ang - math.pi * 2 end
  while ang < 0 do ang = ang + math.pi * 2 end
  return ang
end;
--[[*****************************************************]]
--[[  возвращаяет угол в пределах 0 <= ang <= math.pi*2  ]]
--[[-----------------------------------------------------]]

--[[**********************************************************]]
--[[  вернет a_beg, a_beg+math.pi*2, или a_beg-math.pi*2      ]]
--[[  для кратчайшей анимации поворота угла от a_beg к a_end  ]]
--[[----------------------------------------------------------]]
function gm.ang_closer( a_beg, a_end )
  if math.abs(a_beg-a_end) > math.pi then
    if a_beg > a_end then
      a_beg = a_beg - math.pi * 2
    else
      a_beg = a_beg + math.pi * 2
    end;
  end;
  return a_beg;
end;
--[[----------------------------------------------------------]]
--[[          0 <= ( a_beg и a_end ) <= math.pi*2             ]]
--[[**********************************************************]]
function gm.obj_drop( obj, vx, vy, g )
  vx = vx or math.random(-30,30)
  vy = vy or math.random(-60,-30)
  g = g or 40

  vx = vx * 0.1
  vy = vy * 0.1
  g = g * 0.1

  local o = ObjGet( obj )

  local ts = 0.05
  local t = 0
  local y = o.pos_y
  local x = o.pos_x
  local anm = {}

  repeat
    table.insert( anm, t )
    table.insert( anm, 0 )
    table.insert( anm, x )
    table.insert( anm, y )
    x = x + vx
    y = y + vy
    vy = vy + g
    t = t + ts
  until y > 1400
  --ld.LogTrace( anm )
  ObjAnimate( o.name, 6,0,0, _, {0,0,1,1, 0.4,2,1.1,1.1} )
  ObjAnimate( o.name, 7,0,0, _, {0,0,o.ang, t,2,o.ang + math.random()*0.5*(math.random(0,1) == 0 and 1 or -1)} )
  ObjAnimate( o.name, 3,0,0, _, anm )
  --ld.LogTrace( t )
  ld.StartTimer( "tmr_mechanisms_"..o.name, t, function()
    ObjStopAnimate(o.name,3)
    ObjStopAnimate(o.name,6)
    ObjStopAnimate(o.name,7)
    ObjSet( o.name, { pos_x = x, pos_y = y } ) 
  end )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
  function gm.GateHalf( enable )
    if enable then
      local gate = ObjGet( "grm_casket_entrypoint" )
      if gate then
        private.MiniGameShow_gate_half = {
          name = gate.name;
          inputrect_y = gate.inputrect_y;
        }
        ObjSet( gate.name, { 
          inputrect_y = gate.inputrect_y + gate.inputrect_h / 2;
        } )
      end
    else
      if private.MiniGameShow_gate_half then
        local gate = ObjGet( private.MiniGameShow_gate_half.name )
        if gate then
          ObjSet( gate.name, { 
            inputrect_y = private.MiniGameShow_gate_half.inputrect_y;
          } )
          private.MiniGameShow_gate_half = false
        end
      end;
    end
  end
  function gm.CubeUse( func_end, func_step )
    gm.CubeUseFunc = func_end
    gm.CubeUseFuncStep = func_step
  end
  function gm.CubeBack( func_end )
    SoundSfx( "aud_casket_construct" )
    ld.AnimPlay( "anm_casket_anm_cube", "cube_anim_close", function() 
      if func_end then
        func_end()
        gm.CubeSleep( int_cube.GoOut )
      end
    end )
  end
  function gm.CubeSleep( func_end )
    SoundEnv( "aud_mg_casket_1_env" )
    ObjSet( "anm_casket_anm_cube", { animfunc = "cube_cikl", frame = 0, playing = 0 } )
    if func_end then
      func_end();
    end
  end
  function gm.CubeOut()
    local mg_num = gm.GetActiveGame()
    if ng_global.progress["std"]["win_casket"..mg_num] and cmn.IsEventStart( "win_casket"..mg_num ) and not ld.CheckRequirements( {"win_casket"..mg_num} ) then
      gm.GateHalf( true )
    end
    SoundEnv( "aud_mg_casket_1_env" )
    ObjSet( "anm_casket_anm_cube", { animfunc = "", frame = 0, playing = 0 } )
  end
  function gm.CubeAnim()
    if gm.CubeUseFunc then

      local mg_num = gm.GetActiveGame();
      --gm[ "load_mmg"..mg_num ]( "no_attach" );
      --ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
      --ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 0; alp = 0; } )

      ld.StartTimer( 2, function() 
        ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 1, active = 1 } )
        ObjAnimate( "obj_casket_mmg"..mg_num.."_root", 8,0,0, _, { 0,0,0, 0.5,0,1 } )
        if gm.CubeUseFuncStep then
          gm.CubeUseFuncStep();
          gm.CubeUseFuncStep = false
        end
      end )
      SoundEnv( "aud_mg_casket_1_env" )
      SoundSfx( "aud_casket_amulet" )
      ld.AnimPlay( "anm_casket_anm_cube", "cube_anim", function() 
        gm.CubeUseFunc();
        cmn.MiniGameShow( "casket"..mg_num );
        SoundMgTheme( true )
        gm.CubeOut()
        gm.CubeUseFunc = false
      end )
    else
      SoundEnv( "aud_mg_casket_env" )
      ld.AnimPlay( "anm_casket_anm_cube", "cube_cikl", gm.CubeAnim )
    end
  end
  function gm.GetActiveGame()
    for i = 1, 7 do
      if not ng_global.progress["std"]["win_casket"..i] then
        return "";
      end
      if not cmn.IsEventDone( "win_casket"..i ) then
        return i;
      end
    end
    return "";
  end

  function gm.load()
    
    local mg_num = gm.GetActiveGame();
    --ld.LogTrace( mg_num, cmn.IsEventStart( "win_casket"..mg_num ), cmn.IsEventDone( "win_casket"..mg_num ) )
    if gm[ "load_mmg"..mg_num ] and not cmn.IsEventDone( "win_casket"..mg_num ) then
      if cmn.IsEventStart( "win_casket"..mg_num ) or ld.CheckRequirements( { "use_amuletelf"..mg_num } ) then
        gm[ "load_mmg"..mg_num ](  );
      else
        gm[ "load_mmg"..mg_num ]( "no_attach" );
      end
    end

  end

  --*********************************************************************************************************************
  function gm.event_menter( obj, time_scale, alp )
    ld.ShCur(CURSOR_HAND)
    time_scale = time_scale or 0.25
    alp = alp or 0.5
    obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
    obj = obj.."_light"
    local o = ObjGet( obj )
    if not o then
      obj = obj:gsub( "_light$", "" )
      o = ObjGet( obj )
    end
    if o then
      ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (alp-o.alp)*time_scale,0,alp } )
    end
  end;
  --*********************************************************************************************************************
  function gm.event_mleave( obj, time_scale, alp )
    ld.ShCur(CURSOR_DEFAULT)
    time_scale = time_scale or 0.25
    alp = alp or 0.5
    obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
    obj = obj.."_light"
    local o = ObjGet( obj )
    if not o then
      obj = obj:gsub( "_light$", "" )
      o = ObjGet( obj )
    end
    if o then
      ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)*time_scale,0,0 } )
    end
  end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG 0 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load_mmg0( param )
  
  local mg_num = 0;

  gm[ "mmg"..mg_num ] = gm[ "mmg"..mg_num ] or {}
  local gm = gm[ "mmg"..mg_num ]

  if not gm[ "loaded_mmg"..mg_num ] then
    gm[ "loaded_mmg"..mg_num ] = true;
    function gm.default() 

    end
    
    function gm.save()
      ng_global.progress[ "std" ][ "win_casket"..mg_num ].state = ld.TableCopy( gm.state )
    end
    function gm.reset()
      local func_end = function()
        gm.default()
        gm.save()
        gm.set_all()
        ld.Lock( 0 )
      end
      ld.Lock( 1 )
      func_end()
    end
    function gm.skip()
      local func_end = function()
        gm.win()
      end
      ld.Lock( 1 )
      func_end()
    end
    function gm.win()
      ld.Lock( 1 )
      public[ "win_casket"..mg_num ]()
    end

    function gm.win_check()

    end

    function gm.event_end()
      if gm.win_check() then
        gm.win()
      else
        gm.save()
        ld.Lock( 0 )
      end
    end

    function gm.event_mdown()
      if ld.Lock( 1 ) then
        gm.event_end()
      end
    end

    function gm.init()

    end

    function gm.set_all()

    end

    gm.default()

    if ng_global.progress[ "std" ][ "win_casket"..mg_num ].state then
      gm.state = ld.TableCopy( ng_global.progress[ "std" ][ "win_casket"..mg_num ].state )
    end

    gm.init()
    gm.set_all()

    if param == "no_attach" then
      ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
      ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 0; alp = 0; } )
    else
      ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
      ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 1; alp = 1; } )
    end
  else
    
  end
  
  if param ~= "no_attach" then
    cmn.MiniGameShow( "casket"..mg_num );
    SoundMgTheme( true )
  end
  
end

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG 1 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load_mmg1( param )
  
  gm.mmg1 = gm.mmg1 or {}
  local gm = gm.mmg1

  local mg_num = 1;

  if not gm.loaded_mmg1 then

    gm.loaded_mmg1 = true;

    function gm.default() 
      gm.choise = false
      gm.map = {
        {{2,1},{3,1},{2,2},{3,2}};
        {{3,3},{1,1},{3,4},{1,2}};
        {{1,3},{2,3},{1,4},{2,4}};
      }
    end

    function gm.save()
      ng_global.progress[ "std" ][ "win_casket"..mg_num ].state = ld.TableCopy( gm.map )
    end

    function gm.happynes()
      for j = 1, #gm.map do
        local happy = true
        for i = 1, #gm.map[ j ] do
          if gm.map[ j ][ i ][ 1 ] ~= j then
            happy = false;
            break;
          end;
        end;
        if happy then
          local o = ObjGet( "anm_casket_mmg1_anm_biscuit"..j )
          if o.animfunc == "biscuit"..j then
            ld.AnimPlay( o.name, "biscuit"..j.."_smile", function() 
              ld.AnimPlay( o.name, "biscuit"..j.."_smile_c", _ );
            end )
          end
        else
          local o = ObjGet( "anm_casket_mmg1_anm_biscuit"..j )
          if o.animfunc ~= "biscuit"..j then
            ld.AnimPlay( o.name, "biscuit"..j, _ )
          end
        end
      end
    end

    function gm.set_all()
      local o
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          o = ObjGet( "obj_casket_mmg1_get_"..j.."_"..i )
          ObjSet( "spr_casket_mmg1_get_"..gm.map[ j ][ i ][ 1 ].."_"..gm.map[ j ][ i ][ 2 ], { pos_x = o.pos_x; pos_y = o.pos_y; } )
          --ObjAttach( "spr_casket_mmg1_get_"..gm.map[ j ][ i ][ 1 ].."_"..gm.map[ j ][ i ][ 2 ], "obj_casket_mmg1_get_"..j.."_"..i )
        end;
      end
    end;

    function gm.win_check()
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          if gm.map[ j ][ i ][ 1 ] ~= j then
            return false;
          end;          
        end;
      end
      return true
    end;

    function gm.build()
      local obj, light, choise
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          local n1 = gm.map[ j ][ i ][ 1 ]
          local n2 = gm.map[ j ][ i ][ 2 ]

          ObjSet( "obj_casket_mmg1_get_"..j.."_"..i, {
            inputrect_init = 1;
            inputrect_x = -35;
            inputrect_y = -35;
            inputrect_w = 70;
            inputrect_h = 70;
            event_mdown = function() gm.event_mdown( j, i ) end;
            event_menter = function() gm.event_menter( j, i ) end;
            event_mleave = function() gm.event_mleave( j, i ) end;
            --res = "assets/levels/level/mg_casket/mmg1/berry"..n1;
          } )

          obj = "spr_casket_mmg1_get_"..n1.."_"..n2
          ObjCreate( obj, "spr" )
          ObjSet( obj, {
            input = 0;
            res = "assets/levels/level/mg_casket/mmg1/berry"..n1;
          } )
          ObjAttach( obj, "obj_casket_mmg1_root" )

          light = obj.."_light"
          ObjCreate( light, "spr" )
          ObjSet( light, {
            res = "assets/levels/level/mg_casket/mmg1/berry"..n1.."_light";
            blendmode = 2;
            input = 0;
            alp = 0;
          } )
          ObjAttach( light, obj )

          choise = obj.."_choise"
          ObjCreate( choise, "spr" )
          ObjSet( choise, {
            res = "assets/levels/level/mg_casket/mmg1/berry"..n1.."_detailed";
            blendmode = 2;
            input = 0;
            alp = 0;
          } )
          ObjAttach( choise, obj )

        end;
      end
    end

    function gm.lighter( n1, n2, on, choise )
      local o = ObjGet( "spr_casket_mmg1_get_"..gm.map[ n1 ][ n2 ][ 1 ].."_"..gm.map[ n1 ][ n2 ][ 2 ]..( choise and "_choise" or "_light" ) )
      local t;
      if on then
        t = ( 1 - o.alp ) * 0.25
      else
        t = ( o.alp ) * 0.25
      end
      ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,0,on and 1 or 0 } )
    end

    function gm.get_place( n1, n2 )
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          if gm.map[ j ][ i ][ 1 ] == n1 and gm.map[ j ][ i ][ 2 ] == n2 then
            return j, i;
          end;          
        end;
      end
    end

    function gm.change( n11, n12, n21, n22, ta )
      local obj1 = "spr_casket_mmg1_get_"..gm.map[ n11 ][ n12 ][ 1 ].."_"..gm.map[ n11 ][ n12 ][ 2 ]
      local obj2 = "spr_casket_mmg1_get_"..gm.map[ n21 ][ n22 ][ 1 ].."_"..gm.map[ n21 ][ n22 ][ 2 ]
      --local p1 = GetObjPosByObj( obj1, "obj_casket_mmg1_root" )
      --local p2 = GetObjPosByObj( obj2, "obj_casket_mmg1_root" )
      local o1 = ObjGet( obj1 )
      local o2 = ObjGet( obj2 )

      local o1e = ObjGet( "obj_casket_mmg1_get_"..n11.."_"..n12 )
      local o2e = ObjGet( "obj_casket_mmg1_get_"..n21.."_"..n22 )

      local b1 = { o1.pos_x, o1.pos_y  }
      local b2 = { o2.pos_x, o2.pos_y  }
      local e1 = { o1e.pos_x, o1e.pos_y  }
      local e2 = { o2e.pos_x, o2e.pos_y  }

      local mx1 = b1[ 1 ] > b2[ 1 ] and ( b1[ 1 ] + 50 ) or ( b2[ 1 ] + 50 )
      local mx2 = b1[ 1 ] > b2[ 1 ] and ( b2[ 1 ] - 50 ) or ( b1[ 1 ] - 50 )
      local my1 = b1[ 2 ] > b2[ 2 ] and ( b1[ 2 ] + 50 ) or ( b2[ 2 ] + 50 )
      local my2 = b1[ 2 ] > b2[ 2 ] and ( b2[ 2 ] - 50 ) or ( b1[ 2 ] - 50 )

      --ObjAttach( obj1, "obj_casket_mmg1_root" )
      --ObjAttach( obj2, "obj_casket_mmg1_root" )
      ObjSet( obj1, { pos_z = 44 } )
      ObjSet( obj2, { pos_z = 44 } )
      if math.abs( b1[ 1 ] - b2[ 1 ] ) < math.abs( b1[ 2 ] - b2[ 2 ] ) then
        ObjAnimate( obj1, 0,0,0, _, { 0,0,b1[ 1 ], ta*0.5,2,mx1, ta,3,e2[ 1 ] } )
        ObjAnimate( obj2, 0,0,0, _, { 0,0,b2[ 1 ], ta*0.5,2,mx2, ta,3,e1[ 1 ] } )
        ObjAnimate( obj1, 1,0,0, _, { 0,0,b1[ 2 ], ta,3,e2[ 2 ] } )
        ObjAnimate( obj2, 1,0,0, _, { 0,0,b2[ 2 ], ta,3,e1[ 2 ] } )
      else
        ObjAnimate( obj1, 0,0,0, _, { 0,0,b1[ 1 ], ta,3,e2[ 1 ] } )
        ObjAnimate( obj2, 0,0,0, _, { 0,0,b2[ 1 ], ta,3,e1[ 1 ] } )
        ObjAnimate( obj1, 1,0,0, _, { 0,0,b1[ 2 ], ta*0.5,2,my1, ta,1,e2[ 2 ] } )
        ObjAnimate( obj2, 1,0,0, _, { 0,0,b2[ 2 ], ta*0.5,2,my2, ta,1,e1[ 2 ] } )
      end
      ObjAnimate( obj1, 6,0,0, _, { 0,0,1,1, ta*0.5,2,1.5,1.5, ta,1,1,1 } )
      ObjAnimate( obj2, 6,0,0, _, { 0,0,1,1, ta*0.5,2,1.5,1.5, ta,1,1,1 } )
      --gm.map[ n11 ][ n12 ], gm.map[ n21 ][ n22 ] = gm.map[ n21 ][ n22 ], gm.map[ n11 ][ n12 ]
      ObjAnimate( obj1, 9,0,0, function() 

        ObjSet( obj1, { pos_z = 33; } )
        ObjSet( obj2, { pos_z = 33; } )
        gm.set_all()
      end, { 0,0,1, ta,0,1 } )
      ObjStopAnimate( obj2, 9 )
    end

    function gm.event_mdown( n1, n2 )

      if ld.Lock( 1 ) then

        SoundSfx( "aud_clk_berry" )

        if not gm.choise then

          gm.lighter( n1, n2, true, true )
          gm.choise = { n1, n2 }
          ld.Lock( 0 )

        elseif gm.choise[ 1 ] == n1 and gm.choise[ 2 ] == n2 then

          gm.lighter( n1, n2, false, true )
          gm.choise = false
          ld.Lock( 0 )

        else
          

          local ta = 0.75
          gm.lighter( gm.choise[ 1 ], gm.choise[ 2 ], false, true )
          gm.lighter( n1, n2, false, true )
          gm.lighter( gm.choise[ 1 ], gm.choise[ 2 ], false, false )
          gm.lighter( n1, n2, false, false )

          gm.change( n1, n2, gm.choise[ 1 ], gm.choise[ 2 ], ta )
          gm.map[ n1 ][ n2 ], gm.map[ gm.choise[ 1 ] ][ gm.choise[ 2 ] ] = gm.map[ gm.choise[ 1 ] ][ gm.choise[ 2 ] ], gm.map[ n1 ][ n2 ]
          gm.happynes()

          ld.StartTimer( ta - 0.1, function() 
            SoundSfx( "aud_berry_replace" )
          end )

          ld.StartTimer( ta, function() 

            gm.choise = false
            gm.event_mdown_end()
          end )

        end

      end

    end

    function gm.event_mdown_end()

      if gm.win_check() then
        gm.win()
      else
        gm.save()
        ld.Lock( 0 )
      end
    end

    function gm.event_menter( n1, n2 )
      ld.ShCur(CURSOR_HAND)
      --if not gm.choise or gm.choise[ 1 ] ~= n1 or gm.choise[ 2 ] ~= n2 then
        gm.lighter( n1, n2, true )
      --end
    end

    function gm.event_mleave( n1, n2 )
      ld.ShCur(CURSOR_DEFAULT)
      --if not gm.choise or gm.choise[ 1 ] ~= n1 or gm.choise[ 2 ] ~= n2 then
        gm.lighter( n1, n2, false )
      --end
    end

    function gm.win()
      ld.Lock( 1 )
      public[ "win_casket"..mg_num ]()

      ld.StartTimer( 0.0, function() 
        local o;
        for j = 1, #gm.map do
          for i = 1, #gm.map[ j ] do
            ObjAttach( "spr_casket_mmg1_get_"..j.."_"..i, "anm_casket_mmg1_anm_biscuit"..j )
            o = ObjGet( "spr_casket_mmg1_get_"..j.."_"..i )
            --ld.LogTrace( o.name, o.pos_x, o.pos_y )
            ObjSet( o.name, { pos_x = o.pos_x + 171 * 1 } )
            --o = ObjGet( "spr_casket_mmg1_get_"..j.."_"..i )
            --ld.LogTrace( o.name, o.pos_x, o.pos_y )
            --ObjAttach( o.name, "anm_casket_mmg1_anm_biscuit"..j )
          end;
        end
      end )




    end 

    function gm.reset()
      ld.Lock( 1 )

      if gm.choise then
        gm.lighter( gm.choise[ 1 ], gm.choise[ 2 ], false, true )
        gm.choise = false
      end

      local ta = 0.75
      gm.map_def = ld.TableCopy( gm.map )
      gm.default()
      gm.map, gm.map_def = gm.map_def, gm.map

      local changed = false 
      local searthing = true
      while searthing do
        searthing = false
        local finded = false
        for j = 1, #gm.map_def do
          for i = 1, #gm.map_def[ j ] do
            if ( gm.map[ j ][ i ][ 1 ] ~= gm.map_def[ j ][ i ][ 1 ] ) and not gm.map[ j ][ i ][ 3 ] then
              for jj = 1, #gm.map do
                for ii = 1, #gm.map[ jj ] do
                  if ( i ~= ii or j ~= jj )
                  and not gm.map[ jj ][ ii ][ 3 ]
                  and gm.map[ jj ][ ii ][ 1 ] == gm.map_def[ j ][ i ][ 1 ]
                  and gm.map[ jj ][ ii ][ 1 ] ~= gm.map_def[ jj ][ ii ][ 1 ]
                  then
                    searthing = true
                    gm.change( j,i,jj,ii, ta );
                    gm.map[ j ][ i ], gm.map[ jj ][ ii ] = gm.map[ jj ][ ii ], gm.map[ j ][ i ]
                    finded = true
                    changed = true
                    break
                  end
                end
                if finded then break end
              end
            end
            if finded then break end
          end
          if finded then break end
        end
      end
      gm.default()
      gm.happynes()
      if changed then
        ld.StartTimer( ta, function() 
          gm.set_all()
          gm.save()
          ld.Lock( 0 )
        end )
      else
        gm.set_all()
        ld.Lock( 0 )
      end
    end

    function gm.skip()

      if gm.choise then
        gm.lighter( gm.choise[ 1 ], gm.choise[ 2 ], false, true )
        gm.choise = false
      end

      ld.Lock( 1 )
      local ta = 0.75
      gm.map_def = ld.TableCopy( gm.map )
      gm.map = {
        {{1,1},{1,2},{1,3},{1,4}};
        {{2,1},{2,2},{2,3},{2,4}};
        {{3,1},{3,2},{3,3},{3,4}};
      }
      gm.map, gm.map_def = gm.map_def, gm.map

      local fly 
      local searthing = true
      while searthing do
        searthing = false
        local finded = false
        for j = 1, #gm.map_def do
          for i = 1, #gm.map_def[ j ] do
            if ( gm.map[ j ][ i ][ 1 ] ~= gm.map_def[ j ][ i ][ 1 ] ) and not gm.map[ j ][ i ][ 3 ] then
              for jj = 1, #gm.map do
                for ii = 1, #gm.map[ jj ] do
                  if ( i ~= ii or j ~= jj )
                  and not gm.map[ jj ][ ii ][ 3 ]
                  and gm.map[ jj ][ ii ][ 1 ] == gm.map_def[ j ][ i ][ 1 ]
                  and gm.map[ jj ][ ii ][ 1 ] ~= gm.map_def[ jj ][ ii ][ 1 ]
                  then
                    changed = true
                    searthing = true
                    gm.change( j,i,jj,ii, ta );
                    gm.map[ j ][ i ], gm.map[ jj ][ ii ] = gm.map[ jj ][ ii ], gm.map[ j ][ i ]
                    finded = true
                    break
                  end
                end
                if finded then break end
              end
            end
            if finded then break end
          end
          if finded then break end
        end
      end
      --gm.default()
      gm.happynes()
      if changed then
        ld.StartTimer( ta, gm.win )
      else
        ld.Lock( 0 )
      end


      --ld.StartTimer( ta, public[ "win_casket"..mg_num ] )
    end

    function gm.Init()

      gm.default()

      if ng_global.progress[ "std" ][ "win_casket"..mg_num ].state then
        gm.map = ld.TableCopy( ng_global.progress[ "std" ][ "win_casket"..mg_num ].state )
      end

      gm.build()

      if param == "no_attach" then
        ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
        ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 0; alp = 0; } )
      else
        ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
        ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 1; alp = 1; } )
      end

      gm.set_all()
      gm.happynes()
    end

    gm.Init()

  else

  end;
  
  if param ~= "no_attach" then
    cmn.MiniGameShow( "casket"..mg_num );
    SoundMgTheme( true )
  end

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG 2 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load_mmg2( param )
  
  local mg_num = 2;

  gm[ "mmg"..mg_num ] = gm[ "mmg"..mg_num ] or {}
  local gm = gm[ "mmg"..mg_num ]

  if not gm[ "loaded_mmg"..mg_num ] then

    gm[ "loaded_mmg"..mg_num ] = true;

    function gm.default() 
      gm.round_wait_time = 2
      gm.state_def = 10;
      gm.state = gm.state_def;
      
      gm.PLACES = 11--12
    end

    function gm.save()
      ng_global.progress[ "std" ][ "win_casket"..mg_num ].state = gm.state
    end

    function gm.set_all()
      for i = 1, gm.state do
        ObjSet( "spr_casket_mmg2_light"..i, { alp = 0 } )
      end
      --for i = 1, gm.state do
      --  ObjSet( "spr_casket_mmg2_light"..i, { alp = 1 } )
      --end
    end;

    function gm.win_check()
      
    end;

    function gm.build()
      
    end

    function gm.character_show( character, place )
      --ld.LogTrace( "character_show", character, place )
      if not ObjGet( "tmr_casket_mmg3_character_show" ) then
        SoundSfx( "aud_elf_show" )
        ld.StartTimer( "tmr_casket_mmg3_character_show", 0.1, function()  end )
      end
      gm.character_place = gm.character_place or {}
      local t_anim = 0.35
      local obj = private.game.manager_obj_get( character )
      gm.character_place[ place ] = obj
      ObjAttach( obj, "obj_casket_mmg2_place_"..place );
      local oo = ObjGet( obj )
      ObjSet( obj, { drawoff_y = oo.draw_height / 8; input = 0 } )
      local o = ObjGet( "obj_casket_mmg2_place_"..place.."_finish" )
      local ang = private.game.ang_gip( o.pos_x, o.pos_y )
      local dx = - 15 * math.cos( ang )
      local dy = 15 * math.sin( ang )
      ObjSet( obj, { ang = ang + math.pi * 0.5 } )
      ObjAnimate( obj, 3,0,0, function() 
        ObjSet( obj, { input = 1 } )
      end, { 
        0, 0, 0, 0; 
        t_anim * 0.75, 2, o.pos_x + dx, o.pos_y + dy;
        t_anim, 3, o.pos_x, o.pos_y;
      } )
      return t_anim
    end

    function gm.character_hide( place )
      if not ObjGet( "tmr_casket_mmg3_character_hide" ) then
        SoundSfx( "aud_elf_hide" )
        ld.StartTimer( "tmr_casket_mmg3_character_hide", 0.1, function()  end )
      end
      local obj = gm.character_place[ place ]
      local t_anim = 0.35
      local o = ObjGet( "obj_casket_mmg2_place_"..place.."_finish" )
      local o_hide = ObjGet( obj )
      local ang = o_hide.ang - math.pi * 0.5
      local dx = - 20 * math.cos( ang )
      local dy = 20 * math.sin( ang )

      ObjAnimate( obj, 3,0,0, function() 
        ObjSet( obj, { input = 0 } )
        private.game.manager_obj_detach( obj, 0.25 )
      end, { 
        0, 0, o_hide.pos_x, o_hide.pos_y; 
        t_anim * 0.20, 2, o_hide.pos_x + dx, o_hide.pos_y + dy;
        t_anim, 1, 0, 0;
      } )
      return t_anim
    end

    function gm.characters_hide()
      gm.characters_hiding = true
      local t_anim = 0
      for k, v in pairs( gm.character_place ) do
        t_anim = gm.character_hide( k )
      end
      gm.character_place = {}
      return t_anim
    end

    function gm.round_start()
      --ld.LogTrace( "round_start" )
      gm.characters_hiding = false
      local t_wait = gm.round_wait_time
      local t_anim
      local characters_to_show = math.floor( ( gm.state_def - gm.state ) / 2  + 1 )
      local places = {}
      for i = 1, gm.PLACES do
        places[ i ] = i;
      end
      local place
      if math.random( ) > 0.4 then
        characters_to_show = characters_to_show - 1
        place = table.remove( places, math.random( 1, #places ) )
        t_anim = gm.character_show( "baady", place )
      end
      for i = 1, characters_to_show do
        place = table.remove( places, math.random( 1, #places ) )
        t_anim = gm.character_show( "goody", place )
      end
      ObjAnimate( "obj_casket_mmg2_trash_root", 7,0,0, gm.round_end, { 0,0,0, t_wait + t_anim,0,0 } )
    end

    function gm.round_end()
      --ld.LogTrace( "round_end" )
      local t_anim = gm.characters_hide()
      ObjAnimate( "obj_casket_mmg2_trash_root", 7,0,0, gm.round_start, { 0,0,0, t_anim,0,0 } )
    end

    function gm.event_mdown( obj, way )
      if ld.Lock( 1 ) then
        ObjStopAnimate( "obj_casket_mmg2_trash_root", 7 );
        gm.snowball_throw( obj, way );
        --ObjSet( "spr_casket_mmg2_snow_trow", { pos_x = 512, pos_y = 768 } );
      end
    end

    function gm.snowball_throw( obj, way )
      SoundSfx( "aud_throw_snowball" )
      ObjSet( "spr_casket_mmg2_snow_trow", { alp = 1, scale_x = 1, scale_y = 1 } )
      local o1 = ObjGet( "spr_casket_mmg2_snow" )
      local o2 = GetObjPosByObj( obj, "obj_casket_mmg2_root" )
      o2.pos_x = o2[ 1 ];
      o2.pos_y = o2[ 2 ];
      local x1 = o1.pos_x
      local y1 = o1.pos_y
      local x2 = ( o1.pos_x + o2.pos_x * 2 ) / 3
      local y2 = o2.pos_y - ( o1.pos_y - o2.pos_y ) * 0.1
      local x3 = o2.pos_x
      local y3 = o2.pos_y
      local t = private.game.len( x1, y1, x2, y2 ) / 1000
      ObjAnimate( "spr_casket_mmg2_snow_trow", 0,0,0, _, { 0,0,x1, t,0,x3 } )
      local sc = 1 - t * 0.2
      ObjAnimate( "spr_casket_mmg2_snow_trow", 6,0,0, _, { 0,0,1,1, t,0,sc,sc } )
      ObjAnimate( "spr_casket_mmg2_snow_trow", 1,0,0, function()
        gm.snowball_throw_step( obj, way )
      end, { 0,0,y1, t*0.75,2,y2, t,1,y3 } )
    end

    function gm.snowball_throw_step( obj, way )

      if ld.TableContains( gm.character_place, obj ) then
        gm.state = gm.state + way
        if gm.state > gm.state_def then
          gm.state = gm.state_def
        end
        ObjSet( "txt_casket_mmg2_counter", { text = gm.state } )
        if way > 0 then
          SoundSfx( "aud_goody_shot" )
          local o = ObjGet( "spr_casket_mmg2_light"..( gm.state ) )
          ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, 0.25,2,0 } )
        else
          SoundSfx( "aud_garland_shines" )
          local o = ObjGet( "spr_casket_mmg2_light"..( gm.state - way ) )
          ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, 0.25,2,1 } )
        end
      end

      ObjSet( "spr_casket_mmg2_snow_trow", { alp = 0 } );
      local o = ObjGet( "spr_casket_mmg2_snow_trow" );
      local fx = private.game.manager_obj_get( "snow_fx", 3 );
      ObjSet( fx, { pos_x = o.pos_x; pos_y = o.pos_y; } );
      PartSysRestart( fx );

      if not gm.characters_hiding then
        local snow = private.game.manager_obj_get( way > 0 and "goody_snow" or "baady_snow", 0.25+0.35 )
        ObjSet( snow, { drawoff_y = ObjGet( obj ).drawoff_y } )
        ObjAttach( snow, obj );
      end

      ld.StartTimer( 0.25, function() 
        local t_anim = gm.characters_hide();
        ld.StartTimer( t_anim, gm.snowball_throw_end );
      end )

    end

    function gm.snowball_throw_end()
      if gm.state > 0 then
        gm.save()
        ld.Lock( 0 );
        gm.round_start();
        ObjSet( "spr_casket_mmg2_snow_trow", { pos_x = 512, pos_y = 768 } );
      else
        gm.win()
      end
    end

    function gm.cursor_shadow( bool )
      if bool then
        local p = GetZoomCursorPos();
        ObjSet( "spr_casket_mmg2_snow_trow", { visible = bool, alp = bool, pos_x = p[ 1 ], pos_y = p[ 2 ] } );
        ObjSet( "spr_casket_mmg2_snow_trow", { pos_x = 512, pos_y = 768 } );
        ObjAnimate( "spr_casket_mmg2_snow_trow", 7,0,0, function() gm.cursor_shadow( true ) end, { 0,0,0 } );
      else
        ObjSet( "spr_casket_mmg2_snow_trow", { pos_x = -999, pos_y = -999 } )
        ObjStopAnimate( "spr_casket_mmg2_snow_trow", 7 )
      end
    end

    function gm.event_menter( obj )
      --ld.ShCur(CURSOR_HAND)
      ld.ShCur(CURSOR_NULL)
      gm.cursor_shadow( true )
    end

    ObjSet( "obj_casket_mmg2_cur_snow", { event_menter = gm.event_menter } );

    function gm.event_mleave( obj )
      ld.ShCur(CURSOR_DEFAULT)
      gm.cursor_shadow( false )
    end

    function gm.win()
      ld.Lock( 1 )
      public[ "win_casket"..mg_num ]()
    end 

    function gm.reset()
      local o
      for i = 1, gm.state_def do
        o = ObjGet( "spr_casket_mmg2_light"..i )
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, 0.25,2,0 } )
      end
      gm.default()
      ObjSet( "txt_casket_mmg2_counter", { text = gm.state } )
      gm.save()
      ld.Lock( 0 )
    end

    function gm.skip()
      ObjStopAnimate( "obj_casket_mmg2_trash_root", 7 )
      gm.characters_hide()
      gm.win()
    end

    function gm.Init()

      private.game.manager_obj_init( "goody", "spr", false, {
        res = "assets/levels/level/mg_casket/mmg2/g1";
        input = 1;
        event_menter = function( ne_params ) gm.cursor_shadow( true ) gm.event_menter( ne_params.sender ) end;
        event_mleave = function( ne_params ) gm.cursor_shadow( false ) gm.event_mleave( ne_params.sender ) end;
        event_mdown =  function( ne_params ) gm.cursor_shadow( false ) gm.event_mdown( ne_params.sender, 1 ) end;
      } )
      private.game.manager_obj_init( "goody_snow", "spr", false, {
        res = "assets/levels/level/mg_casket/mmg2/g1_snow";
        input = 0;
      } )
      private.game.manager_obj_init( "baady", "spr", false, {
        res = "assets/levels/level/mg_casket/mmg2/g2";
        input = 1;
        event_menter = function( ne_params ) gm.cursor_shadow( true ) gm.event_menter( ne_params.sender ) end;
        event_mleave = function( ne_params ) gm.cursor_shadow( false ) gm.event_mleave( ne_params.sender ) end;
        event_mdown =  function( ne_params ) gm.cursor_shadow( false ) gm.event_mdown( ne_params.sender, -1 ) end;
      } )
      private.game.manager_obj_init( "baady_snow", "spr", false, {
        res = "assets/levels/level/mg_casket/mmg2/g2_snow";
        input = 0;
      } )
      private.game.manager_obj_init( "snow_fx", "partsys", "obj_casket_mmg2_root", {
        res = "assets/levels/level/mg_casket/mmg2/snow_fx";
        input = 0;
        pos_z = 99;
      } )

      gm.default()

      if ng_global.progress[ "std" ][ "win_casket"..mg_num ].state then
        gm.state = ng_global.progress[ "std" ][ "win_casket"..mg_num ].state
      end

      ObjSet( "txt_casket_mmg2_counter", { text = gm.state } )

      gm.build()

      if param == "no_attach" then
        ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
        ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 0; alp = 0; } )
      else
        ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
        ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 1; alp = 1; } )
      end

      gm.set_all()

      gm.round_start()

    end

    gm.Init()

  else

  end;
  
  if param ~= "no_attach" then
    cmn.MiniGameShow( "casket"..mg_num );
    SoundMgTheme( true )
  end

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG 3 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load_mmg3( param )
  
  local mg_num = 3;

  gm[ "mmg"..mg_num ] = gm[ "mmg"..mg_num ] or {}
  local gm = gm[ "mmg"..mg_num ]

  if not gm[ "loaded_mmg"..mg_num ] then

    gm.loaded_mmg3 = true;

    function gm.line_push( y, way )
      if way > 0 then
        gm.map[ y ][ 1 ], gm.map[ y ][ 2 ], gm.map[ y ][ 3 ], gm.map[ y ][ 4 ] =
        gm.map[ y ][ 4 ], gm.map[ y ][ 1 ], gm.map[ y ][ 2 ], gm.map[ y ][ 3 ]
      else
        gm.map[ y ][ 1 ], gm.map[ y ][ 2 ], gm.map[ y ][ 3 ], gm.map[ y ][ 4 ] =
        gm.map[ y ][ 2 ], gm.map[ y ][ 3 ], gm.map[ y ][ 4 ], gm.map[ y ][ 1 ]
      end
    end

    function gm.column_push( x, way )
      if way > 0 then
        gm.map[ 1 ][ x ], gm.map[ 2 ][ x ], gm.map[ 3 ][ x ], gm.map[ 4 ][ x ] =
        gm.map[ 4 ][ x ], gm.map[ 1 ][ x ], gm.map[ 2 ][ x ], gm.map[ 3 ][ x ]
      else
        gm.map[ 1 ][ x ], gm.map[ 2 ][ x ], gm.map[ 3 ][ x ], gm.map[ 4 ][ x ] =
        gm.map[ 2 ][ x ], gm.map[ 3 ][ x ], gm.map[ 4 ][ x ], gm.map[ 1 ][ x ]
      end
    end

    function gm.default() 
      gm.map = {
        {1,2,3,4};
        {1,2,3,4};
        {1,2,3,4};
        {1,2,3,4};
      }
      gm.line_push( 1, 1 )
      gm.column_push( 1, 1 )
      gm.line_push( 2, -1 )
      gm.column_push( 2, -1 )
      gm.line_push( 3, 1 )
      gm.column_push( 3, 1 )
      gm.line_push( 4, -1 )
      gm.column_push( 4, -1 )
    end

    function gm.save()
      ng_global.progress[ "std" ][ "win_casket"..mg_num ].state = ld.TableCopy( gm.map )
    end

    function gm.set_all()
      for j = 1, 4 do
        for i = 1, 4 do
          for c = 1, 4 do
            ObjSet( "spr_casket_mmg3_"..j.."_"..i.."_"..c, { alp = gm.map[ j ][ i ] == c and 1 or 0 } )
            --ld.LogTrace( "spr_casket_mmg3_"..j.."_"..i.."_"..c, gm.map[ j ][ i ] == c and 1 or 0 )
          end;
        end;
      end
      gm.happynes( true )
    end;

    function gm.win_check()
      for j = 1, 4 do
        for i = 1, 4 do
          if gm.map[ j ][ i ] ~= i then
            return false
          end
        end;
      end
      return true
    end;

    function gm.happynes( loading )
      local happy, o, animating, sfx;
      for i = 1, 4 do
        happy = true
        for j = 1, 4 do
          if gm.map[ j ][ i ] ~= i then
            happy = false
            --break
          end
          o = ObjGet( "spr_casket_mmg3_st"..i.."_light_"..j.."_light" )
          ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, 0.2,0,gm.map[ j ][ i ] == i and 1 or 0 } )
        end;
        if not animating then
          animating = happy
        end
        o = ObjGet( "spr_casket_mmg3_face"..i )
        ObjAnimate( "spr_casket_mmg3_face"..i, 8,0,0, _, { 0,0,o.alp, 0.2,0,happy and 0 or 1 } )
        o = ObjGet( "spr_casket_mmg3_st"..i.."_backlight" )
        ObjAnimate( "spr_casket_mmg3_st"..i.."_backlight", 8,0,0, _, { 0,0,o.alp, 0.2,0,happy and 1 or 0 } )
        ObjAnimate( "spr_casket_mmg3_body"..i.."_light", 8,0,0, _, { 0,0,o.alp, 0.2,0,happy and 1 or 0 } )
        if not sfx and happy then
          sfx = o.alp < 1
        end
      end
      if sfx and not loading then
        SoundSfx( "aud_wright_cloth_icon" )
      end
    end

    function gm.clr_hide( ta )
      for j = 1, 4 do
        for i = 1, 4 do
          ObjAnimate( "spr_casket_mmg3_"..j.."_"..i.."_"..gm.map[ j ][ i ], 8,0,0, _, { 0,0,1, ta,2,0 } )
        end;
      end
    end

    function gm.clr_show( ta )
      local o
      for j = 1, 4 do
        for i = 1, 4 do
        o = ObjGet( "spr_casket_mmg3_"..j.."_"..i.."_"..gm.map[ j ][ i ] )
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, ta,1,1 } )
        end;
      end
    end

    function gm.move_end()
      if gm.win_check() then
        public.win_casket3()
      else
        gm.save()
        ld.Lock( 0 )
      end
    end

    function gm.move_fly_fx( ta, n, clr, o1, o2 )

      local fx = "fx_casket_mmg3_fx"..n;
      local color = {
        {0.3137,0.3058,0.8509};
        {0.1411,0.7686,0.1764};
        {0.9215,0.1215,0.1215};
        {0.9215,0.7764,0.1450};
      }
      ObjSet( fx, { active = 1, color_r = color[ clr ][ 1 ], color_g = color[ clr ][ 2 ], color_b = color[ clr ][ 3 ] } )
      PartSysRestart( fx );

      o1 = ObjGet( o1 )
      o2 = ObjGet( o2 )

      --ld.LogTrace( o1,o2,ObjGet( fx ) )

      ObjAnimate( fx, 3,0,0, function() 
        PartSysStop( fx, 0 );
      end, { 
         0, 0, o1.pos_x, o1.pos_y; 
        ta, 2, o2.pos_x, o2.pos_y;
      } )
    end;

    function gm.move_column( x, way )
      if ld.Lock( 1 ) then
        SoundSfx( "aud_clk_arrow_magic" )
        local ta = 0.2
        for j = 1, 4 do
          ObjAnimate( "spr_casket_mmg3_"..j.."_"..x.."_"..gm.map[ j ][ x ], 8,0,0, _, { 0,0,1, ta,2,0 } )
        end;

        for z = 1, 4 do
          if ( ( z + way ) >= 1 ) and ( ( z + way ) <= 4 ) then
            gm.move_fly_fx( ta, z, gm.map[ z ][ x ], "spr_casket_mmg3_"..z.."_"..x.."_"..gm.map[ z ][ x ], "spr_casket_mmg3_"..( z + way ).."_"..x.."_"..gm.map[ z + way ][ x ] )
          end
        end

        gm.column_push( x, way )
        gm.happynes()
        
        ld.StartTimer( ta, function() gm.move_column_step( x, way ) end )
      end
    end;

    function gm.move_column_step( x, way )
      local ta = 0.2
      for j = 1, 4 do
        local o = ObjGet( "spr_casket_mmg3_"..j.."_"..x.."_"..gm.map[ j ][ x ] )
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, ta,1,1 } )
      end;
      ld.StartTimer( ta, gm.move_end )
    end

    function gm.move_line( y, way )
      if ld.Lock( 1 ) then
        SoundSfx( "aud_clk_arrow_magic" )
        local ta = 0.2
        for i = 1, 4 do
          ObjAnimate( "spr_casket_mmg3_"..y.."_"..i.."_"..gm.map[ y ][ i ], 8,0,0, _, { 0,0,1, ta,2,0 } )
        end;
        
        for z = 1, 4 do
          if ( ( z + way ) >= 1 ) and ( ( z + way ) <= 4 ) then
            gm.move_fly_fx( ta, z, gm.map[ y ][ z ], "spr_casket_mmg3_"..y.."_"..z.."_"..gm.map[ y ][ z ], "spr_casket_mmg3_"..y.."_"..( z + way ).."_"..gm.map[ y ][ z + way ] )
          end
        end

        gm.line_push( y, way )
        gm.happynes()

        ld.StartTimer( ta, function() gm.move_line_step( y, way ) end )
      end
    end;

    function gm.move_line_step( y, way )
      local ta = 0.2
      for i = 1, 4 do
        ObjAnimate( "spr_casket_mmg3_"..y.."_"..i.."_"..gm.map[ y ][ i ], 8,0,0, _, { 0,0,0, ta,0,1 } )
      end;
      ld.StartTimer( ta, gm.move_end )
    end

    function gm.button_click( ne_params )
      local o = ObjGet( ne_params.sender )
      local dy = ( o.name:find( "_up_" ) or o.name:find( "_down_" ) ) and ( -25 * o.scale_x ) or 0
      local dx = ( o.name:find( "_right_" ) or o.name:find( "_left_" ) ) and ( 25 * o.scale_x ) or 0
      ObjAnimate( o.name, 3,0,0, _, { 
        0.0,0,o.pos_x,o.pos_y; 
        0.1,2,o.pos_x + dx,o.pos_y + dy;
        0.2,1,o.pos_x,o.pos_y;
      } )
    end

    gm.default()

    local clrs1 = {
      { 0.1, 0.1, 1.0 };
      { 0.0, 1.0, 0.0 };
      { 1.0, 0.0, 0.0 };
      { 1.0, 1.0, 0.0 };
    }
    local clrs2 = {
      { 0.4, 0.4, 1.0 };
      { 0.5, 1.0, 0.5 };
      { 1.0, 0.4, 0.4 };
      { 1.0, 1.0, 0.5 };
    }
    local st_clr, st_obj
    for j = 1, 4 do
      for i = 1, 4 do
        ObjSet( "spr_casket_mmg3_st"..i.."_light_"..j, { 
          color_r = clrs1[ i ][ 1 ];
          color_g = clrs1[ i ][ 2 ];
          color_b = clrs1[ i ][ 3 ];
        } )
        ObjSet( "spr_casket_mmg3_st"..i.."_light_"..j.."_light", { 
          color_r = clrs2[ i ][ 1 ];
          color_g = clrs2[ i ][ 2 ];
          color_b = clrs2[ i ][ 3 ];
        } )
        if ( j == 1 or j == 4 ) then
          ObjSet( "spr_casket_mmg3_arrow_"..( j == 1 and "up" or "down" ).."_"..i, {
            event_mdown = function( ne_params ) gm.button_click( ne_params ) gm.move_column( i, j == 1 and -1 or 1 ) end;
            event_menter = function( ne_params ) private.game.event_menter( ne_params.sender.."_light" ) end;
            event_mleave = function( ne_params ) private.game.event_mleave( ne_params.sender.."_light" ) end;
          } )
        end
        if ( i == 1 or i == 4 ) then
          ObjSet( "spr_casket_mmg3_arrow_"..( i == 1 and "left" or "right" ).."_"..j, {
            event_mdown = function( ne_params ) gm.button_click( ne_params ) gm.move_line( j, i == 1 and -1 or 1 ) end;
            event_menter = function( ne_params ) private.game.event_menter( ne_params.sender.."_light" ) end;
            event_mleave = function( ne_params ) private.game.event_mleave( ne_params.sender.."_light" ) end;
          } )
        end
      end;
    end

    local dx = { 72, 30, -30, -72 }
    local o
    for j = 1, 4 do
      o = ObjGet( "spr_casket_mmg3_arrow_right_"..j )
      ObjSet( o.name, { pos_x = o.pos_x + dx[ 4 ] } )
      o = ObjGet( "spr_casket_mmg3_arrow_left_"..j )
      ObjSet( o.name, { pos_x = o.pos_x + dx[ 1 ] } )
      o = ObjGet( "spr_casket_mmg3_arrow_up_"..j )
      ObjSet( o.name, { pos_x = o.pos_x + dx[ j ] } )
      o = ObjGet( "spr_casket_mmg3_arrow_down_"..j )
      ObjSet( o.name, { pos_x = o.pos_x + dx[ j ] } )

      o = ObjGet( "spr_casket_mmg3_body"..j )
      ObjSet( o.name, { pos_x = o.pos_x + dx[ j ] } )
      o = ObjGet( "spr_casket_mmg3_face"..j )
      ObjSet( o.name, { pos_x = o.pos_x + dx[ j ] } )
      o = ObjGet( "spr_casket_mmg3_body"..j.."_light" )
      ObjSet( o.name, { pos_x = o.pos_x + dx[ j ] } )
      for i = 1, 4 do
        for c = 1, 4 do
          o = ObjGet( "spr_casket_mmg3_"..j.."_"..i.."_"..c )
          ObjSet( o.name, { pos_x = o.pos_x + dx[ i ] } )
          --ld.LogTrace( "spr_casket_mmg3_"..j.."_"..i.."_"..c, gm.map[ j ][ i ] == c and 1 or 0 )
        end;
      end;
    end

    if ng_global.progress[ "std" ][ "win_casket"..mg_num ].state then
      gm.map = ld.TableCopy( ng_global.progress[ "std" ][ "win_casket"..mg_num ].state )
    end

      if param == "no_attach" then
        ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
        ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 0; alp = 0; } )
      else
        ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
        ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 1; alp = 1; } )
      end

    gm.set_all()

    function gm.reset()
      ld.Lock( 1 )
      local ta = 0.2
      gm.clr_hide( ta )
      gm.default()
      gm.clr_show( ta )
      gm.happynes()
      ld.StartTimer( ta, function() 
        gm.save()
        ld.Lock( 0 )
      end )
    end

    function gm.skip()
      ld.Lock( 1 )
      local ta = 0.2
      gm.clr_hide( ta )
      for j = 1, 4 do
        for i = 1, 4 do
          gm.map[ j ][ i ] = i;
        end;
      end
      gm.clr_show( ta )
      gm.happynes()
      ld.StartTimer( ta + 0.5, public[ "win_casket"..mg_num ] )
    end

  else

  end;
  
  if param ~= "no_attach" then
    cmn.MiniGameShow( "casket"..mg_num );
    SoundMgTheme( true )
  end

end;

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG 4 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load_mmg4( param )
  
  local mg_num = 4;

  gm[ "mmg"..mg_num ] = gm[ "mmg"..mg_num ] or {}
  local gm = gm[ "mmg"..mg_num ]

  if not gm[ "loaded_mmg"..mg_num ] then
    gm[ "loaded_mmg"..mg_num ] = true;
    function gm.default() 
      gm.state_max = 29
      gm.state = 1;
    end
    
    function gm.save()
      ng_global.progress[ "std" ][ "win_casket"..mg_num ].state = ld.TableCopy( gm.state )
    end
    function gm.reset()
      ld.Lock( 1 )
      local func_end = function()
        gm.default()
        gm.save()
        gm.set_all()
        ld.Lock( 0 )
      end
      local t = 0.25;
      local o
      for i = 1, gm.state_max do
        ObjAnimate( "spr_casket_mmg4_star_"..i, 8,0,0, _, { 
          0,0,gm.state <= i and 0 or 1, 
          t,0,0
        } )
        ObjAnimate( "txt_casket_mmg4_star_"..i, 8,0,0, _, { 
          0,0,gm.state <= i and 1 or 0, 
          t,0,1
        } )
        ObjAnimate( "txt_casket_mmg4_star_"..i, 6,0,0, _, { 
          0,0,gm.state == i and 1.2 or 1, gm.state == i and 1.2 or 1,
          t,0,1 == i and 1.2 or 1, 1 == i and 1.2 or 1
        } )
      end
      ld.StartTimer( t, func_end )
    end
    function gm.skip()
      local func_end = function()
        gm.win()
      end
      ld.Lock( 1 )
      local t = 0.25;
      local o
      for i = gm.state, gm.state_max do
        ObjAnimate( "spr_casket_mmg4_star_"..gm.state, 8,0,0, _, { 0,0,0, t,0,1 } )
        ObjSet( "spr_casket_mmg4_star_"..gm.state, { input = 0 } )

        local o = ObjGet( "txt_casket_mmg4_star_"..gm.state )
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,0,0 } )
        ObjAnimate( o.name, 6,0,0, _, { 0,0,o.scale_x,o.scale_y, t,0,1,1 } )

        ObjSet( "fx_casket_mmg4_star_"..gm.state, { active = 1 } )
        PartSysRestart( "fx_casket_mmg4_star_"..gm.state );
        gm.state = gm.state + 1;
        if gm.state <= gm.state_max then
          ObjSet( "spr_casket_mmg4_star_"..gm.state, { input = 1 } )
          local o = ObjGet( "txt_casket_mmg4_star_"..gm.state )
          ObjAnimate( o.name, 6,0,0, _, { 0,0,o.scale_x,o.scale_y, t,0,1.2,1.2 } )
        end
      end
      ld.StartTimer( t, func_end )
    end
    function gm.win()
      ld.Lock( 1 )
      local func_step = function()
        SoundSfx( "aud_cats_shine" )
        local t = 0.0
        local ta = 0.25
        local ts = 0.04
        for i = 1, gm.state_max do
          ObjAnimate( "spr_casket_mmg4_star_"..i, 8,0,0, function() 
            ObjSet( "fx_casket_mmg4_star_"..i, { active = 1 } )
            PartSysRestart( "fx_casket_mmg4_star_"..i );
            ObjAnimate( "spr_casket_mmg4_star_"..i, 8,0,0, _, { 0,0,1, ta,0,0 } )
          end, { 0,0,1, t,0,1 } )
          t = t + ts
        end
        ld.StartTimer( t + ta, public[ "win_casket"..mg_num ] )
      end
      local o = ObjGet( "spr_casket_mmg4_cat_color" )
      ObjAnimate( o.name, 8,0,0, func_step, { 0,0,o.alp, 1,0,1, 1.5,0,1 } )
    end

    function gm.win_check()
      return gm.state > gm.state_max
    end

    function gm.event_end()
      if gm.win_check() then
        gm.win()
      else
        gm.save()
        ld.Lock( 0 )
      end
    end

    function gm.event_mdown()
      if ld.Lock( 1 ) then
        SoundSfx( "aud_clk_star_"..math.random( 1, 5 ) )
        local t = 0.2;
        ObjAnimate( "spr_casket_mmg4_star_"..gm.state, 8,0,0, gm.event_end, { 0,0,0, t,0,1 } )
        ObjSet( "spr_casket_mmg4_star_"..gm.state, { input = 0 } )

        local o = ObjGet( "txt_casket_mmg4_star_"..gm.state )
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,0,0 } )
        ObjAnimate( o.name, 6,0,0, _, { 0,0,o.scale_x,o.scale_y, t,0,1,1 } )

        ObjSet( "fx_casket_mmg4_star_"..gm.state, { active = 1 } )
        PartSysRestart( "fx_casket_mmg4_star_"..gm.state );
        gm.state = gm.state + 1;
        if gm.state <= gm.state_max then
          ObjSet( "spr_casket_mmg4_star_"..gm.state, { input = 1 } )
          local o = ObjGet( "txt_casket_mmg4_star_"..gm.state )
          ObjAnimate( o.name, 6,0,0, _, { 0,0,o.scale_x,o.scale_y, t,0,1.2,1.2 } )
        end
      end
    end

    function gm.init()
      local o
      for i = 1, gm.state_max do
        o = ObjGet( "spr_casket_mmg4_star_"..i )
        ObjSet( "spr_casket_mmg4_star_"..i, {
          blendmode = 2;
          event_menter = function() ld.ShCur(CURSOR_HAND) end;
          event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end;
          event_mdown = gm.event_mdown;
          inputrect_init = true;
          inputrect_x = -35;
          inputrect_y = -35;
          inputrect_w = 70;
          inputrect_h = 70;
        } );
        common_impl.ObjCreate( "fx_casket_mmg4_star_"..i, "partsys", "obj_casket_mmg4_root", {
          res = "assets/levels/level/mg_casket/mmg4/star_fx";
          pos_z = 12;
          active = 0;
          pos_x = o.pos_x;
          pos_y = o.pos_y;
        } );
        common_impl.ObjCreate( "txt_casket_mmg4_star_"..i, "text", "obj_casket_mmg4_root", {
          res = "assets/levels/level/mg_casket/mmg4/star_fx";
          disprawtext = true;
          text = i;
          fontsize = 24;
          display_outline = true;
          outline_size = 2;
          fontcolor_b = 0;
          
          
          
          
          input = false;
          pos_z = 9;
          pos_x = o.pos_x;
          pos_y = o.pos_y + 5;
          res = "assets/fonts/arial";
        } );
      end
    end

    function gm.set_all()
      for i = 1, gm.state_max do
        ObjSet( "spr_casket_mmg4_star_"..i, {
          input = gm.state == i;
          alp = gm.state <= i and 0 or 1;
        } );
        ObjSet( "txt_casket_mmg4_star_"..i, {
          alp = gm.state <= i and 1 or 0;
          scale_x = gm.state == i and 1.2 or 1;
          scale_y = gm.state == i and 1.2 or 1;
        } );
      end
    end

    gm.default()

    if ng_global.progress[ "std" ][ "win_casket"..mg_num ].state then
      gm.state = ld.TableCopy( ng_global.progress[ "std" ][ "win_casket"..mg_num ].state )
    end

    gm.init()
    gm.set_all()

    if param == "no_attach" then
      ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
      ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 0; alp = 0; } )
    else
      ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
      ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 1; alp = 1; } )
    end
  else
    
  end
  
  if param ~= "no_attach" then
    cmn.MiniGameShow( "casket"..mg_num );
    SoundMgTheme( true )
  end
  
end






--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG 5 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load_mmg5( param )
  
  local mg_num = 5;

  gm[ "mmg"..mg_num ] = gm[ "mmg"..mg_num ] or {}
  local gm = gm[ "mmg"..mg_num ]

  if not gm[ "loaded_mmg"..mg_num ] then
    gm[ "loaded_mmg"..mg_num ] = true;
    function gm.default() 
      gm.piece_in_snowflake = false
      gm.map = { 
        {1,2,3,4};
        {2,3,4,1};
        {3,4,1,2};
        {4,1,2,3};
      };
      local id = {}
      local v;
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          id[ gm.map[ j ][ i ] ] = id[ gm.map[ j ][ i ] ] or 0
          id[ gm.map[ j ][ i ] ] = id[ gm.map[ j ][ i ] ] + 1
          v = gm.map[ j ][ i ]
          gm.map[ j ][ i ] = { type = v; id = id[ v ] };
        end
      end
    end
    
    function gm.save()
      ng_global.progress[ "std" ][ "win_casket"..mg_num ].state = ld.TableCopy( gm.map )
    end
    function gm.reset()
      ld.Lock( 1 )
      local t = 0.35
      gm.piece_show_all( false, t )
      local o = ObjGet( "obj_casket_mmg5_place_0" )
      ObjAnimate( o.name, 7,0,0, _, { 0,0,private.game.ang_closer( o.ang, 0 ), t,3,0 } )
      ObjAnimate( "spr_casket_mmg5_place_0", 7,0,0, function() 
        gm.default()
        gm.set_all()
        for j = 1, #gm.map do
          gm.place_enable( j, true )
        end
        gm.piece_show_all( true, t )
        ld.StartTimer( t, function() 
          gm.save()
          ld.Lock( 0 )
        end );
      end, { 0,0,private.game.ang_closer( o.ang, 0 ), t,3,0 } )
    end
    function gm.skip()
      ld.Lock( 1 )
      local t = 0.35
      gm.piece_show_all( false, t )
      ld.StartTimer( t, function() 
        for j = 1, #gm.map do
          for i = 1, #gm.map[ j ] do
            gm.map[ j ][ i ] = { type = j; id = i }
          end
        end
        gm.set_all()
        gm.piece_show_all( true, t )
        ld.StartTimer( t,gm.event_end );
      end )
    end
    function gm.win()
      ld.Lock( 1 )
      public[ "win_casket"..mg_num ]()
    end

    function gm.event_menter( obj )
      ld.ShCur(CURSOR_HAND)
      local alp = 0.5
      obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
      obj = obj.."_light"
      local o = ObjGet( obj )
      if not o then
        obj = obj:gsub( "_light$", "" )
        o = ObjGet( obj )
      end
      if o then
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (alp-o.alp)/4,0,alp } )
      end
    end;

    function gm.event_mleave( obj )
      ld.ShCur(CURSOR_DEFAULT)
      local alp = 0.5
      obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
      obj = obj.."_light"
      local o = ObjGet( obj )
      if not o then
        obj = obj:gsub( "_light$", "" )
        o = ObjGet( obj )
      end
      if o then
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/4,0,0 } )
      end
    end;

    function gm.masive_push( m, way )
      if way > 0 then
        local buf = m[ 1 ]
        for i = 1, #m - 1, 1 do
          m[ i ] = m[ i + 1 ]
        end
        m[ #m ] = buf
      else
        local buf = m[ #m ]
        for i = #m, 2, -1 do
          m[ i ] = m[ i - 1 ]
        end
        m[ 1 ] = buf
      end
    end

    function gm.win_place_check( j )
      for i = 1, #gm.map[ j ] do
        if ( gm.map[ j ][ i ].type ~= j or gm.map[ j ][ i ].id ~= i ) then
          return false;
        end
      end
      return true
    end

    function gm.win_check()
      for j = 1, #gm.map do
        if not gm.win_place_check( j ) then
          return false;
        end
      end
      return true
    end

    function gm.event_end()
      if gm.win_check() then
        gm.win()
      else
        gm.set_input()
        gm.save()
        ld.Lock( 0 )
      end
    end

    function gm.event_mdown_arrow( n )
      if ld.Lock( 1 ) then
        SoundSfx( "aud_clk_arrow" )
        local t = 0.35
        local way = n % 2 == 1 and 1 or -1
        local o, m
        ld.AnimPlay( "anm_casket_mmg5_anm_arrow_"..n, "arrow", nil );
        if gm.win_place_check( n ) then
          gm.place_light_controller( n, false )
        end
        gm.masive_push( gm.map[ n ], way )
        for i = 1, #gm.map[ n ] do
          m = gm.map[ n ][ i ]
          o = ObjGet( "obj_casket_mmg5_place_"..m.type.."_"..m.id )
          ObjAnimate( o.name, 7,0,0, _, { 0,0,o.ang, t,3,o.ang + math.pi / 2 * way } )
        end
        ObjAnimate( "anm_casket_mmg5_anm_arrow_"..n, 7,0,0, gm.event_end, { 0,0,0, t,0,0 } )
      end
    end

    function gm.place_0_get_nearest_obj( piece_place )
      local o_place,l,min_obj,pos_min
      local min_l = 9999
      local o_piece = GetObjPosByObj( "obj_casket_mmg5_place_"..piece_place.j )
      for i = 1, 6 do
        o_place = GetObjPosByObj( "obj_casket_mmg5_place_0_"..i )
        l = private.game.len( o_piece[ 1 ], o_piece[ 2 ], o_place[ 1 ], o_place[ 2 ] )
        --ld.LogTrace( o_piece[ 1 ], o_piece[ 2 ], o_place[ 1 ], o_place[ 2 ], l )
        if l < min_l then
          min_obj = "obj_casket_mmg5_place_0_"..i
          --ld.LogTrace( min_obj )
          min_l = l
          pos_min = o_place;
        end
      end
      return min_obj
    end

    --анимация доварота снежинки с указаным куском на ней, к родителю снежинки
    function gm.place_0_rotate_to_place( piece, func_end )

      local piece_place = gm.piece_place( piece )
      local destanation_root = "obj_casket_mmg5_place_"..piece_place.j
      local place_0_nearest_obj_to_root = gm.place_0_get_nearest_obj( piece_place )

      local piec_obj = "obj_casket_mmg5_place_"..piece.type.."_"..piece.id
      local piece_parent = ObjGetRelations( piec_obj ).parent

      local place_0_ang = private.game.ang_norm( ObjGet( "obj_casket_mmg5_place_0" ).ang )
      local place_0_piece_ang = private.game.ang_gip( 0, 0, ObjGet( piece_parent ).pos_x, ObjGet( piece_parent ).pos_y )
      local place_0_to_root_ang = private.game.ang_gip( 0, 0, ObjGet( place_0_nearest_obj_to_root ).pos_x, ObjGet( place_0_nearest_obj_to_root ).pos_y )
      
      local ang_end = private.game.ang_norm( place_0_ang + place_0_to_root_ang - place_0_piece_ang )
      local ang_beg = private.game.ang_closer( place_0_ang, ang_end )
      local t = math.abs( ang_end - ang_beg ) * 0.2

      --ld.LogTrace( ang_beg, ang_end, t )

      ObjAnimate( "spr_casket_mmg5_place_0", 7,0,0, _, { 0,0,ang_beg, t,3,ang_end } )
      ObjAnimate( "obj_casket_mmg5_place_0", 7,0,0, func_end, { 0,0,ang_beg, t,3,ang_end } )

    end

    --анимация перелета куска к снежинке и обратно
    function gm.piece_go_to( piece, place, func_end )

      if gm.piece_go_to_anim_now then return end;
      gm.piece_go_to_anim_now = true
      
      local t = 0.35

      ld.Lock( 1 )
      func_end = func_end or function()
        if not gm.piece_in_snowflake then
          gm.set_input()
        end
        ld.Lock( 0 )
      end

      local piece_place = gm.piece_place( piece )
      local piece_obj = "obj_casket_mmg5_place_"..piece.type.."_"..piece.id

      if place == 0 then

        gm.place_enable( piece_place.j, false )

        local place_obj = gm.place_0_get_nearest_obj( piece_place )
        local piece_pos = GetObjPosByObj( "obj_casket_mmg5_place_"..piece_place.j )
        local place_pos = GetObjPosByObj( place_obj )
        ObjAttach( piece_obj, "obj_casket_mmg5_root" )
        ObjSet( piece_obj, { pos_x = piece_pos[ 1 ]; pos_y = piece_pos[ 2 ]; } )
        ObjAnimate( piece_obj, 3,0,0, _, { 0,0,piece_pos[ 1 ], piece_pos[ 2 ], t,3,place_pos[ 1 ], place_pos[ 2 ] } )
        
        --докручиваем кусок
        local piece_ang = private.game.ang_norm( ObjGet( piece_obj ).ang )
        local place_ang = private.game.ang_norm( ObjGet( "obj_casket_mmg5_place_0" ).ang )
        local piece_place_ang = private.game.ang_gip( 0, 0, ObjGet( place_obj ).pos_x, ObjGet( place_obj ).pos_y )
        local piece_turned_ang = private.game.ang_norm( piece_place_ang + place_ang + math.pi * 0.25 );
        ObjAnimate( piece_obj, 7,0,0, function() 
          ObjSet( piece_obj, { pos_x = 0; pos_y = 0; ang = piece_place_ang + math.pi * 0.25; } )
          ObjAttach( piece_obj, place_obj )
          gm.piece_go_to_anim_now = false
          func_end()
        end, { 0,0,private.game.ang_closer( piece_ang, piece_turned_ang ), t,3,piece_turned_ang } )

      else
        
        local place0_obj = gm.place_0_get_nearest_obj( piece_place )
        local place_obj = "obj_casket_mmg5_place_"..piece_place.j
        local piece_pos = GetObjPosByObj( piece_obj )
        local place_pos = GetObjPosByObj( place_obj )
        ObjAttach( piece_obj, "obj_casket_mmg5_root" )
        ObjSet( piece_obj, { pos_x = piece_pos[ 1 ]; pos_y = piece_pos[ 2 ]; } )
        ObjAnimate( piece_obj, 3,0,0, _, { 0,0,piece_pos[ 1 ], piece_pos[ 2 ], t,3,place_pos[ 1 ], place_pos[ 2 ] } )
        
        --докручиваем кусок
        local place_ang = private.game.ang_norm( gm.piece_ang( piece ) )
        local place0_ang = private.game.ang_norm( ObjGet( "obj_casket_mmg5_place_0" ).ang )
        local piece_ang = private.game.ang_gip( 0, 0, ObjGet( place0_obj ).pos_x, ObjGet( place0_obj ).pos_y )
        local piece_place_ang = private.game.ang_norm( place0_ang + piece_ang + math.pi * 0.25 );
        ObjAnimate( piece_obj, 7,0,0, function() 
          ObjSet( piece_obj, { pos_x = 0; pos_y = 0 } )
          ObjAttach( piece_obj, place_obj )
          gm.place_enable( piece_place.j, true )
          gm.piece_go_to_anim_now = false
          func_end()
        end, { 0,0,private.game.ang_closer( piece_place_ang, place_ang ), t,3,place_ang } )
        
      end

      ObjAnimate( piece_obj, 6,0,0, _, { 0,0,1,1, t*0.5,2,1.2,1.2, t,1,1,1 } )

    end;

    function gm.place_enable( place, bool )
      local o = ObjGet( "spr_casket_mmg5_arrow_"..place )
      local clr_beg = o.color_r
      local clr_end = bool and 1 or 0.5
      ObjAnimate( o.name, 12,0,0, _, { 0,0,clr_beg,clr_beg,clr_beg, 0.35,3,clr_end,clr_end,clr_end } )
      ObjSet( o.name, { input = bool } )
    end

    function gm.piece_show_all( bool, t )
      t = t or 0.35
      local o
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          o = ObjGet( "obj_casket_mmg5_place_"..j.."_"..i )
          ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,0,bool and 1 or 0 } )
        end
        local o = ObjGet( "spr_casket_mmg5_place_"..j.."_done_light" )
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,0,0 } )
      end
    end

    function gm.piece_ang( piece )
      return ( 1 - gm.piece_place( piece ).i ) * math.pi / 2;
    end

    function gm.piece_place( piece )
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          if gm.map[ j ][ i ].type == piece.type and gm.map[ j ][ i ].id == piece.id then
            return {
              j = j;
              i = i;
            }
          end;
        end
      end
    end

    function gm.event_mdown_piece( p_type, p_id )
      if ld.Lock( 1 ) then
        local piece = { type = p_type; id = p_id }
        local place = gm.piece_place( piece )
        if not gm.piece_in_snowflake then
          --кликнули по куску когд в снежинке ничего - пихаем в снежинку
          SoundSfx( "aud_clk_snowflake" )
          gm.piece_go_to( piece, 0 )
          gm.piece_in_snowflake = piece
          gm.place_light_controller( place.j, false )
        elseif gm.piece_in_snowflake.type == piece.type and gm.piece_in_snowflake.id == piece.id then
          --кликнули по тойже снежинке, возвращаем её на место
          SoundSfx( "aud_clk_snowflake" )
          gm.piece_go_to( piece, place.j )
          gm.piece_in_snowflake = false
          --gm.set_input()
        else
          --меняем местами
          SoundSfx( "aud_clk_snowflake" )
          if gm.win_place_check( place.j ) then
            gm.place_light_controller( place.j, false )
          end
          --piece to snowflake
          gm.piece_go_to( piece, 0, function() 
            --change piece places
            SoundSfx( "aud_change_snowflakes" )
            local place_1 = gm.piece_place( piece )
            local place_2 = gm.piece_place( gm.piece_in_snowflake )
            --ld.LogTrace( place_1, place_2, gm.map )
            gm.map[ place_1.j ][ place_1.i ], gm.map[ place_2.j ][ place_2.i ] = gm.map[ place_2.j ][ place_2.i ], gm.map[ place_1.j ][ place_1.i ]
            --ld.LogTrace( gm.map )
            --rotate snowflake with piece to new place
            gm.place_0_rotate_to_place( piece, function() 
              --piece from snowflake to new place
              gm.piece_go_to( piece, gm.piece_place( piece ).j, function()
                --rotate snowflake with old piece to new place
                gm.place_0_rotate_to_place( gm.piece_in_snowflake, function() 
                  --old piece from snowflake to new place
                  --SoundSfx( "aud_clk_snowflake" )
                  gm.piece_go_to( gm.piece_in_snowflake, gm.piece_place( gm.piece_in_snowflake ), function()
                    gm.piece_in_snowflake = false
                    gm.event_end()
                  end )
                end )
              end )
            end )
          end )
          
        end
      end
    end
    
    function gm.init()
      local drawoff = 43.25;
      local dw = { { -1, -1 }; { 1, -1 }; { 1, 1 }; { -1, 1 }; };
      for j = 1, #gm.map do
        ObjSet( "spr_casket_mmg5_arrow_"..j, {
          event_mdown = function() gm.event_mdown_arrow( j ) end;
          event_menter = gm.event_menter;
          event_mleave = gm.event_mleave;
        } )
        common_impl.ObjCreate( "spr_casket_mmg5_arrow_"..j.."_light", "spr", "spr_casket_mmg5_arrow_"..j, {
          res = "assets/levels/level/mg_casket/mmg5/arrow";
          alp = 0;
          input = 0;
          blendmode = 2;
        } );
        for i = 1, #gm.map[ j ] do
          local obj = "obj_casket_mmg5_place_"..j.."_"..i
          common_impl.ObjCreate( obj, "obj", "obj_casket_mmg5_place_"..j, {} );
          common_impl.ObjCreate( obj.."_spr", "spr", obj, {
            drawoff_x = dw[ i ][ 1 ] * drawoff;
            drawoff_y = dw[ i ][ 2 ] * drawoff;
            ang = ( -1 + i ) * math.pi / 2;
            res = "assets/levels/level/mg_casket/mmg5/"..j.."_"..i;
            event_mdown = function() gm.event_mdown_piece( j, i ) end;
            event_menter = gm.event_menter;
            event_mleave = gm.event_mleave;
          } );
          common_impl.ObjCreate( obj.."_spr_light", "spr", obj.."_spr", {
            res = "assets/levels/level/mg_casket/mmg5/"..j.."_"..i;
            alp = 0;
            input = 0;
            blendmode = 2;
            drawoff_x = dw[ i ][ 1 ] * drawoff;
            drawoff_y = dw[ i ][ 2 ] * drawoff;
          } );
        end
      end
    end

    function gm.set_all()
      local m
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          m = gm.map[ j ][ i ]
          ObjAttach( "obj_casket_mmg5_place_"..m.type.."_"..m.id, "obj_casket_mmg5_place_"..j )
          ObjSet( "obj_casket_mmg5_place_"..m.type.."_"..m.id, { ang = ( 1 - i ) * math.pi / 2; } )
        end
      end
      gm.set_input()
    end

    function gm.set_input()
      local m, v
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          m = gm.map[ j ][ i ]
          v = ( ( j + #gm.map[ j ] / 2 ) % #gm.map[ j ] )
          v = v == 0 and #gm.map[ j ] or v;
          --ld.LogTrace( j, i, m.type, m.id, v )
          ObjSet( "obj_casket_mmg5_place_"..m.type.."_"..m.id, { input = ( v == i ) } )
        end
        if gm.win_place_check( j ) then
          --gm.place_enable( j, false )
          --for i = 1, #gm.map[ j ] do
          --  ObjSet( "obj_casket_mmg5_place_"..j.."_"..i, { input = false } )
          --end
          gm.place_light_controller( j, true )
        else
          gm.place_light_controller( j, false )
        end
      end
    end

    function gm.place_light_controller( j, bool )
      local o = ObjGet( "spr_casket_mmg5_place_"..j.."_done_light" )
      if bool and not ObjGet( "tmr_mg_casket_place_light_controller" ) and o.alp < 0.5 then
        SoundSfx( "aud_snowflake_shines" )
        ld.StartTimer( "tmr_mg_casket_place_light_controller", 0.1, function() end )
      end
      ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, 0.25,0,bool and 0.5 or 0 } )
    end

    gm.default()

    if ng_global.progress[ "std" ][ "win_casket"..mg_num ].state then
      gm.map = ld.TableCopy( ng_global.progress[ "std" ][ "win_casket"..mg_num ].state )
    end

    gm.init()
    gm.set_all()

    if param == "no_attach" then
      ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
      ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 0; alp = 0; } )
    else
      ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
      ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 1; alp = 1; } )
    end
  else
    
  end
  
  if param ~= "no_attach" then
    cmn.MiniGameShow( "casket"..mg_num );
    SoundMgTheme( true )
  end
  
end

--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG 6 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load_mmg6( param )
  
  local mg_num = 6;

  gm[ "mmg"..mg_num ] = gm[ "mmg"..mg_num ] or {}
  local gm = gm[ "mmg"..mg_num ]

  if not gm[ "loaded_mmg"..mg_num ] then
    gm[ "loaded_mmg"..mg_num ] = true;
    
    gm.W = 35;
    gm.WAYS = {
      { x = 1; y = -1; };
      { x = 0; y = -2; };
      { x = -1; y = -1; };
      { x = -1; y = 1; };
      { x = 0; y = 2; };
      { x = 1; y = 1; };
    };
    gm.PLATE = {
      { 0, 1, 1, 1, 1, 0 };
      { 1, 1, 1, 1, 1, 0 };
      { 0, 1, 0, 1, 0, 1 };
      { 0, 1, 1, 0, 0, 0 };
      { 1, 1, 1, 0, 1, 1 };

      { 0, 0, 0, 1, 0, 0 };
      { 1, 0, 0, 1, 0, 1 };
      { 0, 0, 0, 0, 1, 0 };
      { 0, 1, 1, 1, 1, 1 };
      { 0, 0, 1, 1, 1, 1 };

      { 0, 0, 1, 0, 1, 1 };
      { 0, 0, 1, 0, 1, 0 };
      { 0, 0, 0, 1, 1, 1 };
      { 1, 0, 0, 0, 1, 1 };
    }
    
    function gm.default() 
      local x = -99;
      local o = -99;
      gm.map = {
        { o, x, o, x, o, x, o, x, o, x, o };
        { x, o, x, o, x, o, x, o, x, o, x };
        { o, 1, o, 2, o, 3, o, 4, o, 5, o };
        { x, o, x, o, x, o, x, o, x, o, x };
        { o, x, o, x, o, x, o, x, o, x, o };
        { o, o, 6, o, 7, o, 8, o, 9, o, o };
        { o, x, o, x, o, x, o, x, o, x, o };
        { x, o, x, o, x, o, x, o, x, o, x };
        { o,10, o,11, o,12, o,13, o,14, o };
        { x, o, x, o, x, o, x, o, x, o, x };
        { o, x, o, x, o, x, o, x, o, x, o };
      }
      gm.map_win = ld.TableCopy( gm.map )
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          if gm.map[ j ][ i ] >= 0 then
            gm.map[ j ][ i ] = 0;
          end
        end
      end
    end
    
    function gm.save()
      ng_global.progress[ "std" ][ "win_casket"..mg_num ].state = ld.TableCopy( gm.map )
    end
    function gm.reset()
      ld.Lock( 1 )
      local count = 0
      local func_end = function()
        count = count - 1
        --ld.LogTrace( count )
        if count <= 0 then
          gm.set_all();
          ld.Lock( 0 );
        end
      end
      local place
      for i = 1, #gm.PLATE do
        gm.event_mleave( i );
        place = gm.plate_get_place( i );
        if place then
          count = count + 1
          gm.place_set_plate( place, i, false )
          gm.plate_go_to( i, false, func_end )
        end
      end
      func_end();
      gm.save();
      --[[
      --====================
      gm.WAYS = {
        { x = 1; y = -1; };
        { x = 0; y = -2; };
        { x = -1; y = -1; };
        { x = -1; y = 1; };
        { x = 0; y = 2; };
        { x = 1; y = 1; };
      };
      gm.PLATE = {
        { 0, 1, 1, 1, 1, 0 };
        { 1, 1, 1, 1, 1, 0 };
        { 0, 1, 0, 1, 0, 1 };
        { 0, 1, 1, 0, 0, 0 };
        { 1, 1, 1, 0, 1, 1 };

        { 0, 0, 0, 1, 0, 0 };
        { 1, 0, 0, 1, 0, 1 };
        { 0, 0, 0, 0, 1, 0 };
        { 0, 1, 1, 1, 1, 1 };
        { 0, 0, 1, 1, 1, 1 };

        { 0, 0, 1, 0, 1, 1 };
        { 0, 0, 1, 0, 1, 0 };
        { 0, 0, 0, 1, 1, 1 };
        { 1, 0, 0, 0, 1, 1 };
      };
      ]]
      --===============
    end
    function gm.skip()
      local count = #gm.PLATE
      local func_end = function()
        count = count - 1
        if count <= 0 then
          gm.win()
        end
      end
      ld.Lock( 1 )
      SoundSfx( "aud_skip_balls" )
      gm.map = ld.TableCopy( gm.map_win )
      local place
      for i = 1, #gm.PLATE do
        place = gm.plate_get_place( i )
        gm.plate_go_to( i, place, func_end )
      end
    end
    function gm.win()
      ld.Lock( 1 )
      --public[ "win_casket"..mg_num ]()
--gm.obj_drop( obj, vx, vy, g )
      local ta = 0.35
      local o
      local m = {}
      for i = 1, 14 do
        m[ i ] = i
        o = ObjGet( "spr_casket_mmg6_"..i.."_light" )
        ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, ta,0,1 } )
      end
      ld.StartTimer( 0.35, function()
        ObjSet( "spr_casket_shell", { visible = 1, input = 1, active = 1 } )
        local rnd = {}
        while #m > 0 do
          local v = table.remove( m, math.random( 1, #m ) )
          table.insert( rnd, v )
        end
        local t = 0
        local ts = 0.05
        --for i = 1, 14 do
        --  o = ObjGet( "spr_casket_mmg6_"..i )
        --  ObjAnimate( o.name, 3,0,0, nil, { 0,0,o.pos_x,o.pos_y, t,0,o.pos_x,o.pos_y, t+ta,3,512,384 } )
        --  ObjAnimate( o.name.."_light", 8,0,0, nil, { 0,0,1, ta,0,0 } )
        --  t = t + ts;
        --end
        ld.StartTimer( t, function()
          private.game.obj_drop( "spr_casket_mmg6_box" )
        end )
        ld.StartTimer( t, function()
          ObjSet( "spr_casket_shell", { visible = 1, input = 1, active = 1 } )
          for i = 1, #rnd do
            private.game.obj_drop( "spr_casket_mmg6_"..rnd[ i ] )
            ObjAnimate( "spr_casket_mmg6_"..rnd[ i ].."_light", 8,0,0, nil, { 0,0,1, ta,0,0 } )
          end
          ld.StartTimer( ta, public[ "win_casket"..mg_num ] )
          ld.StartTimer( ta*3, function() ObjDelete( "obj_casket_mmg6_root" ); end )
        end )
      end )
    end

    function gm.win_check()
      for i = 1, #gm.PLATE do
        place = gm.plate_get_place( i )
        if not place then
          return false
        end
      end
      return true
    end

    function gm.event_end()
      if gm.win_check() then
        gm.win()
      else
        gm.save()
        ld.Lock( 0 )
      end
    end

    function gm.event_menter( n )
      if not gm.draging_now then
        local o = ObjGet( "spr_casket_mmg6_"..n.."_light" )
        ObjSet( "spr_casket_mmg6_"..n, { pos_z = 1 } )
        ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, (1-o.alp)*0.15,0,1 } )
      end
    end
    
    function gm.event_mleave( n )
      if not gm.draging_now then
        local o = ObjGet( "spr_casket_mmg6_"..n.."_light" )
        ObjSet( "spr_casket_mmg6_"..n, { pos_z = 0 } )
        ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, (o.alp)*0.15,0,0 } )
      end
    end

    function gm.event_startdrag( n )
      SoundSfx( "aud_drag_ball" )
      local obj = "spr_casket_mmg6_"..n;
      ObjSet( obj, { 
        pos_z = 33;
        inputrect_init = true;
        inputrect_x = -gm.W * 0.25;
        inputrect_y = -gm.W * 0.25;
        inputrect_w = gm.W * 0.5;
        inputrect_h = gm.W * 0.5;
      } )
    end

    function gm.event_drag( n )
      --local obj = "spr_casket_mmg6_"..n;
    end

    function gm.event_dragdrop( n )
      --ld.LogTrace( n, gm.PLATE[ n ] )
      gm.draging_now = false
      gm.event_mleave( n )
      local obj = "spr_casket_mmg6_"..n;
      local count = 0;
      local place;
      local p = GetZoomCursorPos()
      ObjSet( "spr_casket_mmg6_"..n, { pos_x = p[ 1 ]; pos_y = p[ 2 ] } )
      --определяем, попали ли мы в слот
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          if gm.map[ j ][ i ] >= 0 then
            count = count + 1
            if gm.map[ j ][ i ] == 0 and ApplyObj( obj, "obj_casket_mmg6_"..count.."_place" ) then
              place = { j = j; i = i }
              if gm.place_is_free_for_plate( place, n ) then
                SoundSfx( "aud_placing_ball" )
                gm.place_set_plate( place, n, true )
                gm.plate_go_to( n, place )
              else
                SoundSfx( "aud_wrong" )
                gm.plate_go_to( n, false )
              end
              return
            end
          end
        end
      end
      SoundSfx( "aud_wrong" )
      gm.plate_go_to( n, false )
    end
    
    function gm.event_mdown( n )
      gm.draging_now = n
      local place = gm.plate_get_place( n )
      if place then
        gm.place_set_plate( place, n, false )
      end
      --if ld.Lock( 1 ) then
      --  gm.event_end()
      --end
    end

    function gm.place_get_obj( place )
      --ld.LogTrace( place )
      local count = 0
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          if gm.map[ j ][ i ] >= 0 then
            count = count + 1
            --ld.LogTrace( j, i, gm.map[ j ][ i ] )
            if j == place.j and i == place.i then
              return "obj_casket_mmg6_"..count.."_place"
            end
          end
        end
      end
      return false
    end

    function gm.place_is_free_for_plate( place, plate )
      --определяем, можем ли мы применить в слот пластину
      --ld.LogTrace( place, plate )
      for z = 1, #gm.WAYS do
        --ld.LogTrace( gm.PLATE[ plate ][ z ], gm.map[ place.j + gm.WAYS[ z ].y ][ place.i + gm.WAYS[ z ].x ] )
        if ( gm.PLATE[ plate ][ z ] == 1 ) and ( gm.map[ place.j + gm.WAYS[ z ].y ][ place.i + gm.WAYS[ z ].x ] ~= -99 ) then
          --ld.LogTrace( "BAD!!!" )
          return false
        else
          
        end
      end
      --ld.LogTrace( "GOOD!!!" )
      return true;
    end

    function gm.place_set_plate( place, plate, bool )
      --выставляем в слот пластину или убираем
      for z = 1, #gm.WAYS do
        if gm.PLATE[ plate ][ z ] == 1 then
          local value = -99
          if bool then
            value = -plate * gm.PLATE[ plate ][ z ]
          end
          gm.map[ place.j + gm.WAYS[ z ].y ][ place.i + gm.WAYS[ z ].x ] = value
        end
      end
      gm.map[ place.j ][ place.i ] = bool and plate or 0
      --ld.LogTrace( gm.map )
    end

    function gm.plate_get_place( n )
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          if gm.map[ j ][ i ] == n then
            return { j = j, i = i }
          end
        end
      end
      return false
    end

    function gm.plate_go_to( plate, place, func_action )
      ld.Lock( 1 )
      local t = 0.5
      local obj = "spr_casket_mmg6_"..plate
      ObjSet( obj, { pos_z = 2; } );
      local func_end = function() 
        ObjSet( obj, { 
          pos_z = 0;
          inputrect_init = false;
          inputrect_x = 0;
          inputrect_y = 0;
          inputrect_w = 0;
          inputrect_h = 0;
        } )
        if func_action then
          func_action()
        else
          gm.event_end()
        end
      end
      if place then
        local o1 = ObjGet( obj )
        local o2 = ObjGet( gm.place_get_obj( place ) )
        --ld.LogTrace( "plate_go_to PLACE "..o.name )
        t = ( private.game.len( o1.pos_x,o1.pos_y, o2.pos_x,o2.pos_y ) / 2000 ) ^ 0.5
        ObjAnimate( obj, 3,0,0, func_end, { 0,0,o1.pos_x,o1.pos_y, t,2,o2.pos_x,o2.pos_y } )
      else
        --ld.LogTrace( "plate_go_to BACK "..obj )
        local o = ObjGet( obj )
        --ld.LogTrace( GetZoomCursorPos(), o.pos_x,o.pos_y, gm.POS_DEF[ obj ].pos_x,gm.POS_DEF[ obj ].pos_y )
        t = ( private.game.len( o.pos_x,o.pos_y, gm.POS_DEF[ obj ].pos_x,gm.POS_DEF[ obj ].pos_y ) / 3500 ) ^ 0.65
        ObjAnimate( obj, 3,0,0, func_end, { 0,0,o.pos_x,o.pos_y, t,2,gm.POS_DEF[ obj ].pos_x,gm.POS_DEF[ obj ].pos_y } )
      end

    end

    function gm.init()
      gm.POS_DEF = {}
      local o
      for i = 1, #gm.PLATE do
        o = ObjGet( "spr_casket_mmg6_"..i )
        gm.POS_DEF[ o.name ] = { pos_x = o.pos_x, pos_y = o.pos_y }
        ObjSet( o.name, { 
          event_menter = function() gm.event_menter( i ) end;
          event_mleave = function() gm.event_mleave( i ) end;
          event_mdown = function() gm.event_mdown( i ) end;
          event_startdrag = function() gm.event_startdrag( i ) end;
          --event_drag = function() gm.event_drag( i ) end;
          event_dragdrop = function() gm.event_dragdrop( i ) end;
        } )
        common_impl.ObjCreate( "spr_casket_mmg6_"..i.."_light", "spr", "spr_casket_mmg6_"..i, {
          res = ObjGet( "spr_casket_mmg6_"..i ).res.."_light";
          alp = 0;
          input = 0;
          blendmode = 2;
        } )
      end
      --local clr_place = { 1, 2, 3, 4, 2, 5, 6, 5, 2, 1, 6, 7, 3, 3 }
      --local clr = { 
      --  {  45, 172,  73 };
      --  { 175, 255,  90 };
      --  { 250, 240,  40 };
      --  { 255,  82, 182 };
      --  { 222,  57,  68 };
      --  {  57, 167, 195 };
      --  { 166,  32, 185 };
      --}
      --local box = ObjGet( "spr_casket_mmg6_box" )
      local count = 0
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          if gm.map[ j ][ i ] >= 0 then
            count = count + 1
            local place = count;
            common_impl.ObjCreate( "obj_casket_mmg6_"..count.."_place", "obj", "obj_casket_mmg6_root", {
              alp = 1;
              input = 1;
              inputrect_init = true;
              inputrect_x = -gm.W / 2;
              inputrect_y = -gm.W / 2;
              inputrect_w = gm.W;
              inputrect_h = gm.W;
              pos_x = 178 + i * 55.5;
              pos_y = 188 + j * 32.5;
              --event_mdown = function() ld.LogTrace( "place "..place ) end;
            } )
            --if clr_place[ place ] and clr_place[ place ] > 0 then
            --  common_impl.ObjCreate( "obj_casket_mmg6_"..count.."_hint", "spr", "spr_casket_mmg6_box", {
            --    res = "assets/levels/level/mg_casket/mmg6/hint";
            --    alp = 1;
            --    input = 0;
            --    pos_x = 177.5 + i * 55.5 - box.pos_x;
            --    pos_y = 192 + j * 32.0 - box.pos_y;
            --    color_r = clr[ clr_place[ place ] ][ 1 ] / 255;
            --    color_g = clr[ clr_place[ place ] ][ 2 ] / 255;
            --    color_b = clr[ clr_place[ place ] ][ 3 ] / 255;
            --  } )
            --end
            --ObjAttach( "spr_casket_mmg6_"..count.."_light", "obj_casket_mmg6_"..count.."_place" );
          end
        end
      end
    end

    function gm.set_all()
      local place, o
      for i = 1, #gm.PLATE do
        place = gm.plate_get_place( i )
        if place then
          o = ObjGet( gm.place_get_obj( place ) )
          ObjSet( "spr_casket_mmg6_"..i, { pos_x = o.pos_x; pos_y = o.pos_y; scale_x = 0.95; scale_y = 0.95; } )
        end
      end
    end

    gm.default()

    if ng_global.progress[ "std" ][ "win_casket"..mg_num ].state then
      gm.map = ld.TableCopy( ng_global.progress[ "std" ][ "win_casket"..mg_num ].state )
    end

    gm.init()
    gm.set_all()

    if param == "no_attach" then
      ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
      ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 0; alp = 0; } )
    else
      ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
      ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 1; alp = 1; } )
    end
  else
    
  end
  
  if param ~= "no_attach" then
    cmn.MiniGameShow( "casket"..mg_num );
    SoundMgTheme( true )
  end
  
end
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** MMG 7 *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load_mmg7( param )
  
  local mg_num = 7;

  gm[ "mmg"..mg_num ] = gm[ "mmg"..mg_num ] or {}
  local gm = gm[ "mmg"..mg_num ]

  if not gm[ "loaded_mmg"..mg_num ] then
    gm[ "loaded_mmg"..mg_num ] = true;

    gm.T = 0.25
    gm.CLR = {
      { color_r = 255 / 255; color_g =  54 / 255; color_b = 255 / 255; }; 
      { color_r = 250 / 255; color_g = 255 / 255; color_b =  33 / 255; }; 
      { color_r = 159 / 255; color_g =  69 / 255; color_b =  27 / 255; }; 
      { color_r =  45 / 255; color_g = 192 / 255; color_b =  66 / 255; }; 
    }
    gm.CLR[ 0 ] = { color_r = 1; color_g =  1; color_b = 1; }; 

    function gm.default() 
      gm.buttons = {
        { win_clr = 0; clr = 0; btn = false; pushed = false;  connections = { 5 }; }; --not exist
        { win_clr = 4; clr = 0; btn = true; pushed = false;  connections = { 3, 4, 5, 6, 8, 10 }; };
        { win_clr = 0; clr = 0; btn = false; pushed = false;  connections = { 2 }; }; --not exist
        { win_clr = 2; clr = 0; btn = true; pushed = false;  connections = { 2, 5, 6 }; };
        { win_clr = 4; clr = 0; btn = true; pushed = false;  connections = { 1, 2, 4, 6 }; };

        { win_clr = 4; clr = 0; btn = true; pushed = false;  connections = { 2, 4, 5, 7, 8, 9 }; };
        { win_clr = 1; clr = 0; btn = true; pushed = false;  connections = { 6, 8, 11 }; };
        { win_clr = 4; clr = 0; btn = true; pushed = false;  connections = { 2, 6, 7, 9, 10, 11, 12 }; };
        { win_clr = 2; clr = 0; btn = true; pushed = false;  connections = { 6, 8 }; };
        { win_clr = 1; clr = 0; btn = true; pushed = false;  connections = { 2, 8, 12 }; };

        { win_clr = 4; clr = 0; btn = true; pushed = false;  connections = { 7, 8, 12, 13, 14, 15 }; };
        { win_clr = 4; clr = 0; btn = true; pushed = false;  connections = { 8, 10, 11, 14, 16, 17 }; };
        { win_clr = 1; clr = 0; btn = true; pushed = false;  connections = { 11 }; };
        { win_clr = 4; clr = 0; btn = true; pushed = false;  connections = { 11, 12, 15, 16, 17, 20, 21, 22 }; };
        { win_clr = 2; clr = 0; btn = true; pushed = false;  connections = { 11, 14 }; };

        { win_clr = 1; clr = 0; btn = true; pushed = false;  connections = { 12, 14 }; };
        { win_clr = 2; clr = 0; btn = true; pushed = false;  connections = { 12, 14, 21 }; };
        { win_clr = 0; clr = 0; btn = false; pushed = false;  connections = { 21 }; }; --not exist
        { win_clr = 0; clr = 0; btn = false; pushed = false;  connections = { 20 }; }; --not exist
        { win_clr = 4; clr = 0; btn = true; pushed = false;  connections = { 14, 19, 22 }; };

        { win_clr = 4; clr = 0; btn = true; pushed = false;  connections = { 14, 17, 18, 22, 25 }; };
        { win_clr = 4; clr = 0; btn = true; pushed = false;  connections = { 14, 20, 21, 23, 24, 26, 28, 29 }; };
        { win_clr = 1; clr = 0; btn = true; pushed = false;  connections = { 22 }; };
        { win_clr = 2; clr = 0; btn = true; pushed = false;  connections = { 22 }; };
        { win_clr = 1; clr = 0; btn = true; pushed = false;  connections = { 21 }; };

        { win_clr = 2; clr = 0; btn = true; pushed = false;  connections = { 22 }; };
        { win_clr = 0; clr = 0; btn = false; pushed = false;  connections = {  }; }; --not exist
        { win_clr = 3; clr = 0; btn = true; pushed = false;  connections = { 22, 29 }; };
        { win_clr = 1; clr = 0; btn = true; pushed = false;  connections = { 22, 28 }; };
      }
    end
    
    function gm.save()
      ng_global.progress[ "std" ][ "win_casket"..mg_num ].state = ld.TableCopy( gm.buttons )
    end
    function gm.reset()
      local func_end = function()
        gm.default()
        gm.save()
        gm.set_all()
        ld.Lock( 0 )
      end
      local reseting = false
      for i = 1, #gm.buttons do
        if gm.buttons[ i ].btn and gm.buttons[ i ].pushed == true then
          gm.button_click( i, function()  end )
          reseting = true
        end
      end
      if reseting then
        ld.Lock( 1 )
        ld.StartTimer( gm.T, func_end )
      else
        ld.Lock( 0 )
      end
    end
    function gm.skip()
      ld.Lock( 1 )
      local func_end = function()
        public[ "win_casket"..mg_num ]()
      end
      for i = 1, #gm.buttons do
        if gm.buttons[ i ].btn and gm.buttons[ i ].pushed == false then
          gm.button_click( i, function()  end )
        end
        if gm.buttons[ i ].btn then-- and gm.buttons[ i ].clr ~= gm.buttons[ i ].win_clr then
          gm.button_repaint_child( i, 0, 1 )
          gm.button_repaint_child( i, gm.buttons[ i ].win_clr, 1 )
        end
      end
      ld.StartTimer( gm.T, func_end )
    end
    function gm.win()
      ld.Lock( 1 )
      gm.skip()
    end

    function gm.win_check()
      for i = 1, #gm.buttons do
        if gm.buttons[ i ].btn and gm.buttons[ i ].clr ~= gm.buttons[ i ].win_clr then
          --ld.LogTrace( i, gm.buttons[ i ].clr, gm.buttons[ i ].win_clr )
          return false
        end
      end
      return true
    end

    function gm.event_end()
      if gm.win_check() then
        gm.win()
      else
        gm.save()
        ld.Lock( 0 )
      end
    end

    function gm.event_menter( n )
      ld.ShCur(CURSOR_HAND)
    end
    
    function gm.event_mleave( n )
      ld.ShCur(CURSOR_DEFAULT)
    end

    function gm.event_mdown_button( n )
      if ld.Lock( 1 ) then
        gm.event_end()
      end
    end

    function gm.button_click( n, func_end )
      if not gm.button_click_sfx then
        gm.button_click_sfx = true
        SoundSfx( "aud_clk_ho" )
        ld.StartTimer( 0, function() gm.button_click_sfx = false end )
      end
      func_end = func_end or gm.event_end
      local btn = gm.buttons[ n ]
      local o = ObjGet( "spr_casket_mmg7_color"..n )
      if btn.pushed then
        btn.pushed = false
        btn.clr = 0
        ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, gm.T,1,0 } )
        ObjAnimate( "spr_casket_mmg7_uppush"..n, 8,0,0, func_end, { 0,0,0, gm.T,2,1 } )
      else
        btn.pushed = true
        ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, gm.T,2,0 } )
        ObjAnimate( "spr_casket_mmg7_uppush"..n, 8,0,0, func_end, { 0,0,1, gm.T,2,0 } )
        if btn.clr ~= 0 then
          gm.button_paint( n, 0 )
        end
      end
    end

    function gm.button_repaint_childs( n, clr, deep )
      deep = deep or 1
      local btn = gm.buttons[ n ]
      local painting = false
      gm.button_repaints = gm.button_repaints or 0
      if gm.button_repaints == 0 then
        gm.button_repaints_deep = 0
      end
      gm.button_repaints_deep = math.max( deep )
      gm.button_repaints = gm.button_repaints + 1
      local repaints = {}
      for i = 1, #btn.connections do
        if gm.button_repaint_child( btn.connections[ i ], clr, deep ) then
          --gm.button_repaints = gm.button_repaints + 1
          painting = true
          table.insert( repaints, btn.connections[ i ] )
          --gm.button_repaint_childs( btn.connections[ i ], clr, deep + 1 )
        end
      end
      for i = 1, #repaints do
        gm.button_repaint_childs( repaints[ i ], clr, deep + 1 )
      end
      gm.button_repaints = gm.button_repaints - 1
      --ld.LogTrace( n, clr, deep, gm.button_repaints, gm.button_repaints_deep, painting )
      if gm.button_repaints == 0 then
        gm.button_repaints = -1;
        ld.StartTimer( gm.T * ( gm.button_repaints_deep - 1 ), gm.event_end )
      end
    end

    function gm.button_repaint_child( n, clr, deep )
      local btn = gm.buttons[ n ]
      --ld.LogTrace( btn )
      if ( btn.clr == 0 or clr == 0 ) and btn.pushed == true and btn.btn == true then
        btn.clr = clr
        local o = ObjGet( "spr_casket_mmg7_color"..n )
        ObjAnimate( o.name, 8,0,0, nil, { 
          0,0,o.alp;
          gm.T*(deep-1),0,o.alp;
          gm.T*deep,0,clr == 0 and 0 or 1;
        } );
        ld.StartTimer( gm.T*(deep-1), function() gm.paint_fx( n, clr ) end )
        ObjAnimate( o.name, 12,0,0, nil, { 
          0,0,o.color_r,o.color_g,o.color_b;
          gm.T*(deep-1),0,o.color_r,o.color_g,o.color_b;
          gm.T*deep,0,gm.CLR[ btn.clr ].color_r,gm.CLR[ btn.clr ].color_g,gm.CLR[ btn.clr ].color_b;
        } );
        
        return true;
      elseif btn.clr == 0 and btn.btn == false then

        return true;
      end
      --ld.LogTrace( btn )
      return false
    end

    function gm.button_paint( n, clr )
      local btn = gm.buttons[ n ]
      btn.clr = clr
      local o = ObjGet( "spr_casket_mmg7_color"..n )
      ObjAnimate( o.name, 12,0,0, nil, { 
        0,0,o.color_r,o.color_g,o.color_b;
        gm.T,0,gm.CLR[ btn.clr ].color_r,gm.CLR[ btn.clr ].color_g,gm.CLR[ btn.clr ].color_b;
      } );
      ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, gm.T,0,clr == 0 and 0 or 1 } )
    end

    function gm.paint_fx( n, clr )
      local o = ObjGet( "spr_casket_mmg7_color"..n )
      if o then
        if not gm.paint_fx_sfx then
          gm.paint_fx_sfx = true
          SoundSfx( "aud_clk_ho_2" )
          ld.StartTimer( 0, function() gm.paint_fx_sfx = false end )
        end
        local collect_name = "spr_casket_mmg7_color"..n.."_fx"
        if not ObjGet( collect_name ) then
          ObjCreate( collect_name, "partsys" )
          ObjSet( collect_name,
          {
            res = "assets/interface/resources/effects_ho_fast",
            --pos_x = o.pos_x, pos_y = o.pos_y,
            active = 1, visible = 1, input = 0, blendmode = 2, pos_z = 50
          } );
          ObjAttach( collect_name, "obj_casket_mmg7_root" );
          PartSysSetMaskObj( collect_name, "spr_casket_mmg7_color"..n );  
        end
        ObjSet( collect_name, { 
          blendmode = 2;
          color_r = gm.CLR[ clr ].color_r;
          color_g = gm.CLR[ clr ].color_g;
          color_b = gm.CLR[ clr ].color_b;
        } );
        --ld.LogTrace( collect_name, ObjGet( collect_name ) )
        PartSysRestart( collect_name )

      end
--common_impl.FxAnmObj( "spr_casket_mmg7_color"..n )
    end

    function gm.paint_click( n )
      if ld.Lock( 1 ) then
        SoundSfx( "aud_clk_bucket" )
        gm.button_repaints = 0
        local connect = { 1, 3, 18, 19 }
        ld.AnimPlay( "anm_casket_mmg7_anm_paint_"..n, "bucket"..n, function() 
          
        end )
        gm.paint_fx( connect[ n ], n )
        ld.StartTimer( gm.T*1.5, function() 
          gm.button_repaint_childs( connect[ n ], n )
        end )
        local btn = gm.buttons[ connect[ n ] ]
        btn.clr = n
        local o = ObjGet( "spr_casket_mmg7_color"..connect[ n ] )
        ObjAnimate( o.name, 8,0,0, nil, { 
          0,0,0;
          gm.T*1,2,1;
          gm.T*2,1,1;
          gm.T*3,1,0;
        } );
        ObjSet( o.name, { 
          color_r = gm.CLR[ btn.clr ].color_r;
          color_g = gm.CLR[ btn.clr ].color_g;
          color_b = gm.CLR[ btn.clr ].color_b;
        } );
        --ObjAnimate( o.name, 12,0,0, nil, { 
        --  0,0,o.color_r,o.color_g,o.color_b;
        --  gm.T,2,gm.CLR[ btn.clr ].color_r,gm.CLR[ btn.clr ].color_g,gm.CLR[ btn.clr ].color_b;
        --  --gm.T*2,1,o.color_r,o.color_g,o.color_b;
        --} );
        btn.clr = 0
      end
    end

    function gm.init()
      for i = 1, #gm.buttons do
        if gm.buttons[ i ].btn then
          ObjSet( "spr_casket_mmg7_color"..i, { 
            input = 1;
            event_mdown = function() gm.button_click( i ) end;
            event_menter = function() gm.event_menter( i ) end;
            event_mleave = function() gm.event_mleave( i ) end;
          } )
        end
      end
      for i = 1, 4 do
          ObjSet( "obj_casket_mmg7_paint_"..i, { 
            input = 1;
            event_mdown = function() gm.paint_click( i ) end;
            event_menter = function() gm.event_menter( i ) end;
            event_mleave = function() gm.event_mleave( i ) end;
          } )
      end
    end

    function gm.set_all()
      for i = 1, #gm.buttons do
        if gm.buttons[ i ].btn then
          ObjSet( "spr_casket_mmg7_color"..i, { 
            alp = gm.buttons[ i ].clr > 0 and 1 or 0;
            color_r = gm.CLR[ gm.buttons[ i ].clr ].color_r;
            color_g = gm.CLR[ gm.buttons[ i ].clr ].color_g;
            color_b = gm.CLR[ gm.buttons[ i ].clr ].color_b;
          } )
          ObjSet( "spr_casket_mmg7_uppush"..i, { alp = gm.buttons[ i ].pushed and 0 or 1; pos_z = 2; } )
        else
          ObjSet( "spr_casket_mmg7_color"..i, { 
            alp = 0;
          } )
        end
      end
    end

    gm.default()

    if ng_global.progress[ "std" ][ "win_casket"..mg_num ].state then
      gm.buttons = ld.TableCopy( ng_global.progress[ "std" ][ "win_casket"..mg_num ].state )
    end

    gm.init()
    gm.set_all()

    if param == "no_attach" then
      ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
      ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 0; alp = 0; } )
    else
      ObjAttach( "obj_casket_mmg"..mg_num.."_root", "mg_casket" )
      ObjSet( "obj_casket_mmg"..mg_num.."_root", { visible = 1; alp = 1; } )
    end
  else
    
  end
  
  if param ~= "no_attach" then
    cmn.MiniGameShow( "casket"..mg_num );
    SoundMgTheme( true )
  end
  
end