-- name=rm_attic
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_attic";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  SoundEnvInit( "aud_zz_angryoven_env", "zz_angryoven" )
  --------------------------------------------------------------------------------------------
function private.opn_attic()
  if not ( cmn.IsEventDone( "opn_attic" ) ) then
    local func_end = function()
        ld.Lock(0)
        ObjDelete("vid_attic_vid_oven_awake_239");
        common_impl.SetWidgetsVisible( "DialogVideoShow", true )
        cmn.SetEventDone( "opn_attic" );
        cmn.CallEventHandler( "opn_attic" )
        ld.ShowBbtOpn( private.room_objname )
    end;
    local func_end_2 = function()
      ld.Lock(1)
      int.DialogVideoHide();
      VidPause( "vid_attic_vid_oven_awake_239", 1 )
      ObjAnimate( "vid_attic_vid_oven_awake_239", 8,0,0, func_end, { 0,0,1, 0.3,0,0 } )
    end
    --[[
    common_impl.VideoSubtitleVocStart( {
      { "srt_aud_oven_awake_239_voc" , aud_voc_false, 1,7 };
    } );
    ]]
    SoundVoice( "aud_oven_awake_239_voc" );
    int.DialogVideoShow( "", 1, func_end_2 );
    SoundVid( "vid_oven_awake_239" )
    VidPlay("vid_attic_vid_oven_awake_239",func_end_2)
  end;
  if ld.CheckRequirements( {"win_train"} ) and not ld.CheckRequirements( {"clk_trainelfreturn"} ) then
    cmn.SetEventDone( "clk_trainelfreturn" );
    cmn.CallEventHandler( "clk_trainelfreturn" );  
    interface.SimonReturn()
  end

end;
--------------------------------------------------------------------
local opn_attic = function() end;
local opn_attic_logic = function() end;
cmn.AddSubscriber( "opn_attic", opn_attic_logic )
cmn.AddSubscriber( "opn_attic", opn_attic, private.room_objname )
--------------------------------------------------------------------------------------------

local function clk_trainelfreturn_logic()
  int_simon.SimonSetVisible(1)
end
cmn.AddSubscriber("clk_trainelfreturn", clk_trainelfreturn_logic )

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_boxwithtoys *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_humanform" ] = { type = "get", get_obj = "spr_boxwithtoys_humanform", room = "rm_attic", zz = "zz_boxwithtoys", zz_gate = "gzz_attic_boxwithtoys" };

private.get_humanform_logic = function()
  
end;
private.get_humanform_inv = function()
  interface.InventoryItemAdd("inv_humanform","spr_boxwithtoys_humanform");
end;
private.get_humanform_beg = function()
  ObjDelete("gfx_boxwithtoys_humanform")
  ObjDelete("spr_boxwithtoys_humanform_shadow")
end;
private.get_humanform_end = function()
  ObjDelete("spr_attic_humanform")
  if common_impl.ZzCompleteCheck("get_humanform") then ObjSet( common_impl.hint["get_humanform"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_humanform", private.get_humanform_inv );
cmn.AddSubscriber( "get_humanform", private.get_humanform_beg, private.room_objname );
cmn.AddSubscriber( "get_humanform", private.get_humanform_end, private.room_objname );
cmn.AddSubscriber( "get_humanform", private.get_humanform_logic );
--------------------------------------------------------------------
function public.get_humanform()
  cmn.SetEventDone( "get_humanform" );
  cmn.CallEventHandler( "get_humanform" );
  if common_impl.ZzCompleteCheck("get_humanform") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_funnyracoon" ] = { type = "use", inv_obj = "inv_funnyracoon", use_place = "gfx_boxwithtoys_funnyracoon_zone", room = "rm_attic", zz = "zz_boxwithtoys", zz_gate = "gzz_attic_boxwithtoys" };

private.use_funnyracoon_logic = function()
  ObjSet( "gfx_boxwithtoys_clk_boxwithtoys1_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_funnyracoon_inv = function()
  common_impl.ProcessMultiUseAll("funnyracoon", "funnyracoon")
end;
private.use_funnyracoon_beg = function()
  ObjDelete( "gfx_boxwithtoys_funnyracoon_zone" );
end;
private.use_funnyracoon_end = function()
  ObjSet( "spr_attic_open_box", {visible = 1} );
  ObjSet( "spr_attic_enot_amulet", {visible = 1} );
  ObjSet( "anm_boxwithtoys_anm_box", {animfunc = "anim_toy_1", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_funnyracoon") then ObjSet( common_impl.hint["use_funnyracoon"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_funnyracoon", private.use_funnyracoon_inv );
cmn.AddSubscriber( "use_funnyracoon", private.use_funnyracoon_beg, private.room_objname );
cmn.AddSubscriber( "use_funnyracoon", private.use_funnyracoon_end, private.room_objname );
cmn.AddSubscriber( "use_funnyracoon", private.use_funnyracoon_logic );
cmn.AddSubscriber( "use_funnyracoon_inv", private.use_funnyracoon_inv, private.room_objname );
cmn.AddSubscriber( "use_funnyracoon_beg", private.use_funnyracoon_beg, private.room_objname );
cmn.AddSubscriber( "use_funnyracoon_end", private.use_funnyracoon_end, private.room_objname );
cmn.AddSubscriber( "use_funnyracoon_end", private.use_funnyracoon_logic );
--------------------------------------------------------------------------------------------
function public.use_funnyracoon( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_funnyracoon" );
    cmn.CallEventHandler( "use_funnyracoon_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_funnyracoon") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_funnyracoon_inv" );
  cmn.CallEventHandler( "use_funnyracoon_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boxwithtoys_anm_box", "anim_open_chest", func_end );
  SoundSfx( "aud_use_funnyracoon_attic" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_boxwithtoys1" ] = { type = "click", use_place = "gfx_boxwithtoys_clk_boxwithtoys1_zone", room = "rm_attic", zz = "zz_boxwithtoys", zz_gate = "gzz_attic_boxwithtoys" };

private.clk_boxwithtoys1_logic = function()
  ObjSet( "gfx_boxwithtoys_clk_boxwithtoys2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_boxwithtoys1_beg = function()
  ObjDelete( "gfx_boxwithtoys_clk_boxwithtoys1_zone" );
end;
private.clk_boxwithtoys1_end = function()
  ObjSet( "anm_boxwithtoys_anm_box", {animfunc = "anim_toy_2", frame = 0 } );
  if common_impl.ZzCompleteCheck("clk_boxwithtoys1") then ObjSet( common_impl.hint["clk_boxwithtoys1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_boxwithtoys1", private.clk_boxwithtoys1_beg, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys1", private.clk_boxwithtoys1_end, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys1", private.clk_boxwithtoys1_logic );
cmn.AddSubscriber( "clk_boxwithtoys1_beg", private.clk_boxwithtoys1_beg, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys1_end", private.clk_boxwithtoys1_end, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys1_end", private.clk_boxwithtoys1_logic );
--------------------------------------------------------------------------------------------
function public.clk_boxwithtoys1()

  local func_end = function()
    cmn.SetEventDone( "clk_boxwithtoys1" );
    cmn.CallEventHandler( "clk_boxwithtoys1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_boxwithtoys1") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_boxwithtoys1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boxwithtoys_anm_box", "anim_toy_1", func_end );
  SoundSfx( "aud_clk_boxwithtoys_attic" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_boxwithtoys2" ] = { type = "click", use_place = "gfx_boxwithtoys_clk_boxwithtoys2_zone", room = "rm_attic", zz = "zz_boxwithtoys", zz_gate = "gzz_attic_boxwithtoys" };

private.clk_boxwithtoys2_logic = function()
  ObjSet( "gfx_boxwithtoys_clk_boxwithtoys3_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_boxwithtoys2_beg = function()
  ObjDelete( "gfx_boxwithtoys_clk_boxwithtoys2_zone" );
end;
private.clk_boxwithtoys2_end = function()
  ObjSet( "anm_boxwithtoys_anm_box", {animfunc = "anim_toy_3", frame = 0 } );
  if common_impl.ZzCompleteCheck("clk_boxwithtoys2") then ObjSet( common_impl.hint["clk_boxwithtoys2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_boxwithtoys2", private.clk_boxwithtoys2_beg, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys2", private.clk_boxwithtoys2_end, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys2", private.clk_boxwithtoys2_logic );
cmn.AddSubscriber( "clk_boxwithtoys2_beg", private.clk_boxwithtoys2_beg, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys2_end", private.clk_boxwithtoys2_end, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys2_end", private.clk_boxwithtoys2_logic );
--------------------------------------------------------------------------------------------
function public.clk_boxwithtoys2()

  local func_end = function()
    cmn.SetEventDone( "clk_boxwithtoys2" );
    cmn.CallEventHandler( "clk_boxwithtoys2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_boxwithtoys2") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_boxwithtoys2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boxwithtoys_anm_box", "anim_toy_2", func_end );
  SoundSfx( "aud_clk_boxwithtoys_attic" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "clk_boxwithtoys3" ] = { type = "click", use_place = "gfx_boxwithtoys_clk_boxwithtoys3_zone", room = "rm_attic", zz = "zz_boxwithtoys", zz_gate = "gzz_attic_boxwithtoys" };

private.clk_boxwithtoys3_logic = function()
  ObjSet( "gfx_boxwithtoys_clk_boxwithtoys4_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_boxwithtoys3_beg = function()
  ObjDelete( "gfx_boxwithtoys_clk_boxwithtoys3_zone" );
end;
private.clk_boxwithtoys3_end = function()
  ObjSet( "anm_boxwithtoys_anm_box", {animfunc = "anim_toy_4", frame = 0 } );
  if common_impl.ZzCompleteCheck("clk_boxwithtoys3") then ObjSet( common_impl.hint["clk_boxwithtoys3"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_boxwithtoys3", private.clk_boxwithtoys3_beg, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys3", private.clk_boxwithtoys3_end, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys3", private.clk_boxwithtoys3_logic );
cmn.AddSubscriber( "clk_boxwithtoys3_beg", private.clk_boxwithtoys3_beg, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys3_end", private.clk_boxwithtoys3_end, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys3_end", private.clk_boxwithtoys3_logic );
--------------------------------------------------------------------------------------------
function public.clk_boxwithtoys3()

  local func_end = function()
    cmn.SetEventDone( "clk_boxwithtoys3" );
    cmn.CallEventHandler( "clk_boxwithtoys3_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_boxwithtoys3") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_boxwithtoys3_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boxwithtoys_anm_box", "anim_toy_3", func_end );
  SoundSfx( "aud_clk_boxwithtoys_attic" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "clk_boxwithtoys4" ] = { type = "click", use_place = "gfx_boxwithtoys_clk_boxwithtoys4_zone", room = "rm_attic", zz = "zz_boxwithtoys", zz_gate = "gzz_attic_boxwithtoys" };

private.clk_boxwithtoys4_logic = function()
  ObjSet( "spr_boxwithtoys_spoon", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_boxwithtoys_faceprint", { visible = 1, input = 1, active = 1 } )

end;
private.clk_boxwithtoys4_beg = function()
  ObjDelete( "gfx_boxwithtoys_clk_boxwithtoys4_zone" );
end;
private.clk_boxwithtoys4_end = function()
  ObjSet( "anm_boxwithtoys_anm_box", {animfunc = "anim_toy_end3", frame = 0 } );
  if common_impl.ZzCompleteCheck("clk_boxwithtoys4") then ObjSet( common_impl.hint["clk_boxwithtoys4"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_boxwithtoys4", private.clk_boxwithtoys4_beg, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys4", private.clk_boxwithtoys4_end, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys4", private.clk_boxwithtoys4_logic );
cmn.AddSubscriber( "clk_boxwithtoys4_beg", private.clk_boxwithtoys4_beg, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys4_end", private.clk_boxwithtoys4_end, private.room_objname );
cmn.AddSubscriber( "clk_boxwithtoys4_end", private.clk_boxwithtoys4_logic );
--------------------------------------------------------------------------------------------
function public.clk_boxwithtoys4()

  local func_end = function()
    cmn.SetEventDone( "clk_boxwithtoys4" );
    cmn.CallEventHandler( "clk_boxwithtoys4_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_boxwithtoys4") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_boxwithtoys4_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boxwithtoys_anm_box", "anim_toy_4", func_end );
  SoundSfx( "aud_clk_boxwithtoys_attic" )


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_spoon" ] = { type = "get", get_obj = "spr_boxwithtoys_spoon", room = "rm_attic", zz = "zz_boxwithtoys", zz_gate = "gzz_attic_boxwithtoys" };

private.get_spoon_logic = function()
  
end;
private.get_spoon_inv = function()
  interface.InventoryItemAdd("inv_spoon","spr_boxwithtoys_spoon");
end;
private.get_spoon_beg = function()
  ObjDelete("gfx_boxwithtoys_spoon")
end;
private.get_spoon_end = function()
  if common_impl.ZzCompleteCheck("get_spoon") then ObjSet( common_impl.hint["get_spoon"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_spoon", private.get_spoon_inv );
cmn.AddSubscriber( "get_spoon", private.get_spoon_beg, private.room_objname );
cmn.AddSubscriber( "get_spoon", private.get_spoon_end, private.room_objname );
cmn.AddSubscriber( "get_spoon", private.get_spoon_logic );
--------------------------------------------------------------------
function public.get_spoon()
  cmn.SetEventDone( "get_spoon" );
  cmn.CallEventHandler( "get_spoon" );
  if common_impl.ZzCompleteCheck("get_spoon") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_faceprint" ] = { type = "get", get_obj = "spr_boxwithtoys_faceprint", room = "rm_attic", zz = "zz_boxwithtoys", zz_gate = "gzz_attic_boxwithtoys" };

private.get_faceprint_logic = function()
  
end;
private.get_faceprint_inv = function()
  interface.InventoryItemAdd("inv_faceprint","spr_boxwithtoys_faceprint");
end;
private.get_faceprint_beg = function()
  ObjDelete("gfx_boxwithtoys_faceprint")
end;
private.get_faceprint_end = function()
  if common_impl.ZzCompleteCheck("get_faceprint") then ObjSet( common_impl.hint["get_faceprint"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_faceprint", private.get_faceprint_inv );
cmn.AddSubscriber( "get_faceprint", private.get_faceprint_beg, private.room_objname );
cmn.AddSubscriber( "get_faceprint", private.get_faceprint_end, private.room_objname );
cmn.AddSubscriber( "get_faceprint", private.get_faceprint_logic );
--------------------------------------------------------------------
function public.get_faceprint()
  cmn.SetEventDone( "get_faceprint" );
  cmn.CallEventHandler( "get_faceprint" );
  if common_impl.ZzCompleteCheck("get_faceprint") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_harefoot" ] = { type = "use", inv_obj = "inv_harefoot", use_place = "gfx_boxwithtoys_harefoot_zone", room = "rm_attic", zz = "zz_boxwithtoys", zz_gate = "gzz_attic_boxwithtoys" };

private.use_harefoot_logic = function()
  ObjSet( "gfx_boxwithtoys_drumstick_zone", {active = 1, input = 1, visible = 1} );
  if ld.CheckRequirements( {"use_harefoot","use_drumstick"} ) then
    ObjSet( "spr_boxwithtoys_clockworkmouse", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_boxwithtoys_mosaicsun", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_harefoot_inv = function()
  common_impl.ProcessMultiUseAll("harefoot", "harefoot")
end;
private.use_harefoot_beg = function()
  ObjDelete( "gfx_boxwithtoys_harefoot_zone" );
end;
private.use_harefoot_end = function()
  ObjSet( "spr_attic_paw", {visible = 1} );
  ObjSet( "anm_boxwithtoys_anm_rabbit", {animfunc = "anim_bunny2", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_harefoot") then ObjSet( common_impl.hint["use_harefoot"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_harefoot", private.use_harefoot_inv );
cmn.AddSubscriber( "use_harefoot", private.use_harefoot_beg, private.room_objname );
cmn.AddSubscriber( "use_harefoot", private.use_harefoot_end, private.room_objname );
cmn.AddSubscriber( "use_harefoot", private.use_harefoot_logic );
cmn.AddSubscriber( "use_harefoot_inv", private.use_harefoot_inv, private.room_objname );
cmn.AddSubscriber( "use_harefoot_beg", private.use_harefoot_beg, private.room_objname );
cmn.AddSubscriber( "use_harefoot_end", private.use_harefoot_end, private.room_objname );
cmn.AddSubscriber( "use_harefoot_end", private.use_harefoot_logic );
--------------------------------------------------------------------------------------------
function public.use_harefoot( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_harefoot" );
    cmn.CallEventHandler( "use_harefoot_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_harefoot") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_harefoot_inv" );
  cmn.CallEventHandler( "use_harefoot_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boxwithtoys_anm_rabbit", "anim_toy_end1", func_end );
  SoundSfx( "aud_use_harefoot_attic" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_drumstick" ] = { type = "use", inv_obj = "inv_drumstick", use_place = "gfx_boxwithtoys_drumstick_zone", room = "rm_attic", zz = "zz_boxwithtoys", zz_gate = "gzz_attic_boxwithtoys" };

private.use_drumstick_logic = function()
  if ld.CheckRequirements( {"use_drumstick","use_harefoot"} ) then
    ObjSet( "spr_boxwithtoys_clockworkmouse", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_boxwithtoys_mosaicsun", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_drumstick_inv = function()
  common_impl.ProcessMultiUseAll("drumstick", "drumstick")
end;
private.use_drumstick_beg = function()
  ObjDelete( "gfx_boxwithtoys_drumstick_zone" );
end;
private.use_drumstick_end = function()
  ObjSet( "spr_attic_hole", {visible = 1} );
  ObjSet( "anm_boxwithtoys_anm_rabbit", {animfunc = "anim_bunny2_end", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_drumstick") then ObjSet( common_impl.hint["use_drumstick"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_drumstick", private.use_drumstick_inv );
cmn.AddSubscriber( "use_drumstick", private.use_drumstick_beg, private.room_objname );
cmn.AddSubscriber( "use_drumstick", private.use_drumstick_end, private.room_objname );
cmn.AddSubscriber( "use_drumstick", private.use_drumstick_logic );
cmn.AddSubscriber( "use_drumstick_inv", private.use_drumstick_inv, private.room_objname );
cmn.AddSubscriber( "use_drumstick_beg", private.use_drumstick_beg, private.room_objname );
cmn.AddSubscriber( "use_drumstick_end", private.use_drumstick_end, private.room_objname );
cmn.AddSubscriber( "use_drumstick_end", private.use_drumstick_logic );
--------------------------------------------------------------------------------------------
function public.use_drumstick( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_drumstick" );
    cmn.CallEventHandler( "use_drumstick_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_drumstick") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_drumstick_inv" );
  cmn.CallEventHandler( "use_drumstick_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_boxwithtoys_anm_rabbit", "anim_bunny2", func_end );
  SoundSfx( "aud_use_drumstick_attic" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_clockworkmouse" ] = { type = "get", get_obj = "spr_boxwithtoys_clockworkmouse", room = "rm_attic", zz = "zz_boxwithtoys", zz_gate = "gzz_attic_boxwithtoys" };

private.get_clockworkmouse_logic = function()
  
end;
private.get_clockworkmouse_inv = function()
  interface.InventoryItemAdd("inv_clockworkmouse","spr_boxwithtoys_clockworkmouse");
  ObjSet( "inv_clockworkmouse", { drag = 0 } );
end;
private.get_clockworkmouse_beg = function()
  ObjDelete("gfx_boxwithtoys_clockworkmouse")
end;
private.get_clockworkmouse_end = function()
  if common_impl.ZzCompleteCheck("get_clockworkmouse") then ObjSet( common_impl.hint["get_clockworkmouse"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_clockworkmouse", private.get_clockworkmouse_inv );
cmn.AddSubscriber( "get_clockworkmouse", private.get_clockworkmouse_beg, private.room_objname );
cmn.AddSubscriber( "get_clockworkmouse", private.get_clockworkmouse_end, private.room_objname );
cmn.AddSubscriber( "get_clockworkmouse", private.get_clockworkmouse_logic );
--------------------------------------------------------------------
function public.get_clockworkmouse()
  cmn.SetEventDone( "get_clockworkmouse" );
  cmn.CallEventHandler( "get_clockworkmouse" );
  if common_impl.ZzCompleteCheck("get_clockworkmouse") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_mosaicsun" ] = { type = "get", get_obj = "spr_boxwithtoys_mosaicsun", room = "rm_attic", zz = "zz_boxwithtoys", zz_gate = "gzz_attic_boxwithtoys" };

private.get_mosaicsun_logic = function()
  
end;
private.get_mosaicsun_inv = function()
  interface.InventoryItemAdd("inv_mosaicsun","spr_boxwithtoys_mosaicsun");
end;
private.get_mosaicsun_beg = function()
  ObjDelete("gfx_boxwithtoys_mosaicsun")
end;
private.get_mosaicsun_end = function()
  if common_impl.ZzCompleteCheck("get_mosaicsun") then ObjSet( common_impl.hint["get_mosaicsun"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_mosaicsun", private.get_mosaicsun_inv );
cmn.AddSubscriber( "get_mosaicsun", private.get_mosaicsun_beg, private.room_objname );
cmn.AddSubscriber( "get_mosaicsun", private.get_mosaicsun_end, private.room_objname );
cmn.AddSubscriber( "get_mosaicsun", private.get_mosaicsun_logic );
--------------------------------------------------------------------
function public.get_mosaicsun()
  cmn.SetEventDone( "get_mosaicsun" );
  cmn.CallEventHandler( "get_mosaicsun" );
  if common_impl.ZzCompleteCheck("get_mosaicsun") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_angryoven *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_openangryoven" ] = { type = "click", use_place = "gfx_angryoven_clk_openangryoven_zone", room = "rm_attic", zz = "zz_angryoven", zz_gate = "gzz_attic_angryoven" };

private.clk_openangryoven_logic = function()

end;
private.clk_openangryoven_beg = function()
  ObjDelete( "gfx_angryoven_clk_openangryoven_zone" );
end;
private.clk_openangryoven_end = function()
  ObjSet( "anm_angryoven_anm", {animfunc = "openzz", frame = 0, playing = 1 } );
  if common_impl.ZzCompleteCheck("clk_openangryoven") then ObjSet( common_impl.hint["clk_openangryoven"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_openangryoven", private.clk_openangryoven_beg, private.room_objname );
cmn.AddSubscriber( "clk_openangryoven", private.clk_openangryoven_end, private.room_objname );
cmn.AddSubscriber( "clk_openangryoven", private.clk_openangryoven_logic );
cmn.AddSubscriber( "clk_openangryoven_beg", private.clk_openangryoven_beg, private.room_objname );
cmn.AddSubscriber( "clk_openangryoven_end", private.clk_openangryoven_end, private.room_objname );
cmn.AddSubscriber( "clk_openangryoven_end", private.clk_openangryoven_logic );
--------------------------------------------------------------------------------------------
function public.clk_openangryoven()

  local func_end = function()
    cmn.SetEventDone( "clk_openangryoven" );
    cmn.CallEventHandler( "clk_openangryoven_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_openangryoven") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_openangryoven_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_angryoven_anm", "static1", func_end );
  SoundSfx( "aud_xx_angryoven" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_recipecookies" ] = { type = "get", get_obj = "spr_angryoven_recipecookies", room = "rm_attic", zz = "zz_angryoven", zz_gate = "gzz_attic_angryoven" };

private.get_recipecookies_logic = function()
  
end;
private.get_recipecookies_inv = function()
  interface.InventoryItemAdd("inv_recipecookies","spr_angryoven_recipecookies");
end;
private.get_recipecookies_beg = function()
  ObjDelete("gfx_angryoven_recipecookies")
  ObjSet( "spr_angryoven_recipecookies", {visible = 1} );
  ObjDelete("anm_angryoven_anm_recipecookies")
end;
private.get_recipecookies_end = function()
  ObjDelete("spr_attic_recipecookies")
  if common_impl.ZzCompleteCheck("get_recipecookies") then ObjSet( common_impl.hint["get_recipecookies"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_recipecookies", private.get_recipecookies_inv );
cmn.AddSubscriber( "get_recipecookies", private.get_recipecookies_beg, private.room_objname );
cmn.AddSubscriber( "get_recipecookies", private.get_recipecookies_end, private.room_objname );
cmn.AddSubscriber( "get_recipecookies", private.get_recipecookies_logic );
--------------------------------------------------------------------
function public.get_recipecookies()
  cmn.SetEventDone( "get_recipecookies" );
  cmn.CallEventHandler( "get_recipecookies" );
  if common_impl.ZzCompleteCheck("get_recipecookies") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_ovencookies" ] = { type = "use", inv_obj = "inv_ovencookies", use_place = "gfx_angryoven_ovencookies_zone", room = "rm_attic", zz = "zz_angryoven", zz_gate = "gzz_attic_angryoven" };

private.use_ovencookies_logic = function()

  ObjSet( "gfx_angryoven_stovepart_zone", { visible = 1, input = 1, active = 1 } )
  --ObjSet( "gfx_angryoven_clk_flashback32_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_angryoven_abigailletter2", { visible = 1, input = 1, active = 1 } )
end;
private.use_ovencookies_inv = function()
  common_impl.ProcessMultiUseAll("ovencookies", "ovencookies")
end;
private.use_ovencookies_beg = function()
  ObjDelete( "gfx_angryoven_ovencookies_zone" );
end;
private.use_ovencookies_end = function()
  ObjSet( "anm_angryoven_anm", {animfunc = "prot1", frame = 0, playing = 0 } );
  ObjSet( "anm_angryoven_anm_box", {animfunc = "box_open", frame = 999 } );
  ObjSet( "spr_attic_box", {visible = 1} );
  ObjSet( "spr_attic_newbutton2", {visible = 1} );
  ObjSet( "spr_attic_dragon1", {visible = 1} );
  ObjSet( "spr_attic_abigailletter2", {visible = 1} );
  ObjSet( "gfx_angryoven_abigailletter2", {active = 1, visible = 1} );
  if common_impl.ZzCompleteCheck("use_ovencookies") then ObjSet( common_impl.hint["use_ovencookies"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ovencookies", private.use_ovencookies_inv );
cmn.AddSubscriber( "use_ovencookies", private.use_ovencookies_beg, private.room_objname );
cmn.AddSubscriber( "use_ovencookies", private.use_ovencookies_end, private.room_objname );
cmn.AddSubscriber( "use_ovencookies", private.use_ovencookies_logic );
cmn.AddSubscriber( "use_ovencookies_inv", private.use_ovencookies_inv, private.room_objname );
cmn.AddSubscriber( "use_ovencookies_beg", private.use_ovencookies_beg, private.room_objname );
cmn.AddSubscriber( "use_ovencookies_end", private.use_ovencookies_end, private.room_objname );
cmn.AddSubscriber( "use_ovencookies_end", private.use_ovencookies_logic );
--------------------------------------------------------------------------------------------
function public.use_ovencookies( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_ovencookies" );
    cmn.CallEventHandler( "use_ovencookies_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_ovencookies") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ovencookies_inv" );
  cmn.CallEventHandler( "use_ovencookies_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_angryoven_anm", "prot", function() 
    ld.AnimPlay( "anm_angryoven_anm_box", "box_open", func_end );
  end );
  SoundSfx( "aud_use_ovencookies_attic" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_dragon1" ] = { type = "get", get_obj = "spr_angryoven_dragon1", room = "rm_attic", zz = "zz_angryoven", zz_gate = "gzz_attic_angryoven" };

private.get_dragon1_logic = function()
  
end;
private.get_dragon1_inv = function()
  interface.InventoryItemAdd("inv_dragon1","spr_angryoven_dragon1");
end;
private.get_dragon1_beg = function()
  ObjDelete("gfx_angryoven_dragon1")
end;
private.get_dragon1_end = function()
  ObjDelete("spr_attic_dragon1")
  if common_impl.ZzCompleteCheck("get_dragon1") then ObjSet( common_impl.hint["get_dragon1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_dragon1", private.get_dragon1_inv );
cmn.AddSubscriber( "get_dragon1", private.get_dragon1_beg, private.room_objname );
cmn.AddSubscriber( "get_dragon1", private.get_dragon1_end, private.room_objname );
cmn.AddSubscriber( "get_dragon1", private.get_dragon1_logic );
--------------------------------------------------------------------
function public.get_dragon1()
  cmn.SetEventDone( "get_dragon1" );
  cmn.CallEventHandler( "get_dragon1" );
  if common_impl.ZzCompleteCheck("get_dragon1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_newbutton2" ] = { type = "get", get_obj = "spr_angryoven_newbutton2", room = "rm_attic", zz = "zz_angryoven", zz_gate = "gzz_attic_angryoven" };

private.get_newbutton2_logic = function()
  
end;
private.get_newbutton2_inv = function()
  interface.InventoryItemAdd("inv_newbutton","spr_angryoven_newbutton2",function() level_inv.ProcessGetNewbuttonAll( "get_newbutton2" ) end);
end;
private.get_newbutton2_beg = function()
  ObjDelete("gfx_angryoven_newbutton2")
end;
private.get_newbutton2_end = function()
  ObjDelete("spr_attic_newbutton2")
  if common_impl.ZzCompleteCheck("get_newbutton2") then ObjSet( common_impl.hint["get_newbutton2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_newbutton2", private.get_newbutton2_inv );
cmn.AddSubscriber( "get_newbutton2", private.get_newbutton2_beg, private.room_objname );
cmn.AddSubscriber( "get_newbutton2", private.get_newbutton2_end, private.room_objname );
cmn.AddSubscriber( "get_newbutton2", private.get_newbutton2_logic );
--------------------------------------------------------------------
function public.get_newbutton2()
  cmn.SetEventDone( "get_newbutton2" );
  cmn.CallEventHandler( "get_newbutton2" );
  if common_impl.ZzCompleteCheck("get_newbutton2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_abigailletter2" ] = { type = "get", get_obj = "spr_angryoven_abigailletter2", room = "rm_attic", zz = "zz_angryoven", zz_gate = "gzz_attic_angryoven" };

private.get_abigailletter2_logic = function()
  
end;
private.get_abigailletter2_inv = function()
  interface.InventoryItemAdd("inv_abigailletter","spr_angryoven_abigailletter2",function() level_inv.ProcessGetAbigailletterAll( "get_abigailletter2" ) end);
end;
private.get_abigailletter2_beg = function()
  ObjDelete("gfx_angryoven_abigailletter2")
end;
private.get_abigailletter2_end = function()
  ObjDelete("spr_attic_abigailletter2")
  if common_impl.ZzCompleteCheck("get_abigailletter2") then ObjSet( common_impl.hint["get_abigailletter2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_abigailletter2", private.get_abigailletter2_inv );
cmn.AddSubscriber( "get_abigailletter2", private.get_abigailletter2_beg, private.room_objname );
cmn.AddSubscriber( "get_abigailletter2", private.get_abigailletter2_end, private.room_objname );
cmn.AddSubscriber( "get_abigailletter2", private.get_abigailletter2_logic );
--------------------------------------------------------------------
function public.get_abigailletter2()
  
  cmn.CallEventHandler( "get_abigailletter2" );
  public.clk_flashback32()
  if common_impl.ZzCompleteCheck("get_abigailletter2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_flashback32" ] = { type = "click", use_place = "gfx_angryoven_clk_flashback32_zone", room = "rm_attic", zz = "zz_angryoven", zz_gate = "gzz_attic_angryoven" };

private.clk_flashback32_logic = function()
  ObjSet( "spr_angryoven_dragon1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_angryoven_newbutton2", { visible = 1, input = 1, active = 1 } )

end;
private.clk_flashback32_beg = function()
  ObjDelete( "gfx_angryoven_clk_flashback32_zone" );
end;
private.clk_flashback32_end = function()
  ObjSet( "gfx_angryoven_newbutton2", {active = 1, visible = 1} );
  ObjSet( "gfx_angryoven_dragon1", {active = 1, visible = 1} );
  if common_impl.ZzCompleteCheck("clk_flashback32") then ObjSet( common_impl.hint["clk_flashback32"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_flashback32", private.clk_flashback32_beg, private.room_objname );
cmn.AddSubscriber( "clk_flashback32", private.clk_flashback32_end, private.room_objname );
cmn.AddSubscriber( "clk_flashback32", private.clk_flashback32_logic );
cmn.AddSubscriber( "clk_flashback32_beg", private.clk_flashback32_beg, private.room_objname );
cmn.AddSubscriber( "clk_flashback32_end", private.clk_flashback32_end, private.room_objname );
cmn.AddSubscriber( "clk_flashback32_end", private.clk_flashback32_logic );
--------------------------------------------------------------------------------------------
function public.clk_flashback32()

  local func_end = function()
    SoundSfx( 0 )
    SoundEnv( "aud_entrypoint_env", -1 )
    common_impl.FlashbackHide()
    cmn.SetEventDone( "get_abigailletter2" );
    cmn.SetEventDone( "clk_flashback32" );
    cmn.CallEventHandler( "clk_flashback32_end" );
    common_impl.Lock(0);
    common_impl.Gate_MDown( 'gzz_attic_angryoven', { ObjGet( "gzz_attic_angryoven" ).pos_x, ObjGet( "gzz_attic_angryoven" ).pos_y } )

    if common_impl.ZzCompleteCheck("clk_flashback32") then ld.CloseSubRoom() end;
    ld.ShowBbt( "after_clk_flashback32" )
  end;

  cmn.CallEventHandler( "clk_flashback32_beg" );
  local obj_root   = "obj_attic_vid_flashback_root"
  local vid_prefix = "vid_attic_vid_flashback_"
  local str_prefix = "str_attic_vid_flashback_"
  local lip_prefix = "vid_attic_vid_flashback_33"
  local aud_count_dif = -1
  common_impl.FlashbackInit( obj_root, func_end, vid_prefix, str_prefix, lip_prefix, aud_count_dif )  

  local func_step_2 = function()
    SoundSfx( 0 )
    SoundSfx( "aud_flashback_33" )
    SoundEnv( "aud_street_env", -1 )
    SoundEnv( "aud_entrypoint_env", -1 )
    common_impl.FlashbackShow( 2, func_end )
  end;

  local func_step_1 = function()
    SoundSfx( "aud_flashback_33" )
    SoundEnv( "aud_street_env", -1 )
    common_impl.FlashbackShow( 1, func_step_2 )
  end;

  local func_fb_start = function()
    ld.Lock(0)
    ld.CloseSubRoom()
    func_step_1()
  end

  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_clk_flashback32" )
  func_fb_start()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_stovepart" ] = { type = "use", inv_obj = "inv_stovepart", use_place = "gfx_angryoven_stovepart_zone", room = "rm_attic", zz = "zz_angryoven", zz_gate = "gzz_attic_angryoven" };

private.use_stovepart_logic = function()
  ObjSet( "spr_angryoven_cookiesready", { visible = 1, input = 1, active = 1 } )

end;
private.use_stovepart_inv = function()
  common_impl.ProcessMultiUseAll("stovepart", "stovepart")
end;
private.use_stovepart_beg = function()
  ObjDelete( "gfx_angryoven_stovepart_zone" );
end;
private.use_stovepart_end = function()
  ObjSet( "anm_angryoven_anm", {animfunc = "prot2", frame = 999 } );
  ObjSet( "spr_attic_grip", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_stovepart") then ObjSet( common_impl.hint["use_stovepart"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_stovepart", private.use_stovepart_inv );
cmn.AddSubscriber( "use_stovepart", private.use_stovepart_beg, private.room_objname );
cmn.AddSubscriber( "use_stovepart", private.use_stovepart_end, private.room_objname );
cmn.AddSubscriber( "use_stovepart", private.use_stovepart_logic );
cmn.AddSubscriber( "use_stovepart_inv", private.use_stovepart_inv, private.room_objname );
cmn.AddSubscriber( "use_stovepart_beg", private.use_stovepart_beg, private.room_objname );
cmn.AddSubscriber( "use_stovepart_end", private.use_stovepart_end, private.room_objname );
cmn.AddSubscriber( "use_stovepart_end", private.use_stovepart_logic );
--------------------------------------------------------------------------------------------
function public.use_stovepart( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_stovepart" );
    cmn.CallEventHandler( "use_stovepart_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_stovepart") then ld.CloseSubRoom() end;
    public.get_cookiesready()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_stovepart_inv" );
  cmn.CallEventHandler( "use_stovepart_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_angryoven_anm", "prot1", function() 
    ld.AnimPlay( "anm_angryoven_anm", "prot2", func_end );
  end );
  SoundSfx( "aud_use_stovepart_attic" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cookiesready" ] = { type = "get", get_obj = "spr_angryoven_cookiesready", room = "rm_attic", zz = "zz_angryoven", zz_gate = "gzz_attic_angryoven" };

private.get_cookiesready_logic = function()
  
end;
private.get_cookiesready_inv = function()
  interface.InventoryItemAdd("inv_cookiesready","spr_angryoven_cookiesready");
end;
private.get_cookiesready_beg = function()
  ObjDelete("gfx_angryoven_cookiesready")
end;
private.get_cookiesready_end = function()
  if common_impl.ZzCompleteCheck("get_cookiesready") then ObjSet( common_impl.hint["get_cookiesready"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_cookiesready", private.get_cookiesready_inv );
cmn.AddSubscriber( "get_cookiesready", private.get_cookiesready_beg, private.room_objname );
cmn.AddSubscriber( "get_cookiesready", private.get_cookiesready_end, private.room_objname );
cmn.AddSubscriber( "get_cookiesready", private.get_cookiesready_logic );
--------------------------------------------------------------------
function public.get_cookiesready()
  cmn.SetEventDone( "get_cookiesready" );
  cmn.CallEventHandler( "get_cookiesready" );
  if common_impl.ZzCompleteCheck("get_cookiesready") then ld.CloseSubRoom() end;
  if port.isPortable()==1 then
    iOS_RateMe();
  end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_railroad *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_bakingtray" ] = { type = "get", get_obj = "spr_railroad_bakingtray", room = "rm_attic", zz = "zz_railroad", zz_gate = "gzz_attic_railroad" };

private.get_bakingtray_logic = function()
  ObjSet( "gfx_railroad_railroadpart_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_bakingtray_inv = function()
  interface.InventoryItemAdd("inv_bakingtray","spr_railroad_bakingtray");
  ObjSet( "spr_railroad_bakingtray", {visible = 1} );
  ObjSet( "inv_bakingtray", { drag = 0 } );
end;
private.get_bakingtray_beg = function()
  ObjDelete("gfx_railroad_bakingtray")
end;
private.get_bakingtray_end = function()
  ObjDelete("anm_railroad_anm_tray")
  ObjDelete("spr_attic_bakingtray")
  if common_impl.ZzCompleteCheck("get_bakingtray") then ObjSet( common_impl.hint["get_bakingtray"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bakingtray", private.get_bakingtray_inv );
cmn.AddSubscriber( "get_bakingtray", private.get_bakingtray_beg, private.room_objname );
cmn.AddSubscriber( "get_bakingtray", private.get_bakingtray_end, private.room_objname );
cmn.AddSubscriber( "get_bakingtray", private.get_bakingtray_logic );

cmn.AddSubscriber( "get_bakingtray_end", private.get_bakingtray_inv );
cmn.AddSubscriber( "get_bakingtray_beg", private.get_bakingtray_beg, private.room_objname );
cmn.AddSubscriber( "get_bakingtray_end", private.get_bakingtray_end, private.room_objname );
cmn.AddSubscriber( "get_bakingtray_end", private.get_bakingtray_logic );
--------------------------------------------------------------------
function public.get_bakingtray()
  local function func_end()  
    ld.Lock(0)
    cmn.SetEventDone( "get_bakingtray" );
    cmn.CallEventHandler( "get_bakingtray_end" );    
    if common_impl.ZzCompleteCheck("get_bakingtray") then ld.CloseSubRoom() end;
  end

  cmn.CallEventHandler( "get_bakingtray_beg" );
  ld.Lock(1)
  SoundSfx( "aud_get_owentray" )
  ld.AnimPlay( "anm_railroad_anm_tray", "bakingtray", func_end )
  
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_toytrain" ] = { type = "use", inv_obj = "inv_toytrain", use_place = "gfx_railroad_toytrain_zone", room = "rm_attic", zz = "zz_railroad", zz_gate = "gzz_attic_railroad" };

private.use_toytrain_logic = function()
  if ld.CheckRequirements( {"use_toytrain","use_railroadpart"} ) then
    ObjSet( "gfx_railroad_elf_railroad_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_toytrain_inv = function()
  common_impl.ProcessMultiUseAll("toytrain", "toytrain")
end;
private.use_toytrain_beg = function()
  ObjDelete( "gfx_railroad_toytrain_zone" );
end;
private.use_toytrain_end = function()
  ObjSet( "spr_attic_train", {visible = 1} );
  ObjSet( "anm_railroad_anm_train", {animfunc = "train", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_toytrain") then ObjSet( common_impl.hint["use_toytrain"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_toytrain", private.use_toytrain_inv );
cmn.AddSubscriber( "use_toytrain", private.use_toytrain_beg, private.room_objname );
cmn.AddSubscriber( "use_toytrain", private.use_toytrain_end, private.room_objname );
cmn.AddSubscriber( "use_toytrain", private.use_toytrain_logic );
cmn.AddSubscriber( "use_toytrain_inv", private.use_toytrain_inv, private.room_objname );
cmn.AddSubscriber( "use_toytrain_beg", private.use_toytrain_beg, private.room_objname );
cmn.AddSubscriber( "use_toytrain_end", private.use_toytrain_end, private.room_objname );
cmn.AddSubscriber( "use_toytrain_end", private.use_toytrain_logic );
--------------------------------------------------------------------------------------------
function public.use_toytrain( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_toytrain" );
    cmn.CallEventHandler( "use_toytrain_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_toytrain") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_toytrain_inv" );
  cmn.CallEventHandler( "use_toytrain_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_railroad_anm_train", "train", func_end );
  SoundSfx( "aud_use_toytrain_attic" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_railroadpart" ] = { type = "use", inv_obj = "inv_railroadpart", use_place = "gfx_railroad_railroadpart_zone", room = "rm_attic", zz = "zz_railroad", zz_gate = "gzz_attic_railroad" };

private.use_railroadpart_logic = function()
  if ld.CheckRequirements( {"use_railroadpart","use_toytrain"} ) then
    ObjSet( "gfx_railroad_elf_railroad_zone", { visible = 1, input = 1, active = 1 } )
  end;
  ObjSet( "gfx_railroad_toytrain_zone", {active = 1, input = 1, visible = 1} );
end;
private.use_railroadpart_inv = function()
  common_impl.ProcessMultiUseAll("railroadpart", "railroadpart")
end;
private.use_railroadpart_beg = function()
  ObjDelete( "gfx_railroad_railroadpart_zone" );
end;
private.use_railroadpart_end = function()
  ObjSet( "spr_attic_rel", {visible = 1} );
  ObjSet( "anm_railroad_anm_rel", {animfunc = "rel", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_railroadpart") then ObjSet( common_impl.hint["use_railroadpart"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_railroadpart", private.use_railroadpart_inv );
cmn.AddSubscriber( "use_railroadpart", private.use_railroadpart_beg, private.room_objname );
cmn.AddSubscriber( "use_railroadpart", private.use_railroadpart_end, private.room_objname );
cmn.AddSubscriber( "use_railroadpart", private.use_railroadpart_logic );
cmn.AddSubscriber( "use_railroadpart_inv", private.use_railroadpart_inv, private.room_objname );
cmn.AddSubscriber( "use_railroadpart_beg", private.use_railroadpart_beg, private.room_objname );
cmn.AddSubscriber( "use_railroadpart_end", private.use_railroadpart_end, private.room_objname );
cmn.AddSubscriber( "use_railroadpart_end", private.use_railroadpart_logic );
--------------------------------------------------------------------------------------------
function public.use_railroadpart( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_railroadpart" );
    cmn.CallEventHandler( "use_railroadpart_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_railroadpart") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_railroadpart_inv" );
  cmn.CallEventHandler( "use_railroadpart_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_railroad_anm_rel", "rel", func_end );
  SoundSfx( "aud_use_railroadpart_attic" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_elf_railroad" ] = { type = "use", inv_obj = "obj_simon_cursor_drag", use_place = "gfx_railroad_elf_railroad_zone", room = "rm_attic", zz = "zz_railroad", zz_gate = "gzz_attic_railroad" };

private.use_elf_railroad_logic = function()
  ObjSet( "gho_attic_train", { visible = 1, input = 1, active = 1 } )
  int_simon.SimonSetVisible(0)
end;
private.use_elf_railroad_inv = function()
  common_impl.ProcessMultiUseAll("elf", "elf_railroad")
end;
private.use_elf_railroad_beg = function()
  ObjDelete( "gfx_railroad_elf_railroad_zone" );
end;
private.use_elf_railroad_end = function()
  ObjSet( "spr_attic_goody", {visible = 1} );
  ObjSet( "anm_railroad_anm_train", {animfunc = "goody", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_elf_railroad") then ObjSet( common_impl.hint["use_elf_railroad"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_elf_railroad", private.use_elf_railroad_inv );
cmn.AddSubscriber( "use_elf_railroad", private.use_elf_railroad_beg, private.room_objname );
cmn.AddSubscriber( "use_elf_railroad", private.use_elf_railroad_end, private.room_objname );
cmn.AddSubscriber( "use_elf_railroad", private.use_elf_railroad_logic );
cmn.AddSubscriber( "use_elf_railroad_inv", private.use_elf_railroad_inv, private.room_objname );
cmn.AddSubscriber( "use_elf_railroad_beg", private.use_elf_railroad_beg, private.room_objname );
cmn.AddSubscriber( "use_elf_railroad_end", private.use_elf_railroad_end, private.room_objname );
cmn.AddSubscriber( "use_elf_railroad_end", private.use_elf_railroad_logic );
--------------------------------------------------------------------------------------------
function public.use_elf_railroad( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_elf_railroad" );
    cmn.CallEventHandler( "use_elf_railroad_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_elf_railroad") then ld.CloseSubRoom() end;
    common_impl.Gate_MDown( "gho_attic_train" )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_elf_railroad_inv" );
  cmn.CallEventHandler( "use_elf_railroad_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_elf_railroad" )
  interface.SimonJump(
    function() 
      ld.AnimPlay( "anm_railroad_anm_train", "goody", func_end );    
    end
  )

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

  local win_train_for_attic = function()
    if ld.CheckRequirements( {"win_train"} ) then
      ObjSet( "gho_attic_train", {input = 0, visible = 0} );
      ObjDelete("spr_attic_goody")
    end
  end;
  --local win_train_for_attic_logic = function()
  --  if ld.CheckRequirements( {"win_train"} ) then
  --    int_simon.SimonSetVisible(1)
  --  end
  --end

  cmn.AddSubscriber("win_train", win_train_for_attic, private.room_objname )

  --cmn.AddSubscriber("win_train", win_train_for_attic_logic )



end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_attic();
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not ld.CheckRequirements( { "opn_attic" } ) then
    ObjAttach( "vid_attic_vid_oven_awake_239", "rm_attic" )
    common_impl.SetWidgetsVisible( "DialogVideoShow", false )
  end
  SoundEnv( "aud_cabinet_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_railroad" );
  function zz_railroad.Open()
  end;
  function zz_railroad.PreOpen()
  end;
  function zz_railroad.PreClose()
  end;
  function zz_railroad.Close()
  end;

  subroom.Define( "zz_angryoven" );
  function zz_angryoven.Open()
    if not ld.CheckRequirements( {"clk_openangryoven"} ) then
      public.clk_openangryoven()
    end
  end;
  function zz_angryoven.PreOpen()
  end;
  function zz_angryoven.PreClose()
  end;
  function zz_angryoven.Close()
  end;

  subroom.Define( "zz_boxwithtoys" );
  function zz_boxwithtoys.Open()
  end;
  function zz_boxwithtoys.PreOpen()
  end;
  function zz_boxwithtoys.PreClose()
  end;
  function zz_boxwithtoys.Close()
  end;
  
end;
--*********************************************************************************************************************