-- name=rm_cabinet
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_cabinet";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("spr_worktable_photo_della1", "spr_worktable_photo_della", "txt_worktable_photo_della")
  SoundEnvInit( "aud_zz_fairplace_env", "zz_fairplace" )
  --------------------------------------------------------------------------------------------
function private.opn_cabinet()
  if not ( cmn.IsEventDone( "opn_cabinet" ) ) then
  local func_end = function()
      --SoundVid( 0 )
      common_impl.SetWidgetsVisible( "DialogVideoShow", true )
      cmn.SetEventDone( "opn_cabinet" );
      cmn.CallEventHandler( "opn_cabinet" )
      ld.ShowBbtOpn( private.room_objname )
      ld.Lock( 0 )
  end;
  local func_step_0 = function()
    ld.Lock( 1 )
    int.DialogVideoHide()

    VidPause( "vid_cabinet_vid_goblinspell_berta_458", 1 )
    ObjAnimate( "vid_cabinet_vid_goblinspell_berta_458", 8,0,0, _, { 0,0,1, 0.3,0,0 } )

    ObjAttach( "vid_cabinet_vid_grumpy_esc_70", "rm_cabinet" )
    SoundVid( "aud_grumpy_esc_70" )
    VidPlay( "vid_cabinet_vid_grumpy_esc_70", func_end )
  end;
  
  ObjAttach( "vid_cabinet_vid_goblinspell_berta_458", "rm_cabinet" )
  --ObjAnimate( "vid_cabinet_vid_goblinspell_berta_458", 8,0,0, _, { 0,0,0, 0.3,0,1 } )
  VidPlay( "vid_cabinet_vid_goblinspell_berta_458", func_step_0 )

  SoundVid( "aud_goblinspell_berta_458" )

  int.DialogVideoShow( "", 1, func_step_0, 1 );
  --[[
  common_impl.VideoSubtitleVocStart( {
    { "srt_cabinet_berta_1", aud_voc_false, 8 };
  } );
  ]]
  SoundVoice( "aud_goblinspell_berta_458_voc" );

  end;
end;
--------------------------------------------------------------------
local opn_cabinet = function()
  ObjDelete( "vid_cabinet_vid_grumpy_esc_70" )
  ObjDelete( "vid_cabinet_vid_goblinspell_berta_458" )
end;
local opn_cabinet_logic = function() end;
cmn.AddSubscriber( "opn_cabinet", opn_cabinet_logic )
cmn.AddSubscriber( "opn_cabinet", opn_cabinet, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_photowall *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_silverwing" ] = { type = "get", get_obj = "spr_photowall_silverwing", room = "rm_cabinet", zz = "zz_photowall", zz_gate = "gzz_cabinet_photowall" };

private.get_silverwing_logic = function()
  
end;
private.get_silverwing_inv = function()
  interface.InventoryItemAdd("inv_silverwing","spr_photowall_silverwing");
end;
private.get_silverwing_beg = function()
  ObjDelete("gfx_photowall_silverwing")
end;
private.get_silverwing_end = function()
  ObjDelete( "spr_photowall_silverwing_tr" )
  ObjDelete( "spr_cabinet_silverwing" )
  if common_impl.ZzCompleteCheck("get_silverwing") then ObjSet( common_impl.hint["get_silverwing"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_silverwing", private.get_silverwing_inv );
cmn.AddSubscriber( "get_silverwing", private.get_silverwing_beg, private.room_objname );
cmn.AddSubscriber( "get_silverwing", private.get_silverwing_end, private.room_objname );
cmn.AddSubscriber( "get_silverwing", private.get_silverwing_logic );
--------------------------------------------------------------------
function public.get_silverwing()
  cmn.SetEventDone( "get_silverwing" );
  cmn.CallEventHandler( "get_silverwing" );
  if common_impl.ZzCompleteCheck("get_silverwing") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_photo" ] = { type = "use", inv_obj = "inv_photo", use_place = "gfx_photowall_photo_zone", room = "rm_cabinet", zz = "zz_photowall", zz_gate = "gzz_cabinet_photowall" };

private.use_photo_logic = function()
  ObjSet( "gfx_photowall_win_photowall_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_photo_inv = function()
  common_impl.ProcessMultiUseAll("photo", "photo")
end;
private.use_photo_beg = function()
  ObjDelete( "gfx_photowall_photo_zone" );
end;
private.use_photo_end = function()
  ObjSet( "obj_photowall_take_root", { input = 1, alp = 1 } )
  ObjDelete( "obj_photowall_fake_root" )
  if common_impl.ZzCompleteCheck("use_photo") then ObjSet( common_impl.hint["use_photo"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_photo", private.use_photo_inv );
cmn.AddSubscriber( "use_photo", private.use_photo_beg, private.room_objname );
cmn.AddSubscriber( "use_photo", private.use_photo_end, private.room_objname );
cmn.AddSubscriber( "use_photo", private.use_photo_logic );
cmn.AddSubscriber( "use_photo_inv", private.use_photo_inv, private.room_objname );
cmn.AddSubscriber( "use_photo_beg", private.use_photo_beg, private.room_objname );
cmn.AddSubscriber( "use_photo_end", private.use_photo_end, private.room_objname );
cmn.AddSubscriber( "use_photo_end", private.use_photo_logic );
--------------------------------------------------------------------------------------------
function public.use_photo( obj )

  local func_end = function()
    cmn.MiniGameShow( "photowall" );
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_photo" );
    cmn.CallEventHandler( "use_photo_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_photo") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_photo_inv" );
  cmn.CallEventHandler( "use_photo_beg" );
  common_impl.Lock(1);

  for i = 4, 6 do
    ObjAnimate( "spr_photowall_fake_"..i, 8,0,0, _, { 0,0,0, 0.5,0,1 } )
  end
  ld.StartTimer( 0.5, function() 
    ObjSet( "obj_photowall_take_root", { input = 1, alp = 1 } )
    for i = 1, 6 do
      local o1 = ObjGet( "spr_photowall_fake_"..i )
      local o2 = ObjGet( "spr_photowall_"..i )
      ObjAnimate( o1.name, 8,0,0, _, { 0,0,1, 0.5,1,0 } )
      ObjAnimate( o2.name, 8,0,0, _, { 0,0,0, 0.5,2,1 } )
      ObjAnimate( "spr_photowall_"..i.."_light", 8,0,0, _, { 0,0,0, 0.5,2,1 } )
      ObjAnimate( o1.name, 3,0,0, _, { 0,0,o1.pos_x,o1.pos_y, 0.5,3,o2.pos_x,o2.pos_y } )
      ObjAnimate( o2.name, 3,0,0, _, { 0,0,o1.pos_x,o1.pos_y, 0.5,3,o2.pos_x,o2.pos_y } )
    end
    ld.StartTimer( 0.5, func_end )
  end )

  SoundSfx( "aud_photo_pieces" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_photowall" ] = { type = "click", use_place = "obj_photowall_take_root", room = "rm_cabinet", zz = "zz_photowall", zz_gate = "gzz_cabinet_photowall" };

private.win_photowall_logic = function()
  if ld.CheckRequirements( { "win_photowall" } ) then
    ObjSet( "gfx_photowall_clk_photowall_zone", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_photowall_beg = function()

end;
private.win_photowall_end = function()
  if ld.CheckRequirements( { "win_photowall" } ) then
    ObjDelete( "obj_photowall_place_root" )
    ObjDelete( "obj_photowall_take_root" )
    ObjDelete( "spr_cabinet_tr01" )
    ObjSet( "spr_cabinet_photo", { visible = 1 } )
    ObjSet( "anm_photowall_anm", { animfunc = "get_photoadress", frame = 0, alp = 1 } )
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_photowall", private.win_photowall_beg, private.room_objname );
cmn.AddSubscriber( "win_photowall", private.win_photowall_end, private.room_objname );
cmn.AddSubscriber( "win_photowall", private.win_photowall_logic );
cmn.AddSubscriber( "win_photowall_beg", private.win_photowall_beg, private.room_objname );
cmn.AddSubscriber( "win_photowall_end", private.win_photowall_end, private.room_objname );
cmn.AddSubscriber( "win_photowall_end", private.win_photowall_logic );
--------------------------------------------------------------------------------------------
function public.win_photowall()

  local func_end = function()
    cmn.SetEventDone( "win_photowall" );
    cmn.CallEventHandler( "win_photowall_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_photowall") then ld.CloseSubRoom() end;
  end;

  cmn.MiniGameHide( "photowall", true );

  cmn.CallEventHandler( "win_photowall_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_photowall_anm", { animfunc = "photo", frame = 0 } )
  ObjAnimate( "anm_photowall_anm", 8,0,0, function() 
    ObjDelete( "obj_photowall_place_root" )
    ObjDelete( "obj_photowall_take_root" )
    ld.AnimPlay( "anm_photowall_anm", "photo", func_end )
  end, { 0,0,0, 0.4,0,1 } )

  SoundSfx( "aud_mmg_photowall" )

end;
function public.win_photowall_load()

  if ld.CheckRequirements( { "win_photowall" } ) then
    return;
  end

  if ld.CheckRequirements( { "use_photo" } ) then
    cmn.MiniGameShow( "photowall" );
  end

  if not public.win_photowall_loaded then

    public.win_photowall_game = {}
    gm = public.win_photowall_game
    ng_global.progress["std"]["win_photowall"].state = ng_global.progress["std"]["win_photowall"].state or {0,0,0,0,0,0}

    function gm.event_mdown( n )

    end
    function gm.event_menter( n )
      ld.ShCur(CURSOR_GET)
      local o = ObjGet( "spr_photowall_"..n )
      local scx = o.scale_x
      ObjAnimate( o.name, 6,0,0, _, { 0,0,scx,scx, (1.5-scx)*0.25,3,0.6,0.6 } )
      ObjAnimate( o.name, "pos_z",0,0, _, { 0,0,scx*100, (1.5-scx)*0.25,3,1*100 } )
    end
    function gm.event_mleave( n )
      ld.ShCur(CURSOR_DEFAULT)
      local o = ObjGet( "spr_photowall_"..n )
      local scx = o.scale_x
      ObjAnimate( o.name, 6,0,0, _, { 0,0,scx,scx, (0.5+scx)*0.25,3,0.5,0.5 } )
      ObjAnimate( o.name, "pos_z",0,0, _, { 0,0,scx*100, (0.5+scx)*0.25,3,0 } )
    end
    function gm.event_startdrag( n )
      SoundSfx( "aud_get_stuff" )
      local o = ObjGet( "spr_photowall_"..n )
      local scx = o.scale_x
      ObjAnimate( o.name, 6,0,0, _, { 0,0,scx,scx, (1.5-scx)*0.25,3,1,1 } )
      ObjAnimate( o.name, "pos_z",0,0, _, { 0,0,scx*100, (1.5-scx)*0.25,3,1*100 } )
      ObjSet( o.name, { 
        inputrect_init = 1;
        inputrect_x = -15;
        inputrect_y = -15;
        inputrect_w = 30;
        inputrect_h = 30;
      } )
    end
    function gm.event_dragdrop( n )
      SoundSfx( "aud_put_picture_part" )
      local o = ObjGet( "spr_photowall_"..n )
      if ApplyObj( o.name, "spr_photowall_place_"..n ) then
        ObjSet( o.name, { input = 0; alp = 0; scale_x = 0.5; scale_y = 0.5; } )
        ObjSet( "spr_photowall_place_"..n, { alp = 1 } )
        if ld.TableSum( ng_global.progress["std"]["win_photowall"].state ) >= 5 then
          public.win_photowall()
        else
          ng_global.progress["std"]["win_photowall"].state[ n ] = 1
        end
      else
        local scx = o.scale_x
        local p = GetZoomCursorPos()
        local zz = ObjGet( "zz_photowall" )
        p[ 1 ] = p[ 1 ] - zz.pos_x;
        p[ 2 ] = p[ 2 ] - zz.pos_y;
        ObjAnimate( o.name, 3,0,0, _, { 0,0,p[ 1 ],p[ 2 ], (1.5-scx)*0.25,3,o.pos_x,o.pos_y } )
        ObjAnimate( o.name, 6,0,0, _, { 0,0,scx,scx, (1.5-scx)*0.25,3,0.5,0.5 } )
        ObjAnimate( o.name, "pos_z",0,0, _, { 0,0,scx*100, (1.5-scx)*0.25,3,0 } )  
      end;
      ObjSet( o.name, { 
        inputrect_init = 0;
      } )
    end

    for i = 1, 6 do
      local val = ng_global.progress["std"]["win_photowall"].state[ i ] or 0
      ObjSet( "spr_photowall_"..i, { 
        event_mdown = function() gm.event_mdown( i ) end;
        event_menter = function() gm.event_menter( i ) end;
        event_mleave = function() gm.event_mleave( i ) end;
        event_startdrag = function() gm.event_startdrag( i ) end;
        event_dragdrop = function() gm.event_dragdrop( i ) end;
        drag = 1;
        input = 1 - val;
        alp = 1 - val;
      } )
      ObjSet( "spr_photowall_"..i.."_light", { 
        input = 0;
        alp = 1;
      } )
      ObjSet( "spr_photowall_place_"..i, { 
        inputrect_init = 1;
        inputrect_x = -15;
        inputrect_y = -15;
        inputrect_w = 30;
        inputrect_h = 30;
        alp = val;
      } )
    end;

    function gm.reset()
      if ld.TableSum( ng_global.progress["std"]["win_photowall"].state ) > 0 and ld.Lock( 1 ) then
        for k, v in pairs( ng_global.progress["std"]["win_photowall"].state ) do
          if v == 1 then
            ObjAnimate( "spr_photowall_place_"..k, 8,0,0, _, { 0,0,1, 0.35,0,0 } )
            ObjAnimate( "spr_photowall_"..k, 8,0,0, _, { 0,0,0, 0.35,0,1 } )
            ObjSet( "spr_photowall_"..k, { input = 1 } )
          end
        end
        ld.StartTimer( 0.35, function() 
          ng_global.progress["std"]["win_photowall"].state = {0,0,0,0,0,0}
          ld.Lock( 0 )
        end )
      end
    end;

    function gm.skip()
      if ld.Lock( 1 ) then
        for k, v in pairs( ng_global.progress["std"]["win_photowall"].state ) do
          if v == 0 then
            ObjAnimate( "spr_photowall_place_"..k, 8,0,0, _, { 0,0,0, 0.35,0,1 } )
            ObjAnimate( "spr_photowall_"..k, 8,0,0, _, { 0,0,1, 0.35,0,0 } )
          end
        end
        ld.StartTimer( 0.35, public.win_photowall )
      end;
    end;

    public.win_photowall_loaded = true;
  else

  end
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_photowall" ] = { type = "click", use_place = "gfx_photowall_clk_photowall_zone", room = "rm_cabinet", zz = "zz_photowall", zz_gate = "gzz_cabinet_photowall" };

private.clk_photowall_logic = function()
    ObjSet( "spr_photowall_photoadress", { visible = 1, input = 1, active = 1 } )
end;
private.clk_photowall_beg = function()
  ObjDelete( "gfx_photowall_clk_photowall_zone" );
end;
private.clk_photowall_end = function()
  ObjDelete( "anm_photowall_anm" )
  ObjDelete( "spr_cabinet_photo" )
  ObjSet( "spr_cabinet_photoadress", { visible = 1 } )
  if common_impl.ZzCompleteCheck("clk_photowall") then ObjSet( common_impl.hint["clk_photowall"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_photowall", private.clk_photowall_beg, private.room_objname );
cmn.AddSubscriber( "clk_photowall", private.clk_photowall_end, private.room_objname );
cmn.AddSubscriber( "clk_photowall", private.clk_photowall_logic );
cmn.AddSubscriber( "clk_photowall_beg", private.clk_photowall_beg, private.room_objname );
cmn.AddSubscriber( "clk_photowall_end", private.clk_photowall_end, private.room_objname );
cmn.AddSubscriber( "clk_photowall_end", private.clk_photowall_logic );
--------------------------------------------------------------------------------------------
function public.clk_photowall()

  local func_end = function()
    cmn.SetEventDone( "clk_photowall" );
    cmn.CallEventHandler( "clk_photowall_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_photowall") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_photowall_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_turn_arownd_picture" )
  ld.AnimPlay( "anm_photowall_anm", "get_photoadress", func_end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_photoadress" ] = { type = "get", get_obj = "spr_photowall_photoadress", room = "rm_cabinet", zz = "zz_photowall", zz_gate = "gzz_cabinet_photowall" };

private.get_photoadress_logic = function()
  
end;
private.get_photoadress_inv = function()
  interface.InventoryItemAdd("inv_photoadress","spr_photowall_photoadress");
end;
private.get_photoadress_beg = function()
  ObjDelete("gfx_photowall_photoadress")
end;
private.get_photoadress_end = function()
  ObjDelete( "spr_cabinet_photoadress" )
  if common_impl.ZzCompleteCheck("get_photoadress") then ObjSet( common_impl.hint["get_photoadress"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_photoadress", private.get_photoadress_inv );
cmn.AddSubscriber( "get_photoadress", private.get_photoadress_beg, private.room_objname );
cmn.AddSubscriber( "get_photoadress", private.get_photoadress_end, private.room_objname );
cmn.AddSubscriber( "get_photoadress", private.get_photoadress_logic );
--------------------------------------------------------------------
function public.get_photoadress()
  cmn.SetEventDone( "get_photoadress" );
  cmn.CallEventHandler( "get_photoadress" );
  if common_impl.ZzCompleteCheck("get_photoadress") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_worktable *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_coal" ] = { type = "get", get_obj = "spr_worktable_coal", room = "rm_cabinet", zz = "zz_worktable", zz_gate = "gzz_cabinet_worktable" };

private.get_coal_logic = function()
  
end;
private.get_coal_inv = function()
  interface.InventoryItemAdd("inv_coal","spr_worktable_coal");
end;
private.get_coal_beg = function()
  ObjDelete("gfx_worktable_coal")
end;
private.get_coal_end = function()
  ObjDelete( "spr_worktable_coal_shadow" )
  if common_impl.ZzCompleteCheck("get_coal") then ObjSet( common_impl.hint["get_coal"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_coal", private.get_coal_inv );
cmn.AddSubscriber( "get_coal", private.get_coal_beg, private.room_objname );
cmn.AddSubscriber( "get_coal", private.get_coal_end, private.room_objname );
cmn.AddSubscriber( "get_coal", private.get_coal_logic );
--------------------------------------------------------------------
function public.get_coal()
  cmn.SetEventDone( "get_coal" );
  cmn.CallEventHandler( "get_coal" );
  if common_impl.ZzCompleteCheck("get_coal") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_catfigurine" ] = { type = "use", inv_obj = "inv_catfigurine", use_place = "gfx_worktable_catfigurine_zone", room = "rm_cabinet", zz = "zz_worktable", zz_gate = "gzz_cabinet_worktable" };

private.use_catfigurine_logic = function()

  ObjSet( "spr_worktable_snowflake1", { visible = 1, input = 1, active = 1 } )


end;
private.use_catfigurine_inv = function()
  common_impl.ProcessMultiUseAll("catfigurine", "catfigurine")
end;
private.use_catfigurine_beg = function()
  ObjDelete( "gfx_worktable_catfigurine_zone" );
end;
private.use_catfigurine_end = function()
  ObjDelete( "spr_cabinet_zz_table_t1" )

  ObjSet( "spr_cabinet_zz_table_t2", { visible = 1 } )
  ObjSet( "spr_cabinet_butterfly", { visible = 1 } )
  ObjSet( "spr_cabinet_photo1", { visible = 1 } )
  ObjSet( "spr_cabinet_snowflake1", { visible = 1 } )

  ObjSet( "spr_worktable_snowflake1", { visible = 1 } )
  ObjSet( "spr_worktable_butterfly", { visible = 1 } )
  ObjSet( "spr_worktable_photo1", { visible = 1 } )

  ObjSet( "spr_worktable_butterfly_shadow", { visible = 1 } )
  ObjSet( "spr_worktable_photo1_shadow", { visible = 1 } )
  ObjSet( "spr_worktable_snowflake1_shadow", { visible = 1 } )
  ObjSet( "anm_worktable_anm_open_cap", { animfunc = "open_cap_0", frame = 0 } )
  if common_impl.ZzCompleteCheck("use_catfigurine") then ObjSet( common_impl.hint["use_catfigurine"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_catfigurine", private.use_catfigurine_inv );
cmn.AddSubscriber( "use_catfigurine", private.use_catfigurine_beg, private.room_objname );
cmn.AddSubscriber( "use_catfigurine", private.use_catfigurine_end, private.room_objname );
cmn.AddSubscriber( "use_catfigurine", private.use_catfigurine_logic );
cmn.AddSubscriber( "use_catfigurine_inv", private.use_catfigurine_inv, private.room_objname );
cmn.AddSubscriber( "use_catfigurine_beg", private.use_catfigurine_beg, private.room_objname );
cmn.AddSubscriber( "use_catfigurine_end", private.use_catfigurine_end, private.room_objname );
cmn.AddSubscriber( "use_catfigurine_end", private.use_catfigurine_logic );
--------------------------------------------------------------------------------------------
function public.use_catfigurine( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_catfigurine" );
    cmn.CallEventHandler( "use_catfigurine_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_catfigurine") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_catfigurine_inv" );
  cmn.CallEventHandler( "use_catfigurine_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_worktable_anm_open_cap", "open_cap", func_end )
  SoundSfx( "aud_cat_figurine" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_photo1" ] = { type = "get", get_obj = "spr_worktable_photo1", room = "rm_cabinet", zz = "zz_worktable", zz_gate = "gzz_cabinet_worktable" };

private.get_photo1_logic = function()
  ObjSet( "spr_worktable_butterfly", { visible = 1, input = 1, active = 1 } )
end;
private.get_photo1_inv = function()
  interface.InventoryItemAdd("inv_photo","spr_worktable_photo1",function() level_inv.ProcessGetPhotoAll( "get_photo1" ) end);
end;
private.get_photo1_beg = function()
  ObjDelete("gfx_worktable_photo1")
end;
private.get_photo1_end = function()
  ObjDelete( "spr_worktable_photo1_shadow" )
  ObjDelete( "spr_cabinet_photo1" )
  if common_impl.ZzCompleteCheck("get_photo1") then ObjSet( common_impl.hint["get_photo1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_photo1", private.get_photo1_inv );
cmn.AddSubscriber( "get_photo1", private.get_photo1_beg, private.room_objname );
cmn.AddSubscriber( "get_photo1", private.get_photo1_end, private.room_objname );
cmn.AddSubscriber( "get_photo1", private.get_photo1_logic );
--------------------------------------------------------------------
function public.get_photo1()
  cmn.SetEventDone( "get_photo1" );
  cmn.CallEventHandler( "get_photo1" );
  if common_impl.ZzCompleteCheck("get_photo1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_snowflake1" ] = { type = "get", get_obj = "spr_worktable_snowflake1", room = "rm_cabinet", zz = "zz_worktable", zz_gate = "gzz_cabinet_worktable" };

private.get_snowflake1_logic = function()
  ObjSet( "spr_worktable_photo1", { visible = 1, input = 1, active = 1 } )
end;
private.get_snowflake1_inv = function()
  interface.InventoryItemAdd("inv_snowflake1","spr_worktable_snowflake1");
end;
private.get_snowflake1_beg = function()
  ObjDelete("gfx_worktable_snowflake1")
end;
private.get_snowflake1_end = function()
  ObjDelete( "spr_worktable_snowflake1_shadow" )
  ObjDelete( "spr_cabinet_snowflake1" )
  if common_impl.ZzCompleteCheck("get_snowflake1") then ObjSet( common_impl.hint["get_snowflake1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_snowflake1", private.get_snowflake1_inv );
cmn.AddSubscriber( "get_snowflake1", private.get_snowflake1_beg, private.room_objname );
cmn.AddSubscriber( "get_snowflake1", private.get_snowflake1_end, private.room_objname );
cmn.AddSubscriber( "get_snowflake1", private.get_snowflake1_logic );
--------------------------------------------------------------------
function public.get_snowflake1()
  cmn.SetEventDone( "get_snowflake1" );
  cmn.CallEventHandler( "get_snowflake1" );
  if common_impl.ZzCompleteCheck("get_snowflake1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_butterfly" ] = { type = "get", get_obj = "spr_worktable_butterfly", room = "rm_cabinet", zz = "zz_worktable", zz_gate = "gzz_cabinet_worktable" };

private.get_butterfly_logic = function()
  
end;
private.get_butterfly_inv = function()
  interface.InventoryItemAdd("inv_butterfly","spr_worktable_butterfly");
end;
private.get_butterfly_beg = function()
  ObjDelete("gfx_worktable_butterfly")
end;
private.get_butterfly_end = function()
  ObjDelete( "spr_worktable_butterfly_shadow" )
  ObjDelete( "spr_cabinet_butterfly" )
  if common_impl.ZzCompleteCheck("get_butterfly") then ObjSet( common_impl.hint["get_butterfly"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_butterfly", private.get_butterfly_inv );
cmn.AddSubscriber( "get_butterfly", private.get_butterfly_beg, private.room_objname );
cmn.AddSubscriber( "get_butterfly", private.get_butterfly_end, private.room_objname );
cmn.AddSubscriber( "get_butterfly", private.get_butterfly_logic );
--------------------------------------------------------------------
function public.get_butterfly()
  cmn.SetEventDone( "get_butterfly" );
  cmn.CallEventHandler( "get_butterfly" );
  if common_impl.ZzCompleteCheck("get_butterfly") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "get_balerina" ] = { type = "get", get_obj = "spr_worktable_balerina", room = "rm_cabinet", zz = "zz_worktable", zz_gate = "gzz_cabinet_worktable" };

private.get_balerina_logic = function()
  
end;
private.get_balerina_inv = function()
  interface.InventoryItemAdd("inv_balerina","spr_worktable_balerina");
  ObjSet("inv_balerina",{drag=0})
end;
private.get_balerina_beg = function()
  ObjDelete("gfx_worktable_balerina")

end;
private.get_balerina_end = function()
  ObjDelete( "spr_cabinet_figurwomen1" )
  ObjSet( "spr_worktable_balerina", {visible = 1} );
  ObjSet( "anm_worktable_anm_rasp", { animfunc = "rasp_final_end", frame = 0 } )
  if common_impl.ZzCompleteCheck("get_balerina") then ObjSet( common_impl.hint["get_balerina"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_balerina", private.get_balerina_inv );
cmn.AddSubscriber( "get_balerina", private.get_balerina_beg, private.room_objname );
cmn.AddSubscriber( "get_balerina", private.get_balerina_end, private.room_objname );
cmn.AddSubscriber( "get_balerina", private.get_balerina_logic );

cmn.AddSubscriber( "get_balerina_end", private.get_balerina_inv );
cmn.AddSubscriber( "get_balerina_beg", private.get_balerina_beg, private.room_objname );
cmn.AddSubscriber( "get_balerina_end", private.get_balerina_end, private.room_objname );
cmn.AddSubscriber( "get_balerina_end", private.get_balerina_logic );
--------------------------------------------------------------------
function public.get_balerina()
  local func_end = function()
    ObjSet( "spr_worktable_balerina", {pos_x = -3.0770, pos_y = -87.4449, ang = -0.0792} );
    cmn.SetEventDone( "get_balerina" );
    cmn.CallEventHandler( "get_balerina_end" );
    if common_impl.ZzCompleteCheck("get_balerina") then ld.CloseSubRoom() end;
    ld.Lock( 0 )
  end

  ld.Lock( 1 )
  cmn.CallEventHandler( "get_balerina_beg" );

  ld.AnimPlay( "anm_worktable_anm_rasp", "rasp_final", func_end )
  SoundSfx( "aud_get_balerine" )
end

--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_citymaket *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_snowflake1" ] = { type = "use", inv_obj = "inv_snowflake1", use_place = "gfx_citymaket_snowflake1_zone", room = "rm_cabinet", zz = "zz_citymaket", zz_gate = "gzz_cabinet_citymaket" };

private.use_snowflake1_logic = function()
  if ld.CheckRequirements( {"use_snowflake1","use_snowflake2"} ) then
    ObjSet( "gmg_cabinet_citymg", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.use_snowflake1_inv = function()
  common_impl.ProcessMultiUseAll("snowflake1", "snowflake1")
end;
private.use_snowflake1_beg = function()
  ObjDelete( "gfx_citymaket_snowflake1_zone" );
end;
private.use_snowflake1_end = function()
  if ld.CheckRequirements( {"use_snowflake1","use_snowflake2"} ) then
    ObjDelete( "anm_citymaket_anm" )
    ObjDelete( "spr_cabinet_glass" )
  else
    ObjSet( "anm_citymaket_anm", { animfunc = "idle_snowflake", frame = 0 } )
  end
  if common_impl.ZzCompleteCheck("use_snowflake1") then ObjSet( common_impl.hint["use_snowflake1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_snowflake1", private.use_snowflake1_inv );
cmn.AddSubscriber( "use_snowflake1", private.use_snowflake1_beg, private.room_objname );
cmn.AddSubscriber( "use_snowflake1", private.use_snowflake1_end, private.room_objname );
cmn.AddSubscriber( "use_snowflake1", private.use_snowflake1_logic );
cmn.AddSubscriber( "use_snowflake1_inv", private.use_snowflake1_inv, private.room_objname );
cmn.AddSubscriber( "use_snowflake1_beg", private.use_snowflake1_beg, private.room_objname );
cmn.AddSubscriber( "use_snowflake1_end", private.use_snowflake1_end, private.room_objname );
cmn.AddSubscriber( "use_snowflake1_end", private.use_snowflake1_logic );
--------------------------------------------------------------------------------------------
function public.use_snowflake1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_snowflake1" );
    cmn.CallEventHandler( "use_snowflake1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_snowflake1") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_snowflake1_inv" );
  cmn.CallEventHandler( "use_snowflake1_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_glass_snowflake" )
  ld.AnimPlay( "anm_citymaket_anm", ld.CheckRequirements( { "use_snowflake1", "use_snowflake2" }, true ) == 1 and "use_snowflake02" or "use_snowflake", function() 
    if ld.CheckRequirements( { "use_snowflake1", "use_snowflake2" }, true ) == 1 then
      SoundSfx( "aud_showcase_open" )
      ld.AnimPlay( "anm_citymaket_anm", "end_snowflake3", func_end )
    else
      func_end()
    end
  end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_snowflake2" ] = { type = "use", inv_obj = "inv_snowflake2", use_place = "gfx_citymaket_snowflake2_zone", room = "rm_cabinet", zz = "zz_citymaket", zz_gate = "gzz_cabinet_citymaket" };

private.use_snowflake2_logic = function()
  if ld.CheckRequirements( {"use_snowflake2","use_snowflake1"} ) then
    ObjSet( "gmg_cabinet_citymg", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_snowflake2_inv = function()
  common_impl.ProcessMultiUseAll("snowflake2", "snowflake2")
end;
private.use_snowflake2_beg = function()
  ObjDelete( "gfx_citymaket_snowflake2_zone" );
end;
private.use_snowflake2_end = function()
  if ld.CheckRequirements( {"use_snowflake1","use_snowflake2"} ) then
    ObjDelete( "anm_citymaket_anm" )
    ObjDelete( "spr_cabinet_glass" )
  else
    ObjSet( "anm_citymaket_anm", { animfunc = "idle_snowflake2", frame = 0 } )
  end
  if common_impl.ZzCompleteCheck("use_snowflake2") then ObjSet( common_impl.hint["use_snowflake2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_snowflake2", private.use_snowflake2_inv );
cmn.AddSubscriber( "use_snowflake2", private.use_snowflake2_beg, private.room_objname );
cmn.AddSubscriber( "use_snowflake2", private.use_snowflake2_end, private.room_objname );
cmn.AddSubscriber( "use_snowflake2", private.use_snowflake2_logic );
cmn.AddSubscriber( "use_snowflake2_inv", private.use_snowflake2_inv, private.room_objname );
cmn.AddSubscriber( "use_snowflake2_beg", private.use_snowflake2_beg, private.room_objname );
cmn.AddSubscriber( "use_snowflake2_end", private.use_snowflake2_end, private.room_objname );
cmn.AddSubscriber( "use_snowflake2_end", private.use_snowflake2_logic );
--------------------------------------------------------------------------------------------
function public.use_snowflake2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_snowflake2" );
    cmn.CallEventHandler( "use_snowflake2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_snowflake2") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_snowflake2_inv" );
  cmn.CallEventHandler( "use_snowflake2_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_glass_snowflake" )
  ld.AnimPlay( "anm_citymaket_anm", ld.CheckRequirements( { "use_snowflake1", "use_snowflake2" }, true ) == 1 and "use_snowflake01" or "use_snowflake2", function() 
    if ld.CheckRequirements( { "use_snowflake1", "use_snowflake2" }, true ) == 1 then
      SoundSfx( "aud_showcase_open" )
      ld.AnimPlay( "anm_citymaket_anm", "end_snowflake3", func_end )
    else
      func_end()
    end
  end )

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_fairplace *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mittens" ] = { type = "use", inv_obj = "inv_mittens", use_place = "gfx_fairplace_mittens_zone", room = "rm_cabinet", zz = "zz_fairplace", zz_gate = "gzz_cabinet_fairplace" };

private.use_mittens_logic = function()
  ObjSet( "spr_fairplace_coalsscoop", { visible = 1, input = 1, active = 1 } )

end;
private.use_mittens_inv = function()
  common_impl.ProcessMultiUseAll("mittens", "mittens")
end;
private.use_mittens_beg = function()
  ObjDelete( "gfx_fairplace_mittens_zone" );
end;
private.use_mittens_end = function()
  ObjDelete( "anm_fairplace_anm_static_coalsscoop" )
  ObjDelete( "anm_fairplace_anm_idle_coalsscoop" )
  ObjSet( "spr_fairplace_coalsscoop_sh", { visible = 1 } )
  if common_impl.ZzCompleteCheck("use_mittens") then ObjSet( common_impl.hint["use_mittens"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mittens", private.use_mittens_inv );
cmn.AddSubscriber( "use_mittens", private.use_mittens_beg, private.room_objname );
cmn.AddSubscriber( "use_mittens", private.use_mittens_end, private.room_objname );
cmn.AddSubscriber( "use_mittens", private.use_mittens_logic );
cmn.AddSubscriber( "use_mittens_inv", private.use_mittens_inv, private.room_objname );
cmn.AddSubscriber( "use_mittens_beg", private.use_mittens_beg, private.room_objname );
cmn.AddSubscriber( "use_mittens_end", private.use_mittens_end, private.room_objname );
cmn.AddSubscriber( "use_mittens_end", private.use_mittens_logic );
--------------------------------------------------------------------------------------------
function public.use_mittens( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mittens" );
    cmn.CallEventHandler( "use_mittens_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mittens") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mittens_inv" );
  cmn.CallEventHandler( "use_mittens_beg" );
  common_impl.Lock(1);

  ObjAnimate( "anm_fairplace_anm_static_coalsscoop", 8,0,0, _, { 0,0,1, 0.4,1,0 } )
  ObjAnimate( "anm_fairplace_anm_idle_coalsscoop", 8,0,0, _, { 0,0,0, 0.4,2,1 } )
  ld.AnimPlay( "anm_fairplace_anm_idle_coalsscoop", "use_mittens", func_end )
  SoundSfx( "aud_mittens" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_coalsscoop" ] = { type = "get", get_obj = "spr_fairplace_coalsscoop", room = "rm_cabinet", zz = "zz_fairplace", zz_gate = "gzz_cabinet_fairplace" };

private.get_coalsscoop_logic = function()
  
end;
private.get_coalsscoop_inv = function()
  interface.InventoryItemAdd("inv_coalsscoop","spr_fairplace_coalsscoop");
end;
private.get_coalsscoop_beg = function()
  ObjDelete("gfx_fairplace_coalsscoop")
end;
private.get_coalsscoop_end = function()
  ObjDelete( "spr_fairplace_coalsscoop_sh" )
  if common_impl.ZzCompleteCheck("get_coalsscoop") then ObjSet( common_impl.hint["get_coalsscoop"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_coalsscoop", private.get_coalsscoop_inv );
cmn.AddSubscriber( "get_coalsscoop", private.get_coalsscoop_beg, private.room_objname );
cmn.AddSubscriber( "get_coalsscoop", private.get_coalsscoop_end, private.room_objname );
cmn.AddSubscriber( "get_coalsscoop", private.get_coalsscoop_logic );
--------------------------------------------------------------------
function public.get_coalsscoop()
  cmn.SetEventDone( "get_coalsscoop" );
  cmn.CallEventHandler( "get_coalsscoop" );
  if common_impl.ZzCompleteCheck("get_coalsscoop") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_frozenpitch" ] = { type = "use", inv_obj = "inv_frozenpitch", use_place = "gfx_fairplace_frozenpitch_zone", room = "rm_cabinet", zz = "zz_fairplace", zz_gate = "gzz_cabinet_fairplace" };

private.use_frozenpitch_logic = function()
  ObjSet( "spr_fairplace_stickymass", { visible = 1, input = 1, active = 1 } )

end;
private.use_frozenpitch_inv = function()
  common_impl.ProcessMultiUseAll("frozenpitch", "frozenpitch")
end;
private.use_frozenpitch_beg = function()
  ObjDelete( "gfx_fairplace_frozenpitch_zone" );
end;
private.use_frozenpitch_end = function()
  ObjDelete( "anm_fairplace_anm_use_frozenpitch" )
  ObjSet( "spr_fairplace_bowl_sh", { visible = 1 } )
  if common_impl.ZzCompleteCheck("use_frozenpitch") then ObjSet( common_impl.hint["use_frozenpitch"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_frozenpitch", private.use_frozenpitch_inv );
cmn.AddSubscriber( "use_frozenpitch", private.use_frozenpitch_beg, private.room_objname );
cmn.AddSubscriber( "use_frozenpitch", private.use_frozenpitch_end, private.room_objname );
cmn.AddSubscriber( "use_frozenpitch", private.use_frozenpitch_logic );
cmn.AddSubscriber( "use_frozenpitch_inv", private.use_frozenpitch_inv, private.room_objname );
cmn.AddSubscriber( "use_frozenpitch_beg", private.use_frozenpitch_beg, private.room_objname );
cmn.AddSubscriber( "use_frozenpitch_end", private.use_frozenpitch_end, private.room_objname );
cmn.AddSubscriber( "use_frozenpitch_end", private.use_frozenpitch_logic );
--------------------------------------------------------------------------------------------
function public.use_frozenpitch( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_frozenpitch" );
    cmn.CallEventHandler( "use_frozenpitch_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_frozenpitch") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_frozenpitch_inv" );
  cmn.CallEventHandler( "use_frozenpitch_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_fairplace_anm_use_frozenpitch", "use_frozenpitch", func_end )
  SoundSfx( "aud_frozentar" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_stickymass" ] = { type = "get", get_obj = "spr_fairplace_stickymass", room = "rm_cabinet", zz = "zz_fairplace", zz_gate = "gzz_cabinet_fairplace" };

private.get_stickymass_logic = function()
  
end;
private.get_stickymass_inv = function()
  interface.InventoryItemAdd("inv_stickymass","spr_fairplace_stickymass");
end;
private.get_stickymass_beg = function()
  ObjDelete("gfx_fairplace_stickymass")
end;
private.get_stickymass_end = function()
  ObjDelete( "spr_fairplace_bowl_sh" )
  if common_impl.ZzCompleteCheck("get_stickymass") then ObjSet( common_impl.hint["get_stickymass"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_stickymass", private.get_stickymass_inv );
cmn.AddSubscriber( "get_stickymass", private.get_stickymass_beg, private.room_objname );
cmn.AddSubscriber( "get_stickymass", private.get_stickymass_end, private.room_objname );
cmn.AddSubscriber( "get_stickymass", private.get_stickymass_logic );
--------------------------------------------------------------------
function public.get_stickymass()
  cmn.SetEventDone( "get_stickymass" );
  cmn.CallEventHandler( "get_stickymass" );
  if common_impl.ZzCompleteCheck("get_stickymass") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local get_santasrendeer_for_cabinet = function()
    if ld.CheckRequirements( {"get_santasrendeer","get_photo2"} ) then
      ObjSet( "gmg_cabinet_citymg", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("get_santasrendeer", get_santasrendeer_for_cabinet, private.room_objname )

  local get_photo2_for_cabinet = function()
    if ld.CheckRequirements( {"get_santasrendeer","get_photo2"} ) then
      ObjSet( "gmg_cabinet_citymg", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("get_photo2", get_santasrendeer_for_cabinet, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom();
  if ( mg_name == "zz_photowall" ) then
    public.win_photowall_game.skip()  
  end
end
--*********************************************************************************************************************
function public.Reset()
  local mg_name = common.GetCurrentSubRoom();
  if ( mg_name == "zz_photowall" ) then
    public.win_photowall_game.reset()         
  end
end
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Open()
  private.opn_cabinet();
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not ld.CheckRequirements( { "opn_cabinet" } ) then
    ObjAttach( "vid_cabinet_vid_goblinspell_berta_458", "rm_cabinet" )
    common_impl.SetWidgetsVisible( "DialogVideoShow", false )
  end
  SoundEnv( "aud_cabinet_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_fairplace" );
  function zz_fairplace.Open()
  end;
  function zz_fairplace.PreOpen()
  end;
  function zz_fairplace.PreClose()
  end;
  function zz_fairplace.Close()
  end;

  subroom.Define( "zz_citymaket" );
  function zz_citymaket.Open()
  end;
  function zz_citymaket.PreOpen()
  end;
  function zz_citymaket.PreClose()
  end;
  function zz_citymaket.Close()
  end;

  subroom.Define( "zz_worktable" );
  function zz_worktable.Open()
  end;
  function zz_worktable.PreOpen()
  end;
  function zz_worktable.PreClose()
  end;
  function zz_worktable.Close()
  end;

  subroom.Define( "zz_photowall" );
  function zz_photowall.Open()
  end;
  function zz_photowall.PreOpen()
    public.win_photowall_load()
  end;
  function zz_photowall.PreClose()
  end;
  function zz_photowall.Close()
  end;
  
end;
--*********************************************************************************************************************