-- name=rm_jewelryshop
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_jewelryshop";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_jewelryshop()
  if not ( cmn.IsEventDone( "opn_jewelryshop" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_jewelryshop" );
      cmn.CallEventHandler( "opn_jewelryshop" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_jewelryshop = function() end;
local opn_jewelryshop_logic = function() end;
cmn.AddSubscriber( "opn_jewelryshop", opn_jewelryshop_logic )
cmn.AddSubscriber( "opn_jewelryshop", opn_jewelryshop, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_jewelryshowcase *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_puzzle1" ] = { type = "get", get_obj = "spr_jewelryshowcase_puzzle1", room = "rm_jewelryshop", zz = "zz_jewelryshowcase", zz_gate = "gzz_jewelryshop_jewelryshowcase" };

private.get_puzzle1_logic = function()
  ObjSet( "gfx_jewelryshowcase_powder_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_puzzle1_inv = function()
  interface.InventoryItemAdd("inv_puzzle","spr_jewelryshowcase_puzzle1",function() level_inv.ProcessGetPuzzleAll( "get_puzzle1" ) end);
end;
private.get_puzzle1_beg = function()
  ObjDelete("gfx_jewelryshowcase_puzzle1")
end;
private.get_puzzle1_end = function()
  ObjDelete("spr_jewelryshowcase_puzzle1_tr_sh")
  ObjDelete("spr_jewelryshop_puzzle1")
  if common_impl.ZzCompleteCheck("get_puzzle1") then ObjSet( common_impl.hint["get_puzzle1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_puzzle1", private.get_puzzle1_inv );
cmn.AddSubscriber( "get_puzzle1", private.get_puzzle1_beg, private.room_objname );
cmn.AddSubscriber( "get_puzzle1", private.get_puzzle1_end, private.room_objname );
cmn.AddSubscriber( "get_puzzle1", private.get_puzzle1_logic );
--------------------------------------------------------------------
function public.get_puzzle1()
  cmn.SetEventDone( "get_puzzle1" );
  cmn.CallEventHandler( "get_puzzle1" );
  if common_impl.ZzCompleteCheck("get_puzzle1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_powder" ] = { type = "use", inv_obj = "inv_powder", use_place = "gfx_jewelryshowcase_powder_zone", room = "rm_jewelryshop", zz = "zz_jewelryshowcase", zz_gate = "gzz_jewelryshop_jewelryshowcase" };

private.use_powder_logic = function()
  ObjSet( "gfx_jewelryshowcase_win_code_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_powder_inv = function()
  common_impl.ProcessMultiUseAll("powder", "powder")
end;
private.use_powder_beg = function()
  ObjDelete( "gfx_jewelryshowcase_powder_zone" );
end;
private.use_powder_end = function()
  ObjSet( "anm_jewelryshowcase_anm", {animfunc = "get_glass", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_powder") then ObjSet( common_impl.hint["use_powder"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_powder", private.use_powder_inv );
cmn.AddSubscriber( "use_powder", private.use_powder_beg, private.room_objname );
cmn.AddSubscriber( "use_powder", private.use_powder_end, private.room_objname );
cmn.AddSubscriber( "use_powder", private.use_powder_logic );
cmn.AddSubscriber( "use_powder_inv", private.use_powder_inv, private.room_objname );
cmn.AddSubscriber( "use_powder_beg", private.use_powder_beg, private.room_objname );
cmn.AddSubscriber( "use_powder_end", private.use_powder_end, private.room_objname );
cmn.AddSubscriber( "use_powder_end", private.use_powder_logic );
--------------------------------------------------------------------------------------------
function public.use_powder( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_powder" );
    cmn.CallEventHandler( "use_powder_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_powder") then ld.CloseSubRoom() end;
    --start mg
    cmn.SetEventStart("win_code")
    public.win_code_load()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_powder_inv" );
  cmn.CallEventHandler( "use_powder_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_jewelryshowcase_anm", "use_powder", func_end );
  SoundSfx( "aud_use_powder_jewelryshowcase" )
  --func_end()

end;
--------------------------------------------------------------------------------------------

local win_code_offset_y = 6
local win_code_source_zone = "obj_jewelryshowcase_click_1"
local win_code_buttons_count = 10
local win_code_start_params_y = {86,132}
local win_code_x_size = win_code_buttons_count/#win_code_start_params_y
local win_code_winstate = {2,5,8}
function public.win_code_load()
  --set zones
  ng_global.progress["std"]["win_code"].state = ng_global.progress["std"]["win_code"].state or {}
  local state = ng_global.progress["std"]["win_code"].state
  local start_x,start_y = ObjGet(win_code_source_zone).pos_x,ObjGet(win_code_source_zone).pos_y
  for i = 1,win_code_buttons_count do

    local column = (i-1)%win_code_x_size+1;  --1...5,1...5
    local row = private.win_code_get_row(i); --1...1,2...2

    if i ~= 1 then
      local next_zone = win_code_source_zone:gsub("_1","_"..i)
      if not ObjGet(next_zone) then
        ld.CopyObj(win_code_source_zone, next_zone, "obj", common_impl.hint[ "win_code" ].use_place)
      end
      -- calculate pos_x, pos_y
      local height,width = ObjGet(win_code_source_zone).inputrect_h,ObjGet(win_code_source_zone).inputrect_w
      --set pos_x, pos_y
      ObjSet( next_zone, {pos_x = start_x + (column-1) * width, pos_y = start_y + (row-1) * height} );
    end
    
    --set base pos_y
    local tag_pos_y = "posy"..i
    ObjSet( "anm_jewelryshowcase_anm", {[tag_pos_y] = win_code_start_params_y[row]} );
  end

  --set pressed buttons
  for i,o in ipairs(state) do
    local tag_pos_y = "posy"..o
    local param_y = ObjGet("anm_jewelryshowcase_anm")[tag_pos_y]
    ObjSet( "anm_jewelryshowcase_anm", {[tag_pos_y] = param_y + win_code_offset_y} );
  end

end



function public.win_code_menter(sender)
  local n = tonumber( ld.StringDivide(sender)[4] )
  ld.ShCur(CURSOR_HAND)
  --ld.LogTrace( n.." button is menter" );
  --ObjAnimate( "anm_jewelryshowcase_anm", "posy1", 0, 0, function() end, {0,0,0, 0.5,0,-50} );
  
end
function public.win_code_mleave(sender)
  local n = tonumber( ld.StringDivide(sender)[4] )
  ld.ShCur(CURSOR_DEFAULT)
  --ld.LogTrace( n.." button is mleave" );
end
function public.win_code_change(sender)
  local n = tonumber( ld.StringDivide(sender)[4] )
  --ld.LogTrace( n.." button is clicked" );
  local state = ng_global.progress["std"]["win_code"].state
  --ld.LogTrace( state );
  local pos = ld.TableContains(state, n, 1) 
  local tag_pos_y = "posy"..n
  local row = private.win_code_get_row(n);
  local pos1,pos2 = win_code_start_params_y[row], win_code_start_params_y[row] + win_code_offset_y
  local animtime = 0.2
  ld.Lock(1)
  if pos ~= 0 then
    SoundSfx( "aud_depress" )
    ObjAnimate( "anm_jewelryshowcase_anm", tag_pos_y, 0, 0, function() 
      ld.Lock(0) 
      table.remove(state,pos) 
    end, {0,0,pos2, animtime,0,pos1} );
  else
    SoundSfx( "aud_press_button" )
    ObjAnimate( "anm_jewelryshowcase_anm", tag_pos_y, 0, 0, function() 
      ld.Lock(0) 
      table.insert(state,n) 
      public.win_code_wincheck(n) 
      state[#win_code_winstate] = nil 
    end, {0,0,pos1, animtime,0,pos2} );
  end
end
function public.win_code_wincheck()
  
  local state = ng_global.progress["std"]["win_code"].state
  --ld.LogTrace( state );
  if #state >= #win_code_winstate then
    local wincount = 0
    for i,o in ipairs(state) do
      for k,j in ipairs(win_code_winstate) do
        if o == j then
          wincount = wincount + 1
        end
      end
    end
    
    if wincount == #win_code_winstate then
      public.win_code()
    else
      for i = 1,win_code_buttons_count do
        local tag_pos_y = "posy"..i
        local row = math.floor((i-1)/win_code_x_size) + 1;
        ObjSet( "anm_jewelryshowcase_anm", {[tag_pos_y] = win_code_start_params_y[row]} );
      end
      ng_global.progress["std"]["win_code"].state = {}
    end
  end

end

function private.win_code_get_row(n)
  return math.floor((n-1)/win_code_x_size) + 1;
end

function public.win_code_hint()
  --ld.LogTrace( "aaa" );
  local state = ng_global.progress["std"]["win_code"].state
  for i,o in ipairs(win_code_winstate) do
    --ld.LogTrace( o );
    if ld.TableContains(state, o) then
      --ld.LogTrace( "1" );  
    else
      --ld.LogTrace( "2" );  
      local name = win_code_source_zone:gsub("_1","_"..o)
      common_impl.HintShowAnm(name)
      break;
    end
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_code" ] = { type = "click", use_place = "gfx_jewelryshowcase_win_code_zone", room = "rm_jewelryshop", zz = "zz_jewelryshowcase", zz_gate = "gzz_jewelryshop_jewelryshowcase", hint = public.win_code_hint };

private.win_code_logic = function()
  if ld.CheckRequirements( {"win_code"} ) then
    ObjSet( "spr_jewelryshowcase_clasp", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_jewelryshowcase_specs", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_code_beg = function()
  if ld.CheckRequirements( {"win_code"} ) then
    ObjSet( "gfx_jewelryshowcase_win_code_zone", {input = 0, visible = 0} );
  end
end;
private.win_code_end = function()
  --load buttons
  public.win_code_load()
  if ld.CheckRequirements( {"win_code"} ) then
    ObjDelete( "obj_jewelryshowcase_bbt_jewelryshowcase_clasp" )
    ObjSet( "anm_jewelryshowcase_anm", {animfunc = "get_glass", frame = 999 } );
    ObjSet( "spr_jewelryshop_open_showacse", {visible = 1} );
    if common_impl.ZzCompleteCheck("win_code") then ObjSet( common_impl.hint["win_code"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_code", private.win_code_beg, private.room_objname );
cmn.AddSubscriber( "win_code", private.win_code_end, private.room_objname );
cmn.AddSubscriber( "win_code", private.win_code_logic );
cmn.AddSubscriber( "win_code_beg", private.win_code_beg, private.room_objname );
cmn.AddSubscriber( "win_code_end", private.win_code_end, private.room_objname );
cmn.AddSubscriber( "win_code_end", private.win_code_logic );
--------------------------------------------------------------------------------------------
function public.win_code()

  local func_end = function()
    ng_global.progress["std"]["win_code"].state = win_code_winstate;
    cmn.SetEventDone( "win_code" );
    cmn.CallEventHandler( "win_code_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_code") then ld.CloseSubRoom() end;
  end;
  ObjSet( "gfx_jewelryshowcase_win_code_zone", {input = 0, visible = 0} );
  cmn.CallEventHandler( "win_code_beg" );
  common_impl.Lock(1);
  ld.AnimPlay( "anm_jewelryshowcase_anm", "get_glass", func_end );
  SoundSfx( "aud_showcase_open" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_clasp" ] = { type = "get", get_obj = "spr_jewelryshowcase_clasp", room = "rm_jewelryshop", zz = "zz_jewelryshowcase", zz_gate = "gzz_jewelryshop_jewelryshowcase" };

private.get_clasp_logic = function()
  
end;
private.get_clasp_inv = function()
  interface.InventoryItemAdd("inv_clasp","spr_jewelryshowcase_clasp");
end;
private.get_clasp_beg = function()
  ObjDelete("gfx_jewelryshowcase_clasp")
end;
private.get_clasp_end = function()
  ObjDelete("spr_jewelryshowcase_clasp_sh")
  ObjDelete("spr_jewelryshop_buckles")
  if common_impl.ZzCompleteCheck("get_clasp") then ObjSet( common_impl.hint["get_clasp"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_clasp", private.get_clasp_inv );
cmn.AddSubscriber( "get_clasp", private.get_clasp_beg, private.room_objname );
cmn.AddSubscriber( "get_clasp", private.get_clasp_end, private.room_objname );
cmn.AddSubscriber( "get_clasp", private.get_clasp_logic );
--------------------------------------------------------------------
function public.get_clasp()
  cmn.SetEventDone( "get_clasp" );
  cmn.CallEventHandler( "get_clasp" );
  if common_impl.ZzCompleteCheck("get_clasp") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_specs" ] = { type = "get", get_obj = "spr_jewelryshowcase_specs", room = "rm_jewelryshop", zz = "zz_jewelryshowcase", zz_gate = "gzz_jewelryshop_jewelryshowcase" };

private.get_specs_logic = function()
  
end;
private.get_specs_inv = function()
  interface.InventoryItemAdd("inv_specs","spr_jewelryshowcase_specs");
end;
private.get_specs_beg = function()
  ObjDelete("gfx_jewelryshowcase_specs")
end;
private.get_specs_end = function()
  ObjDelete("spr_jewelryshowcase_specs_sh")
  ObjDelete("spr_jewelryshop_glasses")
  if common_impl.ZzCompleteCheck("get_specs") then ObjSet( common_impl.hint["get_specs"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_specs", private.get_specs_inv );
cmn.AddSubscriber( "get_specs", private.get_specs_beg, private.room_objname );
cmn.AddSubscriber( "get_specs", private.get_specs_end, private.room_objname );
cmn.AddSubscriber( "get_specs", private.get_specs_logic );
--------------------------------------------------------------------
function public.get_specs()
  cmn.SetEventDone( "get_specs" );
  cmn.CallEventHandler( "get_specs" );
  if common_impl.ZzCompleteCheck("get_specs") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_jewelrywall *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_fife" ] = { type = "get", get_obj = "spr_jewelrywall_fife", room = "rm_jewelryshop", zz = "zz_jewelrywall", zz_gate = "gzz_jewelryshop_jewelrywall" };

private.get_fife_logic = function()
  
end;
private.get_fife_inv = function()
  interface.InventoryItemAdd("inv_fife","spr_jewelrywall_fife");
end;
private.get_fife_beg = function()
  ObjDelete("gfx_jewelrywall_fife")
end;
private.get_fife_end = function()
  ObjDelete("spr_jewelrywall_fife_sh")
  ObjDelete("spr_jewelryshop_fife")
  if common_impl.ZzCompleteCheck("get_fife") then ObjSet( common_impl.hint["get_fife"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_fife", private.get_fife_inv );
cmn.AddSubscriber( "get_fife", private.get_fife_beg, private.room_objname );
cmn.AddSubscriber( "get_fife", private.get_fife_end, private.room_objname );
cmn.AddSubscriber( "get_fife", private.get_fife_logic );
--------------------------------------------------------------------
function public.get_fife()
  cmn.SetEventDone( "get_fife" );
  cmn.CallEventHandler( "get_fife" );
  if common_impl.ZzCompleteCheck("get_fife") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_crown" ] = { type = "use", inv_obj = "inv_crown", use_place = "gfx_jewelrywall_crown_zone", room = "rm_jewelryshop", zz = "zz_jewelrywall", zz_gate = "gzz_jewelryshop_jewelrywall" };

private.use_crown_logic = function()
  ObjSet( "spr_jewelrywall_amuletcake", {  input = 1, active = 1 } )

end;
private.use_crown_inv = function()
  common_impl.ProcessMultiUseAll("crown", "crown")
end;
private.use_crown_beg = function()
  ObjDelete( "gfx_jewelrywall_crown_zone" );
end;
private.use_crown_end = function()
  ObjSet( "spr_jewelryshop_crown", {visible = 1} );
  ObjSet( "anm_jewelrywall_anm", {animfunc = "use_crown", frame = 999 } );
  ObjSet( "gfx_jewelrywall_amuletcake", { visible = 1 } )
  ObjDelete("spr_jewelryshop_cover")
  ObjSet( "spr_jewelryshop_cover_open", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_crown") then ObjSet( common_impl.hint["use_crown"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_crown", private.use_crown_inv );
cmn.AddSubscriber( "use_crown", private.use_crown_beg, private.room_objname );
cmn.AddSubscriber( "use_crown", private.use_crown_end, private.room_objname );
cmn.AddSubscriber( "use_crown", private.use_crown_logic );
cmn.AddSubscriber( "use_crown_inv", private.use_crown_inv, private.room_objname );
cmn.AddSubscriber( "use_crown_beg", private.use_crown_beg, private.room_objname );
cmn.AddSubscriber( "use_crown_end", private.use_crown_end, private.room_objname );
cmn.AddSubscriber( "use_crown_end", private.use_crown_logic );
--------------------------------------------------------------------------------------------
function public.use_crown( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_crown" );
    cmn.CallEventHandler( "use_crown_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_crown") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_crown_inv" );
  cmn.CallEventHandler( "use_crown_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_jewelrywall_anm", "use_crown", func_end );
  SoundSfx( "aud_use_crown_jewelrywall" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletcake" ] = { type = "get", get_obj = "spr_jewelrywall_amuletcake", room = "rm_jewelryshop", zz = "zz_jewelrywall", zz_gate = "gzz_jewelryshop_jewelrywall" };

private.get_amuletcake_logic = function()
  
end;
private.get_amuletcake_inv = function()
  interface.InventoryItemAdd("inv_amuletcake","spr_jewelrywall_amuletcake");
end;
private.get_amuletcake_beg = function()
  ObjDelete("gfx_jewelrywall_amuletcake")
  ObjSet( "spr_jewelrywall_amuletcake", {visible = 1} );
  ObjSet( "anm_jewelrywall_anm", {animfunc = "use_crown1_end", frame = 0 } );
end;
private.get_amuletcake_end = function()
  ObjDelete("spr_jewelryshop_cake")
  if common_impl.ZzCompleteCheck("get_amuletcake") then ObjSet( common_impl.hint["get_amuletcake"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletcake", private.get_amuletcake_inv );
cmn.AddSubscriber( "get_amuletcake", private.get_amuletcake_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletcake", private.get_amuletcake_end, private.room_objname );
cmn.AddSubscriber( "get_amuletcake", private.get_amuletcake_logic );
--------------------------------------------------------------------
function public.get_amuletcake()
  cmn.SetEventDone( "get_amuletcake" );
  cmn.CallEventHandler( "get_amuletcake" );
  if common_impl.ZzCompleteCheck("get_amuletcake") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_roundedshowcase *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_latchkey" ] = { type = "use", inv_obj = "inv_latchkey", use_place = "gfx_roundedshowcase_latchkey_zone", room = "rm_jewelryshop", zz = "zz_roundedshowcase", zz_gate = "gzz_jewelryshop_roundedshowcase" };

private.use_latchkey_logic = function()
  ObjSet( "gho_jewelryshop_jewelryho", { visible = 1, input = 1, active = 1 } )

end;
private.use_latchkey_inv = function()
  common_impl.ProcessMultiUseAll("latchkey", "latchkey")
end;
private.use_latchkey_beg = function()
  ObjDelete( "gfx_roundedshowcase_latchkey_zone" );
end;
private.use_latchkey_end = function()
  ObjDelete("spr_jewelryshop_lock")
  ObjDelete("spr_jewelryshop_left_door_closed")
  ObjDelete("spr_jewelryshop_right_door_closed")
  ObjSet( "spr_jewelryshop_left_door_opened", {visible = 1} );
  ObjSet( "spr_jewelryshop_right_door_opened", {visible = 1} );
  ObjSet( "anm_roundedshowcase_anm", {animfunc = "use_latchkey", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_latchkey") then ObjSet( common_impl.hint["use_latchkey"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_latchkey", private.use_latchkey_inv );
cmn.AddSubscriber( "use_latchkey", private.use_latchkey_beg, private.room_objname );
cmn.AddSubscriber( "use_latchkey", private.use_latchkey_end, private.room_objname );
cmn.AddSubscriber( "use_latchkey", private.use_latchkey_logic );
cmn.AddSubscriber( "use_latchkey_inv", private.use_latchkey_inv, private.room_objname );
cmn.AddSubscriber( "use_latchkey_beg", private.use_latchkey_beg, private.room_objname );
cmn.AddSubscriber( "use_latchkey_end", private.use_latchkey_end, private.room_objname );
cmn.AddSubscriber( "use_latchkey_end", private.use_latchkey_logic );
--------------------------------------------------------------------------------------------
function public.use_latchkey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_latchkey" );
    cmn.CallEventHandler( "use_latchkey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_latchkey") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_latchkey_inv" );
  cmn.CallEventHandler( "use_latchkey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_roundedshowcase_anm", "use_latchkey", func_end );
  SoundSfx( "aud_use_latchkey_roundedshowcase" )
  

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_jewelryho_for_jewelryshop = function()
    if ld.CheckRequirements( {"win_jewelryho"} ) then
      ObjSet( "gho_jewelryshop_jewelryho", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_jewelryho", win_jewelryho_for_jewelryshop, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_jewelryshop();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_jewelryshop_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_roundedshowcase" );
  function zz_roundedshowcase.Open()
  end;
  function zz_roundedshowcase.PreOpen()
  end;
  function zz_roundedshowcase.PreClose()
  end;
  function zz_roundedshowcase.Close()
  end;

  subroom.Define( "zz_jewelrywall" );
  function zz_jewelrywall.Open()
  end;
  function zz_jewelrywall.PreOpen()
  end;
  function zz_jewelrywall.PreClose()
  end;
  function zz_jewelrywall.Close()
  end;

  subroom.Define( "zz_jewelryshowcase" );
  function zz_jewelryshowcase.Open()
    if ( not private.zz_jewelryshowcase_first_open ) and ( not ld.CheckRequirements( { "get_puzzle1" } ) ) then
      ld.ShowBbt( "zz_jewelryshowcase_first_open" )
      private.zz_jewelryshowcase_first_open = true;
    end
  end;
  function zz_jewelryshowcase.PreOpen()
  end;
  function zz_jewelryshowcase.PreClose()
  end;
  function zz_jewelryshowcase.Close()
  end;
  
end;
--*********************************************************************************************************************