-- name=ho_painthoext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "painthoext" );
  game.relations[ "ho_painthoext" ].exitroom = "rm_corridorext";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_painthoext" ] = { type = "win", room = "rm_corridorext", zz = "ho_painthoext", zz_gate = "gho_corridorext_painthoext" };
 
  local win_painthoext_func = function ()

    if ( cmn.IsEventDone( "win_painthoext" ) ) then
      interface.InventoryItemAdd( "inv_mistletoeext", "spr_painthoext_win", level_inv.ProcessGetMistletoeextAll( "win_painthoext" ) );
      ObjDelete( "gho_corridorext_painthoext" );
    end;

  end;
  cmn.AddSubscriber( "win_painthoext", win_painthoext_func );
  
  local start_painthoext_func = function ()
  if not cmn.IsEventDone("win_painthoext") then
    common_impl.ProcessHoStart( "painthoext" );
    
    
    local ho_found = ng_global.progress[ "ext" ][ "win_painthoext" ].found;
    for i = 1, #ho_found do
      local name = common.GetObjectName( ho_found[ i ].item );
      ObjSet( "spr_"..name, { input = false} );
      if ObjGet("spr_"..name.."_sh") then
        ObjDelete("spr_"..name.."_sh")
      end
    end;
    
    
  end
  end;
  cmn.AddSubscriber( "win_painthoext", start_painthoext_func, "ho_painthoext" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_secondfloor_env" )
  if ( not cmn.IsEventDone( "opn_painthoext" ) ) then
    cmn.InitHo( "painthoext" );
    cmn.SetEventDone( "opn_painthoext" );
  end;
  local ho_items = {};
  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_painthoext_aaa"}); --1
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_painthoext_bbb"}); --2
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_painthoext_ccc"}); --3
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_painthoext_ddd"}); --4
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_painthoext_eee"}); --5
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_painthoext_fff"}); --6
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_painthoext_ggg"}); --7
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_painthoext_hhh"}); --8
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_painthoext_iii"}); --9
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_painthoext_jjj"}); --10
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_painthoext_kkk"}); --11
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_painthoext_lll"}); --12
  SoundHoTheme( true );
  interface.ItemPanelShow( ho_items );
  
end;
--*********************************************************************************************************************
function public.PreClose()
  SoundHoTheme( false );
  interface.ItemPanelHide();
end;
--*********************************************************************************************************************
function public.HoComplete()
  common_impl.DialogHo_Show() 
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.TaskComplete( task_name )
  cmn.HoItemFind("spr_painthoext_"..task_name,"itm_painthoext_"..task_name);
  if ObjGet("spr_painthoext_"..task_name.."_sh") then
    ObjDelete("spr_painthoext_"..task_name.."_sh");
  end
end;
---------------------------------------------------------------------------------------------
function private.GetItem( name )
  --ld.PlayAudio("sfx","common/audio/aud_get_item");
end;
----------------------------------------------------------------------------