-- name=ho_pearlsext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "pearlsext" );
  game.relations[ "ho_pearlsext" ].exitroom = "rm_shopext";
  
  private.abc = {};
  private.abc[1]  = "aaa";
  private.abc[2]  = "bbb";
  private.abc[3]  = "ccc";
  private.abc[4]  = "ddd";
  private.abc[5]  = "eee";
  private.abc[6]  = "fff";
  private.abc[7]  = "ggg";
  private.abc[8]  = "hhh";
  private.abc[9]  = "iii";
  private.abc[10] = "jjj";
  private.abc[11] = "kkk";
  private.abc[12] = "lll";
  
  private.abc2num = {};
  private.abc2num["aaa"]  = 1;
  private.abc2num["bbb"]  = 2;
  private.abc2num["ccc"]  = 3;
  private.abc2num["ddd"]  = 4;
  private.abc2num["eee"]  = 5;
  private.abc2num["fff"]  = 6;
  private.abc2num["ggg"]  = 7;
  private.abc2num["hhh"]  = 8;
  private.abc2num["iii"]  = 9;
  private.abc2num["jjj"] = 10;
  private.abc2num["kkk"] = 11;
  private.abc2num["lll"] = 12;
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_pearlsext" ] = { type = "win", room = "rm_shopext", zz = "ho_pearlsext", zz_gate = "gho_shopext_pearlsext" };
 
  local win_pearlsext_func = function ()

    if ( cmn.IsEventDone( "win_pearlsext" ) ) then
      interface.InventoryItemAdd( "inv_necklaceext", "spr_pearlsext_win" );
      ObjDelete( "gho_shopext_pearlsext" );
    end;

  end;
  cmn.AddSubscriber( "win_pearlsext", win_pearlsext_func );
  
  local start_pearlsext_func = function ()
  if not cmn.IsEventDone("win_pearlsext") then
  
  end
  end;
  cmn.AddSubscriber( "win_pearlsext", start_pearlsext_func, "ho_pearlsext" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  int_taskpanel_impl.SetTaskDoneSpecial("_pearl");
  
  SoundEnv( "aud_shop_env" )
  if ( not cmn.IsEventDone( "opn_pearlsext" ) ) then
    
    ng_global.progress["ext"]["win_pearlsext"].state = {};
    for n=1,#private.abc do
      ng_global.progress["ext"]["win_pearlsext"].state[ private.abc[n] ] = 0;
    end
    --ng_global.progress["ext"]["win_pearlsext"].state["unmark_fff"] = 1;
    cmn.InitHo( "pearlsext" );
    cmn.SetEventDone( "opn_pearlsext" );
  end;
  local ho_items = {};
  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_pearlsext_aaa" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_pearlsext_bbb" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_pearlsext_ccc" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_pearlsext_ddd" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_pearlsext_eee" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_pearlsext_fff" } } );
  interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_pearlsext_ggg" } } );
  interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_pearlsext_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_pearlsext_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_pearlsext_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_pearlsext_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_pearlsext_lll" } } );
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );
  --for j = 1, #ng_global.progress["ext"]["win_pearlsext"].found do
    --local name = tostring( ng_global.progress["ext"]["win_pearlsext"].found[j]["object"] );
    --ObjDelete( name );
  --end;
  
  for n=1,#private.abc do
    local obj = "spr_pearlsext_"..private.abc[n];
    local pearl = "spr_pearlsext_pearl_"..n;
    ObjSet(obj,  {event_mdown = function() private.objClick(private.abc[n]); end});
    ObjSet(pearl,
    {
        event_mdown = function() private.pearlClick(private.abc[n]); end;
        inputrect_init=true;
        inputrect_w = 50;
        inputrect_h = 50;
        inputrect_x = -25;
        inputrect_y = -25;
    });
  end
  
  for n=1,#private.abc do
    local obj = "spr_pearlsext_"..private.abc[n];
    local pearl = "spr_pearlsext_pearl_"..n;
    local pearlSet = "spr_pearlsext_"..n;
    local pearlSetSh = pearlSet.."_sh"
    
    if ng_global.progress["ext"]["win_pearlsext"].state[ private.abc[n] ] == 1 then
      ObjDelete( obj );
      ObjSet(pearl,{input=1})
      --ObjSet( "txt_int_taskpanel_task_"..n,{ param3 = StringGet("tsk_pearlsext_open") });
      private.setNewTask(n)
    end
    if ng_global.progress["ext"]["win_pearlsext"].state[ private.abc[n] ] == 2 then
      ObjDelete( obj );
      ObjDelete( pearl );
      ObjDelete(pearl.."_sh");
      ObjSet(pearlSet,{alp=1})
      ObjSet(pearlSetSh,{alp=1})
      --ObjSet( "txt_int_taskpanel_task_"..n,{ param3 = StringGet("tsk_pearlsext_open") });
      private.setNewTask(n)
    end
  end
  
  if ng_global.progress["ext"]["win_pearlsext"].state[ "fff" ] >= 1 then
    ObjDelete("anm_pearlsext_anim_fff")
  end
  
  --if ng_global.progress["ext"]["win_pearlsext"].state["unmark_fff"] == 1
  -- and ng_global.progress["ext"]["win_pearlsext"].state[ "fff" ] == 0
  --  then
  --  private.MarkTaskAnim( private.abc2num["fff"] )
  --end
  --if   ng_global.progress["ext"]["win_pearlsext"].state["unmark_fff"] == 0
  -- and ng_global.progress["ext"]["win_pearlsext"].state[ "fff" ] == 0
  --  then
  --  private.UnmarkTaskAnim( private.abc2num["fff"] )
  --end
  
end;
--*********************************************************************************************************************
function public.PreClose()

  SoundHoTheme( false );
  interface.TaskPanelHide();

end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  ObjSet( "spr_pearlsext_"..task_name, { pos_z = 1 } );
  cmn.HoTaskFind( "spr_pearlsext_"..task_name, task_name );
  private.setNewTask(private.abc2num[task_name])
end;
---------------------------------------------------------------------------------------------
-----------------------------------------------
function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;
----------------------------------------------------------------------------

--******************************************************************************
function private.objClick(key)
  ld.Lock(1);
  local t = 0.4;
  local obj = "spr_pearlsext_"..key;
  local pearl = "spr_pearlsext_pearl_"..private.abc2num[key];
  local func_end = function()
    
    --ObjSet( "txt_int_taskpanel_task_"..private.abc2num[key],{ param3 = StringGet("tsk_pearlsext_open") });
    private.setNewTask(private.abc2num[key])
    ng_global.progress["ext"]["win_pearlsext"].state[ key ] = 1;
    ObjSet(obj,{input=0,visible=0, pos_x=-1111,pos_y=-1111})
    ObjSet(pearl,{input=1});
    ld.Lock(0);
  end
  
  if key ~= "fff" then
    SoundSfx("aud_get_ho");
    private.sparkle(obj);
    ObjAnimate(obj, 8, 0, 0, func_end, {0,0,1, t,0,0});
  else
    SoundSfx( "aud_clk_plane" )
    ld.AnimPlay("anm_pearlsext_anim_fff","anim_fff",func_end);
  end
end
--******************************************************************************
function private.pearlClick(key)
  local pearl = "spr_pearlsext_pearl_"..private.abc2num[key];
  local pearlSet = "spr_pearlsext_"..private.abc2num[key];
  local pearlSetSh = pearlSet.."_sh"
  local t1 = 0.3;
  private.sparkle(pearl);
  local func_end = function()  
    
    ObjSet(pearl,{input=0,visible=0,alp=0})
    ObjSet(pearlSet,{alp=1,visible=1})
    ObjSet(pearlSetSh,{alp=1,visible=1})
    
    local founded = 0;
    for n=1,#private.abc do
      if ng_global.progress["ext"]["win_pearlsext"].state[ private.abc[n] ] == 2 then
        founded=founded+1;
      end
    end
    
    local func_end = function()
      private.TaskComplete( key );
      ng_global.progress["ext"]["win_pearlsext"].state[ key ] = 2;
      ld.Lock(0)
    end
    
    
    if founded<11 then
      func_end();
    else
      local t = 1;
      for n=1,#private.abc do
        local pearlSet_n = "spr_pearlsext_"..n;
        ObjAnimate(pearlSet_n, 8, 0, 0, _, {0,0,1,  t,0,0});
        ObjAnimate(pearlSet_n.."_sh", 8, 0, 0, _, {0,0,1,  t,0,0});
      end
      ObjAnimate("spr_pearlsext_necklace",        8, 0, 0, _,         {0,0,1,  t,0,0});
      ObjAnimate("spr_pearlsext_necklace_shadow", 8, 0, 0, func_end,  {0,0,1,  t,0,0});
    end
    
  end
  SoundSfx( "aud_clk_ho_2" )
  ObjDelete(pearl.."_sh");
  ObjSet(pearl,{pos_z=50})
  ObjAnimate(pearl,     3,0,0, func_end, {0,0,ObjGet(pearl).pos_x,ObjGet(pearl).pos_y,   t1,0,ObjGet(pearlSet).pos_x,ObjGet(pearlSet).pos_y});
  ObjAnimate(pearlSet,  8,0,0, _,        {0,0,0,  t1*0.75,0,0,  t1,0,1});
  ObjAnimate(pearlSetSh,8,0,0, _,        {0,0,0,  t1*0.75,0,0,  t1,0,1});
  ObjAnimate(pearl,     8,0,0, _,        {0,0,1,  t1*0.75,0,1,  t1,0,0});
  ld.Lock(1);
end
-- simple effect from HO -------------------------------------------------------
function private.sparkle(object_name)
  local collect_name  = "pfx_int_taskpanel_collect_"..object_name;
  ObjDelete( collect_name );
  ObjCreate( collect_name, "partsys" );
  
  ObjSet( collect_name,{
    res = "assets/interface/resources/effects_ho",
    pos_x = 0, pos_y = 0,
    active = 1, visible = 1, input = 0, pos_z = 42, blendmode = 2;
  });
  local parent = ObjGetRelations(object_name).parent
  ObjAttach( collect_name, parent );
  PartSysSetMaskObj( collect_name, object_name );  
  ld.StartTimer( 5, function() ObjDelete( collect_name ) end )
end
-- simple effect from HO -------------------------------------------------------

function private.setNewTask(n)
  local name = "txt_int_taskpanel_task_"..n; 
  ObjSet( name,{ param3 = StringGet("tsk_pearlsext_open"); });
end





---------------------------------------------------------------------------
function private.HintShow(hint_obj_name)
  local hints_table = { hint = {} };
  table.insert( hints_table.hint,  { ["pos_x"]=ObjGet(hint_obj_name).pos_x, ["pos_y"]=ObjGet(hint_obj_name).pos_y, ["obj_name"]=hint_obj_name } )   
  MsgSend( Command_Effect_ShowHoHint, hints_table );
end
----------------------------------------------------------------------------
function public.clk_hint()
  local n = math.random(1,#private.abc);
  local doit = true;
  while doit do
    local key = private.abc[n]
    local obj = "spr_pearlsext_"..key;
    local pearl = "spr_pearlsext_pearl_"..n;
    
    if ng_global.progress["ext"]["win_pearlsext"].state[ key ]==0 then
      private.HintShow(obj)
      doit=false;
      break;
    end
    if ng_global.progress["ext"]["win_pearlsext"].state[ key ]==1 then
      private.HintShow(pearl)
      doit=false;
      break;
    end
    n=n+1;
    if n>#private.abc then
      n=1;
    end
  end
end
----------------------------------------------------------------------------