-- name=levelext

function public.Start ( param )

  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 13 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 11 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 9 );

  interface.WidgetAdd( InterfaceWidget_Effects );



  interface.WidgetAdd( InterfaceWidget_DialogHo,30 );

  interface.ButtonLockAdd();
  interface.LockAdd();

  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  interface.WidgetAdd( InterfaceWidget_ItemPanel,9 );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog,30 );

  interface.WidgetAdd( InterfaceWidget_DialogVideo,30 );
  interface.WidgetAdd( InterfaceWidget_DialogStory,30 );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 30 );

  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial,30 );

  interface.WidgetAdd( InterfaceWidget_Map, 16  );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );

  interface.PanelNotificationAdd(10);

  if IsCollectorsEdition() then
    interface.WidgetAdd( InterfaceWidget_StrategyGuide,30 );
    interface.WidgetAdd( InterfaceWidget_BtnGuide, 12 );
  end
  
  --interface.DeployInvAdd(7);
  interface.ComplexInvAdd( 9 )
  interface.DialogHintAdd(20);
  --interface.Btn_DiaryAdd(12)
  --interface.InvestigationButtonAdd( 17 );
  --interface.DiaryAdd( 18 );
  --interface.DiaryDcnAdd( 31 );

  interface.PanelhopairAdd(9)

  interface.ButtonTaskAdd(20)
  interface.DialogTaskAdd(10)

  private.Init();


  ModLoad( "assets/levels/levelext/mod_levelext_inv" );
  levelext_inv.Init()

  private.TutorInit()--тутор
  --

  interface.ArrPuzzles()

  common.LevelLoad( "levelext", "ext", "rm_entrypointext", param );
  --ModLoad( "assets/interface/map/mod_map" );
  interface.ArrInvPlus()  -- проверка состояния плюсика для деплойных инв предметов

  interface.KeyUpdate();

  --временно залочена кнопка SG
  interface.WidgetSetInput(InterfaceWidget_BtnGuide, 1)

  ObjSet( "txt_int_dialog_character", {param0 = GetCurrentProfile()} );
  --автоподствновка имени игрока в диалоги

  interface.CheckPuzzles()
  interface.CheckMorphing()



end;

function public.MapAdd() 
  interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );
end
function public.SimonAdd() -- get_simon
  interface.SimonAdd(14);
  int_simon.LoadAnotherPrg();
end

function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_entrypointext"

--[[AUTO]]  ,"rm_corridorext"
--[[AUTO]]  ,"ho_painthoext"
--[[AUTO]]  ,"rm_dressingroomext"
--[[AUTO]]  ,"mg_laceext"
--[[AUTO]]  ,"ho_portalext"
--[[AUTO]]  ,"rm_nearshopext"
--[[AUTO]]  ,"rm_shopext"
--[[AUTO]]  ,"ho_pearlsext"
--[[AUTO]]  ,"mg_onboxext"
--[[AUTO]]  ,"rm_nearcastleext"
--[[AUTO]]  ,"mg_yardext"
--[[AUTO]]  ,"rm_hallext"
--[[AUTO]]  ,"rm_seconfloorext"
--[[AUTO]]  ,"ho_prizesext"
--[[AUTO]]  ,"mg_fightext"
  };

  game.progress_names =
  {
     "opn_entrypointext"


--[[AUTO]]  ,"dlg_entrypointext_fairyext1"
--[[AUTO]]  ,"get_fairyext"
--[[AUTO]]  ,"clk_viddressext"
--[[AUTO]]  ,"get_snowmanpyramidext"
--[[AUTO]]  ,"get_screwdriverhandleext"
--[[AUTO]]  ,"get_mulledwineext"
--[[AUTO]]  ,"get_snowmanbodyext"
--[[AUTO]]  ,"get_snowmanheadext"
--[[AUTO]]  ,"use_snowmanbodyext"
--[[AUTO]]  ,"use_snowmanheadext"
--[[AUTO]]  ,"get_snowmanext"
--[[AUTO]]  ,"use_snowmanext"
--[[AUTO]]  ,"opn_corridorext"
--[[AUTO]]  ,"get_sunrayext"
--[[AUTO]]  ,"get_candleext"
--[[AUTO]]  ,"get_mistletoeext1"
--[[AUTO]]  ,"use_sunrayext"
--[[AUTO]]  ,"win_worktableext"
--[[AUTO]]  ,"get_mousefigureext1"
--[[AUTO]]  ,"get_matchesext"
--[[AUTO]]  ,"use_matchesext"
--[[AUTO]]  ,"get_firedcandleext"
--[[AUTO]]  ,"use_firedcandleext"
--[[AUTO]]  ,"opn_painthoext"
--[[AUTO]]  ,"win_painthoext"
--[[AUTO]]  ,"use_mistletoeext"
--[[AUTO]]  ,"opn_dressingroomext"
--[[AUTO]]  ,"use_screwdriverhandleext"
--[[AUTO]]  ,"get_screwdriverext"
--[[AUTO]]  ,"get_coloredglassext1"
--[[AUTO]]  ,"get_coloredglassext2"
--[[AUTO]]  ,"dlg_dressingroomext_fairyext2"
--[[AUTO]]  ,"get_amuletthreadsext"
--[[AUTO]]  ,"use_amuletthreadsext"
--[[AUTO]]  ,"get_brokenscissorsext"
--[[AUTO]]  ,"get_coloredglassext3"
--[[AUTO]]  ,"use_screwdriverext_mirrorext"
--[[AUTO]]  ,"get_boltext"
--[[AUTO]]  ,"get_plasticineext"
--[[AUTO]]  ,"get_mousefigureext2"
--[[AUTO]]  ,"use_mousefigureext1"
--[[AUTO]]  ,"use_mousefigureext2"
--[[AUTO]]  ,"get_coloredglassext4"
--[[AUTO]]  ,"use_coloredglassext"
--[[AUTO]]  ,"win_mirrorext"
--[[AUTO]]  ,"get_scissorspartext"
--[[AUTO]]  ,"get_deerhornsext"
--[[AUTO]]  ,"use_scissorspartext"
--[[AUTO]]  ,"use_boltext"
--[[AUTO]]  ,"use_screwdriverext_brokenscissorsext"
--[[AUTO]]  ,"use_fairyext_brokenscissorsext"
--[[AUTO]]  ,"get_fairywithscissorsext"
--[[AUTO]]  ,"use_fairywithscissorsext"
--[[AUTO]]  ,"win_laceext"
--[[AUTO]]  ,"get_dresslaceext"
--[[AUTO]]  ,"use_dresslaceext"
--[[AUTO]]  ,"get_ovenhandleext"
--[[AUTO]]  ,"use_ovenhandleext"
--[[AUTO]]  ,"clk_ovenext"
--[[AUTO]]  ,"get_emberext"
--[[AUTO]]  ,"get_cogext1"
--[[AUTO]]  ,"use_emberext"
--[[AUTO]]  ,"win_sofaext"
--[[AUTO]]  ,"get_sockext"
--[[AUTO]]  ,"get_medalioncatext"
--[[AUTO]]  ,"use_medalioncatext"
--[[AUTO]]  ,"get_tweezersext"
--[[AUTO]]  ,"get_giftgunext"
--[[AUTO]]  ,"get_towelext"
--[[AUTO]]  ,"use_tweezersext"
--[[AUTO]]  ,"get_bowext"
--[[AUTO]]  ,"get_cogext2"
--[[AUTO]]  ,"use_giftgunext"
--[[AUTO]]  ,"use_bowext"
--[[AUTO]]  ,"get_giftsockext"
--[[AUTO]]  ,"use_giftsockext"
--[[AUTO]]  ,"win_flowerstableext"
--[[AUTO]]  ,"get_acornext1"
--[[AUTO]]  ,"get_potholderext"
--[[AUTO]]  ,"get_cogext3"
--[[AUTO]]  ,"use_cogext"
--[[AUTO]]  ,"clk_cogext"
--[[AUTO]]  ,"get_coinext1"
--[[AUTO]]  ,"get_needleandcottonext"
--[[AUTO]]  ,"use_needleandcottonext"
--[[AUTO]]  ,"get_christmasspotholderext"
--[[AUTO]]  ,"use_mulledwineext"
--[[AUTO]]  ,"use_christmasspotholderext"
--[[AUTO]]  ,"get_hotmulledwineext"
--[[AUTO]]  ,"use_hotmulledwineext"
--[[AUTO]]  ,"use_towelext"
--[[AUTO]]  ,"get_catandmouseext"
--[[AUTO]]  ,"use_catandmouseext"
--[[AUTO]]  ,"get_cinderellastaffext"
--[[AUTO]]  ,"get_mouseext"
--[[AUTO]]  ,"dlg_entrypointext_fairyext3"
--[[AUTO]]  ,"opn_portalext"
--[[AUTO]]  ,"win_portalext"
--[[AUTO]]  ,"opn_nearshopext"
--[[AUTO]]  ,"clk_shopdoorext"
--[[AUTO]]  ,"get_amuletmittenext"
--[[AUTO]]  ,"get_acornext2"
--[[AUTO]]  ,"use_amuletmittenext"
--[[AUTO]]  ,"get_lockpickext"
--[[AUTO]]  ,"get_towerext"
--[[AUTO]]  ,"use_lockpickext"
--[[AUTO]]  ,"win_wardrobeext1"
--[[AUTO]]  ,"get_skiext"
--[[AUTO]]  ,"get_piniatabatext"
--[[AUTO]]  ,"use_piniatabatext"
--[[AUTO]]  ,"clk_shopdoorext1"
--[[AUTO]]  ,"clk_shopdoorext2"
--[[AUTO]]  ,"clk_shopdoorext3"
--[[AUTO]]  ,"clk_shopdoorext4"
--[[AUTO]]  ,"opn_shopext"
--[[AUTO]]  ,"get_instructionext"
--[[AUTO]]  ,"get_penguinext"
--[[AUTO]]  ,"get_towerroofext"
--[[AUTO]]  ,"use_towerroofext"
--[[AUTO]]  ,"get_acornext3"
--[[AUTO]]  ,"get_bunnyext"
--[[AUTO]]  ,"get_glasstowerext"
--[[AUTO]]  ,"use_glasstowerext"
--[[AUTO]]  ,"get_tiaraext"
--[[AUTO]]  ,"get_bearext"
--[[AUTO]]  ,"use_bearext"
--[[AUTO]]  ,"use_penguinext"
--[[AUTO]]  ,"use_bunnyext"
--[[AUTO]]  ,"win_wardrobeext2"
--[[AUTO]]  ,"get_toothpicksext"
--[[AUTO]]  ,"get_snowmaidenext2"
--[[AUTO]]  ,"use_acornext"
--[[AUTO]]  ,"use_deerhornsext"
--[[AUTO]]  ,"use_plasticineext"
--[[AUTO]]  ,"use_toothpicksext"
--[[AUTO]]  ,"clk_instructionext1"
--[[AUTO]]  ,"get_deerext"
--[[AUTO]]  ,"use_deerext"
--[[AUTO]]  ,"get_goldenkeyext"
--[[AUTO]]  --,"get_scallopext"
--[[AUTO]]  ,"use_goldenkeyext"
--[[AUTO]]  ,"get_crystalshoesext"
--[[AUTO]]  ,"clk_shoeext"
--[[AUTO]]  ,"opn_pearlsext"
--[[AUTO]]  ,"win_pearlsext"
--[[AUTO]]  ,"use_necklaceext"
--[[AUTO]]  --,"use_scallopext"
--[[AUTO]]  ,"use_crystalshoesext"
--[[AUTO]]  ,"use_tiaraext"
--[[AUTO]]  ,"get_cinderellasetext"
--[[AUTO]]  ,"use_cinderellasetext"
--[[AUTO]]  ,"get_cinderellabagext"
--[[AUTO]]  ,"dlg_shopext_fairyext4"
--[[AUTO]]  ,"clk_cinderellabagext"
--[[AUTO]]  ,"get_medalionpawext"
--[[AUTO]]  ,"clk_invitationext"
--[[AUTO]]  ,"get_invitationext"
--[[AUTO]]  ,"get_screwext1"
--[[AUTO]]  ,"use_medalionpawext"
--[[AUTO]]  ,"get_wrenchext"
--[[AUTO]]  ,"get_flagext"
--[[AUTO]]  ,"use_flagext"
--[[AUTO]]  ,"get_tangleext"
--[[AUTO]]  ,"use_fairyext_tangleext"
--[[AUTO]]  ,"get_fairyclewext"
--[[AUTO]]  ,"clk_pantrydoorext"
--[[AUTO]]  ,"use_fairyclewext"
--[[AUTO]]  ,"get_snowmaidenext3"
--[[AUTO]]  ,"get_screwext2"
--[[AUTO]]  ,"use_snowmaidenext1"
--[[AUTO]]  ,"use_snowmaidenext2"
--[[AUTO]]  ,"use_snowmaidenext3"
--[[AUTO]]  ,"win_onboxext"
--[[AUTO]]  ,"clk_note_1"
--[[AUTO]]  ,"clk_note_2"
--[[AUTO]]  ,"get_dustext"
--[[AUTO]]  ,"use_skiext"
--[[AUTO]]  ,"use_screwext"
--[[AUTO]]  ,"use_wrenchext_brokensleighext"
--[[AUTO]]  ,"use_mouseext"
--[[AUTO]]  ,"use_dustext"
--[[AUTO]]  ,"opn_nearcastleext"
--[[AUTO]]  ,"use_invitationext"
--[[AUTO]]  ,"get_jarext"
--[[AUTO]]  ,"get_toysmithsext"
--[[AUTO]]  ,"get_coinext2"
--[[AUTO]]  ,"use_wrenchext_lucext"
--[[AUTO]]  ,"get_coinext3"
--[[AUTO]]  ,"get_hairstickext"
--[[AUTO]]  ,"use_hairstickext_icesculptureext"
--[[AUTO]]  ,"get_coinext4"
--[[AUTO]]  ,"use_coinext"
--[[AUTO]]  ,"clk_coinext"
--[[AUTO]]  ,"get_valerianext"
--[[AUTO]]  ,"clk_jacrclick"
--[[AUTO]]  ,"use_valerianext"
--[[AUTO]]  ,"get_valerianjarext"
--[[AUTO]]  ,"use_valerianjarext"
--[[AUTO]]  ,"get_unloadedcrossbowext"
--[[AUTO]]  ,"clk_guardiankeyext"
--[[AUTO]]  ,"win_yardext"
--[[AUTO]]  ,"opn_hallext"
--[[AUTO]]  ,"get_rewardext"
--[[AUTO]]  ,"get_ribbonext"
--[[AUTO]]  ,"get_maskext"
--[[AUTO]]  ,"clk_maskext1"
--[[AUTO]]  ,"use_ribbonext"
--[[AUTO]]  ,"use_hairstickext_maskext"
--[[AUTO]]  ,"get_pearlflowerext"
--[[AUTO]]  ,"clk_maskext2"
--[[AUTO]]  ,"clk_maskext3"
--[[AUTO]]  ,"clk_maskext4"
--[[AUTO]]  ,"clk_maskext5"
--[[AUTO]]  ,"get_fishingrodext"
--[[AUTO]]  ,"use_fishingrodext"
--[[AUTO]]  ,"get_brokenshacksawext"
--[[AUTO]]  ,"use_rewardext"
--[[AUTO]]  ,"get_sawhandleext"
--[[AUTO]]  ,"get_cupidext1"
--[[AUTO]]  ,"use_sawhandleext"
--[[AUTO]]  ,"use_toysmithsext"
--[[AUTO]]  ,"get_sawext"
--[[AUTO]]  ,"use_sawext"
--[[AUTO]]  ,"opn_seconfloorext"
--[[AUTO]]  ,"get_fishinglineext"
--[[AUTO]]  ,"get_quiverext"
--[[AUTO]]  ,"use_fishinglineext"
--[[AUTO]]  ,"use_quiverext"
--[[AUTO]]  ,"get_crossbowext"
--[[AUTO]]  ,"use_crossbowext"
--[[AUTO]]  ,"opn_prizesext"
--[[AUTO]]  ,"win_prizesext"
--[[AUTO]]  ,"use_cupidext1"
--[[AUTO]]  ,"use_cupidext2"
--[[AUTO]]  ,"get_amuletarcherext"
--[[AUTO]]  ,"get_emeraldflowerext"
--[[AUTO]]  ,"use_amuletarcherext"
--[[AUTO]]  ,"get_santacatext"
--[[AUTO]]  ,"get_crystalflowerext"
--[[AUTO]]  ,"use_crystalflowerext"
--[[AUTO]]  ,"use_emeraldflowerext"
--[[AUTO]]  ,"use_pearlflowerext"
--[[AUTO]]  ,"get_elfcatext"
--[[AUTO]]  ,"get_cubeext1"
--[[AUTO]]  ,"use_santacatext"
--[[AUTO]]  ,"use_elfcatext"
--[[AUTO]]  ,"get_cubeext2"
--[[AUTO]]  ,"use_cubeext"
--[[AUTO]]  ,"win_tobalconyext"
--[[AUTO]]  ,"use_fairyext_fightext"
--[[AUTO]]  ,"win_fightext"
--[[AUTO]]  ,"clk_outroext"

  };
  game.relations = {};

-- по завершению указанного прогресса запускается/устанавливается таск
-- { "prg_beg", "prg_false" } - при необходимости работы таска в промежутке между прогрессами
--                              после выполнения "prg_false" таск будет выключен, до следующих указанных прогрессов
game.level_tasks = {
--[[01]]  "dlg_entrypointext_fairyext1";
--[[02]]  "dlg_dressingroomext_fairyext2";
--[[03]]  { "use_dresslaceext", "use_towelext" };
--[[04]]  "use_catandmouseext";
--[[05]]  "get_crystalshoesext";--"dlg_shopext_fairyext4";
--[[06]]  "opn_nearcastleext";
--[[07]]  "opn_seconfloorext";
--[[08]]  "win_tobalconyext";
};
end;

function Test ()

  local profiles = GetProfileList();

  local cheater = false;

  for i = 1, #profiles, 1 do

    if ( profiles[ i ] == "CHEATER" ) then

      cheater = true;

    end;

  end;

  AddProfile( "CHEATER" );
  SetCurrentProfile( "CHEATER" );

  if ( not cheater ) then

    ng_global.gamemode = 0;
    ng_global.currentprogress = "std";
    ng_global.progress = {};
    ng_global.progress[ "std" ] = {};
    ng_global.progress[ "std" ].common = {};
    ng_global.progress[ "std" ].common.hinttimer = 0;

    SaveProfiles();

  end;

end;


--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------tutorial----------------------------------------------

function private.TutorInit()


end