-- name=rm_corridorext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_corridorext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_corridorext()
  if not ( cmn.IsEventDone( "opn_corridorext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_corridorext" );
      cmn.CallEventHandler( "opn_corridorext" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
      --private.test() 
end;

function private.test() 
  local max = 15
  local t = 1
  if not ObjGet("lalala1") then
    local r = 200
    local x,y = 512,384
    local ang = 2*math.pi/max
    for i = 1,max do
      local angle = -ang*(i-1)
      ld.CopyObj("spr_corridorext_cogwheels_clone", "lalala"..i, nil, "rm_corridorext")
      ObjSet( "lalala"..i, {pos_x = x+r*math.sin(angle), pos_y = y+r*math.cos(angle)} );
    end
  end
  local table = ld.Anim.Liquid(t,max,1,0,0.9 )
  local scale = ld.Anim.Liquid(t,max,1,1.2,0.95 )
  for i = 1,max do
    ObjAnimate( "lalala"..i, 8, 0, 0, function() end, table[i] );
    ObjAnimate( "lalala"..i, 4, 0, 0, function() end, scale[i] );
    ObjAnimate( "lalala"..i, 5, 0, 0, function() end, scale[i] );
  end
  ld.StartTimer( t, function() private.test()  end )
end

--------------------------------------------------------------------
local opn_corridorext = function() end;
local opn_corridorext_logic = function() end;
cmn.AddSubscriber( "opn_corridorext", opn_corridorext_logic )
cmn.AddSubscriber( "opn_corridorext", opn_corridorext, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_dressingroomdoorext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_sunrayext" ] = { type = "get", get_obj = "spr_dressingroomdoorext_sunrayext", room = "rm_corridorext", zz = "zz_dressingroomdoorext", zz_gate = "gzz_corridorext_dressingroomdoorext" };

private.get_sunrayext_logic = function()
  
end;
private.get_sunrayext_inv = function()
  interface.InventoryItemAdd("inv_sunrayext","spr_dressingroomdoorext_sunrayext");
end;
private.get_sunrayext_beg = function()
  ObjDelete("gfx_dressingroomdoorext_sunrayext")
end;
private.get_sunrayext_end = function()
  ObjDelete("spr_corridorext_sunray")
  if common_impl.ZzCompleteCheck("get_sunrayext") then ObjSet( common_impl.hint["get_sunrayext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_sunrayext", private.get_sunrayext_inv );
cmn.AddSubscriber( "get_sunrayext", private.get_sunrayext_beg, private.room_objname );
cmn.AddSubscriber( "get_sunrayext", private.get_sunrayext_end, private.room_objname );
cmn.AddSubscriber( "get_sunrayext", private.get_sunrayext_logic );
--------------------------------------------------------------------
function public.get_sunrayext()
  cmn.SetEventDone( "get_sunrayext" );
  cmn.CallEventHandler( "get_sunrayext" );
  if common_impl.ZzCompleteCheck("get_sunrayext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mistletoeext" ] = { type = "use", inv_obj = "inv_mistletoeext", use_place = "gfx_dressingroomdoorext_mistletoeext_zone", room = "rm_corridorext", zz = "zz_dressingroomdoorext", zz_gate = "gzz_corridorext_dressingroomdoorext" };

private.use_mistletoeext_logic = function()
  ObjSet( "grm_corridorext_dressingroomext", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_corridorext_dressingroomext_focus");
    end;

end;
private.use_mistletoeext_inv = function()
  common_impl.ProcessMultiUseAll("mistletoeext", "mistletoeext")
end;
private.use_mistletoeext_beg = function()
  ObjDelete( "gfx_dressingroomdoorext_mistletoeext_zone" );
end;
private.use_mistletoeext_end = function()
  --ObjSet( "spr_corridorext_mistletoe", {visible = 1} );
  --ObjSet( "spr_corridorext_light_open_doordress", {visible = 1} );
  ObjSet( "anm_dressingroomdoorext_zz_dressingroomdoorext", {animfunc = "open_door", frame = 999 } );
  ObjSet( "anm_corridorext_rm_corridorext_open_door", {animfunc = "open_door", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_mistletoeext") then ObjSet( common_impl.hint["use_mistletoeext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mistletoeext", private.use_mistletoeext_inv );
cmn.AddSubscriber( "use_mistletoeext", private.use_mistletoeext_beg, private.room_objname );
cmn.AddSubscriber( "use_mistletoeext", private.use_mistletoeext_end, private.room_objname );
cmn.AddSubscriber( "use_mistletoeext", private.use_mistletoeext_logic );
cmn.AddSubscriber( "use_mistletoeext_inv", private.use_mistletoeext_inv, private.room_objname );
cmn.AddSubscriber( "use_mistletoeext_beg", private.use_mistletoeext_beg, private.room_objname );
cmn.AddSubscriber( "use_mistletoeext_end", private.use_mistletoeext_end, private.room_objname );
cmn.AddSubscriber( "use_mistletoeext_end", private.use_mistletoeext_logic );
--------------------------------------------------------------------------------------------
function public.use_mistletoeext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mistletoeext" );
    cmn.CallEventHandler( "use_mistletoeext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mistletoeext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mistletoeext_inv" );
  cmn.CallEventHandler( "use_mistletoeext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_dressingroomdoorext_zz_dressingroomdoorext", "use_mistletoe", function() 
    ld.AnimPlay( "anm_dressingroomdoorext_zz_dressingroomdoorext", "open_door", function() 
      ld.CloseSubRoom();
      ld.AnimPlay( "anm_corridorext_rm_corridorext_open_door", "open_door", function() 
        func_end();
      end );
    end );
  end );
  SoundSfx( "aud_use_mistletoeext_corridorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_flowerstableext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_candleext" ] = { type = "get", get_obj = "spr_flowerstableext_candleext", room = "rm_corridorext", zz = "zz_flowerstableext", zz_gate = "gzz_corridorext_flowerstableext" };

private.get_candleext_logic = function()
  
end;
private.get_candleext_inv = function()
  interface.InventoryItemAdd("inv_candleext","spr_flowerstableext_candleext");
  ObjSet( "inv_candleext", { drag = 0 } );
end;
private.get_candleext_beg = function()
  ObjDelete("gfx_flowerstableext_candleext")
end;
private.get_candleext_end = function()
  ObjDelete("spr_flowerstableext_candle_shadow")
  if common_impl.ZzCompleteCheck("get_candleext") then ObjSet( common_impl.hint["get_candleext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_candleext", private.get_candleext_inv );
cmn.AddSubscriber( "get_candleext", private.get_candleext_beg, private.room_objname );
cmn.AddSubscriber( "get_candleext", private.get_candleext_end, private.room_objname );
cmn.AddSubscriber( "get_candleext", private.get_candleext_logic );
--------------------------------------------------------------------
function public.get_candleext()
  cmn.SetEventDone( "get_candleext" );
  cmn.CallEventHandler( "get_candleext" );
  if common_impl.ZzCompleteCheck("get_candleext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletthreadsext" ] = { type = "use", inv_obj = "inv_amuletthreadsext", use_place = "gfx_flowerstableext_amuletthreadsext_zone", room = "rm_corridorext", zz = "zz_flowerstableext", zz_gate = "gzz_corridorext_flowerstableext" };

private.use_amuletthreadsext_logic = function()
  ObjSet( "spr_flowerstableext_brokenscissorsext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_flowerstableext_coloredglassext3", { visible = 1, input = 1, active = 1 } )

end;
private.use_amuletthreadsext_inv = function()
  common_impl.ProcessMultiUseAll("amuletthreadsext", "amuletthreadsext")
end;
private.use_amuletthreadsext_beg = function()
  ObjDelete( "gfx_flowerstableext_amuletthreadsext_zone" );
end;
private.use_amuletthreadsext_end = function()
  ObjSet( "gfx_flowerstableext_brokenscissorsext", { visible = 1, active = 1 } )
  ObjSet( "gfx_flowerstableext_coloredglassext3", { visible = 1, active = 1 } )
  ObjSet( "anm_flowerstableext_zz_flowerstableext", {animfunc = "use_amulet_end", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_amuletthreadsext") then ObjSet( common_impl.hint["use_amuletthreadsext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletthreadsext", private.use_amuletthreadsext_inv );
cmn.AddSubscriber( "use_amuletthreadsext", private.use_amuletthreadsext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletthreadsext", private.use_amuletthreadsext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletthreadsext", private.use_amuletthreadsext_logic );
cmn.AddSubscriber( "use_amuletthreadsext_inv", private.use_amuletthreadsext_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletthreadsext_beg", private.use_amuletthreadsext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletthreadsext_end", private.use_amuletthreadsext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletthreadsext_end", private.use_amuletthreadsext_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletthreadsext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletthreadsext" );
    cmn.CallEventHandler( "use_amuletthreadsext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletthreadsext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletthreadsext_inv" );
  cmn.CallEventHandler( "use_amuletthreadsext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_flowerstableext_zz_flowerstableext", "use_amulet", func_end );
  SoundSfx( "aud_use_amuletthreadsext_corridorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_brokenscissorsext" ] = { type = "get", get_obj = "spr_flowerstableext_brokenscissorsext", room = "rm_corridorext", zz = "zz_flowerstableext", zz_gate = "gzz_corridorext_flowerstableext" };

private.get_brokenscissorsext_logic = function()
  
end;
private.get_brokenscissorsext_inv = function()
  interface.InventoryItemAdd("inv_brokenscissorsext","spr_flowerstableext_brokenscissorsext");
  ObjSet( "inv_brokenscissorsext", { drag = 0 } );
end;
private.get_brokenscissorsext_beg = function()
  ObjDelete("gfx_flowerstableext_brokenscissorsext")
end;
private.get_brokenscissorsext_end = function()
  if common_impl.ZzCompleteCheck("get_brokenscissorsext") then ObjSet( common_impl.hint["get_brokenscissorsext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_brokenscissorsext", private.get_brokenscissorsext_inv );
cmn.AddSubscriber( "get_brokenscissorsext", private.get_brokenscissorsext_beg, private.room_objname );
cmn.AddSubscriber( "get_brokenscissorsext", private.get_brokenscissorsext_end, private.room_objname );
cmn.AddSubscriber( "get_brokenscissorsext", private.get_brokenscissorsext_logic );
--------------------------------------------------------------------
function public.get_brokenscissorsext()
  cmn.SetEventDone( "get_brokenscissorsext" );
  cmn.CallEventHandler( "get_brokenscissorsext" );
  if common_impl.ZzCompleteCheck("get_brokenscissorsext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_coloredglassext3" ] = { type = "get", get_obj = "spr_flowerstableext_coloredglassext3", room = "rm_corridorext", zz = "zz_flowerstableext", zz_gate = "gzz_corridorext_flowerstableext" };

private.get_coloredglassext3_logic = function()
  
end;
private.get_coloredglassext3_inv = function()
  interface.InventoryItemAdd("inv_coloredglassext","spr_flowerstableext_coloredglassext3",function() level_inv.ProcessGetColoredglassextAll( "get_coloredglassext3" ) end);
end;
private.get_coloredglassext3_beg = function()
  ObjDelete("gfx_flowerstableext_coloredglassext3")
end;
private.get_coloredglassext3_end = function()
  if common_impl.ZzCompleteCheck("get_coloredglassext3") then ObjSet( common_impl.hint["get_coloredglassext3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_coloredglassext3", private.get_coloredglassext3_inv );
cmn.AddSubscriber( "get_coloredglassext3", private.get_coloredglassext3_beg, private.room_objname );
cmn.AddSubscriber( "get_coloredglassext3", private.get_coloredglassext3_end, private.room_objname );
cmn.AddSubscriber( "get_coloredglassext3", private.get_coloredglassext3_logic );
--------------------------------------------------------------------
function public.get_coloredglassext3()
  cmn.SetEventDone( "get_coloredglassext3" );
  cmn.CallEventHandler( "get_coloredglassext3" );
  if common_impl.ZzCompleteCheck("get_coloredglassext3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_giftsockext" ] = { type = "use", inv_obj = "inv_giftsockext", use_place = "gfx_flowerstableext_giftsockext_zone", room = "rm_corridorext", zz = "zz_flowerstableext", zz_gate = "gzz_corridorext_flowerstableext" };

private.use_giftsockext_logic = function()
  ObjSet( "gfx_flowerstableext_win_flowerstableext_zone", { visible = 1, input = 1, active = 1 } )
  ld.mmgZoomInit("win_flowerstableext");
end;
private.use_giftsockext_inv = function()
  common_impl.ProcessMultiUseAll("giftsockext", "giftsockext")
end;
private.use_giftsockext_beg = function()
  ObjDelete( "gfx_flowerstableext_giftsockext_zone" );
end;
private.use_giftsockext_end = function()
  ObjSet( "anm_flowerstableext_zz_flowerstableext_wall", {animfunc = "use_sock", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_giftsockext") then ObjSet( common_impl.hint["use_giftsockext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_giftsockext", private.use_giftsockext_inv );
cmn.AddSubscriber( "use_giftsockext", private.use_giftsockext_beg, private.room_objname );
cmn.AddSubscriber( "use_giftsockext", private.use_giftsockext_end, private.room_objname );
cmn.AddSubscriber( "use_giftsockext", private.use_giftsockext_logic );
cmn.AddSubscriber( "use_giftsockext_inv", private.use_giftsockext_inv, private.room_objname );
cmn.AddSubscriber( "use_giftsockext_beg", private.use_giftsockext_beg, private.room_objname );
cmn.AddSubscriber( "use_giftsockext_end", private.use_giftsockext_end, private.room_objname );
cmn.AddSubscriber( "use_giftsockext_end", private.use_giftsockext_logic );
--------------------------------------------------------------------------------------------
function public.use_giftsockext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_giftsockext" );
    cmn.CallEventHandler( "use_giftsockext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_giftsockext") then ld.CloseSubRoom() end;
    public.win_flowerstableext_load()
    ObjGet( "gfx_flowerstableext_win_flowerstableext_zone" ).event_mdown()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_giftsockext_inv" );
  cmn.CallEventHandler( "use_giftsockext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_flowerstableext_zz_flowerstableext_wall", "use_sock", func_end );
  SoundSfx( "aud_use_giftsockext_corridorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_flowerstableext" ] = { type = "click", use_place = "gfx_flowerstableext_win_flowerstableext_zone", room = "rm_corridorext", zz = "zz_flowerstableext", zz_gate = "gzz_corridorext_flowerstableext" };

private.win_flowerstableext_logic = function()
  if ld.CheckRequirements( {"win_flowerstableext"} ) then
    ObjSet( "spr_flowerstableext_acornext1", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_flowerstableext_potholderext", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_flowerstableext_cogext3", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_flowerstableext_beg = function(force)
  if ld.CheckRequirements( {"win_flowerstableext"} ) or force then
    ObjDelete( "gfx_flowerstableext_win_flowerstableext_zone" );
  end
end;
private.win_flowerstableext_end = function()
  if ld.CheckRequirements( {"win_flowerstableext"} ) then
    ObjSet( "spr_flowerstableext_acornext1_shadow", { visible = 1} );
    ObjSet( "spr_flowerstableext_cogext3_shadow", { visible = 1} );
    ObjSet( "spr_flowerstableext_potholderext_shadow", { visible = 1} );
    ObjSet( "anm_flowerstableext_zz_flowerstableext_wall", {animfunc = "open_zoom_end", frame = 0 } );
    if common_impl.ZzCompleteCheck("win_flowerstableext") then ObjSet( common_impl.hint["win_flowerstableext"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_flowerstableext", private.win_flowerstableext_beg, private.room_objname );
cmn.AddSubscriber( "win_flowerstableext", private.win_flowerstableext_end, private.room_objname );
cmn.AddSubscriber( "win_flowerstableext", private.win_flowerstableext_logic );
cmn.AddSubscriber( "win_flowerstableext_beg", private.win_flowerstableext_beg, private.room_objname );
cmn.AddSubscriber( "win_flowerstableext_end", private.win_flowerstableext_end, private.room_objname );
cmn.AddSubscriber( "win_flowerstableext_end", private.win_flowerstableext_logic );
--------------------------------------------------------------------------------------------
function public.win_flowerstableext()

  local func_end = function()
    cmn.SetEventDone( "win_flowerstableext" );
    cmn.CallEventHandler( "win_flowerstableext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_flowerstableext") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_flowerstableext_beg" );
  common_impl.Lock(1);

  private.win_flowerstableext_beg(true)
  ObjGet( "obj_flowerstableext_win_flowerstableext_zoom" ).event_mdown()
  cmn.MiniGameHide( "flowerstableext", true );
  ld.StartTimer( 1, function() 
    ld.AnimPlay( "anm_flowerstableext_zz_flowerstableext_wall", "open_zoom", func_end );
  end )
  
  --SoundSfx( 0 )
  --func_end()


end;
--------------------------------------------------------------------------------------------
local win_flowerstableext_loaded;
local win_flowerstableext_item = {}
function public.win_flowerstableext_load(reset,skip)
  local animtime = 0.5
  local begstate = {{6,5,3},{4,7,9},{2,11,12},{10,8,1}}
  local winstate = {{3,10,7},{2,6,1},{5,9,12},{11,8,4}}  
  local coord = {
                -284.0,  -135.0,  
                -287.0,  -27.0,  
                -289.0,  58.0,  
                -61.0,  -134.0,  
                -68.0,  -25.0,  
                -68.0,  58.0,  
                162.0,  -135.0,  
                157.0,  -26.0,  
                155.0,  58.0,  
                381.0,  -132.0,  
                373.0,  -24.0,  
                374.0,  63.0  
                }
  
  local items = "obj_flowerstableext_win_flowerstableext_items"
  local item = win_flowerstableext_item;
  local point = "obj_flowerstableext_win_flowerstableext_point_"

  if not ng_global.progress["ext"]["win_flowerstableext"].state or reset then
    ng_global.progress["ext"]["win_flowerstableext"].state = ld.TableCopy(begstate)
  end

  local function find(sender,list)
    local host = ld.TableContains(item, ld.StringDivide(sender)[3], 1) -- get item ID 
    list = list or ng_global.progress["ext"]["win_flowerstableext"].state
    for i,o in ipairs(list) do
      for j,k in ipairs(o) do
        if k == host then
          return {i,j}
        end
      end
    end    
  end

  local function load_map(skip)
    if not win_flowerstableext_loaded then
      for i,o in ipairs(ObjGetRelations( "obj_flowerstableext_win_flowerstableext_items" ).childs) do
        ld.CopyObj(o, o.."_light", "spr", o)
        ObjSet( o.."_light", {blendmode = 2, alp = 0} );
        ObjSet( o,  { input = 1, drag = 1, 
          event_menter = function() public.win_flowerstableext_menter(o) end,
          event_mleave = function()  public.win_flowerstableext_mleave(o) end,
          event_mdown = function()  public.win_flowerstableext_drag(o) end,
          event_dragdrop = function()  public.win_flowerstableext_drop(o) end
        } );
        table.insert(win_flowerstableext_item, ld.StringDivide(o)[3])
        --ld.LogTrace( i.." "..ld.StringDivide(o)[3] );
      end
      local count = 0;
      for i,o in ipairs(begstate) do
        for j,k in ipairs(o) do
          ObjSet( point..i.."_"..j, {pos_x = coord[count+1], pos_y = coord[count+2]});
          count = count + 2;
        end
      end
    end

    local toload = skip and winstate or ng_global.progress["ext"]["win_flowerstableext"].state
    for i,o in ipairs(toload) do
      for j,k in ipairs(o) do
        ObjAttach("spr_flowerstableext_"..item[k],point..i.."_"..j);
      end
    end

    win_flowerstableext_loaded = true;
  end

  --wincheck
  local prevstate
  local function wincheck(skip)
    local time = 3*animtime;
    local function win()
      public.win_flowerstableext()
    end

    local wincount = 0;
    for i,o in ipairs(ng_global.progress["ext"]["win_flowerstableext"].state) do
      for j,k in ipairs(o) do
        if ld.TableContains(winstate[i], k) then
          wincount = wincount + 1;
        else
          break
        end
      end
    end
    
    if wincount == #item or skip then
      if not skip then
        ng_global.progress["ext"]["win_flowerstableext"].state = ld.TableCopy(prevstate)
      end
      SoundSfx( "aud_win_flowerstableext" )
      local animArr = ld.Anim.Liquid(time,#winstate,0,1,0.5 )
      for i,o in ipairs(winstate) do
        for j,k in ipairs(o) do
          ObjAnimate( "spr_flowerstableext_"..item[k].."_light", 8, 0, 0, function() end, animArr[i] );
        end
      end


      ld.Lock(1)
      ld.StartTimer( time, function() win() end )
    end
  end

  --load
  local function load(skip)
    load_map(skip)
  end
  local function chooseload(reset,skip)
    if reset or skip then
      local toload = skip and winstate or begstate
      local time = animtime
      ld.Lock(1)
      for i,o in ipairs(item) do
        ObjAnimate( "spr_flowerstableext_"..o, 8, 0, 0, function() end, {0,0,1, 0.5*time,0,0, time,0,1} );
      end
      ld.StartTimer( 0.5*time, function() load(skip)  end )
      ld.StartTimer( time, function() ld.Lock(0) wincheck(skip)  end )
    else
      load()
    end
  end
  chooseload(reset,skip)
  --save
  local function save(coord1,coord2)
    prevstate = ld.TableCopy(ng_global.progress["ext"]["win_flowerstableext"].state)
    ng_global.progress["ext"]["win_flowerstableext"].state[ coord1[1] ][ coord1[2] ],ng_global.progress["ext"]["win_flowerstableext"].state[ coord2[1] ][ coord2[2] ] =
    ng_global.progress["ext"]["win_flowerstableext"].state[ coord2[1] ][ coord2[2] ],ng_global.progress["ext"]["win_flowerstableext"].state[ coord1[1] ][ coord1[2] ]
    wincheck()
  end  

  --public
  function public.win_flowerstableext_menter(sender)
    ld.ShCur(CURSOR_GET)
    ObjSet( sender.."_light", {alp = 1} );
  end
  local dragged;
  function public.win_flowerstableext_mleave(sender)
    if not dragged then
      ld.ShCur(CURSOR_DEFAULT)
      ObjSet( sender.."_light", {alp = 0} );
    end
  end
  function public.win_flowerstableext_drag(sender)
    dragged = true
    SoundSfx( "aud_drag_note" )
    ObjAttach(sender, "obj_flowerstableext_win_flowerstableext_points")
    ObjSet( sender, {pos_z = 100} );
    ObjSet( sender.."_light", {alp = 1} );
    ld.ShCur(CURSOR_NULL)
  end
  function public.win_flowerstableext_drop(sender)
    SoundSfx( "aud_drop_note" )
    local time = animtime
    local arr = {}
    dragged = false
    ld.ShCur(CURSOR_DEFAULT)
    ObjSet( sender, {pos_z = 0} );
    ObjSet( sender.."_light", {alp = 0} );
    for i = 1,4 do
      for j = 1,3 do
        if ApplyObj(sender,point..i.."_"..j) then
          table.insert(arr,{i,j});
        end
      end
    end
    if #arr == 0 then 
      local coord = find(sender);
      ObjAttach(sender, point..coord[1].."_"..coord[2])
      return; 
    end
    local minLen = 0;
    local min = {};
    for i,o in ipairs(arr) do
      local xy1 = GetObjPosByObj(sender, "zz_flowerstableext")
      local obj2 = ObjGet(point..o[1].."_"..o[2])
      local xy2 = {obj2.pos_x, obj2.pos_y}
      local curLen = ld.Len( xy1[1],xy1[2],xy2[1],xy2[2] );
      if i == 1 or curLen < minLen then
        minLen = curLen;
        min = o;
      end
      --ld.LogTrace( o[1].." "..o[2].." len="..ld.Len( xy1[1],xy1[2],xy2[1],xy2[2] ) );
    end
    
    local state = ng_global.progress["ext"]["win_flowerstableext"].state

    local coord1 = find(sender)
    local coord2 = min
    local obj1 = sender
    local obj2 = "spr_flowerstableext_"..item[ state[min [1] ][min [2] ] ]

    ObjAttach(obj1,point..coord2[1].."_"..coord2[2]);
    ObjAttach(obj2,point..coord1[1].."_"..coord1[2]);
    
    save(coord1,coord2)
    
    --ld.Lock(1)
    --ld.StartTimer( time, function() ld.Lock(0) save() end )
  end
end
--------------------------------------------------------------------
common_impl.hint[ "get_acornext1" ] = { type = "get", get_obj = "spr_flowerstableext_acornext1", room = "rm_corridorext", zz = "zz_flowerstableext", zz_gate = "gzz_corridorext_flowerstableext" };

private.get_acornext1_logic = function()
  
end;
private.get_acornext1_inv = function()
  interface.InventoryItemAdd("inv_acornext","spr_flowerstableext_acornext1",function() level_inv.ProcessGetAcornextAll( "get_acornext1" ) end);
end;
private.get_acornext1_beg = function()
  ObjDelete("gfx_flowerstableext_acornext1")
end;
private.get_acornext1_end = function()
  ObjDelete("spr_flowerstableext_acornext1_shadow")
  if common_impl.ZzCompleteCheck("get_acornext1") then ObjSet( common_impl.hint["get_acornext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_acornext1", private.get_acornext1_inv );
cmn.AddSubscriber( "get_acornext1", private.get_acornext1_beg, private.room_objname );
cmn.AddSubscriber( "get_acornext1", private.get_acornext1_end, private.room_objname );
cmn.AddSubscriber( "get_acornext1", private.get_acornext1_logic );
--------------------------------------------------------------------
function public.get_acornext1()
  cmn.SetEventDone( "get_acornext1" );
  cmn.CallEventHandler( "get_acornext1" );
  if common_impl.ZzCompleteCheck("get_acornext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_potholderext" ] = { type = "get", get_obj = "spr_flowerstableext_potholderext", room = "rm_corridorext", zz = "zz_flowerstableext", zz_gate = "gzz_corridorext_flowerstableext" };

private.get_potholderext_logic = function()
  
end;
private.get_potholderext_inv = function()
  interface.InventoryItemAdd("inv_potholderext","spr_flowerstableext_potholderext");
  ObjSet( "inv_potholderext", { drag = 0 } );
end;
private.get_potholderext_beg = function()
  ObjDelete("gfx_flowerstableext_potholderext")
end;
private.get_potholderext_end = function()
  ObjDelete("spr_flowerstableext_potholderext_shadow")
  if common_impl.ZzCompleteCheck("get_potholderext") then ObjSet( common_impl.hint["get_potholderext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_potholderext", private.get_potholderext_inv );
cmn.AddSubscriber( "get_potholderext", private.get_potholderext_beg, private.room_objname );
cmn.AddSubscriber( "get_potholderext", private.get_potholderext_end, private.room_objname );
cmn.AddSubscriber( "get_potholderext", private.get_potholderext_logic );
--------------------------------------------------------------------
function public.get_potholderext()
  cmn.SetEventDone( "get_potholderext" );
  cmn.CallEventHandler( "get_potholderext" );
  if common_impl.ZzCompleteCheck("get_potholderext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cogext3" ] = { type = "get", get_obj = "spr_flowerstableext_cogext3", room = "rm_corridorext", zz = "zz_flowerstableext", zz_gate = "gzz_corridorext_flowerstableext" };

private.get_cogext3_logic = function()
  
end;
private.get_cogext3_inv = function()
  interface.InventoryItemAdd("inv_cogext","spr_flowerstableext_cogext3",function() level_inv.ProcessGetCogextAll( "get_cogext3" ) end);
end;
private.get_cogext3_beg = function()
  ObjDelete("gfx_flowerstableext_cogext3")
end;
private.get_cogext3_end = function()
  ObjDelete("spr_flowerstableext_cogext3_shadow")
  if common_impl.ZzCompleteCheck("get_cogext3") then ObjSet( common_impl.hint["get_cogext3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_cogext3", private.get_cogext3_inv );
cmn.AddSubscriber( "get_cogext3", private.get_cogext3_beg, private.room_objname );
cmn.AddSubscriber( "get_cogext3", private.get_cogext3_end, private.room_objname );
cmn.AddSubscriber( "get_cogext3", private.get_cogext3_logic );
--------------------------------------------------------------------
function public.get_cogext3()
  cmn.SetEventDone( "get_cogext3" );
  cmn.CallEventHandler( "get_cogext3" );
  if common_impl.ZzCompleteCheck("get_cogext3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_sofaext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_mistletoeext1" ] = { type = "get", get_obj = "spr_sofaext_mistletoeext1", room = "rm_corridorext", zz = "zz_sofaext", zz_gate = "gzz_corridorext_sofaext" };

private.get_mistletoeext1_logic = function()
  
end;
private.get_mistletoeext1_inv = function()
  interface.InventoryItemAdd("inv_mistletoeext","spr_sofaext_mistletoeext1",function() level_inv.ProcessGetMistletoeextAll( "get_mistletoeext1" ) end);
end;
private.get_mistletoeext1_beg = function()
  ObjDelete("gfx_sofaext_mistletoeext1")
end;
private.get_mistletoeext1_end = function()
  ObjDelete("spr_sofaext_mistletoeext1_shadow")
  ObjDelete("spr_corridorext_mistletoe_collect")
  if common_impl.ZzCompleteCheck("get_mistletoeext1") then ObjSet( common_impl.hint["get_mistletoeext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_mistletoeext1", private.get_mistletoeext1_inv );
cmn.AddSubscriber( "get_mistletoeext1", private.get_mistletoeext1_beg, private.room_objname );
cmn.AddSubscriber( "get_mistletoeext1", private.get_mistletoeext1_end, private.room_objname );
cmn.AddSubscriber( "get_mistletoeext1", private.get_mistletoeext1_logic );
--------------------------------------------------------------------
function public.get_mistletoeext1()
  cmn.SetEventDone( "get_mistletoeext1" );
  cmn.CallEventHandler( "get_mistletoeext1" );
  if common_impl.ZzCompleteCheck("get_mistletoeext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_emberext" ] = { type = "use", inv_obj = "inv_emberext", use_place = "gfx_sofaext_emberext_zone", room = "rm_corridorext", zz = "zz_sofaext", zz_gate = "gzz_corridorext_sofaext" };

private.use_emberext_logic = function()
  ObjSet( "gfx_sofaext_win_sofaext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_emberext_inv = function()
  common_impl.ProcessMultiUseAll("emberext", "emberext")
end;
private.use_emberext_beg = function()
  ObjDelete( "gfx_sofaext_emberext_zone" );
end;
private.use_emberext_end = function()
  ObjSet( "spr_corridorext_paint_trash", {visible = 1} );
  ObjSet( "anm_sofaext_zz_sofaext_coal", {animfunc = "use_coal", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_emberext") then ObjSet( common_impl.hint["use_emberext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_emberext", private.use_emberext_inv );
cmn.AddSubscriber( "use_emberext", private.use_emberext_beg, private.room_objname );
cmn.AddSubscriber( "use_emberext", private.use_emberext_end, private.room_objname );
cmn.AddSubscriber( "use_emberext", private.use_emberext_logic );
cmn.AddSubscriber( "use_emberext_inv", private.use_emberext_inv, private.room_objname );
cmn.AddSubscriber( "use_emberext_beg", private.use_emberext_beg, private.room_objname );
cmn.AddSubscriber( "use_emberext_end", private.use_emberext_end, private.room_objname );
cmn.AddSubscriber( "use_emberext_end", private.use_emberext_logic );
--------------------------------------------------------------------------------------------
function public.use_emberext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_emberext" );
    cmn.CallEventHandler( "use_emberext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_emberext") then ld.CloseSubRoom() end;
    cmn.SetEventStart("win_sofaext")
    public.win_sofaext_load()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_emberext_inv" );
  cmn.CallEventHandler( "use_emberext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sofaext_zz_sofaext_coal", "use_coal", func_end );
  SoundSfx( "aud_use_emberext_corridorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
local win_sofaext_winstate = {2,1,3}
function public.win_sofaext_load()
  ng_global.progress["ext"]["win_sofaext"].state = ng_global.progress["ext"]["win_sofaext"].state or {}
  for i = 1,3 do
    ObjSet( "spr_sofaext_button_"..i, {event_mdown = function() public.win_sofaext_clk(i) end,
    event_menter = function() ld.ShCur(CURSOR_HAND) end,
    event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end } );
  end
  for i,o in ipairs(ng_global.progress["ext"]["win_sofaext"].state) do
    ObjSet( "spr_sofaext_button_"..o, {visible = 0, input = 0} );  
  end
end
function public.win_sofaext_clk(n)
  --ld.LogTrace( "clicked.."..n );
  SoundSfx( "aud_press_button4" )
  ObjSet( "spr_sofaext_button_"..n, {visible = 0, input = 0} );
  table.insert(ng_global.progress["ext"]["win_sofaext"].state,n)
  if ld.TableEquals(ng_global.progress["ext"]["win_sofaext"].state,win_sofaext_winstate) then
     ng_global.progress["ext"]["win_sofaext"].state[3] = nil
     ld.Lock(1)
     ld.StartTimer( 0.5, function() public.win_sofaext() end )
  elseif #ng_global.progress["ext"]["win_sofaext"].state == 3 then
    local function func_end() 
      SoundSfx( "aud_depress_button4" )
      for i = 1,3 do
        ObjSet( "spr_sofaext_button_"..i, {visible = 1, input = 1} );
      end    
    end
    ng_global.progress["ext"]["win_sofaext"].state = {}
    ld.StartTimer( 0.5, function() func_end() end )
  end
end

function public.win_sofaext_hint()
  local state = ng_global.progress["ext"]["win_sofaext"].state
  for i,o in ipairs(win_sofaext_winstate) do
    if ld.TableContains(state, o) then
    else
      common_impl.HintShowAnm("spr_sofaext_button_"..o)
      break;
    end
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_sofaext" ] = { type = "click", use_place = "gfx_sofaext_win_sofaext_zone", room = "rm_corridorext", zz = "zz_sofaext", zz_gate = "gzz_corridorext_sofaext", hint = public.win_sofaext_hint };

private.win_sofaext_logic = function()
  if ld.CheckRequirements( {"win_sofaext"} ) then
    ObjSet( "spr_sofaext_sockext", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_sofaext_medalioncatext", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_sofaext_beg = function()
  if ld.CheckRequirements( {"win_sofaext"} ) then
    ObjDelete( "gfx_sofaext_win_sofaext_zone" );
  end
end;
private.win_sofaext_end = function()
  public.win_sofaext_load()
  if ld.CheckRequirements( {"win_sofaext"} ) then
    ObjSet( "spr_sofaext_sockext_shadow", {visible = 1} );
    ObjSet( "spr_sofaext_medalioncatext_shadow", {visible = 1} );
    ObjDelete("spr_sofaext_button_1")
    ObjDelete("spr_sofaext_button_2")
    ObjDelete("spr_sofaext_button_3")
    ObjSet( "anm_sofaext_zz_sofaext_open_case", {animfunc = "case_open_end", frame = 0 } );

    ObjSet( "spr_corridorext_medalioncat", {visible = 1} );
    ObjSet( "spr_corridorext_sock", {visible = 1} );
    ObjSet( "spr_corridorext_open_case", {visible = 1} );
  end
  if common_impl.ZzCompleteCheck("win_sofaext") then ObjSet( common_impl.hint["win_sofaext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_sofaext", private.win_sofaext_beg, private.room_objname );
cmn.AddSubscriber( "win_sofaext", private.win_sofaext_end, private.room_objname );
cmn.AddSubscriber( "win_sofaext", private.win_sofaext_logic );
cmn.AddSubscriber( "win_sofaext_beg", private.win_sofaext_beg, private.room_objname );
cmn.AddSubscriber( "win_sofaext_end", private.win_sofaext_end, private.room_objname );
cmn.AddSubscriber( "win_sofaext_end", private.win_sofaext_logic );
--------------------------------------------------------------------------------------------
function public.win_sofaext()

  local func_end = function()
    cmn.SetEventDone( "win_sofaext" );
    cmn.CallEventHandler( "win_sofaext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_sofaext") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_sofaext_beg" );
  common_impl.Lock(1);
  ObjDelete( "gfx_sofaext_win_sofaext_zone" );
  ld.AnimPlay( "anm_sofaext_zz_sofaext_open_case", "case_open", func_end );
  SoundSfx( "aud_bag_open" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sockext" ] = { type = "get", get_obj = "spr_sofaext_sockext", room = "rm_corridorext", zz = "zz_sofaext", zz_gate = "gzz_corridorext_sofaext" };

private.get_sockext_logic = function()
  
end;
private.get_sockext_inv = function()
  interface.InventoryItemAdd("inv_sockext","spr_sofaext_sockext");
  ObjSet( "inv_sockext", { drag = 0 } );
end;
private.get_sockext_beg = function()
  ObjDelete("gfx_sofaext_sockext")
end;
private.get_sockext_end = function()
  ObjDelete("spr_sofaext_sockext_shadow")
  ObjDelete("spr_corridorext_sock")
  if common_impl.ZzCompleteCheck("get_sockext") then ObjSet( common_impl.hint["get_sockext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_sockext", private.get_sockext_inv );
cmn.AddSubscriber( "get_sockext", private.get_sockext_beg, private.room_objname );
cmn.AddSubscriber( "get_sockext", private.get_sockext_end, private.room_objname );
cmn.AddSubscriber( "get_sockext", private.get_sockext_logic );
--------------------------------------------------------------------
function public.get_sockext()
  cmn.SetEventDone( "get_sockext" );
  cmn.CallEventHandler( "get_sockext" );
  if common_impl.ZzCompleteCheck("get_sockext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_medalioncatext" ] = { type = "get", get_obj = "spr_sofaext_medalioncatext", room = "rm_corridorext", zz = "zz_sofaext", zz_gate = "gzz_corridorext_sofaext" };

private.get_medalioncatext_logic = function()
  
end;
private.get_medalioncatext_inv = function()
  interface.InventoryItemAdd("inv_medalioncatext","spr_sofaext_medalioncatext");
end;
private.get_medalioncatext_beg = function()
  ObjDelete("gfx_sofaext_medalioncatext")
end;
private.get_medalioncatext_end = function()
  ObjDelete("spr_sofaext_medalioncatext_shadow")
  ObjDelete("spr_corridorext_medalioncat")
  if common_impl.ZzCompleteCheck("get_medalioncatext") then ObjSet( common_impl.hint["get_medalioncatext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_medalioncatext", private.get_medalioncatext_inv );
cmn.AddSubscriber( "get_medalioncatext", private.get_medalioncatext_beg, private.room_objname );
cmn.AddSubscriber( "get_medalioncatext", private.get_medalioncatext_end, private.room_objname );
cmn.AddSubscriber( "get_medalioncatext", private.get_medalioncatext_logic );
--------------------------------------------------------------------
function public.get_medalioncatext()
  cmn.SetEventDone( "get_medalioncatext" );
  cmn.CallEventHandler( "get_medalioncatext" );
  if common_impl.ZzCompleteCheck("get_medalioncatext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_cogext" ] = { type = "use", inv_obj = "inv_cogext", use_place = "gfx_sofaext_cogext_zone", room = "rm_corridorext", zz = "zz_sofaext", zz_gate = "gzz_corridorext_sofaext" };

private.use_cogext_logic = function()
  ObjSet( "gfx_sofaext_clk_cogext_zone", {active = 1, input = 1, visible = 1} );
end;
private.use_cogext_inv = function()
  common_impl.ProcessMultiUseAll("cogext", "cogext")
end;
private.use_cogext_beg = function()
  ObjDelete( "gfx_sofaext_cogext_zone" );
end;
private.use_cogext_end = function()
  ObjSet( "anm_sofaext_zz_sofaext_cogwheel", {animfunc = "use_cogwheel", frame = 999 } );
  ObjSet( "spr_corridorext_cogwheels", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_cogext") then ObjSet( common_impl.hint["use_cogext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cogext", private.use_cogext_inv );
cmn.AddSubscriber( "use_cogext", private.use_cogext_beg, private.room_objname );
cmn.AddSubscriber( "use_cogext", private.use_cogext_end, private.room_objname );
cmn.AddSubscriber( "use_cogext", private.use_cogext_logic );
cmn.AddSubscriber( "use_cogext_inv", private.use_cogext_inv, private.room_objname );
cmn.AddSubscriber( "use_cogext_beg", private.use_cogext_beg, private.room_objname );
cmn.AddSubscriber( "use_cogext_end", private.use_cogext_end, private.room_objname );
cmn.AddSubscriber( "use_cogext_end", private.use_cogext_logic );
--------------------------------------------------------------------------------------------
function public.use_cogext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cogext" );
    cmn.CallEventHandler( "use_cogext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_cogext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cogext_inv" );
  cmn.CallEventHandler( "use_cogext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sofaext_zz_sofaext_cogwheel", "use_cogwheel", func_end );
  SoundSfx( "aud_use_cogext_corridorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_cogext" ] = { type = "click", use_place = "gfx_sofaext_clk_cogext_zone", room = "rm_corridorext", zz = "zz_sofaext", zz_gate = "gzz_corridorext_sofaext" };

private.clk_cogext_logic = function()
  ObjSet( "spr_sofaext_coinext1", {  input = 1, active = 1 } )
  ObjSet( "spr_sofaext_needleandcottonext", {  input = 1, active = 1 } )

end;
private.clk_cogext_beg = function()
  ObjDelete( "gfx_sofaext_clk_cogext_zone" );
end;
private.clk_cogext_end = function()
  ObjSet( "gfx_sofaext_coinext1", { visible = 1, active = 1 } )
  ObjSet( "gfx_sofaext_needleandcottonext", { visible = 1, active = 1 } )
  ObjSet( "anm_sofaext_zz_sofaext_cover", {animfunc = "click_cover_2", frame = 999 } );
  ObjSet( "spr_corridorext_cover_open", {visible = 1} );
  ObjSet( "spr_corridorext_cover_cog_in", {visible = 1} );
  ObjSet( "spr_corridorext_ded", {visible = 1} );
  ObjDelete("spr_corridorext_cover_cog_out")
  ObjSet( "spr_corridorext_coin", {visible = 1} );
  ObjSet( "spr_corridorext_needle", {visible = 1} );
  ObjDelete("spr_corridorext_coverbox_close")
  if common_impl.ZzCompleteCheck("clk_cogext") then ObjSet( common_impl.hint["clk_cogext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_cogext", private.clk_cogext_beg, private.room_objname );
cmn.AddSubscriber( "clk_cogext", private.clk_cogext_end, private.room_objname );
cmn.AddSubscriber( "clk_cogext", private.clk_cogext_logic );
cmn.AddSubscriber( "clk_cogext_beg", private.clk_cogext_beg, private.room_objname );
cmn.AddSubscriber( "clk_cogext_end", private.clk_cogext_end, private.room_objname );
cmn.AddSubscriber( "clk_cogext_end", private.clk_cogext_logic );
--------------------------------------------------------------------------------------------
function public.clk_cogext()

  local func_end = function()
    cmn.SetEventDone( "clk_cogext" );
    cmn.CallEventHandler( "clk_cogext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_cogext") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_cogext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sofaext_zz_sofaext_cover", "click_cover_1", function() 
    ld.AnimPlay( "anm_sofaext_zz_sofaext_cover", "click_cover_2", func_end );
  end );
  SoundSfx( "aud_placing_cover" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_coinext1" ] = { type = "get", get_obj = "spr_sofaext_coinext1", room = "rm_corridorext", zz = "zz_sofaext", zz_gate = "gzz_corridorext_sofaext" };

private.get_coinext1_logic = function()
  
end;
private.get_coinext1_inv = function()
  interface.InventoryItemAdd("inv_coinext","spr_sofaext_coinext1",function() level_inv.ProcessGetCoinextAll( "get_coinext1" ) end);
end;
private.get_coinext1_beg = function()
  ObjDelete("gfx_sofaext_coinext1")
  ObjSet( "spr_sofaext_coinext1", {visible = 1} );
end;
private.get_coinext1_end = function()
  ObjDelete("spr_corridorext_coin")
  if ld.CheckRequirements( {"get_coinext1","get_needleandcottonext"} ) then
    ObjSet( "anm_sofaext_zz_sofaext_cover", {animfunc = "collect_coin_end", frame = 0 } );    
  else
    ObjSet( "anm_sofaext_zz_sofaext_cover", {animfunc = "click_cover_2_end", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("get_coinext1") then ObjSet( common_impl.hint["get_coinext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_coinext1", private.get_coinext1_inv );
cmn.AddSubscriber( "get_coinext1", private.get_coinext1_beg, private.room_objname );
cmn.AddSubscriber( "get_coinext1", private.get_coinext1_end, private.room_objname );
cmn.AddSubscriber( "get_coinext1", private.get_coinext1_logic );
--------------------------------------------------------------------
function public.get_coinext1()
  cmn.SetEventDone( "get_coinext1" );
  cmn.CallEventHandler( "get_coinext1" );
  cmn.SetEventDone( "get_needleandcottonext" );
  cmn.CallEventHandler( "get_needleandcottonext" );
  if common_impl.ZzCompleteCheck("get_coinext1") then ld.CloseSubRoom() end;
  
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_needleandcottonext" ] = { type = "get", get_obj = "spr_sofaext_needleandcottonext", room = "rm_corridorext", zz = "zz_sofaext", zz_gate = "gzz_corridorext_sofaext" };

private.get_needleandcottonext_logic = function()
  
end;
private.get_needleandcottonext_inv = function()
  interface.InventoryItemAdd("inv_needleandcottonext","spr_sofaext_needleandcottonext");
end;
private.get_needleandcottonext_beg = function()
  ObjDelete("gfx_sofaext_needleandcottonext")
  ObjSet( "spr_sofaext_needleandcottonext", {visible = 1} );
end;
private.get_needleandcottonext_end = function()
  ObjDelete("spr_corridorext_needle")
  if ld.CheckRequirements( {"get_coinext1","get_needleandcottonext"} ) then
    ObjSet( "anm_sofaext_zz_sofaext_cover", {animfunc = "collect_coin_end", frame = 0 } );    
  else
    ObjSet( "anm_sofaext_zz_sofaext_cover", {animfunc = "collect_needle_end", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("get_needleandcottonext") then ObjSet( common_impl.hint["get_needleandcottonext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_needleandcottonext", private.get_needleandcottonext_inv );
cmn.AddSubscriber( "get_needleandcottonext", private.get_needleandcottonext_beg, private.room_objname );
cmn.AddSubscriber( "get_needleandcottonext", private.get_needleandcottonext_end, private.room_objname );
cmn.AddSubscriber( "get_needleandcottonext", private.get_needleandcottonext_logic );
--------------------------------------------------------------------
function public.get_needleandcottonext()
  cmn.SetEventDone( "get_coinext1" );
  cmn.CallEventHandler( "get_coinext1" );
  cmn.SetEventDone( "get_needleandcottonext" );
  cmn.CallEventHandler( "get_needleandcottonext" );
  if common_impl.ZzCompleteCheck("get_needleandcottonext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_wallpaintext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_firedcandleext" ] = { type = "use", inv_obj = "inv_firedcandleext", use_place = "gfx_wallpaintext_firedcandleext_zone", room = "rm_corridorext", zz = "zz_wallpaintext", zz_gate = "gzz_corridorext_wallpaintext" };

private.use_firedcandleext_logic = function()
  ObjSet( "gho_corridorext_painthoext", { visible = 1, input = 1, active = 1 } )

end;
private.use_firedcandleext_inv = function()
  common_impl.ProcessMultiUseAll("firedcandleext", "firedcandleext")
end;
private.use_firedcandleext_beg = function()
  ObjDelete( "gfx_wallpaintext_firedcandleext_zone" );
end;
private.use_firedcandleext_end = function()
  ObjSet( "anm_wallpaintext_anm", {animfunc = "use_firedcandle", frame = 999 } );
  ObjDelete("spr_corridorext_picture_dark")
  ObjSet( "spr_corridorext_picture_light", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_firedcandleext") then ObjSet( common_impl.hint["use_firedcandleext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_firedcandleext", private.use_firedcandleext_inv );
cmn.AddSubscriber( "use_firedcandleext", private.use_firedcandleext_beg, private.room_objname );
cmn.AddSubscriber( "use_firedcandleext", private.use_firedcandleext_end, private.room_objname );
cmn.AddSubscriber( "use_firedcandleext", private.use_firedcandleext_logic );
cmn.AddSubscriber( "use_firedcandleext_inv", private.use_firedcandleext_inv, private.room_objname );
cmn.AddSubscriber( "use_firedcandleext_beg", private.use_firedcandleext_beg, private.room_objname );
cmn.AddSubscriber( "use_firedcandleext_end", private.use_firedcandleext_end, private.room_objname );
cmn.AddSubscriber( "use_firedcandleext_end", private.use_firedcandleext_logic );
--------------------------------------------------------------------------------------------
function public.use_firedcandleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_firedcandleext" );
    cmn.CallEventHandler( "use_firedcandleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_firedcandleext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_firedcandleext_inv" );
  cmn.CallEventHandler( "use_firedcandleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_wallpaintext_anm", "use_firedcandle", func_end );
  SoundSfx( "aud_use_firedcandleext_corridorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_painthoext_for_corridorext = function()
    if ld.CheckRequirements( {"win_painthoext"} ) then
      ObjSet( "gho_corridorext_painthoext", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_painthoext", win_painthoext_for_corridorext, private.room_objname )

  function public.Reset()
    local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

    if ( mg_name == "zz_flowerstableext" ) then
      public.win_flowerstableext_load(1)
    end

  end;
  function public.Skip()
    local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
      
    if ( mg_name == "zz_flowerstableext" ) then
      public.win_flowerstableext_load(nil,1)
    end

  end;

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_corridorext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_secondfloor_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_wallpaintext" );
  function zz_wallpaintext.Open()
  end;
  function zz_wallpaintext.PreOpen()
  end;
  function zz_wallpaintext.PreClose()
  end;
  function zz_wallpaintext.Close()
  end;

  subroom.Define( "zz_sofaext" );
  function zz_sofaext.Open()
  end;
  function zz_sofaext.PreOpen()
  end;
  function zz_sofaext.PreClose()
  end;
  function zz_sofaext.Close()
  end;

  subroom.Define( "zz_flowerstableext" );
  function zz_flowerstableext.Open()
  end;
  function zz_flowerstableext.PreOpen()
    if ld.CheckRequirements( {"use_giftsockext"} ) and not ld.CheckRequirements( {"win_flowerstableext"} ) then
      public.win_flowerstableext_load()
      --ObjGet( "gfx_flowerstableext_win_flowerstableext_zone" ).event_mdown()
    end  
  end;
  function zz_flowerstableext.PreClose()
  end;
  function zz_flowerstableext.Close()
  end;

  subroom.Define( "zz_dressingroomdoorext" );
  function zz_dressingroomdoorext.Open()
  end;
  function zz_dressingroomdoorext.PreOpen()
  end;
  function zz_dressingroomdoorext.PreClose()
  end;
  function zz_dressingroomdoorext.Close()
  end;
  
end;
--*********************************************************************************************************************