-- name=rm_entrypointext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.entrypointext_objname = "rm_entrypointext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  --private.vid_golem_static_list = {
  --  "vid_entrypointext_golem_1static_71";
  --  "vid_entrypointext_golem_2static_101";
  --}
  --ld.VidStaticInit( 
  --  private.vid_golem_static_list, 
  --  "rm_entrypointext", 
  --  {  }, 
  --  { 4, 7 }, 
  --  nil, 
  --  {"get_golemext"}, 
  --  sfx_rnd, 
  --  root
  --)

function private.opn_entrypointext()
  --cmn.SetEventDone( "opn_entrypointext" );
  --cmn.CallEventHandler( "opn_entrypointext" )
  --ld.ShowBbtOpn( private.entrypointext_objname )    
end;

function private.SeeIntro()

  local func_end = function()
    SoundTheme( 0 )
    ld.Lock( 1 )
    VidPause( "vid_entrypointext_vid_intro", 1 )
    ObjAnimate( "vid_entrypointext_vid_intro", 8,0,0, function() 
      ObjDelete( "vid_entrypointext_vid_intro" )
      ld.Lock(0)
      cmn.SetEventDone( "opn_entrypointext" )
      cmn.CallEventHandler( "opn_entrypointext" )
      SoundEnv( "aud_workshop_env" )
    end, { 0,0,1, 0.4,0,0 } )
  end
  
  local func_step = function ()
  
    interface.DialogVideoSubtitleHide()
    --voices( false )
    SoundVid( 0 )
    ld.Lock(1)
    int.DialogVideoHide();
    
    ld.SetWidgetsVisible("DialogVideoShow", 1, false)
  
    func_end()
  
  end
  
  ld.SetWidgetsVisible("DialogVideoShow", 0, true)

  
  --SoundTheme( "aud_swan_lake_mus", 1 )
  ObjSet( "vid_entrypointext_vid_intro", {alp=1} );
  ObjAttach("vid_entrypointext_vid_intro","rm_entrypointext")
  
  ObjAnimate( "vid_entrypointext_vid_intro", 7,0,0, function()
    --[[
    common_impl.VideoSubtitleVocStart( {
      { "srt_vid_introext_1" , aud_voc_false, 26,37 };
      { "srt_vid_introext_2" , aud_voc_false, 37,39 };
    } );
    ]]
    SoundVoice( "aud_introext_voc" );
    SoundVid( "aud_introext" );
    VidPlay( "vid_entrypointext_vid_intro", func_step )


    --voices( true ) 
  end, { 0,0,0, 0,0,0 } )
  int.DialogVideoShow( "", 1, func_step, 1 );
  
  --func_end();

end
--------------------------------------------------------------------
local opn_entrypointext = function() end;
local opn_entrypointext_logic = function() end;
cmn.AddSubscriber( "opn_entrypointext", opn_entrypointext_logic )
cmn.AddSubscriber( "opn_entrypointext", opn_entrypointext, private.entrypointext_objname )
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "fairyext1" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    elseif count_txt == 2 then
      common_impl.continue_visible = true
      --ld.Anim.SwitchByAlpha("anm_entrypointext_fairyext1", "anm_entrypointext_cinderella")
    elseif count_txt == 3 then
      common_impl.continue_visible = true
      --ld.Anim.SwitchByAlpha("anm_entrypointext_cinderella", "anm_entrypointext_fairyext1")
    elseif count_txt == 4 then 
      --ld.AnimPlay( "anm_entrypointext_fairyext1", "", "" )
      --cmn.CallEventHandler( "get_fairyext" );
    end
  elseif dlg_name == "fairyext3" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    elseif count_txt == 2 then
      common_impl.continue_visible = true
    elseif count_txt == 3 then
      --common_impl.continue_visible = true
    end
  end
end


--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_entrypointext_fairyext1" ] = { type = "click", use_place = "gfx_entrypointext_dlg_entrypointext_fairyext1_zone", room = "rm_entrypointext" };

private.dlg_entrypointext_fairyext1_logic = function()
  ObjSet( "spr_entrypointext_fairyext", { visible = 1, active = 1 } )
  ObjSet( "gzz_entrypointext_mirrorext", {active = 1, input = 1, visible = 1} );
  ObjSet( "gzz_entrypointext_tableext", {active = 1, input = 1, visible = 1} );
  ObjSet( "gzz_entrypointext_secondfloordoorext", {active = 1, input = 1, visible = 1} );
  ObjSet( "gzz_entrypointext_dressext", {active = 1, input = 1, visible = 1} );
end;
private.dlg_entrypointext_fairyext1_beg = function()
  ObjDelete( "gfx_entrypointext_dlg_entrypointext_fairyext1_zone" );
end;
private.dlg_entrypointext_fairyext1_end = function()
  ObjDelete("vid_entrypointext_fairy_sart_84")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_entrypointext_fairyext1", private.dlg_entrypointext_fairyext1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_entrypointext_fairyext1", private.dlg_entrypointext_fairyext1_end, private.room_objname );
cmn.AddSubscriber( "dlg_entrypointext_fairyext1", private.dlg_entrypointext_fairyext1_logic );
cmn.AddSubscriber( "dlg_entrypointext_fairyext1_beg", private.dlg_entrypointext_fairyext1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_entrypointext_fairyext1_end", private.dlg_entrypointext_fairyext1_end, private.room_objname );
cmn.AddSubscriber( "dlg_entrypointext_fairyext1_end", private.dlg_entrypointext_fairyext1_logic );
--------------------------------------------------------------------------------------------
function public.dlg_entrypointext_fairyext1( obj )
  local func_end = function()
    --cmn.SetEventDone( "get_fairyext" );
    
    cmn.CallEventHandler( "dlg_entrypointext_fairyext1_end" );
    common_impl.Lock(0);
  end;
  function public.dlg_entrypointext_fairyext1_func_end()
    common_impl.Lock(1);
    ObjDelete("vid_entrypointext_fairy_sart_84")
    --if ObjGetRelations( "inv_fairyext" ).parent == "levelext_inv_hub" then
      public.get_fairyext()
    --end  
    func_end()
  end
  cmn.CallEventHandler( "dlg_entrypointext_fairyext1_beg" );
  common_impl.dialog_character_loc = "obj_entrypointext_dlg_root";
  common_impl.Start( "fairyext1", 4, nil, nil, true, "dlg_entrypointext_fairyext1_func_end", { "aud_fairy_3_voc", "aud_cinderella_1_voc", "aud_fairy_4_voc" }, { "fairy", "cinderella", "fairy" } );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fairyext" ] = { type = "get", get_obj = "spr_entrypointext_fairyext", room = "rm_entrypointext" };

private.get_fairyext_logic = function()
  levelext.SimonAdd()
  interface.SimonGet()
  ObjDelete("spr_entrypointext_fairyext")
end;
private.get_fairyext_inv = function()
  --interface.InventoryItemAdd("inv_fairyext","spr_entrypointext_fairyext");
end;
private.get_fairyext_beg = function()
  ObjDelete("gfx_entrypointext_fairyext")
end;
private.get_fairyext_end = function()
  
end;

cmn.AddSubscriber( "get_fairyext", private.get_fairyext_inv );
cmn.AddSubscriber( "get_fairyext", private.get_fairyext_beg, private.room_objname );
cmn.AddSubscriber( "get_fairyext", private.get_fairyext_end, private.room_objname );
cmn.AddSubscriber( "get_fairyext", private.get_fairyext_logic );

--------------------------------------------------------------------
function public.get_fairyext()
  ObjDelete("gfx_entrypointext_fairyext")
  ld.Lock(1)
  int_inventory.StdItemFlyAnimation("spr_entrypointext_fairyext","obj_int_button_map_point_for_cube",
  function() 
    ld.Lock(0);
    cmn.SetEventDone( "dlg_entrypointext_fairyext1" );
    cmn.SetEventDone( "get_fairyext" );
    cmn.CallEventHandler( "get_fairyext" );
    interface.SimonReturn() 
  end)
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_entrypointext_fairyext3" ] = { type = "click", use_place = "gfx_entrypointext_dlg_entrypointext_fairyext3_zone", room = "rm_entrypointext" };

private.dlg_entrypointext_fairyext3_logic = function()
  ObjSet( "gho_entrypointext_portalext", {active = 1, input = 1, visible = 1} );
end;
private.dlg_entrypointext_fairyext3_beg = function()
  ObjDelete( "gfx_entrypointext_dlg_entrypointext_fairyext3_zone" );
end;
private.dlg_entrypointext_fairyext3_end = function()
  ObjAttach("obj_entrypointext_teleport","rm_entrypointext")
  ObjDelete("obj_entrypointext_bbt_door")
  if common_impl.ZzCompleteCheck("get_mouseext") then ObjSet( common_impl.hint["get_mouseext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_entrypointext_fairyext3", private.dlg_entrypointext_fairyext3_beg, private.room_objname );
cmn.AddSubscriber( "dlg_entrypointext_fairyext3", private.dlg_entrypointext_fairyext3_end, private.room_objname );
cmn.AddSubscriber( "dlg_entrypointext_fairyext3", private.dlg_entrypointext_fairyext3_logic );
cmn.AddSubscriber( "dlg_entrypointext_fairyext3_beg", private.dlg_entrypointext_fairyext3_beg, private.room_objname );
cmn.AddSubscriber( "dlg_entrypointext_fairyext3_end", private.dlg_entrypointext_fairyext3_end, private.room_objname );
cmn.AddSubscriber( "dlg_entrypointext_fairyext3_end", private.dlg_entrypointext_fairyext3_logic );
--------------------------------------------------------------------------------------------
function public.dlg_entrypointext_fairyext3( obj )
  local func_end = function()
    cmn.SetEventDone( "get_mouseext" );
    cmn.SetEventDone( "dlg_entrypointext_fairyext3" );
    cmn.CallEventHandler( "dlg_entrypointext_fairyext3_end" );
    common_impl.Lock(0);
    ObjDelete("vid_entrypointext_fairy_portal_137")
    ObjDelete("vid_entrypointext_portal_appears_137")
    interface.SimonReturn()
    ld.ShowBbt("entrypoitext_after_portal");
  end;
  local func_end_2 = function()
    ObjAttach("vid_entrypointext_portal_appears_137","rm_entrypointext")
    ObjAttach("vid_entrypointext_fairy_portal_137","rm_entrypointext")
    VidPlay("vid_entrypointext_portal_appears_137",func_end)
    VidPlay("vid_entrypointext_fairy_portal_137","")
    SoundSfx( "aud_make_portal" )
  end
  function public.dlg_entrypointext_fairyext3_func_end()
    common_impl.Lock(1);
    int_simon.SimonStaticStop()
    interface.SimonJump(func_end_2)
  end
  cmn.CallEventHandler( "dlg_entrypointext_fairyext3_beg" );
  common_impl.dialog_character_loc = "";
  common_impl.Start( "fairyext3", 3, nil, nil, true, "dlg_entrypointext_fairyext3_func_end", { "aud_fairy_5_voc", "aud_fairy_6_voc" } );
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_dressext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_viddressext" ] = { type = "click", use_place = "gfx_dressext_clk_viddressext_zone", room = "rm_entrypointext", zz = "zz_dressext", zz_gate = "gzz_entrypointext_dressext" };

private.clk_viddressext_logic = function()
  ObjSet( "spr_dressext_snowmanpyramidext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_dressext_dresslaceext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_viddressext_beg = function()
  ObjDelete( "gfx_dressext_clk_viddressext_zone" );
end;
private.clk_viddressext_end = function()
  ObjSet( "spr_entrypointext_krujeva", {visible = 0} );
  ObjSet( "spr_dressext_dresslace_ok", {visible = 0} );
  if common_impl.ZzCompleteCheck("clk_viddressext") then ObjSet( common_impl.hint["clk_viddressext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_viddressext", private.clk_viddressext_beg, private.room_objname );
cmn.AddSubscriber( "clk_viddressext", private.clk_viddressext_end, private.room_objname );
cmn.AddSubscriber( "clk_viddressext", private.clk_viddressext_logic );
cmn.AddSubscriber( "clk_viddressext_beg", private.clk_viddressext_beg, private.room_objname );
cmn.AddSubscriber( "clk_viddressext_end", private.clk_viddressext_end, private.room_objname );
cmn.AddSubscriber( "clk_viddressext_end", private.clk_viddressext_logic );
--------------------------------------------------------------------------------------------
function public.clk_viddressext()

  local func_end = function()
    int.DialogVideoHide();
    cmn.SetEventDone( "clk_viddressext" );
    cmn.CallEventHandler( "clk_viddressext_end" );
    common_impl.Gate_MDown( "gzz_entrypointext_dressext",{ ObjGet( "gzz_entrypointext_dressext" ).pos_x, ObjGet( "gzz_entrypointext_dressext" ).pos_y}  )
    ld.ShowBbt("entrypoitext_after_laces");
  end;
  local func_start = function()
    ld.Lock(0)
    int.DialogVideoShow( "vid_entrypointext_vid_run_lace", 1, func_end );
    VidPlay("vid_entrypointext_vid_run_lace", func_end);
    SoundVid( "aud_run_lace" )
  end
  cmn.CallEventHandler( "clk_viddressext_beg" );
  ld.CloseSubRoom()
  ld.Lock(1)
  ld.StartTimer( 0.5,function() func_start() end )
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_snowmanpyramidext" ] = { type = "get", get_obj = "spr_dressext_snowmanpyramidext", room = "rm_entrypointext", zz = "zz_dressext", zz_gate = "gzz_entrypointext_dressext" };

private.get_snowmanpyramidext_logic = function()
  
end;
private.get_snowmanpyramidext_inv = function()
  interface.InventoryItemAdd("inv_snowmanpyramidext","spr_dressext_snowmanpyramidext");
  ObjSet( "inv_snowmanpyramidext", { drag = 0 } );
end;
private.get_snowmanpyramidext_beg = function()
  ObjDelete("gfx_dressext_snowmanpyramidext")
end;
private.get_snowmanpyramidext_end = function()
  ObjDelete("spr_dressext_snowmanpyramid_tr")
  ObjDelete("spr_dressext_snowmanpyramid_sh")
  ObjDelete("spr_entrypointext_snowmanpyramid_tr")
  if common_impl.ZzCompleteCheck("get_snowmanpyramidext") then ObjSet( common_impl.hint["get_snowmanpyramidext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_snowmanpyramidext", private.get_snowmanpyramidext_inv );
cmn.AddSubscriber( "get_snowmanpyramidext", private.get_snowmanpyramidext_beg, private.room_objname );
cmn.AddSubscriber( "get_snowmanpyramidext", private.get_snowmanpyramidext_end, private.room_objname );
cmn.AddSubscriber( "get_snowmanpyramidext", private.get_snowmanpyramidext_logic );
--------------------------------------------------------------------
function public.get_snowmanpyramidext()
  cmn.SetEventDone( "get_snowmanpyramidext" );
  cmn.CallEventHandler( "get_snowmanpyramidext" );
  if common_impl.ZzCompleteCheck("get_snowmanpyramidext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_dresslaceext" ] = { type = "use", inv_obj = "inv_dresslaceext", use_place = "gfx_dressext_dresslaceext_zone", room = "rm_entrypointext", zz = "zz_dressext", zz_gate = "gzz_entrypointext_dressext" };

private.use_dresslaceext_logic = function()
  ObjSet( "gfx_dressext_catandmouseext_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_entrypointext_frozenext", {active = 1, input = 1, visible = 1} );
end;
private.use_dresslaceext_inv = function()
  common_impl.ProcessMultiUseAll("dresslaceext", "dresslaceext")
end;
private.use_dresslaceext_beg = function()
  ObjDelete( "gfx_dressext_dresslaceext_zone" );
  ObjSet( "spr_entrypointext_krujeva", {visible = 1} );
end;
private.use_dresslaceext_end = function()
  
  ObjSet( "spr_entrypointext_cat", {visible = 1} );
  ObjSet( "spr_entrypointext_ice_normal", {visible = 1} );
  ObjSet( "spr_entrypointext_ice_add", {visible = 1} );
  ObjSet( "spr_entrypointext_ovenhandleext_tr", {visible = 1} );
  ObjSet( "spr_dressext_dresslace", {visible = 1} );
  ObjDelete("obj_entrypointext_bbt_simp")
  ObjDetach("spr_entrypointext_simpkin_mouses_static_147")
  if common_impl.ZzCompleteCheck("use_dresslaceext") then ObjSet( common_impl.hint["use_dresslaceext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dresslaceext", private.use_dresslaceext_inv );
cmn.AddSubscriber( "use_dresslaceext", private.use_dresslaceext_beg, private.room_objname );
cmn.AddSubscriber( "use_dresslaceext", private.use_dresslaceext_end, private.room_objname );
cmn.AddSubscriber( "use_dresslaceext", private.use_dresslaceext_logic );
cmn.AddSubscriber( "use_dresslaceext_inv", private.use_dresslaceext_inv, private.room_objname );
cmn.AddSubscriber( "use_dresslaceext_beg", private.use_dresslaceext_beg, private.room_objname );
cmn.AddSubscriber( "use_dresslaceext_end", private.use_dresslaceext_end, private.room_objname );
cmn.AddSubscriber( "use_dresslaceext_end", private.use_dresslaceext_logic );
--------------------------------------------------------------------------------------------
function public.use_dresslaceext( obj )

  local func_end = function()
    ObjDelete("anm_dressext_anm2")
    ObjSet( "anm_dressext_anm", {visible = 1} );
    ObjSet(obj,{visible = 1});
    int.DialogVideoHide();
    cmn.SetEventDone( "use_dresslaceext" );
    cmn.CallEventHandler( "use_dresslaceext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_dresslaceext") then ld.CloseSubRoom() end;
    common_impl.Gate_MDown( "gzz_entrypointext_dressext",{ ObjGet( "gzz_entrypointext_dressext" ).pos_x, ObjGet( "gzz_entrypointext_dressext" ).pos_y}  )
    ld.ShowBbt("entrypoitext_after_morgana_appear");
  end;

  local func_start = function()
    ld.Lock(0)
    int.DialogVideoShow( "vid_entrypointext_vid_morgana_appear", 1, func_end );
    --[[
    common_impl.VideoSubtitleVocStart( {
      { "srt_vid_morgana_appear" , aud_voc_false, 8,15 };
    } );
    ]]
    SoundVid( "aud_morgana_appear" );
    SoundVoice( "aud_morgana_appear_voc" );
    VidPlay("vid_entrypointext_vid_morgana_appear", func_end);
  end

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dresslaceext_inv" );
  cmn.CallEventHandler( "use_dresslaceext_beg" );
  common_impl.Lock(1);
  
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_dresslaceext_entrypointext" )
  ObjSet( "anm_dressext_anm", {visible = 0} );
  ObjSet( "anm_dressext_anm2", {visible = 1} );
  ld.AnimPlay( "anm_dressext_anm2", "dresslace", function() ld.CloseSubRoom() ld.StartTimer( 0.5,function() func_start() end )  end )
  --ObjSet( "spr_dressext_dresslace", {visible = 1, alp = 0} );
  --ObjAnimate( "spr_dressext_dresslace", 8, 0, 0, function() ld.CloseSubRoom() ld.StartTimer( 0.5,function() func_start() end )  end, {0,0,0, 1,0,1, 1.5,0,1} );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_catandmouseext" ] = { type = "use", inv_obj = "inv_catandmouseext", use_place = "gfx_dressext_catandmouseext_zone", room = "rm_entrypointext", zz = "zz_dressext", zz_gate = "gzz_entrypointext_dressext" };

private.use_catandmouseext_logic = function()
  ObjSet( "spr_dressext_cinderellastaffext", {  input = 1, active = 1 } )


end;
private.use_catandmouseext_inv = function()
  common_impl.ProcessMultiUseAll("catandmouseext", "catandmouseext")
end;
private.use_catandmouseext_beg = function()
  
  ObjDelete( "gfx_dressext_catandmouseext_zone" );
end;
private.use_catandmouseext_end = function()
  ObjDelete("spr_dressext_dresslace")
  ObjSet( "spr_dressext_dresslace_ok", {visible = 1} );
  ObjSet( "gfx_dressext_cinderellastaffext", {active = 1, visible = 1} );
  ObjAttach("vid_entrypointext_simp_1_mouse_static_79","rm_entrypointext")
  ObjAttach("vid_entrypointext_simp_2_mouse_static_79","rm_entrypointext")
  ObjAttach("vid_entrypointext_simp_3_mouse_static_79","rm_entrypointext")
  ObjAttach("vid_dressext_simp_cat_static_79","zz_dressext")
  ObjAttach("vid_dressext_simp_mouse_1_static_79","zz_dressext")
  ObjAttach("vid_dressext_simp_mouse_2_static_79","zz_dressext")
  if common_impl.ZzCompleteCheck("use_catandmouseext") then ObjSet( common_impl.hint["use_catandmouseext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_catandmouseext", private.use_catandmouseext_inv );
cmn.AddSubscriber( "use_catandmouseext", private.use_catandmouseext_beg, private.room_objname );
cmn.AddSubscriber( "use_catandmouseext", private.use_catandmouseext_end, private.room_objname );
cmn.AddSubscriber( "use_catandmouseext", private.use_catandmouseext_logic );
cmn.AddSubscriber( "use_catandmouseext_inv", private.use_catandmouseext_inv, private.room_objname );
cmn.AddSubscriber( "use_catandmouseext_beg", private.use_catandmouseext_beg, private.room_objname );
cmn.AddSubscriber( "use_catandmouseext_end", private.use_catandmouseext_end, private.room_objname );
cmn.AddSubscriber( "use_catandmouseext_end", private.use_catandmouseext_logic );
--------------------------------------------------------------------------------------------
function public.use_catandmouseext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_catandmouseext" );
    cmn.CallEventHandler( "use_catandmouseext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_catandmouseext") then ld.CloseSubRoom() end;
    ld.ShowBbt("entrypoitext_after_dress");
    ObjDelete("vid_dressext_simp_stitching_170")
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_catandmouseext_inv" );
  cmn.CallEventHandler( "use_catandmouseext_beg" );
  common_impl.Lock(1);
  ld.Anim.SwitchByAlpha("spr_dressext_dresslace", "vid_dressext_simp_stitching_170", 0.5, 1)
  
  ObjAttach("vid_dressext_simp_stitching_170","zz_dressext")
  VidPlay("vid_dressext_simp_stitching_170",func_end)
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_catandmouseext_entrypointext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cinderellastaffext" ] = { type = "get", get_obj = "spr_dressext_cinderellastaffext", room = "rm_entrypointext", zz = "zz_dressext", zz_gate = "gzz_entrypointext_dressext" };

private.get_cinderellastaffext_logic = function()
  ObjSet( "spr_dressext_mouseext", {  input = 1, active = 1 } )
    
end;
private.get_cinderellastaffext_inv = function()
  interface.InventoryItemAdd("inv_cinderellastaffext","spr_dressext_cinderellastaffext");
  ObjSet( "inv_cinderellastaffext", { drag = 0 } );
end;
private.get_cinderellastaffext_beg = function()
  ObjDelete("gfx_dressext_cinderellastaffext")
  ObjSet( "spr_dressext_cinderellastaffext", {visible = 1} );
  ObjDelete("spr_dressext_dresslace_ok")
  ObjDelete("spr_dressext_cinderellastaffext_tr")
end;
private.get_cinderellastaffext_end = function()
  ObjDelete("spr_entrypointext_dress")
  ObjDelete("spr_entrypointext_krujeva")
  ObjDelete("spr_dressext_cinderellastaffext_sh")
  ObjSet( "spr_entrypointext_no_dress", {visible = 1} );
  ObjSet( "gfx_dressext_mouseext", { visible = 1,  active = 1 } )
  
  if common_impl.ZzCompleteCheck("get_cinderellastaffext") then ObjSet( common_impl.hint["get_cinderellastaffext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_cinderellastaffext", private.get_cinderellastaffext_inv );
cmn.AddSubscriber( "get_cinderellastaffext", private.get_cinderellastaffext_beg, private.room_objname );
cmn.AddSubscriber( "get_cinderellastaffext", private.get_cinderellastaffext_end, private.room_objname );
cmn.AddSubscriber( "get_cinderellastaffext", private.get_cinderellastaffext_logic );
--------------------------------------------------------------------
function public.get_cinderellastaffext()
  cmn.SetEventDone( "get_cinderellastaffext" );

  cmn.CallEventHandler( "get_cinderellastaffext" );
  if common_impl.ZzCompleteCheck("get_cinderellastaffext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_mouseext" ] = { type = "get", get_obj = "spr_dressext_mouseext", room = "rm_entrypointext", zz = "zz_dressext", zz_gate = "gzz_entrypointext_dressext" };

private.get_mouseext_logic = function()
  ObjSet( "gfx_entrypointext_dlg_entrypointext_fairyext3_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_mouseext_inv = function()
  interface.InventoryItemAdd("inv_mouseext","spr_dressext_mouseext");
end;
private.get_mouseext_beg = function()
  ObjSet( "spr_dressext_mouseext", {visible = 1} );
  ObjDelete("gfx_dressext_mouseext")
end;
private.get_mouseext_end = function()
  ObjDelete("vid_entrypointext_simp_3_mouse_static_79")
  ObjDelete("vid_dressext_simp_mouse_1_static_79")
end;

cmn.AddSubscriber( "get_mouseext", private.get_mouseext_inv );
cmn.AddSubscriber( "get_mouseext", private.get_mouseext_beg, private.room_objname );
cmn.AddSubscriber( "get_mouseext", private.get_mouseext_end, private.room_objname );
cmn.AddSubscriber( "get_mouseext", private.get_mouseext_logic );
--------------------------------------------------------------------
function public.get_mouseext()
  ObjSet( common_impl.hint["get_cinderellastaffext"].zz_gate, { visible = 0, input = 0 } );
  cmn.CallEventHandler( "get_mouseext" );
  ld.CloseSubRoom()
  ld.Lock(1)
  ld.StartTimer( 0.5, function() ld.Lock(0) public.dlg_entrypointext_fairyext3( obj ) end )
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_secondfloordoorext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_screwdriverhandleext" ] = { type = "get", get_obj = "spr_secondfloordoorext_screwdriverhandleext", room = "rm_entrypointext", zz = "zz_secondfloordoorext", zz_gate = "gzz_entrypointext_secondfloordoorext" };

private.get_screwdriverhandleext_logic = function()
  ObjSet( "gfx_secondfloordoorext_snowmanext_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_screwdriverhandleext_inv = function()
  interface.InventoryItemAdd("inv_screwdriverhandleext","spr_secondfloordoorext_screwdriverhandleext");
end;
private.get_screwdriverhandleext_beg = function()
  ObjDelete("gfx_secondfloordoorext_screwdriverhandleext")
end;
private.get_screwdriverhandleext_end = function()
  ObjDelete("spr_secondfloordoorext_screwdriverhandleext_tr")
  ObjDelete("spr_secondfloordoorext_screwdriverhandleext_sh")
  ObjDelete("spr_entrypointext_screwdriverhandleext")
  if common_impl.ZzCompleteCheck("get_screwdriverhandleext") then ObjSet( common_impl.hint["get_screwdriverhandleext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_screwdriverhandleext", private.get_screwdriverhandleext_inv );
cmn.AddSubscriber( "get_screwdriverhandleext", private.get_screwdriverhandleext_beg, private.room_objname );
cmn.AddSubscriber( "get_screwdriverhandleext", private.get_screwdriverhandleext_end, private.room_objname );
cmn.AddSubscriber( "get_screwdriverhandleext", private.get_screwdriverhandleext_logic );
--------------------------------------------------------------------
function public.get_screwdriverhandleext()
  cmn.SetEventDone( "get_screwdriverhandleext" );
  cmn.CallEventHandler( "get_screwdriverhandleext" );
  if common_impl.ZzCompleteCheck("get_screwdriverhandleext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_snowmanext" ] = { type = "use", inv_obj = "inv_snowmanext", use_place = "gfx_secondfloordoorext_snowmanext_zone", room = "rm_entrypointext", zz = "zz_secondfloordoorext", zz_gate = "gzz_entrypointext_secondfloordoorext" };

private.use_snowmanext_logic = function()
  ObjSet( "grm_entrypointext_corridorext", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_entrypointext_corridorext_focus");
    end;

end;
private.use_snowmanext_inv = function()
  common_impl.ProcessMultiUseAll("snowmanext", "snowmanext")
end;
private.use_snowmanext_beg = function()
  ObjDelete( "gfx_secondfloordoorext_snowmanext_zone" );
end;
private.use_snowmanext_end = function()
  ObjSet( "anm_entrypointext_anim_door", {animfunc = "open_coridor_door", frame = 999 } );
  ObjSet( "anm_secondfloordoorext_anm", {animfunc = "use_snowman", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_snowmanext") then ObjSet( common_impl.hint["use_snowmanext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_snowmanext", private.use_snowmanext_inv );
cmn.AddSubscriber( "use_snowmanext", private.use_snowmanext_beg, private.room_objname );
cmn.AddSubscriber( "use_snowmanext", private.use_snowmanext_end, private.room_objname );
cmn.AddSubscriber( "use_snowmanext", private.use_snowmanext_logic );
cmn.AddSubscriber( "use_snowmanext_inv", private.use_snowmanext_inv, private.room_objname );
cmn.AddSubscriber( "use_snowmanext_beg", private.use_snowmanext_beg, private.room_objname );
cmn.AddSubscriber( "use_snowmanext_end", private.use_snowmanext_end, private.room_objname );
cmn.AddSubscriber( "use_snowmanext_end", private.use_snowmanext_logic );
--------------------------------------------------------------------------------------------
function public.use_snowmanext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_snowmanext" );
    cmn.CallEventHandler( "use_snowmanext_end" );
    common_impl.Lock(0);
    --if common_impl.ZzCompleteCheck("use_snowmanext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_snowmanext_inv" );
  cmn.CallEventHandler( "use_snowmanext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_secondfloordoorext_anm", "use_snowman", function() 
    ld.CloseSubRoom() 
    ld.AnimPlay( "anm_entrypointext_anim_door", "open_coridor_door", function() 
      func_end()
    end );
  end );
  SoundSfx( "aud_use_snowmanext_entrypointext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_tableext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_mulledwineext" ] = { type = "get", get_obj = "spr_tableext_mulledwineext", room = "rm_entrypointext", zz = "zz_tableext", zz_gate = "gzz_entrypointext_tableext" };

private.get_mulledwineext_logic = function()
  
end;
private.get_mulledwineext_inv = function()
  interface.InventoryItemAdd("inv_mulledwineext","spr_tableext_mulledwineext");
end;
private.get_mulledwineext_beg = function()
  ObjDelete("gfx_tableext_mulledwineext")
end;
private.get_mulledwineext_end = function()
  ObjDelete("spr_tableext_mulledwineext_sh")
  ObjDelete("spr_entrypointext_mulledwineext")
  if common_impl.ZzCompleteCheck("get_mulledwineext") then ObjSet( common_impl.hint["get_mulledwineext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_mulledwineext", private.get_mulledwineext_inv );
cmn.AddSubscriber( "get_mulledwineext", private.get_mulledwineext_beg, private.room_objname );
cmn.AddSubscriber( "get_mulledwineext", private.get_mulledwineext_end, private.room_objname );
cmn.AddSubscriber( "get_mulledwineext", private.get_mulledwineext_logic );
--------------------------------------------------------------------
function public.get_mulledwineext()
  cmn.SetEventDone( "get_mulledwineext" );
  cmn.CallEventHandler( "get_mulledwineext" );
  if common_impl.ZzCompleteCheck("get_mulledwineext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_snowmanbodyext" ] = { type = "get", get_obj = "spr_tableext_snowmanbodyext", room = "rm_entrypointext", zz = "zz_tableext", zz_gate = "gzz_entrypointext_tableext" };

private.get_snowmanbodyext_logic = function()
  
end;
private.get_snowmanbodyext_inv = function()
  interface.InventoryItemAdd("inv_snowmanbodyext","spr_tableext_snowmanbodyext");
end;
private.get_snowmanbodyext_beg = function()
  ObjDelete("gfx_tableext_snowmanbodyext")
end;
private.get_snowmanbodyext_end = function()
  ObjDelete("spr_tableext_snowmanbodyext_sh")
  ObjDelete("spr_tableext_snowmanbodyext_tr")
  ObjDelete("spr_entrypointext_snowmanbodyext")
  if common_impl.ZzCompleteCheck("get_snowmanbodyext") then ObjSet( common_impl.hint["get_snowmanbodyext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_snowmanbodyext", private.get_snowmanbodyext_inv );
cmn.AddSubscriber( "get_snowmanbodyext", private.get_snowmanbodyext_beg, private.room_objname );
cmn.AddSubscriber( "get_snowmanbodyext", private.get_snowmanbodyext_end, private.room_objname );
cmn.AddSubscriber( "get_snowmanbodyext", private.get_snowmanbodyext_logic );
--------------------------------------------------------------------
function public.get_snowmanbodyext()
  cmn.SetEventDone( "get_snowmanbodyext" );
  cmn.CallEventHandler( "get_snowmanbodyext" );
  if common_impl.ZzCompleteCheck("get_snowmanbodyext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_sunrayext" ] = { type = "use", inv_obj = "inv_sunrayext", use_place = "gfx_tableext_sunrayext_zone", room = "rm_entrypointext", zz = "zz_tableext", zz_gate = "gzz_entrypointext_tableext" };

private.use_sunrayext_logic = function()
  ObjSet( "gfx_tableext_win_worktableext_zone", { visible = 1, input = 1, active = 1 } )
  
end;
private.use_sunrayext_inv = function()
  ld.mmgZoomInit("win_worktableext");
  common_impl.ProcessMultiUseAll("sunrayext", "sunrayext")
end;
private.use_sunrayext_beg = function()
  ObjDelete( "gfx_tableext_sunrayext_zone" );
end;
private.use_sunrayext_end = function()
  ObjDelete("anm_tableext_anm_ray")
  ObjSet( "spr_tableext_hh", {visible = 1} );
  ObjSet( "spr_tableext_cover_ee", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_sunrayext") then ObjSet( common_impl.hint["use_sunrayext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sunrayext", private.use_sunrayext_inv );
cmn.AddSubscriber( "use_sunrayext", private.use_sunrayext_beg, private.room_objname );
cmn.AddSubscriber( "use_sunrayext", private.use_sunrayext_end, private.room_objname );
cmn.AddSubscriber( "use_sunrayext", private.use_sunrayext_logic );
cmn.AddSubscriber( "use_sunrayext_inv", private.use_sunrayext_inv, private.room_objname );
cmn.AddSubscriber( "use_sunrayext_beg", private.use_sunrayext_beg, private.room_objname );
cmn.AddSubscriber( "use_sunrayext_end", private.use_sunrayext_end, private.room_objname );
cmn.AddSubscriber( "use_sunrayext_end", private.use_sunrayext_logic );
--------------------------------------------------------------------------------------------
function public.use_sunrayext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_sunrayext" );
    cmn.CallEventHandler( "use_sunrayext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_sunrayext") then ld.CloseSubRoom() end;

  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sunrayext_inv" );
  cmn.CallEventHandler( "use_sunrayext_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_sunrayext_entrypointext" )
  public.win_worktableext_load()
  ObjGet( "gfx_tableext_win_worktableext_zone" ).event_mdown()  
  ld.StartTimer( 0.5, function()  
    ld.AnimPlay( "anm_tableext_anm_ray", "use_sunray", func_end )
  end )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_worktableext" ] = { type = "click", use_place = "gfx_tableext_win_worktableext_zone", room = "rm_entrypointext", zz = "zz_tableext", zz_gate = "gzz_entrypointext_tableext" };

private.win_worktableext_logic = function()
  if ld.CheckRequirements( {"win_worktableext"} ) then
    ObjSet( "spr_tableext_mousefigureext1", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_tableext_matchesext", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_worktableext_beg = function(force)
  if ld.CheckRequirements( {"win_worktableext"} ) or force then
    ObjDelete( "gfx_tableext_win_worktableext_zone" );
    ObjSet( "anm_tableext_anm_cover", {visible = 1} );
    ObjDelete("spr_tableext_cover")
    ObjDelete("spr_tableext_cover_ee")
  end
end;
private.win_worktableext_end = function()
  if ld.CheckRequirements( {"win_worktableext"} ) then
    ObjSet( "anm_tableext_anm_cover", {animfunc = "end_mmg", frame = 999 } );
    ObjDelete("spr_entrypointext_cover")
    ObjSet( "spr_entrypointext_cover_open", {visible = 1} );
    if common_impl.ZzCompleteCheck("win_worktableext") then ObjSet( common_impl.hint["win_worktableext"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_worktableext", private.win_worktableext_beg, private.room_objname );
cmn.AddSubscriber( "win_worktableext", private.win_worktableext_end, private.room_objname );
cmn.AddSubscriber( "win_worktableext", private.win_worktableext_logic );
cmn.AddSubscriber( "win_worktableext_beg", private.win_worktableext_beg, private.room_objname );
cmn.AddSubscriber( "win_worktableext_end", private.win_worktableext_end, private.room_objname );
cmn.AddSubscriber( "win_worktableext_end", private.win_worktableext_logic );
--------------------------------------------------------------------------------------------
function public.win_worktableext()

  local func_end = function()
    cmn.SetEventDone( "win_worktableext" );
    cmn.CallEventHandler( "win_worktableext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_worktableext") then ld.CloseSubRoom() end;
  end;
  
  cmn.CallEventHandler( "win_worktableext_beg" );
  private.win_worktableext_beg(true);
  common_impl.Lock(1);
  
  
  --SoundSfx( 0 )
  --func_end()
  cmn.MiniGameHide( "worktableext", true );
  SoundSfx( "aud_win_tableext" )
  ld.StartTimer( 1, function() 
    ObjGet( "obj_tableext_win_worktableext_zoom" ).event_mdown()
    ld.StartTimer( 1, function() 
      ld.AnimPlay( "anm_tableext_anm_cover", "end_mmg", func_end );
    end)
  end )
  

end;
--------------------------------------------------------------------------------------------
local win_worktableext_loaded
function public.win_worktableext_load(reset,skip)
  local animtime = 0.5
  local begstate = {5, -8}
  local winstate = {0, 0}  
  local moon = "spr_tableext_moon"
  local step = 20
  
  local obj = "spr_tableext_win_worktableext_test"
  if not ng_global.progress["ext"]["win_worktableext"].state or reset then
    ng_global.progress["ext"]["win_worktableext"].state = ld.TableCopy(begstate)
  end
  local function dir(i) 
    local a = 2
    local s = 6
    local d = 9
    local arr = {
      {0,-d},
      {-d,d},
      {a,-a},
      {-s,-s},
      {0,s},
      {s,s},
      {-s,0},
      {d,0}
    }
    return arr[i][1],arr[i][2]
  end
  local function load_map(skip)
    local toload = skip and winstate or ng_global.progress["ext"]["win_worktableext"].state
    ObjSet( moon, {pos_x = step*toload[1], pos_y = step*toload[2]} );
    
    if not win_worktableext_loaded then
      local lightTime = 0.2
      for i,o in ipairs(ObjGetRelations( "obj_tableext_win_worktableext_root_rays" ).childs) do
        ld.CopyObj(o, o.."_light", "spr", o)
        ObjSet( o.."_light", {pos_x = 0, pos_y = 0, blendmode = 2, alp = 0, visible = 1} );
        ObjSet( o, {event_mdown = function() public.win_worktableext_click(o, dir(i)) end;
        event_menter = function() 
          ld.ShCur(CURSOR_HAND) 
          ObjAnimate( o.."_light", 8, 0, 0, function() end, {0,0,ObjGet(o.."_light").alp, lightTime,0,1} ); 
        end;
        event_mleave = function() 
          ld.ShCur(CURSOR_DEFAULT) 
          ObjAnimate( o.."_light", 8, 0, 0, function() end, {0,0,ObjGet(o.."_light").alp, lightTime,0,0} ); 
        end;
        input = 1;
        } );
      end
    end
  end

  --wincheck
  local prevstate
  local function wincheck(skip)
    local function win()
      public.win_worktableext()
    end
    if ld.TableEquals(ng_global.progress["ext"]["win_worktableext"].state,winstate) or skip then
      if not skip then
        ng_global.progress["ext"]["win_worktableext"].state = ld.TableCopy(prevstate)
      end
      ld.Lock(1)
      win()
    end
  end

  --load
  local function load(skip)
    load_map(skip)
    win_worktableext_loaded = true
  end
  local function chooseload(reset,skip)
    if reset or skip then
      local toload = skip and winstate or begstate
      local time = animtime
      ld.Lock(1)
      ld.StartTimer( time, function() ld.Lock(0) load(skip) wincheck(skip)  end )
      ObjAnimate( moon, 3, 0, 0, function() end, {0,3,ObjGet(moon).pos_x,ObjGet(moon).pos_y, 
                                               time,3,toload[1]*step,toload[2]*step} );
    else
      load()
    end
  end
  chooseload(reset,skip)
  --save
  local function save(x,y)
    prevstate = ld.TableCopy(ng_global.progress["ext"]["win_worktableext"].state)
    ng_global.progress["ext"]["win_worktableext"].state[1] = ng_global.progress["ext"]["win_worktableext"].state[1] + x
    ng_global.progress["ext"]["win_worktableext"].state[2] = ng_global.progress["ext"]["win_worktableext"].state[2] + y
    --ld.LogTrace( ng_global.progress["ext"]["win_worktableext"].state );
    wincheck()
  end  

  --public
  function public.win_worktableext_click(sender,x,y)
    local rx = (ng_global.progress["ext"]["win_worktableext"].state[1]+x) 
    local ry = (ng_global.progress["ext"]["win_worktableext"].state[2]+y)

    local dist = rx^2 + ry^2
    if (dist>160) then
      --wronganim
      return
    end
    SoundSfx( "aud_clk_ray_sun" )
    local time = animtime
    ld.Lock(1)
    local scalePresed = 0.9
    ObjAnimate( sender, 6, 0, 0, function() end, {0,3,1,1, time/6,3,scalePresed,scalePresed, time/3,3,1,1 } );
    ld.StartTimer( time, function() ld.Lock(0) save(x,y) end )
    ObjAnimate( moon, 3, 0, 0, function() end, {0,3,ObjGet(moon).pos_x,ObjGet(moon).pos_y, 
                                             time,3,ObjGet(moon).pos_x + x*step,ObjGet(moon).pos_y + y*step} );
  end
end
--------------------------------------------------------------------
common_impl.hint[ "get_mousefigureext1" ] = { type = "get", get_obj = "spr_tableext_mousefigureext1", room = "rm_entrypointext", zz = "zz_tableext", zz_gate = "gzz_entrypointext_tableext" };

private.get_mousefigureext1_logic = function()
  
end;
private.get_mousefigureext1_inv = function()
  interface.InventoryItemAdd("inv_mousefigureext1","spr_tableext_mousefigureext1");
end;
private.get_mousefigureext1_beg = function()
  ObjDelete("gfx_tableext_mousefigureext1")
end;
private.get_mousefigureext1_end = function()
  ObjDelete("spr_entrypointext_mousefigureext1")
  if common_impl.ZzCompleteCheck("get_mousefigureext1") then ObjSet( common_impl.hint["get_mousefigureext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_mousefigureext1", private.get_mousefigureext1_inv );
cmn.AddSubscriber( "get_mousefigureext1", private.get_mousefigureext1_beg, private.room_objname );
cmn.AddSubscriber( "get_mousefigureext1", private.get_mousefigureext1_end, private.room_objname );
cmn.AddSubscriber( "get_mousefigureext1", private.get_mousefigureext1_logic );
--------------------------------------------------------------------
function public.get_mousefigureext1()
  cmn.SetEventDone( "get_mousefigureext1" );
  cmn.CallEventHandler( "get_mousefigureext1" );
  if common_impl.ZzCompleteCheck("get_mousefigureext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_matchesext" ] = { type = "get", get_obj = "spr_tableext_matchesext", room = "rm_entrypointext", zz = "zz_tableext", zz_gate = "gzz_entrypointext_tableext" };

private.get_matchesext_logic = function()
  
end;
private.get_matchesext_inv = function()
  interface.InventoryItemAdd("inv_matchesext","spr_tableext_matchesext");
end;
private.get_matchesext_beg = function()
  ObjDelete("gfx_tableext_matchesext")
end;
private.get_matchesext_end = function()
  ObjDelete("spr_entrypointext_matchesext")
  if common_impl.ZzCompleteCheck("get_matchesext") then ObjSet( common_impl.hint["get_matchesext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_matchesext", private.get_matchesext_inv );
cmn.AddSubscriber( "get_matchesext", private.get_matchesext_beg, private.room_objname );
cmn.AddSubscriber( "get_matchesext", private.get_matchesext_end, private.room_objname );
cmn.AddSubscriber( "get_matchesext", private.get_matchesext_logic );
--------------------------------------------------------------------
function public.get_matchesext()
  cmn.SetEventDone( "get_matchesext" );
  cmn.CallEventHandler( "get_matchesext" );
  if common_impl.ZzCompleteCheck("get_matchesext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletmittenext" ] = { type = "use", inv_obj = "inv_amuletmittenext", use_place = "gfx_tableext_amuletmittenext_zone", room = "rm_entrypointext", zz = "zz_tableext", zz_gate = "gzz_entrypointext_tableext" };

private.use_amuletmittenext_logic = function()
  ObjSet( "spr_tableext_lockpickext", {  input = 1, active = 1 } )
  ObjSet( "spr_tableext_towerext", {  input = 1, active = 1 } )

end;
private.use_amuletmittenext_inv = function()
  common_impl.ProcessMultiUseAll("amuletmittenext", "amuletmittenext")
end;
private.use_amuletmittenext_beg = function()
  ObjDelete( "gfx_tableext_amuletmittenext_zone" );
end;
private.use_amuletmittenext_end = function()
  ObjSet( "gfx_tableext_lockpickext", { visible = 1, active = 1 } )
  ObjSet( "gfx_tableext_towerext", { visible = 1, active = 1 } )
  ObjSet( "anm_tableext_anm_box", {animfunc = "use_amuletmitten", frame = 999 } );
  ObjDelete("spr_entrypointext_table_box_in")
  ObjSet( "spr_entrypointext_table_box_out", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_amuletmittenext") then ObjSet( common_impl.hint["use_amuletmittenext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletmittenext", private.use_amuletmittenext_inv );
cmn.AddSubscriber( "use_amuletmittenext", private.use_amuletmittenext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletmittenext", private.use_amuletmittenext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletmittenext", private.use_amuletmittenext_logic );
cmn.AddSubscriber( "use_amuletmittenext_inv", private.use_amuletmittenext_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletmittenext_beg", private.use_amuletmittenext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletmittenext_end", private.use_amuletmittenext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletmittenext_end", private.use_amuletmittenext_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletmittenext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletmittenext" );
    cmn.CallEventHandler( "use_amuletmittenext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletmittenext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletmittenext_inv" );
  cmn.CallEventHandler( "use_amuletmittenext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_tableext_anm_box", "use_amuletmitten", func_end );
  SoundSfx( "aud_use_amuletmittenext_entrypointext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lockpickext" ] = { type = "get", get_obj = "spr_tableext_lockpickext", room = "rm_entrypointext", zz = "zz_tableext", zz_gate = "gzz_entrypointext_tableext" };

private.get_lockpickext_logic = function()
  
end;
private.get_lockpickext_inv = function()
  interface.InventoryItemAdd("inv_lockpickext","spr_tableext_lockpickext");
end;
private.get_lockpickext_beg = function()
  ObjDelete("gfx_tableext_lockpickext")
  ObjSet( "spr_tableext_lockpickext", {visible = 1} );
end;
private.get_lockpickext_end = function()
  if ld.CheckRequirements( {"get_lockpickext","get_towerext"} ) then
    ObjSet( "anm_tableext_anm_box", {animfunc = "end_amuletmitten3", frame = 0 } );
  else
    ObjSet( "anm_tableext_anm_box", {animfunc = "end_amuletmitten2", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("get_lockpickext") then ObjSet( common_impl.hint["get_lockpickext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lockpickext", private.get_lockpickext_inv );
cmn.AddSubscriber( "get_lockpickext", private.get_lockpickext_beg, private.room_objname );
cmn.AddSubscriber( "get_lockpickext", private.get_lockpickext_end, private.room_objname );
cmn.AddSubscriber( "get_lockpickext", private.get_lockpickext_logic );
--------------------------------------------------------------------
function public.get_lockpickext()
  cmn.SetEventDone( "get_lockpickext" );
  cmn.CallEventHandler( "get_lockpickext" );
  if common_impl.ZzCompleteCheck("get_lockpickext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_towerext" ] = { type = "get", get_obj = "spr_tableext_towerext", room = "rm_entrypointext", zz = "zz_tableext", zz_gate = "gzz_entrypointext_tableext" };

private.get_towerext_logic = function()
  
end;
private.get_towerext_inv = function()
  interface.InventoryItemAdd("inv_towerext","spr_tableext_towerext");
  ObjSet( "inv_towerext", { drag = 0 } );
end;
private.get_towerext_beg = function()
  ObjDelete("gfx_tableext_towerext")
  ObjSet( "spr_tableext_towerext", {visible = 1} );
end;
private.get_towerext_end = function()
  if ld.CheckRequirements( {"get_lockpickext","get_towerext"} ) then
    ObjSet( "anm_tableext_anm_box", {animfunc = "end_amuletmitten3", frame = 0 } );
  else
    ObjSet( "anm_tableext_anm_box", {animfunc = "end_amuletmitten1", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("get_towerext") then ObjSet( common_impl.hint["get_towerext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_towerext", private.get_towerext_inv );
cmn.AddSubscriber( "get_towerext", private.get_towerext_beg, private.room_objname );
cmn.AddSubscriber( "get_towerext", private.get_towerext_end, private.room_objname );
cmn.AddSubscriber( "get_towerext", private.get_towerext_logic );
--------------------------------------------------------------------
function public.get_towerext()
  cmn.SetEventDone( "get_towerext" );
  cmn.CallEventHandler( "get_towerext" );
  if common_impl.ZzCompleteCheck("get_towerext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_mirrorext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_snowmanheadext" ] = { type = "get", get_obj = "spr_mirrorext_snowmanheadext", room = "rm_entrypointext", zz = "zz_mirrorext", zz_gate = "gzz_entrypointext_mirrorext" };

private.get_snowmanheadext_logic = function()
  
end;
private.get_snowmanheadext_inv = function()
  interface.InventoryItemAdd("inv_snowmanheadext","spr_mirrorext_snowmanheadext");
end;
private.get_snowmanheadext_beg = function()
  ObjDelete("gfx_mirrorext_snowmanheadext")
end;
private.get_snowmanheadext_end = function()
  ObjDelete("spr_mirrorext_snowmanheadext_sh")
  ObjDelete("spr_entrypointext_snowmanheadext")
  if common_impl.ZzCompleteCheck("get_snowmanheadext") then ObjSet( common_impl.hint["get_snowmanheadext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_snowmanheadext", private.get_snowmanheadext_inv );
cmn.AddSubscriber( "get_snowmanheadext", private.get_snowmanheadext_beg, private.room_objname );
cmn.AddSubscriber( "get_snowmanheadext", private.get_snowmanheadext_end, private.room_objname );
cmn.AddSubscriber( "get_snowmanheadext", private.get_snowmanheadext_logic );
--------------------------------------------------------------------
function public.get_snowmanheadext()
  cmn.SetEventDone( "get_snowmanheadext" );
  cmn.CallEventHandler( "get_snowmanheadext" );
  if common_impl.ZzCompleteCheck("get_snowmanheadext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_screwdriverext_mirrorext" ] = { type = "use", inv_obj = "inv_screwdriverext", use_place = "gfx_mirrorext_screwdriverext_mirrorext_zone", room = "rm_entrypointext", zz = "zz_mirrorext", zz_gate = "gzz_entrypointext_mirrorext" };

private.use_screwdriverext_mirrorext_logic = function()
  ObjSet( "spr_mirrorext_boltext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_mirrorext_plasticineext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_mirrorext_mousefigureext2", { visible = 1, input = 1, active = 1 } )

end;
private.use_screwdriverext_mirrorext_inv = function()
  common_impl.ProcessMultiUseAll("screwdriverext", "screwdriverext_mirrorext")
end;
private.use_screwdriverext_mirrorext_beg = function()
  ObjDelete( "gfx_mirrorext_screwdriverext_mirrorext_zone" );
end;
private.use_screwdriverext_mirrorext_end = function()
  ObjSet( "spr_mirrorext_plasticineext_sh", {visible = 1} );
  ObjSet( "spr_mirrorext_plasticineext_tr", {visible = 1} );
  ObjSet( "spr_mirrorext_mousefigureext2_sh", {visible = 1} );
  ObjSet( "spr_mirrorext_boltext_sh", {visible = 1} );
  ObjSet( "gfx_mirrorext_plasticineext", {active = 1, visible = 1} );
  ObjDelete("anm_mirrorext_anm_vent")
  if common_impl.ZzCompleteCheck("use_screwdriverext_mirrorext") then ObjSet( common_impl.hint["use_screwdriverext_mirrorext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_screwdriverext_mirrorext", private.use_screwdriverext_mirrorext_inv );
cmn.AddSubscriber( "use_screwdriverext_mirrorext", private.use_screwdriverext_mirrorext_beg, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext_mirrorext", private.use_screwdriverext_mirrorext_end, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext_mirrorext", private.use_screwdriverext_mirrorext_logic );
cmn.AddSubscriber( "use_screwdriverext_mirrorext_inv", private.use_screwdriverext_mirrorext_inv, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext_mirrorext_beg", private.use_screwdriverext_mirrorext_beg, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext_mirrorext_end", private.use_screwdriverext_mirrorext_end, private.room_objname );
cmn.AddSubscriber( "use_screwdriverext_mirrorext_end", private.use_screwdriverext_mirrorext_logic );
--------------------------------------------------------------------------------------------
function public.use_screwdriverext_mirrorext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_screwdriverext_mirrorext" );
    cmn.CallEventHandler( "use_screwdriverext_mirrorext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_screwdriverext_mirrorext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_screwdriverext_mirrorext_inv" );
  cmn.CallEventHandler( "use_screwdriverext_mirrorext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mirrorext_anm_vent", "use_screwdriver", func_end );
  SoundSfx( "aud_use_screwdriverext_mirrorext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_boltext" ] = { type = "get", get_obj = "spr_mirrorext_boltext", room = "rm_entrypointext", zz = "zz_mirrorext", zz_gate = "gzz_entrypointext_mirrorext" };

private.get_boltext_logic = function()
  
end;
private.get_boltext_inv = function()
  interface.InventoryItemAdd("inv_boltext","spr_mirrorext_boltext");
end;
private.get_boltext_beg = function()
  ObjDelete("gfx_mirrorext_boltext")
end;
private.get_boltext_end = function()
  ObjDelete("spr_mirrorext_boltext_sh")
  if common_impl.ZzCompleteCheck("get_boltext") then ObjSet( common_impl.hint["get_boltext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_boltext", private.get_boltext_inv );
cmn.AddSubscriber( "get_boltext", private.get_boltext_beg, private.room_objname );
cmn.AddSubscriber( "get_boltext", private.get_boltext_end, private.room_objname );
cmn.AddSubscriber( "get_boltext", private.get_boltext_logic );
--------------------------------------------------------------------
function public.get_boltext()
  cmn.SetEventDone( "get_boltext" );
  cmn.CallEventHandler( "get_boltext" );
  if common_impl.ZzCompleteCheck("get_boltext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_plasticineext" ] = { type = "get", get_obj = "spr_mirrorext_plasticineext", room = "rm_entrypointext", zz = "zz_mirrorext", zz_gate = "gzz_entrypointext_mirrorext" };

private.get_plasticineext_logic = function()
  
end;
private.get_plasticineext_inv = function()
  interface.InventoryItemAdd("inv_plasticineext","spr_mirrorext_plasticineext");
end;
private.get_plasticineext_beg = function()
  ObjDelete("gfx_mirrorext_plasticineext")
end;
private.get_plasticineext_end = function()
  ObjDelete("spr_mirrorext_plasticineext_sh")
  ObjDelete("spr_mirrorext_plasticineext_tr")
  if common_impl.ZzCompleteCheck("get_plasticineext") then ObjSet( common_impl.hint["get_plasticineext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_plasticineext", private.get_plasticineext_inv );
cmn.AddSubscriber( "get_plasticineext", private.get_plasticineext_beg, private.room_objname );
cmn.AddSubscriber( "get_plasticineext", private.get_plasticineext_end, private.room_objname );
cmn.AddSubscriber( "get_plasticineext", private.get_plasticineext_logic );
--------------------------------------------------------------------
function public.get_plasticineext()
  cmn.SetEventDone( "get_plasticineext" );
  cmn.CallEventHandler( "get_plasticineext" );
  if common_impl.ZzCompleteCheck("get_plasticineext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_mousefigureext2" ] = { type = "get", get_obj = "spr_mirrorext_mousefigureext2", room = "rm_entrypointext", zz = "zz_mirrorext", zz_gate = "gzz_entrypointext_mirrorext" };

private.get_mousefigureext2_logic = function()
  
end;
private.get_mousefigureext2_inv = function()
  interface.InventoryItemAdd("inv_mousefigureext2","spr_mirrorext_mousefigureext2");
end;
private.get_mousefigureext2_beg = function()
  ObjDelete("gfx_mirrorext_mousefigureext2")
end;
private.get_mousefigureext2_end = function()
  ObjDelete("spr_mirrorext_mousefigureext2_sh")
  if common_impl.ZzCompleteCheck("get_mousefigureext2") then ObjSet( common_impl.hint["get_mousefigureext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_mousefigureext2", private.get_mousefigureext2_inv );
cmn.AddSubscriber( "get_mousefigureext2", private.get_mousefigureext2_beg, private.room_objname );
cmn.AddSubscriber( "get_mousefigureext2", private.get_mousefigureext2_end, private.room_objname );
cmn.AddSubscriber( "get_mousefigureext2", private.get_mousefigureext2_logic );
--------------------------------------------------------------------
function public.get_mousefigureext2()
  cmn.SetEventDone( "get_mousefigureext2" );
  cmn.CallEventHandler( "get_mousefigureext2" );
  if common_impl.ZzCompleteCheck("get_mousefigureext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_coloredglassext" ] = { type = "use", inv_obj = "inv_coloredglassext", use_place = "gfx_mirrorext_coloredglassext_zone", room = "rm_entrypointext", zz = "zz_mirrorext", zz_gate = "gzz_entrypointext_mirrorext" };

private.use_coloredglassext_logic = function()
  ObjSet( "gfx_mirrorext_win_mirrorext_zone", { visible = 1, input = 1, active = 1 } )
  ld.mmgZoomInit("win_mirrorext");
end;
private.use_coloredglassext_inv = function()
  common_impl.ProcessMultiUseAll("coloredglassext", "coloredglassext")
end;
private.use_coloredglassext_beg = function()
  ObjDelete( "gfx_mirrorext_coloredglassext_zone" );
end;
private.use_coloredglassext_end = function()
  ObjSet( "anm_mirrorext_anm_idle_box2", {visible = 1} );
  ObjSet( "anm_mirrorext_anm_idle_box", {animfunc = "use_coloredglass", frame = 999 } );
  ObjSet( "spr_entrypointext_glass_1_floor", {visible = 1} );
  ObjSet( "spr_entrypointext_glass_2_floor", {visible = 1} );
  ObjSet( "spr_entrypointext_glass_3_floor", {visible = 1} );
  ObjSet( "spr_entrypointext_glass_4_floor", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_coloredglassext") then ObjSet( common_impl.hint["use_coloredglassext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_coloredglassext", private.use_coloredglassext_inv );
cmn.AddSubscriber( "use_coloredglassext", private.use_coloredglassext_beg, private.room_objname );
cmn.AddSubscriber( "use_coloredglassext", private.use_coloredglassext_end, private.room_objname );
cmn.AddSubscriber( "use_coloredglassext", private.use_coloredglassext_logic );
cmn.AddSubscriber( "use_coloredglassext_inv", private.use_coloredglassext_inv, private.room_objname );
cmn.AddSubscriber( "use_coloredglassext_beg", private.use_coloredglassext_beg, private.room_objname );
cmn.AddSubscriber( "use_coloredglassext_end", private.use_coloredglassext_end, private.room_objname );
cmn.AddSubscriber( "use_coloredglassext_end", private.use_coloredglassext_logic );
--------------------------------------------------------------------------------------------
function public.use_coloredglassext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_coloredglassext" );
    cmn.CallEventHandler( "use_coloredglassext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_coloredglassext") then ld.CloseSubRoom() end;
    public.win_mirrorext_load()
    ObjGet( "gfx_mirrorext_win_mirrorext_zone" ).event_mdown()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_coloredglassext_inv" );
  cmn.CallEventHandler( "use_coloredglassext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mirrorext_anm_idle_box", "use_coloredglass", func_end );
  SoundSfx( "aud_use_coloredglassext_entrypointext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_mirrorext" ] = { type = "click", use_place = "gfx_mirrorext_win_mirrorext_zone", room = "rm_entrypointext", zz = "zz_mirrorext", zz_gate = "gzz_entrypointext_mirrorext" };

private.win_mirrorext_logic = function()
  if ld.CheckRequirements( {"win_mirrorext"} ) then
    ObjSet( "spr_mirrorext_scissorspartext", { input = 1, active = 1 } )
    ObjSet( "spr_mirrorext_deerhornsext", {  input = 1, active = 1 } )
  end
end;
private.win_mirrorext_beg = function()
  if ld.CheckRequirements( {"win_mirrorext"} ) then
    ObjDelete( "gfx_mirrorext_win_mirrorext_zone" );
  end
end;
private.win_mirrorext_end = function()
  if ld.CheckRequirements( {"win_mirrorext"} ) then
    ObjDelete("anm_mirrorext_anm_idle_box")
    ObjSet( "gfx_mirrorext_scissorspartext", { visible = 1, active = 1 } )
    ObjSet( "gfx_mirrorext_deerhornsext", { visible = 1, active = 1 } )
    ObjSet( "anm_mirrorext_anm_idle_box2", {animfunc = "end_coloredglass", frame = 999 } );
    ObjSet( "spr_entrypointext_glass", {visible = 1} );
    ObjSet( "spr_entrypointext_mirror_box_open", {visible = 1} );

    ObjSet( "spr_entrypointext_glass_1_floor", {visible = 0} );
    ObjSet( "spr_entrypointext_glass_2_floor", {visible = 0} );
    ObjSet( "spr_entrypointext_glass_3_floor", {visible = 0} );
    ObjSet( "spr_entrypointext_glass_4_floor", {visible = 0} );
    ObjSet( "spr_entrypointext_glass_1", {visible = 1} );
    ObjSet( "spr_entrypointext_glass_2", {visible = 1} );
    ObjSet( "spr_entrypointext_glass_3", {visible = 1} );
    ObjSet( "spr_entrypointext_glass_4", {visible = 1} );

    local names = {"orange", "blue", "green", "dark_green"}
    for _,o in ipairs(names) do
      ObjSet( string.format("spr_mirrorext_anim_glass_mmg_%s_2", o) , {alp=1, visible = 1} ); 
    end
    if common_impl.ZzCompleteCheck("win_mirrorext") then ObjSet( common_impl.hint["win_mirrorext"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_mirrorext", private.win_mirrorext_beg, private.room_objname );
cmn.AddSubscriber( "win_mirrorext", private.win_mirrorext_end, private.room_objname );
cmn.AddSubscriber( "win_mirrorext", private.win_mirrorext_logic );
cmn.AddSubscriber( "win_mirrorext_beg", private.win_mirrorext_beg, private.room_objname );
cmn.AddSubscriber( "win_mirrorext_end", private.win_mirrorext_end, private.room_objname );
cmn.AddSubscriber( "win_mirrorext_end", private.win_mirrorext_logic );
--------------------------------------------------------------------------------------------
function public.win_mirrorext()

  local func_end = function()
    cmn.SetEventDone( "win_mirrorext" );
    cmn.CallEventHandler( "win_mirrorext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_mirrorext") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_mirrorext_beg" );
  common_impl.Lock(1);
  ObjDelete( "gfx_mirrorext_win_mirrorext_zone" );
  ObjDelete("anm_mirrorext_anm_idle_box")
  cmn.MiniGameHide( "mirrorext", true );

  SoundSfx( "aud_win_mirrorext" )

  ld.StartTimer( 0.5, function()  


    ObjGet( "obj_mirrorext_win_mirrorext_zoom" ).event_mdown()
    ld.AnimPlay( "anm_mirrorext_anm_idle_box2", "end_coloredglass", func_end );
  end )
  --SoundSfx( 0 )
  --func_end()

end;

function public.win_mirrorext_load(reset,skip)
  local animtime = 0.5
  local begstate = {false, false, false, false}
  local winstate = {true, true, true, true}  
  local names = {"orange", "blue", "green", "dark_green"}

  if not ng_global.progress["ext"]["win_mirrorext"].state or reset then
    ng_global.progress["ext"]["win_mirrorext"].state = ld.TableCopy(begstate)
  end

  local function part(i)
    return string.format("spr_mirrorext_glass%s_mmg", i)
  end
  local function fromzz_free(i)
    return string.format("spr_mirrorext_anim_glass_mmg_%s", names[i])
  end
  local function fromzz_set(i)
    return string.format("spr_mirrorext_anim_glass_mmg_%s_2", names[i])
  end
  local function fromloc_free(i)
    return string.format("spr_entrypointext_glass_%s_floor", i)
  end
  local function fromloc_set(i)
    return string.format("spr_entrypointext_glass_%s", i)
  end
  local function final(i)
    return string.format("spr_mirrorext_glass%s_mmg_end", i)
  end

  local function load_objs()
    for i,o in ipairs(ng_global.progress["ext"]["win_mirrorext"].state) do
      ObjSet( part(i), { 
        drag = true, pos_z = 1,
        event_mdown = function() SoundSfx( "aud_drag_brush" )  ObjSet(part(i),{pos_z = 15}) end,
        event_dragdrop = function() SoundSfx( "aud_glass_placing" ) ld.ShCur(CURSOR_DEFAULT) ObjSet(part(i),{pos_z = 1}) public.win_mirrorext_drop(i) end,
        event_drag   = function() ld.ShCur(CURSOR_NULL) end,
        event_menter = function() ld.ShCur(CURSOR_GET) end,
        event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end
      } );
      ObjSet( final(i), { 
        event_mdown = function() public.win_mirrorext_click(i) end;
      } );
    end
  end
  local function load_map(skip)
    local toload = skip and winstate or ng_global.progress["ext"]["win_mirrorext"].state
    
    for i,o in ipairs(toload) do
      ObjSet( part(i), {
        input = not o, alp = o and 0 or 1, drag = true, pos_z = 1,
      } );
      ObjSet( final(i), {
        input = o, alp = o and 1 or 0, 
        event_menter = o and function() ld.ShCur(CURSOR_HAND) end or nil,
        event_mleave = o and function() ld.ShCur(CURSOR_DEFAULT) end or nil,
        inputrect_init = not o, inputrect_w = 20, inputrect_h = 20, inputrect_x = -10, inputrect_y = -10
      } );
      ObjSet( fromzz_free(i), {visible = o and 0 or 1} );
      ObjSet( fromzz_set(i), {visible = o and 1 or 0} );
      ObjSet( fromloc_free(i), {visible = o and 0 or 1} );
      ObjSet( fromloc_set(i), {visible = o and 1 or 0} );
    end
  end

  --wincheck
  local prevstate
  local function wincheck(skip)
    local function win()
      public.win_mirrorext()
    end
    
    if ld.TableEquals(ng_global.progress["ext"]["win_mirrorext"].state,winstate) or skip then
      if not skip then
        ng_global.progress["ext"]["win_mirrorext"].state = ld.TableCopy(prevstate)
      end

      ld.Lock(1)
      win()
    end
  end

  --load
  local function load(skip)
    load_objs()
    load_map(skip)
  end
  local function chooseload(reset,skip)
    if reset or skip then
      local toload = skip and winstate or begstate
      local time = animtime
      ld.Lock(1)
      for i,o in ipairs(toload) do
        ObjAnimate( part(i), 8, 0, 0, function() end, {0,0,ObjGet(part(i)).alp, time,0,skip and 0 or 1} );
        ObjAnimate( final(i), 8, 0, 0, function() end, {0,0,ObjGet(final(i)).alp, time,0,skip and 1 or 0} );
      end      
      ld.StartTimer( time, function()  ld.Lock(0) load(skip) wincheck(skip)  end )
    else
      load()
    end
  end
  chooseload(reset,skip)

  --save
  local function save(i, value)
    prevstate = ld.TableCopy(ng_global.progress["ext"]["win_mirrorext"].state)
    ng_global.progress["ext"]["win_mirrorext"].state[i] = value
    load_map()
    wincheck()
  end  

  --public
  function public.win_mirrorext_click(i)
    save(i, false)
  end
  function public.win_mirrorext_drop(i)
    if ApplyObj(part(i), final(i)) then
      save(i, true) 
    end
  end
end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_scissorspartext" ] = { type = "get", get_obj = "spr_mirrorext_scissorspartext", room = "rm_entrypointext", zz = "zz_mirrorext", zz_gate = "gzz_entrypointext_mirrorext" };

private.get_scissorspartext_logic = function()
  
end;
private.get_scissorspartext_inv = function()
  interface.InventoryItemAdd("inv_scissorspartext","spr_mirrorext_scissorspartext");
end;
private.get_scissorspartext_beg = function()
  ObjDelete("gfx_mirrorext_scissorspartext")
  ObjSet( "spr_mirrorext_scissorspartext", {visible = 1} );
end;
private.get_scissorspartext_end = function()
  if ld.CheckRequirements( {"get_scissorspartext", "get_deerhornsext"} ) then
    ObjSet( "anm_mirrorext_anm_idle_box2", {animfunc = "end_coloredglass3", frame = 0 } );
  else
    ObjSet( "anm_mirrorext_anm_idle_box2", {animfunc = "end_coloredglass2", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("get_scissorspartext") then ObjSet( common_impl.hint["get_scissorspartext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_scissorspartext", private.get_scissorspartext_inv );
cmn.AddSubscriber( "get_scissorspartext", private.get_scissorspartext_beg, private.room_objname );
cmn.AddSubscriber( "get_scissorspartext", private.get_scissorspartext_end, private.room_objname );
cmn.AddSubscriber( "get_scissorspartext", private.get_scissorspartext_logic );
--------------------------------------------------------------------
function public.get_scissorspartext()
  cmn.SetEventDone( "get_scissorspartext" );
  cmn.CallEventHandler( "get_scissorspartext" );
  if common_impl.ZzCompleteCheck("get_scissorspartext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_deerhornsext" ] = { type = "get", get_obj = "spr_mirrorext_deerhornsext", room = "rm_entrypointext", zz = "zz_mirrorext", zz_gate = "gzz_entrypointext_mirrorext" };

private.get_deerhornsext_logic = function()
  
end;
private.get_deerhornsext_inv = function()
  interface.InventoryItemAdd("inv_deerhornsext","spr_mirrorext_deerhornsext");
end;
private.get_deerhornsext_beg = function()
  ObjDelete("gfx_mirrorext_deerhornsext")
  ObjSet( "spr_mirrorext_deerhornsext", {visible = 1} );
end;
private.get_deerhornsext_end = function()
  if ld.CheckRequirements( {"get_scissorspartext", "get_deerhornsext"} ) then
    ObjSet( "anm_mirrorext_anm_idle_box2", {animfunc = "end_coloredglass3", frame = 0 } );
  else
    ObjSet( "anm_mirrorext_anm_idle_box2", {animfunc = "end_coloredglass1", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("get_deerhornsext") then ObjSet( common_impl.hint["get_deerhornsext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_deerhornsext", private.get_deerhornsext_inv );
cmn.AddSubscriber( "get_deerhornsext", private.get_deerhornsext_beg, private.room_objname );
cmn.AddSubscriber( "get_deerhornsext", private.get_deerhornsext_end, private.room_objname );
cmn.AddSubscriber( "get_deerhornsext", private.get_deerhornsext_logic );
--------------------------------------------------------------------
function public.get_deerhornsext()
  cmn.SetEventDone( "get_deerhornsext" );
  cmn.CallEventHandler( "get_deerhornsext" );
  if common_impl.ZzCompleteCheck("get_deerhornsext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_tweezersext" ] = { type = "use", inv_obj = "inv_tweezersext", use_place = "gfx_mirrorext_tweezersext_zone", room = "rm_entrypointext", zz = "zz_mirrorext", zz_gate = "gzz_entrypointext_mirrorext" };

private.use_tweezersext_logic = function()
  ObjSet( "spr_mirrorext_bowext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_mirrorext_cogext2", { visible = 1, input = 1, active = 1 } )

end;
private.use_tweezersext_inv = function()
  common_impl.ProcessMultiUseAll("tweezersext", "tweezersext")
end;
private.use_tweezersext_beg = function()
  ObjDelete( "gfx_mirrorext_tweezersext_zone" );
  ObjDelete("anm_mirrorext_anm_use_tweezers_hh1")
  ObjDelete("anm_mirrorext_anm_use_tweezers_hh2")
end;
private.use_tweezersext_end = function()
  ObjSet( "spr_mirrorext_cogext2_sh", {visible = 1} );
  ObjSet( "spr_mirrorext_bowext_sh", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_tweezersext") then ObjSet( common_impl.hint["use_tweezersext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_tweezersext", private.use_tweezersext_inv );
cmn.AddSubscriber( "use_tweezersext", private.use_tweezersext_beg, private.room_objname );
cmn.AddSubscriber( "use_tweezersext", private.use_tweezersext_end, private.room_objname );
cmn.AddSubscriber( "use_tweezersext", private.use_tweezersext_logic );
cmn.AddSubscriber( "use_tweezersext_inv", private.use_tweezersext_inv, private.room_objname );
cmn.AddSubscriber( "use_tweezersext_beg", private.use_tweezersext_beg, private.room_objname );
cmn.AddSubscriber( "use_tweezersext_end", private.use_tweezersext_end, private.room_objname );
cmn.AddSubscriber( "use_tweezersext_end", private.use_tweezersext_logic );
--------------------------------------------------------------------------------------------
function public.use_tweezersext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_tweezersext" );
    cmn.CallEventHandler( "use_tweezersext_end" );
    common_impl.Lock(0);
    ObjDelete("anm_mirrorext_anm_use_tweezers")
    if common_impl.ZzCompleteCheck("use_tweezersext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_tweezersext_inv" );
  cmn.CallEventHandler( "use_tweezersext_beg" );
  common_impl.Lock(1);
  ObjSet( "anm_mirrorext_anm_use_tweezers", {visible = 1} );
  ld.AnimPlay( "anm_mirrorext_anm_use_tweezers", "use_tweezers", func_end );
  SoundSfx( "aud_use_tweezersext_entrypointext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bowext" ] = { type = "get", get_obj = "spr_mirrorext_bowext", room = "rm_entrypointext", zz = "zz_mirrorext", zz_gate = "gzz_entrypointext_mirrorext" };

private.get_bowext_logic = function()
  
end;
private.get_bowext_inv = function()
  interface.InventoryItemAdd("inv_bowext","spr_mirrorext_bowext");
end;
private.get_bowext_beg = function()
  ObjDelete("gfx_mirrorext_bowext")
end;
private.get_bowext_end = function()
  ObjDelete("spr_mirrorext_bowext_sh")
  if common_impl.ZzCompleteCheck("get_bowext") then ObjSet( common_impl.hint["get_bowext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bowext", private.get_bowext_inv );
cmn.AddSubscriber( "get_bowext", private.get_bowext_beg, private.room_objname );
cmn.AddSubscriber( "get_bowext", private.get_bowext_end, private.room_objname );
cmn.AddSubscriber( "get_bowext", private.get_bowext_logic );
--------------------------------------------------------------------
function public.get_bowext()
  cmn.SetEventDone( "get_bowext" );
  cmn.CallEventHandler( "get_bowext" );
  if common_impl.ZzCompleteCheck("get_bowext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cogext2" ] = { type = "get", get_obj = "spr_mirrorext_cogext2", room = "rm_entrypointext", zz = "zz_mirrorext", zz_gate = "gzz_entrypointext_mirrorext" };

private.get_cogext2_logic = function()
  
end;
private.get_cogext2_inv = function()
  interface.InventoryItemAdd("inv_cogext","spr_mirrorext_cogext2",function() level_inv.ProcessGetCogextAll( "get_cogext2" ) end);
end;
private.get_cogext2_beg = function()
  ObjDelete("gfx_mirrorext_cogext2")
end;
private.get_cogext2_end = function()  
  ObjDelete("spr_mirrorext_cogext2_sh")
  if common_impl.ZzCompleteCheck("get_cogext2") then ObjSet( common_impl.hint["get_cogext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_cogext2", private.get_cogext2_inv );
cmn.AddSubscriber( "get_cogext2", private.get_cogext2_beg, private.room_objname );
cmn.AddSubscriber( "get_cogext2", private.get_cogext2_end, private.room_objname );
cmn.AddSubscriber( "get_cogext2", private.get_cogext2_logic );
--------------------------------------------------------------------
function public.get_cogext2()
  cmn.SetEventDone( "get_cogext2" );
  cmn.CallEventHandler( "get_cogext2" );
  if common_impl.ZzCompleteCheck("get_cogext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_frozenext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_ovenhandleext" ] = { type = "get", get_obj = "spr_frozenext_ovenhandleext", room = "rm_entrypointext", zz = "zz_frozenext", zz_gate = "gzz_entrypointext_frozenext" };

private.get_ovenhandleext_logic = function()
  
end;
private.get_ovenhandleext_inv = function()
  interface.InventoryItemAdd("inv_ovenhandleext","spr_frozenext_ovenhandleext");
end;
private.get_ovenhandleext_beg = function()
  ObjDelete("gfx_frozenext_ovenhandleext")
end;
private.get_ovenhandleext_end = function()
  ObjDelete("spr_frozenext_ovenhandleext_tr")
  ObjDelete("spr_frozenext_ovenhandleext_sh")
  ObjDelete("spr_entrypointext_ovenhandleext_tr")
  if common_impl.ZzCompleteCheck("get_ovenhandleext") then ObjSet( common_impl.hint["get_ovenhandleext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_ovenhandleext", private.get_ovenhandleext_inv );
cmn.AddSubscriber( "get_ovenhandleext", private.get_ovenhandleext_beg, private.room_objname );
cmn.AddSubscriber( "get_ovenhandleext", private.get_ovenhandleext_end, private.room_objname );
cmn.AddSubscriber( "get_ovenhandleext", private.get_ovenhandleext_logic );
--------------------------------------------------------------------
function public.get_ovenhandleext()
  cmn.SetEventDone( "get_ovenhandleext" );
  cmn.CallEventHandler( "get_ovenhandleext" );
  if common_impl.ZzCompleteCheck("get_ovenhandleext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_hotmulledwineext" ] = { type = "use", inv_obj = "inv_hotmulledwineext", use_place = "gfx_frozenext_hotmulledwineext_zone", room = "rm_entrypointext", zz = "zz_frozenext", zz_gate = "gzz_entrypointext_frozenext" };

private.use_hotmulledwineext_logic = function()
  ObjSet( "gfx_frozenext_towelext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_hotmulledwineext_inv = function()
  common_impl.ProcessMultiUseAll("hotmulledwineext", "hotmulledwineext")
end;
private.use_hotmulledwineext_beg = function()
  ObjDelete( "gfx_frozenext_hotmulledwineext_zone" );
end;
private.use_hotmulledwineext_end = function()
  ObjDelete("spr_entrypointext_ice_add")
  ObjDelete("spr_entrypointext_ice_normal")
  ObjDelete("spr_frozenext_ice")
  ObjDelete("spr_frozenext_ice_sh")
  ObjAttach("vid_frozenext_vid_simp_static_61","zz_frozenext")
  ObjDelete("spr_entrypointext_cat")
  ObjAttach("spr_entrypointext_simp_wait_static_61","rm_entrypointext")
  if common_impl.ZzCompleteCheck("use_hotmulledwineext") then ObjSet( common_impl.hint["use_hotmulledwineext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hotmulledwineext", private.use_hotmulledwineext_inv );
cmn.AddSubscriber( "use_hotmulledwineext", private.use_hotmulledwineext_beg, private.room_objname );
cmn.AddSubscriber( "use_hotmulledwineext", private.use_hotmulledwineext_end, private.room_objname );
cmn.AddSubscriber( "use_hotmulledwineext", private.use_hotmulledwineext_logic );
cmn.AddSubscriber( "use_hotmulledwineext_inv", private.use_hotmulledwineext_inv, private.room_objname );
cmn.AddSubscriber( "use_hotmulledwineext_beg", private.use_hotmulledwineext_beg, private.room_objname );
cmn.AddSubscriber( "use_hotmulledwineext_end", private.use_hotmulledwineext_end, private.room_objname );
cmn.AddSubscriber( "use_hotmulledwineext_end", private.use_hotmulledwineext_logic );
--------------------------------------------------------------------------------------------
function public.use_hotmulledwineext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hotmulledwineext" );
    cmn.CallEventHandler( "use_hotmulledwineext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hotmulledwineext") then ld.CloseSubRoom() end;
    ObjDelete("vid_frozenext_vid_simp_turn_37")
  end;
  local func_end_2 = function()
    ObjDelete("vid_frozenext_simp_unfreez_150")
    ObjAttach("vid_frozenext_vid_simp_turn_37","zz_frozenext")
    VidPlay("vid_frozenext_vid_simp_turn_37",func_end)
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hotmulledwineext_inv" );
  cmn.CallEventHandler( "use_hotmulledwineext_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_hotmulledwineext_entrypointext" )
  --func_end()
  ObjAnimate( "spr_frozenext_ice", 8, 0, 0, function() end, {0,0,1, 0.5,1,0} );
  ObjAnimate( "spr_frozenext_ice_sh", 8, 0, 0, function() end, {0,0,1, 0.5,1,0} );

  ObjAnimate( "vid_frozenext_simp_unfreez_150", 8, 0, 0, function() end, {0,0,0, 0.5,2,1} );
  ObjAttach("vid_frozenext_simp_unfreez_150","zz_frozenext")
  VidPlay("vid_frozenext_simp_unfreez_150",func_end_2)
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_towelext" ] = { type = "use", inv_obj = "inv_towelext", use_place = "gfx_frozenext_towelext_zone", room = "rm_entrypointext", zz = "zz_frozenext", zz_gate = "gzz_entrypointext_frozenext" };

private.use_towelext_logic = function()
  ObjSet( "spr_frozenext_catandmouseext", { input = 1, active = 1 } )

end;
private.use_towelext_inv = function()
  common_impl.ProcessMultiUseAll("towelext", "towelext")
end;
private.use_towelext_beg = function()
  ObjDelete("vid_frozenext_vid_simp_static_61")
  ObjDelete( "gfx_frozenext_towelext_zone" );
  ObjDelete("vid_frozenext_vid_simp_static_61")
end;
private.use_towelext_end = function()
  ObjSet( "gfx_frozenext_catandmouseext", { visible= 1, active = 1 } )
  ObjDelete("spr_entrypointext_simp_wait_static_61")
  ObjAttach("spr_entrypointext_simp_wait_pick_static_76","rm_entrypointext")
  ObjAttach("vid_frozenext_simp_pick_static_75","zz_frozenext")
  if common_impl.ZzCompleteCheck("use_towelext") then ObjSet( common_impl.hint["use_towelext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_towelext", private.use_towelext_inv );
cmn.AddSubscriber( "use_towelext", private.use_towelext_beg, private.room_objname );
cmn.AddSubscriber( "use_towelext", private.use_towelext_end, private.room_objname );
cmn.AddSubscriber( "use_towelext", private.use_towelext_logic );
cmn.AddSubscriber( "use_towelext_inv", private.use_towelext_inv, private.room_objname );
cmn.AddSubscriber( "use_towelext_beg", private.use_towelext_beg, private.room_objname );
cmn.AddSubscriber( "use_towelext_end", private.use_towelext_end, private.room_objname );
cmn.AddSubscriber( "use_towelext_end", private.use_towelext_logic );
--------------------------------------------------------------------------------------------
function public.use_towelext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_towelext" );
    cmn.CallEventHandler( "use_towelext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_towelext") then ld.CloseSubRoom() end;
    ObjDelete("vid_frozenext_simp_wipe_221")
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_towelext_inv" );
  cmn.CallEventHandler( "use_towelext_beg" );
  common_impl.Lock(1);

  ObjAttach("vid_frozenext_simp_wipe_221","zz_frozenext")
  VidPlay("vid_frozenext_simp_wipe_221",func_end)
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_towelext_entrypointext" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_catandmouseext" ] = { type = "get", get_obj = "spr_frozenext_catandmouseext", room = "rm_entrypointext", zz = "zz_frozenext", zz_gate = "gzz_entrypointext_frozenext" };

private.get_catandmouseext_logic = function()
  
end;
private.get_catandmouseext_inv = function()
  interface.InventoryItemAdd("inv_catandmouseext","spr_frozenext_catandmouseext");
end;
private.get_catandmouseext_beg = function()
  ObjDelete("gfx_frozenext_catandmouseext")
  ObjDelete("vid_frozenext_simp_pick_static_75")
  ObjSet( "spr_frozenext_catandmouseext", {visible = 1} );
end;
private.get_catandmouseext_end = function()
  ObjDelete("spr_entrypointext_simp_wait_pick_static_76")
  if common_impl.ZzCompleteCheck("get_catandmouseext") then ObjSet( common_impl.hint["get_catandmouseext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_catandmouseext", private.get_catandmouseext_inv );
cmn.AddSubscriber( "get_catandmouseext", private.get_catandmouseext_beg, private.room_objname );
cmn.AddSubscriber( "get_catandmouseext", private.get_catandmouseext_end, private.room_objname );
cmn.AddSubscriber( "get_catandmouseext", private.get_catandmouseext_logic );
--------------------------------------------------------------------
function public.get_catandmouseext()
  cmn.SetEventDone( "get_catandmouseext" );
  cmn.CallEventHandler( "get_catandmouseext" );
  if common_impl.ZzCompleteCheck("get_catandmouseext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_portalext_for_entrypointext_logic = function()
    if ld.CheckRequirements( {"win_portalext"} ) then
      ObjSet( "grm_entrypointext_nearshopext", {active = 1, input = 1, visible = 1} );
      if port.isPortable() == 1 then
        port.GrmEventLightOn("grm_entrypointext_nearshopext_focus");
      end;
    end
  end;
  local win_portalext_for_entrypointext = function()
    if ld.CheckRequirements( {"win_portalext"} ) then
      ObjSet( "gho_entrypointext_portalext", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_portalext", win_portalext_for_entrypointext_logic )
  cmn.AddSubscriber("win_portalext", win_portalext_for_entrypointext, private.room_objname )


  local opn_shopext_for_entrypointext = function()
    ObjDelete("spr_shopext_vid_cinderella_static");
    ObjDelete("obj_entrypointext_bbt_cind");
  end;
  cmn.AddSubscriber("opn_shopext", opn_shopext_for_entrypointext, private.room_objname )
  
function public.Skip()

  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_mirrorext" ) then
    public.win_mirrorext_load(nil,1)
  end
  if ( mg_name == "zz_tableext" ) then
    public.win_worktableext_load(nil,1)
  end

end;
---------------------------------------------------------------------------------
function public.Reset()

  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_mirrorext" ) then
    public.win_mirrorext_load(1)
  end
  if ( mg_name == "zz_tableext" ) then
    public.win_worktableext_load(1)
  end
end;

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_entrypointext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not ( cmn.IsEventDone( "opn_entrypointext" ) ) then
    private.SeeIntro()
  else
    SoundEnv( "aud_workshop_env" )
    if ld.CheckRequirements( {"use_coloredglassext"} ) and not ld.CheckRequirements( {"win_mirrorext"} ) then
      public.win_mirrorext_load()
    end
  end;
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_frozenext" );
  function zz_frozenext.Open()
  end;
  function zz_frozenext.PreOpen()
  end;
  function zz_frozenext.PreClose()
  end;
  function zz_frozenext.Close()
  end;

  subroom.Define( "zz_mirrorext" );
  function zz_mirrorext.Open()

  end;
  function zz_mirrorext.PreOpen()
    if ld.CheckRequirements( {"use_coloredglassext"} ) and not ld.CheckRequirements( {"win_mirrorext"} ) then
      public.win_mirrorext_load()
      --ObjGet( "gfx_mirrorext_win_mirrorext_zone" ).event_mdown()
    end
  end;
  function zz_mirrorext.PreClose()
  end;
  function zz_mirrorext.Close()
  end;

  subroom.Define( "zz_tableext" );
  function zz_tableext.Open()
  end;
  function zz_tableext.PreOpen()
    if ld.CheckRequirements( {"use_sunrayext"} ) and not ld.CheckRequirements( {"win_worktableext"} ) then
      public.win_worktableext_load()
    end  
  end;
  function zz_tableext.PreClose()
  end;
  function zz_tableext.Close()
  end;

  subroom.Define( "zz_secondfloordoorext" );
  function zz_secondfloordoorext.Open()
  end;
  function zz_secondfloordoorext.PreOpen()
  end;
  function zz_secondfloordoorext.PreClose()
  end;
  function zz_secondfloordoorext.Close()
  end;

  subroom.Define( "zz_dressext" );
  function zz_dressext.Open()
    --if not ld.CheckRequirements( {"clk_viddressext"} ) then
    --  public.clk_viddressext()
    --end
  end;
  function zz_dressext.PreOpen()
  end;
  function zz_dressext.PreClose()
  end;
  function zz_dressext.Close()
  end;

end;
--*********************************************************************************************************************