-- name=rm_hallext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_hallext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_hallext()
  if not ( cmn.IsEventDone( "opn_hallext" ) ) then
  local func_end = function()
    cmn.SetEventDone( "opn_hallext" );
    cmn.CallEventHandler( "opn_hallext" )
    ld.ShowBbtOpn( private.room_objname )
    int.DialogVideoHide();
    VidPause( "vid_hallext_vid_morgana_prince", 1 )
  end;
  int.DialogVideoShow( "vid_hallext_vid_morgana_prince", 1, func_end, 1 );
  --[[
  common_impl.VideoSubtitleVocStart( {
    { "srt_vid_morgana_prince_1" , aud_voc_false, 0,8 };
    { "srt_vid_morgana_prince_2" , aud_voc_false, 8,22 };
  } );
  ]]
  SoundVid( "aud_morgana_prince" );
  SoundVoice( "aud_morgana_prince_voc" );
  VidPlay( "vid_hallext_vid_morgana_prince", func_end );
  end;
end;
--------------------------------------------------------------------
local opn_hallext = function()
  ObjDelete( "spr_hallext_morgaprince" )
  ObjSet( "spr_hallext_reward", { visible = 1 } )
  ObjSet( "anm_hallext_rm_hallext_open_door", { animfunc = "open_door", frame = 0 } )
  ObjSet( "spr_hallext_chain_trash", { visible = 1 } )
end;
local opn_hallext_logic = function() end;
cmn.AddSubscriber( "opn_hallext", opn_hallext_logic )
cmn.AddSubscriber( "opn_hallext", opn_hallext, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_corridordoorext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_rewardext" ] = { type = "get", get_obj = "spr_corridordoorext_rewardext", room = "rm_hallext", zz = "zz_corridordoorext", zz_gate = "gzz_hallext_corridordoorext" };

private.get_rewardext_logic = function()
  
end;
private.get_rewardext_inv = function()
  interface.InventoryItemAdd("inv_rewardext","spr_corridordoorext_rewardext");
end;
private.get_rewardext_beg = function()
  ObjDelete("gfx_corridordoorext_rewardext")
end;
private.get_rewardext_end = function()
  ObjDelete( "spr_hallext_reward" )
  if common_impl.ZzCompleteCheck("get_rewardext") then ObjSet( common_impl.hint["get_rewardext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_rewardext", private.get_rewardext_inv );
cmn.AddSubscriber( "get_rewardext", private.get_rewardext_beg, private.room_objname );
cmn.AddSubscriber( "get_rewardext", private.get_rewardext_end, private.room_objname );
cmn.AddSubscriber( "get_rewardext", private.get_rewardext_logic );
--------------------------------------------------------------------
function public.get_rewardext()
  cmn.SetEventDone( "get_rewardext" );
  cmn.CallEventHandler( "get_rewardext" );
  if common_impl.ZzCompleteCheck("get_rewardext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_sawext" ] = { type = "use", inv_obj = "inv_sawext", use_place = "gfx_corridordoorext_sawext_zone", room = "rm_hallext", zz = "zz_corridordoorext", zz_gate = "gzz_hallext_corridordoorext" };

private.use_sawext_logic = function()
  ObjSet( "grm_hallext_seconfloorext", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_hallext_seconfloorext_focus");
    end;
end;
private.use_sawext_inv = function()
  common_impl.ProcessMultiUseAll("sawext", "sawext")
end;
private.use_sawext_beg = function()
  ObjDelete( "gfx_corridordoorext_sawext_zone" );
  ObjDelete( "spr_hallext_chain_trash" )
end;
private.use_sawext_end = function()
  ObjDelete( "anm_corridordoorext_anm_idle" )
  ObjSet( "anm_hallext_rm_hallext_open_door", { animfunc = "open_door", frame = 999 } )
  if common_impl.ZzCompleteCheck("use_sawext") then ObjSet( common_impl.hint["use_sawext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sawext", private.use_sawext_inv );
cmn.AddSubscriber( "use_sawext", private.use_sawext_beg, private.room_objname );
cmn.AddSubscriber( "use_sawext", private.use_sawext_end, private.room_objname );
cmn.AddSubscriber( "use_sawext", private.use_sawext_logic );
cmn.AddSubscriber( "use_sawext_inv", private.use_sawext_inv, private.room_objname );
cmn.AddSubscriber( "use_sawext_beg", private.use_sawext_beg, private.room_objname );
cmn.AddSubscriber( "use_sawext_end", private.use_sawext_end, private.room_objname );
cmn.AddSubscriber( "use_sawext_end", private.use_sawext_logic );
--------------------------------------------------------------------------------------------
function public.use_sawext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_sawext" );
    cmn.CallEventHandler( "use_sawext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_sawext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sawext_inv" );
  cmn.CallEventHandler( "use_sawext_beg" );
  common_impl.Lock(1);

  ObjAnimate( "anm_corridordoorext_anm_idle", 8,0,0, nil, { 0,0,1, 0.5,0,0 } )
  ld.AnimPlay( "anm_corridordoorext_anm_use_saw", "use_saw", function()
    ld.CloseSubRoom()
    ObjAnimate( "anm_hallext_rm_hallext_open_door", 7,0,0, function() 
      ld.AnimPlay( "anm_hallext_rm_hallext_open_door", "open_door", func_end )
    end, { 0,0,0, 0,0,0 } )
  end );
  SoundSfx( "aud_use_sawext_hallext" )

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_firtreeext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_ribbonext" ] = { type = "get", get_obj = "spr_firtreeext_ribbonext", room = "rm_hallext", zz = "zz_firtreeext", zz_gate = "gzz_hallext_firtreeext" };

private.get_ribbonext_logic = function()
  
end;
private.get_ribbonext_inv = function()
  interface.InventoryItemAdd("inv_ribbonext","spr_firtreeext_ribbonext");
end;
private.get_ribbonext_beg = function()
  ObjDelete("gfx_firtreeext_ribbonext")
end;
private.get_ribbonext_end = function()
  ObjDelete( "spr_firtreeext_ribbonext_sh" )
  ObjDelete( "spr_hallext_ribbon" )
  if common_impl.ZzCompleteCheck("get_ribbonext") then ObjSet( common_impl.hint["get_ribbonext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_ribbonext", private.get_ribbonext_inv );
cmn.AddSubscriber( "get_ribbonext", private.get_ribbonext_beg, private.room_objname );
cmn.AddSubscriber( "get_ribbonext", private.get_ribbonext_end, private.room_objname );
cmn.AddSubscriber( "get_ribbonext", private.get_ribbonext_logic );
--------------------------------------------------------------------
function public.get_ribbonext()
  cmn.SetEventDone( "get_ribbonext" );
  cmn.CallEventHandler( "get_ribbonext" );
  if common_impl.ZzCompleteCheck("get_ribbonext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_santacatext" ] = { type = "use", inv_obj = "inv_santacatext", use_place = "gfx_firtreeext_santacatext_zone", room = "rm_hallext", zz = "zz_firtreeext", zz_gate = "gzz_hallext_firtreeext" };

private.use_santacatext_logic = function()
  if ld.CheckRequirements( {"use_santacatext","use_elfcatext"} ) then
    ObjSet( "spr_firtreeext_cubeext2", { visible = 0, input = 1, active = 1 } )
  end;

end;
private.use_santacatext_inv = function()
  common_impl.ProcessMultiUseAll("santacatext", "santacatext")
end;
private.use_santacatext_beg = function()
  ObjDelete( "gfx_firtreeext_santacatext_zone" );
end;
private.use_santacatext_end = function()
  if ld.CheckRequirements( { "use_santacatext", "use_elfcatext" } ) then
    ObjSet( "spr_hallext_open_bag", { visible = 1 } )
    ObjSet( "spr_hallext_cats_keep", { visible = 1 } )
    ObjDelete( "spr_hallext_cat_right" )
    ObjSet( "gfx_firtreeext_cubeext2", { active = 1 } )
    ObjDelete( "anm_firtreeext_anm_cat1" )
    ObjDelete( "anm_firtreeext_anm_cat2" )
    ObjDelete( "anm_firtreeext_anm_line" )
    ObjSet( "anm_firtreeext_anm_all", { animfunc = "cat1_2_static", frame = 0, playing = 1 } )
  else
    ObjSet( "spr_hallext_cat_left", { visible = 1 } )
    ObjSet( "anm_firtreeext_anm_cat2", { animfunc = "cat2_static", frame = 0, playing = 1 } )
  end
  if common_impl.ZzCompleteCheck("use_santacatext") then ObjSet( common_impl.hint["use_santacatext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_santacatext", private.use_santacatext_inv );
cmn.AddSubscriber( "use_santacatext", private.use_santacatext_beg, private.room_objname );
cmn.AddSubscriber( "use_santacatext", private.use_santacatext_end, private.room_objname );
cmn.AddSubscriber( "use_santacatext", private.use_santacatext_logic );
cmn.AddSubscriber( "use_santacatext_inv", private.use_santacatext_inv, private.room_objname );
cmn.AddSubscriber( "use_santacatext_beg", private.use_santacatext_beg, private.room_objname );
cmn.AddSubscriber( "use_santacatext_end", private.use_santacatext_end, private.room_objname );
cmn.AddSubscriber( "use_santacatext_end", private.use_santacatext_logic );
--------------------------------------------------------------------------------------------
function public.use_santacatext( obj )

  local func_end = function()
    ObjSet( "anm_firtreeext_anm_cat1", { pos_z = 7 } )
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_santacatext" );
    cmn.CallEventHandler( "use_santacatext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_santacatext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_santacatext_inv" );
  cmn.CallEventHandler( "use_santacatext_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_firtreeext_anm_cat1", { pos_z = 6 } )
  ld.AnimPlay( "anm_firtreeext_anm_cat2", "cat2", function() public.use_catext_all( func_end ) end );
  SoundSfx( "aud_use_santacatext_hallext" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_elfcatext" ] = { type = "use", inv_obj = "inv_elfcatext", use_place = "gfx_firtreeext_elfcatext_zone", room = "rm_hallext", zz = "zz_firtreeext", zz_gate = "gzz_hallext_firtreeext" };

private.use_elfcatext_logic = function()
  if ld.CheckRequirements( {"use_elfcatext","use_santacatext"} ) then
    ObjSet( "spr_firtreeext_cubeext2", { visible = 0, input = 1, active = 1 } )
  end;

end;
private.use_elfcatext_inv = function()
  common_impl.ProcessMultiUseAll("elfcatext", "elfcatext")
end;
private.use_elfcatext_beg = function()
  ObjDelete( "gfx_firtreeext_elfcatext_zone" );
end;
private.use_elfcatext_end = function()
  if ld.CheckRequirements( { "use_santacatext", "use_elfcatext" } ) then
    ObjSet( "spr_hallext_open_bag", { visible = 1 } )
    ObjSet( "spr_hallext_cats_keep", { visible = 1 } )
    ObjDelete( "spr_hallext_cat_left" )
    ObjSet( "gfx_firtreeext_cubeext2", { active = 1 } )
    ObjDelete( "anm_firtreeext_anm_cat1" )
    ObjDelete( "anm_firtreeext_anm_cat2" )
    ObjDelete( "anm_firtreeext_anm_line" )
    ObjSet( "anm_firtreeext_anm_all", { animfunc = "cat1_2_static", frame = 0, playing = 1 } )
  else
    ObjSet( "spr_hallext_cat_right", { visible = 1 } )
    ObjSet( "anm_firtreeext_anm_cat1", { animfunc = "cat1_static", frame = 0, playing = 1 } )
  end
  if common_impl.ZzCompleteCheck("use_elfcatext") then ObjSet( common_impl.hint["use_elfcatext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_elfcatext", private.use_elfcatext_inv );
cmn.AddSubscriber( "use_elfcatext", private.use_elfcatext_beg, private.room_objname );
cmn.AddSubscriber( "use_elfcatext", private.use_elfcatext_end, private.room_objname );
cmn.AddSubscriber( "use_elfcatext", private.use_elfcatext_logic );
cmn.AddSubscriber( "use_elfcatext_inv", private.use_elfcatext_inv, private.room_objname );
cmn.AddSubscriber( "use_elfcatext_beg", private.use_elfcatext_beg, private.room_objname );
cmn.AddSubscriber( "use_elfcatext_end", private.use_elfcatext_end, private.room_objname );
cmn.AddSubscriber( "use_elfcatext_end", private.use_elfcatext_logic );
--------------------------------------------------------------------------------------------
function public.use_elfcatext( obj )

  local func_end = function()
    ObjSet( "anm_firtreeext_anm_cat2", { pos_z = 7 } )
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_elfcatext" );
    cmn.CallEventHandler( "use_elfcatext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_elfcatext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_elfcatext_inv" );
  cmn.CallEventHandler( "use_elfcatext_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_firtreeext_anm_cat2", { pos_z = 6 } )
  ld.AnimPlay( "anm_firtreeext_anm_cat1", "cat1", function() public.use_catext_all( func_end ) end );
  SoundSfx( "aud_use_santacatext_hallext" )

end;
function public.use_catext_all( func_end )
  if common_impl.IsLastActionLeft( { "use_santacatext", "use_elfcatext" } ) then
    ObjAnimate( "anm_firtreeext_anm_cat1", 8,0,0, _, { 0,0,1, 0.25,1,0 } )
    ObjAnimate( "anm_firtreeext_anm_cat2", 8,0,0, _, { 0,0,1, 0.25,1,0 } )
    ObjAnimate( "anm_firtreeext_anm_line", 8,0,0, _, { 0,0,1, 0.25,1,0 } )
    ObjAnimate( "anm_firtreeext_anm_all", 8,0,0, _, { 0,0,0, 0.25,2,1 } )
    SoundSfx( "aud_untie_bag" )
    ld.AnimPlay( "anm_firtreeext_anm_all", "cat1_2", func_end )
  else
    func_end()
  end
end;
function public.use_catext_xx( bbt )
  local func_end = function() 
    ld.Lock( 0 )
    ld.ShowBbt( bbt )
  end
  ld.Lock( 1 )
  SoundSfx( "aud_xx_sock" )
  if ld.CheckRequirements( { "use_santacatext", "use_elfcatext" }, true ) == 0 then
    ld.AnimPlay( "anm_firtreeext_anm_cat1", "line_cat2_hol", nil )
    ld.AnimPlay( "anm_firtreeext_anm_cat2", "line_cat1_hol", func_end )
  elseif ld.CheckRequirements( { "use_santacatext" } ) then
    ld.AnimPlay( "anm_firtreeext_anm_cat1", "line_cat2_hol", func_end )
  else
    ld.AnimPlay( "anm_firtreeext_anm_cat2", "line_cat1_hol", func_end )
  end
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cubeext2" ] = { type = "get", get_obj = "spr_firtreeext_cubeext2", room = "rm_hallext", zz = "zz_firtreeext", zz_gate = "gzz_hallext_firtreeext" };

private.get_cubeext2_logic = function()
  
end;
private.get_cubeext2_inv = function()
  interface.InventoryItemAdd("inv_cubeext","spr_firtreeext_cubeext2",function() level_inv.ProcessGetCubeextAll( "get_cubeext2" ) end);
end;
private.get_cubeext2_beg = function()
  ObjDelete("gfx_firtreeext_cubeext2")
end;
private.get_cubeext2_end = function()
  ObjDelete( "spr_hallext_cats_keep" )
  ObjSet( "spr_hallext_cats", { visible = 1 } )
  ObjSet( "anm_firtreeext_anm_all", { animfunc = "cat1_2_static_nocube" } )
  if common_impl.ZzCompleteCheck("get_cubeext2") then ObjSet( common_impl.hint["get_cubeext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_cubeext2", private.get_cubeext2_inv );
cmn.AddSubscriber( "get_cubeext2", private.get_cubeext2_beg, private.room_objname );
cmn.AddSubscriber( "get_cubeext2", private.get_cubeext2_end, private.room_objname );
cmn.AddSubscriber( "get_cubeext2", private.get_cubeext2_logic );
--------------------------------------------------------------------
function public.get_cubeext2()
    ObjSet( "spr_firtreeext_cubeext2", { visible = 1, input = 1, active = 1 } )
  cmn.SetEventDone( "get_cubeext2" );
  cmn.CallEventHandler( "get_cubeext2" );
  if common_impl.ZzCompleteCheck("get_cubeext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_treatstableext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_maskext" ] = { type = "get", get_obj = "spr_treatstableext_maskext", room = "rm_hallext", zz = "zz_treatstableext", zz_gate = "gzz_hallext_treatstableext" };

private.get_maskext_logic = function()
  ObjSet( "gfx_treatstableext_cupidext1_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_treatstableext_cupidext2_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_maskext_inv = function()
  interface.InventoryItemAdd("inv_maskext","spr_treatstableext_maskext");
  ObjSet( "inv_maskext", { drag = 0 } );
end;
private.get_maskext_beg = function()
  ObjDelete("gfx_treatstableext_maskext")
end;
private.get_maskext_end = function()
  ObjDelete( "spr_hallext_mask" )
  ObjDelete( "spr_treatstableext_sh_maskext" )
  if common_impl.ZzCompleteCheck("get_maskext") then ObjSet( common_impl.hint["get_maskext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_maskext", private.get_maskext_inv );
cmn.AddSubscriber( "get_maskext", private.get_maskext_beg, private.room_objname );
cmn.AddSubscriber( "get_maskext", private.get_maskext_end, private.room_objname );
cmn.AddSubscriber( "get_maskext", private.get_maskext_logic );
--------------------------------------------------------------------
function public.get_maskext()
  cmn.SetEventDone( "get_maskext" );
  cmn.CallEventHandler( "get_maskext" );
  if common_impl.ZzCompleteCheck("get_maskext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_cupidext1" ] = { type = "use", inv_obj = "inv_cupidext1", use_place = "gfx_treatstableext_cupidext1_zone", room = "rm_hallext", zz = "zz_treatstableext", zz_gate = "gzz_hallext_treatstableext" };

private.use_cupidext1_logic = function()
  if ld.CheckRequirements( {"use_cupidext1","use_cupidext2"} ) then
    ObjSet( "spr_treatstableext_amuletarcherext", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_treatstableext_emeraldflowerext", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.use_cupidext1_inv = function()
  common_impl.ProcessMultiUseAll("cupidext1", "cupidext1")
end;
private.use_cupidext1_beg = function()
  ObjSet( "spr_treatstableext_cupid1", { visible = 1 } )
  ObjDelete( "gfx_treatstableext_cupidext1_zone" );
end;
private.use_cupidext1_end = function()
  if ld.CheckRequirements( {"use_cupidext1","use_cupidext2"} ) then
    ObjSet( "anm_treatstableext_anm", { animfunc = "end", frame = 0 } )
    ObjSet( "spr_hallext_fountain_trash", { visible = 1 } )
  end
  ObjSet( "spr_hallext_cupid_2", { visible = 1 } )
  if common_impl.ZzCompleteCheck("use_cupidext1") then ObjSet( common_impl.hint["use_cupidext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cupidext1", private.use_cupidext1_inv );
cmn.AddSubscriber( "use_cupidext1", private.use_cupidext1_beg, private.room_objname );
cmn.AddSubscriber( "use_cupidext1", private.use_cupidext1_end, private.room_objname );
cmn.AddSubscriber( "use_cupidext1", private.use_cupidext1_logic );
cmn.AddSubscriber( "use_cupidext1_inv", private.use_cupidext1_inv, private.room_objname );
cmn.AddSubscriber( "use_cupidext1_beg", private.use_cupidext1_beg, private.room_objname );
cmn.AddSubscriber( "use_cupidext1_end", private.use_cupidext1_end, private.room_objname );
cmn.AddSubscriber( "use_cupidext1_end", private.use_cupidext1_logic );
--------------------------------------------------------------------------------------------
function public.use_cupidext1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cupidext1" );
    cmn.CallEventHandler( "use_cupidext1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_cupidext1") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cupidext1_inv" );
  cmn.CallEventHandler( "use_cupidext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_treatstableext_anm", "use_cupid1", function()
    private.use_cupidext_all( func_end )
  end );
  SoundSfx( "aud_use_cupidext1_hallext" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_cupidext2" ] = { type = "use", inv_obj = "inv_cupidext2", use_place = "gfx_treatstableext_cupidext2_zone", room = "rm_hallext", zz = "zz_treatstableext", zz_gate = "gzz_hallext_treatstableext" };

private.use_cupidext2_logic = function()
  if ld.CheckRequirements( {"use_cupidext2","use_cupidext1"} ) then
    ObjSet( "spr_treatstableext_amuletarcherext", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_treatstableext_emeraldflowerext", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_cupidext2_inv = function()
  common_impl.ProcessMultiUseAll("cupidext2", "cupidext2")
end;
private.use_cupidext2_beg = function()
  ObjSet( "spr_treatstableext_cupid2", { visible = 2 } )
  ObjDelete( "gfx_treatstableext_cupidext2_zone" );
end;
private.use_cupidext2_end = function()
  if ld.CheckRequirements( {"use_cupidext1","use_cupidext2"} ) then
    ObjSet( "anm_treatstableext_anm", { animfunc = "end", frame = 0 } )
    ObjSet( "spr_hallext_fountain_trash", { visible = 1 } )
  end
  ObjSet( "spr_hallext_cupid_1", { visible = 1 } )
  if common_impl.ZzCompleteCheck("use_cupidext2") then ObjSet( common_impl.hint["use_cupidext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cupidext2", private.use_cupidext2_inv );
cmn.AddSubscriber( "use_cupidext2", private.use_cupidext2_beg, private.room_objname );
cmn.AddSubscriber( "use_cupidext2", private.use_cupidext2_end, private.room_objname );
cmn.AddSubscriber( "use_cupidext2", private.use_cupidext2_logic );
cmn.AddSubscriber( "use_cupidext2_inv", private.use_cupidext2_inv, private.room_objname );
cmn.AddSubscriber( "use_cupidext2_beg", private.use_cupidext2_beg, private.room_objname );
cmn.AddSubscriber( "use_cupidext2_end", private.use_cupidext2_end, private.room_objname );
cmn.AddSubscriber( "use_cupidext2_end", private.use_cupidext2_logic );
--------------------------------------------------------------------------------------------
function public.use_cupidext2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cupidext2" );
    cmn.CallEventHandler( "use_cupidext2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_cupidext2") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cupidext2_inv" );
  cmn.CallEventHandler( "use_cupidext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_treatstableext_anm", "use_cupid2", function()
    private.use_cupidext_all( func_end )
  end );
  SoundSfx( "aud_use_cupidext1_hallext" )

end;
--------------------------------------------------------------------------------------------
function private.use_cupidext_all( func_end )
  if ld.CheckRequirements( { "use_cupidext1", "use_cupidext2" }, true ) == 1 then
    SoundSfx( "aud_pour_ice" )
    ld.AnimPlay( "anm_treatstableext_anm", "fountain", function() 
      func_end()
      public.get_amuletarcherext()
      public.get_emeraldflowerext()
    end );
  else
    func_end();
  end
end
--------------------------------------------------------------------
common_impl.hint[ "get_amuletarcherext" ] = { type = "get", get_obj = "spr_treatstableext_amuletarcherext", room = "rm_hallext", zz = "zz_treatstableext", zz_gate = "gzz_hallext_treatstableext" };

private.get_amuletarcherext_logic = function()
  
end;
private.get_amuletarcherext_inv = function()
  interface.InventoryItemAdd("inv_amuletarcherext","spr_treatstableext_amuletarcherext");
end;
private.get_amuletarcherext_beg = function()
  ObjDelete("gfx_treatstableext_amuletarcherext")
end;
private.get_amuletarcherext_end = function()
  if common_impl.ZzCompleteCheck("get_amuletarcherext") then ObjSet( common_impl.hint["get_amuletarcherext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletarcherext", private.get_amuletarcherext_inv );
cmn.AddSubscriber( "get_amuletarcherext", private.get_amuletarcherext_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletarcherext", private.get_amuletarcherext_end, private.room_objname );
cmn.AddSubscriber( "get_amuletarcherext", private.get_amuletarcherext_logic );
--------------------------------------------------------------------
function public.get_amuletarcherext()
  cmn.SetEventDone( "get_amuletarcherext" );
  cmn.CallEventHandler( "get_amuletarcherext" );
  if common_impl.ZzCompleteCheck("get_amuletarcherext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_emeraldflowerext" ] = { type = "get", get_obj = "spr_treatstableext_emeraldflowerext", room = "rm_hallext", zz = "zz_treatstableext", zz_gate = "gzz_hallext_treatstableext" };

private.get_emeraldflowerext_logic = function()
  
end;
private.get_emeraldflowerext_inv = function()
  interface.InventoryItemAdd("inv_emeraldflowerext","spr_treatstableext_emeraldflowerext");
end;
private.get_emeraldflowerext_beg = function()
  ObjDelete("gfx_treatstableext_emeraldflowerext")
end;
private.get_emeraldflowerext_end = function()
  if common_impl.ZzCompleteCheck("get_emeraldflowerext") then ObjSet( common_impl.hint["get_emeraldflowerext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_emeraldflowerext", private.get_emeraldflowerext_inv );
cmn.AddSubscriber( "get_emeraldflowerext", private.get_emeraldflowerext_beg, private.room_objname );
cmn.AddSubscriber( "get_emeraldflowerext", private.get_emeraldflowerext_end, private.room_objname );
cmn.AddSubscriber( "get_emeraldflowerext", private.get_emeraldflowerext_logic );
--------------------------------------------------------------------
function public.get_emeraldflowerext()
  cmn.SetEventDone( "get_emeraldflowerext" );
  cmn.CallEventHandler( "get_emeraldflowerext" );
  if common_impl.ZzCompleteCheck("get_emeraldflowerext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

function public.frozen_click( n )
  ld.ShowBbt( "hallext_frozen" )
  local o= ObjGet( "spr_hallext_vid_frozen_"..n )
  if o.alp < 0.6 then
    SoundSfx( "aud_xx_charmed_cats" );
  end
  ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, 0.2,2,1, 0.4,1,0.55 } )
end

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_hallext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_newhall_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_treatstableext" );
  function zz_treatstableext.Open()
  end;
  function zz_treatstableext.PreOpen()
  end;
  function zz_treatstableext.PreClose()
  end;
  function zz_treatstableext.Close()
  end;

  subroom.Define( "zz_firtreeext" );
  function zz_firtreeext.Open()
  end;
  function zz_firtreeext.PreOpen()
  end;
  function zz_firtreeext.PreClose()
  end;
  function zz_firtreeext.Close()
  end;

  subroom.Define( "zz_corridordoorext" );
  function zz_corridordoorext.Open()
  end;
  function zz_corridordoorext.PreOpen()
  end;
  function zz_corridordoorext.PreClose()
  end;
  function zz_corridordoorext.Close()
  end;
  
end;
--*********************************************************************************************************************