-- name=rm_nearshopext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearshopext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_nearshopext()
  if not ( cmn.IsEventDone( "opn_nearshopext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_nearshopext" );
      cmn.CallEventHandler( "opn_nearshopext" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_nearshopext = function() end;
local opn_nearshopext_logic = function() end;
cmn.AddSubscriber( "opn_nearshopext", opn_nearshopext_logic )
cmn.AddSubscriber( "opn_nearshopext", opn_nearshopext, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_shopdoorext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_shopdoorext" ] = { type = "click", use_place = "gfx_shopdoorext_clk_shopdoorext_zone", room = "rm_nearshopext", zz = "zz_shopdoorext", zz_gate = "gzz_nearshopext_shopdoorext" };

private.clk_shopdoorext_logic = function()
  ObjSet( "spr_shopdoorext_amuletmittenext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_shopdoorext_piniatabatext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_shopdoorext_beg = function()
  ObjDelete( "gfx_shopdoorext_clk_shopdoorext_zone" );
end;
private.clk_shopdoorext_end = function()
  ObjSet( "anm_shopdoorext_anm_ice", {animfunc = "bb", frame = 0 } );
  ObjSet( "spr_nearshopext_ice", {visible = 1} );
  if common_impl.ZzCompleteCheck("clk_shopdoorext") then ObjSet( common_impl.hint["clk_shopdoorext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_shopdoorext", private.clk_shopdoorext_beg, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext", private.clk_shopdoorext_end, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext", private.clk_shopdoorext_logic );
cmn.AddSubscriber( "clk_shopdoorext_beg", private.clk_shopdoorext_beg, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext_end", private.clk_shopdoorext_end, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext_end", private.clk_shopdoorext_logic );
--------------------------------------------------------------------------------------------
function public.clk_shopdoorext()

  local func_end = function()
    cmn.SetEventDone( "clk_shopdoorext" );
    cmn.CallEventHandler( "clk_shopdoorext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_shopdoorext") then ld.CloseSubRoom() end;
    ld.ShowBbt("nearshopext_after_icicles");
    ObjDelete("vid_shopdoorext_ice_door_handle_151")
  end;

  cmn.CallEventHandler( "clk_shopdoorext_beg" );
  common_impl.Lock(1);
  ObjAttach("vid_shopdoorext_ice_door_handle_151","zz_shopdoorext")
  VidPlay("vid_shopdoorext_ice_door_handle_151",func_end)
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_clk_shopdoorext_nearshopext" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletmittenext" ] = { type = "get", get_obj = "spr_shopdoorext_amuletmittenext", room = "rm_nearshopext", zz = "zz_shopdoorext", zz_gate = "gzz_nearshopext_shopdoorext" };

private.get_amuletmittenext_logic = function()
  
end;
private.get_amuletmittenext_inv = function()
  interface.InventoryItemAdd("inv_amuletmittenext","spr_shopdoorext_amuletmittenext");
end;
private.get_amuletmittenext_beg = function()
  ObjDelete("gfx_shopdoorext_amuletmittenext")
end;
private.get_amuletmittenext_end = function()
  ObjDelete("spr_nearshopext_amuletmittenext")
  ObjDelete("spr_shopdoorext_amuletmittenext_sh")
  if common_impl.ZzCompleteCheck("get_amuletmittenext") then ObjSet( common_impl.hint["get_amuletmittenext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletmittenext", private.get_amuletmittenext_inv );
cmn.AddSubscriber( "get_amuletmittenext", private.get_amuletmittenext_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletmittenext", private.get_amuletmittenext_end, private.room_objname );
cmn.AddSubscriber( "get_amuletmittenext", private.get_amuletmittenext_logic );
--------------------------------------------------------------------
function public.get_amuletmittenext()
  cmn.SetEventDone( "get_amuletmittenext" );
  cmn.CallEventHandler( "get_amuletmittenext" );
  if common_impl.ZzCompleteCheck("get_amuletmittenext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_piniatabatext" ] = { type = "use", inv_obj = "inv_piniatabatext", use_place = "gfx_shopdoorext_piniatabatext_zone", room = "rm_nearshopext", zz = "zz_shopdoorext", zz_gate = "gzz_nearshopext_shopdoorext" };

private.use_piniatabatext_logic = function()
  ObjSet( "gfx_shopdoorext_clk_shopdoorext4_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_piniatabatext_inv = function()
  common_impl.ProcessMultiUseAll("piniatabatext", "piniatabatext")
end;
private.use_piniatabatext_beg = function()
  ObjDelete( "gfx_shopdoorext_piniatabatext_zone" );
end;
private.use_piniatabatext_end = function()
  ObjSet( "anm_shopdoorext_anm_ice", {animfunc = "opendoor", frame = 0 } );
  ObjDelete("spr_nearshopext_ice")
  if common_impl.ZzCompleteCheck("use_piniatabatext") then ObjSet( common_impl.hint["use_piniatabatext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_piniatabatext", private.use_piniatabatext_inv );
cmn.AddSubscriber( "use_piniatabatext", private.use_piniatabatext_beg, private.room_objname );
cmn.AddSubscriber( "use_piniatabatext", private.use_piniatabatext_end, private.room_objname );
cmn.AddSubscriber( "use_piniatabatext", private.use_piniatabatext_logic );
cmn.AddSubscriber( "use_piniatabatext_inv", private.use_piniatabatext_inv, private.room_objname );
cmn.AddSubscriber( "use_piniatabatext_beg", private.use_piniatabatext_beg, private.room_objname );
cmn.AddSubscriber( "use_piniatabatext_end", private.use_piniatabatext_end, private.room_objname );
cmn.AddSubscriber( "use_piniatabatext_end", private.use_piniatabatext_logic );
--------------------------------------------------------------------------------------------
function public.use_piniatabatext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "clk_shopdoorext1" );
    cmn.SetEventDone( "clk_shopdoorext2" );
    cmn.SetEventDone( "clk_shopdoorext3" );
    cmn.SetEventDone( "use_piniatabatext" );
    cmn.CallEventHandler( "use_piniatabatext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_piniatabatext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_piniatabatext_inv" );
  cmn.CallEventHandler( "use_piniatabatext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_shopdoorext_anm_ice", "bb", func_end );
  SoundSfx( "aud_use_piniatabatext_nearshopext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_shopdoorext1" ] = { type = "click", use_place = "gfx_shopdoorext_clk_shopdoorext1_zone", room = "rm_nearshopext", zz = "zz_shopdoorext", zz_gate = "gzz_nearshopext_shopdoorext" };

private.clk_shopdoorext1_logic = function()
  ObjSet( "gfx_shopdoorext_clk_shopdoorext2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_shopdoorext1_beg = function()
  ObjDelete( "gfx_shopdoorext_clk_shopdoorext1_zone" );
end;
private.clk_shopdoorext1_end = function()
  if common_impl.ZzCompleteCheck("clk_shopdoorext1") then ObjSet( common_impl.hint["clk_shopdoorext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_shopdoorext1", private.clk_shopdoorext1_beg, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext1", private.clk_shopdoorext1_end, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext1", private.clk_shopdoorext1_logic );
cmn.AddSubscriber( "clk_shopdoorext1_beg", private.clk_shopdoorext1_beg, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext1_end", private.clk_shopdoorext1_end, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext1_end", private.clk_shopdoorext1_logic );
--------------------------------------------------------------------------------------------
function public.clk_shopdoorext1()

  local func_end = function()
    cmn.SetEventDone( "clk_shopdoorext1" );
    cmn.CallEventHandler( "clk_shopdoorext1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_shopdoorext1") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_shopdoorext1_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_clk_shopdoorext1_nearshopext" )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_shopdoorext2" ] = { type = "click", use_place = "gfx_shopdoorext_clk_shopdoorext2_zone", room = "rm_nearshopext", zz = "zz_shopdoorext", zz_gate = "gzz_nearshopext_shopdoorext" };

private.clk_shopdoorext2_logic = function()
  ObjSet( "gfx_shopdoorext_clk_shopdoorext3_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_shopdoorext2_beg = function()
  ObjDelete( "gfx_shopdoorext_clk_shopdoorext2_zone" );
end;
private.clk_shopdoorext2_end = function()
  if common_impl.ZzCompleteCheck("clk_shopdoorext2") then ObjSet( common_impl.hint["clk_shopdoorext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_shopdoorext2", private.clk_shopdoorext2_beg, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext2", private.clk_shopdoorext2_end, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext2", private.clk_shopdoorext2_logic );
cmn.AddSubscriber( "clk_shopdoorext2_beg", private.clk_shopdoorext2_beg, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext2_end", private.clk_shopdoorext2_end, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext2_end", private.clk_shopdoorext2_logic );
--------------------------------------------------------------------------------------------
function public.clk_shopdoorext2()

  local func_end = function()
    cmn.SetEventDone( "clk_shopdoorext2" );
    cmn.CallEventHandler( "clk_shopdoorext2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_shopdoorext2") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_shopdoorext2_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_clk_shopdoorext2_nearshopext" )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_shopdoorext3" ] = { type = "click", use_place = "gfx_shopdoorext_clk_shopdoorext3_zone", room = "rm_nearshopext", zz = "zz_shopdoorext", zz_gate = "gzz_nearshopext_shopdoorext" };

private.clk_shopdoorext3_logic = function()
  ObjSet( "gfx_shopdoorext_clk_shopdoorext4_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_shopdoorext3_beg = function()
  ObjDelete( "gfx_shopdoorext_clk_shopdoorext3_zone" );
end;
private.clk_shopdoorext3_end = function()
  if common_impl.ZzCompleteCheck("clk_shopdoorext3") then ObjSet( common_impl.hint["clk_shopdoorext3"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_shopdoorext3", private.clk_shopdoorext3_beg, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext3", private.clk_shopdoorext3_end, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext3", private.clk_shopdoorext3_logic );
cmn.AddSubscriber( "clk_shopdoorext3_beg", private.clk_shopdoorext3_beg, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext3_end", private.clk_shopdoorext3_end, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext3_end", private.clk_shopdoorext3_logic );
--------------------------------------------------------------------------------------------
function public.clk_shopdoorext3()

  local func_end = function()
    cmn.SetEventDone( "clk_shopdoorext3" );
    cmn.CallEventHandler( "clk_shopdoorext3_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_shopdoorext3") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_shopdoorext3_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_clk_shopdoorext3_nearshopext" )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_shopdoorext4" ] = { type = "click", use_place = "gfx_shopdoorext_clk_shopdoorext4_zone", room = "rm_nearshopext", zz = "zz_shopdoorext", zz_gate = "gzz_nearshopext_shopdoorext" };

private.clk_shopdoorext4_logic = function()
  ObjSet( "grm_nearshopext_shopext", {active = 1, input = 1, visible = 1} );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_nearshopext_shopext_focus");
    end;
end;
private.clk_shopdoorext4_beg = function()
  ObjDelete( "gfx_shopdoorext_clk_shopdoorext4_zone" );
end;
private.clk_shopdoorext4_end = function()
  ObjDelete("spr_nearshopext_door_close")
  ObjSet( "anm_shopdoorext_anm_ice", {animfunc = "opendoor", frame = 999 } );
  if common_impl.ZzCompleteCheck("clk_shopdoorext4") then ObjSet( common_impl.hint["clk_shopdoorext4"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_shopdoorext4", private.clk_shopdoorext4_beg, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext4", private.clk_shopdoorext4_end, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext4", private.clk_shopdoorext4_logic );
cmn.AddSubscriber( "clk_shopdoorext4_beg", private.clk_shopdoorext4_beg, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext4_end", private.clk_shopdoorext4_end, private.room_objname );
cmn.AddSubscriber( "clk_shopdoorext4_end", private.clk_shopdoorext4_logic );
--------------------------------------------------------------------------------------------
function public.clk_shopdoorext4()

  local func_end = function()
    cmn.SetEventDone( "clk_shopdoorext4" );
    cmn.CallEventHandler( "clk_shopdoorext4_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_shopdoorext4") then ld.CloseSubRoom() end;
  end;
  local func_end2 = function()
    ld.CloseSubRoom()
    ObjAnimate( "spr_nearshopext_door_close", 8, 0, 0, function() func_end() end, {0,0,1, 0.5,0,0} );
  end
  cmn.CallEventHandler( "clk_shopdoorext4_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_shopdoorext_anm_ice", "opendoor", func_end2 );
  SoundSfx( "aud_open_door_to_shop" )
  --func_end2()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_icecastleext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_acornext2" ] = { type = "get", get_obj = "spr_icecastleext_acornext2", room = "rm_nearshopext", zz = "zz_icecastleext", zz_gate = "gzz_nearshopext_icecastleext" };

private.get_acornext2_logic = function()
  
end;
private.get_acornext2_inv = function()
  interface.InventoryItemAdd("inv_acornext","spr_icecastleext_acornext2",function() level_inv.ProcessGetAcornextAll( "get_acornext2" ) end);
end;
private.get_acornext2_beg = function()
  ObjDelete("gfx_icecastleext_acornext2")
end;
private.get_acornext2_end = function()
  ObjDelete("spr_icecastleext_acornext2_shadow")
  ObjDelete("spr_icecastleext_acornext2_tr")
  ObjDelete("spr_nearshopext_acornext2")
  if common_impl.ZzCompleteCheck("get_acornext2") then ObjSet( common_impl.hint["get_acornext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_acornext2", private.get_acornext2_inv );
cmn.AddSubscriber( "get_acornext2", private.get_acornext2_beg, private.room_objname );
cmn.AddSubscriber( "get_acornext2", private.get_acornext2_end, private.room_objname );
cmn.AddSubscriber( "get_acornext2", private.get_acornext2_logic );
--------------------------------------------------------------------
function public.get_acornext2()
  cmn.SetEventDone( "get_acornext2" );
  cmn.CallEventHandler( "get_acornext2" );
  if common_impl.ZzCompleteCheck("get_acornext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_glasstowerext" ] = { type = "use", inv_obj = "inv_glasstowerext", use_place = "gfx_icecastleext_glasstowerext_zone", room = "rm_nearshopext", zz = "zz_icecastleext", zz_gate = "gzz_nearshopext_icecastleext" };

private.use_glasstowerext_logic = function()
  ObjSet( "spr_icecastleext_tiaraext", { input = 1, active = 1 } )
end;
private.use_glasstowerext_inv = function()
  common_impl.ProcessMultiUseAll("glasstowerext", "glasstowerext")
end;
private.use_glasstowerext_beg = function()
  ObjDelete( "gfx_icecastleext_glasstowerext_zone" );
end;
private.use_glasstowerext_end = function()
  ObjSet( "gfx_icecastleext_tiaraext", { visible = 1, active = 1 } )
  ObjSet( "anm_icecastleext_anm_tower", {animfunc = "tower", frame = 999 } );
  ObjSet( "spr_nearshopext_tower", {visible = 1} );
  ObjSet( "spr_nearshopext_stone", {visible = 1} );
  ObjSet( "spr_nearshopext_bearext", {visible = 1} );
  ObjSet( "spr_nearshopext_tiaraext", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_glasstowerext") then ObjSet( common_impl.hint["use_glasstowerext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_glasstowerext", private.use_glasstowerext_inv );
cmn.AddSubscriber( "use_glasstowerext", private.use_glasstowerext_beg, private.room_objname );
cmn.AddSubscriber( "use_glasstowerext", private.use_glasstowerext_end, private.room_objname );
cmn.AddSubscriber( "use_glasstowerext", private.use_glasstowerext_logic );
cmn.AddSubscriber( "use_glasstowerext_inv", private.use_glasstowerext_inv, private.room_objname );
cmn.AddSubscriber( "use_glasstowerext_beg", private.use_glasstowerext_beg, private.room_objname );
cmn.AddSubscriber( "use_glasstowerext_end", private.use_glasstowerext_end, private.room_objname );
cmn.AddSubscriber( "use_glasstowerext_end", private.use_glasstowerext_logic );
--------------------------------------------------------------------------------------------
function public.use_glasstowerext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_glasstowerext" );
    cmn.CallEventHandler( "use_glasstowerext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_glasstowerext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_glasstowerext_inv" );
  cmn.CallEventHandler( "use_glasstowerext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_icecastleext_anm_tower", "tower", func_end );
  SoundSfx( "aud_use_glasstowerext_nearshopext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bearext" ] = { type = "get", get_obj = "spr_icecastleext_bearext", room = "rm_nearshopext", zz = "zz_icecastleext", zz_gate = "gzz_nearshopext_icecastleext" };

private.get_bearext_logic = function()
  
end;
private.get_bearext_inv = function()
  interface.InventoryItemAdd("inv_bearext","spr_icecastleext_bearext");
end;
private.get_bearext_beg = function()
  ObjDelete("gfx_icecastleext_bearext")
  ObjSet( "spr_icecastleext_bearext", {visible = 1} );
  ObjSet( "anm_icecastleext_anm_tower", {animfunc = "tower_end2", frame = 0 } );
end;
private.get_bearext_end = function()
  ObjDelete("spr_nearshopext_bearext")
  ObjSet( "spr_nearshopext_stone", {visible = 0} );
  if common_impl.ZzCompleteCheck("get_bearext") then ObjSet( common_impl.hint["get_bearext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bearext", private.get_bearext_inv );
cmn.AddSubscriber( "get_bearext", private.get_bearext_beg, private.room_objname );
cmn.AddSubscriber( "get_bearext", private.get_bearext_end, private.room_objname );
cmn.AddSubscriber( "get_bearext", private.get_bearext_logic );


cmn.AddSubscriber( "get_bearext_beg", private.get_bearext_inv );
cmn.AddSubscriber( "get_bearext_beg", private.get_bearext_beg, private.room_objname );
cmn.AddSubscriber( "get_bearext_end", private.get_bearext_end, private.room_objname );
cmn.AddSubscriber( "get_bearext_end", private.get_bearext_logic );
--------------------------------------------------------------------
function public.get_bearext()
  local function func_end() 
    ld.Lock(0)
    cmn.SetEventDone( "get_bearext" );
    cmn.CallEventHandler( "get_bearext_end" );
    if common_impl.ZzCompleteCheck("get_bearext") then ld.CloseSubRoom() end;
  end
  ld.Lock(1)
  cmn.CallEventHandler( "get_bearext_beg" );
  ld.AnimPlay( "anm_icecastleext_anm_lift", "tangleext", func_end )
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_tiaraext" ] = { type = "get", get_obj = "spr_icecastleext_tiaraext", room = "rm_nearshopext", zz = "zz_icecastleext", zz_gate = "gzz_nearshopext_icecastleext" };

private.get_tiaraext_logic = function()
  ObjSet( "spr_icecastleext_bearext", { input = 1, active = 1 } )
end;
private.get_tiaraext_inv = function()
  interface.InventoryItemAdd("inv_tiaraext","spr_icecastleext_tiaraext");
end;
private.get_tiaraext_beg = function()
  ObjDelete("gfx_icecastleext_tiaraext")
  ObjSet( "spr_icecastleext_tiaraext", {visible = 1} );
  ObjSet( "anm_icecastleext_anm_tower", {animfunc = "tower_end", frame = 0 } );
end;
private.get_tiaraext_end = function()
  ObjSet( "gfx_icecastleext_bearext", { visible = 1, active = 1 } )
  ObjDelete("spr_nearshopext_tiaraext")
  if common_impl.ZzCompleteCheck("get_tiaraext") then ObjSet( common_impl.hint["get_tiaraext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_tiaraext", private.get_tiaraext_inv );
cmn.AddSubscriber( "get_tiaraext", private.get_tiaraext_beg, private.room_objname );
cmn.AddSubscriber( "get_tiaraext", private.get_tiaraext_end, private.room_objname );
cmn.AddSubscriber( "get_tiaraext", private.get_tiaraext_logic );
--------------------------------------------------------------------
function public.get_tiaraext()
  cmn.SetEventDone( "get_tiaraext" );
  cmn.CallEventHandler( "get_tiaraext" );
  if common_impl.ZzCompleteCheck("get_tiaraext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_flagext" ] = { type = "use", inv_obj = "inv_flagext", use_place = "gfx_icecastleext_flagext_zone", room = "rm_nearshopext", zz = "zz_icecastleext", zz_gate = "gzz_nearshopext_icecastleext" };

private.use_flagext_logic = function()
  ObjSet( "spr_icecastleext_tangleext", {  input = 1, active = 1 } )

end;
private.use_flagext_inv = function()
  common_impl.ProcessMultiUseAll("flagext", "flagext")
end;
private.use_flagext_beg = function()
  ObjDelete( "gfx_icecastleext_flagext_zone" );
end;
private.use_flagext_end = function()
  ObjSet( "gfx_icecastleext_tangleext", { visible = 1, active = 1 } )
  ObjSet( "anm_icecastleext_anm_flag", {animfunc = "flag_static2", frame = 0, playing = 1 } );
  ObjSet( "anm_icecastleext_anm_lift", {animfunc = "flag1", frame = 999 } );
  ObjSet( "spr_nearshopext_flag", {visible = 1} );
  ObjSet( "spr_nearshopext_tangleext", {visible = 1} );
  ObjSet( "spr_nearshopext_stone", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_flagext") then ObjSet( common_impl.hint["use_flagext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_flagext", private.use_flagext_inv );
cmn.AddSubscriber( "use_flagext", private.use_flagext_beg, private.room_objname );
cmn.AddSubscriber( "use_flagext", private.use_flagext_end, private.room_objname );
cmn.AddSubscriber( "use_flagext", private.use_flagext_logic );
cmn.AddSubscriber( "use_flagext_inv", private.use_flagext_inv, private.room_objname );
cmn.AddSubscriber( "use_flagext_beg", private.use_flagext_beg, private.room_objname );
cmn.AddSubscriber( "use_flagext_end", private.use_flagext_end, private.room_objname );
cmn.AddSubscriber( "use_flagext_end", private.use_flagext_logic );
--------------------------------------------------------------------------------------------
function public.use_flagext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_flagext" );
    cmn.CallEventHandler( "use_flagext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_flagext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_flagext_inv" );
  cmn.CallEventHandler( "use_flagext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_icecastleext_anm_flag", "flag", 
  function() 
    ld.AnimPlay( "anm_icecastleext_anm_lift", "flag1", func_end )
  end );
  SoundSfx( "aud_use_flagext_nearshopext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_tangleext" ] = { type = "get", get_obj = "spr_icecastleext_tangleext", room = "rm_nearshopext", zz = "zz_icecastleext", zz_gate = "gzz_nearshopext_icecastleext" };

private.get_tangleext_logic = function()
  
end;
private.get_tangleext_inv = function()
  interface.InventoryItemAdd("inv_tangleext","spr_icecastleext_tangleext");
  ObjSet( "inv_tangleext", { drag = 0 } );
end;
private.get_tangleext_beg = function()
  ObjDelete("gfx_icecastleext_tangleext")
  ObjSet( "spr_icecastleext_tangleext", {visible = 1} );
end;
private.get_tangleext_end = function()
  ObjDelete("anm_icecastleext_anm_lift")
  ObjSet( "spr_nearshopext_stone", {visible = 0} );
  ObjDelete("spr_nearshopext_tangleext")
  if common_impl.ZzCompleteCheck("get_tangleext") then ObjSet( common_impl.hint["get_tangleext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_tangleext", private.get_tangleext_inv );
cmn.AddSubscriber( "get_tangleext", private.get_tangleext_beg, private.room_objname );
cmn.AddSubscriber( "get_tangleext", private.get_tangleext_end, private.room_objname );
cmn.AddSubscriber( "get_tangleext", private.get_tangleext_logic );

cmn.AddSubscriber( "get_tangleext_beg", private.get_tangleext_inv );
cmn.AddSubscriber( "get_tangleext_beg", private.get_tangleext_beg, private.room_objname );
cmn.AddSubscriber( "get_tangleext_end", private.get_tangleext_end, private.room_objname );
cmn.AddSubscriber( "get_tangleext_end", private.get_tangleext_logic );
--------------------------------------------------------------------
function public.get_tangleext()
  local function func_end()
    ld.Lock(0)
    cmn.SetEventDone( "get_tangleext" );
    cmn.CallEventHandler( "get_tangleext_end" );
    if common_impl.ZzCompleteCheck("get_tangleext") then ld.CloseSubRoom() end;
  end
  cmn.CallEventHandler( "get_tangleext_beg" );
  ld.Lock(1)
  ld.AnimPlay( "anm_icecastleext_anm_lift", "tangleext", func_end )
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_brokensleighext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_skiext" ] = { type = "use", inv_obj = "inv_skiext", use_place = "gfx_brokensleighext_skiext_zone", room = "rm_nearshopext", zz = "zz_brokensleighext", zz_gate = "gzz_nearshopext_brokensleighext" };

private.use_skiext_logic = function()
  ObjSet( "gfx_brokensleighext_screwext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_skiext_inv = function()
  common_impl.ProcessMultiUseAll("skiext", "skiext")
end;
private.use_skiext_beg = function()
  ObjDelete( "gfx_brokensleighext_skiext_zone" );
end;
private.use_skiext_end = function()
  ObjDelete("spr_nearshopext_trr")
  ObjSet( "spr_nearshopext_tr_sleigh", {visible = 1} );
  ObjSet( "anm_brokensleighext_anm", {animfunc = "g", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_skiext") then ObjSet( common_impl.hint["use_skiext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_skiext", private.use_skiext_inv );
cmn.AddSubscriber( "use_skiext", private.use_skiext_beg, private.room_objname );
cmn.AddSubscriber( "use_skiext", private.use_skiext_end, private.room_objname );
cmn.AddSubscriber( "use_skiext", private.use_skiext_logic );
cmn.AddSubscriber( "use_skiext_inv", private.use_skiext_inv, private.room_objname );
cmn.AddSubscriber( "use_skiext_beg", private.use_skiext_beg, private.room_objname );
cmn.AddSubscriber( "use_skiext_end", private.use_skiext_end, private.room_objname );
cmn.AddSubscriber( "use_skiext_end", private.use_skiext_logic );
--------------------------------------------------------------------------------------------
function public.use_skiext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_skiext" );
    cmn.CallEventHandler( "use_skiext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_skiext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_skiext_inv" );
  cmn.CallEventHandler( "use_skiext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_brokensleighext_anm", "sleigh", func_end );
  SoundSfx( "aud_use_skiext_nearshopext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_screwext" ] = { type = "use", inv_obj = "inv_screwext", use_place = "gfx_brokensleighext_screwext_zone", room = "rm_nearshopext", zz = "zz_brokensleighext", zz_gate = "gzz_nearshopext_brokensleighext" };

private.use_screwext_logic = function()
  ObjSet( "gfx_brokensleighext_wrenchext_brokensleighext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_screwext_inv = function()
  common_impl.ProcessMultiUseAll("screwext", "screwext")
end;
private.use_screwext_beg = function()
  ObjDelete( "gfx_brokensleighext_screwext_zone" );
end;
private.use_screwext_end = function()
  ObjSet( "anm_brokensleighext_anm", {animfunc = "wrench", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_screwext") then ObjSet( common_impl.hint["use_screwext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_screwext", private.use_screwext_inv );
cmn.AddSubscriber( "use_screwext", private.use_screwext_beg, private.room_objname );
cmn.AddSubscriber( "use_screwext", private.use_screwext_end, private.room_objname );
cmn.AddSubscriber( "use_screwext", private.use_screwext_logic );
cmn.AddSubscriber( "use_screwext_inv", private.use_screwext_inv, private.room_objname );
cmn.AddSubscriber( "use_screwext_beg", private.use_screwext_beg, private.room_objname );
cmn.AddSubscriber( "use_screwext_end", private.use_screwext_end, private.room_objname );
cmn.AddSubscriber( "use_screwext_end", private.use_screwext_logic );
--------------------------------------------------------------------------------------------
function public.use_screwext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_screwext" );
    cmn.CallEventHandler( "use_screwext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_screwext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_screwext_inv" );
  cmn.CallEventHandler( "use_screwext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_brokensleighext_anm", "g", func_end );
  SoundSfx( "aud_use_screwext_nearshopext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_wrenchext_brokensleighext" ] = { type = "use", inv_obj = "inv_wrenchext", use_place = "gfx_brokensleighext_wrenchext_brokensleighext_zone", room = "rm_nearshopext", zz = "zz_brokensleighext", zz_gate = "gzz_nearshopext_brokensleighext" };

private.use_wrenchext_brokensleighext_logic = function()
  ObjSet( "gfx_brokensleighext_mouseext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_wrenchext_brokensleighext_inv = function()
  common_impl.ProcessMultiUseAll("wrenchext", "wrenchext_brokensleighext")
end;
private.use_wrenchext_brokensleighext_beg = function()
  ObjDelete( "gfx_brokensleighext_wrenchext_brokensleighext_zone" );
end;
private.use_wrenchext_brokensleighext_end = function()
  ObjSet( "anm_brokensleighext_anm", {animfunc = "wrench", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_wrenchext_brokensleighext") then ObjSet( common_impl.hint["use_wrenchext_brokensleighext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_wrenchext_brokensleighext", private.use_wrenchext_brokensleighext_inv );
cmn.AddSubscriber( "use_wrenchext_brokensleighext", private.use_wrenchext_brokensleighext_beg, private.room_objname );
cmn.AddSubscriber( "use_wrenchext_brokensleighext", private.use_wrenchext_brokensleighext_end, private.room_objname );
cmn.AddSubscriber( "use_wrenchext_brokensleighext", private.use_wrenchext_brokensleighext_logic );
cmn.AddSubscriber( "use_wrenchext_brokensleighext_inv", private.use_wrenchext_brokensleighext_inv, private.room_objname );
cmn.AddSubscriber( "use_wrenchext_brokensleighext_beg", private.use_wrenchext_brokensleighext_beg, private.room_objname );
cmn.AddSubscriber( "use_wrenchext_brokensleighext_end", private.use_wrenchext_brokensleighext_end, private.room_objname );
cmn.AddSubscriber( "use_wrenchext_brokensleighext_end", private.use_wrenchext_brokensleighext_logic );
--------------------------------------------------------------------------------------------
function public.use_wrenchext_brokensleighext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_wrenchext_brokensleighext" );
    cmn.CallEventHandler( "use_wrenchext_brokensleighext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_wrenchext_brokensleighext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_wrenchext_brokensleighext_inv" );
  cmn.CallEventHandler( "use_wrenchext_brokensleighext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_brokensleighext_anm", "wrench", func_end );
  SoundSfx( "aud_use_wrenchext_brokensleighext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mouseext" ] = { type = "use", inv_obj = "inv_mouseext", use_place = "gfx_brokensleighext_mouseext_zone", room = "rm_nearshopext", zz = "zz_brokensleighext", zz_gate = "gzz_nearshopext_brokensleighext" };

private.use_mouseext_logic = function()
  ObjSet( "gfx_brokensleighext_dustext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_mouseext_inv = function()
  common_impl.ProcessMultiUseAll("mouseext", "mouseext")
end;
private.use_mouseext_beg = function()
  ObjDelete( "gfx_brokensleighext_mouseext_zone" );
end;
private.use_mouseext_end = function()
  ObjSet( "spr_nearshopext_mouse", {visible = 1} );
  ObjSet( "anm_brokensleighext_anm_mouse", {animfunc = "mouse_static", frame = 0, playing = 1 } );
  if common_impl.ZzCompleteCheck("use_mouseext") then ObjSet( common_impl.hint["use_mouseext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mouseext", private.use_mouseext_inv );
cmn.AddSubscriber( "use_mouseext", private.use_mouseext_beg, private.room_objname );
cmn.AddSubscriber( "use_mouseext", private.use_mouseext_end, private.room_objname );
cmn.AddSubscriber( "use_mouseext", private.use_mouseext_logic );
cmn.AddSubscriber( "use_mouseext_inv", private.use_mouseext_inv, private.room_objname );
cmn.AddSubscriber( "use_mouseext_beg", private.use_mouseext_beg, private.room_objname );
cmn.AddSubscriber( "use_mouseext_end", private.use_mouseext_end, private.room_objname );
cmn.AddSubscriber( "use_mouseext_end", private.use_mouseext_logic );
--------------------------------------------------------------------------------------------
function public.use_mouseext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mouseext" );
    cmn.CallEventHandler( "use_mouseext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mouseext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mouseext_inv" );
  cmn.CallEventHandler( "use_mouseext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_brokensleighext_anm_mouse", "mouse1", func_end );
  SoundSfx( "aud_use_mouseext_nearshopext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_dustext" ] = { type = "use", inv_obj = "inv_dustext", use_place = "gfx_brokensleighext_dustext_zone", room = "rm_nearshopext", zz = "zz_brokensleighext", zz_gate = "gzz_nearshopext_brokensleighext" };

private.use_dustext_logic = function()
  ObjSet( "grm_nearshopext_nearcastleext", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_nearshopext_nearcastleext_focus");
    end;

end;
private.use_dustext_inv = function()
  common_impl.ProcessMultiUseAll("dustext", "dustext")
end;
private.use_dustext_beg = function()
  ObjDelete( "gfx_brokensleighext_dustext_zone" );
end;
private.use_dustext_end = function()
  if common_impl.ZzCompleteCheck("use_dustext") then ObjSet( common_impl.hint["use_dustext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_dustext", private.use_dustext_inv );
cmn.AddSubscriber( "use_dustext", private.use_dustext_beg, private.room_objname );
cmn.AddSubscriber( "use_dustext", private.use_dustext_end, private.room_objname );
cmn.AddSubscriber( "use_dustext", private.use_dustext_logic );
cmn.AddSubscriber( "use_dustext_inv", private.use_dustext_inv, private.room_objname );
cmn.AddSubscriber( "use_dustext_beg", private.use_dustext_beg, private.room_objname );
cmn.AddSubscriber( "use_dustext_end", private.use_dustext_end, private.room_objname );
cmn.AddSubscriber( "use_dustext_end", private.use_dustext_logic );
--------------------------------------------------------------------------------------------
function public.use_dustext( obj )

  local func_end = function()
    int.DialogVideoHide();
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_dustext" );
    cmn.CallEventHandler( "use_dustext_end" );
    --common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_dustext") then ld.CloseSubRoom() end;
    ObjSet( "rm_nearshopext", {color_r = 0, color_g = 0, color_b = 0} );
    common_impl.Gate_MDown( "grm_nearshopext_nearcastleext" )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_dustext_inv" );
  cmn.CallEventHandler( "use_dustext_beg" );
  --common_impl.Lock(1);
  ObjSet( common_impl.hint["use_mouseext"].zz_gate, { visible = 0, input = 0 } );
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_dustext_nearshopext" )
  
  local function func_step()  
    ld.CloseSubRoom()
    --ObjAnimate( "spr_nearshopext_horse", 8, 0, 0, function() 
      ld.Lock(0)
      int.DialogVideoShow( "vid_nearshopext_vid_move_kareta", 1, func_end );
      SoundVid( "aud_move_kareta" )
      VidPlay("vid_nearshopext_vid_move_kareta", func_end)
    --end, {0,0,0, 1,0,1} );
  end
  ld.Lock(1)
  ld.AnimPlay( "anm_brokensleighext_anm_magic", "magic", func_step )
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_nearshopext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_nearshop_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_brokensleighext" );
  function zz_brokensleighext.Open()
  end;
  function zz_brokensleighext.PreOpen()
  end;
  function zz_brokensleighext.PreClose()
  end;
  function zz_brokensleighext.Close()
  end;

  subroom.Define( "zz_icecastleext" );
  function zz_icecastleext.Open()
  end;
  function zz_icecastleext.PreOpen()
  end;
  function zz_icecastleext.PreClose()
  end;
  function zz_icecastleext.Close()
  end;

  subroom.Define( "zz_shopdoorext" );
  function zz_shopdoorext.Open()
  end;
  function zz_shopdoorext.PreOpen()
  end;
  function zz_shopdoorext.PreClose()
  end;
  function zz_shopdoorext.Close()
  end;
  
end;
--*********************************************************************************************************************