-- name=rm_seconfloorext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_seconfloorext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_seconfloorext()
  if not ( cmn.IsEventDone( "opn_seconfloorext" ) ) then
  local func_end = function()
    cmn.SetEventDone( "opn_seconfloorext" );
    cmn.CallEventHandler( "opn_seconfloorext" )
    ld.ShowBbtOpn( private.room_objname )
    int.DialogVideoHide();
    VidPause( "vid_seconfloorext_vid_glowing_door", 1 )
  end;
  int.DialogVideoShow( "vid_seconfloorext_vid_glowing_door", 1, func_end, 1 );
  SoundVid( "vid_glowing_door" )
  VidPlay( "vid_seconfloorext_vid_glowing_door", func_end )
  end;
end;
--------------------------------------------------------------------
local opn_seconfloorext = function() end;
local opn_seconfloorext_logic = function() end;
cmn.AddSubscriber( "opn_seconfloorext", opn_seconfloorext_logic )
cmn.AddSubscriber( "opn_seconfloorext", opn_seconfloorext, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_tobalconyext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_fishinglineext" ] = { type = "get", get_obj = "spr_tobalconyext_fishinglineext", room = "rm_seconfloorext", zz = "zz_tobalconyext", zz_gate = "gzz_seconfloorext_tobalconyext" };

private.get_fishinglineext_logic = function()
  
end;
private.get_fishinglineext_inv = function()
  interface.InventoryItemAdd("inv_fishinglineext","spr_tobalconyext_fishinglineext");
end;
private.get_fishinglineext_beg = function()
  ObjDelete("gfx_tobalconyext_fishinglineext")
end;
private.get_fishinglineext_end = function()
  ObjDelete( "spr_tobalconyext_fishinglineext_sh" )
  if common_impl.ZzCompleteCheck("get_fishinglineext") then ObjSet( common_impl.hint["get_fishinglineext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_fishinglineext", private.get_fishinglineext_inv );
cmn.AddSubscriber( "get_fishinglineext", private.get_fishinglineext_beg, private.room_objname );
cmn.AddSubscriber( "get_fishinglineext", private.get_fishinglineext_end, private.room_objname );
cmn.AddSubscriber( "get_fishinglineext", private.get_fishinglineext_logic );
--------------------------------------------------------------------
function public.get_fishinglineext()
  cmn.SetEventDone( "get_fishinglineext" );
  cmn.CallEventHandler( "get_fishinglineext" );
  if common_impl.ZzCompleteCheck("get_fishinglineext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_cubeext" ] = { type = "use", inv_obj = "inv_cubeext", use_place = "gfx_tobalconyext_cubeext_zone", room = "rm_seconfloorext", zz = "zz_tobalconyext", zz_gate = "gzz_seconfloorext_tobalconyext" };

private.use_cubeext_logic = function()
  ObjSet( "obj_tobalconyext_mmg_root", { visible = 1, input = 1, active = 1 } )
end;
private.use_cubeext_inv = function()
  common_impl.ProcessMultiUseAll("cubeext", "cubeext")
end;
private.use_cubeext_beg = function()
  ObjDelete( "gfx_tobalconyext_cubeext_zone" );
end;
private.use_cubeext_end = function()
  ObjSet( "spr_seconfloorext_cubes", { visible = 1 } )
  ObjSet( "spr_tobalconyext_1_2", { alp = 1 } )
  ObjSet( "spr_tobalconyext_2_2", { alp = 1 } )
  if common_impl.ZzCompleteCheck("use_cubeext") then ObjSet( common_impl.hint["use_cubeext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cubeext", private.use_cubeext_inv );
cmn.AddSubscriber( "use_cubeext", private.use_cubeext_beg, private.room_objname );
cmn.AddSubscriber( "use_cubeext", private.use_cubeext_end, private.room_objname );
cmn.AddSubscriber( "use_cubeext", private.use_cubeext_logic );
cmn.AddSubscriber( "use_cubeext_inv", private.use_cubeext_inv, private.room_objname );
cmn.AddSubscriber( "use_cubeext_beg", private.use_cubeext_beg, private.room_objname );
cmn.AddSubscriber( "use_cubeext_end", private.use_cubeext_end, private.room_objname );
cmn.AddSubscriber( "use_cubeext_end", private.use_cubeext_logic );
--------------------------------------------------------------------------------------------
function public.use_cubeext_xx()
  if ld.Lock( 1 ) then
    SoundSfx( "aud_xx_puzzle" )
    local t = 0;
    local ta = 0.25;
    local ts = 0.025;
    local d = 5;
    local o
    for j = 1, 3 do
      for i = 1, 3 do
        o = ObjGet( "spr_tobalconyext_"..j.."_"..i );
        ObjAnimate( o.name, 0,0,0, nil, { 0,0,o.pos_x, t,0,o.pos_x, t+ta*0.5,math.random(0,3),o.pos_x+math.random(-d,d), t+ta,0,o.pos_x } )
        ObjAnimate( o.name, 1,0,0, nil, { 0,0,o.pos_y, t,0,o.pos_y, t+ta*0.5,math.random(0,3),o.pos_y+math.random(-d,d), t+ta,0,o.pos_y } )
        t = t + ts;
      end;
    end
    ld.StartTimer( t + ta, function() common_impl.ShowBbt( 'need_cubeext' ) ld.Lock( 0 ) end )
  end
end
function public.use_cubeext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cubeext" );
    cmn.CallEventHandler( "use_cubeext_end" );
    common_impl.Lock(0);
    cmn.MiniGameShow( "tobalconyext" );
    if common_impl.ZzCompleteCheck("use_cubeext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cubeext_inv" );
  cmn.CallEventHandler( "use_cubeext_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_cubeext_seconfloorext" )
  local t = 0.4
  for i = 1, 2 do
    local o = ObjGet( "spr_tobalconyext_"..i.."_2" )
    ObjAttach( o.name, "obj_tobalconyext_mmg_root" )
    ObjAnimate( o.name, 6,0,0, nil, { 0,0,1.5,1.5, t,2,1,1 } )
    ObjAnimate( o.name, 0,0,0, nil, { 0,0,o.pos_x + 50 * math.random(), t,2,o.pos_x } )
    ObjAnimate( o.name, 1,0,0, nil, { 0,0,o.pos_y + 50 * math.random(), t,2,o.pos_y } )
    ObjAnimate( o.name, 8,0,0, function() ObjAttach( o.name, "obj_tobalconyext_mmg_blocks_root" ) end, { 0,0,0, t,0,1 } )
  end

  local anm = ld.TableShuffle( ld.Anim.Liquid( 0.8, 12 , 0, 1, 0.95 ) )
  for i, o in ipairs( ObjGetRelations( "obj_tobalconyext_mmg_controller_root" ).childs ) do
    ObjAnimate( o, 8,0,0, nil, anm[ i ] )
  end

  ld.StartTimer( 0.8, func_end )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_tobalconyext" ] = { type = "click", use_place = "obj_tobalconyext_mmg_root", room = "rm_seconfloorext", zz = "zz_tobalconyext", zz_gate = "gzz_seconfloorext_tobalconyext" };

private.win_tobalconyext_logic = function()
  if ld.CheckRequirements( { "win_tobalconyext" } ) then
    ObjSet( "gmg_seconfloorext_fightext", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_tobalconyext_beg = function( force )
  if force or ld.CheckRequirements( { "win_tobalconyext" } ) then
    ObjDelete( "spr_seconfloorext_mmg_wait" );
    ObjDelete( "spr_seconfloorext_cubes" );
  end
end;
private.win_tobalconyext_end = function()
  if ld.CheckRequirements( { "win_tobalconyext" } ) then
    ObjSet( "anm_seconfloorext_anim_open_door", { animfunc = "open_door", frame = 999 } )
    if common_impl.ZzCompleteCheck("win_tobalconyext") then ObjSet( common_impl.hint["win_tobalconyext"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_tobalconyext", private.win_tobalconyext_beg, private.room_objname );
cmn.AddSubscriber( "win_tobalconyext", private.win_tobalconyext_end, private.room_objname );
cmn.AddSubscriber( "win_tobalconyext", private.win_tobalconyext_logic );
cmn.AddSubscriber( "win_tobalconyext_beg", private.win_tobalconyext_beg, private.room_objname );
cmn.AddSubscriber( "win_tobalconyext_end", private.win_tobalconyext_end, private.room_objname );
cmn.AddSubscriber( "win_tobalconyext_end", private.win_tobalconyext_logic );
--------------------------------------------------------------------------------------------
function public.win_tobalconyext()

  local func_end = function()
    cmn.SetEventDone( "win_tobalconyext" );
    cmn.CallEventHandler( "win_tobalconyext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_tobalconyext") then ld.CloseSubRoom() end;
  end;

  private.win_tobalconyext_beg( true )
  common_impl.Lock(1);

  ObjSet( common_impl.hint["win_tobalconyext"].zz_gate, { visible = 0, input = 0 } );

  cmn.MiniGameHide( "tobalconyext", true );
  
  ld.AnimPlay( "anm_tobalconyext_anim", "win", function() 
    ld.CloseSubRoom()
    ObjSet( "anm_seconfloorext_anim_open_door", { animfunc = "open_door", frame = 0 } )
    ObjAnimate( "anm_seconfloorext_anim_open_door", 7,0,0, function() 
      ld.AnimPlay( "anm_seconfloorext_anim_open_door", "open_door", func_end )
    end, { 0,0,0, 0,0,0 } )
  end );
  SoundSfx( "aud_win_tobalconyext" )

end;
function private.win_tobalconyext_load()
  
  if ld.CheckRequirements( { "use_cubeext" } ) then
    cmn.MiniGameShow( "tobalconyext" );
  end

  if not private.win_tobalconyext_game then
    private.win_tobalconyext_game = {}
    local gm = private.win_tobalconyext_game

    gm.win_tobalconyext_loaded = true;

    function gm.line_push( y, way )
      if way > 0 then
        gm.map[ y ][ 1 ], gm.map[ y ][ 2 ], gm.map[ y ][ 3 ] =
        gm.map[ y ][ 3 ], gm.map[ y ][ 1 ], gm.map[ y ][ 2 ]
      else
        gm.map[ y ][ 1 ], gm.map[ y ][ 2 ], gm.map[ y ][ 3 ] =
        gm.map[ y ][ 2 ], gm.map[ y ][ 3 ], gm.map[ y ][ 1 ]
      end
    end

    function gm.column_push( x, way )
      if way > 0 then
        gm.map[ 1 ][ x ], gm.map[ 2 ][ x ], gm.map[ 3 ][ x ] =
        gm.map[ 3 ][ x ], gm.map[ 1 ][ x ], gm.map[ 2 ][ x ]
      else
        gm.map[ 1 ][ x ], gm.map[ 2 ][ x ], gm.map[ 3 ][ x ] =
        gm.map[ 2 ][ x ], gm.map[ 3 ][ x ], gm.map[ 1 ][ x ]
      end
    end

    function gm.default() 
      gm.T = 0.3;
      gm.W = 115
      gm.map = {
        {11,12,13};
        {21,22,23};
        {31,32,33};
      }
      gm.line_push( 1, 1 )
      gm.column_push( 1, 1 )
      gm.line_push( 2, -1 )
      gm.column_push( 2, -1 )
      gm.line_push( 3, 1 )
      gm.column_push( 3, 1 )
    end

    function gm.save()
      ng_global.progress[ "ext" ][ "win_tobalconyext" ].state = ld.TableCopy( gm.map )
    end

    function gm.get_obj_name( j, i )
      return "spr_tobalconyext_"..( math.floor( gm.map[ j ][ i ] / 10 ) ).."_"..( gm.map[ j ][ i ] % 10 )
    end

    function gm.get_pos_x( i )
      return ( i - 2 ) * gm.W
    end

    function gm.get_pos_y( j )
      return ( j - 2 ) * gm.W
    end

    function gm.set_all()
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
            ObjSet( gm.get_obj_name( j, i ), { pos_x = gm.get_pos_x( i ); pos_y = gm.get_pos_y( j ); } )
        end;
      end
    end;

    function gm.win_check()
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          if gm.map[ j ][ i ] ~= j * 10 + i then
            return false
          end
        end;
      end
      return true
    end;

    function gm.event_menter( obj )
      ld.ShCur(CURSOR_HAND)
      obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
      local o = ObjGet( obj.."_light" )
      if not o then o = ObjGet( obj.."_focus" ) end
      if not o then o = ObjGet( obj ) end
      if o then
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
      end
    end;

    function gm.event_mleave( obj )
      ld.ShCur(CURSOR_DEFAULT)
      obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
      local o = ObjGet( obj.."_light" )
      if not o then o = ObjGet( obj.."_focus" ) end
      if not o then o = ObjGet( obj ) end
      if o then
        ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
      end
    end;

    function gm.move_end()
      
      if gm.win_check() then
        public.win_tobalconyext()
      else
        ObjSet( "spr_tobalconyext_changer", { res = "" } )
        gm.set_all()
        gm.save()
        ld.Lock( 0 )
      end
    end

    function gm.move_column( x, way )
      if ld.Lock( 1 ) then
        local changer_j_res = way > 0 and #gm.map or 1
        local changer_j_pos = way > 0 and 0 or ( #gm.map + 1 )
        ObjSet( "spr_tobalconyext_changer", { res = ObjGet( gm.get_obj_name( changer_j_res, x ) ).res } )

        for j = 1, #gm.map do
          ObjAnimate( gm.get_obj_name( j, x ), 1,0,0, nil, { 0,0,gm.get_pos_y( j ), gm.T,3,gm.get_pos_y( j + way ) } )
        end

        gm.column_push( x, way )

        ObjAnimate( "spr_tobalconyext_changer", 3,0,0, gm.move_end, { 0,0,gm.get_pos_x( x ),gm.get_pos_y( changer_j_pos ), gm.T,3,gm.get_pos_x( x ),gm.get_pos_y( changer_j_pos + way ) } )

      end
    end;

    function gm.move_line( y, way )
      if ld.Lock( 1 ) then

        local changer_i_res = way > 0 and #gm.map[ y ] or 1
        local changer_i_pos = way > 0 and 0 or ( #gm.map[ y ] + 1 )
        ObjSet( "spr_tobalconyext_changer", { res = ObjGet( gm.get_obj_name( y, changer_i_res) ).res } )

        for i = 1, #gm.map[ y ] do
          ObjAnimate( gm.get_obj_name( y, i ), 0,0,0, nil, { 0,0,gm.get_pos_x( i ), gm.T,3,gm.get_pos_x( i + way ) } )
        end

        gm.line_push( y, way )

        ObjAnimate( "spr_tobalconyext_changer", 3,0,0, gm.move_end, { 0,0,gm.get_pos_x( changer_i_pos ),gm.get_pos_y( y ), gm.T,3,gm.get_pos_x( changer_i_pos + way ),gm.get_pos_y( y ) } )

      end
    end;

    gm.default()

    for j = 1, #gm.map do
      for i = 1, #gm.map[ j ] do
        if ( j == 1 or j == #gm.map ) then
          ObjSet( "spr_tobalconyext_arrow_"..( j == 1 and "up" or "down" ).."_"..i, {
            alp = 0;
            input = 1;
            event_mdown = function( ne_params ) SoundSfx( "aud_clk_arrow1" ) gm.move_column( i, j == 1 and -1 or 1 ) end;
            event_menter = gm.event_menter;
            event_mleave = gm.event_mleave;
          } )
        end
        if ( i == 1 or i == #gm.map[ j ] ) then
          ObjSet( "spr_tobalconyext_arrow_"..( i == 1 and "left" or "right" ).."_"..j, {
            alp = 0;
            input = 1;
            event_mdown = function( ne_params ) SoundSfx( "aud_clk_arrow1" ) gm.move_line( j, i == 1 and -1 or 1 ) end;
            event_menter = gm.event_menter;
            event_mleave = gm.event_mleave;
          } )
        end
      end;
    end


    if ng_global.progress[ "ext" ][ "win_tobalconyext" ].state then
      gm.map = ld.TableCopy( ng_global.progress[ "ext" ][ "win_tobalconyext"].state )
    end

    gm.set_all()

    function gm.anim_to_state()
      local o, animated
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          o = ObjGet( gm.get_obj_name( j, i) )
          if o.pos_x ~= gm.get_pos_x( i ) then
            animated = true
            ObjAnimate( o.name, 0,0,0, nil, { 0,0,o.pos_x, gm.T,math.random( 0, 3 ),gm.get_pos_x( i ) } )
          end
          if o.pos_y ~= gm.get_pos_y( j ) then
            animated = true
            ObjAnimate( o.name, 1,0,0, nil, { 0,0,o.pos_y, gm.T,math.random( 0, 3 ),gm.get_pos_y( j ) } )
          end
        end;
      end
      return animated
    end

    function gm.reset()
      gm.default()
      if gm.anim_to_state() then
        ld.Lock( 1 )
        ld.StartTimer( gm.T, gm.move_end )
      end
    end

    function gm.skip()
      ld.Lock( 1 )
      for j = 1, #gm.map do
        for i = 1, #gm.map[ j ] do
          gm.map[ j ][ i ] = j * 10 + i;
        end;
      end
      gm.anim_to_state()
      ld.StartTimer( gm.T, public.win_tobalconyext  )
    end

  else

  end;

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_archercatext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_quiverext" ] = { type = "get", get_obj = "spr_archercatext_quiverext", room = "rm_seconfloorext", zz = "zz_archercatext", zz_gate = "gzz_seconfloorext_archercatext" };

private.get_quiverext_logic = function()
  
end;
private.get_quiverext_inv = function()
  interface.InventoryItemAdd("inv_quiverext","spr_archercatext_quiverext");
end;
private.get_quiverext_beg = function()
  ObjDelete("gfx_archercatext_quiverext")
end;
private.get_quiverext_end = function()
  ObjDelete( "spr_seconfloorext_quiverext" )
  ObjDelete( "spr_archercatext_quiverext_sh" )
  if common_impl.ZzCompleteCheck("get_quiverext") then ObjSet( common_impl.hint["get_quiverext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_quiverext", private.get_quiverext_inv );
cmn.AddSubscriber( "get_quiverext", private.get_quiverext_beg, private.room_objname );
cmn.AddSubscriber( "get_quiverext", private.get_quiverext_end, private.room_objname );
cmn.AddSubscriber( "get_quiverext", private.get_quiverext_logic );
--------------------------------------------------------------------
function public.get_quiverext()
  cmn.SetEventDone( "get_quiverext" );
  cmn.CallEventHandler( "get_quiverext" );
  if common_impl.ZzCompleteCheck("get_quiverext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletarcherext" ] = { type = "use", inv_obj = "inv_amuletarcherext", use_place = "gfx_archercatext_amuletarcherext_zone", room = "rm_seconfloorext", zz = "zz_archercatext", zz_gate = "gzz_seconfloorext_archercatext" };

private.use_amuletarcherext_logic = function()
  ObjSet( "spr_archercatext_santacatext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_archercatext_crystalflowerext", { visible = 1, input = 1, active = 1 } )

end;
private.use_amuletarcherext_inv = function()
  common_impl.ProcessMultiUseAll("amuletarcherext", "amuletarcherext")
end;
private.use_amuletarcherext_beg = function()
  ObjDelete( "gfx_archercatext_amuletarcherext_zone" );
end;
private.use_amuletarcherext_end = function()
  ObjDelete( "spr_seconfloorext_cover" )
  ObjSet( "spr_seconfloorext_cover_moved", { visible = 1 } )
  ObjSet( "gfx_archercatext_santacatext", { active = 1 } )
  ObjSet( "gfx_archercatext_crystalflowerext", { active = 1 } )
  ObjSet( "anm_archercatext_anim_use_amulet", { animfunc = "use_amulet", frame = 999 } )
  if common_impl.ZzCompleteCheck("use_amuletarcherext") then ObjSet( common_impl.hint["use_amuletarcherext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletarcherext", private.use_amuletarcherext_inv );
cmn.AddSubscriber( "use_amuletarcherext", private.use_amuletarcherext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletarcherext", private.use_amuletarcherext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletarcherext", private.use_amuletarcherext_logic );
cmn.AddSubscriber( "use_amuletarcherext_inv", private.use_amuletarcherext_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletarcherext_beg", private.use_amuletarcherext_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletarcherext_end", private.use_amuletarcherext_end, private.room_objname );
cmn.AddSubscriber( "use_amuletarcherext_end", private.use_amuletarcherext_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletarcherext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletarcherext" );
    cmn.CallEventHandler( "use_amuletarcherext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletarcherext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletarcherext_inv" );
  cmn.CallEventHandler( "use_amuletarcherext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_archercatext_anim_use_amulet", "use_amulet", func_end );
  SoundSfx( "aud_use_amuletarcherext_seconfloorext" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_santacatext" ] = { type = "get", get_obj = "spr_archercatext_santacatext", room = "rm_seconfloorext", zz = "zz_archercatext", zz_gate = "gzz_seconfloorext_archercatext" };

private.get_santacatext_logic = function()
  
end;
private.get_santacatext_inv = function()
  interface.InventoryItemAdd("inv_santacatext","spr_archercatext_santacatext");
end;
private.get_santacatext_beg = function()
  ObjDelete("gfx_archercatext_santacatext")
end;
private.get_santacatext_end = function()
  ObjDelete( "spr_seconfloorext_santacatext" )
  if common_impl.ZzCompleteCheck("get_santacatext") then ObjSet( common_impl.hint["get_santacatext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_santacatext", private.get_santacatext_inv );
cmn.AddSubscriber( "get_santacatext", private.get_santacatext_beg, private.room_objname );
cmn.AddSubscriber( "get_santacatext", private.get_santacatext_end, private.room_objname );
cmn.AddSubscriber( "get_santacatext", private.get_santacatext_logic );
--------------------------------------------------------------------
function public.get_santacatext()
  cmn.SetEventDone( "get_santacatext" );
  cmn.CallEventHandler( "get_santacatext" );
  if common_impl.ZzCompleteCheck("get_santacatext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_crystalflowerext" ] = { type = "get", get_obj = "spr_archercatext_crystalflowerext", room = "rm_seconfloorext", zz = "zz_archercatext", zz_gate = "gzz_seconfloorext_archercatext" };

private.get_crystalflowerext_logic = function()
  
end;
private.get_crystalflowerext_inv = function()
  interface.InventoryItemAdd("inv_crystalflowerext","spr_archercatext_crystalflowerext");
end;
private.get_crystalflowerext_beg = function()
  ObjDelete("gfx_archercatext_crystalflowerext")
end;
private.get_crystalflowerext_end = function()
  ObjDelete( "spr_seconfloorext_crystalflowerext" )
  if common_impl.ZzCompleteCheck("get_crystalflowerext") then ObjSet( common_impl.hint["get_crystalflowerext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_crystalflowerext", private.get_crystalflowerext_inv );
cmn.AddSubscriber( "get_crystalflowerext", private.get_crystalflowerext_beg, private.room_objname );
cmn.AddSubscriber( "get_crystalflowerext", private.get_crystalflowerext_end, private.room_objname );
cmn.AddSubscriber( "get_crystalflowerext", private.get_crystalflowerext_logic );
--------------------------------------------------------------------
function public.get_crystalflowerext()
  cmn.SetEventDone( "get_crystalflowerext" );
  cmn.CallEventHandler( "get_crystalflowerext" );
  if common_impl.ZzCompleteCheck("get_crystalflowerext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_fightext_for_seconfloorext = function()
    if ld.CheckRequirements( {"win_fightext"} ) then
      --ObjSet( "gmg_seconfloorext_fightext", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_fightext", win_fightext_for_seconfloorext, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Skip()
  local mg_name = common.GetCurrentSubRoom();
  if ( mg_name == "zz_tobalconyext" ) then
    private.win_tobalconyext_game.skip()  
  end
end
--*********************************************************************************************************************
function public.Reset()
  local mg_name = common.GetCurrentSubRoom();
  if ( mg_name == "zz_tobalconyext" ) then
    private.win_tobalconyext_game.reset()         
  end
end
--*********************************************************************************************************************
function public.Open()
  private.opn_seconfloorext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_secondfloor_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_archercatext" );
  function zz_archercatext.Open()
  end;
  function zz_archercatext.PreOpen()
  end;
  function zz_archercatext.PreClose()
  end;
  function zz_archercatext.Close()
  end;

  subroom.Define( "zz_tobalconyext" );
  function zz_tobalconyext.Open()
  end;
  function zz_tobalconyext.PreOpen()
    private.win_tobalconyext_load()
  end;
  function zz_tobalconyext.PreClose()
  end;
  function zz_tobalconyext.Close()
  end;
  
end;
--*********************************************************************************************************************