-- name=rm_shopext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_shopext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("spr_shoeext_paper_shadow", "spr_shoeext_paper_big", "txt_shoeext_note")
  ld.NoteRelaseLock("spr_shoeext_paper_shadow")
  --------------------------------------------------------------------------------------------
function private.opn_shopext()
  if not ( cmn.IsEventDone( "opn_shopext" ) ) then
    local func_end = function()
        SoundVid( 0 )
        cmn.SetEventDone( "opn_shopext" );
        cmn.CallEventHandler( "opn_shopext" )
        ld.ShowBbtOpn( private.room_objname )
        ObjDelete("vid_shopext_cinderella_goes_131")
        ld.Lock(0)
    end;
    ld.Lock(1)
    ObjAttach("vid_shopext_cinderella_goes_131","rm_shopext")
    ObjAnimate( "vid_shopext_cinderella_goes_131", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
    VidPlay("vid_shopext_cinderella_goes_131",func_end)
    SoundVid( "aud_cinderella_came_to_shop" )
  end;
end;
--------------------------------------------------------------------
local opn_shopext = function()
  ObjAttach("vid_shopext_cinderella_static_97","rm_shopext")
end;
local opn_shopext_logic = function() 
  ObjSet( "gfx_shopext_cinderellasetext_zone", {active = 1, input = 1, visible = 1} );
end;
cmn.AddSubscriber( "opn_shopext", opn_shopext_logic )
cmn.AddSubscriber( "opn_shopext", opn_shopext, private.room_objname )
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "fairyext4" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    elseif count_txt == 2 then
      common_impl.continue_visible = true
    elseif count_txt == 3 then
      --common_impl.continue_visible = true
    end
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_cinderellasetext" ] = { type = "use", inv_obj = "inv_cinderellasetext", use_place = "gfx_shopext_cinderellasetext_zone", room = "rm_shopext" };

private.use_cinderellasetext_logic = function()
  ObjSet( "spr_shopext_cinderellabagext", {  input = 1, active = 1 } )
  

end;
private.use_cinderellasetext_inv = function()
  common_impl.ProcessMultiUseAll("cinderellasetext", "cinderellasetext")
end;
private.use_cinderellasetext_beg = function()
  ObjDelete( "gfx_shopext_cinderellasetext_zone" );
end;
private.use_cinderellasetext_end = function()
  ObjSet( "gfx_shopext_cinderellabagext", { visible = 1, active = 1 } )
  ObjDelete("vid_shopext_cinderella_static_97")
  ObjAttach("vid_shopext_cinderella_bag_71","rm_shopext")
  ObjSet( "vid_shopext_cinderella_bag_71", {frame = 70} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cinderellasetext", private.use_cinderellasetext_inv );
cmn.AddSubscriber( "use_cinderellasetext", private.use_cinderellasetext_beg, private.room_objname );
cmn.AddSubscriber( "use_cinderellasetext", private.use_cinderellasetext_end, private.room_objname );
cmn.AddSubscriber( "use_cinderellasetext", private.use_cinderellasetext_logic );
cmn.AddSubscriber( "use_cinderellasetext_inv", private.use_cinderellasetext_inv, private.room_objname );
cmn.AddSubscriber( "use_cinderellasetext_beg", private.use_cinderellasetext_beg, private.room_objname );
cmn.AddSubscriber( "use_cinderellasetext_end", private.use_cinderellasetext_end, private.room_objname );
cmn.AddSubscriber( "use_cinderellasetext_end", private.use_cinderellasetext_logic );
--------------------------------------------------------------------------------------------
function public.use_cinderellasetext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cinderellasetext" );
    cmn.CallEventHandler( "use_cinderellasetext_end" );
    common_impl.Lock(0);
    ld.ShowBbt("shopext_after_cinderella_dress");
  end;
  local func_end_2 = function()
    ld.Lock(1)
    int.DialogVideoHide();
    ObjDelete("vid_shopext_cinderella_static_97")
    ObjAttach("vid_shopext_cinderella_bag_71","rm_shopext")
    VidPlay("vid_shopext_cinderella_bag_71",func_end)
    SoundSfx( "aud_cinderella_bag_71" )
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cinderellasetext_inv" );
  cmn.CallEventHandler( "use_cinderellasetext_beg" );
  --common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  int.DialogVideoShow( "vid_shopext_cinderella_dress", 1, func_end_2 );
  VidPlay("vid_shopext_cinderella_dress",func_end_2)
  SoundVid( "aud_cinderella_dress" )
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cinderellabagext" ] = { type = "get", get_obj = "spr_shopext_cinderellabagext", room = "rm_shopext" };

private.get_cinderellabagext_logic = function()
  --ObjSet( "gfx_shopext_dlg_shopext_fairyext4_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_cinderellabagext_inv = function()
  interface.InventoryItemAdd("inv_cinderellabagext","spr_shopext_cinderellabagext");
  ObjSet( "inv_cinderellabagext", { drag = 0 } );
end;
private.get_cinderellabagext_beg = function()
  ObjDelete("gfx_shopext_cinderellabagext")
  ObjDelete("vid_shopext_cinderella_bag_71")
  ObjSet( "spr_shopext_cinderellabagext", {visible = 1} );
end;
private.get_cinderellabagext_end = function()
  
end;

cmn.AddSubscriber( "get_cinderellabagext", private.get_cinderellabagext_inv );
cmn.AddSubscriber( "get_cinderellabagext", private.get_cinderellabagext_beg, private.room_objname );
cmn.AddSubscriber( "get_cinderellabagext", private.get_cinderellabagext_end, private.room_objname );
cmn.AddSubscriber( "get_cinderellabagext", private.get_cinderellabagext_logic );
--------------------------------------------------------------------
function public.get_cinderellabagext()
  cmn.CallEventHandler( "get_cinderellabagext" );
  ld.Lock(1)
  ObjAttach("vid_shopext_cinderella_without_bags_26","rm_shopext")
  VidPlay("vid_shopext_cinderella_without_bags_26",function() 
    ld.Lock(0)
    ObjDelete("vid_shopext_cinderella_without_bags_26")
    ObjAttach("vid_shopext_cinderella_without_bags_statics_124","rm_shopext")
    public.dlg_shopext_fairyext4( obj )
  end)
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_shopext_fairyext4" ] = { type = "click", use_place = "gfx_shopext_dlg_shopext_fairyext4_zone", room = "rm_shopext" };

private.dlg_shopext_fairyext4_logic = function()

end;
private.dlg_shopext_fairyext4_beg = function()
  ObjDelete( "gfx_shopext_dlg_shopext_fairyext4_zone" );
end;
private.dlg_shopext_fairyext4_end = function()
  ObjAttach("vid_shopext_cinderella_without_bags_statics_124","rm_shopext")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_shopext_fairyext4", private.dlg_shopext_fairyext4_beg, private.room_objname );
cmn.AddSubscriber( "dlg_shopext_fairyext4", private.dlg_shopext_fairyext4_end, private.room_objname );
cmn.AddSubscriber( "dlg_shopext_fairyext4", private.dlg_shopext_fairyext4_logic );
cmn.AddSubscriber( "dlg_shopext_fairyext4_beg", private.dlg_shopext_fairyext4_beg, private.room_objname );
cmn.AddSubscriber( "dlg_shopext_fairyext4_end", private.dlg_shopext_fairyext4_end, private.room_objname );
cmn.AddSubscriber( "dlg_shopext_fairyext4_end", private.dlg_shopext_fairyext4_logic );
--------------------------------------------------------------------------------------------
function public.dlg_shopext_fairyext4( obj )
  local func_end = function()
    cmn.SetEventDone( "get_cinderellabagext" );
    cmn.SetEventDone( "dlg_shopext_fairyext4" );
    cmn.CallEventHandler( "dlg_shopext_fairyext4_end" );
    common_impl.Lock(0);
  end;
  function public.dlg_shopext_fairyext4_func_end()
    common_impl.Lock(1);
    func_end()
  end
  cmn.CallEventHandler( "dlg_shopext_fairyext4_beg" );
  common_impl.dialog_character_loc = "";
  common_impl.Start( "fairyext4", 3, nil, nil, true, "dlg_shopext_fairyext4_func_end", { "aud_fairy_7_voc", "aud_fairy_8_voc" } );
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_shoeext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_instructionext" ] = { type = "get", get_obj = "spr_shoeext_instructionext", room = "rm_shopext", zz = "zz_shoeext", zz_gate = "gzz_shopext_shoeext" };

private.get_instructionext_logic = function()
  ObjSet( "gfx_shoeext_goldenkeyext_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_instructionext_inv = function()
  interface.InventoryItemAdd("inv_instructionext","spr_shoeext_instructionext");
  ObjSet( "inv_instructionext", { drag = 0 } );
end;
private.get_instructionext_beg = function()
  ObjDelete("gfx_shoeext_instructionext")
end;
private.get_instructionext_end = function()
  ObjDelete("spr_shoeext_sh_instructionext")
  ObjDelete("spr_shopext_paper")
  if common_impl.ZzCompleteCheck("get_instructionext") then ObjSet( common_impl.hint["get_instructionext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_instructionext", private.get_instructionext_inv );
cmn.AddSubscriber( "get_instructionext", private.get_instructionext_beg, private.room_objname );
cmn.AddSubscriber( "get_instructionext", private.get_instructionext_end, private.room_objname );
cmn.AddSubscriber( "get_instructionext", private.get_instructionext_logic );
--------------------------------------------------------------------
function public.get_instructionext()
  cmn.SetEventDone( "get_instructionext" );
  cmn.CallEventHandler( "get_instructionext" );
  if common_impl.ZzCompleteCheck("get_instructionext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_goldenkeyext" ] = { type = "use", inv_obj = "inv_goldenkeyext", use_place = "gfx_shoeext_goldenkeyext_zone", room = "rm_shopext", zz = "zz_shoeext", zz_gate = "gzz_shopext_shoeext" };

private.use_goldenkeyext_logic = function()
  ObjSet( "spr_shoeext_crystalshoesext", { input = 1, active = 1 } )


end;
private.use_goldenkeyext_inv = function()
  common_impl.ProcessMultiUseAll("goldenkeyext", "goldenkeyext")
end;
private.use_goldenkeyext_beg = function()
  ObjDelete( "gfx_shoeext_goldenkeyext_zone" );
  ObjSet( "spr_shoeext_busy", {visible = 1} );
end;
private.use_goldenkeyext_end = function()
  ObjSet( "gfx_shoeext_crystalshoesext", { visible = 1, active = 1 } )
  ObjSet( "anm_shoeext_anm", {animfunc = "use_key", frame = 999 } );
  ObjSet( "spr_shopext_cover_open", {visible = 1} );
  ObjSet( "spr_shopext_crystalshoesext", {visible = 1} );
  ObjDelete("spr_shopext_cover_closed")
  ObjSet( "spr_shopext_busy", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_goldenkeyext") then ObjSet( common_impl.hint["use_goldenkeyext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_goldenkeyext", private.use_goldenkeyext_inv );
cmn.AddSubscriber( "use_goldenkeyext", private.use_goldenkeyext_beg, private.room_objname );
cmn.AddSubscriber( "use_goldenkeyext", private.use_goldenkeyext_end, private.room_objname );
cmn.AddSubscriber( "use_goldenkeyext", private.use_goldenkeyext_logic );
cmn.AddSubscriber( "use_goldenkeyext_inv", private.use_goldenkeyext_inv, private.room_objname );
cmn.AddSubscriber( "use_goldenkeyext_beg", private.use_goldenkeyext_beg, private.room_objname );
cmn.AddSubscriber( "use_goldenkeyext_end", private.use_goldenkeyext_end, private.room_objname );
cmn.AddSubscriber( "use_goldenkeyext_end", private.use_goldenkeyext_logic );
--------------------------------------------------------------------------------------------
function public.use_goldenkeyext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_goldenkeyext" );
    cmn.CallEventHandler( "use_goldenkeyext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_goldenkeyext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_goldenkeyext_inv" );
  cmn.CallEventHandler( "use_goldenkeyext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_shoeext_anm", "use_key", func_end );
  SoundSfx( "aud_use_goldenkeyext_shopext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_crystalshoesext" ] = { type = "get", get_obj = "spr_shoeext_crystalshoesext", room = "rm_shopext", zz = "zz_shoeext", zz_gate = "gzz_shopext_shoeext" };

private.get_crystalshoesext_logic = function()
    ObjSet( "gfx_shoeext_clk_shoeext_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_crystalshoesext_inv = function()
  interface.InventoryItemAdd("inv_crystalshoesext","spr_shoeext_crystalshoesext");
end;
private.get_crystalshoesext_beg = function()
  ObjDelete("gfx_shoeext_crystalshoesext")
  ObjSet( "anm_shoeext_anm", {animfunc = "end_key", frame = 0 } );
  ObjSet( "spr_shoeext_crystalshoesext", {visible = 1} );
end;
private.get_crystalshoesext_end = function()
  ObjDelete("spr_shopext_crystalshoesext")
  if common_impl.ZzCompleteCheck("get_crystalshoesext") then ObjSet( common_impl.hint["get_crystalshoesext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_crystalshoesext", private.get_crystalshoesext_inv );
cmn.AddSubscriber( "get_crystalshoesext", private.get_crystalshoesext_beg, private.room_objname );
cmn.AddSubscriber( "get_crystalshoesext", private.get_crystalshoesext_end, private.room_objname );
cmn.AddSubscriber( "get_crystalshoesext", private.get_crystalshoesext_logic );
--------------------------------------------------------------------
function public.get_crystalshoesext()
  cmn.SetEventDone( "get_crystalshoesext" );
  cmn.CallEventHandler( "get_crystalshoesext" );
  if common_impl.ZzCompleteCheck("get_crystalshoesext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_shoeext" ] = { type = "click", use_place = "gfx_shoeext_clk_shoeext_zone", room = "rm_shopext", zz = "zz_shoeext", zz_gate = "gzz_shopext_shoeext" };

private.clk_shoeext_logic = function()
  ObjSet( "gho_shopext_pearlsext", {active = 1, input = 1, visible = 1} );
end;
private.clk_shoeext_beg = function()
  ObjDelete( "gfx_shoeext_clk_shoeext_zone" );
  ObjDelete("spr_shoeext_busy")
end;
private.clk_shoeext_end = function()
  ObjSet( "spr_shopext_ho", {visible = 1} );
  ObjDelete("spr_shopext_busy")
  ObjSet( "spr_shopext_ho_no_busy", {visible =1} );
  if common_impl.ZzCompleteCheck("clk_shoeext") then ObjSet( common_impl.hint["clk_shoeext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_shoeext", private.clk_shoeext_beg, private.room_objname );
cmn.AddSubscriber( "clk_shoeext", private.clk_shoeext_end, private.room_objname );
cmn.AddSubscriber( "clk_shoeext", private.clk_shoeext_logic );
cmn.AddSubscriber( "clk_shoeext_beg", private.clk_shoeext_beg, private.room_objname );
cmn.AddSubscriber( "clk_shoeext_end", private.clk_shoeext_end, private.room_objname );
cmn.AddSubscriber( "clk_shoeext_end", private.clk_shoeext_logic );
--------------------------------------------------------------------------------------------
function public.clk_shoeext()

  local func_end = function()
    cmn.SetEventDone( "clk_shoeext" );
    cmn.CallEventHandler( "clk_shoeext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_shoeext") then ld.CloseSubRoom() end;
    ld.ShowBbt("shoeext_after_beads");
  end;

  cmn.CallEventHandler( "clk_shoeext_beg" );
  common_impl.Lock(1);
  ObjAttach("vid_shoeext_beads_are_torn_111","zz_shoeext")
  VidPlay("vid_shoeext_beads_are_torn_111",func_end)
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_clk_shoeext_shopext" )

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_pantrydoorext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_penguinext" ] = { type = "get", get_obj = "spr_pantrydoorext_penguinext", room = "rm_shopext", zz = "zz_pantrydoorext", zz_gate = "gzz_shopext_pantrydoorext" };

private.get_penguinext_logic = function()
  ObjSet( "gfx_pantrydoorext_medalionpawext_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_penguinext_inv = function()
  interface.InventoryItemAdd("inv_penguinext","spr_pantrydoorext_penguinext");
end;
private.get_penguinext_beg = function()
  ObjDelete("gfx_pantrydoorext_penguinext")
end;
private.get_penguinext_end = function()
  ObjDelete("spr_pantrydoorext_sh_penguinext")
  ObjDelete("spr_shopext_penguinext")
  if common_impl.ZzCompleteCheck("get_penguinext") then ObjSet( common_impl.hint["get_penguinext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_penguinext", private.get_penguinext_inv );
cmn.AddSubscriber( "get_penguinext", private.get_penguinext_beg, private.room_objname );
cmn.AddSubscriber( "get_penguinext", private.get_penguinext_end, private.room_objname );
cmn.AddSubscriber( "get_penguinext", private.get_penguinext_logic );
--------------------------------------------------------------------
function public.get_penguinext()
  cmn.SetEventDone( "get_penguinext" );
  cmn.CallEventHandler( "get_penguinext" );
  if common_impl.ZzCompleteCheck("get_penguinext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_medalionpawext" ] = { type = "use", inv_obj = "inv_medalionpawext", use_place = "gfx_pantrydoorext_medalionpawext_zone", room = "rm_shopext", zz = "zz_pantrydoorext", zz_gate = "gzz_shopext_pantrydoorext" };

private.use_medalionpawext_logic = function()
  ObjSet( "spr_pantrydoorext_wrenchext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_pantrydoorext_flagext", { visible = 1, input = 1, active = 1 } )


end;
private.use_medalionpawext_inv = function()
  common_impl.ProcessMultiUseAll("medalionpawext", "medalionpawext")
end;
private.use_medalionpawext_beg = function()
  ObjDelete( "gfx_pantrydoorext_medalionpawext_zone" );
end;
private.use_medalionpawext_end = function()
  ObjDelete("anm_pantrydoorext_anm_light1")
  --ObjDelete("spr_pantrydoorext_tr_toys")
  ObjSet( "anm_pantrydoorext_anm_door", {animfunc = "end_medallion", frame = 0} );
  ObjSet( "spr_pantrydoorext_flagext", {pos_z = 8} );
  ObjSet( "spr_pantrydoorext_sh_flagext", {pos_z = 7.9} );
  ObjSet( "spr_shopext_door_open", {visible = 1} );
  ObjSet( "spr_shopext_wrenchext", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_medalionpawext") then ObjSet( common_impl.hint["use_medalionpawext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_medalionpawext", private.use_medalionpawext_inv );
cmn.AddSubscriber( "use_medalionpawext", private.use_medalionpawext_beg, private.room_objname );
cmn.AddSubscriber( "use_medalionpawext", private.use_medalionpawext_end, private.room_objname );
cmn.AddSubscriber( "use_medalionpawext", private.use_medalionpawext_logic );
cmn.AddSubscriber( "use_medalionpawext_inv", private.use_medalionpawext_inv, private.room_objname );
cmn.AddSubscriber( "use_medalionpawext_beg", private.use_medalionpawext_beg, private.room_objname );
cmn.AddSubscriber( "use_medalionpawext_end", private.use_medalionpawext_end, private.room_objname );
cmn.AddSubscriber( "use_medalionpawext_end", private.use_medalionpawext_logic );
--------------------------------------------------------------------------------------------
function public.use_medalionpawext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_medalionpawext" );
    cmn.CallEventHandler( "use_medalionpawext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_medalionpawext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_medalionpawext_inv" );
  cmn.CallEventHandler( "use_medalionpawext_beg" );
  common_impl.Lock(1);
  ObjAttach("anm_pantrydoorext_anm_light1","anm_pantrydoorext_anm_door")
  ld.AnimPlay( "anm_pantrydoorext_anm_door", "use_medallion", func_end );
  SoundSfx( "aud_use_medalionpawext_shopext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_wrenchext" ] = { type = "get", get_obj = "spr_pantrydoorext_wrenchext", room = "rm_shopext", zz = "zz_pantrydoorext", zz_gate = "gzz_shopext_pantrydoorext" };

private.get_wrenchext_logic = function()
    ObjSet( "gfx_pantrydoorext_clk_pantrydoorext_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_wrenchext_inv = function()
  interface.InventoryItemAdd("inv_wrenchext","spr_pantrydoorext_wrenchext");
end;
private.get_wrenchext_beg = function()
  ObjDelete("gfx_pantrydoorext_wrenchext")
end;
private.get_wrenchext_end = function()
  ObjDelete("spr_pantrydoorext_sh_wrenchext")
  ObjDelete("spr_shopext_wrenchext")
  if common_impl.ZzCompleteCheck("get_wrenchext") then ObjSet( common_impl.hint["get_wrenchext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
cmn.AddSubscriber( "get_wrenchext", private.get_wrenchext_inv );
cmn.AddSubscriber( "get_wrenchext", private.get_wrenchext_beg, private.room_objname );
cmn.AddSubscriber( "get_wrenchext", private.get_wrenchext_end, private.room_objname );
cmn.AddSubscriber( "get_wrenchext", private.get_wrenchext_logic );
--------------------------------------------------------------------
function public.get_wrenchext()
  cmn.SetEventDone( "get_wrenchext" );
  cmn.CallEventHandler( "get_wrenchext" );
  if common_impl.ZzCompleteCheck("get_wrenchext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_flagext" ] = { type = "get", get_obj = "spr_pantrydoorext_flagext", room = "rm_shopext", zz = "zz_pantrydoorext", zz_gate = "gzz_shopext_pantrydoorext" };

private.get_flagext_logic = function()
  
end;
private.get_flagext_inv = function()
  interface.InventoryItemAdd("inv_flagext","spr_pantrydoorext_flagext");
end;
private.get_flagext_beg = function()
  ObjDelete("gfx_pantrydoorext_flagext")
end;
private.get_flagext_end = function()
  ObjDelete("spr_pantrydoorext_sh_flagext")
  if common_impl.ZzCompleteCheck("get_flagext") then ObjSet( common_impl.hint["get_flagext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_flagext", private.get_flagext_inv );
cmn.AddSubscriber( "get_flagext", private.get_flagext_beg, private.room_objname );
cmn.AddSubscriber( "get_flagext", private.get_flagext_end, private.room_objname );
cmn.AddSubscriber( "get_flagext", private.get_flagext_logic );
--------------------------------------------------------------------
function public.get_flagext()
  cmn.SetEventDone( "get_flagext" );
  cmn.CallEventHandler( "get_flagext" );
  if common_impl.ZzCompleteCheck("get_flagext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_pantrydoorext" ] = { type = "click", use_place = "gfx_pantrydoorext_clk_pantrydoorext_zone", room = "rm_shopext", zz = "zz_pantrydoorext", zz_gate = "gzz_shopext_pantrydoorext" };

private.clk_pantrydoorext_logic = function()
  ObjSet( "gfx_pantrydoorext_fairyclewext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_pantrydoorext_beg = function()
  ObjDelete( "gfx_pantrydoorext_clk_pantrydoorext_zone" );
end;
private.clk_pantrydoorext_end = function()
  ObjSet( "anm_pantrydoorext_anm_cleek_1", {animfunc = "cleek_1", frame = 999 } );
  ObjSet( "anm_pantrydoorext_anm_cleek_2", {animfunc = "cleek_2", frame = 999 } );
  ObjSet( "fx_pantrydoorext_hole_fx", {pos_z = 3} );
  if common_impl.ZzCompleteCheck("clk_pantrydoorext") then ObjSet( common_impl.hint["clk_pantrydoorext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_pantrydoorext", private.clk_pantrydoorext_beg, private.room_objname );
cmn.AddSubscriber( "clk_pantrydoorext", private.clk_pantrydoorext_end, private.room_objname );
cmn.AddSubscriber( "clk_pantrydoorext", private.clk_pantrydoorext_logic );
cmn.AddSubscriber( "clk_pantrydoorext_beg", private.clk_pantrydoorext_beg, private.room_objname );
cmn.AddSubscriber( "clk_pantrydoorext_end", private.clk_pantrydoorext_end, private.room_objname );
cmn.AddSubscriber( "clk_pantrydoorext_end", private.clk_pantrydoorext_logic );
--------------------------------------------------------------------------------------------
function public.clk_pantrydoorext()

  local func_end = function()
    cmn.SetEventDone( "clk_pantrydoorext" );
    cmn.CallEventHandler( "clk_pantrydoorext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_pantrydoorext") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_pantrydoorext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_pantrydoorext_anm_cleek_1", "cleek_1", func_end );
  ld.AnimPlay( "anm_pantrydoorext_anm_cleek_2", "cleek_2", _ );
  SoundSfx( "aud_clk_pantrydoorext_shopext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fairyclewext" ] = { type = "use", inv_obj = "inv_fairyclewext", use_place = "gfx_pantrydoorext_fairyclewext_zone", room = "rm_shopext", zz = "zz_pantrydoorext", zz_gate = "gzz_shopext_pantrydoorext" };

private.use_fairyclewext_logic = function()
  ObjSet( "spr_pantrydoorext_snowmaidenext3", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_pantrydoorext_screwext2", { visible = 1, input = 1, active = 1 } )
  int_simon.SimonSetVisible(1)
end;
private.use_fairyclewext_inv = function()
  common_impl.ProcessMultiUseAll("fairyclewext", "fairyclewext")
end;
private.use_fairyclewext_beg = function()
  ObjDelete( "gfx_pantrydoorext_fairyclewext_zone" );
end;
private.use_fairyclewext_end = function()
  ObjDelete("fx_pantrydoorext_hole_fx")
  if common_impl.ZzCompleteCheck("use_fairyclewext") then ObjSet( common_impl.hint["use_fairyclewext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fairyclewext", private.use_fairyclewext_inv );
cmn.AddSubscriber( "use_fairyclewext", private.use_fairyclewext_beg, private.room_objname );
cmn.AddSubscriber( "use_fairyclewext", private.use_fairyclewext_end, private.room_objname );
cmn.AddSubscriber( "use_fairyclewext", private.use_fairyclewext_logic );
cmn.AddSubscriber( "use_fairyclewext_inv", private.use_fairyclewext_inv, private.room_objname );
cmn.AddSubscriber( "use_fairyclewext_beg", private.use_fairyclewext_beg, private.room_objname );
cmn.AddSubscriber( "use_fairyclewext_end", private.use_fairyclewext_end, private.room_objname );
cmn.AddSubscriber( "use_fairyclewext_end", private.use_fairyclewext_logic );
--------------------------------------------------------------------------------------------
function public.use_fairyclewext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "get_screwext2" );
    cmn.SetEventDone( "get_snowmaidenext3" );
    cmn.SetEventDone( "use_fairyclewext" );
    cmn.CallEventHandler( "use_fairyclewext_end" );
    common_impl.Lock(0); 
    ObjDelete("spr_pantrydoorext_fairy") 
    interface.SimonReturn()
    if common_impl.ZzCompleteCheck("use_fairyclewext") then ld.CloseSubRoom() end;
  end;
  local func_step = function()
    ObjSet( "spr_pantrydoorext_fairy", {visible = 1} );
    ObjDelete("vid_pantrydoorext_fairy_in_the_hole_189")
    ObjSet( "spr_pantrydoorext_snowmaidenext3", { visible = 1, active = 1 } )
    ObjSet( "spr_pantrydoorext_screwext2", { visible = 1, active = 1 } )
    cmn.CallEventHandler( "get_screwext2" );
    cmn.CallEventHandler( "get_snowmaidenext3" );
    int_inventory.StdItemFlyAnimation( "spr_pantrydoorext_fairy", "obj_int_button_map_point_for_cube", function() func_end() end );
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fairyclewext_inv" );
  cmn.CallEventHandler( "use_fairyclewext_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( "aud_use_fairyclewext_shopext" )
  --func_end()
  ObjAnimate( "fx_pantrydoorext_hole_fx", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
  ObjAttach("vid_pantrydoorext_fairy_in_the_hole_189","zz_pantrydoorext")
  VidPlay("vid_pantrydoorext_fairy_in_the_hole_189",func_step)
  SoundVid( "aud_fairy_in_the_hole_189" )
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_snowmaidenext3" ] = { type = "get", get_obj = "spr_pantrydoorext_snowmaidenext3", room = "rm_shopext", zz = "zz_pantrydoorext", zz_gate = "gzz_shopext_pantrydoorext" };

private.get_snowmaidenext3_logic = function()
  
end;
private.get_snowmaidenext3_inv = function()
  interface.InventoryItemAdd("inv_snowmaidenext3","spr_pantrydoorext_snowmaidenext3");
end;
private.get_snowmaidenext3_beg = function()
  ObjDelete("gfx_pantrydoorext_snowmaidenext3")
end;
private.get_snowmaidenext3_end = function()
  if common_impl.ZzCompleteCheck("get_snowmaidenext3") then ObjSet( common_impl.hint["get_snowmaidenext3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_snowmaidenext3", private.get_snowmaidenext3_inv );
cmn.AddSubscriber( "get_snowmaidenext3", private.get_snowmaidenext3_beg, private.room_objname );
cmn.AddSubscriber( "get_snowmaidenext3", private.get_snowmaidenext3_end, private.room_objname );
cmn.AddSubscriber( "get_snowmaidenext3", private.get_snowmaidenext3_logic );
--------------------------------------------------------------------
function public.get_snowmaidenext3()
  cmn.SetEventDone( "get_snowmaidenext3" );
  cmn.CallEventHandler( "get_snowmaidenext3" );
  if common_impl.ZzCompleteCheck("get_snowmaidenext3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_screwext2" ] = { type = "get", get_obj = "spr_pantrydoorext_screwext2", room = "rm_shopext", zz = "zz_pantrydoorext", zz_gate = "gzz_shopext_pantrydoorext" };

private.get_screwext2_logic = function()
  
end;
private.get_screwext2_inv = function()
  interface.InventoryItemAdd("inv_screwext","spr_pantrydoorext_screwext2",function() level_inv.ProcessGetScrewextAll( "get_screwext2" ) end);
end;
private.get_screwext2_beg = function()
  ObjDelete("gfx_pantrydoorext_screwext2")
end;
private.get_screwext2_end = function()
  ObjDelete("spr_pantrydoorext_sh_screwext2")
  if common_impl.ZzCompleteCheck("get_screwext2") then ObjSet( common_impl.hint["get_screwext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_screwext2", private.get_screwext2_inv );
cmn.AddSubscriber( "get_screwext2", private.get_screwext2_beg, private.room_objname );
cmn.AddSubscriber( "get_screwext2", private.get_screwext2_end, private.room_objname );
cmn.AddSubscriber( "get_screwext2", private.get_screwext2_logic );
--------------------------------------------------------------------
function public.get_screwext2()
  cmn.SetEventDone( "get_screwext2" );
  cmn.CallEventHandler( "get_screwext2" );
  if common_impl.ZzCompleteCheck("get_screwext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_counterext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_towerroofext" ] = { type = "get", get_obj = "spr_counterext_towerroofext", room = "rm_shopext", zz = "zz_counterext", zz_gate = "gzz_shopext_counterext" };

private.get_towerroofext_logic = function()
  ObjSet( "gfx_counterext_snowmaidenext1_zone", {active = 1, input = 1, visible = 1} );
  ObjSet( "gfx_counterext_snowmaidenext2_zone", {active = 1, input = 1, visible = 1} );
  ObjSet( "gfx_counterext_snowmaidenext3_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_towerroofext_inv = function()
  interface.InventoryItemAdd("inv_towerroofext","spr_counterext_towerroofext");
end;
private.get_towerroofext_beg = function()
  ObjDelete("gfx_counterext_towerroofext")
end;
private.get_towerroofext_end = function()
  ObjDelete("spr_counterext_sh_towerroofext")
  ObjDelete("spr_shopext_towerroofext")
  if common_impl.ZzCompleteCheck("get_towerroofext") then ObjSet( common_impl.hint["get_towerroofext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_towerroofext", private.get_towerroofext_inv );
cmn.AddSubscriber( "get_towerroofext", private.get_towerroofext_beg, private.room_objname );
cmn.AddSubscriber( "get_towerroofext", private.get_towerroofext_end, private.room_objname );
cmn.AddSubscriber( "get_towerroofext", private.get_towerroofext_logic );
--------------------------------------------------------------------
function public.get_towerroofext()
  cmn.SetEventDone( "get_towerroofext" );
  cmn.CallEventHandler( "get_towerroofext" );
  if common_impl.ZzCompleteCheck("get_towerroofext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_deerext" ] = { type = "use", inv_obj = "inv_deerext", use_place = "gfx_counterext_deerext_zone", room = "rm_shopext", zz = "zz_counterext", zz_gate = "gzz_shopext_counterext" };

private.use_deerext_logic = function()
  ObjSet( "spr_counterext_goldenkeyext", { input = 1, active = 1 } )
  --ObjSet( "spr_counterext_scallopext", { visible = 1, input = 1, active = 1 } )

end;
private.use_deerext_inv = function()
  common_impl.ProcessMultiUseAll("deerext", "deerext")
end;
private.use_deerext_beg = function()
  ObjDelete( "gfx_counterext_deerext_zone" );
end;
private.use_deerext_end = function()
  ObjSet( "gfx_counterext_goldenkeyext", { visible = 1, active = 1 } )
  ObjSet( "anm_counterext_anm_deer", {animfunc = "use_deerext", frame = 999 } );
  ObjSet( "spr_shopext_tr_deer_open", {visible = 1} );
  ObjSet( "spr_shopext_deerext", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_deerext") then ObjSet( common_impl.hint["use_deerext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_deerext", private.use_deerext_inv );
cmn.AddSubscriber( "use_deerext", private.use_deerext_beg, private.room_objname );
cmn.AddSubscriber( "use_deerext", private.use_deerext_end, private.room_objname );
cmn.AddSubscriber( "use_deerext", private.use_deerext_logic );
cmn.AddSubscriber( "use_deerext_inv", private.use_deerext_inv, private.room_objname );
cmn.AddSubscriber( "use_deerext_beg", private.use_deerext_beg, private.room_objname );
cmn.AddSubscriber( "use_deerext_end", private.use_deerext_end, private.room_objname );
cmn.AddSubscriber( "use_deerext_end", private.use_deerext_logic );
--------------------------------------------------------------------------------------------
function public.use_deerext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_deerext" );
    cmn.CallEventHandler( "use_deerext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_deerext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_deerext_inv" );
  cmn.CallEventHandler( "use_deerext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_counterext_anm_deer", "use_deerext", func_end );
  SoundSfx( "aud_use_deerext_shopext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_goldenkeyext" ] = { type = "get", get_obj = "spr_counterext_goldenkeyext", room = "rm_shopext", zz = "zz_counterext", zz_gate = "gzz_shopext_counterext" };

private.get_goldenkeyext_logic = function()
  
end;
private.get_goldenkeyext_inv = function()
  interface.InventoryItemAdd("inv_goldenkeyext","spr_counterext_goldenkeyext");
end;
private.get_goldenkeyext_beg = function()
  ObjDelete("gfx_counterext_goldenkeyext")
  ObjSet( "spr_counterext_goldenkeyext", {visible = 1} );
  ObjSet( "anm_counterext_anm_deer", {animfunc = "end_deerext"} );
end;
private.get_goldenkeyext_end = function()
  ObjDelete("spr_shopext_goldenkeyext")
  if common_impl.ZzCompleteCheck("get_goldenkeyext") then ObjSet( common_impl.hint["get_goldenkeyext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_goldenkeyext", private.get_goldenkeyext_inv );
cmn.AddSubscriber( "get_goldenkeyext", private.get_goldenkeyext_beg, private.room_objname );
cmn.AddSubscriber( "get_goldenkeyext", private.get_goldenkeyext_end, private.room_objname );
cmn.AddSubscriber( "get_goldenkeyext", private.get_goldenkeyext_logic );
--------------------------------------------------------------------
function public.get_goldenkeyext()
  cmn.SetEventDone( "get_goldenkeyext" );
  cmn.CallEventHandler( "get_goldenkeyext" );
  if common_impl.ZzCompleteCheck("get_goldenkeyext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
--common_impl.hint[ "get_scallopext" ] = { type = "get", get_obj = "spr_counterext_scallopext", room = "rm_shopext", zz = "zz_counterext", zz_gate = "gzz_shopext_counterext" };
--
--private.get_scallopext_logic = function()
--  
--end;
--private.get_scallopext_inv = function()
--  interface.InventoryItemAdd("inv_scallopext","spr_counterext_scallopext");
--end;
--private.get_scallopext_beg = function()
--  ObjDelete("gfx_counterext_scallopext")
--end;
--private.get_scallopext_end = function()
--  if common_impl.ZzCompleteCheck("get_scallopext") then ObjSet( common_impl.hint["get_scallopext"].zz_gate, { visible = 0, input = 0 } ); end;
--end;
--
--cmn.AddSubscriber( "get_scallopext", private.get_scallopext_inv );
--cmn.AddSubscriber( "get_scallopext", private.get_scallopext_beg, private.room_objname );
--cmn.AddSubscriber( "get_scallopext", private.get_scallopext_end, private.room_objname );
--cmn.AddSubscriber( "get_scallopext", private.get_scallopext_logic );
----------------------------------------------------------------------
--function public.get_scallopext()
--  cmn.SetEventDone( "get_scallopext" );
--  cmn.CallEventHandler( "get_scallopext" );
--  if common_impl.ZzCompleteCheck("get_scallopext") then ld.CloseSubRoom() end;
--end
--------------------------------------------------------------------
function public.use_snowmaidenext_all( func )
  if ld.CheckRequirements( {"use_snowmaidenext3","use_snowmaidenext1","use_snowmaidenext2"},1 ) == 2 then
    ObjDelete("anm_counterext_anm_maiden1")
    ObjDelete("anm_counterext_anm_maiden2")
    ObjDelete("anm_counterext_anm_maiden3")
    SoundSfx( "aud_remove_cover" )
    ld.AnimPlay( "anm_counterext_anm_cover", "open", function() func() common_impl.Gate_MDown( "gmg_shopext_onboxext" )  end )
  else
    func()
  end
end
function public.use_snowmaidenext_all_end(  )
  if ld.CheckRequirements( {"use_snowmaidenext3","use_snowmaidenext1","use_snowmaidenext2"} ) then
    ObjDelete("anm_counterext_anm_maiden1")
    ObjDelete("anm_counterext_anm_maiden2")
    ObjDelete("anm_counterext_anm_maiden3")
    ObjDelete("anm_counterext_anm_cover")
    ObjDelete("spr_shopext_cover")
    ObjDelete("spr_shopext_green_s_m")
    ObjDelete("spr_shopext_blue_s_m")
    ObjDelete("spr_shopext_red_s_m")
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_snowmaidenext1" ] = { type = "use", inv_obj = "inv_snowmaidenext1", use_place = "gfx_counterext_snowmaidenext1_zone", room = "rm_shopext", zz = "zz_counterext", zz_gate = "gzz_shopext_counterext" };

private.use_snowmaidenext1_logic = function()
  if ld.CheckRequirements( {"use_snowmaidenext1","use_snowmaidenext2","use_snowmaidenext3"} ) then
  ObjSet( "gmg_shopext_onboxext", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_snowmaidenext1_inv = function()
  common_impl.ProcessMultiUseAll("snowmaidenext1", "snowmaidenext1")
end;
private.use_snowmaidenext1_beg = function()
  ObjDelete( "gfx_counterext_snowmaidenext1_zone" );
end;
private.use_snowmaidenext1_end = function()
  ObjSet( "anm_counterext_anm_maiden1", {animfunc = "use_red", frame = 999 } );
  ObjSet( "spr_shopext_red_s_m", {visible = 1} );
  public.use_snowmaidenext_all_end()
  if common_impl.ZzCompleteCheck("use_snowmaidenext1") then ObjSet( common_impl.hint["use_snowmaidenext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_snowmaidenext1", private.use_snowmaidenext1_inv );
cmn.AddSubscriber( "use_snowmaidenext1", private.use_snowmaidenext1_beg, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext1", private.use_snowmaidenext1_end, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext1", private.use_snowmaidenext1_logic );
cmn.AddSubscriber( "use_snowmaidenext1_inv", private.use_snowmaidenext1_inv, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext1_beg", private.use_snowmaidenext1_beg, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext1_end", private.use_snowmaidenext1_end, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext1_end", private.use_snowmaidenext1_logic );
--------------------------------------------------------------------------------------------
function public.use_snowmaidenext1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_snowmaidenext1" );
    cmn.CallEventHandler( "use_snowmaidenext1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_snowmaidenext1") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_snowmaidenext1_inv" );
  cmn.CallEventHandler( "use_snowmaidenext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_counterext_anm_maiden1", "use_red", function() public.use_snowmaidenext_all( func_end ) end );
  SoundSfx( "aud_use_snowmaidenext1_shopext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_snowmaidenext2" ] = { type = "use", inv_obj = "inv_snowmaidenext2", use_place = "gfx_counterext_snowmaidenext2_zone", room = "rm_shopext", zz = "zz_counterext", zz_gate = "gzz_shopext_counterext" };

private.use_snowmaidenext2_logic = function()
  if ld.CheckRequirements( {"use_snowmaidenext2","use_snowmaidenext1","use_snowmaidenext3"} ) then
  ObjSet( "gmg_shopext_onboxext", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_snowmaidenext2_inv = function()
  common_impl.ProcessMultiUseAll("snowmaidenext2", "snowmaidenext2")
end;
private.use_snowmaidenext2_beg = function()
  ObjDelete( "gfx_counterext_snowmaidenext2_zone" );
end;
private.use_snowmaidenext2_end = function()
  ObjSet( "anm_counterext_anm_maiden2", {animfunc = "use_blue", frame = 999 } );
  ObjSet( "spr_shopext_blue_s_m", {visible = 1} );
  public.use_snowmaidenext_all_end()
  if common_impl.ZzCompleteCheck("use_snowmaidenext2") then ObjSet( common_impl.hint["use_snowmaidenext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_snowmaidenext2", private.use_snowmaidenext2_inv );
cmn.AddSubscriber( "use_snowmaidenext2", private.use_snowmaidenext2_beg, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext2", private.use_snowmaidenext2_end, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext2", private.use_snowmaidenext2_logic );
cmn.AddSubscriber( "use_snowmaidenext2_inv", private.use_snowmaidenext2_inv, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext2_beg", private.use_snowmaidenext2_beg, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext2_end", private.use_snowmaidenext2_end, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext2_end", private.use_snowmaidenext2_logic );
--------------------------------------------------------------------------------------------
function public.use_snowmaidenext2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_snowmaidenext2" );
    cmn.CallEventHandler( "use_snowmaidenext2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_snowmaidenext2") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_snowmaidenext2_inv" );
  cmn.CallEventHandler( "use_snowmaidenext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_counterext_anm_maiden2", "use_blue", function() public.use_snowmaidenext_all( func_end ) end );
  SoundSfx( "aud_use_snowmaidenext1_shopext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_snowmaidenext3" ] = { type = "use", inv_obj = "inv_snowmaidenext3", use_place = "gfx_counterext_snowmaidenext3_zone", room = "rm_shopext", zz = "zz_counterext", zz_gate = "gzz_shopext_counterext" };

private.use_snowmaidenext3_logic = function()
  if ld.CheckRequirements( {"use_snowmaidenext3","use_snowmaidenext1","use_snowmaidenext2"} ) then
  ObjSet( "gmg_shopext_onboxext", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_snowmaidenext3_inv = function()
  common_impl.ProcessMultiUseAll("snowmaidenext3", "snowmaidenext3")
end;
private.use_snowmaidenext3_beg = function()
  ObjDelete( "gfx_counterext_snowmaidenext3_zone" );
end;
private.use_snowmaidenext3_end = function()
  ObjSet( "anm_counterext_anm_maiden3", {animfunc = "use_green", frame = 999 } );
  ObjSet( "spr_shopext_green_s_m", {visible = 1} );
  public.use_snowmaidenext_all_end()
  if common_impl.ZzCompleteCheck("use_snowmaidenext3") then ObjSet( common_impl.hint["use_snowmaidenext3"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_snowmaidenext3", private.use_snowmaidenext3_inv );
cmn.AddSubscriber( "use_snowmaidenext3", private.use_snowmaidenext3_beg, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext3", private.use_snowmaidenext3_end, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext3", private.use_snowmaidenext3_logic );
cmn.AddSubscriber( "use_snowmaidenext3_inv", private.use_snowmaidenext3_inv, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext3_beg", private.use_snowmaidenext3_beg, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext3_end", private.use_snowmaidenext3_end, private.room_objname );
cmn.AddSubscriber( "use_snowmaidenext3_end", private.use_snowmaidenext3_logic );
--------------------------------------------------------------------------------------------
function public.use_snowmaidenext3( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_snowmaidenext3" );
    cmn.CallEventHandler( "use_snowmaidenext3_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_snowmaidenext3") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_snowmaidenext3_inv" );
  cmn.CallEventHandler( "use_snowmaidenext3_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_counterext_anm_maiden3", "use_green", function() public.use_snowmaidenext_all( func_end ) end );
  SoundSfx( "aud_use_snowmaidenext1_shopext" )
  --func_end()

end;


--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_onboxext_for_shopext = function()
    if ld.CheckRequirements( {"get_dustext"} ) then
      ObjSet( "gmg_shopext_onboxext", {input = 0, visible = 0} );
      ObjDelete("spr_shopext_dust_bag")
    end
  end;
  cmn.AddSubscriber("get_dustext", win_onboxext_for_shopext, private.room_objname )

  local win_onboxext2_for_shopext = function()
    if ld.CheckRequirements( {"win_onboxext"} ) then
      ObjSet( "spr_shopext_dust_bag", {visible = 1} );
      ObjSet( "spr_shopext_open_mg", {visible = 1} );
    end
  end;
  cmn.AddSubscriber("win_onboxext", win_onboxext2_for_shopext, private.room_objname )
  local win_pearlsext_for_shopext = function()
    if ld.CheckRequirements( {"win_pearlsext"} ) then
      ObjSet( "gho_shopext_pearlsext", {input = 0, visible = 0} );
      
    end
  end;
  cmn.AddSubscriber("win_pearlsext", win_pearlsext_for_shopext, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_shopext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_shop_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_counterext" );
  function zz_counterext.Open()
  end;
  function zz_counterext.PreOpen()
  end;
  function zz_counterext.PreClose()
  end;
  function zz_counterext.Close()
  end;

  subroom.Define( "zz_pantrydoorext" );
  function zz_pantrydoorext.Open()
  end;
  function zz_pantrydoorext.PreOpen()
  end;
  function zz_pantrydoorext.PreClose()
  end;
  function zz_pantrydoorext.Close()
  end;

  subroom.Define( "zz_shoeext" );
  function zz_shoeext.Open()
  end;
  function zz_shoeext.PreOpen()
  end;
  function zz_shoeext.PreClose()
  end;
  function zz_shoeext.Close()
  end;
  
end;
--*********************************************************************************************************************