-- name=ho_painthoextscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "painthoextscr" );
  game.relations[ "ho_painthoextscr" ].exitroom = "rm_corridorext";
 
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_painthoextscr" ] = { type = "win", room = "rm_corridorext", zz = "ho_painthoextscr", zz_gate = "gho_corridorext_painthoextscr" };
 
  local win_painthoextscr_func = function ()

    if ( cmn.IsEventDone( "win_painthoextscr" ) ) then
      interface.InventoryItemAdd( "inv_mistletoeext", "spr_painthoextscr_win", level_inv.ProcessGetMistletoeextAll( "win_painthoextscr" ) );
      ObjDelete( "gho_corridorext_painthoextscr" );
    end;

  end;
  cmn.AddSubscriber( "win_painthoextscr", win_painthoextscr_func );
  
  local start_painthoextscr_func = function ()
  if not cmn.IsEventDone("win_painthoextscr") then
    common_impl.ProcessHoStart( "painthoextscr" );
    
    
    local ho_found = ng_global.progress[ "scr" ][ "win_painthoextscr" ].found;
    for i = 1, #ho_found do
      local name = common.GetObjectName( ho_found[ i ].item );
      ObjSet( "spr_"..name, { input = false} );
      if ObjGet("spr_"..name.."_sh") then
        ObjDelete("spr_"..name.."_sh")
      end
    end;
    
    
  end
  end;
  cmn.AddSubscriber( "win_painthoextscr", start_painthoextscr_func, "ho_painthoextscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_corridorext_env" )
  if ( not cmn.IsEventDone( "opn_painthoextscr" ) ) then
    cmn.InitHo( "painthoextscr" );
    cmn.SetEventDone( "opn_painthoextscr" );
  end;
  local ho_items = {};
  interface.ItemPanelItemAdd( ho_items, "aaa" ,{"spr_painthoextscr_aaa"}); --1
  interface.ItemPanelItemAdd( ho_items, "bbb" ,{"spr_painthoextscr_bbb"}); --2
  interface.ItemPanelItemAdd( ho_items, "ccc" ,{"spr_painthoextscr_ccc"}); --3
  interface.ItemPanelItemAdd( ho_items, "ddd" ,{"spr_painthoextscr_ddd"}); --4
  interface.ItemPanelItemAdd( ho_items, "eee" ,{"spr_painthoextscr_eee"}); --5
  interface.ItemPanelItemAdd( ho_items, "fff" ,{"spr_painthoextscr_fff"}); --6
  interface.ItemPanelItemAdd( ho_items, "ggg" ,{"spr_painthoextscr_ggg"}); --7
  interface.ItemPanelItemAdd( ho_items, "hhh" ,{"spr_painthoextscr_hhh"}); --8
  interface.ItemPanelItemAdd( ho_items, "iii" ,{"spr_painthoextscr_iii"}); --9
  interface.ItemPanelItemAdd( ho_items, "jjj" ,{"spr_painthoextscr_jjj"}); --10
  interface.ItemPanelItemAdd( ho_items, "kkk" ,{"spr_painthoextscr_kkk"}); --11
  interface.ItemPanelItemAdd( ho_items, "lll" ,{"spr_painthoextscr_lll"}); --12
  SoundHoTheme( true );
  interface.ItemPanelShow( ho_items );
  
end;
--*********************************************************************************************************************
function public.PreClose()
  SoundHoTheme( false );
  interface.ItemPanelHide();
end;
--*********************************************************************************************************************
function public.HoComplete()
  common_impl.DialogHo_Show() 
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function public.TaskComplete( task_name )
  cmn.HoItemFind("spr_painthoextscr_"..task_name,"itm_painthoextscr_"..task_name);
  if ObjGet("spr_painthoextscr_"..task_name.."_sh") then
    ObjDelete("spr_painthoextscr_"..task_name.."_sh");
  end
end;
---------------------------------------------------------------------------------------------
function private.GetItem( name )
  --ld.PlayAudio("sfx","common/audio/aud_get_item");
end;
----------------------------------------------------------------------------
