-- name=rm_screensaver
--******************************************************************************************
function public.Init()
              
  ObjAttach( "rm_screensaver", "rooms_hub" );


  ObjSet("spr_screensaver_button_main_menu",{ 
    event_mdown =  function () private.Exit()           end,
    event_menter = function () private.ButtonMouseEnter( "button_main_menu" ); end,
    event_mleave = function () private.ButtonMouseLeave( "button_main_menu" ); end 
                    })
  ObjSet("spr_screensaver_button_screensaver_arrow_left",{ 
    event_menter = function () private.ButtonMouseEnter( "button_screensaver_arrow_left" ); end,
    event_mleave = function () private.ButtonMouseLeave( "button_screensaver_arrow_left" ); end 
                    })
  ObjSet("spr_screensaver_button_screensaver_arrow_right",{ 
    event_menter = function () private.ButtonMouseEnter( "button_screensaver_arrow_right" ); end,
    event_mleave = function () private.ButtonMouseLeave( "button_screensaver_arrow_right" ); end 
                    })
  for i=1,3 do 
    ObjSet("spr_screensaver_button_setscreensaver"..i,{ 
    event_menter = function () private.ButtonMouseEnter( "button_setscreensaver"..i ); end,
    event_mleave = function () private.ButtonMouseLeave( "button_setscreensaver"..i ); end 
                    })
  end

  common_impl.SetButtonTextColor({"txt_screensaver_button_main_menu"}, nil, common_impl.ButtonTextOutlineColor())
end;
--******************************************************************************************
function public.PreOpen()
  --interface.InterfaceSetInput( false ); 
  --interface.InterfaceSetVisible( false );


  --------------12 --> 36
  for i = 1, 36 do

    if private.drop_pos[i] then
      ObjSet( "obj_screensaver_puzzle"..i.."_drop", {pos_x = private.drop_pos[i][1], pos_y = private.drop_pos[i][2]} );
    end
    ObjSet("spr_screensaver_puzzle"..i,{pos_x=private.start_pos_ang[i][1]-171,pos_y = private.start_pos_ang[i][2],ang = private.start_pos_ang[i][3],pos_z = private.start_pos_ang[i][4] or i%12+1,input = 0})
    local obj_create = "spr_screensaver_puzzle"..i.."_counter"
    ObjCreate(obj_create,"spr")
    ObjSet( obj_create, {color_b = 1,color_b=1,alp = 1,pos_x=private.start_pos_ang[i][1]-171,pos_y = private.start_pos_ang[i][2],ang = private.start_pos_ang[i][3],pos_z = private.start_pos_ang[i][4] or i,input = 0} );
    
    if i<13 then
      ObjAttach(obj_create,"obj_screensaver_screen1")
      ObjSet( obj_create, {res = "assets/levels/menu/rm_screensaver/screensaver_1/puzzle"..i.."_contur"} );
    elseif i>=13 and i<25 then
      ObjAttach(obj_create,"obj_screensaver_screen2")
      ObjSet( obj_create, {res = "assets/levels/menu/rm_screensaver/screensaver_2/puzzle"..i.."_contur"} );
    elseif i>=25 and i<37 then
      ObjAttach(obj_create,"obj_screensaver_screen3")
      ObjSet( obj_create, {res = "assets/levels/menu/rm_screensaver/screensaver_3/puzzle"..i.."_contur"} );
    end

  -- DbgTrace(private.start_pos_ang[i][1]..","..private.start_pos_ang[i][2]..","..private.start_pos_ang[i][3]..","..private.start_pos_ang[i][4])
  end
  ObjSet( "anm_screensaver_screen_1_anim", {alp = 0,animfunc="anim_puzzl",frame=0} );
  ObjSet( "anm_screensaver_screen_2_anim", {alp = 0,animfunc="anim_puzzl",frame=0} );
  ObjSet( "anm_screensaver_screen_3_anim", {alp = 0,animfunc="anim_puzzl",frame=0} );


--LoadCurrentProfile()
  --private.Load()  
  private.LoadPuzzle()


  if ng_global.achievements.puzzle_screen[public.screensaver_current] and not ng_global.achievements.done_puzzle_screen[public.screensaver_current] then
    ObjSet( "spr_screensaver_arrow1", {alp = 1,input=1} );
    ObjSet( "spr_screensaver_arrow2", {alp = 1,input=1} );
  else
    ObjSet( "spr_screensaver_arrow1", {alp = 0,input=0} );
    ObjSet( "spr_screensaver_arrow2", {alp = 0,input=0} );  
  end


  if not cmn.is_inmenunow then
  DbgTrace("screensaver open game")
      local widget_settings = 
      {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Simon,
        --InterfaceWidget_Cube,

      }

      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], false,true );
        interface.WidgetSetInput(widget_settings[i],false)
      end;
  end


end;
--******************************************************************************************
function public.Open()
  DbgTrace("screensaver open")
  SoundMgTheme( true )
  private.current_room = common.GetCurrentRoom();

end;

function public.PreClose()
  SoundMgTheme( false )
end

function public.Close()

  --interface.InterfaceSetInput( true );
  --interface.InterfaceSetVisible( true );

  for i=1,36 do
    ObjDelete("spr_screensaver_puzzle"..i.."_counter")
  end
  if not cmn.is_inmenunow then
    local widget_settings = 
    {
        InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        InterfaceWidget_BtnMap,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        InterfaceWidget_Simon,
        --InterfaceWidget_Cube,
    }

    for i = 1, #widget_settings do
      interface.WidgetSetVisible( widget_settings[i], true, true );
      interface.WidgetSetInput(widget_settings[i],true)
    end;
  end
end
--******************************************************************************************
function private.ButtonMouseEnter ( but_name )


  if but_name == "button_main_menu" then
    SetCursor(CURSOR_HAND)
    local txt = "txt_screensaver_"..but_name
    ObjSet( txt, {color_r = 1, color_g = 1, color_b = 1} );
  elseif string.find(but_name,"puzzle") then
    SetCursor(CURSOR_GET)
  elseif string.find(but_name,"setscreensaver") then
    SetCursor(CURSOR_HAND)
  elseif but_name == "button_screensaver_arrow_left" or but_name == "button_screensaver_arrow_right" then
    SetCursor(CURSOR_HAND)
  end

  local obj = "spr_screensaver_"..but_name.."_focus";
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );
  
end;

function private.ButtonMouseLeave ( but_name )

  SetCursor( CURSOR_DEFAULT );

  local obj = "spr_screensaver_"..but_name.."_focus";
  local txt = "txt_screensaver_"..but_name
  local alp = ObjGet( obj ).alp;
  ObjAnimate( obj, "alp", 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

  if but_name == "button_main_menu" then 
    local r,g,b = common_impl.ButtonTextColorLeave()
    ObjSet( txt, {color_r = r, color_g = g, color_b = b} );
  end

end;
--******************************************************************************************
function private.Exit()
  SoundSfx( "aud_clk_menu" )
  if ( not private.current_room ) then

    private.current_room = "rm_extra";

  end;
    common.GotoRoom( private.current_room );
end






public.screensaver_current = 1
private.screensaver = {}

private.puzzle_anim = false
private.puzzle_angle ={0,0,0,0,0,0, 0,0,0,0,0,0,
                       0,0,0,0,0,0, 0,0,0,0,0,0,
                       0,0,0,0,0,0, 0,0,0,0,0,0}


private.puzzle_pos_ang = {  -- положение в конце анимации
{383,   438,  0},
{686,   164,  3},
{1024,  550,  0},
{487,   157,  2},
{269,   538,  3},
{287,   425,  1},
{1067,  397,  0},
{1060,  294,  1},
{311,   319,  3},
{662,   100,  3},
{833,   90,   1},
{1007,  143,  2},
----
{383,   438,  0},
{686,   164,  3},
{1024,  550,  0},
{487,   157,  2},
{269,   538,  3},
{287,   425,  1},
{1067,  397,  0},
{1060,  294,  1},
{311,   319,  3},
{662,   100,  3},
{833,   90,   1},
{1007,  143,  2},
----
{383,   438,  0},
{686,   164,  3},
{1024,  550,  0},
{487,   157,  2},
{269,   538,  3},
{287,   425,  1},
{1067,  397,  0},
{1060,  294,  1},
{311,   319,  3},
{662,   100,  3},
{833,   90,   1},
{1007,  143,  2},
}


private.start_pos_ang =       -- положения в начале анимации (x,y,ang,z)

{
{673.377  ,328.2361, 0.3793},
{833.9734 ,352.1847, -0.4894},
{845.2433 ,480.3799, 0},
{590.2616 ,411.3517, 2.3813},
{425.4390 ,421.2129, -3.0631},
{635.3412 ,524.0508, 0},
{766.3538 ,440.9352, -1.0456},
{755.084  ,225.3982, 0},
{580.4003 ,315.5575, -0.8321},
{677.6033 ,373.3158, 0},
{628.2975 ,212.7196, -1.2569},
{879.053  ,349.3672, 0},

{673.377  ,328.2361, 0.3793},
{833.9734 ,352.1847, -0.4894},
{845.2433 ,480.3799, 0},
{590.2616 ,411.3517, 2.3813},
{425.4390 ,421.2129, -3.0631},
{635.3412 ,524.0508, 0},
{766.3538 ,440.9352, -1.0456},
{755.084  ,225.3982, 0},
{580.4003 ,315.5575, -0.8321},
{677.6033 ,373.3158, 0},
{628.2975 ,212.7196, -1.2569},
{879.053  ,349.3672, 0},

{673.377  ,328.2361, 0.3793},
{833.9734 ,352.1847, -0.4894},
{845.2433 ,480.3799, 0},
{590.2616 ,411.3517, 2.3813},
{425.4390 ,421.2129, -3.0631},
{635.3412 ,524.0508, 0},
{766.3538 ,440.9352, -1.0456},
{755.084  ,225.3982, 0},
{580.4003 ,315.5575, -0.8321},
{677.6033 ,373.3158, 0},
{628.2975 ,212.7196, -1.2569},
{879.053  ,349.3672, 0},
}

private.drop_pos = {
{250+24, 289+35},
{338+24, 316+35},
{435+24, 287+35},
{569+24, 289+35},
{672+24, 316+35},
{768+24, 287+35},
{232+24, 448+35},
{338+24, 474+35},
{466+24, 445+35},
{566+24, 448+35},
{671+24, 474+35},
{784+24, 445+35},

{576, 488},    
{473, 327},    
{271, 326},    
{361, 354},    
{254, 488},    
{360, 514},    
{474, 484},    
{608, 326},    
{698, 354},    
{795, 325},    
{697, 514},    
{811, 484},

{273, 325},
{363, 353},
{460, 324},
{256, 488},
{362, 513},
{491, 484},
{595, 327},
{699, 353},
{796, 325},
{592, 486},
{698, 511},
{812, 481}

}

----------------------------------------------------------------------------------------------------
function public.ScreensaverNext( inc )
  SoundSfx( "aud_clk_menu" )
  local max_count = 3;
  local new_num;

  if public.screensaver_current == max_count and inc == 1 then
    new_num = 1;
  elseif public.screensaver_current == 1 and inc == -1 then
    new_num = max_count;
  else
    new_num = public.screensaver_current + inc;
  end;

  local name     = "obj_screensaver_screen";
  local name_arr = "obj_screensaver_arrows";
  local tme      = 0.3;
--ld.extra.ActivateExtraScr( 0, name_arr );
  ObjSet( 'rm_screensaver', {  input = 0 } );
  ObjSet( name..public.screensaver_current, {input = 0} );
  ObjSet( name..new_num, {input = 1} );
  
  ObjAnimate( name..public.screensaver_current, "alp", 0, 0, "", { 0,0,1, tme,0,0 } );
  ObjAnimate( name..new_num, "alp", 0, 0, function() ObjSet( 'rm_screensaver', {  input = 1 } );end, { 0,0,0, tme,0,1 } );  
  ObjSet( "txt_screensaver_counter", { text = new_num.."/"..max_count } );
  
  --ObjSet( "txt_screensaver_screensaver_name", { text = "str_screensaver_screensaver_name_"..new_num } );

  public.screensaver_current = new_num;


  if ng_global.achievements.puzzle_screen[public.screensaver_current] and not ng_global.achievements.done_puzzle_screen[public.screensaver_current] then
    ObjSet( "spr_screensaver_arrow1", {alp = 1,input=1} );
    ObjSet( "spr_screensaver_arrow2", {alp = 1,input=1} );
  else
    ObjSet( "spr_screensaver_arrow1", {alp = 0,input=0} );
    ObjSet( "spr_screensaver_arrow2", {alp = 0,input=0} );   
  end
  

end;

----------------------------------------------------------------------------------------------------

function private.LoadPuzzle()
  local count = 0
  for j=1,3 do
    ObjSet( "spr_screensaver_frame_"..j, {alp = 0} );
    count = 0 
    for i=1,12 do
      local index = (j-1)*12 + i
      if ng_global.achievements.puzzle[index] then
        ObjSet( "spr_screensaver_puzzle"..index, { visible = 1} );
        ObjDelete("spr_screensaver_puzzle"..index.."_counter")
        count = count + 1
      else 
        ObjSet( "spr_screensaver_puzzle"..index, {input = 0, visible = 0} );
      end
      ObjSet( "txt_screensaver_screen"..j, {text = count.."/12"} );
      --DbgTrace(index)

      --если собраны все 12 на скрине 
        if ng_global.achievements.puzzle_screen[j] and count == 12 then
          ObjSet( "spr_screensaver_frame_"..j, {alp = 1} );
          --ObjDelete("anm_screensaver_screen_"..j.."_anim")
          --ObjDelete("txt_screensaver_screen"..j)
          --ObjDelete("obj_screensaver_screen"..j.."_clk_open")

          ObjSet( "anm_screensaver_screen_"..j.."_anim", {alp= 0 ,input = 0} );
          ObjSet( "txt_screensaver_screen"..j, {alp= 0 ,input = 0} );
          ObjSet( "obj_screensaver_screen"..j.."_clk_open", {alp= 0 ,input = 0} );

          for i=1,12 do
            local index = (j-1)*12 + i
            ObjSet( "spr_screensaver_puzzle"..index, {input = 1,alp=1,pos_x=private.puzzle_pos_ang[index][1]-171,pos_y=private.puzzle_pos_ang[index][2],ang = private.puzzle_pos_ang[index][3]*1.57,
                      event_menter = function () private.ButtonMouseEnter( "puzzle"..index ); end;
                      event_mleave = function () private.ButtonMouseLeave( "puzzle"..index ); end;   
                      event_startdrag = function () private.PuzzlwStartDrag( "puzzle"..index ); end;    
                  } );
            ObjSet( "obj_screensaver_puzzle"..index.."_drop", {input = 1} );
            if ng_global.achievements.puzzle_done[index] then
              ObjSet( "spr_screensaver_puzzle"..index, {input = 0,pos_x = ObjGet("obj_screensaver_puzzle"..index.."_drop").pos_x,pos_y = ObjGet("obj_screensaver_puzzle"..index.."_drop").pos_y,pos_z = 0,ang = 0} );
              ObjSet("obj_screensaver_puzzle"..index.."_drop",{input=0})     
              ObjAttach( "spr_screensaver_puzzle"..index, ObjGetRelations( "spr_screensaver_puzzle"..index ).parent )   
            end
          end
        elseif not (ng_global.achievements.puzzle_screen[j]) and count == 12 then
          ObjSet( "anm_screensaver_screen_"..j.."_anim", {alp = 1} );
          for i=1,12 do 
            local index = (j-1)*12 + i
            ObjSet("spr_screensaver_puzzle"..index,{alp=0})
          end
          ObjSet( "obj_screensaver_screen"..j.."_clk_open", {input = 1} );

        else 
          ObjSet( "anm_screensaver_screen_"..j.."_anim", {alp = 0} );
        end
    end
      --if count ==12 then
      --  DbgTrace("open "..j)
      --else 
      --  DbgTrace("close "..j.."count ="..count)
      --end

        if ng_global.achievements.done_puzzle_screen[j] then
          ObjSet( "spr_screensaver_screen"..j,  {alp = 1})
          ObjSet( "spr_screensaver_button_setscreensaver"..j,{alp = 1 ,input = 1})
          for i=1,12 do 
            local index = (j-1)*12 + i
            ObjSet("spr_screensaver_puzzle"..index,{alp = 0,input = 0})
            ObjSet("obj_screensaver_puzzle"..index.."_drop",{input = 0})
          end
        else 
          ObjSet( "spr_screensaver_screen"..j,  {alp= 0})
          ObjSet( "spr_screensaver_button_setscreensaver"..j,{alp= 0,input = 0})
        end


  end

SaveProfiles();
end

function private.PuzzlwStartDrag( index )
  SoundSfx( "aud_get_stuff" )
end;

function public.PuzzleDrop(str)
--local str = ne_params.sender
local num = ( str:gsub("spr_screensaver_puzzle",""))
  num = tonumber( num )

  local obj = str
    if common_impl.ApplyCheck(obj,"spr_screensaver_arrow1") then

    --if port.isPortable() == 0 then
       --ObjDoNotDrop(obj);
    --end;
      if not private.puzzle_anim then
        SoundSfx( "aud_twist" )
        private.puzzle_pos_ang[num][3] = private.puzzle_pos_ang[num][3] - 1
        if private.puzzle_pos_ang[num][3]==-1 then private.puzzle_pos_ang[num][3] = 3 end
        local a_end = private.puzzle_pos_ang[num][3]*math.pi/2
        local a_beg = private.screensaver.ang( ObjGet(obj).ang, a_end ) 

        private.puzzle_anim = true 
        ObjAnimate( obj, 7, 0, 0, function() private.puzzle_anim = false end, {0,0,a_beg, 0.35,3,a_end} );
    end    
  elseif  common_impl.ApplyCheck(obj,"spr_screensaver_arrow2") then

  --if port.isPortable() == 0 then
     --ObjDoNotDrop(obj);
  --end;
    if not private.puzzle_anim then
      SoundSfx( "aud_twist" )
      private.puzzle_pos_ang[num][3] = private.puzzle_pos_ang[num][3] + 1
      if private.puzzle_pos_ang[num][3]==4 then private.puzzle_pos_ang[num][3] = 0 end
      local a_end = private.puzzle_pos_ang[num][3]*math.pi/2
      local a_beg = private.screensaver.ang( ObjGet(obj).ang, a_end ) 

      private.puzzle_anim = true 
      ObjAnimate( obj, 7, 0, 0, function() private.puzzle_anim = false end, {0,0,a_beg, 0.35,3,a_end} );
    end
  elseif common_impl.ApplyCheck(obj,"obj_screensaver_puzzle"..num.."_drop") and private.puzzle_pos_ang[num][3]==0 then
    SoundSfx( "aud_put_picture_part" )
    ObjSet( obj, {input = 0,pos_x = ObjGet("obj_screensaver_puzzle"..num.."_drop").pos_x,pos_y = ObjGet("obj_screensaver_puzzle"..num.."_drop").pos_y,pos_z = 0} );
    ObjSet("obj_screensaver_puzzle"..num.."_drop",{input = 0})
    ng_global.achievements.puzzle_done[num] = true
    local count = 0
    for i=1,12 do
      local index = (public.screensaver_current-1)*12 + i
      if ng_global.achievements.puzzle_done[index] then
        count= count + 1
      end
    end
    if count == 12 then
      private.DoneScreen()
    end
  else 
    SoundSfx( "aud_put_picture_part" )
    ObjSet( obj, {pos_z =5,inputrect_init = 0} );
  end
SaveProfiles();
end


function private.screensaver.ang( a_beg, a_end )
  if math.abs(a_beg-a_end) > math.pi then
    if a_beg > a_end then
      a_beg = a_beg - math.pi * 2
    else
      a_beg = a_beg + math.pi * 2
    end;
  end;
  return a_beg;
end;




function public.OpenScreen()
    ObjSet( 'rm_screensaver', {input = 0} );
    for i=1,12 do
      ObjSet( "spr_screensaver_puzzle"..i, {alp = 0} );
    end

    ObjSet( "spr_screensaver_arrow1", {alp = 1,input=1} );
    ObjSet( "spr_screensaver_arrow2", {alp = 1,input=1} );
    --DbgTrace("open_screen "..public.screensaver_current)
   -- ObjDelete("obj_screensaver_screen1_clk_open")
    ObjSet( "obj_screensaver_screen"..public.screensaver_current.."_clk_open", {alp = 0,input = 0} );
    ng_global.achievements.puzzle_screen[public.screensaver_current] = true
    ObjSet( "anm_screensaver_screen_"..public.screensaver_current.."_anim", {alp = 1} );
  SoundSfx( "aud_puzzle_slide" )
    ld.AnimPlay("anm_screensaver_screen_"..public.screensaver_current.."_anim","anim_puzzl",function()private.LoadPuzzle();ObjSet( 'rm_screensaver', {input = 1} ); end)
    --ComplexAnmPlay("anm_screensaver_screen_"..public.screensaver_current.."_anim","puzzle","*")
    ObjAnimate( "spr_screensaver_frame_"..public.screensaver_current, 8, 0, 0, "", {0,0,0, 0.5,0,1} );
SaveProfiles();
end


function private.DoneScreen()
  SoundSfx( "aud_puzzle_complete" )
  ObjSet( 'rm_screensaver', {input = 0} );
  ng_global.achievements.done_puzzle_screen[public.screensaver_current] = true
  ObjAnimate( "spr_screensaver_screen"..public.screensaver_current, 8, 0, 0,function()private.LoadPuzzle(); ObjSet( 'rm_screensaver', {input = 1} ); end, {0,0,0, 0.5,0,1} );
  ObjAnimate( "spr_screensaver_button_setscreensaver"..public.screensaver_current, 8, 0, 0, "", {0,0,0, 0.5,0,1} );
  ObjSet( "spr_screensaver_button_setscreensaver"..public.screensaver_current, {input = 1,alp=1} );
    ObjSet( "spr_screensaver_arrow1", {alp = 0,input=0} );
    ObjSet( "spr_screensaver_arrow2", {alp = 0,input=0} );   
SaveProfiles();
end





--SaveProfiles();
--LoadCurrentProfile()

----------------------------------------------------------------------------------------------------

function public.Setscreensaver()

  SetCursor( CURSOR_DEFAULT );
  SoundSfx( 2 )

  if IsDemoEdition() or IsSurveyEdition()  then
    --cmn.DialogWindowShow( "common", "notfull" );
    common.DialogWindowShow( "common", "not_in_demo", true );
  else
    if GetPlatform()=="mac" or GetPlatform()=="ios" or GetPlatform()=="android" then
      common.DialogWindowShow( "common", "setscreensaver_walp", true );
    else
      common.DialogWindowShow( "common", "setscreensaver", true );
    end


  end;  

end;

--------------------------------------------------------------------

common.dialog.common.buttons[ "not_in_demo" ] = { left = nil, center = { text = "ok", func = "Close" }, right = nil };

--------------------------------------------------------------------

common.dialog.common.buttons[ "setscreensaver" ] = { left = { text = "yes", func = "setscreensaver" }, center = nil, right = { text = "no", func = "Close" } };

function common.dialog.common.setscreensaver ()
  ld.LogTrace( public.screensaver_current );
  common.dialog.common.Close()
  SetScreensaver( "assets/levels/menu/rm_screensaver/content/screensaver_"..public.screensaver_current.."/ChristmasStories_TheGiftOfTheMagi_scr"..public.screensaver_current..".scr" );
end;
--------------------------------------------------------------------

common.dialog.common.buttons[ "setscreensaver_walp" ] = { left = { text = "yes", func = "setscreensaver_walp" }, center = nil, right = { text = "no", func = "Close" } };

function common.dialog.common.setscreensaver_walp ()
  common.dialog.common.Close()
  CopyFileToMyDocs( "assets/levels/menu/rm_screensaver/content/wallpaperscreensaver_"..public.screensaver_current);
end;
