-- name=cheater
--******************************************************************************************
function public.Init()
  --------------------------------------------------------------------
  private.HINT_ROOT = common_impl.hint      --массив хинта

  ObjSet( "cheater", { pos_z = 13, visible = false, active = false, input = false } );
  ObjAttach( "cheater", "ne_origin" );

  private.InitButtons();
  private.InitReviewMode();
  private.InitKeyboard();

  public.DIRECTION = -1;
  public.is_progress_executing_now = false;
  private.is_ipad = false;
  private.is_show_done = false;
  private.currentroom = GetCurrentRoom();
  private.column = { room = 0, progress = 0, last = nil, done_amount = 0 };

  private.LINE_MAX_COUNT = 35;
  private.COLUMN_MAX_COUNT = 5;
  private.RECORD_WIDTH = 160;

  private.HeightChange();
  private.ControlButtons( { mode = 1, skip = 1, sound = 1 } );

  private.ButDown();
  public.UpdateRoom( private.currentroom );

  MsgSubscribe( Event_AltF1, private.HandleAltF1 );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  MsgSubscribe( Event_Cheater_KeyPressed, private.HotKey );
  private.onScreen = false;

  private.CheboxaryInit()
  private.BotInit()

--  private.track_objs = {
--    "obj_flowerstableext_win_flowerstableext_point_1_1","obj_flowerstableext_win_flowerstableext_point_1_2","obj_flowerstableext_win_flowerstableext_point_1_3",
--    "obj_flowerstableext_win_flowerstableext_point_2_1","obj_flowerstableext_win_flowerstableext_point_2_2","obj_flowerstableext_win_flowerstableext_point_2_3",
--    "obj_flowerstableext_win_flowerstableext_point_3_1","obj_flowerstableext_win_flowerstableext_point_3_2","obj_flowerstableext_win_flowerstableext_point_3_3",
--    "obj_flowerstableext_win_flowerstableext_point_4_1","obj_flowerstableext_win_flowerstableext_point_4_2","obj_flowerstableext_win_flowerstableext_point_4_3"
--}


--  private.track_objs = {
--    "int_simon"
--}

  private.track_objs = {
  "txt_menu_but_profile";
  "txt_menu_but_options";
  "txt_menu_but_quit";
  "txt_menu_but_strguide";
  "txt_menu_but_moregames";
  "txt_menu_but_play";
  "txt_menu_but_extra";
}


end;
--******************************************************************************************
function public.Destroy()

  ObjDelete( "hub_cheater_default" );
  ObjDelete( "cheater" );
  ObjDelete( "txt_cheater_review_field" );
  MsgUnsubscribe( Event_AltF1, private.HandleAltF1 );
  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  MsgUnsubscribe( Event_Cheater_KeyPressed, private.HotKey );
    
end;
--******************************************************************************************
function public.IsLdCheater()
  if not private.editor_super_cheater_obj then
    private.editor_super_cheater_obj = ObjGet( "editor_super_cheater" )
    private.editor_super_cheater_obj = private.editor_super_cheater_obj or { draw_width = 0 }
  end
  return private.editor_super_cheater_obj.draw_width == 120 and IsEditor()
end
--******************************************************************************************
function public.IsSoundCheater()
  if not private.editor_super_cheater_obj then
    private.editor_super_cheater_obj = ObjGet( "editor_super_cheater" )
    private.editor_super_cheater_obj = private.editor_super_cheater_obj or { draw_width = 0 }
  end
  return private.editor_super_cheater_obj.draw_width.draw_width == 126 and IsEditor()
end
--******************************************************************************************
function private.HotKey( msg, params )
  local key_code = params.key;
  if private.keycodes_logging_off then
  else
    private.BotLog( "CheaterKeyPress "..key_code);
  end

  if not ( private.reviewmode_enabled ) then
    
    if ( key_code == 81 ) then --Q

      --private.BotLog( "QQQ" )
      --private.BotLog( "BotStartNow", private.BotStartNow )
      --private.BotLog( "BotStepNow", private.BotStepNow )
      --private.BotLog( "BotStepNowEnded", private.BotStepNowEnded )

      if private.BotStartNow and private.BotStepNow and ( not private.BotStepNowEnded ) then
        private.BotStartNow = false
        private.BotStepNow = false
      end
        
      if private.BotStartNow then
        private.BotStop();
        return
      else
        private.BotStart();
        return
      end

      if public.IsSoundCheater() then
        if not game then return end;
        local progress = private.GetGlobalProgress();
        local progress_names = private.GetProgressNames()
        for i = 1, #progress_names do
          if not string.find(progress_names[i],"^tutorial_") and progress[progress_names[i] ].done == 0 then
            private.ProgressExecute( i, i )
            break;
          end;
        end;
      end

    elseif ( key_code == 83 ) then --S

      if not private.SkipVideoNow then

        private.SkipVideo();
        if private.GetGlobalProgress()[ "opn_entrypoint" ] and not ld.CheckRequirements( {"opn_entrypoint"} ) and public.IsLdCheater() then
          cmn.SetEventDone( "opn_entrypoint" )
          cmn.CallEventHandler( "opn_entrypoint" )
          level.TutorialDisable()
          --rm_entrypoint.dlg_entrypoint_amadey1_end()
        end
        private.SkipVideoNow = true
        ld.StartTimer( 1.5, function() private.SkipVideoNow = false end )
      end

    elseif ( key_code == 87 ) and IsEditor() then --W skip intro
      
      if GetCurrentRoom() == "rm_intro" then
        
        int.DialogVideoHide();
        cmn.GotoRoom('rm_menu',0); 

      end

    elseif public.IsLdCheater() then

      if private.CheboxaryFuncs then
        if key_code == 18 then
          private.LdCheaterAlt = not private.LdCheaterAlt
        elseif private.LdCheaterAlt then
          local func_num = key_code - 48
          if private.CheboxaryFuncs[ func_num ] then
            private[ private.CheboxaryFuncs[ func_num ][ 1 ] ]();
          end
          private.LdCheaterAlt = false
        end
      end
      
      if( key_code == 32 ) then --PROBEL MG SKIP

        if cmn.current_mg then
          if int_complex_inv and int_complex_inv.GetCurrentName() ~= "" then
            level_inv.Skip();
          elseif _G[ GetCurrentRoom() ].Skip then
            _G[ GetCurrentRoom() ].Skip();
          end;
        end

      elseif( key_code == 33 ) then --PAGE UP return progres
       
        if not game then return end;
        local progress = private.GetGlobalProgress();
        local progress_names = private.GetProgressNames()
        local returned = false
        if private.InGameDoneOrder and #private.InGameDoneOrder > 0 then
          for i = #private.InGameDoneOrder, 1, -1 do
            if string.find( private.InGameDoneOrder[i],"^tutorial_" ) or progress[ private.InGameDoneOrder[i] ].done == 0 then
              table.remove( private.InGameDoneOrder, i )
            else
              progress[ private.InGameDoneOrder[i] ].done = 0
              progress[ private.InGameDoneOrder[i] ].start = 0
              ld.LogTrace( "set progress "..private.InGameDoneOrder[i].." done = 0" )
              returned = true
              break;
            end;
          end
        end
        if not returned then

          for i = #progress_names, 1, -1 do
            if not string.find(progress_names[i],"^tutorial_") and progress[progress_names[i] ].done == 1 then
              progress[progress_names[i] ].done = 0
              progress[progress_names[i] ].start = 0
              ld.LogTrace( "set progress "..progress_names[i].." done = 0" )
              break;
            end;
          end;
        end

      elseif( key_code == 34 ) then --PAGE DOWN execute next progres
       
        if not game then return end;
        local progress = private.GetGlobalProgress();
        local progress_names = private.GetProgressNames()
        for i = 1, #progress_names do
          if not string.find(progress_names[i],"^tutorial_") and progress[progress_names[i] ].done == 0 then
            private.ProgressExecute( i, i )
            break;
          end;
        end;

      elseif( key_code == 46 ) then --DEL execute to first progres in current room
       
        if not game then return end;
        local progress = private.GetGlobalProgress();
        local progress_names = private.GetProgressNames()
        for i = 1, #progress_names do
          if not string.find(progress_names[i],"^tutorial_") 
          and progress_names[i+1]
          and progress[progress_names[i+1] ]
          and progress[progress_names[i+1] ].done == 0 
          and private.HINT_ROOT[progress_names[i+1] ]
          and private.HINT_ROOT[progress_names[i+1] ].room == GetCurrentRoom()
          then
            for ii = 1, i do
              if not string.find(progress_names[ii],"^tutorial_") and progress[progress_names[ii] ].done == 0 then
                private.ProgressExecute( ii, ii )
              end;
            end;
            break;
          end;
        end;

      elseif( key_code == 144 ) then --NumLock > SlowMotion
   
        private.SlowMotion = private.SlowMotion or 1
        local spd = { 1, 0.2 }
        private.SlowMotion = private.SlowMotion % #spd
        private.SlowMotion = private.SlowMotion + 1

        if private.SlowMotion == 1 then
          ne.SetTestMode( 0 )
          ld.LogTrace( "SlowMotion disabled" )
        else
          ne.SetTestMode( 1, spd[ private.SlowMotion ] )
          ld.LogTrace( "SlowMotion speed >> "..spd[ private.SlowMotion ] )
        end

      elseif( key_code == 35 ) then --END restart to room

        common.LevelSwitch( "level" );

      elseif( key_code == 36 ) and public.IsLdCheater() then --HOME restart to room

        common.LevelSwitch( "levelext" );

      elseif( key_code == 145 ) then --SCROLL LOCK interface visible
        ld.LogTrace( private.cheater_hotkey_interface_visibility )
        private.cheater_hotkey_interface_visibility = private.cheater_hotkey_interface_visibility or 1;
        if private.cheater_hotkey_interface_visibility == 1 then
          private.cheater_hotkey_interface_visibility = 0
          interface.InterfaceSetVisible(false,1)
          ObjSet( "int_pause", { visible = 0 } )
        else
          --ld.LogTrace( 1 )
          private.cheater_hotkey_interface_visibility = 1
          interface.InterfaceSetVisible(true,0)
          ObjSet( "int_pause", { visible = 1 } )
        end;

      elseif( key_code == 0 ) then --INSERT fast progres execute
      
        if public.InsertFastExecuter then public.InsertFastExecuter = false
        else public.InsertFastExecuter = true end;
        
      elseif( key_code == 67 ) then --c
        private.keycodes_logging_off = not private.keycodes_logging_off
        ld.LogTrace( (private.keycodes_logging_off and "keycodes_logging_off") or "keycodes_logging_on" );
      elseif( key_code == 16 ) then --Shift
        private.track_shift_on = not private.track_shift_on
        ld.LogTrace( (private.track_shift_on and "track_shift_on") or "track_shift_off" );
      elseif( key_code == 90 ) and true then --z
        --private.track_objs = {"int_tutorial_impl","spr_int_tutorial_arrow_1","spr_int_tutorial_arrow_2"} 
        --private.track_objs = {"spr_screensaver_puzzle25", "spr_screensaver_puzzle26", "spr_screensaver_puzzle27", "spr_screensaver_puzzle28", "spr_screensaver_puzzle29", "spr_screensaver_puzzle30", "spr_screensaver_puzzle31", "spr_screensaver_puzzle32", "spr_screensaver_puzzle33", "spr_screensaver_puzzle34", "spr_screensaver_puzzle35", "spr_screensaver_puzzle36"}
        --private.track_objs = {"int_simon"}
        private.track_select = private.track_select or 0
        private.track_select = private.track_select%#private.track_objs + 1
        private.track_select_name = private.track_objs[private.track_select]
        private.track_selected = function() 
          return (ObjGet(private.track_select_name))
        end
        private.track_change = function(param, step)
          if private.track_select_name and private.track_selected() then
            ObjSet( private.track_select_name, { [param] = private.track_selected()[param] + step * (private.track_shift_on and 10 or 1) } );  
          end
        end
        if private.track_selected() then
          ld.LogTrace( ">>",private.track_select_name.." @ "..ObjGetRelations( private.track_select_name ).parent, " pos_x:"..private.track_selected().pos_x, " pos_y:"..private.track_selected().pos_y, " ang:"..string.format("%.2f", private.track_selected().ang) );
        else
          ld.LogTrace( "Error: no such object <"..private.track_select_name.."> press Z again" );
        end
      elseif( key_code == 88 ) and IsEditor() and private.track_select_name and private.track_selected() then --x
         ld.LogTrace( "||",private.track_select_name.." @ "..ObjGetRelations( private.track_select_name ).parent, " pos_x:"..private.track_selected().pos_x, " pos_y:"..private.track_selected().pos_y, " ang:"..string.format("%.2f", private.track_selected().ang) );

      elseif( key_code == 105 ) and private.track_change then --9 num
        private.track_change("ang",-0.01)
      elseif( key_code == 99 ) and private.track_change then --3 num
        private.track_change("ang", 0.01)
      elseif( key_code == 104 ) and private.track_change then --up num
        private.track_change("pos_y",-1)
      elseif( key_code == 98 ) and private.track_change then --down num
        private.track_change("pos_y", 1)
      elseif( key_code == 100 ) and private.track_change then --left num
        private.track_change("pos_x",-1)
      elseif( key_code == 102 ) and private.track_change then --right num
        private.track_change("pos_x", 1)
      --] ]
      end;
    end
  end;

  -- Review: PauseBreak
  if ( key_code == 19 ) or ( key_code == 123 ) then

    private.ReviewMode();

  -- Review: Up
  elseif ( key_code == 107 ) or ( key_code == 187 ) then

    private.ReviewMarkUp();

  -- Review: Down
  elseif ( key_code == 109 ) or ( key_code == 189 ) then

    private.ReviewMarkDown();

  end;

end;
--******************************************************************************************
--function *** COMMANDS ***() end;
--******************************************************************************************
  function public.Step()

    private.ProgressStep();

  end;
  --******************************************************************************************
  function public.UpdateRoom( room_name )

    private.currentroom = room_name or private.currentroom;
    ObjSet( "txt_cheater_current_room", { text = private.currentroom } ); 
    ObjSet( "txt_cheater_current_subroom", { text = "" } ); 

  end;
  --******************************************************************************************
  function public.StartUpdateSubroom( subroom_name )

    ObjSet( "tmr_cheater_subroom", 
    { 
      playing = true, 
      time = 0.625, 
      endtrig = function () private.UpdateSubroom( subroom_name ); end; 
    } );

  end;
  --******************************************************************************************
  function private.UpdateSubroom( subroom_name )

    ObjSet( "txt_cheater_current_subroom", { text = subroom_name } ); 

  end;
--******************************************************************************************
--function  *** PROGRESS *** () end;
--******************************************************************************************
  function private.GetProgressNames()

    return game.progress_names;

  end;
  --******************************************************************************************
  function private.GetCurrentProgress()

    return ng_global.currentprogress;

  end;
  --******************************************************************************************
  function private.GetGlobalProgress()

    local prg = private.GetCurrentProgress();
    return ng_global.progress[ prg ];

  end;
  --******************************************************************************************
  function public.InsertFastExecuterFunc( prg )
    local firstevent_number = 0
    local lastevent_number = 0
    local progress = private.GetGlobalProgress();
    local progress_names = private.GetProgressNames()
    for i = 1,#progress_names do
      if  progress[progress_names[i] ].done == 0 then
        firstevent_number = i;
        break;
      end;
    end;
    for i = 1,#progress_names do
      if progress_names[i] == prg then
        lastevent_number = i-1;
        break;
      end;
    end;
    private.ProgressExecute( firstevent_number, lastevent_number )
    cheater.InsertFastExecuter = false;
  end;
  --******************************************************************************************
  function private.ProgressExecute( firstevent_number, lastevent_number )

    local progress = private.GetGlobalProgress();
    local progress_names = private.GetProgressNames();

    public.is_progress_executing_now = true;

    --ld.LogTrace( firstevent_number, lastevent_number )

    if ( firstevent_number ) and ( firstevent_number <= (lastevent_number) ) then

      for i = firstevent_number, #progress_names do

        if ( progress[ progress_names[ i ] ].done == 0 ) then

          --progress[ progress_names[ i ] ].done = 1;
          cmn.SetEventDone( progress_names[ i ] )

          if ( cmn.IsSubscribersIncluded() ) then

            cmn.AddSubscribersToQueue( progress_names[ i ] );

          else 

            if ( progress[ progress_names[ i ] ].func ) then
              progress[ progress_names[ i ] ].func();
            else
              DbgTrace( "Event "..progress_names[ i ].." doesnt have func." );
            end;

          end;

        end;

        if ( i == lastevent_number ) then
          break;
        end;

      end;
    
    elseif ( firstevent_number and lastevent_number ) and ( firstevent_number > (lastevent_number+1) ) then
      --отмена прогресса
      for i = firstevent_number, lastevent_number+1, -1 do

        if ( progress[ progress_names[ i ] ].done == 1 ) then

          progress[ progress_names[ i ] ].done = 0;
          progress[ progress_names[ i ] ].start = 0;
          progress[ progress_names[ i ] ].state = nil;

        end;
      end;

      if private.GetCurrentProgress() == "std" then
        common.LevelSwitch( "level" );
      elseif private.GetCurrentProgress() == "ext" then
        common.LevelSwitch( "levelext" );
      end

    end;

    if ( private.currentroom == "" ) then

      private.currentroom = GetCurrentRoom();

    end;

    if ( cmn.IsSubscribersIncluded() ) then

      cmn.ExecuteQueue( private.currentroom );

    end;

    public.is_progress_executing_now = false;

  end;
  --******************************************************************************************
  function private.ProgressFind( is_need_get_number )

    local progress = private.GetGlobalProgress();
    local progress_names = private.GetProgressNames();
    local progressname = nil;

    for i = 1, #progress_names, 1 do

      if ( progress[ progress_names[ i ] ].done == 0 ) then

        if ( is_need_get_number ) then
          progressname = i;
        else
          progressname = progress_names[ i ];
        end;
        break;

      end;

    end;

    if ( progressname == nil ) then

      if ( is_need_get_number ) then
        progressname = #progress_names;
      else 
        progressname = progress_names[ #progress_names ];
      end;

    end;
    
    return progressname;

  end;
  --******************************************************************************************
  function private.ProgressStep()

    public.is_progress_executing_now = true;

    local progress = private.GetGlobalProgress();
    local progress_names = private.GetProgressNames();

    for i = 1, #progress_names, 1 do
      if ( progress[ progress_names[ i ] ].done == 0 ) then

        --progress[ progress_names[ i ] ].done = 1;
        cmn.SetEventDone( progress_names[ i ] )

        if ( cmn.IsSubscribersIncluded() ) then

          cmn.AddSubscribersToQueue( progress_names[ i ] );

        else

          if ( progress[ progress_names[ i ] ].func ) then
            progress[ progress_names[ i ] ].func();
          else
            DbgTrace( "Event "..progress_names[ i ].." doesnt have func." );
          end;

        end;

        break;

      end;

    end;

    if ( private.currentroom == "" ) then

      private.currentroom = GetCurrentRoom();

    end;

    if ( cmn.IsSubscribersIncluded() ) then

      cmn.ExecuteQueue( private.currentroom );

    end;

    public.is_progress_executing_now = false;

  end
  --******************************************************************************************
  function private.ShowProgress( p_column_shift )

    if ( not p_column_shift ) then

      private.column.progress = 0;
      private.SetArrow( "left", "progress", false );
      ObjSet( "cheater_progress_names", { pos_x = 0 } );
      private.DetachColumn( "progress" );

    end;

    local column_amount = p_column_shift or 0;
    local column_counter = column_amount;

    local progress_done_amount = 0;
    local progress_idstart = column_amount * private.LINE_MAX_COUNT + 1;

    if ( not private.is_show_done ) and ( column_amount > 0 ) then
      progress_done_amount = private.column.done_amount;
      progress_idstart = progress_idstart + progress_done_amount;
    end;

    local progress_names = private.GetProgressNames();
    local progress = private.GetGlobalProgress();
    local progress_colour = { 
                        if_done_true  = {
                          def = { color_g = 1.00-0.50, color_b = 1.00-0.50 },
                          dlg = { color_g = 0.80-0.50, color_b = 0.80-0.50 },
                          opn = { color_g = 0.60-0.50, color_b = 0.60-0.50 },
                          get = { color_g = 0.80-0.50, color_b = 1.00-0.50 },
                          use = { color_g = 0.80-0.50, color_b = 0.60-0.50 },
                          win = { color_g = 1.00-0.50, color_b = 0.60-0.50 },
                          clk = { color_g = 0.60-0.50, color_b = 1.00-0.50 }                      },
                        if_done_false = {
                          def = { color_g = 1.00, color_b = 1.00 },
                          dlg = { color_g = 0.80, color_b = 0.80 },
                          opn = { color_g = 0.60, color_b = 0.60 },
                          get = { color_g = 0.80, color_b = 1.00 },
                          use = { color_g = 0.80, color_b = 0.60 },
                          win = { color_g = 1.00, color_b = 0.60 },
                          clk = { color_g = 0.60, color_b = 1.00 }
                        } };
    local color = {   use_ = { 1,0.80,0.80};
                      get_ = { 0.80,1,0.80};
                      --opn_ = { 0.85,0.55,0};
                      opn_ = { 0,0,0};
                      win_ = { 0.9,0.30,0.9};
                      mmg_ = { 1,0.65,0.65};
                      dlg_ = { 0,0.8,0.8};
                  }
    local counter_missevent = 0;
    local arrow_param = false;
    local index_obj = 0;
    local last = 0;

    for index_prg = progress_idstart, #progress_names do

      local event = progress_names[ index_prg ];
      --DbgTrace( "event="..event );
      index_obj = index_prg - counter_missevent;
      local is_done = false;
      --- --- --- --- --- column
      if ( ( index_obj - progress_done_amount ) > ( column_counter * private.LINE_MAX_COUNT ) ) then

        local column_counter_abs = private.COLUMN_MAX_COUNT + column_amount;
        if ( column_counter >= column_counter_abs ) then

          last = index_obj;
          arrow_param = true;
          break;

        end;

        column_counter = column_counter + 1;
        local column_params = 
        {
           counter = column_counter,
           amount  = column_amount,
           type    = 'progress'
        };
        private.CreateColumn( column_params );

      end;
      --- --- --- --- --- done?
      if ( progress[ event ].done == 1 ) then

        is_done = true;
        if ( not private.is_show_done ) then
          counter_missevent = counter_missevent + 1;
        end;

      end;
      --- --- --- --- --- if need - create-attach
      if ( not is_done ) or ( private.is_show_done ) then

        local event_done    = "if_done_"..tostring( is_done );
        local event_prefix  = common.GetObjectPrefix( event );
        if ( progress_colour[ "if_done_"..tostring( is_done ) ][ event_prefix ] == nil ) then
          event_prefix = 'def';
        end;

        local clr = color[ string.sub( event, 1, 4 ) ] or { 1,1,1 }
        
        local index_obj_param = index_obj - progress_done_amount;
        local prg_params = 
        {
            obj_num      = index_obj_param
           ,type         = "progress"
           ,column       = column_counter
           ,text         = event
           ,text_r       = event:find("^opn_") and 1 or 0
           ,text_g       = event:find("^opn_") and 1 or 0
           ,text_b       = event:find("^opn_") and 1 or 0
           ,event_mdown  = function () private.ProgressExecute( private.ProgressFind( true ), index_prg ); private.ButtonDown( "progress" ) end
           ,event_menter = function () private.ProgressMouseOver( index_obj_param, 0 ); end
           ,event_mleave = function () private.ProgressMouseOver( index_obj_param, 1 ); end
           --,color_b      = progress_colour[ event_done ][ event_prefix ].color_b
           --,color_g      = progress_colour[ event_done ][ event_prefix ].color_g
           ,color_r      = is_done and clr[1] > 0.4 and clr[1] - 0.4 or clr[1]
           ,color_g      = is_done and clr[2] > 0.4 and clr[2] - 0.4 or clr[2]
           ,color_b      = is_done and clr[3] > 0.4 and clr[3] - 0.4 or clr[3]
        };
        private.CreateRecord( prg_params );

      end;
      --- --- --- --- ---
    end;

    -- amount done
    if ( counter_missevent ~= 0 ) then
      private.column.done_amount = counter_missevent;
    end;

    -- detach done
    if ( not private.is_show_done ) and ( private.column.done_amount ~= 0 ) and ( last == 0 )  then
      
      local i = ( #progress_names - private.column.done_amount + 1 );

      while ( i <= #progress_names ) do    
        ObjDetach( "spr_cheater_progress_"..i );
        ObjDetach( "txt_cheater_progress_"..i );
        i = i + 1;
      end;
    end;


    private.column.last = last;
    private.SetArrow( "right", "progress", arrow_param );
    
  end
  --******************************************************************************************
  function private.ProgressCheckDown()

    local check_text = { if_true = "hide done", if_false = "show done" }
    private.is_show_done = not private.is_show_done;
    ObjSet( "txt_cheater_progress_check", { text = check_text[ "if_"..tostring( private.is_show_done ) ] } );
    private.ShowProgress();

  end;
  --******************************************************************************************
  function private.ProgressMouseOver( name_number, color_value )

    local cur = {};
    cur[ '0' ] = CURSOR_HAND;
    cur[ '1' ] = CURSOR_DEFAULT;
    SetCursor( cur[ tostring( color_value ) ] );

    local objname = "spr_cheater_progress_";
    local record_first = private.LINE_MAX_COUNT * private.column.progress + 1;
    
    for i = record_first, name_number do
      --ObjSet( objname..i, { color_r = color_value } );
      local o = ObjGet( objname..i )
      if color_value == 0 then
        ObjSet( objname..i, { color_r = o.color_r > 0.2 and o.color_r - 0.2,
                              color_g = o.color_g > 0.2 and o.color_g - 0.2,
                              color_b = o.color_b > 0.2 and o.color_b - 0.2, } );
      elseif color_value == 1 then
        ObjSet( objname..i, { color_r = o.color_r > 0.2 and o.color_r + 0.2,
                              color_g = o.color_g > 0.2 and o.color_g + 0.2,
                              color_b = o.color_b > 0.2 and o.color_b + 0.2, } );
      end;
    end;

    ObjSet( 'spr_cheater_progress_arrow_left', { color_r = color_value } );


end;
--******************************************************************************************
--function  *** CONSOLE *** () end;
--******************************************************************************************
  function private.ShowConsole()
    ld.LogTrace( "ShowConsole" )
  end
  --******************************************************************************************
  function private.ConsoleClearDown()

    ObjSet( "ted_cheater_execute", { text = "" } );
    ld.LogTrace( "ConsoleClearDown" )
  end
  --******************************************************************************************
  function private.ConsoleDown()
    ld.LogTrace( "ConsoleDown" )
    --TrgSet( "trg_cheater_code", { code = ObjGet( "ted_cheater_execute" ).text } );
    --TrgExecute( "trg_cheater_code" );
    common.LogTrace( "Code executed: "..ObjGet( "ted_cheater_execute" ).text );

  end;
--******************************************************************************************
--function  *** KEYBOARD *** () end;
--******************************************************************************************
  function private.InitKeyboard()

    local keys_in_row = { 11, 9, 9, 4 };
    for i = 1, 4 do
      for j = 1, #keys_in_row do
        ObjSet( "spr_cheater_console_keyboard_keys_"..i.."_"..j, {
          event_mdown = function () private.keyboard.key.Down( i.."_"..j ); end,
          event_mdown = function () private.keyboard.key.MouseEnter( i.."_"..j ); end,
          event_mdown = function () private.keyboard.key.MouseLeave( i.."_"..j ); end
        } );
      end;
    end;

    ObjSet( "spr_cheater_console_keyboard_keys_1_11", { event_mdown = private.keyboard.Backspace } );
    ObjSet( "spr_cheater_console_keyboard_keys_3_1",  { event_mdown = private.keyboard.ShiftDown } );
    ObjSet( "spr_cheater_console_keyboard_keys_3_9",  { event_mdown = function () private.ConsoleDown(); private.keyboard.but.Down(); end; } );
    ObjSet( "spr_cheater_console_keyboard_keys_4_1",  { event_mdown = private.keyboard.Switch } );
    ObjSet( "spr_cheater_console_keyboard_keys_4_3",  { event_mdown = private.keyboard.Space } );

  end;
  --******************************************************************************************
  private.keyboard = {};
  private.keyboard.layout = "abc";
  private.keyboard.shift = "usual";
  private.keyboard["abc"] = {};
  private.keyboard["abc"]['usual'] = {
  { 'q',     'w', 'e', 'r', 't',  'y',  'u',  'i',  'o',     'p',  'zz'        },
  { 'a',     's', 'd', 'f', 'g',  'h',  'j',  'k',  'l',     'zz', 'zz'        },
  { 'shift', 'z', 'x', 'c', 'v',  'b',  'n',  'm',  'zz',    'zz', 'zz'        },
  { 'zz',    ',', 'zz','.', 'zz', 'zz', 'zz', 'zz', 'zz',    'zz', 'zz'        }
  };
  private.keyboard["abc"]['shift'] = {
  { 'Q',     'W', 'E',  'R', 'T',  'Y',  'U',  'I',  'O',    'P',  'zz'        },
  { 'A',     'S', 'D',  'F', 'G',  'H',  'J',  'K',  'L',    'zz', 'zz'        },
  { 'shift', 'Z', 'X',  'C', 'V',  'B',  'N',  'M',  'zz',   'zz', 'zz'        },
  { 'zz',    ',', 'zz', '.', 'zz', 'zz', 'zz', 'zz', 'zz',   'zz', 'zz'        }
  };
  private.keyboard["123"] = {};
  private.keyboard["123"]['usual'] = {
  { '1',     '2', '3', '4', '5',  '6',  '7',  '8',  '9',     '0',  'zz'        },
  { '#',     '/', '{', '}', '(',  ')',  "*",  ':',  '\"',    'zz', 'zz'        },
  { 'shift', '[', ']', '+', '=',  '-',  '_',  ';',  'zz',    'zz', 'zz'        },
  { 'zz',    ',', 'zz','.', 'zz', 'zz', 'zz', 'zz', 'zz',    'zz', 'zz'        }
  };
  private.keyboard["123"]['shift'] = {
  { 'zz',    'zz', 'zz', 'zz', 'zz', 'zz', 'zz', 'zz', 'zz', 'zz', 'zz'        },
  { 'zz',    '\\', 'zz', 'zz', "zz", "zz", 'zz', 'zz', '\'', 'zz', 'zz'        },
  { 'shift', 'zz', 'zz', 'zz', 'zz', 'zz', 'zz', 'zz', 'zz', 'zz', 'zz'        },
  { 'zz',    ',',  'zz', '.',  'zz', 'zz', 'zz', 'zz', 'zz', 'zz', 'zz'        }
  };
  private.keyboard.but = {};
  --******************************************************************************************
  function private.keyboard.but.Down()

    local name_keyboard = "cheater_console_keyboard_keys";
    local is_need_show = not ObjGet( name_keyboard ).visible; 
    local need_show = is_need_show;
    ObjSet( name_keyboard, { visible = need_show, input = need_show } );

    private.keyboard.layout = "abc";
    private.keyboard.shift = "usual";
    if ( is_need_show ) then
      private.keyboard.Update();
    end;

  end
  --******************************************************************************************
  function private.keyboard.Update()

    local text = "";
    local objname = "txt_cheater_console_keyboard_keys_";
    local layout = private.keyboard.layout;
    local shift  = private.keyboard.shift;

    for row = 1, #private.keyboard[ layout ][ shift ] do

      for index = 1, #private.keyboard[ layout ][ shift ][ row ] do

        text = private.keyboard[ layout ][ shift ][ row ][ index ];
        if ( text ~= "zz" ) then
          if ( ObjGet( objname..row.."_"..index ).name ) then  
            ObjSet( objname..row.."_"..index, { text = text } );
          end;
        end;

      end;

    end;

  end
  --******************************************************************************************
  function private.keyboard.ShiftDown()

    local params = {};
    params[ "shift" ] = "usual";
    params[ "usual" ] = "shift";
    private.keyboard.shift = params[ private.keyboard.shift ];
    private.keyboard.Update();

  end;
  --******************************************************************************************
  function private.keyboard.Switch()

    local objname = "cheater_console_keyboard_keys_4_1";
    local params = {};
    ObjSet( "txt_"..objname, { text = private.keyboard.layout } );
    params[ "abc" ] = "123";
    params[ "123" ] = "abc";
    private.keyboard.layout = params[ private.keyboard.layout ];
    private.keyboard.shift = "usual";
    private.keyboard.Update();

  end;
  --******************************************************************************************
  function private.keyboard.Backspace()

    local ted_name = "ted_cheater_execute";
    local text_full = ObjGet( ted_name ).text;
    local text_full_len = string.len( text_full );
    if ( text_full_len ~= 0 ) then  
      local text_cut = string.sub( text_full, 1, text_full_len - 1 );
      ObjSet( ted_name, { text = text_cut } );
    end;

  end;
  --******************************************************************************************
  function private.keyboard.Space()

    private.keyboard.key.Down( "4_3", " " );

  end;
  --******************************************************************************************
  function private.keyboard.but.MouseEnter()

    SetCursor( CURSOR_HAND );
    ObjSet( "spr_cheater_console_keyboard", { color_r = 0 } );

  end;
  --******************************************************************************************
  function private.keyboard.but.MouseLeave()

    SetCursor( CURSOR_DEFAULT );
    ObjSet( "spr_cheater_console_keyboard", { color_r = 0.9 } );

  end;
  --******************************************************************************************
  private.keyboard.key = {};
  --******************************************************************************************
  function private.keyboard.key.Down( pos, newsymbol )

    local ted_name = "ted_cheater_execute";
    local key_name = "txt_cheater_console_keyboard_keys_"..pos;
    local symbol = newsymbol or ObjGet( key_name ).text;

    ObjSet( ted_name, { text = ObjGet( ted_name ).text..symbol } );

    if ( private.keyboard.shift == "shift" ) then
      private.keyboard.ShiftDown();
    end;

  end;
  --******************************************************************************************
  function private.keyboard.key.MouseEnter( pos )

    SetCursor( CURSOR_HAND );
    ObjSet( "spr_cheater_console_keyboard_keys_"..pos, { color_r = 0 } );

  end;
  --******************************************************************************************
  function private.keyboard.key.MouseLeave( pos )

    SetCursor( CURSOR_DEFAULT );
    ObjSet( "spr_cheater_console_keyboard_keys_"..pos, { color_r = 1 } );

end;
--******************************************************************************************
-- function *** ROOMS *** () end;
--******************************************************************************************
  function private.GetRoomNames()

    return game.room_names;

  end;
  --******************************************************************************************
  function private.ShowRooms( p_column_shift )

    if ( not p_column_shift ) then

      private.column.room = 0;
      private.SetArrow( "left", "room", false );
      ObjSet( "cheater_room_names", { pos_x = 0 } );
      private.DetachColumn( "room" );

    end;

    local column_amount = p_column_shift or 0;
    local column_counter = column_amount;

    local room_idstart = column_amount * private.LINE_MAX_COUNT + 1;
    local room_names = private.GetRoomNames();
    local room_color = { ho = { color_b = 0.85, color_g = 1.00 }, 
                         mg = { color_b = 1.00, color_g = 0.85 }, 
                         rm = { color_b = 0.85, color_g = 0.85 }  };

    local arrow_param = false;
    --DbgTrace( "ShowRooms: start_room_id = "..start_room_id );

    for room_id = room_idstart, #room_names do

      local room_objname = room_names[ room_id ];

      if ( room_id > ( column_counter * private.LINE_MAX_COUNT ) ) then
        
        local column_counter_abs = private.COLUMN_MAX_COUNT + column_amount;
        
        if ( ( column_counter >= column_counter_abs ) and ( room_names[ room_id + 1 ] ) ) then

          --DbgTrace( "ShowRooms: break "..room_id );
          arrow_param = true;
          break;

        end;

        --DbgTrace( "ShowRooms: column_counter++ "..column_counter.." ( room_id = "..room_id.." )" );
        column_counter = column_counter + 1;
        local column_params = 
        {
           counter = column_counter,
           amount  = column_amount,
           type    = 'room'
        };
        private.CreateColumn( column_params );
          
      end;

      local room_name   = common.GetObjectPrefix( room_objname );
      local room_params = 
      {
          obj_num      = room_id
         ,type         = "room"
         ,column       = column_counter 
         ,text         = room_objname
         ,event_mdown  = function () cmn.GotoRoom( room_objname ); private.ButtonDown( "room" ) end
         ,event_menter = function () private.ButtonMouseEnter( "room", room_id ) end
         ,event_mleave = function () private.ButtonMouseLeave( "room", room_id ) end
         ,color_b      = room_color[ room_name ][ "color_b" ]
         ,color_g      = room_color[ room_name ][ "color_g" ]
      };
      private.CreateRecord( room_params );
      
    end;

    private.SetArrow( "right", "room", arrow_param );

  end
--******************************************************************************************
-- function *** BUTTONS *** () end;
--******************************************************************************************
  function private.InitButtons()

    ObjSet( "spr_cheater_but", { event_mdown = private.ButDown,
                                 event_menter = private.ButMouseEnter,
                                 event_menter = private.ButMouseLeave  } );

    ObjSet( "cheater_close", { event_mdown = private.Close } );

    ObjSet( "spr_cheater_sound_back", {  event_mdown = private.SoundOnOff,
                                         event_menter = function () private.ButtonMouseEnter( "sound", "back" ); end,
                                         event_menter = function () private.ButtonMouseLeave( "sound", "back" ); end } );
    ObjSet( "spr_cheater_skip_back", { event_mdown = private.SkipVideo,
                                       event_menter = function () private.ButtonMouseEnter( "skip", "back" ); end,
                                       event_menter = function () private.ButtonMouseLeave( "skip", "back" ); end } );
    ObjSet( "spr_cheater_mode_back", { event_mdown = private.ChangeMode,
                                       event_menter = function () private.ButtonMouseEnter( "mode", "back" ); end,
                                       event_menter = function () private.ButtonMouseLeave( "mode", "back" ); end } );


    ObjSet( "spr_cheater_progress_back", { event_mdown = function () private.ButtonDown( "progress" ); end,
                                           event_menter = function () private.ButtonMouseEnter( "progress", "back" ); end,
                                           event_menter = function () private.ButtonMouseLeave( "progress", "back" ); end  } );
    ObjSet( "spr_cheater_progress_step", { event_mdown = private.ProgressStep,
                                           event_menter = function () private.ButtonMouseEnter( "progress", "step" ); end,
                                           event_menter = function () private.ButtonMouseLeave( "progress", "step" ); end  } );
    ObjSet( "spr_cheater_progress_check_back", { event_mdown = private.ProgressCheckDown,
                                           event_menter = function () private.ButtonMouseEnter( "progress_check", "back" ); end,
                                           event_menter = function () private.ButtonMouseLeave( "progress_check", "back" ); end  } );
    ObjSet( "obj_cheater_progress_arrow_left", {  event_mdown = function () private.MoveList( "left", "progress" ); end,
                                              event_menter = function () SetCursor( CURSOR_LEFT ); end,
                                              event_menter = function () SetCursor( CURSOR_DEFAULT ) end  } );
    ObjSet( "obj_cheater_progress_arrow_right", {  event_mdown = function () private.MoveList( "right", "progress" ); end,
                                              event_menter = function () SetCursor( CURSOR_LEFT ); end,
                                              event_menter = function () SetCursor( CURSOR_DEFAULT ) end  } );

    ObjSet( "spr_cheater_room_back", { event_mdown = function () private.ButtonDown( "room" ); end,
                                       event_menter = function () private.ButtonMouseEnter( "room", "back" ); end,
                                       event_menter = function () private.ButtonMouseLeave( "room", "back" ); end  } );
    ObjSet( "obj_cheater_room_arrow_left", {  event_mdown = function () private.MoveList( "left", "room" ); end,
                                              event_menter = function () SetCursor( CURSOR_LEFT ); end,
                                              event_menter = function () SetCursor( CURSOR_DEFAULT ) end  } );
    ObjSet( "obj_cheater_room_arrow_right", {  event_mdown = function () private.MoveList( "right", "room" ); end,
                                              event_menter = function () SetCursor( CURSOR_LEFT ); end,
                                              event_menter = function () SetCursor( CURSOR_DEFAULT ) end  } );

    ObjSet( "spr_cheater_execute_back", {  event_mdown = function () private.ButtonDown( "execute" ); end,
                                           event_menter = function () private.ButtonMouseEnter( "execute", "back" ); end,
                                           event_menter = function () private.ButtonMouseLeave( "execute", "back" ); end  } );
    ObjSet( "spr_cheater_console_clear", { event_mdown = private.ConsoleClearDown,
                                           event_menter = function () private.ButtonMouseEnter( "console", "clear" ); end,
                                           event_menter = function () private.ButtonMouseLeave( "console", "clear" ); end  } );
    ObjSet( "spr_cheater_console_keyboard", {  event_mdown = private.keyboard.but.Down,
                                               event_menter = private.keyboard.but.MouseEnter,
                                               event_menter = private.keyboard.but.MouseLeave  } );

    ObjSet( "ted_cheater_execute", { trg_enter = private.ReviewTextEditingDone  } );
    ObjSet( "ted_cheater_default_review_field_text", { trg_enter = private.ReviewTextEditingDone  } );
    ObjSet( "obj_cheater_default_review_field", { event_mdown = private.ReviewMark  } );

  end;
  --******************************************************************************************
  function private.ButDown()

    ObjSet( "txt_cheater_current_version", { text = "ver: "..GetEngineVersion().." / "..(ConfigGetProjectVersion() or "unknown" ) } );
    
    private.ShowFPS( not ObjGet( "tmr_cheater_fps" ).playing );

    local button_params = { in_menu = { progress = false, room = false, execute = true },
                            in_game = { progress = true, room = true, execute = true } };
    local button_index  = "in_game";
    if ( cmn.is_inmenunow ) then
      button_index  = "in_menu";
    end;

    for key in pairs( button_params[ button_index ] ) do
      ObjSet( "cheater_"..key, { 
        input   = button_params[ button_index ][ key ],
        visible = button_params[ button_index ][ key ] } );
    end;

  end;
  --******************************************************************************************
  function private.ButtonDown( selected_button_name )

    --ObjSet( "cheater_progress_step", { visible = true, input = true } );
    local button_funcs = { room = private.ShowRooms, progress = private.ShowProgress, execute = private.ShowConsole };

    for key in pairs( button_funcs ) do

      local list_name  = "cheater_"..key.."_list";
      local list_param = false;
      
      if ( selected_button_name == key ) then

        list_param = not ObjGet( list_name ).visible;
        ObjSet( "cheater_close", { input = list_param } );
        if ( list_param ) then
          button_funcs[ selected_button_name ]();
        end;

      end;

      ObjSet( list_name, { visible = list_param, input = list_param, color_g = list_param } );
      ObjSet( "spr_cheater_"..key.."_back", { color_b = common.ConditionChoose( list_param == 1, 0, 1 ) } );

    end;

  end;
  --******************************************************************************************
  function private.Close()

    local keys = { "room", "progress", "execute" };
    for key, value in pairs( keys ) do
    
      local list_name  = "cheater_"..value.."_list";
      if ( ObjGet( list_name ).visible ) then
        private.ButtonDown( value );
        break;
      end;
    end;

  end;
  --******************************************************************************************
  function private.ButtonMouseEnter( button_part, button_name )

    SetCursor( CURSOR_HAND );
    ObjSet( "spr_cheater_"..button_part.."_"..button_name, { color_r = 0 } );

  end;
  --******************************************************************************************
  function private.ButtonMouseLeave( button_part, button_name )

    SetCursor( CURSOR_DEFAULT );
    local color_r = 0.9;
    if ( button_name ~= "back" ) then color_r = 1; end;
    ObjSet( "spr_cheater_"..button_part.."_"..button_name, { color_r = color_r } );

  end;
  --******************************************************************************************
  function private.ButMouseEnter()

    if ( not ObjGet( "cheater_content" ).visible ) then
      ObjSet( "spr_cheater_but", { alp = 1 } );
    end;
    SetCursor(CURSOR_HAND);

  end;
  --******************************************************************************************
  function private.ButMouseLeave()

    if ( not ObjGet( "cheater_content" ).visible ) then
      ObjSet( "spr_cheater_but", { alp = 0 } );
    end;
    SetCursor(CURSOR_DEFAULT)

  end;
  --******************************************************************************************
  function private.HeightChange()

    local param = { wide = 30, custom = 10 };

    local need = "custom";
    if ( private.is_ipad ) then
      need = "wide";
    end;

    local buttons = { "room_back", "progress_back", "execute_back" };

    for but_key, but_name in pairs( buttons ) do

      ObjSet( "spr_cheater_"..but_name, { scale_y = param[ need ] } );
      ObjSet(     "cheater_"..but_name, {   pos_y = param[ need ] } );

    end;  

    buttons = { "progress_check", "console_clear", "console_keyboard" };

    for but_key, but_name in pairs( buttons ) do

      ObjSet( "spr_cheater_"..but_name, { scale_y = param[ need ] } );
      ObjSet(     "cheater_"..but_name, {   pos_y = (-1)*param[ need ] - 10 } );

    end;  

    ObjSet( "spr_cheater_but", { scale_y = param[ need ]
                                  ,pos_y   = param[ need ]        } );
    ObjSet( "cheater_buttons", { pos_y   = param[ need ] - 10   } );

    ObjSet( "cheater_execute_list",   { pos_y = ( param[ need ] + 10 ) } );
    ObjSet( "cheater_room_list",      { pos_y = ( param[ need ] + 10 ) } );
    ObjSet( "cheater_progress_list",  { pos_y = ( param[ need ] + 10 ) } );

  end;
--******************************************************************************************
--function  *** LIST *** () end;
--******************************************************************************************
--obj_num - id / index_obj
--type - room / progress
--column = 
--text - room_name / progress_name
--event_mdown = 
--event_menter
--event_mleave
--color_b
--color_g
--******************************************************************************************
  function private.CreateRecord( record ) 

        local txtf = record.text
        local add_cube = 0;
        local complex_mark = false

          --complex item
          if ld and ld.StringDivide then
            local div = ld.StringDivide( txtf )
            if div[ 1 ] == "get" and #div == 2 and ObjGet( "inv_complex_"..div[ 2 ] ) then
              complex_mark = true
            end
          end

          --mul Use
          local inv = private.HINT_ROOT[ txtf ] and private.HINT_ROOT[ txtf ].inv_obj or false
          if inv then
            local c = 0
            for k,v in pairs( private.HINT_ROOT ) do
              if v.inv_obj == inv then
                c = c + 1;
                if c >= 2 then
                  record.text = "M"..record.text
                  add_cube = add_cube + 1
                  break
                end;
              end;
            end;
          end;

          if common_impl and common_impl.NumberFromString then
            --mul Get
            if txtf:find( "^get" ) and private.HINT_ROOT[ txtf ] and not private.HINT_ROOT[ txtf ].inv_obj then
              local num = common_impl.NumberFromString( txtf )
              --ld.LogTrace( txtf, num )
              if num then
                --ld.LogTrace( txtf, num, txtf:gsub( num.."$", "" ) )
                local c = 0
                for k,v in pairs( private.HINT_ROOT ) do
                  local num_next = common_impl.NumberFromString( k )
                  local inv_use = txtf:gsub( num.."$", "" ):gsub( "^get", "inv" )
                  if  num_next 
                  and txtf:gsub( num.."$", "" ) == k:gsub( num_next.."$", "" ) 
                  and ld.TableContains( private.HINT_ROOT, inv_use )
                  then
                    c = c + 1;
                    if c >= 2 then
                      record.text = "M"..record.text
                      add_cube = add_cube + 1
                      --ld.LogTrace( inv_use )
                      break
                    end;
                  end;
                end;
              end;
            end
          end

        if private.HINT_ROOT[ txtf ] and private.HINT_ROOT[ txtf ].room == "inv_complex_inv" then
          record.text = "D"..record.text
          add_cube = add_cube + 1
        --end;
        end
        if private.HINT_ROOT[ txtf ] and private.HINT_ROOT[ txtf ].room == "int_diary" then
          record.text = "*"..record.text
          add_cube = add_cube + 1
        end;
        

        

      local new_pos_y   = 0;
      local record_name = "cheater_"..record.type.."_"..record.obj_num;
      local column_name = "cheater_"..record.type.."_column_"..record.column;
      local txt_params  = {};
      local spr_params  = {};
      
      new_pos_y = ( ( record.obj_num - 1 ) - ( record.column - 1 )*private.LINE_MAX_COUNT ) * 20;
    
      txt_params.pos_y        = new_pos_y;
      txt_params.text        = record.text;
        txt_params.color_r     = record and record.text_r or 0;
        txt_params.color_g     = record and record.text_g or 0;
        txt_params.color_b     = record and record.text_b or 0;

      spr_params.pos_y        = new_pos_y;
      spr_params.event_mdown  = record.event_mdown;
      spr_params.event_menter = record.event_menter;
      spr_params.event_mleave = record.event_mleave;

      spr_params.color_r      = record.color_r;
      spr_params.color_g      = record.color_g;
      spr_params.color_b      = record.color_b;


      if ( not ObjGet( "spr_"..record_name ) ) then

        ObjCreate( "txt_"..record_name, "text" );
        ObjCreate( "spr_"..record_name, "spr" );

        txt_params.res = "assets/shared/cheater/courier_new";
        txt_params.fontsize    = 12;
        txt_params.align       = 0;
        txt_params.disprawtext = 1;
        txt_params.pos_x       = -80

        txt_params.visible     = true; 
        txt_params.input       = false; 
        txt_params.active      = false;

        spr_params.res = "assets/shared/cheater/editor_back";
        spr_params.scale_x = 80;
        spr_params.scale_y = 10;
        spr_params.visible = true; 
        spr_params.alp     = 1;
        spr_params.input   = true;
        spr_params.active  = false;

          ObjCreate( "spr_"..record_name.."_dm", "spr")
          ObjSet( "spr_"..record_name.."_dm", { res = "assets/shared/cheater/editor_back", pos_x = -0.98 + add_cube * 0.05, color_r = 0.65,color_g = 0.65,color_b = 1, input = 0,scale_x = 1/21*add_cube, scale_y = 1, alp = 0 } )
          ObjAttach( "spr_"..record_name.."_dm", "spr_"..record_name )

          ObjCreate( "obj_"..record_name.."_complex", "obj")
          ObjAttach( "obj_"..record_name.."_complex", "spr_"..record_name )

          ObjCreate( "spr_"..record_name.."_complex_d", "spr")
          ObjSet( "spr_"..record_name.."_complex_d", { res = "assets/shared/cheater/editor_back", pos_x = 0, pos_y = 0.85, color_r = 0.25,color_g = 0.25,color_b = 0.25, input = 0,scale_x = 1, scale_y = 0.15, alp = 1 } )
          ObjAttach( "spr_"..record_name.."_complex_d", "obj_"..record_name.."_complex" )
          ObjCreate( "spr_"..record_name.."_complex_u", "spr")
          ObjSet( "spr_"..record_name.."_complex_u", { res = "assets/shared/cheater/editor_back", pos_x = 0, pos_y = -0.85, color_r = 0.25,color_g = 0.25,color_b = 0.25, input = 0,scale_x = 1, scale_y = 0.15, alp = 1 } )
          ObjAttach( "spr_"..record_name.."_complex_u", "obj_"..record_name.."_complex" )
          ObjCreate( "spr_"..record_name.."_complex_r", "spr")
          ObjSet( "spr_"..record_name.."_complex_r", { res = "assets/shared/cheater/editor_back", pos_x = 0.98, pos_y = 0, color_r = 0.25,color_g = 0.25,color_b = 0.25, input = 0,scale_x = 0.02, scale_y = 0.9, alp = 1 } )
          ObjAttach( "spr_"..record_name.."_complex_r", "obj_"..record_name.."_complex" )
          ObjCreate( "spr_"..record_name.."_complex_l", "spr")
          ObjSet( "spr_"..record_name.."_complex_l", { res = "assets/shared/cheater/editor_back", pos_x = -0.98, pos_y = 0, color_r = 0.25,color_g = 0.25,color_b = 0.25, input = 0,scale_x = 0.02, scale_y = 0.9, alp = 1 } )
          ObjAttach( "spr_"..record_name.."_complex_l", "obj_"..record_name.."_complex" )

      end;

      ObjSet( "txt_"..record_name, txt_params );
      ObjSet( "spr_"..record_name, spr_params );

      if add_cube > 0 then
        ObjSet( "spr_"..record_name.."_dm", { alp = 1, pos_x = -0.98 + add_cube * 0.05, scale_x = 1/21*add_cube } )
      else
        ObjSet( "spr_"..record_name.."_dm", { alp = 0 } )
      end;
      if complex_mark then
        ObjSet( "obj_"..record_name.."_complex", { alp = 1 } )
      else
        ObjSet( "obj_"..record_name.."_complex", { alp = 0 } )
      end;

      ObjAttach( "spr_"..record_name, column_name );
      ObjAttach( "txt_"..record_name, column_name );

  end;
  --******************************************************************************************
  function private.DetachColumn( param0, param1 ) 

    local column_name_temp = "cheater_%s_column_%i";

    if ( param1 ) then

      local column_shifted_amount  = private.column[ param0 ];
      local column_num = column_shifted_amount; 

      if ( param1 == 'left' ) then
        column_num = column_num + private.COLUMN_MAX_COUNT + 1;
      end;

      local column_name = string.format( column_name_temp, param0, column_num );

      ObjDetach( column_name );

    else
      
      local counter = private.COLUMN_MAX_COUNT;
      local column_name = string.format( column_name_temp, param0, counter );

      while ( ObjGet( column_name ) and ObjGet( column_name ).name ) do

        ObjDetach( column_name );
        counter = counter + 1;
        column_name = string.format( column_name_temp, param0, counter);

      end

    end;

  end;
  --******************************************************************************************
  function private.CreateColumn( column ) 

    local hub_name    = string.format( "cheater_%s_names", column.type );
    local column_numb = column.counter;    
    local column_name = string.format( "cheater_%s_column_%i", column.type, column_numb );
    local column_posx = private.RECORD_WIDTH * ( column.counter - 1 );

    if ( not ObjGet( column_name ) ) then
      ObjCreate( column_name, "obj" );
    end;

    ObjSet( column_name, 
    {
      pos_x  = column_posx,
      active = 0
    } );

    ObjAttach( column_name,  hub_name );

  end;
  --******************************************************************************************
  function private.SetArrow( side, name_part, param )

    local arrow_name  = string.format( "obj_cheater_%s_arrow_%s", name_part, side );
    ObjSet( arrow_name,
      {
          input       = param
         ,visible     = param
      } );

  end;
  --******************************************************************************************
  function private.MoveList( side, type )

    --DbgTrace( "MoveList: Moving "..side..". " );

    local direction = { right = 1, left = -1 };
    local show_func = { room = private.ShowRooms, progress = private.ShowProgress }

    private.column[ type ] = private.column[ type ] + direction[ side ];
    local column_shift = private.column[ type ];

    show_func[ type ]( column_shift );

    local hub = string.format( "cheater_%s_names", type );
    ObjSet( hub, 
    {
      pos_x = ( - 1 ) * private.RECORD_WIDTH * column_shift
    } );

    private.DetachColumn( type, side );

    private.SetArrow( "left", type, ( column_shift ~= 0 ) );

  end;
--******************************************************************************************
--function *** OPTIONS ***() end;
--******************************************************************************************
  function private.ChangeMode() 

    private.is_ipad = not private.is_ipad;
    private.HeightChange();

  end;
  --******************************************************************************************
  function private.SkipVideo() 

    if ( _G[ "int_dialog_video" ] ) then
      
      if ObjGet("int_dialog_video").input then -- если играет видео
        int_dialog_video.SkipClick();
      end

    end;

  end;
  --******************************************************************************************
  private.sound = { sfx = 0, env = 0, soundtrack = 0, voice = 0 };
  private.sound.is_on = true;
  --******************************************************************************************
  function private.SoundOnOff()

    private.sound.is_on = not private.sound.is_on;

    for type, value in pairs( private.sound ) do

      if ( private.sound.is_on ) then
        value = 0.7;
      else
        value = 0;
      end;
      SetSoundVolume( type, value );
    
    end;  

  end
  --******************************************************************************************
  function private.ControlButtons( options )

    local buttons = 
      { 
        mode = "cheater_mode", 
        skip = "cheater_skip", 
        sound = "cheater_sound" 
      };
    local popups  = 
      { 
        mode = "Change cheater buttons height", 
        skip = "Skip video", 
        sound = "Enable or disable sounds" 
      };
    for option, value in pairs( options ) do

      local option_name = string.format( "spr_%s_back", buttons[ option ] );
      local option_params = ObjGet( option_name );
      local color = value / 2 + 0.5;
      local events = { enter = option_params.event_menter, leave = option_params.event_mleave };
      if ( value == 0 ) then
        events.enter = "";
        events.leave = "";
        popups[ option ] = popups[ option ].." ( disabled ) ";
      end;
      ObjSet( option_name, 
        { 
          color_r = color,
          color_g = color,
          color_b = color
          --event_menter = events.enter.."interface.PopupShow( '"..popups[ option ].."' );",
          --event_mleave = events.leave.."interface.PopupHide();"
        } );

    end;

  end;
--******************************************************************************************
--function *** REVIWEW ***() end;
--******************************************************************************************
  function private.InitReviewMode()
    private.default = {};

    private.default.review_field = common.GetObjParamsForSet( "obj_cheater_default_review_field" );

    private.default.review_field_mark = common.GetObjParamsForSet( "spr_cheater_default_review_field_mark" );
    private.default.review_field_text = common.GetObjParamsForSet( "ted_cheater_default_review_field_text" );
    private.default.review_field_back = common.GetObjParamsForSet( "spr_cheater_default_review_field_back" );
    private.default.review_field_link = common.GetObjParamsForSet( "grd_cheater_default_review_field_link" );

    private.reviewmode_enabled = false;

    private.review_mark_count = 0;

    private.review_mark_dragged = nil;
    private.review_back_dragged = nil;
  end;
  --******************************************************************************************
  function private.ReviewMode()

    if not ( private.reviewmode_enabled ) then

      private.reviewmode_enabled = true;

      ObjSet( "ng_level", { active = 0 } );

      ObjCreate( "obj_cheater_review_field", "obj" );

      ObjSet( "obj_cheater_review_field", private.default.review_field );
      ObjAttach( "obj_cheater_review_field", "ng_application" );

      ObjAttach( "txt_cheater_review_field", "obj_cheater_review_field" );

      ObjAnimate( "txt_cheater_review_field", "alp", 1, 0, "",
      {
        0.0, 3, 0.5,
        1.5, 3, 1.0,
        3.0, 3, 0.5
      } );

    else

      if ( private.review_text_editing ) then

        private.ReviewTextEditingDone();

      end;

      MsgSubscribe( Event_Level_ScreenshotSaved, private.ReleaseReview );
      MsgSend( Event_Level_CheaterSaveScreenshot );

    end;

  end;
  --******************************************************************************************
  function private.ReviewMark()

    if not ( private.review_text_editing ) then

      private.review_mark_count = private.review_mark_count + 1;
      local current_num = private.review_mark_count;

      local cur_pos = GetZoomCursorPos();
      -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
      local mark_object = "spr_cheater_review_field_mark_"..private.review_mark_count;
      local mark_params = private.default.review_field_mark;

      mark_params.pos_x = cur_pos[ 1 ];
      mark_params.pos_y = cur_pos[ 2 ];

      mark_params.event_startdrag = function () private.ReviewMarkDragStart( current_num ); end;
      mark_params.event_drag      = function () private.ReviewMarkDrag( current_num ); end;
      mark_params.event_dragdrop  = function () private.ReviewMarkDrop( current_num ); end;

      ObjCreate( mark_object, "spr" );
      ObjSet( mark_object, mark_params );
      ObjAttach( mark_object, "obj_cheater_review_field" );

      ObjAnimate( mark_object, "color_rgb", 1, 0, "",
      {
        0.0, 3, 1, 0, 0,
        0.3, 3, 1, 1, 1,
        0.6, 3, 1, 0, 0
      } );
      -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
      local back_object = "spr_cheater_review_field_back_"..private.review_mark_count;
      local back_params = private.default.review_field_back;

      back_params.pos_x = 150 + 36 + mark_params.pos_x;
      back_params.pos_y = mark_params.pos_y;

      if ( mark_params.pos_x > 512 ) then

        back_params.pos_x = - 150 - 36 + mark_params.pos_x;

      end;

      back_params.event_startdrag = function () private.ReviewBackDragStart( current_num ); end;
      back_params.event_drag      = function () private.ReviewBackDrag( current_num ); end;
      back_params.event_dragdrop  = function () private.ReviewBackDrop( current_num ); end;

      ObjCreate( back_object, "spr" );
      ObjSet( back_object, back_params );
      ObjAttach( back_object, "obj_cheater_review_field" );
      -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
      local text_object = "ted_cheater_review_field_text_"..private.review_mark_count;
      local text_params = private.default.review_field_text;

      text_params.pos_x = 150 + 36 + mark_params.pos_x;
      text_params.pos_y = mark_params.pos_y;

      if ( mark_params.pos_x > 512 ) then

        text_params.pos_x = - 150 - 36 + mark_params.pos_x;

      end;

      ObjCreate( text_object, "textedit" );
      ObjSet( text_object, text_params );
      ObjAttach( text_object, "obj_cheater_review_field" );
      -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
      local link_object = "grd_cheater_review_field_link_"..private.review_mark_count;
      local link_params = private.default.review_field_link; 

      ObjCreate( link_object, "grid" );
      ObjSet( link_object, link_params );
      ObjAttach( link_object, "obj_cheater_review_field" );

      private.ReviewLinkUpdatePos( private.review_mark_count );
      -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 
      private.review_text_editing = true;

      local timer_object = "tmr_cheater_review_field_text_"..private.review_mark_count;

      ObjCreate( timer_object, "timer" );
      ObjAttach( timer_object, "obj_cheater_review_field" );
      ObjSet( timer_object, { time = 0.01, endtrig = private.ReviewBackUpdate, playing = true } );
      -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- 

    end;

  end;
  --******************************************************************************************
  function private.ReviewBackUpdate()

    if ( private.review_text_editing ) then

      local text_object = "ted_cheater_review_field_text_"..private.review_mark_count;
      local text_params = ObjGet( text_object );

      local back_object = "spr_cheater_review_field_back_"..private.review_mark_count;
      ObjSet( back_object, { scale_y = ( text_params.draw_height / 64 ) } );

      local timer_object = "tmr_cheater_review_field_text_"..private.review_mark_count;
      ObjSet( timer_object, { time = 0.01, endtring = private.ReviewBackUpdate, playing = true } );

    end;

  end;
  --******************************************************************************************
  function private.ReviewTextEditingDone()
    
    if not private.review_text_editing then

      --КОСТЫЛЬ для работы консоли
      local txt = ObjGet( "ted_cheater_execute" ).text
      ObjSet( "ted_cheater_execute", { event_startdrag = txt } ) 
      local func = ObjGet( "ted_cheater_execute" ).event_startdrag;
      if func then
        func();
      else
        ld.LogTrace( "ERROR console can't execute '"..txt.."'" )
      end;

    else

      private.review_text_editing = false;

      local timer_object = "tmr_cheater_review_field_text_"..private.review_mark_count;
      ObjDelete( timer_object );

      local text_object = "ted_cheater_review_field_text_"..private.review_mark_count;
      local text_params = common.GetObjParamsForSet( text_object );
      ObjDelete( text_object );

      local mark_object = "spr_cheater_review_field_mark_"..private.review_mark_count;
      local back_object = "spr_cheater_review_field_back_"..private.review_mark_count;
      local link_object = "grd_cheater_review_field_link_"..private.review_mark_count;

      if ( text_params.text == "" ) then

        ObjDelete( mark_object );
        ObjDelete( back_object );
        ObjDelete( link_object );

      else

        local mark_params = ObjGet( mark_object );
        
        ObjAnimate( mark_object, "color_rgb", 0, 0, "",
        {
          0.0, 3, mark_params.color_r, mark_params.color_g, mark_params.color_b,
          0.3, 3, 1, 0, 0
        } );

        ObjSet( mark_object, { input = true } );
        ObjSet( back_object, { input = true } );

        -- Создание нового.
        text_object = "txt_cheater_review_field_text_"..private.review_mark_count;
        ObjCreate( text_object, "text" );
        text_params.input = false;
        ObjSet( text_object, text_params );
        ObjAttach( text_object, "obj_cheater_review_field" );

      end;

    end

  end;
  --******************************************************************************************
  function private.ReviewMarkDragStart( id )

    SetCursor( CURSOR_NULL );

    private.review_mark_dragged = id;

  end;
  --******************************************************************************************
  function private.ReviewMarkDrag( id )

    local cur_pos = GetZoomCursorPos();

    local new_x = cur_pos[ 1 ];
    local new_y = cur_pos[ 2 ];

    local mark_object = "spr_cheater_review_field_mark_"..id;

    ObjSet( mark_object, { pos_x = new_x, pos_y = new_y } );

    private.ReviewLinkUpdatePos( id );

  end;
  --******************************************************************************************
  function private.ReviewMarkDrop( id )

    SetCursor( CURSOR_DEFAULT );

    private.review_mark_dragged = nil;

  end;
  --******************************************************************************************
  function private.ReviewBackDragStart( id )

    SetCursor( CURSOR_NULL );

  end;
  --******************************************************************************************
  function private.ReviewBackDrag( id )

    local cur_pos = GetZoomCursorPos();

    local new_x = cur_pos[ 1 ];
    local new_y = cur_pos[ 2 ];

    local back_object = "spr_cheater_review_field_back_"..id;
    local text_object = "txt_cheater_review_field_text_"..id;

    ObjSet( back_object, { pos_x = new_x, pos_y = new_y } );
    ObjSet( text_object, { pos_x = new_x, pos_y = new_y } );

    private.ReviewLinkUpdatePos( id );

  end;
  --******************************************************************************************
  function private.ReviewBackDrop( id )

    SetCursor( CURSOR_DEFAULT );

  end;
  --******************************************************************************************
  function private.ReviewLinkUpdatePos( id )

    local mark_object = "spr_cheater_review_field_mark_"..id;
    local mark_params = ObjGet( mark_object );

    local back_object = "spr_cheater_review_field_back_"..id;
    local back_params = ObjGet( back_object );

    local angle = math.atan( ( back_params.pos_y - mark_params.pos_y ), ( back_params.pos_x - mark_params.pos_x ) );

    -- Право.
    if     ( angle >= - 0.785 ) and ( angle <   0.785 ) then

      mark_params.pos_x = mark_params.pos_x + 0.5 * 64 * mark_params.scale_x;

      back_params.pos_x = back_params.pos_x - 150;

    -- Верх.
    elseif ( angle >= - 2.355 ) and ( angle < - 0.785 ) then

      mark_params.pos_y = mark_params.pos_y - 0.5 * 64 * mark_params.scale_y;

      back_params.pos_y = back_params.pos_y + 0.5 * 64 * back_params.scale_y;

    -- Низ.
    elseif ( angle >=   0.785 ) and ( angle <   2.355 ) then

      mark_params.pos_y = mark_params.pos_y + 0.5 * 64 * mark_params.scale_y;

      back_params.pos_y = back_params.pos_y - 0.5 * 64 * back_params.scale_y;

    -- Лево.
    elseif ( ( angle >=   2.355 ) and ( angle <   3.142 ) )
    or     ( ( angle >= - 3.142 ) and ( angle < - 2.355 ) ) then

      mark_params.pos_x = mark_params.pos_x - 0.5 * 64 * mark_params.scale_x;

      back_params.pos_x = back_params.pos_x + 150;

    end;

    angle = math.atan( ( back_params.pos_y - mark_params.pos_y ), ( back_params.pos_x - mark_params.pos_x ) );

    -- Половина высоты ресурса линка.
    local radius = 9;

    local point0 = { pos_x = mark_params.pos_x + radius * math.cos( - 1.57 + angle ),
                     pos_y = mark_params.pos_y + radius * math.sin( - 1.57 + angle ) };

    local point2 = { pos_x = mark_params.pos_x + radius * math.cos(   1.57 + angle ),
                     pos_y = mark_params.pos_y + radius * math.sin(   1.57 + angle ) };

    local point1 = { pos_x = back_params.pos_x + radius * math.cos( - 1.57 + angle ),
                     pos_y = back_params.pos_y + radius * math.sin( - 1.57 + angle ) };

    local point3 = { pos_x = back_params.pos_x + radius * math.cos(   1.57 + angle ),
                     pos_y = back_params.pos_y + radius * math.sin(   1.57 + angle ) };

    local link_object = "grd_cheater_review_field_link_"..id;
    GridSet( link_object, 0,
    {
      0, point0,
      2, point2,
      1, point1,
      3, point3,
    } );

  end;
  --******************************************************************************************
  function private.ReviewMarkUp()

    if ( private.review_mark_dragged ) then

      local mark_object = "spr_cheater_review_field_mark_"..private.review_mark_dragged;
      local mark_params = ObjGet( mark_object );

      local scale_new = mark_params.scale_x + 0.1;

      ObjSet( mark_object, { scale_x = scale_new, scale_y = scale_new } );

    end;

  end;
  --******************************************************************************************
  function private.ReviewMarkDown()

    if ( private.review_mark_dragged ) then

      local mark_object = "spr_cheater_review_field_mark_"..private.review_mark_dragged;
      local mark_params = ObjGet( mark_object );

      local scale_new = mark_params.scale_x - 0.1;

      ObjSet( mark_object, { scale_x = scale_new, scale_y = scale_new } );

    end;

  end;
  --******************************************************************************************
  function private.ReleaseReview()  

    MsgUnsubscribe( Event_Level_ScreenshotSaved, private.ReleaseReview );
    private.reviewmode_enabled = false;
    ObjDetach( "txt_cheater_review_field" );
    ObjDelete( "obj_cheater_review_field" );
    ObjSet( "ng_level", { active = true } );
    private.text_editing = false;

end;
--******************************************************************************************
-- function *** OTHER *** () end;
--******************************************************************************************
  function private.ShowFPS( playing_value )

    ObjSet( "txt_cheater_current_fps", { text = string.format( "fps: %.1f; draws: %d;", GetFPS(), ne.GetNumDrawCalls() ) } );
    ObjSet( "tmr_cheater_fps",     { playing = playing_value, time = 0.2, endtrig = function () private.ShowFPS( playing_value ); end } );

  end;
  --******************************************************************************************
  function private.HandleAltF1()

    private.onScreen = not private.onScreen;
    ObjSet("cheater",{ visible = private.onScreen, active = private.onScreen, input = private.onScreen } );

  end;
  --******************************************************************************************
  function private.WideScreenUpdate()

    --interface.WideScreenUpdate( "cheater" );

  end;
--******************************************************************************************

--******************************************************************************************
-- function *** CHEBOXARY *** () end;
--******************************************************************************************
function private.BotInit()
  
  --время ожидания после действия
  private.BOT_STEP_WAIT = private.BotGetConfigParam( "step_wait", "number" ) or 1.0;              

  --количество кликов подряд по объекту, после чего будут выполнены Fake клики
  private.BOT_CLICKS_BEFORE_FAKE = private.BotGetConfigParam( "clicks_before_fake", "number" ) or 4;

  --количество Fake кликов подряд по объекту, после чего будет пропущен прогрес ( вызов функции прогресса )
  private.BOT_CLICKS_BEFORE_STOP = private.BotGetConfigParam( "clicks_before_stop", "number" ) or 6;

  --количество проверок на заблокированность игры
  private.BOT_GAME_LOCK_CHECK_MAX = private.BotGetConfigParam( "game_lock_check_max", "number" ) or 100;

  --количество выполнения BotStep(), когда prg_next не изменяется, для определения "залипания" бота
  private.BOT_GAME_PRG_REPIATS_COUNT = private.BotGetConfigParam( "game_prg_repiats_count", "number" ) or 50;

  --количество кликов по зоне применения, до применения предмета
  private.BOT_USE_PLACE_CLICKS = private.BotGetConfigParam( "use_place_clicks", "number" ) or 0;

  --разрешить скипать пргоресс который не удалось завершить
  private.BOT_ALLOW_SKIP = private.BotGetConfigParam( "allow_skip", "bool" );

  --количество шагов бота между скриншотами, при значении <= 0 выключено 
  private.BOT_SCREENSHOT_STEPS_WAIT = private.BotGetConfigParam( "screenshot_steps_wait", "number" ) or 1;

  --жмём на хинт по возможности, переход в локации будет осуществлен телепортом хинта
  private.BOT_HINT_ON_STEP = private.BotGetConfigParam( "hint_on_step", "bool" );

  --время по истечении которого бот сделает скриншот после нажатия на кнопку хинт, при <0 выкл
  private.BOT_HINT_SCREENSHOT_TIME = private.BotGetConfigParam( "hint_screenshot_time", "number" ) or 0.75;

  --количество "троганий" объектов в сцене с включеным интпутом и наличием функции в event_mdown
  private.BOT_ALL_OBJS_TOUCH = private.BotGetConfigParam( "all_objs_touch", "number" ) or 1;

  --настройка скорости бота
  private.BOT_SPEED = private.BotGetConfigParam( "speed", "number" ) or 5;

  --настройка автостарта бот, с запуском указанного уровня, если <= 0 бот не запускается автоматически
  private.BOT_START = private.BotGetConfigParam( "start", "number" ) or 0;

  --ld.LogTrace( "BotInit", private.BOT_SPEED, private.BOT_START )
  --ld.LogTrace( "BotInit", ng.GetConfigInfo("bot.speed"), ng.GetConfigInfo("bot.start"), ng.GetConfigInfo("bot.xxx") )
  
  --ересь для нормального старта/остановки бота
  private.BotStartNow = false
  private.BotStepNow = false
  private.BotStepNowEnded = true


  ModLoad("assets/shared/cheater/mod_botcontroller_impl" );
  if botcontroller_impl then
    botcontroller_impl.Init()
  end

  if private.BOT_START > 0 then
    private.BotForceStart()
  end
end

  function private.BotGetConfigParam( param_name, param_type )
    param_type = param_type or "number"
    param_name = "bot."..param_name
    local param = ng.GetConfigInfo( param_name )
    if param == "" then
      return false
    else
      if param_type == "number" then
        return tonumber( param )
      elseif param_type == "string" then
        return tostring( param )
      elseif param_type == "bool" then
        return param == "true"
      end
    end
  end
--  local ld = {}
--
--  ld.LogTrace = function(...) 
--    local s = "";
--    for i = 1, #arg do
--      if #arg > 1 then
--        if type( arg[i] ) == "table" then
--          s = s.."\n"..tostring( arg[i] )..private.TableString( arg[i], "\t" ).."\n";
--        else
--          s = s..tostring( arg[i] ).."; ";
--        end;
--      else
--        if type( arg[i] ) == "table" then
--          s = s..private.TableString( arg[i], "\t" );
--        else
--          s = s..tostring( arg[i] );
--        end
--      end;
--    end;
--    DbgTrace( s );
--  end
--
--  private.TableString = function( t, space )
--    space = space or "";
--    local s = space
--    for k,v in pairs( t ) do
--      --local s = space
--      if type( v ) == "table" then
--        s = s.."\n"..space.."\t"..tostring(k).." :: "..tostring(v);
--        s = s..private.TableString( v, space.."\t" )
--      else
--        s = s.."\n\t"..space..tostring(k).." => "..tostring(v);
--      end;
--    end;
--    return s;
--  end;
--
--  ld.StringDivide = function(string, div)
--    div = "_" or div
--    local table = {}
--    local id = 1
--    local il = 1
--    for i = 1, string.len(string) do
--      if string.sub(string,i,i) == div then
--        table[id] = string.sub(string,il,i-1)
--        il = i+1
--        id = id + 1
--      end
--      if i == string.len(string) then
--        table[id] = string.sub(string,il,i)
--        il = i+1
--        id = id + 1
--      end
--    end
--    return table
--  end
--
--   ld.StartTimer = function( timer_name, time, endtrig )  --- 2 (time, endtrig) or 3 ( timer_name, time, endtrig )
--    if type(timer_name) == "number" then
--      time,endtrig = timer_name,time
--      repeat
--        timer_name = "tmr_global_temp_timer_"..math.random(1,10000)
--      until not ObjGet(timer_name)
--    end
--    local func_end = function() 
--      ObjDelete(timer_name); endtrig()
--    end
--    time = tonumber( time )
--    ObjCreate( timer_name, "timer" )
--    ObjAttach( timer_name, "ng_interface" )
--    ObjSet( timer_name, { time = time, endtrig =  func_end , playing = 1 } );
--  end
  function private.BotExceptionHandler( param )
    --обработка исключений в одном месте, для упрощённого обновления бота
    if param.caller == "BotTryGoTo" then

      if param.value == "mg_casket" and common.GetCurrentRoom() ~=  param.value then
        int_cube.MouseDown()
        return true
      end

    end

    --ничего не делали, возвращаем управвление боту
    return false;
  end
  function private.BotLog( string )
    --ld.LogTrace( "BotLog: "..string )
    DbgTrace( "BotLog: "..string )
  end
  --контролим авто запуск
  function private.BotForceStart()
    ObjAnimate( "ng_cheat_highlight", 7,0,0, function() 
      if not common.GetCurrentRoom() then
        ne.dbg.FireInputEvent( 0, 0, 0, 111 + private.BOT_START )

        --local profiles = GetProfileList();
        --for i = 1, #profiles do
        --  DeleteProfile( profiles[i] );
        --end;
        --ObjSet( "ted_dialog_addprofile", { text = "CHEATER", visible = true } );
        --common.dialog.profile.NewDown()
        --ObjSet( "ted_dialog_addprofile", { text = "CHEATER", visible = true } );
        --ObjAnimate( "ng_cheat_highlight", 7,0,0, function() 
        --  common.dialog.addprofile.Down()
        --  ObjAnimate( "ng_cheat_highlight", 7,0,0, function() 
        --    --ng_global.currentprogress = "std"
        --    local prg = ng_global.currentprogress;
        --    local level = ng_global.progress[ prg ].common.chapter;
        --    ng_global.progress[ prg ].common.gamestart = true;
        --    cmn.is_inmenunow = false;
        --    common.LevelSwitch( level );
        --  end, { 0,0,0, 0,0,0 } )
        --end, { 0,0,0, 0,0,0 } )

        --ObjSet( "ted_dialog_addprofile", { text = "CHEATER", visible = true } );
      else
        private.BotStart()
      end;
    end, { 0,0,0, 0.5,0,0 } )

  end
  function private.BotStart()

    --public.BotMouseDragDrop( {768,722}, {660,418} )
    --ld.LogTrace( ng.GetConfigInfo( "bot" ) )
    --ld.LogTrace( ng.GetConfigInfo( "bot.clicker" ) )
    --ld.LogTrace( ng.GetConfigInfo( "bot.clicker.win_casket1" ) )
    --ld.LogTrace( "clicker.win_casket1", private.BotGetConfigParam( "clicker.win_casket1", "string" ) )
    --ld.LogTrace( ne.file.IsExist( "assets/bot_comander.txt" ) )
    --ld.LogTrace( ne.file.GetFileText( "assets/bot_comander.txt" ) )
    --if 1 then return end

    if private.BotStartNow or private.BotStepNow then return end
    --private.BotLog( "BotStart" )

    if interface and interface.InventoryAutoHideSet then
      interface.InventoryAutoHideSet( false );
    end

    if level and level.TutorialDisable and game.tutorial_progress then
      level.TutorialDisable()
    end

    private.BotMakeGateConnections()
    private.BotClickLoggerChain = {}
    private.BotStepChain_log = {}
    private.BotInvObjShowed = false
    private.BotIsGameLocked_count = 0;
    private.BotTryUsePlaceClickNow = 0;
    private.BotStep_obj_in_transporter_steps = 0
    private.BotTryMakeScreenshot_stepCounter = 0

    private.BotTryTouch_touched = {}

    private.BotTryObjUse_activator = {}

    private.BotTryHint_lastPlace = false;
    private.BotTryHint_lastPrgName = false;

    private.BotStartNow = true
    ne.SetTestMode( 1, private.BOT_SPEED )
    ld.LogTrace( "BotStart", ne.GetTestMode(), common.GetCurrentRoom() )

    private.BotDisableObjDoNotDrop( true )

    private.BotStep()
  end
  --нужно чтобы не ломались инвентарные предметы
  function private.BotDisableObjDoNotDrop( bool )
    if not private.BotDisableObjDoNotDrop_cache then
      private.BotDisableObjDoNotDrop_cache = {
         --ObjDoNotDrop;
        int_inventory.InvSetDropable;
        ld.InvSetDropable;
        ObjStartDrag;
      }
    end
    if bool then
       --ObjDoNotDrop = function()  end;
      int_inventory.InvSetDropable = function()  end;
      ld.InvSetDropable = function()  end;
      ObjStartDrag = function()  end;
    else
       --ObjDoNotDrop = private.BotDisableObjDoNotDrop_cache[ 1 ];
      int_inventory.InvSetDropable = private.BotDisableObjDoNotDrop_cache[ 2 ];
      ld.InvSetDropable = private.BotDisableObjDoNotDrop_cache[ 3 ];
      ObjStartDrag = private.BotDisableObjDoNotDrop_cache[ 4 ];
    end
  end
  function private.BotStop()
    --int_inventory_impl.TempLock( false )
    private.BotLog( "BotStop" )
    private.BotStartNow = false
    private.BotMakeScreenshot()
    private.BotDisableObjDoNotDrop( false )
    ne.SetTestMode( 0 )
    if private.BOT_START > 0 then
      ne.dbg.Quit()
    end
  end
  --основная фя бота
  function private.BotStep()
    if not private.BotStartNow then
      private.BotStepNow = false
      return
    end
    private.BotStepNowEnded = false
    private.BotStepNow = true;

    if common.GetCurrentRoom() == "rm_outro" or common.GetCurrentRoom() == "rm_credits"
    or GetCurrentRoom() == "rm_outro" or GetCurrentRoom() == "rm_credits"
    then
      private.BotLog( "BotStep: игра кончилась, последний удачный шаг выполнен для прогресса '"..tostring( private.Bot_prg_previous ).."'" )
      private.BotStop()
      return
    end


    local gameLockedNow, gameLockChecks = private.BotIsGameLocked()
    if gameLockedNow then
      if gameLockChecks > private.BOT_GAME_LOCK_CHECK_MAX then
        if private.ExecuteLockHandler( private.Bot_prg_previous ) then
          private.BotStepWait()
        else
          private.BotLog( "BotStep: Игра заблокированна (BOT_GAME_LOCK_CHECK_MAX), последний выполненный прогресс "..private.Bot_prg_previous )
          private.BotStop()
          return
        end
      else
        --private.BotLog( "BotStep: Lock Now "..( private.Bot_prg_previous or "FIRST_STEP" ) )
        private.BotStepWait()
      end
    elseif private.ExecuteForceHandler( private.BotGetNextProgresName() ) then
      private.BotLog( "BotStep: ожидание ExecuteForceHandler для прогресса "..private.BotGetNextProgresName() )
      private.BotStepWait()
    elseif private.BotTryHint() then
      private.BotStepWait()
    elseif private.BotIsStepChainLocked( private.BotGetNextProgresName() ) then
      local gametStepChainLocked, gametStepChainLockeds = private.BotIsStepChainLocked( private.BotGetNextProgresName() )
      private.BotLog( "BotStep: бот залип на прогрессе (BOT_GAME_PRG_REPIATS_COUNT), последний выполненный прогресс "..private.Bot_prg_previous )
      private.BotStepSkip( private.BotGetNextProgresName() )
    elseif private.BotStep_obj_in_transporter_steps < 3 and private.BotIsAnyObjDraging() then
      -->> может возникнуть при  --ObjDoNotDrop и ObjStartDrag
      private.BotStep_obj_in_transporter_steps = private.BotStep_obj_in_transporter_steps + 1
      if private.BotStep_obj_in_transporter_steps >= 3 then
          private.BotLog( "BotTryObjClick >> ng_interface_transporter >> в руках бота предмет? предидущий прогресс >> '"..( private.Bot_prg_previous or "FALSE" ).."'" );
          private.BotMouseMove( { 9999; 9999; } )
          private.BotMouseUp( { 9999; 9999; } )
      end
      private.BotStepWait()
    else
      private.BotStep_obj_in_transporter_steps = 0
      local prg_next = private.BotGetNextProgresName();
      if prg_next then
        --private.BotLog( "BotStep >> "..prg_next.." >> "..common.GetCurrentRoom().." >> "..GetCurrentRoom() );
        local hnt = private.HINT_ROOT[ prg_next ]
        if hnt then
          if private.BotTryGoTo( hnt.zz or hnt.room ) then
            --ждем когда бот перейдет в нужное место
            private.BotStepWait()
          else
            if private.ExecuteActionHandler( prg_next ) then
              --если добавлен хендлер для прогресса, управление передаётся ему
              private.BotStepWait()
            elseif private.BotTryTouch() then
              --трогатель объектов
              private.BotStepWait()
            elseif hnt.type == "get" then
              if private.BotTryObjClick( hnt.get_obj ) then
                --бот пытается подобрать предмет, ждём
                private.BotStepWait()
              else
                --бот не смог подобрать предмет
                private.BotLog( "BotStep: не удалось подобрать предмет для прогресса "..prg_next )
                private.BotStepSkip( prg_next )
              end
            elseif hnt.type == "use" then
              if private.BotInvObjShow( hnt.inv_obj ) then
                if private.BotTryUsePlaceClick( hnt.use_place ) then
                  --бот кликает по зоне применения, ждём
                  private.BotStepWait()
                elseif private.BotTryObjUse( hnt.inv_obj, hnt.use_place ) then
                  --бот пытается применить предмет, ждём
                  private.BotStepWait()
                else
                  private.BotLog( "BotStep: не удалось применить предмет для прогресса "..prg_next )
                  private.BotStepSkip( prg_next )
                end
              else
                --ждём показа предмета в инвентаре
                private.BotStepWait()
              end
            elseif hnt.type == "click" then
              if prg_next:find( "^win_" ) then
                if private.BotTrySkipMg() then
                  --бот скипает mmg, ждём
                  private.BotStepWait()
                else
                  if private.BotTryObjClick( hnt.use_place ) then
                    --бот пытается кликнуть по зоне ммг, возможно она открывает зум ммг
                    private.BotStepWait()
                  else
                    private.BotLog( "BotStep: не удалось открыть/скипнуть ммг "..prg_next )
                    private.BotStepSkip( prg_next )
                  end
                end
              else
                if private.BotTryObjClick( hnt.use_place ) then
                  --бот пытается кликнуть по зоне клика, ждём
                  --private.BotLog( "BotStep: бот пытается кликнуть по зоне клика, ждём "..hnt.use_place )
                  private.BotStepWait()
                else
                  private.BotLog( "BotStep: не удалось кликнуть по зоне клика для прогресса "..prg_next )
                  private.BotStepSkip( prg_next )
                end
              end
            elseif hnt.type == "win" then
              if hnt.zz:find( "^ho_" ) then
                --бот скипает HO, ждём
                ne.dbg.FireInputEvent( 0,0,0, 32 );
                private.BotLock( 1 )
                ld.StartTimer( 1, function() 
                  private.BotLock( 0 )
                  private.BotMouseClick( { 512, 384 } )
                  private.BotStepWait()
                end )
              elseif hnt.zz:find( "^mg_" ) then
                if private.BotTrySkipMg() then
                  --бот скипает MG, ждём
                  private.BotStepWait()
                else
                  private.BotLog( "BotStep: не удалось cкипнуть мг "..prg_next )
                  private.BotStepSkip( prg_next )
                end
              else
                private.BotLog( "BotStep: неправильный тип хинта для ммг? "..prg_next )
                interface.DialogShow( "BotStep: неправильный тип хинта для ммг? "..prg_next );
                private.BotStop()
              end
            end
            private.BotTryMakeScreenshot()
          end
        elseif prg_next:find( "^opn_" ) then
          local go_to_room = prg_next:gsub( "^opn_", "rm_" )
          if private.BotTryGoTo( go_to_room ) then
            --ждем когда бот перейдет в нужное место
            private.BotStepWait()
          else
            private.BotLog( "BotStep: не удается пройти в "..go_to_room.." ("..prg_next..")" )
            private.BotStepSkip( prg_next )
          end
        else
          private.BotLog( "BotStep: не найден хинт для "..prg_next )
          private.BotStepSkip( prg_next )
        end
        private.Bot_prg_previous = prg_next;
      else
        private.BotLog( "прогресс для следующего шага не найден, последний удачный шаг выполнен для прогресса '"..tostring( private.Bot_prg_previous ).."'" )
        private.BotStop()
      end
    end
    private.BotStepNowEnded = true
  end

  function private.BotStepSkip( prg_skip )
    --здесь нужно отлавливать прогресс который,
    --который проходится нестандартно
    if private.ExecuteStackHandler( prg_skip ) then
      --функция хендлер тестеров, если хендлер знает что нужно делать
      --должна возвращать TRUE, бот будет ждать....
      private.BotStepWait()
    elseif private.BOT_ALLOW_SKIP then
      cmn.SetEventDone( prg_skip );
      cmn.CallEventHandler( prg_skip );
      private.BotLog( "BotStepSkip: програмное выполнение прогресса "..prg_skip )
      private.BotStepWait()
    else
      private.BotLog( "BotStepSkip: бот не смог выполнить '"..prg_skip.."' и был остановлен" )
      private.BotStop()
    end

  end
  --
  function private.BotStepWait()
    ld.StartTimer( private.BOT_STEP_WAIT, private.BotStep )
  end
  --
  function private.BotLock( state )
    ld.LockCustom( "bot_lock_now", state )
  end
  --zrm - 
  --нужно переделать/доделать, возможно отсутствие гейтов
  function private.BotGetConnectedZRM( zrm, room_step, checked, count )
    room_step = room_step or common.GetCurrentRoom()
    checked = checked or {}
    count = count or 0
    if zrm == room_step then
      return room_step
    else

      private.BotMakeZzGateConnections( zrm )
      private.BotMakeZzGateConnections( room_step )

      --ld.LogTrace( private.BotGateConnection )

      local connect = private.BotGateConnection[ room_step ]

    --ld.LogTrace( count, zrm, room_step, connect )

      for i = 1, #connect.childs do
        if not checked[ connect.childs[ i ] ] then
          checked[ connect.childs[ i ] ] = true
          if connect.childs[ i ] == zrm then
            --ld.LogTrace( "checked 1 "..count.." "..room_step )
            --table.insert( answer, room_step )
            return room_step
          else
            local child = private.BotGetConnectedZRM( zrm, connect.childs[ i ], checked, count + 1 )
            if child then
              --ld.LogTrace( "checked 2 "..count.." "..room_step )

              return child
            end
          end
        end
      end
      if connect.parent and not checked[ connect.parent ] then
        --ld.LogTrace( private.BotGateConnection )
        checked[ connect.parent ] = true
        if connect.parent == zrm then
          --ld.LogTrace( "checked 3 "..count.." "..room_step )
          --table.insert( answer, room_step )
          return room_step
        else
          local child = private.BotGetConnectedZRM( zrm, connect.parent, checked, count + 1 )
          if child then
            --ld.LogTrace( "checked 4 "..count.." "..room_step )

            return child
          end
        end
      end


    end
    --if ObjGet( private.BotMakeGate( room_step, zrm ) ) then
    --  return zrm;
    --end
    return false
  end
  --возвращает следующий прогресс
  function private.BotGetNextProgresName()

    local prg_next;

    if common_impl.SmartHint_GetNearestPrg then
      prg_next = common_impl.SmartHint_GetNearestPrg()
    end

    if not prg_next then
      local progress = private.GetGlobalProgress();
      local progress_names = private.GetProgressNames();
      for i = 1, #progress_names, 1 do
        if ( progress[ progress_names[ i ] ].done == 0 ) then
          prg_next = progress_names[ i ];
          break;
        end;
      end;
    end

    return prg_next;

  end
  --
  --нужно переделать, косвенное значение
  function private.BotGetRealDragingObj( obj )
    while ObjGetRelations( obj ).parent do
      if ObjGetRelations( obj ).parent == "ng_interface_transporter" then
        return obj
      else
        obj = ObjGetRelations( obj ).parent
      end
    end
    return false
  end
  --
  function private.BotGetCurrentPlace()
    local place = interface.GetCurrentComplexInv()
    if place == "" then
      place = common.GetCurrentSubRoom() or common.GetCurrentRoom()
    end
    return place;
  end
  --
  function private.BotIsAnyObjDraging()
    return #ObjGetRelations( "ng_interface_transporter" ).childs > 0
  end
  --
  function private.BotIsObjDragNow( obj, parent )
    parent = parent or "ng_interface_transporter"
    local childs = ObjGetRelations( parent ).childs
    for i = 1, #childs do
      --ld.LogTrace( obj, parent, childs[ i ] )
      if childs[ i ] == obj or private.BotIsObjDragNow( obj, childs[ i ] ) then
        --ld.LogTrace( "YES!!!" )
        return true
      end
    end
    return false
  end
  --
  function private.BotIsParentRoom( now_room, check_room )
    local connect = private.BotGateConnection[ now_room ]
    return connect and connect.parent == check_room
  end
  --
  function private.BotIsRoomChild( room1, room2 )
    local progress_names = private.GetProgressNames();
    local prg1 = "opn_"..ld.StringDivide( room1 )[ 2 ]
    local prg2 = "opn_"..ld.StringDivide( room2 )[ 2 ]
    for i = 1, #progress_names, 1 do
      if progress_names[ i ] == prg1 then
        --ld.LogTrace( room1.." parent for "..room2 )
        return true
      elseif progress_names[ i ] == prg2 then
        --ld.LogTrace( room1.." child for "..room2 )
        return false
      end;
    end;
    return false;
  end
  --
  --проверка на заблокированность + обработка диалогов
  function private.BotIsGameLocked()
    private.screen_lock_objects = {
      "obj_int_lock";--CHEB
      "obj_int_lock_room";--CHEB
      "obj_int_lock_Custom_use";--CHEB OLD CUSTOM
    }
    local bool = false;
    if int_lock and int_lock.IsAnyCustomNow and int_lock.IsAnyCustomNow() then
      bool = true
    else
      local o
      for i = 1, #private.screen_lock_objects do
        o = ObjGet( private.screen_lock_objects[ i ] )
        if o and o.input then
          bool = true;
          break
        end
      end
    end

    --int_dialog_vide
    if not bool then
      if ObjGet( "int_dialog_video" ) and ObjGet( "int_dialog_video" ).input then
        bool = true
        if ObjGet( "obj_int_dialog_video_skip" ) and ObjGet( "obj_int_dialog_video_skip" ).input then
          int_dialog_video.SkipClick()
        end
      end
    end

    --int_dialog_story
    if not bool then
      if ObjGet( "int_dialog_story" ) and ObjGet( "int_dialog_story" ).input then
        bool = true
        if ObjGet( "obj_int_dialog_story_skip" ) and ObjGet( "obj_int_dialog_story_skip" ).input then
          int_dialog_story.SkipClick()
        elseif ObjGet( "obj_int_dialog_story_continue" ) and ObjGet( "obj_int_dialog_story_continue" ).input then
          int_dialog_story.ContinueClick()
        end
      end
    end

    --int_dialog_character
    if not bool then
      if ObjGet( "int_dialog_character" ) and ObjGet( "int_dialog_character" ).input then
        bool = true
        if private.BotIsGameLocked_count < private.BOT_GAME_PRG_REPIATS_COUNT / 2 then
          private.BotMouseClick( { 512; 384 } )
        else
        --if ObjGet( "obj_int_dialog_character_skip" ) and ObjGet( "obj_int_dialog_character_skip" ).input then
          int_dialog_character.SkipClick()
        --elseif ObjGet( "obj_int_dialog_character_continue" ) and ObjGet( "obj_int_dialog_character_continue" ).input then
        --  int_dialog_character.ContinueClick()
        --end
        end
      end
    end

    if bool then
      private.BotIsGameLocked_count = private.BotIsGameLocked_count + 1
    else
      private.BotIsGameLocked_count = 0
    end
    return bool, private.BotIsGameLocked_count
  end
  --
  --проверка на затуп бота на пргрессе
  function private.BotIsStepChainLocked( prg )
    if not prg then
      return false, 0
    end
    table.insert( private.BotStepChain_log, prg )
    local count = 0
    for i = #private.BotStepChain_log, 1, -1 do
      if count > private.BOT_GAME_PRG_REPIATS_COUNT then
        return true, count
      elseif private.BotStepChain_log[ i ] == prg then
        count = count + 1
      else
        return false, count
      end
    end;
    return false, count
  end
  --
  function private.BotTryUsePlaceClick( use_place )
    if private.BotTryUsePlaceClickNow >= private.BOT_USE_PLACE_CLICKS then
      private.BotTryUsePlaceClickNow = 0
      return false
    elseif private.BotTryObjClick( use_place ) then
      private.BotTryUsePlaceClickNow = private.BotTryUsePlaceClickNow + 1
      return true
    else
      private.BotTryUsePlaceClickNow = 0
      return false
    end
  end
  --
  function private.BotTryTouch()
    if private.BOT_ALL_OBJS_TOUCH <= 0 then
      return false
    end
    local list = private.BotToucherGetObjs()
    for i = 1, #list do
      if not private.BotTryTouch_touched[ list[ i ] ] then
        private.BotTryTouch_touched[ list[ i ] ] = 0;
      end
      if private.BotTryTouch_touched[ list[ i ] ] < private.BOT_ALL_OBJS_TOUCH then
        --ld.LogTrace( "BotTryTouch >> BotTryObjClick >>", list[ i ] )
        if private.BotTryObjClick( list[ i ], false, "BotTryTouch Error: >> "..list[ i ] ) then
          private.BotTryTouch_touched[ list[ i ] ] = private.BotTryTouch_touched[ list[ i ] ] + 1
          return true;
        end
      end
    end
    --ld.LogTrace( "BotTryTouch", list )
    return false
  end
  --
  function private.BotTryObjClick( obj_name, fake, error_message )
    --ld.LogTrace( "BotTryObjClick", obj_name, fake )
    local o = ObjGet( obj_name )
    if o and o.input then
      local clickLog = private.BotClickLogger( obj_name )
      if clickLog >= private.BOT_CLICKS_BEFORE_STOP then
        return false
      elseif clickLog == private.BOT_CLICKS_BEFORE_FAKE - 1 then
        --если цетр объекта перегорожен или прозрачный, возможно gfx этого объекта указывает в кликабелльное место ( для подбираемых предметов должно быть реализовано )
        local div = ld.StringDivide( obj_name )
        local gfx = obj_name:gsub( "^"..div[ 1 ], "gfx" )
        if ObjGet( gfx ) then
          obj_name = gfx
          o = ObjGet( obj_name )
        end
      elseif clickLog == private.BOT_CLICKS_BEFORE_FAKE then
        --пытаемся найти место клика и кликнуть
        private.BotTryObjClick_FindClickablePoint( obj_name )
      elseif clickLog >= private.BOT_CLICKS_BEFORE_FAKE then
        private.BotLog( "BotTryObjClick: prg_current >> '"..private.BotGetNextProgresName().."'; object >> '"..obj_name.."' - стандартный клик не удался (BOT_CLICKS_BEFORE_FAKE), возможно кликаем в прозрачку или объект перекрыт, пытаемся дёрнуть события объекта"  )
        if error_message then
          private.BotLog( error_message )
        end
        fake = true
      end
      if fake then
        if ObjGet( obj_name ) and ObjGet( obj_name ).event_menter then ObjGet( obj_name ).event_menter( { sender = obj_name } ) end
        if ObjGet( obj_name ) and ObjGet( obj_name ).event_mdown  then ObjGet( obj_name ).event_mdown( { sender = obj_name } )  end
        if ObjGet( obj_name ) and ObjGet( obj_name ).event_mup    then ObjGet( obj_name ).event_mup( { sender = obj_name } )    end
        if ObjGet( obj_name ) and ObjGet( obj_name ).event_mleave then ObjGet( obj_name ).event_mleave( { sender = obj_name } ) end
      else
        local p = GetObjPosByObj( obj_name )
        if o.inputrect_init then
          local inputrect = {}
          inputrect[ 1 ] = p[ 1 ] + o.inputrect_x + o.inputrect_w * 0.5
          inputrect[ 2 ] = p[ 2 ] + o.inputrect_y + o.inputrect_h * 0.5
          if  p[ 1 ] > ( inputrect[ 1 ] - o.inputrect_w * 0.5 ) and p[ 1 ] < ( inputrect[ 1 ] + o.inputrect_w * 0.5 )
          and p[ 2 ] > ( inputrect[ 2 ] - o.inputrect_h * 0.5 ) and p[ 2 ] < ( inputrect[ 2 ] + o.inputrect_w * 0.5 )
          then

          else
            p = inputrect
          end
        end
        -->> TODO добавить рандомный разброс в пределах inputrect или drawrect
        private.BotMouseMove( p )
        private.BotMouseClick( p )
        --ld.LogTrace( "BotTryObjClick", obj_name, p, GetZoomCursorPos() )
      end
      return true
    else
      private.BotLog( "BotTryObjClick: '"..obj_name.."' - объект не существует или Input выключен" )
      return false
    end
  end
  --
  function private.BotTryObjClick_FindClickablePoint( obj_name )
    --ld.LogTrace( "BotTryObjClick_FindClickablePoint", obj_name )
    local click_obj = ObjGet( obj_name )
    local p = GetObjPosByObj( obj_name )
    
    local func_cache = {}

    local mdown_events_all_colled = 0
    local mdown_events_obj_colled = 0
    local mdown_events_other_colled = 0
    local events_pos = {}
    local event_pos
    local function mdown_event_caller( obj )
      mdown_events_all_colled = mdown_events_all_colled + 1
      if obj == obj_name then
        mdown_events_obj_colled = mdown_events_obj_colled + 1
        if not event_pos then
          event_pos = events_pos[ mdown_events_all_colled ]
          --ld.LogTrace( "mdown_event_caller", mdown_events_all_colled, mdown_events_obj_colled, mdown_events_other_colled, event_pos, #events_pos )
        end
      else
        mdown_events_other_colled = mdown_events_other_colled + 1
      end
    end

    local p_o,ch;
    local function set_all_input_objs( obj )
      obj = obj or "ng_application"
      p_o = ObjGet( obj )
      --ld.LogTrace( parent )
      if p_o.input then
        func_cache[ obj ] = { 
          event_mdown = p_o.event_mdown or ""; 
          event_mup = p_o.event_mup or "";
          event_menter = p_o.event_menter or "";
          event_mleave = p_o.event_mleave or "";
         }
        ObjSet( obj, { 
          event_mdown = function() mdown_event_caller( obj ) end;
          event_mup = "";
          event_menter = "";
          event_mleave = "";
        } )
        ch = ObjGetRelations( obj ).childs
        for i, child in ipairs( ch ) do
          set_all_input_objs( child )
        end
      end
    end

    local function restor_all_input_objs()
      for k, v in pairs( func_cache ) do
        ObjSet( k, v )
      end
    end


    local rect
    if click_obj.inputrect_init then
      rect = { 
        x1 = p[ 1 ] + click_obj.inputrect_x;
        y1 = p[ 2 ] + click_obj.inputrect_y;
        x2 = p[ 1 ] + click_obj.inputrect_x + click_obj.inputrect_w;
        y2 = p[ 2 ] + click_obj.inputrect_y + click_obj.inputrect_h;
      };
    else
      rect = { 
        x1 = p[ 1 ] - click_obj.draw_width / 2;
        y1 = p[ 2 ] - click_obj.draw_height / 2;
        x2 = p[ 1 ] + click_obj.draw_width;
        y2 = p[ 2 ] + click_obj.draw_height;
      };
    end
    rect.x = ( rect.x1 + rect.x2 ) / 2
    rect.y = ( rect.y1 + rect.y2 ) / 2
    rect.w = rect.x2 - rect.x1
    rect.h = rect.y2 - rect.y1

    local cache_obj = "bot_cache_obj"
    local cache_pos
    local step_x = math.ceil( rect.w / 10 )
    local step_y = math.ceil( rect.h / 10 )
    local step_xx = math.ceil( step_x / 2 )
    local step_yy = math.ceil( step_y / 2 )
    local count = 0
    local function fake_click( x, y )
       count = count + 1
       ObjAttach( cache_obj, obj_name )
       ObjSet( cache_obj, { pos_x = x; pos_y = y; } )
       --ld.LogTrace( rect.x + x * xx, rect.y + y * yy  )
       cache_pos = GetObjPosByObj( cache_obj );
       table.insert( events_pos, { cache_pos[ 1 ]; cache_pos[ 2 ] } )
       --ld.LogTrace( cache_pos  )
       private.BotMouseMove( cache_pos )
       private.BotMouseClick( cache_pos )
    end
    local function fake_clicker()
      ObjCreate( cache_obj, "obj" )
      ObjSet( cache_obj, { input = 0 } )
      for y = -rect.h / step_y, rect.h / step_y, step_y do
        fake_click( 0, y )
      end
      for x = -rect.w / step_x, rect.w / step_x, step_x do
        fake_click( x, 0 )
      end
      for y = 1, rect.h / step_y do
        for x = 1, rect.w / step_x do
          for xx = -step_xx, step_xx, step_x do
            for yy = -step_yy, step_yy, step_y do
              fake_click( x * xx, y * yy )
            end
          end
        end
      end
    --ld.LogTrace( "fake_clicker", count, rect )
    end
    set_all_input_objs()
    fake_clicker()
    restor_all_input_objs()
    ObjDelete( cache_obj )

    --private.BotStop()

    ld.StartTimer( 0, function() 
      if event_pos then
        ld.LogTrace( "BOT: Clickable point finded >> \nПроверено точек >> "..mdown_events_all_colled.." из "..( math.tointeger( rect.w * rect.h ) ).."\nВсего найдено кликабельных точек объекта >> "..mdown_events_obj_colled.." ( "..string.format( "%g", 100 * mdown_events_obj_colled /mdown_events_all_colled ).." percents )" )
        ld.LogTrace(  event_pos, rect )
        private.BotMouseMove( cache_pos )
        private.BotMouseClick( event_pos )
      end
    end )

  end
  --
  function private.TryObjDragDrop( obj_drag, obj_place )

    local obj_pos = GetObjPosByObj( obj_drag )
    local drag_pos = GetObjPosByObj( obj_place )

    private.BotMouseDown( obj_pos );
    private.BotMouseMove( drag_pos );

    ld.StartTimer( 0.65, function() 

        local o = ObjGet( obj_drag )
        local buf_func = o.event_dragdrop or function( ne_params ) end
        ObjSet( obj_drag, { event_dragdrop = function( ne_params ) 
          ObjSet( obj_drag, { event_dragdrop = buf_func; } )
          local relative_pos = GetObjPosByObj( obj_place, ObjGetRelations( obj_drag ).parent )
          ObjSet( obj_drag, { pos_x = relative_pos[ 1 ]; pos_y = relative_pos[ 2 ]; } )
          buf_func( ne_params )
          ObjSet( obj_drag, { pos_x = o.pos_x; pos_y = o.pos_y; } )
        end } )

        if o.realdrag then
          private.BotMouseUp( drag_pos )
        else
          private.BotMouseDown( drag_pos )
        end

    end )

  end
  --
  function private.BotTryObjUse( obj_drag, obj_place )
    local od = ObjGet( obj_drag )
    local op = ObjGet( obj_place )
    if od and od.input and od.drag then
      if op then
        if private.BotClickLogger( obj_drag ) >= private.BOT_CLICKS_BEFORE_STOP then
          return false
        end

        private.TryObjDragDrop( obj_drag, obj_place )

        return true
      else
        private.BotLog( "BotTryObjUse: '"..obj_place.."' - места применения не существует" )
        return false
      end
    else
      if od and not od.input then
        if BotTryObjUse_activator[ obj_drag ] then
          private.BotLog( "BotTryObjUse: '"..obj_drag.."' - у объекта для драга выключен Input, включаем програмно" )
          ObjSet( obj_drag, { input = 1 } )
        else
          BotTryObjUse_activator[ obj_drag ] = true
        end
        return true
      elseif od and not od.drag then
        if BotTryObjUse_activator[ obj_drag ] then
          private.BotLog( "BotTryObjUse: '"..obj_drag.."' - у объекта для драга выключен Drag, включаем програмно" )
          ObjSet( obj_drag, { drag = 1 } )
        else
          BotTryObjUse_activator[ obj_drag ] = true
        end
        return true
      else
        private.BotLog( "BotTryObjUse: '"..obj_drag.."' - объкт для драга не существует или Input/Drag выключен" )
      end
      return false
    end

  end
  --
  function private.BotTryGoTo( zrm )
    --ld.LogTrace( "private.BotTryGoTo", zrm )

    -->>ОБРАБОТКА ИСКЛЮЧЕНИЙ
    if private.BotExceptionHandler( { caller = "BotTryGoTo"; value = zrm } ) then
      return true
    end
    --<<ОБРАБОТКА ИСКЛЮЧЕНИЙ

    if interface.GetCurrentComplexInv() ~= "" and interface.GetCurrentComplexInv() ~= zrm then
      private.BotInvComplexClose()
    elseif common.GetCurrentSubRoom() then
      if zrm == common.GetCurrentSubRoom() then
        return false
      end
      if zrm:find( "^inv_" ) then
        private.BotInvComplexClose()
      else
        private.BotZzClose()
      end
    elseif common.GetCurrentRoom() == zrm then
      return false
    elseif interface.GetCurrentComplexInv() == zrm then
      return false
    elseif zrm:find( "^inv_" ) then
      local inv_obj = zrm:gsub( "_complex_", "_" )
      if private.BotInvObjShow( inv_obj ) then
        private.BotTryObjClick( inv_obj )
      end
    else
      local now_room = common.GetCurrentRoom()
      local buf_zrm = private.BotGetConnectedZRM( now_room, zrm )
      --ld.LogTrace( now_room, buf_zrm )
      local buf_gate = private.BotMakeGate( now_room, buf_zrm )
      --ld.LogTrace( buf_gate )
      --ld.LogTrace( GetObjPosByObj( buf_gate ) )
      local fake_click = private.BotIsParentRoom( now_room, buf_zrm )
      private.BotTryObjClick( buf_gate, fake_click )
    end
    return true
  end
  --
  function private.BotTrySkipMg()
    local skip = false
    if cmn.current_mg then
      if int_complex_inv.GetCurrentName() ~= "" then
        level_inv.Skip();
        skip = true
      elseif _G[ GetCurrentRoom() ].Skip then
        _G[ GetCurrentRoom() ].Skip();
        skip = true
      end;
    end
    return skip
  end
  --
  function private.BotTryMakeScreenshot()
    if private.BOT_SCREENSHOT_STEPS_WAIT > 0 then
      private.BotTryMakeScreenshot_stepCounter = private.BotTryMakeScreenshot_stepCounter + 1
      if private.BOT_SCREENSHOT_STEPS_WAIT == private.BotTryMakeScreenshot_stepCounter then
        private.BotMakeScreenshot()
        private.BotTryMakeScreenshot_stepCounter = 0
        return true;
      end
    end
    return false;
  end
  --
  function private.BotTryHint()
    if private.BOT_HINT_ON_STEP then
      local place_now = private.BotGetCurrentPlace()
      local prg_now = private.BotGetNextProgresName() -- private.BotTryHint_lastPrgName
      if not ObjGet( "int_button_hint" ).input then
        return false
      elseif ObjGet( "int_dialog_hint" ).input then
        private.BotTryObjClick( "obj_int_dialog_hint_teleport" )
        return true;
      elseif place_now == private.BotTryHint_lastPlace and prg_now == private.BotTryHint_lastPrgName then
        --private.BotTryHint_lastPlace = false
        --private.BotTryHint_lastPrgName = false
        return false
      else
        common_impl.DeleteHintFx()
        int_button_hint.Reload(0);
        int_button_hint.MouseDown();
        private.BotTryHint_lastPlace = place_now
        private.BotTryHint_lastPrgName = prg_now
        if private.BOT_HINT_SCREENSHOT_TIME == 0 then
          private.BotMakeScreenshot()
        elseif private.BOT_HINT_SCREENSHOT_TIME > 0 then
          ld.StartTimer( private.BOT_HINT_SCREENSHOT_TIME, function() private.BotMakeScreenshot() end )
        end
        return true;
      end
    else
      return false;
    end
  end
  --
  function private.BotMakeScreenshot()
    MsgSend( Event_Level_CheaterSaveScreenshot );
  end
  --
  function private.BotMakeGate( from_zrm, to_zrm )
    local from_div = ld.StringDivide( from_zrm )
    local to_div = ld.StringDivide( to_zrm )
    return "g"..to_div[ 1 ].."_"..from_div[ 2 ].."_"..to_div[ 2 ]
  end
  --
  function private.BotMakeZzGateConnections( zrm )
    local connect = private.BotGateConnection
    if not connect[ zrm ] and zrm:find( "^zz" ) then
      for i = 1, #game.room_names do
        if game.room_names[ i ]:find( "^rm" ) and ObjGet( private.BotMakeGate( game.room_names[ i ], zrm ) ) then
          connect[ zrm ] = { childs = {}, parent = game.room_names[ i ] }
          table.insert( connect[ game.room_names[ i ] ].childs, 1, zrm )
          return;
        end
      end
    end
  end
  --
  function private.BotMakeGateConnections()
    private.BotGateConnection = {}
    local connect = private.BotGateConnection
    local div
    for j = 1, #game.room_names do
      div = ld.StringDivide( game.room_names[ j ] )
      if div[ 1 ] == "rm" then
        connect[ game.room_names[ j ] ] = connect[ game.room_names[ j ] ] or { childs = {}, parent = false }
        for i = 1, #game.room_names do
          if i ~= j then
            buf_gate = private.BotMakeGate( game.room_names[ j ], game.room_names[ i ] )
            if ObjGet( buf_gate ) and private.BotIsRoomChild(  game.room_names[ j ], game.room_names[ i ] ) then
              table.insert( connect[ game.room_names[ j ] ].childs, game.room_names[ i ] )
              connect[ game.room_names[ i ] ] = connect[ game.room_names[ i ] ] or { childs = {}, parent = false }
              connect[ game.room_names[ i ] ].parent = game.room_names[ j ]
            end
            buf_gate = private.BotMakeGate( game.room_names[ i ], game.room_names[ j ] )
            if ObjGet( buf_gate ) and private.BotIsRoomChild(  game.room_names[ i ], game.room_names[ j ] )  then
              connect[ game.room_names[ j ] ].parent = game.room_names[ i ]
            end
          end
        end
      end
    end
  end
  --
  function private.BotInvObjShow( inv_obj )
    local item = ld.StringDivide( inv_obj )[ 2 ]
    if private.BotIsObjDragNow( inv_obj ) then
      return true
    elseif not common_impl.TableContains( ObjGetRelations("obj_int_inventory").childs,"hub_int_inventory_"..item ) then
      return true
    elseif private.BotInvObjShowed == inv_obj then
      return true
    else
      private.BotInvObjShowed = inv_obj
      interface.InventoryItemAdd( inv_obj );
    end
    return false
  end
  --
  function private.BotInvComplexClose( bool )
    private.BotTryObjClick( "btn_int_complex_inv_impl_close" )
  end
  --
  function private.BotZzClose()
    --private.BotMouseClick( { 0, 0 } )
    private.BotTryObjClick( "obj_int_frame_subroom_button" )
  end
  --
  function private.BotClickLogger( obj_name )
    local count = 0
    for i = #private.BotClickLoggerChain, 1, -1 do
      if private.BotClickLoggerChain[ i ] == obj_name then
        count = count + 1;
      else
        break
      end
    end
    table.insert( private.BotClickLoggerChain, obj_name )
    return count;
  end
  --//для режима прощупывания всего живого на экране
  function private.BotToucherGetObjs( root, list )
    --возвращает список объектов
    root = root or private.BotGetCurrentPlace()
    list = list or {}
    local o
    for i, v in ipairs( ObjGetRelations( root ).childs ) do
      o = ObjGet( v )

      if o.input
      and not ( v:find( "^gzz" ) or v:find( "^grm" ) or v:find( "^gho" ) or v:find( "^gmg" ) )
      then
        --  ld.LogTrace( "BotGetCurrentPlace Wrong", v )
        --  ld.LogTrace( v:find( "^(grm)|^(gzz)|^(gho)|^(gmg)" ) )
        --end
        --if ( v:find( "^(grm)|^(gzz)|^(gho)|^(gmg)" ) ) then
        --  ld.LogTrace( 11111111111 )
        --else
        --  ld.LogTrace( 22222222222 )
        --end
        if o.event_mdown then
          table.insert( list, v )
        end
        private.BotToucherGetObjs( v, list)
      end
    end
    return list
  end
  --
  function private.BotMouseClick( p )
    private.BotMouseDown( p )
    private.BotMouseUp( p )
  end
  --
  function private.BotMouseMove( p )
    ne.dbg.FireInputEvent( p[ 1 ], p[ 2 ], 5 )
  end
  --
  function private.BotMouseLeave( p )
    ne.dbg.FireInputEvent( p[ 1 ], p[ 2 ], 6 )
  end
  --
  function private.BotMouseUp( p )
    ne.dbg.FireInputEvent( p[ 1 ], p[ 2 ], 4 )
  end
  --
  function private.BotMouseDown( p )
    ne.dbg.FireInputEvent( p[ 1 ], p[ 2 ], 3 )
  end
  --
  --function ***BOTCONTROLLER***() end

    private.StackHandler_events = {};
    function public.AddStackHandler( prg_name, func )
      private.StackHandler_events[ prg_name ] = func;
    end
    function private.ExecuteStackHandler( prg_name )
      if private.StackHandler_events[ prg_name ] then
        return private.StackHandler_events[ prg_name ]()
      else
        return false
      end
    end

    private.ForceHandler_events = {};
    function public.AddForceHandler( prg_name, func )
      private.ForceHandler_events[ prg_name ] = func;
    end    
    function private.ExecuteForceHandler( prg_name )
      if private.ForceHandler_events[ prg_name ] then
        return private.ForceHandler_events[ prg_name ]()
      else
        return false
      end
    end

    private.ActionHandler_events = {};
    function public.AddActionHandler( prg_name, func )
      private.ActionHandler_events[ prg_name ] = func;
    end    
    private.ExecuteActionHandler_clicker = {}
    function private.ExecuteActionHandler( prg_name )
      if private.BotGetConfigParam( "clicker."..prg_name, "string" ) then
        if not private.ExecuteActionHandler_clicker[ prg_name ] then
          private.ExecuteActionHandler_clicker[ prg_name ] = private.BotGetConfigParam( "clicker."..prg_name, "string" )
          private.BotLog( "ExecuteActionHandler from config >> "..prg_name )
          private.BotLog( private.ExecuteActionHandler_clicker[ prg_name ] )
        end
        return true
      elseif private.ActionHandler_events[ prg_name ] then
        return private.ActionHandler_events[ prg_name ]()
      else
        return false
      end
    end

    private.LockHandler_events = {};
    function public.AddLockHandler( prg_name, func )
      private.LockHandler_events[ prg_name ] = func;
    end    
    function private.ExecuteLockHandler( prg_name )
      if private.LockHandler_events[ prg_name ] then
        return private.LockHandler_events[ prg_name ]()
      else
        return false
      end
    end

    function public.BotRestartCurrentLevel()
      local prg = ng_global.currentprogress;
      local level = ng_global.progress[ prg ].common.chapter;
      private.BotStop()
      common.LevelSwitch( level );
    end

    function public.BotStop()
      private.BotStop()
    end

    function public.BotMouseDown( p )
      private.BotMouseDown( p )
    end

    function public.BotMouseUp( p )
      private.BotMouseUp( p )
    end

    function public.BotMouseClick( p )
      private.BotMouseClick( p )
    end

    function public.BotMouseMove( p )
      private.BotMouseMove( p )
    end

    function public.BotMouseLeave( p )
      private.BotMouseLeave( p )
    end

    function public.BotMouseDragDrop( pTake, pDrop )
      private.BotMouseDown( pTake );
      private.BotMouseMove( pDrop );

      ld.StartTimer( 0.65, function() 

        if #ObjGetRelations( "ng_interface_transporter" ).childs == 1 then
          local obj_drag = ObjGetRelations( "ng_interface_transporter" ).childs[ 1 ]
          local isInvItem = false
          if obj_drag:find( "^itm_int_inventory_" ) then
            obj_drag = ObjGetRelations( obj_drag ).childs[ 1 ]
            isInvItem = true
          end
          local o = ObjGet( obj_drag )
          local buf_func = o.event_dragdrop or function( ne_params ) end
          ObjSet( obj_drag, { event_dragdrop = function( ne_params ) 
            ObjSet( obj_drag, { event_dragdrop = buf_func; } )
            ObjSet( obj_drag, { pos_x = pDrop[ 1 ]; pos_y = pDrop[ 2 ]; } )
            buf_func( ne_params )
            ObjSet( obj_drag, { pos_x = o.pos_x; pos_y = o.pos_y; } )
          end } )
          if o.realdrag then
            private.BotMouseUp( pDrop )
          else
            private.BotMouseDown( pDrop )
          end
        else
          return
        end

      end )
    end
--function()  end

--******************************************************************************************
function private.CheboxaryInit()
  private.InGameDoneOrder = {}
  private.CheboxaryFuncs = {};
  private.CheboxaryFuncsPOPAP = {};
  ObjSet( "spr_cheater_but", { 
    input = 1;
    pos_z = 999;
    event_mdown = private.CheboxaryListShow;
    event_menter = function() ld.ShCur(CURSOR_HAND) end;
    event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end;
  } )

  private.SoundhelperInit()

  --private.CheboxaryListAdd( "ShowAllObjectsWithFonts" )
  private.CheboxaryListAdd( "FPS_lower", "вкл/выкл жесточайшие тормоза)" )
  private.CheboxaryListAdd( "TimeWarp", "ускоритель времени" )
  private.CheboxaryListAdd( "ChangeFontForScreenObjs", "Меняет все тексты на экране на имя шрифта" )
  private.CheboxaryListAdd( "DisableFX_ALL", "выключает visible всех fx,pfx,gfx.grm.gho,gmg,gzz" )
  private.CheboxaryListAdd( "DisableFX_GFX_ONLY", "выключает visible gfx,grm,gho,gmg,gzz" )
  private.CheboxaryListAdd( "Show_count_ho_without_hint", "показать счетчик" )
  private.CheboxaryListAdd( "Show_count_mg_without_skip", "показать счетчик" )
  private.CheboxaryListAdd( "Show_Global_Vars", "вывод переменных из массиве _G" )
  private.CheboxaryListAdd( "Show_SmartHint", "вывод переменных связанных с смартхинт" )
  private.CheboxaryListAdd( "Get_all_puzzles", "взять все пазлы" )

end;
--******************************************************************************************
function private.CheboxaryListAdd( name, opisanie )
  table.insert( private.CheboxaryFuncs, { name, opisanie } )
    local obj = "spr_cheater_but_cheboxary_"..name
    ObjCreate( obj, "obj" )
    ObjSet( obj, { 
      visible = 0;
      input = 0;
      event_mdown = function() private[name]() end;
      event_menter = function() ld.ShCur(CURSOR_HAND) ObjSet( "txt_"..obj, { fontcolor_r = 1; fontcolor_g = 0; fontcolor_b = 1; } ) end;
      event_mleave = function() ld.ShCur(CURSOR_DEFAULT) ObjSet( "txt_"..obj, { fontcolor_r = 1; fontcolor_g = 1; fontcolor_b = 1; } ) end;
      scale_x = 1;
      scale_y = 1;
      attachtype = 2;
      inputrect_init = 1;
      inputrect_x = 0;
      inputrect_y = - ObjGet( "spr_cheater_but" ).draw_height / 2 * ObjGet( "spr_cheater_but" ).scale_y;
      inputrect_w = 350* ObjGet( "spr_cheater_but" ).scale_x;
      inputrect_h = ObjGet( "spr_cheater_but" ).draw_height* ObjGet( "spr_cheater_but" ).scale_y;
      pos_x = - ObjGet( "spr_cheater_but" ).draw_width/2* ObjGet( "spr_cheater_but" ).scale_x;
      pos_y = ObjGet( "spr_cheater_but" ).draw_height * ( #private.CheboxaryFuncs ) * ObjGet( "spr_cheater_but" ).scale_y;
    } )
    ObjAttach( obj, "spr_cheater_but" )

    ObjCreate( "txt_"..obj, "text" )
    ObjSet( "txt_"..obj, { 
      res = "assets/shared/cheater/arial", 
      align = 0, input = 0, 
      text = #private.CheboxaryFuncs..") "..name..(opisanie and " >> "..opisanie or "" ) } )
    ObjAttach( "txt_"..obj, obj )

    ObjCreate( "spr_back_"..obj, "spr" )
    ObjSet( "spr_back_"..obj, { 
      res = "assets/shared/cheater/editor_back";
      input = 0;
      pos_z = -1;
      --atachtype = 2;
      pos_x = ObjGet( "txt_"..obj ).draw_width / 2;
      scale_x = ObjGet( "txt_"..obj ).draw_width / 2;
      scale_y = ObjGet( "txt_"..obj ).draw_height * 0.32;
      color_r = 0;
      color_g = 0;
      color_b = 0;
    } )
    ObjAttach( "spr_back_"..obj, obj )

end
--******************************************************************************************
function private.CheboxaryListShow()
  for i = 1, #private.CheboxaryFuncs do
    local v = not ObjGet( "spr_cheater_but_cheboxary_"..private.CheboxaryFuncs[i][1] ).visible
    ObjSet( "spr_cheater_but_cheboxary_"..private.CheboxaryFuncs[i][1], { input = v, visible = v } )
  end
end;
--******************************************************************************************
function public.AddInGameDoneOrder( event )
  table.insert( private.InGameDoneOrder, event )
end
--******************************************************************************************
function private.SoundhelperInit()

  ld.AnimPlay = function( anim, animfunc, func_end ) 
    if anim == "" and animfunc == "" and func_end and type( func_end ) == "function" then
      ld.StartTimer( 0.0, func_end )
    else
      AnimPlay( anim, animfunc, function() 
        local o = ObjGet( anim )
        if o then
          private.SoundHelperShow( "AnimPlay", animfunc.." > "..(math.ceil((o.frame/60)*100)/100) )
        end;
        if func_end then
          if type( func_end ) == "function" then
            func_end( { sender = anim } );
          elseif type( func_end ) == "string" and func_end:len() == 0 then
            --ok
          else
            ld.LogTrace( "ERROR: trying use STRING instead FUNCTION" )
          end
        end
      end );
    end;
  end

  function private.SoundHelperAdd( name, len )
    len = len or 1
    private.SoundHelperList = private.SoundHelperList or {}
    private.SoundHelperLen = private.SoundHelperLen or {}
    private.SoundHelperLen[ name ] = len

    local h = 20;
    local dy = h;
    for i = 1, #private.SoundHelperList do
      dy = dy + h * private.SoundHelperLen[ private.SoundHelperList[ i ] ] + h * 1.5
    end

    table.insert( private.SoundHelperList, name )
    private.SoundHelperNum = private.SoundHelperNum or {}
    private.SoundHelperNum[ name ] = #private.SoundHelperList;

      local txt = "txt_cheater_soundhelper_"..name.."_"..#private.SoundHelperList.."_0"
      ObjCreate( txt, "text" )
      ObjSet( txt, { 
        res = "assets/shared/cheater/arial", 
        align = 0, 
        input = 0, 
        fontsize = 15;
        text = name,
        pos_x = 0;
        pos_y = dy;
      } )
      ObjAttach( txt, "obj_cheater_soundhelper" )
    for i = 1, len do
      local txt = "txt_cheater_soundhelper_"..name.."_"..#private.SoundHelperList.."_"..i
      ObjCreate( txt, "text" )
      ObjSet( txt, { 
        res = "assets/shared/cheater/arial", 
        align = 0, 
        input = 0, 
        fontsize = 15;
        text = #private.SoundHelperList.."_"..i,
        pos_x = 0;
        pos_y = dy + i * h;
      } )
      ObjAttach( txt, "obj_cheater_soundhelper" )
    end

  end
  --private.SoundHelperAdd( "111", 1 )
  --private.SoundHelperAdd( "222", 2 )
  private.SoundHelperAdd( "AnimPlay", 5 )
  private.SoundHelperAdd( "ActionsDone", 5 )
  private.SoundHelperAdd( "UsePlace", 1 )


--cmn.AddSubscriber( "opn_cabinet", opn_cabinet_logic )
  for k, v in pairs( private.HINT_ROOT ) do
    cmn.AddSubscriber( k.."_end", function() private.SoundHelperShow( "ActionsDone", k ) end )
  end

  function public.BbtPrg( prg )
    private.SoundHelperShow( "UsePlace", prg )
  end

  function private.SoundHelperShow( name, text )
    local o
    for i = private.SoundHelperLen[ name ], 2, -1 do
      o = ObjGet( "txt_cheater_soundhelper_"..name.."_"..private.SoundHelperNum[ name ].."_"..( i - 1 ) )
      ObjSet( "txt_cheater_soundhelper_"..name.."_"..private.SoundHelperNum[ name ].."_"..( i ), { 
        text = o.text;
    } )
    end
    ObjSet( "txt_cheater_soundhelper_"..name.."_"..private.SoundHelperNum[ name ].."_1", { 
      text = text;
    } )
  end

end;
--******************************************************************************************
function private.ShowAllObjectsWithFonts( obj )
  
  if not obj then
    ld.LogTrace( ">>>> ShowAllObjectsWithFonts" )
    private.ShowAllObjectsWithFonts( "ne_origin" )
    private.ShowAllObjectsWithFonts( "ne_storage" )
    ld.LogTrace( "<<<< ShowAllObjectsWithFonts" )
  else
    local o = ObjGet( obj )
    
    if o then
      if o.res:find("^assets\\fonts") or o.res:find("^assets/fonts") then
        ld.LogTrace( "\t\t"..o.name.."\t\t"..o.res )
      end;
      local childs = ObjGetRelations( o.name ).childs
      for i = 1, #childs do
        if obj == childs[i] then
          ld.LogTrace( "ERROR: PARRENT IN CHILD!!!" )
        else
          private.ShowAllObjectsWithFonts( childs[i] )
        end
      end
    else
      ld.LogTrace( "ERROR: obj not finded >> "..obj )
    end
  end
end;
--******************************************************************************************
function private.ChangeFontForScreenObjs( obj )
  if not obj then
    ld.LogTrace( ">>>> ChangeFontForScreenObjs" )
    private.ChangeFontForScreenObjs( "ng_level" )
    ld.LogTrace( "<<<< ChangeFontForScreenObjs" )
  else
    local o = ObjGet( obj )
    if o then
      if o.res:find("^assets\\fonts") or o.res:find("^assets/fonts") then
        --ld.LogTrace( "\t\t"..o.name.."\t\t"..o.res )
        ObjSet( o.name, { text = "["..o.res:gsub("^assets\\fonts\\",""):gsub("^assets/fonts/",""):upper().."]", disprawtext = true } )
      end;
      local childs = ObjGetRelations( o.name ).childs
      for i = 1, #childs do
        if obj == childs[i] then
          ld.LogTrace( "ERROR: PARRENT IN CHILD!!!" )
        else
          private.ChangeFontForScreenObjs( childs[i] )
        end
      end
    else
      ld.LogTrace( "ERROR: obj not finded >> "..obj )
    end
  end
end
--******************************************************************************************
function private.DisableFX_ALL( obj, gfx_only )
  if not obj then
    ld.LogTrace( ">>>> DisableFX_ALL" )
    private.DisableFX_ALL( "ng_level", gfx_only )
    ld.LogTrace( "<<<< DisableFX_ALL" )
  else
    local o = ObjGet( obj )
    if o then
      if ( o.name:find("^fx_") and not gfx_only )
      or ( o.name:find("^pfx_") and not gfx_only ) 
      or o.name:find("^gfx_") 
      or o.name:find("^grm_") 
      or o.name:find("^gmg_") 
      or o.name:find("^gho_")
      or o.name:find("^gzz_")
      then
        --ld.LogTrace( "\t\t"..o.name.."\t\t"..o.res )
        ObjSet( o.name, { visible = 0 } )
      end;
      local childs = ObjGetRelations( o.name ).childs
      for i = 1, #childs do
        if obj == childs[i] then
          ld.LogTrace( "ERROR: PARRENT IN CHILD!!!" )
        else
          private.DisableFX_ALL( childs[i], gfx_only )
        end
      end
    else
      ld.LogTrace( "ERROR: obj not finded >> "..obj )
    end
  end
end
function private.DisableFX_GFX_ONLY()
  private.DisableFX_ALL( nil, true )
end
function public.show_ho_count(a) 
  if false then
    local value = tostring(ng_global.achievements.data and ng_global.achievements.data.ho_without_hint and ng_global.achievements.data.ho_without_hint.counter)
    local value2 = tostring(ng_global.achievements.data and ng_global.achievements.data.ho_without_hint and ng_global.achievements.data.ho_without_hint["counter_std"])
    local value3 = tostring(ng_global.achievements.data and ng_global.achievements.data.ho_without_hint and ng_global.achievements.data.ho_without_hint["counter_ext"])
    value = "ho wh:all "..value..",std "..value2..",ext "..value3
    ld.LogTrace( a, value );
  end
end

function private.Show_count_ho_without_hint () 
  local ach_name = "ho_without_hint"
  local value = ng_global.achievements["counter"][ ach_name ]
  local value1 = tostring(ng_global.achievements.data and ng_global.achievements.data.ho_without_hint and ng_global.achievements.data.ho_without_hint.counter)
  local value2 = ng_global.achievements["counter_std"][ ach_name ]
  local value3 = ng_global.achievements["counter_ext"][ ach_name ]
  value = "ho wh:all "..value.."."..value1..",std "..value2..",ext "..value3

  ObjDelete("txt_cheater_ho_count")
  ld.CopyObj("txt_cheater_text_for_copy", "txt_cheater_ho_count", "text")
  ObjSet( "txt_cheater_text_for_copy", {visible = 1, text = value });
  ObjAnimate( "txt_cheater_text_for_copy", 8, 0, 0, function() end, {0,0,0, 0.2,1,1, 3,0,1, 4,0,0} );
end
function private.Show_count_mg_without_skip () 
  local ach_name = "mg_without_skip"
  local value = ng_global.achievements["counter"][ ach_name ]
  local value1 = tostring(ng_global.achievements.data and ng_global.achievements.data.mg_without_skip and ng_global.achievements.data.mg_without_skip.counter)
  local value2 = ng_global.achievements["counter_std"][ ach_name ]
  local value3 = ng_global.achievements["counter_ext"][ ach_name ]

  value = "mg ws:all "..value.."."..value1..",std "..value2..",ext "..value3

  ObjDelete("txt_cheater_ho_count")
  ld.CopyObj("txt_cheater_text_for_copy", "txt_cheater_ho_count", "text")
  ObjSet( "txt_cheater_text_for_copy", {visible = 1, text = value });
  ObjAnimate( "txt_cheater_text_for_copy", 8, 0, 0, function() end, {0,0,0, 0.2,1,1, 3,0,1, 4,0,0} );
end
function private.FPS_lower()
  if private.FPS_lower_on then
    private.FPS_lower_on = false
  else
    private.FPS_lower_on = true
    local stacker = function()  end;
    stacker = function() 
      if not private.FPS_lower_on then return end;
      if not ObjGet( "tmr_FPS_lower" ) then
        for i = 1, 4999999 do
          local a = 1+1;
          local b = a+a;
          local c = a+b;
          local d = a+b+c;
          local e = a+b+c+d;
        end
        ld.StartTimer( "tmr_FPS_lower", 0, stacker )
      else

      end
    end
    stacker()
  end
end;
function private.Show_Global_Vars()
  local m = {}
  for k, v in pairs(_G ) do
    table.insert( m, k )
  end;
  table.sort( m )
  --for i = 1, #m do
    ld.LogTrace( m )
  --end
end
function private.Show_SmartHint()
  ld.LogTrace( "common_impl.smart_hint", common_impl.smart_hint )
  ld.LogTrace( "common_impl.smart_hint_connections", common_impl.smart_hint_connections )
end

function private.Get_all_puzzles()
  
  for i=1,#ng_global.achievements.puzzle do
    ng_global.achievements.puzzle[i] = true
  end
end

function private.TimeWarp()
  if private.TimeWarp_count then
    ne.SetTestMode( 0 )
    private.TimeWarp_count = false
  else
    ne.SetTestMode( 1, 2.5 )
    private.TimeWarp_count = true
  end
end