-- name=int_blackbartext_impl
--******************************************************************************************
function public.Init()

  public.DIRECTION = 0;

  private.SHOW_ANIM_TIME = 0.3;
  private.HIDE_ANIM_TIME = 0.3;

  ObjSet( "obj_int_blackbartext_transpanent", {
    event_mdown = function () int_blackbartext.MouseDown(); end
  } );

end;
--******************************************************************************************
function public.ShowAnim( event_id )
  
  local trg = function () int_blackbartext.EventAnimEnd( event_id ); end;
  local tme = private.SHOW_ANIM_TIME;

  -- >>>> показ спрайта на блэкбаре + липсинк >>>>
  local fast_hide = false
  local childs = ObjGetRelations( "obj_int_blackbartext_character_root" ).childs
  ObjSet( "txt_int_blackbartext", { pos_x = 0, maxwidth = 1024 } )
  for i = 1, #childs do
    ObjDetach( childs[ i ] );
  end;
  if common_impl.bbt_character then
    local o = ObjGet( "spr_int_blackbartext_character_"..common_impl.bbt_character )
    if o then
      ObjAttach( "spr_int_blackbartext_character_"..common_impl.bbt_character, "obj_int_blackbartext_character_root" )
      ObjSet( "txt_int_blackbartext", { pos_x = 50, maxwidth = 924 } )
    end;
    if common_impl.bbt_voice then
      if not ObjGet( "tmr_int_blackbartext_voice_"..common_impl.bbt_voice ) then
        local zrm = common.GetCurrentSubRoom() or common.GetCurrentRoom();
        local ov = ObjGet( "vid_"..(zrm:sub(4)).."_"..common_impl.bbt_voice:gsub("^aud_","vid_") )
        if ov then
          fast_hide = true;
          ObjAttach( ov.name, zrm )
          ObjAnimate( ov.name, 8,0,0, _, { 0,0,ov.alp, private.SHOW_ANIM_TIME,2,1 } )
          VidPlay( ov.name, int_blackbartext.Hide )
          if common_impl.bbt_voice_vid_changer then
            local oh = ObjGet( common_impl.bbt_voice_vid_changer )
            if oh then
              ObjAnimate( oh.name, 8,0,0, _, { 0,0,oh.alp, private.SHOW_ANIM_TIME,1,0 } )
            end;
          end;
          --local ot = ObjGet( "txt_int_blacbartext_character_continue" )
          --ObjAnimate( ot.name, 8,0,0, _, { 0,0,ot.alp, private.SHOW_ANIM_TIME/2,0,1 } )
        end;
        SoundVoice( common_impl.bbt_voice:gsub("^vid_","aud_") )
      end;
      ObjDelete( "tmr_int_blackbartext_voice_"..common_impl.bbt_voice )
      ld.StartTimer( "tmr_int_blackbartext_voice_"..common_impl.bbt_voice , 1, function()  end )
    end;
  end
  common_impl.bbt_character = false
  --чтоб небыло раздвоений при быстрых прокликов
  if fast_hide then
    trg()
    trg = nil;
  end
  -- <<<< показ спрайта на блэкбаре + липсинк <<<<


  ObjAnimate( "int_blackbartext_impl", "alp", 0, 0, trg,
  {
    0.0, 3, 0,
    tme, 3, 1
  } );

end;
--******************************************************************************************
function public.HideAnim( event_id )

  -- >>>> показ спрайта на блэкбаре + липсинк >>>>
    public.HideLipSink()
  -- <<<< показ спрайта на блэкбаре + липсинк <<<<

  local trg = function () int_blackbartext.EventAnimEnd( event_id ); end;
  local alp = ObjGet( "int_blackbartext_impl" ).alp
  local tme = (alp)*private.HIDE_ANIM_TIME;

  ObjAnimate( "int_blackbartext_impl", "alp", 0, 0, trg,
  {
    0.0, 3, alp,
    tme, 3, 0
  } );

end;
--******************************************************************************************
function public.WideScreenUpdate()

  if ( not GetWideScreen() ) then

    --

  else

    --

  end;

end;
--******************************************************************************************
function public.HideLipSink( zrm )
  -- >>>> показ спрайта на блэкбаре + липсинк >>>>
    if common_impl.bbt_voice then
      local close_zz = zrm and true or false
      zrm = zrm or common.GetCurrentSubRoom() or common.GetCurrentRoom();
      local ov = ObjGet( "vid_"..(zrm:sub(4)).."_"..common_impl.bbt_voice:gsub("^aud_","vid_") )
      if ov then
        VidPause( ov.name, 1 )
        if close_zz then
          ObjAnimate( ov.name, 8,0,0, _, { 0,0,ov.alp, private.HIDE_ANIM_TIME,1,0 } )
          ld.StartTimer( private.HIDE_ANIM_TIME, function() ObjDetach( ov.name ); VidStop( ov.name ) end )
        else
          ObjAnimate( ov.name, 8,0,0, function() ObjDetach( ov.name ); VidStop( ov.name ) end, { 0,0,ov.alp, private.HIDE_ANIM_TIME,1,0 } )
        end;
        if common_impl.bbt_voice_vid_changer then
          local oh = ObjGet( common_impl.bbt_voice_vid_changer )
          if oh then
            if close_zz then
              ObjAnimate( oh.name, 8,0,0, _, { 0,0,oh.alp, private.HIDE_ANIM_TIME,2,1 } )
              ld.StartTimer( private.HIDE_ANIM_TIME, function() ObjSet( oh.name, { alp = 1 } ) end )
            else
              ObjAnimate( oh.name, 8,0,0, _, { 0,0,oh.alp, private.HIDE_ANIM_TIME,2,1 } )
            end
            if common_impl.bbt_voice_func_end then
              common_impl.bbt_voice_func_end()
            end;
          end;
          common_impl.bbt_voice_vid_changer_old = common_impl.bbt_voice_vid_changer
          common_impl.bbt_voice_vid_changer = false
        end;
        --local ot = ObjGet( "txt_int_blacbartext_character_continue" )
        --ObjAnimate( ot.name, 8,0,0, _, { 0,0,ot.alp, private.HIDE_ANIM_TIME/2,0,0 } )
      end;
      common_impl.bbt_voice_old = common_impl.bbt_voice
      common_impl.bbt_voice = false
      SoundVoice( 0 )
    end;
  -- <<<< показ спрайта на блэкбаре + липсинк <<<<
end;