-- name=int_panelhopair
--******************************************************************************************
function public.Init (pos_z)
  ObjAttach( "int_panelhopair", interface.originhub );
  ObjSet( "int_panelhopair", { pos_z = pos_z } );
  MsgSubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );
  


  public.MOUSE_OVER_ANIM_TIME=0.3
  public.MOVE_ANIM_TIME = 0.5

  public.MOVE_ANIM_POS_Y_TOP = 691;
  public.MOVE_ANIM_POS_Y_BOT = 845;
  private.ForceHide()
end;
function private.ForceHide()
  ObjSet( "int_panelhopair", { pos_y = private.MOVE_ANIM_POS_Y_BOT } );
end;
--******************************************************************************************
function public.Destroy()

  MsgUnsubscribe( Command_Interface_UpdateTextures, private.WideScreenUpdate );

end;
--******************************************************************************************
function private.MouseDown()

 -- DbgTrace("clk_panelhopair")
  --interface.DiaryShow()

end;
--******************************************************************************************
function private.WideScreenUpdate()

end;
--******************************************************************************************




function public.ShowAnim(event_id)
  ObjSet( "int_panelhopair", { active = 1, visible = 1 } );
  local trg = function() public.EventAnimEnd( event_id ); end

  local tme = public.MOVE_ANIM_TIME;

  ObjAnimate( "int_panelhopair", 1, 0, 0, trg,
  {
    0.0, 2, public.MOVE_ANIM_POS_Y_BOT,
    tme, 2, public.MOVE_ANIM_POS_Y_TOP
  } );

 -- ObjSet("obj_int_button_lock", {input=0});
end;

function public.HideAnim(event_id)
  local trg = function()public.EventAnimEnd(event_id );end

  local tme = public.MOVE_ANIM_TIME;
  public.ClearTask()
  ObjAnimate( "int_panelhopair", 1, 0, 0, trg,
  {
    0.0, 1, public.MOVE_ANIM_POS_Y_TOP,
    tme, 1, public.MOVE_ANIM_POS_Y_BOT
  } );

  --ObjSet("obj_int_button_lock", {input=1});
end;


function public.EventAnimEnd(event_id)

------------------------------------------------------------------------------------
  if ( event_id == "show" ) then
    ObjSet( "int_panelhopair", { input = 1 } );

------------------------------------------------------------------------------------
  elseif ( event_id == "hide" ) then
    ObjSet( "int_panelhopair", { active = 0, visible = 0,input = 0 } );
  end
    
end



--int.panelhopair = {}
--int.panelhopair.MOVE_ANIM_TIME     = 0.5;
--int.panelhopair.MOVE_ANIM_POS_Y_TOP = 694;
--int.panelhopair.MOVE_ANIM_POS_Y_BOT = 778;




function public.EventAnimEnd( event_id )

 -- local event_params = public.event_anim_end[ event_id ];

------------------------------------------------------------------------------------
  if ( event_id == "show" ) then
    ObjSet( "int_panelhopair", { input = 1 } );

------------------------------------------------------------------------------------
  elseif ( event_id == "hide" ) then
    ObjSet( "int_panelhopair", { active = 0, visible = 0,input = 0 } );
  end
end



function public.SendTask(ho_name,task_name,num)
  local count = interface.panelhopair.taskname_pair

  if task_name == ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].wintask then
    count = "wintask"
  end
  local res
  local ce = ""
  if ng_global.currentprogress == "ext" then
    ce="ext"
  elseif ng_global.currentprogress == "scr" then
    ce="scr"
  end
  local item_name = "spr_int_panelhopair_"..count
  if num then
   res = "assets/levels/level"..ce.."/ho_"..ho_name.."/"..task_name..num.."_contour"
  else
   res = "assets/levels/level"..ce.."/ho_"..ho_name.."/"..task_name.."_contour"
  end

  ObjDelete(item_name)
  ObjCreate( item_name, "spr" );
  ObjSet( item_name , {input=0, res = res,alp=0} );
  ObjAttach(item_name,"obj_int_panelhopair_"..count)
  ObjAnimate( item_name, 8, 0, 0, "", {0,0,0, 0.2,0,1} );
  --ObjSet( "fx_int_panelhopair_"..count, {active = 1} );
 -- PartSysStart("fx_int_panelhopair_"..count)
  ObjStopAnimate("txt_int_panelhopair",8)
  ObjSet( "txt_int_panelhopair", {alp=0} );

end

function public.ClearTask()
  ObjDelete("spr_int_panelhopair_1")
  ObjDelete("spr_int_panelhopair_2")
  ObjDelete("spr_int_panelhopair_wintask")  
  --PartSysStart("fx_int_panelhopair_1")
  --PartSysStart("fx_int_panelhopair_2")
  ObjStopAnimate("txt_int_panelhopair",8)

  ObjSet( "txt_int_panelhopair", {alp=1} );

end

function public.CompliteTask(ho_name,task_name,assoc)
  --public.ClearTask()
  ld.Lock(1)
  public.AnimLights(ho_name)
  ObjAnimate( "obj_int_panelhopair_1", 0, 0, 0, "", {0,0,-170, 0.4,0,0} );
  ObjAnimate( "obj_int_panelhopair_2", 0, 0, 0, function() ObjSet( 'fx_int_panelhopair_complite', {active=1} );PartSysStart('fx_int_panelhopair_complite')end, {0,0, 170, 0.4,0,0} );
  ObjAnimate( "spr_int_panelhopair_1", 8, 0, 0, "", {0.4,0,1, 0.8,0,0} );
  ObjAnimate( "spr_int_panelhopair_2", 8, 0, 0, function() public.CompliteTask_end() end, {0.4,0,1, 0.8,0,0} );
  
  ObjAnimate( "txt_int_panelhopair", 8, 0, 0, "", {0.8,0,0, 1.3,0,1} );
    local count = 6
   -- local ho_name = cmn.GetObjectName( GetCurrentRoom() );
    local ho_found =  ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found;
    for i = 1,#ho_found, 1 do
       count = count - 1
    end
    if count == 0 then
      ObjSet( "txt_int_panelhopair", {text = ""} );
    else 
      if assoc then
        ObjSet( "txt_int_panelhopair", {text = "str_int_panelhopair_associations",param0 = count} );
      else
        ObjSet( "txt_int_panelhopair", {text = "str_int_panelhopair",param0 = count} );
      end    
      
    end


end

function public.CompliteTask_end()
  ld.Lock(0)
  
  ObjSet( "obj_int_panelhopair_1", {pos_x=-170} );
  ObjSet( "obj_int_panelhopair_2", {pos_x= 170} );
  ObjDelete("spr_int_panelhopair_1")
  ObjDelete("spr_int_panelhopair_2")
  
  
end


function public.AnimLights(ho_name)

  local ho_found =  ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found;
  local count = 0
  for i = 1,#ho_found, 1 do
    count = count + 1
  end
  
  ObjAnimate( "spr_int_panelhopair_check_light_"..count, 8, 0, 0, "", {0,0,0, 0.5,0,1} );

  ObjSet( "fx_panelhopair_fx_light", {pos_x=ObjGet("spr_int_panelhopair_check_light_"..count).pos_x,pos_y=ObjGet("spr_int_panelhopair_check_light_"..count).pos_y,active = 1} );
  PartSysStart("fx_panelhopair_fx_light")

end


function public.LoadLights(ho_name,assoc)
    local count = 6
    local ho_found =  ng_global.progress[ ng_global.currentprogress ][ "win_"..ho_name ].found;
    for i = 1,#ho_found, 1 do
      ObjSet( "spr_int_panelhopair_check_light_"..i, {alp=1} )
      count = count - 1
    end
    for j = #ho_found+1,6 do
      ObjSet( "spr_int_panelhopair_check_light_"..j, {alp=0} )
    end
    if count == 0 then
      ObjSet( "txt_int_panelhopair", {text = ""} );
    else 
      if assoc then
        ObjSet( "txt_int_panelhopair", {text = "str_int_panelhopair_associations",param0 = count} );
      else
        ObjSet( "txt_int_panelhopair", {text = "str_int_panelhopair",param0 = count} );
      end  
    end
end


-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------

--[[

-------------------------------------------------------------------------------------
local message_type   = tonumber( ne_params.param_0 );
local message_params = ne_params.table;
-------------------------------------------------------------------------------------
if ( message_type == Command_PanelHoPair_Show ) then

  ObjSet( "int_panelhopair", { active = 1, visible = 1 } );


    local event_id = "show";
    --int.panelhopair.event_anim_end[ event_id ] = {};
    int.panelhopair.ShowAnim( event_id );
elseif ( message_type == Command_PanelHoPair_Hide ) then
      local event_id = "hide";
     -- int.panelhopair.event_anim_end[ event_id ] = {};
      int.panelhopair.HideAnim( event_id );
elseif ( message_type == Command_PanelHoPair_CompliteTask ) then
       local ho_name   = message_params[ "ho_name" ];
       local task_name = message_params[ "task_name" ];
       local assoc     = message_params[ "assoc" ];
       int.panelhopair.CompliteTask(ho_name,task_name,assoc)
elseif ( message_type == Command_PanelHoPair_SendTask) then
       local ho_name   = message_params[ "ho_name" ];
       local task_name = message_params[ "task_name" ];
       local num       = message_params[ "num" ];
       int.panelhopair.SendTask(ho_name,task_name,num)
elseif ( message_type == Command_PanelHoPair_ClearTask) then
      int.panelhopair.ClearTask()
elseif ( message_type == Command_PanelHoPair_LoadLights) then
       local ho_name   = message_params[ "ho_name" ];
       local assoc     = message_params[ "assoc" ];
      int.panelhopair.LoadLights(ho_name,assoc)
end


]]