-- name=room_impl
--********************************************************************************************************************
function public.Init()

  public.VIA_BLACK_SCREEN = true;
  public.BLACK_NAME = "spr_room_black_screen";
  public.FADE_TIME = 1;

end;
--********************************************************************************************************************
function public.Hide( event_id, obj_name )

  local trg = function()

    --common_impl.VidStaticEvent( "Close", obj_name );
  -->>
    --common_impl.ZRMeventRun( "PreCloseBefore", obj_name );
  --<<

    room.EventAnimEnd( event_id );

  end;

  ObjAnimate( obj_name, "alp", 0, 0, trg, {0,0,1, public.FADE_TIME,0,0} );

  -->>
    --common_impl.ZRMeventRun( "PreCloseAfter", obj_name );
  --<<

end;
--********************************************************************************************************************
function public.Show( event_id, obj_name )

  -->>автохайд инвенторя в МГ, чтобы нельзя было открыть деплой с мг, когда активна МГ
  if obj_name and obj_name:find("^mg_") then
    local prg = "win_"..common.GetObjectName( obj_name );
    if not cmn.IsEventDone( prg ) and cmn.IsEventStart( prg ) then
      interface.WidgetSetInput( InterfaceWidget_Inventory, false );
      interface.WidgetSetVisible( InterfaceWidget_Inventory, false, true );
    end;
  end;  
  --<<    

  local trg = function() 

    -->> запуск муз сопровождения
    if ( private.SoundBackThemePlaying == nil )
    and ( obj_name )
    and ( not obj_name:find("^ho_") )
    --and (  obj_name ~= "rm_credits" )
    then
      common_impl.SoundBackTheme( true )
    end
    --<<
    room.EventAnimEnd( event_id );
  end;
  ObjAnimate( obj_name, "alp", 0, 0, trg, {0,0,0, public.FADE_TIME,0,1} );

end;
--********************************************************************************************************************
function public.HideBlack( event_id )

  -->>автохайд инвенторя в МГ, чтобы нельзя было открыть деплой с мг, когда активна МГ
  -->>срабатывает если загружаемся в сразу в МГ
  local obj_name = common.GetCurrentRoom();
  if obj_name and private.ShowBlackMg ~= obj_name and obj_name:find("^mg_") and ObjGet( obj_name ) then
    local prg = "win_"..common.GetObjectName( obj_name );
    if not cmn.IsEventDone( prg ) and cmn.IsEventStart( prg ) then
      interface.WidgetSetInput( InterfaceWidget_Inventory, false );
      interface.WidgetSetVisible( InterfaceWidget_Inventory, false, false );
    end;
  end;  
  --<<  

  local trg = function() 

    -->> запуск муз сопровождения
    if ( private.SoundBackThemePlaying == nil )
    and ( obj_name )
    and ( not obj_name:find("^ho_") )
    --and (  obj_name ~= "rm_credits" )
    then
      common_impl.SoundBackTheme( true )
    end
    --<<
    room.EventAnimEnd( event_id ); 
    common_impl.LockRm( 0 );
  end;
  
  --port.
  ObjSet("spr_room_black_screen",{ pos_x = 512, pos_y = 384, scale_x = 21.3438, scale_y = 12 });
  
  ObjAnimate( public.BLACK_NAME, "alp", 0, 0, trg, {0,0,1, public.FADE_TIME/2,0,0} );

end;
--********************************************************************************************************************
function public.ShowBlack( event_id )

  -->>автохайд инвенторя в МГ, чтобы нельзя было открыть деплой с мг, когда активна МГ
  local obj_name = common.GetCurrentRoom();
  if obj_name and obj_name:find("^mg_") and ObjGet( obj_name ) then
    private.ShowBlackMg = obj_name
    local prg = "win_"..common.GetObjectName( obj_name );
    if not cmn.IsEventDone( prg ) and cmn.IsEventStart( prg ) then
      interface.WidgetSetInput( InterfaceWidget_Inventory, false );
      interface.WidgetSetVisible( InterfaceWidget_Inventory, false, true );
    end;
  end;  
  --<<  

  local trg = function()

    room.EventAnimEnd( event_id );

  end;
  
  --port.
  ObjSet("spr_room_black_screen",{ pos_x = 512, pos_y = 384, scale_x = 21.3438, scale_y = 12 });
  
  ObjAnimate( public.BLACK_NAME, "alp", 0, 0, trg, {0,0,0, public.FADE_TIME/2,0,1} );
  common_impl.LockRm( 1 )

end;
--********************************************************************************************************************