-- name=mg_seedmg
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_seedmg";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_seedmg" ] = {type = "win", use_place = "mg_seedmg", room = "rm_mansion", zz = "mg_seedmg", zz_gate = "gmg_mansion_seedmg" };

  local win_seedmg_logic = function()
    if ld.CheckRequirements( {"win_seedmg"} ) then
      
    end
  end;
  local win_seedmg = function()
    if ld.CheckRequirements( {"win_seedmg"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_seedmg", win_seedmg, private.room_objname )
  cmn.AddSubscriber("win_seedmg", win_seedmg_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------
common_impl.hint[ "get_diamond" ] = { type = "get", get_obj = "spr_seedmg_diamond", room = "rm_mansion", zz = "mg_seedmg", zz_gate = "gmg_mansion_seedmg" };

private.get_diamond_logic = function()
  int_simon.SimonSetVisible(1)
end;
private.get_diamond_inv = function()

  interface.InventoryItemAdd("inv_diamond","spr_seedmg_diamond");
end;
private.get_diamond_beg = function()
  ObjDelete("gfx_seedmg_diamond")
end;
private.get_diamond_end = function()

end;

cmn.AddSubscriber( "get_diamond", private.get_diamond_inv );
cmn.AddSubscriber( "get_diamond", private.get_diamond_beg, private.room_objname );
cmn.AddSubscriber( "get_diamond", private.get_diamond_end, private.room_objname );
cmn.AddSubscriber( "get_diamond", private.get_diamond_logic );
cmn.AddSubscriber( "get_diamond_beg", private.get_diamond_inv );
cmn.AddSubscriber( "get_diamond_beg", private.get_diamond_beg, private.room_objname );
cmn.AddSubscriber( "get_diamond_end", private.get_diamond_end, private.room_objname );
cmn.AddSubscriber( "get_diamond_end", private.get_diamond_logic );
--------------------------------------------------------------------
function public.get_diamond()
  cmn.SetEventDone( "get_diamond" );
  cmn.CallEventHandler( "get_diamond_beg" );
  ld.Lock( 1 )
  ObjSet( "anm_seedmg_anm_body", { animfunc = "fool"; playing = 0; frame = 0; } )
  ObjSet( "anm_seedmg_anm_hands", { animfunc = "m"; playing = 0; frame = 0; } )
  int_inventory.StdItemFlyAnimation( "anm_seedmg_anm_body", "obj_int_button_map_point_for_cube", function()
    ObjDelete( "anm_seedmg_anm_body" )
    cmn.CallEventHandler( "get_diamond_end" );
    interface.SimonReturn()
    ld.Lock( 0 )
  end );
  if common_impl.ZzCompleteCheck( "get_diamond" ) then cmn.GotoRoom( "rm_mansion" ); end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  
  if not ld.CheckRequirements( {"win_seedmg"} ) then
    SoundMgTheme( true )
    cmn.MiniGameShow( "seedmg" );
  end;
end;
--*********************************************************************************************************************
function public.PreOpen()
  iOS_NeedDrag(0);
  SoundEnv( "aud_mg_casket_1_env" );
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_seedmg"} ) then
    cmn.MiniGameHide( "seedmg" );
    SoundMgTheme( false )
  end;
  iOS_NeedDrag(1);
end;
--*********************************************************************************************************************
function public.PreClose()

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  ld.Lock( 1 )
  ObjSet( "obj_seedmg_arrow_root", { pos_z = 3 } )
  local o = ObjGet( "obj_seedmg_block_root" )
  local t = ( ( 800 - o.pos_y ) / 400 ) ^ 0.75

    gm.gun_disarm()

  SoundSfx( "aud_reset_seedmg_fall" )

  ObjAnimate( o.name, 1,0,0, function() 


    for j = 1, #gm.map do
      for i = 1, #gm.map[ j ] do
        if gm.map[ j ][ i ].type > 0 then
          gm.destroyed[ gm.map[ j ][ i ].type ] = gm.destroyed[ gm.map[ j ][ i ].type ] or {}
          table.insert( gm.destroyed[ gm.map[ j ][ i ].type ], gm.map[ j ][ i ] )
          
        end;
      end;
    end;




    gm.default()

    gm.blocks_build( gm.map )
    gm.blocks_set_pos()
    gm.gun_init( true )
    gm.blocks_free_line_checker()

    for k, v in pairs( gm.destroyed ) do
      for kk, vv in pairs( v ) do
        ObjDetach( vv.obj )
      end
    end

    gm.blocks_root_pos_y_normer( true )
    gm.get_random_init()

    gm.gun_shooting = false
    gm.save()
    ld.Lock( 0 )

  end, { 0,0,o.pos_y, t,1,800 } ) 
end;
--*********************************************************************************************************************
function public.Skip()
  port.skip_mg = true;
  ld.Lock( 1 )
  gm.gun_shoot_end( false, true )
end;
--*********************************************************************************************************************
function private.WinEnd()
  gm.WinCount = gm.WinCount - 1
  if gm.WinCount == 0 then
    gm.manager_clear()
    ld.Lock(0);
    cmn.SetEventDone( "win_seedmg" );
    cmn.CallEventHandler( "win_seedmg" );
    public.get_diamond()
    interface_impl.ShowMgAchievements();
    ld.LockCustom( "mg_seedmg_gun_anims", 0 )
    ld.LockCustom( "mg_seedmg_blocks_root_pos_y_normer", 0 )
  end
end;
--*********************************************************************************************************************
function private.Win()
  
  if gm.gun_loading then
    return
  end
  SoundSfx( "aud_win_seedmg" )
  local o = ObjGet( "spr_seedmg_arrow2_light" )
  ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp) / 2,0,0 } )
  gm.WinCount = 2
  ld.Lock(1);

  cmn.MiniGameHide();
  SoundMgTheme( false )

  ObjSet( "obj_seedmg_arrow_root", { pos_z = 3 } )

  SoundSfx( "aud_win_seedmg" )

  local o = ObjGet( "obj_seedmg_block_root" )
  local t = ( ( 800 - o.pos_y ) / 400 ) ^ 0.75
  ObjAnimate( o.name, 1,0,0, private.WinEnd, { 0,0,o.pos_y, t,1,800 } ) 

  local o = ObjGet( gm.win_block_obj )  
  local p1 = GetObjPosByObj( o.name, "mg_seedmg" )
  local p2
  if gm.gun_blocks[ 1 ] then
    p2 = GetObjPosByObj( gm.gun_blocks[ 1 ].obj, "mg_seedmg" )
    gm.gun_disarm()
  else
    ObjSet( o.name, { pos_x = 0; pos_y = 0; anim_tag = "tag_left" } )
    ObjAttach( o.name, "anm_seedmg_anm_hands" )
    p2 = GetObjPosByObj( o.name, "mg_seedmg" )
  end
  ObjAttach( o.name, "mg_seedmg" )
  ObjSet( o.name, { pos_z = 33; } )
  local dx = p1[ 1 ] - p1[ 1 ]
  local dy = p1[ 2 ] - p2[ 2 ]
  local t = math.abs( dy ) / 500

  ObjAnimate( o.name, 0,0,0, _, { 0,0,p1[ 1 ], t,0,p2[ 1 ] } )
  ObjAnimate( o.name, 1,0,0, function() 
    local p = GetObjPosByObj( o.name, "mg_seedmg" )
    ObjSet( "spr_seedmg_diamond", { pos_x = p[ 1 ]; pos_y = p[ 2 ]; visible = 1; } )
    ObjDelete( o.name )
    
    private.WinEnd()
  end, { 0,0,p1[ 2 ], t*0.1,2,p1[ 2 ] - 25, t,1,p2[ 2 ] } )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then

    gm.clrs = {
      {
        color_r = 1;
        color_g = 0;
        color_b = 0;
      };
      {
        color_r = 0;
        color_g = 1;
        color_b = 0;
      };
      {
        color_r = 0.55;
        color_g = 0.55;
        color_b = 1;
      };
      {
        color_r = 1;
        color_g = 1;
        color_b = 0;
      };
    }

    gm.manager_obj_init( "cross", "spr", "mg_seedmg", {
      res = "assets/levels/level/mg_seedmg/diamond";
      input = 0;
      scale_x = 0.25;
      scale_y = 0.25;
    } )
  
    gm.manager_obj_init( "text", "text", "mg_seedmg", {
      res = "assets/fonts/arial";
      input = 0;
    } )

    gm.manager_obj_init( "block_fly_fx", "partsys", "obj_seedmg_block_root", {
      res = "assets/levels/level/mg_seedmg/fx_fly";
      input = 0;
      pos_z = 199;
    } )

    gm.manager_obj_init( "block_blow_fx", "partsys", "obj_seedmg_block_root", {
      res = "assets/levels/level/mg_seedmg/glass_fx2";
      input = 0;
      pos_z = 99;
    } )

    gm.default()

    local full_level = true
    if ng_global.progress["std"]["win_seedmg"].state then
      gm.map = ld.TableCopy( ng_global.progress["std"]["win_seedmg"].state.map )
      gm.gun_chain = ld.TableCopy( ng_global.progress["std"]["win_seedmg"].state.gun_chain )
      gm.gun_charges = ng_global.progress["std"]["win_seedmg"].state.gun_charges
      full_level = false
    end
    
    gm.build()

    gm.blocks_build( gm.map )
    gm.blocks_set_pos()
    gm.gun_init( full_level )
    gm.blocks_free_line_checker()
    gm.blocks_root_pos_y_normer( full_level )
    gm.get_random_init()

    gm.static_player( "anm_seedmg_anm_body", { "static3", "static3", "static3","static3", "static1", "static1", "static2" } )

    gm.blocks_root_listener( true )

    gm.loaded  = true;
  else
  
  end;
end
--*********************************************************************************************************************
function gm.default()

  gm.BLOCK_TYPES = 4
  gm.X = 170;
  gm.Y = 50;
  gm.W = 37;
  gm.R = 15;
  gm.WFX = 200;
  gm.ROOT_BLOCK = "obj_seedmg_block_root"
--  gm.ROOT_FX = "obj_battle_root_fx"
--  gm.ROOT_TRASH = "obj_battle_root_trash"
--

  gm.borders = {
    pos_x = 512;
    pos_y = 384;
    croprect_x = -290;
    croprect_y = -2950;
    croprect_w = 580;
    croprect_h = 3800;
  }

  gm.J_ZERO = 12;  --количество отоброжаемых линий
  gm.root_dy = 0

  gm.SPEED = 900

  --gm.ARROW_POS = { 512, 600 }

  gm.gun_chain  = { 1, 2 }
  gm.gun_charges = 62

  gm.pole = {
    "xxxxxxxxxxxxxxxxx";
    "x000000011000000x";
    "x000034151430000x";
    "x000003411430000x";
    "x000003424300000x";
    "x000000322300000x";
    "x000000424000000x";
    "x000000244200000x";
    "x000003222300000x";
    "x000002333320000x";
    "x000012222210000x";
    "x000021111112000x";
    "x000422222224000x";
    "x000244444444200x";
    "x003222222222200x";
    "x002333331122230x";
    "x022222113333320x";
    "x022222244222222x";
    "x000004111400000x";
    "x000004000040000x";
    "x000040030040000x";
    "x001104333340110x";
    "x013134030431310x";
    "x001330433403310x";
    "x033300030003330x";
    "x044033011033044x";
    "x434001232100434x";
    "x003001322310030x";
    "x333313333313333x";
    "x003001322310030x";
    "x434001232100434x";
    "x044033011033044x";
    "x033300030003330x";
    "x001330433403310x";
    "x413134030431310x";
    "x341104333340110x";
    "x340004030400000x";
    "x234000400420200x";
    "x233000303022000x";
    "x123400033224220x";
    "x113403313322404x";
    "x412240233121244x";
    "x412342323114434x";
    "x341234221131144x";
    "x341234000110404x";
    "x234121400131300x";
    "x223331400033000x";
    "x113412330330330x";
    "x123412340233000x";
    "x412341234232300x";
    "x412341234220000x";
    "x041234222400000x";
    "x041234113300000x";
    --"x004123412340000x";
    --"x004222112340000x";
    --"x000411341234000x";
    --"x000412341234000x";
    --"x000041234323300x";
    --"x000041234111400x";
    --"x000004123412340x";
    --"x000004121412340x";
    --"x000000312331234x";
    --"x000000442344230x";
    --"x000000041134123x";
    --"x000000041234120x";
    --"x000000004123412x";
    --"x000000004123410x";
    --"x000000000412341x";
    "xxxxxxxxxxxxxxxxx";
  }
  gm.map = {};
  local w
  local v
  for j = 1, #gm.pole do
    w = gm.pole[ j ]:len()
    gm.map[ j ] = {}
    for i = 1, w do
      v = gm.pole[ j ]:sub( i, i )
      gm.map[ j ][ i ] = {};
      gm.map[ j ][ i ].type = 0;
      if v == "x" then
        gm.map[ j ][ i ].type = -2
      elseif v == "0" then
        gm.map[ j ][ i ].type = -1
      elseif v~= "0" and tonumber( v ) then
        gm.map[ j ][ i ].type = tonumber( v )
      end
    end
  end
  gm.J_DEFAULT = #gm.map
end
--*********************************************************************************************************************
function gm.save()
  if ( not gm.gun_loading ) and ( not gm.gun_shooting ) and ( not gm.gun_changing ) then
    --ld.LogTrace( "SAVING" )
    ng_global.progress["std"]["win_seedmg"].state = { 
      map = ld.TableCopy( gm.map );
      gun_chain = { gm.gun_blocks[ 1 ].type, gm.gun_blocks[ 2 ] and gm.gun_blocks[ 2 ].type or 0 };
      gun_charges = gm.gun_charges + #gm.gun_blocks;
    }
  end
end;
--*********************************************************************************************************************
function gm.build()
  --ObjSet( "obj_seedmg_input_root", {
  --  event_mdown = function() ObjStartDrag( "obj_seedmg_input_drag" ) end;
  --} )

  local platform = GetPlatform();
  if ( platform == "android" ) or ( platform == "ios" ) then
    ObjSet( "obj_seedmg_input_root", {
      event_mdown = function() ObjStartDrag( "obj_seedmg_input_drag" ) end,
    } )
    ObjSet( "obj_seedmg_input_drag", {
      realdrag = 1;
      drag = 1;
      event_startdrag = gm.event_startdrag;
      event_drag = function() gm.event_drag() end;
      event_dragdrop = gm.event_dragdrop;
    } );
  else
    ObjSet( "obj_seedmg_input_root", {
      event_mdown = function() ObjStartDrag( "obj_seedmg_input_drag" ) end;
    } );
    ObjSet( "obj_seedmg_input_drag", {
      realdrag = 1;
      drag = 1;
      event_startdrag = gm.event_startdrag;
      event_drag = function() gm.event_drag() end;
      event_dragdrop = function() gm.event_dragdrop(); end;
    } );
    --ObjSet( "obj_seedmg_input_root", {
    --  event_menter = function() gm.event_menter() end;
    --  event_mleave = function() gm.event_mleave() end;
    --  event_mdown = function() gm.event_dragdrop() end;
    --  } );
  end;

  ObjSet( "spr_seedmg_gg", { pos_y = gm.get_pos_y( 1 ) + 5 } )

  local menter = function() 
    ld.ShCur(CURSOR_HAND)
    local o = ObjGet( "spr_seedmg_arrow2_light" )
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (0.5-o.alp) / 2,0,0.5 } )
  end
  local mleave = function() 
    ld.ShCur(CURSOR_DEFAULT)
    local o = ObjGet( "spr_seedmg_arrow2_light" )
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp) / 2,0,0 } )
  end

  ObjSet( "obj_seedmg_gun_root", {
    input = 1;
    event_mdown = gm.gun_change;
    event_menter = menter;
    event_mleave = mleave;
  } )
  ObjSet( "obj_seedmg_gun_root_2", {
    input = 1;
    event_mdown = gm.gun_change;
    event_menter = menter;
    event_mleave = mleave;
  } )
end
--*********************************************************************************************************************
function gm.blocks_build( map )
  gm.destroyed = gm.destroyed or {}
  math.randomseed(7);
  for j = 1, #map do
    for i = 1, #map[ j ] do
      if map[ j ][ i ].type > 0 then
        map[ j ][ i ] = gm.block_new( gm.map[ j ][ i ].type, true );
      elseif map[ j ][ i ].type == 0 then
        map[ j ][ i ] = gm.block_new();
      end;
    end;
  end;
end;
--*********************************************************************************************************************
function gm.block_new( type_value, building, trash )
  type_value = type_value or math.random(1,gm.BLOCK_TYPES)
  if not building and type_value == 5 and not trash then
    --if math.random( 1, 100 ) < 60 then
      type_value = math.random(1,gm.BLOCK_TYPES-1)
    --end;
  end;

  gm.destroyed[ type_value ] = gm.destroyed[ type_value ] or {}

  if gm.destroyed[ type_value ] and #gm.destroyed[ type_value ] > ( trash and 12 or 0 )  then

    ObjSet( gm.destroyed[ type_value ][ 1 ].obj , { scale_x = 1; scale_y = 1; pos_x = 0; pos_y = 0; pos_z = 0; ang = 0; anim_tag = "" } );
    ObjAttach( gm.destroyed[ type_value ][ 1 ].obj, "obj_seedmg_block_root" )

    return table.remove( gm.destroyed[ type_value ], 1 );

  else

    gm.block_counter = gm.block_counter or 1
    local b = {};
    b.id = gm.block_counter;
    b.obj = "obj_seedmg_block_"..gm.block_counter;
    b.type = type_value;

    ObjCreate( b.obj, "spr" )
    ObjSet( b.obj, {  
      res = "assets/levels/level/mg_seedmg/block"..b.type;
      input = 0;
    } )
    ObjAttach( b.obj, "obj_seedmg_block_root"  )

    if b.type == 5 then
      ObjAttach( "fx_seedmg_diamond_fx", b.obj )
      ObjSet( b.obj, { pos_z = 99 } );
    end

    gm.block_counter = gm.block_counter + 1
    return b;

  end;
end;
--*********************************************************************************************************************
function  gm.blocks_free_line_checker()
  --добавляем пустую линию в конец карты, если таковой нет, чтобы можно было при лепить шарик при необходимости
  local need_line = false
  local j = #gm.map - 1
  for i = 2, #gm.map[ j ] - 1 do
    if gm.map[ j ][ i ].type > 0 then
      need_line = true
      break
    end
  end
  local line = {}
  for i = 2, #gm.map[ j ] - 1 do
    line[ i ] = { type = -1 }
  end
  line[ 1 ] = { type = -2 }
  line[ #gm.map[ j ] ] = { type = -2 }
  table.insert( gm.map, j + 1, line )
  --удаляем лишние пустые линии, чтобы уровень могу опустится при необходимости
  if not need_line then
    local need_remove = true
    local j = #gm.map - 2
    while need_remove and j > 0 do
      for i = 2, #gm.map[ j ] - 1 do
        if gm.map[ j ][ i ].type > 0 then
          need_remove = false
          break
        end
      end
      if need_remove then
        table.remove( gm.map, j )
        j = #gm.map - 2
      end
    end
  end
end;
--*********************************************************************************************************************
function   gm.blocks_set_pos()
  for j = 1, #gm.map do
    for i = 1, #gm.map[ j ] do
      if gm.map[ j ][ i ].type > 0 then
        ObjSet( gm.map[ j ][ i ].obj, { pos_x = gm.get_pos_x( i, j ), pos_y = gm.get_pos_y( j ) } )
      end;
    end;
  end;
end;
--*********************************************************************************************************************
function   gm.blocks_root_pos_y_normer( full_level )
  local o = ObjGet( "obj_seedmg_block_root" )

  local j_map = #gm.map

  if j_map > gm.J_ZERO then
    gm.root_dy = ( gm.J_ZERO - j_map ) * gm.W * 0.9
  else
    gm.root_dy = 0
  end

  if full_level then
    ObjSet( "obj_seedmg_arrow_root", { pos_z = 3 } )
  end

  if full_level == true or full_level == nil then

    ld.LockCustom( "mg_seedmg_blocks_root_pos_y_normer", 1 )

    ObjSet( "fx_seedmg_diamond_fx", { active = 1 } )
    if full_level then
      PartSysRestart( "fx_seedmg_diamond_fx" );
    end

    ld.StartTimer( full_level and 3 or 0, function()
      if full_level then 
        SoundSfx( "aud_reset_seedmg_rise" )
      elseif math.abs( o.pos_y - gm.root_dy ) > 5 then
        SoundSfx( "aud_balls_fall" )
      end
    end )

    local t = math.abs( o.pos_y - gm.root_dy ) / 200
    t = t ^ 0.5 + ( full_level and 3 or 0 )
    --ld.LogTrace( j_map, gm.J_ZERO, dy, t )
    ObjAnimate( o.name, 1,0,0, function() 
      if full_level then
        ObjSet( "obj_seedmg_arrow_root", { pos_z = 1 } )
      end
      gm.blocks_set_pos()
      ld.LockCustom( "mg_seedmg_blocks_root_pos_y_normer", 0 )
      --ld.LogTrace( gm.map )
    end, { 0,0,o.pos_y, full_level and 3 or 0,0,o.pos_y, t,3,gm.root_dy } )

    --ld.StartTimer( full_level and 3, function() 
    --  gm.root_dy >
    --end )

  else
    ObjSet( "obj_seedmg_block_root", { pos_y = gm.root_dy } )
  end

end;
--*********************************************************************************************************************
function gm.blocks_root_listener( force )
  local h = 440
  local step = h / ( gm.J_DEFAULT )
  local pos = math.max( -h, -h + step * ( #gm.map - 3 ) )
  local pos = math.min( 0.001, pos )
  if force then
    ObjSet( "spr_seedmg_path_int_head", { pos_y = pos } )
    ObjSet( "spr_seedmg_path_int_life", { 
      croprect_init = true;
      croprect_x = -32;
      croprect_y = h / 2 / 2 + pos / 2;
      croprect_w = 64;
      croprect_h = math.abs(pos)/2;
    } )
    gm.blocks_root_listener()
  else
    local o = ObjGet( "spr_seedmg_path_int_head" )
    ObjSet( "spr_seedmg_path_int_life", { 
      croprect_y = h / 2 / 2 + o.pos_y / 2;
      croprect_h = math.abs( o.pos_y )/2;
    } )
    --ld.LogTrace( o.pos_y, pos )
    ObjAnimate( o.name, 7,0,0, function() gm.blocks_root_listener() end, { 0,0,0, 0.05,0,0 } )
    ObjAnimate( o.name, 1,0,0, _, { 0,0,o.pos_y, 0.25,3,pos } )
  end
end
--*********************************************************************************************************************
function   gm.blocks_relase_try( y, x, conected )
  --пытаемся уронить шары, которые не держатся цепочкой за второй ряд
  --ld.LogTrace( y, x, conected  )
  local entry = false
  if not conected then
    conected = {}
    --conected[ y.."_"..x ] = { y, x }
    entry = true
    for i = 2, #gm.map[ 2 ] do
      if gm.map[ 2 ][ i ].type > 0 then
        --y = 2
        --x = i
        conected[ "2_"..i ] = true
        --break
        gm.blocks_relase_try( 2, i, conected )
      end
    end
    for j = 1, #gm.map do
      for i = 1, #gm.map[ j ] do
        if gm.map[ j ][ i ].type > 0 and gm.map[ j ][ i ].type < 5 and ( not conected[ j.."_"..i ] ) then
          gm.block_drop( j, i )
        end;
      end;
    end;
  else
    local w = gm.get_ways( y )
    local j, i
    for z = 1, #w do
      i = x + w[ z ][ 1 ]
      j = y + w[ z ][ 2 ]
      if gm.map[ j ][ i ].type > 0 and not conected[ j.."_"..i ] then
        conected[ j.."_"..i ] = true
        gm.blocks_relase_try( j, i, conected )
      end
    end;
  end
end
--*********************************************************************************************************************
function gm.block_blow_try( j, i )
  local blows, count = gm.block_get_blows( j, i )
  if count > 2 then
    for k, v in pairs( blows ) do
      gm.block_destroy( v[ 1 ], v[ 2 ], j, i )
    end
    gm.blocks_relase_try();
    return true
  end
end
--*********************************************************************************************************************
function gm.block_get_blows( y, x, blows, count )
  local b = gm.map[ y ][ x ]
  if not blows then
    count = 1
    blows = {}
    blows[ y.."_"..x ] = { y, x, b.type }
  end
  local w = gm.get_ways( y )
  local j, i
  for z = 1, #w do
    i = x + w[ z ][ 1 ]
    j = y + w[ z ][ 2 ]
    if gm.map[ j ][ i ].type == b.type and not blows[ j.."_"..i ] then
      blows[ j.."_"..i ] = { j, i, gm.map[ j ][ i ].type }
      count = count + 1
      blows, count = gm.block_get_blows( j, i, blows, count )
    end
  end;
  return blows, count
end
--*********************************************************************************************************************
function gm.block_fly( b, to, func_end )
  gm.block_fly_queue = gm.block_fly_queue or {}
  gm.block_fly_queue_stoping = gm.block_fly_queue_stoping or {}
  local o = ObjGet( b.obj )
  local t = gm.len( o.pos_x, o.pos_y, to[ 1 ],to[ 2 ] ) / gm.SPEED
  ObjAnimate( o.name, 3,0,0, func_end, { 0,0,o.pos_x,o.pos_y, t,0,to[ 1 ],to[ 2 ] } )
  if not gm.block_fly_queue[ b.obj ] then
    gm.block_fly_queue[ b.obj ] = gm.manager_obj_get( "block_fly_fx" )
    PartSysRestart( gm.block_fly_queue[ b.obj ] );
    ObjSet( gm.block_fly_queue[ b.obj ], gm.clrs[ b.type ] )
  end
  gm.block_fly_queue_stoping[ b.obj ] = false
  --ld.LogTrace( ObjGet( gm.block_fly_queue[ b.obj ] ) )
  --ObjAttach( gm.block_fly_queue[ b.obj ], ObjGetRelations( b.obj ).parent )
  local root = ObjGet( "obj_seedmg_block_root" )
  ObjAnimate( gm.block_fly_queue[ b.obj ], 3,0,0, _, { 
    0,0,o.pos_x-root.pos_x,o.pos_y-root.pos_y, 
    t,0,to[ 1 ]-root.pos_x,to[ 2 ]-root.pos_y } )

  ObjAnimate( o.name, 3,0,0, function() 
    gm.block_fly_queue_stoping[ o.name ] = true
    if func_end then
      func_end()
    end
    gm.block_fly_stop( o.name )
  end, { 0,0,o.pos_x,o.pos_y, t,0,to[ 1 ],to[ 2 ] } )
end
function gm.block_fly_stop( obj )
  if gm.block_fly_queue_stoping[ obj ] then
    PartSysStop( gm.block_fly_queue[ obj ], 0 )
    gm.manager_obj_detach( gm.block_fly_queue[ obj ], 3, function() 
      gm.block_fly_queue[ obj ] = nil
    end )
  end
end
--*********************************************************************************************************************
function gm.block_nearest_free_place( j, i, pos_x, pos_y )
  --ld.LogTrace( j, i, pos_x, pos_y )
  local w = gm.get_ways( j )
  local len_min = 9999
  local j_min = 9999
  local i_min = 9999
  local len
  for z = 1, #w do
    if gm.map[ j + w[ z ][ 2 ] ][ i + w[ z ][ 1 ] ].type == -1 then
      len = gm.len( pos_x, pos_y, gm.get_pos_x( i + w[ z ][ 1 ], j + w[ z ][ 2 ] ), gm.get_relative_pos_y( j + w[ z ][ 2 ] ) )
      --ld.LogTrace( j + w[ z ][ 2 ],  i + w[ z ][ 1 ], gm.get_pos_x( i + w[ z ][ 1 ], j + w[ z ][ 2 ] ), gm.get_pos_y( j + w[ z ][ 2 ] ), len )
      if len < len_min then

        len_min = len
        j_min = j + w[ z ][ 2 ]
        i_min = i + w[ z ][ 1 ]
      end
    end
  end;
  return { len_min = len_min; j_min = j_min; i_min = i_min }
end;
--*********************************************************************************************************************
function gm.block_destroy( j, i )
  local block = gm.map[ j ][ i ]
  if block.obj then
    
    local o = ObjGet( block.obj )
    local fx = gm.manager_obj_get( "block_blow_fx", 3 )
    ObjSet( fx, { pos_x = o.pos_x, pos_y = o.pos_y, pos_z = 99  } )
    ObjSet( fx, gm.clrs[ block.type ] )
    PartSysRestart( fx )

    --gm.block_drop( block.obj, function() 
      --gm.block_relase( block )
    --end)

    gm.block_drop( j, i )



  end;
  --gm.map[ j ][ i ] = { type = -1 };
end
--*********************************************************************************************************************
function gm.block_relase( block )

      ObjDetach( block.obj )
      gm.destroyed[ block.type ] = gm.destroyed[ block.type ] or {}
      table.insert( gm.destroyed[ block.type ], block )


end
--*********************************************************************************************************************
function gm.block_drop( j, i )
  local y_max = 900 - ObjGet( "obj_seedmg_block_root" ).pos_y

  local block = i and gm.map[ j ][ i ] or j



  if i then
    gm.block_fly_stop( block )
    gm.map[ j ][ i ] = { type = -1 }
  end

  gm.get_random_add_type_chance( block.type, -1 )

  local vx = math.random(-30,30)
  local vy = math.random(-80,-50)
  local g = 40

  vx = vx * 0.1
  vy = vy * 0.1
  g = g * 0.1

  local o = ObjGet( block.obj )
  ObjSet( block.obj, { pos_z = 3 } )
  local ts = 0.05
  local t = 0
  local y = o.pos_y
  local x = o.pos_x
  local anm = {}

  repeat
    table.insert( anm, t )
    table.insert( anm, 0 )
    table.insert( anm, x )
    table.insert( anm, y )
    x = x + vx
    y = y + vy
    vy = vy + g
    t = t + ts
  until y > y_max
  --ld.LogTrace( anm )
  ObjAnimate( o.name, 6,0,0, _, {0,0,1,1, 0.4,2,1.1,1.1} )
  ObjAnimate( o.name, 7,0,0, _, {0,0,o.ang, t,2,o.ang + math.random()*0.5*(math.random(0,1) == 0 and 1 or -1)} )
  ObjAnimate( o.name, 3,0,0, _, anm )
  --ld.LogTrace( t )
  ld.StartTimer( "tmr_seedmg_"..o.name, t, function()
    ObjStopAnimate(o.name,3)
    ObjStopAnimate(o.name,6)
    ObjStopAnimate(o.name,7)
    --ObjSet( o.name, { pos_x = x, pos_y = y } ) 
    gm.block_relase( block )
  end )

end;
--*********************************************************************************************************************
function gm.set_all()

end
--*********************************************************************************************************************
function gm.pc_arrow()
  if ( not gm.gun_shooting ) and ( gm.menter_now ) then
    gm.event_drag();
  end
  ObjAnimate( "obj_seedmg_input_drag", 7,0,0, gm.pc_arrow, { 0,0,0, 0,0,0 } )
end
--*********************************************************************************************************************
function gm.event_mdown( num )
  gm.event_dragdrop();
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  gm.menter_now = true
  gm.event_startdrag();
  gm.pc_arrow();
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT);
  gm.menter_now = false;
  gm.arrow_draw( false );
end;
--*********************************************************************************************************************
function gm.event_startdrag()
  local b = gm.gun_get_charge()
  ObjSet( "spr_seedmg_input_arrow_body", gm.clrs[ b.type ] )
  ObjSet( "spr_seedmg_input_arrow_body_next", gm.clrs[ b.type ] )
  ObjSet( "spr_seedmg_input_arrow_body_midle", gm.clrs[ b.type ] )
  ObjSet( "spr_seedmg_input_arrow", gm.clrs[ b.type ] )
  gm.ARROW_POS = GetObjPosByObj( gm.gun_get_charge().obj, "obj_seedmg_arrow_root" )
end
--*********************************************************************************************************************
function gm.event_drag( from, to, ray_len)
  gm.line_arrow = gm.gun_line( from, to, ray_len );
end
--*********************************************************************************************************************
function gm.event_dragdrop()
  
  common_impl.Lock(1);
  
  gm.blocks_free_line_checker();
  gm.arrow_draw( false );

  if gm.can_shoot then
    

    ld.Lock( 1 )
    SoundSfx( "aud_ball_shot" )
    AnimPlay( "anm_seedmg_anm_hands", "shoot", function() 
      gm.gun_shooting = true
      gm.gun_shoot( gm.gun_load_next() )
    end );
  else
    ld.Lock(0);
    common_impl.Lock(0);
  end;

end
--*********************************************************************************************************************
function gm.win_check()
  for j = 1, #gm.map do
    for i = 1, #gm.map[ j ] do
      if gm.map[ j ][ i ].type == 5 then
        gm.win_block_obj = gm.map[ j ][ i ].obj
        local w = gm.get_ways( j )
        for z = 1, #w do
          if gm.map[ j + w[ z ][ 1 ] ][ i + w[ z ][ 2 ] ].type > 0 then
            return false
          end
        end
      end;
    end;
  end;
  return true
end
--*********************************************************************************************************************
function gm.gun_init( new_load )
  gm.gun_blocks = {}


  if not new_load then
    local b = gm.block_new( gm.gun_chain[ 1 ] )
    ObjSet( b.obj, { pos_x = 0, pos_y = 0, anim_tag = "tag_left" } )
    ObjAttach( b.obj, "anm_seedmg_anm_hands" )
    table.insert( gm.gun_blocks, b )

    if gm.gun_chain[ 2 ] > 0 then
      b = gm.block_new( gm.gun_chain[ 2 ] )
      ObjSet( b.obj, { pos_x = 0, pos_y = 0, anim_tag = "tag_right" } )
      ObjAttach( b.obj, "anm_seedmg_anm_hands" )
      table.insert( gm.gun_blocks, b )
    end

    gm.gun_charges = gm.gun_charges - #gm.gun_blocks

    ObjSet( "txt_seedmg_gun_counter", { text = gm.gun_charges } )  
  else
    ObjSet( "txt_seedmg_gun_counter", { text = gm.gun_charges } )  
    gm.gun_load_next( gm.gun_chain[ 1 ], function() 
      gm.gun_load_next( gm.gun_chain[ 2 ], function() gm.save() end )
    end )
  end
end;
--*********************************************************************************************************************
function gm.gun_line( from, to, ray_len )
  gm.ARROW_POS = from or gm.ARROW_POS
  gm.ARROW_W = gm.W
  gm.ARROW_LEN = ray_len or 6600

  local p = to or GetZoomCursorPos();
  local ang, gip = gm.ang_gip( gm.ARROW_POS[ 1 ], gm.ARROW_POS[ 2 ], p[ 1 ], p[ 2 ] )

  --if not line_arrow then
  local line_arrow = { x1 = gm.ARROW_POS[ 1 ]; y1 = gm.ARROW_POS[ 2 ]; }
  --end
  line_arrow.x2 = gm.ARROW_POS[ 1 ] + ( gm.ARROW_LEN - 1 ) * math.cos( ang ); 
  line_arrow.y2 = gm.ARROW_POS[ 2 ] - ( gm.ARROW_LEN - 1 ) * math.sin( ang );
  --line_arrow.x2 = gm.ARROW_POS[ 1 ] + ( gm.ARROW_LEN - 1 ) * math.cos( ang ); 
  --line_arrow.y2 = gm.ARROW_POS[ 2 ] - ( gm.ARROW_LEN - 1 ) * math.sin( ang );

  --local o = ObjGet( "obj_seedmg_input_root" )
  local cross_left = gm.circle_ray_line_collision( line_arrow, gm.R, { 
    x1 = gm.borders.pos_x + gm.borders.croprect_x;
    y1 = gm.borders.pos_y + gm.borders.croprect_y;
    x2 = gm.borders.pos_x + gm.borders.croprect_x;
    y2 = gm.borders.pos_y + gm.borders.croprect_y + gm.borders.croprect_h * 2;
  } )
  local cross_up = gm.circle_ray_line_collision( line_arrow, gm.R, { 
    x1 = gm.borders.pos_x + gm.borders.croprect_x;
    y1 = gm.get_relative_pos_y( 1 ) + gm.R;
    x2 = gm.borders.pos_x + gm.borders.croprect_w;
    y2 = gm.get_relative_pos_y( 1 ) + gm.R;
  } )
  local cross_right = gm.circle_ray_line_collision( line_arrow, gm.R, { 
    x1 = gm.borders.pos_x + gm.borders.croprect_w / 2;
    y1 = gm.borders.pos_y + gm.borders.croprect_y;
    x2 = gm.borders.pos_x + gm.borders.croprect_w / 2;
    y2 = gm.borders.pos_y + gm.borders.croprect_y + gm.borders.croprect_h * 2;
  } )
  local cross_down = gm.circle_ray_line_collision( line_arrow, gm.R, { 
    x1 = gm.borders.pos_x + gm.borders.croprect_x;
    y1 = 800;
    x2 = gm.borders.pos_x + gm.borders.croprect_w;
    y2 = 800;
  } )

  if cross_up then
    if cross_left and cross_left.len < cross_up.len then
      cross_up = false
    elseif cross_right and cross_right.len < cross_up.len then
      cross_up = false
    end
  end

  --ищем пересечения с шариками
  local o, collision, collision_next
  --if ang < math.pi or cross_up then
    local i_way, i_beg, i_end, cross_y
    local j_beg, j_end, j_way
    if ang > math.pi * 0.5 and ang < math.pi * 1.5 then
      i_way = -1
      i_beg = #gm.map[ 1 ]
      i_end = 1
    else
      i_way = 1
      i_beg = 1
      i_end = #gm.map[ 1 ]
    end
    if line_arrow.y2 > line_arrow.y1 then 
      j_beg = 1
      j_end = #gm.map
      j_way = 1
    else
      j_beg = #gm.map
      j_end = 1
      j_way = -1
    end
    for j = j_beg, j_end, j_way do
      collision_next = false;
      cross_y = gm.get_relative_pos_y( j ) + gm.R
      if j_way == 1 then
        if ( cross_left and cross_y > cross_left.pos_y ) or ( cross_right and cross_y > cross_right.pos_y ) then
          --ld.LogTrace( cross_y, cross_left, cross_right )
          break
        end;
      else
        if ( cross_left and cross_y < cross_left.pos_y ) or ( cross_right and cross_y < cross_right.pos_y ) then
          break
        end;
      end
      for i = i_beg, i_end, i_way do



        if gm.map[ j ][ i ].type > 0 then
--



          collision = collision_next or gm.arrow_collision( line_arrow, ang, j, i )
          --collision = gm.arrow_collision( ang, j, i )

          if gm.map[ j ][ i + i_way ].type > 0 then
            collision_next = gm.arrow_collision( line_arrow, ang, j, i + i_way )
            if collision_next then
              if not collision then
                collision = collision_next
                --collision.i = i + i_way
              elseif collision_next.len < collision.len then
                --ld.LogTrace( "ALARMA", collision_next, collision )
          --ld.LogTrace( "ALARMA", collision_next, collision, j_way,i_way, line_arrow )
                collision = collision_next
                --collision.i = i + i_way
              end
            end
          else
            collision_next = false;
          end;



          if collision then

            line_arrow.x2 = collision[ 1 ]
            line_arrow.y2 = collision[ 2 ]
            line_arrow.j = collision.j;
            line_arrow.i = collision.i;
            --ld.LogTrace( "ball collision",j_way,i_way, line_arrow )
            break;
          end
        end
      end;
      if collision then
        break;
      end
    end;
  --end

  gm.collision_state = collision;

  if collision then
    --пересечение с шариком
    --line_arrow.x2 = collision[ 1 ]
    --line_arrow.y2 = collision[ 2 ]
            --ObjSet( gm.manager_obj_get( "dot_small", 0 ), { 
            --  pos_x = collision[ 1 ]; 
            --  pos_y = collision[ 2 ]; 
            --  color_r = 0;
            --  color_g = 0;
            --  color_b = 0;
            --} )
    --line_arrow = {}
    --line_arrow.x1 = 

  else
    local cross_len = math.min ( cross_left and cross_left.len or 9999, cross_right and cross_right.len or 9999 )
    cross_len = math.min ( cross_len, cross_up and cross_up.len or 9999 )
    cross_len = math.min ( cross_len, cross_down and cross_down.len or 9999 )
    if cross_down and cross_down.len == cross_len then
      --пересечение с нижней границей, ниже рисовать не нужно
      --local cross = gm.manager_obj_get( "cross", 1 )
      --ObjSet( cross, cross_down )
      line_arrow.x2 = cross_down.pos_x
      line_arrow.y2 = cross_down.pos_y
      line_arrow.cross_right = false
      line_arrow.cross_left = false
      line_arrow.cross_up = false
      line_arrow.cross_down = true
    elseif cross_up and cross_up.len == cross_len then
      --пересечение с верхней границей, выше рисовать не нужно
      --local cross = gm.manager_obj_get( "cross", 1 )
      --ObjSet( cross, cross_up )
      line_arrow.x2 = cross_up.pos_x
      line_arrow.y2 = cross_up.pos_y
      line_arrow.cross_right = false
      line_arrow.cross_left = false
      line_arrow.cross_up = true
      line_arrow.cross_down = false
      --ld.LogTrace( line_arrow )
    elseif cross_left and cross_left.len == cross_len then
      --пересечение с левой стенкой, нужно зеркалить
      --local cross = gm.manager_obj_get( "cross", 1 )
      --ObjSet( cross, cross_left )
      line_arrow.x2 = cross_left.pos_x
      line_arrow.y2 = cross_left.pos_y
      line_arrow.cross_left = true
      line_arrow.cross_right = false
      line_arrow.cross_up = false
      line_arrow.cross_down = false
    elseif cross_right and cross_right.len == cross_len then
      --пересечение с правой стенкой, нужно зеркалить
      --local cross = gm.manager_obj_get( "cross", 1 )
      --ObjSet( cross, cross_right )
      line_arrow.x2 = cross_right.pos_x
      line_arrow.y2 = cross_right.pos_y
      line_arrow.cross_right = true
      line_arrow.cross_left = false
      line_arrow.cross_up = false
      line_arrow.cross_down = false
    end
  --ld.LogTrace( "cross_left",cross_left, "cross_right",cross_right, "cross_up",cross_up, "cross_down",cross_down )
  end

  --if cross_down then
  --  local cross = gm.manager_obj_get( "cross", 0 )
  --  ObjSet( cross, cross_down )
  --end

  gm.line_ang = ang
  -->> ARROW -->>
    if line_arrow.y2 < 550 then
      gm.can_shoot = true

      local len = gm.len( line_arrow.x1,  line_arrow.y1, line_arrow.x2, line_arrow.y2 )

      line_arrow.ang = ang
      line_arrow.len = len

      --local rad_15 = ( 15 /180 ) * math.pi
      --local rad_165 = ( 165 /180 ) * math.pi
      ----if ang > rad_165 then
      --  ang = ang <= math.pi * 1.5 and rad_165 or rad_15
      --elseif ang < rad_15 then
      --  ang = rad_15
      --end
      if( not from ) then
        gm.arrow_draw( line_arrow )
      end;
    else
      gm.can_shoot = false;
      --gm.arrow_state = false;
      --gm.line_ang = false
      --if( not from ) then
      gm.arrow_draw( false );
      --end
      --line_arrow = false
    end
  --<< ARROW --<<

  
  return line_arrow;
end
--*********************************************************************************************************************
function gm.gun_disarm()
  if gm.gun_blocks[ 1 ] then
    local p = GetObjPosByObj( gm.gun_blocks[ 1 ].obj, "obj_seedmg_arrow_root" )
    ObjSet( gm.gun_blocks[ 1 ].obj, { pos_x = p[ 1 ]; pos_y = p[ 2 ] } )
    ObjAttach( gm.gun_blocks[ 1 ].obj, "obj_seedmg_arrow_root" )
    gm.block_drop( gm.gun_blocks[ 1 ] )
    if gm.gun_blocks[ 2 ] then
      local p = GetObjPosByObj( gm.gun_blocks[ 2 ].obj, "obj_seedmg_arrow_root" )
      ObjSet( gm.gun_blocks[ 2 ].obj, { pos_x = p[ 1 ]; pos_y = p[ 2 ] } )
      ObjAttach( gm.gun_blocks[ 2 ].obj, "obj_seedmg_arrow_root" )
      gm.block_drop( gm.gun_blocks[ 2 ] )
    end
    ObjSet( "txt_seedmg_gun_counter", { text = gm.gun_charges } )  
  end
end
--*********************************************************************************************************************
function gm.gun_shoot( b )
  if gm.gun_shoot_sfx_last then
    SoundSfx( gm.gun_shoot_sfx_last )
  end
  gm.gun_shooting = true
  if gm.line_arrow.cross_down then
    --попадаем в пол
    gm.gun_shoot_sfx_last = false

    gm.block_fly( b, { gm.line_arrow.x2, gm.line_arrow.y2 }, function() 
      --gm.gun_shooting = false
      gm.block_relase( b )
      --ld.Lock( 0 )
      gm.gun_shoot_end()
    end )

  elseif gm.line_arrow.cross_up then

    --попадаем в потолок
    gm.gun_shoot_sfx_last = "aud_ball_hit_the_wall"

    gm.block_fly( b, { gm.line_arrow.x2, gm.line_arrow.y2 }, function() 
      gm.event_drag( 
        { gm.line_arrow.x2, gm.line_arrow.y2 + 0.01 },
        { gm.line_arrow.x2 * 2 - gm.line_arrow.x1, gm.line_arrow.y1 }
      );
      gm.gun_shoot( b )
    end )

  elseif gm.line_arrow.cross_right or gm.line_arrow.cross_left then
    --попадаем в стенку
    gm.gun_shoot_sfx_last = "aud_ball_hit_the_wall"

    gm.block_fly( b, { gm.line_arrow.x2, gm.line_arrow.y2 }, function() 
      gm.event_drag( 
        { gm.line_arrow.x2 - ( gm.line_arrow.cross_right and 0.01 or - 0.01 ) , gm.line_arrow.y2 },
        { gm.line_arrow.x1, gm.line_arrow.y2 * 2 - gm.line_arrow.y1 }
      );
      gm.gun_shoot( b )
    end )

  else
    gm.gun_shoot_sfx_last = false
    --попадаем в шар
    --local coll = gm.circle_ray_circle_collision( 
    --                gm.line_arrow.x1, 
    --                gm.line_arrow.y1, 
    --                gm.line_arrow.x2, 
    --                gm.line_arrow.y2, 
    --                gm.R, 
    --                gm.get_pos_x( gm.line_arrow.i, gm.line_arrow.j ), 
    --                gm.get_relative_pos_y( gm.line_arrow.j ), 
    --                gm.R
    --             );

    --gm.block_fly( b, coll, function() 
    gm.block_fly( b, { gm.line_arrow.x2; gm.line_arrow.y2 }, function() 
      --ObjSet( gm.map[ gm.line_arrow.j ][ gm.line_arrow.i ].obj, { blendmode = 2 } )
      local place = gm.block_nearest_free_place( 
        gm.line_arrow.j, gm.line_arrow.i, gm.line_arrow.x2, gm.line_arrow.y2
      );
      --ld.LogTrace( place, place.i_min, place.j_min, gm.get_pos_x( place.i_min, place.j_min ), gm.get_pos_y( place.j_min )  )
      gm.map[ place.j_min ][ place.i_min ] = b
      --долетаем в ближайшее свободное место
      gm.get_random_add_type_chance( b.type, 1 )
      local blows, count = gm.block_get_blows( place.j_min, place.i_min )
      local func_end = function() 
        local p = GetObjPosByObj( b.obj, "obj_seedmg_block_root" );
        ObjAttach( b.obj, "obj_seedmg_block_root" );
        ObjSet( b.obj, { pos_x = p[ 1 ]; pos_y = p[ 2 ]; } )
        --ObjSet( b.obj, { pos_y = gm.get_relative_pos_y( place.j_min ) } )
        gm.gun_shoot_end( place )
      end

      if count < 3 then
        SoundSfx( "aud_ball_hit_the_wall" )
        gm.block_fly( b, { gm.get_pos_x( place.i_min, place.j_min ), gm.get_relative_pos_y( place.j_min ) }, func_end )
      else
        SoundSfx( "aud_ball_crash" )
        func_end()
      end

    end )
  end
end
function gm.gun_shoot_end( place, skip, gun_load_end )
  if place then
    gm.blocks_free_line_checker()
    gm.block_blow_try( place.j_min, place.i_min )
    gm.blocks_relase_try( place.j_min, place.i_min  )
    gm.blocks_free_line_checker()
    gm.blocks_root_pos_y_normer()
  end
  if not gun_load_end then
    gm.gun_shooting = false;
  end
  if gm.win_check() or skip then
    gm.gun_shooting = true
    if gm.gun_loading and not gun_load_end then

    else
      --ld.LogTrace( "WIN!!!", skip )
      common_impl.Lock(0);
      private.Win();
    end
  elseif gm.gun_charges > 0 or #gm.gun_blocks > 0 then
    if ( gm.gun_shooting or gm.gun_loading ) then

    else
      common_impl.Lock(0);
      ld.Lock( 0 );
      gm.save();
    end
  else
    if ( gm.gun_shooting or gm.gun_loading ) then

    else
      gm.gun_shooting = true
      public.Reset()
    end
  end
end
--*********************************************************************************************************************
function gm.gun_load_next( load_type, func_end )

  --if gm.gun_charges > 0 then
  --  gm.gun_charges = gm.gun_charges - 1
  --end
      
    gm.gun_loading = true
  
    local b_out;
    if func_end and #gm.gun_blocks < 2 then 

    else
      b_out = table.remove( gm.gun_blocks, 1 );
    end

    if b_out then
      local p = GetObjPosByObj( b_out.obj, "obj_seedmg_arrow_root" )
      ObjSet( b_out.obj, { pos_x = p[ 1 ]; pos_y = p[ 2 ]; anim_tag = "" } )
      ObjAttach( b_out.obj, "obj_seedmg_arrow_root" )
    end

    ld.LockCustom( "mg_seedmg_gun_anims", 1 )

    local func_step = function() 

      ld.StartTimer( 0.25, function() 
        ObjSet( "txt_seedmg_gun_counter", { text = math.max( gm.gun_charges, 0 ) } )
      end )

      if gm.gun_blocks[ 1 ] then
        ObjSet( gm.gun_blocks[ 1 ].obj, { pos_x = 0, pos_y = 0, anim_tag = "tag_left" } )
      end

      if gm.gun_charges > 0 then
        gm.gun_charges = gm.gun_charges - 1
        local b
        if load_type then
          b = gm.block_new( load_type )
        else
          b = gm.block_new( gm.get_random_type() )
        end
        ObjSet( b.obj, { pos_x = 0, pos_y = 0, anim_tag = "tag_right" } )
        ObjAttach( b.obj, "anm_seedmg_anm_hands" )
        table.insert( gm.gun_blocks, b )
        ObjSet( "anm_seedmg_anm_body", { visible = 0 } )
        AnimPlay( "anm_seedmg_anm_hands", "reload", function() 
          ObjSet( "anm_seedmg_anm_hands", { animfunc = "shoot", frame = 0 } )
          ObjSet( "anm_seedmg_anm_body", { visible = 1 } )
          ld.LockCustom( "mg_seedmg_gun_anims", 0 )
          gm.gun_loading = false
          if func_end then
            func_end()
          else
            gm.gun_shoot_end( _, _, true )
            --gm.save()
          end
        end )
      else
        ObjSet( "anm_seedmg_anm_hands", { animfunc = "shoot", frame = 0 } )
        ld.LockCustom( "mg_seedmg_gun_anims", 0 )
        gm.gun_loading = false
        gm.gun_shoot_end( _, _, true )
        --gm.save()

      end;
    end

    if #gm.gun_blocks == 0 then
      func_step()
    else
      SoundSfx( "aud_clk_menu" )
      AnimPlay( "anm_seedmg_anm_hands", "change", func_step )
    end

    return b_out
  --else
  --  return false
  --end
end
--*********************************************************************************************************************
function gm.gun_change()
  if #gm.gun_blocks == 1 or gm.gun_changing then
    return
  end
  SoundSfx( "aud_clk_menu" )
  gm.gun_changing = true
  gm.gun_blocks[ 1 ], gm.gun_blocks[ 2 ] = gm.gun_blocks[ 2 ], gm.gun_blocks[ 1 ]
  ld.LockCustom( "mg_seedmg_gun_anims", 1 )
  AnimPlay( "anm_seedmg_anm_hands", "change", function() 
    ObjSet( gm.gun_blocks[ 1 ].obj, { anim_tag = "tag_left" } )
    ObjSet( gm.gun_blocks[ 2 ].obj, { anim_tag = "tag_right" } )
    ObjSet( "anm_seedmg_anm_hands", { animfunc = "shoot", frame = 0 } )
    ld.LockCustom( "mg_seedmg_gun_anims", 0 )
    gm.gun_changing = false
    gm.save()
  end )
end;
--*********************************************************************************************************************
function gm.gun_get_charge()
  return gm.gun_blocks[ 1 ]
end;
--*********************************************************************************************************************
function gm.arrow_draw( line )
  if line then
    local next_len = 25;
    ObjSet( "spr_seedmg_input_arrow_body", { 
      visible = 1;
      ang = line.ang;
      scale_x = line.len / 36;
      drawoff_x = 36 / 2;
      pos_x = line.x1;
      pos_y = line.y1;
    } )
    if line.cross_left or line.cross_right then

    --elseif line.cross_right then
      local ang, gip = gm.ang_gip( line.x2, line.y2, line.x1, line.y2 * 2 - line.y1 )
      ObjSet( "spr_seedmg_input_arrow", { 
        visible = 1;
        ang = ang;
        --scale_x = gip / gm.ARROW_W;
        pos_x = line.x2 + next_len * math.cos( ang );
        pos_y = line.y2 - next_len * math.sin( ang );
      } )
      --local ang_sum = ang + line.ang
      --local ang_midle = ang_sum * 0.5
      ObjSet( "spr_seedmg_input_arrow_body_midle", { 
        visible = 1;
        --ang = ang_midle;
        --scale_y = math.abs( 36 * math.sin( ang ) ) / 36;
        --scale_x = math.abs( 24 * math.cos( ang ) ) / 36;
        drawoff_x = 0;
        pos_x = line.x2;
        pos_y = line.y2;
      } )
      ObjSet( "spr_seedmg_input_arrow_body_next", { 
        visible = 1;
        ang = ang;
        scale_x = next_len / 36;
        drawoff_x = 36 / 2;
        pos_x = line.x2;
        pos_y = line.y2;
      } )
    else
      ObjSet( "spr_seedmg_input_arrow", { 
        visible = 1;
        ang = line.ang;
        --scale_x = gip / gm.ARROW_W;
        pos_x = line.x2;
        pos_y = line.y2;
      } )
      ObjSet( "spr_seedmg_input_arrow_body_next", { 
        visible = 0;
      } )
      ObjSet( "spr_seedmg_input_arrow_body_midle", { 
        visible = 0;
      } )
    end
  else
    ObjSet( "spr_seedmg_input_arrow_body", { 
      visible = 0;
    } )
    ObjSet( "spr_seedmg_input_arrow_body_midle", { 
      visible = 0;
    } )
    ObjSet( "spr_seedmg_input_arrow_body_next", { 
      visible = 0;
    } )
    ObjSet( "spr_seedmg_input_arrow", { 
      visible = 0;
    } )
  end
end
--*********************************************************************************************************************
function gm.arrow_collision( line_arrow, ang, j, i )
  --local o = ObjGet( gm.map[ j ][ i ].obj )
  --      o.pos_y = o.pos_y + gm.root_dy

  

  local collision = gm.circle_ray_circle_collision( 
                      line_arrow.x1, line_arrow.y1, line_arrow.x2, line_arrow.y2,
                      gm.R,
                      gm.get_pos_x( i, j ), gm.get_relative_pos_y( j ), gm.R
                     );

  if collision then
    collision.x1 = collision[ 1 ]
    collision.y1 = collision[ 2 ]
    collision.x2 = collision[ 3 ]
    collision.y2 = collision[ 4 ]
    local ang, gip = gm.ang_gip( line_arrow.x1, line_arrow.y1, collision.x1, collision.y1 )
    collision.len = gip
    collision.ang = ang
    collision.j = j
    collision.i = i
    collision[ 5 ], collision[ 6 ] = gip, ang
  end

  return collision
end;
--*********************************************************************************************************************
function gm.get_pos_y( y )
  return gm.Y + y * gm.W * 0.90
end
function gm.get_relative_pos_y( y )
  return gm.Y + y * gm.W * 0.90 + gm.root_dy
end
function gm.get_pos_x( x, y )
  return gm.X + x * gm.W + ( y % 2 ) * gm.W * 0.5
end
function gm.get_ways( y )
  if y % 2 == 0 then
    return { { 1, 0 }; { 0, -1 }; { -1, -1 }; { -1, 0}; { -1, 1 }; { 0, 1 }; }
  else
    return { { 1, 0 }; { 1, -1 }; { 0, -1 }; { -1, 0}; { 0, 1 }; { 1, 1 }; }
  end
end
--*********************************************************************************************************************
function gm.get_random_init()
  --возвращает рандомный тип шарика
  --чем больше шариков орпеделенного типа на поле
  --тем больше вероятность его выподания
  --при отсутствии какого то типа шаров на поле
  --выпадать он не будет
  gm.get_random_types = {}
  for i = 1, 4 do
    gm.get_random_types[ i ] = 0
  end
  for j = 1, #gm.map do
    for i = 1, #gm.map[ j ] do
      if gm.map[ j ][ i ].type > 0 and gm.map[ j ][ i ].type < 5 then
        gm.get_random_types[ gm.map[ j ][ i ].type ] = gm.get_random_types[ gm.map[ j ][ i ].type ] + 1
      end
    end
  end
end
function gm.get_random_type()
  --возвращает рандомный тип шарика
  --чем больше шариков орпеделенного типа на поле
  --тем больше вероятность его выпадения
  --при отсутствии какого то типа шаров на поле
  --выпадать он не будет
  gm.get_random_type_last = gm.get_random_type_last or 0
  local chance = 0
  local chance_type = 0
  --ld.LogTrace( gm.get_random_types )
  for i = 1, 4 do
    local ch = math.random( 0, gm.get_random_types[ i ] )
    --ld.LogTrace( i, gm.get_random_types[ i ], ch )
    if i == gm.get_random_type_last then
      ch = ch / 2
    end
    if ch > chance then
      chance = ch
      chance_type = i
    end
  end
  --ld.LogTrace( "returning", chance_type )
  if chance_type == 0 then
    return false;
  end
  --ld.LogTrace( gm.get_random_types, chance_type )
  gm.get_random_type_last = chance_type
  return chance_type
end
function gm.get_random_add_type_chance( chance_type, count )
  if not gm.get_random_types[ chance_type ] then
    return
  end
  gm.get_random_types[ chance_type ] = gm.get_random_types[ chance_type ] + count
  if gm.get_random_types[ chance_type ] < 0 then
    gm.get_random_init()
  end
end
--*********************************************************************************************************************
function gm.manager_obj_init( name, obj_type, obj_owner, obj_set )
  gm.manager_objs = gm.manager_objs or {}
  gm.manager_trash = gm.manager_trash or {}
  gm.manager_trash[ name ] = {}
  gm.manager_counter = gm.manager_counter or {}
  gm.manager_counter[ name ] = 0 
  gm.manager_obj_type = gm.manager_obj_type or {}
  gm.manager_obj_type[ name ] = obj_type
  gm.manager_obj_owner = gm.manager_obj_owner or {}
  gm.manager_obj_owner[ name ] = obj_owner
  gm.manager_obj_set = gm.manager_obj_set or {}
  gm.manager_obj_set[ name ] = obj_set
end;
function   gm.manager_clear()
  for k, v in pairs( gm.manager_objs ) do
    ObjDelete( k )
  end;
  gm.manager_objs = nil
  gm.manager_trash = nil
  gm.manager_counter = nil
  gm.manager_obj_type = nil
  gm.manager_obj_owner = nil
  gm.manager_obj_set = nil
end;
function   gm.manager_obj_get( name, life_time )
  local obj
  if #gm.manager_trash[ name ] == 0 then
    gm.manager_counter[ name ] = gm.manager_counter[ name ] + 1
    obj = gm.manager_obj_type[ name ].."_seedmg_"..name.."_"..gm.manager_counter[ name ]
    ObjCreate( obj, gm.manager_obj_type[ name ] )
    ObjSet( obj, gm.manager_obj_set[ name ] )
    gm.manager_objs[ obj ] = name
  else
    obj = table.remove( gm.manager_trash[ name ] )
  end
  ObjAttach( obj, gm.manager_obj_owner[ name ] )
  if life_time then
    ld.StartTimer( "tmr_manager_obj_detach_"..obj, life_time, function() gm.manager_obj_detach( obj ) end )
  end;
  return obj;
end
function   gm.manager_obj_detach( obj, time, func_end )
  local func = function() 
    if not gm.manager_objs then
      ObjDelete( obj )
    else
      table.insert( gm.manager_trash[ gm.manager_objs[ obj ] ], obj )
      ObjDetach( obj )
      if func_end then
        func_end()
      end
    end
  end
  if time then
    ld.StartTimer( "tmr_manager_obj_detach_"..obj, time, func )
  else
    func();
  end
end
function   gm.manager_obj_disable( obj )
  if not gm.manager_objs then
    ObjDelete( obj )
  else
    table.insert( gm.manager_trash[ gm.manager_objs[ obj ] ], obj )
  end
end
--*********************************************************************************************************************
function gm.static_player( anim, funcs )
  AnimPlay( anim, funcs[ math.random( 1, #funcs ) ], function() 
    gm.static_player( anim, funcs )
  end )
end
--*********************************************************************************************************************
function gm.len( x1,y1,x2,y2 )
  return ( (x1-x2)^2 +(y1-y2)^2 )^0.5
end
--*********************************************************************************************************************
--[[********************************************************************]]
--[[  возвращает угол между прямой и осью ОХ, расстояние между точками  ]]
--[[--------------------------------------------------------------------]]
function gm.ang_gip( x1,y1,x2,y2,len )
  len = len or ( (x1-x2)^2 +(y1-y2)^2 )^0.5
  y1=-y1; --переворот для игровой системы координат
  y2=-y2; --переворот для игровой системы координат
  if len == 0 then return 0,0 end --исключение
  local k = ( y1 - y2 ) / len
  local a = math.abs( math.asin( k ) )
  if x2 >= x1 and y2 <= y1 then
    a = math.pi*2 - a
    return a,len
  elseif x2 >= x1 and y2 >= y1 then
    return a,len
  elseif x2 <= x1 and y2 <= y1 then
    a = math.pi + a
    return a,len
  elseif x2 <= x1 and y2 >= y1 then
    a = math.pi - a
    return a,len
  end;
end
--[[********************************************************************]]
--[[                                                                    ]]
--[[--------------------------------------------------------------------]]

--[[*************************************************************************************]]
--[[                 возвращает координаты пересечения прямой line1, line2             --]]
--[[-------------------------------------------------------------------------------------]]
function gm.line_line_collision( line1, line2 )
--ld.LogTrace( line1, line2 )

  if (    line1.x1 > line2.x1
      and line1.x1 > line2.x2
      and line1.x2 > line2.x1
      and line1.x2 > line2.x2
     ) 
    or 
    (     line1.x1 < line2.x1
      and line1.x1 < line2.x2
      and line1.x2 < line2.x1
      and line1.x2 < line2.x2
     )
    or
     (    line1.y1 > line2.y1
      and line1.y1 > line2.y2
      and line1.y2 > line2.y1
      and line1.y2 > line2.y2
     ) 
    or 
    (     line1.y1 < line2.y1
      and line1.y1 < line2.y2
      and line1.y2 < line2.y1
      and line1.y2 < line2.y2
     )
  then
    --[[ не пересекаются ]]
      return false;
  end

  line1.y1 = -line1.y1; --переворот для игровой системы координат
  line1.y2 = -line1.y2; --переворот для игровой системы координат
  line2.y1 = -line2.y1; --переворот для игровой системы координат
  line2.y2 = -line2.y2; --переворот для игровой системы координат

  local zk1 = ( line1.x1 - line1.x2 )
  local zk2 = ( line2.x1 - line2.x2 )
  local k1
  local k2
  local b1
  local b2
  local x, y
  local n = 0
  if zk1 == 0 and zk2 == 0 then
    --[[ паралельные прямые отностительно У ]]
    line1.y1 = -line1.y1; --переворот для игровой системы координат
    line1.y2 = -line1.y2; --переворот для игровой системы координат
    line2.y1 = -line2.y1; --переворот для игровой системы координат
    line2.y2 = -line2.y2; --переворот для игровой системы координат
    return false
  elseif zk1 == 0 then
    k2 = ( line2.y1 - line2.y2 ) / zk2;
    x = line1.x1
    y = k2 * ( line1.x1 - line2.x1 ) + line2.y1
  elseif zk2 == 0 then
    k1 = ( line1.y1 - line1.y2 ) / zk1;
    x = line2.x1
    y = k1 * ( line2.x1 - line1.x1 ) + line1.y1
  else
    k1 = ( line1.y1 - line1.y2 ) / zk1;
    k2 = ( line2.y1 - line2.y2 ) / zk2;
    b1 = line1.y1 - k1 * line1.x1
    b2 = line2.y1 - k2 * line2.x1
    x = ( b2 - b1 ) / ( k1 - k2 )
    y = k2 * x + b2
    x = x
  end

  y=-y

  line1.y1 = -line1.y1; --переворот для игровой системы координат
  line1.y2 = -line1.y2; --переворот для игровой системы координат
  line2.y1 = -line2.y1; --переворот для игровой системы координат
  line2.y2 = -line2.y2; --переворот для игровой системы координат

  --ld.LogTrace( line1, line2, n, k1, b1, k2, b2, x, y )

  if ( ( x > line1.x1 and x > line1.x2 ) or ( x > line2.x1 and x > line2.x2 ) )
  or ( ( x < line1.x1 and x < line1.x2 ) or ( x < line2.x1 and x < line2.x2 ) )
  or ( ( y > line1.y1 and y > line1.y2 ) or ( y > line2.y1 and y > line2.y2 ) )
  or ( ( y < line1.y1 and y < line1.y2 ) or ( y < line2.y1 and y < line2.y2 ) )
  then
    return false
  end

  --ld.LogTrace( line1, line2, n, k1, b1, k2, b2, x, y )

  return { pos_x = x, pos_y = y, len = gm.len( line1.x1, line1.y1, x, y ) }

end;
--[[*************************************************************************************]]
--[[                                                                                   --]]
--[[-------------------------------------------------------------------------------------]]

--[[*****************************************************************************************************************]]
--[[                 возвращает координаты пересечения прямой lx1,ly1, lx2,ly2 и окружности cx,cy,cr               --]]
--[[-----------------------------------------------------------------------------------------------------------------]]
function gm.circle_line_collision( lx1, ly1, lx2, ly2, cx, cy, cr, first_closer_to_lx1_ly1 )
  ly1 = -ly1; --переворот для игровой системы координат
  ly2 = -ly2; --переворот для игровой системы координат
  cy  = -cy;  --переворот для игровой системы координат

  if not ( ( ( ( ( lx1 - cr ) < cx ) and ( cx < ( lx2 + cr ) ) ) or ( ( ( lx1 + cr ) > cx ) and ( cx > ( lx2 - cr ) ) ) )
  and ( ( ( ( ly1 - cr ) < cy ) and ( cy < ( ly2 + cr ) ) ) or ( ( ( ly1 + cr ) > cy ) and ( cy > ( ly2 - cr ) ) ) ) )
  then
    --[[  окружность не входит в пределы отрезка ( упрощенная обработка окружности в виде квадрата )  ]]--
    return false;
  end;



  local k, b, A, B, C, D, X1, Y1, X2, Y2
  if math.abs( lx1 - lx2 ) < 0.001 then
    --исключение для прямой паралельной оси Y
    --ld.LogTrace( lx1, ly1, lx2, ly2, cx, cy, cr, first_closer_to_lx1_ly1 )
    --k = ( ly1 - ly2 ) / ( lx1 - lx2 );
    b = ly2-- - k * lx2
    -- уравнение прямой      {  y = b
    -- уравнение окружности  { (x-cx)^2+(y-cy)^2=cr^2
    A = 1;
    B = -2 * cy;
    C = lx1 ^ 2 + cx ^ 2 + cy ^ 2 - cr ^2 - 2 * lx1 * cx;
    D = B ^ 2 - 4 * A * C

    if D < 0 then
      return false
    else
      D = D ^ 0.5;
    end;
    Y1 = ( -B - D ) / ( 2 * A );
    Y2 = ( -B + D ) / ( 2 * A );
    X1 = lx1;
    X2 = lx1;

  else

    k = ( ly1 - ly2 ) / ( lx1 - lx2 );
    b = ly2 - k * lx2
    -- уравнение прямой      {  y = kx + b
    -- уравнение окружности  { (x-cx)^2+(y-cy)^2=cr^2
    -- >> (x-cx)^2 + (kx+b-cy)^2 = cr^2
    -- >> x^2 - 2xcx + cx^2 + (kx+b)^2 - 2(kx+b)cy + cy^2 - cr^2 = 0
    -- >> X^2 - 2cxX + cx^2 + k^2X^2 + 2kbX + b^2 - 2kcyX - 2bcy + cy^2 - cr^2 = 0
    -- >> ( 1 + k^2 ) X^2 + ( -2cx + 2kb - 2kcy ) X + ( cx^2 + b^2 - 2bcy + cy^2 - cr^2 ) = 0
    -- > A = ( 1 + k^2 ); B = ( -2cx + 2kb - 2kcy ); C = ( cx^2 + b^2 - 2bcy + cy^2 - cr^2 );
    A = 1 + k ^ 2;
    B = -2 * cx + 2 * k * b - 2 * k * cy;
    C = cx ^ 2 + b ^ 2 - 2 * b * cy + cy ^ 2 - cr ^ 2;
    D = B ^ 2 - 4 * A * C
    if D < 0 then
      return false
    else
      D = D ^ 0.5;
    end;
    X1 = ( -B - D ) / ( 2 * A );
    X2 = ( -B + D ) / ( 2 * A );
    Y1 = k * X1 + b;
    Y2 = k * X2 + b;


  end

  if first_closer_to_lx1_ly1 == true then
    if gm.len( lx1,ly1, X1,Y1 ) > gm.len( lx1,ly1, X2,Y2 ) then
      X1,Y1,X2,Y2 = X2,Y2,X1,Y1
    end;
  elseif first_closer_to_lx1_ly1 == false then
    if gm.len( lx1,ly1, X1,Y1 ) < gm.len( lx1,ly1, X2,Y2 ) then
      X1,Y1,X2,Y2 = X2,Y2,X1,Y1
    end;
  end;

  if not (
    ( ( ( lx1 <= X1 and X1 <= lx2 ) or ( lx2 <= X1 and X1 <= lx1 ) ) and ( ( ly1 <= Y1 and Y1 <= ly2 ) or ( ly2 <= Y1 and Y1 <= ly1 ) ) )
    or ( ( ( lx1 <= X2 and X2 <= lx2 ) or ( lx2 <= X2 and X2 <= lx1 ) ) and ( ( ly1 <= Y2 and Y2 <= ly2 ) or ( ly2 <= Y2 and Y2 <= ly1 ) ) )
  ) then
    --[[  отрезок не входит в окружность  ]]--
    return false;
  end;
  --if ZZZ then   ld.LogTrace(222, X1, Y1, X2, Y2 ) end
  Y1 = - Y1;  --переворот для игровой системы координат
  Y2 = - Y2;  --переворот для игровой системы координат

  return {X1,Y1,X2,Y2}
end;
--[[*****************************************************************************************************************]]
--[[  first_closer_to_lx1_ly1 -> true - ближняя точка к lx1,ly1 будет первой; false - далней; nil - как получится  --]]
--[[-----------------------------------------------------------------------------------------------------------------]]

--[[*****************************************************************************************************************]]
--[[                возвращяет координаты пересечения луча(на конце луча круг) с окружностью                       --]]
--[[-----------------------------------------------------------------------------------------------------------------]]
function gm.circle_ray_circle_collision( lx1, ly1, lx2, ly2, lrr, cx, cy, cr )
  return gm.circle_line_collision( lx1, ly1, lx2, ly2, cx, cy, cr + lrr, true )
end;
--[[*****************************************************************************************************************]]
--[[                                                                                                               --]]
--[[-----------------------------------------------------------------------------------------------------------------]]

--[[*****************************************************************************************************************]]
--[[                возвращяет координаты пересечения луча(на конце луча круг) с линией                            --]]
--[[-----------------------------------------------------------------------------------------------------------------]]
function gm.circle_ray_line_collision( line1, lr, line2 )
  local coll = gm.line_line_collision( line1, line2 )
  if coll then
    --пересечение линий есть, нужно сдвинуть вторую линию к первой на расстояние LR
    local ang1, gip1 = gm.ang_gip( line1.x2, line1.y2, line1.x1, line1.y1 )
    local ang2, gip2 = gm.ang_gip( line2.x1, line2.y1, line2.x2, line2.y2 )
    --ld.LogTrace( ang1, ang2 )
    ang3 = gm.ang_closer( ang2, ang1 )
    if ang3 > ang1 then
      ang2 = ang2 - math.pi * 0.5
    else
      ang2 = ang2 + math.pi * 0.5
    end
    --ld.LogTrace( ang2 )
    line2.x1 = line2.x1 + math.cos( ang2 ) * lr
    line2.y1 = line2.y1 - math.sin( ang2 ) * lr
    line2.x2 = line2.x2 + math.cos( ang2 ) * lr
    line2.y2 = line2.y2 - math.sin( ang2 ) * lr
    coll = gm.line_line_collision( line1, line2 )
  end
  return coll
end;
--[[*****************************************************************************************************************]]
--[[                                                                                                               --]]
--[[-----------------------------------------------------------------------------------------------------------------]]

--[[*****************************************************]]
--[[  возвращаяет угол в пределах 0 <= ang <= math.pi*2  ]]
--[[-----------------------------------------------------]]
function gm.ang_norm( ang )
  while ang > math.pi * 2 do ang = ang - math.pi * 2 end
  while ang < 0 do ang = ang + math.pi * 2 end
  return ang
end;
--[[*****************************************************]]
--[[  возвращаяет угол в пределах 0 <= ang <= math.pi*2  ]]
--[[-----------------------------------------------------]]

--[[**********************************************************]]
--[[  вернет a_beg, a_beg+math.pi*2, или a_beg-math.pi*2      ]]
--[[  для кратчайшей анимации поворота угла от a_beg к a_end  ]]
--[[----------------------------------------------------------]]
function gm.ang_closer( a_beg, a_end )
  if math.abs(a_beg-a_end) > math.pi then
    if a_beg > a_end then
      a_beg = a_beg - math.pi * 2
    else
      a_beg = a_beg + math.pi * 2
    end;
  end;
  return a_beg;
end;
--[[----------------------------------------------------------]]
--[[          0 <= ( a_beg и a_end ) <= math.pi*2             ]]
--[[**********************************************************]]