-- name=level

function public.Start ( param )


  interface.WidgetAdd( InterfaceWidget_Pause, 1800 );

  interface.WidgetAdd( InterfaceWidget_BtnMenu, 13 );

  interface.WidgetAdd( InterfaceWidget_BtnHint, 11  );
  interface.WidgetAdd( InterfaceWidget_BtnSkip, 11 );
  interface.WidgetAdd( InterfaceWidget_BtnInfo, 9 );
  interface.WidgetAdd( InterfaceWidget_BtnReset, 9 );

  --interface.WidgetAdd( InterfaceWidget_TaskHeader );
  interface.WidgetAdd( InterfaceWidget_Inventory, 9 );
  interface.WidgetAdd( InterfaceWidget_TaskPanel, 9 );

  interface.WidgetAdd( InterfaceWidget_Effects );



  interface.WidgetAdd( InterfaceWidget_DialogHo,30 );

  interface.ButtonLockAdd();
  interface.LockAdd();



  interface.WidgetAdd( InterfaceWidget_FrameSubroom, 8 );

  interface.WidgetAdd( InterfaceWidget_ItemPanel,9 );
  interface.WidgetAdd( InterfaceWidget_Popup );

  interface.WidgetAdd( InterfaceWidget_BlackBarText, 1500 );
  interface.WidgetAdd( InterfaceWidget_Dialog,30 );

  interface.WidgetAdd( InterfaceWidget_DialogVideo,30 );
  interface.WidgetAdd( InterfaceWidget_DialogStory,30 );
  interface.WidgetAdd( InterfaceWidget_DialogCharacter, 30 );

  interface.WidgetAdd( InterfaceWidget_Window );

  interface.WidgetAdd( InterfaceWidget_Tutorial,30 );

  interface.WidgetAdd( InterfaceWidget_Map, 16  );

  interface.WidgetAdd( InterfaceWidget_BtnMap, 11 );

  interface.PanelNotificationAdd(10);

  if IsCollectorsEdition() then
    if true then -- temp for version
      interface.WidgetAdd( InterfaceWidget_StrategyGuide,30 );
      interface.WidgetAdd( InterfaceWidget_BtnGuide, 12 );
    end
  end
  
  --interface.DeployInvAdd(7);
  interface.ComplexInvAdd( 9 )
  interface.DialogHintAdd(20);
  --interface.Btn_DiaryAdd(12)
  --interface.InvestigationButtonAdd( 17 );
  --interface.DiaryAdd( 18 );
  --interface.DiaryDcnAdd( 31 );

  interface.PanelhopairAdd(9)

  interface.ButtonTaskAdd(20)
  interface.DialogTaskAdd(10)

  private.Init();


  ModLoad( "assets/levels/level/mod_level_inv" );
  level_inv.Init()

  private.TutorInit()--тутор
  --

  interface.ArrPuzzles()

  common.LevelLoad( "level", "std", "rm_entrypoint", param );
  --ModLoad( "assets/interface/map/mod_map" );


  local function GetPuzlesRooms()
    for i = 1, 36 do
      local puzzle = "spr_puzzle_"..i
      local result

      local parent = ObjGetRelations( puzzle ).parent
      local grandparent = common_impl.smart_hint_connections[parent];
      local arr = {}
      if type(grandparent) == "string" then
        local gate = "gzz_"..ld.StringDivide(grandparent)[2].."_"..ld.StringDivide(parent)[2]
        ld.LogTrace( string.format("%s: room = \"%s\",   zz_gate = \"%s\",   zz= \"%s\"", i, grandparent, gate, parent) );
      else
        ld.LogTrace( string.format("%s: room = \"%s\"", i, parent) );
      end
      --result = string.gsub(result,"%#(%w+)",arr)
      --ld.LogTrace( i, result );
    end
  end
  --GetPuzlesRooms() -- для interface.ArrPuzzles()

  interface.ArrInvPlus()  -- проверка состояния плюсика для деплойных инв предметов

  interface.KeyUpdate();

  --временно залочена кнопка SG
  interface.WidgetSetInput(InterfaceWidget_BtnGuide, 1)

  ObjSet( "txt_int_dialog_character", {param0 = GetCurrentProfile()} );
  --автоподствновка имени игрока в диалоги

  interface.CheckPuzzles()
  interface.CheckMorphing()





end;

function public.CubeAdd() -- get_casket
  
  interface.CubeAdd( -999 )
  cmn.CallEventHandler( "LevelLoaded" )

end

function public.SimonAdd() -- get_simon
  
  interface.SimonAdd(14)
 -- int_simon.LoadAnotherPrg()
end

function private.Init ()

  game = {};
  game.room_names =
  {
     "rm_entrypoint"
    ,"rm_outro"

--[[AUTO]]  ,"mg_casket"
--[[AUTO]]  ,"rm_hall"
--[[AUTO]]  ,"ho_underfirtreeho"
--[[AUTO]]  ,"rm_cabinet"
--[[AUTO]]  ,"mg_citymg"
--[[AUTO]]  ,"rm_street"
--[[AUTO]]  ,"ho_sledge"
--[[AUTO]]  ,"rm_nearshop"
--[[AUTO]]  ,"rm_shop"
--[[AUTO]]  ,"rm_mansion"
--[[AUTO]]  ,"ho_knightho"
--[[AUTO]]  ,"rm_river"
--[[AUTO]]  ,"mg_seedmg"
--[[AUTO]]  ,"ho_elfho"
--[[AUTO]]  ,"mg_statuemg"
--[[AUTO]]  ,"rm_workshop"
--[[AUTO]]  ,"rm_secondfloor"
--[[AUTO]]  ,"rm_bedroom"
--[[AUTO]]  ,"mg_mousemg"
--[[AUTO]]  ,"rm_citystreets"
--[[AUTO]]  ,"rm_jewelryshop"
--[[AUTO]]  ,"ho_musicansho"
--[[AUTO]]  ,"rm_dressroom"
--[[AUTO]]  ,"mg_hatsmg"
--[[AUTO]]  ,"ho_jewelryho"

--[[AUTO]]  ,"rm_newyard"
--[[AUTO]]  ,"rm_newhall"
--[[AUTO]]  ,"ho_winterbalcony"
--[[AUTO]]  ,"rm_floor"
--[[AUTO]]  ,"rm_attic"
--[[AUTO]]  ,"ho_train"
--[[AUTO]]  ,"rm_backyard"
--[[AUTO]]  ,"mg_labyrinth"
--[[AUTO]]  ,"rm_chapel"
--[[AUTO]]  ,"ho_icearbour"
--[[AUTO]]  ,"mg_fight"
  };

  game.progress_names =
  {
     "opn_entrypoint"
--[[AUTO]]  ,"dlg_entrypoint_jack1"
--[[AUTO]]  ,"get_goodball"
--[[AUTO]]  ,"get_amuletelf1"
--[[AUTO]]  ,"get_cone1"
--[[AUTO]]  ,"get_casket"
--[[AUTO]]  ,"use_amuletelf1"
--[[AUTO]]  ,"win_casket1"
--[[AUTO]]  ,"get_goldenfeather"
--[[AUTO]]  ,"use_goldenfeather_case"
--[[AUTO]]  ,"clk_casefeather"
--[[AUTO]]  ,"clk_flashback1"
--[[AUTO]]  ,"get_paper"
--[[AUTO]]  ,"clk_cakepaper"
--[[AUTO]]  ,"get_cake"
--[[AUTO]]  ,"use_cake"
--[[AUTO]]  ,"get_cherry"
--[[AUTO]]  ,"get_postalcheck"
--[[AUTO]]  ,"use_postalcheck"
--[[AUTO]]  ,"clk_mailboxpackage"
--[[AUTO]]  ,"get_giftknife"
--[[AUTO]]  ,"get_catfigurine"
--[[AUTO]]  ,"use_giftknife_case"
--[[AUTO]]  ,"get_thermos"
--[[AUTO]]  ,"use_thermos"
            ,"dlg_entrypoint_goody"
--[[AUTO]]  ,"get_elf"
--[[AUTO]]  ,"use_elf_window"
--[[AUTO]]  ,"opn_hall"
--[[AUTO]]  ,"clk_flashback2"
--[[AUTO]]  ,"get_monogram"
--[[AUTO]]  ,"get_lockpart1"
--[[AUTO]]  ,"get_titmouse"
--[[AUTO]]  ,"use_monogram"
--[[AUTO]]  ,"get_lighter"
--[[AUTO]]  ,"get_lockpart2"
--[[AUTO]]  ,"use_lighter"
--[[AUTO]]  ,"opn_underfirtreeho"
--[[AUTO]]  ,"win_underfirtreeho"
--[[AUTO]]  ,"use_giftknife_gift"
--[[AUTO]]  ,"get_sealingtape"
--[[AUTO]]  ,"clk_giftcover"
--[[AUTO]]  ,"clk_giftletter"
--[[AUTO]]  ,"get_bullfinch"
--[[AUTO]]  ,"get_cone2"
--[[AUTO]]  ,"use_titmouse"
--[[AUTO]]  ,"use_bullfinch"
--[[AUTO]]  ,"get_lockpart3"
--[[AUTO]]  ,"get_bunchofrowan"
--[[AUTO]]  ,"use_bunchofrowan"
--[[AUTO]]  ,"use_cone"
--[[AUTO]]  ,"clk_cone"
--[[AUTO]]  ,"clk_apples"
--[[AUTO]]  ,"clk_bunchofrowan"
--[[AUTO]]  ,"clk_balloons"
--[[AUTO]]  ,"clk_bow"
--[[AUTO]]  ,"clk_bow1"
--[[AUTO]]  ,"clk_tape"
--[[AUTO]]  ,"clk_snow"
--[[AUTO]]  ,"get_christmaswreath"
--[[AUTO]]  ,"get_lockpart4"
--[[AUTO]]  ,"use_lockpart"
--[[AUTO]]  ,"opn_cabinet"
--[[AUTO]]  ,"get_silverwing"
--[[AUTO]]  ,"get_coal"
            ,"get_balerina"
--[[AUTO]]  ,"use_catfigurine"
--[[AUTO]]  ,"get_photo1"
--[[AUTO]]  ,"get_snowflake1"
--"get_butterfly"
--[[AUTO]]  ,"get_thongs"
--[[AUTO]]  ,"use_silverwing"
--  ,"use_butterfly"
--[[AUTO]]  ,"get_brokenrackets"
--[[AUTO]]  ,"get_bucket"
--[[AUTO]]  ,"get_wadding"
--[[AUTO]]  ,"use_coal"
--[[AUTO]]  ,"use_bucket"
--[[AUTO]]  ,"get_snowflake2"
--[[AUTO]]  ,"use_snowflake1"
--[[AUTO]]  ,"use_snowflake2"
--[[AUTO]]  ,"win_citymg"
--[[AUTO]]  ,"get_santasrendeer"
--[[AUTO]]  ,"get_photo2"
--[[AUTO]]  ,"use_santasrendeer"
--[[AUTO]]  ,"get_buttons"
--[[AUTO]]  ,"use_buttons"
--[[AUTO]]  ,"get_paperdove"
--[[AUTO]]  ,"clk_paperdove1"
--[[AUTO]]  ,"clk_paperdove2"
--[[AUTO]]  ,"clk_paperdove3"
--[[AUTO]]  ,"get_snowshoespaper"
--[[AUTO]]  ,"get_goldenwing"
--[[AUTO]]  ,"use_goldenwing"
--[[AUTO]]  ,"get_smallaxe"
--[[AUTO]]  ,"get_photo3"
--[[AUTO]]  ,"use_photo"
--[[AUTO]]  ,"win_photowall"
--[[AUTO]]  ,"clk_photowall"
--[[AUTO]]  ,"get_photoadress"
--[[AUTO]]  ,"use_smallaxe"
--[[AUTO]]  ,"get_branch"
--[[AUTO]]  ,"clk_brokenrackets"
--[[AUTO]]  ,"use_snowshoespaper"
--[[AUTO]]  ,"use_branch"
--[[AUTO]]  ,"use_sealingtape"
--[[AUTO]]  ,"clk_selingtape"
--[[AUTO]]  ,"use_thongs"
--[[AUTO]]  ,"clk_thongs"
--[[AUTO]]  ,"get_snowshoes"
--[[AUTO]]  ,"use_snowshoes"
--[[AUTO]]  ,"use_photoadress"
--[[AUTO]]  ,"opn_street"
--[[AUTO]]  ,"get_brokenbrush"
--[[AUTO]]  ,"get_solvent"
--[[AUTO]]  ,"use_solvent"
--[[AUTO]]  ,"use_wadding"
--[[AUTO]]  ,"get_insulatingtape"
--[[AUTO]]  ,"get_needlthreads"
--[[AUTO]]  ,"use_insulatingtape"
--[[AUTO]]  ,"get_brush"
--[[AUTO]]  ,"use_brush"
--[[AUTO]]  ,"opn_sledge"
--[[AUTO]]  ,"win_sledge"
--[[AUTO]]  ,"clk_sledge"
--[[AUTO]]  ,"opn_nearshop"
--[[AUTO]]  ,"get_garland"
--[[AUTO]]  ,"win_garland"
--[[AUTO]]  ,"use_elf_garland"
--[[AUTO]]  ,"get_elfclimber"
--[[AUTO]]  ,"use_elfclimber"
--[[AUTO]]  ,"get_mittens"
--[[AUTO]]  ,"use_mittens"
--[[AUTO]]  ,"get_coalsscoop"
--[[AUTO]]  ,"use_coalsscoop"
--[[AUTO]]  ,"clk_shopdoor"
--[[AUTO]]  ,"opn_shop"
--[[AUTO]]  ,"clk_boltinshop"
--[[AUTO]]  ,"dlg_shop_michael1"
--[[AUTO]]  ,"get_amuletelf2"
--[[AUTO]]  ,"use_amuletelf2"
--[[AUTO]]  ,"win_casket2"
--[[AUTO]]  ,"get_snowqueen"
--[[AUTO]]  ,"get_lostwallet"
--[[AUTO]]  ,"clk_lostwallet"
--[[AUTO]]  ,"clk_lostwalletopen"
--[[AUTO]]  ,"get_amuletpalette"
--[[AUTO]]  ,"get_twocoins"
--[[AUTO]]  ,"use_snowqueen"
--[[AUTO]]  ,"win_icecastle"
--[[AUTO]]  ,"get_ironbowl"
--[[AUTO]]  ,"use_ironbowl"
--[[AUTO]]  ,"get_frozenpitch"
--[[AUTO]]  ,"use_amuletpalette"
--[[AUTO]]  ,"get_paints"
--[[AUTO]]  ,"use_frozenpitch"
--[[AUTO]]  ,"get_stickymass"
--[[AUTO]]  ,"use_stickymass"
--[[AUTO]]  ,"use_paints"
--[[AUTO]]  ,"win_statuemg"
--[[AUTO]]  ,"dlg_shop_michael2"
--[[AUTO]]  ,"get_moneybag1"
--[[AUTO]]  ,"use_goldenfeather_shop"
--[[AUTO]]  ,"use_paper"
--[[AUTO]]  ,"dlg_shop_michael3"
--[[AUTO]]  ,"get_alexnote"
--[[AUTO]]  ,"get_gateskey"
--[[AUTO]]  ,"use_gateskey"
--[[AUTO]]  ,"opn_mansion"
--[[AUTO]]  ,"use_alexnote"
--[[AUTO]]  ,"dlg_mansion_alex1"
--[[AUTO]]  ,"get_girlsdoll"
--[[AUTO]]  ,"clk_floweronchain"
--[[AUTO]]  ,"get_floweronchain"
--[[AUTO]]  ,"get_rasp"
--[[AUTO]]  ,"use_rasp_icecastle"
--[[AUTO]]  ,"get_figurmaster"
--[[AUTO]]  ,"use_rasp_tree"
--[[AUTO]]  ,"get_figurboy"
--[[AUTO]]  ,"get_scarf"
--[[AUTO]]  ,"use_rasp_worktable"
--[[AUTO]]  ,"get_figurwomen"
--[[AUTO]]  ,"use_figurmaster"
--[[AUTO]]  ,"use_figurboy"
--[[AUTO]]  ,"use_figurwomen"
--[[AUTO]]  ,"win_showcase"
--[[AUTO]]  ,"get_knighthelm"
--[[AUTO]]  ,"use_knighthelm"
--[[AUTO]]  ,"opn_knightho"
--[[AUTO]]  ,"win_knightho"
--[[AUTO]]  ,"use_scarf"
--[[AUTO]]  ,"get_sled"
--[[AUTO]]  ,"use_sled"
--[[AUTO]]  ,"opn_river"
--[[AUTO]]  ,"use_girlsdoll"
--[[AUTO]]  ,"dlg_river_chloe1"
--[[AUTO]]  ,"get_brokenbrooch"
--[[AUTO]]  ,"get_bluntscates"
--[[AUTO]]  ,"get_bread"
--[[AUTO]]  ,"use_bluntscates"
--[[AUTO]]  ,"get_scates"
--[[AUTO]]  ,"use_scates"
--[[AUTO]]  ,"get_forceps"
--[[AUTO]]  ,"get_fishingline"
--[[AUTO]]  ,"clk_anim"
--[[AUTO]]  ,"use_bread"
--[[AUTO]]  ,"get_emerald"
--[[AUTO]]  ,"get_magnet"
--[[AUTO]]  ,"get_button"
--[[AUTO]]  ,"use_fishingline"
--[[AUTO]]  ,"get_linedmagnet"
--[[AUTO]]  ,"use_linedmagnet_icehole1"
--[[AUTO]]  ,"clk_linedmagnet1"
--[[AUTO]]  ,"use_linedmagnet_icehole2"
--[[AUTO]]  ,"clk_linedmagnet2"
--[[AUTO]]  ,"use_linedmagnet_icehole3"
--[[AUTO]]  ,"get_ironpattern"
--[[AUTO]]  ,"get_amuletelf3"
--[[AUTO]]  ,"use_amuletelf3"
--[[AUTO]]  ,"win_casket3"
--[[AUTO]]  ,"get_firtree"
--[[AUTO]]  ,"use_firtree"
--[[AUTO]]  ,"use_elf_smallwindow"
--[[AUTO]]  ,"win_seedmg"
--[[AUTO]]  ,"get_diamond"
--[[AUTO]]  ,"use_button"
--[[AUTO]]  ,"clk_button"
--[[AUTO]]  ,"get_goldsprayer"
--[[AUTO]]  ,"use_floweronchain"
--[[AUTO]]  ,"use_forceps"
--[[AUTO]]  ,"clk_forceps"
--[[AUTO]]  ,"use_diamond"
--[[AUTO]]  ,"clk_diamond"
--[[AUTO]]  ,"use_emerald"
--[[AUTO]]  ,"clk_emerald"
--[[AUTO]]  ,"use_ironpattern"
--[[AUTO]]  ,"clk_ironpattern"
--[[AUTO]]  ,"use_goldsprayer"
--[[AUTO]]  ,"clk_brokenbrooch"
--[[AUTO]]  ,"get_chloebrooch"
--[[AUTO]]  ,"use_chloebrooch"
--[[AUTO]]  ,"opn_elfho"
--[[AUTO]]  ,"win_elfho"
--[[AUTO]]  ,"use_goodbrooch"
--[[AUTO]]  ,"dlg_river_chloe2"
--[[AUTO]]  ,"dlg_mansion_alex2"
--[[AUTO]]  ,"get_moneybag2"
--[[AUTO]]  ,"use_moneybag"
--[[AUTO]]  ,"clk_outro1"


--[[AUTO]]  ,"opn_workshop"
--[[AUTO]]  ,"get_amuletmonequin"
--[[AUTO]]  ,"clk_sewingtableanim"
--[[AUTO]]  ,"get_pillow"
--[[AUTO]]  ,"use_pillow"
--[[AUTO]]  ,"get_piterdiary"
--[[AUTO]]  ,"clk_buffetanim"
--[[AUTO]]  ,"clk_buffetcup"
--[[AUTO]]  ,"get_diarykey"
--[[AUTO]]  ,"use_diarykey"
--[[AUTO]]  ,"win_flashback"
--[[AUTO]]  ,"get_amuletelf4"
--[[AUTO]]  ,"clk_workshopbertagoldvid"
--[[AUTO]]  ,"use_amuletelf4"
--[[AUTO]]  ,"win_casket4"
--[[AUTO]]  ,"get_hatamulet"
--[[AUTO]]  ,"use_hatamulet"
--[[AUTO]]  ,"use_amuletmonequin"
--[[AUTO]]  ,"clk_doortoupopen"
--[[AUTO]]  ,"opn_secondfloor"
--[[AUTO]]  ,"get_bell1"
--[[AUTO]]  ,"get_tweezers"
--[[AUTO]]  ,"use_tweezers_doortodressroom1"
--[[AUTO]]  ,"get_woodhorse"
--[[AUTO]]  ,"use_tweezers_doortodressroom2"
--[[AUTO]]  ,"get_candy1"
--[[AUTO]]  ,"use_woodhorse"
--[[AUTO]]  ,"get_sparkler"
--[[AUTO]]  ,"get_choppedfigure"
--[[AUTO]]  ,"use_sparkler"
--[[AUTO]]  ,"get_aflamesparkler"
--[[AUTO]]  ,"use_aflamesparkler"
--[[AUTO]]  ,"use_tweezers_floorshelfs1"
--[[AUTO]]  ,"get_angel"
--[[AUTO]]  ,"use_tweezers_floorshelfs2"
--[[AUTO]]  ,"get_candy2"
--[[AUTO]]  ,"use_angel"
--[[AUTO]]  ,"win_angels"
--[[AUTO]]  ,"clk_doortobedroom"
--[[AUTO]]  ,"opn_bedroom"
--[[AUTO]]  ,"clk_mouseanim"
--[[AUTO]]  ,"get_glue"
--[[AUTO]]  ,"get_firurepart"
--[[AUTO]]  ,"get_panicleofeathers"
--[[AUTO]]  ,"use_firurepart"
--[[AUTO]]  ,"use_glue"
--[[AUTO]]  ,"get_figure"
--[[AUTO]]  ,"use_figure"
--[[AUTO]]  ,"win_figures"
--[[AUTO]]  ,"get_bulb"
--[[AUTO]]  ,"get_apron"
--[[AUTO]]  ,"use_elf_panicleofeathers"
--[[AUTO]]  ,"use_apron"
--[[AUTO]]  ,"get_elfcleaner"
--[[AUTO]]  ,"use_bulb"
--[[AUTO]]  ,"use_elfcleaner"
--[[AUTO]]  ,"get_skewers"
--[[AUTO]]  ,"use_skewers"
--[[AUTO]]  ,"win_mousemg"
--[[AUTO]]  ,"get_mousemessage"
--[[AUTO]]  ,"clk_hoof2"
--[[AUTO]]  ,"clk_hoof"
--[[AUTO]]  ,"get_hoof"
--[[AUTO]]  ,"use_hoof"
--[[AUTO]]  ,"get_loupe"
--[[AUTO]]  ,"clk_loupe"
--[[AUTO]]  ,"use_loupe"
--[[AUTO]]  ,"get_list"
--[[AUTO]]  ,"use_list"
--[[AUTO]]  ,"dlg_workshop_goody2"
--[[AUTO]]  ,"get_bell2"
--[[AUTO]]  ,"get_mouse"
--[[AUTO]]  ,"use_bell1"
--[[AUTO]]  ,"use_bell2"
--[[AUTO]]  ,"win_sound"
--[[AUTO]]  ,"opn_citystreets"
--[[AUTO]]  ,"get_woodhorse2"
--[[AUTO]]  ,"get_collar"
--[[AUTO]]  ,"use_woodhorse2"
--[[AUTO]]  ,"get_rope"
--[[AUTO]]  ,"get_bear"
--[[AUTO]]  ,"use_rope"
--[[AUTO]]  ,"get_lead"
--[[AUTO]]  ,"use_mouse_citystreets"
--[[AUTO]]  ,"use_lead"
--[[AUTO]]  ,"get_candy3"
--[[AUTO]]  ,"use_christmaswreath"
--[[AUTO]]  ,"clk_doortojewelryshopopen"
--[[AUTO]]  ,"opn_jewelryshop"
--[[AUTO]]  ,"get_puzzle1"
--[[AUTO]]  ,"get_fife"
--[[AUTO]]  ,"use_fife"
--[[AUTO]]  ,"opn_musicansho"
--[[AUTO]]  ,"win_musicansho"
--[[AUTO]]  ,"clk_candyprizeopen"
--[[AUTO]]  ,"get_candy4"
--[[AUTO]]  ,"get_wolf"
--[[AUTO]]  ,"use_bear"
--[[AUTO]]  ,"use_wolf"
--[[AUTO]]  ,"clk_phonetablecsket"
--[[AUTO]]  ,"get_whitethreads"
--[[AUTO]]  ,"get_amuletelf5"
--[[AUTO]]  ,"use_amuletelf5"
--[[AUTO]]  ,"win_casket5"
--[[AUTO]]  ,"get_horn"
--[[AUTO]]  ,"use_horn"
--[[AUTO]]  ,"get_crown"
--[[AUTO]]  ,"get_puzzle2"
--[[AUTO]]  ,"use_crown"
--[[AUTO]]  ,"get_amuletcake"
--[[AUTO]]  ,"use_amuletcake"
--[[AUTO]]  ,"use_cherry"
--[[AUTO]]  ,"get_pretzel"
--[[AUTO]]  ,"get_powder"
--[[AUTO]]  ,"use_powder"
--[[AUTO]]  ,"win_code"
--[[AUTO]]  ,"get_clasp"
--[[AUTO]]  ,"get_specs"
--[[AUTO]]  ,"use_specs"
--[[AUTO]]  ,"get_candy5"
--[[AUTO]]  ,"use_candy"
--[[AUTO]]  ,"get_key"
--[[AUTO]]  ,"get_torneddiplom"
--[[AUTO]]  ,"use_key"
--[[AUTO]]  ,"opn_dressroom"
--[[AUTO]]  ,"get_frame"
--[[AUTO]]  ,"get_puzzle3"
--[[AUTO]]  ,"use_puzzle"
--[[AUTO]]  ,"win_tag"
--[[AUTO]]  ,"get_pliers"
--[[AUTO]]  ,"get_hatbase"
--[[AUTO]]  ,"use_pliers"
--[[AUTO]]  ,"clk_manequinopn"
--[[AUTO]]  ,"use_mouse_manequin"
--[[AUTO]]  ,"get_ruby"
--[[AUTO]]  ,"get_diplompart"
--[[AUTO]]  ,"use_diplompart"
--[[AUTO]]  ,"clk_diplomant_1"
--[[AUTO]]  ,"clk_diplomant_2"
--[[AUTO]]  ,"clk_diplomant_3"
--[[AUTO]]  ,"clk_diplomant_4"
--[[AUTO]]  ,"clk_diplomant_5"
--[[AUTO]]  ,"use_frame"
--[[AUTO]]  ,"get_diplom"
--[[AUTO]]  ,"use_diplom"
--[[AUTO]]  ,"get_feather"
--[[AUTO]]  ,"get_goldenbuttons"
--[[AUTO]]  ,"use_feather"
--[[AUTO]]  ,"use_ruby"
--[[AUTO]]  ,"use_bells"
--[[AUTO]]  ,"use_needlthreads"
--[[AUTO]]  ,"get_carnivalhat"
--[[AUTO]]  ,"use_carnivalhat"
--[[AUTO]]  ,"win_hatsmg"
--[[AUTO]]  ,"get_camisole1"
--[[AUTO]]  ,"get_confectioner"
--[[AUTO]]  ,"get_goldenthreads"
--[[AUTO]]  ,"use_confectioner"
--[[AUTO]]  ,"get_lily1"
--[[AUTO]]  ,"get_mitten"
--[[AUTO]]  ,"use_mitten"
--[[AUTO]]  ,"get_lily2"
--[[AUTO]]  ,"use_lily1"
--[[AUTO]]  ,"use_lily2"
--[[AUTO]]  ,"get_latchkey"
--[[AUTO]]  ,"get_camisole2"
--[[AUTO]]  ,"use_latchkey"
--[[AUTO]]  ,"opn_jewelryho"
--[[AUTO]]  ,"win_jewelryho"
--[[AUTO]]  ,"use_lionpen"
--[[AUTO]]  ,"get_oldbook"
--[[AUTO]]  ,"get_camisole3"
--[[AUTO]]  ,"use_camisole"
--[[AUTO]]  ,"clk_camisole"
--[[AUTO]]  ,"clk_camisole2"
--[[AUTO]]  ,"clk_camisole3"
--[[AUTO]]  ,"get_sketch"
--[[AUTO]]  ,"use_whitethreads"
--[[AUTO]]  ,"use_clasp"
--[[AUTO]]  ,"use_goldenthreads"
--[[AUTO]]  ,"use_sketch"
--[[AUTO]]  ,"use_goldenbuttons"
--[[AUTO]]  ,"use_elf_sewingtable"

--[[AUTO]]  ,"opn_newyard"
--[[AUTO]]  ,"dlg_newyard_abigail31"
--[[AUTO]]  ,"get_housekey"
--[[AUTO]]  ,"use_housekey"
--[[AUTO]]  ,"get_amuletelf6"
--[[AUTO]]  ,"use_amuletelf6"
--[[AUTO]]  ,"win_casket6"
--[[AUTO]]  ,"get_shell"
--[[AUTO]]  ,"use_shell"
--[[AUTO]]  ,"get_mosaicbow"
--[[AUTO]]  ,"get_sharpteeth"
--[[AUTO]]  ,"get_toyhouse"
--[[AUTO]]  ,"use_sharpteeth_angels"
--[[AUTO]]  ,"get_splinter"
--[[AUTO]]  ,"use_mosaicbow"
--[[AUTO]]  ,"use_splinter"
--[[AUTO]]  ,"get_firedsplinter"
--[[AUTO]]  ,"use_firedsplinter"
--[[AUTO]]  ,"clk_newhalldoor1"
--[[AUTO]]  ,"clk_newhalldoor2"
--[[AUTO]]  ,"opn_newhall"
--[[AUTO]]  ,"get_letterscasket"
--[[AUTO]]  ,"get_nimbus"
--[[AUTO]]  ,"use_twocoins"
--[[AUTO]]  ,"get_casketpart1"
--[[AUTO]]  ,"use_nimbus"
--[[AUTO]]  ,"get_balconyhandle"
--[[AUTO]]  ,"get_seastar1"
--[[AUTO]]  ,"use_balconyhandle"
--[[AUTO]]  ,"clk_balcony"
--[[AUTO]]  ,"opn_winterbalcony"
--[[AUTO]]  ,"win_winterbalcony"
--[[AUTO]]  ,"use_seastar1"
--[[AUTO]]  ,"use_seastar2"
--[[AUTO]]  ,"win_newfireplace"
--[[AUTO]]  ,"get_umbrella"
--[[AUTO]]  ,"get_sandpaper"
--[[AUTO]]  ,"use_elf_umbrella"
--[[AUTO]]  ,"get_elfumbrella"
--[[AUTO]]  ,"use_elfumbrella"
--[[AUTO]]  ,"get_pipebillet"
--[[AUTO]]  ,"get_smallwheel"
--[[AUTO]]  ,"use_sandpaper"
--[[AUTO]]  ,"use_sharpteeth_pipebillet"
--[[AUTO]]  ,"get_magicpipe"
--[[AUTO]]  ,"use_magicpipe"
--[[AUTO]]  ,"win_cerber"
--[[AUTO]]  ,"opn_floor"
--[[AUTO]]  ,"get_casketpart2"
--[[AUTO]]  ,"use_pretzel"
--[[AUTO]]  ,"get_amuletelf7"
--[[AUTO]]  ,"use_amuletelf7"
--[[AUTO]]  ,"win_casket7"
--[[AUTO]]  ,"get_newangel"
--[[AUTO]]  ,"use_newangel"
--[[AUTO]]  ,"get_oldbook2"
--[[AUTO]]  ,"get_boytoy"
--[[AUTO]]  ,"use_toyhouse"
--[[AUTO]]  ,"use_boytoy"
--[[AUTO]]  ,"get_casketpart3"
--[[AUTO]]  ,"get_drumstick"
--[[AUTO]]  ,"use_casketpart"
--[[AUTO]]  ,"get_hinrletter"
--[[AUTO]]  ,"get_toytrain"
--[[AUTO]]  ,"use_oldbook"
--[[AUTO]]  ,"use_oldbook2"
--[[AUTO]]  ,"use_hinrletter"
--[[AUTO]]  ,"clk_newfireplace1"
--[[AUTO]]  ,"clk_newfireplace2"
--[[AUTO]]  ,"get_abigailletter1"
--[[AUTO]]  ,"clk_flashback31"
--[[AUTO]]  ,"get_griffonhead"
--[[AUTO]]  ,"get_railroadpart"



--[[AUTO]]  ,"use_griffonhead"
--[[AUTO]]  ,"win_atticdoor"
--[[AUTO]]  ,"opn_attic"
--[[AUTO]]  ,"get_humanform"
--[[AUTO]]  ,"clk_openangryoven"
--[[AUTO]]  ,"get_recipecookies"
--[[AUTO]]  ,"get_bakingtray"
--[[AUTO]]  ,"use_railroadpart"
--[[AUTO]]  ,"use_toytrain"
--[[AUTO]]  ,"use_elf_railroad"
--[[AUTO]]  ,"opn_train"
--[[AUTO]]  ,"win_train"
            ,"clk_trainelfreturn"
--[[AUTO]]  ,"use_beargirl"
--[[AUTO]]  ,"get_dough"
--[[AUTO]]  ,"get_funnyracoon"
--[[AUTO]]  ,"use_funnyracoon"
--[[AUTO]]  ,"clk_boxwithtoys1"
--[[AUTO]]  ,"clk_boxwithtoys2"
--[[AUTO]]  ,"clk_boxwithtoys3"
--[[AUTO]]  ,"clk_boxwithtoys4"
--[[AUTO]]  ,"get_spoon"
--[[AUTO]]  ,"get_faceprint"
--[[AUTO]]  ,"clk_shugar"
--[[AUTO]]  ,"use_spoon"
--[[AUTO]]  ,"get_sugarspoon"
--[[AUTO]]  ,"get_newbutton1"
--[[AUTO]]  ,"use_recipecookies"
--[[AUTO]]  ,"use_humanform"
--[[AUTO]]  ,"use_dough"
--[[AUTO]]  ,"use_sugarspoon"
--[[AUTO]]  ,"use_faceprint"
--[[AUTO]]  ,"get_ovencookies"
--[[AUTO]]  ,"use_ovencookies"
--[[AUTO]]  ,"get_abigailletter2"
--[[AUTO]]  ,"clk_flashback32"

--[[AUTO]]  ,"get_dragon1"
--[[AUTO]]  ,"get_newbutton2"
--[[AUTO]]  ,"use_newbutton"
--[[AUTO]]  ,"clk_newbutton1"
--[[AUTO]]  ,"clk_newbutton2"
--[[AUTO]]  ,"get_dragon2"
--[[AUTO]]  ,"use_dragon1"
--[[AUTO]]  ,"use_dragon2"
--[[AUTO]]  ,"clk_doortobackyard"
--[[AUTO]]  ,"opn_backyard"
--[[AUTO]]  ,"get_ball1"
--[[AUTO]]  ,"get_mosaicmoon"
--[[AUTO]]  ,"clk_startclimbs"
--[[AUTO]]  ,"get_harefoot"
--[[AUTO]]  ,"use_harefoot"
--[[AUTO]]  ,"use_drumstick"
--[[AUTO]]  ,"get_clockworkmouse"
--[[AUTO]]  ,"get_mosaicsun"
--[[AUTO]]  ,"use_mosaicmoon"
--[[AUTO]]  ,"use_mosaicsun"
--[[AUTO]]  ,"get_mousekey"
--[[AUTO]]  ,"get_ball2"
--[[AUTO]]  ,"use_smallwheel"
--[[AUTO]]  ,"use_mousekey"
--[[AUTO]]  ,"get_mouseready"
--[[AUTO]]  ,"use_mouseready"
--[[AUTO]]  ,"win_labyrinth"
--[[AUTO]]  ,"get_slapstick"
--[[AUTO]]  ,"get_ovalframe"
--[[AUTO]]  ,"use_slapstick"
--[[AUTO]]  ,"get_ball3"
--[[AUTO]]  ,"use_ball"
--[[AUTO]]  ,"get_nippers"
--[[AUTO]]  ,"use_nippers_arbourroof"
--[[AUTO]]  ,"get_abigailletter3"
--[[AUTO]]  ,"clk_flashback33"
--[[AUTO]]  ,"use_abigailletter"
--[[AUTO]]  ,"get_fullcasket"
--[[AUTO]]  ,"use_fullcasket"
--[[AUTO]]  ,"dlg_newyard_abigail32"
--[[AUTO]]  ,"get_oldphoto"
--[[AUTO]]  ,"get_map"
--[[AUTO]]  ,"use_oldphoto"
--[[AUTO]]  ,"get_photoboy"
--[[AUTO]]  ,"use_map"
--[[AUTO]]  ,"win_snowpath"
--[[AUTO]]  ,"opn_chapel"
--[[AUTO]]  ,"get_crystalflower"
--[[AUTO]]  ,"use_crystalflower"
--[[AUTO]]  ,"opn_icearbour"
--[[AUTO]]  ,"win_icearbour"
--[[AUTO]]  ,"use_nippers_childrenstruck"
--[[AUTO]]  ,"get_stovepart"
--[[AUTO]]  ,"get_truck"
--[[AUTO]]  ,"use_stovepart"
--[[AUTO]]  ,"get_cookiesready"
--[[AUTO]]  ,"use_photoboy"
--[[AUTO]]  ,"use_truck"
--[[AUTO]]  ,"use_cookiesready"
--[[AUTO]]  ,"dlg_chapel_jack31"
--[[AUTO]]  ,"get_jackalbum"
--[[AUTO]]  ,"use_jackalbum"
--[[AUTO]]  ,"dlg_newyard_abigail33"
--[[AUTO]]  ,"clk_vidonopenfight"
--[[AUTO]]  ,"use_goodball"
--[[AUTO]]  ,"win_fight"

--[[AUTO]]  ,"win_casket"

--[[AUTO]]  ,"clk_outro3"


  };


  game.relations = {};

 --{ prg_true; prg_false; };
game.level_tasks = {

----------LVL--1----------
--[[01]]  "dlg_entrypoint_jack1";
--[[02]]  "clk_flashback1";
--[[03]]  "opn_cabinet";
--[[04]]  "win_photowall";
--[[05]]  "dlg_shop_michael1";
--[[06]]  "dlg_shop_michael3";
--[[07]]  "dlg_mansion_alex1";
--[[08]]  "dlg_river_chloe1";
--[[09]]  "dlg_river_chloe2";

----------LVL--2----------
--[[10]]  "opn_workshop";
--[[11]]  "clk_workshopbertagoldvid";
--[[12]]  "clk_mouseanim";
--[[13]]  "dlg_workshop_goody2";
--[[14]]  "get_clasp";--"get_goldenthreads";
--[[15]]  { "get_sketch", "opn_newyard" };

----------LVL--3----------
--[[16]]  "dlg_newyard_abigail31";
--[[17]]  "get_letterscasket";
--[[18]]  "use_casketpart";
--[[19]]  "get_abigailletter1";
--[[20]]  "get_abigailletter2";
--[[21]]  "get_abigailletter3";
--[[22]]  "dlg_newyard_abigail32";
--[[23]]  "dlg_chapel_jack31";
--[[24]]  "clk_vidonopenfight";
};

end;

function Test ()

  local profiles = GetProfileList();

  local cheater = false;

  for i = 1, #profiles, 1 do

    if ( profiles[ i ] == "CHEATER" ) then

      cheater = true;

    end;

  end;

  AddProfile( "CHEATER" );
  SetCurrentProfile( "CHEATER" );

  if ( not cheater ) then

    ng_global.gamemode = 0;
    ng_global.currentprogress = "std";
    ng_global.progress = {};
    ng_global.progress[ "std" ] = {};
    ng_global.progress[ "std" ].common = {};
    ng_global.progress[ "std" ].common.hinttimer = 0;

    SaveProfiles();

  end;

end;


--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--------------------------------------tutorial----------------------------------------------

function private.TutorInit()

----------------------progress for tutorial
  game.tutorial_progress =
  {
    ["tutorial_question"]     = { uncecked = true, lock = 1, pos_x = 500, pos_y = 180 }
    ,["tutorial_zz"]          = { pos_x = 442, pos_y = 177, tut_arrows= {{pos_x = 11, pos_y =   209, ang =  3.16}} }
    ,["tutorial_get"]         = { pos_x = 400, pos_y = 100, tut_arrows= {{pos_x =  0, pos_y = 219, ang = -1.57}} }
    --,["tutorial_cube"]        = { special = true, pos_x = 500, pos_y = 430, tut_arrows= {{pos_x = -250, pos_y =  200, ang =  3.14}} }
    ,["tutorial_use"]         = { special = true, pos_x = 500, pos_y = 430, tut_arrows= {{pos_x = -250, pos_y =  200, ang =  3.14}} }
    ,["tutorial_deploy"]      = { gamemode_custom = "plus_inv", special = true, pos_x = 500, pos_y = 430, tut_arrows= {{pos_x = -250, pos_y =  200, ang =  3.14}} }
    ,["tutorial_mg"]          = { gamemode_custom = "skip", gamemodeoff = 2, pos_x = 580, pos_y = 410, tut_arrows= {{pos_x =  290, pos_y =   40, ang =  4.71}, {pos_x =  290, pos_y =   160, ang =  3.92}} }
    --,["tutorial_use2"]        = { pos_x = 410, pos_y = 430, tut_arrows= {{pos_x = -160, pos_y =  200, ang =  3.14}, {pos_x =  290, pos_y =    10, ang =  4.84}} }
    ,["tutorial_task"]        = { pos_x = 467, pos_y = 381, tut_arrows= {{pos_x =  -120, pos_y =  200, ang =  -3}} }
    ,["tutorial_hint"]        = { gamemode_custom = "hint", pos_x = 580, pos_y = 440, tut_arrows= {{pos_x =  300, pos_y =  140, ang =  3.92}} }
    ,["tutorial_navigation"]  = { gamemode_custom = "cursor", pos_x = 680, pos_y = 140, tut_arrows= {{pos_x = 168, pos_y =  190, ang =  4.54}} }
    ,["tutorial_map1"]        = { pos_x = 390, pos_y = 400, tut_arrows= {{pos_x = -210, pos_y =  250, ang =  2.36}} }
    ,["tutorial_map2"]        = { pos_x = 600, pos_y = 200 }
    ,["tutorial_hosparkles"]  = { gamemode_custom = "sparkle_area", gamemodeoff = 2, pos_x = 550, pos_y = 139, tut_arrows= {{pos_x = 0, pos_y =  230, ang =  3.14}} }

    ,["tutorial_goody"]        = { special = true, pos_x = 390, pos_y = 400, tut_arrows= {{pos_x = -250, pos_y =  200, ang =  2.36}} }
    ,["tutorial_goody_use"]    = { gamemode_custom = "cursor", special = true, pos_x = 500, pos_y = 380, tut_arrows= {{pos_x = -50, pos_y =  -140, ang =  -1.57}} }


    ,["tutorial_ach"]         = { special = true, pos_x = 512, pos_y = 300, tut_arrows= {{pos_x = -300, pos_y = -50, ang = 0.785}} }
    ,["tutorial_puzzle"]      = { special = true, pos_x = 512, pos_y = 300, tut_arrows= {{pos_x = -300, pos_y = -50, ang = 0.785}} }
    ,["tutorial_morph"]       = { special = true, pos_x = 512, pos_y = 300, tut_arrows= {{pos_x = -300, pos_y = -50, ang = 0.785}} }
--SPECIAL FEATURES
    ,["tutorial_newho1"]= { special = true, pos_x = 512, pos_y = 350, tut_arrows= {{pos_x = 0, pos_y = 250, ang = 3.14}} }
    --,["tutorial_newho2_1"]= { special = true, pos_x = 277, pos_y = 380, tut_arrows= {{pos_x = 210, pos_y = 240, ang = 3.24}, {pos_x = 260, pos_y = 120, ang = -0.66}} }
    --,["tutorial_newho2_2"]= { special = true, pos_x = 362, pos_y = 200, tut_arrows= {{pos_x = 180, pos_y = 200, ang = 3.94}} }
    --,["tutorial_newho2_3"]= { special = true, pos_x = 512, pos_y = 350, tut_arrows= {{pos_x = 0, pos_y = 250, ang = 3.14}, {pos_x = -160, pos_y = -150, ang = 6.54}} }
    --,["tutorial_newho3"]= { special = true, pos_x = 512, pos_y = 350, tut_arrows= {{pos_x = 0, pos_y = 250, ang = 3.14}} }
  };
  
  for i,o in pairs(game.tutorial_progress) do

    table.insert(   game.progress_names, i );

    level[ i ] = {}
  end;
--level.tutorial_question.first()
--level.tutorial_zz.first()
--level.tutorial_get.first()
--level.tutorial_deploy.first()
--level.tutorial_use.first()
--level.tutorial_mg.first()
--level.tutorial_use2.first()
--level.tutorial_task.first()
--level.tutorial_hint.first()
--level.tutorial_navigation.first()
--level.tutorial_map1.first()
--level.tutorial_map2.first()
--level.tutorial_hosparkles.first()
--level.tutorial_ach.first()
--level.tutorial_puzzle.first()
--level.tutorial_morph.first()
--level.tutorial_newho1.first()
--level.tutorial_newho2.first()
--level.tutorial_newho3.first()

   level.tutorial_current = "";
----------------------------------------------------------------------------------------
  function private.TutorialShow(name, offset) -- set current and Show
    if game.tutorial_progress[name].uncecked or ( private.TutorialGameModeCheck( name ) ) then
      level.tutorial_current = name;
      local tut_params = game.tutorial_progress[name];
      if offset then
        for i = 1,#offset-1 do
          tut_params.tut_arrows[i].pos_x = tut_params.tut_arrows[i].pos_x + offset[i+1];
        end
        tut_params.pos_x = tut_params.pos_x + offset[1]
      end
      if tut_params.gamemodeoff then
        if ng_global.gamemode == tut_params.gamemodeoff then
          cmn.SetEventDone( name );
          return false
        end
      end
      if tut_params.gamemode_custom then
        if ng_global.gamemode == 3 and not ng_global.gamemode_custom[ tut_params.gamemode_custom ] then
          cmn.SetEventDone( name );
          return false
        end
      end
      interface.TutorialShow( "str_"..name, tut_params.lock, tut_params.pos_x, tut_params.pos_y, tut_params.tut_arrows );
      return true
    else
      cmn.SetEventDone( name );
      return false
    end
  end

  function private.TutorialHide() -- set current nil and Hide
    cmn.SetEventDone( level.tutorial_current );
    level.tutorial_current = nil
    interface.TutorialHide();
  end

  function public.TutorialDisable() -- skip tutor all
    level.tutorial_current = nil
    if private.panel_notification_on_screen then
      ObjSet( "tmr_int_panel_notification", {playing = 1} );
    end
    for i,o in pairs(game.tutorial_progress) do

      cmn.SetEventDone( i );

    end;

  end;

  function public.TutorialSpecialDisable() --  вырубает только стандартные
    cmn.SetEventDone( level.tutorial_current );
    if private.panel_notification_on_screen then
      ObjSet( "tmr_int_panel_notification", {playing = 1} );
    end
    level.tutorial_current = nil
    for i,o in pairs(game.tutorial_progress) do

      if not o.special then
        cmn.SetEventDone( i );
      end

    end;
    level.tutorial_sp_skiped = true
  end;

  function private.TutorialGameModeCheck(tutorial_name)  -- проверка на кастом режим и выключен ли туториал
    if ng_global.gamemode == 3 and not ng_global.gamemode_custom["tutorial"] then
      cmn.SetEventDone(tutorial_name)
    end
    if not cmn.IsEventDone(tutorial_name) and cmn.IsEventDone( "tutorial_question" ) then
      return true
    else
      return false
    end
  end
----------------------------------------------------------------------------------------
  function public.tutorial_question.first()

    if ( ng_global.gamemode == 0 ) or (ng_global.gamemode == 3) then

      if ng_global.gamemode == 3 and not ng_global.gamemode_custom["tutorial"] then  --
        for i,o in pairs(game.tutorial_progress) do
          cmn.SetEventDone( i );
        end;
      end
      if  ( cmn.IsEventDone( "dlg_entrypoint_jack1" ) )
      and ( not cmn.IsEventDone( "tutorial_question" ) )
      then
        private.TutorialShow("tutorial_question");
      end;

    else
      level.TutorialDisable();
    end;

  end;

  function public.tutorial_question.click() -- событие по клику на да
    private.TutorialHide()
    ld.Lock(1)
    ld.StartTimer( 0.3, function() ld.Lock(0);level.tutorial_zz.first() end )
  end
  function public.tutorial_question.click_no() --не обязательно
    --some code
    interface.TutorialHide();
    level.TutorialDisable();

  end
--------------------------------------------------------------------------------------------
  function public.tutorial_zz.first()
      if  ( cmn.IsEventDone( "tutorial_question" ) ) then
        private.TutorialShow("tutorial_zz");
      end
  end

  function public.tutorial_zz.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
--  function public.tutorial_cube.first()
--      if  ( cmn.IsEventDone( "get_casket" ) ) then
--        local offset = ObjGet("hub_int_inventory_casket") and ObjGet("hub_int_inventory_casket").pos_x
--        private.TutorialShow("tutorial_cube",{0,offset});
--        int_inventory_impl.TempLock(true)
--      end
--  end
--
--  function public.tutorial_cube.click()
--    int_inventory_impl.TempLock(false)
--    private.TutorialHide()
--  end

--------------------------------------------------------------------------------------------
  function public.tutorial_goody.first()
      if  ( cmn.IsEventDone( "get_elf" )  and not cmn.IsEventDone( "use_elf_window" ) ) then
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        private.TutorialShow("tutorial_goody",{-offset});
      end
  end

  function public.tutorial_goody.click()
    private.TutorialHide()
  end

------------------------------------------------------------------------------------------
  function public.tutorial_goody_use.first()
      if  ( cmn.IsEventDone( "get_elf" ) and cmn.IsEventDone( "get_cone1" ) ) then
        --private.TutorialShow("tutorial_goody_use");
      end
  end

  function public.tutorial_goody_use.click()
    if not  ( cmn.IsEventDone( "tutorial_goody_use" ) ) then 
      --private.TutorialHide()
    end
  end



--------------------------------------------------------------------------------------------
  function public.tutorial_get.first()
      private.TutorialShow("tutorial_get");
  end

  function public.tutorial_get.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_deploy.first()
      if  ( cmn.IsEventDone( "get_casket" ) ) then
        local offset = ObjGet("hub_int_inventory_casket") and ObjGet("hub_int_inventory_casket").pos_x
        private.TutorialShow("tutorial_deploy",{0,offset});
      end
  end

  function public.tutorial_deploy.click()
      private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_use.first()
      if ld.CheckRequirements( {"get_amuletelf1","get_casket"} ) then
        local offset = ObjGet("hub_int_inventory_amuletelf1") and ObjGet("hub_int_inventory_amuletelf1").pos_x
        private.TutorialShow("tutorial_use",{0,offset});
      end
  end

  function public.tutorial_use.click()

    private.TutorialHide()

  end
--------------------------------------------------------------------------------------------
  function public.tutorial_mg.first()
      if  ( cmn.IsEventDone( "use_amuletelf1" ) ) then
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        private.TutorialShow("tutorial_mg",{offset});
      end
  end

  function public.tutorial_mg.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
  function public.tutorial_task.first()
      if  ( cmn.IsEventDone( "win_casket1" ) ) then
        if private.TutorialShow("tutorial_task") then
          int_inventory_impl.TempLock(true)
        end
      end
  end

  function public.tutorial_task.click()
    int_inventory_impl.TempLock(false)
    private.TutorialHide()
    --ld.LockRm(1)
    --ld.StartTimer( 0.3, function() ld.LockRm(0) level.tutorial_hint.first() end )
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_hint.first()
      if  ( cmn.IsEventDone( "use_goldenfeather_case" ) ) then
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        private.TutorialShow("tutorial_hint",{offset});
      end
  end

  function public.tutorial_hint.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_navigation.first()
      if  ( cmn.IsEventDone( "use_elf_window" ) ) then
        private.TutorialShow("tutorial_navigation");
      end
  end

  function public.tutorial_navigation.click()
    private.TutorialHide()
  end

--------------------------------------------------------------------------------------------
  function public.tutorial_map1.first()
      if  ( cmn.IsEventDone( "clk_flashback2" ) ) then
        local offset = 0.5 * ( GetAppWidth() - 1024 );
        private.TutorialShow("tutorial_map1",{-offset});
      end
  end

  function public.tutorial_map1.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_map2.first()
      if  ( cmn.IsEventDone( "tutorial_question" ) ) then
        private.TutorialShow("tutorial_map2");
      end
  end

  function public.tutorial_map2.click()
    private.TutorialHide()
    cmn.SetEventDone( "tutorial_map1" );
    
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_hosparkles.first()
      if  ( cmn.IsEventDone( "use_lighter" ) ) then
        private.TutorialShow("tutorial_hosparkles");
      end
  end

  function public.tutorial_hosparkles.click()
    private.TutorialHide()
  end

--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
  function private.tutorial_notification_first(type)
    if  ( cmn.IsEventDone( "tutorial_question" ) ) then
      local func_end = function()
        if level.tutorial_current == type then
          ObjSet( "tmr_int_panel_notification", {playing = 0} );
          private.panel_notification_on_screen = true;
        end
      end
      if private.TutorialShow(type) then
        ld.StartTimer( "tmr_tutorial_panel_notification", 0.7 , func_end )
      end
    end
  end

  function private.tutorial_notification_click()
    private.panel_notification_on_screen = false;
    ObjSet( "tmr_int_panel_notification", {playing = 1} );
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_ach.first()
    private.tutorial_notification_first("tutorial_ach")
  end

  function public.tutorial_ach.click()
    private.tutorial_notification_click()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_puzzle.first()
    private.tutorial_notification_first("tutorial_puzzle")
  end

  function public.tutorial_puzzle.click()
    private.tutorial_notification_click()
  end
--------------------------------------------------------------------------------------------
  function public.tutorial_morph.first()
    private.tutorial_notification_first("tutorial_morph")
  end

  function public.tutorial_morph.click()
    private.tutorial_notification_click()
  end

--------------------------------------------------------------------------------------------
--                SPECIAL FEATURES
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
  function public.tutorial_newho1.first()
      if  ( cmn.IsEventDone( "opn_underfirtreeho" ) ) then
        private.TutorialShow("tutorial_newho1");
      end
  end

  function public.tutorial_newho1.click()
    private.TutorialHide()
  end
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
--  function public.tutorial_newho2_1.first()
--      if  ( cmn.IsEventDone( "opn_apartment" ) ) then
--        private.TutorialShow("tutorial_newho2_1");
--      end
--  end
--
--  function public.tutorial_newho2_1.click()
--    private.TutorialHide()
--    --ld.LockRm(1)
--    --ld.StartTimer( 0.3, function() ld.LockRm(0) level.tutorial_newho2_2.first() end )    
--  end
----------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--  function public.tutorial_newho2_2.first()
--      if  ( cmn.IsEventDone( "opn_apartment" ) ) then
--        private.TutorialShow("tutorial_newho2_2");
--      end
--  end
--
--  function public.tutorial_newho2_2.click()
--    private.TutorialHide()
--    --ld.LockRm(1)
--    --ld.StartTimer( 0.3, function() ld.LockRm(0) level.tutorial_newho2_3.first() end )        
--  end
----------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--  function public.tutorial_newho2_3.first()
--      if  ( cmn.IsEventDone( "opn_apartment" ) ) then
--        private.TutorialShow("tutorial_newho2_3");
--      end
--  end
--
--  function public.tutorial_newho2_3.click()
--    private.TutorialHide()
--  end
----------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------
--  function public.tutorial_newho3.first()
--      if  ( cmn.IsEventDone( "opn_frescho" ) ) then
--        private.TutorialShow("tutorial_newho3");
--      end
--  end
--
--  function public.tutorial_newho3.click()
--    private.TutorialHide()
--  end
--------------------------------------------------------------------------------------------


end