-- name=rm_bedroom
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_bedroom";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_bedroom()
  if not ( cmn.IsEventDone( "opn_bedroom" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_bedroom" );
      cmn.CallEventHandler( "opn_bedroom" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_bedroom = function() end;
local opn_bedroom_logic = function() end;
cmn.AddSubscriber( "opn_bedroom", opn_bedroom_logic )
cmn.AddSubscriber( "opn_bedroom", opn_bedroom, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_mouse *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_mouseanim" ] = { type = "click", use_place = "gfx_mouse_clk_mouseanim_zone", room = "rm_bedroom", zz = "zz_mouse", zz_gate = "gzz_bedroom_mouse" };

private.clk_mouseanim_logic = function()
  ObjSet( "gfx_mouse_skewers_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_mouseanim_beg = function()
  ObjDelete( "gfx_mouse_clk_mouseanim_zone" );
end;
private.clk_mouseanim_end = function()
  ObjSet( "spr_bedroom_mouse", {visible = 1} );
  ObjDelete("spr_bedroom_mouse_start")
  ObjSet( "anm_mouse_anm", {animfunc = "mouse_static", playing = 1, frame = 0 } );
  if common_impl.ZzCompleteCheck("clk_mouseanim") then ObjSet( common_impl.hint["clk_mouseanim"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_mouseanim", private.clk_mouseanim_beg, private.room_objname );
cmn.AddSubscriber( "clk_mouseanim", private.clk_mouseanim_end, private.room_objname );
cmn.AddSubscriber( "clk_mouseanim", private.clk_mouseanim_logic );
cmn.AddSubscriber( "clk_mouseanim_beg", private.clk_mouseanim_beg, private.room_objname );
cmn.AddSubscriber( "clk_mouseanim_end", private.clk_mouseanim_end, private.room_objname );
cmn.AddSubscriber( "clk_mouseanim_end", private.clk_mouseanim_logic );
--------------------------------------------------------------------------------------------
function public.clk_mouseanim()
  if not ld.CheckRequirements( {"clk_mouseanim"} ) then
    local func_end = function()
      cmn.SetEventDone( "clk_mouseanim" );
      cmn.CallEventHandler( "clk_mouseanim_end" );
      common_impl.Lock(0);
      if common_impl.ZzCompleteCheck("clk_mouseanim") then ld.CloseSubRoom() end;
      ld.AnimPlay( "anm_mouse_anm", "mouse_static", "" );
      ld.ShowBbt( "clk_mouseanim" )
    end;

    cmn.CallEventHandler( "clk_mouseanim_beg" );
    common_impl.Lock(1);

    ld.AnimPlay( "anm_mouse_anm", "mouse", function() 
      ld.AnimPlay( "anm_mouse_anm", "mouse1", func_end );
    end );
    SoundSfx( "aud_clk_mouseanim" )
  --func_end()
  end
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_glue" ] = { type = "get", get_obj = "spr_mouse_glue", room = "rm_bedroom", zz = "zz_mouse", zz_gate = "gzz_bedroom_mouse" };

private.get_glue_logic = function()
  
end;
private.get_glue_inv = function()
  interface.InventoryItemAdd("inv_glue","spr_mouse_glue");
end;
private.get_glue_beg = function()
  ObjDelete("gfx_mouse_glue")
end;
private.get_glue_end = function()
  ObjDelete("spr_bedroom_glue_sh")
  ObjDelete("spr_mouse_glue_sh")
  if common_impl.ZzCompleteCheck("get_glue") then ObjSet( common_impl.hint["get_glue"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_glue", private.get_glue_inv );
cmn.AddSubscriber( "get_glue", private.get_glue_beg, private.room_objname );
cmn.AddSubscriber( "get_glue", private.get_glue_end, private.room_objname );
cmn.AddSubscriber( "get_glue", private.get_glue_logic );
--------------------------------------------------------------------
function public.get_glue()
  cmn.SetEventDone( "get_glue" );
  cmn.CallEventHandler( "get_glue" );
  if common_impl.ZzCompleteCheck("get_glue") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_skewers" ] = { type = "use", inv_obj = "inv_skewers", use_place = "gfx_mouse_skewers_zone", room = "rm_bedroom", zz = "zz_mouse", zz_gate = "gzz_bedroom_mouse" };

private.use_skewers_logic = function()
  ObjSet( "gmg_bedroom_mousemg", { visible = 1, input = 1, active = 1 } )

end;
private.use_skewers_inv = function()
  common_impl.ProcessMultiUseAll("skewers", "skewers")
end;
private.use_skewers_beg = function()
  ObjDelete( "gfx_mouse_skewers_zone" );
end;
private.use_skewers_end = function()
  ObjSet( "spr_bedroom_p", {visible = 1} );
  ObjSet( "anm_mouse_anm_p", {animfunc = "p", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_skewers") then ObjSet( common_impl.hint["use_skewers"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_skewers", private.use_skewers_inv );
cmn.AddSubscriber( "use_skewers", private.use_skewers_beg, private.room_objname );
cmn.AddSubscriber( "use_skewers", private.use_skewers_end, private.room_objname );
cmn.AddSubscriber( "use_skewers", private.use_skewers_logic );
cmn.AddSubscriber( "use_skewers_inv", private.use_skewers_inv, private.room_objname );
cmn.AddSubscriber( "use_skewers_beg", private.use_skewers_beg, private.room_objname );
cmn.AddSubscriber( "use_skewers_end", private.use_skewers_end, private.room_objname );
cmn.AddSubscriber( "use_skewers_end", private.use_skewers_logic );
--------------------------------------------------------------------------------------------
function public.use_skewers( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_skewers" );
    cmn.CallEventHandler( "use_skewers_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_skewers") then ld.CloseSubRoom() end;
    common_impl.Gate_MDown( "gmg_bedroom_mousemg" )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_skewers_inv" );
  cmn.CallEventHandler( "use_skewers_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mouse_anm_p", "p", func_end );
  SoundSfx( "aud_use_skewers_mouse" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_nearbed *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_firurepart" ] = { type = "get", get_obj = "spr_nearbed_firurepart", room = "rm_bedroom", zz = "zz_nearbed", zz_gate = "gzz_bedroom_nearbed" };

private.get_firurepart_logic = function()
  
end;
private.get_firurepart_inv = function()
  interface.InventoryItemAdd("inv_firurepart","spr_nearbed_firurepart");
end;
private.get_firurepart_beg = function()
  ObjDelete("gfx_nearbed_firurepart")
end;
private.get_firurepart_end = function()
  ObjDelete("spr_nearbed_firurepart_sh")
  ObjDelete("spr_bedroom_f")
  if common_impl.ZzCompleteCheck("get_firurepart") then ObjSet( common_impl.hint["get_firurepart"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_firurepart", private.get_firurepart_inv );
cmn.AddSubscriber( "get_firurepart", private.get_firurepart_beg, private.room_objname );
cmn.AddSubscriber( "get_firurepart", private.get_firurepart_end, private.room_objname );
cmn.AddSubscriber( "get_firurepart", private.get_firurepart_logic );
--------------------------------------------------------------------
function public.get_firurepart()
  cmn.SetEventDone( "get_firurepart" );
  cmn.CallEventHandler( "get_firurepart" );
  if common_impl.ZzCompleteCheck("get_firurepart") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_diplom" ] = { type = "use", inv_obj = "inv_diplom", use_place = "gfx_nearbed_diplom_zone", room = "rm_bedroom", zz = "zz_nearbed", zz_gate = "gzz_bedroom_nearbed" };

private.use_diplom_logic = function()
  ObjSet( "spr_nearbed_feather", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_nearbed_goldenbuttons", { visible = 1, input = 1, active = 1 } )

end;
private.use_diplom_inv = function()
  common_impl.ProcessMultiUseAll("diplom", "diplom")
end;
private.use_diplom_beg = function()
  ObjDelete( "gfx_nearbed_diplom_zone" );
end;
private.use_diplom_end = function()
  ObjDelete("spr_bedroom_tr1")
  ObjSet( "spr_bedroom_feather", {visible = 1} );
  ObjSet( "spr_bedroom_goldenbuttons", {visible = 1} );
  ObjSet( "spr_bedroom_diplom", {visible = 1} );
  ObjSet( "anm_nearbed_anm", {animfunc = "use_diplom", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_diplom") then ObjSet( common_impl.hint["use_diplom"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_diplom", private.use_diplom_inv );
cmn.AddSubscriber( "use_diplom", private.use_diplom_beg, private.room_objname );
cmn.AddSubscriber( "use_diplom", private.use_diplom_end, private.room_objname );
cmn.AddSubscriber( "use_diplom", private.use_diplom_logic );
cmn.AddSubscriber( "use_diplom_inv", private.use_diplom_inv, private.room_objname );
cmn.AddSubscriber( "use_diplom_beg", private.use_diplom_beg, private.room_objname );
cmn.AddSubscriber( "use_diplom_end", private.use_diplom_end, private.room_objname );
cmn.AddSubscriber( "use_diplom_end", private.use_diplom_logic );
--------------------------------------------------------------------------------------------
function public.use_diplom( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_diplom" );
    cmn.CallEventHandler( "use_diplom_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_diplom") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_diplom_inv" );
  cmn.CallEventHandler( "use_diplom_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_nearbed_anm", "use_diplom", func_end );
  SoundSfx( "aud_use_diplom_nearbed" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_feather" ] = { type = "get", get_obj = "spr_nearbed_feather", room = "rm_bedroom", zz = "zz_nearbed", zz_gate = "gzz_bedroom_nearbed" };

private.get_feather_logic = function()
  
end;
private.get_feather_inv = function()
  interface.InventoryItemAdd("inv_feather","spr_nearbed_feather");
end;
private.get_feather_beg = function()
  ObjDelete("gfx_nearbed_feather")
end;
private.get_feather_end = function()
  ObjDelete("spr_nearbed_feather_sh")
  ObjDelete("spr_bedroom_feather")
  if common_impl.ZzCompleteCheck("get_feather") then ObjSet( common_impl.hint["get_feather"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_feather", private.get_feather_inv );
cmn.AddSubscriber( "get_feather", private.get_feather_beg, private.room_objname );
cmn.AddSubscriber( "get_feather", private.get_feather_end, private.room_objname );
cmn.AddSubscriber( "get_feather", private.get_feather_logic );
--------------------------------------------------------------------
function public.get_feather()
  cmn.SetEventDone( "get_feather" );
  cmn.CallEventHandler( "get_feather" );
  if common_impl.ZzCompleteCheck("get_feather") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_goldenbuttons" ] = { type = "get", get_obj = "spr_nearbed_goldenbuttons", room = "rm_bedroom", zz = "zz_nearbed", zz_gate = "gzz_bedroom_nearbed" };

private.get_goldenbuttons_logic = function()
  
end;
private.get_goldenbuttons_inv = function()
  interface.InventoryItemAdd("inv_goldenbuttons","spr_nearbed_goldenbuttons");
end;
private.get_goldenbuttons_beg = function()
  ObjDelete("gfx_nearbed_goldenbuttons")
end;
private.get_goldenbuttons_end = function()
  ObjDelete("spr_nearbed_goldenbuttons_sh")
  ObjDelete("spr_bedroom_goldenbuttons")
  if common_impl.ZzCompleteCheck("get_goldenbuttons") then ObjSet( common_impl.hint["get_goldenbuttons"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_goldenbuttons", private.get_goldenbuttons_inv );
cmn.AddSubscriber( "get_goldenbuttons", private.get_goldenbuttons_beg, private.room_objname );
cmn.AddSubscriber( "get_goldenbuttons", private.get_goldenbuttons_end, private.room_objname );
cmn.AddSubscriber( "get_goldenbuttons", private.get_goldenbuttons_logic );
--------------------------------------------------------------------
function public.get_goldenbuttons()
  cmn.SetEventDone( "get_goldenbuttons" );
  cmn.CallEventHandler( "get_goldenbuttons" );
  if common_impl.ZzCompleteCheck("get_goldenbuttons") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_lionpen" ] = { type = "use", inv_obj = "inv_lionpen", use_place = "gfx_nearbed_lionpen_zone", room = "rm_bedroom", zz = "zz_nearbed", zz_gate = "gzz_bedroom_nearbed" };

private.use_lionpen_logic = function()
  ObjSet( "spr_nearbed_oldbook", {  input = 1, active = 1 } )
end;
private.use_lionpen_inv = function()
  common_impl.ProcessMultiUseAll("lionpen", "lionpen")
end;
private.use_lionpen_beg = function()
  ObjDelete( "gfx_nearbed_lionpen_zone" );
end;
private.use_lionpen_end = function()
  ObjSet( "spr_bedroom_tr2", {visible = 1} );
  ObjSet( "gfx_nearbed_oldbook", { visible = 1 } )
  ObjSet( "anm_nearbed_anm_down", {animfunc = "use_lionpen", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_lionpen") then ObjSet( common_impl.hint["use_lionpen"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lionpen", private.use_lionpen_inv );
cmn.AddSubscriber( "use_lionpen", private.use_lionpen_beg, private.room_objname );
cmn.AddSubscriber( "use_lionpen", private.use_lionpen_end, private.room_objname );
cmn.AddSubscriber( "use_lionpen", private.use_lionpen_logic );
cmn.AddSubscriber( "use_lionpen_inv", private.use_lionpen_inv, private.room_objname );
cmn.AddSubscriber( "use_lionpen_beg", private.use_lionpen_beg, private.room_objname );
cmn.AddSubscriber( "use_lionpen_end", private.use_lionpen_end, private.room_objname );
cmn.AddSubscriber( "use_lionpen_end", private.use_lionpen_logic );
--------------------------------------------------------------------------------------------
function public.use_lionpen( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lionpen" );
    cmn.CallEventHandler( "use_lionpen_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_lionpen") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lionpen_inv" );
  cmn.CallEventHandler( "use_lionpen_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_nearbed_anm_down", "use_lionpen", func_end );
  SoundSfx( "aud_use_lionpen_nearbed" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_oldbook" ] = { type = "get", get_obj = "spr_nearbed_oldbook", room = "rm_bedroom", zz = "zz_nearbed", zz_gate = "gzz_bedroom_nearbed" };

private.get_oldbook_logic = function()
  ObjSet( "spr_nearbed_camisole3", {  input = 1, active = 1 } )
end;
private.get_oldbook_inv = function()
  interface.InventoryItemAdd("inv_oldbook","spr_nearbed_oldbook");
end;
private.get_oldbook_beg = function()
  ObjDelete("gfx_nearbed_oldbook")
  ObjSet( "spr_nearbed_oldbook", {visible = 1} );
  ObjSet( "gfx_nearbed_camisole3", { visible = 1 } )
end;
private.get_oldbook_end = function()
  if ld.CheckRequirements( {"get_oldbook","get_camisole3"} ) then
    ObjSet( "anm_nearbed_anm_down", {animfunc = "end_lionpen", frame = 0 } );
  else
    ObjSet( "anm_nearbed_anm_down", {animfunc = "end_lionpen2", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("get_oldbook") then ObjSet( common_impl.hint["get_oldbook"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_oldbook", private.get_oldbook_inv );
cmn.AddSubscriber( "get_oldbook", private.get_oldbook_beg, private.room_objname );
cmn.AddSubscriber( "get_oldbook", private.get_oldbook_end, private.room_objname );
cmn.AddSubscriber( "get_oldbook", private.get_oldbook_logic );
--------------------------------------------------------------------
function public.get_oldbook()
  cmn.SetEventDone( "get_oldbook" );
  cmn.CallEventHandler( "get_oldbook" );
  if common_impl.ZzCompleteCheck("get_oldbook") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_camisole3" ] = { type = "get", get_obj = "spr_nearbed_camisole3", room = "rm_bedroom", zz = "zz_nearbed", zz_gate = "gzz_bedroom_nearbed" };

private.get_camisole3_logic = function()
  
end;
private.get_camisole3_inv = function()
  interface.InventoryItemAdd("inv_camisole","spr_nearbed_camisole3",function() level_inv.ProcessGetCamisoleAll( "get_camisole3" ) end);
end;
private.get_camisole3_beg = function()
  ObjDelete("gfx_nearbed_camisole3")
  ObjSet( "spr_nearbed_camisole3", {visible = 1} );
end;
private.get_camisole3_end = function()
  if ld.CheckRequirements( {"get_oldbook","get_camisole3"} ) then
    ObjSet( "anm_nearbed_anm_down", {animfunc = "end_lionpen", frame = 0 } );
  else
    ObjSet( "anm_nearbed_anm_down", {animfunc = "end_lionpen1", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("get_camisole3") then ObjSet( common_impl.hint["get_camisole3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_camisole3", private.get_camisole3_inv );
cmn.AddSubscriber( "get_camisole3", private.get_camisole3_beg, private.room_objname );
cmn.AddSubscriber( "get_camisole3", private.get_camisole3_end, private.room_objname );
cmn.AddSubscriber( "get_camisole3", private.get_camisole3_logic );
--------------------------------------------------------------------
function public.get_camisole3()
  cmn.SetEventDone( "get_camisole3" );
  cmn.CallEventHandler( "get_camisole3" );
  if common_impl.ZzCompleteCheck("get_camisole3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_drawings *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_panicleofeathers" ] = { type = "get", get_obj = "spr_drawings_panicleofeathers", room = "rm_bedroom", zz = "zz_drawings", zz_gate = "gzz_bedroom_drawings" };

private.get_panicleofeathers_logic = function()
  ObjSet( "gfx_drawings_camisole_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_panicleofeathers_inv = function()
  interface.InventoryItemAdd("inv_panicleofeathers","spr_drawings_panicleofeathers");
  ObjSet( "inv_panicleofeathers", { drag = 0 } );
end;
private.get_panicleofeathers_beg = function()
  ObjDelete("gfx_drawings_panicleofeathers")
end;
private.get_panicleofeathers_end = function()
  ObjDelete("spr_drawings_panicleofeathers_shadow")
  ObjDelete("spr_bedroom_panicleofeathers")
  if common_impl.ZzCompleteCheck("get_panicleofeathers") then ObjSet( common_impl.hint["get_panicleofeathers"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_panicleofeathers", private.get_panicleofeathers_inv );
cmn.AddSubscriber( "get_panicleofeathers", private.get_panicleofeathers_beg, private.room_objname );
cmn.AddSubscriber( "get_panicleofeathers", private.get_panicleofeathers_end, private.room_objname );
cmn.AddSubscriber( "get_panicleofeathers", private.get_panicleofeathers_logic );
--------------------------------------------------------------------
function public.get_panicleofeathers()
  cmn.SetEventDone( "get_panicleofeathers" );
  cmn.CallEventHandler( "get_panicleofeathers" );
  if common_impl.ZzCompleteCheck("get_panicleofeathers") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mitten" ] = { type = "use", inv_obj = "inv_mitten", use_place = "gfx_drawings_mitten_zone", room = "rm_bedroom", zz = "zz_drawings", zz_gate = "gzz_bedroom_drawings" };

private.use_mitten_logic = function()
  ObjSet( "spr_drawings_lily2", {  input = 1, active = 1 } )

end;
private.use_mitten_inv = function()
  common_impl.ProcessMultiUseAll("mitten", "mitten")
end;
private.use_mitten_beg = function()
  ObjDelete( "gfx_drawings_mitten_zone" );
end;
private.use_mitten_end = function()
  ObjSet( "gfx_drawings_lily2", { visible = 1 } )
  ObjSet( "anm_drawings_anm_rose", {animfunc = "rose", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_mitten") then ObjSet( common_impl.hint["use_mitten"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mitten", private.use_mitten_inv );
cmn.AddSubscriber( "use_mitten", private.use_mitten_beg, private.room_objname );
cmn.AddSubscriber( "use_mitten", private.use_mitten_end, private.room_objname );
cmn.AddSubscriber( "use_mitten", private.use_mitten_logic );
cmn.AddSubscriber( "use_mitten_inv", private.use_mitten_inv, private.room_objname );
cmn.AddSubscriber( "use_mitten_beg", private.use_mitten_beg, private.room_objname );
cmn.AddSubscriber( "use_mitten_end", private.use_mitten_end, private.room_objname );
cmn.AddSubscriber( "use_mitten_end", private.use_mitten_logic );
--------------------------------------------------------------------------------------------
function public.use_mitten( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mitten" );
    cmn.CallEventHandler( "use_mitten_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mitten") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mitten_inv" );
  cmn.CallEventHandler( "use_mitten_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_drawings_anm_rose", "rose", func_end );
  SoundSfx( "aud_use_mitten_drawings" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lily2" ] = { type = "get", get_obj = "spr_drawings_lily2", room = "rm_bedroom", zz = "zz_drawings", zz_gate = "gzz_bedroom_drawings" };

private.get_lily2_logic = function()
  
end;
private.get_lily2_inv = function()
  interface.InventoryItemAdd("inv_lily2","spr_drawings_lily2");
end;
private.get_lily2_beg = function()
  ObjDelete("gfx_drawings_lily2")
  ObjSet( "spr_drawings_lily2", {visible = 1} );
  ObjSet( "anm_drawings_anm_rose", {animfunc = "rose_end", frame = 0 } );
end;
private.get_lily2_end = function()
  if common_impl.ZzCompleteCheck("get_lily2") then ObjSet( common_impl.hint["get_lily2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lily2", private.get_lily2_inv );
cmn.AddSubscriber( "get_lily2", private.get_lily2_beg, private.room_objname );
cmn.AddSubscriber( "get_lily2", private.get_lily2_end, private.room_objname );
cmn.AddSubscriber( "get_lily2", private.get_lily2_logic );
--------------------------------------------------------------------
function public.get_lily2()
  cmn.SetEventDone( "get_lily2" );
  cmn.CallEventHandler( "get_lily2" );
  if common_impl.ZzCompleteCheck("get_lily2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_camisole" ] = { type = "use", inv_obj = "inv_camisole", use_place = "gfx_drawings_camisole_zone", room = "rm_bedroom", zz = "zz_drawings", zz_gate = "gzz_bedroom_drawings" };

private.use_camisole_logic = function()
  ObjSet( "gfx_drawings_clk_camisole_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_camisole_inv = function()
  common_impl.ProcessMultiUseAll("camisole", "camisole")
end;
private.use_camisole_beg = function()
  ObjDelete( "gfx_drawings_camisole_zone" );
end;
private.use_camisole_end = function()
  ObjSet( "anm_drawings_anm_draw", {animfunc = "sketch1", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_camisole") then ObjSet( common_impl.hint["use_camisole"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_camisole", private.use_camisole_inv );
cmn.AddSubscriber( "use_camisole", private.use_camisole_beg, private.room_objname );
cmn.AddSubscriber( "use_camisole", private.use_camisole_end, private.room_objname );
cmn.AddSubscriber( "use_camisole", private.use_camisole_logic );
cmn.AddSubscriber( "use_camisole_inv", private.use_camisole_inv, private.room_objname );
cmn.AddSubscriber( "use_camisole_beg", private.use_camisole_beg, private.room_objname );
cmn.AddSubscriber( "use_camisole_end", private.use_camisole_end, private.room_objname );
cmn.AddSubscriber( "use_camisole_end", private.use_camisole_logic );
--------------------------------------------------------------------------------------------
function public.use_camisole( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_camisole" );
    cmn.CallEventHandler( "use_camisole_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_camisole") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_camisole_inv" );
  cmn.CallEventHandler( "use_camisole_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_drawings_anm_draw", "sketch_table", func_end );
  SoundSfx( "aud_use_camisole_drawings" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_camisole" ] = { type = "click", use_place = "gfx_drawings_clk_camisole_zone", room = "rm_bedroom", zz = "zz_drawings", zz_gate = "gzz_bedroom_drawings" };

private.clk_camisole_logic = function()
  ObjSet( "gfx_drawings_clk_camisole2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_camisole_beg = function()
  ObjDelete( "gfx_drawings_clk_camisole_zone" );
end;
private.clk_camisole_end = function()
  ObjSet( "spr_bedroom_paper3", {visible = 1} );
  ObjSet( "anm_drawings_anm_draw", {animfunc = "sketch2", frame = 0 } );
  if common_impl.ZzCompleteCheck("clk_camisole") then ObjSet( common_impl.hint["clk_camisole"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_camisole", private.clk_camisole_beg, private.room_objname );
cmn.AddSubscriber( "clk_camisole", private.clk_camisole_end, private.room_objname );
cmn.AddSubscriber( "clk_camisole", private.clk_camisole_logic );
cmn.AddSubscriber( "clk_camisole_beg", private.clk_camisole_beg, private.room_objname );
cmn.AddSubscriber( "clk_camisole_end", private.clk_camisole_end, private.room_objname );
cmn.AddSubscriber( "clk_camisole_end", private.clk_camisole_logic );
--------------------------------------------------------------------------------------------
function public.clk_camisole()

  local func_end = function()
    cmn.SetEventDone( "clk_camisole" );
    cmn.CallEventHandler( "clk_camisole_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_camisole") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_camisole_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_drawings_anm_draw", "sketch1", func_end );
  SoundSfx( "aud_clk_camisole" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_camisole2" ] = { type = "click", use_place = "gfx_drawings_clk_camisole2_zone", room = "rm_bedroom", zz = "zz_drawings", zz_gate = "gzz_bedroom_drawings" };

private.clk_camisole2_logic = function()
  ObjSet( "gfx_drawings_clk_camisole3_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_camisole2_beg = function()
  ObjDelete( "gfx_drawings_clk_camisole2_zone" );
end;
private.clk_camisole2_end = function()
  ObjSet( "spr_bedroom_paper1", {visible = 1} );
  ObjSet( "anm_drawings_anm_draw", {animfunc = "sketch3", frame = 0 } );
  if common_impl.ZzCompleteCheck("clk_camisole2") then ObjSet( common_impl.hint["clk_camisole2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_camisole2", private.clk_camisole2_beg, private.room_objname );
cmn.AddSubscriber( "clk_camisole2", private.clk_camisole2_end, private.room_objname );
cmn.AddSubscriber( "clk_camisole2", private.clk_camisole2_logic );
cmn.AddSubscriber( "clk_camisole2_beg", private.clk_camisole2_beg, private.room_objname );
cmn.AddSubscriber( "clk_camisole2_end", private.clk_camisole2_end, private.room_objname );
cmn.AddSubscriber( "clk_camisole2_end", private.clk_camisole2_logic );
--------------------------------------------------------------------------------------------
function public.clk_camisole2()

  local func_end = function()
    cmn.SetEventDone( "clk_camisole2" );
    cmn.CallEventHandler( "clk_camisole2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_camisole2") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_camisole2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_drawings_anm_draw", "sketch2", func_end );
  SoundSfx( "aud_clk_camisole" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_camisole3" ] = { type = "click", use_place = "gfx_drawings_clk_camisole3_zone", room = "rm_bedroom", zz = "zz_drawings", zz_gate = "gzz_bedroom_drawings" };

private.clk_camisole3_logic = function()
  ObjSet( "spr_drawings_sketch", {  input = 1, active = 1 } )

end;
private.clk_camisole3_beg = function()
  ObjDelete( "gfx_drawings_clk_camisole3_zone" );
end;
private.clk_camisole3_end = function()
  ObjDelete("spr_bedroom_paper1")
  ObjDelete("spr_bedroom_paper2")
  ObjDelete("spr_bedroom_paper3")
  ObjDelete("spr_bedroom_paper4")
  ObjSet( "spr_bedroom_paper", {visible = 1} );
  ObjSet( "gfx_drawings_sketch", { visible = 1 } )
  ObjSet( "anm_drawings_anm_draw", {animfunc = "sketch3", frame = 999 } );
  if common_impl.ZzCompleteCheck("clk_camisole3") then ObjSet( common_impl.hint["clk_camisole3"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_camisole3", private.clk_camisole3_beg, private.room_objname );
cmn.AddSubscriber( "clk_camisole3", private.clk_camisole3_end, private.room_objname );
cmn.AddSubscriber( "clk_camisole3", private.clk_camisole3_logic );
cmn.AddSubscriber( "clk_camisole3_beg", private.clk_camisole3_beg, private.room_objname );
cmn.AddSubscriber( "clk_camisole3_end", private.clk_camisole3_end, private.room_objname );
cmn.AddSubscriber( "clk_camisole3_end", private.clk_camisole3_logic );
--------------------------------------------------------------------------------------------
function public.clk_camisole3()

  local func_end = function()
    cmn.SetEventDone( "clk_camisole3" );
    cmn.CallEventHandler( "clk_camisole3_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_camisole3") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_camisole3_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_drawings_anm_draw", "sketch3", func_end );
  SoundSfx( "aud_clk_camisole" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sketch" ] = { type = "get", get_obj = "spr_drawings_sketch", room = "rm_bedroom", zz = "zz_drawings", zz_gate = "gzz_bedroom_drawings" };

private.get_sketch_logic = function()
  
end;
private.get_sketch_inv = function()
  interface.InventoryItemAdd("inv_sketch","spr_drawings_sketch");
end;
private.get_sketch_beg = function()
  ObjDelete("gfx_drawings_sketch")
  ObjSet( "spr_drawings_sketch", {visible = 1} );
  ObjDelete("anm_drawings_anm_draw")
end;
private.get_sketch_end = function()
  ObjDelete("spr_bedroom_paper")
  if common_impl.ZzCompleteCheck("get_sketch") then ObjSet( common_impl.hint["get_sketch"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_sketch", private.get_sketch_inv );
cmn.AddSubscriber( "get_sketch", private.get_sketch_beg, private.room_objname );
cmn.AddSubscriber( "get_sketch", private.get_sketch_end, private.room_objname );
cmn.AddSubscriber( "get_sketch", private.get_sketch_logic );
--------------------------------------------------------------------
function public.get_sketch()
  cmn.SetEventDone( "get_sketch" );
  cmn.CallEventHandler( "get_sketch" );
  if common_impl.ZzCompleteCheck("get_sketch") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

  local get_mousemessage_for_bedroom = function()
    if ld.CheckRequirements( {"get_mousemessage"} ) then
      ObjSet( "gmg_bedroom_mousemg", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("get_mousemessage", get_mousemessage_for_bedroom, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_bedroom();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_bedroom_env" )
  private.anim_static() 
end;
function private.anim_static()  
  ld.StartTimer( "tmr_bedroom_mouse_wait_1", math.random(5,10), function()  
    SoundSfx( "aud_runing_mouse1" )
    ld.AnimPlay( "anm_bedroom_anm_mouse", "mouse1", function() 
      ld.StartTimer( "tmr_bedroom_mouse_wait_2", math.random(5,10), function() 
        SoundSfx( "aud_runing_mouse2" ) 
        ld.AnimPlay( "anm_bedroom_anm_mouse", "mouse2", function() 
          ObjSet( "anm_bedroom_anm_mouse", {animfunc = "mouse1", frame = 0 } );
          ld.StartTimer( "tmr_bedroom_mouse_wait_3", math.random(5,10), function()private.anim_static() end)
        end )
      end )
    end )
  end )
end
--*********************************************************************************************************************
function public.Close()
  ObjSet( "anm_bedroom_anm_mouse", {animfunc = "mouse1", frame = 0, playing = 0 } );
  ObjDelete("tmr_bedroom_mouse_wait_1")
  ObjDelete("tmr_bedroom_mouse_wait_2")
  ObjDelete("tmr_bedroom_mouse_wait_3")
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_drawings" );
  function zz_drawings.Open()
  end;
  function zz_drawings.PreOpen()
  end;
  function zz_drawings.PreClose()
  end;
  function zz_drawings.Close()
  end;

  subroom.Define( "zz_nearbed" );
  function zz_nearbed.Open()
  end;
  function zz_nearbed.PreOpen()
  end;
  function zz_nearbed.PreClose()
  end;
  function zz_nearbed.Close()
  end;

  subroom.Define( "zz_mouse" );
  function zz_mouse.Open()
    public.clk_mouseanim()
  end;
  function zz_mouse.PreOpen()
  end;
  function zz_mouse.PreClose()
  end;
  function zz_mouse.Close()
  end;
  
end;
--*********************************************************************************************************************