-- name=rm_entrypoint
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_entrypoint";
  --------------------------------------------------------------------------------------------
  private.InitZz()
  ld.NoteInit( "spr_entrypoint_gift", "spr_entrypoint_gift_big", function() 
    if ld.CheckRequirements( {"clk_flashback1"} ) then
      ld.ShowBbt("txt_entrypoint_gift2"); 
    else
      ld.ShowBbt("txt_entrypoint_gift"); 
    end
  end ,false, false )
  ld.NoteInit("spr_mailbox_note_small", "spr_mailbox_note_big", "txt_mailbox_note")
  ld.NoteInit("spr_case_note_small", "spr_case_note_big", "txt_case_note" )
  private.vid_jack_static_list = {
    "vid_entrypoint_jack_vid_root_frost_prime_static";
    "vid_entrypoint_jack_vid_root_frost_prime_static";
    "vid_entrypoint_jack_vid_root_frost_prime_static";
    "vid_entrypoint_jack_vid_root_frost_prime_static";
    "vid_entrypoint_jack_vid_root_frost_prime_static";
    "vid_entrypoint_jack_vid_root_frost_prime_static";
    "vid_entrypoint_jack_vid_root_frost_prime_static";
    "vid_entrypoint_jack_vid_root_frost_prime_static";
    "vid_entrypoint_jack_vid_root_frost_prime_static";
    "vid_entrypoint_jack_vid_root_frost_prime_static";
    "vid_entrypoint_jack_vid_root_frost_static1";
    "vid_entrypoint_jack_vid_root_frost_static1"
  }
  ld.VidStaticInit( 
    private.vid_jack_static_list, 
    "rm_entrypoint",
    { _, _, _, _, _, _, _, _, _, _, "aud_frost_static1", "aud_frost_static1"},
    false, 
    {"opn_entrypoint"}, 
    {"dlg_entrypoint_jack1"}, 
    sfx_rnd, 
    "obj_entrypoint_jack_vid_root"
  )
--------------------------------------------------------------------------------------------
function private.opn_entrypoint()

end;


local opn_entrypoint = function()

end;
local opn_entrypoint_logic = function() 
  --interface.SetTask("leveltask_1")
end;
cmn.AddSubscriber( "opn_entrypoint", opn_entrypoint_logic )
cmn.AddSubscriber( "opn_entrypoint", opn_entrypoint, private.room_objname )

--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "jack" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    elseif count_txt == 2 then 
      ld.AnimPlay( "anm_entrypoint_ball", "anim1", "" )
    elseif count_txt == 3 then 
      SoundSfx( "aud_ball_anim" )
      ld.AnimPlay( "anm_entrypoint_ball", "anim2", function() 
      end )
    elseif count_txt == 4 then 
      ObjAnimate( "anm_entrypoint_ball", 8, 0, 0, function() ld.AnimPlay( "anm_entrypoint_jack","give_ball", ""); end, {0,0,1, 0.5,0,0} );
      --ld.AnimPlay( "anm_entrypoint_ball", "anim3", function() 
      --  ld.AnimPlay( "anm_entrypoint_jack","give_ball", "");
      --end )
    elseif count_txt == 5 then 
      cmn.CallEventHandler( "get_goodball" );
      ld.AnimPlay( "anm_entrypoint_jack","give_ball1", function() ld.AnimPlay( "anm_entrypoint_jack","static", ""); end);
    end
  elseif dlg_name == "jack1" then
    if count_txt == 1 then
      common_impl.continue_visible = true
      --ld.AnimPlay( "anm_entrypoint_ball1", "anim1", "" );
      ld.AnimPlay( "anm_entrypoint_ball1", "house", "" );
    elseif count_txt == 2 then
      
    elseif count_txt == 3 then
      
      --ObjAnimate( "anm_workshop_ball", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
    end
  elseif dlg_name == "goody" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    elseif count_txt == 2 then 
    elseif count_txt == 3 then 
    end
  end
end

function private.SeeIntro()

  --local voices = function( run ) 
  --  local voc = {
  --    { "aud_rupert_greeting_voc" , 15, 30 };
  --    --{ "aud_player_2_voc" , 12, 18.5 };
  --    --{ "aud_player_3_voc" , 21, 28 };
  --    --{ "aud_player_4_voc" , 30, 40 };
  --  }
  --  if run then
  --    for i = 1, #voc do
  --      ld.StartTimer( "tmr_entrypoint_intro_show_"..i, voc[i][2] or 0, function() SoundVoice( voc[i][1] ) interface.DialogVideoSubtitleShow( "srt_vid_intro_"..i ) end )
  --      if voc[i][3] then
  --        ld.StartTimer( "tmr_entrypoint_intro_hide_"..i, voc[i][3], function() SoundVoice( 0 ) interface.DialogVideoSubtitleHide() end )
  --      end
  --    end;
  --  else
  --    for i = 1, #voc do
  --      ObjDelete( "tmr_entrypoint_intro_show_"..i )
  --      ObjDelete( "tmr_entrypoint_intro_hide_"..i )
  --    end;
  --    SoundVoice( 0 )
  --    interface.DialogVideoSubtitleHide()
  --  end;
  --end


  local func_end = function()
    SoundTheme( 0 )
    ld.Lock( 1 )
    VidPause( "vid_entrypoint_vid_intro", 1 )
    ObjAnimate( "vid_entrypoint_vid_intro", 8,0,0, function() 
      ObjDelete( "vid_entrypoint_vid_intro" )
      ld.Lock(0)
      cmn.SetEventDone( "opn_entrypoint" )
      cmn.CallEventHandler( "opn_entrypoint" )
      SoundEnv( "aud_entrypoint_env" )
    end, { 0,0,1, 0.4,0,0 } )
    ld.VidStaticPlay(private.vid_jack_static_list);
  end

  local widget_settings = 
  {
    InterfaceWidget_Inventory,
    InterfaceWidget_BtnHint,
    InterfaceWidget_BtnGuide,
    InterfaceWidget_BtnMenu,
    InterfaceWidget_BtnMap,
  }
  
  local func_step = function ()
  
    interface.DialogVideoSubtitleHide()
    --voices( false )
    SoundVid( 0 )
    ld.Lock(1)
    int.DialogVideoHide();
    
    for i = 1, #widget_settings do
      interface.WidgetSetVisible( widget_settings[i], 1, true );
    end;
  
    func_end()
  
  end
  
  for i = 1, #widget_settings do
    interface.WidgetSetVisible( widget_settings[i], 0, false );
  end;
  
  --SoundTheme( "aud_swan_lake_mus", 1 )
  ObjSet( "vid_entrypoint_vid_intro", {alp=1} );
  ObjAttach("vid_entrypoint_vid_intro","rm_entrypoint")
  
  ObjAnimate( "vid_entrypoint_vid_intro", 7,0,0, function()
    --[[
    common_impl.VideoSubtitleVocStart( {
      { "srt_intro_1" , aud_voc_false, 12,19 },
      { "srt_intro_2" , aud_voc_false, 20,22 },
      { "srt_intro_3" , aud_voc_false, 25,30 },
      { "srt_intro_4" , aud_voc_false, 30,36 }
    } )
    ]]
    SoundVoice( "aud_intro_voc" );
    SoundVid( "aud_intro" );
    VidPlay( "vid_entrypoint_vid_intro", func_step )


    --SoundVid( "aud_intro_1_lvl" ) 
    --voices( true ) 
    end, { 0,0,0, 0.1,0,0 } )
  int.DialogVideoShow( "vid_entrypoint_vid_intro", 1, func_step, 1 );
  
  --func_end();

end

--------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_entrypoint_jack1" ] = { type = "click", use_place = "gfx_entrypoint_dlg_entrypoint_jack1_zone", room = "rm_entrypoint" };

private.dlg_entrypoint_jack1_logic = function()
  ObjSet( "spr_entrypoint_goodball", { visible = 1, input = 1, active = 1 } )

  ObjSet( "gfx_entrypoint_snowshoes_zone", {active = 1, input = 1, visible = 1} );
  ObjSet( "gfx_entrypoint_smallaxe_zone", {active = 1, input = 1, visible = 1} );
  ObjSet( "gzz_entrypoint_snowman", {active = 1, input = 1, visible = 1} );
  ObjSet( "gzz_entrypoint_mailbox", {active = 1, input = 1, visible = 1} );
  ObjSet( "gzz_entrypoint_housedoor", {active = 1, input = 1, visible = 1} );
  ObjSet( "gzz_entrypoint_window", {active = 1, input = 1, visible = 1} );
  ObjSet( "gzz_entrypoint_case", {active = 1, input = 1, visible = 1} );

end;
private.dlg_entrypoint_jack1_beg = function()
  ObjDelete( "gfx_entrypoint_dlg_entrypoint_jack1_zone" );
end;
private.dlg_entrypoint_jack1_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_entrypoint_jack1", private.dlg_entrypoint_jack1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_entrypoint_jack1", private.dlg_entrypoint_jack1_end, private.room_objname );
cmn.AddSubscriber( "dlg_entrypoint_jack1", private.dlg_entrypoint_jack1_logic );
cmn.AddSubscriber( "dlg_entrypoint_jack1_beg", private.dlg_entrypoint_jack1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_entrypoint_jack1_end", private.dlg_entrypoint_jack1_end, private.room_objname );
cmn.AddSubscriber( "dlg_entrypoint_jack1_end", private.dlg_entrypoint_jack1_logic );
--------------------------------------------------------------------------------------------
function public.dlg_entrypoint_jack1( obj )

  local func_end = function()
    cmn.SetEventDone( "dlg_entrypoint_jack1" );
    cmn.SetEventDone( "get_goodball" );
    cmn.CallEventHandler( "dlg_entrypoint_jack1_end" );
    ld.ShowBbt( "after_dlg_entrypoint_jack1" )
    common_impl.Lock(0);
    level.tutorial_question.first()
    ObjDelete("vid_entrypoint_jack_vid_root_frost_esc")
  end;
  function public.dlg_entrypoint_jack1_func_end()
    common_impl.Lock(1);
    if ObjGetRelations( "inv_goodball" ).parent == "level_inv_hub" then
      cmn.CallEventHandler( "get_goodball" );
    end
    ld.VidStaticDetach(private.vid_jack_static_list)
    ObjAttach("vid_entrypoint_jack_vid_root_frost_esc","obj_entrypoint_jack_vid_root")
    SoundVid( "aud_frost_esc" )
    VidPlay("vid_entrypoint_jack_vid_root_frost_esc",func_end)
  end
  ld.VidStaticHide(private.vid_jack_static_list)
  cmn.CallEventHandler( "dlg_entrypoint_jack1_beg" );
  common_impl.dialog_character_loc = "obj_entrypoint_jack_vid_root";
  common_impl.Start( "jack", 5, nil, nil, true, "dlg_entrypoint_jack1_func_end", { "aud_jack_frost_1_voc", "aud_jack_frost_2_voc", "aud_jack_frost_3_voc", "aud_jack_frost_4_voc" } );

end;


--------------------------------------------------------------------------------------------


--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_goodball" ] = { type = "get", get_obj = "spr_entrypoint_goodball", room = "rm_entrypoint" };

private.get_goodball_logic = function()
  
end;
private.get_goodball_inv = function()
  interface.InventoryItemAdd("inv_goodball","spr_entrypoint_goodball");
end;
private.get_goodball_beg = function()
  ObjDelete("gfx_entrypoint_goodball")
  ObjSet( "spr_entrypoint_goodball", {visible = 1} );
end;
private.get_goodball_end = function()
  
end;

cmn.AddSubscriber( "get_goodball", private.get_goodball_inv );
cmn.AddSubscriber( "get_goodball", private.get_goodball_beg, private.room_objname );
cmn.AddSubscriber( "get_goodball", private.get_goodball_end, private.room_objname );
cmn.AddSubscriber( "get_goodball", private.get_goodball_logic );
--------------------------------------------------------------------
function public.get_goodball()
  cmn.SetEventDone( "get_goodball" );
  cmn.CallEventHandler( "get_goodball" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_smallaxe" ] = { type = "use", inv_obj = "inv_smallaxe", use_place = "gfx_entrypoint_smallaxe_zone", room = "rm_entrypoint" };

private.use_smallaxe_logic = function()
  ObjSet( "spr_entrypoint_branch", { visible = 1, input = 1, active = 1 } )

end;
private.use_smallaxe_inv = function()
  common_impl.ProcessMultiUseAll("smallaxe", "smallaxe")
end;
private.use_smallaxe_beg = function()
  ObjDelete( "gfx_entrypoint_smallaxe_zone" );
end;
private.use_smallaxe_end = function()
  ObjSet( "anm_entrypoint_anim_hol_brench", {animfunc = "anim_hol_brench_end", frame = 0 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_smallaxe", private.use_smallaxe_inv );
cmn.AddSubscriber( "use_smallaxe", private.use_smallaxe_beg, private.room_objname );
cmn.AddSubscriber( "use_smallaxe", private.use_smallaxe_end, private.room_objname );
cmn.AddSubscriber( "use_smallaxe", private.use_smallaxe_logic );
cmn.AddSubscriber( "use_smallaxe_inv", private.use_smallaxe_inv, private.room_objname );
cmn.AddSubscriber( "use_smallaxe_beg", private.use_smallaxe_beg, private.room_objname );
cmn.AddSubscriber( "use_smallaxe_end", private.use_smallaxe_end, private.room_objname );
cmn.AddSubscriber( "use_smallaxe_end", private.use_smallaxe_logic );
--------------------------------------------------------------------------------------------
function public.use_smallaxe( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_smallaxe" );
    cmn.CallEventHandler( "use_smallaxe_end" );
    common_impl.Lock(0);
    public.get_branch()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_smallaxe_inv" );
  cmn.CallEventHandler( "use_smallaxe_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_entrypoint_anim_hol_brench", "anim_hol_brench1", func_end );
  SoundSfx( "aud_small_axe" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_branch" ] = { type = "get", get_obj = "spr_entrypoint_branch", room = "rm_entrypoint" };

private.get_branch_logic = function()
  
end;
private.get_branch_inv = function()
  interface.InventoryItemAdd("inv_branch","spr_entrypoint_branch");
end;
private.get_branch_beg = function()
  ObjDelete("gfx_entrypoint_branch")
end;
private.get_branch_end = function()
  
end;

cmn.AddSubscriber( "get_branch", private.get_branch_inv );
cmn.AddSubscriber( "get_branch", private.get_branch_beg, private.room_objname );
cmn.AddSubscriber( "get_branch", private.get_branch_end, private.room_objname );
cmn.AddSubscriber( "get_branch", private.get_branch_logic );
--------------------------------------------------------------------
function public.get_branch()
  cmn.SetEventDone( "get_branch" );
  cmn.CallEventHandler( "get_branch" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_snowshoes" ] = { type = "use", inv_obj = "inv_snowshoes", use_place = "gfx_entrypoint_snowshoes_zone", room = "rm_entrypoint" };

private.use_snowshoes_logic = function()
  if ld.CheckRequirements( {"use_snowshoes","use_photoadress"} ) then
    ObjSet( "grm_entrypoint_street", { visible = 1, input = 1, active = 1 } )
  end;
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_entrypoint_street_focus");
    end;
  ObjSet( "gfx_entrypoint_photoadress_zone", {active = 1, input = 1, visible = 1} );
end;
private.use_snowshoes_inv = function()
  common_impl.ProcessMultiUseAll("snowshoes", "snowshoes")
end;
private.use_snowshoes_beg = function()
  ObjDelete( "gfx_entrypoint_snowshoes_zone" );
end;
private.use_snowshoes_end = function()
  ObjSet( "anm_entrypoint_anim_use_snegostup", {animfunc = "anim_use_snegostup", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_snowshoes", private.use_snowshoes_inv );
cmn.AddSubscriber( "use_snowshoes", private.use_snowshoes_beg, private.room_objname );
cmn.AddSubscriber( "use_snowshoes", private.use_snowshoes_end, private.room_objname );
cmn.AddSubscriber( "use_snowshoes", private.use_snowshoes_logic );
cmn.AddSubscriber( "use_snowshoes_inv", private.use_snowshoes_inv, private.room_objname );
cmn.AddSubscriber( "use_snowshoes_beg", private.use_snowshoes_beg, private.room_objname );
cmn.AddSubscriber( "use_snowshoes_end", private.use_snowshoes_end, private.room_objname );
cmn.AddSubscriber( "use_snowshoes_end", private.use_snowshoes_logic );
--------------------------------------------------------------------------------------------
function public.use_snowshoes( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_snowshoes" );
    cmn.CallEventHandler( "use_snowshoes_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_snowshoes_inv" );
  cmn.CallEventHandler( "use_snowshoes_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_entrypoint_anim_use_snegostup", "anim_use_snegostup", func_end );
  SoundSfx( "aud_snowshoes" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_photoadress" ] = { type = "use", inv_obj = "inv_photoadress", use_place = "gfx_entrypoint_photoadress_zone", room = "rm_entrypoint" };

private.use_photoadress_logic = function()
  if ld.CheckRequirements( {"use_snowshoes","use_photoadress"} ) then
    ObjSet( "grm_entrypoint_street", { visible = 1, input = 1, active = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_entrypoint_street_focus");
    end;
  end;
end;
private.use_photoadress_inv = function()
  common_impl.ProcessMultiUseAll("photoadress", "photoadress")
end;
private.use_photoadress_beg = function()
  ObjDelete( "gfx_entrypoint_photoadress_zone" );
end;
private.use_photoadress_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_photoadress", private.use_photoadress_inv );
cmn.AddSubscriber( "use_photoadress", private.use_photoadress_beg, private.room_objname );
cmn.AddSubscriber( "use_photoadress", private.use_photoadress_end, private.room_objname );
cmn.AddSubscriber( "use_photoadress", private.use_photoadress_logic );
cmn.AddSubscriber( "use_photoadress_inv", private.use_photoadress_inv, private.room_objname );
cmn.AddSubscriber( "use_photoadress_beg", private.use_photoadress_beg, private.room_objname );
cmn.AddSubscriber( "use_photoadress_end", private.use_photoadress_end, private.room_objname );
cmn.AddSubscriber( "use_photoadress_end", private.use_photoadress_logic );
--------------------------------------------------------------------------------------------
function public.use_photoadress( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_photoadress" );
    cmn.CallEventHandler( "use_photoadress_end" );
    common_impl.Lock(0);
    common_impl.Gate_MDown( "grm_entrypoint_street" )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_photoadress_inv" );
  cmn.CallEventHandler( "use_photoadress_beg" );
  common_impl.Lock(1);

  SoundSfx( "aud_photoadress" )
  func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_case *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_amuletelf1" ] = { type = "get", get_obj = "spr_case_amuletelf1", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.get_amuletelf1_logic = function()
  ObjSet( "gfx_case_goldenfeather_case_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_amuletelf1_inv = function()
  interface.InventoryItemAdd("inv_amuletelf1","spr_case_amuletelf1");
end;
private.get_amuletelf1_beg = function()
  ObjDelete("gfx_case_amuletelf1")
end;
private.get_amuletelf1_end = function()
  ObjDelete("spr_case_amuletelf1_sh")
  ObjDelete("spr_entrypoint_tr_amuletelf1")
  if common_impl.ZzCompleteCheck("get_amuletelf1") then ObjSet( common_impl.hint["get_amuletelf1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletelf1", private.get_amuletelf1_inv );
cmn.AddSubscriber( "get_amuletelf1", private.get_amuletelf1_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletelf1", private.get_amuletelf1_end, private.room_objname );
cmn.AddSubscriber( "get_amuletelf1", private.get_amuletelf1_logic );
--------------------------------------------------------------------
function public.get_amuletelf1()
  cmn.SetEventDone( "get_amuletelf1" );
  cmn.CallEventHandler( "get_amuletelf1" );
  if common_impl.ZzCompleteCheck("get_amuletelf1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_goldenfeather_case" ] = { type = "use", inv_obj = "inv_goldenfeather", use_place = "gfx_case_goldenfeather_case_zone", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.use_goldenfeather_case_logic = function()
  ObjSet( "gfx_case_clk_casefeather_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_goldenfeather_case_inv = function()
  common_impl.ProcessMultiUseAll("goldenfeather", "goldenfeather_case")
end;
private.use_goldenfeather_case_beg = function()
  ObjDelete( "gfx_case_goldenfeather_case_zone" );
end;
private.use_goldenfeather_case_end = function()
  ObjSet( "anm_case_case_anm_case", {animfunc = "open_cover", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_goldenfeather_case") then ObjSet( common_impl.hint["use_goldenfeather_case"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_goldenfeather_case", private.use_goldenfeather_case_inv );
cmn.AddSubscriber( "use_goldenfeather_case", private.use_goldenfeather_case_beg, private.room_objname );
cmn.AddSubscriber( "use_goldenfeather_case", private.use_goldenfeather_case_end, private.room_objname );
cmn.AddSubscriber( "use_goldenfeather_case", private.use_goldenfeather_case_logic );
cmn.AddSubscriber( "use_goldenfeather_case_inv", private.use_goldenfeather_case_inv, private.room_objname );
cmn.AddSubscriber( "use_goldenfeather_case_beg", private.use_goldenfeather_case_beg, private.room_objname );
cmn.AddSubscriber( "use_goldenfeather_case_end", private.use_goldenfeather_case_end, private.room_objname );
cmn.AddSubscriber( "use_goldenfeather_case_end", private.use_goldenfeather_case_logic );
--------------------------------------------------------------------------------------------
function public.use_goldenfeather_case( obj )
  SoundSfx( "aud_golden_feather" )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_goldenfeather_case" );
    cmn.CallEventHandler( "use_goldenfeather_case_end" );
    common_impl.Lock(0);
    level.tutorial_hint.first()
    if common_impl.ZzCompleteCheck("use_goldenfeather_case") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_goldenfeather_case_inv" );
  cmn.CallEventHandler( "use_goldenfeather_case_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_case_case_anm_case", "use_feather", func_end );
  --SoundSfx( 0 )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_casefeather" ] = { type = "click", use_place = "gfx_case_clk_casefeather_zone", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.clk_casefeather_logic = function()
  ObjSet( "gfx_case_clk_flashback1_zone", { visible = 1, input = 1, active = 1 } )


end;
private.clk_casefeather_beg = function()
  ObjDelete( "gfx_case_clk_casefeather_zone" );
end;
private.clk_casefeather_end = function()
  ObjDelete("spr_entrypoint_tr_cover")
  ObjSet( "spr_entrypoint_tr_open", {visible = 1} );
  ObjSet( "spr_entrypoint_box_cover", {visible = 1} );
  ObjSet( "spr_entrypoint_tr_tee", {visible = 1} );
  ObjDelete("anm_case_case_anm_case")
  ObjSet( "anm_case_case_anm_case_termos", {visible = 1} );
  ObjSet( "anm_case_case_anm_case_box", {visible = 1} );
  ObjSet( "anm_case_case_anm_case_doc", {visible = 1} );
  ObjSet( "anm_case_case_anm_case_cake", {visible = 1} );
  if common_impl.ZzCompleteCheck("clk_casefeather") then ObjSet( common_impl.hint["clk_casefeather"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_casefeather", private.clk_casefeather_beg, private.room_objname );
cmn.AddSubscriber( "clk_casefeather", private.clk_casefeather_end, private.room_objname );
cmn.AddSubscriber( "clk_casefeather", private.clk_casefeather_logic );
cmn.AddSubscriber( "clk_casefeather_beg", private.clk_casefeather_beg, private.room_objname );
cmn.AddSubscriber( "clk_casefeather_end", private.clk_casefeather_end, private.room_objname );
cmn.AddSubscriber( "clk_casefeather_end", private.clk_casefeather_logic );
--------------------------------------------------------------------------------------------
function public.clk_casefeather()
  SoundSfx( "aud_open_case" )

  local func_end = function()
    cmn.SetEventDone( "clk_casefeather" );
    cmn.CallEventHandler( "clk_casefeather_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_casefeather") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_casefeather_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_case_case_anm_case", "open_cover", func_end );
  --SoundSfx( 0 )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_flashback1" ] = { type = "click", use_place = "gfx_case_clk_flashback1_zone", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.clk_flashback1_logic = function()
  ObjSet( "spr_case_paper", { input = 1, active = 1 } )

  ObjSet( "gfx_case_clk_cakepaper_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_case_giftknife_case_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_case_monogram_zone", { visible = 1, input = 1, active = 1 } )
end;
private.clk_flashback1_beg = function()
  ObjDelete( "gfx_case_clk_flashback1_zone" );
end;
private.clk_flashback1_end = function()
  ObjSet( "gfx_case_paper", { visible = 1 } )
  ObjSet( "spr_case_note_small", {input = 1, visible = 1} );
  ObjSet( "anm_case_case_anm_case_doc", {animfunc = "end_document1", frame = 0 } );
  if common_impl.ZzCompleteCheck("clk_flashback1") then ObjSet( common_impl.hint["clk_flashback1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_flashback1", private.clk_flashback1_beg, private.room_objname );
cmn.AddSubscriber( "clk_flashback1", private.clk_flashback1_end, private.room_objname );
cmn.AddSubscriber( "clk_flashback1", private.clk_flashback1_logic );
cmn.AddSubscriber( "clk_flashback1_beg", private.clk_flashback1_beg, private.room_objname );
cmn.AddSubscriber( "clk_flashback1_end", private.clk_flashback1_end, private.room_objname );
cmn.AddSubscriber( "clk_flashback1_end", private.clk_flashback1_logic );
--------------------------------------------------------------------------------------------
function public.clk_flashback1()

  local func_end = function()
    common_impl.FlashbackHide()
    cmn.SetEventDone( "clk_flashback1" );
    cmn.CallEventHandler( "clk_flashback1_end" );

    common_impl.Gate_MDown( 'gzz_entrypoint_case', { ObjGet( "gzz_entrypoint_case" ).pos_x, ObjGet( "gzz_entrypoint_case" ).pos_y } )
    
    ld.ShowBbt( "after_clk_flashback1" )

    if common_impl.ZzCompleteCheck("clk_flashback1") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_flashback1_beg" );

  local obj_root   = "obj_entrypoint_vid_flashback_root"
  local vid_prefix = "vid_entrypoint_vid_flashback_"
  local str_prefix = "str_entrypoint_vid_flashback_"
  local lip_prefix = "vid_entrypoint_vid_flashback_"
  local aud_count_dif = 0
  common_impl.FlashbackInit( obj_root, func_end, vid_prefix, str_prefix, lip_prefix, aud_count_dif )  

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )

  local func_step_3 = function()
    --SoundEnv( "aud_square_env" )
    SoundSfx( 0 )
    SoundSfx( "aud_flashback_2" )
    common_impl.FlashbackShow( 3, func_end )
  end;

  local func_step_2 = function()
    --SoundEnv( "aud_street_env" )
    SoundSfx( 0 )
    SoundSfx( "aud_flashback_2" )
    common_impl.FlashbackShow( 2, func_step_3 )
  end;

  local func_step_1 = function()
    --SoundEnv( "aud_entrypoint_env" )
    SoundSfx( 0 )
    SoundSfx( "aud_flashback_1" )
    common_impl.FlashbackShow( 1, func_step_2 )
  end;

  local func_fb_start = function()
    ld.Lock(0)
    ld.CloseSubRoom()
    func_step_1()
  end
  ld.Lock(1)
  SoundSfx( "aud_open_folder" )
  ld.AnimPlay( "anm_case_case_anm_case_doc", "use_document_flashback1", func_fb_start )
end;

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_paper" ] = { type = "get", get_obj = "spr_case_paper", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.get_paper_logic = function()
  ObjSet( "gfx_case_moneybag_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_paper_inv = function()
  interface.InventoryItemAdd("inv_paper","spr_case_paper");
end;
private.get_paper_beg = function()
  ObjDelete("gfx_case_paper")
  ObjSet( "spr_case_paper", {visible = 1} );
end;
private.get_paper_end = function()
  ObjSet( "anm_case_case_anm_case_doc", {animfunc = "close_document", frame = 999 } );
  if common_impl.ZzCompleteCheck("get_paper") then ObjSet( common_impl.hint["get_paper"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_paper", private.get_paper_inv );
cmn.AddSubscriber( "get_paper", private.get_paper_beg, private.room_objname );
cmn.AddSubscriber( "get_paper", private.get_paper_end, private.room_objname );
cmn.AddSubscriber( "get_paper", private.get_paper_logic );

cmn.AddSubscriber( "get_paper_beg", private.get_paper_inv );
cmn.AddSubscriber( "get_paper_beg", private.get_paper_beg, private.room_objname );
cmn.AddSubscriber( "get_paper_end", private.get_paper_end, private.room_objname );
cmn.AddSubscriber( "get_paper_end", private.get_paper_logic );

--------------------------------------------------------------------
function public.get_paper()
  local func_end = function()
    ld.Lock(0)
    cmn.SetEventDone( "get_paper" );
    cmn.CallEventHandler( "get_paper_end" );  
    if common_impl.ZzCompleteCheck("get_paper") then ld.CloseSubRoom() end;
  end
  cmn.CallEventHandler( "get_paper_beg" );
  ld.Lock(1)
  SoundSfx( "aud_close_folder" )
  ld.AnimPlay( "anm_case_case_anm_case_doc", "close_document", func_end )
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_cakepaper" ] = { type = "click", use_place = "gfx_case_clk_cakepaper_zone", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.clk_cakepaper_logic = function()
  ObjSet( "spr_case_cake", { visible = 1, input = 1, active = 1 } )

end;
private.clk_cakepaper_beg = function()
  ObjDelete( "gfx_case_clk_cakepaper_zone" );
end;
private.clk_cakepaper_end = function()
  ObjSet( "spr_case_cake_sh", {visible = 1} );
  ObjSet( "anm_case_case_anm_case_cake", {animfunc = "end_cakepaper", frame = 0 } );
  if common_impl.ZzCompleteCheck("clk_cakepaper") then ObjSet( common_impl.hint["clk_cakepaper"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_cakepaper", private.clk_cakepaper_beg, private.room_objname );
cmn.AddSubscriber( "clk_cakepaper", private.clk_cakepaper_end, private.room_objname );
cmn.AddSubscriber( "clk_cakepaper", private.clk_cakepaper_logic );
cmn.AddSubscriber( "clk_cakepaper_beg", private.clk_cakepaper_beg, private.room_objname );
cmn.AddSubscriber( "clk_cakepaper_end", private.clk_cakepaper_end, private.room_objname );
cmn.AddSubscriber( "clk_cakepaper_end", private.clk_cakepaper_logic );
--------------------------------------------------------------------------------------------
function public.clk_cakepaper()

  local func_end = function()
    cmn.SetEventDone( "clk_cakepaper" );
    cmn.CallEventHandler( "clk_cakepaper_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_cakepaper") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_cakepaper_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_case_case_anm_case_cake", "click_cakepaper", func_end );
  SoundSfx( "aud_open_cake" )
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cake" ] = { type = "get", get_obj = "spr_case_cake", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.get_cake_logic = function()
  
end;
private.get_cake_inv = function()
  interface.InventoryItemAdd("inv_cake","spr_case_cake");
end;
private.get_cake_beg = function()
  ObjDelete("gfx_case_cake")
end;
private.get_cake_end = function()
  ObjDelete("spr_case_cake_sh")
  if common_impl.ZzCompleteCheck("get_cake") then ObjSet( common_impl.hint["get_cake"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_cake", private.get_cake_inv );
cmn.AddSubscriber( "get_cake", private.get_cake_beg, private.room_objname );
cmn.AddSubscriber( "get_cake", private.get_cake_end, private.room_objname );
cmn.AddSubscriber( "get_cake", private.get_cake_logic );
--------------------------------------------------------------------
function public.get_cake()
  cmn.SetEventDone( "get_cake" );
  cmn.CallEventHandler( "get_cake" );
  if common_impl.ZzCompleteCheck("get_cake") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_giftknife_case" ] = { type = "use", inv_obj = "inv_giftknife", use_place = "gfx_case_giftknife_case_zone", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.use_giftknife_case_logic = function()
  ObjSet( "spr_case_thermos", { input = 1, active = 1 } )

end;
private.use_giftknife_case_inv = function()
  common_impl.ProcessMultiUseAll("giftknife", "giftknife_case")
end;
private.use_giftknife_case_beg = function()
  ObjDelete( "gfx_case_giftknife_case_zone" );
end;
private.use_giftknife_case_end = function()
  ObjSet( "gfx_case_thermos", {visible = 1} );
  ObjSet( "anm_case_case_anm_case_termos", {animfunc = "use_giftknife", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_giftknife_case") then ObjSet( common_impl.hint["use_giftknife_case"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_giftknife_case", private.use_giftknife_case_inv );
cmn.AddSubscriber( "use_giftknife_case", private.use_giftknife_case_beg, private.room_objname );
cmn.AddSubscriber( "use_giftknife_case", private.use_giftknife_case_end, private.room_objname );
cmn.AddSubscriber( "use_giftknife_case", private.use_giftknife_case_logic );
cmn.AddSubscriber( "use_giftknife_case_inv", private.use_giftknife_case_inv, private.room_objname );
cmn.AddSubscriber( "use_giftknife_case_beg", private.use_giftknife_case_beg, private.room_objname );
cmn.AddSubscriber( "use_giftknife_case_end", private.use_giftknife_case_end, private.room_objname );
cmn.AddSubscriber( "use_giftknife_case_end", private.use_giftknife_case_logic );
--------------------------------------------------------------------------------------------
function public.use_giftknife_case( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_giftknife_case" );
    cmn.CallEventHandler( "use_giftknife_case_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_giftknife_case") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_giftknife_case_inv" );
  cmn.CallEventHandler( "use_giftknife_case_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_case_case_anm_case_termos", "use_giftknife", func_end );
  SoundSfx( "aud_gift_knife1" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_thermos" ] = { type = "get", get_obj = "spr_case_thermos", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.get_thermos_logic = function()
  
end;
private.get_thermos_inv = function()
  interface.InventoryItemAdd("inv_thermos","spr_case_thermos");
end;
private.get_thermos_beg = function()
  ObjSet( "spr_case_thermos", {visible = 1} );
  ObjDelete("gfx_case_thermos")
end;
private.get_thermos_end = function()
  ObjDelete("spr_entrypoint_tr_tee")
  ObjSet( "anm_case_case_anm_case_termos", {animfunc = "end_thermos", frame = 0 } );
  if common_impl.ZzCompleteCheck("get_thermos") then ObjSet( common_impl.hint["get_thermos"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_thermos", private.get_thermos_inv );
cmn.AddSubscriber( "get_thermos", private.get_thermos_beg, private.room_objname );
cmn.AddSubscriber( "get_thermos", private.get_thermos_end, private.room_objname );
cmn.AddSubscriber( "get_thermos", private.get_thermos_logic );
--------------------------------------------------------------------
function public.get_thermos()
  cmn.SetEventDone( "get_thermos" );
  cmn.CallEventHandler( "get_thermos" );
  if common_impl.ZzCompleteCheck("get_thermos") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_monogram" ] = { type = "use", inv_obj = "inv_monogram", use_place = "gfx_case_monogram_zone", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.use_monogram_logic = function()
  ObjSet( "spr_case_lighter", {  input = 1, active = 1 } )
  ObjSet( "spr_case_lockpart2", {  input = 1, active = 1 } )

end;
private.use_monogram_inv = function()
  common_impl.ProcessMultiUseAll("monogram", "monogram")
end;
private.use_monogram_beg = function()
  ObjDelete( "gfx_case_monogram_zone" );
end;
private.use_monogram_end = function()
  ObjSet( "gfx_case_lighter", {  visible = 1 } )
  ObjSet( "gfx_case_lockpart2", { visible = 1 } )
  ObjDelete("spr_entrypoint_box_cover")
  ObjSet( "spr_entrypoint_tr_box", {visible = 1} );
  ObjSet( "anm_case_case_anm_case_box", {animfunc = "use_monogram", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_monogram") then ObjSet( common_impl.hint["use_monogram"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_monogram", private.use_monogram_inv );
cmn.AddSubscriber( "use_monogram", private.use_monogram_beg, private.room_objname );
cmn.AddSubscriber( "use_monogram", private.use_monogram_end, private.room_objname );
cmn.AddSubscriber( "use_monogram", private.use_monogram_logic );
cmn.AddSubscriber( "use_monogram_inv", private.use_monogram_inv, private.room_objname );
cmn.AddSubscriber( "use_monogram_beg", private.use_monogram_beg, private.room_objname );
cmn.AddSubscriber( "use_monogram_end", private.use_monogram_end, private.room_objname );
cmn.AddSubscriber( "use_monogram_end", private.use_monogram_logic );
--------------------------------------------------------------------------------------------
function public.use_monogram( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_monogram" );
    cmn.CallEventHandler( "use_monogram_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_monogram") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_monogram_inv" );
  cmn.CallEventHandler( "use_monogram_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_case_case_anm_case_box", "use_monogram", func_end );
  SoundSfx( "aud_monogram" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lighter" ] = { type = "get", get_obj = "spr_case_lighter", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.get_lighter_logic = function()
  
end;
private.get_lighter_inv = function()
  interface.InventoryItemAdd("inv_lighter","spr_case_lighter");
end;
private.get_lighter_beg = function()
  ObjDelete("gfx_case_lighter")
  ObjSet( "spr_case_lighter", {visible = 1} );
  if ld.CheckRequirements( {"get_lighter","get_lockpart2"} ) then
    ObjSet( "anm_case_case_anm_case_box", {animfunc = "end_monogram", frame = 0 } );
  else
    ObjSet( "anm_case_case_anm_case_box", {animfunc = "end_monogram1", frame = 0 } );
  end
end;
private.get_lighter_end = function()
  if common_impl.ZzCompleteCheck("get_lighter") then ObjSet( common_impl.hint["get_lighter"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lighter", private.get_lighter_inv );
cmn.AddSubscriber( "get_lighter", private.get_lighter_beg, private.room_objname );
cmn.AddSubscriber( "get_lighter", private.get_lighter_end, private.room_objname );
cmn.AddSubscriber( "get_lighter", private.get_lighter_logic );
--------------------------------------------------------------------
function public.get_lighter()
  cmn.SetEventDone( "get_lighter" );
  cmn.CallEventHandler( "get_lighter" );
  if common_impl.ZzCompleteCheck("get_lighter") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lockpart2" ] = { type = "get", get_obj = "spr_case_lockpart2", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.get_lockpart2_logic = function()
  
end;
private.get_lockpart2_inv = function()
  interface.InventoryItemAdd("inv_lockpart","spr_case_lockpart2",function() level_inv.ProcessGetLockpartAll( "get_lockpart2" ) end);
end;
private.get_lockpart2_beg = function()
  ObjDelete("gfx_case_lockpart2")
  ObjSet( "spr_case_lockpart2", {visible = 1} );
  if ld.CheckRequirements( {"get_lighter","get_lockpart2"} ) then
    ObjSet( "anm_case_case_anm_case_box", {animfunc = "end_monogram", frame = 0 } );
  else
    ObjSet( "anm_case_case_anm_case_box", {animfunc = "end_monogram2", frame = 0 } );
  end
end;
private.get_lockpart2_end = function()
  if common_impl.ZzCompleteCheck("get_lockpart2") then ObjSet( common_impl.hint["get_lockpart2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lockpart2", private.get_lockpart2_inv );
cmn.AddSubscriber( "get_lockpart2", private.get_lockpart2_beg, private.room_objname );
cmn.AddSubscriber( "get_lockpart2", private.get_lockpart2_end, private.room_objname );
cmn.AddSubscriber( "get_lockpart2", private.get_lockpart2_logic );
--------------------------------------------------------------------
function public.get_lockpart2()
  cmn.SetEventDone( "get_lockpart2" );
  cmn.CallEventHandler( "get_lockpart2" );
  if common_impl.ZzCompleteCheck("get_lockpart2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_moneybag" ] = { type = "use", inv_obj = "inv_moneybag", use_place = "gfx_case_moneybag_zone", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.use_moneybag_logic = function()
  ObjSet( "gfx_case_clk_outro1_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_moneybag_inv = function()
  common_impl.ProcessMultiUseAll("moneybag", "moneybag")
end;
private.use_moneybag_beg = function()
  ObjDelete( "gfx_case_moneybag_zone" );
end;
private.use_moneybag_end = function()
  ObjSet( "anm_case_case_anm_case_money", {animfunc = "use_moneybag", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_moneybag") then ObjSet( common_impl.hint["use_moneybag"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_moneybag", private.use_moneybag_inv );
cmn.AddSubscriber( "use_moneybag", private.use_moneybag_beg, private.room_objname );
cmn.AddSubscriber( "use_moneybag", private.use_moneybag_end, private.room_objname );
cmn.AddSubscriber( "use_moneybag", private.use_moneybag_logic );
cmn.AddSubscriber( "use_moneybag_inv", private.use_moneybag_inv, private.room_objname );
cmn.AddSubscriber( "use_moneybag_beg", private.use_moneybag_beg, private.room_objname );
cmn.AddSubscriber( "use_moneybag_end", private.use_moneybag_end, private.room_objname );
cmn.AddSubscriber( "use_moneybag_end", private.use_moneybag_logic );
--------------------------------------------------------------------------------------------
function public.use_moneybag( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    
    cmn.CallEventHandler( "use_moneybag_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_moneybag") then ld.CloseSubRoom() end;
    public.clk_outro1()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_moneybag_inv" );
  cmn.CallEventHandler( "use_moneybag_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_case_case_anm_case_money", "use_moneybag", func_end );
  SoundSfx( "aud_moneybags" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_outro1" ] = { type = "click", use_place = "gfx_case_clk_outro1_zone", room = "rm_entrypoint", zz = "zz_case", zz_gate = "gzz_entrypoint_case" };

private.clk_outro1_logic = function()
  level_inv.SetGoodball(2);
end;
private.clk_outro1_beg = function()
  ObjDelete( "gfx_case_clk_outro1_zone" );
end;
private.clk_outro1_end = function()
  ObjDelete("spr_entrypoint_jimm")
  ObjDelete("spr_entrypoint_gift")
  ObjDelete("anm_entrypoint_anim_jim_st")
  if common_impl.ZzCompleteCheck("clk_outro1") then ObjSet( common_impl.hint["clk_outro1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_outro1", private.clk_outro1_beg, private.room_objname );
cmn.AddSubscriber( "clk_outro1", private.clk_outro1_end, private.room_objname );
cmn.AddSubscriber( "clk_outro1", private.clk_outro1_logic );
cmn.AddSubscriber( "clk_outro1_beg", private.clk_outro1_beg, private.room_objname );
cmn.AddSubscriber( "clk_outro1_end", private.clk_outro1_end, private.room_objname );
cmn.AddSubscriber( "clk_outro1_end", private.clk_outro1_logic );
--------------------------------------------------------------------------------------------
function public.clk_outro1()

  local func_end = function()
    cmn.SetEventDone( "use_moneybag" );
    cmn.SetEventDone( "clk_outro1" );
    cmn.CallEventHandler( "clk_outro1_end" );
    int.DialogVideoHide();
    if common_impl.ZzCompleteCheck("clk_outro1") then ld.CloseSubRoom() end;
    --[[
    if ( IsSurveyEdition() ) or ( IsDemoEdition() ) then
      ObjSet( "rm_entrypoint", {color_r = 0, color_g = 0, color_b = 0} );
      local widget_settings = 
       {
         InterfaceWidget_Inventory,
         InterfaceWidget_BtnHint,
         InterfaceWidget_BtnMap,
         InterfaceWidget_BtnGuide,
         InterfaceWidget_BtnMenu,
         InterfaceWidget_Btn_Diary,
         InterfaceWidget_Dialog_Task,
         InterfaceWidget_Simon
       }

      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], 0 );
      end;    
      cmn.GotoRoom( "rm_outro" );
    else
      ObjSet( "rm_entrypoint", {color_r = 0, color_g = 0, color_b = 0} );
      cmn.GotoRoom( "rm_workshop");
    end 
    ]]
    if (iOS_IsBought() == 1) then
      ObjSet( "rm_entrypoint", {color_r = 0, color_g = 0, color_b = 0} );
      cmn.GotoRoom( "rm_workshop");
    else
      common.LevelSwitch("menu","unlock");
    end;
  end;

  local function dlg_entrypoint_jack2_1(  )
    function public.dlg_entrypoint_jack2_func_end()
      --func_end()
      level_inv.SetGoodball(2);
      int.DialogVideoShow( "vid_entrypoint_teleport", 1, func_end );
      SoundVid( "aud_teleport" )
      VidPlay("vid_entrypoint_teleport",func_end)
    end
    ld.Lock(0)
    common_impl.dialog_character_loc = "";
    common_impl.Start( "jack1", 3, nil, nil, true, "dlg_entrypoint_jack2_func_end", { "aud_jack_frost_6_voc", "aud_jack_frost_7_voc" } );
  end;
  local function dlg_entrypoint_jack2(  )
    ObjDelete("spr_entrypoint_jimm")
    ObjDelete("spr_entrypoint_gift")
    ObjDelete("anm_entrypoint_anim_jim_st")
    int.DialogVideoHide();
    ld.Lock(1)
    ld.StartTimer( 0.5, dlg_entrypoint_jack2_1 )
  end

  cmn.CallEventHandler( "clk_outro1_beg" );
  --common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  ld.CloseSubRoom()
  int.DialogVideoShow( "vid_entrypoint_vid_outro", 1, dlg_entrypoint_jack2 );

  ObjAnimate( "vid_entrypoint_vid_outro", 7, 0, 0, function() 
    --[[
    common_impl.VideoSubtitleVocStart( {
      { "srt_outro_1" , aud_voc_false, 1.5,5.5 };
      { "srt_outro_2" , aud_voc_false, 6.5,10 };
      { "srt_outro_3" , aud_voc_false, 11,14.5 };
      { "srt_outro_4" , aud_voc_false, 15.5,21 };
      { "srt_outro_5" , aud_voc_false, 39.5,43 };
      { "srt_outro_6" , aud_voc_false, 46.5,51 };
      { "srt_outro_7" , aud_voc_false, 51,58 };
      { "srt_outro_8" , aud_voc_false, 58,62 };
    } );
    ]]
    SoundVoice( "aud_outro_voc" );
    SoundVid( "aud_outro" );
    VidPlay( "vid_entrypoint_vid_outro", dlg_entrypoint_jack2 )

  end, {0,0,0, 0,0,0} );
  --ld.StartTimer( 1, function() func_end() end ) 

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_window *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_cone1" ] = { type = "get", get_obj = "spr_window_cone1", room = "rm_entrypoint", zz = "zz_window", zz_gate = "gzz_entrypoint_window" };

private.get_cone1_logic = function()
  ObjSet( "gfx_window_elf_window_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_cone1_inv = function()
  interface.InventoryItemAdd("inv_cone","spr_window_cone1",function() level_inv.ProcessGetConeAll( "get_cone1" ) end);
end;
private.get_cone1_beg = function()
  ObjDelete("gfx_window_cone1")
  ObjDelete("spr_window_cone1_shadow")
end;
private.get_cone1_end = function()
  ObjDelete("spr_entrypoint_tr_cone1")
  if common_impl.ZzCompleteCheck("get_cone1") then ObjSet( common_impl.hint["get_cone1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_cone1", private.get_cone1_inv );
cmn.AddSubscriber( "get_cone1", private.get_cone1_beg, private.room_objname );
cmn.AddSubscriber( "get_cone1", private.get_cone1_end, private.room_objname );
cmn.AddSubscriber( "get_cone1", private.get_cone1_logic );
--------------------------------------------------------------------
function public.get_cone1()
  cmn.SetEventDone( "get_cone1" );
  cmn.CallEventHandler( "get_cone1" );
  if common_impl.ZzCompleteCheck("get_cone1") then ld.CloseSubRoom() end;
  level.tutorial_goody_use.first()
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_elf_window" ] = { type = "use", inv_obj = "obj_simon_cursor_drag", use_place = "gfx_window_elf_window_zone", room = "rm_entrypoint", zz = "zz_window", zz_gate = "gzz_entrypoint_window" };

private.use_elf_window_logic = function()
  ObjSet( "grm_entrypoint_hall", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_entrypoint_hall_focus");
    end;

end;
private.use_elf_window_inv = function()
  common_impl.ProcessMultiUseAll("elf", "elf_window")
end;
private.use_elf_window_beg = function()
  ObjDelete( "gfx_window_elf_window_zone" );
end;
private.use_elf_window_end = function()
  ObjSet( "anm_window_anm", {animfunc = "window_open", frame = 999 } );
  ObjSet( "spr_entrypoint_tr_windows_open", {visible = 1} );
  ObjDelete( "spr_window_elf" )
  if common_impl.ZzCompleteCheck("use_elf_window") then ObjSet( common_impl.hint["use_elf_window"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_elf_window", private.use_elf_window_inv );
cmn.AddSubscriber( "use_elf_window", private.use_elf_window_beg, private.room_objname );
cmn.AddSubscriber( "use_elf_window", private.use_elf_window_end, private.room_objname );
cmn.AddSubscriber( "use_elf_window", private.use_elf_window_logic );
cmn.AddSubscriber( "use_elf_window_inv", private.use_elf_window_inv, private.room_objname );
cmn.AddSubscriber( "use_elf_window_beg", private.use_elf_window_beg, private.room_objname );
cmn.AddSubscriber( "use_elf_window_end", private.use_elf_window_end, private.room_objname );
cmn.AddSubscriber( "use_elf_window_end", private.use_elf_window_logic );
--------------------------------------------------------------------------------------------
function public.use_elf_window( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_elf_window" );
    cmn.CallEventHandler( "use_elf_window_end" );
    common_impl.Lock(0);
    --interface.InventoryItemAdd( "inv_elf", "spr_window_elf" );
    level.tutorial_navigation.first()
    if common_impl.ZzCompleteCheck("use_elf_window") then ld.CloseSubRoom() end;
    ObjSet( "spr_window_elf", {visible = 0} );
    interface.SimonReturn()
    
  end;
  local func_end_2 = function()
    ObjSet( "spr_window_elf", {visible = 1} );
    int_inventory.StdItemFlyAnimation( "spr_window_elf", "obj_int_button_map_point_for_cube", func_end );
    ObjDelete("vid_window_openwindow_116")
    ObjSet( "anm_window_anm", {alp = 1, animfunc = "window_open", frame = 999 } );
  end
  local func_end_3 = function()
    --ld.AnimPlay( "anm_window_anm", "window_open", func_end );
    --
    
    ObjAttach("vid_window_openwindow_116","zz_window")
    ObjAnimate( "anm_window_anm", 8, 0, 0, function() end, {0,0,1, 0.5,1,0} );
    ObjAnimate( "vid_window_openwindow_116", 8, 0, 0, function() end, {0,0,0, 0.5,2,1} );
    SoundVid( "aud_openwindow_116" )
    VidPlay("vid_window_openwindow_116",func_end_2)
  end
  level.tutorial_goody_use.click()
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_elf_window_inv" );
  cmn.CallEventHandler( "use_elf_window_beg" );
  common_impl.Lock(1);
  --interface.InventoryItemRemove( "inv_elf" )
--  ObjSet( "anm_window_anm", {visible = 0} );
--
--  ObjAttach("vid_window_openwindow_116","zz_window")
--  VidPlay("vid_window_openwindow_116",func_end)
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  interface.SimonJump(func_end_3)  

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_housedoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_casket" ] = { type = "get", get_obj = "spr_housedoor_casket", room = "rm_entrypoint", zz = "zz_housedoor", zz_gate = "gzz_entrypoint_housedoor" };

private.get_casket_logic = function()
  ObjSet( "gmg_entrypoint_casket", { 
    input = 1;
-->> TODO сделано для бота
    pos_x = 9999;
    pos_y = 9999;
    event_mdown = int_cube.MouseDown;
--<< TODO сделано для бота
  } )
  ObjSet( "gfx_housedoor_cake_zone", {active = 1, input = 1, visible = 1} );
end;
private.get_casket_inv = function()
  interface.InventoryItemAdd("inv_casket","spr_housedoor_casket");
  level.CubeAdd()
  ObjSet( "inv_casket", { drag = 0 } );
end;
private.get_casket_beg = function()
  ObjDelete("gfx_housedoor_casket")
  ObjSet("spr_housedoor_trash",{pos_z = -1})
end;
private.get_casket_end = function()
  ObjDelete("spr_housedoor_casket")
  ObjSet( "spr_entrypoint_tr_ice", {visible = 1} );
  if common_impl.ZzCompleteCheck("get_casket") then ObjSet( common_impl.hint["get_casket"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjAttach("vid_housedoor_evilfreez_static_51","zz_housedoor")
end;

cmn.AddSubscriber( "get_casket", private.get_casket_inv );
cmn.AddSubscriber( "get_casket", private.get_casket_beg, private.room_objname );
cmn.AddSubscriber( "get_casket", private.get_casket_end, private.room_objname );
cmn.AddSubscriber( "get_casket", private.get_casket_logic );

cmn.AddSubscriber( "get_casket_beg", private.get_casket_inv );
cmn.AddSubscriber( "get_casket_beg", private.get_casket_beg, private.room_objname );
cmn.AddSubscriber( "get_casket_end", private.get_casket_end, private.room_objname );
cmn.AddSubscriber( "get_casket_end", private.get_casket_logic );
--------------------------------------------------------------------
function public.get_casket()
  local function func_end() 
    ld.Lock(0)
    cmn.SetEventDone( "get_casket" );
    cmn.CallEventHandler( "get_casket_end" );
    ObjDelete("vid_housedoor_doorfreeze_341")    
    if common_impl.ZzCompleteCheck("get_casket") then ld.CloseSubRoom() end;
    common_impl.Gate_MDown( "gzz_entrypoint_housedoor", {ObjGet("gzz_entrypoint_housedoor").pos_x,ObjGet("gzz_entrypoint_housedoor").pos_y} )
    level.tutorial_deploy.first()
    ObjDelete("vid_entrypoint_grumpy_street_esc")
  end
  local function func_end_2() 
    ld.CloseSubRoom()
    ObjSet( "spr_entrypoint_tr_ice", {visible = 1} );
    ObjAttach("vid_entrypoint_grumpy_street_esc","rm_entrypoint")
    ObjAnimate( "vid_entrypoint_grumpy_street_esc", 7,0,0, function() SoundVid( "aud_grumpy_street_esc" ) end, { 0,0,0, 0,0,0 } )
    VidPlay("vid_entrypoint_grumpy_street_esc",func_end)
  end
  if ObjGet("spr_housedoor_casket").input then
    ld.Lock(1)
    ObjSet( "spr_housedoor_casket", {input = 0} );
    cmn.CallEventHandler( "get_casket_beg" );
--
--    int_inventory.StdItemFlyAnimation("spr_housedoor_casket","obj_int_button_map_point_for_cube",
--      function() 
--          cmn.CallEventHandler( "get_casket_beg" );
--          ObjAnimate( "obj_int_cube_button", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
--          ObjAnimate( "obj_int_cube_button", 6, 0, 0, function() end, {0,0,0.2,0.2, 0.5,0,1,1} );
--      end
--    )
    ObjAnimate( "vid_housedoor_doorfreeze_341", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
    ObjAttach("vid_housedoor_doorfreeze_341","zz_housedoor")
    VidPlay("vid_housedoor_doorfreeze_341",func_end_2)
    SoundVid( "aud_doorfreeze_341" )
  end
end
--------------------------------------------------------------------
function public.use_cake_wrong()
  ld.Lock(1)
  VidStop("vid_housedoor_evilfreez_static_51")
  SoundSfx( "aud_evilfreez_static_51" )
  VidPlay("vid_housedoor_evilfreez_static_51",function() ld.ShowBbt("need_cake"); ld.Lock(0) end)
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_cake" ] = { type = "use", inv_obj = "inv_cake", use_place = "gfx_housedoor_cake_zone", room = "rm_entrypoint", zz = "zz_housedoor", zz_gate = "gzz_entrypoint_housedoor" };

private.use_cake_logic = function()

  ObjSet( "gfx_housedoor_thermos_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_cake_inv = function()
  common_impl.ProcessMultiUseAll("cake", "cake")
end;
private.use_cake_beg = function()
  ObjDelete( "gfx_housedoor_cake_zone" );
  ObjDelete("vid_housedoor_evilfreez_static_51")
end;
private.use_cake_end = function()
  ObjAttach("vid_housedoor_goodfeez_static_66","zz_housedoor")
  if common_impl.ZzCompleteCheck("use_cake") then ObjSet( common_impl.hint["use_cake"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_cake", private.use_cake_inv );
cmn.AddSubscriber( "use_cake", private.use_cake_beg, private.room_objname );
cmn.AddSubscriber( "use_cake", private.use_cake_end, private.room_objname );
cmn.AddSubscriber( "use_cake", private.use_cake_logic );
cmn.AddSubscriber( "use_cake_inv", private.use_cake_inv, private.room_objname );
cmn.AddSubscriber( "use_cake_beg", private.use_cake_beg, private.room_objname );
cmn.AddSubscriber( "use_cake_end", private.use_cake_end, private.room_objname );
cmn.AddSubscriber( "use_cake_end", private.use_cake_logic );
--------------------------------------------------------------------------------------------
function public.use_cake( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_cake" );
    cmn.SetEventDone( "get_cherry" );
    cmn.SetEventDone( "get_postalcheck" );
    cmn.CallEventHandler( "use_cake_end" );
    common_impl.Lock(0);
    ld.ShowBbt( "after_use_cake_end" )
    ObjDelete("vid_housedoor_goodcake_2_416")
    if common_impl.ZzCompleteCheck("use_cake") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_cake_inv" );
  cmn.CallEventHandler( "use_cake_beg" );
  common_impl.Lock(1);
  ObjAttach("vid_housedoor_goodcake_0_416","zz_housedoor")
  VidPlay("vid_housedoor_goodcake_0_416", function() 
    ObjDelete("vid_housedoor_goodcake_0_416")
    cmn.CallEventHandler( "get_cherry" );
    ObjSet( "spr_housedoor_cherry", { visible = 1 } )
    ObjAttach("vid_housedoor_goodcake_1_416","zz_housedoor")
    VidPlay("vid_housedoor_goodcake_1_416",function() 
      ObjDelete("vid_housedoor_goodcake_1_416")
      cmn.CallEventHandler( "get_postalcheck" );
      ObjSet( "spr_housedoor_postalcheck", { visible = 1 } )
      ObjAttach("vid_housedoor_goodcake_2_416","zz_housedoor")
      VidPlay("vid_housedoor_goodcake_2_416",func_end)
    end)
  end)
  SoundVid( "aud_goodcake_0_130" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cherry" ] = { type = "get", get_obj = "spr_housedoor_cherry", room = "rm_entrypoint", zz = "zz_housedoor", zz_gate = "gzz_entrypoint_housedoor" };

private.get_cherry_logic = function()
  
end;
private.get_cherry_inv = function()
  interface.InventoryItemAdd("inv_cherry","spr_housedoor_cherry");
end;
private.get_cherry_beg = function()
  ObjDelete("gfx_housedoor_cherry")
end;
private.get_cherry_end = function()
  if common_impl.ZzCompleteCheck("get_cherry") then ObjSet( common_impl.hint["get_cherry"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_cherry", private.get_cherry_inv );
cmn.AddSubscriber( "get_cherry", private.get_cherry_beg, private.room_objname );
cmn.AddSubscriber( "get_cherry", private.get_cherry_end, private.room_objname );
cmn.AddSubscriber( "get_cherry", private.get_cherry_logic );
--------------------------------------------------------------------
function public.get_cherry()
  cmn.SetEventDone( "get_cherry" );
  cmn.CallEventHandler( "get_cherry" );
  if common_impl.ZzCompleteCheck("get_cherry") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_postalcheck" ] = { type = "get", get_obj = "spr_housedoor_postalcheck", room = "rm_entrypoint", zz = "zz_housedoor", zz_gate = "gzz_entrypoint_housedoor" };

private.get_postalcheck_logic = function()
  
end;
private.get_postalcheck_inv = function()
  interface.InventoryItemAdd("inv_postalcheck","spr_housedoor_postalcheck");
end;
private.get_postalcheck_beg = function()
  ObjDelete("gfx_housedoor_postalcheck")
end;
private.get_postalcheck_end = function()
  if common_impl.ZzCompleteCheck("get_postalcheck") then ObjSet( common_impl.hint["get_postalcheck"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_postalcheck", private.get_postalcheck_inv );
cmn.AddSubscriber( "get_postalcheck", private.get_postalcheck_beg, private.room_objname );
cmn.AddSubscriber( "get_postalcheck", private.get_postalcheck_end, private.room_objname );
cmn.AddSubscriber( "get_postalcheck", private.get_postalcheck_logic );
--------------------------------------------------------------------
function public.get_postalcheck()
  cmn.SetEventDone( "get_postalcheck" );
  cmn.CallEventHandler( "get_postalcheck" );
  if common_impl.ZzCompleteCheck("get_postalcheck") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
function public.use_thermos_wrong()
  ld.Lock(1)
  VidStop("vid_housedoor_goodfeez_static_66")
  SoundSfx( "aud_goodfeez_static_66" )
  VidPlay("vid_housedoor_goodfeez_static_66",function() ld.ShowBbt("need_thermos"); ld.Lock(0) end)
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_thermos" ] = { type = "use", inv_obj = "inv_thermos", use_place = "gfx_housedoor_thermos_zone", room = "rm_entrypoint", zz = "zz_housedoor", zz_gate = "gzz_entrypoint_housedoor" };

private.use_thermos_logic = function()
  --ObjSet( "spr_housedoor_elf", { input = 1, active = 1 } )

end;
private.use_thermos_inv = function()
  common_impl.ProcessMultiUseAll("thermos", "thermos")
end;
private.use_thermos_beg = function()
  ObjDelete( "gfx_housedoor_thermos_zone" );
  ObjDelete("vid_housedoor_goodfeez_static_66")
end;
private.use_thermos_end = function()
  
  if common_impl.ZzCompleteCheck("use_thermos") then ObjSet( common_impl.hint["use_thermos"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_thermos", private.use_thermos_inv );
cmn.AddSubscriber( "use_thermos", private.use_thermos_beg, private.room_objname );
cmn.AddSubscriber( "use_thermos", private.use_thermos_end, private.room_objname );
cmn.AddSubscriber( "use_thermos", private.use_thermos_logic );
cmn.AddSubscriber( "use_thermos_inv", private.use_thermos_inv, private.room_objname );
cmn.AddSubscriber( "use_thermos_beg", private.use_thermos_beg, private.room_objname );
cmn.AddSubscriber( "use_thermos_end", private.use_thermos_end, private.room_objname );
cmn.AddSubscriber( "use_thermos_end", private.use_thermos_logic );
--------------------------------------------------------------------------------------------
function public.use_thermos( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.CallEventHandler( "use_thermos_end" );
    ld.CloseSubRoom()
    ld.StartTimer( 0.5, function()  ld.Lock(0) public.dlg_entrypoint_goody( ) end )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_thermos_inv" );
  cmn.CallEventHandler( "use_thermos_beg" );
  common_impl.Lock(1);

  ObjAttach("vid_housedoor_elf_free_102","zz_housedoor")
  VidPlay("vid_housedoor_elf_free_102",func_end)
  SoundSfx( "aud_elf_free_102" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_entrypoint_goody" ] = { type = "click", use_place = "spr_housedoor_elf", room = "rm_entrypoint", zz = "zz_housedoor", zz_gate = "gzz_entrypoint_housedoor" };

private.dlg_entrypoint_goody_logic = function()

end;
private.dlg_entrypoint_goody_beg = function()
end;
private.dlg_entrypoint_goody_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_entrypoint_goody", private.dlg_entrypoint_goody_beg, private.room_objname );
cmn.AddSubscriber( "dlg_entrypoint_goody", private.dlg_entrypoint_goody_end, private.room_objname );
cmn.AddSubscriber( "dlg_entrypoint_goody", private.dlg_entrypoint_goody_logic );
cmn.AddSubscriber( "dlg_entrypoint_goody_beg", private.dlg_entrypoint_goody_beg, private.room_objname );
cmn.AddSubscriber( "dlg_entrypoint_goody_end", private.dlg_entrypoint_goody_end, private.room_objname );
cmn.AddSubscriber( "dlg_entrypoint_goody_end", private.dlg_entrypoint_goody_logic );
--------------------------------------------------------------------------------------------
function public.dlg_entrypoint_goody( obj )

  local func_end = function()
    cmn.CallEventHandler( "dlg_entrypoint_goody_end" );
    


ld.StartTimer( 0.5, function() 
    common_impl.Lock(0);
    ObjDelete("vid_housedoor_elf_free_102")
    public.get_elf()
 end )


    
    common_impl.Gate_MDown( "gzz_entrypoint_housedoor", {ObjGet("gzz_entrypoint_housedoor").pos_x,ObjGet("gzz_entrypoint_housedoor").pos_y} )

  end;
  function public.dlg_entrypoint_goody_func_end()
    common_impl.Lock(1);
    ld.StartTimer( 0.5, function() func_end() end )
    
  end
  cmn.CallEventHandler( "dlg_entrypoint_goody_beg" );
  common_impl.dialog_character_loc = "";
  common_impl.Start( "goody", 3, nil, nil, true, "dlg_entrypoint_goody_func_end", { "aud_goody_1_voc", "aud_goody_2_voc" } );

end;
--------------------------------------------------------------------
common_impl.hint[ "get_elf" ] = { type = "get", get_obj = "spr_housedoor_elf", room = "rm_entrypoint", zz = "zz_housedoor", zz_gate = "gzz_entrypoint_housedoor" };

private.get_elf_logic = function()
  
end;
private.get_elf_inv = function()
  --interface.InventoryItemAdd("inv_elf","spr_housedoor_elf");
  level.SimonAdd()
  interface.SimonGet()   
end;
private.get_elf_beg = function()
  ObjDelete("gfx_housedoor_elf")
  ObjSet( "spr_housedoor_ice", {visible = 1} );
end;
private.get_elf_end = function()
  ObjDelete( "spr_housedoor_elf" )
  if common_impl.ZzCompleteCheck("get_elf") then ObjSet( common_impl.hint["get_elf"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_elf", private.get_elf_inv );
cmn.AddSubscriber( "get_elf", private.get_elf_beg, private.room_objname );
cmn.AddSubscriber( "get_elf", private.get_elf_end, private.room_objname );
cmn.AddSubscriber( "get_elf", private.get_elf_logic );
cmn.AddSubscriber( "get_elf_end", private.get_elf_inv );
cmn.AddSubscriber( "get_elf_beg", private.get_elf_beg, private.room_objname );
cmn.AddSubscriber( "get_elf_end", private.get_elf_end, private.room_objname );
cmn.AddSubscriber( "get_elf_end", private.get_elf_logic );
--------------------------------------------------------------------
function public.get_elf()
  local function func_end() 
    ld.Lock(0)
    cmn.SetEventDone( "dlg_entrypoint_goody" );
    cmn.SetEventDone( "use_thermos" );
    cmn.SetEventDone( "get_elf" );
    cmn.CallEventHandler( "get_elf_end" );
    if common_impl.ZzCompleteCheck("get_elf") then ld.CloseSubRoom() end;
    interface.SimonReturn()
    level.tutorial_goody.first()
  end
  cmn.CallEventHandler( "get_elf_beg" );
  ld.Lock(1)
  ObjSet( "spr_housedoor_elf", {visible = 1} );
  int_inventory.StdItemFlyAnimation("spr_housedoor_elf","obj_int_button_map_point_for_cube",
    function() 
        func_end()
        --ObjAnimate( "obj_int_cube_button", 8, 0, 0, function() end, {0,0,0, 0.5,0,1} );
        --ObjAnimate( "obj_int_cube_button", 6, 0, 0, function() end, {0,0,0.2,0.2, 0.5,0,1,1} );
    end)
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_mailbox *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_postalcheck" ] = { type = "use", inv_obj = "inv_postalcheck", use_place = "gfx_mailbox_postalcheck_zone", room = "rm_entrypoint", zz = "zz_mailbox", zz_gate = "gzz_entrypoint_mailbox" };

private.use_postalcheck_logic = function()

  ObjSet( "spr_mailbox_catfigurine", { visible = 1, input = 1, active = 1 } )
end;
private.use_postalcheck_inv = function()
  common_impl.ProcessMultiUseAll("postalcheck", "postalcheck")
end;
private.use_postalcheck_beg = function()
  ObjDelete( "gfx_mailbox_postalcheck_zone" );
end;
private.use_postalcheck_end = function()
  ObjDelete("anm_mailbox_anm_flag")
  ObjSet( "anm_mailbox_anm_cover", {animfunc = "open_box", frame =  0} );
  ObjDelete("spr_entrypoint_tr_cap")
  ObjSet( "spr_entrypoint_tr_check", {visible = 1} );
  ObjSet( "spr_entrypoint_tr_cap_open", {visible = 1} );
  ObjSet( "spr_entrypoint_tr_box2", {visible = 1} );
  ObjSet( "spr_mailbox_catfigurine_shadow", {visible = 1} );
  ObjSet( "spr_entrypoint_tr_catfigurine", {visible = 1} ); 
  ObjSet( "spr_mailbox_note_small", {input = 1} );
  if common_impl.ZzCompleteCheck("use_postalcheck") then ObjSet( common_impl.hint["use_postalcheck"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_postalcheck", private.use_postalcheck_inv );
cmn.AddSubscriber( "use_postalcheck", private.use_postalcheck_beg, private.room_objname );
cmn.AddSubscriber( "use_postalcheck", private.use_postalcheck_end, private.room_objname );
cmn.AddSubscriber( "use_postalcheck", private.use_postalcheck_logic );
cmn.AddSubscriber( "use_postalcheck_inv", private.use_postalcheck_inv, private.room_objname );
cmn.AddSubscriber( "use_postalcheck_beg", private.use_postalcheck_beg, private.room_objname );
cmn.AddSubscriber( "use_postalcheck_end", private.use_postalcheck_end, private.room_objname );
cmn.AddSubscriber( "use_postalcheck_end", private.use_postalcheck_logic );
--------------------------------------------------------------------------------------------
function public.use_postalcheck( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_postalcheck" );
    cmn.CallEventHandler( "use_postalcheck_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_postalcheck") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_postalcheck_inv" );
  cmn.CallEventHandler( "use_postalcheck_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mailbox_anm_cover", "use_key", function() 
    ld.AnimPlay( "anm_mailbox_anm_cover", "open_cap", func_end ); 
  end );
  SoundSfx( "aud_mail_flag" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_catfigurine" ] = { type = "get", get_obj = "spr_mailbox_catfigurine", room = "rm_entrypoint", zz = "zz_mailbox", zz_gate = "gzz_entrypoint_mailbox" };

private.get_catfigurine_logic = function()
  ObjSet( "gfx_mailbox_clk_mailboxpackage_zone", { visible = 1, input = 1, active = 1 } )  
end;
private.get_catfigurine_inv = function()
  interface.InventoryItemAdd("inv_catfigurine","spr_mailbox_catfigurine");
end;
private.get_catfigurine_beg = function()
  ObjDelete("gfx_mailbox_catfigurine")
end;
private.get_catfigurine_end = function()
  ObjDelete("spr_entrypoint_tr_catfigurine")
  ObjDelete("spr_mailbox_catfigurine_shadow")
  if common_impl.ZzCompleteCheck("get_catfigurine") then ObjSet( common_impl.hint["get_catfigurine"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_catfigurine", private.get_catfigurine_inv );
cmn.AddSubscriber( "get_catfigurine", private.get_catfigurine_beg, private.room_objname );
cmn.AddSubscriber( "get_catfigurine", private.get_catfigurine_end, private.room_objname );
cmn.AddSubscriber( "get_catfigurine", private.get_catfigurine_logic );
--------------------------------------------------------------------
function public.get_catfigurine()
  cmn.SetEventDone( "get_catfigurine" );
  cmn.CallEventHandler( "get_catfigurine" );
  if common_impl.ZzCompleteCheck("get_catfigurine") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_mailboxpackage" ] = { type = "click", use_place = "gfx_mailbox_clk_mailboxpackage_zone", room = "rm_entrypoint", zz = "zz_mailbox", zz_gate = "gzz_entrypoint_mailbox" };

private.clk_mailboxpackage_logic = function()
  ObjSet( "spr_mailbox_giftknife", { visible = 1, input = 1, active = 1 } )

end;
private.clk_mailboxpackage_beg = function()
  ObjDelete( "gfx_mailbox_clk_mailboxpackage_zone" );
end;
private.clk_mailboxpackage_end = function()
  ObjDelete("spr_entrypoint_tr_box2")
  ObjSet( "anm_mailbox_anm_cover", {animfunc = "open_box", frame = 999 } );
  if common_impl.ZzCompleteCheck("clk_mailboxpackage") then ObjSet( common_impl.hint["clk_mailboxpackage"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_mailboxpackage", private.clk_mailboxpackage_beg, private.room_objname );
cmn.AddSubscriber( "clk_mailboxpackage", private.clk_mailboxpackage_end, private.room_objname );
cmn.AddSubscriber( "clk_mailboxpackage", private.clk_mailboxpackage_logic );
cmn.AddSubscriber( "clk_mailboxpackage_beg", private.clk_mailboxpackage_beg, private.room_objname );
cmn.AddSubscriber( "clk_mailboxpackage_end", private.clk_mailboxpackage_end, private.room_objname );
cmn.AddSubscriber( "clk_mailboxpackage_end", private.clk_mailboxpackage_logic );
--------------------------------------------------------------------------------------------
function public.clk_mailboxpackage()

  local func_end = function()
    cmn.SetEventDone( "clk_mailboxpackage" );
    cmn.CallEventHandler( "clk_mailboxpackage_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_mailboxpackage") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_mailboxpackage_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mailbox_anm_cover", "open_box", func_end );
  SoundSfx( "aud_open_cardboard_box" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_giftknife" ] = { type = "get", get_obj = "spr_mailbox_giftknife", room = "rm_entrypoint", zz = "zz_mailbox", zz_gate = "gzz_entrypoint_mailbox" };

private.get_giftknife_logic = function()
  
end;
private.get_giftknife_inv = function()
  interface.InventoryItemAdd("inv_giftknife","spr_mailbox_giftknife");
end;
private.get_giftknife_beg = function()
  ObjDelete("gfx_mailbox_giftknife")
  ObjDelete("spr_mailbox_giftknife_shadow")
end;
private.get_giftknife_end = function()
  ObjDelete("spr_mailbox_giftknife_shadow")
  if common_impl.ZzCompleteCheck("get_giftknife") then ObjSet( common_impl.hint["get_giftknife"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_giftknife", private.get_giftknife_inv );
cmn.AddSubscriber( "get_giftknife", private.get_giftknife_beg, private.room_objname );
cmn.AddSubscriber( "get_giftknife", private.get_giftknife_end, private.room_objname );
cmn.AddSubscriber( "get_giftknife", private.get_giftknife_logic );
--------------------------------------------------------------------
function public.get_giftknife()
  cmn.SetEventDone( "get_giftknife" );
  cmn.CallEventHandler( "get_giftknife" );
  if common_impl.ZzCompleteCheck("get_giftknife") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "use_titmouse" ] = { type = "use", inv_obj = "inv_titmouse", use_place = "gfx_mailbox_titmouse_zone", room = "rm_entrypoint", zz = "zz_mailbox", zz_gate = "gzz_entrypoint_mailbox" };

private.use_titmouse_logic = function()
  if ld.CheckRequirements( {"use_titmouse","use_bullfinch"} ) then
    ObjSet( "spr_mailbox_lockpart3", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_mailbox_bunchofrowan", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_titmouse_inv = function()
  common_impl.ProcessMultiUseAll("titmouse", "titmouse")
end;
private.use_titmouse_beg = function()
  ObjDelete( "gfx_mailbox_titmouse_zone" );
end;
private.use_titmouse_end = function()
  ObjSet( "anm_mailbox_anm_bird2", {animfunc = "use_bird2", frame = 999 } );
  ObjSet( "spr_entrypoint_tr_bird2", {visible = 1} );
  if ld.CheckRequirements( {"use_titmouse","use_bullfinch"} ) then
    ObjDelete("anm_mailbox_anm_bird1")
    ObjDelete("anm_mailbox_anm_bird2")
    ObjSet( "anm_mailbox_anm_bird0", {animfunc = "close_bill", frame = 999 } );
  end
  if common_impl.ZzCompleteCheck("use_titmouse") then ObjSet( common_impl.hint["use_titmouse"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_titmouse", private.use_titmouse_inv );
cmn.AddSubscriber( "use_titmouse", private.use_titmouse_beg, private.room_objname );
cmn.AddSubscriber( "use_titmouse", private.use_titmouse_end, private.room_objname );
cmn.AddSubscriber( "use_titmouse", private.use_titmouse_logic );
cmn.AddSubscriber( "use_titmouse_inv", private.use_titmouse_inv, private.room_objname );
cmn.AddSubscriber( "use_titmouse_beg", private.use_titmouse_beg, private.room_objname );
cmn.AddSubscriber( "use_titmouse_end", private.use_titmouse_end, private.room_objname );
cmn.AddSubscriber( "use_titmouse_end", private.use_titmouse_logic );
--------------------------------------------------------------------------------------------
function public.use_titmouse( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_titmouse" );
    if ld.CheckRequirements( {"use_titmouse","use_bullfinch"} ) then
      cmn.SetEventDone( "get_lockpart3" );
      cmn.SetEventDone( "get_bunchofrowan" );
    end
    cmn.CallEventHandler( "use_titmouse_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_titmouse") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()
    if ld.IsLastActionLeft( {"use_titmouse","use_bullfinch"} ) then
      ObjDelete("anm_mailbox_anm_bird1")
      ObjDelete("anm_mailbox_anm_bird2")
      SoundSfx( "aud_bird_release_rowan" )
      ld.AnimPlay( "anm_mailbox_anm_bird0", "open_bill", function() 
        cmn.CallEventHandler( "get_lockpart3" );
        cmn.CallEventHandler( "get_bunchofrowan" );        
        ld.AnimPlay( "anm_mailbox_anm_bird0", "close_bill", function() 
          func_end()
        end )
      end )
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_titmouse_inv" );
  cmn.CallEventHandler( "use_titmouse_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mailbox_anm_bird2", "use_bird2", func_end_2 );
  SoundSfx( "aud_titmouse" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bullfinch" ] = { type = "use", inv_obj = "inv_bullfinch", use_place = "gfx_mailbox_bullfinch_zone", room = "rm_entrypoint", zz = "zz_mailbox", zz_gate = "gzz_entrypoint_mailbox" };

private.use_bullfinch_logic = function()
  if ld.CheckRequirements( {"use_bullfinch","use_titmouse"} ) then
    ObjSet( "spr_mailbox_lockpart3", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_mailbox_bunchofrowan", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_bullfinch_inv = function()
  common_impl.ProcessMultiUseAll("bullfinch", "bullfinch")
end;
private.use_bullfinch_beg = function()
  ObjDelete( "gfx_mailbox_bullfinch_zone" );
end;
private.use_bullfinch_end = function()
  ObjSet( "anm_mailbox_anm_bird1", {animfunc = "use_bird1", frame = 999 } );
  ObjSet( "spr_entrypoint_tr_bird1", {visible = 1} );
  if ld.CheckRequirements( {"use_titmouse","use_bullfinch"} ) then
    ObjDelete("anm_mailbox_anm_bird1")
    ObjDelete("anm_mailbox_anm_bird2")
    ObjSet( "anm_mailbox_anm_bird0", {animfunc = "close_bill", frame = 999 } );
  end
  if common_impl.ZzCompleteCheck("use_bullfinch") then ObjSet( common_impl.hint["use_bullfinch"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bullfinch", private.use_bullfinch_inv );
cmn.AddSubscriber( "use_bullfinch", private.use_bullfinch_beg, private.room_objname );
cmn.AddSubscriber( "use_bullfinch", private.use_bullfinch_end, private.room_objname );
cmn.AddSubscriber( "use_bullfinch", private.use_bullfinch_logic );
cmn.AddSubscriber( "use_bullfinch_inv", private.use_bullfinch_inv, private.room_objname );
cmn.AddSubscriber( "use_bullfinch_beg", private.use_bullfinch_beg, private.room_objname );
cmn.AddSubscriber( "use_bullfinch_end", private.use_bullfinch_end, private.room_objname );
cmn.AddSubscriber( "use_bullfinch_end", private.use_bullfinch_logic );
--------------------------------------------------------------------------------------------
function public.use_bullfinch( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bullfinch" );
    if ld.CheckRequirements( {"use_titmouse","use_bullfinch"} ) then
      cmn.SetEventDone( "get_lockpart3" );
      cmn.SetEventDone( "get_bunchofrowan" );
    end
    cmn.CallEventHandler( "use_bullfinch_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bullfinch") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()
    if ld.IsLastActionLeft( {"use_titmouse","use_bullfinch"} ) then
      ObjDelete("anm_mailbox_anm_bird1")
      ObjDelete("anm_mailbox_anm_bird2")
      SoundSfx( "aud_bird_release_rowan" )
      ld.AnimPlay( "anm_mailbox_anm_bird0", "open_bill", function() 
        cmn.CallEventHandler( "get_lockpart3" );
        cmn.CallEventHandler( "get_bunchofrowan" );  
        
        ld.AnimPlay( "anm_mailbox_anm_bird0", "close_bill", function() 
          func_end()
        end )
      end )
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bullfinch_inv" );
  cmn.CallEventHandler( "use_bullfinch_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_mailbox_anm_bird1", "use_bird1", func_end_2 );
  SoundSfx( "aud_titmouse" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_lockpart3" ] = { type = "get", get_obj = "spr_mailbox_lockpart3", room = "rm_entrypoint", zz = "zz_mailbox", zz_gate = "gzz_entrypoint_mailbox" };

private.get_lockpart3_logic = function()
  
end;
private.get_lockpart3_inv = function()
  interface.InventoryItemAdd("inv_lockpart","spr_mailbox_lockpart3",function() level_inv.ProcessGetLockpartAll( "get_lockpart3" ) end);
end;
private.get_lockpart3_beg = function()
  ObjDelete("gfx_mailbox_lockpart3")
  ObjSet( "spr_mailbox_lockpart3", {visible = 1} );
end;
private.get_lockpart3_end = function()
  if common_impl.ZzCompleteCheck("get_lockpart3") then ObjSet( common_impl.hint["get_lockpart3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lockpart3", private.get_lockpart3_inv );
cmn.AddSubscriber( "get_lockpart3", private.get_lockpart3_beg, private.room_objname );
cmn.AddSubscriber( "get_lockpart3", private.get_lockpart3_end, private.room_objname );
cmn.AddSubscriber( "get_lockpart3", private.get_lockpart3_logic );
--------------------------------------------------------------------
function public.get_lockpart3()
  cmn.SetEventDone( "get_lockpart3" );
  cmn.CallEventHandler( "get_lockpart3" );
  if common_impl.ZzCompleteCheck("get_lockpart3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bunchofrowan" ] = { type = "get", get_obj = "spr_mailbox_bunchofrowan", room = "rm_entrypoint", zz = "zz_mailbox", zz_gate = "gzz_entrypoint_mailbox" };

private.get_bunchofrowan_logic = function()
  
end;
private.get_bunchofrowan_inv = function()
  interface.InventoryItemAdd("inv_bunchofrowan","spr_mailbox_bunchofrowan");
end;
private.get_bunchofrowan_beg = function()
  ObjDelete("gfx_mailbox_bunchofrowan")
  ObjSet( "spr_mailbox_bunchofrowan", {visible = 1} );
end;
private.get_bunchofrowan_end = function()
  ObjDelete("spr_entrypoint_tr_bunchofrowan")
  if common_impl.ZzCompleteCheck("get_bunchofrowan") then ObjSet( common_impl.hint["get_bunchofrowan"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bunchofrowan", private.get_bunchofrowan_inv );
cmn.AddSubscriber( "get_bunchofrowan", private.get_bunchofrowan_beg, private.room_objname );
cmn.AddSubscriber( "get_bunchofrowan", private.get_bunchofrowan_end, private.room_objname );
cmn.AddSubscriber( "get_bunchofrowan", private.get_bunchofrowan_logic );
--------------------------------------------------------------------
function public.get_bunchofrowan()
  cmn.SetEventDone( "get_bunchofrowan" );
  cmn.CallEventHandler( "get_bunchofrowan" );
  if common_impl.ZzCompleteCheck("get_bunchofrowan") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_snowman *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_coal" ] = { type = "use", inv_obj = "inv_coal", use_place = "gfx_snowman_coal_zone", room = "rm_entrypoint", zz = "zz_snowman", zz_gate = "gzz_entrypoint_snowman" };

private.use_coal_logic = function()
  if ld.CheckRequirements( {"use_coal","use_bucket"} ) then
    ObjSet( "spr_snowman_snowflake2", { input = 1, active = 1 } )
  end;

end;
private.use_coal_inv = function()
  common_impl.ProcessMultiUseAll("coal", "coal")
end;
private.use_coal_beg = function()
  ObjDelete( "gfx_snowman_coal_zone" );
end;
private.use_coal_end = function()
  ObjSet( "anm_snowman_anm_coal", {animfunc = "use_coal", frame = 999 } );
  ObjSet( "spr_entrypoint_tr_coal_teeth", {visible = 1} );
  ObjSet( "spr_entrypoint_tr_coal_eye1", {visible = 1} );
  ObjSet( "spr_entrypoint_tr_coal_eye2", {visible = 1} );
  if ld.CheckRequirements( {"use_coal","use_bucket"} ) then
    ObjSet( "gfx_snowman_snowflake2", { visible = 1 } )
    ObjSet( "anm_snowman_anm_arm_l", {animfunc = "arm_l", frame = 999 } );
    ObjSet( "spr_entrypoint_tr_hand", {visible = 1} );
    ObjSet( "spr_entrypoint_tr_snowflake2", {visible = 1} );
  end
  if common_impl.ZzCompleteCheck("use_coal") then ObjSet( common_impl.hint["use_coal"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_coal", private.use_coal_inv );
cmn.AddSubscriber( "use_coal", private.use_coal_beg, private.room_objname );
cmn.AddSubscriber( "use_coal", private.use_coal_end, private.room_objname );
cmn.AddSubscriber( "use_coal", private.use_coal_logic );
cmn.AddSubscriber( "use_coal_inv", private.use_coal_inv, private.room_objname );
cmn.AddSubscriber( "use_coal_beg", private.use_coal_beg, private.room_objname );
cmn.AddSubscriber( "use_coal_end", private.use_coal_end, private.room_objname );
cmn.AddSubscriber( "use_coal_end", private.use_coal_logic );
--------------------------------------------------------------------------------------------
function public.use_coal( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_coal" );
    cmn.CallEventHandler( "use_coal_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_coal") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()
    if ld.IsLastActionLeft( {"use_coal","use_bucket"} ) then
      ld.AnimPlay( "anm_snowman_anm_arm_l", "arm_l", func_end )
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_coal_inv" );
  cmn.CallEventHandler( "use_coal_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_snowman_anm_coal", "use_coal", func_end_2 );
  SoundSfx( "aud_coal" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bucket" ] = { type = "use", inv_obj = "inv_bucket", use_place = "gfx_snowman_bucket_zone", room = "rm_entrypoint", zz = "zz_snowman", zz_gate = "gzz_entrypoint_snowman" };

private.use_bucket_logic = function()
  if ld.CheckRequirements( {"use_bucket","use_coal"} ) then
    ObjSet( "spr_snowman_snowflake2", { input = 1, active = 1 } )
  end;

end;
private.use_bucket_inv = function()
  common_impl.ProcessMultiUseAll("bucket", "bucket")
end;
private.use_bucket_beg = function()
  ObjDelete( "gfx_snowman_bucket_zone" );
end;
private.use_bucket_end = function()
  ObjSet( "anm_snowman_anm_bucket", {animfunc = "use_bucket", frame = 999 } );
  ObjSet( "spr_entrypoint_tr_bucket", {visible = 1} );
  if ld.CheckRequirements( {"use_coal","use_bucket"} ) then
    ObjSet( "anm_snowman_anm_arm_l", {animfunc = "arm_l", frame = 999 } );
    ObjSet( "spr_entrypoint_tr_hand", {visible = 1} );
    ObjSet( "gfx_snowman_snowflake2", { visible = 1 } )
    ObjSet( "spr_entrypoint_tr_snowflake2", {visible = 1} );
  end
  if common_impl.ZzCompleteCheck("use_bucket") then ObjSet( common_impl.hint["use_bucket"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bucket", private.use_bucket_inv );
cmn.AddSubscriber( "use_bucket", private.use_bucket_beg, private.room_objname );
cmn.AddSubscriber( "use_bucket", private.use_bucket_end, private.room_objname );
cmn.AddSubscriber( "use_bucket", private.use_bucket_logic );
cmn.AddSubscriber( "use_bucket_inv", private.use_bucket_inv, private.room_objname );
cmn.AddSubscriber( "use_bucket_beg", private.use_bucket_beg, private.room_objname );
cmn.AddSubscriber( "use_bucket_end", private.use_bucket_end, private.room_objname );
cmn.AddSubscriber( "use_bucket_end", private.use_bucket_logic );
--------------------------------------------------------------------------------------------
function public.use_bucket( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bucket" );
    cmn.CallEventHandler( "use_bucket_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bucket") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()
    if ld.IsLastActionLeft( {"use_coal","use_bucket"} ) then
      ld.AnimPlay( "anm_snowman_anm_arm_l", "arm_l", func_end )
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bucket_inv" );
  cmn.CallEventHandler( "use_bucket_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_snowman_anm_bucket", "use_bucket", func_end_2 );
  SoundSfx( "aud_bucket" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_snowflake2" ] = { type = "get", get_obj = "spr_snowman_snowflake2", room = "rm_entrypoint", zz = "zz_snowman", zz_gate = "gzz_entrypoint_snowman" };

private.get_snowflake2_logic = function()
  
end;
private.get_snowflake2_inv = function()
  interface.InventoryItemAdd("inv_snowflake2","spr_snowman_snowflake2");
end;
private.get_snowflake2_beg = function()
  ObjDelete("gfx_snowman_snowflake2")
  ObjSet( "spr_snowman_snowflake2", {visible = 1} );
  ObjSet( "anm_snowman_anm_arm_l", {animfunc = "arm_l1", frame = 0 } );
end;
private.get_snowflake2_end = function()
  ObjDelete("spr_entrypoint_tr_snowflake2")
  if common_impl.ZzCompleteCheck("get_snowflake2") then ObjSet( common_impl.hint["get_snowflake2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_snowflake2", private.get_snowflake2_inv );
cmn.AddSubscriber( "get_snowflake2", private.get_snowflake2_beg, private.room_objname );
cmn.AddSubscriber( "get_snowflake2", private.get_snowflake2_end, private.room_objname );
cmn.AddSubscriber( "get_snowflake2", private.get_snowflake2_logic );
--------------------------------------------------------------------
function public.get_snowflake2()
  cmn.SetEventDone( "get_snowflake2" );
  cmn.CallEventHandler( "get_snowflake2" );
  if common_impl.ZzCompleteCheck("get_snowflake2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_buttons" ] = { type = "use", inv_obj = "inv_buttons", use_place = "gfx_snowman_buttons_zone", room = "rm_entrypoint", zz = "zz_snowman", zz_gate = "gzz_entrypoint_snowman" };

private.use_buttons_logic = function()
  ObjSet( "spr_snowman_paperdove", { input = 1, active = 1 } )

end;
private.use_buttons_inv = function()
  common_impl.ProcessMultiUseAll("buttons", "buttons")
end;
private.use_buttons_beg = function()
  ObjDelete( "gfx_snowman_buttons_zone" );
end;
private.use_buttons_end = function()
  ObjSet( "spr_entrypoint_tr_paperdove", {visible = 1} );
  ObjSet( "gfx_snowman_paperdove", { visible = 1 } )
  ObjSet( "anm_snowman_anm_button", {animfunc = "use_button", frame = 999 } );
  ObjSet( "anm_snowman_anm_arm_r", {animfunc = "arm_r", frame = 999 } );
  ObjSet( "spr_entrypoint_tr_hand2", {visible = 1} );
  ObjSet( "spr_entrypoint_tr_button", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_buttons") then ObjSet( common_impl.hint["use_buttons"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_buttons", private.use_buttons_inv );
cmn.AddSubscriber( "use_buttons", private.use_buttons_beg, private.room_objname );
cmn.AddSubscriber( "use_buttons", private.use_buttons_end, private.room_objname );
cmn.AddSubscriber( "use_buttons", private.use_buttons_logic );
cmn.AddSubscriber( "use_buttons_inv", private.use_buttons_inv, private.room_objname );
cmn.AddSubscriber( "use_buttons_beg", private.use_buttons_beg, private.room_objname );
cmn.AddSubscriber( "use_buttons_end", private.use_buttons_end, private.room_objname );
cmn.AddSubscriber( "use_buttons_end", private.use_buttons_logic );
--------------------------------------------------------------------------------------------
function public.use_buttons( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_buttons" );
    cmn.CallEventHandler( "use_buttons_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_buttons") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_buttons_inv" );
  cmn.CallEventHandler( "use_buttons_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_snowman_anm_button", "use_button", function() 
    ld.AnimPlay( "anm_snowman_anm_arm_r", "arm_r", func_end );
  end );
  SoundSfx( "aud_buttons" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_paperdove" ] = { type = "get", get_obj = "spr_snowman_paperdove", room = "rm_entrypoint", zz = "zz_snowman", zz_gate = "gzz_entrypoint_snowman" };

private.get_paperdove_logic = function()
  
end;
private.get_paperdove_inv = function()
  interface.InventoryItemAdd("inv_paperdove","spr_snowman_paperdove");
  ObjSet( "inv_paperdove", { drag = 0 } );
end;
private.get_paperdove_beg = function()
  ObjDelete("gfx_snowman_paperdove")
  ObjSet( "spr_snowman_paperdove", {visible = 1} );
  ObjSet( "anm_snowman_anm_arm_r", {animfunc = "arm_r1", frame = 0 } );
end;
private.get_paperdove_end = function()
  ObjDelete("spr_entrypoint_tr_paperdove")
  if common_impl.ZzCompleteCheck("get_paperdove") then ObjSet( common_impl.hint["get_paperdove"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_paperdove", private.get_paperdove_inv );
cmn.AddSubscriber( "get_paperdove", private.get_paperdove_beg, private.room_objname );
cmn.AddSubscriber( "get_paperdove", private.get_paperdove_end, private.room_objname );
cmn.AddSubscriber( "get_paperdove", private.get_paperdove_logic );
--------------------------------------------------------------------
function public.get_paperdove()
  cmn.SetEventDone( "get_paperdove" );
  cmn.CallEventHandler( "get_paperdove" );
  if common_impl.ZzCompleteCheck("get_paperdove") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_casket_for_entrypoint = function()
    if ld.CheckRequirements( {"win_casket"} ) then
      --ObjSet( "gmg_entrypoint_casket", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_casket", win_casket_for_entrypoint, private.room_objname )

end
--*********************************************************************************************************************

--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()
  private.opn_entrypoint();
  level.tutorial_question.first()
  level.tutorial_zz.first()
  --level.tutorial_cube.first()
  level.tutorial_task.first()
  level.tutorial_hint.first()
  level.tutorial_navigation.first()
  level.tutorial_deploy.first()
  level.tutorial_goody.first()
end;
--*********************************************************************************************************************
function public.PreOpen()
  if not ( cmn.IsEventDone( "opn_entrypoint" ) ) then
    private.SeeIntro();
  else
    SoundEnv( "aud_entrypoint_env" );
  end;
  
  
end;
--*********************************************************************************************************************
function public.Close()

end;
--*********************************************************************************************************************
function public.PreClose()

end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_snowman" );
  function zz_snowman.Open()
  end;
  function zz_snowman.PreOpen()
  end;
  function zz_snowman.PreClose()
  end;
  function zz_snowman.Close()
  end;

  subroom.Define( "zz_mailbox" );
  function zz_mailbox.Open()
  end;
  function zz_mailbox.PreOpen()
  end;
  function zz_mailbox.PreClose()
  end;
  function zz_mailbox.Close()
  end;

  subroom.Define( "zz_housedoor" );
  function zz_housedoor.Open()
  end;
  function zz_housedoor.PreOpen()
  end;
  function zz_housedoor.PreClose()
  end;
  function zz_housedoor.Close()
  end;

  subroom.Define( "zz_window" );
  function zz_window.Open()
    level.tutorial_goody_use.first()
  end;
  function zz_window.PreOpen()
  end;
  function zz_window.PreClose()
  end;
  function zz_window.Close()
  end;

  subroom.Define( "zz_case" );
  function zz_case.Open()
    level.tutorial_get.first()
  end;
  function zz_case.PreOpen()
  end;
  function zz_case.PreClose()
  end;
  function zz_case.Close()
  end;

end;

--*********************************************************************************************************************
-- function *** OTHER *** () end;
--*********************************************************************************************************************