-- name=rm_mansion
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_mansion";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  SoundEnvInit( "aud_alex_calls_chloe_env", private.room_objname, false, { "dlg_river_chloe2" } )
  --------------------------------------------------------------------------------------------
function private.opn_mansion()
  if not ( cmn.IsEventDone( "opn_mansion" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_mansion" );
      cmn.CallEventHandler( "opn_mansion" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_mansion = function() end;
local opn_mansion_logic = function() end;
cmn.AddSubscriber( "opn_mansion", opn_mansion_logic )
cmn.AddSubscriber( "opn_mansion", opn_mansion, private.room_objname )
--------------------------------------------------------------------------------------------


function public.SwitchFrase( dlg_name, count_txt )

  if dlg_name == "alex1" then-------------------------------------
    common_impl.continue_visible = true
    if count_txt == 1 then
      --ld.AnimPlay("anm_mansion_anim_alex1","static","")
      ld.AnimPlay("anm_mansion_anim_alex1","give_doll","")
    elseif count_txt == 2 then
      ObjSet( "spr_mansion_girlsdoll", {input = 1, visible = 1,active=1} );
      ld.AnimPlay( "anm_mansion_anim_alex1","hand_end", function() ld.AnimPlay( "anm_mansion_anim_alex1","static","")  end);
      cmn.CallEventHandler( "get_girlsdoll" );
    end
  elseif dlg_name == "alex2" then---------------------------------
    common_impl.continue_visible = true
    if count_txt == 1 then
      --ld.AnimPlay("anm_mansion_anim_alex2","static","")
      ld.AnimPlay("anm_mansion_anim_alex2","give_money","")
    elseif count_txt == 2 then  
      private.moneybag2_getting = true;
      ObjSet( "spr_mansion_moneybag2", {input = 1, visible = 1,active=1} );
      ld.AnimPlay( "anm_mansion_anim_alex2","hand_end", function() ld.AnimPlay( "anm_mansion_anim_alex2","static","")  end);
      cmn.CallEventHandler( "get_moneybag2" );
    end
  end
  
  
  
end

--------------------------------------------------------------------------------------------
common_impl.hint[ "use_alexnote" ] = { type = "use", inv_obj = "inv_alexnote", use_place = "gfx_mansion_alexnote_zone", room = "rm_mansion" };

private.use_alexnote_logic = function()
  ObjSet( "gfx_mansion_dlg_mansion_alex1_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_alexnote_inv = function()
  common_impl.ProcessMultiUseAll("alexnote", "alexnote")
end;
private.use_alexnote_beg = function()
  ObjDelete( "gfx_mansion_alexnote_zone" );
end;
private.use_alexnote_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_alexnote", private.use_alexnote_inv );
cmn.AddSubscriber( "use_alexnote", private.use_alexnote_beg, private.room_objname );
cmn.AddSubscriber( "use_alexnote", private.use_alexnote_end, private.room_objname );
cmn.AddSubscriber( "use_alexnote", private.use_alexnote_logic );
cmn.AddSubscriber( "use_alexnote_inv", private.use_alexnote_inv, private.room_objname );
cmn.AddSubscriber( "use_alexnote_beg", private.use_alexnote_beg, private.room_objname );
cmn.AddSubscriber( "use_alexnote_end", private.use_alexnote_end, private.room_objname );
cmn.AddSubscriber( "use_alexnote_end", private.use_alexnote_logic );
--------------------------------------------------------------------------------------------
function public.use_alexnote( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    
    cmn.SetEventDone( "get_girlsdoll" );
    
    cmn.SetEventDone( "use_alexnote" );
    cmn.CallEventHandler( "use_alexnote_end" );
    
    cmn.SetEventDone( "dlg_mansion_alex1" );
    cmn.CallEventHandler( "dlg_mansion_alex1" );
    
    --ld.ShowBbt("dlg_mansion_alex1_after");
    --SoundTheme( "aud_adventure_2_mus" )
    SoundEnv( "aud_alex_calls_chloe_env", 1 )
    
    ld.StartTimer( 1, function() ObjSet( "anm_mansion_anim_alex1", {animfunc=""}) end )
    
  end;

  
  function public.dlg_mansion_alex1_func_end()
    if ObjGetRelations( "inv_girlsdoll" ).parent == "level_inv_hub" then
      cmn.CallEventHandler( "get_girlsdoll" );
    end
    func_end();
  end
  
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_alexnote_inv" );
  cmn.CallEventHandler( "use_alexnote_beg" );

  SoundEnv( "aud_alex_calls_chloe_env", 0 )
  
  common_impl.dialog_character_loc = "anm_mansion_anim_alex_static";
  common_impl.Start( "alex1", 2, nil, nil, true, "dlg_mansion_alex1_func_end", {"aud_alex_1_voc"} );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_mansion_alex1" ] = { type = "click", use_place = "gfx_mansion_dlg_mansion_alex1_zone", room = "rm_mansion" };

private.dlg_mansion_alex1_logic = function()
  --ObjSet( "spr_mansion_girlsdoll", { visible = 1, input = 1, active = 1 } )
  --ObjSet( "gfx_mansion_dlg_mansion_alex2_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet("gzz_mansion_smallwindow",{ visible = 1, input = 1, active = 1 })
  ObjSet("gzz_mansion_burrow",{ visible = 1, input = 1, active = 1 })
  ObjSet("gzz_mansion_knight",{ visible = 1, input = 1, active = 1 })
  ObjSet("gzz_mansion_fencehole",{ visible = 1, input = 1, active = 1 })
end;
private.dlg_mansion_alex1_beg = function()
  ObjDelete( "gfx_mansion_dlg_mansion_alex1_zone" );
end;
private.dlg_mansion_alex1_end = function()
  ObjSet("obj_mansion_alexwait1",{input=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_mansion_alex1", private.dlg_mansion_alex1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_mansion_alex1", private.dlg_mansion_alex1_end, private.room_objname );
cmn.AddSubscriber( "dlg_mansion_alex1", private.dlg_mansion_alex1_logic );
cmn.AddSubscriber( "dlg_mansion_alex1_beg", private.dlg_mansion_alex1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_mansion_alex1_end", private.dlg_mansion_alex1_end, private.room_objname );
cmn.AddSubscriber( "dlg_mansion_alex1_end", private.dlg_mansion_alex1_logic );
--------------------------------------------------------------------------------------------
function public.dlg_mansion_alex1( obj )

  local func_end = function()
    cmn.SetEventDone( "dlg_mansion_alex1" );
    cmn.CallEventHandler( "dlg_mansion_alex1_end" );
    common_impl.Lock(0);
  end;

  cmn.CallEventHandler( "dlg_mansion_alex1_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_girlsdoll" ] = { type = "get", get_obj = "spr_mansion_girlsdoll", room = "rm_mansion" };

private.get_girlsdoll_logic = function()
  
end;
private.get_girlsdoll_inv = function()
  interface.InventoryItemAdd("inv_girlsdoll","spr_mansion_girlsdoll");
end;
private.get_girlsdoll_beg = function()
  ObjDelete("gfx_mansion_girlsdoll")
end;
private.get_girlsdoll_end = function()
  
end;

cmn.AddSubscriber( "get_girlsdoll", private.get_girlsdoll_inv );
cmn.AddSubscriber( "get_girlsdoll", private.get_girlsdoll_beg, private.room_objname );
cmn.AddSubscriber( "get_girlsdoll", private.get_girlsdoll_end, private.room_objname );
cmn.AddSubscriber( "get_girlsdoll", private.get_girlsdoll_logic );
--------------------------------------------------------------------
function public.get_girlsdoll()
  cmn.SetEventDone( "get_girlsdoll" );
  cmn.CallEventHandler( "get_girlsdoll" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_mansion_alex2" ] = { type = "click", use_place = "gfx_mansion_dlg_mansion_alex2_zone", room = "rm_mansion" };

private.dlg_mansion_alex2_logic = function()
  ObjSet( "spr_mansion_moneybag2", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_mansion_alex2_beg = function()
  ObjDelete( "gfx_mansion_dlg_mansion_alex2_zone" );
end;
private.dlg_mansion_alex2_end = function()
  ObjSet("anm_mansion_anim_alex_static", {animfunc="static2",playing=true} )
  ObjSet("anm_mansion_anim_loc_hloya",{visible=1,playing=true,animfunc="anim_hloya"})
  ObjDelete("obj_mansion_alexwait1");
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_mansion_alex2", private.dlg_mansion_alex2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_mansion_alex2", private.dlg_mansion_alex2_end, private.room_objname );
cmn.AddSubscriber( "dlg_mansion_alex2", private.dlg_mansion_alex2_logic );
cmn.AddSubscriber( "dlg_mansion_alex2_beg", private.dlg_mansion_alex2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_mansion_alex2_end", private.dlg_mansion_alex2_end, private.room_objname );
cmn.AddSubscriber( "dlg_mansion_alex2_end", private.dlg_mansion_alex2_logic );
--------------------------------------------------------------------------------------------
function public.dlg_mansion_alex2( obj )

  local func_end = function()
    cmn.SetEventDone( "dlg_mansion_alex2" );
    cmn.CallEventHandler( "dlg_mansion_alex2_end" );
    
    cmn.SetEventDone( "get_moneybag2" );
    
    --ld.ShowBbt("dlg_mansion_alex2_after");
    --SoundTheme( "aud_adventure_2_mus" )
    
    ld.StartTimer( 1, function() ObjSet( "anm_mansion_anim_alex2", {animfunc=""}) end )
      
      
  end;

  function public.dlg_mansion_alex2_func_end()
    --if ObjGetRelations( "inv_moneybag" ).parent == "level_inv_hub" then
    if not private.moneybag2_getting then
      cmn.CallEventHandler( "get_moneybag2" );
    end
    func_end();
  end
  
  cmn.CallEventHandler( "dlg_mansion_alex2_beg" );

  common_impl.dialog_character_loc = "anm_mansion_anim_alex_static";
  common_impl.Start( "alex2", 2, nil, nil, true, "dlg_mansion_alex2_func_end", {"aud_alex_2_voc"} );


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_moneybag2" ] = { type = "get", get_obj = "spr_mansion_moneybag2", room = "rm_mansion" };

private.get_moneybag2_logic = function()
  
end;
private.get_moneybag2_inv = function()
  interface.InventoryItemAdd("inv_moneybag","spr_mansion_moneybag2",function() level_inv.ProcessGetMoneybagAll( "get_moneybag2" ) end);
end;
private.get_moneybag2_beg = function()
  ObjDelete("gfx_mansion_moneybag2")
end;
private.get_moneybag2_end = function()
  
end;

cmn.AddSubscriber( "get_moneybag2", private.get_moneybag2_inv );
cmn.AddSubscriber( "get_moneybag2", private.get_moneybag2_beg, private.room_objname );
cmn.AddSubscriber( "get_moneybag2", private.get_moneybag2_end, private.room_objname );
cmn.AddSubscriber( "get_moneybag2", private.get_moneybag2_logic );
--------------------------------------------------------------------
function public.get_moneybag2()
  cmn.SetEventDone( "get_moneybag2" );
  cmn.CallEventHandler( "get_moneybag2" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_fencehole *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_floweronchain" ] = { type = "click", use_place = "gfx_fencehole_clk_floweronchain_zone", room = "rm_mansion", zz = "zz_fencehole", zz_gate = "gzz_mansion_fencehole" };

private.clk_floweronchain_logic = function()

end;
private.clk_floweronchain_beg = function()
  
end;
private.clk_floweronchain_end = function()
  if common_impl.ZzCompleteCheck("clk_floweronchain") then ObjSet( common_impl.hint["clk_floweronchain"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete( "gfx_fencehole_clk_floweronchain_zone" );
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_floweronchain", private.clk_floweronchain_beg, private.room_objname );
cmn.AddSubscriber( "clk_floweronchain", private.clk_floweronchain_end, private.room_objname );
cmn.AddSubscriber( "clk_floweronchain", private.clk_floweronchain_logic );
cmn.AddSubscriber( "clk_floweronchain_beg", private.clk_floweronchain_beg, private.room_objname );
cmn.AddSubscriber( "clk_floweronchain_end", private.clk_floweronchain_end, private.room_objname );
cmn.AddSubscriber( "clk_floweronchain_end", private.clk_floweronchain_logic );
--------------------------------------------------------------------------------------------
function public.clk_floweronchain()

  --local func_end = function()
  --  cmn.SetEventDone( "clk_floweronchain" );
  --  cmn.CallEventHandler( "clk_floweronchain_end" );
  --  common_impl.Lock(0);
  --  if common_impl.ZzCompleteCheck("clk_floweronchain") then ld.CloseSubRoom() end;
  --end;

  cmn.CallEventHandler( "clk_floweronchain_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( "##sfx##" )
  --func_end()
  if ObjGet("spr_note_init_black_back_poster") then
    ObjDelete("spr_note_init_black_back_poster")
  end
  ObjCreate( "spr_note_init_black_back_poster", "spr" )
    ObjSet( "spr_note_init_black_back_poster", { 
      visible=true;
      alp=0;
      input = true;
      res = "assets/interface/resources/editor_back";
      color_r = 0; color_g = 0; color_b = 0;
      scale_x = 1366; scale_y = 512;
      pos_x=0;
      pos_y=0;
      pos_z = 100;
      event_menter = function() ld.ShCur(CURSOR_HAND); end;
      event_mleave = function() ld.ShCur(CURSOR_DEFAULT); end;  
        event_mdown = function() private.hide_poster() end;
  } )
  ObjAttach( "spr_note_init_black_back_poster" , "zz_fencehole");
  ObjAnimate( "spr_note_init_black_back_poster", 8, 0, 0, "", {0,0,0,   0.5,0,0.5} );
  
  --ObjSet("gfx_fencehole_clk_floweronchain_zone",{input=0,visible=0})
  
  ObjAnimate( "spr_fencehole_floweronchain",  8, 0, 0, "", {0,0,1, 0.5,0,0} );
  
  
  ObjAnimate( "spr_fencehole_floweronchain_big", 6, 0, 0, "", {0,0,0.5,0.5, 0.5,0,1,1} );
  ObjAnimate( "spr_fencehole_floweronchain_big", 8, 0, 0, function() ld.Lock(0); end, {0,0,0, 0.5,0,1} );
  --SoundSfx( "aud_paperzoom_in" )
  
  
end;
--------------------------------------------------------------------------------------------
function private.hide_poster()
  
  ObjSet("spr_note_init_black_back_poster",{input=0})
  
  --SoundSfx( "aud_paperzoom_out" )
  ObjAnimate( "spr_note_init_black_back_poster", 8, 0, 0, function() ObjDelete("spr_note_init_black_back_poster"); end, {0,0,0.5, 0.5,0,0} );
  cmn.SetEventDone( "clk_floweronchain" );
  cmn.CallEventHandler( "clk_floweronchain" );
  
  public.get_floweronchain();
    
end
--------------------------------------------------------------------
common_impl.hint[ "get_floweronchain" ] = { type = "get", get_obj = "spr_fencehole_floweronchain", room = "rm_mansion", zz = "zz_fencehole", zz_gate = "gzz_mansion_fencehole" };

private.get_floweronchain_logic = function()
  ObjSet("gfx_fencehole_sled_zone",{active=1,input=1,visible=1})
end;
private.get_floweronchain_inv = function()
  interface.InventoryItemAdd("inv_floweronchain","spr_fencehole_floweronchain_big");
end;
private.get_floweronchain_beg = function()
  ObjDelete("gfx_fencehole_floweronchain")
end;
private.get_floweronchain_end = function()
  if common_impl.ZzCompleteCheck("get_floweronchain") then ObjSet( common_impl.hint["get_floweronchain"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_mansion_floweronchain")
  ObjDelete("spr_fencehole_floweronchain")
end;

cmn.AddSubscriber( "get_floweronchain", private.get_floweronchain_inv );
cmn.AddSubscriber( "get_floweronchain", private.get_floweronchain_beg, private.room_objname );
cmn.AddSubscriber( "get_floweronchain", private.get_floweronchain_end, private.room_objname );
cmn.AddSubscriber( "get_floweronchain", private.get_floweronchain_logic );
--------------------------------------------------------------------
function public.get_floweronchain()
  cmn.SetEventDone( "get_floweronchain" );
  cmn.CallEventHandler( "get_floweronchain" );
  if common_impl.ZzCompleteCheck("get_floweronchain") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_sled" ] = { type = "use", inv_obj = "inv_sled", use_place = "gfx_fencehole_sled_zone", room = "rm_mansion", zz = "zz_fencehole", zz_gate = "gzz_mansion_fencehole" };

private.use_sled_logic = function()
  ObjSet( "grm_mansion_river", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_mansion_river_focus");
    end;

end;
private.use_sled_inv = function()
  common_impl.ProcessMultiUseAll("sled", "sled")
end;
private.use_sled_beg = function()
  ObjDelete( "gfx_fencehole_sled_zone" );
end;
private.use_sled_end = function()
  if common_impl.ZzCompleteCheck("use_sled") then ObjSet( common_impl.hint["use_sled"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sled", private.use_sled_inv );
cmn.AddSubscriber( "use_sled", private.use_sled_beg, private.room_objname );
cmn.AddSubscriber( "use_sled", private.use_sled_end, private.room_objname );
cmn.AddSubscriber( "use_sled", private.use_sled_logic );
cmn.AddSubscriber( "use_sled_inv", private.use_sled_inv, private.room_objname );
cmn.AddSubscriber( "use_sled_beg", private.use_sled_beg, private.room_objname );
cmn.AddSubscriber( "use_sled_end", private.use_sled_end, private.room_objname );
cmn.AddSubscriber( "use_sled_end", private.use_sled_logic );
--------------------------------------------------------------------------------------------
function public.use_sled( obj )
  
  local func_end = function()
    int.DialogVideoHide();
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_sled" );
    cmn.CallEventHandler( "use_sled_end" );
    common_impl.Lock(0);
  end;

  
  local func_step_1 = function()        
     interface.DialogVideoSubtitleHide()
    --local torem1 = room_impl.VIA_BLACK_SCREEN;
    --local torem2 = room_impl.FADE_TIME;
    --room_impl.VIA_BLACK_SCREEN=false;
    --room_impl.FADE_TIME=0;
    ObjSet("rm_mansion",{color_r=0;color_g=0;color_b=0})
    cmn.GotoRoom( "rm_river" );
    --room_impl.VIA_BLACK_SCREEN=torem1;
    --room_impl.FADE_TIME=torem2;
    --ObjAnimate("spr_river_bread", 7, 0, 0, func_end, {0, 0, 0, 0.01, 0, 0});
    func_end()    
  end
  
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sled_inv" );
  cmn.CallEventHandler( "use_sled_beg" );
  
  
  ld.CloseSubRoom()
  SoundEnv( 0 )
  int.DialogVideoShow( "vid_mansion_move_to_the_river", 1, function() VidPause( "vid_mansion_move_to_the_river", 1 ); func_step_1() end, 1 );
  
  ObjAnimate( "vid_mansion_move_to_the_river", 7,0,0, function()
   --[[ 
    common_impl.VideoSubtitleVocStart( {
      { "srt_mansion_berta_1", aud_voc_false, 12, 16 };
    } );
    ]]
    SoundVoice( "aud_move_to_the_river_voc" );
    SoundVid( "aud_move_to_the_river" );
    VidPlay( "vid_mansion_move_to_the_river", func_step_1 )
  end, { 0,0,0, 0,0,0 } )
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_knight *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_rasp" ] = { type = "get", get_obj = "spr_knight_rasp", room = "rm_mansion", zz = "zz_knight", zz_gate = "gzz_mansion_knight" };

private.get_rasp_logic = function()
  
end;
private.get_rasp_inv = function()
  interface.InventoryItemAdd("inv_rasp","spr_knight_rasp");
end;
private.get_rasp_beg = function()
  ObjDelete("gfx_knight_rasp")
end;
private.get_rasp_end = function()
  if common_impl.ZzCompleteCheck("get_rasp") then ObjSet( common_impl.hint["get_rasp"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjDelete("spr_knight_rasp_sh")
end;

cmn.AddSubscriber( "get_rasp", private.get_rasp_inv );
cmn.AddSubscriber( "get_rasp", private.get_rasp_beg, private.room_objname );
cmn.AddSubscriber( "get_rasp", private.get_rasp_end, private.room_objname );
cmn.AddSubscriber( "get_rasp", private.get_rasp_logic );
--------------------------------------------------------------------
function public.get_rasp()
  cmn.SetEventDone( "get_rasp" );
  cmn.CallEventHandler( "get_rasp" );
  if common_impl.ZzCompleteCheck("get_rasp") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_knighthelm" ] = { type = "use", inv_obj = "inv_knighthelm", use_place = "gfx_knight_knighthelm_zone", room = "rm_mansion", zz = "zz_knight", zz_gate = "gzz_mansion_knight" };

private.use_knighthelm_logic = function()
  ObjSet("gho_mansion_knightho",{input=1,visible=1,active=1})
end;
private.use_knighthelm_inv = function()
  common_impl.ProcessMultiUseAll("knighthelm", "knighthelm")
end;
private.use_knighthelm_beg = function()
  ObjDelete( "gfx_knight_knighthelm_zone" );
end;
private.use_knighthelm_end = function()
  if common_impl.ZzCompleteCheck("use_knighthelm") then ObjSet( common_impl.hint["use_knighthelm"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_knight_anm",{frame=999})
  ObjSet("spr_mansion_knight_head",{visible=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_knighthelm", private.use_knighthelm_inv );
cmn.AddSubscriber( "use_knighthelm", private.use_knighthelm_beg, private.room_objname );
cmn.AddSubscriber( "use_knighthelm", private.use_knighthelm_end, private.room_objname );
cmn.AddSubscriber( "use_knighthelm", private.use_knighthelm_logic );
cmn.AddSubscriber( "use_knighthelm_inv", private.use_knighthelm_inv, private.room_objname );
cmn.AddSubscriber( "use_knighthelm_beg", private.use_knighthelm_beg, private.room_objname );
cmn.AddSubscriber( "use_knighthelm_end", private.use_knighthelm_end, private.room_objname );
cmn.AddSubscriber( "use_knighthelm_end", private.use_knighthelm_logic );
--------------------------------------------------------------------------------------------
function public.use_knighthelm( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_knighthelm" );
    cmn.CallEventHandler( "use_knighthelm_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_knighthelm") then ld.CloseSubRoom() end;
    --ld.StartTimer(0.5, function() common_impl.Gate_MDown( "gho_mansion_knightho" ) end)
    common_impl.Gate_MDown( "gho_mansion_knightho" )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_knighthelm_inv" );
  cmn.CallEventHandler( "use_knighthelm_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_knight_anm", "use_knighthelm", func_end );
  SoundSfx( "aud_helmet" )

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_burrow *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_anim" ] = { type = "click", use_place = "gfx_burrow_clk_anim_zone", room = "rm_mansion", zz = "zz_burrow", zz_gate = "gzz_mansion_burrow" };

private.clk_anim_logic = function()

end;
private.clk_anim_beg = function()
  ObjDelete( "gfx_burrow_clk_anim_zone" );
end;
private.clk_anim_end = function()
  if common_impl.ZzCompleteCheck("clk_anim") then ObjSet( common_impl.hint["clk_anim"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_burrow_anm_anim",{animfunc="static_anim",playing=true});
  ObjSet("gfx_burrow_bread_zone",{active=1,visible=1,input=1});
  ObjDelete("spr_mansion_crown");
  ObjSet("spr_mansion_mouse",{visible=1});
  ObjDelete("anm_mansion_anim_crow_fly")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_anim", private.clk_anim_beg, private.room_objname );
cmn.AddSubscriber( "clk_anim", private.clk_anim_end, private.room_objname );
cmn.AddSubscriber( "clk_anim", private.clk_anim_logic );
cmn.AddSubscriber( "clk_anim_beg", private.clk_anim_beg, private.room_objname );
cmn.AddSubscriber( "clk_anim_end", private.clk_anim_end, private.room_objname );
cmn.AddSubscriber( "clk_anim_end", private.clk_anim_logic );
--------------------------------------------------------------------------------------------
function public.clk_anim()

  local func_end = function()
    cmn.SetEventDone( "clk_anim" );
    cmn.CallEventHandler( "clk_anim_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_anim") then ld.CloseSubRoom() end;
    
  end;
  
  local func_step_2 = function()
    common_impl.Gate_MDown( "gzz_mansion_burrow" );
    ld.StartTimer(0.5,function()
      ld.AnimPlay("anm_burrow_anm_anim", "anim1", func_end)  
    end)
    
  end
  
  local func_step_1 = function()
    ObjSet("spr_mansion_mouse",{visible=1});
    ld.CloseSubRoom();    
    ld.StartTimer(0.5, function()
      ObjDelete("spr_mansion_crown")
      AnimPlay("anm_mansion_anim_crow_fly","crow_fly",func_step_2) 
    end )
    
  end
  
  
  cmn.CallEventHandler( "clk_anim_beg" );
  common_impl.Lock(1);
  
  private.anm_burrow_anm_anim_run = true;
  
  ld.AnimPlay( "anm_burrow_anm_anim", "anim", func_step_1 );
  SoundSfx( "aud_mouse_magpie" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bread" ] = { type = "use", inv_obj = "inv_bread", use_place = "gfx_burrow_bread_zone", room = "rm_mansion", zz = "zz_burrow", zz_gate = "gzz_mansion_burrow" };

private.use_bread_logic = function()
  ObjSet( "spr_burrow_emerald", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_burrow_magnet", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_burrow_button", { visible = 1, input = 1, active = 1 } )

end;
private.use_bread_inv = function()
  common_impl.ProcessMultiUseAll("bread", "bread")
end;
private.use_bread_beg = function()
  ObjDelete( "gfx_burrow_bread_zone" );
end;
private.use_bread_end = function()
  if common_impl.ZzCompleteCheck("use_bread") then ObjSet( common_impl.hint["use_bread"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_burrow_anm_anim",{frame=999,animfunc="use_bread"})
  ObjSet( "gfx_burrow_emerald",{ visible = 1, active = 1 } )
  ObjSet( "gfx_burrow_magnet", { visible = 1, active = 1 } )
  ObjSet( "gfx_burrow_button", { visible = 1, active = 1 } )
  ObjDelete("spr_mansion_mouse")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bread", private.use_bread_inv );
cmn.AddSubscriber( "use_bread", private.use_bread_beg, private.room_objname );
cmn.AddSubscriber( "use_bread", private.use_bread_end, private.room_objname );
cmn.AddSubscriber( "use_bread", private.use_bread_logic );
cmn.AddSubscriber( "use_bread_inv", private.use_bread_inv, private.room_objname );
cmn.AddSubscriber( "use_bread_beg", private.use_bread_beg, private.room_objname );
cmn.AddSubscriber( "use_bread_end", private.use_bread_end, private.room_objname );
cmn.AddSubscriber( "use_bread_end", private.use_bread_logic );
--------------------------------------------------------------------------------------------
function public.use_bread( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bread" );
    cmn.CallEventHandler( "use_bread_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bread") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bread_inv" );
  cmn.CallEventHandler( "use_bread_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_burrow_anm_anim", "use_bread", func_end );
  SoundSfx( "aud_bread" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_emerald" ] = { type = "get", get_obj = "spr_burrow_emerald", room = "rm_mansion", zz = "zz_burrow", zz_gate = "gzz_mansion_burrow" };

private.get_emerald_logic = function()
  
end;
private.get_emerald_inv = function()
  interface.InventoryItemAdd("inv_emerald","spr_burrow_emerald");
end;
private.get_emerald_beg = function()
  ObjDelete("gfx_burrow_emerald")
  ObjDelete("spr_burrow_emerald_tr")
end;
private.get_emerald_end = function()
  if common_impl.ZzCompleteCheck("get_emerald") then ObjSet( common_impl.hint["get_emerald"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_emerald", private.get_emerald_inv );
cmn.AddSubscriber( "get_emerald", private.get_emerald_beg, private.room_objname );
cmn.AddSubscriber( "get_emerald", private.get_emerald_end, private.room_objname );
cmn.AddSubscriber( "get_emerald", private.get_emerald_logic );
--------------------------------------------------------------------
function public.get_emerald()
  cmn.SetEventDone( "get_emerald" );
  cmn.CallEventHandler( "get_emerald" );
  if common_impl.ZzCompleteCheck("get_emerald") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_magnet" ] = { type = "get", get_obj = "spr_burrow_magnet", room = "rm_mansion", zz = "zz_burrow", zz_gate = "gzz_mansion_burrow" };

private.get_magnet_logic = function()
  
end;
private.get_magnet_inv = function()
  interface.InventoryItemAdd("inv_magnet","spr_burrow_magnet");
  ObjSet( "inv_magnet", { drag = 0 } );
end;
private.get_magnet_beg = function()
  ObjDelete("gfx_burrow_magnet")
  ObjDelete("spr_burrow_magnet_shtr")
end;
private.get_magnet_end = function()
  if common_impl.ZzCompleteCheck("get_magnet") then ObjSet( common_impl.hint["get_magnet"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_magnet", private.get_magnet_inv );
cmn.AddSubscriber( "get_magnet", private.get_magnet_beg, private.room_objname );
cmn.AddSubscriber( "get_magnet", private.get_magnet_end, private.room_objname );
cmn.AddSubscriber( "get_magnet", private.get_magnet_logic );
--------------------------------------------------------------------
function public.get_magnet()
  cmn.SetEventDone( "get_magnet" );
  cmn.CallEventHandler( "get_magnet" );
  if common_impl.ZzCompleteCheck("get_magnet") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_button" ] = { type = "get", get_obj = "spr_burrow_button", room = "rm_mansion", zz = "zz_burrow", zz_gate = "gzz_mansion_burrow" };

private.get_button_logic = function()
  
end;
private.get_button_inv = function()
  interface.InventoryItemAdd("inv_button","spr_burrow_button");
end;
private.get_button_beg = function()
  ObjDelete("gfx_burrow_button")
  ObjDelete("spr_burrow_button_tr")
end;
private.get_button_end = function()
  if common_impl.ZzCompleteCheck("get_button") then ObjSet( common_impl.hint["get_button"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_button", private.get_button_inv );
cmn.AddSubscriber( "get_button", private.get_button_beg, private.room_objname );
cmn.AddSubscriber( "get_button", private.get_button_end, private.room_objname );
cmn.AddSubscriber( "get_button", private.get_button_logic );
--------------------------------------------------------------------
function public.get_button()
  cmn.SetEventDone( "get_button" );
  cmn.CallEventHandler( "get_button" );
  if common_impl.ZzCompleteCheck("get_button") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_smallwindow *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_firtree" ] = { type = "use", inv_obj = "inv_firtree", use_place = "gfx_smallwindow_firtree_zone", room = "rm_mansion", zz = "zz_smallwindow", zz_gate = "gzz_mansion_smallwindow" };

private.use_firtree_logic = function()
  ObjSet( "gfx_smallwindow_elf_smallwindow_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_firtree_inv = function()
  common_impl.ProcessMultiUseAll("firtree", "firtree")
end;
private.use_firtree_beg = function()
  ObjDelete( "gfx_smallwindow_firtree_zone" );
end;
private.use_firtree_end = function()
  if common_impl.ZzCompleteCheck("use_firtree") then ObjSet( common_impl.hint["use_firtree"].zz_gate, { visible = 0, input = 0 } ); end;
  ObjSet("anm_smallwindow_anm_use_firtree",{animfunc="use_firtree",frame=999})
  ObjSet("anm_smallwindow_anm_light_open",{visible=true,playing=true})
  ObjDelete("anm_smallwindow_anm_light_window1");
  ObjSet("spr_mansion_open_window",{visible=1});
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_firtree", private.use_firtree_inv );
cmn.AddSubscriber( "use_firtree", private.use_firtree_beg, private.room_objname );
cmn.AddSubscriber( "use_firtree", private.use_firtree_end, private.room_objname );
cmn.AddSubscriber( "use_firtree", private.use_firtree_logic );
cmn.AddSubscriber( "use_firtree_inv", private.use_firtree_inv, private.room_objname );
cmn.AddSubscriber( "use_firtree_beg", private.use_firtree_beg, private.room_objname );
cmn.AddSubscriber( "use_firtree_end", private.use_firtree_end, private.room_objname );
cmn.AddSubscriber( "use_firtree_end", private.use_firtree_logic );
--------------------------------------------------------------------------------------------
function public.use_firtree( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_firtree" );
    cmn.CallEventHandler( "use_firtree_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_firtree") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_firtree_inv" );
  cmn.CallEventHandler( "use_firtree_beg" );
  common_impl.Lock(1);
  
  
  ObjAnimate("anm_smallwindow_anm_light_window1", 8, 0, 0, "", {0,0,1,  0.3,0,0});
  ld.AnimPlay( "anm_smallwindow_anm_use_firtree", "use_firtree", func_end );
  SoundSfx( "aud_christmastree" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_elf_smallwindow" ] = { type = "use", inv_obj = "obj_simon_cursor_drag", use_place = "gfx_smallwindow_elf_smallwindow_zone", room = "rm_mansion", zz = "zz_smallwindow", zz_gate = "gzz_mansion_smallwindow" };

private.use_elf_smallwindow_logic = function()
  ObjSet( "gmg_mansion_seedmg", { visible = 1, input = 1, active = 1 } )
  int_simon.SimonSetVisible(0)
end;
private.use_elf_smallwindow_inv = function()
  
  common_impl.ProcessMultiUseAll("elf", "elf_smallwindow")
end;
private.use_elf_smallwindow_beg = function()
  ObjDelete( "gfx_smallwindow_elf_smallwindow_zone" );
end;
private.use_elf_smallwindow_end = function()
  
  if common_impl.ZzCompleteCheck("use_elf_smallwindow") then ObjSet( common_impl.hint["use_elf_smallwindow"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_elf_smallwindow", private.use_elf_smallwindow_inv );
cmn.AddSubscriber( "use_elf_smallwindow", private.use_elf_smallwindow_beg, private.room_objname );
cmn.AddSubscriber( "use_elf_smallwindow", private.use_elf_smallwindow_end, private.room_objname );
cmn.AddSubscriber( "use_elf_smallwindow", private.use_elf_smallwindow_logic );
cmn.AddSubscriber( "use_elf_smallwindow_inv", private.use_elf_smallwindow_inv, private.room_objname );
cmn.AddSubscriber( "use_elf_smallwindow_beg", private.use_elf_smallwindow_beg, private.room_objname );
cmn.AddSubscriber( "use_elf_smallwindow_end", private.use_elf_smallwindow_end, private.room_objname );
cmn.AddSubscriber( "use_elf_smallwindow_end", private.use_elf_smallwindow_logic );
--------------------------------------------------------------------------------------------
function public.use_elf_smallwindow( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_elf_smallwindow" );
    cmn.CallEventHandler( "use_elf_smallwindow_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_elf_smallwindow") then ld.CloseSubRoom() end;
    ObjDelete("vid_smallwindow_vid_goody_enter_29")
    --ObjGet("gmg_mansion_seedmg").event_mdown();
    --ld.StartTimer( 0.5, function() common_impl.Gate_MDown( "gmg_mansion_seedmg" ) end);
    common_impl.Gate_MDown( "gmg_mansion_seedmg" )
  end;
  
  local func_step_1 = function() 
    ObjAttach("vid_smallwindow_vid_goody_enter_29","zz_smallwindow");
    VidPlay("vid_smallwindow_vid_goody_enter_29",func_end);
    SoundSfx( "aud_goody_enter_29" )
  end

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_elf_smallwindow_inv" );
  cmn.CallEventHandler( "use_elf_smallwindow_beg" );
  common_impl.Lock(1);

  

  interface.SimonJump(func_step_1)
  
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_seedmg_for_mansion = function()
    if ld.CheckRequirements( {"win_seedmg"} ) then
      ObjSet( "gmg_mansion_seedmg", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_seedmg", win_seedmg_for_mansion, private.room_objname )
  local win_knightho_for_mansion = function()
    if ld.CheckRequirements( {"win_knightho"} ) then
      ObjSet( "gho_mansion_knightho", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_knightho", win_knightho_for_mansion, private.room_objname )
  local win_elfho_for_mansion = function()
    if ld.CheckRequirements( {"win_elfho"} ) then
      ObjSet( "gfx_mansion_dlg_mansion_alex2_zone", {input = 1} );
    end
  end;
  cmn.AddSubscriber("win_elfho", win_elfho_for_mansion )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_mansion();
  if ld.CheckRequirements( {"dlg_river_chloe2"} ) and not ld.CheckRequirements( {"dlg_mansion_alex2"} )   then
    public.dlg_mansion_alex2()
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_mansion_env" )
  if ld.CheckRequirements( {"dlg_river_chloe2"} ) and not ld.CheckRequirements( {"dlg_mansion_alex2"} )   then
    ObjSet("anm_mansion_anim_loc_hloya",{visible=1})
    ObjDelete("obj_mansion_alexwait1");
  end
  ObjSet("rm_mansion",{color_r=1;color_g=1;color_b=1})
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_smallwindow" );
  function zz_smallwindow.Open()
  end;
  function zz_smallwindow.PreOpen()
  end;
  function zz_smallwindow.PreClose()
  end;
  function zz_smallwindow.Close()
  end;

  subroom.Define( "zz_burrow" );
  function zz_burrow.Open()
    if not ld.CheckRequirements( {"clk_anim"} ) and not private.anm_burrow_anm_anim_run then
      public.clk_anim()
    end
  end;
  function zz_burrow.PreOpen()
  end;
  function zz_burrow.PreClose()
  end;
  function zz_burrow.Close()
  end;

  subroom.Define( "zz_knight" );
  function zz_knight.Open()
  end;
  function zz_knight.PreOpen()
  end;
  function zz_knight.PreClose()
  end;
  function zz_knight.Close()
  end;

  subroom.Define( "zz_fencehole" );
  function zz_fencehole.Open()
  end;
  function zz_fencehole.PreOpen()
  end;
  function zz_fencehole.PreClose()
  end;
  function zz_fencehole.Close()
    if not ld.CheckRequirements( {"clk_floweronchain"} ) then
      ObjSet( "spr_fencehole_floweronchain_big", {alp=0} );
      ObjSet( "spr_fencehole_floweronchain", {alp=1} );
      if ObjGet("spr_note_init_black_back_poster") then
        ObjDelete("spr_note_init_black_back_poster")
      end
    end
  end;
  
end;
--*********************************************************************************************************************