-- name=rm_nearshop
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_nearshop";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_nearshop()
  if not ( cmn.IsEventDone( "opn_nearshop" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_nearshop" );
      cmn.CallEventHandler( "opn_nearshop" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_nearshop = function() end;
local opn_nearshop_logic = function() end;
cmn.AddSubscriber( "opn_nearshop", opn_nearshop_logic )
cmn.AddSubscriber( "opn_nearshop", opn_nearshop, private.room_objname )
--------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_shopdoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_garland" ] = { type = "get", get_obj = "spr_shopdoor_garland", room = "rm_nearshop", zz = "zz_shopdoor", zz_gate = "gzz_nearshop_shopdoor" };

private.get_garland_logic = function()

end;
private.get_garland_inv = function()
  interface.InventoryItemAdd("inv_garland","spr_shopdoor_garland");
  ObjSet( "inv_garland", { drag = 0 } );
end;
private.get_garland_beg = function()
  ObjDelete("gfx_shopdoor_garland")
end;
private.get_garland_end = function()
  ObjDelete("spr_shopdoor_garland_trash")
  ObjDelete("spr_shopdoor_garland_shadow")
  ObjDelete("spr_nearshop_garland")
  if common_impl.ZzCompleteCheck("get_garland") then ObjSet( common_impl.hint["get_garland"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_garland", private.get_garland_inv );
cmn.AddSubscriber( "get_garland", private.get_garland_beg, private.room_objname );
cmn.AddSubscriber( "get_garland", private.get_garland_end, private.room_objname );
cmn.AddSubscriber( "get_garland", private.get_garland_logic );
--------------------------------------------------------------------
function public.get_garland()
  cmn.SetEventDone( "get_garland" );
  cmn.CallEventHandler( "get_garland" );
  if common_impl.ZzCompleteCheck("get_garland") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_coalsscoop" ] = { type = "use", inv_obj = "inv_coalsscoop", use_place = "gfx_shopdoor_coalsscoop_zone", room = "rm_nearshop", zz = "zz_shopdoor", zz_gate = "gzz_nearshop_shopdoor" };

private.use_coalsscoop_logic = function()
  ObjSet( "gfx_shopdoor_clk_shopdoor_zone", {active = 1, input = 1, visible = 1} );
end;
private.use_coalsscoop_inv = function()
  common_impl.ProcessMultiUseAll("coalsscoop", "coalsscoop")
end;
private.use_coalsscoop_beg = function()
  ObjDelete( "gfx_shopdoor_coalsscoop_zone" );
end;
private.use_coalsscoop_end = function()
  ObjDelete("spr_nearshop_ice_trash")
  ObjSet( "anm_shopdoor_anm_door", {animfunc = "open_door", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_coalsscoop") then ObjSet( common_impl.hint["use_coalsscoop"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_coalsscoop", private.use_coalsscoop_inv );
cmn.AddSubscriber( "use_coalsscoop", private.use_coalsscoop_beg, private.room_objname );
cmn.AddSubscriber( "use_coalsscoop", private.use_coalsscoop_end, private.room_objname );
cmn.AddSubscriber( "use_coalsscoop", private.use_coalsscoop_logic );
cmn.AddSubscriber( "use_coalsscoop_inv", private.use_coalsscoop_inv, private.room_objname );
cmn.AddSubscriber( "use_coalsscoop_beg", private.use_coalsscoop_beg, private.room_objname );
cmn.AddSubscriber( "use_coalsscoop_end", private.use_coalsscoop_end, private.room_objname );
cmn.AddSubscriber( "use_coalsscoop_end", private.use_coalsscoop_logic );
--------------------------------------------------------------------------------------------
function public.use_coalsscoop( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_coalsscoop" );
    cmn.CallEventHandler( "use_coalsscoop_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_coalsscoop") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_coalsscoop_inv" );
  cmn.CallEventHandler( "use_coalsscoop_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_shopdoor_anm_door", "use_scoop", func_end );
  SoundSfx( "aud_coal_scoop" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_shopdoor" ] = { type = "click", use_place = "gfx_shopdoor_clk_shopdoor_zone", room = "rm_nearshop", zz = "zz_shopdoor", zz_gate = "gzz_nearshop_shopdoor" };

private.clk_shopdoor_logic = function()
  ObjSet( "grm_nearshop_shop", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_nearshop_shop_focus");
    end;
end;
private.clk_shopdoor_beg = function()
  ObjDelete( "gfx_shopdoor_clk_shopdoor_zone" );
end;
private.clk_shopdoor_end = function()
  ObjSet( "anm_shopdoor_anm_door", {animfunc = "open_door", frame = 999 } );
  ObjSet( "anm_nearshop_anm_door", {animfunc = "door_open", frame = 999 } );
  if common_impl.ZzCompleteCheck("clk_shopdoor") then ObjSet( common_impl.hint["clk_shopdoor"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_shopdoor", private.clk_shopdoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_shopdoor", private.clk_shopdoor_end, private.room_objname );
cmn.AddSubscriber( "clk_shopdoor", private.clk_shopdoor_logic );
cmn.AddSubscriber( "clk_shopdoor_beg", private.clk_shopdoor_beg, private.room_objname );
cmn.AddSubscriber( "clk_shopdoor_end", private.clk_shopdoor_end, private.room_objname );
cmn.AddSubscriber( "clk_shopdoor_end", private.clk_shopdoor_logic );
--------------------------------------------------------------------------------------------
function public.clk_shopdoor()

  local func_end = function()
    cmn.SetEventDone( "clk_shopdoor" );
    cmn.CallEventHandler( "clk_shopdoor_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_shopdoor") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_shopdoor_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_shopdoor_anm_door", "open_door", function() 
    ld.CloseSubRoom()
    ld.AnimPlay( "anm_nearshop_anm_door", "door_open", function()  
      func_end()
    end); 
  end);
  SoundSfx( "aud_open_door_to_shop" )

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_icecastle *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_snowqueen" ] = { type = "use", inv_obj = "inv_snowqueen", use_place = "gfx_icecastle_snowqueen_zone", room = "rm_nearshop", zz = "zz_icecastle", zz_gate = "gzz_nearshop_icecastle" };

private.use_snowqueen_logic = function()
  ObjSet( "gfx_icecastle_win_icecastle_zone", { input = 1, active = 1 } );
  ld.mmgZoomInit("win_icecastle");
end;
private.use_snowqueen_inv = function()
  common_impl.ProcessMultiUseAll("snowqueen", "snowqueen")
end;
private.use_snowqueen_beg = function()
  ObjDelete( "gfx_icecastle_snowqueen_zone" );
end;
private.use_snowqueen_end = function()
  ObjSet( "spr_nearshop_snow_queen", {visible = 1} );
  ObjSet( "anm_icecastle_anm_snowqueen", {animfunc = "use_snow_queen", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_snowqueen") then ObjSet( common_impl.hint["use_snowqueen"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_snowqueen", private.use_snowqueen_inv );
cmn.AddSubscriber( "use_snowqueen", private.use_snowqueen_beg, private.room_objname );
cmn.AddSubscriber( "use_snowqueen", private.use_snowqueen_end, private.room_objname );
cmn.AddSubscriber( "use_snowqueen", private.use_snowqueen_logic );
cmn.AddSubscriber( "use_snowqueen_inv", private.use_snowqueen_inv, private.room_objname );
cmn.AddSubscriber( "use_snowqueen_beg", private.use_snowqueen_beg, private.room_objname );
cmn.AddSubscriber( "use_snowqueen_end", private.use_snowqueen_end, private.room_objname );
cmn.AddSubscriber( "use_snowqueen_end", private.use_snowqueen_logic );
--------------------------------------------------------------------------------------------
function public.use_snowqueen( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_snowqueen" );
    cmn.CallEventHandler( "use_snowqueen_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_snowqueen") then ld.CloseSubRoom() end;
    public.win_icecastle_load()
    ObjAttach("obj_icecastle_mmg_hud","int_frame_subroom_impl")
    ObjGet( "gfx_icecastle_win_icecastle_zone" ).event_mdown();  
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_snowqueen_inv" );
  cmn.CallEventHandler( "use_snowqueen_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_icecastle_anm_snowqueen", "use_snow_queen", func_end );
  SoundSfx( "aud_snow_queen" )

end;
--------------------------------------------------------------------------------------------
function public.win_icecastle_load(reset,skip)
  local begstate = {1}--   |     |                   |     |              |     |               |           |                   |            |
  local anims = {"use_boot","go1",         "use_acid","go2", "give_letter","go3",     "use_coat","use_coat1","use_rose",    "use_key","end"}
  local statics={false,     false,"bloom_agro_static",false,"guard_static",false,"bandit_static",      false,     false,"boy_static1",false} 
  local drops = {"boot",    false,             "acid",false,      "letter",false,         "coat",      false,    "rose",        "key",false}
  local light = {2,4,8}
  local anims2= { [10] = "rose_static"}
  local rooms = { {[1] = "room1",[2] ="",[4]="dead_bloom_static"},
                  {[1] = "room2",[4] ="",[6]="guard_static2"},
                  {[1] = "room3",[6] ="",[8]="bandit_static2"},
                  {[1] = "room4",[8] =""}
                }    

  local sfx   = {
    "aud_use_shoes";
    "aud_gerda_moves";
    "aud_use_acid";
    "aud_gerda_moves1";
    "aud_give_letter";
    "aud_gerda_moves2";
    "aud_use_coat";
    "aud_gerda_moves3";
    "aud_use_rose";
    "aud_release_kay";
  }

  local winstate = {#anims}
  local obj = "anm_icecastle_anm_mmg"
  local obj2 = "anm_icecastle_anm_mmg_2"
  if not ng_global.progress["std"]["win_icecastle"].state or reset then
    ng_global.progress["std"]["win_icecastle"].state = ld.TableCopy(begstate)
  end

  local function load_map(skip)
    local toload = skip and winstate or ng_global.progress["std"]["win_icecastle"].state
    local anim = statics[ toload[1] ] or anims[ toload[1] ]
    ObjSet( obj, {animfunc = anim, frame = 0, playing = statics[ toload[1] ] and true or false } );
    if anims2[ toload[1] ] then
      ObjSet( obj2, {animfunc = anims2[ toload[1] ], frame = 0 } );  
    end    
    for i,o in ipairs(rooms) do
      local anim = ""
      for j = 1,toload[1] do
        if o[j] then anim = o[j] end
      end
      ObjSet( "anm_icecastle_anm_mmg_room_"..i, {animfunc = anim, frame = 0 } );
    end
    for i,o in ipairs(drops) do
      if o then
        if i >= toload[1] then
          ObjSet( "spr_icecastle_"..o.."_inv", {input = 1, visible = 1} );
        else
          ObjSet( "spr_icecastle_"..o.."_inv", {input = 0, visible = 0} );
        end
      end
    end
    for i,o in ipairs(light) do
      if o == toload[1] then
        ObjSet( "anm_icecastle_anm_mmg_light_"..i, {playing = 1, visible = 1, alp = 1} );
      else
        ObjSet( "anm_icecastle_anm_mmg_light_"..i, {playing = 0, visible = 0, alp = 0} );
      end
    end
  end

  --wincheck
  local prevstate
  local function wincheck(skip)
    local function win()
      public.win_icecastle()
    end
    if ld.TableEquals(ng_global.progress["std"]["win_icecastle"].state,winstate) or skip then
      if not skip then
        ng_global.progress["std"]["win_icecastle"].state = ld.TableCopy(prevstate)
      end
      ld.Lock(1)
      win()
    end
  end

  --load
  local function load(skip)
    load_map(skip)
  end
  local function chooseload(reset,skip)
    if reset or skip then
      local toload = skip and winstate or begstate
      local time = 1
      --ld.Lock(1)
      ObjSet( obj, {animfunc = anims[ toload[1] ], frame = 0 } );
      load(skip) wincheck(skip) 
      --ld.StartTimer( time, function() load(skip) wincheck(skip)  end )
    else
      load()
    end
  end
  chooseload(reset,skip)
  --save
  local function save()
    prevstate = ld.TableCopy(ng_global.progress["std"]["win_icecastle"].state)
    ng_global.progress["std"]["win_icecastle"].state[1] = ng_global.progress["std"]["win_icecastle"].state[1] + 1

    local state = ng_global.progress["std"]["win_icecastle"].state
    local anim = statics[ state[1] ] or anims[ state[1] ]
    ObjSet( obj, {animfunc = anim, frame = 0, playing = statics[ state[1] ] and true or false } );
    if anims2[ state[1] ] then
      ObjSet( obj2, {animfunc = anims2[ state[1] ], frame = 0 } );  
    end
    for i,o in ipairs(rooms) do
      local anim = ""
      for j = 1,state[1] do
        if o[j] then anim = o[j] end
      end
      ObjSet( "anm_icecastle_anm_mmg_room_"..i, {animfunc = anim, frame = 0 } );
    end
    for i,o in ipairs(light) do
      if o == state[1] then
        ObjSet( "anm_icecastle_anm_mmg_light_"..i, {playing = 1, visible = 1, alp = 1} );
      else
        ObjSet( "anm_icecastle_anm_mmg_light_"..i, {playing = 0, visible = 0, alp = 0} );
      end
    end
    wincheck()
  end  

  --public
  function public.win_icecastle_menter(sender)
    ld.ShCur(CURSOR_GET)
  end
  function public.win_icecastle_mleave(sender)
    ld.ShCur(CURSOR_DEFAULT)
  end
  function public.win_icecastle_startdrag(sender)
    ObjSet( sender, {pos_z = 1} );
    --SoundSfx( "aud_get" )
  end
  function public.win_icecastle_click()
    local state = ng_global.progress["std"]["win_icecastle"].state[1]
    if not drops[state] then
      ld.Lock(1)

      for i,o in ipairs(light) do
        if o == state then
          ObjAnimate( "anm_icecastle_anm_mmg_light_"..i, 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
        end
      end
      SoundSfx( sfx[ state ] )
      ld.AnimPlay( obj, anims[ state ], function() ld.Lock(0) save() end )
    end
  end
  function public.win_icecastle_dragdrop(sender)
    ObjSet( sender, {pos_z = 0} );
    if ApplyObj(sender,"spr_icecastle_backmmg") then
      local state = ng_global.progress["std"]["win_icecastle"].state[1]
      if sender == "spr_icecastle_"..(drops[state] or "").."_inv" then
        ObjSet( sender, {input = 0, visible = 0} );
        ld.Lock(1)
        if anims[ state ] then
          SoundSfx( sfx[ state ] )
          ld.AnimPlay( obj, anims[ state ], function() ld.Lock(0) save() end )
        else
          SoundSfx( sfx[ state ] )
          ld.AnimPlay( obj2, anims2[ state ], function() ld.Lock(0) save() end )
        end
      end
    else
      --SoundSfx( "aud_put" )
    end
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_icecastle" ] = { type = "click", use_place = "gfx_icecastle_win_icecastle_zone", room = "rm_nearshop", zz = "zz_icecastle", zz_gate = "gzz_nearshop_icecastle" };

private.win_icecastle_logic = function()
  if ld.CheckRequirements( {"win_icecastle"} ) then
  ObjSet( "spr_icecastle_ironbowl", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_icecastle_beg = function()
  if ld.CheckRequirements( {"win_icecastle"} ) then
  ObjDelete( "gfx_icecastle_win_icecastle_zone" );
  end
end;
private.win_icecastle_end = function()
  if ld.CheckRequirements( {"win_icecastle"} ) then
    ObjDelete("spr_nearshop_snow_queen")
    ObjSet( "spr_nearshop_snow_queen_dead_trash", {visible = 1} );
    ObjSet( "spr_nearshop_ironbowl", {visible = 1} );
    ObjSet( "spr_icecastle_ironbowl_shadow", {visible = 1} );
    ObjSet( "anm_icecastle_anm_snowqueen", {animfunc = "mmg_win", frame = 0 } );
  if common_impl.ZzCompleteCheck("win_icecastle") then ObjSet( common_impl.hint["win_icecastle"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_icecastle", private.win_icecastle_beg, private.room_objname );
cmn.AddSubscriber( "win_icecastle", private.win_icecastle_end, private.room_objname );
cmn.AddSubscriber( "win_icecastle", private.win_icecastle_logic );
cmn.AddSubscriber( "win_icecastle_beg", private.win_icecastle_beg, private.room_objname );
cmn.AddSubscriber( "win_icecastle_end", private.win_icecastle_end, private.room_objname );
cmn.AddSubscriber( "win_icecastle_end", private.win_icecastle_logic );
--------------------------------------------------------------------------------------------
function public.win_icecastle()
  
  local func_end = function()
    cmn.MiniGameHide( "icecastle", true );
    ObjGet( "obj_icecastle_win_icecastle_zoom" ).event_mdown()
    cmn.SetEventDone( "win_icecastle" );
    cmn.CallEventHandler( "win_icecastle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_icecastle") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()

    ld.AnimPlay( "anm_icecastle_anm_mmg_dead", "queen_dead", func_end )
    --func_end()
  end
  ObjSet( "obj_icecastle_mmg_hud", {input = 0} );
  ObjSet("obj_icecastle_mmg_hud",{ alp = 0});
  --ObjAnimate( "obj_icecastle_mmg_hud", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
  cmn.CallEventHandler( "win_icecastle_beg" );
  ObjDelete( "gfx_icecastle_win_icecastle_zone" );
  common_impl.Lock(1);
  ObjSet( "anm_icecastle_anm_mmg_dead", {visible = 1} );
  ld.AnimPlay( "anm_icecastle_anm_mmg", "end", func_end_2 );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ironbowl" ] = { type = "get", get_obj = "spr_icecastle_ironbowl", room = "rm_nearshop", zz = "zz_icecastle", zz_gate = "gzz_nearshop_icecastle" };

private.get_ironbowl_logic = function()
  
end;
private.get_ironbowl_inv = function()
  interface.InventoryItemAdd("inv_ironbowl","spr_icecastle_ironbowl");
end;
private.get_ironbowl_beg = function()
  ObjDelete("gfx_icecastle_ironbowl")
  ObjDelete("spr_icecastle_ironbowl_shadow")
end;
private.get_ironbowl_end = function()
  ObjDelete("spr_nearshop_ironbowl")
  if common_impl.ZzCompleteCheck("get_ironbowl") then ObjSet( common_impl.hint["get_ironbowl"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_ironbowl", private.get_ironbowl_inv );
cmn.AddSubscriber( "get_ironbowl", private.get_ironbowl_beg, private.room_objname );
cmn.AddSubscriber( "get_ironbowl", private.get_ironbowl_end, private.room_objname );
cmn.AddSubscriber( "get_ironbowl", private.get_ironbowl_logic );
--------------------------------------------------------------------
function public.get_ironbowl()
  cmn.SetEventDone( "get_ironbowl" );
  cmn.CallEventHandler( "get_ironbowl" );
  if common_impl.ZzCompleteCheck("get_ironbowl") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_rasp_icecastle" ] = { type = "use", inv_obj = "inv_rasp", use_place = "gfx_icecastle_rasp_icecastle_zone", room = "rm_nearshop", zz = "zz_icecastle", zz_gate = "gzz_nearshop_icecastle" };

private.use_rasp_icecastle_logic = function()
  ObjSet( "spr_icecastle_figurmaster", { visible = 1, input = 1, active = 1 } )

end;
private.use_rasp_icecastle_inv = function()
  common_impl.ProcessMultiUseAll("rasp", "rasp_icecastle")
end;
private.use_rasp_icecastle_beg = function()
  ObjDelete( "gfx_icecastle_rasp_icecastle_zone" );
end;
private.use_rasp_icecastle_end = function()
  ObjDelete("anm_icecastle_anm")
  if common_impl.ZzCompleteCheck("use_rasp_icecastle") then ObjSet( common_impl.hint["use_rasp_icecastle"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_rasp_icecastle", private.use_rasp_icecastle_inv );
cmn.AddSubscriber( "use_rasp_icecastle", private.use_rasp_icecastle_beg, private.room_objname );
cmn.AddSubscriber( "use_rasp_icecastle", private.use_rasp_icecastle_end, private.room_objname );
cmn.AddSubscriber( "use_rasp_icecastle", private.use_rasp_icecastle_logic );
cmn.AddSubscriber( "use_rasp_icecastle_inv", private.use_rasp_icecastle_inv, private.room_objname );
cmn.AddSubscriber( "use_rasp_icecastle_beg", private.use_rasp_icecastle_beg, private.room_objname );
cmn.AddSubscriber( "use_rasp_icecastle_end", private.use_rasp_icecastle_end, private.room_objname );
cmn.AddSubscriber( "use_rasp_icecastle_end", private.use_rasp_icecastle_logic );
--------------------------------------------------------------------------------------------
function public.use_rasp_icecastle( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_rasp_icecastle" );
    cmn.CallEventHandler( "use_rasp_icecastle_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_rasp_icecastle") then ld.CloseSubRoom() end;
    public.get_figurmaster()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_rasp_icecastle_inv" );
  cmn.CallEventHandler( "use_rasp_icecastle_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_icecastle_anm", "use_rasp", func_end );
  SoundSfx( "aud_file" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_figurmaster" ] = { type = "get", get_obj = "spr_icecastle_figurmaster", room = "rm_nearshop", zz = "zz_icecastle", zz_gate = "gzz_nearshop_icecastle" };

private.get_figurmaster_logic = function()
  
end;
private.get_figurmaster_inv = function()
  interface.InventoryItemAdd("inv_figurmaster","spr_icecastle_figurmaster");
end;
private.get_figurmaster_beg = function()
  ObjDelete("gfx_icecastle_figurmaster")
end;
private.get_figurmaster_end = function()
  ObjDelete("spr_nearshop_figurmaster")
  if common_impl.ZzCompleteCheck("get_figurmaster") then ObjSet( common_impl.hint["get_figurmaster"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_figurmaster", private.get_figurmaster_inv );
cmn.AddSubscriber( "get_figurmaster", private.get_figurmaster_beg, private.room_objname );
cmn.AddSubscriber( "get_figurmaster", private.get_figurmaster_end, private.room_objname );
cmn.AddSubscriber( "get_figurmaster", private.get_figurmaster_logic );
--------------------------------------------------------------------
function public.get_figurmaster()
  cmn.SetEventDone( "get_figurmaster" );
  cmn.CallEventHandler( "get_figurmaster" );
  if common_impl.ZzCompleteCheck("get_figurmaster") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_icecastle" ) then
    public.win_icecastle_load(1)
  end

end;
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
    
  if ( mg_name == "zz_icecastle" ) then
    public.win_icecastle_load(nil,1)
  end

end;

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_nearshop();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_nearshop_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_icecastle" );
  function zz_icecastle.Open()
  end;
  function zz_icecastle.PreOpen()
    if ld.CheckRequirements( {"use_snowqueen"} ) and not ld.CheckRequirements( {"win_icecastle"} ) then
      ObjSet("obj_icecastle_win_icecastle_zoom",{ visible = true, alp = 1 });
      public.win_icecastle_load();
      ObjAttach("obj_icecastle_mmg_hud","int_frame_subroom_impl");
      ObjGet( "gfx_icecastle_win_icecastle_zone" ).event_mdown();
    end    
  end;
  function zz_icecastle.PreClose()
  end;
  function zz_icecastle.Close()
    ObjDetach("obj_icecastle_mmg_hud")
  end;

  subroom.Define( "zz_shopdoor" );
  function zz_shopdoor.Open()
  end;
  function zz_shopdoor.PreOpen()
  end;
  function zz_shopdoor.PreClose()
  end;
  function zz_shopdoor.Close()
  end;
  
end;
--*********************************************************************************************************************