-- name=rm_newyard
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_newyard";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  SoundEnvInit( "aud_fountain_env", "rm_newyard", { "use_shell" } )
  SoundEnvInit( "aud_zz_fountain_env", "zz_fountain", { "use_shell" } )
  SoundEnvInit( "aud_candle_env", "zz_lantern", { "use_mosaicbow" } )
  --------------------------------------------------------------------------------------------
function private.opn_newyard()
  if not ( cmn.IsEventDone( "opn_newyard" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_newyard" );
      cmn.CallEventHandler( "opn_newyard" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_newyard = function() end;
local opn_newyard_logic = function() end;
cmn.AddSubscriber( "opn_newyard", opn_newyard_logic )
cmn.AddSubscriber( "opn_newyard", opn_newyard, private.room_objname )
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "abigail1" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    elseif count_txt == 2 then
      common_impl.continue_visible = true
      ld.AnimPlay( "anm_newyard_abigail1", "give_key", "" )
    elseif count_txt == 3 then 
      ld.AnimPlay( "anm_newyard_abigail1", "give_end", "" )
      cmn.CallEventHandler( "get_housekey" );
      --common_impl.continue_visible = true
    --elseif count_txt == 4 then
    --  common_impl.continue_visible = true
    end
  elseif dlg_name == "abigail2" then
    if count_txt == 1 then
      common_impl.continue_visible = true
      ld.AnimPlay( "anm_newyard_abigail2", "give_photo", "" )
    elseif count_txt == 2 then 
      ld.AnimPlay( "anm_newyard_abigail2", "give_end", function() ld.AnimPlay( "anm_newyard_abigail2", "give_map", "" ) end )
      cmn.CallEventHandler( "get_oldphoto" );
    elseif count_txt == 3 then 
      ld.AnimPlay( "anm_newyard_abigail2", "give_end", "" )
      cmn.CallEventHandler( "get_map" );
    elseif count_txt == 4 then
      common_impl.continue_visible = true
    end
  elseif dlg_name == "abigail3" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    elseif count_txt == 2 then
      common_impl.continue_visible = true
    elseif count_txt == 3 then
    end
  elseif dlg_name == "jack" then
    if count_txt == 1 then
      common_impl.continue_visible = true
      ObjAnimate( "anm_newyard_jack_ball", 8, 0, 0, function()
        ld.AnimPlay( "anm_newyard_jack_ball", "family", "" );  
      end, {0,0,0, 0.5,0,1} );
    elseif count_txt == 2 then
    end
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_newyard_abigail31" ] = { type = "click", use_place = "gfx_newyard_dlg_newyard_abigail31_zone", room = "rm_newyard" };

private.dlg_newyard_abigail31_logic = function()
  ObjSet( "spr_newyard_housekey", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_newyard_fullcasket_zone", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_newyard_abigail31_beg = function()
  ObjDelete( "gfx_newyard_dlg_newyard_abigail31_zone" );
end;
private.dlg_newyard_abigail31_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_newyard_abigail31", private.dlg_newyard_abigail31_beg, private.room_objname );
cmn.AddSubscriber( "dlg_newyard_abigail31", private.dlg_newyard_abigail31_end, private.room_objname );
cmn.AddSubscriber( "dlg_newyard_abigail31", private.dlg_newyard_abigail31_logic );
cmn.AddSubscriber( "dlg_newyard_abigail31_beg", private.dlg_newyard_abigail31_beg, private.room_objname );
cmn.AddSubscriber( "dlg_newyard_abigail31_end", private.dlg_newyard_abigail31_end, private.room_objname );
cmn.AddSubscriber( "dlg_newyard_abigail31_end", private.dlg_newyard_abigail31_logic );
--------------------------------------------------------------------------------------------
function public.dlg_newyard_abigail31( obj )

  local func_end = function()
    cmn.SetEventDone( "get_housekey" );
    cmn.SetEventDone( "dlg_newyard_abigail31" );
    cmn.CallEventHandler( "dlg_newyard_abigail31_end" );
    ld.ShowBbt( "after_dlg_newyard_abigail31" )
    common_impl.Lock(0);
  end;
  function public.dlg_newyard_abigail31_func_end()
    common_impl.Lock(1);
    if ObjGetRelations( "inv_housekey" ).parent == "level_inv_hub" then
      cmn.CallEventHandler( "get_housekey" );
    end  
    func_end()
  end

  cmn.CallEventHandler( "dlg_newyard_abigail31_beg" );
  common_impl.dialog_character_loc = "obj_newyard_abigail_root";
  common_impl.Start( "abigail1", 3, nil, nil, true, "dlg_newyard_abigail31_func_end", { "aud_abigail_1_voc", "aud_abigail_2_voc" } );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_housekey" ] = { type = "get", get_obj = "spr_newyard_housekey", room = "rm_newyard" };

private.get_housekey_logic = function()
  
end;
private.get_housekey_inv = function()
  interface.InventoryItemAdd("inv_housekey","spr_newyard_housekey");
end;
private.get_housekey_beg = function()
  ObjDelete("gfx_newyard_housekey")
  ObjSet( "spr_newyard_housekey", {visible = 1} );
end;
private.get_housekey_end = function()
  
end;

cmn.AddSubscriber( "get_housekey", private.get_housekey_inv );
cmn.AddSubscriber( "get_housekey", private.get_housekey_beg, private.room_objname );
cmn.AddSubscriber( "get_housekey", private.get_housekey_end, private.room_objname );
cmn.AddSubscriber( "get_housekey", private.get_housekey_logic );
--------------------------------------------------------------------
function public.get_housekey()
  cmn.SetEventDone( "get_housekey" );
  cmn.CallEventHandler( "get_housekey" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------

common_impl.hint[ "use_fullcasket" ] = { type = "use", inv_obj = "inv_fullcasket", use_place = "gfx_newyard_fullcasket_zone", room = "rm_newyard" };

private.use_fullcasket_logic = function()
  ObjSet( "gfx_newyard_dlg_newyard_abigail32_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_fullcasket_inv = function()
  common_impl.ProcessMultiUseAll("fullcasket", "fullcasket")
end;
private.use_fullcasket_beg = function()
  ObjDelete( "gfx_newyard_fullcasket_zone" );
end;
private.use_fullcasket_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fullcasket", private.use_fullcasket_inv );
cmn.AddSubscriber( "use_fullcasket", private.use_fullcasket_beg, private.room_objname );
cmn.AddSubscriber( "use_fullcasket", private.use_fullcasket_end, private.room_objname );
cmn.AddSubscriber( "use_fullcasket", private.use_fullcasket_logic );
cmn.AddSubscriber( "use_fullcasket_inv", private.use_fullcasket_inv, private.room_objname );
cmn.AddSubscriber( "use_fullcasket_beg", private.use_fullcasket_beg, private.room_objname );
cmn.AddSubscriber( "use_fullcasket_end", private.use_fullcasket_end, private.room_objname );
cmn.AddSubscriber( "use_fullcasket_end", private.use_fullcasket_logic );
--------------------------------------------------------------------------------------------
function public.use_fullcasket( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    
    cmn.CallEventHandler( "use_fullcasket_end" );
    common_impl.Lock(0);
    public.dlg_newyard_abigail32( obj )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fullcasket_inv" );
  cmn.CallEventHandler( "use_fullcasket_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( "aud_use_fullcasket_newyard" )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_newyard_abigail32" ] = { type = "click", use_place = "gfx_newyard_dlg_newyard_abigail32_zone", room = "rm_newyard" };

private.dlg_newyard_abigail32_logic = function()
  ObjSet( "spr_newyard_oldphoto", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_newyard_map", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_newyard_jackalbum_zone", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_newyard_abigail32_beg = function()
  ObjDelete( "gfx_newyard_dlg_newyard_abigail32_zone" );
end;
private.dlg_newyard_abigail32_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_newyard_abigail32", private.dlg_newyard_abigail32_beg, private.room_objname );
cmn.AddSubscriber( "dlg_newyard_abigail32", private.dlg_newyard_abigail32_end, private.room_objname );
cmn.AddSubscriber( "dlg_newyard_abigail32", private.dlg_newyard_abigail32_logic );
cmn.AddSubscriber( "dlg_newyard_abigail32_beg", private.dlg_newyard_abigail32_beg, private.room_objname );
cmn.AddSubscriber( "dlg_newyard_abigail32_end", private.dlg_newyard_abigail32_end, private.room_objname );
cmn.AddSubscriber( "dlg_newyard_abigail32_end", private.dlg_newyard_abigail32_logic );
--------------------------------------------------------------------------------------------
function public.dlg_newyard_abigail32( obj )

  local func_end = function()
    cmn.SetEventDone( "get_map" );
    cmn.SetEventDone( "get_oldphoto" );
    cmn.SetEventDone( "use_fullcasket" );
    cmn.SetEventDone( "dlg_newyard_abigail32" );
    cmn.CallEventHandler( "dlg_newyard_abigail32_end" );
    ld.ShowBbt( "after_dlg_newyard_abigail32" )
    common_impl.Lock(0);
  end;
  function public.dlg_newyard_abigail32_func_end()
    common_impl.Lock(1);
    if ObjGetRelations( "inv_oldphoto" ).parent == "level_inv_hub" then
      cmn.CallEventHandler( "get_oldphoto" );
    end  
    if ObjGetRelations( "inv_map" ).parent == "level_inv_hub" then
      cmn.CallEventHandler( "get_map" );
    end 
    func_end()
  end
  cmn.CallEventHandler( "dlg_newyard_abigail32_beg" );

  common_impl.dialog_character_loc = "obj_newyard_abigail_root";
  common_impl.Start( "abigail2", 4, nil, nil, true, "dlg_newyard_abigail32_func_end", { "aud_abigail_3_voc", "aud_abigail_4_voc", "aud_abigail_5_voc" } );


end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_oldphoto" ] = { type = "get", get_obj = "spr_newyard_oldphoto", room = "rm_newyard" };

private.get_oldphoto_logic = function()
  
end;
private.get_oldphoto_inv = function()
  interface.InventoryItemAdd("inv_oldphoto","spr_newyard_oldphoto");
end;
private.get_oldphoto_beg = function()
  ObjDelete("gfx_newyard_oldphoto")
  ObjSet( "spr_newyard_oldphoto", {visible = 1} );
end;
private.get_oldphoto_end = function()
  
end;

cmn.AddSubscriber( "get_oldphoto", private.get_oldphoto_inv );
cmn.AddSubscriber( "get_oldphoto", private.get_oldphoto_beg, private.room_objname );
cmn.AddSubscriber( "get_oldphoto", private.get_oldphoto_end, private.room_objname );
cmn.AddSubscriber( "get_oldphoto", private.get_oldphoto_logic );
--------------------------------------------------------------------
function public.get_oldphoto()
  cmn.SetEventDone( "get_oldphoto" );
  cmn.CallEventHandler( "get_oldphoto" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_map" ] = { type = "get", get_obj = "spr_newyard_map", room = "rm_newyard" };

private.get_map_logic = function()
  
end;
private.get_map_inv = function()
  interface.InventoryItemAdd("inv_map","spr_newyard_map");
end;
private.get_map_beg = function()
  ObjDelete("gfx_newyard_map")
  ObjSet( "spr_newyard_map", {visible = 1} );
end;
private.get_map_end = function()
  
end;

cmn.AddSubscriber( "get_map", private.get_map_inv );
cmn.AddSubscriber( "get_map", private.get_map_beg, private.room_objname );
cmn.AddSubscriber( "get_map", private.get_map_end, private.room_objname );
cmn.AddSubscriber( "get_map", private.get_map_logic );
--------------------------------------------------------------------
function public.get_map()
  cmn.SetEventDone( "get_map" );
  cmn.CallEventHandler( "get_map" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_jackalbum" ] = { type = "use", inv_obj = "inv_jackalbum", use_place = "gfx_newyard_jackalbum_zone", room = "rm_newyard" };

private.use_jackalbum_logic = function()
  ObjSet( "gfx_newyard_dlg_newyard_abigail33_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_jackalbum_inv = function()
  common_impl.ProcessMultiUseAll("jackalbum", "jackalbum")
end;
private.use_jackalbum_beg = function()
  ObjDelete( "gfx_newyard_jackalbum_zone" );
end;
private.use_jackalbum_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_jackalbum", private.use_jackalbum_inv );
cmn.AddSubscriber( "use_jackalbum", private.use_jackalbum_beg, private.room_objname );
cmn.AddSubscriber( "use_jackalbum", private.use_jackalbum_end, private.room_objname );
cmn.AddSubscriber( "use_jackalbum", private.use_jackalbum_logic );
cmn.AddSubscriber( "use_jackalbum_inv", private.use_jackalbum_inv, private.room_objname );
cmn.AddSubscriber( "use_jackalbum_beg", private.use_jackalbum_beg, private.room_objname );
cmn.AddSubscriber( "use_jackalbum_end", private.use_jackalbum_end, private.room_objname );
cmn.AddSubscriber( "use_jackalbum_end", private.use_jackalbum_logic );
--------------------------------------------------------------------------------------------
function public.use_jackalbum( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    
    cmn.CallEventHandler( "use_jackalbum_end" );
    common_impl.Lock(0);
    public.dlg_newyard_abigail33( obj )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_jackalbum_inv" );
  cmn.CallEventHandler( "use_jackalbum_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( "aud_use_jackalbum_newyard" )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_newyard_abigail33" ] = { type = "click", use_place = "gfx_newyard_dlg_newyard_abigail33_zone", room = "rm_newyard" };

private.dlg_newyard_abigail33_logic = function()
level_inv.SetGoodball(4);
end;
private.dlg_newyard_abigail33_beg = function()
  ObjDelete( "gfx_newyard_dlg_newyard_abigail33_zone" );
end;
private.dlg_newyard_abigail33_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_newyard_abigail33", private.dlg_newyard_abigail33_beg, private.room_objname );
cmn.AddSubscriber( "dlg_newyard_abigail33", private.dlg_newyard_abigail33_end, private.room_objname );
cmn.AddSubscriber( "dlg_newyard_abigail33", private.dlg_newyard_abigail33_logic );
cmn.AddSubscriber( "dlg_newyard_abigail33_beg", private.dlg_newyard_abigail33_beg, private.room_objname );
cmn.AddSubscriber( "dlg_newyard_abigail33_end", private.dlg_newyard_abigail33_end, private.room_objname );
cmn.AddSubscriber( "dlg_newyard_abigail33_end", private.dlg_newyard_abigail33_logic );
--------------------------------------------------------------------------------------------
--function public.dlg_newyard_abigail33( obj )
--
--  local func_end = function()
--    cmn.SetEventDone( "use_jackalbum" );
--    cmn.SetEventDone( "dlg_newyard_abigail33" );
--    cmn.CallEventHandler( "dlg_newyard_abigail33_end" );
--    common_impl.Lock(0);
--    common_impl.Gate_MDown( "gmg_newyard_fight" );
--  end;
--  function public.dlg_newyard_jack_func_end()
--    common_impl.Lock(1);
--    ld.StartTimer( 1, function() func_end() end)
--  end
--  function public.dlg_newyard_abigail33_func_end()
--    common_impl.Lock(1);
--    ld.StartTimer( 0.5, function() 
--      ld.Lock(0);
--      common_impl.dialog_character_loc = "";
--      common_impl.Start( "jack", 2, nil, nil, true, "dlg_newyard_jack_func_end", { "aud_jack_frost_1_voc" } );
--    end )
--  end
--  cmn.CallEventHandler( "dlg_newyard_abigail33_beg" );
--
--  common_impl.dialog_character_loc = "obj_newyard_abigail_root";
--  common_impl.Start( "abigail3", 3, nil, nil, true, "dlg_newyard_abigail33_func_end", {  } );
--
--
--end;
function public.dlg_newyard_abigail33( obj )

  local func_end = function()
    int.DialogVideoHide();
    ObjSet( "rm_newyard", {color_r = 0,color_g = 0,color_b = 0} );
    cmn.SetEventDone( "use_jackalbum" );
    cmn.SetEventDone( "dlg_newyard_abigail33" );
    cmn.CallEventHandler( "dlg_newyard_abigail33_end" );
    common_impl.Gate_MDown( "gmg_newyard_fight" );
  end;
  cmn.CallEventHandler( "dlg_newyard_abigail33_beg" );
  --[[
  common_impl.VideoSubtitleVocStart( {
    { "srt_aud_jack_abigel_voc_1" , aud_voc_false, 2.5,6 };
    { "srt_aud_jack_abigel_voc_2" , aud_voc_false, 15,25 };
    { "srt_aud_jack_abigel_voc_3" , aud_voc_false, 27.5,32.5 };
  } );
  ]]
  SoundVoice( "aud_jack_abigel_voc" );
  int.DialogVideoShow( "vid_newyard_jack_abigel", 1, func_end );
  VidPlay("vid_newyard_jack_abigel",func_end)
  SoundVid( "aud_jack_abigel" )

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_newhalldoor *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_housekey" ] = { type = "use", inv_obj = "inv_housekey", use_place = "gfx_newhalldoor_housekey_zone", room = "rm_newyard", zz = "zz_newhalldoor", zz_gate = "gzz_newyard_newhalldoor" };

private.use_housekey_logic = function()
  ObjSet( "gzz_newyard_angels", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_newyard_fountain", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_newyard_lantern", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_newhalldoor_firedsplinter_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_housekey_inv = function()
  common_impl.ProcessMultiUseAll("housekey", "housekey")
end;
private.use_housekey_beg = function()
  ObjDelete( "gfx_newhalldoor_housekey_zone" );
end;
private.use_housekey_end = function()
  ObjSet( "anm_newhalldoor_anim_use_key", {animfunc = "use_splinter", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_housekey") then ObjSet( common_impl.hint["use_housekey"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_housekey", private.use_housekey_inv );
cmn.AddSubscriber( "use_housekey", private.use_housekey_beg, private.room_objname );
cmn.AddSubscriber( "use_housekey", private.use_housekey_end, private.room_objname );
cmn.AddSubscriber( "use_housekey", private.use_housekey_logic );
cmn.AddSubscriber( "use_housekey_inv", private.use_housekey_inv, private.room_objname );
cmn.AddSubscriber( "use_housekey_beg", private.use_housekey_beg, private.room_objname );
cmn.AddSubscriber( "use_housekey_end", private.use_housekey_end, private.room_objname );
cmn.AddSubscriber( "use_housekey_end", private.use_housekey_logic );
--------------------------------------------------------------------------------------------
function public.use_housekey( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_housekey" );
    cmn.CallEventHandler( "use_housekey_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_housekey") then ld.CloseSubRoom() end;
    
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_housekey_inv" );
  cmn.CallEventHandler( "use_housekey_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_newhalldoor_anim_use_key", "use_key", func_end );
  SoundSfx( "aud_use_housekey_newyard" )
  

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_firedsplinter" ] = { type = "use", inv_obj = "inv_firedsplinter", use_place = "gfx_newhalldoor_firedsplinter_zone", room = "rm_newyard", zz = "zz_newhalldoor", zz_gate = "gzz_newyard_newhalldoor" };

private.use_firedsplinter_logic = function()
  ObjSet( "gfx_newhalldoor_clk_newhalldoor1_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_firedsplinter_inv = function()
  common_impl.ProcessMultiUseAll("firedsplinter", "firedsplinter")
end;
private.use_firedsplinter_beg = function()
  ObjDelete( "gfx_newhalldoor_firedsplinter_zone" );
end;
private.use_firedsplinter_end = function()
    ObjSet( "anm_newhalldoor_anim_use_key", {animfunc = "click_key", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_firedsplinter") then ObjSet( common_impl.hint["use_firedsplinter"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_firedsplinter", private.use_firedsplinter_inv );
cmn.AddSubscriber( "use_firedsplinter", private.use_firedsplinter_beg, private.room_objname );
cmn.AddSubscriber( "use_firedsplinter", private.use_firedsplinter_end, private.room_objname );
cmn.AddSubscriber( "use_firedsplinter", private.use_firedsplinter_logic );
cmn.AddSubscriber( "use_firedsplinter_inv", private.use_firedsplinter_inv, private.room_objname );
cmn.AddSubscriber( "use_firedsplinter_beg", private.use_firedsplinter_beg, private.room_objname );
cmn.AddSubscriber( "use_firedsplinter_end", private.use_firedsplinter_end, private.room_objname );
cmn.AddSubscriber( "use_firedsplinter_end", private.use_firedsplinter_logic );
--------------------------------------------------------------------------------------------
function public.use_firedsplinter( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_firedsplinter" );
    cmn.CallEventHandler( "use_firedsplinter_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_firedsplinter") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_firedsplinter_inv" );
  cmn.CallEventHandler( "use_firedsplinter_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_newhalldoor_anim_use_key", "use_splinter", func_end );
  SoundSfx( "aud_use_firedsplinter_newyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_newhalldoor1" ] = { type = "click", use_place = "gfx_newhalldoor_clk_newhalldoor1_zone", room = "rm_newyard", zz = "zz_newhalldoor", zz_gate = "gzz_newyard_newhalldoor" };

private.clk_newhalldoor1_logic = function()
  ObjSet( "gfx_newhalldoor_clk_newhalldoor2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_newhalldoor1_beg = function()
  ObjDelete( "gfx_newhalldoor_clk_newhalldoor1_zone" );
end;
private.clk_newhalldoor1_end = function()
    ObjSet( "anm_newhalldoor_anim_use_key", {animfunc = "open_door", frame = 0 } );
  if common_impl.ZzCompleteCheck("clk_newhalldoor1") then ObjSet( common_impl.hint["clk_newhalldoor1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_newhalldoor1", private.clk_newhalldoor1_beg, private.room_objname );
cmn.AddSubscriber( "clk_newhalldoor1", private.clk_newhalldoor1_end, private.room_objname );
cmn.AddSubscriber( "clk_newhalldoor1", private.clk_newhalldoor1_logic );
cmn.AddSubscriber( "clk_newhalldoor1_beg", private.clk_newhalldoor1_beg, private.room_objname );
cmn.AddSubscriber( "clk_newhalldoor1_end", private.clk_newhalldoor1_end, private.room_objname );
cmn.AddSubscriber( "clk_newhalldoor1_end", private.clk_newhalldoor1_logic );
--------------------------------------------------------------------------------------------
function public.clk_newhalldoor1()

  local func_end = function()
    cmn.SetEventDone( "clk_newhalldoor1" );
    cmn.CallEventHandler( "clk_newhalldoor1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_newhalldoor1") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_newhalldoor1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_newhalldoor_anim_use_key", "click_key", func_end );
  SoundSfx( "aud_clk_newhalldoor1_newyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_newhalldoor2" ] = { type = "click", use_place = "gfx_newhalldoor_clk_newhalldoor2_zone", room = "rm_newyard", zz = "zz_newhalldoor", zz_gate = "gzz_newyard_newhalldoor" };

private.clk_newhalldoor2_logic = function()
  ObjSet( "grm_newyard_newhall", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_newyard_newhall_focus");
    end;

end;
private.clk_newhalldoor2_beg = function()
  ObjDelete( "gfx_newhalldoor_clk_newhalldoor2_zone" );
end;
private.clk_newhalldoor2_end = function()
    ObjSet( "spr_newyard_open_door", {visible = 1} );
    ObjSet( "anm_newhalldoor_anim_use_key", {animfunc = "open_door", frame = 999 } );
  if common_impl.ZzCompleteCheck("clk_newhalldoor2") then ObjSet( common_impl.hint["clk_newhalldoor2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_newhalldoor2", private.clk_newhalldoor2_beg, private.room_objname );
cmn.AddSubscriber( "clk_newhalldoor2", private.clk_newhalldoor2_end, private.room_objname );
cmn.AddSubscriber( "clk_newhalldoor2", private.clk_newhalldoor2_logic );
cmn.AddSubscriber( "clk_newhalldoor2_beg", private.clk_newhalldoor2_beg, private.room_objname );
cmn.AddSubscriber( "clk_newhalldoor2_end", private.clk_newhalldoor2_end, private.room_objname );
cmn.AddSubscriber( "clk_newhalldoor2_end", private.clk_newhalldoor2_logic );
--------------------------------------------------------------------------------------------
function public.clk_newhalldoor2()

  local func_end = function()
    cmn.SetEventDone( "clk_newhalldoor2" );
    cmn.CallEventHandler( "clk_newhalldoor2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_newhalldoor2") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_newhalldoor2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_newhalldoor_anim_use_key", "open_door", 
    function() 
      ld.CloseSubRoom()
      ObjSet( "spr_newyard_open_door", {visible = 1, alp = 0} );
      ObjAnimate( "spr_newyard_open_door", 8, 0, 0, function() func_end() end, {0,0,0, 0.5,0,1} );
    end
  );
  SoundSfx( "aud_clk_newhalldoor2_newyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_fountain *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_shell" ] = { type = "use", inv_obj = "inv_shell", use_place = "gfx_fountain_shell_zone", room = "rm_newyard", zz = "zz_fountain", zz_gate = "gzz_newyard_fountain" };

private.use_shell_logic = function()
  ObjSet( "spr_fountain_mosaicbow", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_fountain_sharpteeth", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_fountain_elfumbrella_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_shell_inv = function()
  common_impl.ProcessMultiUseAll("shell", "shell")
end;
private.use_shell_beg = function()
  ObjDelete( "gfx_fountain_shell_zone" );
end;
private.use_shell_end = function()
  ObjAttach("vid_fountain_waterfall_loop_57","zz_fountain")
  ObjSet( "anm_fountain_anim_fountain_2", {animfunc = "use_key", frame = 999 } );
  ObjSet( "anm_fountain_anim_fountain", {animfunc = "broken_ice", frame = 999 } );
  ObjAttach("vid_newyard_vid_fountain_loop_57","rm_newyard")
  ObjDelete("spr_newyard_bow_sharpteeth")
  ObjDelete("spr_newyard_ice")
  if common_impl.ZzCompleteCheck("use_shell") then ObjSet( common_impl.hint["use_shell"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_shell", private.use_shell_inv );
cmn.AddSubscriber( "use_shell", private.use_shell_beg, private.room_objname );
cmn.AddSubscriber( "use_shell", private.use_shell_end, private.room_objname );
cmn.AddSubscriber( "use_shell", private.use_shell_logic );
cmn.AddSubscriber( "use_shell_inv", private.use_shell_inv, private.room_objname );
cmn.AddSubscriber( "use_shell_beg", private.use_shell_beg, private.room_objname );
cmn.AddSubscriber( "use_shell_end", private.use_shell_end, private.room_objname );
cmn.AddSubscriber( "use_shell_end", private.use_shell_logic );
--------------------------------------------------------------------------------------------
function public.use_shell( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_shell" );
    cmn.SetEventDone( "get_sharpteeth" );
    cmn.SetEventDone( "get_mosaicbow" );
    cmn.CallEventHandler( "use_shell_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_shell") then ld.CloseSubRoom() end;
    --public.get_sharpteeth()
    --public.get_mosaicbow()
  end;
  local function  func_end_2()
    SoundEnv( "aud_zz_fountain_env", 1 )
    ObjAttach("vid_fountain_waterfall_loop_57","zz_fountain")
    ObjSet( "vid_fountain_waterfall_loop_57", {alp = 0} );
    ObjAnimate( "vid_fountain_waterfall_loop_57", 8, 0, 0, function() 
      cmn.CallEventHandler( "get_sharpteeth" );
      cmn.CallEventHandler( "get_mosaicbow" );
      ld.AnimPlay( "anm_fountain_anim_fountain", "broken_ice", func_end );  
    end, {0,0,0, 0.5,0,1} );
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_shell_inv" );
  cmn.CallEventHandler( "use_shell_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_fountain_anim_fountain_2", "use_key", func_end_2 );
  SoundSfx( "aud_use_shell_newyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_mosaicbow" ] = { type = "get", get_obj = "spr_fountain_mosaicbow", room = "rm_newyard", zz = "zz_fountain", zz_gate = "gzz_newyard_fountain" };

private.get_mosaicbow_logic = function()
  
end;
private.get_mosaicbow_inv = function()
  interface.InventoryItemAdd("inv_mosaicbow","spr_fountain_mosaicbow");
end;
private.get_mosaicbow_beg = function()
  ObjDelete("gfx_fountain_mosaicbow")
end;
private.get_mosaicbow_end = function()
  if common_impl.ZzCompleteCheck("get_mosaicbow") then ObjSet( common_impl.hint["get_mosaicbow"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_mosaicbow", private.get_mosaicbow_inv );
cmn.AddSubscriber( "get_mosaicbow", private.get_mosaicbow_beg, private.room_objname );
cmn.AddSubscriber( "get_mosaicbow", private.get_mosaicbow_end, private.room_objname );
cmn.AddSubscriber( "get_mosaicbow", private.get_mosaicbow_logic );
--------------------------------------------------------------------
function public.get_mosaicbow()
  cmn.SetEventDone( "get_mosaicbow" );
  cmn.CallEventHandler( "get_mosaicbow" );
  if common_impl.ZzCompleteCheck("get_mosaicbow") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sharpteeth" ] = { type = "get", get_obj = "spr_fountain_sharpteeth", room = "rm_newyard", zz = "zz_fountain", zz_gate = "gzz_newyard_fountain" };

private.get_sharpteeth_logic = function()
  
end;
private.get_sharpteeth_inv = function()
  interface.InventoryItemAdd("inv_sharpteeth","spr_fountain_sharpteeth");
end;
private.get_sharpteeth_beg = function()
  ObjDelete("gfx_fountain_sharpteeth")
end;
private.get_sharpteeth_end = function()
  if common_impl.ZzCompleteCheck("get_sharpteeth") then ObjSet( common_impl.hint["get_sharpteeth"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_sharpteeth", private.get_sharpteeth_inv );
cmn.AddSubscriber( "get_sharpteeth", private.get_sharpteeth_beg, private.room_objname );
cmn.AddSubscriber( "get_sharpteeth", private.get_sharpteeth_end, private.room_objname );
cmn.AddSubscriber( "get_sharpteeth", private.get_sharpteeth_logic );
--------------------------------------------------------------------
function public.get_sharpteeth()
  cmn.SetEventDone( "get_sharpteeth" );
  cmn.CallEventHandler( "get_sharpteeth" );
  if common_impl.ZzCompleteCheck("get_sharpteeth") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_elfumbrella" ] = { type = "use", inv_obj = "inv_elfumbrella", use_place = "gfx_fountain_elfumbrella_zone", room = "rm_newyard", zz = "zz_fountain", zz_gate = "gzz_newyard_fountain" };

private.use_elfumbrella_logic = function()
  ObjSet( "spr_fountain_pipebillet", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_fountain_smallwheel", { visible = 1, input = 1, active = 1 } )
  int_simon.SimonSetVisible(1)
end;
private.use_elfumbrella_inv = function()
  common_impl.ProcessMultiUseAll("elfumbrella", "elfumbrella")
end;
private.use_elfumbrella_beg = function()
  ObjDelete( "gfx_fountain_elfumbrella_zone" );
end;
private.use_elfumbrella_end = function()
  ObjDelete("spr_fountain_anim_fountain_pipebillet")
  ObjDelete("spr_fountain_anim_fountain_smallwheel")
  if common_impl.ZzCompleteCheck("use_elfumbrella") then ObjSet( common_impl.hint["use_elfumbrella"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_elfumbrella", private.use_elfumbrella_inv );
cmn.AddSubscriber( "use_elfumbrella", private.use_elfumbrella_beg, private.room_objname );
cmn.AddSubscriber( "use_elfumbrella", private.use_elfumbrella_end, private.room_objname );
cmn.AddSubscriber( "use_elfumbrella", private.use_elfumbrella_logic );
cmn.AddSubscriber( "use_elfumbrella_inv", private.use_elfumbrella_inv, private.room_objname );
cmn.AddSubscriber( "use_elfumbrella_beg", private.use_elfumbrella_beg, private.room_objname );
cmn.AddSubscriber( "use_elfumbrella_end", private.use_elfumbrella_end, private.room_objname );
cmn.AddSubscriber( "use_elfumbrella_end", private.use_elfumbrella_logic );
--------------------------------------------------------------------------------------------
function public.use_elfumbrella( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_elfumbrella" );
    cmn.SetEventDone( "get_pipebillet" );
    cmn.SetEventDone( "get_smallwheel" );
    cmn.CallEventHandler( "use_elfumbrella_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_elfumbrella") then ld.CloseSubRoom() end;
    ObjDelete( "spr_fountain_elf" )
    interface.SimonReturn()
  end;
  local function func_end_2()
    ObjSet( "spr_fountain_elf", {visible = 1} );
    int_inventory.StdItemFlyAnimation( "spr_fountain_elf", "obj_int_button_map_point_for_cube", func_end );
    ObjDetach("vid_fountain_goody_through_water_156")
    ObjSet( "vid_fountain_waterfall_loop_57", {alp = 1} );
    ObjAttach("vid_fountain_waterfall_loop_57","zz_fountain")
    public.get_pipebillet()
    public.get_smallwheel()
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_elfumbrella_inv" );
  cmn.CallEventHandler( "use_elfumbrella_beg" );
  common_impl.Lock(1);

  
  --ObjDetach("vid_fountain_waterfall_loop_57")
  ObjAttach("vid_fountain_goody_through_water_156","zz_fountain")
  ObjSet( "vid_fountain_goody_through_water_156", {alp = 0} );
  ObjAnimate( "vid_fountain_goody_through_water_156", 7, 0, 0, function() 
    ObjAnimate( "vid_fountain_waterfall_loop_57", 8, 0, 0, function() ObjDetach("vid_fountain_waterfall_loop_57") end, {0,0,1, 0.5,1,0} );
    ObjAnimate( "vid_fountain_goody_through_water_156", 8, 0, 0, function()   
      ObjDelete("spr_fountain_anim_fountain_pipebillet")
      ObjDelete("spr_fountain_anim_fountain_smallwheel") end, {0,0,0, 0.5,2,1} );
    SoundVid( "aud_goody_through_water_156" )
    VidPlay("vid_fountain_goody_through_water_156", func_end_2);
  end, {0,0,0, 0,0,0} );
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_pipebillet" ] = { type = "get", get_obj = "spr_fountain_pipebillet", room = "rm_newyard", zz = "zz_fountain", zz_gate = "gzz_newyard_fountain" };

private.get_pipebillet_logic = function()
  
end;
private.get_pipebillet_inv = function()
  interface.InventoryItemAdd("inv_pipebillet","spr_fountain_pipebillet");
  ObjSet( "inv_pipebillet", { drag = 0 } );
end;
private.get_pipebillet_beg = function()
  ObjDelete("gfx_fountain_pipebillet")
  ObjSet( "spr_fountain_pipebillet", {visible = 1} );
end;
private.get_pipebillet_end = function()
  if common_impl.ZzCompleteCheck("get_pipebillet") then ObjSet( common_impl.hint["get_pipebillet"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_pipebillet", private.get_pipebillet_inv );
cmn.AddSubscriber( "get_pipebillet", private.get_pipebillet_beg, private.room_objname );
cmn.AddSubscriber( "get_pipebillet", private.get_pipebillet_end, private.room_objname );
cmn.AddSubscriber( "get_pipebillet", private.get_pipebillet_logic );
--------------------------------------------------------------------
function public.get_pipebillet()

  cmn.CallEventHandler( "get_pipebillet" );
  if common_impl.ZzCompleteCheck("get_pipebillet") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_smallwheel" ] = { type = "get", get_obj = "spr_fountain_smallwheel", room = "rm_newyard", zz = "zz_fountain", zz_gate = "gzz_newyard_fountain" };

private.get_smallwheel_logic = function()
  
end;
private.get_smallwheel_inv = function()
  interface.InventoryItemAdd("inv_smallwheel","spr_fountain_smallwheel");
end;
private.get_smallwheel_beg = function()
  ObjDelete("gfx_fountain_smallwheel")
  ObjSet( "spr_fountain_smallwheel", {visible = 1} );
end;
private.get_smallwheel_end = function()
  if common_impl.ZzCompleteCheck("get_smallwheel") then ObjSet( common_impl.hint["get_smallwheel"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_smallwheel", private.get_smallwheel_inv );
cmn.AddSubscriber( "get_smallwheel", private.get_smallwheel_beg, private.room_objname );
cmn.AddSubscriber( "get_smallwheel", private.get_smallwheel_end, private.room_objname );
cmn.AddSubscriber( "get_smallwheel", private.get_smallwheel_logic );
--------------------------------------------------------------------
function public.get_smallwheel()

  cmn.CallEventHandler( "get_smallwheel" );
  if common_impl.ZzCompleteCheck("get_smallwheel") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_lantern *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_toyhouse" ] = { type = "get", get_obj = "spr_lantern_toyhouse", room = "rm_newyard", zz = "zz_lantern", zz_gate = "gzz_newyard_lantern" };

private.get_toyhouse_logic = function()
  
end;
private.get_toyhouse_inv = function()
  interface.InventoryItemAdd("inv_toyhouse","spr_lantern_toyhouse");
end;
private.get_toyhouse_beg = function()
  ObjDelete("gfx_lantern_toyhouse")
end;
private.get_toyhouse_end = function()
  ObjDelete("spr_lantern_toyhouse_trash")
  ObjDelete("spr_newyard_house_trash")
  if common_impl.ZzCompleteCheck("get_toyhouse") then ObjSet( common_impl.hint["get_toyhouse"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_toyhouse", private.get_toyhouse_inv );
cmn.AddSubscriber( "get_toyhouse", private.get_toyhouse_beg, private.room_objname );
cmn.AddSubscriber( "get_toyhouse", private.get_toyhouse_end, private.room_objname );
cmn.AddSubscriber( "get_toyhouse", private.get_toyhouse_logic );
--------------------------------------------------------------------
function public.get_toyhouse()
  cmn.SetEventDone( "get_toyhouse" );
  cmn.CallEventHandler( "get_toyhouse" );
  if common_impl.ZzCompleteCheck("get_toyhouse") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mosaicbow" ] = { type = "use", inv_obj = "inv_mosaicbow", use_place = "gfx_lantern_mosaicbow_zone", room = "rm_newyard", zz = "zz_lantern", zz_gate = "gzz_newyard_lantern" };

private.use_mosaicbow_logic = function()
  ObjSet( "gfx_lantern_splinter_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_mosaicbow_inv = function()
  common_impl.ProcessMultiUseAll("mosaicbow", "mosaicbow")
end;
private.use_mosaicbow_beg = function()
  ObjDelete( "gfx_lantern_mosaicbow_zone" );
end;
private.use_mosaicbow_end = function()
  ObjDelete("spr_newyard_door_1")
  ObjSet( "spr_newyard_open_door_1", {visible = 1} );
  ObjSet( "anm_lantern_anim_lantern", {animfunc = "use_bow", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_mosaicbow") then ObjSet( common_impl.hint["use_mosaicbow"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mosaicbow", private.use_mosaicbow_inv );
cmn.AddSubscriber( "use_mosaicbow", private.use_mosaicbow_beg, private.room_objname );
cmn.AddSubscriber( "use_mosaicbow", private.use_mosaicbow_end, private.room_objname );
cmn.AddSubscriber( "use_mosaicbow", private.use_mosaicbow_logic );
cmn.AddSubscriber( "use_mosaicbow_inv", private.use_mosaicbow_inv, private.room_objname );
cmn.AddSubscriber( "use_mosaicbow_beg", private.use_mosaicbow_beg, private.room_objname );
cmn.AddSubscriber( "use_mosaicbow_end", private.use_mosaicbow_end, private.room_objname );
cmn.AddSubscriber( "use_mosaicbow_end", private.use_mosaicbow_logic );
--------------------------------------------------------------------------------------------
function public.use_mosaicbow( obj )

  local func_end = function()
    SoundEnv( "aud_candle_env", 1 )
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mosaicbow" );
    cmn.CallEventHandler( "use_mosaicbow_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mosaicbow") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mosaicbow_inv" );
  cmn.CallEventHandler( "use_mosaicbow_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_lantern_anim_lantern", "use_bow", func_end );
  SoundSfx( "aud_use_mosaicbow_newyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_splinter" ] = { type = "use", inv_obj = "inv_splinter", use_place = "gfx_lantern_splinter_zone", room = "rm_newyard", zz = "zz_lantern", zz_gate = "gzz_newyard_lantern" };

private.use_splinter_logic = function()
  --ObjSet( "spr_lantern_firedsplinter", { visible = 1, input = 1, active = 1 } )

end;
private.use_splinter_inv = function()
  common_impl.ProcessMultiUseAll("splinter", "splinter")
end;
private.use_splinter_beg = function()
  ObjDelete( "gfx_lantern_splinter_zone" );
end;
private.use_splinter_end = function()
  if common_impl.ZzCompleteCheck("use_splinter") then ObjSet( common_impl.hint["use_splinter"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_splinter", private.use_splinter_inv );
cmn.AddSubscriber( "use_splinter", private.use_splinter_beg, private.room_objname );
cmn.AddSubscriber( "use_splinter", private.use_splinter_end, private.room_objname );
cmn.AddSubscriber( "use_splinter", private.use_splinter_logic );
cmn.AddSubscriber( "use_splinter_inv", private.use_splinter_inv, private.room_objname );
cmn.AddSubscriber( "use_splinter_beg", private.use_splinter_beg, private.room_objname );
cmn.AddSubscriber( "use_splinter_end", private.use_splinter_end, private.room_objname );
cmn.AddSubscriber( "use_splinter_end", private.use_splinter_logic );
--------------------------------------------------------------------------------------------
function public.use_splinter( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_splinter" );
    cmn.CallEventHandler( "use_splinter_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_splinter") then ld.CloseSubRoom() end;
    public.get_firedsplinter()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_splinter_inv" );
  cmn.CallEventHandler( "use_splinter_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_lantern_anim_lantern_splinter", "use_splinter", func_end );
  SoundSfx( "aud_use_splinter_newyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_firedsplinter" ] = { type = "get", get_obj = "spr_lantern_firedsplinter", room = "rm_newyard", zz = "zz_lantern", zz_gate = "gzz_newyard_lantern" };

private.get_firedsplinter_logic = function()
  
end;
private.get_firedsplinter_inv = function()
  interface.InventoryItemAdd("inv_firedsplinter","anm_lantern_anim_lantern_splinter");
  --ld.StartTimer( 0.1, function() ObjSet( "inv_firedsplinter_fx", {pause = 1} ); end )
end;
private.get_firedsplinter_beg = function()
  ObjDelete("gfx_lantern_firedsplinter")
end;
private.get_firedsplinter_end = function()
  ObjDelete("spr_lantern_firedsplinter")
  if common_impl.ZzCompleteCheck("get_firedsplinter") then ObjSet( common_impl.hint["get_firedsplinter"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_firedsplinter", private.get_firedsplinter_inv );
cmn.AddSubscriber( "get_firedsplinter", private.get_firedsplinter_beg, private.room_objname );
cmn.AddSubscriber( "get_firedsplinter", private.get_firedsplinter_end, private.room_objname );
cmn.AddSubscriber( "get_firedsplinter", private.get_firedsplinter_logic );
--------------------------------------------------------------------
function public.get_firedsplinter()
  cmn.SetEventDone( "get_firedsplinter" );
  cmn.CallEventHandler( "get_firedsplinter" );
  if common_impl.ZzCompleteCheck("get_firedsplinter") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mosaicmoon" ] = { type = "use", inv_obj = "inv_mosaicmoon", use_place = "gfx_lantern_mosaicmoon_zone", room = "rm_newyard", zz = "zz_lantern", zz_gate = "gzz_newyard_lantern" };

private.use_mosaicmoon_logic = function()
  if ld.CheckRequirements( {"use_mosaicmoon","use_mosaicsun"} ) then
    ObjSet( "spr_lantern_mousekey", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_lantern_ball2", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_mosaicmoon_inv = function()
  common_impl.ProcessMultiUseAll("mosaicmoon", "mosaicmoon")
end;
private.use_mosaicmoon_beg = function()
  ObjDelete( "gfx_lantern_mosaicmoon_zone" );
end;
private.use_mosaicmoon_end = function()
  if ld.CheckRequirements( {"use_mosaicmoon","use_mosaicsun"} ) then
    ObjSet( "spr_newyard_ball", {visible = 1} );
    ObjSet( "spr_newyard_key", {visible = 1} );
    ObjDelete("spr_newyard_door_2")
    ObjDelete("spr_newyard_sun")
    ObjDelete("spr_newyard_moon")
    ObjSet( "spr_newyard_open_door_2", {visible = 1} );
    ObjDelete("anm_lantern_anim_lantern_moon")
    ObjDelete("anm_lantern_anim_lantern_sun")
    ObjSet( "anm_lantern_anim_lantern_door", {animfunc = "open_door_2", frame = 999 } );
  else
    ObjSet( "spr_newyard_moon", {visible = 1} );
    ObjSet( "anm_lantern_anim_lantern_moon", {animfunc = "use_moon", frame = 999 } );
  end
  if common_impl.ZzCompleteCheck("use_mosaicmoon") then ObjSet( common_impl.hint["use_mosaicmoon"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mosaicmoon", private.use_mosaicmoon_inv );
cmn.AddSubscriber( "use_mosaicmoon", private.use_mosaicmoon_beg, private.room_objname );
cmn.AddSubscriber( "use_mosaicmoon", private.use_mosaicmoon_end, private.room_objname );
cmn.AddSubscriber( "use_mosaicmoon", private.use_mosaicmoon_logic );
cmn.AddSubscriber( "use_mosaicmoon_inv", private.use_mosaicmoon_inv, private.room_objname );
cmn.AddSubscriber( "use_mosaicmoon_beg", private.use_mosaicmoon_beg, private.room_objname );
cmn.AddSubscriber( "use_mosaicmoon_end", private.use_mosaicmoon_end, private.room_objname );
cmn.AddSubscriber( "use_mosaicmoon_end", private.use_mosaicmoon_logic );
--------------------------------------------------------------------------------------------
function public.use_mosaicmoon( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mosaicmoon" );
    cmn.CallEventHandler( "use_mosaicmoon_end" );
    common_impl.Lock(0);
    
    if common_impl.ZzCompleteCheck("use_mosaicmoon") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()
    ObjSet( "anm_lantern_anim_lantern_moon", {pos_z = 6} );
    if ld.IsLastActionLeft({"use_mosaicmoon","use_mosaicsun"}) then
      ObjDelete("anm_lantern_anim_lantern_moon")
      ObjDelete("anm_lantern_anim_lantern_sun")      
      SoundSfx( "aud_open_lantern" ) 
      ld.AnimPlay( "anm_lantern_anim_lantern_door", "open_door_2", func_end )
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mosaicmoon_inv" );
  cmn.CallEventHandler( "use_mosaicmoon_beg" );
  common_impl.Lock(1);
  ObjSet( "anm_lantern_anim_lantern_moon", {pos_z = 7} );
  ld.AnimPlay( "anm_lantern_anim_lantern_moon", "use_moon", func_end_2 );
  SoundSfx( "aud_use_mosaicmoon_newyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mosaicsun" ] = { type = "use", inv_obj = "inv_mosaicsun", use_place = "gfx_lantern_mosaicsun_zone", room = "rm_newyard", zz = "zz_lantern", zz_gate = "gzz_newyard_lantern" };

private.use_mosaicsun_logic = function()
  if ld.CheckRequirements( {"use_mosaicsun","use_mosaicmoon"} ) then
    ObjSet( "spr_lantern_mousekey", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_lantern_ball2", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_mosaicsun_inv = function()
  common_impl.ProcessMultiUseAll("mosaicsun", "mosaicsun")
end;
private.use_mosaicsun_beg = function()
  ObjDelete( "gfx_lantern_mosaicsun_zone" );
end;
private.use_mosaicsun_end = function()
  if ld.CheckRequirements( {"use_mosaicmoon","use_mosaicsun"} ) then
    ObjSet( "spr_newyard_ball", {visible = 1} );
    ObjSet( "spr_newyard_key", {visible = 1} );
    ObjDelete("spr_newyard_door_2")
    ObjDelete("spr_newyard_sun")
    ObjDelete("spr_newyard_moon")
    ObjSet( "spr_newyard_open_door_2", {visible = 1} );
    ObjDelete("anm_lantern_anim_lantern_moon")
    ObjDelete("anm_lantern_anim_lantern_sun")
    ObjSet( "anm_lantern_anim_lantern_door", {animfunc = "open_door_2", frame = 999 } );
  else
    ObjSet( "spr_newyard_sun", {visible = 1} );
    ObjSet( "anm_lantern_anim_lantern_sun", {animfunc = "use_sun", frame = 999 } );
  end
  if common_impl.ZzCompleteCheck("use_mosaicsun") then ObjSet( common_impl.hint["use_mosaicsun"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mosaicsun", private.use_mosaicsun_inv );
cmn.AddSubscriber( "use_mosaicsun", private.use_mosaicsun_beg, private.room_objname );
cmn.AddSubscriber( "use_mosaicsun", private.use_mosaicsun_end, private.room_objname );
cmn.AddSubscriber( "use_mosaicsun", private.use_mosaicsun_logic );
cmn.AddSubscriber( "use_mosaicsun_inv", private.use_mosaicsun_inv, private.room_objname );
cmn.AddSubscriber( "use_mosaicsun_beg", private.use_mosaicsun_beg, private.room_objname );
cmn.AddSubscriber( "use_mosaicsun_end", private.use_mosaicsun_end, private.room_objname );
cmn.AddSubscriber( "use_mosaicsun_end", private.use_mosaicsun_logic );
--------------------------------------------------------------------------------------------
function public.use_mosaicsun( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mosaicsun" );
    cmn.CallEventHandler( "use_mosaicsun_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mosaicsun") then ld.CloseSubRoom() end;
  end;
  local func_end_2 = function()
    ObjSet( "anm_lantern_anim_lantern_sun", {pos_z = 6} );
    if ld.IsLastActionLeft({"use_mosaicmoon","use_mosaicsun"}) then
      ObjDelete("anm_lantern_anim_lantern_moon")
      ObjDelete("anm_lantern_anim_lantern_sun")     
      SoundSfx( "aud_open_lantern" ) 
      ld.AnimPlay( "anm_lantern_anim_lantern_door", "open_door_2", func_end )
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mosaicsun_inv" );
  cmn.CallEventHandler( "use_mosaicsun_beg" );
  common_impl.Lock(1);
  ObjSet( "anm_lantern_anim_lantern_sun", {pos_z = 7} );
  ld.AnimPlay( "anm_lantern_anim_lantern_sun", "use_sun", func_end_2 );
  SoundSfx( "aud_use_mosaicmoon_newyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_mousekey" ] = { type = "get", get_obj = "spr_lantern_mousekey", room = "rm_newyard", zz = "zz_lantern", zz_gate = "gzz_newyard_lantern" };

private.get_mousekey_logic = function()
  
end;
private.get_mousekey_inv = function()
  interface.InventoryItemAdd("inv_mousekey","spr_lantern_mousekey");
end;
private.get_mousekey_beg = function()
  ObjDelete("gfx_lantern_mousekey")
end;
private.get_mousekey_end = function()
  ObjDelete("spr_newyard_key")
  if common_impl.ZzCompleteCheck("get_mousekey") then ObjSet( common_impl.hint["get_mousekey"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_mousekey", private.get_mousekey_inv );
cmn.AddSubscriber( "get_mousekey", private.get_mousekey_beg, private.room_objname );
cmn.AddSubscriber( "get_mousekey", private.get_mousekey_end, private.room_objname );
cmn.AddSubscriber( "get_mousekey", private.get_mousekey_logic );
--------------------------------------------------------------------
function public.get_mousekey()
  cmn.SetEventDone( "get_mousekey" );
  cmn.CallEventHandler( "get_mousekey" );
  if common_impl.ZzCompleteCheck("get_mousekey") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ball2" ] = { type = "get", get_obj = "spr_lantern_ball2", room = "rm_newyard", zz = "zz_lantern", zz_gate = "gzz_newyard_lantern" };

private.get_ball2_logic = function()
  
end;
private.get_ball2_inv = function()
  interface.InventoryItemAdd("inv_ball","spr_lantern_ball2",function() level_inv.ProcessGetBallAll( "get_ball2" ) end);
end;
private.get_ball2_beg = function()
  ObjDelete("gfx_lantern_ball2")
end;
private.get_ball2_end = function()
  ObjDelete("spr_newyard_ball")
  if common_impl.ZzCompleteCheck("get_ball2") then ObjSet( common_impl.hint["get_ball2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_ball2", private.get_ball2_inv );
cmn.AddSubscriber( "get_ball2", private.get_ball2_beg, private.room_objname );
cmn.AddSubscriber( "get_ball2", private.get_ball2_end, private.room_objname );
cmn.AddSubscriber( "get_ball2", private.get_ball2_logic );
--------------------------------------------------------------------
function public.get_ball2()
  cmn.SetEventDone( "get_ball2" );
  cmn.CallEventHandler( "get_ball2" );
  if common_impl.ZzCompleteCheck("get_ball2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_angels *** () end
--*********************************************************************************************************************

--------------------------------------------------------------------------------------------
common_impl.hint[ "get_amuletelf6" ] = { type = "get", get_obj = "spr_angels_amuletelf6", room = "rm_newyard", zz = "zz_angels", zz_gate = "gzz_newyard_angels" };

private.get_amuletelf6_logic = function()
  
end;
private.get_amuletelf6_inv = function()
  interface.InventoryItemAdd("inv_amuletelf6","spr_angels_amuletelf6");
end;
private.get_amuletelf6_beg = function()
  ObjDelete("gfx_angels_amuletelf6")
end;
private.get_amuletelf6_end = function()
  ObjDelete("spr_newyard_elfamulet")
  if common_impl.ZzCompleteCheck("get_amuletelf6") then ObjSet( common_impl.hint["get_amuletelf6"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletelf6", private.get_amuletelf6_inv );
cmn.AddSubscriber( "get_amuletelf6", private.get_amuletelf6_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletelf6", private.get_amuletelf6_end, private.room_objname );
cmn.AddSubscriber( "get_amuletelf6", private.get_amuletelf6_logic );
--------------------------------------------------------------------
function public.get_amuletelf6()
  if common_impl.ZzCompleteCheck("get_amuletelf6") then ld.CloseSubRoom() end;
  cmn.SetEventDone( "get_amuletelf6" );
  cmn.CallEventHandler( "get_amuletelf6" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_sharpteeth_angels" ] = { type = "use", inv_obj = "inv_sharpteeth", use_place = "gfx_angels_sharpteeth_angels_zone", room = "rm_newyard", zz = "zz_angels", zz_gate = "gzz_newyard_angels" };

private.use_sharpteeth_angels_logic = function()
  ObjSet( "spr_angels_splinter", { visible = 1, input = 1, active = 1 } )

end;
private.use_sharpteeth_angels_inv = function()
  common_impl.ProcessMultiUseAll("sharpteeth", "sharpteeth_angels")
end;
private.use_sharpteeth_angels_beg = function()
  ObjDelete( "gfx_angels_sharpteeth_angels_zone" );
end;
private.use_sharpteeth_angels_end = function()
  ObjSet( "anm_angels_anim_angels_teeth", {animfunc = "use_teeth_end", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_sharpteeth_angels") then ObjSet( common_impl.hint["use_sharpteeth_angels"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sharpteeth_angels", private.use_sharpteeth_angels_inv );
cmn.AddSubscriber( "use_sharpteeth_angels", private.use_sharpteeth_angels_beg, private.room_objname );
cmn.AddSubscriber( "use_sharpteeth_angels", private.use_sharpteeth_angels_end, private.room_objname );
cmn.AddSubscriber( "use_sharpteeth_angels", private.use_sharpteeth_angels_logic );
cmn.AddSubscriber( "use_sharpteeth_angels_inv", private.use_sharpteeth_angels_inv, private.room_objname );
cmn.AddSubscriber( "use_sharpteeth_angels_beg", private.use_sharpteeth_angels_beg, private.room_objname );
cmn.AddSubscriber( "use_sharpteeth_angels_end", private.use_sharpteeth_angels_end, private.room_objname );
cmn.AddSubscriber( "use_sharpteeth_angels_end", private.use_sharpteeth_angels_logic );
--------------------------------------------------------------------------------------------
function public.use_sharpteeth_angels( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_sharpteeth_angels" );
    cmn.CallEventHandler( "use_sharpteeth_angels_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_sharpteeth_angels") then ld.CloseSubRoom() end;
    public.get_splinter()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sharpteeth_angels_inv" );
  cmn.CallEventHandler( "use_sharpteeth_angels_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_angels_anim_angels_teeth", "use_teeth", func_end );
  SoundSfx( "aud_use_sharpteeth_angels" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_splinter" ] = { type = "get", get_obj = "spr_angels_splinter", room = "rm_newyard", zz = "zz_angels", zz_gate = "gzz_newyard_angels" };

private.get_splinter_logic = function()
  
end;
private.get_splinter_inv = function()
  interface.InventoryItemAdd("inv_splinter","spr_angels_splinter");
end;
private.get_splinter_beg = function()
  ObjDelete("gfx_angels_splinter")
end;
private.get_splinter_end = function()
  ObjDelete("spr_newyard_splinter")
  if common_impl.ZzCompleteCheck("get_splinter") then ObjSet( common_impl.hint["get_splinter"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_splinter", private.get_splinter_inv );
cmn.AddSubscriber( "get_splinter", private.get_splinter_beg, private.room_objname );
cmn.AddSubscriber( "get_splinter", private.get_splinter_end, private.room_objname );
cmn.AddSubscriber( "get_splinter", private.get_splinter_logic );
--------------------------------------------------------------------
function public.get_splinter()
  cmn.SetEventDone( "get_splinter" );
  cmn.CallEventHandler( "get_splinter" );
  if common_impl.ZzCompleteCheck("get_splinter") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_nimbus" ] = { type = "use", inv_obj = "inv_nimbus", use_place = "gfx_angels_nimbus_zone", room = "rm_newyard", zz = "zz_angels", zz_gate = "gzz_newyard_angels" };

private.use_nimbus_logic = function()
  ObjSet( "spr_angels_balconyhandle", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_angels_seastar1", { visible = 1, input = 1, active = 1 } )

end;
private.use_nimbus_inv = function()
  common_impl.ProcessMultiUseAll("nimbus", "nimbus")
end;
private.use_nimbus_beg = function()
  ObjDelete( "gfx_angels_nimbus_zone" );
end;
private.use_nimbus_end = function()
  ObjSet( "spr_newyard_angel_openhand", {visible = 1} );
  ObjSet( "spr_newyard_nimbus", {visible = 1} );
  ObjSet( "anm_angels_anim_angels_nimb", {animfunc = "use_nimb_end"} );
  if common_impl.ZzCompleteCheck("use_nimbus") then ObjSet( common_impl.hint["use_nimbus"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_nimbus", private.use_nimbus_inv );
cmn.AddSubscriber( "use_nimbus", private.use_nimbus_beg, private.room_objname );
cmn.AddSubscriber( "use_nimbus", private.use_nimbus_end, private.room_objname );
cmn.AddSubscriber( "use_nimbus", private.use_nimbus_logic );
cmn.AddSubscriber( "use_nimbus_inv", private.use_nimbus_inv, private.room_objname );
cmn.AddSubscriber( "use_nimbus_beg", private.use_nimbus_beg, private.room_objname );
cmn.AddSubscriber( "use_nimbus_end", private.use_nimbus_end, private.room_objname );
cmn.AddSubscriber( "use_nimbus_end", private.use_nimbus_logic );
--------------------------------------------------------------------------------------------
function public.use_nimbus( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_nimbus" );
    cmn.CallEventHandler( "use_nimbus_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_nimbus") then ld.CloseSubRoom() end;
    public.get_seastar1()
    public.get_balconyhandle()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_nimbus_inv" );
  cmn.CallEventHandler( "use_nimbus_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_angels_anim_angels_nimb", "use_nimb", func_end );
  SoundSfx( "aud_use_nimbus_newyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_balconyhandle" ] = { type = "get", get_obj = "spr_angels_balconyhandle", room = "rm_newyard", zz = "zz_angels", zz_gate = "gzz_newyard_angels" };

private.get_balconyhandle_logic = function()
  
end;
private.get_balconyhandle_inv = function()
  interface.InventoryItemAdd("inv_balconyhandle","spr_angels_balconyhandle");
end;
private.get_balconyhandle_beg = function()
  ObjDelete("gfx_angels_balconyhandle")
end;
private.get_balconyhandle_end = function()
  if common_impl.ZzCompleteCheck("get_balconyhandle") then ObjSet( common_impl.hint["get_balconyhandle"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_balconyhandle", private.get_balconyhandle_inv );
cmn.AddSubscriber( "get_balconyhandle", private.get_balconyhandle_beg, private.room_objname );
cmn.AddSubscriber( "get_balconyhandle", private.get_balconyhandle_end, private.room_objname );
cmn.AddSubscriber( "get_balconyhandle", private.get_balconyhandle_logic );
--------------------------------------------------------------------
function public.get_balconyhandle()
  cmn.SetEventDone( "get_balconyhandle" );
  cmn.CallEventHandler( "get_balconyhandle" );
  if common_impl.ZzCompleteCheck("get_balconyhandle") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_seastar1" ] = { type = "get", get_obj = "spr_angels_seastar1", room = "rm_newyard", zz = "zz_angels", zz_gate = "gzz_newyard_angels" };

private.get_seastar1_logic = function()
  
end;
private.get_seastar1_inv = function()
  interface.InventoryItemAdd("inv_seastar1","spr_angels_seastar1");
end;
private.get_seastar1_beg = function()
  ObjDelete("gfx_angels_seastar1")
end;
private.get_seastar1_end = function()
  if common_impl.ZzCompleteCheck("get_seastar1") then ObjSet( common_impl.hint["get_seastar1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_seastar1", private.get_seastar1_inv );
cmn.AddSubscriber( "get_seastar1", private.get_seastar1_beg, private.room_objname );
cmn.AddSubscriber( "get_seastar1", private.get_seastar1_end, private.room_objname );
cmn.AddSubscriber( "get_seastar1", private.get_seastar1_logic );
--------------------------------------------------------------------
function public.get_seastar1()
  cmn.SetEventDone( "get_seastar1" );
  cmn.CallEventHandler( "get_seastar1" );
  if common_impl.ZzCompleteCheck("get_seastar1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_newangel" ] = { type = "use", inv_obj = "inv_newangel", use_place = "gfx_angels_newangel_zone", room = "rm_newyard", zz = "zz_angels", zz_gate = "gzz_newyard_angels" };

private.use_newangel_logic = function()
  ObjSet( "spr_angels_oldbook2", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_angels_boytoy", { visible = 1, input = 1, active = 1 } )

end;
private.use_newangel_inv = function()
  common_impl.ProcessMultiUseAll("newangel", "newangel")
end;
private.use_newangel_beg = function()
  ObjSet( "spr_angels_oldbook2", { visible = 1 } )
  ObjSet( "spr_angels_boytoy", { visible = 1 } )
  ObjDelete( "gfx_angels_newangel_zone" );
end;
private.use_newangel_end = function()
  ObjSet( "spr_newyard_angel", {visible = 1} );
  ObjDelete("spr_newyard_cover")
  ObjSet( "gfx_angels_boytoy", {active = 1, visible = 1} );
  ObjSet( "gfx_angels_oldbook2", {active = 1, visible = 1} );
  ObjSet( "anm_angels_anim_angels_angel", {animfunc = "use_angel", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_newangel") then ObjSet( common_impl.hint["use_newangel"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_newangel", private.use_newangel_inv );
cmn.AddSubscriber( "use_newangel", private.use_newangel_beg, private.room_objname );
cmn.AddSubscriber( "use_newangel", private.use_newangel_end, private.room_objname );
cmn.AddSubscriber( "use_newangel", private.use_newangel_logic );
cmn.AddSubscriber( "use_newangel_inv", private.use_newangel_inv, private.room_objname );
cmn.AddSubscriber( "use_newangel_beg", private.use_newangel_beg, private.room_objname );
cmn.AddSubscriber( "use_newangel_end", private.use_newangel_end, private.room_objname );
cmn.AddSubscriber( "use_newangel_end", private.use_newangel_logic );
--------------------------------------------------------------------------------------------
function public.use_newangel( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_newangel" );
    cmn.CallEventHandler( "use_newangel_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_newangel") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_newangel_inv" );
  cmn.CallEventHandler( "use_newangel_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_angels_anim_angels_angel", "use_angel", func_end );
  SoundSfx( "aud_use_newangel_newyard" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_oldbook2" ] = { type = "get", get_obj = "spr_angels_oldbook2", room = "rm_newyard", zz = "zz_angels", zz_gate = "gzz_newyard_angels" };

private.get_oldbook2_logic = function()
  
end;
private.get_oldbook2_inv = function()
  interface.InventoryItemAdd("inv_oldbook2","spr_angels_oldbook2");
end;
private.get_oldbook2_beg = function()
  ObjDelete("gfx_angels_oldbook2")
end;
private.get_oldbook2_end = function()
  if common_impl.ZzCompleteCheck("get_oldbook2") then ObjSet( common_impl.hint["get_oldbook2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_oldbook2", private.get_oldbook2_inv );
cmn.AddSubscriber( "get_oldbook2", private.get_oldbook2_beg, private.room_objname );
cmn.AddSubscriber( "get_oldbook2", private.get_oldbook2_end, private.room_objname );
cmn.AddSubscriber( "get_oldbook2", private.get_oldbook2_logic );
--------------------------------------------------------------------
function public.get_oldbook2()
  cmn.SetEventDone( "get_oldbook2" );
  cmn.CallEventHandler( "get_oldbook2" );
  if common_impl.ZzCompleteCheck("get_oldbook2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_boytoy" ] = { type = "get", get_obj = "spr_angels_boytoy", room = "rm_newyard", zz = "zz_angels", zz_gate = "gzz_newyard_angels" };

private.get_boytoy_logic = function()
  
end;
private.get_boytoy_inv = function()
  interface.InventoryItemAdd("inv_boytoy","spr_angels_boytoy");
end;
private.get_boytoy_beg = function()
  ObjDelete("gfx_angels_boytoy")
end;
private.get_boytoy_end = function()
  if common_impl.ZzCompleteCheck("get_boytoy") then ObjSet( common_impl.hint["get_boytoy"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_boytoy", private.get_boytoy_inv );
cmn.AddSubscriber( "get_boytoy", private.get_boytoy_beg, private.room_objname );
cmn.AddSubscriber( "get_boytoy", private.get_boytoy_end, private.room_objname );
cmn.AddSubscriber( "get_boytoy", private.get_boytoy_logic );
--------------------------------------------------------------------
function public.get_boytoy()
  cmn.SetEventDone( "get_boytoy" );
  cmn.CallEventHandler( "get_boytoy" );
  if common_impl.ZzCompleteCheck("get_boytoy") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_fight_for_newyard = function()
    if ld.CheckRequirements( {"win_fight"} ) then
      --ObjSet( "gmg_newyard_fight", {input = 0, visible = 0} );
    end
  end;
  cmn.AddSubscriber("win_fight", win_fight_for_newyard, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_newyard();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_river_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_angels" );
  function zz_angels.Open()
  end;
  function zz_angels.PreOpen()
  end;
  function zz_angels.PreClose()
  end;
  function zz_angels.Close()
  end;

  subroom.Define( "zz_lantern" );
  function zz_lantern.Open()
  end;
  function zz_lantern.PreOpen()
  end;
  function zz_lantern.PreClose()
  end;
  function zz_lantern.Close()
  end;

  subroom.Define( "zz_fountain" );
  function zz_fountain.Open()
  end;
  function zz_fountain.PreOpen()
  end;
  function zz_fountain.PreClose()
  end;
  function zz_fountain.Close()
  end;

  subroom.Define( "zz_newhalldoor" );
  function zz_newhalldoor.Open()
  end;
  function zz_newhalldoor.PreOpen()
  end;
  function zz_newhalldoor.PreClose()
  end;
  function zz_newhalldoor.Close()
  end;
  
end;
--*********************************************************************************************************************