-- name=rm_river
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_river";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
  SoundEnvInit( "aud_crying_girl_env", private.room_objname, false, { "dlg_river_chloe1" } )
  --------------------------------------------------------------------------------------------
function private.opn_river()
  if not ( cmn.IsEventDone( "opn_river" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_river" );
      cmn.CallEventHandler( "opn_river" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_river = function() end;
local opn_river_logic = function() end;
cmn.AddSubscriber( "opn_river", opn_river_logic )
cmn.AddSubscriber( "opn_river", opn_river, private.room_objname )
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "chloe1" then
    if count_txt == 1 then
      common_impl.continue_visible = true
      ld.AnimPlay( "anm_river_chloe1", "give", "" )
      SoundSfx( "aud_chloe_give_us" )
    elseif count_txt == 2 then
      ld.AnimPlay( "anm_shop_michael2", "give_end", "" )
      cmn.CallEventHandler( "get_brokenbrooch" );
    end
  elseif dlg_name == "chloe2" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    elseif count_txt == 2 then 
    end
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_girlsdoll" ] = { type = "use", inv_obj = "inv_girlsdoll", use_place = "gfx_river_girlsdoll_zone", room = "rm_river" };

private.use_girlsdoll_logic = function()
  --ObjSet( "gfx_river_dlg_river_chloe1_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_girlsdoll_inv = function()
  common_impl.ProcessMultiUseAll("girlsdoll", "girlsdoll")
end;
private.use_girlsdoll_beg = function()
  ObjDelete( "gfx_river_girlsdoll_zone" );
end;
private.use_girlsdoll_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_girlsdoll", private.use_girlsdoll_inv );
cmn.AddSubscriber( "use_girlsdoll", private.use_girlsdoll_beg, private.room_objname );
cmn.AddSubscriber( "use_girlsdoll", private.use_girlsdoll_end, private.room_objname );
cmn.AddSubscriber( "use_girlsdoll", private.use_girlsdoll_logic );
cmn.AddSubscriber( "use_girlsdoll_inv", private.use_girlsdoll_inv, private.room_objname );
cmn.AddSubscriber( "use_girlsdoll_beg", private.use_girlsdoll_beg, private.room_objname );
cmn.AddSubscriber( "use_girlsdoll_end", private.use_girlsdoll_end, private.room_objname );
cmn.AddSubscriber( "use_girlsdoll_end", private.use_girlsdoll_logic );
--------------------------------------------------------------------------------------------
function public.use_girlsdoll( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    
    cmn.CallEventHandler( "use_girlsdoll_end" );
    common_impl.Lock(0);
    public.dlg_river_chloe1( obj )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_girlsdoll_inv" );
  cmn.CallEventHandler( "use_girlsdoll_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_river_chloe1" ] = { type = "click", use_place = "gfx_river_dlg_river_chloe1_zone", room = "rm_river" };

private.dlg_river_chloe1_logic = function()
  ObjSet( "spr_river_brokenbrooch", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_river_chloebrooch_zone", { visible = 1, input = 1, active = 1 } )
  --ObjSet( "spr_river_bluntscates", {input = 1} );
  --ObjSet( "spr_river_bread", {input = 1} );
  --ObjSet( "gfx_river_scates_zone", {active = 1, input = 1, visible = 1} );
end;
private.dlg_river_chloe1_beg = function()
  ObjDelete( "gfx_river_dlg_river_chloe1_zone" );
end;
private.dlg_river_chloe1_end = function()
  ObjSet( "anm_river_anim_hloya", {visible = 0} );
  ObjSet( "anm_river_anim_hloya_2", {visible = 1} );
  ObjSet( "spr_river_smalldoll", {visible = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_river_chloe1", private.dlg_river_chloe1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_river_chloe1", private.dlg_river_chloe1_end, private.room_objname );
cmn.AddSubscriber( "dlg_river_chloe1", private.dlg_river_chloe1_logic );
cmn.AddSubscriber( "dlg_river_chloe1_beg", private.dlg_river_chloe1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_river_chloe1_end", private.dlg_river_chloe1_end, private.room_objname );
cmn.AddSubscriber( "dlg_river_chloe1_end", private.dlg_river_chloe1_logic );
--------------------------------------------------------------------------------------------
function public.dlg_river_chloe1( obj )

  local func_end = function()
    cmn.SetEventDone( "get_brokenbrooch" );
    cmn.SetEventDone( "use_girlsdoll" );
    cmn.SetEventDone( "dlg_river_chloe1" );
    cmn.CallEventHandler( "dlg_river_chloe1_end" );
    common_impl.Lock(0);
  end;
  function public.dlg_river_chloe1_func_end()
    common_impl.Lock(1);
    if ObjGetRelations( "inv_brokenbrooch" ).parent == "level_inv_hub" then
      cmn.CallEventHandler( "get_brokenbrooch" );
    end  
    func_end()
  end
  SoundEnv( "aud_crying_girl_env", 0 )
  cmn.CallEventHandler( "dlg_river_chloe1_beg" );
  common_impl.dialog_character_loc = "obj_river_hloya";
  common_impl.Start( "chloe1", 2, nil, nil, true, "dlg_river_chloe1_func_end", { "aud_chloe_1_voc" } );  
end;

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_brokenbrooch" ] = { type = "get", get_obj = "spr_river_brokenbrooch", room = "rm_river" };

private.get_brokenbrooch_logic = function()
  
end;
private.get_brokenbrooch_inv = function()
  interface.InventoryItemAdd("inv_brokenbrooch","spr_river_brokenbrooch");
  ObjSet( "inv_brokenbrooch", { drag = 0 } );
end;
private.get_brokenbrooch_beg = function()
  ObjDelete("gfx_river_brokenbrooch")
  ObjSet( "spr_river_brokenbrooch", {visible = 1} );
end;
private.get_brokenbrooch_end = function()
  
end;

cmn.AddSubscriber( "get_brokenbrooch", private.get_brokenbrooch_inv );
cmn.AddSubscriber( "get_brokenbrooch", private.get_brokenbrooch_beg, private.room_objname );
cmn.AddSubscriber( "get_brokenbrooch", private.get_brokenbrooch_end, private.room_objname );
cmn.AddSubscriber( "get_brokenbrooch", private.get_brokenbrooch_logic );
--------------------------------------------------------------------
function public.get_brokenbrooch()
  cmn.SetEventDone( "get_brokenbrooch" );
  cmn.CallEventHandler( "get_brokenbrooch" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bluntscates" ] = { type = "get", get_obj = "spr_river_bluntscates", room = "rm_river" };

private.get_bluntscates_logic = function()
  
end;
private.get_bluntscates_inv = function()
  interface.InventoryItemAdd("inv_bluntscates","spr_river_bluntscates");
end;
private.get_bluntscates_beg = function()
  ObjDelete("gfx_river_bluntscates")
end;
private.get_bluntscates_end = function()
  ObjDelete("spr_river_bluntscates_shadow")
end;

cmn.AddSubscriber( "get_bluntscates", private.get_bluntscates_inv );
cmn.AddSubscriber( "get_bluntscates", private.get_bluntscates_beg, private.room_objname );
cmn.AddSubscriber( "get_bluntscates", private.get_bluntscates_end, private.room_objname );
cmn.AddSubscriber( "get_bluntscates", private.get_bluntscates_logic );
--------------------------------------------------------------------
function public.get_bluntscates()
  cmn.SetEventDone( "get_bluntscates" );
  cmn.CallEventHandler( "get_bluntscates" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bread" ] = { type = "get", get_obj = "spr_river_bread", room = "rm_river" };

private.get_bread_logic = function()
  
end;
private.get_bread_inv = function()
  interface.InventoryItemAdd("inv_bread","spr_river_bread");
end;
private.get_bread_beg = function()
  ObjDelete("gfx_river_bread")
end;
private.get_bread_end = function()
  
end;

cmn.AddSubscriber( "get_bread", private.get_bread_inv );
cmn.AddSubscriber( "get_bread", private.get_bread_beg, private.room_objname );
cmn.AddSubscriber( "get_bread", private.get_bread_end, private.room_objname );
cmn.AddSubscriber( "get_bread", private.get_bread_logic );
--------------------------------------------------------------------
function public.get_bread()
  cmn.SetEventDone( "get_bread" );
  cmn.CallEventHandler( "get_bread" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_scates" ] = { type = "use", inv_obj = "inv_scates", use_place = "gfx_river_scates_zone", room = "rm_river" };

private.use_scates_logic = function()
  ObjSet( "gzz_river_icehole", { visible = 1, input = 1, active = 1 } )

end;
private.use_scates_inv = function()
  common_impl.ProcessMultiUseAll("scates", "scates")
end;
private.use_scates_beg = function()
  ObjDelete( "gfx_river_scates_zone" );
  ObjSet( "anm_river_anim_river_scates", {visible = 1} );
end;
private.use_scates_end = function()
  ObjSet( "anm_river_anim_river_scates", {animfunc = "az", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_scates", private.use_scates_inv );
cmn.AddSubscriber( "use_scates", private.use_scates_beg, private.room_objname );
cmn.AddSubscriber( "use_scates", private.use_scates_end, private.room_objname );
cmn.AddSubscriber( "use_scates", private.use_scates_logic );
cmn.AddSubscriber( "use_scates_inv", private.use_scates_inv, private.room_objname );
cmn.AddSubscriber( "use_scates_beg", private.use_scates_beg, private.room_objname );
cmn.AddSubscriber( "use_scates_end", private.use_scates_end, private.room_objname );
cmn.AddSubscriber( "use_scates_end", private.use_scates_logic );
--------------------------------------------------------------------------------------------
function public.use_scates( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_scates" );
    cmn.CallEventHandler( "use_scates_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_scates_inv" );
  cmn.CallEventHandler( "use_scates_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_river_anim_river_scates", "az", func_end );
  SoundSfx( "aud_iceskate" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_chloebrooch" ] = { type = "use", inv_obj = "inv_chloebrooch", use_place = "gfx_river_chloebrooch_zone", room = "rm_river" };

private.use_chloebrooch_logic = function()
  ObjSet( "gfx_river_goodbrooch_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gho_river_elfho", { visible = 1, input = 1, active = 1 } )
end;
private.use_chloebrooch_inv = function()
  common_impl.ProcessMultiUseAll("chloebrooch", "chloebrooch")
end;
private.use_chloebrooch_beg = function()
  ObjDelete( "gfx_river_chloebrooch_zone" );
end;
private.use_chloebrooch_end = function()
  ObjSet( "anm_river_anim_hloya", {visible = 1} );
  ObjSet( "anm_river_anim_hloya_2", {visible = 0, alp = 1} );
  ObjAttach("vid_river_grumpy_wait","rm_river")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_chloebrooch", private.use_chloebrooch_inv );
cmn.AddSubscriber( "use_chloebrooch", private.use_chloebrooch_beg, private.room_objname );
cmn.AddSubscriber( "use_chloebrooch", private.use_chloebrooch_end, private.room_objname );
cmn.AddSubscriber( "use_chloebrooch", private.use_chloebrooch_logic );
cmn.AddSubscriber( "use_chloebrooch_inv", private.use_chloebrooch_inv, private.room_objname );
cmn.AddSubscriber( "use_chloebrooch_beg", private.use_chloebrooch_beg, private.room_objname );
cmn.AddSubscriber( "use_chloebrooch_end", private.use_chloebrooch_end, private.room_objname );
cmn.AddSubscriber( "use_chloebrooch_end", private.use_chloebrooch_logic );
--------------------------------------------------------------------------------------------
function public.use_chloebrooch( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_chloebrooch" );
    cmn.CallEventHandler( "use_chloebrooch_end" );
    common_impl.Lock(0);
    ObjDelete("vid_river_grumpy_stole")
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_chloebrooch_inv" );
  cmn.CallEventHandler( "use_chloebrooch_beg" );
  common_impl.Lock(1);

  ObjAnimate( "anm_river_anim_hloya_2", 8, 0, 0, function() end, {0,0,1, 0.5,1,0} );
  ObjAnimate( "vid_river_grumpy_stole", 8, 0, 0, function() end, {0,0,0, 0.5,2,1} );
  ObjAttach("vid_river_grumpy_stole","rm_river")
  SoundVid( "aud_grumpy_stole" )
  VidPlay("vid_river_grumpy_stole", function() 
    SoundVid( 0 )
    ObjAttach("vid_river_grumpy_wait","rm_river")
    ObjAnimate( "vid_river_grumpy_wait", 8, 0, 0, function() end, {0,0,0, 0.5,2,1} );
    ObjSet( "anm_river_anim_hloya", {visible = 1} );
    ObjAnimate( "anm_river_anim_hloya", 8, 0, 0, function() end, {0,0,0, 0.5,2,1} );
    ObjAnimate( "vid_river_grumpy_stole", 8, 0, 0, function() func_end() end, {0,0,1, 0.5,1,0} );
 end)
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_goodbrooch" ] = { type = "use", inv_obj = "inv_goodbrooch", use_place = "gfx_river_goodbrooch_zone", room = "rm_river" };

private.use_goodbrooch_logic = function()

  --ObjSet( "gfx_river_dlg_river_chloe2_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_goodbrooch_inv = function()
  common_impl.ProcessMultiUseAll("goodbrooch", "goodbrooch")
end;
private.use_goodbrooch_beg = function()
  ObjDelete( "gfx_river_goodbrooch_zone" );
end;
private.use_goodbrooch_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_goodbrooch", private.use_goodbrooch_inv );
cmn.AddSubscriber( "use_goodbrooch", private.use_goodbrooch_beg, private.room_objname );
cmn.AddSubscriber( "use_goodbrooch", private.use_goodbrooch_end, private.room_objname );
cmn.AddSubscriber( "use_goodbrooch", private.use_goodbrooch_logic );
cmn.AddSubscriber( "use_goodbrooch_inv", private.use_goodbrooch_inv, private.room_objname );
cmn.AddSubscriber( "use_goodbrooch_beg", private.use_goodbrooch_beg, private.room_objname );
cmn.AddSubscriber( "use_goodbrooch_end", private.use_goodbrooch_end, private.room_objname );
cmn.AddSubscriber( "use_goodbrooch_end", private.use_goodbrooch_logic );
--------------------------------------------------------------------------------------------
function public.use_goodbrooch( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.CallEventHandler( "use_goodbrooch_end" );
    common_impl.Lock(0);
    public.dlg_river_chloe2( obj )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_goodbrooch_inv" );
  cmn.CallEventHandler( "use_goodbrooch_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_river_chloe2" ] = { type = "click", use_place = "gfx_river_dlg_river_chloe2_zone", room = "rm_river" };

private.dlg_river_chloe2_logic = function()

end;
private.dlg_river_chloe2_beg = function()
  ObjDelete( "gfx_river_dlg_river_chloe2_zone" );
end;
private.dlg_river_chloe2_end = function()
  ObjDelete("obj_river_hloya")
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_river_chloe2", private.dlg_river_chloe2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_river_chloe2", private.dlg_river_chloe2_end, private.room_objname );
cmn.AddSubscriber( "dlg_river_chloe2", private.dlg_river_chloe2_logic );
cmn.AddSubscriber( "dlg_river_chloe2_beg", private.dlg_river_chloe2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_river_chloe2_end", private.dlg_river_chloe2_end, private.room_objname );
cmn.AddSubscriber( "dlg_river_chloe2_end", private.dlg_river_chloe2_logic );
--------------------------------------------------------------------------------------------
function public.dlg_river_chloe2( obj )

  local func_end = function()
    cmn.SetEventDone( "use_goodbrooch" );
    cmn.SetEventDone( "dlg_river_chloe2" );
    cmn.CallEventHandler( "dlg_river_chloe2_end" );
    common_impl.Lock(0);
  end;
  function public.dlg_river_chloe2_func_end()
    common_impl.Lock(1);
    func_end()
  end
  SoundEnv( "aud_crying_girl_env", 0 )
  cmn.CallEventHandler( "dlg_river_chloe2_beg" );
  common_impl.dialog_character_loc = "obj_river_hloya";
  common_impl.Start( "chloe2", 2, nil, nil, true, "dlg_river_chloe2_func_end", { "aud_chloe_2_voc" } );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_icehole *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_forceps" ] = { type = "get", get_obj = "spr_icehole_forceps", room = "rm_river", zz = "zz_icehole", zz_gate = "gzz_river_icehole" };

private.get_forceps_logic = function()
  
end;
private.get_forceps_inv = function()
  interface.InventoryItemAdd("inv_forceps","spr_icehole_forceps");
end;
private.get_forceps_beg = function()
  ObjDelete("gfx_icehole_forceps")
end;
private.get_forceps_end = function()
  ObjDelete("spr_icehole_forceps_shadow")
  if common_impl.ZzCompleteCheck("get_forceps") then ObjSet( common_impl.hint["get_forceps"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_forceps", private.get_forceps_inv );
cmn.AddSubscriber( "get_forceps", private.get_forceps_beg, private.room_objname );
cmn.AddSubscriber( "get_forceps", private.get_forceps_end, private.room_objname );
cmn.AddSubscriber( "get_forceps", private.get_forceps_logic );
--------------------------------------------------------------------
function public.get_forceps()
  cmn.SetEventDone( "get_forceps" );
  cmn.CallEventHandler( "get_forceps" );
  if common_impl.ZzCompleteCheck("get_forceps") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_fishingline" ] = { type = "get", get_obj = "spr_icehole_fishingline", room = "rm_river", zz = "zz_icehole", zz_gate = "gzz_river_icehole" };

private.get_fishingline_logic = function()
  
end;
private.get_fishingline_inv = function()
  interface.InventoryItemAdd("inv_fishingline","spr_icehole_fishingline");
end;
private.get_fishingline_beg = function()
  ObjDelete("gfx_icehole_fishingline")
end;
private.get_fishingline_end = function()
  if common_impl.ZzCompleteCheck("get_fishingline") then ObjSet( common_impl.hint["get_fishingline"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_fishingline", private.get_fishingline_inv );
cmn.AddSubscriber( "get_fishingline", private.get_fishingline_beg, private.room_objname );
cmn.AddSubscriber( "get_fishingline", private.get_fishingline_end, private.room_objname );
cmn.AddSubscriber( "get_fishingline", private.get_fishingline_logic );
--------------------------------------------------------------------
function public.get_fishingline()
  cmn.SetEventDone( "get_fishingline" );
  cmn.CallEventHandler( "get_fishingline" );
  if common_impl.ZzCompleteCheck("get_fishingline") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_linedmagnet_icehole1" ] = { type = "use", inv_obj = "inv_linedmagnet", use_place = "gfx_icehole_linedmagnet_icehole1_zone", room = "rm_river", zz = "zz_icehole", zz_gate = "gzz_river_icehole" };

private.use_linedmagnet_icehole1_logic = function()
  ObjSet( "gfx_icehole_clk_linedmagnet1_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_linedmagnet_icehole1_inv = function()
  common_impl.ProcessMultiUseAll("linedmagnet", "linedmagnet_icehole1")
  interface.InventoryItemRemove("inv_linedmagnet")
end;
private.use_linedmagnet_icehole1_beg = function()
  ObjDelete( "gfx_icehole_linedmagnet_icehole1_zone" );
end;
private.use_linedmagnet_icehole1_end = function()
  ObjSet( "anm_icehole_anim_icehole", {animfunc = "fishing_bank_2", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_linedmagnet_icehole1") then ObjSet( common_impl.hint["use_linedmagnet_icehole1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_linedmagnet_icehole1", private.use_linedmagnet_icehole1_inv );
cmn.AddSubscriber( "use_linedmagnet_icehole1", private.use_linedmagnet_icehole1_beg, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole1", private.use_linedmagnet_icehole1_end, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole1", private.use_linedmagnet_icehole1_logic );
cmn.AddSubscriber( "use_linedmagnet_icehole1_inv", private.use_linedmagnet_icehole1_inv, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole1_beg", private.use_linedmagnet_icehole1_beg, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole1_end", private.use_linedmagnet_icehole1_end, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole1_end", private.use_linedmagnet_icehole1_logic );
--------------------------------------------------------------------------------------------
function public.use_linedmagnet_icehole1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_linedmagnet_icehole1" );
    cmn.CallEventHandler( "use_linedmagnet_icehole1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_linedmagnet_icehole1") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_linedmagnet_icehole1_inv" );
  cmn.CallEventHandler( "use_linedmagnet_icehole1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_icehole_anim_icehole", "fishing_bank_1", func_end );
  SoundSfx( "aud_magnetonfishingline" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_linedmagnet1" ] = { type = "click", use_place = "gfx_icehole_clk_linedmagnet1_zone", room = "rm_river", zz = "zz_icehole", zz_gate = "gzz_river_icehole" };

private.clk_linedmagnet1_logic = function()
  interface.InventoryItemAdd("inv_linedmagnet","");
end;
private.clk_linedmagnet1_logic_2 = function()
  ObjSet( "gfx_icehole_linedmagnet_icehole2_zone", { visible = 1, input = 1, active = 1 } )
end;
private.clk_linedmagnet1_beg = function()
  ObjDelete( "gfx_icehole_clk_linedmagnet1_zone" );
end;
private.clk_linedmagnet1_end = function()
  ObjSet( "anm_icehole_anim_icehole", {animfunc = "fishing_ship_1", frame = 0 } );
  ObjSet( "anm_icehole_anim_icehole_bank", {visible = 1} );
  if common_impl.ZzCompleteCheck("clk_linedmagnet1") then ObjSet( common_impl.hint["clk_linedmagnet1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_linedmagnet1", private.clk_linedmagnet1_beg, private.room_objname );
cmn.AddSubscriber( "clk_linedmagnet1", private.clk_linedmagnet1_end, private.room_objname );
cmn.AddSubscriber( "clk_linedmagnet1", private.clk_linedmagnet1_logic );
cmn.AddSubscriber( "clk_linedmagnet1", private.clk_linedmagnet1_logic_2 );

cmn.AddSubscriber( "clk_linedmagnet1_beg", private.clk_linedmagnet1_beg, private.room_objname );
cmn.AddSubscriber( "clk_linedmagnet1_end", private.clk_linedmagnet1_end, private.room_objname );
cmn.AddSubscriber( "clk_linedmagnet1_end", private.clk_linedmagnet1_logic );
cmn.AddSubscriber( "clk_linedmagnet1_end_2", private.clk_linedmagnet1_logic_2 );
--------------------------------------------------------------------------------------------
function public.clk_linedmagnet1()

  local func_end = function()
    ld.ShowBbt( "after_linedmagnet_on_icehole" )
    cmn.SetEventDone( "clk_linedmagnet1" );
    cmn.CallEventHandler( "clk_linedmagnet1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_linedmagnet1") then ld.CloseSubRoom() end;

    ObjStartDrag( "inv_linedmagnet" )
    --int_inventory.StartDragInvItem( "inv_linedmagnet" )
    ObjSet( "inv_linedmagnet", {visible = 0} );
    ld.Lock(1)
    ld.StartTimer( 0.35, function() ObjSet( "inv_linedmagnet", {visible = 1} ); ld.Lock(0) cmn.CallEventHandler( "clk_linedmagnet1_end_2" ); end )
  end;

  cmn.CallEventHandler( "clk_linedmagnet1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_icehole_anim_icehole", "fishing_bank_2", func_end );
  SoundSfx( "aud_put_on_the_snow" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_linedmagnet_icehole2" ] = { type = "use", inv_obj = "inv_linedmagnet", use_place = "gfx_icehole_linedmagnet_icehole2_zone", room = "rm_river", zz = "zz_icehole", zz_gate = "gzz_river_icehole" };

private.use_linedmagnet_icehole2_logic = function()
  ObjSet( "gfx_icehole_clk_linedmagnet2_zone", { visible = 1, input = 1, active = 1 } )
end;
private.use_linedmagnet_icehole2_inv = function()
  common_impl.ProcessMultiUseAll("linedmagnet", "linedmagnet_icehole2")
  interface.InventoryItemRemove("inv_linedmagnet")
end;
private.use_linedmagnet_icehole2_beg = function()
  ObjDelete( "gfx_icehole_linedmagnet_icehole2_zone" );
end;
private.use_linedmagnet_icehole2_end = function()
  ObjSet( "anm_icehole_anim_icehole", {animfunc = "fishing_ship_2", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_linedmagnet_icehole2") then ObjSet( common_impl.hint["use_linedmagnet_icehole2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_linedmagnet_icehole2", private.use_linedmagnet_icehole2_inv );
cmn.AddSubscriber( "use_linedmagnet_icehole2", private.use_linedmagnet_icehole2_beg, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole2", private.use_linedmagnet_icehole2_end, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole2", private.use_linedmagnet_icehole2_logic );
cmn.AddSubscriber( "use_linedmagnet_icehole2_inv", private.use_linedmagnet_icehole2_inv, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole2_beg", private.use_linedmagnet_icehole2_beg, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole2_end", private.use_linedmagnet_icehole2_end, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole2_end", private.use_linedmagnet_icehole2_logic );
--------------------------------------------------------------------------------------------
function public.use_linedmagnet_icehole2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_linedmagnet_icehole2" );
    cmn.CallEventHandler( "use_linedmagnet_icehole2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_linedmagnet_icehole2") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_linedmagnet_icehole2_inv" );
  cmn.CallEventHandler( "use_linedmagnet_icehole2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_icehole_anim_icehole", "fishing_ship_1", func_end );
  SoundSfx( "aud_magnetonfishingline" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_linedmagnet2" ] = { type = "click", use_place = "gfx_icehole_clk_linedmagnet2_zone", room = "rm_river", zz = "zz_icehole", zz_gate = "gzz_river_icehole" };

private.clk_linedmagnet2_logic = function()
  interface.InventoryItemAdd("inv_linedmagnet","");
end;
private.clk_linedmagnet2_logic_2 = function()
  ObjSet( "gfx_icehole_linedmagnet_icehole3_zone", { visible = 1, input = 1, active = 1 } )
end;
private.clk_linedmagnet2_beg = function()
  ObjDelete( "gfx_icehole_clk_linedmagnet2_zone" );
end;
private.clk_linedmagnet2_end = function()
  ObjSet( "anm_icehole_anim_icehole_ship", {visible = 1} );
  ObjSet( "anm_icehole_anim_icehole", {animfunc = "fishing_final_1", frame = 0 } );
  if common_impl.ZzCompleteCheck("clk_linedmagnet2") then ObjSet( common_impl.hint["clk_linedmagnet2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_linedmagnet2", private.clk_linedmagnet2_beg, private.room_objname );
cmn.AddSubscriber( "clk_linedmagnet2", private.clk_linedmagnet2_end, private.room_objname );
cmn.AddSubscriber( "clk_linedmagnet2", private.clk_linedmagnet2_logic );
cmn.AddSubscriber( "clk_linedmagnet2", private.clk_linedmagnet2_logic_2 );
cmn.AddSubscriber( "clk_linedmagnet2_beg", private.clk_linedmagnet2_beg, private.room_objname );
cmn.AddSubscriber( "clk_linedmagnet2_end", private.clk_linedmagnet2_end, private.room_objname );
cmn.AddSubscriber( "clk_linedmagnet2_end", private.clk_linedmagnet2_logic );
cmn.AddSubscriber( "clk_linedmagnet2_end_2", private.clk_linedmagnet2_logic_2 );
--------------------------------------------------------------------------------------------
function public.clk_linedmagnet2()

  local func_end = function()
    ObjAttach("itm_int_inventory_linedmagnet","ng_interface_transporter")
    ld.ShowBbt( "after_linedmagnet_on_icehole" )
    cmn.SetEventDone( "clk_linedmagnet2" );
    cmn.CallEventHandler( "clk_linedmagnet2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_linedmagnet2") then ld.CloseSubRoom() end;
    ObjStartDrag( "inv_linedmagnet" )
    ObjSet( "inv_linedmagnet", {visible = 0} );
    ld.Lock(1)
    ld.StartTimer( 0.35, function() ObjSet( "inv_linedmagnet", {visible = 1} ); ld.Lock(0) cmn.CallEventHandler( "clk_linedmagnet2_end_2" ); end )
  end;

  cmn.CallEventHandler( "clk_linedmagnet2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_icehole_anim_icehole", "fishing_ship_2", func_end );
  SoundSfx( "aud_put_on_the_snow" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_linedmagnet_icehole3" ] = { type = "use", inv_obj = "inv_linedmagnet", use_place = "gfx_icehole_linedmagnet_icehole3_zone", room = "rm_river", zz = "zz_icehole", zz_gate = "gzz_river_icehole" };

private.use_linedmagnet_icehole3_logic = function()
  ObjSet( "spr_icehole_ironpattern", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_icehole_amuletelf3", { visible = 1, input = 1, active = 1 } )

end;
private.use_linedmagnet_icehole3_inv = function()
  common_impl.ProcessMultiUseAll("linedmagnet", "linedmagnet_icehole3")
end;
private.use_linedmagnet_icehole3_beg = function()
  ObjDelete( "gfx_icehole_linedmagnet_icehole3_zone" );
end;
private.use_linedmagnet_icehole3_end = function()
  if common_impl.ZzCompleteCheck("use_linedmagnet_icehole3") then ObjSet( common_impl.hint["use_linedmagnet_icehole3"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_linedmagnet_icehole3", private.use_linedmagnet_icehole3_inv );
cmn.AddSubscriber( "use_linedmagnet_icehole3", private.use_linedmagnet_icehole3_beg, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole3", private.use_linedmagnet_icehole3_end, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole3", private.use_linedmagnet_icehole3_logic );
cmn.AddSubscriber( "use_linedmagnet_icehole3_inv", private.use_linedmagnet_icehole3_inv, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole3_beg", private.use_linedmagnet_icehole3_beg, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole3_end", private.use_linedmagnet_icehole3_end, private.room_objname );
cmn.AddSubscriber( "use_linedmagnet_icehole3_end", private.use_linedmagnet_icehole3_logic );
--------------------------------------------------------------------------------------------
function public.use_linedmagnet_icehole3( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_linedmagnet_icehole3" );
    cmn.CallEventHandler( "use_linedmagnet_icehole3_end" );
    public.get_amuletelf3()
    public.get_ironpattern()
    ld.AnimPlay( "anm_icehole_anim_icehole", "fishing_final_end", function() 
      if common_impl.ZzCompleteCheck("use_linedmagnet_icehole3") then ld.CloseSubRoom() end;
      common_impl.Lock(0);
    end );
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_linedmagnet_icehole3_inv" );
  cmn.CallEventHandler( "use_linedmagnet_icehole3_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_icehole_anim_icehole", "fishing_final_1", func_end );
  SoundSfx( "aud_magnetonfishingline" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_ironpattern" ] = { type = "get", get_obj = "spr_icehole_ironpattern", room = "rm_river", zz = "zz_icehole", zz_gate = "gzz_river_icehole" };

private.get_ironpattern_logic = function()
  
end;
private.get_ironpattern_inv = function()
  interface.InventoryItemAdd("inv_ironpattern","spr_icehole_ironpattern");
end;
private.get_ironpattern_beg = function()
  ObjDelete("gfx_icehole_ironpattern")
end;
private.get_ironpattern_end = function()
  if common_impl.ZzCompleteCheck("get_ironpattern") then ObjSet( common_impl.hint["get_ironpattern"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_ironpattern", private.get_ironpattern_inv );
cmn.AddSubscriber( "get_ironpattern", private.get_ironpattern_beg, private.room_objname );
cmn.AddSubscriber( "get_ironpattern", private.get_ironpattern_end, private.room_objname );
cmn.AddSubscriber( "get_ironpattern", private.get_ironpattern_logic );
--------------------------------------------------------------------
function public.get_ironpattern()
  cmn.SetEventDone( "get_ironpattern" );
  cmn.CallEventHandler( "get_ironpattern" );
  if common_impl.ZzCompleteCheck("get_ironpattern") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_amuletelf3" ] = { type = "get", get_obj = "spr_icehole_amuletelf3", room = "rm_river", zz = "zz_icehole", zz_gate = "gzz_river_icehole" };

private.get_amuletelf3_logic = function()
  
end;
private.get_amuletelf3_inv = function()
  interface.InventoryItemAdd("inv_amuletelf3","spr_icehole_amuletelf3");
end;
private.get_amuletelf3_beg = function()
  ObjDelete("gfx_icehole_amuletelf3")
end;
private.get_amuletelf3_end = function()
  if common_impl.ZzCompleteCheck("get_amuletelf3") then ObjSet( common_impl.hint["get_amuletelf3"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletelf3", private.get_amuletelf3_inv );
cmn.AddSubscriber( "get_amuletelf3", private.get_amuletelf3_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletelf3", private.get_amuletelf3_end, private.room_objname );
cmn.AddSubscriber( "get_amuletelf3", private.get_amuletelf3_logic );
--------------------------------------------------------------------
function public.get_amuletelf3()
  cmn.SetEventDone( "get_amuletelf3" );
  cmn.CallEventHandler( "get_amuletelf3" );
  if common_impl.ZzCompleteCheck("get_amuletelf3") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local win_elfho_for_river = function()
    if ld.CheckRequirements( {"win_elfho"} ) then
      ObjSet( "gho_river_elfho", {input = 0, visible = 0} );
      ObjDelete("vid_river_grumpy_wait")
    end
  end;
  cmn.AddSubscriber("win_elfho", win_elfho_for_river, private.room_objname )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_river();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_river_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_icehole" );
  function zz_icehole.Open()
  end;
  function zz_icehole.PreOpen()
  end;
  function zz_icehole.PreClose()
  end;
  function zz_icehole.Close()
  end;
  
end;
--*********************************************************************************************************************