-- name=rm_shop
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_shop";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("spr_brokenstatuete_note_small", "spr_brokenstatuete_note_big", "txt_brokenstatuete_note" )
  ld.NoteRelaseLock( "spr_brokenstatuete_note_small" )
  SoundEnvInit( "aud_rasping_env", private.room_objname, { "clk_boltinshop" } )
  --aud_rasping_env
  --------------------------------------------------------------------------------------------
function private.opn_shop()
  if not ( cmn.IsEventDone( "opn_shop" ) ) then
    local func_end = function()
        interface.DialogVideoSubtitleHide()
        ObjDelete( "tmr_opn_cabinet_vid_srt_1" )
        ObjDelete( "tmr_opn_cabinet_vid_srt_1_hide" )
        cmn.SetEventDone( "opn_shop" );
        cmn.CallEventHandler( "opn_shop" )
        ld.ShowBbtOpn( private.room_objname )
        int.DialogVideoHide();
    end;
    ld.StartTimer( "tmr_opn_shop_vid_srt_1", 11, function() interface.DialogVideoSubtitleShow( "srt_shop_berta_1" ) end )
    ld.StartTimer( "tmr_opn_shop_vid_srt_1_hide", 17, function() interface.DialogVideoSubtitleHide() end )
    
    int.DialogVideoShow( "vid_shop_grumpycrush_bertawendi_open", 1, func_end );
    --[[
    common_impl.VideoSubtitleVocStart( {
      { "srt_shop_berta_1", aud_voc_false, 11, 17 };
    } );
    ]]
    SoundVoice( "aud_grumpycrush_bertawendi_open_voc" );
    SoundVid( "aud_grumpycrush_bertawendi_open" );
    VidPlay("vid_shop_grumpycrush_bertawendi_open",func_end)
  else
    if ld.CheckRequirements( {"win_statuemg"} ) and not ld.CheckRequirements( {"dlg_shop_michael2"} ) then
      public.dlg_shop_michael2(  )
    end
  end;
end;
--------------------------------------------------------------------
local opn_shop = function() 
  ObjSet( "spr_shop_tr_deer_br", {visible = 1} );
  ObjSet( "spr_shop_tr_deer", {visible = 0} );
end;
local opn_shop_logic = function() end;
cmn.AddSubscriber( "opn_shop", opn_shop_logic )
cmn.AddSubscriber( "opn_shop", opn_shop, private.room_objname )
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "michael1" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    elseif count_txt == 2 then 
      common_impl.continue_visible = true
    elseif count_txt == 3 then 

    end
  elseif dlg_name == "michael2" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    elseif count_txt == 2 then
      common_impl.continue_visible = true
      SoundSfx( "aud_piterson_gives_us" )
      ld.AnimPlay( "anm_shop_michael2", "give_money", "" )
    elseif count_txt == 3 then 
      ld.AnimPlay( "anm_shop_michael2", "give_hand_end", "" )
      cmn.CallEventHandler( "get_moneybag1" );
    elseif count_txt == 4 then
      common_impl.continue_visible = true
    end
  elseif dlg_name == "michael3" then
    if count_txt == 1 then
      common_impl.continue_visible = true
      ld.AnimPlay( "anm_shop_michael3", "give_note", "" )
    elseif count_txt == 2 then 
      cmn.CallEventHandler( "get_alexnote" );
      ld.AnimPlay( "anm_shop_michael3", "give_hand_end", function() ld.AnimPlay( "anm_shop_michael3", "give_key", "" ) end )
    elseif count_txt == 3 then 
      ld.AnimPlay( "anm_shop_michael3", "give_hand_end", "" )
      cmn.CallEventHandler( "get_gateskey" );
    end
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_boltinshop" ] = { type = "click", use_place = "gfx_shop_clk_boltinshop_zone", room = "rm_shop" };

private.clk_boltinshop_logic = function()
  ObjSet( "gfx_shop_dlg_shop_michael1_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_boltinshop_beg = function()
  ObjDelete( "gfx_shop_clk_boltinshop_zone" );
end;
private.clk_boltinshop_end = function()

  ObjSet( "anm_shop_anim_door", {animfunc = "anim_dooropen", frame = 999 } );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_boltinshop", private.clk_boltinshop_beg, private.room_objname );
cmn.AddSubscriber( "clk_boltinshop", private.clk_boltinshop_end, private.room_objname );
cmn.AddSubscriber( "clk_boltinshop", private.clk_boltinshop_logic );
cmn.AddSubscriber( "clk_boltinshop_beg", private.clk_boltinshop_beg, private.room_objname );
cmn.AddSubscriber( "clk_boltinshop_end", private.clk_boltinshop_end, private.room_objname );
cmn.AddSubscriber( "clk_boltinshop_end", private.clk_boltinshop_logic );
--------------------------------------------------------------------------------------------
function public.clk_boltinshop()

  local func_end = function()
    
    cmn.CallEventHandler( "clk_boltinshop_end" );
    common_impl.Lock(0);
    public.dlg_shop_michael1( obj )
  end;

  cmn.CallEventHandler( "clk_boltinshop_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_shop_anim_door", "anim_dooropen", func_end );
  SoundSfx( "aud_clk_shop_door" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_shop_michael1" ] = { type = "click", use_place = "gfx_shop_dlg_shop_michael1_zone", room = "rm_shop" };

private.dlg_shop_michael1_logic = function()
  ObjSet( "gzz_shop_brokenstatue", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gzz_shop_showcase", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_shop_michael1_beg = function()
  ObjSet( "anm_shop_anim_door_1", {visible = 1} );
  ObjDelete( "gfx_shop_dlg_shop_michael1_zone" );
end;
private.dlg_shop_michael1_end = function()
  ObjDelete("anm_shop_anim_hh1")
  ObjDelete("anm_shop_anim_door")
  ObjSet( "anm_shop_anim_michael", {visible = 1} );
  ObjSet( "obj_shop_michael_fig_broken", {input = 1} );
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_shop_michael1", private.dlg_shop_michael1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_shop_michael1", private.dlg_shop_michael1_end, private.room_objname );
cmn.AddSubscriber( "dlg_shop_michael1", private.dlg_shop_michael1_logic );
cmn.AddSubscriber( "dlg_shop_michael1_beg", private.dlg_shop_michael1_beg, private.room_objname );
cmn.AddSubscriber( "dlg_shop_michael1_end", private.dlg_shop_michael1_end, private.room_objname );
cmn.AddSubscriber( "dlg_shop_michael1_end", private.dlg_shop_michael1_logic );
--------------------------------------------------------------------------------------------
function public.dlg_shop_michael1( obj )
  local func_end = function()
    cmn.SetEventDone( "clk_boltinshop" );
    cmn.SetEventDone( "dlg_shop_michael1" );
    cmn.CallEventHandler( "dlg_shop_michael1_end" );
    SoundEnv( "aud_rasping_env", 1 )
    common_impl.Lock(0);
  end;
  function public.dlg_shop_michael1_func_end()
    common_impl.Lock(1);
    func_end()
  end
  cmn.CallEventHandler( "dlg_shop_michael1_beg" );
  common_impl.dialog_character_loc = "obj_shop_michael";
  common_impl.Start( "michael1", 3, nil, nil, true, "dlg_shop_michael1_func_end", { "aud_michael_1_voc", "aud_michael_2_voc" } );
end;

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_shop_michael2" ] = { type = "click", use_place = "gfx_shop_dlg_shop_michael2_zone", room = "rm_shop" };

private.dlg_shop_michael2_logic = function()
  ObjSet( "spr_shop_moneybag1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_shop_goldenfeather_shop_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_shop_paper_zone", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_shop_michael2_beg = function()
  ObjDelete( "gfx_shop_dlg_shop_michael2_zone" );
end;
private.dlg_shop_michael2_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_shop_michael2", private.dlg_shop_michael2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_shop_michael2", private.dlg_shop_michael2_end, private.room_objname );
cmn.AddSubscriber( "dlg_shop_michael2", private.dlg_shop_michael2_logic );
cmn.AddSubscriber( "dlg_shop_michael2_beg", private.dlg_shop_michael2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_shop_michael2_end", private.dlg_shop_michael2_end, private.room_objname );
cmn.AddSubscriber( "dlg_shop_michael2_end", private.dlg_shop_michael2_logic );
--------------------------------------------------------------------------------------------
function public.dlg_shop_michael2( obj )
  local func_end = function()
    SoundEnv( "aud_rasping_env", 1 )
    cmn.SetEventDone( "get_moneybag1" );
    cmn.SetEventDone( "dlg_shop_michael2" );
    cmn.CallEventHandler( "dlg_shop_michael2_end" );
    common_impl.Lock(0);
  end;
  function public.dlg_shop_michael2_func_end()
    common_impl.Lock(1);
    if ObjGetRelations( "inv_moneybag" ).parent == "level_inv_hub" then
      cmn.CallEventHandler( "get_moneybag1" );
    end  
    func_end()
  end
  SoundEnv( "aud_rasping_env", 0 )
  cmn.CallEventHandler( "dlg_shop_michael2_beg" );
  common_impl.dialog_character_loc = "obj_shop_michael";
  common_impl.Start( "michael2", 4, nil, nil, true, "dlg_shop_michael2_func_end", { "aud_michael_3_voc", "aud_michael_4_voc", "aud_michael_5_voc" } );
end;

--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_moneybag1" ] = { type = "get", get_obj = "spr_shop_moneybag1", room = "rm_shop" };

private.get_moneybag1_logic = function()
  
end;
private.get_moneybag1_inv = function()
  interface.InventoryItemAdd("inv_moneybag","spr_shop_moneybag1",function() level_inv.ProcessGetMoneybagAll( "get_moneybag1" ) end);
end;
private.get_moneybag1_beg = function()
  ObjDelete("gfx_shop_moneybag1")
  ObjSet( "spr_shop_moneybag1", {visible = 1} );
end;
private.get_moneybag1_end = function()
  
end;

cmn.AddSubscriber( "get_moneybag1", private.get_moneybag1_inv );
cmn.AddSubscriber( "get_moneybag1", private.get_moneybag1_beg, private.room_objname );
cmn.AddSubscriber( "get_moneybag1", private.get_moneybag1_end, private.room_objname );
cmn.AddSubscriber( "get_moneybag1", private.get_moneybag1_logic );
--------------------------------------------------------------------
function public.get_moneybag1()
  cmn.SetEventDone( "get_moneybag1" );
  cmn.CallEventHandler( "get_moneybag1" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_goldenfeather_shop" ] = { type = "use", inv_obj = "inv_goldenfeather", use_place = "gfx_shop_goldenfeather_shop_zone", room = "rm_shop" };

private.use_goldenfeather_shop_logic = function()
  if ld.CheckRequirements( {"use_goldenfeather_shop","use_paper"} ) then
    ObjSet( "gfx_shop_dlg_shop_michael3_zone", {  input = 1, active = 1 } )
  end;

end;
private.use_goldenfeather_shop_inv = function()
  common_impl.ProcessMultiUseAll("goldenfeather", "goldenfeather_shop")
end;
private.use_goldenfeather_shop_beg = function()
  ObjDelete( "gfx_shop_goldenfeather_shop_zone" );
end;
private.use_goldenfeather_shop_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_goldenfeather_shop", private.use_goldenfeather_shop_inv );
cmn.AddSubscriber( "use_goldenfeather_shop", private.use_goldenfeather_shop_beg, private.room_objname );
cmn.AddSubscriber( "use_goldenfeather_shop", private.use_goldenfeather_shop_end, private.room_objname );
cmn.AddSubscriber( "use_goldenfeather_shop", private.use_goldenfeather_shop_logic );
cmn.AddSubscriber( "use_goldenfeather_shop_inv", private.use_goldenfeather_shop_inv, private.room_objname );
cmn.AddSubscriber( "use_goldenfeather_shop_beg", private.use_goldenfeather_shop_beg, private.room_objname );
cmn.AddSubscriber( "use_goldenfeather_shop_end", private.use_goldenfeather_shop_end, private.room_objname );
cmn.AddSubscriber( "use_goldenfeather_shop_end", private.use_goldenfeather_shop_logic );
--------------------------------------------------------------------------------------------
function public.use_goldenfeather_shop( obj )

  local func_end = function()
    if ld.IsLastActionLeft({"use_paper","use_goldenfeather_shop"}) then
      public.dlg_shop_michael3(  )
    else
      cmn.SetEventDone( "use_goldenfeather_shop" );
    end
    ObjSet(obj,{visible = 1});
    cmn.CallEventHandler( "use_goldenfeather_shop_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_goldenfeather_shop_inv" );
  cmn.CallEventHandler( "use_goldenfeather_shop_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_paper" ] = { type = "use", inv_obj = "inv_paper", use_place = "gfx_shop_paper_zone", room = "rm_shop" };

private.use_paper_logic = function()
  if ld.CheckRequirements( {"use_paper","use_goldenfeather_shop"} ) then
    ObjSet( "gfx_shop_dlg_shop_michael3_zone", {  input = 1, active = 1 } )
  end;

end;
private.use_paper_inv = function()
  common_impl.ProcessMultiUseAll("paper", "paper")
end;
private.use_paper_beg = function()
  ObjDelete( "gfx_shop_paper_zone" );
end;
private.use_paper_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_paper", private.use_paper_inv );
cmn.AddSubscriber( "use_paper", private.use_paper_beg, private.room_objname );
cmn.AddSubscriber( "use_paper", private.use_paper_end, private.room_objname );
cmn.AddSubscriber( "use_paper", private.use_paper_logic );
cmn.AddSubscriber( "use_paper_inv", private.use_paper_inv, private.room_objname );
cmn.AddSubscriber( "use_paper_beg", private.use_paper_beg, private.room_objname );
cmn.AddSubscriber( "use_paper_end", private.use_paper_end, private.room_objname );
cmn.AddSubscriber( "use_paper_end", private.use_paper_logic );
--------------------------------------------------------------------------------------------
function public.use_paper( obj )

  local func_end = function()
    if ld.IsLastActionLeft({"use_paper","use_goldenfeather_shop"}) then
      public.dlg_shop_michael3(  )
    else
      cmn.SetEventDone( "use_paper" );
    end
    ObjSet(obj,{visible = 1});
    cmn.CallEventHandler( "use_paper_end" );
    common_impl.Lock(0);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_paper_inv" );
  cmn.CallEventHandler( "use_paper_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_shop_michael3" ] = { type = "click", use_place = "gfx_shop_dlg_shop_michael3_zone", room = "rm_shop" };

private.dlg_shop_michael3_logic = function()
  ObjSet( "spr_shop_alexnote", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_shop_gateskey", { visible = 1, input = 1, active = 1 } )

end;
private.dlg_shop_michael3_beg = function()
  ObjDelete( "gfx_shop_dlg_shop_michael3_zone" );
end;
private.dlg_shop_michael3_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_shop_michael3", private.dlg_shop_michael3_beg, private.room_objname );
cmn.AddSubscriber( "dlg_shop_michael3", private.dlg_shop_michael3_end, private.room_objname );
cmn.AddSubscriber( "dlg_shop_michael3", private.dlg_shop_michael3_logic );
cmn.AddSubscriber( "dlg_shop_michael3_beg", private.dlg_shop_michael3_beg, private.room_objname );
cmn.AddSubscriber( "dlg_shop_michael3_end", private.dlg_shop_michael3_end, private.room_objname );
cmn.AddSubscriber( "dlg_shop_michael3_end", private.dlg_shop_michael3_logic );
--------------------------------------------------------------------------------------------
function public.dlg_shop_michael3( obj )
  local func_end = function()
    SoundEnv( "aud_rasping_env", 1 )
    cmn.SetEventDone( "get_alexnote" );
    if not ld.CheckRequirements( {"use_paper"} ) then
      cmn.SetEventDone( "use_paper" );
    end
    if not ld.CheckRequirements( {"use_goldenfeather_shop"} ) then
      cmn.SetEventDone( "use_goldenfeather_shop" );
    end
    cmn.SetEventDone( "get_gateskey" );
    cmn.SetEventDone( "dlg_shop_michael3" );
    cmn.CallEventHandler( "dlg_shop_michael3_end" );
    common_impl.Lock(0);
  end;
  function public.dlg_shop_michael3_func_end()
    common_impl.Lock(1);
    if ObjGetRelations( "inv_alexnote" ).parent == "level_inv_hub" then
      cmn.CallEventHandler( "get_alexnote" );
    end  
    if ObjGetRelations( "inv_gateskey" ).parent == "level_inv_hub" then
      cmn.CallEventHandler( "get_gateskey" );
    end  
    func_end()
  end
  SoundEnv( "aud_rasping_env", 0 )
  cmn.CallEventHandler( "dlg_shop_michael3_beg" );
  common_impl.dialog_character_loc = "obj_shop_michael";
  common_impl.Start( "michael3", 3, nil, nil, true, "dlg_shop_michael3_func_end", { "aud_michael_6_voc", "aud_michael_6_voc" } );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_alexnote" ] = { type = "get", get_obj = "spr_shop_alexnote", room = "rm_shop" };

private.get_alexnote_logic = function()
  
end;
private.get_alexnote_inv = function()
  interface.InventoryItemAdd("inv_alexnote","spr_shop_alexnote");
end;
private.get_alexnote_beg = function()
  ObjDelete("gfx_shop_alexnote")
  ObjSet( "spr_shop_alexnote", {visible = 1} );
end;
private.get_alexnote_end = function()
  
end;

cmn.AddSubscriber( "get_alexnote", private.get_alexnote_inv );
cmn.AddSubscriber( "get_alexnote", private.get_alexnote_beg, private.room_objname );
cmn.AddSubscriber( "get_alexnote", private.get_alexnote_end, private.room_objname );
cmn.AddSubscriber( "get_alexnote", private.get_alexnote_logic );
--------------------------------------------------------------------
function public.get_alexnote()
  cmn.SetEventDone( "get_alexnote" );
  cmn.CallEventHandler( "get_alexnote" );
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_gateskey" ] = { type = "get", get_obj = "spr_shop_gateskey", room = "rm_shop" };

private.get_gateskey_logic = function()
  
end;
private.get_gateskey_inv = function()
  interface.InventoryItemAdd("inv_gateskey","spr_shop_gateskey");
end;
private.get_gateskey_beg = function()
  ObjDelete("gfx_shop_gateskey")
  ObjSet( "spr_shop_gateskey", {visible = 1} );
end;
private.get_gateskey_end = function()
  
end;

cmn.AddSubscriber( "get_gateskey", private.get_gateskey_inv );
cmn.AddSubscriber( "get_gateskey", private.get_gateskey_beg, private.room_objname );
cmn.AddSubscriber( "get_gateskey", private.get_gateskey_end, private.room_objname );
cmn.AddSubscriber( "get_gateskey", private.get_gateskey_logic );
--------------------------------------------------------------------
function public.get_gateskey()
  cmn.SetEventDone( "get_gateskey" );
  cmn.CallEventHandler( "get_gateskey" );
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_brokenstatue *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_amuletelf2" ] = { type = "get", get_obj = "spr_brokenstatue_amuletelf2", room = "rm_shop", zz = "zz_brokenstatue", zz_gate = "gzz_shop_brokenstatue" };

private.get_amuletelf2_logic = function()
  
end;
private.get_amuletelf2_inv = function()
  interface.InventoryItemAdd("inv_amuletelf2","spr_brokenstatue_amuletelf2");
end;
private.get_amuletelf2_beg = function()
  ObjDelete("gfx_brokenstatue_amuletelf2")
end;
private.get_amuletelf2_end = function()
  ObjDelete("spr_brokenstatue_amuletelf2_sh")
  if common_impl.ZzCompleteCheck("get_amuletelf2") then ObjSet( common_impl.hint["get_amuletelf2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletelf2", private.get_amuletelf2_inv );
cmn.AddSubscriber( "get_amuletelf2", private.get_amuletelf2_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletelf2", private.get_amuletelf2_end, private.room_objname );
cmn.AddSubscriber( "get_amuletelf2", private.get_amuletelf2_logic );

cmn.AddSubscriber( "get_amuletelf2_end", private.get_amuletelf2_inv );
cmn.AddSubscriber( "get_amuletelf2_beg", private.get_amuletelf2_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletelf2_end", private.get_amuletelf2_end, private.room_objname );
cmn.AddSubscriber( "get_amuletelf2_end", private.get_amuletelf2_logic );
--------------------------------------------------------------------
function public.get_amuletelf2()
  local func_end = function()
    cmn.SetEventDone( "get_amuletelf2" );
    cmn.CallEventHandler( "get_amuletelf2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("get_amuletelf2") then ld.CloseSubRoom() end;
  end;
  ld.Lock(1)
  SoundSfx( "aud_get_amuletelf2" )
  cmn.CallEventHandler( "get_amuletelf2_beg" );
  func_end()
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_stickymass" ] = { type = "use", inv_obj = "inv_stickymass", use_place = "gfx_brokenstatue_stickymass_zone", room = "rm_shop", zz = "zz_brokenstatue", zz_gate = "gzz_shop_brokenstatue" };

private.use_stickymass_logic = function()
  if ld.CheckRequirements( {"use_stickymass","use_paints"} ) then
  ObjSet( "gmg_shop_statuemg", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_stickymass_inv = function()
  common_impl.ProcessMultiUseAll("stickymass", "stickymass")
end;
private.use_stickymass_beg = function()
  ObjDelete( "gfx_brokenstatue_stickymass_zone" );
end;
private.use_stickymass_end = function()
  ObjSet( "anm_brokenstatue_anm2_stickymass", {animfunc = "stickymass", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_stickymass") then ObjSet( common_impl.hint["use_stickymass"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_stickymass", private.use_stickymass_inv );
cmn.AddSubscriber( "use_stickymass", private.use_stickymass_beg, private.room_objname );
cmn.AddSubscriber( "use_stickymass", private.use_stickymass_end, private.room_objname );
cmn.AddSubscriber( "use_stickymass", private.use_stickymass_logic );
cmn.AddSubscriber( "use_stickymass_inv", private.use_stickymass_inv, private.room_objname );
cmn.AddSubscriber( "use_stickymass_beg", private.use_stickymass_beg, private.room_objname );
cmn.AddSubscriber( "use_stickymass_end", private.use_stickymass_end, private.room_objname );
cmn.AddSubscriber( "use_stickymass_end", private.use_stickymass_logic );
--------------------------------------------------------------------------------------------
function public.use_stickymass( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_stickymass" );
    cmn.CallEventHandler( "use_stickymass_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_stickymass") then ld.CloseSubRoom() common_impl.Gate_MDown( "gmg_shop_statuemg" ) end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_stickymass_inv" );
  cmn.CallEventHandler( "use_stickymass_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_brokenstatue_anm2_stickymass", "stickymass", func_end );
  SoundSfx( "aud_sticky_mass" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_paints" ] = { type = "use", inv_obj = "inv_paints", use_place = "gfx_brokenstatue_paints_zone", room = "rm_shop", zz = "zz_brokenstatue", zz_gate = "gzz_shop_brokenstatue" };

private.use_paints_logic = function()
  if ld.CheckRequirements( {"use_paints","use_stickymass"} ) then
  ObjSet( "gmg_shop_statuemg", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_paints_inv = function()
  common_impl.ProcessMultiUseAll("paints", "paints")
end;
private.use_paints_beg = function()
  ObjDelete( "gfx_brokenstatue_paints_zone" );
end;
private.use_paints_end = function()
  ObjSet( "anm_brokenstatue_anm2_paints", {animfunc = "colors", frame = 999} );
  if common_impl.ZzCompleteCheck("use_paints") then ObjSet( common_impl.hint["use_paints"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_paints", private.use_paints_inv );
cmn.AddSubscriber( "use_paints", private.use_paints_beg, private.room_objname );
cmn.AddSubscriber( "use_paints", private.use_paints_end, private.room_objname );
cmn.AddSubscriber( "use_paints", private.use_paints_logic );
cmn.AddSubscriber( "use_paints_inv", private.use_paints_inv, private.room_objname );
cmn.AddSubscriber( "use_paints_beg", private.use_paints_beg, private.room_objname );
cmn.AddSubscriber( "use_paints_end", private.use_paints_end, private.room_objname );
cmn.AddSubscriber( "use_paints_end", private.use_paints_logic );
--------------------------------------------------------------------------------------------
function public.use_paints( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_paints" );
    cmn.CallEventHandler( "use_paints_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_paints") then ld.CloseSubRoom() common_impl.Gate_MDown( "gmg_shop_statuemg" ) end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_paints_inv" );
  cmn.CallEventHandler( "use_paints_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_brokenstatue_anm2_paints", "colors", func_end );
  SoundSfx( "aud_paints" )

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_showcase *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_lostwallet" ] = { type = "get", get_obj = "spr_showcase_lostwallet", room = "rm_shop", zz = "zz_showcase", zz_gate = "gzz_shop_showcase" };

private.get_lostwallet_logic = function()
  
end;
private.get_lostwallet_inv = function()
  interface.InventoryItemAdd("inv_lostwallet","spr_showcase_lostwallet");
  ObjSet( "inv_lostwallet", { drag = 0 } );
end;
private.get_lostwallet_beg = function()
  ObjDelete("gfx_showcase_lostwallet")
end;
private.get_lostwallet_end = function()
  ObjDelete("spr_showcase_lostwallet_sh")
  ObjDelete("spr_shop_lostwallet_tr")
  if common_impl.ZzCompleteCheck("get_lostwallet") then ObjSet( common_impl.hint["get_lostwallet"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_lostwallet", private.get_lostwallet_inv );
cmn.AddSubscriber( "get_lostwallet", private.get_lostwallet_beg, private.room_objname );
cmn.AddSubscriber( "get_lostwallet", private.get_lostwallet_end, private.room_objname );
cmn.AddSubscriber( "get_lostwallet", private.get_lostwallet_logic );
--------------------------------------------------------------------
function public.get_lostwallet()
  cmn.SetEventDone( "get_lostwallet" );
  cmn.CallEventHandler( "get_lostwallet" );
  if common_impl.ZzCompleteCheck("get_lostwallet") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
function public.use_figures_try(bbt)
  if ld.CheckRequirements( {"use_figurmaster","use_figurboy","use_figurwomen"},1 ) == 0 and ld.CheckRequirements( {"get_lostwallet"} ) then
    SoundSfx( "aud_xx_chest_showcase" )
    ld.Lock(1); ld.AnimPlay("anm_showcase_anim_base","idle_box", function() ld.Lock(0) ld.ShowBbt(bbt) end)
  else
    ld.ShowBbt( bbt )
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_figurmaster" ] = { type = "use", inv_obj = "inv_figurmaster", use_place = "gfx_showcase_figurmaster_zone", room = "rm_shop", zz = "zz_showcase", zz_gate = "gzz_shop_showcase" };

private.use_figurmaster_logic = function()
  if ld.CheckRequirements( {"use_figurmaster","use_figurboy","use_figurwomen"} ) then
    ObjSet( "gfx_showcase_win_showcase_zone", { visible = 1, input = 1, active = 1 } )
    ld.mmgZoomInit( "win_showcase", "aud_paperzoom_in", "aud_paperzoom_out" );
  end;

end;
private.use_figurmaster_inv = function()
  common_impl.ProcessMultiUseAll("figurmaster", "figurmaster")
end;
private.use_figurmaster_beg = function()
  ObjDelete( "gfx_showcase_figurmaster_zone" );
end;
private.use_figurmaster_end = function()
  ObjSet( "spr_shop_charly_tr", {visible = 1} );
  ObjSet( "anm_showcase_anim_tin", {animfunc = "use_tin_soldier", frame = 999 } );
  if ld.CheckRequirements( {"use_figurmaster","use_figurboy","use_figurwomen"} ) then
    ObjDelete("anm_showcase_anim_bal")
    ObjDelete("anm_showcase_anim_nut")
    ObjDelete("anm_showcase_anim_tin")
    ObjSet( "anm_showcase_anim_base", {animfunc = "mmg_open", frame = 0 } );
  end
  if common_impl.ZzCompleteCheck("use_figurmaster") then ObjSet( common_impl.hint["use_figurmaster"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_figurmaster", private.use_figurmaster_inv );
cmn.AddSubscriber( "use_figurmaster", private.use_figurmaster_beg, private.room_objname );
cmn.AddSubscriber( "use_figurmaster", private.use_figurmaster_end, private.room_objname );
cmn.AddSubscriber( "use_figurmaster", private.use_figurmaster_logic );
cmn.AddSubscriber( "use_figurmaster_inv", private.use_figurmaster_inv, private.room_objname );
cmn.AddSubscriber( "use_figurmaster_beg", private.use_figurmaster_beg, private.room_objname );
cmn.AddSubscriber( "use_figurmaster_end", private.use_figurmaster_end, private.room_objname );
cmn.AddSubscriber( "use_figurmaster_end", private.use_figurmaster_logic );
--------------------------------------------------------------------------------------------
function public.use_figurmaster( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_figurmaster" );
    cmn.CallEventHandler( "use_figurmaster_end" );
    if common_impl.ZzCompleteCheck("use_figurmaster") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_figurmaster","use_figurboy","use_figurwomen"} ) then
      public.win_showcase_load()
      SoundSfx( "aud_xx_magic" )
      ld.AnimPlay( "anm_showcase_anim_base_start", "start_mmg", function() ld.Lock(0) ObjGet( "gfx_showcase_win_showcase_zone" ).event_mdown() end )
    else
      ld.Lock(0)
    end
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_figurmaster_inv" );
  cmn.CallEventHandler( "use_figurmaster_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_showcase_anim_tin", "use_tin_soldier", func_end );
  SoundSfx( "aud_figurine_to_chest" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_figurboy" ] = { type = "use", inv_obj = "inv_figurboy", use_place = "gfx_showcase_figurboy_zone", room = "rm_shop", zz = "zz_showcase", zz_gate = "gzz_shop_showcase" };

private.use_figurboy_logic = function()
  if ld.CheckRequirements( {"use_figurboy","use_figurmaster","use_figurwomen"} ) then
    ObjSet( "gfx_showcase_win_showcase_zone", { visible = 1, input = 1, active = 1 } )
    ld.mmgZoomInit( "win_showcase", "aud_paperzoom_in", "aud_paperzoom_out" );
  end;

end;
private.use_figurboy_inv = function()
  common_impl.ProcessMultiUseAll("figurboy", "figurboy")
end;
private.use_figurboy_beg = function()
  ObjDelete( "gfx_showcase_figurboy_zone" );
end;
private.use_figurboy_end = function()
  ObjSet( "anm_showcase_anim_nut", {animfunc = "use_nutcracker", frame = 999 } );
  if ld.CheckRequirements( {"use_figurmaster","use_figurboy","use_figurwomen"} ) then
    ObjSet( "anm_showcase_anim_base", {animfunc = "mmg_open", frame = 0 } );
    ObjDelete("anm_showcase_anim_bal")
    ObjDelete("anm_showcase_anim_nut")
    ObjDelete("anm_showcase_anim_tin")
  end
  ObjSet( "spr_shop_nut_tr", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_figurboy") then ObjSet( common_impl.hint["use_figurboy"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_figurboy", private.use_figurboy_inv );
cmn.AddSubscriber( "use_figurboy", private.use_figurboy_beg, private.room_objname );
cmn.AddSubscriber( "use_figurboy", private.use_figurboy_end, private.room_objname );
cmn.AddSubscriber( "use_figurboy", private.use_figurboy_logic );
cmn.AddSubscriber( "use_figurboy_inv", private.use_figurboy_inv, private.room_objname );
cmn.AddSubscriber( "use_figurboy_beg", private.use_figurboy_beg, private.room_objname );
cmn.AddSubscriber( "use_figurboy_end", private.use_figurboy_end, private.room_objname );
cmn.AddSubscriber( "use_figurboy_end", private.use_figurboy_logic );
--------------------------------------------------------------------------------------------
function public.use_figurboy( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_figurboy" );
    cmn.CallEventHandler( "use_figurboy_end" );
    if common_impl.ZzCompleteCheck("use_figurboy") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_figurmaster","use_figurboy","use_figurwomen"} ) then
      public.win_showcase_load()
      SoundSfx( "aud_xx_magic" )
      ld.AnimPlay( "anm_showcase_anim_base_start", "start_mmg", function() ld.Lock(0) ObjGet( "gfx_showcase_win_showcase_zone" ).event_mdown() end )
    else
      ld.Lock(0)
    end
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_figurboy_inv" );
  cmn.CallEventHandler( "use_figurboy_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_showcase_anim_nut", "use_nutcracker", func_end );
  SoundSfx( "aud_figurine_to_chest" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_figurwomen" ] = { type = "use", inv_obj = "inv_figurwomen", use_place = "gfx_showcase_figurwomen_zone", room = "rm_shop", zz = "zz_showcase", zz_gate = "gzz_shop_showcase" };

private.use_figurwomen_logic = function()
  if ld.CheckRequirements( {"use_figurwomen","use_figurmaster","use_figurboy"} ) then
    ObjSet( "gfx_showcase_win_showcase_zone", { visible = 1, input = 1, active = 1 } )
    ld.mmgZoomInit( "win_showcase", "aud_paperzoom_in", "aud_paperzoom_out" );
  end;
end;
private.use_figurwomen_inv = function()
  common_impl.ProcessMultiUseAll("figurwomen", "figurwomen")
end;
private.use_figurwomen_beg = function()
  ObjDelete( "gfx_showcase_figurwomen_zone" );
end;
private.use_figurwomen_end = function()
  ObjSet( "anm_showcase_anim_bal", {animfunc = "use_balerina", frame = 999 } );
  if ld.CheckRequirements( {"use_figurmaster","use_figurboy","use_figurwomen"} ) then
    ObjSet( "anm_showcase_anim_base", {animfunc = "mmg_open", frame = 0 } );
    ObjDelete("anm_showcase_anim_bal")
    ObjDelete("anm_showcase_anim_nut")
    ObjDelete("anm_showcase_anim_tin")
  end
  ObjSet( "spr_shop_bal_tr", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_figurwomen") then ObjSet( common_impl.hint["use_figurwomen"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_figurwomen", private.use_figurwomen_inv );
cmn.AddSubscriber( "use_figurwomen", private.use_figurwomen_beg, private.room_objname );
cmn.AddSubscriber( "use_figurwomen", private.use_figurwomen_end, private.room_objname );
cmn.AddSubscriber( "use_figurwomen", private.use_figurwomen_logic );
cmn.AddSubscriber( "use_figurwomen_inv", private.use_figurwomen_inv, private.room_objname );
cmn.AddSubscriber( "use_figurwomen_beg", private.use_figurwomen_beg, private.room_objname );
cmn.AddSubscriber( "use_figurwomen_end", private.use_figurwomen_end, private.room_objname );
cmn.AddSubscriber( "use_figurwomen_end", private.use_figurwomen_logic );
--------------------------------------------------------------------------------------------
function public.use_figurwomen( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_figurwomen" );
    cmn.CallEventHandler( "use_figurwomen_end" );
    if common_impl.ZzCompleteCheck("use_figurwomen") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_figurmaster","use_figurboy","use_figurwomen"} ) then
      public.win_showcase_load()
      SoundSfx( "aud_xx_magic" )
      ld.AnimPlay( "anm_showcase_anim_base_start", "start_mmg", function() ld.Lock(0) ObjGet( "gfx_showcase_win_showcase_zone" ).event_mdown() end )
    else
      ld.Lock(0)
    end
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_figurwomen_inv" );
  cmn.CallEventHandler( "use_figurwomen_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_showcase_anim_bal", "use_balerina", func_end );
  SoundSfx( "aud_figurine_to_chest" )

end;
--------------------------------------------------------------------------------------------


function public.win_showcase_load(reset,skip)
  local begstate = {0,4,0,0,0,0,0,0,0,0}
  local winstate = {2,4,2,2,2,2,2,2,1,1} 

  private.win_showcase_arr = {
    { lighttag = "alpha_ts_hand_1", funcs = {"tinsoldier_hand_1",3} },
    { lighttag = "alpha_ts_arm", funcs = {"tinsoldier_arm",5} },
    { lighttag = "alpha_ts_hand_2_light", funcs = {"tinsoldier_hand_2",3} },
    { lighttag = "alpha_b_arm_1", funcs = {"balerina_arm_1",3} },
    { lighttag = "alpha_b_head", funcs = {"balerina_head",3} },
    { lighttag = "alpha_b_leg", funcs = {"balerina_leg",3} },
    { lighttag = "alpha_b_arm_2", funcs = {"balerina_arm_2",3} },
    { lighttag = "alpha_ts_head", funcs = {"tinsoldier_head",3} },
    { lighttag = "alpha_nut_arm_1_light", funcs = {"nutcracker_hand_1",3} },
    { lighttag = "alpha_nut_arm_2_light", funcs = {"nutcracker_hand_2",3} }
  }
  local iswin = false 

  if not ng_global.progress["std"]["win_showcase"].state or reset then
    ng_global.progress["std"]["win_showcase"].state = ld.TableCopy(begstate)
  end

  local function load_map(skip)
    local toload = skip and winstate or ng_global.progress["std"]["win_showcase"].state
    for i,o in ipairs(toload) do
      ObjSet( "anm_showcase_anim_"..i, {animfunc = private.win_showcase_arr[i].funcs[1].."_"..o, frame = 0 } );
    end
  end

  --wincheck
  local prevstate
  local function wincheck(skip)
    local function win()
      public.win_showcase()
      iswin = true
    end
    if ld.TableEquals(ng_global.progress["std"]["win_showcase"].state,winstate) or skip then
      if not skip then
        ng_global.progress["std"]["win_showcase"].state = ld.TableCopy(prevstate)
      end
      ld.Lock(1)
      win()
    end
  end

  --load
  local function load(skip)
    load_map(skip)
  end
  local function chooseload(reset,skip)
    if reset or skip then
      local toload = skip and winstate or begstate
      local count = 0
      local wincount = #toload
      local function exit()
        load(skip)
        wincheck(skip)
      end
      for i,o in ipairs(toload) do
        local anim = "anm_showcase_anim_"..i
        local funcs = private.win_showcase_arr[i].funcs
        local arr = ld.StringDivide(ObjGet("anm_showcase_anim_"..i).animfunc)
        if o == tonumber(arr[#arr]) then
          wincount = wincount - 1
        else
          local function func_end()
            ObjSet( anim, {animfunc = funcs[1].."_"..o, frame = 0 } );
            ld.LockCustom(anim,0)
            count = count + 1
            if count == wincount then
              exit()
            end
          end
          local function iteration(v)
            v = tonumber( v )
            ld.AnimPlay( anim, funcs[1].."_"..(v)%funcs[2], function() 
              v = (v+1)%funcs[2]
              if v == o then
                func_end()
              else
                iteration(v)
              end
            end )
          end
          ld.LockCustom(anim,1)
          iteration(arr[#arr])
        end
      end
    else
      load()
    end
  end
  chooseload(reset,skip)
  --save
  local function save(n)
    prevstate = ld.TableCopy(ng_global.progress["std"]["win_showcase"].state)
    ng_global.progress["std"]["win_showcase"].state[n] = (ng_global.progress["std"]["win_showcase"].state[n]+1)%private.win_showcase_arr[n].funcs[2]
    wincheck()
  end  

  --public
  --function public.win_showcase_click(sender)
  --  ld.Lock(1)
  --  ObjAnimate( obj, 8, 0, 0, function() ld.Lock(0) save()  end, {0,0,ObjGet(obj).alp, 0.5,0,(ng_global.progress["std"]["win_showcase"].state[1] + 1)/winstate[1]} );
  --end

  function public.win_showcase_preopen()
    ld.AnimPlay( "anm_showcase_anim_base", "mmg_open", "" )
  end
  function public.win_showcase_open()
    ObjAttach("anm_showcase_anim_base","obj_showcase_win_showcase_zoom_block")
    ObjSet( "anm_showcase_anim_base", {input = 1} );
    ObjSet( "anm_showcase_anim_base", {animfunc = "mmg_close", frame = 0 } );
  end
  function public.win_showcase_preclose()
    ObjAttach("anm_showcase_anim_base","zz_showcase")
    ObjSet( "anm_showcase_anim_base", {input = 0} );
    ld.AnimPlay( "anm_showcase_anim_base", "mmg_close", "" )
  end
  function public.win_showcase_close()
    ObjSet( "anm_showcase_anim_base", {animfunc = "mmg_open", frame = 0 } );
    public.win_showcase_trywin()
  end

  function private.win_showcase_parse(sender)
    local n = ld.NumberFromString( sender )
    local arr = private.win_showcase_arr[n]
    return n, "anm_showcase_anim_"..n, arr.lighttag, arr.funcs
  end
  function public.win_showcase_menter(sender)  
    local n,anim,alphatag,funcs = private.win_showcase_parse(sender)
    ObjAnimate( anim, alphatag, 0, 0, function() end, {0,0,ObjGet(anim)[alphatag] or 0, 0.2,0,1} );
    if n == 1 then
      ObjAnimate( "anm_showcase_anim_"..2, "alpha_ts_arm", 0, 0, function() end, {0,0,ObjGet("anm_showcase_anim_"..2)["alpha_ts_arm"] or 0, 0.2,0,1} );
    end
  end
  function public.win_showcase_mleave(sender)  
    local n,anim,alphatag,funcs = private.win_showcase_parse(sender)
    ObjAnimate( anim, alphatag, 0, 0, function() end, {0,0,ObjGet(anim)[alphatag] or 0, 0.2,0,0} );
    if n == 1 then
      ObjAnimate( "anm_showcase_anim_"..2, "alpha_ts_arm", 0, 0, function() end, {0,0,ObjGet("anm_showcase_anim_"..2)["alpha_ts_arm"] or 0, 0.2,0,0} );
    end
  end
  function public.win_showcase_click(sender)
    SoundSfx( "aud_move_body_"..math.random( 1, 6 ) )
    local n,anim,alphatag,funcs = private.win_showcase_parse(sender)  
    local state = ng_global.progress["std"]["win_showcase"].state[n]
    local nextstate = (state+1)%funcs[2]
    ld.Lock(1)
    ld.AnimPlay( anim, funcs[1].."_"..state, function() 
      ObjSet( anim, {animfunc = funcs[1].."_"..nextstate, frame = 0 } );
      ld.Lock(0)
      save(n) 
    end )
  end
  function public.win_showcase_trywin()
    if iswin then
      public.win_showcase(iswin)
    end
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_showcase" ] = { type = "click", use_place = "gfx_showcase_win_showcase_zone", room = "rm_shop", zz = "zz_showcase", zz_gate = "gzz_shop_showcase" };

private.win_showcase_logic = function()
  if ld.CheckRequirements( {"win_showcase"} ) then
    ObjSet( "spr_showcase_knighthelm", { input = 1, active = 1 } )
  end

end;
private.win_showcase_beg = function()
  if ld.CheckRequirements( {"win_showcase"} ) then
    ObjDelete( "gfx_showcase_win_showcase_zone" );
  end
end;
private.win_showcase_end = function()
  if ld.CheckRequirements( {"win_showcase"} ) then
    ObjSet( "gfx_showcase_knighthelm", { visible = 1 } )
    ObjDelete("spr_shop_bal_tr")
    ObjDelete("spr_shop_nut_tr")
    ObjDelete("spr_shop_charly_tr")
    ObjSet( "spr_shop_open_box_tr", {visible = 1} );
    ObjSet( "spr_shop_knighthelm_tr", {visible = 1} );
    ObjSet( "anm_showcase_anim_base", {animfunc = "win_mmg", frame = 999 } );
    if common_impl.ZzCompleteCheck("win_showcase") then ObjSet( common_impl.hint["win_showcase"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_showcase", private.win_showcase_beg, private.room_objname );
cmn.AddSubscriber( "win_showcase", private.win_showcase_end, private.room_objname );
cmn.AddSubscriber( "win_showcase", private.win_showcase_logic );
cmn.AddSubscriber( "win_showcase_beg", private.win_showcase_beg, private.room_objname );
cmn.AddSubscriber( "win_showcase_end", private.win_showcase_end, private.room_objname );
cmn.AddSubscriber( "win_showcase_end", private.win_showcase_logic );
--------------------------------------------------------------------------------------------
function public.win_showcase(close)

  local func_end = function()
    cmn.SetEventDone( "win_showcase" );
    cmn.CallEventHandler( "win_showcase_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_showcase") then ld.CloseSubRoom() end;
  end;
  if not close then
    SoundSfx( "aud_win_showcase" )
    cmn.CallEventHandler( "win_showcase_beg" );
    common_impl.Lock(1);
    ObjSet( "anm_showcase_anim_base", {input = 0} );
    ObjDelete( "gfx_showcase_win_showcase_zone" );
    ObjGet( "obj_showcase_win_showcase_zoom" ).event_mdown()
    cmn.MiniGameHide( "showcase", true );
  else
    for i,o in pairs(ObjGetRelations( "anm_showcase_anim_base" ).childs) do
      ObjDelete(o)
    end
    ld.AnimPlay( "anm_showcase_anim_base", "win_mmg", func_end );
  end

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_knighthelm" ] = { type = "get", get_obj = "spr_showcase_knighthelm", room = "rm_shop", zz = "zz_showcase", zz_gate = "gzz_shop_showcase" };

private.get_knighthelm_logic = function()
  
end;
private.get_knighthelm_inv = function()
  interface.InventoryItemAdd("inv_knighthelm","spr_showcase_knighthelm");
end;
private.get_knighthelm_beg = function()
  ObjDelete("gfx_showcase_knighthelm")
  ObjSet( "spr_showcase_knighthelm", {visible = 1} );
  ObjSet( "anm_showcase_anim_base", {animfunc = "end_mmg", frame = 0 } );
end;
private.get_knighthelm_end = function()
  ObjDelete("spr_shop_knighthelm_tr")
  if common_impl.ZzCompleteCheck("get_knighthelm") then ObjSet( common_impl.hint["get_knighthelm"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_knighthelm", private.get_knighthelm_inv );
cmn.AddSubscriber( "get_knighthelm", private.get_knighthelm_beg, private.room_objname );
cmn.AddSubscriber( "get_knighthelm", private.get_knighthelm_end, private.room_objname );
cmn.AddSubscriber( "get_knighthelm", private.get_knighthelm_logic );
--------------------------------------------------------------------
function public.get_knighthelm()
  cmn.SetEventDone( "get_knighthelm" );
  cmn.CallEventHandler( "get_knighthelm" );
  if common_impl.ZzCompleteCheck("get_knighthelm") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bluntscates" ] = { type = "use", inv_obj = "inv_bluntscates", use_place = "gfx_showcase_bluntscates_zone", room = "rm_shop", zz = "zz_showcase", zz_gate = "gzz_shop_showcase" };

private.use_bluntscates_logic = function()
  ObjSet( "spr_showcase_scates", { visible = 1, input = 1, active = 1 } )

end;
private.use_bluntscates_inv = function()
  common_impl.ProcessMultiUseAll("bluntscates", "bluntscates")
end;
private.use_bluntscates_beg = function()
  ObjDelete( "gfx_showcase_bluntscates_zone" );
  
end;
private.use_bluntscates_end = function()
  if common_impl.ZzCompleteCheck("use_bluntscates") then ObjSet( common_impl.hint["use_bluntscates"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bluntscates", private.use_bluntscates_inv );
cmn.AddSubscriber( "use_bluntscates", private.use_bluntscates_beg, private.room_objname );
cmn.AddSubscriber( "use_bluntscates", private.use_bluntscates_end, private.room_objname );
cmn.AddSubscriber( "use_bluntscates", private.use_bluntscates_logic );
cmn.AddSubscriber( "use_bluntscates_inv", private.use_bluntscates_inv, private.room_objname );
cmn.AddSubscriber( "use_bluntscates_beg", private.use_bluntscates_beg, private.room_objname );
cmn.AddSubscriber( "use_bluntscates_end", private.use_bluntscates_end, private.room_objname );
cmn.AddSubscriber( "use_bluntscates_end", private.use_bluntscates_logic );
--------------------------------------------------------------------------------------------
function public.use_bluntscates( obj )

  local func_end = function()
    ObjSet( "vid_showcase_vid_idle_wheel_25", {visible = 1} );
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bluntscates" );
    cmn.CallEventHandler( "use_bluntscates_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bluntscates") then ld.CloseSubRoom() end;
    ObjDelete("vid_showcase_vid_skate_sharp_188")
    public.get_scates()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bluntscates_inv" );
  cmn.CallEventHandler( "use_bluntscates_beg" );
  common_impl.Lock(1);
  
  ObjSet( "vid_showcase_vid_idle_wheel_25", {visible = 0} );
  ObjAttach("vid_showcase_vid_skate_sharp_188","zz_showcase")
  VidPlay("vid_showcase_vid_skate_sharp_188",func_end)
  SoundVid( "aud_skate_sharp_188" )
  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_scates" ] = { type = "get", get_obj = "spr_showcase_scates", room = "rm_shop", zz = "zz_showcase", zz_gate = "gzz_shop_showcase" };

private.get_scates_logic = function()
  
end;
private.get_scates_inv = function()
  interface.InventoryItemAdd("inv_scates","spr_showcase_scates");
end;
private.get_scates_beg = function()
  ObjDelete("gfx_showcase_scates")
end;
private.get_scates_end = function()
  if common_impl.ZzCompleteCheck("get_scates") then ObjSet( common_impl.hint["get_scates"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_scates", private.get_scates_inv );
cmn.AddSubscriber( "get_scates", private.get_scates_beg, private.room_objname );
cmn.AddSubscriber( "get_scates", private.get_scates_end, private.room_objname );
cmn.AddSubscriber( "get_scates", private.get_scates_logic );
--------------------------------------------------------------------
function public.get_scates()
  cmn.SetEventDone( "get_scates" );
  cmn.CallEventHandler( "get_scates" );
  if common_impl.ZzCompleteCheck("get_scates") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  function public.Reset()
    local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

    if ( mg_name == "zz_showcase" ) then
      public.win_showcase_load(1)
    end

  end;
  function public.Skip()
    local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
      
    if ( mg_name == "zz_showcase" ) then
      public.win_showcase_load(nil,1)
    end

  end;

  local win_statuemg_for_shop_logic = function()
    if ld.CheckRequirements( {"win_statuemg"} ) then
      ObjSet( "gfx_shop_dlg_shop_michael2_zone", { input = 1, active = 1 } )
      ObjDelete("obj_shop_michael_fig_broken")
    end
  end

  local win_statuemg_for_shop = function()
    if ld.CheckRequirements( {"win_statuemg"} ) then
      ObjSet( "gmg_shop_statuemg", {input = 0, visible = 0} );
      ObjDelete("spr_shop_tr_deer_br")
      ObjSet( "spr_shop_tr_deer_get", {visible = 1} );
    end
  end;
  cmn.AddSubscriber("win_statuemg", win_statuemg_for_shop, private.room_objname )
  cmn.AddSubscriber("win_statuemg", win_statuemg_for_shop_logic )

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_shop();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_shop_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_showcase" );
  function zz_showcase.Open()
  end;
  function zz_showcase.PreOpen()
    if ld.CheckRequirements( {"use_figurmaster","use_figurboy","use_figurwomen"} ) and not ld.CheckRequirements( {"win_showcase"} ) then
      public.win_showcase_load()
    end  
  end;
  function zz_showcase.PreClose()
  end;
  function zz_showcase.Close()
    if ld.CheckRequirements( {"use_figurmaster","use_figurboy","use_figurwomen"} ) and not ld.CheckRequirements( {"win_showcase"} ) then
      ObjAttach("anm_showcase_anim_base","zz_showcase")
      ObjSet( "anm_showcase_anim_base", {animfunc = "mmg_open", frame = 0, input = 0 } );
    end
  end;

  subroom.Define( "zz_brokenstatue" );
  function zz_brokenstatue.Open()
  end;
  function zz_brokenstatue.PreOpen()
  end;
  function zz_brokenstatue.PreClose()
  end;
  function zz_brokenstatue.Close()
  end;
  
end;
--*********************************************************************************************************************