-- name=rm_workshop
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_workshop";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  ld.NoteInit("anm_sewingtable_anim_use_list", "spr_sewingtable_list_big", "txt_sewingtable_list")
  ld.NoteRelaseLock("anm_sewingtable_anim_use_list")

  --------------------------------------------------------------------------------------------
function private.opn_workshop()
  if not ( cmn.IsEventDone( "opn_workshop" ) ) then
    cmn.SetEventDone( "opn_workshop" );
    cmn.CallEventHandler( "opn_workshop" )
    ld.ShowBbtOpn( private.room_objname)
  else
    public.clk_workshopbertagoldvid()
  end;
end;
--------------------------------------------------------------------
local opn_workshop = function() 

end;
local opn_workshop_logic = function() 
  
end;
cmn.AddSubscriber( "opn_workshop", opn_workshop_logic )
cmn.AddSubscriber( "opn_workshop", opn_workshop, private.room_objname )
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "goody2" then
    if count_txt == 1 then
      common_impl.continue_visible = true
      ld.AnimPlay( "anm_workshop_goody2", "give_bell", "" )
    elseif count_txt == 2 then
      ld.AnimPlay( "anm_workshop_goody2", "hand_end", "" )
      cmn.CallEventHandler( "get_bell2" );
    end

  elseif dlg_name == "jack2" then
    if count_txt == 1 then
      common_impl.continue_visible = true
      ObjAnimate( "anm_workshop_2_ball", 8, 0, 0, function() ld.AnimPlay( "anm_workshop_2_ball", "spuce", "" ); end, {0,0,0, 0.5,0,1} );
    elseif count_txt == 2 then
      

      --ObjAnimate( "anm_workshop_2_ball", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
    end
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_workshopbertagoldvid" ] = { type = "click", use_place = "gfx_workshop_clk_workshopbertagoldvid_zone", room = "rm_workshop" };

private.clk_workshopbertagoldvid_logic = function()

end;
private.clk_workshopbertagoldvid_beg = function()
  ObjDelete( "gfx_workshop_clk_workshopbertagoldvid_zone" );
end;
private.clk_workshopbertagoldvid_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_workshopbertagoldvid", private.clk_workshopbertagoldvid_beg, private.room_objname );
cmn.AddSubscriber( "clk_workshopbertagoldvid", private.clk_workshopbertagoldvid_end, private.room_objname );
cmn.AddSubscriber( "clk_workshopbertagoldvid", private.clk_workshopbertagoldvid_logic );
cmn.AddSubscriber( "clk_workshopbertagoldvid_beg", private.clk_workshopbertagoldvid_beg, private.room_objname );
cmn.AddSubscriber( "clk_workshopbertagoldvid_end", private.clk_workshopbertagoldvid_end, private.room_objname );
cmn.AddSubscriber( "clk_workshopbertagoldvid_end", private.clk_workshopbertagoldvid_logic );
--------------------------------------------------------------------------------------------
function public.clk_workshopbertagoldvid()
  if not ld.CheckRequirements( {"clk_workshopbertagoldvid"} ) and  ld.CheckRequirements( {"get_amuletelf4"} ) then
    local func_end = function()
      cmn.SetEventDone( "clk_workshopbertagoldvid" );
      cmn.CallEventHandler( "clk_workshopbertagoldvid_end" );
      int.DialogVideoHide();
      ld.ShowBbt( "clk_workshopbertagoldvid" )
    end;
    cmn.CallEventHandler( "clk_workshopbertagoldvid_beg" );
    int.DialogVideoShow( "vid_workshop_bertagold", 1, func_end );
    --[[
    common_impl.VideoSubtitleVocStart( {
      { "srt_clk_workshopbertagoldvid" , aud_voc_false, 17,22 };
    } );
    ]]
    SoundVoice( "aud_bertagold_voc" );
    SoundVid( "aud_bertagold" );
    VidPlay("vid_workshop_bertagold",func_end);
  end
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------

--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
function public.dlg_workshop_jack2(  )
  local func_end = function()
    common_impl.Lock(0);
    cmn.SetEventDone( "use_elf_sewingtable" );
    cmn.CallEventHandler( "use_elf_sewingtable_end" );
    cmn.GotoRoom( "rm_newyard" );
    --cmn.GotoRoom( "rm_outro" );
  end
  function public.dlg_workshop_jack2_func_end()
    level_inv.SetGoodball(3);
    ld.Lock(1)
    ld.StartTimer( 1, function() func_end() end )
    --video teleport 2 -> 3
  end
  local start_dialog = function() 
    ld.Lock(0)
    common_impl.dialog_character_loc = "";
    common_impl.Start( "jack2", 2, nil, nil, true, "dlg_workshop_jack2_func_end", { "aud_jack_frost_11_voc" } );
  end
  local start_dialog_1 = function()
    ObjSet( "spr_workshop_no_kaftan", {visible = 1} );
    ObjSet( "spr_workshop_no_peter", {visible = 1} );
    int.DialogVideoHide();
    ld.Lock(1)
    ld.StartTimer( 0.5, start_dialog )    
  end
  int.DialogVideoShow( "vid_workshop_outro", 1, start_dialog_1 );
  ObjAnimate( "vid_workshop_outro", 7, 0, 0, function() 
    SoundVid( "aud_outro_2lvl" );
    SoundVoice( "aud_outro_2lvl_voc" );
    --[[
    common_impl.VideoSubtitleVocStart( {
      { "srt_outro_2lvl_1" , aud_voc_false, 0,6.5 };
      { "srt_outro_2lvl_2" , aud_voc_false, 8,15 };
    } );
    ]]
    VidPlay("vid_workshop_outro",start_dialog_1);
  end, {0,0,0, 0,0,0} );
end;
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_workshop_goody2" ] = { type = "click", use_place = "gfx_workshop_dlg_workshop_goody2_zone", room = "rm_workshop" };

private.dlg_workshop_goody2_logic = function()
  --ObjSet( "spr_sewingtable_mouse", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_sewingtable_bell2", { visible = 1, input = 1, active = 1 } )


end;
private.dlg_workshop_goody2_beg = function()
  ObjDelete( "gfx_workshop_dlg_workshop_goody2_zone" );
end;
private.dlg_workshop_goody2_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_workshop_goody2", private.dlg_workshop_goody2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_workshop_goody2", private.dlg_workshop_goody2_end, private.room_objname );
cmn.AddSubscriber( "dlg_workshop_goody2", private.dlg_workshop_goody2_logic );
cmn.AddSubscriber( "dlg_workshop_goody2_beg", private.dlg_workshop_goody2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_workshop_goody2_end", private.dlg_workshop_goody2_end, private.room_objname );
cmn.AddSubscriber( "dlg_workshop_goody2_end", private.dlg_workshop_goody2_logic );
--------------------------------------------------------------------------------------------
function public.dlg_workshop_goody2( obj )

  local func_end = function()

    cmn.CallEventHandler( "dlg_workshop_goody2_end" );
    common_impl.Lock(0);
    public.get_mouse()

  end
  function public.dlg_workshop_goody2_func_end()
    if ObjGetRelations( "inv_bell2" ).parent == "level_inv_hub" then
      cmn.CallEventHandler( "get_bell2" );
    end  
    ObjDelete("vid_sewingtable_vid_mother_static")
    ObjAttach("vid_sewingtable_vid_mother_out","zz_sewingtable")
    common_impl.Lock(1);
    --ObjSet( "spr_sewingtable_mouse", { visible = 1 } )
    ObjSet( "spr_sewingtable_bell2", { visible = 1 } )
    ld.StartTimer( 0.5, function() 
      common_impl.Gate_MDown( "gzz_workshop_sewingtable", {ObjGet("gzz_workshop_sewingtable").pos_x,ObjGet("gzz_workshop_sewingtable").pos_y} )
      ld.StartTimer( 0.5, function() func_end() end )
    end )
    
  end
  cmn.CallEventHandler( "dlg_workshop_goody2_beg" );
  --common_impl.Lock(1);
  common_impl.dialog_character_loc = "";
  common_impl.Start( "goody2", 2, nil, nil, true, "dlg_workshop_goody2_func_end", { "aud_goody_3_voc" } );

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( 0 )
  --func_end()

end;

--------------------------------------------------------------------
common_impl.hint[ "get_bell2" ] = { type = "get", get_obj = "spr_workshop_bell2", room = "rm_workshop" };

private.get_bell2_logic = function()
  
end;
private.get_bell2_inv = function()
  interface.InventoryItemAdd("inv_bell2","spr_workshop_bell2");
end;
private.get_bell2_beg = function()
  ObjDelete("gfx_workshop_bell2")
  ObjSet( "spr_workshop_bell2", {visible = 1} );
end;
private.get_bell2_end = function()
end;

cmn.AddSubscriber( "get_bell2", private.get_bell2_inv );
cmn.AddSubscriber( "get_bell2", private.get_bell2_beg, private.room_objname );
cmn.AddSubscriber( "get_bell2", private.get_bell2_end, private.room_objname );
cmn.AddSubscriber( "get_bell2", private.get_bell2_logic );
--------------------------------------------------------------------
function public.get_bell2()
  cmn.SetEventDone( "get_bell2" );
  cmn.CallEventHandler( "get_bell2" );
end
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_piter *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_amuletmonequin" ] = { type = "get", get_obj = "spr_piter_amuletmonequin", room = "rm_workshop", zz = "zz_piter", zz_gate = "gzz_workshop_piter" };

private.get_amuletmonequin_logic = function()
  
end;
private.get_amuletmonequin_inv = function()
  interface.InventoryItemAdd("inv_amuletmonequin","spr_piter_amuletmonequin");
end;
private.get_amuletmonequin_beg = function()
  ObjDelete("gfx_piter_amuletmonequin")
end;
private.get_amuletmonequin_end = function()
  if common_impl.ZzCompleteCheck("get_amuletmonequin") then ObjSet( common_impl.hint["get_amuletmonequin"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletmonequin", private.get_amuletmonequin_inv );
cmn.AddSubscriber( "get_amuletmonequin", private.get_amuletmonequin_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletmonequin", private.get_amuletmonequin_end, private.room_objname );
cmn.AddSubscriber( "get_amuletmonequin", private.get_amuletmonequin_logic );
--------------------------------------------------------------------
function public.get_amuletmonequin()
  cmn.SetEventDone( "get_amuletmonequin" );
  cmn.CallEventHandler( "get_amuletmonequin" );
  if common_impl.ZzCompleteCheck("get_amuletmonequin") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_pillow" ] = { type = "use", inv_obj = "inv_pillow", use_place = "gfx_piter_pillow_zone", room = "rm_workshop", zz = "zz_piter", zz_gate = "gzz_workshop_piter" };

private.use_pillow_logic = function()
  ObjSet( "spr_piter_piterdiary", { visible = 1, input = 1, active = 1 } )

end;
private.use_pillow_inv = function()
  common_impl.ProcessMultiUseAll("pillow", "pillow")
end;
private.use_pillow_beg = function()
  ObjDelete( "gfx_piter_pillow_zone" );
end;
private.use_pillow_end = function()
  ObjDelete("spr_workshop_diary")
  ObjSet( "anm_piter_anim_piter", {animfunc = "use_pillow_end", frame = 0 } );
  ObjSet( "spr_workshop_pillow_used", {visible = 1} );
  ObjSet( "anm_piter_anim_candy", {pos_z = 9 } );
  ObjSet( "anm_piter_anim_hh1", {pos_z = 10 } );
  if common_impl.ZzCompleteCheck("use_pillow") then ObjSet( common_impl.hint["use_pillow"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_pillow", private.use_pillow_inv );
cmn.AddSubscriber( "use_pillow", private.use_pillow_beg, private.room_objname );
cmn.AddSubscriber( "use_pillow", private.use_pillow_end, private.room_objname );
cmn.AddSubscriber( "use_pillow", private.use_pillow_logic );
cmn.AddSubscriber( "use_pillow_inv", private.use_pillow_inv, private.room_objname );
cmn.AddSubscriber( "use_pillow_beg", private.use_pillow_beg, private.room_objname );
cmn.AddSubscriber( "use_pillow_end", private.use_pillow_end, private.room_objname );
cmn.AddSubscriber( "use_pillow_end", private.use_pillow_logic );
--------------------------------------------------------------------------------------------
function public.use_pillow( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_pillow" );
    cmn.CallEventHandler( "use_pillow_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_pillow") then ld.CloseSubRoom() end;
    public.get_piterdiary()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_pillow_inv" );
  cmn.CallEventHandler( "use_pillow_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_piter_anim_piter", "use_pillow", func_end );
  SoundSfx( "aud_use_pillow_piter" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_piterdiary" ] = { type = "get", get_obj = "spr_piter_piterdiary", room = "rm_workshop", zz = "zz_piter", zz_gate = "gzz_workshop_piter" };

private.get_piterdiary_logic = function()
  
end;
private.get_piterdiary_inv = function()
  interface.InventoryItemAdd("inv_piterdiary","spr_piter_piterdiary");
  ObjSet( "inv_piterdiary", { drag = 0 } );
end;
private.get_piterdiary_beg = function()
  ObjDelete("gfx_piter_piterdiary")
end;
private.get_piterdiary_end = function()
  ObjSet( "obj_piter_bbt_piter_sleep", { visible = 1, input = 1, active = 1 } )
  ObjSet( "obj_workshop_bbt_piter_sleep", { visible = 1, input = 1, active = 1 } )
  if common_impl.ZzCompleteCheck("get_piterdiary") then ObjSet( common_impl.hint["get_piterdiary"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_piterdiary", private.get_piterdiary_inv );
cmn.AddSubscriber( "get_piterdiary", private.get_piterdiary_beg, private.room_objname );
cmn.AddSubscriber( "get_piterdiary", private.get_piterdiary_end, private.room_objname );
cmn.AddSubscriber( "get_piterdiary", private.get_piterdiary_logic );
--------------------------------------------------------------------
function public.get_piterdiary()
  cmn.SetEventDone( "get_piterdiary" );
  cmn.CallEventHandler( "get_piterdiary" );
  if common_impl.ZzCompleteCheck("get_piterdiary") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_candy" ] = { type = "use", inv_obj = "inv_candy", use_place = "gfx_piter_candy_zone", room = "rm_workshop", zz = "zz_piter", zz_gate = "gzz_workshop_piter" };

private.use_candy_logic = function()
  ObjSet( "spr_piter_key", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_piter_torneddiplom", { visible = 1, input = 1, active = 1 } )

end;
private.use_candy_inv = function()
  common_impl.ProcessMultiUseAll("candy", "candy")
end;
private.use_candy_beg = function()
  ObjDelete( "gfx_piter_candy_zone" );
end;
private.use_candy_end = function()
  ObjDelete("spr_workshop_closed_candyhouse")
  ObjSet( "spr_workshop_opened_candyhouse", {visible = 1} );
  ObjSet( "anm_piter_anim_candy", {animfunc = "use_candy_end", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_candy") then ObjSet( common_impl.hint["use_candy"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_candy", private.use_candy_inv );
cmn.AddSubscriber( "use_candy", private.use_candy_beg, private.room_objname );
cmn.AddSubscriber( "use_candy", private.use_candy_end, private.room_objname );
cmn.AddSubscriber( "use_candy", private.use_candy_logic );
cmn.AddSubscriber( "use_candy_inv", private.use_candy_inv, private.room_objname );
cmn.AddSubscriber( "use_candy_beg", private.use_candy_beg, private.room_objname );
cmn.AddSubscriber( "use_candy_end", private.use_candy_end, private.room_objname );
cmn.AddSubscriber( "use_candy_end", private.use_candy_logic );
--------------------------------------------------------------------------------------------
function public.use_candy( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_candy" );
    cmn.CallEventHandler( "use_candy_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_candy") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_candy_inv" );
  cmn.CallEventHandler( "use_candy_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_piter_anim_candy", "use_candy", func_end );
  SoundSfx( "aud_use_candy_piter" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_key" ] = { type = "get", get_obj = "spr_piter_key", room = "rm_workshop", zz = "zz_piter", zz_gate = "gzz_workshop_piter" };

private.get_key_logic = function()
  
end;
private.get_key_inv = function()
  interface.InventoryItemAdd("inv_key","spr_piter_key");
end;
private.get_key_beg = function()
  ObjDelete("gfx_piter_key")
end;
private.get_key_end = function()
  if common_impl.ZzCompleteCheck("get_key") then ObjSet( common_impl.hint["get_key"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_key", private.get_key_inv );
cmn.AddSubscriber( "get_key", private.get_key_beg, private.room_objname );
cmn.AddSubscriber( "get_key", private.get_key_end, private.room_objname );
cmn.AddSubscriber( "get_key", private.get_key_logic );
--------------------------------------------------------------------
function public.get_key()
  cmn.SetEventDone( "get_key" );
  cmn.CallEventHandler( "get_key" );
  if common_impl.ZzCompleteCheck("get_key") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_torneddiplom" ] = { type = "get", get_obj = "spr_piter_torneddiplom", room = "rm_workshop", zz = "zz_piter", zz_gate = "gzz_workshop_piter" };

private.get_torneddiplom_logic = function()
  
end;
private.get_torneddiplom_inv = function()
  interface.InventoryItemAdd("inv_torneddiplom","spr_piter_torneddiplom");
  ObjSet( "inv_torneddiplom", { drag = 0 } );
end;
private.get_torneddiplom_beg = function()
  ObjDelete("gfx_piter_torneddiplom")
end;
private.get_torneddiplom_end = function()
  if common_impl.ZzCompleteCheck("get_torneddiplom") then ObjSet( common_impl.hint["get_torneddiplom"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_torneddiplom", private.get_torneddiplom_inv );
cmn.AddSubscriber( "get_torneddiplom", private.get_torneddiplom_beg, private.room_objname );
cmn.AddSubscriber( "get_torneddiplom", private.get_torneddiplom_end, private.room_objname );
cmn.AddSubscriber( "get_torneddiplom", private.get_torneddiplom_logic );
--------------------------------------------------------------------
function public.get_torneddiplom()
  cmn.SetEventDone( "get_torneddiplom" );
  cmn.CallEventHandler( "get_torneddiplom" );
  if common_impl.ZzCompleteCheck("get_torneddiplom") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_sewingtable *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_sewingtableanim" ] = { type = "click", use_place = "gfx_sewingtable_clk_sewingtableanim_zone", room = "rm_workshop", zz = "zz_sewingtable", zz_gate = "gzz_workshop_sewingtable" };

private.clk_sewingtableanim_logic = function()
  ObjSet( "spr_sewingtable_pillow", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_sewingtable_sparkler_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_sewingtable_list_zone", { visible = 1, input = 1, active = 1 } ) 

end;
private.clk_sewingtableanim_beg = function()
  ObjDelete( "gfx_sewingtable_clk_sewingtableanim_zone" );
end;
private.clk_sewingtableanim_end = function()
  ObjSet( "spr_workshop_mouse_static", {visible = 1} );
  ObjAttach("vid_sewingtable_vid_mother_static","zz_sewingtable")
  if common_impl.ZzCompleteCheck("clk_sewingtableanim") then ObjSet( common_impl.hint["clk_sewingtableanim"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_sewingtableanim", private.clk_sewingtableanim_beg, private.room_objname );
cmn.AddSubscriber( "clk_sewingtableanim", private.clk_sewingtableanim_end, private.room_objname );
cmn.AddSubscriber( "clk_sewingtableanim", private.clk_sewingtableanim_logic );
cmn.AddSubscriber( "clk_sewingtableanim_beg", private.clk_sewingtableanim_beg, private.room_objname );
cmn.AddSubscriber( "clk_sewingtableanim_end", private.clk_sewingtableanim_end, private.room_objname );
cmn.AddSubscriber( "clk_sewingtableanim_end", private.clk_sewingtableanim_logic );
--------------------------------------------------------------------------------------------
function public.clk_sewingtableanim()

  local func_end = function()
    cmn.SetEventDone( "clk_sewingtableanim" );
    cmn.CallEventHandler( "clk_sewingtableanim_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_sewingtableanim") then ld.CloseSubRoom() end;
    ld.ShowBbt( "clk_sewingtableanim" )
    ObjDelete("vid_sewingtable_vid_mother_in")
  end;
  local func_end_2 = function() 
    ObjDelete("vid_sewingtable_vid_little_mouse")
    ObjAttach("vid_sewingtable_vid_mother_in","zz_sewingtable")
    VidPlay("vid_sewingtable_vid_mother_in",func_end)
  end
  cmn.CallEventHandler( "clk_sewingtableanim_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  ObjAttach("vid_sewingtable_vid_little_mouse","zz_sewingtable");
  VidPlay("vid_sewingtable_vid_little_mouse",func_end_2)
  SoundVid( "aud_clk_sewingtableanim" )

  --func_end()
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_pillow" ] = { type = "get", get_obj = "spr_sewingtable_pillow", room = "rm_workshop", zz = "zz_sewingtable", zz_gate = "gzz_workshop_sewingtable" };

private.get_pillow_logic = function()
 
end;
private.get_pillow_inv = function()
  interface.InventoryItemAdd("inv_pillow","spr_sewingtable_pillow");
end;
private.get_pillow_beg = function()
  ObjDelete("gfx_sewingtable_pillow")
end;
private.get_pillow_end = function()
  ObjDelete("spr_sewingtable_pillow_shadow")
  ObjDelete("spr_workshop_pillow")
  if common_impl.ZzCompleteCheck("get_pillow") then ObjSet( common_impl.hint["get_pillow"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_pillow", private.get_pillow_inv );
cmn.AddSubscriber( "get_pillow", private.get_pillow_beg, private.room_objname );
cmn.AddSubscriber( "get_pillow", private.get_pillow_end, private.room_objname );
cmn.AddSubscriber( "get_pillow", private.get_pillow_logic );
--------------------------------------------------------------------
function public.get_pillow()
  cmn.SetEventDone( "get_pillow" );
  cmn.CallEventHandler( "get_pillow" );
  if common_impl.ZzCompleteCheck("get_pillow") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_sparkler" ] = { type = "use", inv_obj = "inv_sparkler", use_place = "gfx_sewingtable_sparkler_zone", room = "rm_workshop", zz = "zz_sewingtable", zz_gate = "gzz_workshop_sewingtable" };

private.use_sparkler_logic = function()
  ObjSet( "spr_sewingtable_aflamesparkler", {  input = 1, active = 1 } )

end;
private.use_sparkler_inv = function()
  common_impl.ProcessMultiUseAll("sparkler", "sparkler")
end;
private.use_sparkler_beg = function()
  ObjDelete( "gfx_sewingtable_sparkler_zone" );
end;
private.use_sparkler_end = function()
  
  if common_impl.ZzCompleteCheck("use_sparkler") then ObjSet( common_impl.hint["use_sparkler"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sparkler", private.use_sparkler_inv );
cmn.AddSubscriber( "use_sparkler", private.use_sparkler_beg, private.room_objname );
cmn.AddSubscriber( "use_sparkler", private.use_sparkler_end, private.room_objname );
cmn.AddSubscriber( "use_sparkler", private.use_sparkler_logic );
cmn.AddSubscriber( "use_sparkler_inv", private.use_sparkler_inv, private.room_objname );
cmn.AddSubscriber( "use_sparkler_beg", private.use_sparkler_beg, private.room_objname );
cmn.AddSubscriber( "use_sparkler_end", private.use_sparkler_end, private.room_objname );
cmn.AddSubscriber( "use_sparkler_end", private.use_sparkler_logic );
--------------------------------------------------------------------------------------------
function public.use_sparkler( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_sparkler" );
    cmn.CallEventHandler( "use_sparkler_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_sparkler") then ld.CloseSubRoom() end;
    public.get_aflamesparkler()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sparkler_inv" );
  cmn.CallEventHandler( "use_sparkler_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sewingtable_anim_use_sparkler", "use_sparkler", func_end );
  SoundSfx( "aud_use_sparkler_sewingtable" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_aflamesparkler" ] = { type = "get", get_obj = "spr_sewingtable_aflamesparkler", room = "rm_workshop", zz = "zz_sewingtable", zz_gate = "gzz_workshop_sewingtable" };

private.get_aflamesparkler_logic = function()
  
end;
private.get_aflamesparkler_inv = function()
  interface.InventoryItemAdd("inv_aflamesparkler","anm_sewingtable_anim_use_sparkler");
  ObjDelete("spr_sewingtable_aflamesparkler")
  ld.StartTimer( 0.1, function() ObjSet( "fx_aflamesparkler", {active = 0} ); end )
end;
private.get_aflamesparkler_beg = function()
  ObjDelete("gfx_sewingtable_aflamesparkler")
end;
private.get_aflamesparkler_end = function()
  if common_impl.ZzCompleteCheck("get_aflamesparkler") then ObjSet( common_impl.hint["get_aflamesparkler"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_aflamesparkler", private.get_aflamesparkler_inv );
cmn.AddSubscriber( "get_aflamesparkler", private.get_aflamesparkler_beg, private.room_objname );
cmn.AddSubscriber( "get_aflamesparkler", private.get_aflamesparkler_end, private.room_objname );
cmn.AddSubscriber( "get_aflamesparkler", private.get_aflamesparkler_logic );
--------------------------------------------------------------------
function public.get_aflamesparkler()
  cmn.SetEventDone( "get_aflamesparkler" );
  cmn.CallEventHandler( "get_aflamesparkler" );
  if common_impl.ZzCompleteCheck("get_aflamesparkler") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_list" ] = { type = "use", inv_obj = "inv_list", use_place = "gfx_sewingtable_list_zone", room = "rm_workshop", zz = "zz_sewingtable", zz_gate = "gzz_workshop_sewingtable" };

private.use_list_logic = function()
  ObjSet( "gfx_workshop_dlg_workshop_goody2_zone", {  input = 1, active = 1 } )

end;
private.use_list_inv = function()
  common_impl.ProcessMultiUseAll("list", "list")
end;
private.use_list_beg = function()
  ObjDelete( "gfx_sewingtable_list_zone" );
end;
private.use_list_end = function()
  ObjSet( "spr_workshop_list", {visible = 1} );
  ObjSet( "anm_sewingtable_anim_use_list", {animfunc = "use_list", frame = 999, input = 1 } );
  if common_impl.ZzCompleteCheck("use_list") then ObjSet( common_impl.hint["use_list"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_list", private.use_list_inv );
cmn.AddSubscriber( "use_list", private.use_list_beg, private.room_objname );
cmn.AddSubscriber( "use_list", private.use_list_end, private.room_objname );
cmn.AddSubscriber( "use_list", private.use_list_logic );
cmn.AddSubscriber( "use_list_inv", private.use_list_inv, private.room_objname );
cmn.AddSubscriber( "use_list_beg", private.use_list_beg, private.room_objname );
cmn.AddSubscriber( "use_list_end", private.use_list_end, private.room_objname );
cmn.AddSubscriber( "use_list_end", private.use_list_logic );
--------------------------------------------------------------------------------------------
function public.use_list( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});

    cmn.CallEventHandler( "use_list_end" );
    common_impl.Lock(0);
    --if common_impl.ZzCompleteCheck("use_list") then ld.CloseSubRoom() end;
    ld.CloseSubRoom()
    public.dlg_workshop_goody2( )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_list_inv" );
  cmn.CallEventHandler( "use_list_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sewingtable_anim_use_list", "use_list", func_end );
  SoundSfx( "aud_use_list_sewingtable" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_mouse" ] = { type = "get", get_obj = "spr_sewingtable_mouse", room = "rm_workshop", zz = "zz_sewingtable", zz_gate = "gzz_workshop_sewingtable" };

private.get_mouse_logic = function()
  ObjSet( "gfx_sewingtable_whitethreads_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_sewingtable_clasp_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_sewingtable_goldenthreads_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_sewingtable_sketch_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_sewingtable_goldenbuttons_zone", { visible = 1, input = 1, active = 1 } )
end;
private.get_mouse_inv = function()
  --interface.InventoryItemAdd("inv_mouse","spr_sewingtable_mouse");
  ObjDelete("spr_sewingtable_mouse")
  int_simon.LoadAnotherPrg();
end;
private.get_mouse_beg = function()
  ObjDelete("gfx_sewingtable_mouse")
  ObjSet( "spr_sewingtable_mouse", {input = 0} );
end;
private.get_mouse_end = function()
  ObjSet( "obj_sewingtable_goody_action_zone", {input = 1} );
  ObjDelete("spr_workshop_mouse_static")
  ObjDelete("vid_sewingtable_vid_mother_static")
  ObjSet( "spr_sewingtable_goodie_sit", {visible = 1} );
  ObjSet( "spr_workshop_goodie_table", {visible = 1} );
  if common_impl.ZzCompleteCheck("get_mouse") then ObjSet( common_impl.hint["get_mouse"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_mouse", private.get_mouse_inv );
cmn.AddSubscriber( "get_mouse", private.get_mouse_beg, private.room_objname );
cmn.AddSubscriber( "get_mouse", private.get_mouse_end, private.room_objname );
cmn.AddSubscriber( "get_mouse", private.get_mouse_logic );

cmn.AddSubscriber( "get_mouse_end", private.get_mouse_inv );
cmn.AddSubscriber( "get_mouse_beg", private.get_mouse_beg, private.room_objname );
cmn.AddSubscriber( "get_mouse_end", private.get_mouse_end, private.room_objname );
cmn.AddSubscriber( "get_mouse_end", private.get_mouse_logic );
--------------------------------------------------------------------
function public.get_mouse()
  local function func_end() 
    cmn.SetEventDone( "get_bell2" );
    cmn.SetEventDone( "use_list" );
    cmn.SetEventDone( "dlg_workshop_goody2" );
    cmn.SetEventDone( "get_mouse" );
    cmn.CallEventHandler( "get_mouse_end" );
    ld.Lock(0)
    if common_impl.ZzCompleteCheck("get_mouse") then ld.CloseSubRoom() end;
    int_simon.SimonSetVisible(1)
    interface.SimonReturn()
    ObjDelete("vid_sewingtable_vid_mother_out")
  end
  local function func_end_3() 
    ObjDelete("vid_sewingtable_vid_mother_out")
    ObjSet( "spr_sewingtable_mouse", {visible = 1} );
    ObjSet( "spr_sewingtable_goodie_sit", {visible = 1} );
    SoundSfx( "aud_get" )
    int_inventory.StdItemFlyAnimation( "spr_sewingtable_mouse", "obj_int_button_map_point_for_cube", func_end );
  end
  local function func_end_2() 
    VidPlay("vid_sewingtable_vid_mother_out",func_end_3)
  end
  ld.Lock(1)
  cmn.CallEventHandler( "get_mouse_beg" );
  int_simon.SimonActiveCursor()
  interface.SimonJump(func_end_2)
end
--------------------------------------------------------------------

--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_whitethreads" ] = { type = "use", inv_obj = "inv_whitethreads", use_place = "gfx_sewingtable_whitethreads_zone", room = "rm_workshop", zz = "zz_sewingtable", zz_gate = "gzz_workshop_sewingtable" };

private.use_whitethreads_logic = function()
  if ld.CheckRequirements( {"use_whitethreads","use_clasp","use_goldenthreads","use_sketch","use_goldenbuttons"} ) then
    ObjSet( "gfx_sewingtable_elf_sewingtable_zone", { visible = 1, input = 1, active = 1 } )
  end;
end;
private.use_whitethreads_inv = function()
  common_impl.ProcessMultiUseAll("whitethreads", "whitethreads")
end;
private.use_whitethreads_beg = function()
  ObjDelete( "gfx_sewingtable_whitethreads_zone" );
end;
private.use_whitethreads_end = function()
  ObjSet( "spr_workshop_white_thread", {visible = 1} );
  ObjSet( "anm_sewingtable_anim_use_white_thread", {animfunc = "use_white_thread", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_whitethreads") then ObjSet( common_impl.hint["use_whitethreads"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_whitethreads", private.use_whitethreads_inv );
cmn.AddSubscriber( "use_whitethreads", private.use_whitethreads_beg, private.room_objname );
cmn.AddSubscriber( "use_whitethreads", private.use_whitethreads_end, private.room_objname );
cmn.AddSubscriber( "use_whitethreads", private.use_whitethreads_logic );
cmn.AddSubscriber( "use_whitethreads_inv", private.use_whitethreads_inv, private.room_objname );
cmn.AddSubscriber( "use_whitethreads_beg", private.use_whitethreads_beg, private.room_objname );
cmn.AddSubscriber( "use_whitethreads_end", private.use_whitethreads_end, private.room_objname );
cmn.AddSubscriber( "use_whitethreads_end", private.use_whitethreads_logic );
--------------------------------------------------------------------------------------------
function public.use_whitethreads( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_whitethreads" );
    cmn.CallEventHandler( "use_whitethreads_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_whitethreads") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_whitethreads_inv" );
  cmn.CallEventHandler( "use_whitethreads_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sewingtable_anim_use_white_thread", "use_white_thread", func_end );
  SoundSfx( "aud_use_whitethreads_sewingtable" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_clasp" ] = { type = "use", inv_obj = "inv_clasp", use_place = "gfx_sewingtable_clasp_zone", room = "rm_workshop", zz = "zz_sewingtable", zz_gate = "gzz_workshop_sewingtable" };

private.use_clasp_logic = function()
  if ld.CheckRequirements( {"use_clasp","use_whitethreads","use_goldenthreads","use_sketch","use_goldenbuttons"} ) then
    ObjSet( "gfx_sewingtable_elf_sewingtable_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_clasp_inv = function()
  common_impl.ProcessMultiUseAll("clasp", "clasp")
end;
private.use_clasp_beg = function()
  ObjDelete( "gfx_sewingtable_clasp_zone" );
end;
private.use_clasp_end = function()
  ObjSet( "spr_workshop_buckles", {visible = 1} );
  ObjSet( "anm_sewingtable_anim_use_buckles", {animfunc = "use_buckles", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_clasp") then ObjSet( common_impl.hint["use_clasp"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_clasp", private.use_clasp_inv );
cmn.AddSubscriber( "use_clasp", private.use_clasp_beg, private.room_objname );
cmn.AddSubscriber( "use_clasp", private.use_clasp_end, private.room_objname );
cmn.AddSubscriber( "use_clasp", private.use_clasp_logic );
cmn.AddSubscriber( "use_clasp_inv", private.use_clasp_inv, private.room_objname );
cmn.AddSubscriber( "use_clasp_beg", private.use_clasp_beg, private.room_objname );
cmn.AddSubscriber( "use_clasp_end", private.use_clasp_end, private.room_objname );
cmn.AddSubscriber( "use_clasp_end", private.use_clasp_logic );
--------------------------------------------------------------------------------------------
function public.use_clasp( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_clasp" );
    cmn.CallEventHandler( "use_clasp_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_clasp") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_clasp_inv" );
  cmn.CallEventHandler( "use_clasp_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sewingtable_anim_use_buckles", "use_buckles", func_end );
  SoundSfx( "aud_use_clasp_sewingtable" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_goldenthreads" ] = { type = "use", inv_obj = "inv_goldenthreads", use_place = "gfx_sewingtable_goldenthreads_zone", room = "rm_workshop", zz = "zz_sewingtable", zz_gate = "gzz_workshop_sewingtable" };

private.use_goldenthreads_logic = function()
  if ld.CheckRequirements( {"use_goldenthreads","use_whitethreads","use_clasp","use_sketch","use_goldenbuttons"} ) then
    ObjSet( "gfx_sewingtable_elf_sewingtable_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_goldenthreads_inv = function()
  common_impl.ProcessMultiUseAll("goldenthreads", "goldenthreads")
end;
private.use_goldenthreads_beg = function()
  ObjDelete( "gfx_sewingtable_goldenthreads_zone" );
end;
private.use_goldenthreads_end = function()
  ObjSet( "spr_workshop_gold_thread", {visible = 1} );
  ObjSet( "anm_sewingtable_anim_use_gold_thread", {animfunc = "use_gold_thread", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_goldenthreads") then ObjSet( common_impl.hint["use_goldenthreads"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_goldenthreads", private.use_goldenthreads_inv );
cmn.AddSubscriber( "use_goldenthreads", private.use_goldenthreads_beg, private.room_objname );
cmn.AddSubscriber( "use_goldenthreads", private.use_goldenthreads_end, private.room_objname );
cmn.AddSubscriber( "use_goldenthreads", private.use_goldenthreads_logic );
cmn.AddSubscriber( "use_goldenthreads_inv", private.use_goldenthreads_inv, private.room_objname );
cmn.AddSubscriber( "use_goldenthreads_beg", private.use_goldenthreads_beg, private.room_objname );
cmn.AddSubscriber( "use_goldenthreads_end", private.use_goldenthreads_end, private.room_objname );
cmn.AddSubscriber( "use_goldenthreads_end", private.use_goldenthreads_logic );
--------------------------------------------------------------------------------------------
function public.use_goldenthreads( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_goldenthreads" );
    cmn.CallEventHandler( "use_goldenthreads_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_goldenthreads") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_goldenthreads_inv" );
  cmn.CallEventHandler( "use_goldenthreads_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sewingtable_anim_use_gold_thread", "use_gold_thread", func_end );
  SoundSfx( "aud_use_goldenthreads_sewingtable" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_sketch" ] = { type = "use", inv_obj = "inv_sketch", use_place = "gfx_sewingtable_sketch_zone", room = "rm_workshop", zz = "zz_sewingtable", zz_gate = "gzz_workshop_sewingtable" };

private.use_sketch_logic = function()
  if ld.CheckRequirements( {"use_sketch","use_whitethreads","use_clasp","use_goldenthreads","use_goldenbuttons"} ) then
    ObjSet( "gfx_sewingtable_elf_sewingtable_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_sketch_inv = function()
  common_impl.ProcessMultiUseAll("sketch", "sketch")
end;
private.use_sketch_beg = function()
  ObjDelete( "gfx_sewingtable_sketch_zone" );
end;
private.use_sketch_end = function()
  ObjSet( "spr_workshop_eskiz", {visible = 1} );
  ObjSet( "anm_sewingtable_anim_use_sketch", {animfunc = "use_sketch", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_sketch") then ObjSet( common_impl.hint["use_sketch"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_sketch", private.use_sketch_inv );
cmn.AddSubscriber( "use_sketch", private.use_sketch_beg, private.room_objname );
cmn.AddSubscriber( "use_sketch", private.use_sketch_end, private.room_objname );
cmn.AddSubscriber( "use_sketch", private.use_sketch_logic );
cmn.AddSubscriber( "use_sketch_inv", private.use_sketch_inv, private.room_objname );
cmn.AddSubscriber( "use_sketch_beg", private.use_sketch_beg, private.room_objname );
cmn.AddSubscriber( "use_sketch_end", private.use_sketch_end, private.room_objname );
cmn.AddSubscriber( "use_sketch_end", private.use_sketch_logic );
--------------------------------------------------------------------------------------------
function public.use_sketch( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_sketch" );
    cmn.CallEventHandler( "use_sketch_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_sketch") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_sketch_inv" );
  cmn.CallEventHandler( "use_sketch_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sewingtable_anim_use_sketch", "use_sketch", func_end );
  SoundSfx( "aud_use_sketch_sewingtable" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_goldenbuttons" ] = { type = "use", inv_obj = "inv_goldenbuttons", use_place = "gfx_sewingtable_goldenbuttons_zone", room = "rm_workshop", zz = "zz_sewingtable", zz_gate = "gzz_workshop_sewingtable" };

private.use_goldenbuttons_logic = function()
  if ld.CheckRequirements( {"use_goldenbuttons","use_whitethreads","use_clasp","use_goldenthreads","use_sketch"} ) then
    ObjSet( "gfx_sewingtable_elf_sewingtable_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_goldenbuttons_inv = function()
  common_impl.ProcessMultiUseAll("goldenbuttons", "goldenbuttons")
end;
private.use_goldenbuttons_beg = function()
  ObjDelete( "gfx_sewingtable_goldenbuttons_zone" );
end;
private.use_goldenbuttons_end = function()
  ObjSet( "spr_workshop_buttons", {visible = 1} );
  ObjSet( "anm_sewingtable_anim_use_buttons", {animfunc = "use_buttons", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_goldenbuttons") then ObjSet( common_impl.hint["use_goldenbuttons"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_goldenbuttons", private.use_goldenbuttons_inv );
cmn.AddSubscriber( "use_goldenbuttons", private.use_goldenbuttons_beg, private.room_objname );
cmn.AddSubscriber( "use_goldenbuttons", private.use_goldenbuttons_end, private.room_objname );
cmn.AddSubscriber( "use_goldenbuttons", private.use_goldenbuttons_logic );
cmn.AddSubscriber( "use_goldenbuttons_inv", private.use_goldenbuttons_inv, private.room_objname );
cmn.AddSubscriber( "use_goldenbuttons_beg", private.use_goldenbuttons_beg, private.room_objname );
cmn.AddSubscriber( "use_goldenbuttons_end", private.use_goldenbuttons_end, private.room_objname );
cmn.AddSubscriber( "use_goldenbuttons_end", private.use_goldenbuttons_logic );
--------------------------------------------------------------------------------------------
function public.use_goldenbuttons( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_goldenbuttons" );
    cmn.CallEventHandler( "use_goldenbuttons_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_goldenbuttons") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_goldenbuttons_inv" );
  cmn.CallEventHandler( "use_goldenbuttons_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_sewingtable_anim_use_buttons", "use_buttons", func_end );
  SoundSfx( "aud_use_goldenbuttons_sewingtable" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
function public.sewingtable_goodie_action()
  local function func_end()
    ld.Lock(0)
    VidStop("vid_sewingtable_goodie_action_66")
    ObjDetach("vid_sewingtable_goodie_action_66")
    ObjSet( "spr_sewingtable_goodie_sit", {visible = 1} );
  end
  ld.Lock(1)
  ObjSet( "spr_sewingtable_goodie_sit", {visible = 0} );
  ObjAttach("vid_sewingtable_goodie_action_66","zz_sewingtable")
  SoundSfx( "aud_goodie_action_66" )
  VidPlay("vid_sewingtable_goodie_action_66",func_end)
end

--------------------------------------------------------------------------------------------
common_impl.hint[ "use_elf_sewingtable" ] = { type = "use", inv_obj = "obj_simon_cursor_drag", use_place = "gfx_sewingtable_elf_sewingtable_zone", room = "rm_workshop", zz = "zz_sewingtable", zz_gate = "gzz_workshop_sewingtable" };

private.use_elf_sewingtable_logic = function()
  int_simon.LoadAnotherPrg()
  level_inv.SetGoodball(3);
end;
private.use_elf_sewingtable_inv = function()
  common_impl.ProcessMultiUseAll("elf", "elf_sewingtable")
end;
private.use_elf_sewingtable_beg = function()
  ObjDelete( "gfx_sewingtable_elf_sewingtable_zone" );
  ObjDelete("spr_workshop_goodie_table")
end;
private.use_elf_sewingtable_end = function()
  ObjDelete("spr_sewingtable_goodie_sit")
  ObjDelete("obj_sewingtable_goody_action_zone")
  ObjSet( "spr_workshop_no_kaftan", {visible = 1} );
  ObjSet( "spr_workshop_no_peter", {visible = 1} );
  
  if common_impl.ZzCompleteCheck("use_elf_sewingtable") then ObjSet( common_impl.hint["use_elf_sewingtable"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_elf_sewingtable", private.use_elf_sewingtable_inv );
cmn.AddSubscriber( "use_elf_sewingtable", private.use_elf_sewingtable_beg, private.room_objname );
cmn.AddSubscriber( "use_elf_sewingtable", private.use_elf_sewingtable_end, private.room_objname );
cmn.AddSubscriber( "use_elf_sewingtable", private.use_elf_sewingtable_logic );
cmn.AddSubscriber( "use_elf_sewingtable_inv", private.use_elf_sewingtable_inv, private.room_objname );
cmn.AddSubscriber( "use_elf_sewingtable_beg", private.use_elf_sewingtable_beg, private.room_objname );
cmn.AddSubscriber( "use_elf_sewingtable_end", private.use_elf_sewingtable_end, private.room_objname );
cmn.AddSubscriber( "use_elf_sewingtable_end", private.use_elf_sewingtable_logic );
--------------------------------------------------------------------------------------------
function public.use_elf_sewingtable( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    ld.CloseSubRoom();
    ObjDelete("spr_sewingtable_elf")
    int_simon.LoadAnotherPrg("simon");
    interface.SimonReturn();
    ld.StartTimer( 1, function()  ld.Lock(0) public.dlg_workshop_jack2() end );
  end;
  local func_end_2 = function()
    --func_end()
    ObjDelete("spr_sewingtable_goodie_sit")
    ObjSet( "spr_sewingtable_elf", {visible = 1} );
    int_inventory.StdItemFlyAnimation( "spr_sewingtable_elf", "obj_int_button_map_point_for_cube", func_end );
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_elf_sewingtable_inv" );
  cmn.CallEventHandler( "use_elf_sewingtable_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( "aud_use_elf_sewingtable" )
  --func_end()
  interface.SimonJump(func_end_2)

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_buffet *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_buffetanim" ] = { type = "click", use_place = "gfx_buffet_clk_buffetanim_zone", room = "rm_workshop", zz = "zz_buffet", zz_gate = "gzz_workshop_buffet" };

private.clk_buffetanim_logic = function()
  ObjSet( "gfx_buffet_clk_buffetcup_zone", { visible = 1, input = 1, active = 1 } )

end;
private.clk_buffetanim_beg = function()
  ObjDelete( "gfx_buffet_clk_buffetanim_zone" );
end;
private.clk_buffetanim_end = function()
  ObjSet( "spr_buffet_diarykey", { visible = 1 } )
  ObjSet( "anm_buffet_anim_door_cup", {animfunc = "click_cup", frame = 0 } );
  ObjSet( "spr_workshop_cup", {visible = 1} );
  ObjSet( "spr_workshop_cup_pos_2", {visible = 0} );
  if common_impl.ZzCompleteCheck("clk_buffetanim") then ObjSet( common_impl.hint["clk_buffetanim"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_buffetanim", private.clk_buffetanim_beg, private.room_objname );
cmn.AddSubscriber( "clk_buffetanim", private.clk_buffetanim_end, private.room_objname );
cmn.AddSubscriber( "clk_buffetanim", private.clk_buffetanim_logic );
cmn.AddSubscriber( "clk_buffetanim_beg", private.clk_buffetanim_beg, private.room_objname );
cmn.AddSubscriber( "clk_buffetanim_end", private.clk_buffetanim_end, private.room_objname );
cmn.AddSubscriber( "clk_buffetanim_end", private.clk_buffetanim_logic );
--------------------------------------------------------------------------------------------
function public.clk_buffetanim()
  if not ld.CheckRequirements( {"clk_buffetanim"} ) then

    local func_end = function()
      cmn.SetEventDone( "clk_buffetanim" );
      cmn.CallEventHandler( "clk_buffetanim_end" );
      common_impl.Lock(0);
      if common_impl.ZzCompleteCheck("clk_buffetanim") then ld.CloseSubRoom() end;
      ld.ShowBbt( "clk_buffetanim" )
    end

    cmn.CallEventHandler( "clk_buffetanim_beg" );
    common_impl.Lock(1);

    ld.AnimPlay( "anm_buffet_anim_door_cup", "cup_firstlook", func_end );
    SoundSfx( "aud_clk_buffetanim" )
    --func_end()

  end
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_buffetcup" ] = { type = "click", use_place = "gfx_buffet_clk_buffetcup_zone", room = "rm_workshop", zz = "zz_buffet", zz_gate = "gzz_workshop_buffet" };

private.clk_buffetcup_logic = function()
  ObjSet( "spr_buffet_diarykey", { visible = 1, input = 1, active = 1 } )

end;
private.clk_buffetcup_beg = function()
  ObjDelete( "gfx_buffet_clk_buffetcup_zone" );
end;
private.clk_buffetcup_end = function()
  ObjSet( "gfx_buffet_diarykey", {active = 1, visible = 1} );
  ObjSet( "anm_buffet_anim_door_cup", {animfunc = "cup_end", frame = 0 } );
  ObjSet( "spr_workshop_cup", {visible = 0} );
  ObjSet( "spr_workshop_cup_pos_2", {visible = 1} );
  if common_impl.ZzCompleteCheck("clk_buffetcup") then ObjSet( common_impl.hint["clk_buffetcup"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_buffetcup", private.clk_buffetcup_beg, private.room_objname );
cmn.AddSubscriber( "clk_buffetcup", private.clk_buffetcup_end, private.room_objname );
cmn.AddSubscriber( "clk_buffetcup", private.clk_buffetcup_logic );
cmn.AddSubscriber( "clk_buffetcup_beg", private.clk_buffetcup_beg, private.room_objname );
cmn.AddSubscriber( "clk_buffetcup_end", private.clk_buffetcup_end, private.room_objname );
cmn.AddSubscriber( "clk_buffetcup_end", private.clk_buffetcup_logic );
--------------------------------------------------------------------------------------------
function public.clk_buffetcup()

  local func_end = function()
    cmn.SetEventDone( "clk_buffetcup" );
    cmn.CallEventHandler( "clk_buffetcup_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_buffetcup") then ld.CloseSubRoom() end;
    ObjDelete("vid_buffet_mouse_run_35")
    ld.ShowBbt( "clk_buffetcup" )
  end;
  local func_end_2 = function()
    ObjAttach("vid_buffet_mouse_run_35","zz_buffet")
    VidPlay("vid_buffet_mouse_run_35",func_end)
  end;

  cmn.CallEventHandler( "clk_buffetcup_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_buffet_anim_door_cup", "click_cup", func_end_2 );
  SoundSfx( "aud_clk_buffetcup" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_diarykey" ] = { type = "get", get_obj = "spr_buffet_diarykey", room = "rm_workshop", zz = "zz_buffet", zz_gate = "gzz_workshop_buffet" };

private.get_diarykey_logic = function()
  
end;
private.get_diarykey_inv = function()
  interface.InventoryItemAdd("inv_diarykey","spr_buffet_diarykey");
end;
private.get_diarykey_beg = function()
  ObjDelete("gfx_buffet_diarykey")
end;
private.get_diarykey_end = function()
  ObjDelete("spr_buffet_diarykey_shadow")
  ObjDelete("spr_workshop_diarykey")
  if common_impl.ZzCompleteCheck("get_diarykey") then ObjSet( common_impl.hint["get_diarykey"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_diarykey", private.get_diarykey_inv );
cmn.AddSubscriber( "get_diarykey", private.get_diarykey_beg, private.room_objname );
cmn.AddSubscriber( "get_diarykey", private.get_diarykey_end, private.room_objname );
cmn.AddSubscriber( "get_diarykey", private.get_diarykey_logic );
--------------------------------------------------------------------
function public.get_diarykey()
  cmn.SetEventDone( "get_diarykey" );
  cmn.CallEventHandler( "get_diarykey" );
  if common_impl.ZzCompleteCheck("get_diarykey") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_woodhorse" ] = { type = "use", inv_obj = "inv_woodhorse", use_place = "gfx_buffet_woodhorse_zone", room = "rm_workshop", zz = "zz_buffet", zz_gate = "gzz_workshop_buffet" };

private.use_woodhorse_logic = function()
  ObjSet( "spr_buffet_sparkler", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_buffet_choppedfigure", { visible = 1, input = 1, active = 1 } )

end;
private.use_woodhorse_inv = function()
  common_impl.ProcessMultiUseAll("woodhorse", "woodhorse")
end;
private.use_woodhorse_beg = function()
  ObjDelete( "gfx_buffet_woodhorse_zone" );
end;
private.use_woodhorse_end = function()
  ObjDelete("gfx_buffet_bulb_zone_2")
  ObjSet( "anm_buffet_anim_door_right", {animfunc = "end_door_right", frame = 0 } );
  ObjDelete("spr_workshop_door_right")
  ObjSet( "spr_workshop_door_right_open", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_woodhorse") then ObjSet( common_impl.hint["use_woodhorse"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_woodhorse", private.use_woodhorse_inv );
cmn.AddSubscriber( "use_woodhorse", private.use_woodhorse_beg, private.room_objname );
cmn.AddSubscriber( "use_woodhorse", private.use_woodhorse_end, private.room_objname );
cmn.AddSubscriber( "use_woodhorse", private.use_woodhorse_logic );
cmn.AddSubscriber( "use_woodhorse_inv", private.use_woodhorse_inv, private.room_objname );
cmn.AddSubscriber( "use_woodhorse_beg", private.use_woodhorse_beg, private.room_objname );
cmn.AddSubscriber( "use_woodhorse_end", private.use_woodhorse_end, private.room_objname );
cmn.AddSubscriber( "use_woodhorse_end", private.use_woodhorse_logic );
--------------------------------------------------------------------------------------------
function public.use_woodhorse( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_woodhorse" );
    cmn.CallEventHandler( "use_woodhorse_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_woodhorse") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_woodhorse_inv" );
  cmn.CallEventHandler( "use_woodhorse_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_buffet_anim_door_right", "open_door_right", func_end );
  SoundSfx( "aud_use_woodhorse_buffet" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_sparkler" ] = { type = "get", get_obj = "spr_buffet_sparkler", room = "rm_workshop", zz = "zz_buffet", zz_gate = "gzz_workshop_buffet" };

private.get_sparkler_logic = function()
  
end;
private.get_sparkler_inv = function()
  interface.InventoryItemAdd("inv_sparkler","spr_buffet_sparkler");
end;
private.get_sparkler_beg = function()
  ObjDelete("gfx_buffet_sparkler")
end;
private.get_sparkler_end = function()
  ObjDelete("spr_buffet_sparkler_shadow")
  ObjDelete("spr_workshop_sparkler")
  if common_impl.ZzCompleteCheck("get_sparkler") then ObjSet( common_impl.hint["get_sparkler"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_sparkler", private.get_sparkler_inv );
cmn.AddSubscriber( "get_sparkler", private.get_sparkler_beg, private.room_objname );
cmn.AddSubscriber( "get_sparkler", private.get_sparkler_end, private.room_objname );
cmn.AddSubscriber( "get_sparkler", private.get_sparkler_logic );
--------------------------------------------------------------------
function public.get_sparkler()
  cmn.SetEventDone( "get_sparkler" );
  cmn.CallEventHandler( "get_sparkler" );
  if common_impl.ZzCompleteCheck("get_sparkler") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_choppedfigure" ] = { type = "get", get_obj = "spr_buffet_choppedfigure", room = "rm_workshop", zz = "zz_buffet", zz_gate = "gzz_workshop_buffet" };

private.get_choppedfigure_logic = function()
  
end;
private.get_choppedfigure_inv = function()
  interface.InventoryItemAdd("inv_choppedfigure","spr_buffet_choppedfigure");
  ObjSet( "inv_choppedfigure", { drag = 0 } );
end;
private.get_choppedfigure_beg = function()
  ObjDelete("gfx_buffet_choppedfigure")
end;
private.get_choppedfigure_end = function()
  ObjDelete("spr_buffet_choppedfigure_shadow")
  ObjDelete("spr_workshop_choppedfigure")
  if common_impl.ZzCompleteCheck("get_choppedfigure") then ObjSet( common_impl.hint["get_choppedfigure"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_choppedfigure", private.get_choppedfigure_inv );
cmn.AddSubscriber( "get_choppedfigure", private.get_choppedfigure_beg, private.room_objname );
cmn.AddSubscriber( "get_choppedfigure", private.get_choppedfigure_end, private.room_objname );
cmn.AddSubscriber( "get_choppedfigure", private.get_choppedfigure_logic );
--------------------------------------------------------------------
function public.get_choppedfigure()
  cmn.SetEventDone( "get_choppedfigure" );
  cmn.CallEventHandler( "get_choppedfigure" );
  if common_impl.ZzCompleteCheck("get_choppedfigure") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bulb" ] = { type = "use", inv_obj = "inv_bulb", use_place = "gfx_buffet_bulb_zone", room = "rm_workshop", zz = "zz_buffet", zz_gate = "gzz_workshop_buffet" };

private.use_bulb_logic = function()
  ObjSet( "gfx_buffet_elfcleaner_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_bulb_inv = function()
  common_impl.ProcessMultiUseAll("bulb", "bulb")
end;
private.use_bulb_beg = function()
  ObjDelete( "gfx_buffet_bulb_zone" );
end;
private.use_bulb_end = function()
  ObjDelete("anm_buffet_anim_door_static")
  ObjDelete("fx_buffet_sparkles_fx")
  ObjSet( "spr_workshop_bulb", {visible = 1} );
  ObjDelete("spr_workshop_shadow")
  ObjSet( "anm_buffet_anim_door_bulb", {animfunc = "use_bulb_end", frame = 0, playing = 1 } );
  if common_impl.ZzCompleteCheck("use_bulb") then ObjSet( common_impl.hint["use_bulb"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bulb", private.use_bulb_inv );
cmn.AddSubscriber( "use_bulb", private.use_bulb_beg, private.room_objname );
cmn.AddSubscriber( "use_bulb", private.use_bulb_end, private.room_objname );
cmn.AddSubscriber( "use_bulb", private.use_bulb_logic );
cmn.AddSubscriber( "use_bulb_inv", private.use_bulb_inv, private.room_objname );
cmn.AddSubscriber( "use_bulb_beg", private.use_bulb_beg, private.room_objname );
cmn.AddSubscriber( "use_bulb_end", private.use_bulb_end, private.room_objname );
cmn.AddSubscriber( "use_bulb_end", private.use_bulb_logic );
--------------------------------------------------------------------------------------------
function public.use_bulb( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bulb" );
    cmn.CallEventHandler( "use_bulb_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bulb") then ld.CloseSubRoom() end;
    ld.AnimPlay( "anm_buffet_anim_door_bulb", "use_bulb_end", "" )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bulb_inv" );
  cmn.CallEventHandler( "use_bulb_beg" );
  common_impl.Lock(1);
  ObjAnimate( "anm_buffet_anim_door_static", 8, 0, 0, function() end, {0,0,1, 0.2,0,0} );
  ObjAnimate( "fx_buffet_sparkles_fx", 8, 0, 0, function() end, {0,0,1, 0.2,0,0} );
  ld.AnimPlay( "anm_buffet_anim_door_bulb", "use_bulb", func_end );
  SoundSfx( "aud_use_bulb_buffet" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_elfcleaner" ] = { type = "use", inv_obj = "inv_elfcleaner", use_place = "gfx_buffet_elfcleaner_zone", room = "rm_workshop", zz = "zz_buffet", zz_gate = "gzz_workshop_buffet" };

private.use_elfcleaner_logic = function()
  --ObjSet( "spr_buffet_skewers", { visible = 1, input = 1, active = 1 } )
  int_simon.SimonSetVisible(1)
end;
private.use_elfcleaner_inv = function()
  common_impl.ProcessMultiUseAll("elfcleaner", "elfcleaner")
  
end;
private.use_elfcleaner_beg = function()
  ObjDelete( "gfx_buffet_elfcleaner_zone" );
  ObjDelete("spr_buffet_cobweb")
  ObjDelete("spr_buffet_dust")
  ObjDelete("spr_workshop_cobweb")
  ObjDelete("spr_buffet_skewers_tr")
  ObjDelete("spr_buffet_skewers_up")
end;
private.use_elfcleaner_end = function()
  if common_impl.ZzCompleteCheck("use_elfcleaner") then ObjSet( common_impl.hint["use_elfcleaner"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_elfcleaner", private.use_elfcleaner_inv );
cmn.AddSubscriber( "use_elfcleaner", private.use_elfcleaner_beg, private.room_objname );
cmn.AddSubscriber( "use_elfcleaner", private.use_elfcleaner_end, private.room_objname );
cmn.AddSubscriber( "use_elfcleaner", private.use_elfcleaner_logic );
cmn.AddSubscriber( "use_elfcleaner_inv", private.use_elfcleaner_inv, private.room_objname );
cmn.AddSubscriber( "use_elfcleaner_beg", private.use_elfcleaner_beg, private.room_objname );
cmn.AddSubscriber( "use_elfcleaner_end", private.use_elfcleaner_end, private.room_objname );
cmn.AddSubscriber( "use_elfcleaner_end", private.use_elfcleaner_logic );
--------------------------------------------------------------------------------------------
function public.use_elfcleaner( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "get_skewers" );
    cmn.SetEventDone( "use_elfcleaner" );
    cmn.CallEventHandler( "use_elfcleaner_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_elfcleaner") then ld.CloseSubRoom() end;
    ObjDelete("spr_buffet_elf")
    interface.SimonReturn()
  end;
  local func_end_2 = function()
    --ObjAnimate( "spr_buffet_dust", 8, 0, 0, function() end, {0,0,1, 0.5,0,0} );
    --ObjAnimate( "spr_buffet_cobweb", 8, 0, 0, function() func_end() end, {0,0,1, 0.5,0,1, 1,0,0} );
    ObjDelete("vid_buffet_vid_goodie_clean_get_skewers_196")
    ObjSet( "spr_buffet_elf", {visible = 1} );
    int_inventory.StdItemFlyAnimation( "spr_buffet_elf", "obj_int_button_map_point_for_cube", func_end );
    public.get_skewers()
    --func_end();
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_elfcleaner_inv" );
  cmn.CallEventHandler( "use_elfcleaner_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundVid( "aud_use_elfcleaner_buffet" )
  ObjAttach("vid_buffet_vid_goodie_clean_get_skewers_196","zz_buffet");
  VidPlay("vid_buffet_vid_goodie_clean_get_skewers_196", func_end_2 );
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_skewers" ] = { type = "get", get_obj = "spr_buffet_skewers", room = "rm_workshop", zz = "zz_buffet", zz_gate = "gzz_workshop_buffet" };

private.get_skewers_logic = function()
  
end;
private.get_skewers_inv = function()
  interface.InventoryItemAdd("inv_skewers","spr_buffet_skewers");
end;
private.get_skewers_beg = function()
  ObjDelete("gfx_buffet_skewers")
  ObjSet( "spr_buffet_skewers", {visible = 1} );
end;
private.get_skewers_end = function()
  if common_impl.ZzCompleteCheck("get_skewers") then ObjSet( common_impl.hint["get_skewers"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_skewers", private.get_skewers_inv );
cmn.AddSubscriber( "get_skewers", private.get_skewers_beg, private.room_objname );
cmn.AddSubscriber( "get_skewers", private.get_skewers_end, private.room_objname );
cmn.AddSubscriber( "get_skewers", private.get_skewers_logic );
--------------------------------------------------------------------
function public.get_skewers()
  
  cmn.CallEventHandler( "get_skewers" );
  if common_impl.ZzCompleteCheck("get_skewers") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_woodhorse2" ] = { type = "use", inv_obj = "inv_woodhorse2", use_place = "gfx_buffet_woodhorse2_zone", room = "rm_workshop", zz = "zz_buffet", zz_gate = "gzz_workshop_buffet" };

private.use_woodhorse2_logic = function()
  ObjSet( "spr_buffet_rope", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_buffet_bear", { visible = 1, input = 1, active = 1 } )

end;
private.use_woodhorse2_inv = function()
  common_impl.ProcessMultiUseAll("woodhorse2", "woodhorse2")
end;
private.use_woodhorse2_beg = function()
  ObjDelete( "gfx_buffet_woodhorse2_zone" );
end;
private.use_woodhorse2_end = function()
  ObjDelete("spr_workshop_door_left")
  ObjSet( "spr_workshop_door_left_open", {visible = 1} );
  ObjSet( "anm_buffet_anim_door_left", {animfunc = "end_door_left", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_woodhorse2") then ObjSet( common_impl.hint["use_woodhorse2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_woodhorse2", private.use_woodhorse2_inv );
cmn.AddSubscriber( "use_woodhorse2", private.use_woodhorse2_beg, private.room_objname );
cmn.AddSubscriber( "use_woodhorse2", private.use_woodhorse2_end, private.room_objname );
cmn.AddSubscriber( "use_woodhorse2", private.use_woodhorse2_logic );
cmn.AddSubscriber( "use_woodhorse2_inv", private.use_woodhorse2_inv, private.room_objname );
cmn.AddSubscriber( "use_woodhorse2_beg", private.use_woodhorse2_beg, private.room_objname );
cmn.AddSubscriber( "use_woodhorse2_end", private.use_woodhorse2_end, private.room_objname );
cmn.AddSubscriber( "use_woodhorse2_end", private.use_woodhorse2_logic );
--------------------------------------------------------------------------------------------
function public.use_woodhorse2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_woodhorse2" );
    cmn.CallEventHandler( "use_woodhorse2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_woodhorse2") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_woodhorse2_inv" );
  cmn.CallEventHandler( "use_woodhorse2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_buffet_anim_door_left", "open_door_left", func_end );
  SoundSfx( "aud_use_woodhorse2_buffet" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_rope" ] = { type = "get", get_obj = "spr_buffet_rope", room = "rm_workshop", zz = "zz_buffet", zz_gate = "gzz_workshop_buffet" };

private.get_rope_logic = function()
  
end;
private.get_rope_inv = function()
  interface.InventoryItemAdd("inv_rope","spr_buffet_rope");
end;
private.get_rope_beg = function()
  ObjDelete("gfx_buffet_rope")
end;
private.get_rope_end = function()
  ObjDelete("spr_buffet_rope_shadow")
  ObjDelete("spr_workshop_rope")
  if common_impl.ZzCompleteCheck("get_rope") then ObjSet( common_impl.hint["get_rope"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_rope", private.get_rope_inv );
cmn.AddSubscriber( "get_rope", private.get_rope_beg, private.room_objname );
cmn.AddSubscriber( "get_rope", private.get_rope_end, private.room_objname );
cmn.AddSubscriber( "get_rope", private.get_rope_logic );
--------------------------------------------------------------------
function public.get_rope()
  cmn.SetEventDone( "get_rope" );
  cmn.CallEventHandler( "get_rope" );
  if common_impl.ZzCompleteCheck("get_rope") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_bear" ] = { type = "get", get_obj = "spr_buffet_bear", room = "rm_workshop", zz = "zz_buffet", zz_gate = "gzz_workshop_buffet" };

private.get_bear_logic = function()
  
end;
private.get_bear_inv = function()
  interface.InventoryItemAdd("inv_bear","spr_buffet_bear");
end;
private.get_bear_beg = function()
  ObjDelete("gfx_buffet_bear")
end;
private.get_bear_end = function()
  ObjDelete("spr_workshop_bear")
  if common_impl.ZzCompleteCheck("get_bear") then ObjSet( common_impl.hint["get_bear"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_bear", private.get_bear_inv );
cmn.AddSubscriber( "get_bear", private.get_bear_beg, private.room_objname );
cmn.AddSubscriber( "get_bear", private.get_bear_end, private.room_objname );
cmn.AddSubscriber( "get_bear", private.get_bear_logic );
--------------------------------------------------------------------
function public.get_bear()
  cmn.SetEventDone( "get_bear" );
  cmn.CallEventHandler( "get_bear" );
  if common_impl.ZzCompleteCheck("get_bear") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_doortoup *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_hatamulet" ] = { type = "use", inv_obj = "inv_hatamulet", use_place = "gfx_doortoup_hatamulet_zone", room = "rm_workshop", zz = "zz_doortoup", zz_gate = "gzz_workshop_doortoup" };

private.use_hatamulet_logic = function()
  if ld.CheckRequirements( {"use_hatamulet","use_amuletmonequin"} ) then
    --ObjSet( "gfx_doortoup_clk_doortoupopen_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_hatamulet_inv = function()
  common_impl.ProcessMultiUseAll("hatamulet", "hatamulet")
end;
private.use_hatamulet_beg = function()
  ObjDelete( "gfx_doortoup_hatamulet_zone" );
end;
private.use_hatamulet_end = function()
  ObjSet( "spr_workshop_amulet_hat", {visible = 1} );
  ObjSet( "anm_doortoup_anim", {animfunc = "use_hat", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_hatamulet") then ObjSet( common_impl.hint["use_hatamulet"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_hatamulet", private.use_hatamulet_inv );
cmn.AddSubscriber( "use_hatamulet", private.use_hatamulet_beg, private.room_objname );
cmn.AddSubscriber( "use_hatamulet", private.use_hatamulet_end, private.room_objname );
cmn.AddSubscriber( "use_hatamulet", private.use_hatamulet_logic );
cmn.AddSubscriber( "use_hatamulet_inv", private.use_hatamulet_inv, private.room_objname );
cmn.AddSubscriber( "use_hatamulet_beg", private.use_hatamulet_beg, private.room_objname );
cmn.AddSubscriber( "use_hatamulet_end", private.use_hatamulet_end, private.room_objname );
cmn.AddSubscriber( "use_hatamulet_end", private.use_hatamulet_logic );
--------------------------------------------------------------------------------------------
function public.use_hatamulet( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_hatamulet" );
    cmn.CallEventHandler( "use_hatamulet_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_hatamulet") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_amuletmonequin","use_hatamulet"} ) then
      public.clk_doortoupopen()
    end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_hatamulet_inv" );
  cmn.CallEventHandler( "use_hatamulet_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doortoup_anim", "use_hat", func_end );
  SoundSfx( "aud_use_hatamulet_doortoup" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_amuletmonequin" ] = { type = "use", inv_obj = "inv_amuletmonequin", use_place = "gfx_doortoup_amuletmonequin_zone", room = "rm_workshop", zz = "zz_doortoup", zz_gate = "gzz_workshop_doortoup" };

private.use_amuletmonequin_logic = function()
  if ld.CheckRequirements( {"use_amuletmonequin","use_hatamulet"} ) then
    --ObjSet( "gfx_doortoup_clk_doortoupopen_zone", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_amuletmonequin_inv = function()
  common_impl.ProcessMultiUseAll("amuletmonequin", "amuletmonequin")
end;
private.use_amuletmonequin_beg = function()
  ObjDelete( "gfx_doortoup_amuletmonequin_zone" );
end;
private.use_amuletmonequin_end = function()
  ObjSet( "spr_workshop_amulet_dumy", {visible = 1} );
  ObjSet( "anm_doortoup_anim_2", {animfunc = "use_dummy", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_amuletmonequin") then ObjSet( common_impl.hint["use_amuletmonequin"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_amuletmonequin", private.use_amuletmonequin_inv );
cmn.AddSubscriber( "use_amuletmonequin", private.use_amuletmonequin_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletmonequin", private.use_amuletmonequin_end, private.room_objname );
cmn.AddSubscriber( "use_amuletmonequin", private.use_amuletmonequin_logic );
cmn.AddSubscriber( "use_amuletmonequin_inv", private.use_amuletmonequin_inv, private.room_objname );
cmn.AddSubscriber( "use_amuletmonequin_beg", private.use_amuletmonequin_beg, private.room_objname );
cmn.AddSubscriber( "use_amuletmonequin_end", private.use_amuletmonequin_end, private.room_objname );
cmn.AddSubscriber( "use_amuletmonequin_end", private.use_amuletmonequin_logic );
--------------------------------------------------------------------------------------------
function public.use_amuletmonequin( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_amuletmonequin" );
    cmn.CallEventHandler( "use_amuletmonequin_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_amuletmonequin") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_amuletmonequin","use_hatamulet"} ) then
      public.clk_doortoupopen()
    end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_amuletmonequin_inv" );
  cmn.CallEventHandler( "use_amuletmonequin_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doortoup_anim_2", "use_dummy", func_end );
  SoundSfx( "aud_use_amuletmonequin_doortoup" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_doortoupopen" ] = { type = "click", use_place = "gfx_doortoup_clk_doortoupopen_zone", room = "rm_workshop", zz = "zz_doortoup", zz_gate = "gzz_workshop_doortoup" };

private.clk_doortoupopen_logic = function()
  ObjSet( "grm_workshop_secondfloor", { visible = 1, input = 1, active = 1 } );
  if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_workshop_secondfloor_focus");
    end;
end;
private.clk_doortoupopen_beg = function()
  ObjDelete( "gfx_doortoup_clk_doortoupopen_zone" );
  ObjDelete("spr_workshop_amulet_hat")
  ObjDelete("spr_workshop_amulet_dumy")
end;
private.clk_doortoupopen_end = function()
  ObjSet( "anm_workshop_anim_door_up", {animfunc = "open_door_up", frame = 999 } );
  if common_impl.ZzCompleteCheck("clk_doortoupopen") then ObjSet( common_impl.hint["clk_doortoupopen"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_doortoupopen", private.clk_doortoupopen_beg, private.room_objname );
cmn.AddSubscriber( "clk_doortoupopen", private.clk_doortoupopen_end, private.room_objname );
cmn.AddSubscriber( "clk_doortoupopen", private.clk_doortoupopen_logic );
cmn.AddSubscriber( "clk_doortoupopen_beg", private.clk_doortoupopen_beg, private.room_objname );
cmn.AddSubscriber( "clk_doortoupopen_end", private.clk_doortoupopen_end, private.room_objname );
cmn.AddSubscriber( "clk_doortoupopen_end", private.clk_doortoupopen_logic );
--------------------------------------------------------------------------------------------
function public.clk_doortoupopen()

  local func_end = function()
    cmn.CallEventHandler( "clk_doortoupopen_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_doortoupopen") then ld.CloseSubRoom() end;
  end;
  cmn.SetEventDone( "clk_doortoupopen" );
  cmn.CallEventHandler( "clk_doortoupopen_beg" );
  common_impl.Lock(1);
  ld.CloseSubRoom()
  ld.AnimPlay( "anm_workshop_anim_door_up", "open_door_up", func_end );
  SoundSfx( "aud_clk_doortoupopen" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_doortostreet *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bell1" ] = { type = "use", inv_obj = "inv_bell1", use_place = "gfx_doortostreet_bell1_zone", room = "rm_workshop", zz = "zz_doortostreet", zz_gate = "gzz_workshop_doortostreet" };

private.use_bell1_logic = function()
  if ld.CheckRequirements( {"use_bell1","use_bell2"} ) then
    ObjSet( "gfx_doortostreet_win_sound_zone", { input = 1, active = 1 } )
    ld.mmgZoomInit("win_sound"); 
    ObjSet( "obj_doorstreet_mmg_root", {input = 1} );
  end;

end;
private.use_bell1_inv = function()
  common_impl.ProcessMultiUseAll("bell1", "bell1")
end;
private.use_bell1_beg = function()
  ObjDelete( "gfx_doortostreet_bell1_zone" );
end;
private.use_bell1_end = function()
  ObjDelete("anm_doortostreet_anim_1")
  ObjSet( "spr_doorstreet_mmg_bell_8", {visible = 1} );
  ObjSet( "spr_workshop_bell_1", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_bell1") then ObjSet( common_impl.hint["use_bell1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bell1", private.use_bell1_inv );
cmn.AddSubscriber( "use_bell1", private.use_bell1_beg, private.room_objname );
cmn.AddSubscriber( "use_bell1", private.use_bell1_end, private.room_objname );
cmn.AddSubscriber( "use_bell1", private.use_bell1_logic );
cmn.AddSubscriber( "use_bell1_inv", private.use_bell1_inv, private.room_objname );
cmn.AddSubscriber( "use_bell1_beg", private.use_bell1_beg, private.room_objname );
cmn.AddSubscriber( "use_bell1_end", private.use_bell1_end, private.room_objname );
cmn.AddSubscriber( "use_bell1_end", private.use_bell1_logic );
--------------------------------------------------------------------------------------------
function public.use_bell1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bell1" );
    cmn.CallEventHandler( "use_bell1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bell1") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_bell1","use_bell2"} ) then 
      public.win_sound_load()
      ObjGet( "gfx_doortostreet_win_sound_zone" ).event_mdown()   
    end
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bell1_inv" );
  cmn.CallEventHandler( "use_bell1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doortostreet_anim_1", "use_bell_1", func_end );
  SoundSfx( "aud_use_bell1_doortostreet" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bell2" ] = { type = "use", inv_obj = "inv_bell2", use_place = "gfx_doortostreet_bell2_zone", room = "rm_workshop", zz = "zz_doortostreet", zz_gate = "gzz_workshop_doortostreet" };

private.use_bell2_logic = function()
  if ld.CheckRequirements( {"use_bell2","use_bell1"} ) then
    ObjSet( "gfx_doortostreet_win_sound_zone", { input = 1, active = 1 } )
    ld.mmgZoomInit("win_sound"); 
    ObjSet( "obj_doorstreet_mmg_root", {input = 1} );
  end;
end;
private.use_bell2_inv = function()
  common_impl.ProcessMultiUseAll("bell2", "bell2")
end;
private.use_bell2_beg = function()
  ObjDelete( "gfx_doortostreet_bell2_zone" );
end;
private.use_bell2_end = function()
  ObjDelete("anm_doortostreet_anim_2")
  ObjSet( "spr_doorstreet_mmg_bell_9", {visible = 1} );
  ObjSet( "spr_workshop_bell_2", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_bell2") then ObjSet( common_impl.hint["use_bell2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bell2", private.use_bell2_inv );
cmn.AddSubscriber( "use_bell2", private.use_bell2_beg, private.room_objname );
cmn.AddSubscriber( "use_bell2", private.use_bell2_end, private.room_objname );
cmn.AddSubscriber( "use_bell2", private.use_bell2_logic );
cmn.AddSubscriber( "use_bell2_inv", private.use_bell2_inv, private.room_objname );
cmn.AddSubscriber( "use_bell2_beg", private.use_bell2_beg, private.room_objname );
cmn.AddSubscriber( "use_bell2_end", private.use_bell2_end, private.room_objname );
cmn.AddSubscriber( "use_bell2_end", private.use_bell2_logic );
--------------------------------------------------------------------------------------------
function public.use_bell2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bell2" );
    cmn.CallEventHandler( "use_bell2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_bell2") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_bell1","use_bell2"} ) then 
      public.win_sound_load()
      ObjGet( "gfx_doortostreet_win_sound_zone" ).event_mdown()
    end 
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bell2_inv" );
  cmn.CallEventHandler( "use_bell2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_doortostreet_anim_2", "use_bell_2", func_end );
  SoundSfx( "aud_use_bell2_doortostreet" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
private.win_sound_poses = {}
private.win_sound_begstate = {2,6,13,12,15,3,8,10,9,7,1,11,4,14,5}
private.mmg_loaded = false
local bell = "spr_doorstreet_mmg_bell_"
local chosen
function private.win_sound_read_poses()
  for i,o in ipairs(private.win_sound_begstate) do
    local pb = ObjGet(bell..i)
    private.win_sound_poses[i] = {pb.pos_x, pb.pos_y}
  end

end
private.win_sound_read_poses()

function public.win_sound_load(reset,skip)
  local begstate = private.win_sound_begstate
  local winstate = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15}
  local winsset = {1,2,3,4,5,3,4,5,2,1,5,2,1,4,3}
  local light = "spr_doorstreet_mmg_light"
  local flytime = 0.5

  if not ng_global.progress["std"]["win_sound"].state or reset then
    ng_global.progress["std"]["win_sound"].state = ld.TableCopy(begstate)
  end

  local function load_map(skip)
    local source = ObjGet(bell..1)
    local toload = skip and winstate or ng_global.progress["std"]["win_sound"].state

    for i,o in ipairs(toload) do

      
      ObjSet( bell..i, { inputrect_init = source.inputrect_init,
                         inputrect_x = source.inputrect_x, 
                         inputrect_y = source.inputrect_y, 
                         inputrect_w = source.inputrect_w, 
                         inputrect_h = source.inputrect_h, 
                         event_mdown = source.event_mdown,
                         event_menter = source.event_menter,
                         event_mleave = source.event_mleave
                        } );
      if not ObjGet(light.."_"..i) then
        ld.CopyObj(light, light.."_"..i, "spr", bell..i)
      end
  
      ObjSet( bell..o, {pos_x = private.win_sound_poses[ i ][1],
                        pos_y = private.win_sound_poses[ i ][2]} );

    end
  end

  --wincheck
  local prevstate
  local function wincheck(skip)
    local function win()
      public.win_sound()
    end
    local function wining()
      local count = 0
      for i,o in ipairs(winsset) do
        local s = ObjGet(bell..ng_global.progress["std"]["win_sound"].state[i]).res
        local n = tonumber(s:sub(s:len()))
        if n == o then
          count = count + 1
        end
      end
      return count == #winsset
    end
    if wining() or skip then
      SoundSfx( "aud_win_doortostreet" )
      ObjSet( "obj_doorstreet_mmg_root", {input = 0} );
      for i,o in ipairs(ng_global.progress["std"]["win_sound"].state) do
        ObjAnimate( light.."_"..i, 8, 0, 0, function() end, {0,0,0, i/5+0.001,0,0, 0.5+i/5,0,1, 1+i/5,0,0} );
      end
      if not skip then
        ng_global.progress["std"]["win_sound"].state = ld.TableCopy(prevstate)
      end
      ld.Lock(1)
      ld.StartTimer( #ng_global.progress["std"]["win_sound"].state/5+1, function() win() end )
    end
  end

  --load
  local function load(skip)
    load_map(skip)
  end
  local function chooseload(reset,skip)
    if reset or skip then
      chosen = nil
      local toload = skip and winstate or begstate
      local time = flytime
      local animated = false
      ld.Lock(1)
      for i,o in ipairs(toload) do
        ObjSet( light.."_"..i, {alp = 0} );

        if ObjGet(bell..o).pos_x ~= private.win_sound_poses[i][1] then
          animated = true;
          ObjSet( bell..o, {pos_z = 1} );
          ObjAnimate( bell..o, 3, 0, 0, function() ObjSet( bell..o, {pos_z = 0} ); end, {
          0,0, ObjGet(bell..o).pos_x,ObjGet(bell..o).pos_y, 
          time,0,private.win_sound_poses[i][1],private.win_sound_poses[i][2]
          } );
        end
      end
      if animated then
        SoundSfx( "aud_change_bells" )
      end
      ld.StartTimer( time, function() ld.Lock(0) load(skip) wincheck(skip)  end )
    else
      load()
    end
  end
  chooseload(reset,skip)
  --save
  local function save(a,b)
    prevstate = ld.TableCopy(ng_global.progress["std"]["win_sound"].state)
    local i,j = ld.TableContains(ng_global.progress["std"]["win_sound"].state, a, 1),ld.TableContains(ng_global.progress["std"]["win_sound"].state, b, 1)
    ng_global.progress["std"]["win_sound"].state[i],ng_global.progress["std"]["win_sound"].state[j] = 
    ng_global.progress["std"]["win_sound"].state[j],ng_global.progress["std"]["win_sound"].state[i]
    wincheck()
  end  


  function public.win_sound_menter(sender)
    local n = tonumber( ld.StringDivide(sender)[5])
    local li = ObjGet(light.."_"..n)
    if chosen ~= n then
      ObjAnimate( li.name, 8, 0, 0, function() end, {0,0,li.alp, 0.2,0,1} );
    end
  end
  function public.win_sound_mleave(sender)
    local n = tonumber( ld.StringDivide(sender)[5] )
    local li = ObjGet(light.."_"..n)
    if chosen ~= n then
      ObjAnimate( li.name, 8, 0, 0, function() end, {0,0,li.alp, 0.2,0,0} );
    end
  end
  --public

  function public.win_sound_click(sender)
    local n = tonumber( ld.StringDivide(sender)[5] )
    if chosen then
      if chosen == n then 
      else
        SoundSfx( "aud_change_bells" )
        local bell1 = ObjGet(bell..n)
        local bell2 = ObjGet(bell..chosen)
        local time = flytime
        ObjSet( bell1.name, {pos_z = 1} );
        ObjSet( bell2.name, {pos_z = 1} );
        ObjAnimate( bell1.name, 3, 0, 0, function() end, {0,0,bell1.pos_x,bell1.pos_y, time/2,1,(bell1.pos_x+bell2.pos_x)/2,(bell1.pos_y+bell2.pos_y)/2-50, time,2,bell2.pos_x,bell2.pos_y} );
        ObjAnimate( bell2.name, 3, 0, 0, function() end, {0,0,bell2.pos_x,bell2.pos_y, time/2,1,(bell1.pos_x+bell2.pos_x)/2,(bell1.pos_y+bell2.pos_y)/2+50, time,2,bell1.pos_x,bell1.pos_y} );
        local a,b = n,chosen
        ld.Lock(1)
        ObjSet( light.."_"..chosen, {alp = 0} );
        ld.StartTimer( time, function() 
          ObjSet( bell1.name, {pos_z = 0} );
          ObjSet( bell2.name, {pos_z = 0} );
          ld.Lock(0) 
          save(a,b)
        end )
      end
      chosen = nil
    else
      chosen = n
      --ObjSet( light.."_"..n, {alp = 1} );
      SoundSfx( "aud_clk_bell" )
    end
  end
end

--------------------------------------------------------------------------------------------
common_impl.hint[ "win_sound" ] = { type = "click", use_place = "gfx_doortostreet_win_sound_zone", room = "rm_workshop", zz = "zz_doortostreet", zz_gate = "gzz_workshop_doortostreet" };

private.win_sound_logic = function()
  if ld.CheckRequirements( {"win_sound"} ) then
    ObjSet( "grm_workshop_citystreets", { visible = 1, input = 1, active = 1 } );
    if port.isPortable() == 1 then
      port.GrmEventLightOn("grm_workshop_citystreets_focus");
    end;
  end
end;
private.win_sound_beg = function()
  if ld.CheckRequirements( {"win_sound"} ) then
  ObjDelete( "gfx_doortostreet_win_sound_zone" );
  end
end;
private.win_sound_end = function()
  if ld.CheckRequirements( {"win_sound"} ) then
    ObjDelete("spr_workshop_bell_1")
    ObjDelete("spr_workshop_bell_2")
    ObjDelete("spr_workshop_bells_wrong")
    ObjSet( "spr_workshop_bells_done", {visible = 1} );
    ObjSet( "anm_workshop_anim_door_street", {animfunc = "open_door_street", frame = 999 } );
  end
  if common_impl.ZzCompleteCheck("win_sound") then ObjSet( common_impl.hint["win_sound"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_sound", private.win_sound_beg, private.room_objname );
cmn.AddSubscriber( "win_sound", private.win_sound_end, private.room_objname );
cmn.AddSubscriber( "win_sound", private.win_sound_logic );
cmn.AddSubscriber( "win_sound_beg", private.win_sound_beg, private.room_objname );
cmn.AddSubscriber( "win_sound_end", private.win_sound_end, private.room_objname );
cmn.AddSubscriber( "win_sound_end", private.win_sound_logic );
--------------------------------------------------------------------------------------------
function public.win_sound()

  local func_end = function()
    cmn.SetEventDone( "win_sound" );
    cmn.CallEventHandler( "win_sound_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_sound") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_sound_beg" );
  common_impl.Lock(1);

  ObjDelete("spr_workshop_bell_1")
  ObjDelete("spr_workshop_bell_2")
  ObjDelete("spr_workshop_bells_wrong")
  ObjSet( "spr_workshop_bells_done", {visible = 1} );
  --SoundSfx( 0 )
  --func_end()
  
  cmn.MiniGameHide( "sound", true );
  ObjGet( "obj_doortostreet_win_sound_zoom" ).event_mdown()

  ld.CloseSubRoom()
  ld.AnimPlay( "anm_workshop_anim_door_street", "open_door_street", func_end );  
end;


--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local function get_amuletelf4_for_workshop()
    if ld.CheckRequirements( {"get_amuletelf4"} ) and not ld.CheckRequirements( {"clk_workshopbertagoldvid"} ) then
      --public.clk_workshopbertagoldvid()
    end
  end
  local function get_amuletelf4_for_workshop_logic()
    if ld.CheckRequirements( {"get_amuletelf4"} ) then
      ObjSet( "gfx_workshop_clk_workshopbertagoldvid_zone", {input = 1} );
    end
  end
  cmn.AddSubscriber( "get_amuletelf4", get_amuletelf4_for_workshop, private.room_objname );
  cmn.AddSubscriber( "get_amuletelf4", get_amuletelf4_for_workshop_logic );


function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_doortostreet" ) then
    public.win_sound_load(1)
  end

end;
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
    
  if ( mg_name == "zz_doortostreet" ) then
    public.win_sound_load(nil,1)
  end

end;

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_workshop();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_workshop_env" )
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_doortostreet" );
  function zz_doortostreet.Open()
  end;
  function zz_doortostreet.PreOpen()
    public.win_sound_load()
    if ld.CheckRequirements( {"use_bell1","use_bell2"} ) and not ld.CheckRequirements( {"win_sound"} ) then
      ObjGet( "gfx_doortostreet_win_sound_zone" ).event_mdown()
    end    
  end;
  function zz_doortostreet.PreClose()
  end;
  function zz_doortostreet.Close()
  end;

  subroom.Define( "zz_doortoup" );
  function zz_doortoup.Open()
  end;
  function zz_doortoup.PreOpen()
  end;
  function zz_doortoup.PreClose()
  end;
  function zz_doortoup.Close()
  end;

  subroom.Define( "zz_buffet" );
  function zz_buffet.Open()
    public.clk_buffetanim()
  end;
  function zz_buffet.PreOpen()
  end;
  function zz_buffet.PreClose()
  end;
  function zz_buffet.Close()
  end;

  subroom.Define( "zz_sewingtable" );
  function zz_sewingtable.Open()
    if not ld.CheckRequirements( {"clk_sewingtableanim"} ) then
      public.clk_sewingtableanim()
    end
  end;
  function zz_sewingtable.PreOpen()
  end;
  function zz_sewingtable.PreClose()
  end;
  function zz_sewingtable.Close()
  end;

  subroom.Define( "zz_piter" );
  function zz_piter.Open()
  end;
  function zz_piter.PreOpen()
  end;
  function zz_piter.PreClose()
  end;
  function zz_piter.Close()
  end;
  
end;
--*********************************************************************************************************************