-- name=rm_dressingroomext
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_dressingroomext";
  --------------------------------------------------------------------------------------------
  private.InitZz();
  --------------------------------------------------------------------------------------------
function private.opn_dressingroomext()
  if not ( cmn.IsEventDone( "opn_dressingroomext" ) ) then
  local func_end = function()
      cmn.SetEventDone( "opn_dressingroomext" );
      cmn.CallEventHandler( "opn_dressingroomext" )
      ld.ShowBbtOpn( private.room_objname )
  end;
  func_end()
  end;
end;
--------------------------------------------------------------------
local opn_dressingroomext = function() end;
local opn_dressingroomext_logic = function() end;
cmn.AddSubscriber( "opn_dressingroomext", opn_dressingroomext_logic )
cmn.AddSubscriber( "opn_dressingroomext", opn_dressingroomext, private.room_objname )
--------------------------------------------------------------------------------------------
function public.SwitchFrase( dlg_name, count_txt )
  if dlg_name == "fairyext2" then
    if count_txt == 1 then
      common_impl.continue_visible = true
    elseif count_txt == 2 then
      common_impl.continue_visible = true
    elseif count_txt == 3 then
      --common_impl.continue_visible = true
    end
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "dlg_dressingroomext_fairyext2" ] = { type = "click", use_place = "gfx_dressingroomext_dlg_dressingroomext_fairyext2_zone", room = "rm_dressingroomext", zz = "zz_mannequinext", zz_gate = "gzz_dressingroomext_mannequinext" };

private.dlg_dressingroomext_fairyext2_logic = function()
  ObjSet( "gfx_mannequinext_fairywithscissorsext_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_mannequinext_amuletthreadsext", {active = 1, input = 1, visible = 1} );
end;
private.dlg_dressingroomext_fairyext2_beg = function()
  ObjDelete( "gfx_dressingroomext_dlg_dressingroomext_fairyext2_zone" );
end;
private.dlg_dressingroomext_fairyext2_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "dlg_dressingroomext_fairyext2", private.dlg_dressingroomext_fairyext2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_dressingroomext_fairyext2", private.dlg_dressingroomext_fairyext2_end, private.room_objname );
cmn.AddSubscriber( "dlg_dressingroomext_fairyext2", private.dlg_dressingroomext_fairyext2_logic );
cmn.AddSubscriber( "dlg_dressingroomext_fairyext2_beg", private.dlg_dressingroomext_fairyext2_beg, private.room_objname );
cmn.AddSubscriber( "dlg_dressingroomext_fairyext2_end", private.dlg_dressingroomext_fairyext2_end, private.room_objname );
cmn.AddSubscriber( "dlg_dressingroomext_fairyext2_end", private.dlg_dressingroomext_fairyext2_logic );
--------------------------------------------------------------------------------------------
function public.dlg_dressingroomext_fairyext2( obj )
  local func_end = function()
    cmn.SetEventDone( "dlg_dressingroomext_fairyext2" );
    cmn.CallEventHandler( "dlg_dressingroomext_fairyext2_end" );
    common_impl.Lock(0);
  end;
  function public.dlg_dressingroomext_fairyext2_func_end()
    common_impl.Lock(1);
    ld.StartTimer( 0.5, function() 
      common_impl.Gate_MDown( "gzz_dressingroomext_mannequinext",{ ObjGet( "gzz_dressingroomext_mannequinext" ).pos_x, ObjGet( "gzz_dressingroomext_mannequinext" ).pos_y}  )
      func_end()
    end )
  end
  local func_start = function()
    ld.Lock(0)
    common_impl.dialog_character_loc = "";
    common_impl.Start( "fairyext2", 3, nil, nil, true, "dlg_dressingroomext_fairyext2_func_end", { "aud_fairy_1_voc", "aud_fairy_2_voc" } );
  end
  cmn.CallEventHandler( "dlg_dressingroomext_fairyext2_beg" );
  ld.Lock(1)
  VidStop("vid_mannequinext_vid_click")
  ObjAttach("vid_mannequinext_vid_click","zz_mannequinext")
  SoundSfx( "aud_xx_mannequinn" )
  VidPlay("vid_mannequinext_vid_click",function() 
    ld.CloseSubRoom()
    ld.StartTimer( 0.5,function() func_start() end )    
    ObjDetach("vid_mannequinext_vid_click")
  end)

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_bustext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_screwdriverhandleext" ] = { type = "use", inv_obj = "inv_screwdriverhandleext", use_place = "gfx_bustext_screwdriverhandleext_zone", room = "rm_dressingroomext", zz = "zz_bustext", zz_gate = "gzz_dressingroomext_bustext" };

private.use_screwdriverhandleext_logic = function()
  ObjSet( "spr_bustext_screwdriverext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_bustext_coloredglassext1", { visible = 1, input = 1, active = 1 } )

end;
private.use_screwdriverhandleext_inv = function()
  common_impl.ProcessMultiUseAll("screwdriverhandleext", "screwdriverhandleext")
end;
private.use_screwdriverhandleext_beg = function()
  ObjDelete( "gfx_bustext_screwdriverhandleext_zone" );
end;
private.use_screwdriverhandleext_end = function()
  ObjSet( "spr_bustext_coloredglassext1_sh", { visible = 1 } )
  ObjSet( "gfx_bustext_coloredglassext1", { visible = 1, active = 1 } )
  ObjSet( "anm_bustext_anim_screwdriver", {animfunc = "get_screwdriver_end", frame = 0, input = 1 } );
  ObjDelete("spr_dressingroomext_coloredglassext1")
  ObjDelete("spr_dressingroomext_screwdriverext_shpilka")
  ObjSet( "spr_dressingroomext_coloredglassext1_lay", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_screwdriverhandleext") then ObjSet( common_impl.hint["use_screwdriverhandleext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_screwdriverhandleext", private.use_screwdriverhandleext_inv );
cmn.AddSubscriber( "use_screwdriverhandleext", private.use_screwdriverhandleext_beg, private.room_objname );
cmn.AddSubscriber( "use_screwdriverhandleext", private.use_screwdriverhandleext_end, private.room_objname );
cmn.AddSubscriber( "use_screwdriverhandleext", private.use_screwdriverhandleext_logic );
cmn.AddSubscriber( "use_screwdriverhandleext_inv", private.use_screwdriverhandleext_inv, private.room_objname );
cmn.AddSubscriber( "use_screwdriverhandleext_beg", private.use_screwdriverhandleext_beg, private.room_objname );
cmn.AddSubscriber( "use_screwdriverhandleext_end", private.use_screwdriverhandleext_end, private.room_objname );
cmn.AddSubscriber( "use_screwdriverhandleext_end", private.use_screwdriverhandleext_logic );
--------------------------------------------------------------------------------------------
function public.use_screwdriverhandleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_screwdriverhandleext" );
    cmn.CallEventHandler( "use_screwdriverhandleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_screwdriverhandleext") then ld.CloseSubRoom() end;
    public.get_screwdriverext()
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_screwdriverhandleext_inv" );
  cmn.CallEventHandler( "use_screwdriverhandleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bustext_anim_screwdriver", "get_screwdriver", func_end );
  SoundSfx( "aud_use_screwdriverhandleext_dressingroomext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_screwdriverext" ] = { type = "get", get_obj = "spr_bustext_screwdriverext", room = "rm_dressingroomext", zz = "zz_bustext", zz_gate = "gzz_dressingroomext_bustext" };

private.get_screwdriverext_logic = function()
  
end;
private.get_screwdriverext_inv = function()
  interface.InventoryItemAdd("inv_screwdriverext","spr_bustext_screwdriverext");
end;
private.get_screwdriverext_beg = function()
  ObjDelete("gfx_bustext_screwdriverext")
end;
private.get_screwdriverext_end = function()
  if common_impl.ZzCompleteCheck("get_screwdriverext") then ObjSet( common_impl.hint["get_screwdriverext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_screwdriverext", private.get_screwdriverext_inv );
cmn.AddSubscriber( "get_screwdriverext", private.get_screwdriverext_beg, private.room_objname );
cmn.AddSubscriber( "get_screwdriverext", private.get_screwdriverext_end, private.room_objname );
cmn.AddSubscriber( "get_screwdriverext", private.get_screwdriverext_logic );
--------------------------------------------------------------------
function public.get_screwdriverext()
  cmn.SetEventDone( "get_screwdriverext" );
  cmn.CallEventHandler( "get_screwdriverext" );
  if common_impl.ZzCompleteCheck("get_screwdriverext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_coloredglassext1" ] = { type = "get", get_obj = "spr_bustext_coloredglassext1", room = "rm_dressingroomext", zz = "zz_bustext", zz_gate = "gzz_dressingroomext_bustext" };

private.get_coloredglassext1_logic = function()
  
end;
private.get_coloredglassext1_inv = function()
  interface.InventoryItemAdd("inv_coloredglassext","spr_bustext_coloredglassext1",function() level_inv.ProcessGetColoredglassextAll( "get_coloredglassext1" ) end);
end;
private.get_coloredglassext1_beg = function()
  ObjDelete("gfx_bustext_coloredglassext1")
  ObjSet( "spr_bustext_coloredglassext1", {ang = 1.4461} );
end;
private.get_coloredglassext1_end = function()
  ObjDelete("spr_dressingroomext_coloredglassext1_lay")
  ObjDelete("spr_bustext_coloredglassext1_sh")
  if common_impl.ZzCompleteCheck("get_coloredglassext1") then ObjSet( common_impl.hint["get_coloredglassext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_coloredglassext1", private.get_coloredglassext1_inv );
cmn.AddSubscriber( "get_coloredglassext1", private.get_coloredglassext1_beg, private.room_objname );
cmn.AddSubscriber( "get_coloredglassext1", private.get_coloredglassext1_end, private.room_objname );
cmn.AddSubscriber( "get_coloredglassext1", private.get_coloredglassext1_logic );
--------------------------------------------------------------------
function public.get_coloredglassext1()
  cmn.SetEventDone( "get_coloredglassext1" );
  cmn.CallEventHandler( "get_coloredglassext1" );
  if common_impl.ZzCompleteCheck("get_coloredglassext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mousefigureext1" ] = { type = "use", inv_obj = "inv_mousefigureext1", use_place = "gfx_bustext_mousefigureext1_zone", room = "rm_dressingroomext", zz = "zz_bustext", zz_gate = "gzz_dressingroomext_bustext" };

private.use_mousefigureext1_logic = function()
  if ld.CheckRequirements( {"use_mousefigureext1","use_mousefigureext2"} ) then
    ObjSet( "spr_bustext_coloredglassext4", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_mousefigureext1_inv = function()
  common_impl.ProcessMultiUseAll("mousefigureext1", "mousefigureext1")
end;
private.use_mousefigureext1_beg = function()
  ObjDelete( "gfx_bustext_mousefigureext1_zone" );
  ObjDelete("spr_bustext_anim_click_karusel_mouse1")
  ObjDelete("spr_bustext_anim_click_karusel_mouse_holder_1")
end;
private.use_mousefigureext1_end = function()
  ObjSet( "anm_bustext_anim_use_mouse_1", {animfunc = "use_mouse_1", frame = 999 } );
  ObjSet( "spr_dressingroomext_mouse1", {visible = 1} );
  if ld.CheckRequirements( {"use_mousefigureext2","use_mousefigureext1"} ) then
    ObjSet( "anm_bustext_anim_click_karusel", {animfunc = "use_mouses_end", frame = 0 } );
    ObjSet( "gfx_bustext_coloredglassext4", { visible = 1, active = 1 } )
    ObjSet( "spr_dressingroomext_box_open", {visible = 1} );
    ObjSet( "spr_dressingroomext_coloredglassext4", {visible = 1} );
    ObjSet( "spr_bustext_coloredglassext4_sh", { visible = 1 } )
  end
  if common_impl.ZzCompleteCheck("use_mousefigureext1") then ObjSet( common_impl.hint["use_mousefigureext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mousefigureext1", private.use_mousefigureext1_inv );
cmn.AddSubscriber( "use_mousefigureext1", private.use_mousefigureext1_beg, private.room_objname );
cmn.AddSubscriber( "use_mousefigureext1", private.use_mousefigureext1_end, private.room_objname );
cmn.AddSubscriber( "use_mousefigureext1", private.use_mousefigureext1_logic );
cmn.AddSubscriber( "use_mousefigureext1_inv", private.use_mousefigureext1_inv, private.room_objname );
cmn.AddSubscriber( "use_mousefigureext1_beg", private.use_mousefigureext1_beg, private.room_objname );
cmn.AddSubscriber( "use_mousefigureext1_end", private.use_mousefigureext1_end, private.room_objname );
cmn.AddSubscriber( "use_mousefigureext1_end", private.use_mousefigureext1_logic );
--------------------------------------------------------------------------------------------

function public.use_mousefigureext1( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mousefigureext1" );
    cmn.CallEventHandler( "use_mousefigureext1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mousefigureext1") then ld.CloseSubRoom() end;
  end;
  local func_end2 = function()
    if ld.CheckRequirements( {"use_mousefigureext2"} ) then
      SoundSfx( "aud_carousel_spinning" )
      ld.AnimPlay( "anm_bustext_anim_click_karusel", "use_mouses_all", func_end )
      public.use_mousefigureext_all( function() 
        
      end )
    else
      func_end()
    end
  end

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mousefigureext1_inv" );
  cmn.CallEventHandler( "use_mousefigureext1_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bustext_anim_use_mouse_1", "use_mouse_1", func_end2 );
  SoundSfx( "aud_use_mousefigureext1_dressingroomext" )
  --func_end2()

end;
--------------------------------------------------------------------------------------------
function public.use_mousefigureext_all( func_after )
  ObjSet( "anm_bustext_anim_mouses", {animfunc = ""} );
  --ObjSet( "anm_bustext_anim_click_karusel", {visible = 0} );
  ObjSet( "anm_bustext_anim_use_mouse_2", {visible = 0} );
  ObjSet( "anm_bustext_anim_use_mouse_1", {visible = 0} );
  ObjAttach("vid_bustext_vid_mouses","zz_bustext")
  VidPlay("vid_bustext_vid_mouses",function() 
    ObjSet( "anm_bustext_anim_mouses", {animfunc = "static"} );
    --ObjSet( "anm_bustext_anim_click_karusel", {visible = 1} );
    ObjSet( "anm_bustext_anim_use_mouse_2", {visible = 1} );
    ObjSet( "anm_bustext_anim_use_mouse_1", {visible = 1} );
    ObjDelete("vid_bustext_vid_mouses") 
    func_after() 
  end)
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mousefigureext2" ] = { type = "use", inv_obj = "inv_mousefigureext2", use_place = "gfx_bustext_mousefigureext2_zone", room = "rm_dressingroomext", zz = "zz_bustext", zz_gate = "gzz_dressingroomext_bustext" };

private.use_mousefigureext2_logic = function()
  if ld.CheckRequirements( {"use_mousefigureext2","use_mousefigureext1"} ) then
    ObjSet( "spr_bustext_coloredglassext4", { visible = 1, input = 1, active = 1 } )
  end;

end;
private.use_mousefigureext2_inv = function()
  common_impl.ProcessMultiUseAll("mousefigureext2", "mousefigureext2")
end;
private.use_mousefigureext2_beg = function()
  ObjDelete( "gfx_bustext_mousefigureext2_zone" );
  ObjDelete("spr_bustext_anim_click_karusel_mouse2")
  ObjDelete("spr_bustext_anim_click_karusel_mouse_holder_2")
end;
private.use_mousefigureext2_end = function()
  ObjSet( "spr_dressingroomext_mouse2", {visible = 1} );
  ObjSet( "anm_bustext_anim_use_mouse_2", {animfunc = "use_mouse_2", frame = 999 } );
  if ld.CheckRequirements( {"use_mousefigureext2","use_mousefigureext1"} ) then
    ObjSet( "anm_bustext_anim_click_karusel", {animfunc = "use_mouses_end", frame = 0 } );
    ObjSet( "gfx_bustext_coloredglassext4", { visible = 1, active = 1 } )
    ObjSet( "spr_dressingroomext_box_open", {visible = 1} );
    ObjSet( "spr_dressingroomext_coloredglassext4", {visible = 1} );
    ObjSet( "spr_bustext_coloredglassext4_sh", { visible = 1 } )
  end
  if common_impl.ZzCompleteCheck("use_mousefigureext2") then ObjSet( common_impl.hint["use_mousefigureext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mousefigureext2", private.use_mousefigureext2_inv );
cmn.AddSubscriber( "use_mousefigureext2", private.use_mousefigureext2_beg, private.room_objname );
cmn.AddSubscriber( "use_mousefigureext2", private.use_mousefigureext2_end, private.room_objname );
cmn.AddSubscriber( "use_mousefigureext2", private.use_mousefigureext2_logic );
cmn.AddSubscriber( "use_mousefigureext2_inv", private.use_mousefigureext2_inv, private.room_objname );
cmn.AddSubscriber( "use_mousefigureext2_beg", private.use_mousefigureext2_beg, private.room_objname );
cmn.AddSubscriber( "use_mousefigureext2_end", private.use_mousefigureext2_end, private.room_objname );
cmn.AddSubscriber( "use_mousefigureext2_end", private.use_mousefigureext2_logic );
--------------------------------------------------------------------------------------------
function public.use_mousefigureext2( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mousefigureext2" );
    cmn.CallEventHandler( "use_mousefigureext2_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mousefigureext2") then ld.CloseSubRoom() end;
  end;
  local func_end2 = function()
    if ld.CheckRequirements( {"use_mousefigureext1"} ) then
      SoundSfx( "aud_carousel_spinning" )
      ld.AnimPlay( "anm_bustext_anim_click_karusel", "use_mouses_all", func_end )
      public.use_mousefigureext_all( function() 
        
      end )
    else
      func_end()
    end
  end
  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mousefigureext2_inv" );
  cmn.CallEventHandler( "use_mousefigureext2_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bustext_anim_use_mouse_2", "use_mouse_2", func_end2 );
  SoundSfx( "aud_use_mousefigureext1_dressingroomext" )
  
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_coloredglassext4" ] = { type = "get", get_obj = "spr_bustext_coloredglassext4", room = "rm_dressingroomext", zz = "zz_bustext", zz_gate = "gzz_dressingroomext_bustext" };

private.get_coloredglassext4_logic = function()
  
end;
private.get_coloredglassext4_inv = function()
  interface.InventoryItemAdd("inv_coloredglassext","spr_bustext_coloredglassext4",function() level_inv.ProcessGetColoredglassextAll( "get_coloredglassext4" ) end);
end;
private.get_coloredglassext4_beg = function()
  ObjDelete("gfx_bustext_coloredglassext4")
end;
private.get_coloredglassext4_end = function()
  ObjDelete("spr_dressingroomext_coloredglassext4")
  ObjDetach( "spr_bustext_coloredglassext4_sh" )
  if common_impl.ZzCompleteCheck("get_coloredglassext4") then ObjSet( common_impl.hint["get_coloredglassext4"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_coloredglassext4", private.get_coloredglassext4_inv );
cmn.AddSubscriber( "get_coloredglassext4", private.get_coloredglassext4_beg, private.room_objname );
cmn.AddSubscriber( "get_coloredglassext4", private.get_coloredglassext4_end, private.room_objname );
cmn.AddSubscriber( "get_coloredglassext4", private.get_coloredglassext4_logic );
--------------------------------------------------------------------
function public.get_coloredglassext4()
  cmn.SetEventDone( "get_coloredglassext4" );
  cmn.CallEventHandler( "get_coloredglassext4" );
  if common_impl.ZzCompleteCheck("get_coloredglassext4") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_medalioncatext" ] = { type = "use", inv_obj = "inv_medalioncatext", use_place = "gfx_bustext_medalioncatext_zone", room = "rm_dressingroomext", zz = "zz_bustext", zz_gate = "gzz_dressingroomext_bustext" };

private.use_medalioncatext_logic = function()
  ObjSet( "spr_bustext_tweezersext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_bustext_giftgunext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_bustext_towelext", { visible = 1, input = 1, active = 1 } )

end;
private.use_medalioncatext_inv = function()
  common_impl.ProcessMultiUseAll("medalioncatext", "medalioncatext")
end;
private.use_medalioncatext_beg = function()
  ObjDelete( "gfx_bustext_medalioncatext_zone" );
end;
private.use_medalioncatext_end = function()
  ObjSet( "gfx_bustext_tweezersext", { visible = 1, active = 1 } )
  ObjSet( "gfx_bustext_giftgunext", { visible = 1, active = 1 } )
  ObjSet( "gfx_bustext_towelext", { visible = 1, active = 1 } )
  ObjSet( "anm_bustext_anim_cat", {animfunc = "use_cat_end", frame = 0 } );
  ObjDelete("spr_dressingroomext_byust")
  ObjSet( "spr_dressingroomext_byust_moved", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_medalioncatext") then ObjSet( common_impl.hint["use_medalioncatext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_medalioncatext", private.use_medalioncatext_inv );
cmn.AddSubscriber( "use_medalioncatext", private.use_medalioncatext_beg, private.room_objname );
cmn.AddSubscriber( "use_medalioncatext", private.use_medalioncatext_end, private.room_objname );
cmn.AddSubscriber( "use_medalioncatext", private.use_medalioncatext_logic );
cmn.AddSubscriber( "use_medalioncatext_inv", private.use_medalioncatext_inv, private.room_objname );
cmn.AddSubscriber( "use_medalioncatext_beg", private.use_medalioncatext_beg, private.room_objname );
cmn.AddSubscriber( "use_medalioncatext_end", private.use_medalioncatext_end, private.room_objname );
cmn.AddSubscriber( "use_medalioncatext_end", private.use_medalioncatext_logic );
--------------------------------------------------------------------------------------------
function public.use_medalioncatext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_medalioncatext" );
    cmn.CallEventHandler( "use_medalioncatext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_medalioncatext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_medalioncatext_inv" );
  cmn.CallEventHandler( "use_medalioncatext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_bustext_anim_cat", "use_cat", func_end );
  SoundSfx( "aud_use_medalioncatext_dressingroomext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_tweezersext" ] = { type = "get", get_obj = "spr_bustext_tweezersext", room = "rm_dressingroomext", zz = "zz_bustext", zz_gate = "gzz_dressingroomext_bustext" };

private.get_tweezersext_logic = function()
  
end;
private.get_tweezersext_inv = function()
  interface.InventoryItemAdd("inv_tweezersext","spr_bustext_tweezersext");
end;
private.get_tweezersext_beg = function()
  ObjDelete("gfx_bustext_tweezersext")
end;
private.get_tweezersext_end = function()
  ObjDelete("spr_dressingroomext_tweezersext")
  if common_impl.ZzCompleteCheck("get_tweezersext") then ObjSet( common_impl.hint["get_tweezersext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_tweezersext", private.get_tweezersext_inv );
cmn.AddSubscriber( "get_tweezersext", private.get_tweezersext_beg, private.room_objname );
cmn.AddSubscriber( "get_tweezersext", private.get_tweezersext_end, private.room_objname );
cmn.AddSubscriber( "get_tweezersext", private.get_tweezersext_logic );
--------------------------------------------------------------------
function public.get_tweezersext()
  cmn.SetEventDone( "get_tweezersext" );
  cmn.CallEventHandler( "get_tweezersext" );
  if common_impl.ZzCompleteCheck("get_tweezersext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_giftgunext" ] = { type = "get", get_obj = "spr_bustext_giftgunext", room = "rm_dressingroomext", zz = "zz_bustext", zz_gate = "gzz_dressingroomext_bustext" };

private.get_giftgunext_logic = function()
  
end;
private.get_giftgunext_inv = function()
  interface.InventoryItemAdd("inv_giftgunext","spr_bustext_giftgunext");
end;
private.get_giftgunext_beg = function()
  ObjDelete("gfx_bustext_giftgunext")
end;
private.get_giftgunext_end = function()
  ObjDelete("spr_dressingroomext_giftgunext")
  if common_impl.ZzCompleteCheck("get_giftgunext") then ObjSet( common_impl.hint["get_giftgunext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_giftgunext", private.get_giftgunext_inv );
cmn.AddSubscriber( "get_giftgunext", private.get_giftgunext_beg, private.room_objname );
cmn.AddSubscriber( "get_giftgunext", private.get_giftgunext_end, private.room_objname );
cmn.AddSubscriber( "get_giftgunext", private.get_giftgunext_logic );
--------------------------------------------------------------------
function public.get_giftgunext()
  cmn.SetEventDone( "get_giftgunext" );
  cmn.CallEventHandler( "get_giftgunext" );
  if common_impl.ZzCompleteCheck("get_giftgunext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_towelext" ] = { type = "get", get_obj = "spr_bustext_towelext", room = "rm_dressingroomext", zz = "zz_bustext", zz_gate = "gzz_dressingroomext_bustext" };

private.get_towelext_logic = function()
  
end;
private.get_towelext_inv = function()
  interface.InventoryItemAdd("inv_towelext","spr_bustext_towelext");
end;
private.get_towelext_beg = function()
  ObjDelete("gfx_bustext_towelext")
end;
private.get_towelext_end = function()
  ObjDelete("spr_dressingroomext_towelext")
  if common_impl.ZzCompleteCheck("get_towelext") then ObjSet( common_impl.hint["get_towelext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_towelext", private.get_towelext_inv );
cmn.AddSubscriber( "get_towelext", private.get_towelext_beg, private.room_objname );
cmn.AddSubscriber( "get_towelext", private.get_towelext_end, private.room_objname );
cmn.AddSubscriber( "get_towelext", private.get_towelext_logic );
--------------------------------------------------------------------
function public.get_towelext()
  cmn.SetEventDone( "get_towelext" );
  cmn.CallEventHandler( "get_towelext" );
  if common_impl.ZzCompleteCheck("get_towelext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_ovenext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_coloredglassext2" ] = { type = "get", get_obj = "spr_ovenext_coloredglassext2", room = "rm_dressingroomext", zz = "zz_ovenext", zz_gate = "gzz_dressingroomext_ovenext" };

private.get_coloredglassext2_logic = function()
  
end;
private.get_coloredglassext2_inv = function()
  interface.InventoryItemAdd("inv_coloredglassext","spr_ovenext_coloredglassext2",function() level_inv.ProcessGetColoredglassextAll( "get_coloredglassext2" ) end);
end;
private.get_coloredglassext2_beg = function()
  ObjDelete("gfx_ovenext_coloredglassext2")
end;
private.get_coloredglassext2_end = function()
  ObjDelete("spr_dressingroomext_coloredglassext2")
  if common_impl.ZzCompleteCheck("get_coloredglassext2") then ObjSet( common_impl.hint["get_coloredglassext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_coloredglassext2", private.get_coloredglassext2_inv );
cmn.AddSubscriber( "get_coloredglassext2", private.get_coloredglassext2_beg, private.room_objname );
cmn.AddSubscriber( "get_coloredglassext2", private.get_coloredglassext2_end, private.room_objname );
cmn.AddSubscriber( "get_coloredglassext2", private.get_coloredglassext2_logic );
--------------------------------------------------------------------
function public.get_coloredglassext2()
  cmn.SetEventDone( "get_coloredglassext2" );
  cmn.CallEventHandler( "get_coloredglassext2" );
  if common_impl.ZzCompleteCheck("get_coloredglassext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_ovenhandleext" ] = { type = "use", inv_obj = "inv_ovenhandleext", use_place = "gfx_ovenext_ovenhandleext_zone", room = "rm_dressingroomext", zz = "zz_ovenext", zz_gate = "gzz_dressingroomext_ovenext" };

private.use_ovenhandleext_logic = function()
  --ObjSet( "gfx_ovenext_clk_ovenext_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_ovenext_emberext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_ovenext_cogext1", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_ovenext_mulledwineext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_ovenhandleext_inv = function()
  common_impl.ProcessMultiUseAll("ovenhandleext", "ovenhandleext")
end;
private.use_ovenhandleext_beg = function()
  ObjDelete( "gfx_ovenext_ovenhandleext_zone" );
end;
private.use_ovenhandleext_end = function()
  ObjSet( "anm_ovenext_anim", {animfunc = "use_handle", frame = 999 } );
  ObjSet( "anm_ovenext_anim_glint", {visible = 1} );
  ObjSet( "spr_ovenext_cogext1_tr", {visible = 1} );
  ObjSet( "spr_dressingroomext_opened_oven", {visible = 1} );
  ObjSet( "spr_dressingroomext_cogext1", {visible = 1} );
  ObjSet( "spr_dressingroomext_emberext", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_ovenhandleext") then ObjSet( common_impl.hint["use_ovenhandleext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_ovenhandleext", private.use_ovenhandleext_inv );
cmn.AddSubscriber( "use_ovenhandleext", private.use_ovenhandleext_beg, private.room_objname );
cmn.AddSubscriber( "use_ovenhandleext", private.use_ovenhandleext_end, private.room_objname );
cmn.AddSubscriber( "use_ovenhandleext", private.use_ovenhandleext_logic );
cmn.AddSubscriber( "use_ovenhandleext_inv", private.use_ovenhandleext_inv, private.room_objname );
cmn.AddSubscriber( "use_ovenhandleext_beg", private.use_ovenhandleext_beg, private.room_objname );
cmn.AddSubscriber( "use_ovenhandleext_end", private.use_ovenhandleext_end, private.room_objname );
cmn.AddSubscriber( "use_ovenhandleext_end", private.use_ovenhandleext_logic );
--------------------------------------------------------------------------------------------
function public.use_ovenhandleext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "clk_ovenext" );
    cmn.SetEventDone( "use_ovenhandleext" );
    cmn.CallEventHandler( "use_ovenhandleext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_ovenhandleext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_ovenhandleext_inv" );
  cmn.CallEventHandler( "use_ovenhandleext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ovenext_anim", "use_handle", func_end );
  SoundSfx( "aud_use_ovenhandleext_dressingroomext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_ovenext" ] = { type = "click", use_place = "gfx_ovenext_clk_ovenext_zone", room = "rm_dressingroomext", zz = "zz_ovenext", zz_gate = "gzz_dressingroomext_ovenext" };

private.clk_ovenext_logic = function()

end;
private.clk_ovenext_beg = function()
  ObjDelete( "gfx_ovenext_clk_ovenext_zone" );
end;
private.clk_ovenext_end = function()
  if common_impl.ZzCompleteCheck("clk_ovenext") then ObjSet( common_impl.hint["clk_ovenext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_ovenext", private.clk_ovenext_beg, private.room_objname );
cmn.AddSubscriber( "clk_ovenext", private.clk_ovenext_end, private.room_objname );
cmn.AddSubscriber( "clk_ovenext", private.clk_ovenext_logic );
cmn.AddSubscriber( "clk_ovenext_beg", private.clk_ovenext_beg, private.room_objname );
cmn.AddSubscriber( "clk_ovenext_end", private.clk_ovenext_end, private.room_objname );
cmn.AddSubscriber( "clk_ovenext_end", private.clk_ovenext_logic );
--------------------------------------------------------------------------------------------
function public.clk_ovenext()

  local func_end = function()
    cmn.SetEventDone( "clk_ovenext" );
    cmn.CallEventHandler( "clk_ovenext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("clk_ovenext") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "clk_ovenext_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_clk_ovenext_dressingroomext" )
  func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_emberext" ] = { type = "get", get_obj = "spr_ovenext_emberext", room = "rm_dressingroomext", zz = "zz_ovenext", zz_gate = "gzz_dressingroomext_ovenext" };

private.get_emberext_logic = function()
  
end;
private.get_emberext_inv = function()
  interface.InventoryItemAdd("inv_emberext","spr_ovenext_emberext");
end;
private.get_emberext_beg = function()
  ObjDelete("gfx_ovenext_emberext")
end;
private.get_emberext_end = function()
  ObjDelete("spr_ovenext_emberext_shadow")
  ObjDelete("spr_dressingroomext_emberext")
  if common_impl.ZzCompleteCheck("get_emberext") then ObjSet( common_impl.hint["get_emberext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_emberext", private.get_emberext_inv );
cmn.AddSubscriber( "get_emberext", private.get_emberext_beg, private.room_objname );
cmn.AddSubscriber( "get_emberext", private.get_emberext_end, private.room_objname );
cmn.AddSubscriber( "get_emberext", private.get_emberext_logic );
--------------------------------------------------------------------
function public.get_emberext()
  cmn.SetEventDone( "get_emberext" );
  cmn.CallEventHandler( "get_emberext" );
  if common_impl.ZzCompleteCheck("get_emberext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_cogext1" ] = { type = "get", get_obj = "spr_ovenext_cogext1", room = "rm_dressingroomext", zz = "zz_ovenext", zz_gate = "gzz_dressingroomext_ovenext" };

private.get_cogext1_logic = function()
  
end;
private.get_cogext1_inv = function()
  interface.InventoryItemAdd("inv_cogext","spr_ovenext_cogext1",function() level_inv.ProcessGetCogextAll( "get_cogext1" ) end);
end;
private.get_cogext1_beg = function()
  ObjDelete("gfx_ovenext_cogext1")
end;
private.get_cogext1_end = function()
  ObjDelete("spr_dressingroomext_cogext1")
  if common_impl.ZzCompleteCheck("get_cogext1") then ObjSet( common_impl.hint["get_cogext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_cogext1", private.get_cogext1_inv );
cmn.AddSubscriber( "get_cogext1", private.get_cogext1_beg, private.room_objname );
cmn.AddSubscriber( "get_cogext1", private.get_cogext1_end, private.room_objname );
cmn.AddSubscriber( "get_cogext1", private.get_cogext1_logic );
--------------------------------------------------------------------
function public.get_cogext1()
  cmn.SetEventDone( "get_cogext1" );
  cmn.CallEventHandler( "get_cogext1" );
  if common_impl.ZzCompleteCheck("get_cogext1") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_mulledwineext" ] = { type = "use", inv_obj = "inv_mulledwineext", use_place = "gfx_ovenext_mulledwineext_zone", room = "rm_dressingroomext", zz = "zz_ovenext", zz_gate = "gzz_dressingroomext_ovenext" };

private.use_mulledwineext_logic = function()
  ObjSet( "gfx_ovenext_christmasspotholderext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_mulledwineext_inv = function()
  common_impl.ProcessMultiUseAll("mulledwineext", "mulledwineext")
end;
private.use_mulledwineext_beg = function()
  ObjDelete( "gfx_ovenext_mulledwineext_zone" );
end;
private.use_mulledwineext_end = function()
  ObjSet( "spr_dressingroomext_hotmulledwineext", {visible = 1} );
  ObjSet( "anm_ovenext_anim_glint", {animfunc = "take_wine", frame = 0 } );
  if common_impl.ZzCompleteCheck("use_mulledwineext") then ObjSet( common_impl.hint["use_mulledwineext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_mulledwineext", private.use_mulledwineext_inv );
cmn.AddSubscriber( "use_mulledwineext", private.use_mulledwineext_beg, private.room_objname );
cmn.AddSubscriber( "use_mulledwineext", private.use_mulledwineext_end, private.room_objname );
cmn.AddSubscriber( "use_mulledwineext", private.use_mulledwineext_logic );
cmn.AddSubscriber( "use_mulledwineext_inv", private.use_mulledwineext_inv, private.room_objname );
cmn.AddSubscriber( "use_mulledwineext_beg", private.use_mulledwineext_beg, private.room_objname );
cmn.AddSubscriber( "use_mulledwineext_end", private.use_mulledwineext_end, private.room_objname );
cmn.AddSubscriber( "use_mulledwineext_end", private.use_mulledwineext_logic );
--------------------------------------------------------------------------------------------
function public.use_mulledwineext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_mulledwineext" );
    cmn.CallEventHandler( "use_mulledwineext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_mulledwineext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_mulledwineext_inv" );
  cmn.CallEventHandler( "use_mulledwineext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ovenext_anim_glint", "use_wine", func_end );
  SoundSfx( "aud_use_mulledwineext_dressingroomext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_christmasspotholderext" ] = { type = "use", inv_obj = "inv_christmasspotholderext", use_place = "gfx_ovenext_christmasspotholderext_zone", room = "rm_dressingroomext", zz = "zz_ovenext", zz_gate = "gzz_dressingroomext_ovenext" };

private.use_christmasspotholderext_logic = function()
  ObjSet( "spr_ovenext_hotmulledwineext", { visible = 1, input = 1, active = 1 } )

end;
private.use_christmasspotholderext_inv = function()
  common_impl.ProcessMultiUseAll("christmasspotholderext", "christmasspotholderext")
end;
private.use_christmasspotholderext_beg = function()
  ObjDelete( "gfx_ovenext_christmasspotholderext_zone" );
end;
private.use_christmasspotholderext_end = function()
  ObjDelete("anm_ovenext_anim_glint")
  ObjDelete("spr_dressingroomext_hotmulledwineext")
  ObjSet( "spr_dressingroomext_hotmulledwineext_out", {visible = 1} );
  if common_impl.ZzCompleteCheck("use_christmasspotholderext") then ObjSet( common_impl.hint["use_christmasspotholderext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_christmasspotholderext", private.use_christmasspotholderext_inv );
cmn.AddSubscriber( "use_christmasspotholderext", private.use_christmasspotholderext_beg, private.room_objname );
cmn.AddSubscriber( "use_christmasspotholderext", private.use_christmasspotholderext_end, private.room_objname );
cmn.AddSubscriber( "use_christmasspotholderext", private.use_christmasspotholderext_logic );
cmn.AddSubscriber( "use_christmasspotholderext_inv", private.use_christmasspotholderext_inv, private.room_objname );
cmn.AddSubscriber( "use_christmasspotholderext_beg", private.use_christmasspotholderext_beg, private.room_objname );
cmn.AddSubscriber( "use_christmasspotholderext_end", private.use_christmasspotholderext_end, private.room_objname );
cmn.AddSubscriber( "use_christmasspotholderext_end", private.use_christmasspotholderext_logic );
--------------------------------------------------------------------------------------------
function public.use_christmasspotholderext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_christmasspotholderext" );
    cmn.CallEventHandler( "use_christmasspotholderext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_christmasspotholderext") then ld.CloseSubRoom() end;
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_christmasspotholderext_inv" );
  cmn.CallEventHandler( "use_christmasspotholderext_beg" );
  common_impl.Lock(1);

  ld.AnimPlay( "anm_ovenext_anim_glint", "take_wine", func_end );
  SoundSfx( "aud_use_christmasspotholderext_dressingroomext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_hotmulledwineext" ] = { type = "get", get_obj = "spr_ovenext_hotmulledwineext", room = "rm_dressingroomext", zz = "zz_ovenext", zz_gate = "gzz_dressingroomext_ovenext" };

private.get_hotmulledwineext_logic = function()
  
end;
private.get_hotmulledwineext_inv = function()
  interface.InventoryItemAdd("inv_hotmulledwineext","spr_ovenext_hotmulledwineext");
end;
private.get_hotmulledwineext_beg = function()
  ObjDelete("gfx_ovenext_hotmulledwineext")
end;
private.get_hotmulledwineext_end = function()
  ObjDelete("spr_dressingroomext_hotmulledwineext_out")
  if common_impl.ZzCompleteCheck("get_hotmulledwineext") then ObjSet( common_impl.hint["get_hotmulledwineext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_hotmulledwineext", private.get_hotmulledwineext_inv );
cmn.AddSubscriber( "get_hotmulledwineext", private.get_hotmulledwineext_beg, private.room_objname );
cmn.AddSubscriber( "get_hotmulledwineext", private.get_hotmulledwineext_end, private.room_objname );
cmn.AddSubscriber( "get_hotmulledwineext", private.get_hotmulledwineext_logic );
--------------------------------------------------------------------
function public.get_hotmulledwineext()
  cmn.SetEventDone( "get_hotmulledwineext" );
  cmn.CallEventHandler( "get_hotmulledwineext" );
  if common_impl.ZzCompleteCheck("get_hotmulledwineext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_mannequinext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------
common_impl.hint[ "get_amuletthreadsext" ] = { type = "get", get_obj = "spr_mannequinext_amuletthreadsext", room = "rm_dressingroomext", zz = "zz_mannequinext", zz_gate = "gzz_dressingroomext_mannequinext" };

private.get_amuletthreadsext_logic = function()
  
end;
private.get_amuletthreadsext_inv = function()
  interface.InventoryItemAdd("inv_amuletthreadsext","spr_mannequinext_amuletthreadsext");
end;
private.get_amuletthreadsext_beg = function()
  ObjDelete("gfx_mannequinext_amuletthreadsext")
end;
private.get_amuletthreadsext_end = function()
  ObjDelete("spr_dressingroomext_amuletthreadsext")
  ObjDelete("spr_mannequinext_amuletthreadsext_sh")
  if common_impl.ZzCompleteCheck("get_amuletthreadsext") then ObjSet( common_impl.hint["get_amuletthreadsext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_amuletthreadsext", private.get_amuletthreadsext_inv );
cmn.AddSubscriber( "get_amuletthreadsext", private.get_amuletthreadsext_beg, private.room_objname );
cmn.AddSubscriber( "get_amuletthreadsext", private.get_amuletthreadsext_end, private.room_objname );
cmn.AddSubscriber( "get_amuletthreadsext", private.get_amuletthreadsext_logic );
--------------------------------------------------------------------
function public.get_amuletthreadsext()
  cmn.SetEventDone( "get_amuletthreadsext" );
  cmn.CallEventHandler( "get_amuletthreadsext" );
  if common_impl.ZzCompleteCheck("get_amuletthreadsext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_fairywithscissorsext" ] = { type = "use", inv_obj = "inv_fairywithscissorsext", use_place = "gfx_mannequinext_fairywithscissorsext_zone", room = "rm_dressingroomext", zz = "zz_mannequinext", zz_gate = "gzz_dressingroomext_mannequinext" };

private.use_fairywithscissorsext_logic = function()
  ObjSet( "gmg_dressingroomext_laceext", { visible = 1, input = 1, active = 1 } )

end;
private.use_fairywithscissorsext_inv = function()
  common_impl.ProcessMultiUseAll("fairywithscissorsext", "fairywithscissorsext")
end;
private.use_fairywithscissorsext_beg = function()
  ObjDelete( "gfx_mannequinext_fairywithscissorsext_zone" );
end;
private.use_fairywithscissorsext_end = function()
  ObjDelete("vid_dressingroomext_vid_static_laces")
  ObjSet( "spr_dressingroomext_fairy_loc", {visible = 1} );
  ObjDelete("spr_dressingroomext_mmg_tr")
  ObjSet( "anm_mannequinext_anim", {animfunc = "open_mg", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_fairywithscissorsext") then ObjSet( common_impl.hint["use_fairywithscissorsext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_fairywithscissorsext", private.use_fairywithscissorsext_inv );
cmn.AddSubscriber( "use_fairywithscissorsext", private.use_fairywithscissorsext_beg, private.room_objname );
cmn.AddSubscriber( "use_fairywithscissorsext", private.use_fairywithscissorsext_end, private.room_objname );
cmn.AddSubscriber( "use_fairywithscissorsext", private.use_fairywithscissorsext_logic );
cmn.AddSubscriber( "use_fairywithscissorsext_inv", private.use_fairywithscissorsext_inv, private.room_objname );
cmn.AddSubscriber( "use_fairywithscissorsext_beg", private.use_fairywithscissorsext_beg, private.room_objname );
cmn.AddSubscriber( "use_fairywithscissorsext_end", private.use_fairywithscissorsext_end, private.room_objname );
cmn.AddSubscriber( "use_fairywithscissorsext_end", private.use_fairywithscissorsext_logic );
--------------------------------------------------------------------------------------------
function public.use_fairywithscissorsext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_fairywithscissorsext" );
    cmn.CallEventHandler( "use_fairywithscissorsext_end" );
    common_impl.Lock(0);
    ld.CloseSubRoom()
    common_impl.Gate_MDown( "gmg_dressingroomext_laceext" )
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_fairywithscissorsext_inv" );
  cmn.CallEventHandler( "use_fairywithscissorsext_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_fairywithscissorsext_dressingroomext" )
  --func_end()
  ObjAttach("vid_mannequinext_fairy_mannequin_136","zz_mannequinext")
  VidPlay("vid_mannequinext_fairy_mannequin_136",function() ObjAnimate( "vid_mannequinext_vid_static", 8, 0, 0, function() 
    SoundSfx( "aud_start_mannequinext" )
    ld.AnimPlay( "anm_mannequinext_anim", "open_mg", func_end )
  end, {0,0,1, 0.5,0,0, 1,0,0} ); end)
end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS ZZ zz_wardrobeext *** () end
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_lockpickext" ] = { type = "use", inv_obj = "inv_lockpickext", use_place = "gfx_wardrobeext_lockpickext_zone", room = "rm_dressingroomext", zz = "zz_wardrobeext", zz_gate = "gzz_dressingroomext_wardrobeext" };

private.use_lockpickext_logic = function()
  ObjSet( "gfx_wardrobeext_win_wardrobeext1_zone", { visible = 1, input = 1, active = 1 } )

end;
private.use_lockpickext_inv = function()
  common_impl.ProcessMultiUseAll("lockpickext", "lockpickext")
end;
private.use_lockpickext_beg = function()
  ObjDelete( "gfx_wardrobeext_lockpickext_zone" );
end;
private.use_lockpickext_end = function()
  public.win_wardrobeext1_load();
  ObjSet( "obj_wardrobeext_logic_case_creator_root", {alp=1, input = 1 } );
  if common_impl.ZzCompleteCheck("use_lockpickext") then ObjSet( common_impl.hint["use_lockpickext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_lockpickext", private.use_lockpickext_inv );
cmn.AddSubscriber( "use_lockpickext", private.use_lockpickext_beg, private.room_objname );
cmn.AddSubscriber( "use_lockpickext", private.use_lockpickext_end, private.room_objname );
cmn.AddSubscriber( "use_lockpickext", private.use_lockpickext_logic );
cmn.AddSubscriber( "use_lockpickext_inv", private.use_lockpickext_inv, private.room_objname );
cmn.AddSubscriber( "use_lockpickext_beg", private.use_lockpickext_beg, private.room_objname );
cmn.AddSubscriber( "use_lockpickext_end", private.use_lockpickext_end, private.room_objname );
cmn.AddSubscriber( "use_lockpickext_end", private.use_lockpickext_logic );
--------------------------------------------------------------------------------------------
function public.use_lockpickext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_lockpickext" );
    cmn.CallEventHandler( "use_lockpickext_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("use_lockpickext") then ld.CloseSubRoom() end;
    interface.ButtonHintHide();
    interface.ButtonSkipShow();
    interface.ButtonSkipReload(1);
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_lockpickext_inv" );
  cmn.CallEventHandler( "use_lockpickext_beg" );
  common_impl.Lock(1);

  ObjAnimate( "obj_wardrobeext_logic_case_creator_root", 8, 0, 0, function() func_end() end, {0,0,0, 0.5,0,1} );
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_use_lockpickext_dressingroomext" );
  --func_end()

end;
--------------------------------------------------------------------------------------------
function public.win_wardrobeext1_hint()
  for i = 1,2 do
    local alpha = ObjGet("spr_wardrobeext_otmychka"..i.."_light").alp
    if alpha~=1 then
      local name = "spr_wardrobeext_otmychka"..i
      common_impl.HintShowAnm(name)
      break;
    end
  end
end
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_wardrobeext1" ] = { type = "click", use_place = "gfx_wardrobeext_win_wardrobeext1_zone", room = "rm_dressingroomext", zz = "zz_wardrobeext", zz_gate = "gzz_dressingroomext_wardrobeext", hint = public.win_wardrobeext1_hint };

private.win_wardrobeext1_logic = function()
  ObjSet( "spr_wardrobeext_skiext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "spr_wardrobeext_piniatabatext", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_wardrobeext_bearext_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_wardrobeext_penguinext_zone", { visible = 1, input = 1, active = 1 } )
  ObjSet( "gfx_wardrobeext_bunnyext_zone", { visible = 1, input = 1, active = 1 } )

end;
private.win_wardrobeext1_beg = function()
  ObjDelete( "gfx_wardrobeext_win_wardrobeext1_zone" );
end;
private.win_wardrobeext1_end = function()
  ObjDelete("obj_wardrobeext_logic_case_creator_root")
  ObjDelete("anm_wardrobeext_anim_door")
  ObjSet( "spr_dressingroomext_opened_wardrobe", {visible = 1} );
  ObjSet( "spr_dressingroomext_snowmaidenext2", {visible = 1} );
  ObjSet( "spr_dressingroomext_toothpicksext", {visible = 1} );
  ObjSet( "spr_dressingroomext_skiext", {visible = 1} );
  ObjSet( "spr_dressingroomext_piniatabatext", {visible = 1} );
  ObjSet( "spr_dressingroomext_mmg", {visible = 1} );
  if common_impl.ZzCompleteCheck("win_wardrobeext1") then ObjSet( common_impl.hint["win_wardrobeext1"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_wardrobeext1", private.win_wardrobeext1_beg, private.room_objname );
cmn.AddSubscriber( "win_wardrobeext1", private.win_wardrobeext1_end, private.room_objname );
cmn.AddSubscriber( "win_wardrobeext1", private.win_wardrobeext1_logic );
cmn.AddSubscriber( "win_wardrobeext1_beg", private.win_wardrobeext1_beg, private.room_objname );
cmn.AddSubscriber( "win_wardrobeext1_end", private.win_wardrobeext1_end, private.room_objname );
cmn.AddSubscriber( "win_wardrobeext1_end", private.win_wardrobeext1_logic );
--------------------------------------------------------------------------------------------
function public.win_wardrobeext1()

  local func_end = function()
    cmn.SetEventDone( "win_wardrobeext1" );
    cmn.CallEventHandler( "win_wardrobeext1_end" );
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck("win_wardrobeext1") then ld.CloseSubRoom() end;
  end;

  cmn.CallEventHandler( "win_wardrobeext1_beg" );
  common_impl.Lock(1);
  
  interface.ButtonSkipHide();
  interface.ButtonHintShow();
  --ld.AnimPlay( "", "", func_end );
  SoundSfx( "aud_open_closet" )
  --func_end()
  ObjAnimate( "obj_wardrobeext_logic_case_creator_root", 8, 0, 0, function() 
    ld.AnimPlay( "anm_wardrobeext_anim_door", "open_door", func_end )
  end, {0,0,1, 0.3,0,1, 0.8,0,0} );
  --ld.LogTrace( "Error: Реализуй кастом хинт! win_wardrobeext1" );

end;
--------------------------------------------------------------------------------------------
function public.win_wardrobeext1_load()

  local current = 0;
  local offset = {math.pi/2, -math.pi/2};
  local win = {-2,0.9}
  local wintolerance = 0.05;
  local workarea = {{-2000,-40},{40,2000}}
  local limits = {{-2.66, -0.7},{0.7,2.66}}
  local wincheckData = {false, false}

  function public.win_wardrobeext1_lockpick(n)

    --ld.LogTrace( n );
    current = n
    ObjSet( "obj_wardrobeext_otmychka"..current.."_arrows", {alp=1} );
    ObjStartDrag("obj_wardrobeext_drag_lockpick");
    SoundSfx( "aud_clk_bell" )
  end
  local function wincheck()
    local count = 0;
    for i,o in ipairs(wincheckData) do
      if o then
        count = count+1;
      end
    end
    if count == #wincheckData then
      public.win_wardrobeext1()
    end
  end
  
  function public.win_wardrobeext1_drag()
    
    local xy = GetObjPosByObj("obj_wardrobeext_drag_lockpick", "obj_wardrobeext_lockpick_base_"..current )
    --ld.LogTrace( xy[1] );

    if ld.Math.InBorders( xy[1], workarea[current] ) then

      local angle = math.atan(xy[1], xy[2])
      --ld.LogTrace( "drag", angle );
      if ld.Math.InBorders( angle, limits[current] ) then

          if ld.Math.InBorders( angle, {win[current]-wintolerance,win[current]+wintolerance} ) then
            if ObjGet( "spr_wardrobeext_otmychka"..current.."_light" ).alp == 0 and not ObjGet( "tmr_win_wardrobeext1_drag" ) then
              SoundSfx( "aud_lockpicker_shines" )
              ld.StartTimer( "tmr_win_wardrobeext1_drag", 0.2, function()  end )
            end
            ObjSet( "spr_wardrobeext_otmychka"..current.."_light", {alp = 1} );
            wincheckData[current] = true
          else
            wincheckData[current] = false
            ObjSet( "spr_wardrobeext_otmychka"..current.."_light", {alp = 0} );
          end
          ObjSet( "obj_wardrobeext_lockpick_"..current, {ang = angle+offset[current]} );

      end

    end

  end

  function public.win_wardrobeext1_drop()
    wincheck()
    ObjSet( "obj_wardrobeext_otmychka"..current.."_arrows", {alp=0} );
  end

  ObjSet( "spr_wardrobeext_otmychka1", { event_mdown = function() public.win_wardrobeext1_lockpick(1) end } );
  ObjSet( "spr_wardrobeext_otmychka2", { event_mdown = function() public.win_wardrobeext1_lockpick(2) end } );
  ObjSet( "obj_wardrobeext_drag_lockpick", { event_drag = function() public.win_wardrobeext1_drag() end, 
  event_dragdrop = function() public.win_wardrobeext1_drop() end} );

end
--------------------------------------------------------------------
common_impl.hint[ "get_skiext" ] = { type = "get", get_obj = "spr_wardrobeext_skiext", room = "rm_dressingroomext", zz = "zz_wardrobeext", zz_gate = "gzz_dressingroomext_wardrobeext" };

private.get_skiext_logic = function()
  
end;
private.get_skiext_inv = function()
  interface.InventoryItemAdd("inv_skiext","spr_wardrobeext_skiext");
end;
private.get_skiext_beg = function()
  ObjDelete("gfx_wardrobeext_skiext")
end;
private.get_skiext_end = function()
  ObjDelete("spr_dressingroomext_skiext")
  ObjDelete("spr_wardrobeext_skiext_shadow")
  if common_impl.ZzCompleteCheck("get_skiext") then ObjSet( common_impl.hint["get_skiext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_skiext", private.get_skiext_inv );
cmn.AddSubscriber( "get_skiext", private.get_skiext_beg, private.room_objname );
cmn.AddSubscriber( "get_skiext", private.get_skiext_end, private.room_objname );
cmn.AddSubscriber( "get_skiext", private.get_skiext_logic );
--------------------------------------------------------------------
function public.get_skiext()
  cmn.SetEventDone( "get_skiext" );
  cmn.CallEventHandler( "get_skiext" );
  if common_impl.ZzCompleteCheck("get_skiext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_piniatabatext" ] = { type = "get", get_obj = "spr_wardrobeext_piniatabatext", room = "rm_dressingroomext", zz = "zz_wardrobeext", zz_gate = "gzz_dressingroomext_wardrobeext" };

private.get_piniatabatext_logic = function()
  
end;
private.get_piniatabatext_inv = function()
  interface.InventoryItemAdd("inv_piniatabatext","spr_wardrobeext_piniatabatext");
end;
private.get_piniatabatext_beg = function()
  ObjDelete("gfx_wardrobeext_piniatabatext")
end;
private.get_piniatabatext_end = function()
  ObjDelete("spr_dressingroomext_piniatabatext")
  if common_impl.ZzCompleteCheck("get_piniatabatext") then ObjSet( common_impl.hint["get_piniatabatext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_piniatabatext", private.get_piniatabatext_inv );
cmn.AddSubscriber( "get_piniatabatext", private.get_piniatabatext_beg, private.room_objname );
cmn.AddSubscriber( "get_piniatabatext", private.get_piniatabatext_end, private.room_objname );
cmn.AddSubscriber( "get_piniatabatext", private.get_piniatabatext_logic );
--------------------------------------------------------------------
function public.get_piniatabatext()
  cmn.SetEventDone( "get_piniatabatext" );
  cmn.CallEventHandler( "get_piniatabatext" );
  if common_impl.ZzCompleteCheck("get_piniatabatext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bearext" ] = { type = "use", inv_obj = "inv_bearext", use_place = "gfx_wardrobeext_bearext_zone", room = "rm_dressingroomext", zz = "zz_wardrobeext", zz_gate = "gzz_dressingroomext_wardrobeext" };

private.use_bearext_logic = function()
  if ld.CheckRequirements( {"use_bearext","use_penguinext","use_bunnyext"} ) then
    ObjSet( "gfx_wardrobeext_win_wardrobeext2_zone", { visible = 1, input = 1, active = 1 } )
    ld.mmgZoomInit("win_wardrobeext2");
  end;

end;
private.use_bearext_inv = function()
  common_impl.ProcessMultiUseAll("bearext", "bearext")
end;
private.use_bearext_beg = function()
  ObjDelete( "gfx_wardrobeext_bearext_zone" );
end;
private.use_bearext_end = function()
  ObjDelete("spr_wardrobeext_anim_door_mmg_hh_bear")
  ObjSet( "anm_wardrobeext_anim_door_bear", {animfunc = "use_bear", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_bearext") then ObjSet( common_impl.hint["use_bearext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bearext", private.use_bearext_inv );
cmn.AddSubscriber( "use_bearext", private.use_bearext_beg, private.room_objname );
cmn.AddSubscriber( "use_bearext", private.use_bearext_end, private.room_objname );
cmn.AddSubscriber( "use_bearext", private.use_bearext_logic );
cmn.AddSubscriber( "use_bearext_inv", private.use_bearext_inv, private.room_objname );
cmn.AddSubscriber( "use_bearext_beg", private.use_bearext_beg, private.room_objname );
cmn.AddSubscriber( "use_bearext_end", private.use_bearext_end, private.room_objname );
cmn.AddSubscriber( "use_bearext_end", private.use_bearext_logic );
--------------------------------------------------------------------------------------------
function public.use_bearext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bearext" );
    cmn.CallEventHandler( "use_bearext_end" );
    common_impl.Lock(0);
    ObjSet( "anm_wardrobeext_anim_door_bear", {pos_z = 1} );
    if common_impl.ZzCompleteCheck("use_bearext") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_bunnyext","use_bearext","use_penguinext"} ) then
      public.win_wardrobeext2_load()
      ObjGet( "gfx_wardrobeext_win_wardrobeext2_zone" ).event_mdown()
    end
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bearext_inv" );
  cmn.CallEventHandler( "use_bearext_beg" );
  common_impl.Lock(1);
  ObjSet( "anm_wardrobeext_anim_door_bear", {pos_z = 1.1} );
  ld.AnimPlay( "anm_wardrobeext_anim_door_bear", "use_bear", func_end );
  SoundSfx( "aud_use_bearext_dressingroomext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_penguinext" ] = { type = "use", inv_obj = "inv_penguinext", use_place = "gfx_wardrobeext_penguinext_zone", room = "rm_dressingroomext", zz = "zz_wardrobeext", zz_gate = "gzz_dressingroomext_wardrobeext" };

private.use_penguinext_logic = function()
  if ld.CheckRequirements( {"use_penguinext","use_bearext","use_bunnyext"} ) then
    ObjSet( "gfx_wardrobeext_win_wardrobeext2_zone", { visible = 1, input = 1, active = 1 } )
    ld.mmgZoomInit("win_wardrobeext2");
  end;

end;
private.use_penguinext_inv = function()
  common_impl.ProcessMultiUseAll("penguinext", "penguinext")
end;
private.use_penguinext_beg = function()
  ObjDelete( "gfx_wardrobeext_penguinext_zone" );
end;
private.use_penguinext_end = function()
  ObjDelete("spr_wardrobeext_anim_door_mmg_hh_pinguin")
  ObjSet( "anm_wardrobeext_anim_door_pinguin", {animfunc = "use_pinguin", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_penguinext") then ObjSet( common_impl.hint["use_penguinext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_penguinext", private.use_penguinext_inv );
cmn.AddSubscriber( "use_penguinext", private.use_penguinext_beg, private.room_objname );
cmn.AddSubscriber( "use_penguinext", private.use_penguinext_end, private.room_objname );
cmn.AddSubscriber( "use_penguinext", private.use_penguinext_logic );
cmn.AddSubscriber( "use_penguinext_inv", private.use_penguinext_inv, private.room_objname );
cmn.AddSubscriber( "use_penguinext_beg", private.use_penguinext_beg, private.room_objname );
cmn.AddSubscriber( "use_penguinext_end", private.use_penguinext_end, private.room_objname );
cmn.AddSubscriber( "use_penguinext_end", private.use_penguinext_logic );
--------------------------------------------------------------------------------------------
function public.use_penguinext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_penguinext" );
    cmn.CallEventHandler( "use_penguinext_end" );
    common_impl.Lock(0);
    ObjSet( "anm_wardrobeext_anim_door_pinguin", {pos_z = 1} );
    if common_impl.ZzCompleteCheck("use_penguinext") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_bunnyext","use_bearext","use_penguinext"} ) then
      public.win_wardrobeext2_load()
      ObjGet( "gfx_wardrobeext_win_wardrobeext2_zone" ).event_mdown()
    end
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_penguinext_inv" );
  cmn.CallEventHandler( "use_penguinext_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_wardrobeext_anim_door_pinguin", {pos_z = 1.1} );
  ld.AnimPlay( "anm_wardrobeext_anim_door_pinguin", "use_pinguin", func_end );
  SoundSfx( "aud_use_bearext_dressingroomext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_bunnyext" ] = { type = "use", inv_obj = "inv_bunnyext", use_place = "gfx_wardrobeext_bunnyext_zone", room = "rm_dressingroomext", zz = "zz_wardrobeext", zz_gate = "gzz_dressingroomext_wardrobeext" };

private.use_bunnyext_logic = function()
  if ld.CheckRequirements( {"use_bunnyext","use_bearext","use_penguinext"} ) then
    ObjSet( "gfx_wardrobeext_win_wardrobeext2_zone", { visible = 1, input = 1, active = 1 } )
    ld.mmgZoomInit("win_wardrobeext2");
  end;

end;
private.use_bunnyext_inv = function()
  common_impl.ProcessMultiUseAll("bunnyext", "bunnyext")
end;
private.use_bunnyext_beg = function()
  ObjDelete( "gfx_wardrobeext_bunnyext_zone" );
end;
private.use_bunnyext_end = function()
  ObjDelete("spr_wardrobeext_anim_door_mmg_hh_hare")
  ObjSet( "anm_wardrobeext_anim_door_hare", {animfunc = "use_hare", frame = 999 } );
  if common_impl.ZzCompleteCheck("use_bunnyext") then ObjSet( common_impl.hint["use_bunnyext"].zz_gate, { visible = 0, input = 0 } ); end;
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_bunnyext", private.use_bunnyext_inv );
cmn.AddSubscriber( "use_bunnyext", private.use_bunnyext_beg, private.room_objname );
cmn.AddSubscriber( "use_bunnyext", private.use_bunnyext_end, private.room_objname );
cmn.AddSubscriber( "use_bunnyext", private.use_bunnyext_logic );
cmn.AddSubscriber( "use_bunnyext_inv", private.use_bunnyext_inv, private.room_objname );
cmn.AddSubscriber( "use_bunnyext_beg", private.use_bunnyext_beg, private.room_objname );
cmn.AddSubscriber( "use_bunnyext_end", private.use_bunnyext_end, private.room_objname );
cmn.AddSubscriber( "use_bunnyext_end", private.use_bunnyext_logic );
--------------------------------------------------------------------------------------------
function public.use_bunnyext( obj )

  local func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_bunnyext" );
    cmn.CallEventHandler( "use_bunnyext_end" );
    common_impl.Lock(0);
    ObjSet( "anm_wardrobeext_anim_door_hare", {pos_z = 1} );
    if common_impl.ZzCompleteCheck("use_bunnyext") then ld.CloseSubRoom() end;
    if ld.CheckRequirements( {"use_bunnyext","use_bearext","use_penguinext"} ) then
      public.win_wardrobeext2_load()
      ObjGet( "gfx_wardrobeext_win_wardrobeext2_zone" ).event_mdown()
    end
  end;

  ObjSet(obj,{visible = 0});
  cmn.CallEventHandler( "use_bunnyext_inv" );
  cmn.CallEventHandler( "use_bunnyext_beg" );
  common_impl.Lock(1);

  ObjSet( "anm_wardrobeext_anim_door_hare", {pos_z = 1.1} );
  ld.AnimPlay( "anm_wardrobeext_anim_door_hare", "use_hare", func_end );
  SoundSfx( "aud_use_bearext_dressingroomext" )
  --func_end()

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "win_wardrobeext2" ] = { type = "click", use_place = "gfx_wardrobeext_win_wardrobeext2_zone", room = "rm_dressingroomext", zz = "zz_wardrobeext", zz_gate = "gzz_dressingroomext_wardrobeext" };

private.win_wardrobeext2_logic = function()
  if ld.CheckRequirements( {"win_wardrobeext2"} ) then
    ObjSet( "spr_wardrobeext_toothpicksext", { visible = 1, input = 1, active = 1 } )
    ObjSet( "spr_wardrobeext_snowmaidenext2", { visible = 1, input = 1, active = 1 } )
  end
end;
private.win_wardrobeext2_beg = function(force)
  if ld.CheckRequirements( {"win_wardrobeext2"} ) or force then
    ObjDelete( "gfx_wardrobeext_win_wardrobeext2_zone" );
    ObjDelete("spr_wardrobeext_cover_begin") 
    ObjDelete("anm_wardrobeext_anim_door_pinguin")
    ObjDelete("anm_wardrobeext_anim_door_hare")
    ObjDelete("anm_wardrobeext_anim_door_bear")
  end
end;
private.win_wardrobeext2_end = function()
  if ld.CheckRequirements( {"win_wardrobeext2"} ) then
    ObjDelete("spr_dressingroomext_mmg")
    if common_impl.ZzCompleteCheck("win_wardrobeext2") then ObjSet( common_impl.hint["win_wardrobeext2"].zz_gate, { visible = 0, input = 0 } ); end;
  end
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "win_wardrobeext2", private.win_wardrobeext2_beg, private.room_objname );
cmn.AddSubscriber( "win_wardrobeext2", private.win_wardrobeext2_end, private.room_objname );
cmn.AddSubscriber( "win_wardrobeext2", private.win_wardrobeext2_logic );
cmn.AddSubscriber( "win_wardrobeext2_beg", private.win_wardrobeext2_beg, private.room_objname );
cmn.AddSubscriber( "win_wardrobeext2_end", private.win_wardrobeext2_end, private.room_objname );
cmn.AddSubscriber( "win_wardrobeext2_end", private.win_wardrobeext2_logic );
--------------------------------------------------------------------------------------------
function public.win_wardrobeext2()

  local func_end = function()
    cmn.SetEventDone( "win_wardrobeext2" );
    cmn.CallEventHandler( "win_wardrobeext2_end" );
    common_impl.Lock(0);
    ObjDelete("anm_wardrobeext_anim_door_mmg")
    if common_impl.ZzCompleteCheck("win_wardrobeext2") then ld.CloseSubRoom() end;
  end;

  private.win_wardrobeext2_beg(true)
  --cmn.CallEventHandler( "win_wardrobeext2_beg" );
  common_impl.Lock(1);
  ObjSet( "anm_wardrobeext_anim_door_mmg", {visible = 1} );
  ld.AnimPlay( "anm_wardrobeext_anim_door_mmg", "open_mmg", func_end );
  SoundSfx( "aud_win_wardrobe" )
  ObjGet( "obj_wardrobeext_win_wardrobeext2_zoom" ).event_mdown()
  cmn.MiniGameHide( "wardrobeext2", true );
  

end;
--------------------------------------------------------------------------------------------
local win_wardrobeext2_loaded = false
local win_wardrobeext2_childs = ObjGetRelations( "obj_wardrobeext_win_wardrobeext2_food" ).childs;
function public.win_wardrobeext2_load(reset,skip)
  local nosfx = true;
  local animtime = 0.5
  --small
  local radius = 52;
  local childs = win_wardrobeext2_childs;

  local bigradius = 108;

  local ang_step = 2*math.pi/#childs

  local begstate = {small = 0, big = 0, check = {}}
  local winstate = {small = 0, big = -ang_step, check = 
                    {
                      "sugar",
                      "mushroom",
                      "fish",
                      "carrort",
                      "icecream",
                      "nut"
                    }
                    }  
  
  if not ng_global.progress["ext"]["win_wardrobeext2"].state or reset then
    ng_global.progress["ext"]["win_wardrobeext2"].state = ld.TableCopy(begstate)
  end

  local function light()
    local lights = ObjGetRelations( "obj_wardrobeext_win_wardrobeext2_lights" ).childs
    local alps = {}
    for i,o in ipairs(lights) do
      alps[o]= ObjGet( o ).alp
      ObjSet( o, {alp = 0 } );
    end
    local sfx = false
    for i,o in ipairs(ng_global.progress["ext"]["win_wardrobeext2"].state.check) do
      local index = (i+#childs-#ng_global.progress["ext"]["win_wardrobeext2"].state.check-2)%#childs+1;
      if #childs == #ng_global.progress["ext"]["win_wardrobeext2"].state.check then
        index = i;
      end
      local inplace = winstate.check[index];
      --ld.LogTrace( o , inplace );
      if o == inplace and alps[ lights[index] ] ~= 1 then
        sfx = "aud_clk_kid_or_santa"
      end
      ObjSet(lights[index],{alp = o == inplace and 1 or 0})
    end
    if sfx and not nosfx then
      SoundSfx( sfx )
    end
    nosfx = false
  end

  local function load_map(skip)
    if not win_wardrobeext2_loaded then
      local events = {input = 1, event_menter = function() ld.ShCur(CURSOR_HAND) end, event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end}
      ObjSet( "spr_wardrobeext_small_wheel", { event_mdown = function() public.win_wardrobeext2_small() end} );
      ObjSet( "spr_wardrobeext_big_wheel", { event_mdown = function() public.win_wardrobeext2_big() end} );
      ObjSet( "spr_wardrobeext_small_wheel", events );
      ObjSet( "spr_wardrobeext_big_wheel", events );
      for i,o in ipairs(childs) do
        ObjCreate("obj_wardrobeext_small_wheel_"..i,"obj")
        ObjAttach("obj_wardrobeext_small_wheel_"..i, "spr_wardrobeext_small_wheel")
        ObjAttach(o,"obj_wardrobeext_small_wheel_"..i)
        local angle = -ang_step*(i-1);
        ObjSet( o, {pos_x = 0, pos_y = 0} );
        ObjSet( "obj_wardrobeext_small_wheel_"..i, {pos_x = radius * math.sin(angle), pos_y = -radius * math.cos(angle)} );

        ObjCreate("obj_wardrobeext_big_wheel_"..i,"obj")
        ObjAttach("obj_wardrobeext_big_wheel_"..i, "spr_wardrobeext_big_wheel")
        --ld.CopyObj(o, o.."_big", "spr", "obj_wardrobeext_big_wheel_"..i)
        ObjSet( "obj_wardrobeext_big_wheel_"..i, {pos_x = bigradius * math.sin(angle), pos_y = bigradius * math.cos(angle)} );
      end
      for i,o in ipairs(ObjGetRelations( "obj_wardrobeext_win_wardrobeext2_lights" ).childs) do
        ObjSet( o, {blendmode = 2, alp = 0} );
      end
    end

    local toload = skip and winstate or ng_global.progress["ext"]["win_wardrobeext2"].state

    local smallangle = toload["small"]*ang_step;
    local bigangle = toload["big"]*ang_step;
    ObjSet( "spr_wardrobeext_small_wheel", {ang = smallangle} );
    ObjSet( "spr_wardrobeext_big_wheel", {ang = bigangle} );
    for i,o in ipairs(childs) do
      ObjAttach(o,"obj_wardrobeext_small_wheel_"..i)
      ObjSet( "obj_wardrobeext_small_wheel_"..i, {ang = -smallangle} );
      ObjSet( "obj_wardrobeext_big_wheel_"..i, {ang = -bigangle} );
    end

    for i,o in ipairs(toload.check) do
      --ObjAttach("spr_wardrobeext_"..o,"obj_wardrobeext_big_wheel_"..(i%#childs+1))
      ObjAttach("spr_wardrobeext_"..o,"obj_wardrobeext_big_wheel_"..i)
    end
    if not skip then
      light()
    end
    win_wardrobeext2_loaded = true
  end

  --wincheck
  local prevstate
  local function wincheck(skip)
    local function win()
      public.win_wardrobeext2()
    end
    if ld.TableEquals(ng_global.progress["ext"]["win_wardrobeext2"].state.check,winstate.check) or skip then
      if not skip then
        ng_global.progress["ext"]["win_wardrobeext2"].state = ld.TableCopy(prevstate)
      end
      ld.Lock(1)

      local lights = ObjGetRelations( "obj_wardrobeext_win_wardrobeext2_lights" ).childs
      local function func_end()
        local time = 1;
        local step = time/3
        ld.StartTimer( step, function() SoundSfx( "aud_clk_kid_or_santa" ) end )
        for i,o in ipairs(lights) do
          ObjAnimate( o, 8, 0, 0, function() end, {0,3,1, step,3,0, 2*step,3,1, 3*step,3,0} );
        end
        ld.StartTimer( time, function() win() end )
      end
      if skip then
        SoundSfx( "aud_clk_kid_or_santa" )
        for i,o in ipairs(lights) do
          ObjAnimate( o, 8, 0, 0, function() end, {0,0,ObjGet(o).alp, 0.5,0,1} );
        end
        ld.StartTimer( 0.5, function() func_end() end )
      else
        func_end()
      end
      
      
      return true;
    end
    
    return false;
  end

  --load
  local function load(skip)
    load_map(skip)
  end
  local function chooseload(reset,skip)
    if reset or skip then
      local toload = skip and winstate or begstate
      local time = animtime
      ld.Lock(1)
      local function func_end()  
        ld.Lock(0)
        wincheck(skip)
      end
      local function func_step()
        load(skip)
        for i,o in ipairs(childs) do
          ObjAnimate( o, 8, 0, 0, function() end, {0,0,0, time,0,1} );
        end
        ld.StartTimer( time, func_end )
      end   

          
      ld.StartTimer( time, function() 
        SoundSfx( "aud_wheel_turn" )
      end )

      local angbig = ld.AngCloser( ObjGet("spr_wardrobeext_big_wheel").ang, 0 )
      local angsmall = ld.AngCloser( ObjGet("spr_wardrobeext_small_wheel").ang, 0 )
      ObjAnimate( "spr_wardrobeext_big_wheel", 7, 0, 0, function() end, {0,0,angbig, time,0,angbig, 2*time,0,toload["big"]} );
      ObjAnimate( "spr_wardrobeext_small_wheel", 7, 0, 0, function() end, {0,0,angsmall, time,0,angsmall, 2*time,0,toload["small"]} );
      for i,o in ipairs(childs) do
        ObjAnimate( o, 8, 0, 0, function() end, {0,0,1, time,0,0} );
      end
      
      ld.StartTimer( 2*time, func_step )
    else
      load()
    end
  end
  chooseload(reset,skip)
  --save
  local function save(param, moved)
    prevstate = ld.TableCopy(ng_global.progress["ext"]["win_wardrobeext2"].state)

    if moved then
      local savedata = ld.StringDivide(moved)[3];
      table.insert(ng_global.progress["ext"]["win_wardrobeext2"].state.check,savedata)
    end
    
    if param then
      ng_global.progress["ext"]["win_wardrobeext2"].state[param] = (ng_global.progress["ext"]["win_wardrobeext2"].state[param] + 1)%#childs
    end

    light()

    if #ng_global.progress["ext"]["win_wardrobeext2"].state.check == #childs then
      if not wincheck() then
        public.win_wardrobeext2_load(1)
      end
    end
  end  

  --public
  function public.win_wardrobeext2_big()
    local time = animtime;
    local state = ng_global.progress["ext"]["win_wardrobeext2"].state;
    local moved = childs[ (#childs - state["small"])%#childs + 1 ]
    --ObjAnimate( moved, 6, 0, 0, function() end, {0,0,1,1, time/2,0,1.3,1.3, time,0,1,1} );
    local source = #ObjGetRelations( "obj_wardrobeext_small_wheel_"..((#childs - state["small"])%#childs + 1) ).childs
    if source == 0 then return end
    
    --ObjAnimate( "obj_wardrobeext_big_wheel_"..((#childs - state["big"])%#childs + 1), 6, 0, 0, function() end, {0,0,1,1, time/2,0,1.3,1.3, time,0,1,1} );
    


    ld.Lock(1)

    local root = "obj_wardrobeext_win_wardrobeext2_zoom_block"
    local parent1 = ObjGetRelations( moved ).parent
    local parent2 = "obj_wardrobeext_big_wheel_"..((state["big"])%#childs + 1)

    local function func_end()  
      ObjAttach(moved,parent2);
      ObjSet( moved, {pos_x = 0, pos_y = 0} );

      if #state.check == #childs-1 then
        ld.Lock(0)
        save(false, moved)
        return;
      end
      SoundSfx( "aud_wheel_turn" )
      local curang = ObjGet("spr_wardrobeext_big_wheel").ang;
      ObjAnimate( "spr_wardrobeext_big_wheel", 7, 0, 0, function() ld.Lock(0) save("big", moved) end, {0,0,curang, time,0,curang+ang_step} );
      for i,o in ipairs(childs) do
        local childang = ObjGet("obj_wardrobeext_big_wheel_"..i).ang
        ObjAnimate( "obj_wardrobeext_big_wheel_"..i, 7, 0, 0, function() end, {0,0,childang, time,0,childang-ang_step} );
      end
    end
    SoundSfx( "aud_replace_element" )
    local pos1 = GetObjPosByObj(parent1,root)
    local pos2 = GetObjPosByObj(parent2,root)
    ObjSet( moved, {pos_z = 100 } );
    ObjAttach(moved, root)
    ObjAnimate( moved, 3, 0, 0, func_end, {0,0,pos1[1],pos1[2], time,3,pos2[1],pos2[2]} );
    ObjAnimate( moved, 6, 0, 0, "", {0,0,1,1, time/2,0,1.2,1.2, time,0,1,1} );

  end

  function public.win_wardrobeext2_small()
    local time = animtime;
    local curang = ObjGet("spr_wardrobeext_small_wheel").ang;
    ld.Lock(1)
    SoundSfx( "aud_wheel_turn" )
    ObjAnimate( "spr_wardrobeext_small_wheel", 7, 0, 0, function() ld.Lock(0) save("small") end, {0,0,curang, time,0,curang+ang_step} );
    for i,o in ipairs(childs) do
      local childang = ObjGet("obj_wardrobeext_small_wheel_"..i).ang
      ObjAnimate( "obj_wardrobeext_small_wheel_"..i, 7, 0, 0, function() end, {0,0,childang, time,0,childang-ang_step} );
    end
  end

  function public.win_wardrobeext2_click(sender)
    local time = animtime
    ld.Lock(1)
    ld.StartTimer( time, function() ld.Lock(0) save() end )
   end
end
--------------------------------------------------------------------
common_impl.hint[ "get_toothpicksext" ] = { type = "get", get_obj = "spr_wardrobeext_toothpicksext", room = "rm_dressingroomext", zz = "zz_wardrobeext", zz_gate = "gzz_dressingroomext_wardrobeext" };

private.get_toothpicksext_logic = function()
  
end;
private.get_toothpicksext_inv = function()
  interface.InventoryItemAdd("inv_toothpicksext","spr_wardrobeext_toothpicksext");
end;
private.get_toothpicksext_beg = function()
  ObjDelete("gfx_wardrobeext_toothpicksext")
end;
private.get_toothpicksext_end = function()
  ObjDelete("spr_dressingroomext_toothpicksext")
  if common_impl.ZzCompleteCheck("get_toothpicksext") then ObjSet( common_impl.hint["get_toothpicksext"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_toothpicksext", private.get_toothpicksext_inv );
cmn.AddSubscriber( "get_toothpicksext", private.get_toothpicksext_beg, private.room_objname );
cmn.AddSubscriber( "get_toothpicksext", private.get_toothpicksext_end, private.room_objname );
cmn.AddSubscriber( "get_toothpicksext", private.get_toothpicksext_logic );
--------------------------------------------------------------------
function public.get_toothpicksext()
  cmn.SetEventDone( "get_toothpicksext" );
  cmn.CallEventHandler( "get_toothpicksext" );
  if common_impl.ZzCompleteCheck("get_toothpicksext") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_snowmaidenext2" ] = { type = "get", get_obj = "spr_wardrobeext_snowmaidenext2", room = "rm_dressingroomext", zz = "zz_wardrobeext", zz_gate = "gzz_dressingroomext_wardrobeext" };

private.get_snowmaidenext2_logic = function()
  
end;
private.get_snowmaidenext2_inv = function()
  interface.InventoryItemAdd("inv_snowmaidenext2","spr_wardrobeext_snowmaidenext2");
end;
private.get_snowmaidenext2_beg = function()
  ObjDelete("gfx_wardrobeext_snowmaidenext2")
end;
private.get_snowmaidenext2_end = function()
  ObjDelete("spr_dressingroomext_snowmaidenext2")
  if common_impl.ZzCompleteCheck("get_snowmaidenext2") then ObjSet( common_impl.hint["get_snowmaidenext2"].zz_gate, { visible = 0, input = 0 } ); end;
end;

cmn.AddSubscriber( "get_snowmaidenext2", private.get_snowmaidenext2_inv );
cmn.AddSubscriber( "get_snowmaidenext2", private.get_snowmaidenext2_beg, private.room_objname );
cmn.AddSubscriber( "get_snowmaidenext2", private.get_snowmaidenext2_end, private.room_objname );
cmn.AddSubscriber( "get_snowmaidenext2", private.get_snowmaidenext2_logic );
--------------------------------------------------------------------
function public.get_snowmaidenext2()
  cmn.SetEventDone( "get_snowmaidenext2" );
  cmn.CallEventHandler( "get_snowmaidenext2" );
  if common_impl.ZzCompleteCheck("get_snowmaidenext2") then ld.CloseSubRoom() end;
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
  local get_dresslaceext_for_dressingroomext = function()
    ObjSet( "gmg_dressingroomext_laceext", {input = 0, visible = 0} );
    ObjSet( "spr_dressingroomext_no_laces", {visible = 1} );
  end;
  cmn.AddSubscriber("get_dresslaceext", get_dresslaceext_for_dressingroomext, private.room_objname )

  local win_laceext_for_dressingroomext = function()
    if ld.CheckRequirements( {"win_laceext"} ) then
      ObjDelete("spr_dressingroomext_fairy_loc")
    end
  end;
  cmn.AddSubscriber("win_laceext", win_laceext_for_dressingroomext, private.room_objname )

function public.Reset()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();

  if ( mg_name == "zz_wardrobeext" ) then
    public.win_wardrobeext2_load(1);
  end

end;
function public.Skip()
  local mg_name = common.GetCurrentSubRoom() or common.GetCurrentRoom();
    
  if ( mg_name == "zz_wardrobeext" ) then
    if (cmn.IsEventDone("use_lockpickext") and not cmn.IsEventDone("win_wardrobeext1")) then
      public.win_wardrobeext1();
    else
      public.win_wardrobeext2_load(nil,1);
    end;
  end

end;

end;
--*********************************************************************************************************************
function public.Load()
end;
--*********************************************************************************************************************
function public.Open()
  private.opn_dressingroomext();
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_dressroom_env" );
end;
--*********************************************************************************************************************
function public.Close()
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
function private.InitZz()

  subroom.Define( "zz_wardrobeext" );
  function zz_wardrobeext.Open()
  end;
  function zz_wardrobeext.PreOpen()
    if ld.CheckRequirements( {"use_penguinext","use_bearext","use_bunnyext"} ) and not ld.CheckRequirements( {"win_wardrobeext2"} ) then
      public.win_wardrobeext2_load();
    end
    if (cmn.IsEventDone("use_lockpickext") and not cmn.IsEventDone("win_wardrobeext1")) then
      interface.ButtonHintHide();
      interface.ButtonSkipShow();
    end;
  end;
  function zz_wardrobeext.PreClose()
    if (cmn.IsEventDone("use_lockpickext") and not cmn.IsEventDone("win_wardrobeext1")) then
      interface.ButtonSkipHide();
      interface.ButtonHintShow();
    end;
  end;
  function zz_wardrobeext.Close()
  end;

  subroom.Define( "zz_mannequinext" );
  function zz_mannequinext.Open()
    --if not ld.CheckRequirements( {"dlg_dressingroomext_fairyext2"} ) then
    --  public.dlg_dressingroomext_fairyext2( obj )
    --end
  end;
  function zz_mannequinext.PreOpen()
  end;
  function zz_mannequinext.PreClose()
  end;
  function zz_mannequinext.Close()
  end;

  subroom.Define( "zz_ovenext" );
  function zz_ovenext.Open()
  end;
  function zz_ovenext.PreOpen()
  end;
  function zz_ovenext.PreClose()
  end;
  function zz_ovenext.Close()
  end;

  subroom.Define( "zz_bustext" );
  function zz_bustext.Open()
  end;
  function zz_bustext.PreOpen()
  end;
  function zz_bustext.PreClose()
  end;
  function zz_bustext.Close()
  end;
  
end;
--*********************************************************************************************************************