-- name=ho_prizesextscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------------
  room.Define( "prizesextscr" );
  game.relations[ "ho_prizesextscr" ].exitroom = "rm_nearcastleext";
 
  private.TASK_COLOR_R = 0.918;
  private.TASK_COLOR_G = 0.671;
  private.TASK_COLOR_B = 0.278;
  
  private.abc = {};
  private.abc[1]  = "aaa";
  private.abc[2]  = "bbb";
  private.abc[3]  = "ccc";
  private.abc[4]  = "ddd";
  private.abc[5]  = "eee";
  private.abc[6]  = "fff";
  private.abc[7]  = "ggg";
  private.abc[8]  = "hhh";
  private.abc[9]  = "iii";
  private.abc[10] = "jjj";
  private.abc[11] = "kkk";
  private.abc[12] = "lll";
  
  private.abc2num = {};
  private.abc2num["aaa"]  = 1;
  private.abc2num["bbb"]  = 2;
  private.abc2num["ccc"]  = 3;
  private.abc2num["ddd"]  = 4;
  private.abc2num["eee"]  = 5;
  private.abc2num["fff"]  = 6;
  private.abc2num["ggg"]  = 7;
  private.abc2num["hhh"]  = 8;
  private.abc2num["iii"]  = 9;
  private.abc2num["jjj"] = 10;
  private.abc2num["kkk"] = 11;
  private.abc2num["lll"] = 12;
  
  private.angs = {}
  private.angs[1] = {1.35,-1.31};
  private.angs[2] = {0.94,-0.82};
  --private.angs[3] = {1.36,-1.21};
  private.angs[3] = {1.31, -0.7};
  
  private.act = {}
  private.act[1] = {}; private.act[1][1] = {"ddd","fff","bbb"}; private.act[1][2] = {"aaa","fff","ccc"};       private.act[1][3] = {"aaa","ccc"}; private.act[1][4] = {"ddd","bbb"};
  private.act[2] = {}; private.act[2][1] = {"eee","hhh"};       private.act[2][2] = {"eee","ggg"};             private.act[2][3] = {"ggg"};       private.act[2][4] = {"hhh"};
  private.act[3] = {}; private.act[3][1] = {"lll","iii"};       private.act[3][2] = {"jjj","kkk"};             private.act[3][3] = {"jjj","kkk"}; private.act[3][4] = {"iii","lll"};
  
  
--------------------------------------------------------------------------------------------------
  common_impl.hint[ "win_prizesextscr" ] = { type = "win", room = "rm_nearcastleext", zz = "ho_prizesextscr", zz_gate = "gho_nearcastleext_prizesextscr" };
 
  local win_prizesextscr_func = function ()

    if ( cmn.IsEventDone( "win_prizesextscr" ) ) then
      interface.InventoryItemAdd( "inv_cupidext2", "spr_prizesextscr_win" );
      ObjDelete( "gho_nearcastleext_prizesextscr" );
    end;

  end;
  cmn.AddSubscriber( "win_prizesextscr", win_prizesextscr_func );
  
  local start_prizesextscr_func = function ()
  if not cmn.IsEventDone("win_prizesextscr") then
  
  end
  end;
  cmn.AddSubscriber( "win_prizesextscr", start_prizesextscr_func, "ho_prizesextscr" );  

end;
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.PreOpen()

  SoundEnv( "aud_mansion_env" )

  if ( not cmn.IsEventDone( "opn_prizesextscr" ) ) then

    
    ng_global.progress["scr"]["win_prizesextscr"].state = {};
    ng_global.progress["scr"]["win_prizesextscr"].state[1]=1;
    ng_global.progress["scr"]["win_prizesextscr"].state[2]=2;
    ng_global.progress["scr"]["win_prizesextscr"].state[3]=1;
    
    cmn.InitHo( "prizesextscr" );
    cmn.SetEventDone( "opn_prizesextscr" );
 
  end;

  local ho_items = {};

  interface.TaskPanelTaskAdd( ho_items, "aaa",          1, 0, { { "spr_prizesextscr_aaa","spr_prizesextscr_ggg" } });
  interface.TaskPanelTaskAdd( ho_items, "bbb",          1, 0, { { "spr_prizesextscr_bbb","spr_prizesextscr_hhh" } } );
  interface.TaskPanelTaskAdd( ho_items, "ccc",          1, 0, { { "spr_prizesextscr_ccc","spr_prizesextscr_iii" } } );
  interface.TaskPanelTaskAdd( ho_items, "ddd",          1, 0, { { "spr_prizesextscr_ddd","spr_prizesextscr_jjj" } } );
  interface.TaskPanelTaskAdd( ho_items, "eee",          1, 0, { { "spr_prizesextscr_eee","spr_prizesextscr_kkk" } } );
  interface.TaskPanelTaskAdd( ho_items, "fff",          1, 0, { { "spr_prizesextscr_fff","spr_prizesextscr_lll" } } );
  --interface.TaskPanelTaskAdd( ho_items, "ggg",          1, 0, { { "spr_prizesextscr_ggg" } } );
  --interface.TaskPanelTaskAdd( ho_items, "hhh",          1, 0, { { "spr_prizesextscr_hhh" } } );
  --interface.TaskPanelTaskAdd( ho_items, "iii",          1, 0, { { "spr_prizesextscr_iii" } } );
  --interface.TaskPanelTaskAdd( ho_items, "jjj",          1, 0, { { "spr_prizesextscr_jjj" } } );
  --interface.TaskPanelTaskAdd( ho_items, "kkk",          1, 0, { { "spr_prizesextscr_kkk" } } );
  --interface.TaskPanelTaskAdd( ho_items, "lll",          1, 0, { { "spr_prizesextscr_lll" } } );
  interface.TaskPanelTaskAdd( ho_items, "mmm",          1, 0, { { "spr_prizesextscr_mmm" } } );
  
  SoundHoTheme( true );
  interface.TaskPanelShow( ho_items );
  int_taskpanel_impl.HideTextPanel( "prizesextscr" );
  
  for n=1,3 do
    local name = "spr_prizesextscr_"..n;
    ObjSet(name,{
      input=1;
    })
    ObjSet("spr_prizesextscr_focus_"..n,{
      event_mdown = function() private.setDrum(n); end;
      event_menter = function() private.drumLightOn(n); end; 
      event_mleave = function() private.drumLightOff(n); end; 
      input=1;
    })  
    local state = ng_global.progress["scr"]["win_prizesextscr"].state[n];
    ObjSet(name,{ang = private.angs[n][ state ]});
    local act1 = private.act[n][state]
    for s=1,#act1 do
      ObjSet("spr_prizesextscr_"..act1[s],{input=1})
    end
    local act2 = private.act[n][state+2]
    for s=1,#act2 do
      ObjSet("spr_prizesextscr_"..act2[s],{input=0})
    end
  end
  
  for n=1,6 do
    local name = "spr_prizesextscr_"..private.abc[n];
    ObjSet(name,{event_mdown = function() private.event_mdown(private.abc[n],private.abc[n]); end;
      event_menter = function() ld.ShCur(NULL); end;
      event_mleave = function() ld.ShCur(NULL); end;
      inputrect_init = true;
      inputrect_x = -60;
      inputrect_y = -55;
      inputrect_w = 122;
      inputrect_h = 115;
    });
    local name2 = "spr_prizesextscr_"..private.abc[n+6];
    ObjSet(name2,{event_mdown = function() private.event_mdown(private.abc[n],private.abc[n+6]); end;
      event_menter = function() ld.ShCur(NULL); end;
      event_mleave = function() ld.ShCur(NULL); end;
      inputrect_init = true;
      inputrect_x = -60;
      inputrect_y = -55;
      inputrect_w = 122;
      inputrect_h = 115;
    });  
  end
  
  ObjSet("spr_prizesextscr_mmm",{event_mdown = function() private.event_mdown_mmm() end})
  
  
  
  
  private.count = 0;
  for j = 1, #ng_global.progress["scr"]["win_prizesextscr"].found do
    local name = tostring( ng_global.progress["scr"]["win_prizesextscr"].found[j]["object"] );
    ObjDelete( name );
    private.count = private.count + 1;
    
    local task_name = tostring( ng_global.progress["scr"]["win_prizesextscr"].found[j]["task"] );
    for n=1,6 do
      if private.abc[n] == task_name then
        local name = "spr_prizesextscr_"..private.abc[n+6];
        ObjDelete(name);
      end
    end
    
  end;
  private.setCount();
  
  private.k = (872-587)/786;
  private.b = 587;
  
  if private.count == 6 then
    for n=1,3 do
      ObjSet("spr_prizesextscr_focus_"..n,{input=0});
    end
    ObjSet("spr_prizesextscr_1",{ang=-2.55});
    ObjSet("spr_prizesextscr_st",{visible=1,active=1});
    ObjSet("spr_prizesextscr_mmm",{visible=1,active=1,input=1});
  end
  
  ld.ShCur(NULL);
end;
--*********************************************************************************************************************
private.crossbow = "anm_prizesextscr_cr"
private.aim = "spr_prizesextscr_aim";
function public.Open()
  ObjStopAnimate("obj_prizesextscr_1_to_hint",7)
  private.aimMoving()
end
--*********************************************************************************************************************
function private.aimMoving()
  if not private.shooting then
    local curs = GetZoomCursorPos();
    local obj = ObjGet(GetCurrentRoom());
    local scale = { obj.scale_x, obj.scale_y };
    local pos = { obj.pos_x, obj.pos_y};
    curs[1] = curs[1]/scale[1] - pos[1]/scale[1];
    curs[2] = curs[2]/scale[2] - pos[2]/scale[2];
    ObjSet(private.aim,{pos_x=curs[1],pos_y=curs[2]});
    ObjSet(private.crossbow,{pos_x=curs[1], pos_y = private.k*curs[2] + private.b })
  end
  ObjAnimate("obj_prizesextscr_1_to_hint", 7, 0, 0, private.aimMoving, {0,0,0, 0,0,0});
end
--*********************************************************************************************************************
function public.PreClose()
  SoundHoTheme( false );
  interface.TaskPanelHide();
  ObjStopAnimate("obj_prizesextscr_1_to_hint",7)
  --ObjDelete("tmr_prizesextscr_aim_moving");
end;
--*********************************************************************************************************************
function public.Close()
  int_taskpanel_impl.ShowTextPanel( "prizesextscr" );
  ld.ShCur( CURSOR_DEFAULT );
end;
--*********************************************************************************************************************
function public.HoComplete()

  --common_impl.PlayAudio("sfx","common/audio/aud_ho_win");
   
end;
--*********************************************************************************************************************
function public.ItemFound( item_name )

end;
--*********************************************************************************************************************
--*********************************************************************************************************************
--------------------------------------------------------------------------------------------
function private.TaskComplete( task_name )
  
  local parent1 = ObjGetRelations("spr_prizesextscr_"..task_name).parent;
  local parent2 = ObjGetRelations(parent1).parent;
  ObjSet( "spr_prizesextscr_"..task_name, { pos_z = 1, ang = ObjGet(parent2).ang + ObjGet(parent1).ang } );
  cmn.HoTaskFind( "spr_prizesextscr_"..task_name, task_name );
  
  for n=1,6 do
    if private.abc[n] == task_name then
      local name = "spr_prizesextscr_"..private.abc[n+6];
      private.sparkle(name);
      ObjSet(name,{input=0})
      ObjAnimate(name, 8, 0, 0, function()
        ObjSet(name,{visible=0})
        ObjDelete(name);
      end, {0,0,1, 0.5,0,0});
    end
  end
  
  private.count = private.count + 1;
  private.setCount();
  
  if private.count == 6 then
    
    local func_end = function()
      for n=1,3 do
        ObjSet("spr_prizesextscr_focus_"..n,{input=0});
      end
      ObjSet("spr_prizesextscr_mmm",{visible=1,active=1,input=1});
      ld.Lock(0);
    end
    
    local o = ObjGet("spr_prizesextscr_1");
    SoundSfx( "aud_clk_target" )
    if o.ang>0 then
      ObjAnimate("spr_prizesextscr_1", 7, 0, 0, func_end, {0,0,o.ang,  0.6,0,-2.55});
      ObjSet("spr_prizesextscr_st",{visible=1,active=1});
      ObjSet("spr_prizesextscr_mmm",{visible=1,active=1});
    else
      
      ObjAnimate("spr_prizesextscr_1", 7, 0, 0, func_end, {0,0,o.ang,  0.3,0,0,   0.6,0,6.28-2.55});
      ld.StartTimer( 0.3,
        function()
          ObjSet("spr_prizesextscr_st",{visible=1,active=1});
          ObjSet("spr_prizesextscr_mmm",{visible=1,active=1});
        end
       )
        
    end
  end
  
end;
---------------------------------------------------------------------------------------------
-----------------------------------------------

function private.GetItem( name )
  
  --ld.PlayAudio("sfx","common/audio/aud_get_item");

end;

--------------------------------------------------------------------------------
function private.setCount()
  if private.count < 6 then
    ObjSet("txt_prizesextscr_taskpanel",{param0=private.count})
  else
    local task_color_r = private.TASK_COLOR_R;
    local task_color_g = private.TASK_COLOR_G;
    local task_color_b = private.TASK_COLOR_B;
    ObjSet("txt_prizesextscr_taskpanel",{text="pop_inv_cupidext2",
      color_r = task_color_r,
      color_g = task_color_g,
      color_b = task_color_b,
    })
  end
end
--------------------------------------------------------------------------------
function private.setDrum(pos)
  ld.Lock(1);
  
  ld.ShCur(NULL);
  
  local t = 0.5;
  local drum = "spr_prizesextscr_"..pos;
  local stateStart = ng_global.progress["scr"]["win_prizesextscr"].state[pos];
  local stateEnd = 2;
  if stateStart == 2 then
    stateEnd = 1;
  end
  local angStart = private.angs[pos][stateStart];
  local angEnd   = private.angs[pos][stateEnd];
  
  local func_end = function()  
    
    local act1     = private.act[pos][stateEnd]
    for s=1,#act1 do
      ObjSet("spr_prizesextscr_"..act1[s],{input=1})
    end
    local act2     = private.act[pos][stateEnd+2]
    for s=1,#act2 do
      ObjSet("spr_prizesextscr_"..act2[s],{input=0})
      
      if private.objPrevious then
        if act2[s] == private.objPrevious then
          ObjSet("spr_prizesextscr_"..act2[s].."_focus",{alp=0})
          private.objPrevious="none";
          private.keyPrevious="none";
        end
      end
      
    end
    
    ng_global.progress["scr"]["win_prizesextscr"].state[pos]=stateEnd;
    ld.Lock(0);
    ld.ShCur(NULL);
  end
  SoundSfx( "aud_clk_target" )
  ObjAnimate(drum, 7, 0, 0, func_end, {0,0, angStart, t,0,angEnd});
end
--------------------------------------------------------------------------------
private.keyPrevious = "none";
private.objPrevious = "none"
function private.event_mdown(key,obj)
  
  local func_end = function()
   
    local releaseLock = true;
    
    if private.keyPrevious=="none" then
      private.keyPrevious = key;
      private.objPrevious = obj;
      ObjSet("spr_prizesextscr_"..obj.."_focus",{alp=1})
    else
      if (private.keyPrevious == key) and (private.objPrevious ~= obj) then
        private.TaskComplete( key )
        
        if private.count == 6 then
          releaseLock=false;
        end
        
        local obj1 = "spr_prizesextscr_"..obj.."_focus"
        ObjAnimate(obj1, 8, 0, 0, _, {0,0,ObjGet(obj1).alp, 0.3,0,0});
        local obj2 = "spr_prizesextscr_"..private.objPrevious.."_focus"
        ObjAnimate(obj2, 8, 0, 0, _, {0,0,ObjGet(obj2).alp, 0.3,0,0});
      end
      private.keyPrevious = "none";
      private.objPrevious = "none"
    end
    
    
    
    private.shooting=false;
    ld.ShCur(NULL);
    
    if releaseLock then
      ld.Lock(0);
    end
  end
  
  local o = ObjGet("spr_prizesextscr_arrow");
  
  --Перезарядка
  local func_step_2 = function()
    local t2 = 0.4;
    ObjSet("spr_prizesextscr_arrow",{alp=1});
    ObjAnimate("spr_prizesextscr_arrow", 1, 0, 0, _, {0,0,(-141+300),    t2*0.5,0,-141});
    ObjAnimate("spr_prizesextscr_arrow", 6, 0, 0, _, {0,0,1.4,1.4,       t2*0.5,0,1.5,1.5,     t2*0.8,2,1,1});
    ld.StartTimer(t2,func_end)
  end
  
  --Попадение стрелы - она исчезает
  local func_step_1 = function()
    
    local spark1 = "anm_prizesextscr_spark_1"
    for m=1,5 do
      spark1 = "anm_prizesextscr_spark_"..m;
      if not ObjGet(spark1).playing then
        break;
      end
    end
    local pos = GetObjPosByObj("spr_prizesextscr_"..obj);
    ObjSet(spark1,{pos_x = pos[1],pos_y = pos[2],visible=1,active=1});
    ld.AnimPlay(spark1,"anim_part",_);
    ObjAnimate("spr_prizesextscr_arrow", 8, 0, 0, func_step_2, {0,0,1,   0.3,0,0});
    
    if private.keyPrevious ~= key and private.keyPrevious ~= "none" then
      SoundSfx( "aud_wrong_1" )
      ObjAnimate("spr_prizesextscr_"..obj.."_focus", 8,0,0, _, {0,0,0, 0.15,0,1,  0.3,0,0,  0.45,0,1,  0.6,0,0});
      ObjAnimate("spr_prizesextscr_"..private.objPrevious.."_focus", 8,0,0, _, {0,0,0, 0.15,0,1,  0.3,0,0,  0.45,0,1,  0.6,0,0});
    end
    
    if ((private.keyPrevious == key) and (private.objPrevious ~= obj)) or private.objPrevious == "none" then
      ObjSet("spr_prizesextscr_"..obj.."_focus",{alp=1})
      ObjSet("spr_prizesextscr_"..private.objPrevious.."_focus",{alp=1})
    end
    
    if private.objPrevious == obj then
      ObjSet("spr_prizesextscr_"..obj.."_focus",{alp=0})
      ObjSet("spr_prizesextscr_"..private.objPrevious.."_focus",{alp=0})
    end
    
  end
  
  ld.Lock(1);
  ld.ShCur(NULL);
  private.shooting = true;
  
  --Выстрел стрелы
  local speed = 2000;
  local posEnd = GetObjPosByObj("spr_prizesextscr_"..obj,private.crossbow);
  local xEnd = posEnd[1];
  local yEnd = posEnd[2];
  local t = (o.pos_y - yEnd)/speed;
  ObjAnimate("spr_prizesextscr_arrow", 1, 0, 0, func_step_1, {0,0,o.pos_y,  t,0,yEnd});
  ld.AnimPlay(private.crossbow,"anim_arbalet", _);
  SoundSfx( "aud_shot" )
  
end




--------------------------------------------------------------------------------
function private.event_mdown_mmm()
  
  local key = "mmm"
  local obj = "mmm"
  
  local func_end = function()   
    
  --local parent1 = ObjGetRelations("spr_prizesextscr_"..task_name).parent;
  --local parent2 = ObjGetRelations(parent1).parent;
  --ObjSet( "spr_prizesextscr_"..task_name, { pos_z = 1, ang = ObjGet(parent2).ang + ObjGet(parent1).ang } );
  --cmn.HoTaskFind( "spr_prizesextscr_"..task_name, task_name );
    local ang0 = ObjGet("spr_prizesextscr_mmm").ang;
    local parent1 = ObjGetRelations("spr_prizesextscr_mmm").parent;
    local parent2 = ObjGetRelations(parent1).parent;
    ObjSet( "spr_prizesextscr_mmm", { pos_z = 1, ang = ang0 + ObjGet(parent1).ang } );
    cmn.HoTaskFind( "spr_prizesextscr_mmm", "mmm" );
    
    private.shooting=false;
    ld.Lock(0);
    
  end
  
  local o = ObjGet("spr_prizesextscr_arrow");
  
  --Перезарядка
  local func_step_2 = function()
    local t2 = 0.4;
    ObjSet("spr_prizesextscr_arrow",{alp=1});
    ObjAnimate("spr_prizesextscr_arrow", 1, 0, 0, _, {0,0,(-141+300),    t2*0.5,0,-141});
    ObjAnimate("spr_prizesextscr_arrow", 6, 0, 0, _, {0,0,1.4,1.4,       t2*0.5,0,1.5,1.5,     t2*0.8,2,1,1});
    ld.StartTimer(t2,func_end)
  end
  
  --Попадение стрелы - она исчезает
  local func_step_1 = function()
    
    local spark1 = "anm_prizesextscr_spark_1"
    for m=1,5 do
      spark1 = "anm_prizesextscr_spark_"..m;
      if not ObjGet(spark1).playing then
        break;
      end
    end
    local pos = GetObjPosByObj("spr_prizesextscr_"..obj);
    ObjSet(spark1,{pos_x = pos[1],pos_y = pos[2],visible=1,active=1});
    ld.AnimPlay(spark1,"anim_part",_);
    ObjAnimate("spr_prizesextscr_arrow", 8, 0, 0, func_step_2, {0,0,1,   0.3,0,0});
    
  end
  
  ld.Lock(1);
  ld.ShCur(NULL);
  private.shooting = true;
  
  --Выстрел стрелы
  SoundSfx( "aud_shot" )
  local speed = 2000;
  local posEnd = GetObjPosByObj("spr_prizesextscr_"..obj,private.crossbow);
  local xEnd = posEnd[1];
  local yEnd = posEnd[2];
  local t = (o.pos_y - yEnd)/speed;
  ObjAnimate("spr_prizesextscr_arrow", 1, 0, 0, func_step_1, {0,0,o.pos_y,  t,0,yEnd});
  ld.AnimPlay(private.crossbow,"anim_arbalet", _);
  
end
--------------------------------------------------------------------------------


-- simple effect from HO -------------------------------------------------------
function private.sparkle(object_name)
  local collect_name  = "pfx_int_taskpanel_collect_"..object_name;
  ObjDelete( collect_name );
  ObjCreate( collect_name, "partsys" );
  
  ObjSet( collect_name,{
    res = "assets/interface/resources/effects_ho",
    pos_x = 0, pos_y = 0,
    active = 1, visible = 1, input = 0, pos_z = 32, blendmode = 2;
  });
  local parent = ObjGetRelations(object_name).parent
  ObjAttach( collect_name, parent );
  PartSysSetMaskObj( collect_name, object_name );  
  ld.StartTimer( 5, function() ObjDelete( collect_name ) end )
end
-- simple effect from HO -------------------------------------------------------
function private.drumLightOn(pos)
  ld.ShCur(NULL);
  local t = 0.3;
  local drum = "spr_prizesextscr_focus_"..pos;
  ObjStopAnimate(drum,8)
  ObjAnimate(drum, 8,0,0, _, {0,0,ObjGet(drum).alp, t,0,1});
end
function private.drumLightOff(pos)
  ld.ShCur(NULL);
  local t = 0.3;
  local drum = "spr_prizesextscr_focus_"..pos;
  ObjStopAnimate(drum,8)
  ObjAnimate(drum, 8,0,0, _, {0,0,ObjGet(drum).alp, t,0,0});
end
--------------------------------------------------------------------------------


---------------------------------------------------------------------------
function private.HintShow(hint_obj_name)
  local hints_table = { hint = {} };
  local pos = GetObjPosByObj(hint_obj_name); 
  table.insert( hints_table.hint,  { ["pos_x"]=pos[1], ["pos_y"]=pos[2], ["obj_name"]=hint_obj_name } )   
  MsgSend( Command_Effect_ShowHoHint, hints_table );
  --ld.LogTrace(hint_obj_name)
end
----------------------------------------------------------------------------
function public.clk_hint()
  
  if private.count == 6 then
    private.HintShow("spr_prizesextscr_mmm")
  else
  
  local rnd = math.random(1,6);
  local doit = true;
  local count=0;
  while doit do
    
    local name1 = "spr_prizesextscr_"..private.abc[rnd];
    local name2 = "spr_prizesextscr_"..private.abc[rnd+6];
    
    if ObjGet(name1) and ObjGet(name2) then
    if ObjGet(name1).input and ObjGet(name2).input then
      private.HintShow(name1)
      private.HintShow(name2)
      doit=false;
      break;
    end
    end
    
    count=count+1;
    rnd = rnd + 1;
    if rnd>6 then
      rnd=1;
    end
    if count>6 then

      
      local stage1 = true;
      
      for s=1,12 do
        local name_s = "spr_prizesextscr_"..private.abc[s];
        
        if ObjGet(name_s) then
          if ObjGet(name_s).input then
            
            
            local offset = 6;
            if s<=6 then
              offset=6;
            else
              offset=-6;
            end
            local name_s2 = "spr_prizesextscr_"..private.abc[s+offset];
            
            if ObjGet(name_s2) then
              private.HintShow(name_s);
              stage1=false;
              if ObjGet(name_s2).input then
                
                private.HintShow(name_s2);
              else
                
                private.ObjToHint(name_s2)
                
              end
            end
            
            break;
            
          end
        end
        
      end
      
      
      
      
      if stage1 then
        for s=1,6 do
          local name_s = "spr_prizesextscr_"..private.abc[s];
          local name_s2 = "spr_prizesextscr_"..private.abc[s+6];
          if ObjGet(name_s) and ObjGet(name_s2) then
            
            if ObjGet(name_s).alp>0 and ObjGet(name_s2).alp>0 then
              
              private.ObjToHint(name_s);
              private.ObjToHint(name_s2);
              
              break;
            end
            
          end
        end
      end
      
      
      
      
      doit=false;
      break;
    end
  end
  
  end
  
end
----------------------------------------------------------------------------
function private.ObjToHint(name_s2)
  
  if ObjGet(name_s2).input then
    private.HintShow(name_s2)
  else
    local parent1 = ObjGetRelations(name_s2).parent
    local parent2 = ObjGetRelations(parent1).parent
    local v=1;
    if parent2=="spr_prizesextscr_1" then
      v=1;
    end
    if parent2=="spr_prizesextscr_2" then
      v=2;
    end
    if parent2=="spr_prizesextscr_3" then
      v=3;
    end
    private.HintShow("obj_prizesextscr_"..v.."_to_hint");
  end
  
end
