-- name=mg_fightscr
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_fightscr";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_fightscr" ] = {type = "win", use_place = "mg_fightscr", room = "rm_newyard", zz = "mg_fightscr", zz_gate = "gmg_newyard_fightscr" };

  local win_fightscr_logic = function()
    if ld.CheckRequirements( {"win_fightscr"} ) then
      
    end
  end;
  local win_fight = function()
    if ld.CheckRequirements( {"win_fightscr"} ) then
      ObjDelete( "obj_fightscr_mg_root" )
    end
  end;
  cmn.AddSubscriber("win_fightscr", win_fight, private.room_objname )
  cmn.AddSubscriber("win_fightscr", win_fightscr_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_vidonopenfight" ] = { type = "click", use_place = "gfx_fightscr_clk_vidonopenfight_zone", room = "rm_newyard", zz = "mg_fightscr", zz_gate = "gmg_newyard_fightscr" };

private.clk_vidonopenfight_logic = function()

end;
private.clk_vidonopenfight_beg = function()
  ObjDelete( "gfx_fightscr_clk_vidonopenfight_zone" );
end;
private.clk_vidonopenfight_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_vidonopenfight", private.clk_vidonopenfight_beg, private.room_objname );
cmn.AddSubscriber( "clk_vidonopenfight", private.clk_vidonopenfight_end, private.room_objname );
cmn.AddSubscriber( "clk_vidonopenfight", private.clk_vidonopenfight_logic );
cmn.AddSubscriber( "clk_vidonopenfight_beg", private.clk_vidonopenfight_beg, private.room_objname );
cmn.AddSubscriber( "clk_vidonopenfight_end", private.clk_vidonopenfight_end, private.room_objname );
cmn.AddSubscriber( "clk_vidonopenfight_end", private.clk_vidonopenfight_logic );
--------------------------------------------------------------------------------------------
function public.clk_vidonopenfight()

  local func_end = function()
    func_end = nil
    ld.SetWidgetsVisible( "DialogVideoShow", true );
    ObjSet( "mg_fightscr", { color_r = 1; color_g = 1; color_b = 1; } )
    int.DialogVideoHide()
    cmn.SetEventDone( "clk_vidonopenfight" );
    cmn.CallEventHandler( "clk_vidonopenfight_end" );
    common_impl.Lock(0);
  if common_impl.ZzCompleteCheck( "clk_vidonopenfight" ) then cmn.GotoRoom( "rm_newyard" ); end;
  end;

  cmn.CallEventHandler( "clk_vidonopenfight_beg" );
  

  ObjSet( "mg_fightscr", { color_r = 0; color_g = 0; color_b = 0; } )
  --[[
  common_impl.VideoSubtitleVocStart( {
    { "srt_clk_vidonopenfight" , aud_voc_false, 1,5 };
  } )
  ]]
  int.DialogVideoShow( "vid_fightscr_vid_berta_turn", 1, func_end, 1 );
  VidPlay( "vid_fightscr_vid_berta_turn", func_end );
  SoundVid( "vid_berta_turn" );
  SoundVoice( "aud_berta_1_voc" );

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "use_goodball" ] = { type = "use", inv_obj = "inv_goodball", use_place = "gfx_fightscr_goodball_zone", room = "rm_newyard", zz = "mg_fightscr", zz_gate = "gmg_newyard_fightscr" };

private.use_goodball_logic = function()

end;
private.use_goodball_inv = function()
  common_impl.ProcessMultiUseAll("goodball", "goodball")
end;
private.use_goodball_beg = function()
  ObjDelete( "gfx_fightscr_goodball_zone" );
  ObjAttach( "obj_fightscr_mg_root", "mg_fightscr" )
  ObjSet( "spr_fightscr_back2", { visible = 1 } )
end;
private.use_goodball_end = function()

end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "use_goodball", private.use_goodball_inv );
cmn.AddSubscriber( "use_goodball", private.use_goodball_beg, private.room_objname );
cmn.AddSubscriber( "use_goodball", private.use_goodball_end, private.room_objname );
cmn.AddSubscriber( "use_goodball", private.use_goodball_logic );
cmn.AddSubscriber( "use_goodball_inv", private.use_goodball_inv, private.room_objname );
cmn.AddSubscriber( "use_goodball_beg", private.use_goodball_beg, private.room_objname );
cmn.AddSubscriber( "use_goodball_end", private.use_goodball_end, private.room_objname );
cmn.AddSubscriber( "use_goodball_end", private.use_goodball_logic );
--------------------------------------------------------------------------------------------
function public.use_goodball( obj )

  private.use_goodball_func_end = function()
    ObjSet(obj,{visible = 1});
    cmn.SetEventDone( "use_goodball" );
    cmn.CallEventHandler( "use_goodball_end" );
    common_impl.Lock(0);
    cmn.MiniGameShow( "fightscr" );
  end;

  ObjSet(obj,{visible = 0});

  local func_step = function() 
    ld.Lock( 1 )
    int.DialogVideoHide()

    cmn.CallEventHandler( "use_goodball_inv" );
    cmn.CallEventHandler( "use_goodball_beg" );
    SoundSfx( "aud_use_goodball_newyard" )

    ObjSet( "obj_fightscr_mg_root", { alp = 0 } )
    ObjAnimate( "obj_fightscr_mg_root", 8,0,0, nil, { 0,0,0, 0.5,0,1 } )
    ObjSet( "spr_fightscr_back2", { alp = 0 } )
    ObjAnimate( "spr_fightscr_back2", 8,0,0, nil, { 0,0,0, 0.5,0,1 } )
    gm.map_drop();
  end

  int.DialogVideoShow( "vid_fightscr_vid_use_ball", 1, func_step );
  VidPlay( "vid_fightscr_vid_use_ball", func_step )
  SoundVid( "vid_use_ball" )

end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_outro3" ] = { type = "click", use_place = "gfx_fightscr_clk_outro3_zone", room = "rm_newyard", zz = "mg_fightscr", zz_gate = "gmg_newyard_fightscr" };

private.clk_outro3_logic = function()

end;
private.clk_outro3_beg = function()
  ObjDelete( "gfx_fightscr_clk_outro3_zone" );
end;
private.clk_outro3_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_outro3", private.clk_outro3_beg, private.room_objname );
cmn.AddSubscriber( "clk_outro3", private.clk_outro3_end, private.room_objname );
cmn.AddSubscriber( "clk_outro3", private.clk_outro3_logic );
cmn.AddSubscriber( "clk_outro3_beg", private.clk_outro3_beg, private.room_objname );
cmn.AddSubscriber( "clk_outro3_end", private.clk_outro3_end, private.room_objname );
cmn.AddSubscriber( "clk_outro3_end", private.clk_outro3_logic );
--------------------------------------------------------------------------------------------
function public.clk_outro3()

  local func_end = function()
    ObjSet( "mg_fightscr", { color_r = 0; color_g = 0; color_b = 0; } )
    int.DialogVideoHide()
    VidPause( "vid_fightscr_vid_outro3", 1 )
    cmn.SetEventDone( "clk_outro3" );
    cmn.CallEventHandler( "clk_outro3_end" );
    common.MenuCredits("game")
  --if common_impl.ZzCompleteCheck( "clk_outro3" ) then cmn.GotoRoom( "rm_newyard" ); end;
  end;

  cmn.CallEventHandler( "clk_outro3_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( "aud_clk_outro3" )
  --func_end()

  int.DialogVideoShow( "vid_fightscr_vid_outro3", 1, func_end );

  ObjAnimate( "vid_fightscr_vid_outro3", 7, 0, 0, function() 
      common_impl.Lock(0);
    --common_impl.VideoSubtitleVocStart( {
    --  { "srt_outro_1" , aud_voc_false, 1.5,5.5 };
    --  { "srt_outro_2" , aud_voc_false, 6.5,10 };
    --  { "srt_outro_3" , aud_voc_false, 11,14.5 };
    --  { "srt_outro_4" , aud_voc_false, 15.5,21 };
    --  { "srt_outro_5" , aud_voc_false, 39.5,43 };
    --  { "srt_outro_6" , aud_voc_false, 46.5,51 };
    --  { "srt_outro_7" , aud_voc_false, 51,58 };
    --  { "srt_outro_8" , aud_voc_false, 58,62 };
    --} )
    --SoundVoice( "aud_outro_voc" )
    SoundVid( "aud_outro3" );
    VidPlay( "vid_fightscr_vid_outro3", func_end );

  end, {0,0,0, 0,0,0} );

end;
--------------------------------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  --if not ld.CheckRequirements( { "clk_vidonopenfight" } ) then
  --  public.clk_vidonopenfight()
  --elseif ld.CheckRequirements( {"win_fightscr","use_goodball"}, true ) == 1 then
    SoundMgTheme( true )
    cmn.MiniGameShow( "fightscr" );
  --elseif ld.CheckRequirements( {"win_fightscr"} ) then
  --  public.clk_outro3()
  --end
end;
--*********************************************************************************************************************
function public.PreOpen()
  ObjAttach( "obj_fightscr_mg_root", "mg_fightscr" )
  SoundEnv( "aud_mg_fight_env" )
  gm.load();
    ObjSet( "obj_fightscr_mg_root", { alp = 0 } )
    ObjAnimate( "obj_fightscr_mg_root", 8,0,0, nil, { 0,0,0, 0.5,0,1 } )
--  ObjAttach( "spr_int_button_map_button_lock", "obj_int_button_map" )
--  ObjSet( "spr_int_button_map_button_lock", { alp = 0 } )
--  ObjAnimate( "spr_int_button_map_button_lock", 8,0,0, _, { 0,0,0, 0.5,0,1 } )
--  ObjAnimate( "anm_int_button_map_static", 8,0,0, function() AnimStop( "anm_int_button_map_static" ) end, { 0,0,1, 0.5,0,1 } )
--  ObjSet( "grm_castleext_baileyext", { visible = 0, input = 0 } )
--  interface.WidgetSetInput( InterfaceWidget_BtnMap, false );
--
--  if ld.CheckRequirements( {"win_fightscr"} ) or ( not ld.CheckRequirements( { "clk_vidonopenfight" } ) ) then
--    ld.SetWidgetsVisible( "DialogVideoShow", false );
--    ObjSet( "mg_fightscr", { color_r = 0; color_g = 0; color_b = 0; } )
--  end
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_fightscr"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "fightscr" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  ld.Lock( 1 )
  gm.block_destroy_all()
  SoundSfx( "aud_reset_mg_fight" )
  gm.berta_anim_play( "berta_laughs", function() 
    gm.default()
    gm.counter_set( gm.TURNS )
    gm.foe_reset_all()
    gm.map_drop( true );
  end )
end;
--*********************************************************************************************************************
function public.Skip()
  private.Win();
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_fightscr" );
  cmn.CallEventHandler( "win_fightscr" );
  --interface_impl.ShowMgAchievements();
  --public.clk_outro3()
  rm_masterscr.go_back()
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide();
  SoundMgTheme( false )
  ObjAnimate( "obj_fightscr_mg_root", 8,0,0, private.WinEnd, { 0,0,1, 0.5,0,0 } )
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.default()
  gm.TURNS = 16;
  gm.FOE_LIFE = 14
  gm.BLOCK_TYPES = 4
  gm.X = 512;
  gm.Y = 425;
  gm.W = 100;
  gm.WAY_LINE = { {2,0}; {0,-2}; {-2,0}; {0,2}; };  
  gm.WAY_DIAG = { {2,-2}; {-2,-2}; {-2,2}; {2,2}; };  

  gm.CLR = {
    { color_r = 0.5; color_g = 1  ; color_b = 0.5; };
    { color_r = 1  ; color_g = 1  ; color_b = 0.5; };
    { color_r = 1  ; color_g = 0.5; color_b = 1  ; };
    { color_r = 0.5; color_g = 0.5; color_b = 1  ; };
  }



  gm.HERO_PLACE = {
    { -400, -300 };
    { -200, -300 };
    { 0, -300 };
    { 200, -300 };
    { 300, -300 };
  }
  gm.FOE_PLACE = {
    { 163 - gm.X, 386 - gm.Y };
    { 862 - gm.X, 380 - gm.Y };
    { 163 - gm.X, 241 - gm.Y };
    { 862 - gm.X, 241 - gm.Y };
  }
  gm.FOE_EYE_Y = { -10; -5; -15; -10; }


  --[[
  X - граница поля

  A - ничем незанимаемая клетка
  B - заблокированная клетка, убивается 3мя соседними взрывами

  пробел - рандомный камень

  * - ничем незанятая стенка
  a - глухая стенка
  b - заблокированная стенка, убивается 3мя соседними взрывами
  ]]
  gm.pole = {
    "XXXXXXXXXXX";
    "X*********X";
    "X* * * * *X";
    "X*********X";
    "X* * * * *X";
    "X*********X";
    "X* * * * *X";
    "X*********X";
    "X* * * * *X";
    "X*********X";
    "XXXXXXXXXXX";
  }
  gm.block={};
  gm.hit_counter = gm.TURNS

  --gm.bad_try = {
  --  "xxxxxxxxxxxxx";
  --  "x331xxxx4132x";
  --  "x214xxxx1143x";
  --  "x253xxxx2542x";
  --  "x134xxxx3515x";
  --  "x4124243422xx";
  --  "xx531313523xx";
  --  "xx445524515xx";
  --  "xxxxxxxxxxxxx";
  --}
  --gm.bad_try = {
  --  "xxxxxxxxxxxxx";
  --  "x331xxxx4132x";
  --  "x214xxxx1143x";
  --  "x253xxxx2542x";
  --  "x134xxxx3515x";
  --  "x412424x422xx";
  --  "xx531314523xx";
  --  "xx445523515xx";
  --  "xxxxxxxxxxxxx";
  --}
end

function gm.load()

  if gm.loaded or ld.CheckRequirements( { "win_fightscr" } ) then return end;

  gm.default()
  
  gm.foe_add( 1, true )
  gm.foe_add( 2 )
  gm.foe_add( 3 )
  gm.foe_add( 4 )
  
  local s = ng_global.progress["scr"]["win_fightscr"].state;
  if s then
    
    gm.map = gm.table_copy( s.map )
    gm.hit_counter = s.hit_counter
    gm.foes = gm.table_copy( s.foes )
    
    gm.build_blocks( gm.map )
    gm.block_set_all()
    gm.foe_restore_all()
  else
    
    --ld.Lock( 1 )
    --gm.no_moves_drop()
    gm.map = gm.build_map( gm.pole )
    --gm.map_drop();
    
  end;

  
  
  gm.build_controls( gm.map )
  gm.build_map_barriers( gm.map )
  gm.build_map_walls( gm.map )

  gm.counter_set( gm.hit_counter )
  
  gm.map_drop();
  gm.loaded = true;
end;

--
function gm.build_map( pole )
  local map = {};
  for j = 1, #pole do
    map[j] = {};
    for i = 1, #pole[j] do
      local v = pole[j]:sub(i,i);
      if v == "X" then
        map[j][i] = { type = -99 };                               --граница поля
      elseif v == "A" then
        map[j][i] = { type = -98 };                               --ничем незанимаемая клетка
      elseif v == "B" then
        map[j][i] = { type = -89 };                               --заблокированная клетка, убивается 3мя соседними взрывами
      elseif v == "*" then
        map[j][i] = { type = 0; wall = true; };                   --ничем незанятая стенка
      elseif v == "a" then
        map[j][i] = { type = 1; wall = true; };                   --глухая стенка
      elseif v == "b" then
        map[j][i] = { type = 2; wall = true; };                   --заблокированная стенка, убивается 3мя соседними взрывами
      elseif v == " " then
        --map[j][i] = { type = math.random( 1, gm.BLOCK_TYPES ) };  --рандомный блок
        map[j][i] = { type = 0 };  --рандомный блок
      end;
    end; 
  end;
  return map
end;

function gm.build_map_barriers( map )
  for j = 1, #map do
    for i = 1, #map[j] do
      local b = map[j][i];
      if not b.wall and b.type > -99 and b.type < 0 then
        b.obj = "obj_fightscr_barrier_"..j.."_"..i
        ObjCreate( b.obj, "obj" );
        ObjSet( b.obj, { 
          input = 0;
          pos_x = gm.get_pos_x( i );
          pos_y = gm.get_pos_y( j );
        } )
        ObjAttach( b.obj, "obj_fightscr_block_root" )
        if b.type > -99 then
          b.spr = b.obj:gsub("^obj","spr")
          ObjCreate( b.spr, "spr" );
          ObjSet(  b.spr, { 
            res = "assets/levels/level/mg_fight/barrier_"..( -b.type );
          } )
          ObjAttach(  b.spr, b.obj )   

          if b.type == -89 then
            b.hp = 3;
          end;
        end;
      end
    end;
  end;
end;

function gm.build_map_walls( map )
  for j = 1, #map do
    for i = 1, #map[j] do
      local b = map[j][i];
      if b.wall and b.type > 0 then
        b.obj = "obj_fightscr_wall_"..j.."_"..i
        ObjCreate( b.obj, "obj" );
        ObjSet( b.obj, { 
          input = false;
          pos_x = gm.get_pos_x( i );
          pos_y = gm.get_pos_y( j );
          ang = i%2 == 0 and math.pi / 2 or 0;
        } )
        ObjAttach( b.obj, "obj_fightscr_block_root" )
        b.spr = "spr_fightscr_wall_"..j.."_"..i;
        --if b.type > 0 then
          ObjCreate( b.spr, "spr" );
          ObjSet(  b.spr, { 
            res = "assets/levels/level/mg_fight/wall_"..b.type
          } )
          ObjAttach(  b.spr, b.obj )   
        --end;
        if b.type == 2 then
          b.hp = 3;
          for z = 1, b.hp do
            ObjCreate( b.spr.."_"..z, "spr" );
            ObjSet(  b.spr.."_"..z, { 
              res = "assets/levels/level/mg_fight/wall_"..b.type.."_"..z;
              alp = b.hp == z and 1 or 0;
              pos_z = z;
            } )
            ObjAttach(  b.spr.."_"..z, b.obj )   
          end;
        end;
      end
    end;
  end;
end;

function gm.build_controls( map )
  --ObjCreate( "obj_fightscr_block_root", "obj" )
  --ObjAttach( "obj_fightscr_block_root", "mg_fightscr" )
  local cr_x = 0;
  local cr_y = 0;
  for j = 1, #map do
    for i = 1, #map[j] do
      local b = map[j][i];
      if not b.wall and b.type >= 0 then
        gm.control_build( j, i )
      end;
    end;
  end;
  ObjSet( "obj_fightscr_block_root", { 
    pos_z = 22, ang = 0;
    pos_x = gm.X; 
    pos_y = gm.Y;
  } )
  ObjSet( "obj_fightscr_foe_root", { 
    pos_z = 20;
    pos_x = gm.X; 
    pos_y = gm.Y;
  } )
  --ObjSet( "obj_fightscr_hero_root", { 
  --  pos_z = 24;
  --  pos_x = gm.X; 
  --  pos_y = gm.Y;
  --} )
end;

function gm.control_build( j, i )
        ObjCreate( "obj_fightscr_control_"..j.."_"..i, "obj" );
        ObjSet( "obj_fightscr_control_"..j.."_"..i, { 
          pos_z = 30;
          drag = 1;
          realdrag = 1;
          pos_x = gm.get_pos_x( i );
          pos_y = gm.get_pos_y( j );
          inputrect_init = 1;
          inputrect_x = -gm.W/2;
          inputrect_y = -gm.W/2;
          inputrect_w = gm.W;
          inputrect_h = gm.W;
          event_startdrag = function() gm.control_startdrag( j, i ) end;
          event_drag = function() gm.control_drag( j, i ) end;
          event_dragdrop = function() gm.control_dragdrop( j, i ) end;
          event_mdown = function() gm.control_mdown( j, i ) end;
          event_mup = function() gm.control_mup( j, i ) end;
        } )

        ObjAttach( "obj_fightscr_control_"..j.."_"..i, "obj_fightscr_block_root" )
end;

function gm.build_blocks( map )
  for j = 1, #map do
    for i = 1, #map[j] do
      local b = map[j][i];
      if b.type > 0 then
        map[j][i] = gm.block_build( b.type )
      end;
    end;
  end;
end;

function gm.block_build( type )
  type = type or math.random( 1, gm.BLOCK_TYPES );
  local b;
  if gm.block_destroyed and gm.block_destroyed[type] and #gm.block_destroyed[type] > 0 then

    b = table.remove( gm.block_destroyed[type] );
    ObjSet( b.obj, { pos_z = 0; } )
    ObjAttach( b.obj, "obj_fightscr_block_root" )
    ld.AnimPlay( b.anm_static, b.type, nil )

  else

    gm.block_count = gm.block_count and ( gm.block_count + 1 ) or 1
    b = { 
      type = type;
      id = gm.block_count;
      obj = "obj_fightscr_block_"..gm.block_count;
      anm_sleep = "anm_fightscr_block_"..gm.block_count.."_sleep";
      anm_static  = "anm_fightscr_block_"..gm.block_count.."_static";
      fx_eyes  = "fx_fightscr_block_"..gm.block_count.."_eyes";
    };
    
    ObjCreate( b.obj, "obj" );
    ObjSet( b.obj, { 
      pos_z = 0;
      input = 0;
    } )
    ObjAttach( b.obj, "obj_fightscr_block_root" )

    --ObjCreate( b.obj:gsub("^obj","spr"), "spr" );
    --ObjSet( b.obj:gsub("^obj","spr"), { 
    --  res = "assets/levels/level/mg_fight/"..b.type;
    --  input = 0;
    --} )
    --ObjAttach( b.obj:gsub("^obj","spr"), b.obj )

    ObjCreate( b.anm_sleep, "anim" );
    ObjSet( b.anm_sleep, { 
      res = "assets/levels/level/mg_fight/anm";
      animfunc = b.type.."_sleep";
      input = 0;
      pos_z = 1;
      alp = 0
    } )
    ObjAttach( b.anm_sleep, b.obj )

    ObjCreate( b.anm_static, "anim" );
    ObjSet( b.anm_static, { 
      res = "assets/levels/level/mg_fight/anm";
      animfunc = b.type;
      playing = 1;
      input = 0;
      pos_z = 2;
    } )
    ObjAttach( b.anm_static, b.obj )


    ObjCreate( b.fx_eyes, "partsys" );
    ObjSet( b.fx_eyes, { 
      res = "assets/levels/level/mg_fight/eyes_fx";
      pos_x = -14;
      pos_y = gm.FOE_EYE_Y[ b.type ];
      pos_z = 66; 
    } )
    ObjSet( b.fx_eyes, gm.CLR[ b.type ] )
    ObjAttach( b.fx_eyes, b.obj )
    PartSysStop( b.fx_eyes, 1 );

    --ObjCreate( b.obj:gsub("^obj","spr").."_marked", "spr" );
    --ObjSet( b.obj:gsub("^obj","spr").."_marked", { 
    --  res = "assets/levels/level/mg_fight/marked";
    --  input = 0;
    --  pos_z = 33;
    --  alp = 0;
    --  blendmode = 2;
    --} )
    --ObjAttach( b.obj:gsub("^obj","spr").."_marked", b.obj )
  end;



  return b;
end;

function gm.block_destroy( j, i )
  gm.block_destroyed = gm.block_destroyed  or {}
  local b = gm.map[j][i];
  gm.map[j][i] = { type = 0 };
  local p = GetObjPosByObj( b.obj, "obj_fightscr_mg_root" )
  ObjAttach( b.obj, "obj_fightscr_mg_root" )
  ObjSet( b.obj, { pos_x = p[ 1 ]; pos_y = p[ 2 ]; pos_z = 44; } )
  ld.AnimPlay( b.anm_static, b.type.."_crash", function() 
    ObjDetach( b.obj )
    gm.block_destroyed[b.type] = gm.block_destroyed[b.type] or {};
    table.insert( gm.block_destroyed[b.type], b );
  end )
end;


function gm.block_shake( j, i )
  if not gm.block_shake_now then
    gm.block_shake_now = true
    SoundSfx( "aud_clk_chip" )
    ld.StartTimer( 0, function() gm.block_shake_now = false end )
  end
  local o = ObjGet( gm.map[j][i].obj )
  local t = 0.4;
  ObjAnimate( o.name, 6,0,0, _, { 0,0,o.scale_x,o.scale_y, t*0.2,1,0.8,1.2, t*0.50,3,1.15,0.85, t*0.75,3,0.9,1.1, t*0.90,3,1.05,0.95, t,3,1,1 } );
end;

function gm.block_destroy_all()
  SoundSfx( "aud_green_chips_exp" )
  for j = #gm.map, 1, -1 do
    for i = 1, #gm.map[j] do
      if not gm.map[j][i].wall and gm.map[j][i].type > 0 then
        gm.block_destroy( j, i )
      end;
    end;
  end;
  math.randomseed( 7 )
end

function gm.block_set_all()
  for j = #gm.map, 1, -1 do
      for i = 1, #gm.map[j] do
        if not gm.map[j][i].wall and gm.map[j][i].type > 0 then
          ObjSet( gm.map[j][i].obj, { pos_x = gm.get_pos_x( i ); pos_y = gm.get_pos_y( j ); } )
        end;
      end;
    end;

end

function gm.map_drop( continue, droped, droping )

  local cr_x = gm.get_pos_x( #gm.map[1] ) - (#gm.map[1]%2)*gm.W*0.5
  local cr_y = gm.get_pos_y( #gm.map ) - (#gm.map%2)*gm.W*0.5
  ObjSet( "obj_fightscr_block_root", { 
    croprect_init = 1;
    croprect_x = -cr_x;
    croprect_y = -cr_y;
    croprect_w = cr_x*2;
    croprect_h = cr_y*2;
  } )
  if not continue then
    ld.Lock( 1 )
    --ObjSet( "obj_fightscr_block_root", { croprect_init = 1; } )
  end;  

  gm.map_drops_x = gm.map_drops_x or {}
  
  local map = gm.map

  local map_drops_x = {}
  
  local droped = droped or {};
  local droping = droping == nil and false or droping
  local t = 0.25;

    local obj,x1,x2,y1,y2;
    for j = #map, 1, -1 do
      droped[j] = droped[j] or {}
      droped[j-2] = droped[j-2] or {};
      for i = 1, #map[j] do
        if not droped[j][i] and not map[j][i].wall and map[j][i].type > 0 then
        --блок не дропался, блок свободный, можно ронять верхние блоки
          if map[j+2][i].type == 0 and map[j+1][i].type == 0 then
            --снизу пусто, стенки нет - роняем
            obj = map[j][i].obj
            x1 = gm.get_pos_x( i )
            y1 = gm.get_pos_y( j )
            x2 = gm.get_pos_x( i )
            y2 = gm.get_pos_y( j + 2 )
            map[j+2][i], map[j][i] = map[j][i], map[j+2][i]
            droped[j+2][i] = true
          end
          if obj then
            --ld.LogTrace(obj)
            ObjAnimate( obj, 3,0,0, _, { 0,0,x1,y1, t,0,x2,y2 } )
            droping = true;
            gm.map_drops_x[ obj ] = i
            map_drops_x[ obj ] = i
            obj = false
          end;
        end;
      end;
    end;

    --for j = #map, 1, -1 do
    --  for i = 1, #map[j] do
    --    if not droped[j][i] and not map[j][i].wall and map[j][i].type > 0 then
    --    --блок не дропался, блок свободный, можно ронять верхние блоки
    --      local obj,x1,x2,y1,y2;
    --      if map[j+2][i-2].type == 0 and map[j+1][i].type == 0 and map[j+2][i-1].type == 0
    --      and ( map[j+1][i-2].type > 0 or map[j][i-2].type <= 0 ) then
    --        --снизу слева пусто, слева снизу нет стенки, снизу слева нет стенки
    --        obj = map[j][i].obj
    --        x1 = gm.get_pos_x( i )
    --        y1 = gm.get_pos_y( j )
    --        x2 = gm.get_pos_x( i - 2 )
    --        y2 = gm.get_pos_y( j + 2 )
    --        droped[j+2][i-2] = true
    --        map[j+2][i-2], map[j][i] = map[j][i], map[j+2][i-2]
    --      elseif map[j+2][i+2].type == 0 and map[j+1][i].type == 0 and map[j+2][i+1].type == 0
    --      and ( map[j+1][i+2].type > 0 or map[j][i+2].type <= 0 ) then
    --        --снизу справа пусто, справа снизу нет стенки, снизу справа нет стенки
    --        obj = map[j][i].obj
    --        x1 = gm.get_pos_x( i )
    --        y1 = gm.get_pos_y( j )
    --        x2 = gm.get_pos_x( i + 2 )
    --        y2 = gm.get_pos_y( j + 2 )
    --        map[j+2][i+2], map[j][i] = map[j][i], map[j+2][i+2]
    --        droped[j+2][i+2] = true
    --      end
    --      if obj then
    --        --ld.LogTrace(obj)
    --        ObjAnimate( obj, 3,0,0, _, { 0,0,x1,y1, t,0,x2,y2 } )
    --        droping = true;
    --        gm.map_drop( true, droped, droping )
    --        return
    --      end;
    --    end;
    --  end;
    --end;

    for j = 1, #map do
      for i = 1, #map[j] do
        if not droped[j][i] and not map[j][i].wall and map[j][i].type == 0 then
        --блок не дропался, блок свободный, можно ронять верхние блоки
          --local obj,x1,x2,y1,y2;
          if not droped[j-2][i] and map[j-1][i].type == 0 and map[j-2][i].type == -99 then
          --сверху нет стенки и сверху - граница поля - можно рожать блок и ронять его вниз
            map[j][i] = gm.block_build()
            obj = map[j][i].obj
            x1 = gm.get_pos_x( i )
            y1 = gm.get_pos_y( j - 2 )
            x2 = gm.get_pos_x( i )
            y2 = gm.get_pos_y( j )
            droped[j][i] = true
            droped[j-2][i] = true
          --elseif ( not droped[j-2][i-2] and map[j-2][i-2].type == -99 and map[j][i-2].type > 0 and map[j-1][i].type == 0 and map[j-2][i-1].type == 0 )
          ---- слева сверху граница поля, слева стоит блок, сверху нет стенки, сверху слева нету стенки - можно рожать блок и ронять его
          --or ( not droped[j-2][i-2] and map[j-2][i-2].type == -99 and map[j-1][i-2].type > 0 and map[j-1][i].type == 0 and map[j-2][i-1].type == 0 ) then
          ---- слева сверху граница поля, слева сверху стенка, сверху нет стенки, сверху слева нету стенки - можно рожать блок и ронять его
          --  map[j][i] = gm.block_build()
          --  obj = map[j][i].obj
          --  x1 = gm.get_pos_x( i - 2 )
          --  y1 = gm.get_pos_y( j - 2 )
          --  x2 = gm.get_pos_x( i )
          --  y2 = gm.get_pos_y( j )
          --  droped[j][i] = true
          --  droped[j-2][i-2] = true
          --elseif ( not droped[j-2][i+2] and map[j-2][i+2].type == -99 and map[j][i+2].type > 0 and map[j-1][i].type == 0 and map[j-2][i+1].type == 0 )
          ---- справа сверху граница поля, справа стоит блок, сверху нет стенки, сверху справа нету стенки - можно рожать блок и ронять его
          --or ( not droped[j-2][i+2] and map[j-2][i+2].type == -99 and map[j-1][i+2].type > 0 and map[j-1][i].type == 0 and map[j-2][i+1].type == 0 ) then
          ---- справа сверху граница поля, справа сверху стенка, сверху нет стенки, сверху справа нету стенки - можно рожать блок и ронять его
          --  map[j][i] = gm.block_build()
          --  obj = map[j][i].obj
          --  x1 = gm.get_pos_x( i + 2 )
          --  y1 = gm.get_pos_y( j - 2 )
          --  x2 = gm.get_pos_x( i )
          --  y2 = gm.get_pos_y( j )
          --  droped[j][i] = true
          --  droped[j-2][i+2] = true
          end
          if obj then
            --ld.LogTrace(obj)
            ObjAnimate( obj, 3,0,0, _, { 0,0,x1,y1, t,0,x2,y2 } )
            droping = true;
            gm.map_drops_x[ obj ] = i
            map_drops_x[ obj ] = i
            obj = false
            --gm.map_drop( true, droped, droping )
            --return
          end;
        end
      end;
    end

    for k, v in pairs( gm.map_drops_x ) do
      if not map_drops_x[ k ] then
        gm.map_drops_x[ k ] = nil;
        if not gm.map_drops_x_sfx then
          --ld.LogTrace( "aud_chips_fall" )
          SoundSfx( "aud_chips_fall" )
          gm.map_drops_x_sfx = true
          ld.StartTimer( 0, function() gm.map_drops_x_sfx = false end )
        end
      end
    end

  if droping then
    ld.StartTimer( t, function() gm.map_drop( true ) end )
  else
    gm.map_drops_x = {}
    ObjSet( "obj_fightscr_block_root", { croprect_init = 0; } )
    if gm.map_is_have_moves() then
      --if not ld.CheckRequirements( { "use_goodball" } ) then
      --  private.use_goodball_func_end()
      --end
      gm.save()
      ld.Lock( 0 )
    else
      ld.LogTrace("AHTUNG!!!");
      gm.block_destroy_all()
      gm.map_drop( true );
    end;
  end;
end;

function gm.map_is_have_moves()
  for j = 1, #gm.map do
    for i = 1, #gm.map[j] do
      if not gm.map[j][i].wall and gm.map[j][i].type > 0 then
        if gm.block_is_have_move( j, i ) then
          return true
        end;
      end;
    end;
  end;
  return false
end;

function gm.block_is_have_move( j, i, j_old, i_old, tale)
  if not tale then
    tale = {};
    table.insert( tale, { j, i } );
    gm.block_is_have_move( j, i, j, i, tale)
    return #tale > 2
  else
    local bn = gm.map[j][i];
    local b = gm.map[j_old][i_old];

      local w = gm.WAY_LINE  
      for z = 1, #w do
        local bn = gm.map[j+w[z][1] ][i+w[z][2] ];
        if not gm.tale_is_in(j+w[z][1],i+w[z][2],tale) and bn.type == b.type and gm.map[j+w[z][1]*0.5][i+w[z][2]*0.5].type == 0 then
        -- типы одинаковые,      стенки между контролами нет,                       контрол еще не в хвосте        
          table.insert( tale, { j+w[z][1], i+w[z][2] } );
          gm.block_is_have_move( j+w[z][1], i+w[z][2], j, i, tale)
          return #tale
        end;
      end;

      local w = gm.WAY_DIAG 
      for z = 1, #w do
        local bn = gm.map[j+w[z][1] ][i+w[z][2] ];
        if  not gm.tale_is_in(j+w[z][1],i+w[z][2],tale) and bn.type == b.type
        and ( gm.map[j+w[z][1] ][i+w[z][2]*0.5].type == 0 or gm.map[j+w[z][1]*0.5][i+w[z][2] ].type == 0 )
        and ( gm.map[j+w[z][1]*0.5][i].type == 0 or gm.map[j][i+w[z][2]*0.5].type == 0 ) then
        -- типы одинаковые,      стенок по напралению нет
          table.insert( tale, { j+w[z][1], i+w[z][2] } );
          gm.block_is_have_move( j+w[z][1], i+w[z][2], j, i, tale)
          return #tale
        end;
      end;

    return #tale
  end;
end;

function gm.get_pos_x( x )
  return gm.W * ( x - #gm.map[1] / 2  - 0.5 ) / 2
end

function gm.get_pos_y( y )
  return gm.W * ( y - #gm.map / 2  - 0.5 ) / 2
end

function gm.control_mdown( j, i )
  if not gm.map[j][i].obj then return end;
  
  

  gm.block_shake( j, i )
  gm.tale_add( j, i )
end;

function gm.control_mup( j, i )
  if not gm.map[j][i].obj then return end;
  if gm.draging then return end;

  gm.control_dragdrop( j, i )
end;

function gm.control_startdrag( j, i )
  if not gm.map[j][i].obj then return end;
  gm.draging = true;
end;

gm.CP = {-100,-100 };
gm.CP_old = { -1000, -1000 };
function gm.control_drag( j, i )
  if not gm.map[j][i].obj then return end;

  gm.CP = GetZoomCursorPos();
  if gm.CP[1] == gm.CP_old[1] and gm.CP[2] == gm.CP_old[2] then 
    return;
  end;
  gm.CP_old = gm.CP;

  local removed = false;
  local m = gm.tale[#gm.tale];
  j = m[1];
  i = m[2];
  local b = gm.map[j][i];


  if #gm.tale > 1 then
    local mn = gm.tale[#gm.tale-1];
    local bn = gm.map[mn[1] ][mn[2] ];
    local bp = GetObjPosByObj( bn.obj );
    local l = gm.len( gm.CP[1], gm.CP[2], bp[1], bp[2] );
    if l < ( gm.W / 2 ) then
      gm.tale_remove();
      removed = true;
    end;
  end;

  if not removed then
    local w = { {2,0}; {0,-2}; {-2,0}; {0,2}; };  
    for z = 1, #w do
      local bn = gm.map[j+w[z][1] ][i+w[z][2] ];
      if bn.type == b.type and gm.map[j+w[z][1]*0.5][i+w[z][2]*0.5].type == 0 and not gm.tale_is_in( j+w[z][1], i+w[z][2], gm.tale ) then
      -- типы одинаковые,      стенки между контролами нет,                       контрол еще не в хвосте               
        local bp = GetObjPosByObj( bn.obj );
        local l = gm.len( gm.CP[1], gm.CP[2], bp[1], bp[2] );
        if l < ( gm.W / 2 ) then
          gm.tale_add( j+w[z][1], i+w[z][2] );
          return;
        end;
      end;
    end;
  end;

  if not removed then
    local w = { {2,-2}; {-2,-2}; {-2,2}; {2,2}; };  
    for z = 1, #w do
      local bn = gm.map[j+w[z][1] ][i+w[z][2] ];
      if bn.type == b.type and not gm.tale_is_in( j+w[z][1], i+w[z][2], gm.tale ) 
      and ( gm.map[j+w[z][1] ][i+w[z][2]*0.5].type == 0 or gm.map[j+w[z][1]*0.5][i+w[z][2] ].type == 0 )
      and ( gm.map[j+w[z][1]*0.5][i].type == 0 or gm.map[j][i+w[z][2]*0.5].type == 0 ) then
      -- типы одинаковые,      стенок по напралению нет
        local bp = GetObjPosByObj( bn.obj );
        local l = gm.len( gm.CP[1], gm.CP[2], bp[1], bp[2] );
        if l < ( gm.W / 2 ) then
          gm.tale_add( j+w[z][1], i+w[z][2] );
          return;
        end;
      end;
    end;
  end;

end;

function gm.control_dragdrop( j, i )
  if not gm.map[j][i].obj then return end;
  SoundEnv( "aud_connection_env", 0 )
  SoundSfx( "aud_release_chip" )
  if #gm.tale > 2 then
    gm.counter_add( -1 )
    gm.tale_blow();
  elseif #gm.tale > 0 then
    gm.tale_remove( true );
  end;
  gm.draging = false;
end;

gm.tale = {};
function gm.tale_add( j, i )
  local b = gm.map[j][i];
  local t = 0.25;
  if #gm.tale == 0 then
    SoundSfx( "aud_darknes" )
    for j = 1, #gm.map do
      for i = 1, #gm.map[j] do
        if not gm.map[j][i].wall and gm.map[j][i].type > 0 and gm.map[j][i].type ~= b.type then
          local o = ObjGet( gm.map[j][i].obj );
          ObjAnimate( o.name, 12,0,0, _, { 0,0,o.color_r,o.color_g,o.color_b, t,3,0.4,0.4,0.4 } );
          o = ObjGet( gm.map[j][i].anm_sleep )
          ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,2,1 } );
          o = ObjGet( gm.map[j][i].anm_static )
          ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,1,0 } );
        end;
      end;
    end;
  end
  table.insert( gm.tale, { j, i } )
  --gm.print( "tale_add", b.obj,b.type );
  --local o = ObjGet( b.obj:gsub("^obj","spr").."_marked" );
  --ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,0,1 } );

  if #gm.tale == 2 then
    SoundEnv( "aud_connection_env", 1 )
  end

  PartSysStart( b.fx_eyes )
  gm.block_shake( j, i );
  gm.tale_anim( true )
end;

gm.tale_anim_start = false;
function gm.tale_anim( add )
  local t = 0.25

    if #gm.tale > 1 then
      if add then
        local n = #gm.tale - 1;
        local obj = "obj_fightscr_tale_"..n;
        local o = ObjGet( obj )
        if not o then
          ObjCreate( obj, "obj" );
          ObjSet( obj, { input = 0, pos_z = -30, alp = 1 } );
          ObjAttach( obj, "obj_fightscr_block_root" );
          ObjCreate( obj:gsub("^obj","fx"), "partsys" );
          ObjSet( obj:gsub("^obj","fx"), { pos_x = 50, scale_x = gm.W / 50, input = 0, res = "assets/levels/level/mg_fight/lightning_fx" } );
          ObjAttach( obj:gsub("^obj","fx"), obj );
        end;

        local m1 = gm.tale[n];
        local m2 = gm.tale[#gm.tale];
        local a, l = gm.ang_gip( m1[2], m1[1], m2[2], m2[1] );
        --ld.LogTrace( a,l,gm.W )
        ObjSet( obj, { scale_x = l / 2 , ang = a, pos_x = gm.get_pos_x( m1[2] ), pos_y = gm.get_pos_y( m1[1] ) } );
        PartSysRestart( obj:gsub("^obj","fx") )
        --ObjAnimate( obj, 8,0,0, _, { 0,0,0, t,0,1 } );
      end
      if not gm.tale_anim_start then
        gm.tale_anim_start = true;
        for i = 1, #gm.tale - 1 do
          local o = ObjGet( "obj_fightscr_tale_"..i );
          local dx = (o.ang%(math.pi/2))<0.1 and gm.W or gm.W*1.7
          --gm.print( o.ang, o.ang%(math.pi/4), dx )
          ObjAnimate( o.name:gsub("^obj","spr"), 0,0,0, _, { 0,0,0, t,0,dx } )
        end;
        ld.StartTimer( t, function() gm.tale_anim_start = false gm.tale_anim() end )
      end;
    else
      gm.tale_anim_start = false
    end;

end;

function gm.tale_remove( all )
  local b = table.remove(gm.tale);
  local y = b[1];
  local x = b[2];
  b = gm.map[y][x];
  --gm.print( "tale_remove", b.obj,b.type );
  local t = 0.35;
  if #gm.tale == 0 then
    for j = 1, #gm.map do
      for i = 1, #gm.map[j] do
        if not gm.map[j][i].wall and gm.map[j][i].type > 0 and gm.map[j][i].type ~= b.type then
          local o = ObjGet( gm.map[j][i].obj );
          ObjAnimate( o.name, 12,0,0, _, { 0,0,o.color_r,o.color_g,o.color_b, t,3,1,1,1 } );
          o = ObjGet( gm.map[j][i].anm_sleep )
          ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,1,0 } );
          o = ObjGet( gm.map[j][i].anm_static )
          ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,2,1 } );
        end;
      end;
    end;
  end
  
  --local o = ObjGet( b.obj:gsub("^obj","spr").."_marked" );
  --ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,0,0 } );
  PartSysStop( b.fx_eyes, 0 )

  if not all then
    gm.block_shake( y, x );
  end;

  if #gm.tale > 0 then
    local o = ObjGet( "obj_fightscr_tale_"..#gm.tale )
    --ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,0,0 } );
    PartSysStop( o.name:gsub("^obj","fx"), 0 );
  end;

  if #gm.tale == 1 then
    SoundEnv( "aud_connection_env", 0 )
  end

  if all and #gm.tale > 0 then
    gm.tale_remove( all )
  end;
end;

function gm.tale_is_in( j, i, tale )
  for z = 1, #tale do
    if tale[z][1] == j and tale[z][2] == i then
      return true
    end;
  end;
  return false;
end;

function gm.tale_blow()
  ld.Lock( 1 );
  local t = 0;
  local ts = 0.1;
  for i = #gm.tale, 1, -1 do
    --ld.StartTimer( t, function() gm.player_add_block( gm.tale[#gm.tale][1], gm.tale[#gm.tale][2], i ); gm.tale_remove(); end );
    --t = t + ts;
    gm.player_add_block( gm.tale[#gm.tale][1], gm.tale[#gm.tale][2], i );
    gm.tale_remove();
  end;

  gm.player_shoot()
  --ld.StartTimer( t , gm.player_shoot )
end;

function gm.player_shoot( count )
  count = count or 1; 
  local t = 0;
  local ts = 0.15;
  --local ta = 0.3;
  for i = 1, #gm.player_stack do
    local ps = gm.player_stack[i];
    for j = 1, #ps do
      local b = gm.map[ps[j][1] ][ps[j][2] ];
      local o = ObjGet( b.obj )

--      local fn = 0;
--      if gm.foe_choised and gm.foes[gm.foe_choised].hp > 0 then
--        fn = gm.foe_choised;
--      else
--        local fns = {}
--        for f = 1, #gm.foes do
--          if gm.foes[f].hp > 0 then
--            --table.insert( fns, f );
--            table.insert( fns, b.type );
--          end;
--        end
--        if #fns > 0 then
--          --fn = table.remove( fns, math.random( 1, #fns ) );
--          fn = table.remove( fns, math.random( 1, b.type ) );
--        end;
--      end;
--
      fn = b.type
      if gm.foes[ fn ].hp <= 0 or gm.foes[ fn ].locked then
        if not gm.block_destroy_sfx then
          gm.block_destroy_sfx = true;
          SoundSfx( "aud_green_chips_exp" )
          ld.StartTimer( 0, function() gm.block_destroy_sfx = false end )
        end
            gm.block_destroy( ps[j][1], ps[j][2] ); 
            table.remove( ps, 1 ); 
            gm.player_shoot( count + 1 ); 
      else

        local fx;
        if gm.player_shoot_fx and #gm.player_shoot_fx > 0 then
          fx = table.remove( gm.player_shoot_fx );
        else
          gm.player_shoot_fx = gm.player_shoot_fx or {}
          gm.player_shoot_fx_count = gm.player_shoot_fx_count or 0;
          fx = "fx_fightscr_player_shoot_fx_"..gm.player_shoot_fx_count
          gm.player_shoot_fx_count = gm.player_shoot_fx_count + 1;
          ObjCreate( fx, "partsys" )
          ObjSet( fx, { 
            res = "assets/levels/level/mg_fight/fly_fx";
            input = 0;
          } )
          ObjAttach( fx, "obj_fightscr_mg_root" )
        end
        ObjSet( fx, { pos_z = 36 + i - 0.1 } )
        ObjSet( fx, gm.CLR[ fn ] )
        PartSysRestart( fx )
        ObjAnimate( fx, 3,0,0, function() 
          PartSysStop( fx, 0 )
          ld.StartTimer( 1, function()
            table.insert( gm.player_shoot_fx, fx );
          end )
        end, { 0,0,o.pos_x+512,o.pos_y+415, ts,1,gm.FOE_PLACE[ fn ][ 1 ]+512,gm.FOE_PLACE[ fn ][ 2 ]+415 } );

        ObjSet( o.name, { pos_z = 36 + i } )

        if not gm.player_shoot_sfx then
          gm.player_shoot_sfx = true
          SoundSfx( "aud_chip_flyes_and_exp" )
          ld.StartTimer( 0, function() gm.player_shoot_sfx = false end )
        end
        ObjAnimate( o.name, 3,0,0, 
          function() 
            gm.foe_damage( fn, count );
            gm.block_destroy( ps[j][1], ps[j][2] ); 
            table.remove( ps, 1 ); 
            gm.player_shoot( count + 1 ); 
          end,
        { 0,0,o.pos_x,o.pos_y, ts,1,gm.FOE_PLACE[ fn ][ 1 ],gm.FOE_PLACE[ fn ][ 2 ] } );

      end;
      return;
      --local t = t + ts;
    end;  
  end;

  if gm.foe_is_all_dead() then
    private.Win()
  elseif gm.counter_get() > 0 then
    gm.map_drop( true );
    --DbgTrace( "gm.player_shoot end" );
  else
    --ld.LogTrace( "LOOSE!!!" )
    public.Reset()
  end

end;

function gm.player_add_block( j, i, z )
  if not gm.player_stack then
    gm.player_stack = {}
    for i = 1, 5 do
      gm.player_stack[i] = {};
    end;
  end;
  local t = 0.2;
  local b = gm.map[j][i];
  local o = ObjGet( b.obj )
  
  table.insert( gm.player_stack[b.type], { j, i } );

  local w = { {2,0}; {0,-2}; {-2,0}; {0,2}; };  
  for z = 1, #w do
    if gm.map[j+w[z][1]*0.5][i+w[z][2]*0.5].hp then
      gm.wall_damage( j+w[z][1]*0.5, i+w[z][2]*0.5 )
    elseif gm.map[j+w[z][1] ][i+w[z][2] ].hp then
      gm.barrier_damage( j+w[z][1], i+w[z][2] )
    end;
  end;

  --ObjAttach( o.name, "obj_fightscr_hero_root" )
  ObjSet( o.name, { pos_z = z } );
  --ObjAnimate( o.name, 3,0,0, function() ObjSet( o.name, { pos_z = o.pos_z } ) end, { 0,0,o.pos_x,o.pos_y, t,1,gm.HERO_PLACE[ b.type ][ 1 ],gm.HERO_PLACE[ b.type ][ 2 ] } );
end;

function gm.wall_damage( j, i, d )
  d = d or 1;
  local t =0.2;
  local w = gm.map[j][i];
  ObjAnimate( w.spr.."_"..w.hp, 8,0,0, _, { 0,0,1, t,0,0 } );
  w.hp = w.hp - d;
  if w.hp < 0 then
    w.hp = 0;
  end;
  if w.hp == 0 then
    w.hp = nil;
    w.type = 0;
    ObjAnimate( w.obj, 8,0,0, _, { 0,0,1, t,0,0 } );
  else
    ObjAnimate( w.spr.."_"..w.hp, 8,0,0, _, { 0,0,0, t,0,1 } );
  end;
end;

function gm.barrier_damage( j, i, d )
  d = d or 1;
  local t =0.3;
  local w = gm.map[j][i];
  local o = ObjGet( w.spr )
  w.hp = w.hp - d;
  if w.hp < 0 then
    w.hp = 0;
  end;

  ObjAnimate( w.spr, 6,0,0, _, { 0,0,o.scale_x,o.scale_y, t,3,w.hp/3,w.hp/3 } );


  if w.hp == 0 then
    w.hp = nil;
    w.type = 0;
    gm.control_build( j, i )
    ObjAnimate( w.obj, 8,0,0, _, { 0,0,1, t,0,0 } );
  else

  end;
end;

function gm.foe_add( n, locked )
  gm.foes = gm.foes or {};
  gm.foe_count = gm.foe_count or 0
  gm.foe_count = gm.foe_count + 1;
  local f = {
    obj = "obj_fightscr_foe_"..gm.foe_count;
    spr = "spr_fightscr_foe_"..gm.foe_count;
    anm_lock = "anm_fightscr_foe_"..gm.foe_count.."_lock";
    txt = "txt_fightscr_foe_"..gm.foe_count;
    type = n;
    damage_min = 1;
    damage_max = 3;
    hp = gm.FOE_LIFE;
    hp_max = gm.FOE_LIFE;
    locked = locked;
    Locked = locked;
  }
  table.insert( gm.foes, f );
  local fc = #gm.foes;
  ObjCreate( f.obj, "obj" );
  ObjSet( f.obj, { 
    inputrect_init = 1;  
    inputrect_x = -gm.W/2;  
    inputrect_y = -gm.W/2;  
    inputrect_w = gm.W;  
    inputrect_h = gm.W;
    pos_x = gm.FOE_PLACE[ fc ][ 1 ];
    pos_y = gm.FOE_PLACE[ fc ][ 2 ];
    --event_mdown = function() gm.foe_mdown( fc ) end;
  } );
  ObjAttach( f.obj, "obj_fightscr_foe_root" );

  ObjCreate( f.spr, "spr" );
  ObjSet( f.spr, { res = "assets/levels/level/mg_fight/"..f.type.."_lvl", input = 0 } )
  ObjAttach( f.spr,f.obj );

  ObjCreate( f.anm_lock, "anim" );
  ObjSet( f.anm_lock, { res = "assets/levels/level/mg_fight/anm", input = 0, pos_z = 99, pos_y = 15, animfunc = "lock" } )
  ObjAttach( f.anm_lock, f.obj );

  ObjCreate( f.txt, "text" )
  ObjSet( f.txt, { 
    res = "assets/fonts/times";
    input = 0;
    text = f.hp;
    disprawtext = true;
    pos_z = 99;
    fontsize = 45;
    display_outline = true;
    outline_size = 3.5;
    pos_y = 15;
  } )
  ObjAttach( f.txt,f.spr );

  if locked then
    ObjSet( f.spr, { 
      color_r = 0.6;
      color_g = 0.6;
      color_b = 0.6;
    } )
    ObjSet( f.anm_lock, { alp = 1 } )
  else
    ObjSet( f.spr, { 
      color_r = 1;
      color_g = 1;
      color_b = 1;
    } )
    ObjSet( f.anm_lock, { alp = 0 } )
  end

  --gm.bar_add( f.obj, f, "hp", "hp_max" )
end;

function gm.foe_set( n, life )
  local f = gm.foes[ n ];
  f.hp = life
  ObjSet( f.txt, { text = f.hp } )
  if f.hp <= 0 then
    ObjSet( f.spr, { alp = 0 } )
  end
end

function gm.foe_damage( n, d )
  local d = d or 1;
  d = d > 0 and 1 or d
  local f = gm.foes[ n ];
  local o = ObjGet( f.spr )
  local t = 0.4;
  f.hp = f.hp - d;
  --ObjAnimate( o.name, 6,0,0, _, { 0,0,o.scale_x,o.scale_y, t*0.2,1,0.8,1.2, t*0.50,3,1.15,0.85, t*0.75,3,0.9,1.1, t*0.90,3,1.05,0.95, t,3,1,1 } );
  if f.hp <= 0 then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,0,0 } );
    --if gm.foe_choised == n then
    --  gm.foe_mdown( n );
    --end;
    f.hp = 0
    gm.berta_anim_play( "berta_aggression" )
    for k, v in pairs( gm.foes ) do
      if v.locked then
        gm.foe_unlock( k )
        break
      end
    end
  end;
  ObjSet( f.txt, { text = f.hp } )
end;

function gm.foe_is_all_dead()
  for k, v in pairs( gm.foes ) do
    if v.hp > 0 then
      return false
    end
  end
  return true
end

function gm.foe_restore_all()
  local unlock = false
  for k, v in pairs( gm.foes ) do
    gm.foe_set( k, v.hp )
    if v.hp <= 0 then
      unlock = true
    end
  end
  if unlock then
    for k, v in pairs( gm.foes ) do
      if v.Locked then
        gm.foe_unlock( k, true )
        break
      end
    end
  end
end

function gm.foe_reset_all()
  for k, v in pairs( gm.foes ) do
    gm.foe_set( k, gm.FOE_LIFE )
    --ObjSet( v.spr, { alp = 1; } )
    local o = ObjGet( v.spr )
    ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, 0.35,0,1 } )
  end
  for k, v in pairs( gm.foes ) do
    if v.Locked then
      v.locked = true
      --AnimPlay( v.anm_lock, "", nil );
      
      AnimStop( v.anm_lock )
      ObjSet( v.anm_lock, { animfunc = "lock", frame = 0 } )
      local o = ObjGet( v.anm_lock )
      ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, 0.35,0,1 } )
      --ObjSet( v.spr, { color_r = 0.4; color_g = 0.4; color_b = 0.4; } )
      local o = ObjGet( v.spr )
      ObjAnimate( o.name, 12,0,0, nil, { 0,0,o.color_r,o.color_g,o.color_b, 0.35,0,0.4,0.4,0.4 } )
      break
    end
  end
end

function gm.foe_unlock( n, restore )
  local f = gm.foes[ n ]
  local o = ObjGet( f.spr )
  f.locked = false;
  if restore then
    --ObjSet( f.anm_lock, { animfunc = "", frame = 0 } )
    ld.AnimPlay( f.anm_lock, "", nil )
    ObjSet( f.spr, { color_r = 1; color_g = 1; color_b = 1; } )
  else
    SoundSfx( "aud_unlock_greens" )
    ObjAnimate( f.spr, 12,0,0, nil, { 0,0,o.color_r,o.color_g,o.color_b, 0.35,0,1,1,1 } )
    --ObjAnimate( f.spr_lock, 8,0,0, nil, { 0,0,1, 0.35,0,0 } )
    ld.AnimPlay( f.anm_lock, "lock", function() ObjSet( f.anm_lock, { alp = 0 } ) end )
  end
end

function gm.foe_mdown( n )
  local t = 0.25
  local o = ObjGet( "obj_fightscr_foe_aim" )
  if not o then
    ObjCreate( "obj_fightscr_foe_aim", "obj" );
    ObjSet( "obj_fightscr_foe_aim", { input = 0, alp = 0, pos_x = gm.FOE_PLACE[ n ][ 1 ], pos_y = gm.FOE_PLACE[ n ][ 2 ], pos_z = 30 } );
    ObjAttach( "obj_fightscr_foe_aim", "obj_fightscr_foe_root" );

    ObjCreate( "spr_fightscr_foe_aim", "spr" );
    ObjSet( "spr_fightscr_foe_aim", { input = 0, res = "assets/levels/level/mg_fight/aim" } );
    ObjAttach( "spr_fightscr_foe_aim", "obj_fightscr_foe_aim" );

    o = ObjGet( "obj_fightscr_foe_aim" )
  end;

  if not gm.foe_choised then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,0,1 } )
    ObjAnimate( o.name, 3,0,0, _, { 0,0,o.pos_x,o.pos_y, t,3,gm.FOE_PLACE[ n ][ 1 ],gm.FOE_PLACE[ n ][ 2 ] } )
    gm.foe_choised = n;
  elseif gm.foe_choised == n then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, t,0,0 } )
    gm.foe_choised = false;
  elseif gm.foe_choised ~= n then
    ObjAnimate( o.name, 3,0,0, _, { 0,0,o.pos_x,o.pos_y, t,3,gm.FOE_PLACE[ n ][ 1 ],gm.FOE_PLACE[ n ][ 2 ] } )
    gm.foe_choised = n;
  end

end;

function gm.berta_anim_play( anim, func_end )
  local o = ObjGet( "anm_fightscr_anm_berta" )
  ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, 0.25,1,0 } )
  local o = ObjGet( "anm_fightscr_anm_berta_changer" )
  ObjAnimate( o.name, 8,0,0, nil, { 0,0,o.alp, 0.25,2,1 } )

  ld.AnimPlay( "anm_fightscr_anm_berta_changer", anim, function()
    ld.AnimPlay( "anm_fightscr_anm_berta", "berta", nil )
    ObjSet( "anm_fightscr_anm_berta", { alp = 1 } )
    ObjSet( "anm_fightscr_anm_berta_changer", { alp = 0 } )
    if func_end then
      func_end()
    end
  end )
end

function gm.counter_set( value )
  gm.hit_counter = value
  ObjSet( "txt_fightscr_hit_count", { text = value } )
end

function gm.counter_add( value )
  local value_now = gm.counter_get()
  value_now = value_now + value
  if value_now < 0 then
    value_now = 0;
  elseif value_now > gm.TURNS then
    value_now = gm.TURNS
  end
  if value_now <= 3 then
    SoundSfx( "aud_hits_left_red" )
    ld.AnimPlay( "anm_fightscr_anm_red", "red", nil )
  end
  gm.counter_set( value_now )
end

function gm.counter_get()
  return gm.hit_counter
end

function gm.save()
  ng_global.progress["scr"]["win_fightscr"].state = ng_global.progress["scr"]["win_fightscr"].state or {}
  local s = ng_global.progress["scr"]["win_fightscr"].state;
  s.map = gm.table_copy( gm.map )
  s.hit_counter = gm.hit_counter
  s.foes = gm.table_copy( gm.foes )
end;

gm.BAR_PW = 20
gm.BAR_BW = 100
function gm.bar_add( obj, massive, massive_value, massive_value_max, x, y )

  local x = x or GetObjPosByObj( obj )[1];
  local y = y or GetObjPosByObj( obj )[2] - gm.BAR_BW/2;
  local root = "obj_fightscr_lifebar_root";
  if not gm.bars then
    gm.bars = {};
    ObjCreate( root, "obj" );
    ObjSet( root, { input = 0, pos_z = 99 } );
    ObjAttach( root, "mg_fightscr" );
    ObjAnimate( root, 0,1,0, gm.bar_show, { 0,0,0, 0,0,0 } );
  end;
  local lb = { 
    obj = "obj_fightscr_lifebar_"..obj;
    name = obj;
    massive = massive;
    value = massive_value;
    value_max = massive_value_max;
  };
  gm.bars[ obj ] = lb;
  


  ObjCreate( lb.obj, "obj" )
  ObjSet( lb.obj, { input = 0, pos_x = x - gm.BAR_BW/2, pos_y = y } );
  ObjAttach( lb.obj, root );

  ObjCreate( lb.obj.."_red", "spr" )
  ObjSet( lb.obj.."_red", { scale_x = gm.BAR_BW/gm.BAR_PW, drawoff_x = gm.BAR_PW/2, pos_z = -3, res = "assets/levels/level/mg_fight/red" } );
  ObjAttach( lb.obj.."_red", lb.obj );

  ObjCreate( lb.obj.."_green", "spr" )
  ObjSet( lb.obj.."_green", { scale_x = gm.BAR_BW/gm.BAR_PW, drawoff_x = gm.BAR_PW/2, pos_z = 0, res = "assets/levels/level/mg_fight/green" } );
  ObjAttach( lb.obj.."_green", lb.obj );

end;

function gm.bar_show()
  for k, v in pairs( gm.bars ) do
    local m = v["massive"];
    local val = m[v.value];
    local val_old = v.value_old or 0;
    if val_old ~= val then
      if val > 0 then
        local val_max = m[v.value_max];
        ObjSet( v.obj.."_green", { scale_x = (gm.BAR_BW/gm.BAR_PW)*(val/val_max) } );
      else
        ObjAnimate( v.obj, 8,0,0, function() ObjDelete( v.obj ) end, { 0,0,1, 0.25,0,0 } );
        gm.bars[ k ] = nil;
      end;
      v.value_old = val;
    end;
  end;
end;


--[[*********************************]]
--[[     возвращает копию таблицы    ]]
--[[---------------------------------]]
function gm.table_copy( t )
  local out = {}
  for k,v in pairs( t ) do
    if type( v ) == "table" then
      out[k]=gm.table_copy( v );
    else
      out[k]=v;
    end;
  end;
  return out;
end;
--[[---------------------------------]]
--[[                                 ]]
--[[*********************************]]

function gm.ang_gip( x1, y1, x2, y2, len )
  y1 = -y1;
  y2 = -y2;
  len = len or gm.len( x1,y1,x2,y2 )
  if len == 0 then return 0,0 end;

  local k = (y2 - y1 ) / len;
  local a = math.abs( math.asin( k ) );
  if x2 >= x1 and y2 <= y1 then
    a = math.pi*2 - a
  elseif x2 >= x1 and y2 >= y1 then

  elseif x2 <= x1 and y2 <= y1 then
    a = math.pi + a
  elseif x2 <= x1 and y2 >= y1 then
    a = math.pi - a
  end;
  return a,len
end;

function gm.len( x1,y1,x2,y2 )
  return ( ( x1 - x2 ) ^ 2 + ( y1 - y2 ) ^ 2 ) ^ 0.5
end

function gm.table_show( t, space )
  space = space or "";
  local s = space
  for k,v in pairs( t ) do
    --local s = space
    if type( v ) == "table" then
      s = s.."\n"..space.."\t"..tostring(k).." :: "..tostring(v).."\n";
      --gm.print( s.."\t"..tostring(k).." ::" );
      s = s..gm.table_show( v, space.."\t" )
    else
      s = s.."\t"..tostring(k).." => "..tostring(v);
      --gm.print( s.."\t"..tostring(k).." => "..tostring(v) );
    end;
  end;
  if space == "" then gm.print( s ) end
  return s;
end;
