-- name=mg_onboxextscr
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_onboxextscr";
  --------------------------------------------------------------------------------------------
  --ld.NoteInit("spr_onboxextscr_paper_cl", "spr_onboxextscr_paper_open", "txt_onboxextscr_note" )
  --ld.NoteRelaseLock( "spr_onboxextscr_paper_cl" )
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_onboxextscr" ] = {type = "win", use_place = "mg_onboxextscr", room = "rm_shopext", zz = "mg_onboxextscr", zz_gate = "gmg_shopext_onboxextscr" };

  local win_onboxextscr_logic = function()
    if ld.CheckRequirements( {"win_onboxextscr"} ) then
      --ObjSet("spr_onboxextscr_dustext",{visible=1,active=1,input=1})
      ObjSet("gfx_onboxextscr_clk_note_1_zone",{visible=1,active=1,input=1})
      
    end
  end;
  local win_onboxext = function()
    if ld.CheckRequirements( {"win_onboxextscr"} ) then
      ObjSet("anm_onboxextscr_anim",{animfunc="opencap",frame=999})
      ObjSet("spr_onboxextscr_block_1",{visible=0,input=0})
      ObjSet("spr_onboxextscr_block_2",{visible=0,input=0})
      ObjSet("spr_onboxextscr_block_3",{visible=0,input=0})
      ObjSet("obj_onboxextscr_red",{visible=0,input=0})
      ObjSet("obj_onboxextscr_blue",{visible=0,input=0})
      ObjSet("obj_onboxextscr_step",{visible=0,input=0})
    end
  end;
  cmn.AddSubscriber("win_onboxextscr", win_onboxext, private.room_objname )
  cmn.AddSubscriber("win_onboxextscr", win_onboxextscr_logic )
  --------------------------------------------------------------------------------------------

--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_note_1" ] = { type = "click", use_place = "gfx_onboxextscr_clk_note_1_zone", room = "rm_shopext", zz = "mg_onboxextscr", zz_gate = "gmg_shopext_onboxextscr" };

private.clk_note_1_logic = function()
  
end;
private.clk_note_1_beg = function()
  --ObjDelete( "gfx_onboxextscr_clk_note_1_zone" );
  ObjSet("gfx_onboxextscr_clk_note_1_zone",{visible=0,active=0,input=0})
end;
private.clk_note_1_end = function()
  
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_note_1", private.clk_note_1_beg, private.room_objname );
cmn.AddSubscriber( "clk_note_1", private.clk_note_1_end, private.room_objname );
cmn.AddSubscriber( "clk_note_1", private.clk_note_1_logic );
cmn.AddSubscriber( "clk_note_1_beg", private.clk_note_1_beg, private.room_objname );
cmn.AddSubscriber( "clk_note_1_end", private.clk_note_1_end, private.room_objname );
cmn.AddSubscriber( "clk_note_1_end", private.clk_note_1_logic );
--------------------------------------------------------------------------------------------
function public.clk_note_1()

  local func_end = function()
    --cmn.SetEventDone( "clk_note_1" );
    --cmn.CallEventHandler( "clk_note_1_end" );
    private.localDone = true;
    ObjSet("gfx_onboxextscr_clk_note_2_zone",{visible=1,active=1,input=1})
    common_impl.Lock(0);
    if common_impl.ZzCompleteCheck( "clk_note_1" ) then cmn.GotoRoom( "rm_shopext" ); end;
  end;

  cmn.CallEventHandler( "clk_note_1_beg" );
  common_impl.Lock(1);

  --ld.AnimPlay( "", "", func_end );
  --SoundSfx( "##sfx##" )

  local t = 0.5;
  ObjAnimate("spr_onboxextscr_paper_cl",   8, 0, 0, _, {0,0,1, t,0,0});
  ObjAnimate("spr_onboxextscr_paper_open", 8, 0, 0, _, {0,0,0, t,0,1});
  
  ObjCreate( "spr_onboxextscr_poster", "spr" )
    ObjSet( "spr_onboxextscr_poster", { 
      visible=true;
      alp=0;
      input = 0;
      res = "assets/interface/resources/editor_back";
      color_r = 0; color_g = 0; color_b = 0;
      scale_x = 1366; scale_y = 512;
      pos_x=512;
      pos_y=384;
      pos_z = 99;
  } )
  ObjAttach( "spr_onboxextscr_poster" , "mg_onboxextscr");
  ObjAnimate( "spr_onboxextscr_poster", 8, 0, 0, "", {0,0,0, t,0,0.5} );
  ld.StartTimer(t+0.1,func_end)
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
common_impl.hint[ "clk_note_2" ] = { type = "click", use_place = "gfx_onboxextscr_clk_note_2_zone", room = "rm_shopext", zz = "mg_onboxextscr", zz_gate = "gmg_shopext_onboxextscr" };

private.clk_note_2_logic = function()
  ObjSet("spr_onboxextscr_dustext",{visible=1,active=1,input=1});
end;
private.clk_note_2_beg = function()
  ObjDelete( "gfx_onboxextscr_clk_note_2_zone" );
  ObjDelete( "gfx_onboxextscr_clk_note_1_zone" );
end;
private.clk_note_2_end = function()
  ObjDelete("spr_onboxextscr_paper_cl");
  ObjDelete("spr_onboxextscr_paper_open");
  ObjSet("gfx_onboxextscr_dustext",{visible=1,active=1})
end;
--------------------------------------------------------------------------------------------
cmn.AddSubscriber( "clk_note_2", private.clk_note_2_beg, private.room_objname );
cmn.AddSubscriber( "clk_note_2", private.clk_note_2_end, private.room_objname );
cmn.AddSubscriber( "clk_note_2", private.clk_note_2_logic );
cmn.AddSubscriber( "clk_note_2_beg", private.clk_note_2_beg, private.room_objname );
cmn.AddSubscriber( "clk_note_2_end", private.clk_note_2_end, private.room_objname );
cmn.AddSubscriber( "clk_note_2_end", private.clk_note_2_logic );
--------------------------------------------------------------------------------------------
function public.clk_note_2()

  local func_end = function()
    private.localDone=false;
    cmn.SetEventDone( "clk_note_1" );
    cmn.CallEventHandler( "clk_note_1_end" );
    cmn.SetEventDone( "clk_note_2" );
    cmn.CallEventHandler( "clk_note_2_end" );
    common_impl.Lock(0);
  if common_impl.ZzCompleteCheck( "clk_note_2" ) then cmn.GotoRoom( "rm_shopext" ); end;
  end;

  cmn.CallEventHandler( "clk_note_2_beg" );
  common_impl.Lock(1);
--
--  ld.AnimPlay( "", "", func_end );
--  SoundSfx( "##sfx##" )

  local t = 0.5;
  ObjAnimate( "spr_onboxextscr_poster", 8, 0, 0, "", {0,0,0.5, t,0,0} );
  ObjAnimate("spr_onboxextscr_paper_open", 0, 0, 0, func_end, {0,0,499, t,0,-800});
end;
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------
common_impl.hint[ "get_dustext" ] = { type = "get", get_obj = "spr_onboxextscr_dustext", room = "rm_shopext", zz = "mg_onboxextscr", zz_gate = "gmg_shopext_onboxextscr" };

private.get_dustext_logic = function()
  
end;
private.get_dustext_inv = function()
  interface.InventoryItemAdd("inv_dustext","spr_onboxextscr_dustext");
end;
private.get_dustext_beg = function()
  ObjDelete("gfx_onboxextscr_dustext")
end;
private.get_dustext_end = function()
  ObjDelete("spr_onboxextscr_dustext_sh")
end;

cmn.AddSubscriber( "get_dustext", private.get_dustext_inv );
cmn.AddSubscriber( "get_dustext", private.get_dustext_beg, private.room_objname );
cmn.AddSubscriber( "get_dustext", private.get_dustext_end, private.room_objname );
cmn.AddSubscriber( "get_dustext", private.get_dustext_logic );
--------------------------------------------------------------------
function public.get_dustext()
  cmn.SetEventDone( "get_dustext" );
  cmn.CallEventHandler( "get_dustext" );
  if common_impl.ZzCompleteCheck( "get_dustext" ) then cmn.GotoRoom( "rm_shopext" ); end;
  ld.ShowBbt("after_get_magicpowderext");
end
--------------------------------------------------------------------
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_onboxextscr"} ) then
  SoundMgTheme( true )
    cmn.MiniGameShow( "onboxextscr" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_shopext_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_onboxextscr"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "onboxextscr" );
  end
  if private.localDone  then
    ObjSet("gfx_onboxextscr_clk_note_1_zone",{visible=1,active=1,input=1})
    ObjSet("spr_onboxextscr_paper_cl",{alp=1})
    ObjSet("spr_onboxextscr_paper_open",{alp=0})
    ObjSet("gfx_onboxextscr_clk_note_2_zone",{visible=0,active=0,input=0})
    ObjDelete("spr_onboxextscr_poster")
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  
  ld.Lock(1);
  local t = 1;
  local func_end = function()
    gm.default();
    gm.set_all();
    gm.save();
    ObjAnimate("obj_onboxextscr_blue", 8, 0, 0, 
    function()
      gm.event_mdown(1,1)
      ld.Lock(0);
    end, 
                                                       {0,0,0, t,0,1});
    ObjAnimate("obj_onboxextscr_red",  8, 0, 0, _,        {0,0,0, t,0,1});
    
  end
  ObjAnimate("obj_onboxextscr_blue", 8, 0, 0, func_end, {0,0,1, t*0.75,0,0, t,0,0});
  ObjAnimate("obj_onboxextscr_red",  8, 0, 0, _,        {0,0,1, t*0.75,0,0});
  gm.hide_step_all();
end;
--*********************************************************************************************************************
function public.Skip()
  
  --ld.Lock(1);
  --local t = 1;
  --local func_end = function()
  --  
  --  for r=1,gm.N do
  --    for c=1,gm.N do
  --      if gm.state[r][c]>=0 then
  --        gm.state[r][c]=1;
  --        ObjSet( "spr_onboxextscr_blue_"..r.."_"..c, {visible=1,alp=1} )
  --        ObjSet( "spr_onboxextscr_red_"..r.."_"..c, {visible=0,alp=0} )
  --      end
  --    end
  --  end
  -- 
  --  gm.set_all();
  --  gm.save();
  --  ObjAnimate("obj_onboxextscr_blue", 8, 0, 0, private.Win, 
  --                                                     {0,0,0, t,0,1});
  --  ObjAnimate("obj_onboxextscr_red",  8, 0, 0, _,        {0,0,0, t,0,1});
  --  
  --end
  
  --ld.Lock(1);
  --local func_end = function()
  --  ld.AnimPlay("anm_onboxextscr_anim","opencap",private.Win);
  --end
  --ObjSet("obj_onboxextscr_blue",{input=0})
  --ObjSet("obj_onboxextscr_red",{input=0})
  --ObjSet("obj_onboxextscr_step",{input=0})
  --
  --ObjAnimate("obj_onboxextscr_blue", 8, 0, 0, func_end, {0,0,1, t,0,0});
  --ObjAnimate("obj_onboxextscr_red",  8, 0, 0, _,        {0,0,1, t,0,0});
  --ObjAnimate("obj_onboxextscr_step", 8, 0, 0, _,        {0,0,1, t,0,0});
  --
  --ObjAnimate("spr_onboxextscr_block_1", 8, 0, 0, _,        {0,0,1, t,0,0});
  --ObjAnimate("spr_onboxextscr_block_2", 8, 0, 0, _,        {0,0,1, t,0,0});
  --ObjAnimate("spr_onboxextscr_block_3", 8, 0, 0, _,        {0,0,1, t,0,0});
  
  private.Win();
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_onboxextscr" );
  cmn.CallEventHandler( "win_onboxextscr" );
  --if common_impl.ZzCompleteCheck( "win_onboxextscr" ) then cmn.GotoRoom( "rm_shopext" ); end;
  --interface_impl.ShowMgAchievements();
  rm_masterscr.go_back()
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide();
  SoundMgTheme( false )
  --ld.StartTimer( 0.5, private.WinEnd  ); 
  
  local func_end = function()
    ld.AnimPlay("anm_onboxextscr_anim","opencap",private.WinEnd);
  end
  
  SoundSfx( "aud_win_onboxext" )

  local t = 1;
  
  ObjSet("obj_onboxextscr_blue",{input=0})
  ObjSet("obj_onboxextscr_red",{input=0})
  ObjSet("obj_onboxextscr_step",{input=0})
  
  ObjAnimate("obj_onboxextscr_blue", 8, 0, 0, func_end, {0,0,1, t,0,0});
  ObjAnimate("obj_onboxextscr_red",  8, 0, 0, _,        {0,0,1, t,0,0});
  ObjAnimate("obj_onboxextscr_step", 8, 0, 0, _,        {0,0,1, t,0,0});
  
  ObjAnimate("spr_onboxextscr_block_1", 8, 0, 0, _,        {0,0,1, t,0,0});
  ObjAnimate("spr_onboxextscr_block_2", 8, 0, 0, _,        {0,0,1, t,0,0});
  ObjAnimate("spr_onboxextscr_block_3", 8, 0, 0, _,        {0,0,1, t,0,0});
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
    gm.default()
    if ng_global.progress["scr"]["win_onboxextscr"].state then
      gm.state = ld.TableCopy( ng_global.progress["scr"]["win_onboxextscr"].state )
    end
    gm.set_all();
    gm.loaded  = true;
    gm.event_mdown(1,1)
  else
  
  end;
end
--*********************************************************************************************************************
function gm.default()
  gm.mode = "playerMove"
  gm.N = 26;
  --if gm.state == nil then
    gm.state = {}
    for r=1,gm.N do
      gm.state[r] = {}
      for c=1,gm.N do
        local res = -1
        if ObjGet("spr_onboxextscr_blue_"..r.."_"..c) then
          res = 0;
        end
        gm.state[r][c] = res;
      end
    end
  --end
  
  gm.state[11][3]=1;
  gm.state[11][8]=1;
  gm.state[24][6]=1;
  
  gm.state[19][3]=2;
  gm.state[19][8]=2;
  gm.state[6][6]=2;
  
   
  --local x0 = 504;
  --local y0 = 102;
  --local w = 60;
  --local h = 52;
  
  for r=1,gm.N do
    for c=1,gm.N do
      if gm.state[r][c] >= 0 then
        local name = "spr_onboxextscr_blue_"..r.."_"..c;
        --local o1 = ObjGet(name)
        --local xc = o1.pos_x;
        --local yc = o1.pos_y;
        --s1 = gm.round( (xc-x0)/w );
        --s2 = gm.round( (yc-y0)/h );
        --xc = x0 + s1*w;
        --yc = y0 + s2*h - h/2;
        ObjSet(name,
        {
          event_mdown = function() gm.event_mdown(r,c); end; 
          input=1;
          alp=0;
          visible=0;
          --pos_x = xc;
          --pos_y = yc;
        });
        
        ObjSet("spr_onboxextscr_red_"..r.."_"..c, {input=0;alp=0;visible=0; 
        --pos_x=xc;pos_y=yc
        });
        ObjSet("spr_onboxextscr_step_"..r.."_"..c,{input=0;alp=0;visible=0; 
        --pox_x=xc;pos_y=yc
        });
      end
    end
  end
  
end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["scr"]["win_onboxextscr"].state = ld.TableCopy( gm.state );
end;
--*********************************************************************************************************************
function gm.build()
  
end
--*********************************************************************************************************************
function gm.set_all()
  for r=1,gm.N do
    for c=1,gm.N do
      local red = "spr_onboxextscr_red_"..r.."_"..c;
      local blue = "spr_onboxextscr_blue_"..r.."_"..c;
      local step = "spr_onboxextscr_step_"..r.."_"..c;
      if gm.state[r][c] >= 0 then
        ObjSet(step,{visible=0,alp=0})
      end
      if gm.state[r][c] == 1 then
        ObjSet(blue,{visible=1,alp=1})
      end
      if gm.state[r][c] == 2 then
        ObjSet(red,{visible=1,alp=1})
      end
    end
  end
end
--*********************************************************************************************************************
function gm.event_menter( obj )
  ld.ShCur(CURSOR_HAND)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/3,0,1 } )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( obj )
  ld.ShCur(CURSOR_DEFAULT)
  obj = obj and ( type( obj ) == "table" and obj.sender ) or obj or "";
  local o = ObjGet( obj.."_light" )
  if not o then o = ObjGet( obj.."_focus" ) end
  if o then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/3,0,0 } )
  end
end;
--*********************************************************************************************************************
gm.mode = "playerMove"
gm.stepActive = {}
gm.r0=1;
gm.c0=1;
function gm.event_mdown(r,c)
  
  if gm.mode == "playerMove" then
    
    -- Действие при клике на свою фишку (показать возможные ходы)
    gm.createStepActive(1)
    if #gm.stepActive>0 then
      gm.mode = "showStep";
    else
      gm.check_score();
    end
    
  elseif gm.mode == "showStep" then
    
    if ObjGet("spr_onboxextscr_step_"..r.."_"..c).alp>0 then
      -- Поставить фишку на свободное поле
      gm.hide_step_all();
      gm.put(r,c,"player");
    end
    
  end

end
--*********************************************************************************************************************
function gm.hide_step_all()
  if #gm.stepActive>0 then
    for n=1,#gm.stepActive do
      gm.hide_step_one(gm.stepActive[n][1],gm.stepActive[n][2])
    end
  end
  gm.stepActive={}
  
  for r=1,gm.N do
    for c=1,gm.N do
      local step = "spr_onboxextscr_step_"..r.."_"..c;
      if gm.state[r][c]>=0 then
      if ObjGet(step).alp==1 then
        ObjAnimate(step, 8, 0, 0, _, {0,0,1, 0.3,0,0});
      end
      end
    end
  end
  
end
--****************************
function gm.show_step_one(r,c)
  local step = "spr_onboxextscr_step_"..r.."_"..c;
  if ObjGet(step).alp==0 then
    ObjSet(step,{visible=1})
    
    ObjAnimate(step, 8, 0, 0,
    function() 
      ObjAnimate(step, 8, 1, 0, _, {0,0,0.1, 0.4,0,1,   0.8,0,0.1});
    end, {0,0,0, 0.15,0,0.1});
    
  end
end
function gm.hide_step_one(r,c)
  local step = "spr_onboxextscr_step_"..r.."_"..c;
  if ObjGet(step).alp>0 then
    ObjStopAnimate(step,8);
    ObjAnimate(step, 8, 0, 0, _, {0,0,ObjGet(step).alp, 0.3,0,0});
  end
end
--*********************************************************************************************************************
function gm.cpu_move()
  
  local index = 1;
    
    gm.createStepActive(2)
    
    if #gm.stepActive==0 then
      gm.check_score()
    else
      local rnd=math.random(1,#gm.stepActive)
      local profit = 0; 
      for n=1,#gm.stepActive do
        local nei = gm.get_neighbors( gm.stepActive[n][1],gm.stepActive[n][2] );
        local profitLocal = 0;
        if #nei>0 then
          for m=1,#nei do
            if gm.state[ nei[m][1] ][ nei[m][2] ] == 1 then
              profitLocal=profitLocal+1;
            end
          end
        end
        if profitLocal>profit then
          profit=profitLocal
          rnd=n;
        end
      end
      
      
      gm.put(gm.stepActive[rnd][1],gm.stepActive[rnd][2],"cpu")
    end
end
--*********************************************************************************************************************
function gm.createStepActive(side)
  gm.stepActive = {}
  local index=1;
    for r_all = 1,gm.N do
      for c_all = 1,gm.N do
        
        if gm.state[r_all][c_all]==side then  
          local neigh1 = gm.get_neighbors(r_all,c_all);
          
          if #neigh1>0 then
            for n1=1,#neigh1 do
              if gm.state[neigh1 [n1][1] ][ neigh1[n1][2] ] == 0 then
                gm.stepActive[index] = {}
                gm.stepActive[index][1] = neigh1[n1][1]
                gm.stepActive[index][2] = neigh1[n1][2]
                
                if side==1 then
                gm.show_step_one(neigh1[n1][1],neigh1[n1][2]);
                end
                
                index=index+1;
              end
              
              local neigh2 = gm.get_neighbors( neigh1[n1][1],neigh1[n1][2] );
              if #neigh2>0 then
                for n2=1,#neigh2 do
                  if gm.state[neigh2 [n2][1] ][ neigh2[n2][2] ] == 0 then
                    gm.stepActive[index] = {}
                    gm.stepActive[index][1] = neigh2[n2][1]
                    gm.stepActive[index][2] = neigh2[n2][2]
                    if side==1 then
                    gm.show_step_one(neigh2[n2][1],neigh2[n2][2]);
                    end
                    index=index+1;
                  end
                end
              end
            
            end
            
          end
        end
        
      end
    end
end
--*********************************************************************************************************************
function gm.put(r,c,playerType)
  
  local t = 0.5;
  local prefix1 = "blue";
  local prefix2 = "red";
  local side = 1;
  local prefix3 = "frost"
  if playerType ~= "player" then
    prefix1 = "red";
    prefix2 = "blue";
    side = 2;
    prefix3 = "fire"
  end
  
  local func_end = function()
    --проверка, если рядом есть вражеские фишки, то захватить их
    
    
    local func_end_end = function()
      
      local player_end = true;
      local cpu_end = true;
      for r=1,gm.N do
        for c=1,gm.N do
          if gm.state[r][c]==1 then
            player_end=false;
          end
          if gm.state[r][c]==2 then
            cpu_end=false;
          end
        end
      end
      if cpu_end then
        public.Skip();
      elseif player_end then
        public.Reset();
      end
      
      if not player_end and not cpu_end then
        if playerType ~= "player" then
          gm.save()
          gm.mode = "playerMove";
          gm.event_mdown(1,1)
          ld.Lock(0);
        else
          gm.cpu_move();
        end
      end
    end
    
    local fast_end=true;
    local nei = gm.get_neighbors(r,c);
    if #nei>0 then
      
      local o = ObjGet("spr_onboxextscr_"..prefix1.."_"..r.."_"..c)
      local sfx_need = false
      for n=1,#nei do
        local field = gm.state[ nei[n][1] ][ nei[n][2] ] 
        if field > 0 and gm.state[r][c]~=field and (nei[n][1]~=r or nei[n][2]~=c) then
          local rr =  nei[n][1] 
          local cc =  nei[n][2] 
          local fadeUp = "spr_onboxextscr_"..prefix1.."_"..rr.."_"..cc 
          local fadeDown = "spr_onboxextscr_"..prefix2.."_"..rr.."_"..cc 
          
          ObjSet(fadeUp,{visible=1})
          ObjAnimate(fadeUp, 8, 0,0, _, {0,0,0, t,0,1});

          ObjSet(fadeDown,{visible=1})
          ObjAnimate(fadeDown, 8, 0,0, _, {0,0,1, t,0,0});
          
          local x1 = o.pos_x;
          local y1 = o.pos_y;
          local x2 = ObjGet(fadeDown).pos_x;
          local y2 = ObjGet(fadeDown).pos_y;
          local angd = gm.ang_gip(x1,y1,x2,y2);
          
          local spark = "fx_onboxextscr_"..prefix3.."_"..n;
          ObjSet(spark,{pos_x=o.pos_x,pos_y=o.pos_y;active=1;visible=1;ang=angd+math.pi/2});
          PartSysStart(spark)
          ld.StartTimer(1,function() PartSysStop(spark,0); end)
         
          sfx_need = true
 
          --ld.StartTimer(1,function() ObjSet(spark,{active=0;visible=0})  end)
            
          gm.state[rr][cc]=side
          fast_end=false;
        end
      end
      if sfx_need then
        SoundSfx( prefix3 == "frost" and "aud_freeze" or "aud_burn" )
      end
    end
    if fast_end==false then
      ld.StartTimer(t*1.05,func_end_end)
    else
      func_end_end()
    end
  end
  --кладётся одна фишка
  ld.Lock(1);
  SoundSfx( "aud_clk_slot" )
  ObjSet("spr_onboxextscr_"..prefix1.."_"..r.."_"..c,{visible=1})
  ObjAnimate("spr_onboxextscr_"..prefix1.."_"..r.."_"..c, 8, 0,0, func_end, {0,0,0, t,0,1});
  if gm.state[r][c]>0 then
    ObjSet("spr_onboxextscr_"..prefix2.."_"..r.."_"..c,{visible=1})
    ObjAnimate("spr_onboxextscr_"..prefix2.."_"..r.."_"..c, 8, 0,0, _, {0,0,1, t,0,0});
  end
  gm.state[r][c]=side
end
--*********************************************************************************************************************

--*********************************************************************************************************************
gm.neighbors_r_1 = {-1,1, -1,1, -2,2};gm.neighbors_c_1 = {0,  0, 1,1, 0,0};
gm.neighbors_r_2 = {-1,1, -1,1, -2,2};gm.neighbors_c_2 = {-1,-1, 0,0, 0,0};--чётный случай
function gm.get_neighbors(r,c)
  local flag1 = r%2;
  local neighbors_r;
  local neighbors_c;
  
  if flag1==0 then
    neighbors_r=gm.neighbors_r_2
    neighbors_c=gm.neighbors_c_2
  end
  if flag1==1 then
    neighbors_r=gm.neighbors_r_1
    neighbors_c=gm.neighbors_c_1
  end
  
  local index = 1;
  local res = {}
  for n=1,#neighbors_r do
    local rr =r+neighbors_r[ n ];
    local cc =c+neighbors_c[ n ];
    if gm.state[rr][cc] >= 0 then
      res[index]={}
      res[index][1] = rr
      res[index][2] = cc
      index=index+1;
    end
  end
  return res;
end
--*********************************************************************************************************************
function gm.check_cell_over()
  
  local player_end = true;
  local cpu_end = true;
  
  for r=1,gm.N do
    for c=1,gm.N do
      if gm.state[r][c]==1 then
        player_end=false;
      end
      if gm.state[r][c]==2 then
        cpu_end=false;
      end
    end
  end
  
  if cpu_end then
    public.Skip();
  elseif player_end then
    public.Reset();
  end
  
end
--*********************************************************************************************************************
function gm.check_score()
  
  local player_score = 0;
  local cpu_score = 0;
  
  for r=1,gm.N do
    for c=1,gm.N do
      if gm.state[r][c]==1 then
        player_score=player_score+1;
      end
      if gm.state[r][c]==2 then
        cpu_score=cpu_score+1;
      end
    end
  end
  
  if player_score>cpu_score then
    public.Skip();
  else
    public.Reset();
  end
  
end
--*********************************************************************************************************************
--function gm.angle(x1,y1,x2,y2)
--  if x1==x2 then
--    if y1>y2 then
--      return -math.pi/2;
--    end
--    if y1<y2 then
--      return math.pi/2;
--    end
--    if y1==y2 then
--      return 0;
--    end
--  else
--    return math.atan( (x2-x1)/(y2-y1) )
--  end
--end
function gm.ang_gip( x1, y1, x2, y2, len )
  x2 = x2 or 0;
  y2 = y2 or 0;
  len = len or ( (x1-x2)^2 +(y1-y2)^2 )^0.5
  y1=-y1; --переворот для игровой системы координат
  y2=-y2; --переворот для игровой системы координат
  if len == 0 then return 0,0 end --исключение
  local k = ( y1 - y2 ) / len
  local a = math.abs( math.asin( k ) )
  if x2 >= x1 and y2 <= y1 then
    a = math.pi*2 - a
    return a,len
  elseif x2 >= x1 and y2 >= y1 then
    return a,len
  elseif x2 <= x1 and y2 <= y1 then
    a = math.pi + a
    return a,len
  elseif x2 <= x1 and y2 >= y1 then
    a = math.pi - a
    return a,len
  end;
end
--*********************************************************************************************************************
function gm.ang_norm( ang )
  while ang > math.pi * 2 do ang = ang - math.pi * 2 end
  while ang < 0 do ang = ang + math.pi * 2 end
  return ang
end;
--*********************************************************************************************************************
function gm.round( x )
  local dx = x - math.floor(x);
  if dx>=0.5 then
    res = math.ceil(x);
  else 
    res = math.floor(x);
  end
  return res
end
