-- name=mg_statuemgscr
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_statuemgscr";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_statuemgscr" ] = {type = "win", use_place = "mg_statuemgscr", room = "rm_shop", zz = "mg_statuemgscr", zz_gate = "gmg_shop_statuemgscr" };

  local win_statuemgscr_logic = function()
    if ld.CheckRequirements( {"win_statuemgscr"} ) then
      
    end
  end;
  local win_statuemg = function()
    if ld.CheckRequirements( {"win_statuemgscr"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_statuemgscr", win_statuemg, private.room_objname )
  cmn.AddSubscriber("win_statuemgscr", win_statuemgscr_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_statuemgscr"} ) then
    cmn.MiniGameShow( "statuemgscr" );
    SoundMgTheme( true )
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_shop_env" )
  
  gm.default()
  if ng_global.progress["scr"]["win_statuemgscr"].state then
    gm.state = ld.TableCopy( ng_global.progress["scr"]["win_statuemgscr"].state );
  end
  
  local stage1_done = true;
  for n=1,6 do
    if not gm.state.stage1[n] then
      stage1_done=false;
      ObjSet("spr_statuemgscr_deer_"..n,{inputrect_init=false, input=1,drag=1,
        event_startdrag = function()  gm.stage1_startdrag(n) end;
        event_dragdrop  = function()  gm.stage1_dragdrop(n)  end;
        event_menter    = function()  gm.stage1_menter(n)    end;
        event_mleave    = function()  gm.stage1_mleave(n)    end;
      })
    else
        
      ObjSet("spr_statuemgscr_deer_"..n.."_sh",{visible=0});  
      
      if n==2 or n==3 then
        ObjSet("obj_statuemgscr_place_"..(n+1),{inputrect_y=0,inputrect_h=200,inputrect_w=107});
      end
        
      if n==3 then
        ObjSet("spr_statuemgscr_deer_3_trash",{alp=1})
      end  
      ObjSet("spr_statuemgscr_deer_"..n,{ang=0,pos_z=n,pos_x=gm.etalon1x[n], pos_y=gm.etalon1y[n], pos_x=gm.etalon1x[n], pos_y=gm.etalon1y[n], inputrect_init=false,  input=1,drag=0})
      ObjAttach("spr_statuemgscr_deer_"..n, "obj_statuemgscr_step_1")
      
    end
  end
  
  if stage1_done then
    ObjSet("obj_statuemgscr_step_1",{visible=0,input=0})
    ObjSet("obj_statuemgscr_step_2",{visible=1,input=1})
    ObjSet("anm_statuemgscr_anm",{frame=999,animfunc="colors",visible=1,alp=1})
    ObjSet("anm_statuemgscr_anm_paper",{frame=999})
    ObjSet("spr_statuemgscr_brush",{input=1,alp=1,visible=1,pos_z=10})
    
    for c=1,5 do
      
      local obj = "spr_statuemgscr_deer"..c.."_color_"..gm.state.stage2[c];
      ObjSet(obj,{pos_z=1,alp=1,visible=1})
      ObjAttach(obj,ObjGetRelations(obj).parent)
      if gm.state.stage2[c]>0 then
        ObjSet("spr_statuemgscr_deer"..c.."_color_0",{alp=0})
      end
    end
    ObjSet("spr_statuemgscr_brush_color"..gm.state.stage2[6],{alp=1});
    gm.brush_color = gm.state.stage2[6];
    
    
  else
    
    ObjSet("obj_statuemgscr_step_1",{visible=1,input=1})
    ObjSet("obj_statuemgscr_step_2",{visible=0,input=0})
  end
  
  
  
  
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_statuemgscr"} ) then
    cmn.MiniGameHide( "statuemgscr" );
    SoundMgTheme( false )
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  ng_global.progress["scr"]["win_statuemgscr"].state=nil;
  
  local func_reset_step_1 = function()
    local detail = 1;
    for s=1,6 do
      if gm.state.stage1[s] then
        detail=detail+1;
      end
    end
    
    if detail>1 then
      
      local func_end = function()
        ld.Lock(0);
        gm.default()
      end
      SoundSfx( "aud_wrong_deer_part" )
      ld.Lock(1);
      ObjSet("obj_statuemgscr_place_"..(3),{inputrect_y=170,inputrect_h=30,inputrect_w=40})
      ObjSet("obj_statuemgscr_place_"..(4),{inputrect_y=170,inputrect_h=30,inputrect_w=40})
      ObjSet("obj_statuemgscr_step_2",{input=0})
      local t_anim = 0.5;
      ld.StartTimer(t_anim,func_end)
      for n=2,6 do
        if gm.state.stage1[n] then
          local obj = "spr_statuemgscr_deer_"..n;
          ObjAnimate(obj, 3, 0, 0, "", {0, 0, gm.etalon1x[n],gm.etalon1y[n],    t_anim,0, gm.init1x[n],gm.init1y[n]});
          ObjAnimate(obj, 7, 0, 0, "", {0, 0, 0,   t_anim, 0, gm.init1_ang[n]});
          ObjSet(obj,{pos_z=gm.init1z[n],
            inputrect_init=false, input=1,drag=1,
            event_startdrag = function()  gm.stage1_startdrag(n) end;
            event_dragdrop  = function()  gm.stage1_dragdrop(n)  end;
            event_menter    = function()  gm.stage1_menter(n)    end;
            event_mleave    = function()  gm.stage1_mleave(n)    end;
          })
          
          if n==3 then
            ObjSet("spr_statuemgscr_deer_3_trash",{alp=0})
          end
          
          if ObjGet(obj.."_sh") then
            ObjSet(obj.."_sh",{alp=0,visible=1})
            ObjAnimate(obj.."_sh", 8, 0, 0, "", {0, 0, 0,  t_anim-0.15,0,0,  t_anim, 0, 1});
          end
        end
      end
      
      local n=2;
      local obj = "spr_statuemgscr_deer_"..n;
      ObjSet(obj,{pos_z=gm.init1z[n],
        inputrect_init=false, input=1,drag=1,
        event_startdrag = function()  gm.stage1_startdrag(n) end;
        event_dragdrop  = function()  gm.stage1_dragdrop(n)  end;
        event_menter    = function()  gm.stage1_menter(n)    end;
        event_mleave    = function()  gm.stage1_mleave(n)    end;
      })
        
    end
  end
  
  
  
  
  
  
  
  if ObjGet("obj_statuemgscr_step_1").input then
    
    
    func_reset_step_1()
    
  else
    --
    ld.Lock(1);
    local t_anim = 0.9;
    ObjAnimate("obj_statuemgscr_step_2", 8, 0, 0, "", {0,0,1,   t_anim*0.5,0,1,   t_anim,0,0});
    ObjSet("obj_statuemgscr_step_1",{visible=1,alp=0})
    ObjAnimate("obj_statuemgscr_step_1", 8, 0, 0, "", {0,0,0,   t_anim*0.5,0,1,   t_anim,0,1});
    ObjAnimate("anm_statuemgscr_anm",    8, 0, 0, "", {0,0,1,   t_anim*0.5, 0, 0});
    ObjAnimate("anm_statuemgscr_anm_paper",    8, 0, 0, "", {0,0,1,   t_anim*0.5, 0, 0});
    
    
    ObjAnimate("spr_statuemgscr_brush",  8, 0, 0, "", {0,0,1,   t_anim*0.3, 0, 0});
    ObjSet("spr_statuemgscr_brush",{input=0})
    
    ld.StartTimer(t_anim, 
    function()
      
      ObjSet("spr_statuemgscr_brush_color1",{alp=0})
      ObjSet("spr_statuemgscr_brush_color2",{alp=0})
      ObjSet("spr_statuemgscr_brush_color3",{alp=0})
      for n=1,5 do
        for c=1,3 do
          local obj = "spr_statuemgscr_deer"..n.."_color_"..c;
          ObjSet(obj,{alp=0})
        end
        ObjSet("spr_statuemgscr_deer"..n.."_color_0",{alp=1})
      end
      gm.brush_color = 0;
      gm.state.stage2 = {0,0,0, 0,0,0}
      
      ObjSet("obj_statuemgscr_step_1",{input=1});
      ObjSet("anm_statuemgscr_anm",{frame=0,alp=0});
      ObjSet("anm_statuemgscr_anm_paper",{frame=0,alp=1})
      func_reset_step_1();
    end
    )
    
  end
end;
--*********************************************************************************************************************
function public.Skip()
  
  if ObjGet("obj_statuemgscr_step_1").input then
    
    local t_anim = 0.64
    
    for n=2,6 do
      if not gm.state.stage1[n] then
        local obj = "spr_statuemgscr_deer_"..n;
        ObjAnimate(obj, 3, 0, 0, "", {0, 0, gm.init1x[n],gm.init1y[n],    t_anim,0,   gm.etalon1x[n],gm.etalon1y[n]});
        ObjAnimate(obj, 7, 0, 0, "", {0, 0, gm.init1_ang[n],   t_anim, 0, 0});
        ObjSet(obj,{pos_z=n,
          inputrect_init=false, input=0,drag=0,
          event_startdrag = function()   end;
          event_dragdrop  = function()   end;
          event_menter    = function()   end;
          event_mleave    = function()   end;
        })
        
        if ObjGet(obj.."_sh") then
          ObjSet(obj.."_sh",{alp=0,visible=1})
          ObjAnimate(obj.."_sh", 8, 0, 0, "", {0, 0, 1,  0.15,0,0});
        end
      end
    end
    
    if ObjGet("spr_statuemgscr_deer_3_trash").alp==0 then
      ObjAnimate("spr_statuemgscr_deer_3_trash", 8, 0, 0, "", {0, 0, 0,  t_anim-0.15,0,0,  t_anim, 0, 1});
    end
    
    ld.StartTimer(t_anim,private.Win)
    
  else
    private.Win();
  end
  
  
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.ShCur(CURSOR_DEFAULT);
  ld.Lock(0);
  --cmn.SetEventDone( "win_statuemgscr" );
  --cmn.CallEventHandler( "win_statuemgscr" );
  --cmn.GotoRoom( "rm_shop" );
  --interface_impl.ShowMgAchievements();
  rm_masterscr.go_back()
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);

  cmn.MiniGameHide();
  SoundMgTheme( false )
  
  SoundSfx( "aud_win_statuemg" )
  
  ObjAnimate("anm_statuemgscr_anm_win", 8, 0, 0, 
  function()
    ld.AnimPlay("anm_statuemgscr_anm_win","final",private.WinEnd)
  end, {0, 0, 0, 0.4, 0, 1});
  
  
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************

--*********************************************************************************************************************
function gm.default()
  gm.state = {};
  gm.state.stage1 = {true,false,false, false,false,false};
  gm.state.stage2 = {0,0,0,0,0,0};
  
  gm.etalon1x = {}
  gm.etalon1y = {}
  gm.etalon1x[1] = 519;
  gm.etalon1y[1] = 604;
  gm.etalon1x[2] = 624;
  gm.etalon1y[2] = 410;
  gm.etalon1x[3] = 527;
  gm.etalon1y[3] = 429;
  gm.etalon1x[4] = 427;
  gm.etalon1y[4] = 435;
  gm.etalon1x[5] = 374;
  gm.etalon1y[5] = 351;
  gm.etalon1x[6] = 412;
  gm.etalon1y[6] = 151;
  
  gm.init1x = {};
  gm.init1y = {};
  gm.init1z = {};
  gm.init1_ang = {}
  for m=1,6 do
    gm.init1x[m] = ObjGet( "spr_statuemgscr_deer_"..m).pos_x;
    gm.init1y[m] = ObjGet( "spr_statuemgscr_deer_"..m).pos_y;
    gm.init1z[m] = ObjGet( "spr_statuemgscr_deer_"..m).pos_z;
    gm.init1_ang[m] = ObjGet( "spr_statuemgscr_deer_"..m).ang;
  end
  
  gm.etalon2 = {}
  gm.etalon2[1] = 1;
  gm.etalon2[2] = 3;
  gm.etalon2[3] = 2;
  gm.etalon2[4] = 3;
  gm.etalon2[5] = 2;
  
  gm.brush_set_x = {932,883,794}
  gm.brush_set_y = {274+150,148+150,270+150}
  
  
  if not gm.poly1x then
    gm.poly1x = {}
    gm.poly1y = {}
    
    gm.poly2x = {}
    gm.poly2y = {}
    
    gm.poly3x = {}
    gm.poly3y = {}
    
    gm.poly4x = {}
    gm.poly4y = {}
    
    gm.poly5x = {}
    gm.poly5y = {}


    -- poly1
    local doit = true;
    local n = 1;
    while doit do
      local name = "obj_statuemgscr_deer1_point_"..n;
      if ObjGet(name) then
        gm.poly1x[n] = ObjGet(name).pos_x;
        gm.poly1y[n] = ObjGet(name).pos_y;
        n=n+1;
      else
        doit=false;
        break;
      end
    end
    
    -- poly2
    doit = true;
    n = 1;
    while doit do
      local name = "obj_statuemgscr_deer2_point_"..n;
      if ObjGet(name) then
        gm.poly2x[n] = ObjGet(name).pos_x;
        gm.poly2y[n] = ObjGet(name).pos_y;
        n=n+1;
      else
        doit=false;
        break;
      end
    end
    
    -- poly3
    doit = true;
    n = 1;
    while doit do
      local name = "obj_statuemgscr_deer3_point_"..n;
      if ObjGet(name) then
        gm.poly3x[n] = ObjGet(name).pos_x;
        gm.poly3y[n] = ObjGet(name).pos_y;
        n=n+1;
      else
        doit=false;
        break;
      end
    end
    
    -- poly4
    doit = true;
    n = 1;
    while doit do
      local name = "obj_statuemgscr_deer4_point_"..n;
      if ObjGet(name) then
        gm.poly4x[n] = ObjGet(name).pos_x;
        gm.poly4y[n] = ObjGet(name).pos_y;
        n=n+1;
      else
        doit=false;
        break;
      end
    end
    
    -- poly5
    doit = true;
    n = 1;
    while doit do
      local name = "obj_statuemgscr_deer5_point_"..n;
      if ObjGet(name) then
        gm.poly5x[n] = ObjGet(name).pos_x;
        gm.poly5y[n] = ObjGet(name).pos_y;
        n=n+1;
      else
        doit=false;
        break;
      end
    end
        
  end
  
  
  
  ObjSet("spr_statuemgscr_brush",{
    event_menter     = function() gm.step2_menter() end;
    event_mleave     = function() gm.step2_mleave() end;
    event_startdrag  = function() gm.step2_startdrag() end;
    event_dragdrop   = function() gm.step2_dragdrop() end;
  })
  
end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["scr"]["win_statuemgscr"].state = ld.TableCopy( gm.state )
end;
--*********************************************************************************************************************




--*********************************************************************************************************************
function gm.stage1_startdrag(n)
  ld.ShCur(CURSOR_NULL);
  local obj = "spr_statuemgscr_deer_"..n; 
  gm.pos_x_drag = ObjGet(obj).pos_x;
  gm.pos_y_drag = ObjGet(obj).pos_y;
  gm.pos_z_drag = ObjGet(obj).pos_z;
  gm.ang_drag   = ObjGet(obj).ang;
  
  ObjSet(obj,{pos_z=31,ang=0,inputrect_init=true})
  
  if ObjGet(obj.."_sh") then
    ObjSet(obj.."_sh",{visible=0})
  end

  SoundSfx( "aud_drag_deerpart" )
end
--*********************************************************************************************************************


--*********************************************************************************************************************
function gm.stage1_dragdrop(n)
  ld.ShCur(CURSOR_DEFAULT);
  
  local obj = "spr_statuemgscr_deer_"..n; 
  local o = ObjGet(obj);
  
  if (ObjIntersect( "spr_statuemgscr_deer_"..n, "obj_statuemgscr_place_"..(n) ) and (gm.state.stage1[n-1] or n==2 or n==3 or n==4) ) then
    SoundSfx( "aud_deerpart" )
    local func_end = function()
      ObjSet(obj,{
        inputrect_init=false,  input=1,drag=0,
        event_startdrag = function() end;
        event_dragdrop  = function() end;
        event_menter    = function() end;
        event_mleave    = function() end;
      })
      
      
        
      
      if n==2 or n==3 then
        ObjSet("obj_statuemgscr_place_"..(n+1),{inputrect_y=0,inputrect_h=200,inputrect_w=107})
      end
      
      if n==3 then
        ObjSet("spr_statuemgscr_deer_3_trash",{alp=1})    
      end
      
      
      local detail = 1;
      for s=1,6 do
        if gm.state.stage1[s] then
          detail=detail+1;
        end
      end
      
      if detail==6 then
        
        local func_end = function()
          ObjSet("obj_statuemgscr_step_1",{visible=0,input=0})
          ObjSet("obj_statuemgscr_step_2",{visible=1,input=1})
          ObjSet("spr_statuemgscr_brush",{input=1,alp=1,visible=1,pos_z=10})
          gm.state.stage1[n]=true;
          gm.save();
          ld.Lock(0);
        end
        
        local func_step = function()
          ObjSet("spr_statuemgscr_brush",{visible=1,alp=0})
          ObjAnimate("spr_statuemgscr_brush", 8, 0, 0, func_end, {0, 0, 0,   0.6, 0, 0,     0.9,0,1});
          ObjSet("anm_statuemgscr_anm",{alp=1,visible=1})
          ld.AnimPlay("anm_statuemgscr_anm_paper","paper","")
          ld.AnimPlay("anm_statuemgscr_anm","colors","")
        end
        
        
        
        
        
        ObjSet("anm_statuemgscr_anm_win",{visible=1,alp=0})
        --gm.sparkle("anm_statuemgscr_anm_win");
        --gm.sparkle("obj_statuemgscr_step_1");
        --gm.sparkle("obj_statuemgscr_step_2");

        --SoundSfx( "aud_paintsonthetable" )
        SoundSfx( "aud_deer_complete" )
        
        for l=1,6 do
          gm.sparkle("spr_statuemgscr_deer_"..l)
        end
        for l=1,5 do
          gm.sparkle("spr_statuemgscr_deer"..l.."_color_0")
          
        end
        
        local t = 1.2;
        ObjSet("obj_statuemgscr_step_2",{visible=1,alp=0})
        ObjAnimate("obj_statuemgscr_step_2", 8, 0, 0, "", {0,0,0,  t*0.5,0,1});
        ObjAnimate("obj_statuemgscr_step_1", 8, 0, 0, "", {0,0,1,  t*0.7,0,1,  t,0,0});
        ld.StartTimer(t,func_step)
        
        
      else
        gm.state.stage1[n]=true;
        gm.save();
        ld.Lock(0);
      end
      
      
      
    end
    ld.Lock(1);
    local t_anim = 0.7;
    ObjSet(obj,{pos_z=n});
    
    local curs = GetZoomCursorPos();
    
    gm.sparkle(obj);
    
    
    if n==6 then
      ObjAnimate(obj, 3, 0, 0,func_end, {0,0,curs[1],curs[2],     t_anim*0.9,0,gm.etalon1x[n],gm.etalon1y[n]-10,     t_anim,0,gm.etalon1x[n],gm.etalon1y[n]});
    else
      ObjAnimate(obj, 3, 0, 0,func_end, {0,0,curs[1],curs[2],  t_anim,0,gm.etalon1x[n],gm.etalon1y[n]});
    end
    ObjAnimate(obj, 7, 0, 0, ""     , {0,0,o.ang,            t_anim,0,0});
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
  else
    
    local move_in_void = true;

    for l=1,6 do
      if ObjIntersect( "spr_statuemgscr_deer_"..n, "spr_statuemgscr_deer_"..(l) ) and gm.state.stage1[l] then
        
        local func_end = function()
          ObjSet(obj,{pos_z=gm.pos_z_drag,ang=gm.ang_drag,inputrect_init=false})
          if ObjGet(obj.."_sh") then
            ObjSet(obj.."_sh",{visible=1})
          end
          ld.Lock(0);
        end
        
        local func_step = function()
          local t = 0.25;
          ObjAnimate(obj, 3, 0, 0, func_end, {0, 0, ObjGet(obj).pos_x, ObjGet(obj).pos_y,   t, 0, gm.pos_x_drag, gm.pos_y_drag});
          ObjAnimate(obj, 7, 0, 0, "",       {0, 0, 0,                                      t, 0, gm.ang_drag});
          
          if ObjGet(obj.."_sh") then
            ObjSet(obj.."_sh",{visible=1,alp=0})
            ObjAnimate(obj.."_sh", 8, 0, 0, "", {0,0,0,   t-0.15,0,0,   t,0,1});
          end
          
        end
        
        move_in_void = false;
        ld.Lock(1)
        local curs = GetZoomCursorPos();
        ObjSet(obj,{pos_x=curs[1],pos_y=curs[2]});
        ObjAnimate(obj, 7, 0, 0, func_step, {0,0,0,    0.2,0,-0.1,   0.3,0,0.1,  0.4,0,0});
        
        break;
      end
    end
    
    if move_in_void then
      ObjSet(obj,{pos_z=gm.pos_z_drag,ang=gm.ang_drag,inputrect_init=false})
      if ObjGet(obj.."_sh") then
        ObjSet(obj.."_sh",{visible=1})
      end
    else
      SoundSfx( "aud_wrong_deer_part" )
    end
    
  end
end
--*********************************************************************************************************************


--*********************************************************************************************************************
function gm.stage1_menter(n)
  ld.ShCur(CURSOR_GET);
end
--*********************************************************************************************************************



--*********************************************************************************************************************
function gm.stage1_mleave(n)
  ld.ShCur(CURSOR_DEFAULT);
end
--*********************************************************************************************************************





























--------------------------------------------------------------------------------
                              ---  STEP 2 ---
--------------------------------------------------------------------------------

--ObjSet("spr_statuemgscr_brush",{
--    event_menter     = function() gm.step2_menter() end;
--    event_mleave     = function() gm.step2_mleave() end;
--    event_startdrag  = function() gm.step2_startdrag() end;
--    event_dragdrop   = function() gm.step2_dragdrop() end;
--  })


function gm.step2_menter()
  ld.ShCur(CURSOR_GET);
end

function gm.step2_mleave()
  if not gm.brushing then
    ld.ShCur(CURSOR_DEFAULT);
  end
end


function gm.step2_startdrag()
  ld.ShCur(CURSOR_NULL);
  ObjSet("spr_statuemgscr_brush",{ang=1.26})
  SoundSfx( "aud_drag_brush" )
end


function gm.step2_dragdrop()
  SoundSfx( "aud_drop_brush" )
  gm.brushing = false;
  
  for b = 1,3 do
    if ObjIntersect("obj_statuemgscr_color_place_"..b,"spr_statuemgscr_brush_point") then
      gm.brushing = true;
      gm.brush_color = b;
      break;
    end
  end
  
  
  if gm.brushing then
    
    if gm.brush_color ~= gm.state.stage2[6] then
      SoundSfx( "aud_brush_to_paints" )
      local func_end = function()
        gm.state.stage2[6]=gm.brush_color;
        gm.save()
        ObjSet("spr_statuemgscr_brush",{pos_x=709,pos_y=353})
        ObjStartDrag("spr_statuemgscr_brush")
        
        ld.Lock(0)
        gm.brushing=false
      end
      
      local obj = "spr_statuemgscr_brush"
      ld.Lock(1);
      ld.ShCur(CURSOR_NULL)
      
      local curs = GetZoomCursorPos();
      local t_step = 0.1;   
      ObjAnimate(obj, 7, 0, 0, func_end, {0, 0, 1.26,    t_step, 0, 1.57079,  t_step*4,0,1.57079,   t_step*5,0,1.26});
      ObjAnimate(obj, 3, 0, 0, "", {
      0,  0,     curs[1],curs[2],  
      t_step,0,  gm.brush_set_x[gm.brush_color],gm.brush_set_y[gm.brush_color]-25,  
      t_step*2,0,gm.brush_set_x[gm.brush_color],gm.brush_set_y[gm.brush_color],   
      t_step*3,0,gm.brush_set_x[gm.brush_color],gm.brush_set_y[gm.brush_color]-25,  
      t_step*4,0,gm.brush_set_x[gm.brush_color],gm.brush_set_y[gm.brush_color],
      t_step*5,0,curs[1],curs[2],  
      });
        
      ObjAnimate("spr_statuemgscr_brush_color"..gm.brush_color, 8, 0, 0, "", {0,0,0, 1,0,1});
      for cl = 1,3 do
        if ObjGet("spr_statuemgscr_brush_color"..cl).alp>0 and cl~=gm.brush_color then
          ObjAnimate("spr_statuemgscr_brush_color"..cl, 8, 0, 0, "", {0,0,1, 1,0,0});
        end
      end
    else
      -- --ObjDoNotDrop("spr_statuemgscr_brush"); 
    end
    
    
  end
  
  
  
  
  if not gm.brushing then
  

  
  local painting = false;
  local res = 0;
  local curs = GetZoomCursorPos();
  local line1 = {}
  local line2 = {}
  --line1.x1 = curs[1]-42;
  --line1.y1 = curs[2]+130;
  line1.x1 = curs[1];
  line1.y1 = curs[2];
  line1.x2 = line1.x1+1500;
  line1.y2 = line1.y1+50;
    
  ObjSet("obj_statuemgscr_pos",{pos_x=line1.x1, pos_y=line1.y1})
  
  local ind = 0;
  
  --mane
  if not painting then
    res=0
    for p=1,((#gm.poly3x)-1) do
      line2.x1 = gm.poly3x[p]
      line2.y1 = gm.poly3y[p]
      line2.x2 = gm.poly3x[p+1]
      line2.y2 = gm.poly3y[p+1]
      if gm.line_line_collision( line1, line2 ) then
        res = res + 1;
      end
    end
    --ld.LogTrace("hittest poly3, res="..res)
    if res%2 == 1 then
      painting=true;
      ind=3;
    end
  end
  
  
  --body
  if not painting then
    res=0
    for p=1,((#gm.poly2x)-1) do
      line2.x1 = gm.poly2x[p]
      line2.y1 = gm.poly2y[p]
      line2.x2 = gm.poly2x[p+1]
      line2.y2 = gm.poly2y[p+1]
      if gm.line_line_collision( line1, line2 ) then
        res = res + 1;
      end
    end
    
    --ld.LogTrace("hittest poly2, res="..res)
    if res%2 == 1 then
      painting=true;
      ind=2;
    end
  end
  
  
  
  --pedestal
  if not painting then
    res=0
    for p=1,((#gm.poly1x)-1) do
      line2.x1 = gm.poly1x[p]
      line2.y1 = gm.poly1y[p]
      line2.x2 = gm.poly1x[p+1]
      line2.y2 = gm.poly1y[p+1]
      if gm.line_line_collision( line1, line2 ) then
        res = res + 1;
      end
    end
    --ld.LogTrace("hittest poly1, res="..res)
    
    if res%2 == 1 then
      painting=true;
      ind=1;
    end
  end
  
  
  
  
  
  
  
  
  
  --horns
  if not painting then
    res=0
    for p=1,((#gm.poly5x)-1) do
      line2.x1 = gm.poly5x[p]
      line2.y1 = gm.poly5y[p]
      line2.x2 = gm.poly5x[p+1]
      line2.y2 = gm.poly5y[p+1]
      if gm.line_line_collision( line1, line2 ) then
        res = res + 1;
      end
    end
    --ld.LogTrace("hittest poly5, res="..res)
    if res%2 == 1 then
      painting=true;
      ind=5;
    end
  end
  
  --head
  if not painting then
    res=0
    for p=1,((#gm.poly4x)-1) do
      line2.x1 = gm.poly4x[p]
      line2.y1 = gm.poly4y[p]
      line2.x2 = gm.poly4x[p+1]
      line2.y2 = gm.poly4y[p+1]
      if gm.line_line_collision( line1, line2 ) then
        res = res + 1;
      end
    end
    --ld.LogTrace("hittest poly4, res="..res)
    if res%2 == 1 then
      painting=true;
      ind=4;
    end
  end
  
  
  
  
  
  
  
  
  
  if not painting then
    ObjSet("spr_statuemgscr_brush",{ang=0});
    if not gm.brushing then
      ld.ShCur(CURSOR_DEFAULT);
      SoundSfx( "aud_drop_brush" )
    end
  else
    if ind>0 and gm.brush_color then
      SoundSfx( "aud_paint_deer" )
      gm.step2_painting(ind,gm.brush_color)
    else
      -- --ObjDoNotDrop("spr_statuemgscr_brush");
    end
  end
  
  end
end










function gm.step2_painting(n,c)
  
  if c >0 and gm.state.stage2[n] ~= c then
    
    
    
    local func_end = function()
      
      for other_c = 1,3 do
        if c ~= other_c then
          local obj_other = "spr_statuemgscr_deer"..n.."_color_"..other_c;
          if ObjGet(obj_other).alp>0 then
            ObjSet(obj_other,{pos_z=-1,alp=0})  
          end
        end
      end
      gm.state.stage2[n] = c;
      
      
      
      local right_colored = 0;
      for k = 1,5 do
        if gm.state.stage2[k]==gm.etalon2[k] then
          right_colored=right_colored+1;
        end
      end
      
      if right_colored==5 then
        ObjAnimate("spr_statuemgscr_brush", 8, 0, 0, "", {0, 0, 1, 0.3, 0, 0});
        private.Win();
      else
        ObjStartDrag("spr_statuemgscr_brush");
        ObjSet("spr_statuemgscr_brush",{pos_x=709,pos_y=353})
        gm.save();
        ld.Lock(0);
      end
      
    end
    
    
    
    
    ld.Lock(1);
    local t = 0.5;
    ld.StartTimer(t,func_end)
    
    for other_c = 0,3 do
      if c ~= other_c then
        local obj_other = "spr_statuemgscr_deer"..n.."_color_"..other_c;
        if ObjGet(obj_other).alp>0 then
          ObjSet(obj_other,{pos_z=0.5})  
        end
      end
    end
    
    local obj = "spr_statuemgscr_deer"..n.."_color_"..c;
    ObjSet(obj,{pos_z=1})
    ObjAnimate(obj, 8, 0, 0, "", {0,0,0, t,0,1});
    
    local curs = GetZoomCursorPos();
    ObjSet("spr_statuemgscr_brush",{pos_x=curs[1],pos_y=curs[2]})
    ObjAnimate("spr_statuemgscr_brush", 7, 0, 0, "", {0, 0, 1.26,   t*0.25,0,1.2,  t*0.5,0,1.3,   t*0.75,0,1.2,   t,0,1.26});
    ObjAnimate("spr_statuemgscr_brush", 3, 0, 0, "", {0, 0, curs[1],curs[2],   
      t*0.25, 0, curs[1]-15,curs[2]-10,
      t*0.5,  0, curs[1]+15,curs[2]+10,
      t*0.75, 0, curs[1]-15,curs[2]-10,
      t,      0, curs[1],curs[2]
    });
    
  else
    -- --ObjDoNotDrop("spr_statuemgscr_brush");
    
  end
    
end






















--------------------------------------------------------------------------------
                          ---  ADDITIONAL / OTHER ---
--------------------------------------------------------------------------------
function gm.line_line_collision( line1, line2 )
--ld.LogTrace( line1, line2 )

  if (    line1.x1 > line2.x1
      and line1.x1 > line2.x2
      and line1.x2 > line2.x1
      and line1.x2 > line2.x2
     ) 
    or 
    (     line1.x1 < line2.x1
      and line1.x1 < line2.x2
      and line1.x2 < line2.x1
      and line1.x2 < line2.x2
     )
    or
     (    line1.y1 > line2.y1
      and line1.y1 > line2.y2
      and line1.y2 > line2.y1
      and line1.y2 > line2.y2
     ) 
    or 
    (     line1.y1 < line2.y1
      and line1.y1 < line2.y2
      and line1.y2 < line2.y1
      and line1.y2 < line2.y2
     )
  then
    --[[ не пересекаются ]]
      return false;
  end

  line1.y1 = -line1.y1; --переворот для игровой системы координат
  line1.y2 = -line1.y2; --переворот для игровой системы координат
  line2.y1 = -line2.y1; --переворот для игровой системы координат
  line2.y2 = -line2.y2; --переворот для игровой системы координат

  local zk1 = ( line1.x1 - line1.x2 )
  local zk2 = ( line2.x1 - line2.x2 )
  local k1
  local k2
  local b1
  local b2
  local x, y
  local n = 0
  if zk1 == 0 and zk2 == 0 then
    --[[ паралельные прямые отностительно У ]]
    line1.y1 = -line1.y1; --переворот для игровой системы координат
    line1.y2 = -line1.y2; --переворот для игровой системы координат
    line2.y1 = -line2.y1; --переворот для игровой системы координат
    line2.y2 = -line2.y2; --переворот для игровой системы координат
    return false
  elseif zk1 == 0 then
    k2 = ( line2.y1 - line2.y2 ) / zk2;
    x = line1.x1
    y = k2 * ( line1.x1 - line2.x1 ) + line2.y1
  elseif zk2 == 0 then
    k1 = ( line1.y1 - line1.y2 ) / zk1;
    x = line2.x1
    y = k1 * ( line2.x1 - line1.x1 ) + line1.y1
  else
    k1 = ( line1.y1 - line1.y2 ) / zk1;
    k2 = ( line2.y1 - line2.y2 ) / zk2;
    b1 = line1.y1 - k1 * line1.x1
    b2 = line2.y1 - k2 * line2.x1
    x = ( b2 - b1 ) / ( k1 - k2 )
    y = k2 * x + b2
    x = x
  end

  y=-y

  line1.y1 = -line1.y1; --переворот для игровой системы координат
  line1.y2 = -line1.y2; --переворот для игровой системы координат
  line2.y1 = -line2.y1; --переворот для игровой системы координат
  line2.y2 = -line2.y2; --переворот для игровой системы координат

  --ld.LogTrace( line1, line2, n, k1, b1, k2, b2, x, y )

  if   ( (x > line1.x1 and x > line1.x2) or (x > line2.x1 and x > line2.x2) )
    or ( (x < line1.x1 and x < line1.x2) or (x < line2.x1 and x < line2.x2) )
    or ( (y > line1.y1 and y > line1.y2) or (y > line2.y1 and y > line2.y2) )
    or ( (y < line1.y1 and y < line1.y2) or (y < line2.y1 and y < line2.y2) )
  then
    return false
  end

  --ld.LogTrace( line1, line2, n, k1, b1, k2, b2, x, y )

  --local line1_xmin;
  --local line1_xmax;
  --if line1.x1 > line1.x2 then
  --  line1_xmin = line1.x2;
  --  line1_xmax = line1.x1;
  --else
  --  line1_xmin = line1.x1;
  --  line1_xmax = line1.x2;
  --end
  --
  --local line2_xmin;
  --local line2_xmax;
  --if line2.x1 > line2.x2 then
  --  line2_xmin = line2.x2;
  --  line2_xmax = line2.x1;
  --else
  --  line2_xmin = line2.x1;
  --  line2_xmax = line2.x2;
  --end
  
  
  --if x<line1_xmin or x<line2_xmin or x>line1_xmax or x>line2_xmax then
  --  return false
  --end
  
  
  
  return { pos_x = x, pos_y = y }

end;


-- simple effect from HO -------------------------------------------------------
function gm.sparkle(object_name)
  local collect_name  = "pfx_int_taskpanel_collect_"..object_name;
  ObjDelete( collect_name );
  ObjCreate( collect_name, "partsys" );
  
  ObjSet( collect_name,{
    res = "assets/interface/resources/effects_ho",
    pos_x = 0, pos_y = 0,
    active = 1, visible = 1, input = 0, pos_z = 32, blendmode = 2;
  });
  local parent = ObjGetRelations(object_name).parent
  ObjAttach( collect_name, parent );
  
  PartSysSetMaskObj( collect_name, object_name );  
  ld.StartTimer( 5, function() ObjDelete( collect_name ) end )
end
-- simple effect from HO -------------------------------------------------------
