-- name=mg_yardextscr
private.game = {};
local gm = private.game;
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "mg_yardextscr";
  --------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------
  common_impl.hint[ "win_yardextscr" ] = {type = "win", use_place = "mg_yardextscr", room = "rm_nearcastleext", zz = "mg_yardextscr", zz_gate = "gmg_nearcastleext_yardextscr" };

  local win_yardextscr_logic = function()
    if ld.CheckRequirements( {"win_yardextscr"} ) then
      
    end
  end;
  local win_yardext = function()
    if ld.CheckRequirements( {"win_yardextscr"} ) then
      
    end
  end;
  cmn.AddSubscriber("win_yardextscr", win_yardext, private.room_objname )
  cmn.AddSubscriber("win_yardextscr", win_yardextscr_logic )
  --------------------------------------------------------------------------------------------

--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************

end;
--*********************************************************************************************************************
function public.Open()
  if not ld.CheckRequirements( {"win_yardextscr"} ) then
  SoundMgTheme( true )
    cmn.MiniGameShow( "yardextscr" );
  end
end;
--*********************************************************************************************************************
function public.PreOpen()
  SoundEnv( "aud_mansion_env" )
  gm.load();
end;
--*********************************************************************************************************************
function public.Close()
  if not ld.CheckRequirements( {"win_yardextscr"} ) then
    SoundMgTheme( false )
    cmn.MiniGameHide( "yardextscr" );
  end
end;
--*********************************************************************************************************************
function public.PreClose()
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function public.Reset()
  if ld.Lock( 1 ) then
    gm.reset()
  end
end;
--*********************************************************************************************************************
function public.Skip()
  if ld.Lock( 1 ) then
    private.Win();
  end
end;
--*********************************************************************************************************************
function private.WinEnd()
  ld.Lock(0);
  cmn.SetEventDone( "win_yardextscr" );
  cmn.CallEventHandler( "win_yardextscr" );
  --if common_impl.ZzCompleteCheck( "win_yardextscr" ) then cmn.GotoRoom( "rm_hallext" ); end;
  --interface_impl.ShowMgAchievements();
  rm_masterscr.go_back()
end;
--*********************************************************************************************************************
function private.Win()
  ld.Lock(1);
  cmn.MiniGameHide();
  SoundMgTheme( false )
  ObjAnimate( "obj_yardextscr_root", 8,0,0, nil, { 0,0,1, gm.T,0,0 } )
  ld.AnimPlay( "anm_yardextscr_anm", "opengame", private.WinEnd )
end;
--*********************************************************************************************************************
--*********************************************************************************************************************
-- function *** GAME *** () end;
--*********************************************************************************************************************
--*********************************************************************************************************************
function gm.load()
  if not gm.loaded then
  
    gm.default()
    if ng_global.progress["scr"]["win_yardextscr"].state then
      gm.player = ld.TableCopy( ng_global.progress["scr"]["win_yardextscr"].state.player )
      gm.lights = ld.TableCopy( ng_global.progress["scr"]["win_yardextscr"].state.lights )
    end
    gm.build()
    gm.set_all()
  
    gm.loaded  = true;
  else
  
  end;
end
--*********************************************************************************************************************
function gm.default()
  gm.T = 0.4
  gm.W = 54.25
  gm.map = {
    --{ 0,0,0,0,0,0,0,0,0,0,0};
    --{0,0,0,0,0,0,0,1,0,0,0 };
    --{ 0,1,1,1,1,1,1,1,1,0,0};
    --{0,1,1,@,@,@,@,*,1,1,0 };
    --{ 0,1,@,@,1,@,1,@,@,0,0};
    --{0,1,@,1,1,1,1,1,@,1,0 };
    --{ 0,1,@,1,@,1,@,1,@,0,0};
    --{0,1,1,@,@,@,@,@,@,1,0 };
    --{ 0,1,1,1,1,1,1,1,1,0,0};
    --{0,0,0,0,0,0,0,0,0,0,0 };

    --{ 0,0,0,0,0,0,0,0,0,0,0};
    --{0,0,0,0,0,0,0,1,0,0,0 };
    --{ 0,1,1,1,1,1,1,1,1,0,0};
    --{0,1,@,@,@,@,@,@,@,1,0 };
    --{ 0,1,@,1,@,1,@,@,1,0,0};
    --{0,1,1,@,1,@,@,@,1,1,0 };
    --{ 0,1,1,@,1,1,1,@,1,0,0};
    --{0,1,1,1,*,@,@,@,@,1,0 };
    --{ 0,1,1,1,1,1,1,1,1,0,0};
    --{0,0,0,0,0,0,0,0,0,0,0 };

    { 0,0,0,0,0,0,0,0,0,0,0};
    {0,0,0,0,0,0,0,1,0,0,0 };
    { 0,1,1,1,1,1,1,1,1,0,0};
    {0,1,1,1,1,1,1,1,1,1,0 };
    { 0,1,1,1,1,1,1,1,1,0,0};
    {0,1,1,1,1,1,1,1,1,1,0 };
    { 0,1,1,1,1,1,1,1,1,0,0};
    {0,1,1,1,1,1,1,1,1,1,0 };
    { 0,1,1,1,1,1,1,1,1,0,0};
    {0,0,0,0,0,0,0,0,0,0,0 };
  }
  gm.player = {
    x = 2;
    y = 9;
  }
  gm.lights = { 
    { x = 8; y = 4; step = 1; path = { 6,1,5,6,5,4,3,5,4,3,5,4,3,3,2,2,6,2,1,6,2,1 } };
    { x = 5; y = 7; step = 1; path = { 3,3,3,3,1,1,1,5,6,1,2,3,1,1,5,5,6,6,4,4,4,4 } };
  }
  gm.defaults_check()
end
--*********************************************************************************************************************
function gm.defaults_check()
  if not gm.defaults then
    gm.defaults = {}
    gm.defaults.player = ld.TableCopy( gm.player );
    gm.defaults.lights = ld.TableCopy( gm.lights );
  else
    for k, v in pairs( gm.defaults ) do
      if not ld.TableEquals( v, gm[ k ] ) then
        return false
      end
    end
    return true
  end
end
--*********************************************************************************************************************
function gm.save()
  ng_global.progress["scr"]["win_yardextscr"].state = {
    player = ld.TableCopy( gm.player );
    lights = ld.TableCopy( gm.lights );
  }
end;
--*********************************************************************************************************************
function gm.build()
  --for j = 1, #gm.map do
  --  for i = 1, #gm.map[ j ] do
  --    if gm.map[ j ][ i ] > 0 then
  --      local obj = "spr_yardextscr_control_"..i.."_"..j
  --      ObjCreate( obj, "spr" )
  --      ObjSet( obj, { 
  --        res = "assets/levels/levelext/mg_yardext/step";
  --        pos_x = gm.get_pos_x( i, j );
  --        pos_y = gm.get_pos_y( i, j );
  --      } )
  --      ObjAttach( obj, "mg_yardextscr" )
  --      if ( j % 2 ) ~= 0 then
  --        ObjCreate( obj.."_z", "spr" )
  --        ObjSet( obj.."_z", { 
  --          res = "assets/levels/levelext/mg_yardext/chip";
  --          input = 0;
  --        } )
  --        ObjAttach( obj.."_z", obj )
  --      end
  --    end
  --  end
  --end
  for i = 1, 6 do
    ObjSet( "spr_yardextscr_player_step_"..i, {
      event_mdown = function() gm.event_mdown( i ) end;
      event_menter = function() gm.event_menter( i ) end;
      event_mleave = function() gm.event_mleave( i ) end;
      alp = 0;
    } )
  end
end
--*********************************************************************************************************************
function gm.set_all()
  ObjSet( "obj_yardextscr_player", { 
    pos_x = gm.get_pos_x( gm.player.x, gm.player.y );
    pos_y = gm.get_pos_y( gm.player.x, gm.player.y );
    --pos_z = gm.get_pos_z( gm.player.x, gm.player.y );
  } )
  for i = 1, #gm.lights do
  ObjSet( "obj_yardextscr_light_"..i, { 
    pos_x = gm.get_pos_x( gm.lights[ i ].x, gm.lights[ i ].y );
    pos_y = gm.get_pos_y( gm.lights[ i ].x, gm.lights[ i ].y );
    --pos_z = gm.get_pos_z( gm.lights[ i ].x, gm.lights[ i ].y );
  } )
  end
end
--*********************************************************************************************************************
function gm.reset()
  if not gm.defaults_check() then
    SoundSfx( "aud_cat_reset" )
    ObjSet( "fx_yardextscr_anm_chip", { active = 1 } )
    PartSysRestart( "fx_yardextscr_anm_chip" )
    --ObjSet( "spr_yardextscr_player", { alp = 0 } )
    ObjAnimate( "spr_yardextscr_player", 8,0,0, gm.player_move_end, { 0,0,1, gm.T * 0.5,0,0 } )
    gm.default()
    for i = 1, #gm.lights do
      local o = ObjGet( "obj_yardextscr_light_"..i )
      local pos_x = gm.get_pos_x(gm.lights[ i ].x, gm.lights[ i ].y)
      local pos_y = gm.get_pos_y(gm.lights[ i ].x, gm.lights[ i ].y)
      ObjAnimate( o.name, 3,0,0, nil, { 
        0,0,o.pos_x,o.pos_y, 
        gm.T,0,o.pos_x,o.pos_y, 
        gm.T*2,3,pos_x,pos_y 
      } )
    end
    ld.StartTimer( gm.T*2, function() 
      gm.set_all()
      ObjAnimate( "spr_yardextscr_player", 8,0,0, gm.player_move_end, { 0,0,0, gm.T,0,1 } )
    end )
  else
    ld.Lock( 0 )
  end
end
--*********************************************************************************************************************
function gm.win_check()
  return gm.player.x == 8 and gm.player.y == 2
end;
--*********************************************************************************************************************
function gm.event_mdown( num )
  if ld.Lock( 1 ) then
    SoundSfx( "aud_clk_slot" )
    gm.light_move( 1 )
    gm.light_move( 2 )
    gm.player_move( num )
  end
end
--*********************************************************************************************************************
function gm.event_menter( num )
  if gm.is_wolkable_way( gm.player.x, gm.player.y, num  ) then
    ld.ShCur(CURSOR_HAND)
    gm.player_way_light( num, 1 )
  end
end;
--*********************************************************************************************************************
function gm.event_mleave( num )
  if gm.is_wolkable_way( gm.player.x, gm.player.y, num  ) then
    ld.ShCur(CURSOR_DEFAULT)
  end
  gm.player_way_light( num, 0 )
end;
--*********************************************************************************************************************
function gm.player_way_light( num, alp )
  local o = ObjGet( "spr_yardextscr_player_step_"..num )
  if alp == 0 then
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (o.alp)/4,2,0 } )
  else
    ObjAnimate( o.name, 8,0,0, _, { 0,0,o.alp, (1-o.alp)/4,2,1 } )
  end
end
function gm.player_move_end()
  local lose = gm.is_player_on_light( 1 ) or gm.is_player_on_light( 2 )
  if lose then 
    gm.reset()
  elseif gm.win_check() then
    private.Win()
  else
    gm.save()
    ld.Lock( 0 )
  end
end
function gm.player_move( way )
  local t = gm.T
  local o = ObjGet( "obj_yardextscr_player" )
  local w = gm.get_ways( gm.player.y )[ way ]
  local x_next = gm.player.x + w[ 1 ]
  local y_next = gm.player.y + w[ 2 ]
  local pos_x_next = gm.get_pos_x( x_next, y_next )
  local pos_y_next = gm.get_pos_y( x_next, y_next )
  --local pos_z_next = gm.get_pos_z( x_next, y_next )
  gm.player.x = x_next
  gm.player.y = y_next
  
  --ObjAnimate( o.name, "pos_z",0,0, gm.player_move_end, { 0,0,o.pos_z, t,1,pos_z_next } )
  ObjAnimate( "spr_yardextscr_player", 0,0,0, function() 
    ObjSet( "spr_yardextscr_player", { pos_x = 0; pos_y = 0; } )
    ObjSet( o.name, { pos_x = pos_x_next; pos_y = pos_y_next; } )
  end, { 0,0,0, t,3,pos_x_next-o.pos_x } )
  --ObjAnimate( "spr_yardextscr_player", 1,0,0, gm.player_move_end, { 0,0,0, t*0.5,2,(pos_y_next-o.pos_y) * 0.5 - gm.W*0.5, t,1,pos_y_next-o.pos_y } )
  ObjAnimate( "spr_yardextscr_player", 1,0,0, gm.player_move_end, { 0,0,0, t,3,pos_y_next-o.pos_y } )
  --ObjAnimate( "spr_yardextscr_player", 6,0,0, gm.player_move_end, { 0,0,1,1, t*0.5,2,1.1,1.1, t,1,1,1 } )
end
function gm.light_move( num )
  local t = gm.T
  local o = ObjGet( "obj_yardextscr_light_"..num )
  local light = gm.lights[ num ]
  local way = light.path[ light.step ]
  light.step = light.step % #light.path + 1
  local w = gm.get_ways( light.y )[ way ]
  local x_next = light.x + w[ 1 ]
  local y_next = light.y + w[ 2 ]
  local pos_x_next = gm.get_pos_x( x_next, y_next )
  local pos_y_next = gm.get_pos_y( x_next, y_next )
  --local pos_z_next = gm.get_pos_z( x_next, y_next )
  light.x = x_next
  light.y = y_next
  --ObjAnimate( o.name, "pos_z",0,0, nil, { 0,0,o.pos_z, t,1,pos_z_next } )
  ObjAnimate( o.name, 3,0,0, nil, { 0,0,o.pos_x,o.pos_y, t,3,pos_x_next,pos_y_next } )
end
function gm.is_player_on_light( num )
  local light = gm.lights[ num ]
  local ways = gm.get_ways( light.y )
  for w = 1, #ways do
    if gm.is_wolkable_way( light.x, light.y, w ) then
      local x_next = light.x + ways[ w ][ 1 ]
      local y_next = light.y + ways[ w ][ 2 ]
      if x_next == gm.player.x and y_next == gm.player.y then
        return true
      end
    end
  end
  return false
end
function gm.is_wolkable_way( x, y, way )
  w = gm.get_ways( y )[ way ]
  if gm.map[ y + w[ 2 ] ][ x + w[ 1 ] ] == 1 then
    return true
  else
    return false
  end
end
function gm.get_pos_y( x, y )
  return 17 + y * gm.W*0.76 + x * 15 + ( y % 2 ) * 8
end
function gm.get_pos_x( x, y )
  return 417 + x * gm.W + ( y % 2 ) * 28 - y * 44
end
function gm.get_pos_z( x, y )
  return #gm.map * #gm.map[ 1 ] * 10 * y + #gm.map[ 1 ] * 10 * x;
end
function gm.get_ways( y )
  if y % 2 == 0 then
    return { { 1, 0 }; { 0, -1 }; { -1, -1 }; { -1, 0}; { -1, 1 }; { 0, 1 }; }
  else
    return { { 1, 0 }; { 1, -1 }; { 0, -1 }; { -1, 0}; { 0, 1 }; { 1, 1 }; }
  end
end
