-- name=rm_masterscr
--*********************************************************************************************************************
function public.Init()
  --------------------------------------------------------------------------------------------
  private.room_objname = "rm_masterscr";
  --------------------------------------------------------------------------------------------
end
--*********************************************************************************************************************
-- function *** PROGRESS MISC *** () end;
--*********************************************************************************************************************
function public.Load()

end;
--*********************************************************************************************************************
function public.Open()

end;
--*********************************************************************************************************************
function public.go_back()
    local mgho_objname = ng_global.MOD_MASTERSCR_GOTO_ROOM;
    local mgho = ld.StringDivide( mgho_objname )[ 2 ];
    if ld.CheckRequirements( { "win_"..mgho } ) then
      ng_global.progress["scr"]["win_"..mgho]={}
      ng_global.progress["scr"]["win_"..mgho].done = 0
      ng_global.progress["scr"]["win_"..mgho].start = 0
      if ng_global.progress["scr"]["opn_"..mgho] then
        ng_global.progress["scr"]["opn_"..mgho].done = 0
      end
    end



    ng_global.is_scr = true;
    ng_global.MOD_MASTERSCR_GOTO_ROOM = false

    common.LevelSwitch( "menu", "game" )
end;
--*********************************************************************************************************************
  function public.Gate_MDown( gate, zz_pos_beg )
    local rm = ld.StringDivide( gate )[ 3 ]
    public.GotoRoom( "rm_"..rm )
  end;
  --------------------------------------------------------------------------------------
  function public.Gate_MEnter( gate, cursor )
    local rm = ld.StringDivide( gate )[ 3 ]:gsub( "scr$", "" )
    common_impl.PopupShow( rm )
    local o = ObjGet( gate.."_focus" )
    if o then ObjAnimate( gate.."_focus", 8,0,0, "", { 0,0,o.alp, ((1-o.alp)^0.5)/3,2,1 } ) end;
    ld.ShCur(cursor or CURSOR_UP)
  end;
  --------------------------------------------------------------------------------------
  function public.Gate_MLeave( gate, cursor )
    common_impl.PopupHide()
    ld.ShCur( cursor or CURSOR_DEFAULT );
    local o = ObjGet( gate.."_focus" )
    if o then ObjAnimate( gate.."_focus", 8,0,0, "", { 0,0,o.alp, (o.alp)/1,2,0 } ) end;
  end;
--*********************************************************************************************************************
function public.MorphRmInit( room )
  
  private.MorphRmInitProgress = private.MorphRmInitProgress or 0
  private.MorphRmInitProgress = private.MorphRmInitProgress + 1

  local div = ld.StringDivide( room )
  local rm = div[ 2 ]
  local anm_init = "anm_"..rm.."_init"
  ObjCreate( anm_init, "anim" )
  ObjSet( anm_init, { res = "assets/levels/levelscr/"..room.."/anim_morph_"..rm } )
  ObjAttach( anm_init, room )
  local pos_morph_funcs = ObjGet( anm_init ).anim_funcs
  --ld.LogTrace( pos_morph_funcs )
  for i = 1, #pos_morph_funcs do
    local func_div = ld.StringDivide( pos_morph_funcs[ i ] )
    local morph_type = func_div[ 2 ]
    local morph_num = tonumber( func_div[ 3 ] ) or ""
  
    local obj_anm  = "anm_"..morph_type..morph_num.."scr";

    ObjCreate( obj_anm, "anim" )
    ObjSet( obj_anm, { 
      res = "assets/levels/levelscr/"..room.."/anim_morph_"..rm; 
      pos_x = -171;
      animfunc = pos_morph_funcs[ i ];
    } )
    ObjAttach( obj_anm, room )

    --ld.LogTrace( pos_morph_funcs[ i ], morph_type, morph_num, obj_anm, room )

    local obj_rect  = "obj_"..morph_type..morph_num.."scr";
    ObjCreate( obj_rect, "obj" )
    ObjSet( obj_rect, { 
      anim_tag = "morph";
      input = 0;
      --pos_x = 111;
      --pos_y = 111;
    } )
    ObjAttach( obj_rect, obj_anm )

    local obj_spr  = "spr_"..morph_type..morph_num.."scr";
    ObjCreate( obj_spr, "spr" )
    ObjSet( obj_spr, { 
      res = "assets/levels/levelscr/"..room.."/"..morph_type.."_"..morph_num; 
      event_mdown = function() public.GetPartQuest( morph_type , morph_num ) end;
      --event_menter = function() ld.ShCur(CURSOR_GET) end;
      --event_mleave = function() ld.ShCur(CURSOR_DEFAULT) end;
      --pos_x = 111;
      --pos_y = 111;
    } )
    ObjAttach( obj_spr, obj_rect )

    --local o = ObjGet( obj_spr )
    --ObjSet( obj_spr, { 
    --  inputrect_init = 1;
    --  inputrect_x = - o.draw_width / 2;
    --  inputrect_y = - o.draw_height / 2;
    --  inputrect_w = o.draw_width;
    --  inputrect_h = o.draw_height;
    --} )
    --ld.LogTrace( morph_type, obj_rect )
    common_impl.hint[ "get_"..morph_type..morph_num.."scr" ] = { type = "get", get_obj = obj_rect, room = room };  

  end

  if private.MorphRmInitProgress == 4 then
    local arr = {}
    for k, v in pairs( private.quests ) do
      if v[ 1 ] == 1 then
        table.insert( game.progress_names, 1, "get_"..k.."2scr" )
        table.insert( game.progress_names, 1, "get_"..k.."1scr" )        
      else 
        local ar = {}
        for i = 1, v[ 1 ] do
          table.insert( ar, "get_"..k..i.."scr" )
        end
        arr[ v[ 3 ] ] = ar
      end
    end
    for i = #arr, 1, -1 do
      for j = #arr[ i ], 1, -1 do
        table.insert( game.progress_names, 1, arr[ i ][ j ] )
      end
    end
    --ld.LogTrace( game.progress_names )
  end

end

function public.MorphRmPreOpen( room )
  ng_global.progress[ "scr" ].common.cur_room = room
  if not private.OpenInitialized then

      SoundTheme(0);
    
      local widget_settings = 
      {
        InterfaceWidget_Inventory,
        --InterfaceWidget_BtnHint,
        InterfaceWidget_BtnGuide,
        InterfaceWidget_BtnMenu,
        --InterfaceWidget_Panelscr,
      }

      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], false,false );
        interface.WidgetSetInput(widget_settings[i],false)
      end;

      local widget_settings = 
      {
        --InterfaceWidget_Inventory,
        InterfaceWidget_BtnHint,
        --InterfaceWidget_BtnGuide,
        --InterfaceWidget_BtnMenu,
        InterfaceWidget_Panelscr,
      }

      for i = 1, #widget_settings do
        interface.WidgetSetVisible( widget_settings[i], true,false );
        interface.WidgetSetInput(widget_settings[i],true)
      end;

      public.LoadCurQuest()

      int_button_hint_impl.ChangeParams( {
        DIRECTION = 0;
        POS_X = 200;
        POS_Y = 30;
        back = false;
        hardcore = false;
      } );

      private.currentroom = room

      private.OpenInitialized = {};

    --common_impl.SmartHint_Init();
    int_panelscr.Enabled( true )
  end

  if not private.OpenInitialized[ room ] then
    local div = ld.StringDivide( room )
    local rm = div[ 2 ]
    local anm_init = "anm_"..rm.."_init"
    local pos_morph_funcs = ObjGet( anm_init ).anim_funcs
    for i = 1, #pos_morph_funcs do
      local func_div = ld.StringDivide( pos_morph_funcs[ i ] )
      local morph_type = func_div[ 2 ]
      local morph_num = tonumber( func_div[ 3 ] ) or ""
      local obj_spr  = "spr_"..morph_type..morph_num.."scr";
      local o = ObjGet( obj_spr )
      --ld.LogTrace( o.name,  o.draw_width, o.draw_height )
      ObjSet( obj_spr, { 
        inputrect_init = 1;
        inputrect_x = - math.tointeger( o.draw_width ) / 2;
        inputrect_y = - math.tointeger( o.draw_height ) / 2;
        inputrect_w = math.tointeger( o.draw_width );
        inputrect_h = math.tointeger( o.draw_height );
      } )
      local o = ObjGet( obj_spr )
      --ld.LogTrace( o.name,  o.draw_width, o.draw_height )
    end
    private.OpenInitialized[ room ] = true
  end

  private.MorphGrayUpdate( ng_global.progress[ "scr" ].common.cur_quest )
  private.currentroom = room
end
--*********************************************************************************************************************
function public.PlaySecretgame()
   --SoundSfx( "aud_click_menu" );
      
  if ng_global.progress[ "scr" ].common.gamewin == true then
    --ng_global.progress[ "scr" ].common.gamestart == false 
    common.DialogWindowShow( "common", "finishscr", true );
  else 
    if not ng_global.progress[ "scr" ].common.gamestart then
      ng_global.progress[ "scr" ].common.gamestart = true
      ng_global.progress[ "scr" ].common.cur_quest = "mouse" 
      ng_global.progress[ "scr" ].common.failed_without_hint = false
      ng_global.progress[ "scr" ].common.failed_less_6min = false 
      ng_global.progress[ "scr" ].common.failed_less_12min = false       
      ng_global.progress[ "scr" ].common.time = 0
      ng_global.progress[ "scr" ].common.cur_room = "rm_entrypointscr"
    end   
    ng_global.MOD_MASTERSCR_GOTO_ROOM = ng_global.progress[ "scr" ].common.cur_room
    --common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter,"rm_neartemplescr" )
    public.LoadCurQuest()
    public.GotoRoom("rm_entrypointscr")
    common.LevelSwitch( "levelscr", ng_global.MOD_MASTERSCR_GOTO_ROOM )
  end
end


function public.ResetSecretgame()
   SoundSfx( "aud_click_menu" );
  common.DialogWindowShow( "common", "resetscr", true );
end

--common.dialog.common.buttons[ "finishscr" ] = { left = { text = "yes", func = "finishscr" }, center = nil, right = { text = "no", func = "Close" } };
--common.dialog.common.buttons[ "resetscr" ] = { left = { text = "yes", func = "finishscr" }, center = nil, right = { text = "no", func = "Close" } };
--
--function common.dialog.common.finishscr ()
--
--  common.dialog.common.Close()
--  ng_global.progress[ "scr" ].common.gamestart = false
--  ng_global.progress[ "scr" ].common.gamewin = false 
--  ng_global.progress[ "scr" ].common.failed_without_hint = false
--  ng_global.progress[ "scr" ].common.failed_less_6min = false 
--  ng_global.progress[ "scr" ].common.failed_less_12min = false    
--  ng_global.progress[ "scr" ].common.cur_quest = "mouse" 
--  ng_global.progress[ "scr" ].common.time = 0 
--  ng_global.progress[ "scr" ].common.cur_room = "rm_entrypointscr"
--  for i=1,#game.progress_names do
--    if string.find( game.progress_names[i], "^get_" ) then
--      ng_global.progress["scr"][game.progress_names[i] ].done = 0
--    end
--    --ng_global.progress["scr"][game.progress_names[i] ].start = 1  
--  end
--  public.PlaySecretgame()
--
--end;
----------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------
private.quests = 
{
 ["mouse"]          = {4,"sock",            1},
 ["sock"]           = {8,"bell",            2},
 ["bell"]           = {12,"gingerbreadman", 3},
 ["gingerbreadman"] = {16,"candy",          4},
 ["candy"]          = {20,"goodie",         5},
 ["goodie"]         = {1,"winscr",          6}
}
function public.GetPartQuest(quest,param)

  
  --private.ShowAchiv()
  --int_panelscr.MouseDownClose()
  --if 1 then return end

  local o = ObjGet( "anm_"..quest..param.."scr" )
  --ld.LogTrace( quest,param,o.frame )
  if ( o.frame < 30 or o.frame > 390 ) then
    return
  end

  cmn.SetEventDone( "get_"..quest..param.."scr" );
  local count = 0 
  local cc = 1
  if private.quests[quest][1] > 1 then
    for i=1,private.quests[quest][1] do
      if cmn.IsEventDone( "get_"..quest..i.."scr" )  then
        count =count + 1
      end
    end  
  else
    count = 1
    while common_impl.hint[ "get_"..quest..count.."scr" ] do
      if cmn.IsEventDone( "get_"..quest..count.."scr" ) then
        count = 1
        break
      end
      count = count + 1
    end
  end
  int_panelscr.SetCurQuest(quest,count.."/"..private.quests[quest][1])  
  SoundSfx( "aud_xx_magic" ); 
  ld.Lock(1)
   local object_name = "anm_"..quest..param.."scr"
    ObjSet( object_name, {input=0} );
    ObjSet( "obj_"..quest..param.."scr", {input=0} );
    --ObjAttach( object_name, InterfaceWidget_Top_Name );
    local collect_name  = "fx_item_name_collect_"..object_name;
    ObjCreate( collect_name, "partsys" );
    local p = GetObjPosByObj( ObjGetRelations( "spr_"..quest..param.."scr" ).parent )
    ObjSet( collect_name,
    {
      res = "assets/levels/common/particle_collect",
      pos_x = p[ 1 ], pos_y = p[ 2 ],
      active = 1, visible = 1, input = 0, pos_z = 10
    } );

    ObjAttach( collect_name, public.GetCurrentRoom() );
    ObjSet(collect_name, {blendmode = 2,pos_z = 50});
    PartSysStart(collect_name)

    local func_end = function()
      -- ld.Lock(0)
      
      --ObjAnimate( collect_name, 8, 0, 0, 
      --function()
        --ObjDelete(collect_name);
        ld.StartTimer( 1, function() ObjDelete(collect_name); end )
        ObjSet(object_name,{alp=1,visible=0});
        public.CheckQuest(quest);
        ld.Lock(0);
      --end,
      --{0,0,1, 0.3,0,0} );
      -- ObjDelete(object_name)
    end

    ObjAnimate( object_name, "alp",0,0, func_end,
    { 
        0.0, 0, 1,
        0.3, 0, 1,
        0.6, 0, 0
    } );
  
  --func_end()
  

--
--  local obj = "anm_"..quest..param.."scr"
--  ObjSet( obj, {input = 0} );
--  ObjAnimate( obj, 8, 0, 0, function()ld.Lock(0); end, {0,0,1, 0.5,0,0} );
    private.MorphGrayUpdate( quest )
end

 
function public.CheckQuest(param)
  local count = 0 
  for i=1,private.quests[param][1] do
    if cmn.IsEventDone( "get_"..param..i.."scr" )  then
      count =count + 1
    end
  end
  if count == private.quests[param][1] then
    public.StartNewQuest(private.quests[param][2])
  else 
    
  end 
end
function public.MorphActivate(morph)
  private.MorphActivate(morph);
end;
function private.MorphActivate( morph )
  ObjSet( "obj_"..morph.."scr", {input = 1} );
  ObjAnimate( "anm_"..morph.."scr", 7,0,0, function() 
    ObjSet( "anm_"..morph.."scr", { input = 1, visible=1, playing=1 } );
    ObjSet( "spr_"..morph.."scr", { input = 1, visible=1, playing=1 } );
  end, { 0,0,0, math.random() * ( ld.IsLdCheater and 0 or 6 ) ,0,0 } )
end
function private.MorphGrayUpdate( param )
  for k, v in pairs( common_impl.hint ) do
    if v.room and v.room == public.GetCurrentRoom() and k:find( "^get_"..param ) and ObjGet( v.get_obj ) and ObjGet( v.get_obj ).input then
      int_panelscr.SetCurQuestGray( false )
      return
    end
  end
  int_panelscr.SetCurQuestGray( true )
end
function public.StartNewQuest(param)
  if param ~= "winscr" then
    ng_global.progress[ "scr" ].common.cur_quest = param
    local count = 0
    if private.quests[param][1] > 1 then
      for o=1,private.quests[param][1] do
        if not cmn.IsEventDone( "get_"..param..o.."scr" ) then
          private.MorphActivate( param..o );
          count = count + 1
        end
      end  
    else
      local count = 1
      while common_impl.hint[ "get_"..param..count.."scr" ] do
        if common_impl.hint[ "get_"..param..count.."scr" ].room ~= public.GetCurrentRoom() then
          private.MorphActivate( param..count );
          break
        end
        count = count + 1
      end
    end
    levelscr.tutorial_prgbar.first()
    cmn.IsEventDone( "tutorial_prgbar" )
    int_panelscr.AnimPrgBar()
    int_panelscr.SetCurQuest(param,private.quests[param][1]-count.."/"..private.quests[param][1])      
    private.MorphGrayUpdate( param )
  else 
    local f_end = function()
      --public.GotoRoom("rm_secretroomscr")
      ld.Lock(0)


      int_panelscr.MouseDownClose() 
    end
      ng_global.progress[ "scr" ].common.time = int_panelscr.GetTime()  
      ng_global.progress[ "scr" ].common.gamewin = true 
      ng_global.progress[ "scr" ].common.gamestart = false      
      int_panelscr.SetCurQuest()
      private.ShowAchiv()      
      int_panelscr.AnimPrgBar(f_end)
  end
end

function public.LoadCurQuest()
  if ng_global.progress[ "scr" ].common.failed_less_12min then
    ObjSet( "tmr_panelscr_timer_state", {time=720} );
    int_panelscr.SetTimer()
  else 
    int_panelscr.StartTimer(ng_global.progress[ "scr" ].common.time)
  end
  for i=1,#game.progress_names do
    if string.find( game.progress_names[i], "get_" ) then
      if cmn.IsEventDone( game.progress_names[i] ) then
        ObjSet( "anm_"..common.GetObjectName(game.progress_names[i]), {input = 0, playing=0, visible = 0} );
        ObjSet( "obj_"..common.GetObjectName(game.progress_names[i]), {input = 0} );
      else 
      --  local frame_arr = {math.random(240,360),math.random(660,840)}
      --  local frame = frame_arr[math.random(1,2)]
      --  
        ObjSet( "anm_"..common.GetObjectName(game.progress_names[i]), { visible = 1, playing=0, input = 0 })
        --ObjSet( "obj_"..common.GetObjectName(game.progress_names[i]), {input = 1} );
      end
    end
  end
  local cur_quest = ""
  for a=1,#game.progress_names do
    if not cmn.IsEventDone( game.progress_names[a] ) and string.find( game.progress_names[a], "get_" ) then
      local s = game.progress_names[a]
      cur_quest = string.sub(s,string.find(s,"_")+1,string.find(s,"%d")-1)
      break
    end
  end
  if cur_quest ~="" then
    ld.LogTrace( cur_quest );
    local quest_count = 0
    if private.quests[cur_quest][1] > 1 then
      for o=1,private.quests[cur_quest][1] do
        if not cmn.IsEventDone( "get_"..cur_quest..o.."scr" ) then
          --ld.LogTrace( "anm_"..cur_quest..o.."scr" )
          private.MorphActivate( cur_quest..o );
          quest_count = quest_count + 1 
        end
      end
    else
      local count = 1
      while common_impl.hint[ "get_"..cur_quest..count.."scr" ] do
        ld.LogTrace( "get_"..cur_quest..count.."scr", public.GetCurrentRoom(), common_impl.hint[ "get_"..cur_quest..count.."scr" ] )
        if common_impl.hint[ "get_"..cur_quest..count.."scr" ].room ~= public.GetCurrentRoom() then
          private.MorphActivate( cur_quest..count );
          break
        end
        count = count + 1
      end
    end
    int_panelscr.SetCurQuest(cur_quest,private.quests[cur_quest][1]-quest_count.."/"..private.quests[cur_quest][1])
    int_panelscr.SetPrgBar( private.quests[ cur_quest ][ 3 ] )
    private.MorphGrayUpdate( cur_quest )
  end
end




function public.GotoRoom(room)
  common.GotoRoom(room,false,true)
  ng_global.progress[ "scr" ].common.cur_room = room
  ng_global.progress[ "scr" ].common.currentroom = room
  private.currentroom = room
end


function public.GetCurrentRoom()
  private.currentroom = private.currentroom or ng_global.progress[ "scr" ].common.currentroom or "rm_entrypointscr"
  return private.currentroom;
end;



function private.ShowAchiv()
  --if ng_global.progress[ "scr" ].common.time < 360 then
  --  interface.GetAchievement("scr_complete_less6")  
  --  interface.GetAchievement("scr_complete_less12") 
  --elseif ng_global.progress[ "scr" ].common.time < 720 then
  --  interface.GetAchievement("scr_complete_less12")  
  --end
  --if not ng_global.progress[ "scr" ].common.failed_without_hint then
  --  interface.GetAchievement("scr_complete_nohint")  
  --end
  --interface.GetAchievement("scr_complete_simple")

      --ng_global.achievements.flag[ "scr_complete_simple" ] = true
      ng_global.progress[ "scr" ].common.show_achievement = {}
      table.insert( ng_global.progress[ "scr" ].common.show_achievement, "scr_complete_simple" )
      --interface.GetAchievement("scr_complete_simple")  
      if not ng_global.progress[ "scr" ].common.failed_without_hint then
        --ng_global.achievements.flag[ "scr_complete_nohint" ] = true
        --interface.GetAchievement("scr_complete_nohint")  
        table.insert( ng_global.progress[ "scr" ].common.show_achievement, "scr_complete_nohint" )
      end
      if not ng_global.progress[ "scr" ].common.failed_less_6min then
        --ng_global.achievements.flag[ "scr_complete_less6" ] = true
        --interface.GetAchievement("scr_complete_less6")  
        table.insert( ng_global.progress[ "scr" ].common.show_achievement, "scr_complete_less6" )
      end
      if not ng_global.progress[ "scr" ].common.failed_less_12min then
        --ng_global.achievements.flag[ "scr_complete_less12" ] = true
        --interface.GetAchievement("scr_complete_less12")
        table.insert( ng_global.progress[ "scr" ].common.show_achievement, "scr_complete_less12" )
      end

end
function public.FailedWithoutHint()
  if not ng_global.progress[ "scr" ].common.failed_without_hint then
    int_panelscr.FailedAch("scr_without_hint")
    ng_global.progress[ "scr" ].common.failed_without_hint = true 
  end
end
function public.FailedLess6min()
  if not ng_global.progress[ "scr" ].common.failed_less_6min then
    ng_global.progress[ "scr" ].common.failed_less_6min = true 
    int_panelscr.FailedAch("scr_less_6min")
  end
end
function public.FailedLess12min()
  if not ng_global.progress[ "scr" ].common.failed_less_12min then  
    int_panelscr.FailedAch("scr_less_12min")
    ng_global.progress[ "scr" ].common.failed_less_12min = true 
  end
end

