-- name=rm_extra
--******************************************************************************************
function public.Init()

  ObjAttach( "rm_extra", "rooms_hub" );


--  ObjSet("spr_extra_button_main_menu",{
--    event_mdown =  function() private.Exit()           end,
--    event_menter = function() private.ButtonMouseEnter( "main_menu" ); end,
--    event_mleave = function() private.ButtonMouseLeave( "main_menu" ); end
--                    })
--
--
--  ObjSet("spr_extra_button_ach",
--  {
--    event_mdown = private.AchDown,
--    event_menter = function() public.ButtonMouseEnter('ach'); end,
--    event_mleave = function() public.ButtonMouseLeave('ach'); end
--  });
--
--  ObjSet("spr_extra_button_screensaver",
--  {
--    event_mdown = private.ScreenSaverDown,
--    event_menter = function() private.ButtonMouseEnter('screensaver'); end,
--    event_mleave = function() private.ButtonMouseLeave('screensaver'); end
--  });
--
--  ObjSet("spr_extra_button_collectibles",
--  {
--    event_mdown = private.Collectibles,
--    event_menter = function() private.ButtonMouseEnter('collectibles'); end,
--    event_mleave = function() private.ButtonMouseLeave('collectibles'); end
--  });
--
  local buts = {"txt_extra_button_playho","txt_extra_button_closeho", "txt_extra_button_playmg",
  "txt_extra_button_closemg","txt_extra_button_saveart","txt_extra_button_closeart",
  "txt_extra_button_setwallpaper","txt_extra_button_closewallpaper","txt_extra_button_savemusic",
  "txt_extra_button_closemusic", "txt_extra_button_playplayextra","txt_extra_button_closeplayextra"}
  common_impl.SetButtonTextColor(buts, nil, common_impl.ButtonTextOutlineColor())
  
  if GetPlatform() == "ios" then
    ObjSet("spr_extra_button_savemusic",{ alp = 0, input = false, visible = false, active = false });
  end;

end;
--******************************************************************************************
function public.PreOpen()
  if not ng_global.progress[ "ext" ].common.gamewin == true then
  --  ObjSet( "spr_extra_tr", {alp = 1} );
  else
  --  ObjSet( "spr_extra_tr", {alp = 0} );
  end
  SoundEnv( "aud_cabinet_env" );
  
  local objs_child = ObjGetRelations( "obj_extra_buttons" );
  for i=1,#objs_child.childs do
    local delay = 1.5 + math.random()+ math.random()+ math.random();
    ObjAnimate( ObjGetRelations(objs_child.childs[i]).childs[1], 8, 1, 0, "", {  0,         0,0,
      delay/2,   0,0.75,
      delay,     0,0.75,
      delay*1.5, 0,0,
      delay*1.8, 0,0});
  end;
  
end;
--******************************************************************************************
function public.Open()
  SoundTheme( 0 )
  --SoundEnv( 0 )

  public.PlayExtraTrack( private.music_current );

  private.ShowSecretGameAchivments()

end;

function public.PreClose()
  if private.music_is_play then

    common_impl.StopAllMus();

    local name = "spr_extra_music_track"..private.music_current.."_play";
    ObjSet( name, { alp = 1, input = 1 } );

    name = "spr_extra_music_track"..private.music_current.."_pause";
    ObjSet( name, { input = 0, alp = 0 } );

    ObjSet( "spr_extra_music_track"..private.music_current.."_back_light", { active = 0 } );
    ObjSet( "obj_extra_music_track"..private.music_current.."_back_light", { alp = 0 } );
    private.music_is_play = false;

  end;
end

function public.Close()

end
--******************************************************************************************
--******************************************************************************************
function public.Exit()
  common.GotoRoom( "rm_menu" );
end

--******************************************************************************************
function public.AchDown()
  common.MenuAchievements();
end;
--******************************************************************************************
function public.ScreenSaverDown()
  common.GotoRoom( "rm_screensaver" );
end;
function public.Collectibles()
  common.GotoRoom( "rm_collectibles" );
end;




ObjAttach("rm_extra", "ng_rooms_hub");


----------------------------------------------------------------------------------------------------

----------------------------------------------------------------------------------------------------

private.tab =
{
  "art",
  "music",
  "wallpaper",
  "playextra",
  "mg",
  "ho"
};

private.music =
{
  "soundtrack_1",
  "soundtrack_2",
  "soundtrack_3",
  "soundtrack_4",
  "soundtrack_5"
};

private.mg =
{

  "mg_citymgscr";
  "mg_statuemgscr";
  "mg_seedmgscr";
  "mg_mousemgscr";
  "mg_hatsmgscr";
  "mg_labyrinthscr";
  "mg_fightscr";

  "mg_laceextscr";
  "mg_onboxextscr";
  "mg_yardextscr";
  "mg_fightextscr";

  "mg_casketscr";
--12
};

private.ho =
{
  "ho_underfirtreehoscr";
  "ho_sledgescr";
  "ho_knighthoscr";
  "ho_elfhoscr";
  "ho_musicanshoscr";
  "ho_jewelryhoscr";
  "ho_winterbalconyscr";
  "ho_trainscr";
  "ho_icearbourscr";

  "ho_painthoextscr";
  "ho_portalextscr";
  "ho_pearlsextscr";
  "ho_prizesextscr";


--13
};


private.tab_current       = 4;
private.wallpaper_current = 1;
private.wallpaper_max    = 14;
private.mg_max    = 11;
private.ho_max    = 13;
private.mg_current = 1;
private.ho_current = 1;
private.screensaver_current = 1;
private.art_current       = 1;
private.art_max        = 14;
private.music_current     = 1;
private.music_is_play     = false;

----------------------------------------------------------------------------------------------------
function public.UpdateExtraScr( new_scr )

  new_scr = tonumber( new_scr );
  --SoundSfx( 2 )

  public.ActivateExtraScr( 0 );
  local name = "obj_extra_"..private.tab[ new_scr ]
  local tme = 0.5;
      ObjSet( 'rm_extra', {  input = 0 } );
      ObjSet( name, { visible = 1 } );
      ObjAttach( name, "rm_extra" );
      ObjAnimate( name, "alp", 0, 0, function() public.ActivateExtraScr( 1,name);ObjSet( 'rm_extra', {  input = 1 } );end,
      {
         0.0, 0, 0,
         tme, 0, 1
      } );

end;

function public.CloseExtraScr( new_scr )
  
  new_scr = tonumber( new_scr );

  SoundSfx( "aud_clk_menu" );
  name = "obj_extra_"..private.tab[ new_scr ];
      ObjSet( 'rm_extra', {  input = 0 } );
      ObjAnimate( name, "alp", 0, 0, function() ObjSet( name, { visible = 0, input = 0 } ); ObjAttach( '"..name.."', 'hub_extra' );ObjSet( 'rm_extra', {  input = 1 } );end,
      {
        0.0, 0, ObjGet( name ).alp,
        0.5, 0, 0
      } );
end


----------------------------------------------------------------------------------------------------
function public.ActivateExtraScr( vinput, name )

  ObjSet( "obj_extra_buttons", { input = vinput } );

  if name then

    ObjSet( name, { input = vinput });

  end;

end;
----------------------------------------------------------------------------------------------------

function public.MgNext( inc )

  local max_count = private.mg_max;
  local new_num;

  if private.mg_current == max_count and inc == 1 then
    new_num = 1;
  elseif private.mg_current == 1 and inc == -1 then
    new_num = max_count;
  else
    new_num = private.mg_current + inc;
  end;
  ObjSet( 'rm_extra', {  input = 0 } );
  local name     = "spr_extra_mg_";
  local name_arr = "obj_extra_mg_arrows";
  local tme      = 0.3;
  public.ActivateExtraScr( 0, name_arr );

  ObjAnimate( name..new_num, "alp", 0, 0, "", { 0,0,0, tme,0,1 } );
  ObjAnimate( name..private.mg_current, "alp", 0, 0, function() public.ActivateExtraScr( 6,name_arr );ObjSet( 'rm_extra', {  input = 1 } );end, { 0,0,1, tme,0,0 } );

  ObjSet( "txt_extra_mg_counter", { text = new_num.."/"..max_count } );
  private.mg_current = new_num;
  SoundSfx( "aud_clk_menu" );


end;
----------------------------------------------------------------------------------------------------

function public.HoNext( inc )

  local max_count = private.ho_max;
  local new_num;

  if private.ho_current == max_count and inc == 1 then
    new_num = 1;
  elseif private.ho_current == 1 and inc == -1 then
    new_num = max_count;
  else
    new_num = private.ho_current + inc;
  end;
  ObjSet( 'rm_extra', {  input = 0 } );
  local name     = "spr_extra_ho_";
  local name_arr = "obj_extra_ho_arrows";
  local tme      = 0.3;
  public.ActivateExtraScr( 0, name_arr );

  ObjAnimate( name..new_num, "alp", 0, 0, "", { 0,0,0, tme,0,1 } );
  ObjAnimate( name..private.ho_current, "alp", 0, 0, function() public.ActivateExtraScr( 7,name_arr );ObjSet( 'rm_extra', {  input = 1 } );end, { 0,0,1, tme,0,0 } );

  ObjSet( "txt_extra_ho_counter", { text = new_num.."/"..max_count } );
  private.ho_current = new_num;
  SoundSfx( "aud_clk_menu" );


end;
----------------------------------------------------------------------------------------------------

function public.WallpaperNext( inc )

  local max_count = private.wallpaper_max;
  local new_num;

  if private.wallpaper_current == max_count and inc == 1 then
    new_num = 1;
  elseif private.wallpaper_current == 1 and inc == -1 then
    new_num = max_count;
  else
    new_num = private.wallpaper_current + inc;
  end;
  ObjSet( 'rm_extra', {  input = 0 } );
  local name     = "spr_extra_wallpaper_";
  local name_arr = "obj_extra_wallpaper_arrows";
  local tme      = 0.3;
  public.ActivateExtraScr( 0, name_arr );

  ObjAnimate( name..new_num, "alp", 0, 0, "", { 0,0,0, tme,0,1 } );
  ObjAnimate( name..private.wallpaper_current, "alp", 0, 0, function() public.ActivateExtraScr( 1,name_arr );ObjSet( 'rm_extra', {  input = 1 } );end, { 0,0,1, tme,0,0 } );

  ObjSet( "txt_extra_wallpaper_counter", { text = new_num.."/"..max_count } );
  private.wallpaper_current = new_num;
  SoundSfx( "aud_clk_menu" );


end;

----------------------------------------------------------------------------------------------------

function public.ScreensaverNext( inc )

  local max_count = 3;
  local new_num;

  if private.screensaver_current == max_count and inc == 1 then
    new_num = 1;
  elseif private.screensaver_current == 1 and inc == -1 then
    new_num = max_count;
  else
    new_num = private.screensaver_current + inc;
  end;

  local name     = "spr_extra_screensaver_";
  local name_arr = "obj_extra_screensaver_arrows";
  local tme      = 0.3;
  public.ActivateExtraScr( 0, name_arr );
  ObjSet( 'rm_extra', {  input = 0 } );
  ObjAnimate( name..new_num, "alp", 0, 0, "", { 0,0,0, tme,0,1 } );
  ObjAnimate( name..private.screensaver_current, "alp", 0, 0, function() public.ActivateExtraScr( 1,name_arr );ObjSet( 'rm_extra', {  input = 1 } );end, { 0,0,1, tme,0,0 } );

  ObjSet( "txt_extra_screensaver_counter", { text = new_num.."/"..max_count } );

--  ObjSet( "txt_extra_screensaver_name", { text = "str_extra_screensaver_name_"..new_num } );

  private.screensaver_current = new_num;
  SoundSfx( "aud_clk_menu" );

end;

----------------------------------------------------------------------------------------------------

function public.ArtNext( inc )

  inc = tonumber( inc );
  local max_count = private.art_max  ;
  local new_num;

  if private.art_current == max_count and inc == 1 then
    new_num = 1;
  elseif private.art_current == 1 and inc == -1 then
    new_num = max_count;
  else
    new_num = private.art_current + inc;
  end;

  local name     = "spr_extra_art_";
  local name_arr = "obj_extra_art_arrows";
  local tme      = 0.3;

  public.ActivateExtraScr( 0, name_arr );
  ObjSet( 'rm_extra', {  input = 0 } );
  ObjAnimate( name..new_num, "alp", 0, 0, "",
  {
    0.0, 0, 0,
    tme, 0, 1
  } );

  ObjAnimate( name..private.art_current, "alp", 0, 0, function() public.ActivateExtraScr(1,name_arr);ObjSet( 'rm_extra', {  input = 1 } );end,
  {
    0.0, 0, 1,
    tme, 0, 0
  } );

  ObjSet( "txt_extra_art_counter", { text = new_num.."/"..max_count } );
  private.art_current = new_num;

 SoundSfx( "aud_clk_menu" );

end

----------------------------------------------------------------------------------------------------

function public.PlayExtraTrack( new_mus, is_button )

  new_mus = tonumber( new_mus );

  local name = "";
  local tme = 0.0;

  if not IsNoSoundDevice()  then

    local track_path = "menu/rm_extra/aud_"..private.music[ tonumber( new_mus ) ].."_mus";

    if private.music_is_play then

      common_impl.StopAllMus();


      local str_name = "spr_extra_button_music_track"..private.music_current.."_play";
      ObjAnimate( str_name, "alp", 0, 0, function() ObjSet( str_name, { input = 1 } ); end, { 0,0,0, tme,0,1 } );

      name = "spr_extra_button_music_track"..private.music_current.."_pause";
      ObjSet( name, { input = 0 } );
      ObjAnimate( name, "alp", 0, 0, "", { 0,0,1, tme,0,0 } );
      ObjSet( "spr_extra_music_track"..private.music_current.."_back_light", { active = 0 } );

    end;



    name = "txt_extra_music_track"..private.music_current;

      ObjAnimate( name, 12, 0, 0, "",
    {
       0.0, 0, ObjGet( name ).color_r, ObjGet( name ).color_g, ObjGet( name ).color_b,
       tme, 0, 1.0, 1, 0.5215
    } );



    private.music_current = tonumber( new_mus );
    local next_track = private.music_current + 1;

    if next_track > #private.music then

      next_track = 1;

    end;

    common_impl.PlayAudio( "mus", track_path, 1 );--, "", function()private.PlayExtraTrack( next_track );end, 0.5 );

    private.music_is_play = true;

    name = "spr_extra_button_music_track"..private.music_current.."_play";
    ObjSet( name, { input = 0 } );
    ObjAnimate( name, "alp", 0, 0, "", { 0,0,1, tme,0,0 } );

    local str_name = "spr_extra_button_music_track"..private.music_current.."_pause";
    ObjAnimate( str_name, "alp", 0, 0, function()     ObjSet( str_name, { input = 1 } ); end, { 0,0,0, tme,0,1 } );

    ObjSet( "spr_extra_music_track"..private.music_current.."_back_light", { active = 1 } );


    name = "txt_extra_music_track"..private.music_current;
    ObjAnimate( name, 12, 0, 0, "",
    {
       0.0, 0, ObjGet( name ).color_r, ObjGet( name ).color_g, ObjGet( name ).color_b,
       tme, 0, 1, 0.964, 0.8627
    } );


  else

    if is_button then

      common.DialogWindowShow( "common", "noaudio" );

    end;

--    if tonumber( new_mus ) ~= private.music_current or private.music_current ~= 0 then
--
--      ObjSet( "spr_extra_music_track"..private.music_current.."_light", { active = 0 } );
--
--      name = "obj_extra_music_track"..private.music_current.."_light";
--      ObjAnimate( name, "alp", 0, 0, "", { 0,0,ObjGet( name ).alp, tme,0,0 } );
--
--      name = "txt_extra_music_track"..private.music_current;
--      ObjAnimate( name, 12, 0, 0, "",
--      {
--         0.0, 0, ObjGet( name ).color_r, ObjGet( name ).color_g, ObjGet( name ).color_b,
--         tme, 0, 0.0, 0.0, 0.0
--      } );
--
--    end;
--
--    private.music_current = tonumber( new_mus );
--    name = "obj_extra_music_track"..private.music_current.."_light";
--    ObjAnimate( name, "alp", 0, 0, "", { 0,0,ObjGet( name ).alp, tme,0,1 } );
--
--    name = "txt_extra_music_track"..private.music_current;
--    ObjAnimate( name, 12, 0, 0, "",
--    {
--       0.0, 0, ObjGet( name ).color_r, ObjGet( name ).color_g, ObjGet( name ).color_b,
--       tme, 0, 0.0, 0.0, 0.0
--    } );


  end;

end;

----------------------------------------------------------------------------------------------------
function public.PauseExtraTrack( cur_mus )

  SoundSfx( "aud_clk_menu" );

  common_impl.StopAllMus();
  private.music_is_play = false;

  local name = "spr_extra_button_music_track"..cur_mus.."_pause";
  local tme = 0.0;
  ObjSet( name, { input = 0 } );
  ObjAnimate( name, "alp", 0, 0, "", { 0,0,1, tme,0,0 } );

  local str_name = "spr_extra_button_music_track"..cur_mus.."_play";
  ObjAnimate( str_name, "alp", 0, 0, function()   ObjSet(str_name, { input = 1 } ) end, { 0,0,0, tme,0,1 } );

  ObjSet( "spr_extra_music_track"..private.music_current.."_back_light", { active = 0 } );


  name = "txt_extra_music_track"..private.music_current;
  ObjAnimate( name, 12, 0, 0, "",
  {
     0.0, 0, ObjGet( name ).color_r, ObjGet( name ).color_g, ObjGet( name ).color_b,
     tme, 0, 01, 1, 0.5215
  } );


end;

----------------------------------------------------------------------------------------------------
function public.ButtonDownExit()

  cmn.GotoRoom( "rm_menu", nil, true );

end;

----------------------------------------------------------------------------------------------------
function public.ButtonMouseEnter( but_name )

  SetCursor( CURSOR_HAND );



  local obj = "spr_extra_button_"..but_name.."_focus";
  local txt_obj = "txt_extra_button_"..but_name
  --"art",
  --"music",
  --"wallpaper",
  --"playextra",
  --"screensaver"
  --"achievments"
  --"collectibles"
  --"secretroom"

  if but_name == "menu" then
    SetCursor(CURSOR_DOWN)
  elseif but_name == "art" or but_name == "music" or but_name == "wallpaper" or but_name == "playextra" or
         but_name == "screensaver" or but_name == "achievments" or but_name == "collectibles" or  but_name == "secretroom" or
         but_name == "ho" or but_name == "mg" then
    SetCursor(CURSOR_LOUPE)
    interface.PopupShow( "str_extra_button_"..but_name );
  end


  local alp = ObjGet( obj ).alp;

  ObjAnimate( obj, 8, 0, 0, "", { 0, 0, alp, ( common_impl.animtime * ( 1 - alp ) ), 0, 1 } );
  --ObjSet( txt_obj, {color_r = 1, color_g = 1, color_b = 1} );

  
  ObjSet( txt_obj, {color_r = 1, color_g = 1, color_b = 1} );
  

--  ObjAnimate( "", 8, 0, 0, "", {0,0,0, 0.5,0,1} );

  --ObjAnimate( txt_obj, 12, 0, 0, "",
  --{
  --   0.0, 0, ObjGet( txt_obj ).color_r, ObjGet( txt_obj ).color_g, ObjGet( txt_obj ).color_b,
  --   ( common_impl.animtime * ( 1 - alp ) ), 0, 1, 1, 1
  --} );

end;
--------------------------------------------------------------------
function public.ButtonMouseLeave( but_name )

  SetCursor( CURSOR_DEFAULT );
  interface.PopupHide()
  local obj = "spr_extra_button_"..but_name.."_focus";
  local txt_obj = "txt_extra_button_"..but_name
  local alp = ObjGet( obj ).alp;
  --local pfx_obj = "pfx_extra_button_"..but_name.."_focus";
  ObjAnimate( obj, 8, 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );
  --ObjAnimate( pfx_obj, 8, 0, 0, "", { 0, 0, alp, ( common_impl.animtime * alp ), 0, 0 } );

  if but_name == "bigplayplayextra" then
    ObjSet( txt_obj, {color_r = 0.7, color_g = 1, color_b = 1} );
  else
    local r,g,b = common_impl.ButtonTextColorLeave()
    ObjSet( txt_obj, {color_r = r, color_g = g, color_b = b} );
  end
  --ObjAnimate( txt_obj, 12, 0, 0, "",
  --{
  --   0.0, 0, ObjGet( txt_obj ).color_r, ObjGet( txt_obj ).color_g, ObjGet( txt_obj ).color_b,
  --   ( common_impl.animtime * ( 1 - alp ) ), 0, 0.47, 0.78, 1
  --} );

end;

----------------------------------------------------------------------------------------------------
function public.Setwallpaper()

  SetCursor( CURSOR_DEFAULT );
  SoundSfx( "aud_clk_menu" );

  if IsDemoEdition() or IsSurveyEdition() then

    common.DialogWindowShow( "common", "not_in_demo", true );

  else

    common.DialogWindowShow( "common", "set_wallpaper", true );

  end;

end;
----------------------------------------------------------------------------------------------------
function public.PlayMg()

  SetCursor( CURSOR_DEFAULT );
  SoundSfx( "aud_clk_menu" );

  -- SECRETROOM NEED WORK
  -- remove this code then SR is ready
  --common.DialogWindowShow( "common", "work_in_progress", true );
  --if true then return end

  if IsDemoEdition() or IsSurveyEdition() then

    common.DialogWindowShow( "common", "not_in_demo", true );

  else

    if ( ng_global.progress[ "std" ].common.gamewin and ng_global.progress[ "ext" ].common.gamewin ) then

      ng_global.MOD_MASTERSCR_GOTO_ROOM = private.mg[private.mg_current];
      --ld.LogTrace( "public.PlayMg()", ng_global.MOD_MASTERSCR_GOTO_ROOM )
      common.LevelSwitch( "levelscr", ng_global.MOD_MASTERSCR_GOTO_ROOM )

    else
      common.DialogWindowShow( "common", "unlockextra", true );
    end

  end;

end;

----------------------------------------------------------------------------------------------------
function public.PlayHo()

  SetCursor( CURSOR_DEFAULT );
  SoundSfx( "aud_clk_menu" );

  -- SECRETROOM NEED WORK
  -- remove this code then SR is ready
  --common.DialogWindowShow( "common", "work_in_progress", true );
  --if true then return end

  if IsDemoEdition() or IsSurveyEdition() then

    common.DialogWindowShow( "common", "not_in_demo", true );

  else

    if ( ng_global.progress[ "std" ].common.gamewin and ng_global.progress[ "ext" ].common.gamewin ) then

      ng_global.MOD_MASTERSCR_GOTO_ROOM = private.ho[private.ho_current];
      common.LevelSwitch( "levelscr", ng_global.MOD_MASTERSCR_GOTO_ROOM )

    else

      common.DialogWindowShow( "common", "unlockextra", true );

    end

  end;

end;
----------------------------------------------------------------------------------------------------
--function public.SetScreensaver()
--
--  SetCursor( CURSOR_DEFAULT );
--  --SoundSfx( 2 )
--
--  if IsDemoEdition() or IsSurveyEdition() then
--
--    common.DialogWindowShow( "common", "not_in_demo", true );
--
--  else
--
--    if GetPlatform()=="mac" then
--      common.DialogWindowShow( "common", "setscreensaver_walp", true );
--    else
--      common.DialogWindowShow( "common", "setscreensaver", true );
--    end
--
--  end;
--
--end;

----------------------------------------------------------------------------------------------------
function public.Saveart()

  SetCursor( CURSOR_DEFAULT );
  SoundSfx( "aud_clk_menu" );

  if IsDemoEdition() or IsSurveyEdition() then

    common.DialogWindowShow( "common", "not_in_demo", true );

  else

   common.DialogWindowShow( "common", "save_conceptart", true );

  end;

end;
----------------------------------------------------------------------------------------------------
function public.Savemusic()

  SetCursor( CURSOR_DEFAULT );
  SoundSfx( "aud_clk_menu" );

  if IsDemoEdition() or IsSurveyEdition() then

    common.DialogWindowShow( "common", "not_in_demo", true );

  else

    common.DialogWindowShow( "common", "save_music", true );

  end;

end;


--------------------------------------------------------------------
--------------------------------------------------------------------
function public.ButtonScreensaver()

  cmn.GotoRoom( "rm_screensaver" );

end;
--------------------------------------------------------------------
--------------------------------------------------------------------
--------------------------------------------------------------------
function public.ButtonCollectibles()

  cmn.GotoRoom( "rm_collectibles" );
--  if not(private.load_ach) then
--
--    private.load_ach=true
--
--
--
--     -- ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
--     -- TrgExecute( "trg_achievements_init" );
--  end
--    TrgExecute( "trg_achiev_init" );
--    LoadCurrentProfile();
--  ng_var.previous_room = GetCurrentRoom();
--
--  cmn.GotoRoom( "rm_collectibles", nil, true );

end;
--------------------------------------------------------------------
--------------------------------------------------------------------
function public.ButtonSecretroom()
----  ld.PlayAudio( "sfx", "common/audio/aud_clk_menu" );
--  if not(private.load_ach) then
--
--    private.load_ach=true
--
--
--     -- ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
--     -- TrgExecute( "trg_achievements_init" );
--  end
--
--  --  TrgExecute( "trg_achiev_init" );
--    LoadCurrentProfile();
--  ng_var.previous_room = GetCurrentRoom();
--
 --cmn.GotoRoom( "rm_secretroom" );

end;
--------------------------------------------------------------------
--------------------------------------------------------------------
--------------------------------------------------------------------
function public.ButtonAchievments()
----  ld.PlayAudio( "sfx", "common/audio/aud_clk_menu" );
--  if not(private.load_ach) then
--
--    private.load_ach=true
--
--
--     -- ModLoad( "assets/levels/menu/rm_achievements/mod_achievements" );
--     -- TrgExecute( "trg_achievements_init" );
--  end
--
--  --  TrgExecute( "trg_achiev_init" );
--    LoadCurrentProfile();
--  ng_var.previous_room = GetCurrentRoom();
--
 cmn.GotoRoom( "rm_achievements" );

end;

--CONFIG EXTRA------------------

--if IsSurveyEdition() == 1 then
--
--  ObjDelete( "spr_extra_button_playextra" );
--  ObjDelete( "spr_extra_button_wallpaper" );
--  ObjDelete( "spr_extra_button_art" );
--
--
--  ObjDelete( "obj_extra_wallpaper" );
--  ObjDelete( "obj_extra_art" );
--
--  ObjAttach( "obj_extra_music", "rm_extra" );
--  ObjSet( "obj_extra_music", { input = 1, visible = 1, alp = 1 } );
--
--end;






--------------------------------------------------------------------
function public.PlayExtra(prg)

  SoundSfx( "aud_clk_menu" );
  SetCursor( CURSOR_DEFAULT );

  -- SECRETROOM NEED WORK
  -- remove this code then SR is ready
  --if prg == "scr" then
  --  common.DialogWindowShow( "common", "work_in_progress", true );
  --  return
  --end

  if (prg == "ext" and ng_global.progress[ "std" ].common.gamewin)
  or (prg == "scr" and ng_global.progress[ "ext" ].common.gamewin)
  then

  -- DbgTrace(prg);
    -- SECRETROOM NEED WORK
    -- check any combination of completed chapters and access to progresses
    if ( ng_global.progress[ prg ].common.gamewin == true 
    and ng_global.progress[ prg ].common.gamestart == false )
    then
      common.DialogWindowShow( "common", "finish"..prg, true );
    else

      --ng_global.currentprogress = prg;

      --if ( not ng_global.progress[ prg ].common.gamestart ) then
      --  ng_global.progress[ prg ].common.gamestart = true;
      --end;

      SetCursor( CURSOR_DEFAULT );
      local level = ng_global.progress[ prg ].common.chapter;
      cmn.is_inmenunow = false;

      if prg == "scr" then
        public.PlaySecretgame()
      else
        common.LevelSwitch( level )
      end

    end;

  else

    if IsDemoEdition() or IsSurveyEdition() then

      common.DialogWindowShow( "common", "not_in_demo", true );

    else

      if prg == "ext" then
        common.DialogWindowShow( "common", "unlockextra", true );
      elseif prg == "scr" then
        common.DialogWindowShow( "common", "unlockscr", true );
      end

    end;

  end;


end;
--------------------------------------------------------------------
function public.PlaySecretgame()
  --SoundSfx( "aud_clk_menu" );
      
  if ng_global.progress[ "scr" ].common.gamewin == true then
    --ng_global.progress[ "scr" ].common.gamestart == false 
    common.DialogWindowShow( "common", "finishscr", true );
  else 
    if not ng_global.progress[ "scr" ].common.gamestart then
      ng_global.progress[ "scr" ].common.gamestart = true
      ng_global.progress[ "scr" ].common.cur_quest = "mouse" 
      ng_global.progress[ "scr" ].common.failed_without_hint = false
      ng_global.progress[ "scr" ].common.failed_less_6min = false 
      ng_global.progress[ "scr" ].common.failed_less_12min = false       
      ng_global.progress[ "scr" ].common.time = 0
      ng_global.progress[ "scr" ].common.cur_room = "rm_entrypointscr"
    end   

    if ( not ng_global.progress[ "scr" ].common.cur_room )
    or ( not ng_global.progress[ "scr" ].common.cur_quest )
    then
      --ld.LogTrace( ng_global.progress[ "scr" ].common )
      ng_global.progress[ "scr" ].common.gamestart = false
      public.PlaySecretgame()
      return
    end

    common_impl.MOD_MASTERSCR_GOTO_ROOM = ng_global.progress[ "scr" ].common.cur_room
    --common.LevelSwitch( ng_global.progress[ "scr" ].common.chapter,"rm_neartemplescr" )
    --public.LoadCurQuest()
    --public.GotoRoom("rm_entrypointscr")
    --ld.LogTrace( ng_global.progress[ "scr" ].common )
    common.LevelSwitch( "levelscr", common_impl.MOD_MASTERSCR_GOTO_ROOM )
  end
end
--------------------------------------------------------------------
function private.ShowSecretGameAchivments()
  --ld.LogTrace( "ShowSecretGameAchivments", ng_global.progress[ "scr" ].common )
  if ng_global.progress[ "scr" ].common.show_achievement then
    for i = 1, #ng_global.progress[ "scr" ].common.show_achievement do
      interface.GetAchievement( ng_global.progress[ "scr" ].common.show_achievement[ i ] )
    end
  end
end
--------------------------------------------------------------------

--common.dialog.common.buttons[ "goto_mg" ] = { left = { text = "yes", func = "save_conceptart" }, center = nil, right = { text = "no", func = "Close" } };
--common.dialog.common.buttons[ "goto_ho" ] = { left = { text = "yes", func = "set_wallpaper" }, center = nil, right = { text = "no", func = "Close" } };
--
common.dialog.common.buttons[ "save_conceptart" ] = { left = { text = "yes", func = "save_conceptart" }, center = nil, right = { text = "no", func = "Close" } };
common.dialog.common.buttons[ "set_wallpaper" ] = { left = { text = "yes", func = "set_wallpaper" }, center = nil, right = { text = "no", func = "Close" } };
common.dialog.common.buttons[ "save_music" ] = { left = { text = "yes", func = "save_music" }, center = nil, right = { text = "no", func = "Close" } };
common.dialog.common.buttons[ "setscreensaver" ] = { left = { text = "yes", func = "setscreensaver" }, center = nil, right = { text = "no", func = "Close" } };
common.dialog.common.buttons[ "setscreensaver_walp" ] = { left = { text = "yes", func = "setscreensaver_walp" }, center = nil, right = { text = "no", func = "Close" } };
common.dialog.common.buttons[ "unlockextra" ] = { left = nil, center = { text = "ok", func = "unlockextra" }, right = nil };
common.dialog.common.buttons[ "unlockscr" ] = { left = nil, center = { text = "ok", func = "unlockscr" }, right = nil };
common.dialog.common.buttons[ "finishext" ] = { left = { text = "yes", func = "finishext" }, center = nil, right = { text = "no", func = "Close" } };

common.dialog.common.buttons[ "not_in_demo" ] = { left = nil, center = { text = "ok", func = "not_in_demo" }, right = nil };

common.dialog.common.buttons[ "work_in_progress" ] = { left = nil, center = { text = "ok", func = "not_in_demo" }, right = nil };


common.dialog.common.buttons[ "finishscr" ] = { left = { text = "yes", func = "finishscr" }, center = nil, right = { text = "no", func = "Close" } };
common.dialog.common.buttons[ "resetscr" ] = { left = { text = "yes", func = "finishscr" }, center = nil, right = { text = "no", func = "Close" } };

function common.dialog.common.finishscr ()
  SoundSfx( "aud_clk_menu" )
  common.dialog.common.Close()
  ng_global.progress[ "scr" ].common.gamestart = false
  ng_global.progress[ "scr" ].common.gamewin = false 
  ng_global.progress[ "scr" ].common.failed_without_hint = false
  ng_global.progress[ "scr" ].common.failed_less_6min = false 
  ng_global.progress[ "scr" ].common.failed_less_12min = false    
  ng_global.progress[ "scr" ].common.cur_quest = "mouse" 
  ng_global.progress[ "scr" ].common.time = 0 
  ng_global.progress[ "scr" ].common.cur_room = "rm_entrypointscr"
  --ld.LogTrace( ng_global.progress["scr"] )
  if ng_global.progress["scr"] then
    --for i=1,#game.progress_names do
    --  if string.find( game.progress_names[i], "get_" ) then
    --    ng_global.progress["scr"][game.progress_names[i] ].done = 0
    --  end
    --  --ng_global.progress["scr"][game.progress_names[i] ].start = 1  
    --end
    for k, v in pairs( ng_global.progress["scr"] ) do
      if k:find( "^get_" ) then
        v.done = 0
      end
    end
  end
  public.PlaySecretgame()
end;

function common.dialog.common.not_in_demo ()
  SoundSfx( "aud_clk_menu" )
  common.dialog.common.Close()
end;


function common.dialog.common.save_conceptart ()
  SoundSfx( "aud_clk_menu" )
  common.dialog.common.Close()
  CopyFileToMyDocs( "assets/levels/menu/rm_extra/content/art_"..private.art_current );
end;

function common.dialog.common.set_wallpaper ()
  SoundSfx( "aud_clk_menu" )
  common.dialog.common.Close()
  CopyFileToMyDocs( "assets/levels/menu/rm_extra/content/wallpaper_"..private.wallpaper_current);
end;

function common.dialog.common.save_music ()
  SoundSfx( "aud_clk_menu" )
  common.dialog.common.Close();
  --.port fix 
  if (port.isPortable() == 1) then
    CopySoundFileToMyDocs( "assets/levels/menu/rm_extra/content/soundtrack_"..private.music_current );
  else
    CopyFileToMyDocs( "assets/levels/menu/rm_extra/content/soundtrack_"..private.music_current..".mp3" );
  end;
end;

function common.dialog.common.setscreensaver ()
  SoundSfx( "aud_clk_menu" )
  common.dialog.common.Close()
  SetScreensaver( "assets/levels/menu/rm_extra/content/screensaver_"..private.screensaver_current.."/RoyalDetective_LegendOfTheGolem_scr"..private.screensaver_current..".scr" );
end;

function common.dialog.common.setscreensaver_walp ()
  SoundSfx( "aud_clk_menu" )
  common.dialog.common.Close()
  CopyFileToMyDocs( "assets/levels/menu/rm_extra/content/wallpaperscreensaver_"..private.screensaver_current);
end;

function common.dialog.common.unlockextra ()
  SoundSfx( "aud_clk_menu" )
  common.dialog.common.Close()
end;

function common.dialog.common.unlockscr ()
  SoundSfx( "aud_clk_menu" )
  common.dialog.common.Close()
end;

function common.dialog.common.finishext ()
  SoundSfx( "aud_clk_menu" )
  --common.dialog.common.Close()

  common.dialog.playchoice.resetprogress = "ext";
  --local commonsave = ng_global.progress[ prg ].common;
  --ng_global.currentprogress = prg;
  common.dialog.common.Reset()

  --SaveProfiles();

 -- ld.dialog.common.close();
  --common.DialogWindowShow( "gamemode", "newgame" );

end

--function common.dialog.common.finishscr ()
--  SoundSfx( "aud_clk_menu" )
--
--  -- SECRETROOM NEED WORK
--  -- ATTENTION!!! cleaning scr will clean mg and ho saves too
--  common.dialog.playchoice.resetprogress = "scr";
--  common.dialog.common.Reset()
--
--end;


